"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MarkUnreadRequestBody = void 0;
/** Provides operations to call the markUnread method.  */
class MarkUnreadRequestBody {
    /**
     * Instantiates a new markUnreadRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "messageIds": (o, n) => { o.messageIds = n.getCollectionOfPrimitiveValues(); },
        };
    }
    ;
    /**
     * Gets the messageIds property value.
     * @returns a string
     */
    get messageIds() {
        return this._messageIds;
    }
    ;
    /**
     * Sets the messageIds property value.
     * @param value Value to set for the messageIds property.
     */
    set messageIds(value) {
        this._messageIds = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfPrimitiveValues("messageIds", this.messageIds);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.MarkUnreadRequestBody = MarkUnreadRequestBody;
