"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.KeyCredentialRequestBody = void 0;
const createKeyCredentialFromDiscriminatorValue_1 = require("../../../models/microsoft/graph/createKeyCredentialFromDiscriminatorValue");
const createPasswordCredentialFromDiscriminatorValue_1 = require("../../../models/microsoft/graph/createPasswordCredentialFromDiscriminatorValue");
/** Provides operations to call the addKey method.  */
class KeyCredentialRequestBody {
    /**
     * Instantiates a new KeyCredentialRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "keyCredential": (o, n) => { o.keyCredential = n.getObjectValue(createKeyCredentialFromDiscriminatorValue_1.createKeyCredentialFromDiscriminatorValue); },
            "passwordCredential": (o, n) => { o.passwordCredential = n.getObjectValue(createPasswordCredentialFromDiscriminatorValue_1.createPasswordCredentialFromDiscriminatorValue); },
            "proof": (o, n) => { o.proof = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the keyCredential property value.
     * @returns a keyCredential
     */
    get keyCredential() {
        return this._keyCredential;
    }
    ;
    /**
     * Sets the keyCredential property value.
     * @param value Value to set for the keyCredential property.
     */
    set keyCredential(value) {
        this._keyCredential = value;
    }
    ;
    /**
     * Gets the passwordCredential property value.
     * @returns a passwordCredential
     */
    get passwordCredential() {
        return this._passwordCredential;
    }
    ;
    /**
     * Sets the passwordCredential property value.
     * @param value Value to set for the passwordCredential property.
     */
    set passwordCredential(value) {
        this._passwordCredential = value;
    }
    ;
    /**
     * Gets the proof property value.
     * @returns a string
     */
    get proof() {
        return this._proof;
    }
    ;
    /**
     * Sets the proof property value.
     * @param value Value to set for the proof property.
     */
    set proof(value) {
        this._proof = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("keyCredential", this.keyCredential);
        writer.writeObjectValue("passwordCredential", this.passwordCredential);
        writer.writeStringValue("proof", this.proof);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.KeyCredentialRequestBody = KeyCredentialRequestBody;
