import { IncomingCallOptions, MediaConfig } from '../../../../models/microsoft/graph/';
import { Modality } from '../../../../models/microsoft/graph/modality';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the answer method.  */
export declare class AnswerRequestBody implements AdditionalDataHolder, Parsable {
    private _acceptedModalities?;
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _callbackUri?;
    private _callOptions?;
    private _mediaConfig?;
    private _participantCapacity?;
    /**
     * Gets the acceptedModalities property value.
     * @returns a modality
     */
    get acceptedModalities(): Modality[] | undefined;
    /**
     * Sets the acceptedModalities property value.
     * @param value Value to set for the acceptedModalities property.
     */
    set acceptedModalities(value: Modality[] | undefined);
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the callbackUri property value.
     * @returns a string
     */
    get callbackUri(): string | undefined;
    /**
     * Sets the callbackUri property value.
     * @param value Value to set for the callbackUri property.
     */
    set callbackUri(value: string | undefined);
    /**
     * Gets the callOptions property value.
     * @returns a incomingCallOptions
     */
    get callOptions(): IncomingCallOptions | undefined;
    /**
     * Sets the callOptions property value.
     * @param value Value to set for the callOptions property.
     */
    set callOptions(value: IncomingCallOptions | undefined);
    /**
     * Instantiates a new answerRequestBody and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the mediaConfig property value.
     * @returns a mediaConfig
     */
    get mediaConfig(): MediaConfig | undefined;
    /**
     * Sets the mediaConfig property value.
     * @param value Value to set for the mediaConfig property.
     */
    set mediaConfig(value: MediaConfig | undefined);
    /**
     * Gets the participantCapacity property value.
     * @returns a integer
     */
    get participantCapacity(): number | undefined;
    /**
     * Sets the participantCapacity property value.
     * @param value Value to set for the participantCapacity property.
     */
    set participantCapacity(value: number | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
