"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AnswerRequestBody = void 0;
const createIncomingCallOptionsFromDiscriminatorValue_1 = require("../../../../models/microsoft/graph/createIncomingCallOptionsFromDiscriminatorValue");
const createMediaConfigFromDiscriminatorValue_1 = require("../../../../models/microsoft/graph/createMediaConfigFromDiscriminatorValue");
const modality_1 = require("../../../../models/microsoft/graph/modality");
/** Provides operations to call the answer method.  */
class AnswerRequestBody {
    /**
     * Instantiates a new answerRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the acceptedModalities property value.
     * @returns a modality
     */
    get acceptedModalities() {
        return this._acceptedModalities;
    }
    ;
    /**
     * Sets the acceptedModalities property value.
     * @param value Value to set for the acceptedModalities property.
     */
    set acceptedModalities(value) {
        this._acceptedModalities = value;
    }
    ;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the callbackUri property value.
     * @returns a string
     */
    get callbackUri() {
        return this._callbackUri;
    }
    ;
    /**
     * Sets the callbackUri property value.
     * @param value Value to set for the callbackUri property.
     */
    set callbackUri(value) {
        this._callbackUri = value;
    }
    ;
    /**
     * Gets the callOptions property value.
     * @returns a incomingCallOptions
     */
    get callOptions() {
        return this._callOptions;
    }
    ;
    /**
     * Sets the callOptions property value.
     * @param value Value to set for the callOptions property.
     */
    set callOptions(value) {
        this._callOptions = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "acceptedModalities": (o, n) => { o.acceptedModalities = n.getEnumValues(modality_1.Modality); },
            "callbackUri": (o, n) => { o.callbackUri = n.getStringValue(); },
            "callOptions": (o, n) => { o.callOptions = n.getObjectValue(createIncomingCallOptionsFromDiscriminatorValue_1.createIncomingCallOptionsFromDiscriminatorValue); },
            "mediaConfig": (o, n) => { o.mediaConfig = n.getObjectValue(createMediaConfigFromDiscriminatorValue_1.createMediaConfigFromDiscriminatorValue); },
            "participantCapacity": (o, n) => { o.participantCapacity = n.getNumberValue(); },
        };
    }
    ;
    /**
     * Gets the mediaConfig property value.
     * @returns a mediaConfig
     */
    get mediaConfig() {
        return this._mediaConfig;
    }
    ;
    /**
     * Sets the mediaConfig property value.
     * @param value Value to set for the mediaConfig property.
     */
    set mediaConfig(value) {
        this._mediaConfig = value;
    }
    ;
    /**
     * Gets the participantCapacity property value.
     * @returns a integer
     */
    get participantCapacity() {
        return this._participantCapacity;
    }
    ;
    /**
     * Sets the participantCapacity property value.
     * @param value Value to set for the participantCapacity property.
     */
    set participantCapacity(value) {
        this._participantCapacity = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        this.acceptedModalities && writer.writeEnumValue("acceptedModalities", ...this.acceptedModalities);
        writer.writeStringValue("callbackUri", this.callbackUri);
        writer.writeObjectValue("callOptions", this.callOptions);
        writer.writeObjectValue("mediaConfig", this.mediaConfig);
        writer.writeNumberValue("participantCapacity", this.participantCapacity);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.AnswerRequestBody = AnswerRequestBody;
