import { InvitationParticipantInfo } from '../../../../../models/microsoft/graph/';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the invite method.  */
export declare class InviteRequestBody implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _clientContext?;
    private _participants?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the clientContext property value.
     * @returns a string
     */
    get clientContext(): string | undefined;
    /**
     * Sets the clientContext property value.
     * @param value Value to set for the clientContext property.
     */
    set clientContext(value: string | undefined);
    /**
     * Instantiates a new inviteRequestBody and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the participants property value.
     * @returns a invitationParticipantInfo
     */
    get participants(): InvitationParticipantInfo[] | undefined;
    /**
     * Sets the participants property value.
     * @param value Value to set for the participants property.
     */
    set participants(value: InvitationParticipantInfo[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
