"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RecordResponseRequestBody = void 0;
const createPromptFromDiscriminatorValue_1 = require("../../../../models/microsoft/graph/createPromptFromDiscriminatorValue");
/** Provides operations to call the recordResponse method.  */
class RecordResponseRequestBody {
    /**
     * Instantiates a new recordResponseRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the bargeInAllowed property value.
     * @returns a boolean
     */
    get bargeInAllowed() {
        return this._bargeInAllowed;
    }
    ;
    /**
     * Sets the bargeInAllowed property value.
     * @param value Value to set for the bargeInAllowed property.
     */
    set bargeInAllowed(value) {
        this._bargeInAllowed = value;
    }
    ;
    /**
     * Gets the clientContext property value.
     * @returns a string
     */
    get clientContext() {
        return this._clientContext;
    }
    ;
    /**
     * Sets the clientContext property value.
     * @param value Value to set for the clientContext property.
     */
    set clientContext(value) {
        this._clientContext = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "bargeInAllowed": (o, n) => { o.bargeInAllowed = n.getBooleanValue(); },
            "clientContext": (o, n) => { o.clientContext = n.getStringValue(); },
            "initialSilenceTimeoutInSeconds": (o, n) => { o.initialSilenceTimeoutInSeconds = n.getNumberValue(); },
            "maxRecordDurationInSeconds": (o, n) => { o.maxRecordDurationInSeconds = n.getNumberValue(); },
            "maxSilenceTimeoutInSeconds": (o, n) => { o.maxSilenceTimeoutInSeconds = n.getNumberValue(); },
            "playBeep": (o, n) => { o.playBeep = n.getBooleanValue(); },
            "prompts": (o, n) => { o.prompts = n.getCollectionOfObjectValues(createPromptFromDiscriminatorValue_1.createPromptFromDiscriminatorValue); },
            "stopTones": (o, n) => { o.stopTones = n.getCollectionOfPrimitiveValues(); },
        };
    }
    ;
    /**
     * Gets the initialSilenceTimeoutInSeconds property value.
     * @returns a integer
     */
    get initialSilenceTimeoutInSeconds() {
        return this._initialSilenceTimeoutInSeconds;
    }
    ;
    /**
     * Sets the initialSilenceTimeoutInSeconds property value.
     * @param value Value to set for the initialSilenceTimeoutInSeconds property.
     */
    set initialSilenceTimeoutInSeconds(value) {
        this._initialSilenceTimeoutInSeconds = value;
    }
    ;
    /**
     * Gets the maxRecordDurationInSeconds property value.
     * @returns a integer
     */
    get maxRecordDurationInSeconds() {
        return this._maxRecordDurationInSeconds;
    }
    ;
    /**
     * Sets the maxRecordDurationInSeconds property value.
     * @param value Value to set for the maxRecordDurationInSeconds property.
     */
    set maxRecordDurationInSeconds(value) {
        this._maxRecordDurationInSeconds = value;
    }
    ;
    /**
     * Gets the maxSilenceTimeoutInSeconds property value.
     * @returns a integer
     */
    get maxSilenceTimeoutInSeconds() {
        return this._maxSilenceTimeoutInSeconds;
    }
    ;
    /**
     * Sets the maxSilenceTimeoutInSeconds property value.
     * @param value Value to set for the maxSilenceTimeoutInSeconds property.
     */
    set maxSilenceTimeoutInSeconds(value) {
        this._maxSilenceTimeoutInSeconds = value;
    }
    ;
    /**
     * Gets the playBeep property value.
     * @returns a boolean
     */
    get playBeep() {
        return this._playBeep;
    }
    ;
    /**
     * Sets the playBeep property value.
     * @param value Value to set for the playBeep property.
     */
    set playBeep(value) {
        this._playBeep = value;
    }
    ;
    /**
     * Gets the prompts property value.
     * @returns a prompt
     */
    get prompts() {
        return this._prompts;
    }
    ;
    /**
     * Sets the prompts property value.
     * @param value Value to set for the prompts property.
     */
    set prompts(value) {
        this._prompts = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("bargeInAllowed", this.bargeInAllowed);
        writer.writeStringValue("clientContext", this.clientContext);
        writer.writeNumberValue("initialSilenceTimeoutInSeconds", this.initialSilenceTimeoutInSeconds);
        writer.writeNumberValue("maxRecordDurationInSeconds", this.maxRecordDurationInSeconds);
        writer.writeNumberValue("maxSilenceTimeoutInSeconds", this.maxSilenceTimeoutInSeconds);
        writer.writeBooleanValue("playBeep", this.playBeep);
        writer.writeCollectionOfObjectValues("prompts", this.prompts);
        writer.writeCollectionOfPrimitiveValues("stopTones", this.stopTones);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the stopTones property value.
     * @returns a string
     */
    get stopTones() {
        return this._stopTones;
    }
    ;
    /**
     * Sets the stopTones property value.
     * @param value Value to set for the stopTones property.
     */
    set stopTones(value) {
        this._stopTones = value;
    }
    ;
}
exports.RecordResponseRequestBody = RecordResponseRequestBody;
