import { InvitationParticipantInfo } from '../../../../models/microsoft/graph/';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the redirect method.  */
export declare class RedirectRequestBody implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _callbackUri?;
    private _targets?;
    private _timeout?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the callbackUri property value.
     * @returns a string
     */
    get callbackUri(): string | undefined;
    /**
     * Sets the callbackUri property value.
     * @param value Value to set for the callbackUri property.
     */
    set callbackUri(value: string | undefined);
    /**
     * Instantiates a new redirectRequestBody and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the targets property value.
     * @returns a invitationParticipantInfo
     */
    get targets(): InvitationParticipantInfo[] | undefined;
    /**
     * Sets the targets property value.
     * @param value Value to set for the targets property.
     */
    set targets(value: InvitationParticipantInfo[] | undefined);
    /**
     * Gets the timeout property value.
     * @returns a integer
     */
    get timeout(): number | undefined;
    /**
     * Sets the timeout property value.
     * @param value Value to set for the timeout property.
     */
    set timeout(value: number | undefined);
}
