import { RejectReason } from '../../../../models/microsoft/graph/rejectReason';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the reject method.  */
export declare class RejectRequestBody implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _callbackUri?;
    private _reason?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the callbackUri property value.
     * @returns a string
     */
    get callbackUri(): string | undefined;
    /**
     * Sets the callbackUri property value.
     * @param value Value to set for the callbackUri property.
     */
    set callbackUri(value: string | undefined);
    /**
     * Instantiates a new rejectRequestBody and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the reason property value.
     * @returns a rejectReason
     */
    get reason(): RejectReason | undefined;
    /**
     * Sets the reason property value.
     * @param value Value to set for the reason property.
     */
    set reason(value: RejectReason | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
