import { ChatInfo, MeetingParticipants } from '../../../models/microsoft/graph/';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the createOrGet method.  */
export declare class CreateOrGetRequestBody implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _chatInfo?;
    private _endDateTime?;
    private _externalId?;
    private _participants?;
    private _startDateTime?;
    private _subject?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the chatInfo property value.
     * @returns a chatInfo
     */
    get chatInfo(): ChatInfo | undefined;
    /**
     * Sets the chatInfo property value.
     * @param value Value to set for the chatInfo property.
     */
    set chatInfo(value: ChatInfo | undefined);
    /**
     * Instantiates a new createOrGetRequestBody and sets the default values.
     */
    constructor();
    /**
     * Gets the endDateTime property value.
     * @returns a Date
     */
    get endDateTime(): Date | undefined;
    /**
     * Sets the endDateTime property value.
     * @param value Value to set for the endDateTime property.
     */
    set endDateTime(value: Date | undefined);
    /**
     * Gets the externalId property value.
     * @returns a string
     */
    get externalId(): string | undefined;
    /**
     * Sets the externalId property value.
     * @param value Value to set for the externalId property.
     */
    set externalId(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the participants property value.
     * @returns a meetingParticipants
     */
    get participants(): MeetingParticipants | undefined;
    /**
     * Sets the participants property value.
     * @param value Value to set for the participants property.
     */
    set participants(value: MeetingParticipants | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the startDateTime property value.
     * @returns a Date
     */
    get startDateTime(): Date | undefined;
    /**
     * Sets the startDateTime property value.
     * @param value Value to set for the startDateTime property.
     */
    set startDateTime(value: Date | undefined);
    /**
     * Gets the subject property value.
     * @returns a string
     */
    get subject(): string | undefined;
    /**
     * Sets the subject property value.
     * @param value Value to set for the subject property.
     */
    set subject(value: string | undefined);
}
