import { AdditionalDataHolder, Duration, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the setPresence method.  */
export declare class SetPresenceRequestBody implements AdditionalDataHolder, Parsable {
    private _activity?;
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _availability?;
    private _expirationDuration?;
    private _sessionId?;
    /**
     * Gets the activity property value.
     * @returns a string
     */
    get activity(): string | undefined;
    /**
     * Sets the activity property value.
     * @param value Value to set for the activity property.
     */
    set activity(value: string | undefined);
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the availability property value.
     * @returns a string
     */
    get availability(): string | undefined;
    /**
     * Sets the availability property value.
     * @param value Value to set for the availability property.
     */
    set availability(value: string | undefined);
    /**
     * Instantiates a new setPresenceRequestBody and sets the default values.
     */
    constructor();
    /**
     * Gets the expirationDuration property value.
     * @returns a Duration
     */
    get expirationDuration(): Duration | undefined;
    /**
     * Sets the expirationDuration property value.
     * @param value Value to set for the expirationDuration property.
     */
    set expirationDuration(value: Duration | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the sessionId property value.
     * @returns a string
     */
    get sessionId(): string | undefined;
    /**
     * Sets the sessionId property value.
     * @param value Value to set for the sessionId property.
     */
    set sessionId(value: string | undefined);
}
