import { DeviceAppManagement } from '../models/microsoft/graph/';
import { AndroidManagedAppProtectionsRequestBuilder } from './androidManagedAppProtections/androidManagedAppProtectionsRequestBuilder';
import { AndroidManagedAppProtectionItemRequestBuilder } from './androidManagedAppProtections/item/androidManagedAppProtectionItemRequestBuilder';
import { DefaultManagedAppProtectionsRequestBuilder } from './defaultManagedAppProtections/defaultManagedAppProtectionsRequestBuilder';
import { DefaultManagedAppProtectionItemRequestBuilder } from './defaultManagedAppProtections/item/defaultManagedAppProtectionItemRequestBuilder';
import { IosManagedAppProtectionsRequestBuilder } from './iosManagedAppProtections/iosManagedAppProtectionsRequestBuilder';
import { IosManagedAppProtectionItemRequestBuilder } from './iosManagedAppProtections/item/iosManagedAppProtectionItemRequestBuilder';
import { ManagedAppPolicyItemRequestBuilder } from './managedAppPolicies/item/managedAppPolicyItemRequestBuilder';
import { ManagedAppPoliciesRequestBuilder } from './managedAppPolicies/managedAppPoliciesRequestBuilder';
import { ManagedAppRegistrationItemRequestBuilder } from './managedAppRegistrations/item/managedAppRegistrationItemRequestBuilder';
import { ManagedAppRegistrationsRequestBuilder } from './managedAppRegistrations/managedAppRegistrationsRequestBuilder';
import { ManagedAppStatusItemRequestBuilder } from './managedAppStatuses/item/managedAppStatusItemRequestBuilder';
import { ManagedAppStatusesRequestBuilder } from './managedAppStatuses/managedAppStatusesRequestBuilder';
import { ManagedEBookItemRequestBuilder } from './managedEBooks/item/managedEBookItemRequestBuilder';
import { ManagedEBooksRequestBuilder } from './managedEBooks/managedEBooksRequestBuilder';
import { MdmWindowsInformationProtectionPolicyItemRequestBuilder } from './mdmWindowsInformationProtectionPolicies/item/mdmWindowsInformationProtectionPolicyItemRequestBuilder';
import { MdmWindowsInformationProtectionPoliciesRequestBuilder } from './mdmWindowsInformationProtectionPolicies/mdmWindowsInformationProtectionPoliciesRequestBuilder';
import { MobileAppCategoryItemRequestBuilder } from './mobileAppCategories/item/mobileAppCategoryItemRequestBuilder';
import { MobileAppCategoriesRequestBuilder } from './mobileAppCategories/mobileAppCategoriesRequestBuilder';
import { ManagedDeviceMobileAppConfigurationItemRequestBuilder } from './mobileAppConfigurations/item/managedDeviceMobileAppConfigurationItemRequestBuilder';
import { MobileAppConfigurationsRequestBuilder } from './mobileAppConfigurations/mobileAppConfigurationsRequestBuilder';
import { MobileAppItemRequestBuilder } from './mobileApps/item/mobileAppItemRequestBuilder';
import { MobileAppsRequestBuilder } from './mobileApps/mobileAppsRequestBuilder';
import { SyncMicrosoftStoreForBusinessAppsRequestBuilder } from './syncMicrosoftStoreForBusinessApps/syncMicrosoftStoreForBusinessAppsRequestBuilder';
import { TargetedManagedAppConfigurationItemRequestBuilder } from './targetedManagedAppConfigurations/item/targetedManagedAppConfigurationItemRequestBuilder';
import { TargetedManagedAppConfigurationsRequestBuilder } from './targetedManagedAppConfigurations/targetedManagedAppConfigurationsRequestBuilder';
import { VppTokenItemRequestBuilder } from './vppTokens/item/vppTokenItemRequestBuilder';
import { VppTokensRequestBuilder } from './vppTokens/vppTokensRequestBuilder';
import { WindowsInformationProtectionPolicyItemRequestBuilder } from './windowsInformationProtectionPolicies/item/windowsInformationProtectionPolicyItemRequestBuilder';
import { WindowsInformationProtectionPoliciesRequestBuilder } from './windowsInformationProtectionPolicies/windowsInformationProtectionPoliciesRequestBuilder';
import { RequestAdapter, RequestInformation, RequestOption, ResponseHandler } from '@microsoft/kiota-abstractions';
/** Provides operations to manage the deviceAppManagement singleton.  */
export declare class DeviceAppManagementRequestBuilder {
    get androidManagedAppProtections(): AndroidManagedAppProtectionsRequestBuilder;
    get defaultManagedAppProtections(): DefaultManagedAppProtectionsRequestBuilder;
    get iosManagedAppProtections(): IosManagedAppProtectionsRequestBuilder;
    get managedAppPolicies(): ManagedAppPoliciesRequestBuilder;
    get managedAppRegistrations(): ManagedAppRegistrationsRequestBuilder;
    get managedAppStatuses(): ManagedAppStatusesRequestBuilder;
    get managedEBooks(): ManagedEBooksRequestBuilder;
    get mdmWindowsInformationProtectionPolicies(): MdmWindowsInformationProtectionPoliciesRequestBuilder;
    get mobileAppCategories(): MobileAppCategoriesRequestBuilder;
    get mobileAppConfigurations(): MobileAppConfigurationsRequestBuilder;
    get mobileApps(): MobileAppsRequestBuilder;
    /** Path parameters for the request  */
    private readonly pathParameters;
    /** The request adapter to use to execute the requests.  */
    private readonly requestAdapter;
    get syncMicrosoftStoreForBusinessApps(): SyncMicrosoftStoreForBusinessAppsRequestBuilder;
    get targetedManagedAppConfigurations(): TargetedManagedAppConfigurationsRequestBuilder;
    /** Url template to use to build the URL for the current request builder  */
    private readonly urlTemplate;
    get vppTokens(): VppTokensRequestBuilder;
    get windowsInformationProtectionPolicies(): WindowsInformationProtectionPoliciesRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.androidManagedAppProtections.item collection
     * @param id Unique identifier of the item
     * @returns a androidManagedAppProtectionItemRequestBuilder
     */
    androidManagedAppProtectionsById(id: string): AndroidManagedAppProtectionItemRequestBuilder;
    /**
     * Instantiates a new DeviceAppManagementRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters: Record<string, unknown> | string | undefined, requestAdapter: RequestAdapter);
    /**
     * Get deviceAppManagement
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @returns a RequestInformation
     */
    createGetRequestInformation(q?: {
        expand?: string[];
        select?: string[];
    } | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Update deviceAppManagement
     * @param body
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createPatchRequestInformation(body: DeviceAppManagement | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.defaultManagedAppProtections.item collection
     * @param id Unique identifier of the item
     * @returns a defaultManagedAppProtectionItemRequestBuilder
     */
    defaultManagedAppProtectionsById(id: string): DefaultManagedAppProtectionItemRequestBuilder;
    /**
     * Get deviceAppManagement
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     * @returns a Promise of DeviceAppManagement
     */
    get(q?: {
        expand?: string[];
        select?: string[];
    } | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<DeviceAppManagement | undefined>;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.iosManagedAppProtections.item collection
     * @param id Unique identifier of the item
     * @returns a iosManagedAppProtectionItemRequestBuilder
     */
    iosManagedAppProtectionsById(id: string): IosManagedAppProtectionItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.managedAppPolicies.item collection
     * @param id Unique identifier of the item
     * @returns a managedAppPolicyItemRequestBuilder
     */
    managedAppPoliciesById(id: string): ManagedAppPolicyItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.managedAppRegistrations.item collection
     * @param id Unique identifier of the item
     * @returns a managedAppRegistrationItemRequestBuilder
     */
    managedAppRegistrationsById(id: string): ManagedAppRegistrationItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.managedAppStatuses.item collection
     * @param id Unique identifier of the item
     * @returns a managedAppStatusItemRequestBuilder
     */
    managedAppStatusesById(id: string): ManagedAppStatusItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.managedEBooks.item collection
     * @param id Unique identifier of the item
     * @returns a managedEBookItemRequestBuilder
     */
    managedEBooksById(id: string): ManagedEBookItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.mdmWindowsInformationProtectionPolicies.item collection
     * @param id Unique identifier of the item
     * @returns a mdmWindowsInformationProtectionPolicyItemRequestBuilder
     */
    mdmWindowsInformationProtectionPoliciesById(id: string): MdmWindowsInformationProtectionPolicyItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.mobileAppCategories.item collection
     * @param id Unique identifier of the item
     * @returns a mobileAppCategoryItemRequestBuilder
     */
    mobileAppCategoriesById(id: string): MobileAppCategoryItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.mobileAppConfigurations.item collection
     * @param id Unique identifier of the item
     * @returns a managedDeviceMobileAppConfigurationItemRequestBuilder
     */
    mobileAppConfigurationsById(id: string): ManagedDeviceMobileAppConfigurationItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.mobileApps.item collection
     * @param id Unique identifier of the item
     * @returns a mobileAppItemRequestBuilder
     */
    mobileAppsById(id: string): MobileAppItemRequestBuilder;
    /**
     * Update deviceAppManagement
     * @param body
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    patch(body: DeviceAppManagement | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<void>;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.targetedManagedAppConfigurations.item collection
     * @param id Unique identifier of the item
     * @returns a targetedManagedAppConfigurationItemRequestBuilder
     */
    targetedManagedAppConfigurationsById(id: string): TargetedManagedAppConfigurationItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.vppTokens.item collection
     * @param id Unique identifier of the item
     * @returns a vppTokenItemRequestBuilder
     */
    vppTokensById(id: string): VppTokenItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.windowsInformationProtectionPolicies.item collection
     * @param id Unique identifier of the item
     * @returns a windowsInformationProtectionPolicyItemRequestBuilder
     */
    windowsInformationProtectionPoliciesById(id: string): WindowsInformationProtectionPolicyItemRequestBuilder;
}
