"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeviceAppManagementRequestBuilder = void 0;
const createDeviceAppManagementFromDiscriminatorValue_1 = require("../models/microsoft/graph/createDeviceAppManagementFromDiscriminatorValue");
const createODataErrorFromDiscriminatorValue_1 = require("../models/microsoft/graph/oDataErrors/createODataErrorFromDiscriminatorValue");
const androidManagedAppProtectionsRequestBuilder_1 = require("./androidManagedAppProtections/androidManagedAppProtectionsRequestBuilder");
const androidManagedAppProtectionItemRequestBuilder_1 = require("./androidManagedAppProtections/item/androidManagedAppProtectionItemRequestBuilder");
const defaultManagedAppProtectionsRequestBuilder_1 = require("./defaultManagedAppProtections/defaultManagedAppProtectionsRequestBuilder");
const defaultManagedAppProtectionItemRequestBuilder_1 = require("./defaultManagedAppProtections/item/defaultManagedAppProtectionItemRequestBuilder");
const iosManagedAppProtectionsRequestBuilder_1 = require("./iosManagedAppProtections/iosManagedAppProtectionsRequestBuilder");
const iosManagedAppProtectionItemRequestBuilder_1 = require("./iosManagedAppProtections/item/iosManagedAppProtectionItemRequestBuilder");
const managedAppPolicyItemRequestBuilder_1 = require("./managedAppPolicies/item/managedAppPolicyItemRequestBuilder");
const managedAppPoliciesRequestBuilder_1 = require("./managedAppPolicies/managedAppPoliciesRequestBuilder");
const managedAppRegistrationItemRequestBuilder_1 = require("./managedAppRegistrations/item/managedAppRegistrationItemRequestBuilder");
const managedAppRegistrationsRequestBuilder_1 = require("./managedAppRegistrations/managedAppRegistrationsRequestBuilder");
const managedAppStatusItemRequestBuilder_1 = require("./managedAppStatuses/item/managedAppStatusItemRequestBuilder");
const managedAppStatusesRequestBuilder_1 = require("./managedAppStatuses/managedAppStatusesRequestBuilder");
const managedEBookItemRequestBuilder_1 = require("./managedEBooks/item/managedEBookItemRequestBuilder");
const managedEBooksRequestBuilder_1 = require("./managedEBooks/managedEBooksRequestBuilder");
const mdmWindowsInformationProtectionPolicyItemRequestBuilder_1 = require("./mdmWindowsInformationProtectionPolicies/item/mdmWindowsInformationProtectionPolicyItemRequestBuilder");
const mdmWindowsInformationProtectionPoliciesRequestBuilder_1 = require("./mdmWindowsInformationProtectionPolicies/mdmWindowsInformationProtectionPoliciesRequestBuilder");
const mobileAppCategoryItemRequestBuilder_1 = require("./mobileAppCategories/item/mobileAppCategoryItemRequestBuilder");
const mobileAppCategoriesRequestBuilder_1 = require("./mobileAppCategories/mobileAppCategoriesRequestBuilder");
const managedDeviceMobileAppConfigurationItemRequestBuilder_1 = require("./mobileAppConfigurations/item/managedDeviceMobileAppConfigurationItemRequestBuilder");
const mobileAppConfigurationsRequestBuilder_1 = require("./mobileAppConfigurations/mobileAppConfigurationsRequestBuilder");
const mobileAppItemRequestBuilder_1 = require("./mobileApps/item/mobileAppItemRequestBuilder");
const mobileAppsRequestBuilder_1 = require("./mobileApps/mobileAppsRequestBuilder");
const syncMicrosoftStoreForBusinessAppsRequestBuilder_1 = require("./syncMicrosoftStoreForBusinessApps/syncMicrosoftStoreForBusinessAppsRequestBuilder");
const targetedManagedAppConfigurationItemRequestBuilder_1 = require("./targetedManagedAppConfigurations/item/targetedManagedAppConfigurationItemRequestBuilder");
const targetedManagedAppConfigurationsRequestBuilder_1 = require("./targetedManagedAppConfigurations/targetedManagedAppConfigurationsRequestBuilder");
const vppTokenItemRequestBuilder_1 = require("./vppTokens/item/vppTokenItemRequestBuilder");
const vppTokensRequestBuilder_1 = require("./vppTokens/vppTokensRequestBuilder");
const windowsInformationProtectionPolicyItemRequestBuilder_1 = require("./windowsInformationProtectionPolicies/item/windowsInformationProtectionPolicyItemRequestBuilder");
const windowsInformationProtectionPoliciesRequestBuilder_1 = require("./windowsInformationProtectionPolicies/windowsInformationProtectionPoliciesRequestBuilder");
const kiota_abstractions_1 = require("@microsoft/kiota-abstractions");
/** Provides operations to manage the deviceAppManagement singleton.  */
class DeviceAppManagementRequestBuilder {
    /**
     * Instantiates a new DeviceAppManagementRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters, requestAdapter) {
        if (!pathParameters)
            throw new Error("pathParameters cannot be undefined");
        if (!requestAdapter)
            throw new Error("requestAdapter cannot be undefined");
        this.urlTemplate = "{+baseurl}/deviceAppManagement{?select,expand}";
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(pathParameters);
        this.pathParameters = urlTplParams;
        this.requestAdapter = requestAdapter;
    }
    get androidManagedAppProtections() {
        return new androidManagedAppProtectionsRequestBuilder_1.AndroidManagedAppProtectionsRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get defaultManagedAppProtections() {
        return new defaultManagedAppProtectionsRequestBuilder_1.DefaultManagedAppProtectionsRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get iosManagedAppProtections() {
        return new iosManagedAppProtectionsRequestBuilder_1.IosManagedAppProtectionsRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get managedAppPolicies() {
        return new managedAppPoliciesRequestBuilder_1.ManagedAppPoliciesRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get managedAppRegistrations() {
        return new managedAppRegistrationsRequestBuilder_1.ManagedAppRegistrationsRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get managedAppStatuses() {
        return new managedAppStatusesRequestBuilder_1.ManagedAppStatusesRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get managedEBooks() {
        return new managedEBooksRequestBuilder_1.ManagedEBooksRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get mdmWindowsInformationProtectionPolicies() {
        return new mdmWindowsInformationProtectionPoliciesRequestBuilder_1.MdmWindowsInformationProtectionPoliciesRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get mobileAppCategories() {
        return new mobileAppCategoriesRequestBuilder_1.MobileAppCategoriesRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get mobileAppConfigurations() {
        return new mobileAppConfigurationsRequestBuilder_1.MobileAppConfigurationsRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get mobileApps() {
        return new mobileAppsRequestBuilder_1.MobileAppsRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get syncMicrosoftStoreForBusinessApps() {
        return new syncMicrosoftStoreForBusinessAppsRequestBuilder_1.SyncMicrosoftStoreForBusinessAppsRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get targetedManagedAppConfigurations() {
        return new targetedManagedAppConfigurationsRequestBuilder_1.TargetedManagedAppConfigurationsRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get vppTokens() {
        return new vppTokensRequestBuilder_1.VppTokensRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get windowsInformationProtectionPolicies() {
        return new windowsInformationProtectionPoliciesRequestBuilder_1.WindowsInformationProtectionPoliciesRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.androidManagedAppProtections.item collection
     * @param id Unique identifier of the item
     * @returns a androidManagedAppProtectionItemRequestBuilder
     */
    androidManagedAppProtectionsById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["androidManagedAppProtection_id"] = id;
        return new androidManagedAppProtectionItemRequestBuilder_1.AndroidManagedAppProtectionItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    ;
    /**
     * Get deviceAppManagement
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @returns a RequestInformation
     */
    createGetRequestInformation(q, h, o) {
        const requestInfo = new kiota_abstractions_1.RequestInformation();
        requestInfo.urlTemplate = this.urlTemplate;
        requestInfo.pathParameters = this.pathParameters;
        requestInfo.httpMethod = kiota_abstractions_1.HttpMethod.GET;
        if (h)
            requestInfo.headers = h;
        q && requestInfo.setQueryStringParametersFromRawObject(q);
        o && requestInfo.addRequestOptions(...o);
        return requestInfo;
    }
    ;
    /**
     * Update deviceAppManagement
     * @param body
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createPatchRequestInformation(body, h, o) {
        if (!body)
            throw new Error("body cannot be undefined");
        const requestInfo = new kiota_abstractions_1.RequestInformation();
        requestInfo.urlTemplate = this.urlTemplate;
        requestInfo.pathParameters = this.pathParameters;
        requestInfo.httpMethod = kiota_abstractions_1.HttpMethod.PATCH;
        if (h)
            requestInfo.headers = h;
        requestInfo.setContentFromParsable(this.requestAdapter, "application/json", body);
        o && requestInfo.addRequestOptions(...o);
        return requestInfo;
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.defaultManagedAppProtections.item collection
     * @param id Unique identifier of the item
     * @returns a defaultManagedAppProtectionItemRequestBuilder
     */
    defaultManagedAppProtectionsById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["defaultManagedAppProtection_id"] = id;
        return new defaultManagedAppProtectionItemRequestBuilder_1.DefaultManagedAppProtectionItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Get deviceAppManagement
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     * @returns a Promise of DeviceAppManagement
     */
    get(q, h, o, responseHandler) {
        var _a, _b;
        const requestInfo = this.createGetRequestInformation(q, h, o);
        const errorMapping = {
            "4XX": createODataErrorFromDiscriminatorValue_1.createODataErrorFromDiscriminatorValue,
            "5XX": createODataErrorFromDiscriminatorValue_1.createODataErrorFromDiscriminatorValue,
        };
        return (_b = (_a = this.requestAdapter) === null || _a === void 0 ? void 0 : _a.sendAsync(requestInfo, createDeviceAppManagementFromDiscriminatorValue_1.createDeviceAppManagementFromDiscriminatorValue, responseHandler, errorMapping)) !== null && _b !== void 0 ? _b : Promise.reject(new Error('http core is null'));
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.iosManagedAppProtections.item collection
     * @param id Unique identifier of the item
     * @returns a iosManagedAppProtectionItemRequestBuilder
     */
    iosManagedAppProtectionsById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["iosManagedAppProtection_id"] = id;
        return new iosManagedAppProtectionItemRequestBuilder_1.IosManagedAppProtectionItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.managedAppPolicies.item collection
     * @param id Unique identifier of the item
     * @returns a managedAppPolicyItemRequestBuilder
     */
    managedAppPoliciesById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["managedAppPolicy_id"] = id;
        return new managedAppPolicyItemRequestBuilder_1.ManagedAppPolicyItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.managedAppRegistrations.item collection
     * @param id Unique identifier of the item
     * @returns a managedAppRegistrationItemRequestBuilder
     */
    managedAppRegistrationsById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["managedAppRegistration_id"] = id;
        return new managedAppRegistrationItemRequestBuilder_1.ManagedAppRegistrationItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.managedAppStatuses.item collection
     * @param id Unique identifier of the item
     * @returns a managedAppStatusItemRequestBuilder
     */
    managedAppStatusesById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["managedAppStatus_id"] = id;
        return new managedAppStatusItemRequestBuilder_1.ManagedAppStatusItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.managedEBooks.item collection
     * @param id Unique identifier of the item
     * @returns a managedEBookItemRequestBuilder
     */
    managedEBooksById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["managedEBook_id"] = id;
        return new managedEBookItemRequestBuilder_1.ManagedEBookItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.mdmWindowsInformationProtectionPolicies.item collection
     * @param id Unique identifier of the item
     * @returns a mdmWindowsInformationProtectionPolicyItemRequestBuilder
     */
    mdmWindowsInformationProtectionPoliciesById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["mdmWindowsInformationProtectionPolicy_id"] = id;
        return new mdmWindowsInformationProtectionPolicyItemRequestBuilder_1.MdmWindowsInformationProtectionPolicyItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.mobileAppCategories.item collection
     * @param id Unique identifier of the item
     * @returns a mobileAppCategoryItemRequestBuilder
     */
    mobileAppCategoriesById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["mobileAppCategory_id"] = id;
        return new mobileAppCategoryItemRequestBuilder_1.MobileAppCategoryItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.mobileAppConfigurations.item collection
     * @param id Unique identifier of the item
     * @returns a managedDeviceMobileAppConfigurationItemRequestBuilder
     */
    mobileAppConfigurationsById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["managedDeviceMobileAppConfiguration_id"] = id;
        return new managedDeviceMobileAppConfigurationItemRequestBuilder_1.ManagedDeviceMobileAppConfigurationItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.mobileApps.item collection
     * @param id Unique identifier of the item
     * @returns a mobileAppItemRequestBuilder
     */
    mobileAppsById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["mobileApp_id"] = id;
        return new mobileAppItemRequestBuilder_1.MobileAppItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Update deviceAppManagement
     * @param body
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    patch(body, h, o, responseHandler) {
        var _a, _b;
        if (!body)
            throw new Error("body cannot be undefined");
        const requestInfo = this.createPatchRequestInformation(body, h, o);
        const errorMapping = {
            "4XX": createODataErrorFromDiscriminatorValue_1.createODataErrorFromDiscriminatorValue,
            "5XX": createODataErrorFromDiscriminatorValue_1.createODataErrorFromDiscriminatorValue,
        };
        return (_b = (_a = this.requestAdapter) === null || _a === void 0 ? void 0 : _a.sendNoResponseContentAsync(requestInfo, responseHandler, errorMapping)) !== null && _b !== void 0 ? _b : Promise.reject(new Error('http core is null'));
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.targetedManagedAppConfigurations.item collection
     * @param id Unique identifier of the item
     * @returns a targetedManagedAppConfigurationItemRequestBuilder
     */
    targetedManagedAppConfigurationsById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["targetedManagedAppConfiguration_id"] = id;
        return new targetedManagedAppConfigurationItemRequestBuilder_1.TargetedManagedAppConfigurationItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.vppTokens.item collection
     * @param id Unique identifier of the item
     * @returns a vppTokenItemRequestBuilder
     */
    vppTokensById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["vppToken_id"] = id;
        return new vppTokenItemRequestBuilder_1.VppTokenItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.windowsInformationProtectionPolicies.item collection
     * @param id Unique identifier of the item
     * @returns a windowsInformationProtectionPolicyItemRequestBuilder
     */
    windowsInformationProtectionPoliciesById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["windowsInformationProtectionPolicy_id"] = id;
        return new windowsInformationProtectionPolicyItemRequestBuilder_1.WindowsInformationProtectionPolicyItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
}
exports.DeviceAppManagementRequestBuilder = DeviceAppManagementRequestBuilder;
