"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TargetAppsRequestBody = void 0;
const createManagedMobileAppFromDiscriminatorValue_1 = require("../../../../../../../models/microsoft/graph/createManagedMobileAppFromDiscriminatorValue");
const targetedManagedAppGroupType_1 = require("../../../../../../../models/microsoft/graph/targetedManagedAppGroupType");
/** Provides operations to call the targetApps method.  */
class TargetAppsRequestBody {
    /**
     * Instantiates a new targetAppsRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the appGroupType property value.
     * @returns a targetedManagedAppGroupType
     */
    get appGroupType() {
        return this._appGroupType;
    }
    ;
    /**
     * Sets the appGroupType property value.
     * @param value Value to set for the appGroupType property.
     */
    set appGroupType(value) {
        this._appGroupType = value;
    }
    ;
    /**
     * Gets the apps property value.
     * @returns a managedMobileApp
     */
    get apps() {
        return this._apps;
    }
    ;
    /**
     * Sets the apps property value.
     * @param value Value to set for the apps property.
     */
    set apps(value) {
        this._apps = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "appGroupType": (o, n) => { o.appGroupType = n.getEnumValue(targetedManagedAppGroupType_1.TargetedManagedAppGroupType); },
            "apps": (o, n) => { o.apps = n.getCollectionOfObjectValues(createManagedMobileAppFromDiscriminatorValue_1.createManagedMobileAppFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeEnumValue("appGroupType", this.appGroupType);
        writer.writeCollectionOfObjectValues("apps", this.apps);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.TargetAppsRequestBody = TargetAppsRequestBody;
