import { ManagedDeviceMobileAppConfiguration } from '../../../models/microsoft/graph/';
import { AssignRequestBuilder } from './assign/assignRequestBuilder';
import { AssignmentsRequestBuilder } from './assignments/assignmentsRequestBuilder';
import { ManagedDeviceMobileAppConfigurationAssignmentItemRequestBuilder } from './assignments/item/managedDeviceMobileAppConfigurationAssignmentItemRequestBuilder';
import { DeviceStatusesRequestBuilder } from './deviceStatuses/deviceStatusesRequestBuilder';
import { ManagedDeviceMobileAppConfigurationDeviceStatusItemRequestBuilder } from './deviceStatuses/item/managedDeviceMobileAppConfigurationDeviceStatusItemRequestBuilder';
import { DeviceStatusSummaryRequestBuilder } from './deviceStatusSummary/deviceStatusSummaryRequestBuilder';
import { ManagedDeviceMobileAppConfigurationUserStatusItemRequestBuilder } from './userStatuses/item/managedDeviceMobileAppConfigurationUserStatusItemRequestBuilder';
import { UserStatusesRequestBuilder } from './userStatuses/userStatusesRequestBuilder';
import { UserStatusSummaryRequestBuilder } from './userStatusSummary/userStatusSummaryRequestBuilder';
import { RequestAdapter, RequestInformation, RequestOption, ResponseHandler } from '@microsoft/kiota-abstractions';
/** Provides operations to manage the mobileAppConfigurations property of the microsoft.graph.deviceAppManagement entity.  */
export declare class ManagedDeviceMobileAppConfigurationItemRequestBuilder {
    get assign(): AssignRequestBuilder;
    get assignments(): AssignmentsRequestBuilder;
    get deviceStatuses(): DeviceStatusesRequestBuilder;
    get deviceStatusSummary(): DeviceStatusSummaryRequestBuilder;
    /** Path parameters for the request  */
    private readonly pathParameters;
    /** The request adapter to use to execute the requests.  */
    private readonly requestAdapter;
    /** Url template to use to build the URL for the current request builder  */
    private readonly urlTemplate;
    get userStatuses(): UserStatusesRequestBuilder;
    get userStatusSummary(): UserStatusSummaryRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.mobileAppConfigurations.item.assignments.item collection
     * @param id Unique identifier of the item
     * @returns a managedDeviceMobileAppConfigurationAssignmentItemRequestBuilder
     */
    assignmentsById(id: string): ManagedDeviceMobileAppConfigurationAssignmentItemRequestBuilder;
    /**
     * Instantiates a new ManagedDeviceMobileAppConfigurationItemRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters: Record<string, unknown> | string | undefined, requestAdapter: RequestAdapter);
    /**
     * Delete navigation property mobileAppConfigurations for deviceAppManagement
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createDeleteRequestInformation(h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * The Managed Device Mobile Application Configurations.
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @returns a RequestInformation
     */
    createGetRequestInformation(q?: {
        expand?: string[];
        select?: string[];
    } | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Update the navigation property mobileAppConfigurations in deviceAppManagement
     * @param body
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createPatchRequestInformation(body: ManagedDeviceMobileAppConfiguration | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Delete navigation property mobileAppConfigurations for deviceAppManagement
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    delete(h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<void>;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.mobileAppConfigurations.item.deviceStatuses.item collection
     * @param id Unique identifier of the item
     * @returns a managedDeviceMobileAppConfigurationDeviceStatusItemRequestBuilder
     */
    deviceStatusesById(id: string): ManagedDeviceMobileAppConfigurationDeviceStatusItemRequestBuilder;
    /**
     * The Managed Device Mobile Application Configurations.
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     * @returns a Promise of ManagedDeviceMobileAppConfiguration
     */
    get(q?: {
        expand?: string[];
        select?: string[];
    } | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<ManagedDeviceMobileAppConfiguration | undefined>;
    /**
     * Update the navigation property mobileAppConfigurations in deviceAppManagement
     * @param body
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    patch(body: ManagedDeviceMobileAppConfiguration | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<void>;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceAppManagement.mobileAppConfigurations.item.userStatuses.item collection
     * @param id Unique identifier of the item
     * @returns a managedDeviceMobileAppConfigurationUserStatusItemRequestBuilder
     */
    userStatusesById(id: string): ManagedDeviceMobileAppConfigurationUserStatusItemRequestBuilder;
}
