import { DeviceComplianceScheduledActionForRule } from '../../../../models/microsoft/graph/';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the scheduleActionsForRules method.  */
export declare class ScheduleActionsForRulesRequestBody implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _deviceComplianceScheduledActionForRules?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new scheduleActionsForRulesRequestBody and sets the default values.
     */
    constructor();
    /**
     * Gets the deviceComplianceScheduledActionForRules property value.
     * @returns a deviceComplianceScheduledActionForRule
     */
    get deviceComplianceScheduledActionForRules(): DeviceComplianceScheduledActionForRule[] | undefined;
    /**
     * Sets the deviceComplianceScheduledActionForRules property value.
     * @param value Value to set for the deviceComplianceScheduledActionForRules property.
     */
    set deviceComplianceScheduledActionForRules(value: DeviceComplianceScheduledActionForRule[] | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
