import { DeviceManagement } from '../models/microsoft/graph/';
import { ApplePushNotificationCertificateRequestBuilder } from './applePushNotificationCertificate/applePushNotificationCertificateRequestBuilder';
import { ComplianceManagementPartnersRequestBuilder } from './complianceManagementPartners/complianceManagementPartnersRequestBuilder';
import { ComplianceManagementPartnerItemRequestBuilder } from './complianceManagementPartners/item/complianceManagementPartnerItemRequestBuilder';
import { ConditionalAccessSettingsRequestBuilder } from './conditionalAccessSettings/conditionalAccessSettingsRequestBuilder';
import { DetectedAppsRequestBuilder } from './detectedApps/detectedAppsRequestBuilder';
import { DetectedAppItemRequestBuilder } from './detectedApps/item/detectedAppItemRequestBuilder';
import { DeviceCategoriesRequestBuilder } from './deviceCategories/deviceCategoriesRequestBuilder';
import { DeviceCategoryItemRequestBuilder } from './deviceCategories/item/deviceCategoryItemRequestBuilder';
import { DeviceCompliancePoliciesRequestBuilder } from './deviceCompliancePolicies/deviceCompliancePoliciesRequestBuilder';
import { DeviceCompliancePolicyItemRequestBuilder } from './deviceCompliancePolicies/item/deviceCompliancePolicyItemRequestBuilder';
import { DeviceCompliancePolicyDeviceStateSummaryRequestBuilder } from './deviceCompliancePolicyDeviceStateSummary/deviceCompliancePolicyDeviceStateSummaryRequestBuilder';
import { DeviceCompliancePolicySettingStateSummariesRequestBuilder } from './deviceCompliancePolicySettingStateSummaries/deviceCompliancePolicySettingStateSummariesRequestBuilder';
import { DeviceCompliancePolicySettingStateSummaryItemRequestBuilder } from './deviceCompliancePolicySettingStateSummaries/item/deviceCompliancePolicySettingStateSummaryItemRequestBuilder';
import { DeviceConfigurationDeviceStateSummariesRequestBuilder } from './deviceConfigurationDeviceStateSummaries/deviceConfigurationDeviceStateSummariesRequestBuilder';
import { DeviceConfigurationsRequestBuilder } from './deviceConfigurations/deviceConfigurationsRequestBuilder';
import { DeviceConfigurationItemRequestBuilder } from './deviceConfigurations/item/deviceConfigurationItemRequestBuilder';
import { DeviceEnrollmentConfigurationsRequestBuilder } from './deviceEnrollmentConfigurations/deviceEnrollmentConfigurationsRequestBuilder';
import { DeviceEnrollmentConfigurationItemRequestBuilder } from './deviceEnrollmentConfigurations/item/deviceEnrollmentConfigurationItemRequestBuilder';
import { DeviceManagementPartnersRequestBuilder } from './deviceManagementPartners/deviceManagementPartnersRequestBuilder';
import { DeviceManagementPartnerItemRequestBuilder } from './deviceManagementPartners/item/deviceManagementPartnerItemRequestBuilder';
import { ExchangeConnectorsRequestBuilder } from './exchangeConnectors/exchangeConnectorsRequestBuilder';
import { DeviceManagementExchangeConnectorItemRequestBuilder } from './exchangeConnectors/item/deviceManagementExchangeConnectorItemRequestBuilder';
import { GetEffectivePermissionsWithScopeRequestBuilder } from './getEffectivePermissionsWithScope/getEffectivePermissionsWithScopeRequestBuilder';
import { ImportedWindowsAutopilotDeviceIdentitiesRequestBuilder } from './importedWindowsAutopilotDeviceIdentities/importedWindowsAutopilotDeviceIdentitiesRequestBuilder';
import { ImportedWindowsAutopilotDeviceIdentityItemRequestBuilder } from './importedWindowsAutopilotDeviceIdentities/item/importedWindowsAutopilotDeviceIdentityItemRequestBuilder';
import { IosUpdateStatusesRequestBuilder } from './iosUpdateStatuses/iosUpdateStatusesRequestBuilder';
import { IosUpdateDeviceStatusItemRequestBuilder } from './iosUpdateStatuses/item/iosUpdateDeviceStatusItemRequestBuilder';
import { ManagedDeviceOverviewRequestBuilder } from './managedDeviceOverview/managedDeviceOverviewRequestBuilder';
import { ManagedDeviceItemRequestBuilder } from './managedDevices/item/managedDeviceItemRequestBuilder';
import { ManagedDevicesRequestBuilder } from './managedDevices/managedDevicesRequestBuilder';
import { MobileThreatDefenseConnectorItemRequestBuilder } from './mobileThreatDefenseConnectors/item/mobileThreatDefenseConnectorItemRequestBuilder';
import { MobileThreatDefenseConnectorsRequestBuilder } from './mobileThreatDefenseConnectors/mobileThreatDefenseConnectorsRequestBuilder';
import { NotificationMessageTemplateItemRequestBuilder } from './notificationMessageTemplates/item/notificationMessageTemplateItemRequestBuilder';
import { NotificationMessageTemplatesRequestBuilder } from './notificationMessageTemplates/notificationMessageTemplatesRequestBuilder';
import { RemoteAssistancePartnerItemRequestBuilder } from './remoteAssistancePartners/item/remoteAssistancePartnerItemRequestBuilder';
import { RemoteAssistancePartnersRequestBuilder } from './remoteAssistancePartners/remoteAssistancePartnersRequestBuilder';
import { ReportsRequestBuilder } from './reports/reportsRequestBuilder';
import { ResourceOperationItemRequestBuilder } from './resourceOperations/item/resourceOperationItemRequestBuilder';
import { ResourceOperationsRequestBuilder } from './resourceOperations/resourceOperationsRequestBuilder';
import { DeviceAndAppManagementRoleAssignmentItemRequestBuilder } from './roleAssignments/item/deviceAndAppManagementRoleAssignmentItemRequestBuilder';
import { RoleAssignmentsRequestBuilder } from './roleAssignments/roleAssignmentsRequestBuilder';
import { RoleDefinitionItemRequestBuilder } from './roleDefinitions/item/roleDefinitionItemRequestBuilder';
import { RoleDefinitionsRequestBuilder } from './roleDefinitions/roleDefinitionsRequestBuilder';
import { SoftwareUpdateStatusSummaryRequestBuilder } from './softwareUpdateStatusSummary/softwareUpdateStatusSummaryRequestBuilder';
import { TelecomExpenseManagementPartnerItemRequestBuilder } from './telecomExpenseManagementPartners/item/telecomExpenseManagementPartnerItemRequestBuilder';
import { TelecomExpenseManagementPartnersRequestBuilder } from './telecomExpenseManagementPartners/telecomExpenseManagementPartnersRequestBuilder';
import { TermsAndConditionsItemRequestBuilder } from './termsAndConditions/item/termsAndConditionsItemRequestBuilder';
import { TermsAndConditionsRequestBuilder } from './termsAndConditions/termsAndConditionsRequestBuilder';
import { DeviceManagementTroubleshootingEventItemRequestBuilder } from './troubleshootingEvents/item/deviceManagementTroubleshootingEventItemRequestBuilder';
import { TroubleshootingEventsRequestBuilder } from './troubleshootingEvents/troubleshootingEventsRequestBuilder';
import { VerifyWindowsEnrollmentAutoDiscoveryWithDomainNameRequestBuilder } from './verifyWindowsEnrollmentAutoDiscoveryWithDomainName/verifyWindowsEnrollmentAutoDiscoveryWithDomainNameRequestBuilder';
import { WindowsAutopilotDeviceIdentityItemRequestBuilder } from './windowsAutopilotDeviceIdentities/item/windowsAutopilotDeviceIdentityItemRequestBuilder';
import { WindowsAutopilotDeviceIdentitiesRequestBuilder } from './windowsAutopilotDeviceIdentities/windowsAutopilotDeviceIdentitiesRequestBuilder';
import { WindowsInformationProtectionAppLearningSummaryItemRequestBuilder } from './windowsInformationProtectionAppLearningSummaries/item/windowsInformationProtectionAppLearningSummaryItemRequestBuilder';
import { WindowsInformationProtectionAppLearningSummariesRequestBuilder } from './windowsInformationProtectionAppLearningSummaries/windowsInformationProtectionAppLearningSummariesRequestBuilder';
import { WindowsInformationProtectionNetworkLearningSummaryItemRequestBuilder } from './windowsInformationProtectionNetworkLearningSummaries/item/windowsInformationProtectionNetworkLearningSummaryItemRequestBuilder';
import { WindowsInformationProtectionNetworkLearningSummariesRequestBuilder } from './windowsInformationProtectionNetworkLearningSummaries/windowsInformationProtectionNetworkLearningSummariesRequestBuilder';
import { RequestAdapter, RequestInformation, RequestOption, ResponseHandler } from '@microsoft/kiota-abstractions';
/** Provides operations to manage the deviceManagement singleton.  */
export declare class DeviceManagementRequestBuilder {
    get applePushNotificationCertificate(): ApplePushNotificationCertificateRequestBuilder;
    get complianceManagementPartners(): ComplianceManagementPartnersRequestBuilder;
    get conditionalAccessSettings(): ConditionalAccessSettingsRequestBuilder;
    get detectedApps(): DetectedAppsRequestBuilder;
    get deviceCategories(): DeviceCategoriesRequestBuilder;
    get deviceCompliancePolicies(): DeviceCompliancePoliciesRequestBuilder;
    get deviceCompliancePolicyDeviceStateSummary(): DeviceCompliancePolicyDeviceStateSummaryRequestBuilder;
    get deviceCompliancePolicySettingStateSummaries(): DeviceCompliancePolicySettingStateSummariesRequestBuilder;
    get deviceConfigurationDeviceStateSummaries(): DeviceConfigurationDeviceStateSummariesRequestBuilder;
    get deviceConfigurations(): DeviceConfigurationsRequestBuilder;
    get deviceEnrollmentConfigurations(): DeviceEnrollmentConfigurationsRequestBuilder;
    get deviceManagementPartners(): DeviceManagementPartnersRequestBuilder;
    get exchangeConnectors(): ExchangeConnectorsRequestBuilder;
    get importedWindowsAutopilotDeviceIdentities(): ImportedWindowsAutopilotDeviceIdentitiesRequestBuilder;
    get iosUpdateStatuses(): IosUpdateStatusesRequestBuilder;
    get managedDeviceOverview(): ManagedDeviceOverviewRequestBuilder;
    get managedDevices(): ManagedDevicesRequestBuilder;
    get mobileThreatDefenseConnectors(): MobileThreatDefenseConnectorsRequestBuilder;
    get notificationMessageTemplates(): NotificationMessageTemplatesRequestBuilder;
    /** Path parameters for the request  */
    private readonly pathParameters;
    get remoteAssistancePartners(): RemoteAssistancePartnersRequestBuilder;
    get reports(): ReportsRequestBuilder;
    /** The request adapter to use to execute the requests.  */
    private readonly requestAdapter;
    get resourceOperations(): ResourceOperationsRequestBuilder;
    get roleAssignments(): RoleAssignmentsRequestBuilder;
    get roleDefinitions(): RoleDefinitionsRequestBuilder;
    get softwareUpdateStatusSummary(): SoftwareUpdateStatusSummaryRequestBuilder;
    get telecomExpenseManagementPartners(): TelecomExpenseManagementPartnersRequestBuilder;
    get termsAndConditions(): TermsAndConditionsRequestBuilder;
    get troubleshootingEvents(): TroubleshootingEventsRequestBuilder;
    /** Url template to use to build the URL for the current request builder  */
    private readonly urlTemplate;
    get windowsAutopilotDeviceIdentities(): WindowsAutopilotDeviceIdentitiesRequestBuilder;
    get windowsInformationProtectionAppLearningSummaries(): WindowsInformationProtectionAppLearningSummariesRequestBuilder;
    get windowsInformationProtectionNetworkLearningSummaries(): WindowsInformationProtectionNetworkLearningSummariesRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.complianceManagementPartners.item collection
     * @param id Unique identifier of the item
     * @returns a complianceManagementPartnerItemRequestBuilder
     */
    complianceManagementPartnersById(id: string): ComplianceManagementPartnerItemRequestBuilder;
    /**
     * Instantiates a new DeviceManagementRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters: Record<string, unknown> | string | undefined, requestAdapter: RequestAdapter);
    /**
     * Get deviceManagement
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @returns a RequestInformation
     */
    createGetRequestInformation(q?: {
        expand?: string[];
        select?: string[];
    } | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Update deviceManagement
     * @param body
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createPatchRequestInformation(body: DeviceManagement | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.detectedApps.item collection
     * @param id Unique identifier of the item
     * @returns a detectedAppItemRequestBuilder
     */
    detectedAppsById(id: string): DetectedAppItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.deviceCategories.item collection
     * @param id Unique identifier of the item
     * @returns a deviceCategoryItemRequestBuilder
     */
    deviceCategoriesById(id: string): DeviceCategoryItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.deviceCompliancePolicies.item collection
     * @param id Unique identifier of the item
     * @returns a deviceCompliancePolicyItemRequestBuilder
     */
    deviceCompliancePoliciesById(id: string): DeviceCompliancePolicyItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.deviceCompliancePolicySettingStateSummaries.item collection
     * @param id Unique identifier of the item
     * @returns a deviceCompliancePolicySettingStateSummaryItemRequestBuilder
     */
    deviceCompliancePolicySettingStateSummariesById(id: string): DeviceCompliancePolicySettingStateSummaryItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.deviceConfigurations.item collection
     * @param id Unique identifier of the item
     * @returns a deviceConfigurationItemRequestBuilder
     */
    deviceConfigurationsById(id: string): DeviceConfigurationItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.deviceEnrollmentConfigurations.item collection
     * @param id Unique identifier of the item
     * @returns a deviceEnrollmentConfigurationItemRequestBuilder
     */
    deviceEnrollmentConfigurationsById(id: string): DeviceEnrollmentConfigurationItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.deviceManagementPartners.item collection
     * @param id Unique identifier of the item
     * @returns a deviceManagementPartnerItemRequestBuilder
     */
    deviceManagementPartnersById(id: string): DeviceManagementPartnerItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.exchangeConnectors.item collection
     * @param id Unique identifier of the item
     * @returns a deviceManagementExchangeConnectorItemRequestBuilder
     */
    exchangeConnectorsById(id: string): DeviceManagementExchangeConnectorItemRequestBuilder;
    /**
     * Get deviceManagement
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     * @returns a Promise of DeviceManagement
     */
    get(q?: {
        expand?: string[];
        select?: string[];
    } | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<DeviceManagement | undefined>;
    /**
     * Provides operations to call the getEffectivePermissions method.
     * @param scope Usage: scope='{scope}'
     * @returns a getEffectivePermissionsWithScopeRequestBuilder
     */
    getEffectivePermissionsWithScope(scope: string | undefined): GetEffectivePermissionsWithScopeRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.importedWindowsAutopilotDeviceIdentities.item collection
     * @param id Unique identifier of the item
     * @returns a importedWindowsAutopilotDeviceIdentityItemRequestBuilder
     */
    importedWindowsAutopilotDeviceIdentitiesById(id: string): ImportedWindowsAutopilotDeviceIdentityItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.iosUpdateStatuses.item collection
     * @param id Unique identifier of the item
     * @returns a iosUpdateDeviceStatusItemRequestBuilder
     */
    iosUpdateStatusesById(id: string): IosUpdateDeviceStatusItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.managedDevices.item collection
     * @param id Unique identifier of the item
     * @returns a managedDeviceItemRequestBuilder
     */
    managedDevicesById(id: string): ManagedDeviceItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.mobileThreatDefenseConnectors.item collection
     * @param id Unique identifier of the item
     * @returns a mobileThreatDefenseConnectorItemRequestBuilder
     */
    mobileThreatDefenseConnectorsById(id: string): MobileThreatDefenseConnectorItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.notificationMessageTemplates.item collection
     * @param id Unique identifier of the item
     * @returns a notificationMessageTemplateItemRequestBuilder
     */
    notificationMessageTemplatesById(id: string): NotificationMessageTemplateItemRequestBuilder;
    /**
     * Update deviceManagement
     * @param body
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    patch(body: DeviceManagement | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<void>;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.remoteAssistancePartners.item collection
     * @param id Unique identifier of the item
     * @returns a remoteAssistancePartnerItemRequestBuilder
     */
    remoteAssistancePartnersById(id: string): RemoteAssistancePartnerItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.resourceOperations.item collection
     * @param id Unique identifier of the item
     * @returns a resourceOperationItemRequestBuilder
     */
    resourceOperationsById(id: string): ResourceOperationItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.roleAssignments.item collection
     * @param id Unique identifier of the item
     * @returns a deviceAndAppManagementRoleAssignmentItemRequestBuilder
     */
    roleAssignmentsById(id: string): DeviceAndAppManagementRoleAssignmentItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.roleDefinitions.item collection
     * @param id Unique identifier of the item
     * @returns a roleDefinitionItemRequestBuilder
     */
    roleDefinitionsById(id: string): RoleDefinitionItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.telecomExpenseManagementPartners.item collection
     * @param id Unique identifier of the item
     * @returns a telecomExpenseManagementPartnerItemRequestBuilder
     */
    telecomExpenseManagementPartnersById(id: string): TelecomExpenseManagementPartnerItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.termsAndConditions.item collection
     * @param id Unique identifier of the item
     * @returns a termsAndConditionsItemRequestBuilder
     */
    termsAndConditionsById(id: string): TermsAndConditionsItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.troubleshootingEvents.item collection
     * @param id Unique identifier of the item
     * @returns a deviceManagementTroubleshootingEventItemRequestBuilder
     */
    troubleshootingEventsById(id: string): DeviceManagementTroubleshootingEventItemRequestBuilder;
    /**
     * Provides operations to call the verifyWindowsEnrollmentAutoDiscovery method.
     * @param domainName Usage: domainName='{domainName}'
     * @returns a verifyWindowsEnrollmentAutoDiscoveryWithDomainNameRequestBuilder
     */
    verifyWindowsEnrollmentAutoDiscoveryWithDomainName(domainName: string | undefined): VerifyWindowsEnrollmentAutoDiscoveryWithDomainNameRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.windowsAutopilotDeviceIdentities.item collection
     * @param id Unique identifier of the item
     * @returns a windowsAutopilotDeviceIdentityItemRequestBuilder
     */
    windowsAutopilotDeviceIdentitiesById(id: string): WindowsAutopilotDeviceIdentityItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.windowsInformationProtectionAppLearningSummaries.item collection
     * @param id Unique identifier of the item
     * @returns a windowsInformationProtectionAppLearningSummaryItemRequestBuilder
     */
    windowsInformationProtectionAppLearningSummariesById(id: string): WindowsInformationProtectionAppLearningSummaryItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.windowsInformationProtectionNetworkLearningSummaries.item collection
     * @param id Unique identifier of the item
     * @returns a windowsInformationProtectionNetworkLearningSummaryItemRequestBuilder
     */
    windowsInformationProtectionNetworkLearningSummariesById(id: string): WindowsInformationProtectionNetworkLearningSummaryItemRequestBuilder;
}
