"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SyncRequestBody = void 0;
const deviceManagementExchangeConnectorSyncType_1 = require("../../../../models/microsoft/graph/deviceManagementExchangeConnectorSyncType");
/** Provides operations to call the sync method.  */
class SyncRequestBody {
    /**
     * Instantiates a new syncRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "syncType": (o, n) => { o.syncType = n.getEnumValue(deviceManagementExchangeConnectorSyncType_1.DeviceManagementExchangeConnectorSyncType); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeEnumValue("syncType", this.syncType);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the syncType property value.
     * @returns a deviceManagementExchangeConnectorSyncType
     */
    get syncType() {
        return this._syncType;
    }
    ;
    /**
     * Sets the syncType property value.
     * @param value Value to set for the syncType property.
     */
    set syncType(value) {
        this._syncType = value;
    }
    ;
}
exports.SyncRequestBody = SyncRequestBody;
