import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the wipe method.  */
export declare class WipeRequestBody implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _keepEnrollmentData?;
    private _keepUserData?;
    private _macOsUnlockCode?;
    private _persistEsimDataPlan?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new wipeRequestBody and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the keepEnrollmentData property value.
     * @returns a boolean
     */
    get keepEnrollmentData(): boolean | undefined;
    /**
     * Sets the keepEnrollmentData property value.
     * @param value Value to set for the keepEnrollmentData property.
     */
    set keepEnrollmentData(value: boolean | undefined);
    /**
     * Gets the keepUserData property value.
     * @returns a boolean
     */
    get keepUserData(): boolean | undefined;
    /**
     * Sets the keepUserData property value.
     * @param value Value to set for the keepUserData property.
     */
    set keepUserData(value: boolean | undefined);
    /**
     * Gets the macOsUnlockCode property value.
     * @returns a string
     */
    get macOsUnlockCode(): string | undefined;
    /**
     * Sets the macOsUnlockCode property value.
     * @param value Value to set for the macOsUnlockCode property.
     */
    set macOsUnlockCode(value: string | undefined);
    /**
     * Gets the persistEsimDataPlan property value.
     * @returns a boolean
     */
    get persistEsimDataPlan(): boolean | undefined;
    /**
     * Sets the persistEsimDataPlan property value.
     * @param value Value to set for the persistEsimDataPlan property.
     */
    set persistEsimDataPlan(value: boolean | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
