import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the getHistoricalReport method.  */
export declare class GetHistoricalReportRequestBody implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _filter?;
    private _groupBy?;
    private _name?;
    private _orderBy?;
    private _search?;
    private _select?;
    private _skip?;
    private _top?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new getHistoricalReportRequestBody and sets the default values.
     */
    constructor();
    /**
     * Gets the filter property value.
     * @returns a string
     */
    get filter(): string | undefined;
    /**
     * Sets the filter property value.
     * @param value Value to set for the filter property.
     */
    set filter(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the groupBy property value.
     * @returns a string
     */
    get groupBy(): string[] | undefined;
    /**
     * Sets the groupBy property value.
     * @param value Value to set for the groupBy property.
     */
    set groupBy(value: string[] | undefined);
    /**
     * Gets the name property value.
     * @returns a string
     */
    get name(): string | undefined;
    /**
     * Sets the name property value.
     * @param value Value to set for the name property.
     */
    set name(value: string | undefined);
    /**
     * Gets the orderBy property value.
     * @returns a string
     */
    get orderBy(): string[] | undefined;
    /**
     * Sets the orderBy property value.
     * @param value Value to set for the orderBy property.
     */
    set orderBy(value: string[] | undefined);
    /**
     * Gets the search property value.
     * @returns a string
     */
    get search(): string | undefined;
    /**
     * Sets the search property value.
     * @param value Value to set for the search property.
     */
    set search(value: string | undefined);
    /**
     * Gets the select property value.
     * @returns a string
     */
    get select(): string[] | undefined;
    /**
     * Sets the select property value.
     * @param value Value to set for the select property.
     */
    set select(value: string[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the skip property value.
     * @returns a integer
     */
    get skip(): number | undefined;
    /**
     * Sets the skip property value.
     * @param value Value to set for the skip property.
     */
    set skip(value: number | undefined);
    /**
     * Gets the top property value.
     * @returns a integer
     */
    get top(): number | undefined;
    /**
     * Sets the top property value.
     * @param value Value to set for the top property.
     */
    set top(value: number | undefined);
}
