"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetPolicyNonComplianceSummaryReportRequestBody = void 0;
/** Provides operations to call the getPolicyNonComplianceSummaryReport method.  */
class GetPolicyNonComplianceSummaryReportRequestBody {
    /**
     * Instantiates a new getPolicyNonComplianceSummaryReportRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the filter property value.
     * @returns a string
     */
    get filter() {
        return this._filter;
    }
    ;
    /**
     * Sets the filter property value.
     * @param value Value to set for the filter property.
     */
    set filter(value) {
        this._filter = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "filter": (o, n) => { o.filter = n.getStringValue(); },
            "groupBy": (o, n) => { o.groupBy = n.getCollectionOfPrimitiveValues(); },
            "name": (o, n) => { o.name = n.getStringValue(); },
            "orderBy": (o, n) => { o.orderBy = n.getCollectionOfPrimitiveValues(); },
            "search": (o, n) => { o.search = n.getStringValue(); },
            "select": (o, n) => { o.select = n.getCollectionOfPrimitiveValues(); },
            "sessionId": (o, n) => { o.sessionId = n.getStringValue(); },
            "skip": (o, n) => { o.skip = n.getNumberValue(); },
            "top": (o, n) => { o.top = n.getNumberValue(); },
        };
    }
    ;
    /**
     * Gets the groupBy property value.
     * @returns a string
     */
    get groupBy() {
        return this._groupBy;
    }
    ;
    /**
     * Sets the groupBy property value.
     * @param value Value to set for the groupBy property.
     */
    set groupBy(value) {
        this._groupBy = value;
    }
    ;
    /**
     * Gets the name property value.
     * @returns a string
     */
    get name() {
        return this._name;
    }
    ;
    /**
     * Sets the name property value.
     * @param value Value to set for the name property.
     */
    set name(value) {
        this._name = value;
    }
    ;
    /**
     * Gets the orderBy property value.
     * @returns a string
     */
    get orderBy() {
        return this._orderBy;
    }
    ;
    /**
     * Sets the orderBy property value.
     * @param value Value to set for the orderBy property.
     */
    set orderBy(value) {
        this._orderBy = value;
    }
    ;
    /**
     * Gets the search property value.
     * @returns a string
     */
    get search() {
        return this._search;
    }
    ;
    /**
     * Sets the search property value.
     * @param value Value to set for the search property.
     */
    set search(value) {
        this._search = value;
    }
    ;
    /**
     * Gets the select property value.
     * @returns a string
     */
    get select() {
        return this._select;
    }
    ;
    /**
     * Sets the select property value.
     * @param value Value to set for the select property.
     */
    set select(value) {
        this._select = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("filter", this.filter);
        writer.writeCollectionOfPrimitiveValues("groupBy", this.groupBy);
        writer.writeStringValue("name", this.name);
        writer.writeCollectionOfPrimitiveValues("orderBy", this.orderBy);
        writer.writeStringValue("search", this.search);
        writer.writeCollectionOfPrimitiveValues("select", this.select);
        writer.writeStringValue("sessionId", this.sessionId);
        writer.writeNumberValue("skip", this.skip);
        writer.writeNumberValue("top", this.top);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the sessionId property value.
     * @returns a string
     */
    get sessionId() {
        return this._sessionId;
    }
    ;
    /**
     * Sets the sessionId property value.
     * @param value Value to set for the sessionId property.
     */
    set sessionId(value) {
        this._sessionId = value;
    }
    ;
    /**
     * Gets the skip property value.
     * @returns a integer
     */
    get skip() {
        return this._skip;
    }
    ;
    /**
     * Sets the skip property value.
     * @param value Value to set for the skip property.
     */
    set skip(value) {
        this._skip = value;
    }
    ;
    /**
     * Gets the top property value.
     * @returns a integer
     */
    get top() {
        return this._top;
    }
    ;
    /**
     * Sets the top property value.
     * @param value Value to set for the top property.
     */
    set top(value) {
        this._top = value;
    }
    ;
}
exports.GetPolicyNonComplianceSummaryReportRequestBody = GetPolicyNonComplianceSummaryReportRequestBody;
