"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReportsRequestBuilder = void 0;
const createDeviceManagementReportsFromDiscriminatorValue_1 = require("../../models/microsoft/graph/createDeviceManagementReportsFromDiscriminatorValue");
const createODataErrorFromDiscriminatorValue_1 = require("../../models/microsoft/graph/oDataErrors/createODataErrorFromDiscriminatorValue");
const exportJobsRequestBuilder_1 = require("./exportJobs/exportJobsRequestBuilder");
const deviceManagementExportJobItemRequestBuilder_1 = require("./exportJobs/item/deviceManagementExportJobItemRequestBuilder");
const getCachedReportRequestBuilder_1 = require("./getCachedReport/getCachedReportRequestBuilder");
const getCompliancePolicyNonComplianceReportRequestBuilder_1 = require("./getCompliancePolicyNonComplianceReport/getCompliancePolicyNonComplianceReportRequestBuilder");
const getCompliancePolicyNonComplianceSummaryReportRequestBuilder_1 = require("./getCompliancePolicyNonComplianceSummaryReport/getCompliancePolicyNonComplianceSummaryReportRequestBuilder");
const getComplianceSettingNonComplianceReportRequestBuilder_1 = require("./getComplianceSettingNonComplianceReport/getComplianceSettingNonComplianceReportRequestBuilder");
const getConfigurationPolicyNonComplianceReportRequestBuilder_1 = require("./getConfigurationPolicyNonComplianceReport/getConfigurationPolicyNonComplianceReportRequestBuilder");
const getConfigurationPolicyNonComplianceSummaryReportRequestBuilder_1 = require("./getConfigurationPolicyNonComplianceSummaryReport/getConfigurationPolicyNonComplianceSummaryReportRequestBuilder");
const getConfigurationSettingNonComplianceReportRequestBuilder_1 = require("./getConfigurationSettingNonComplianceReport/getConfigurationSettingNonComplianceReportRequestBuilder");
const getDeviceManagementIntentPerSettingContributingProfilesRequestBuilder_1 = require("./getDeviceManagementIntentPerSettingContributingProfiles/getDeviceManagementIntentPerSettingContributingProfilesRequestBuilder");
const getDeviceManagementIntentSettingsReportRequestBuilder_1 = require("./getDeviceManagementIntentSettingsReport/getDeviceManagementIntentSettingsReportRequestBuilder");
const getDeviceNonComplianceReportRequestBuilder_1 = require("./getDeviceNonComplianceReport/getDeviceNonComplianceReportRequestBuilder");
const getHistoricalReportRequestBuilder_1 = require("./getHistoricalReport/getHistoricalReportRequestBuilder");
const getPolicyNonComplianceMetadataRequestBuilder_1 = require("./getPolicyNonComplianceMetadata/getPolicyNonComplianceMetadataRequestBuilder");
const getPolicyNonComplianceReportRequestBuilder_1 = require("./getPolicyNonComplianceReport/getPolicyNonComplianceReportRequestBuilder");
const getPolicyNonComplianceSummaryReportRequestBuilder_1 = require("./getPolicyNonComplianceSummaryReport/getPolicyNonComplianceSummaryReportRequestBuilder");
const getReportFiltersRequestBuilder_1 = require("./getReportFilters/getReportFiltersRequestBuilder");
const getSettingNonComplianceReportRequestBuilder_1 = require("./getSettingNonComplianceReport/getSettingNonComplianceReportRequestBuilder");
const kiota_abstractions_1 = require("@microsoft/kiota-abstractions");
/** Provides operations to manage the reports property of the microsoft.graph.deviceManagement entity.  */
class ReportsRequestBuilder {
    /**
     * Instantiates a new ReportsRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters, requestAdapter) {
        if (!pathParameters)
            throw new Error("pathParameters cannot be undefined");
        if (!requestAdapter)
            throw new Error("requestAdapter cannot be undefined");
        this.urlTemplate = "{+baseurl}/deviceManagement/reports{?select,expand}";
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(pathParameters);
        this.pathParameters = urlTplParams;
        this.requestAdapter = requestAdapter;
    }
    get exportJobs() {
        return new exportJobsRequestBuilder_1.ExportJobsRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get getCachedReport() {
        return new getCachedReportRequestBuilder_1.GetCachedReportRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get getCompliancePolicyNonComplianceReport() {
        return new getCompliancePolicyNonComplianceReportRequestBuilder_1.GetCompliancePolicyNonComplianceReportRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get getCompliancePolicyNonComplianceSummaryReport() {
        return new getCompliancePolicyNonComplianceSummaryReportRequestBuilder_1.GetCompliancePolicyNonComplianceSummaryReportRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get getComplianceSettingNonComplianceReport() {
        return new getComplianceSettingNonComplianceReportRequestBuilder_1.GetComplianceSettingNonComplianceReportRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get getConfigurationPolicyNonComplianceReport() {
        return new getConfigurationPolicyNonComplianceReportRequestBuilder_1.GetConfigurationPolicyNonComplianceReportRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get getConfigurationPolicyNonComplianceSummaryReport() {
        return new getConfigurationPolicyNonComplianceSummaryReportRequestBuilder_1.GetConfigurationPolicyNonComplianceSummaryReportRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get getConfigurationSettingNonComplianceReport() {
        return new getConfigurationSettingNonComplianceReportRequestBuilder_1.GetConfigurationSettingNonComplianceReportRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get getDeviceManagementIntentPerSettingContributingProfiles() {
        return new getDeviceManagementIntentPerSettingContributingProfilesRequestBuilder_1.GetDeviceManagementIntentPerSettingContributingProfilesRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get getDeviceManagementIntentSettingsReport() {
        return new getDeviceManagementIntentSettingsReportRequestBuilder_1.GetDeviceManagementIntentSettingsReportRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get getDeviceNonComplianceReport() {
        return new getDeviceNonComplianceReportRequestBuilder_1.GetDeviceNonComplianceReportRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get getHistoricalReport() {
        return new getHistoricalReportRequestBuilder_1.GetHistoricalReportRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get getPolicyNonComplianceMetadata() {
        return new getPolicyNonComplianceMetadataRequestBuilder_1.GetPolicyNonComplianceMetadataRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get getPolicyNonComplianceReport() {
        return new getPolicyNonComplianceReportRequestBuilder_1.GetPolicyNonComplianceReportRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get getPolicyNonComplianceSummaryReport() {
        return new getPolicyNonComplianceSummaryReportRequestBuilder_1.GetPolicyNonComplianceSummaryReportRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get getReportFilters() {
        return new getReportFiltersRequestBuilder_1.GetReportFiltersRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get getSettingNonComplianceReport() {
        return new getSettingNonComplianceReportRequestBuilder_1.GetSettingNonComplianceReportRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    ;
    /**
     * Delete navigation property reports for deviceManagement
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createDeleteRequestInformation(h, o) {
        const requestInfo = new kiota_abstractions_1.RequestInformation();
        requestInfo.urlTemplate = this.urlTemplate;
        requestInfo.pathParameters = this.pathParameters;
        requestInfo.httpMethod = kiota_abstractions_1.HttpMethod.DELETE;
        if (h)
            requestInfo.headers = h;
        o && requestInfo.addRequestOptions(...o);
        return requestInfo;
    }
    ;
    /**
     * Reports singleton
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @returns a RequestInformation
     */
    createGetRequestInformation(q, h, o) {
        const requestInfo = new kiota_abstractions_1.RequestInformation();
        requestInfo.urlTemplate = this.urlTemplate;
        requestInfo.pathParameters = this.pathParameters;
        requestInfo.httpMethod = kiota_abstractions_1.HttpMethod.GET;
        if (h)
            requestInfo.headers = h;
        q && requestInfo.setQueryStringParametersFromRawObject(q);
        o && requestInfo.addRequestOptions(...o);
        return requestInfo;
    }
    ;
    /**
     * Update the navigation property reports in deviceManagement
     * @param body
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createPatchRequestInformation(body, h, o) {
        if (!body)
            throw new Error("body cannot be undefined");
        const requestInfo = new kiota_abstractions_1.RequestInformation();
        requestInfo.urlTemplate = this.urlTemplate;
        requestInfo.pathParameters = this.pathParameters;
        requestInfo.httpMethod = kiota_abstractions_1.HttpMethod.PATCH;
        if (h)
            requestInfo.headers = h;
        requestInfo.setContentFromParsable(this.requestAdapter, "application/json", body);
        o && requestInfo.addRequestOptions(...o);
        return requestInfo;
    }
    ;
    /**
     * Delete navigation property reports for deviceManagement
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    delete(h, o, responseHandler) {
        var _a, _b;
        const requestInfo = this.createDeleteRequestInformation(h, o);
        const errorMapping = {
            "4XX": createODataErrorFromDiscriminatorValue_1.createODataErrorFromDiscriminatorValue,
            "5XX": createODataErrorFromDiscriminatorValue_1.createODataErrorFromDiscriminatorValue,
        };
        return (_b = (_a = this.requestAdapter) === null || _a === void 0 ? void 0 : _a.sendNoResponseContentAsync(requestInfo, responseHandler, errorMapping)) !== null && _b !== void 0 ? _b : Promise.reject(new Error('http core is null'));
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.deviceManagement.reports.exportJobs.item collection
     * @param id Unique identifier of the item
     * @returns a deviceManagementExportJobItemRequestBuilder
     */
    exportJobsById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["deviceManagementExportJob_id"] = id;
        return new deviceManagementExportJobItemRequestBuilder_1.DeviceManagementExportJobItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Reports singleton
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     * @returns a Promise of DeviceManagementReports
     */
    get(q, h, o, responseHandler) {
        var _a, _b;
        const requestInfo = this.createGetRequestInformation(q, h, o);
        const errorMapping = {
            "4XX": createODataErrorFromDiscriminatorValue_1.createODataErrorFromDiscriminatorValue,
            "5XX": createODataErrorFromDiscriminatorValue_1.createODataErrorFromDiscriminatorValue,
        };
        return (_b = (_a = this.requestAdapter) === null || _a === void 0 ? void 0 : _a.sendAsync(requestInfo, createDeviceManagementReportsFromDiscriminatorValue_1.createDeviceManagementReportsFromDiscriminatorValue, responseHandler, errorMapping)) !== null && _b !== void 0 ? _b : Promise.reject(new Error('http core is null'));
    }
    ;
    /**
     * Update the navigation property reports in deviceManagement
     * @param body
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    patch(body, h, o, responseHandler) {
        var _a, _b;
        if (!body)
            throw new Error("body cannot be undefined");
        const requestInfo = this.createPatchRequestInformation(body, h, o);
        const errorMapping = {
            "4XX": createODataErrorFromDiscriminatorValue_1.createODataErrorFromDiscriminatorValue,
            "5XX": createODataErrorFromDiscriminatorValue_1.createODataErrorFromDiscriminatorValue,
        };
        return (_b = (_a = this.requestAdapter) === null || _a === void 0 ? void 0 : _a.sendNoResponseContentAsync(requestInfo, responseHandler, errorMapping)) !== null && _b !== void 0 ? _b : Promise.reject(new Error('http core is null'));
    }
    ;
}
exports.ReportsRequestBuilder = ReportsRequestBuilder;
