"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateDevicePropertiesRequestBody = void 0;
/** Provides operations to call the updateDeviceProperties method.  */
class UpdateDevicePropertiesRequestBody {
    /**
     * Instantiates a new updateDevicePropertiesRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the addressableUserName property value.
     * @returns a string
     */
    get addressableUserName() {
        return this._addressableUserName;
    }
    ;
    /**
     * Sets the addressableUserName property value.
     * @param value Value to set for the addressableUserName property.
     */
    set addressableUserName(value) {
        this._addressableUserName = value;
    }
    ;
    ;
    /**
     * Gets the displayName property value.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "addressableUserName": (o, n) => { o.addressableUserName = n.getStringValue(); },
            "displayName": (o, n) => { o.displayName = n.getStringValue(); },
            "groupTag": (o, n) => { o.groupTag = n.getStringValue(); },
            "userPrincipalName": (o, n) => { o.userPrincipalName = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the groupTag property value.
     * @returns a string
     */
    get groupTag() {
        return this._groupTag;
    }
    ;
    /**
     * Sets the groupTag property value.
     * @param value Value to set for the groupTag property.
     */
    set groupTag(value) {
        this._groupTag = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("addressableUserName", this.addressableUserName);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeStringValue("groupTag", this.groupTag);
        writer.writeStringValue("userPrincipalName", this.userPrincipalName);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the userPrincipalName property value.
     * @returns a string
     */
    get userPrincipalName() {
        return this._userPrincipalName;
    }
    ;
    /**
     * Sets the userPrincipalName property value.
     * @param value Value to set for the userPrincipalName property.
     */
    set userPrincipalName(value) {
        this._userPrincipalName = value;
    }
    ;
}
exports.UpdateDevicePropertiesRequestBody = UpdateDevicePropertiesRequestBody;
