import { ContentType } from '../../../../models/microsoft/graph/';
import { AssociateWithHubSitesRequestBuilder } from './associateWithHubSites/associateWithHubSitesRequestBuilder';
import { BaseRequestBuilder } from './base/baseRequestBuilder';
import { BaseTypesRequestBuilder } from './baseTypes/baseTypesRequestBuilder';
import { ContentTypeItemRequestBuilder as i35d96b02c52add6d60af32d4307af63c151b02fdf02d9c1143d1c1c55ee0d949 } from './baseTypes/item/contentTypeItemRequestBuilder';
import { ColumnLinksRequestBuilder } from './columnLinks/columnLinksRequestBuilder';
import { ColumnLinkItemRequestBuilder } from './columnLinks/item/columnLinkItemRequestBuilder';
import { ColumnPositionsRequestBuilder } from './columnPositions/columnPositionsRequestBuilder';
import { ColumnDefinitionItemRequestBuilder as i5d9e5fc55a635fba7378446e3a263d74b49a45880e60983709034ac1b4eb38a0 } from './columnPositions/item/columnDefinitionItemRequestBuilder';
import { ColumnsRequestBuilder } from './columns/columnsRequestBuilder';
import { ColumnDefinitionItemRequestBuilder as i39c8588e137b4036073c41dc215b544ab9611e8b5428ec4ea77b430319d41423 } from './columns/item/columnDefinitionItemRequestBuilder';
import { CopyToDefaultContentLocationRequestBuilder } from './copyToDefaultContentLocation/copyToDefaultContentLocationRequestBuilder';
import { IsPublishedRequestBuilder } from './isPublished/isPublishedRequestBuilder';
import { PublishRequestBuilder } from './publish/publishRequestBuilder';
import { UnpublishRequestBuilder } from './unpublish/unpublishRequestBuilder';
import { RequestAdapter, RequestInformation, RequestOption, ResponseHandler } from '@microsoft/kiota-abstractions';
/** Provides operations to manage the contentTypes property of the microsoft.graph.list entity.  */
export declare class ContentTypeItemRequestBuilder {
    get associateWithHubSites(): AssociateWithHubSitesRequestBuilder;
    get base(): BaseRequestBuilder;
    get baseTypes(): BaseTypesRequestBuilder;
    get columnLinks(): ColumnLinksRequestBuilder;
    get columnPositions(): ColumnPositionsRequestBuilder;
    get columns(): ColumnsRequestBuilder;
    get copyToDefaultContentLocation(): CopyToDefaultContentLocationRequestBuilder;
    /** Path parameters for the request  */
    private readonly pathParameters;
    get publish(): PublishRequestBuilder;
    /** The request adapter to use to execute the requests.  */
    private readonly requestAdapter;
    get unpublish(): UnpublishRequestBuilder;
    /** Url template to use to build the URL for the current request builder  */
    private readonly urlTemplate;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.drive.list.contentTypes.item.baseTypes.item collection
     * @param id Unique identifier of the item
     * @returns a contentTypeItemRequestBuilder
     */
    baseTypesById(id: string): i35d96b02c52add6d60af32d4307af63c151b02fdf02d9c1143d1c1c55ee0d949;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.drive.list.contentTypes.item.columnLinks.item collection
     * @param id Unique identifier of the item
     * @returns a columnLinkItemRequestBuilder
     */
    columnLinksById(id: string): ColumnLinkItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.drive.list.contentTypes.item.columnPositions.item collection
     * @param id Unique identifier of the item
     * @returns a columnDefinitionItemRequestBuilder
     */
    columnPositionsById(id: string): i5d9e5fc55a635fba7378446e3a263d74b49a45880e60983709034ac1b4eb38a0;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.drive.list.contentTypes.item.columns.item collection
     * @param id Unique identifier of the item
     * @returns a columnDefinitionItemRequestBuilder
     */
    columnsById(id: string): i39c8588e137b4036073c41dc215b544ab9611e8b5428ec4ea77b430319d41423;
    /**
     * Instantiates a new ContentTypeItemRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters: Record<string, unknown> | string | undefined, requestAdapter: RequestAdapter);
    /**
     * Delete navigation property contentTypes for drive
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createDeleteRequestInformation(h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * The collection of content types present in this list.
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @returns a RequestInformation
     */
    createGetRequestInformation(q?: {
        expand?: string[];
        select?: string[];
    } | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Update the navigation property contentTypes in drive
     * @param body
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createPatchRequestInformation(body: ContentType | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Delete navigation property contentTypes for drive
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    delete(h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<void>;
    /**
     * The collection of content types present in this list.
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     * @returns a Promise of ContentType
     */
    get(q?: {
        expand?: string[];
        select?: string[];
    } | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<ContentType | undefined>;
    /**
     * Provides operations to call the isPublished method.
     * @returns a isPublishedRequestBuilder
     */
    isPublished(): IsPublishedRequestBuilder;
    /**
     * Update the navigation property contentTypes in drive
     * @param body
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    patch(body: ContentType | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<void>;
}
