import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the associateWithHubSites method.  */
export declare class AssociateWithHubSitesRequestBody implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _hubSiteUrls?;
    private _propagateToExistingLists?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new associateWithHubSitesRequestBody and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the hubSiteUrls property value.
     * @returns a string
     */
    get hubSiteUrls(): string[] | undefined;
    /**
     * Sets the hubSiteUrls property value.
     * @param value Value to set for the hubSiteUrls property.
     */
    set hubSiteUrls(value: string[] | undefined);
    /**
     * Gets the propagateToExistingLists property value.
     * @returns a boolean
     */
    get propagateToExistingLists(): boolean | undefined;
    /**
     * Sets the propagateToExistingLists property value.
     * @param value Value to set for the propagateToExistingLists property.
     */
    set propagateToExistingLists(value: boolean | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
