import { AdminRequestBuilder } from './admin/adminRequestBuilder';
import { AgreementAcceptancesRequestBuilder } from './agreementAcceptances/agreementAcceptancesRequestBuilder';
import { AgreementAcceptanceItemRequestBuilder } from './agreementAcceptances/item/agreementAcceptanceItemRequestBuilder';
import { AgreementsRequestBuilder } from './agreements/agreementsRequestBuilder';
import { AgreementItemRequestBuilder } from './agreements/item/agreementItemRequestBuilder';
import { AppCatalogsRequestBuilder } from './appCatalogs/appCatalogsRequestBuilder';
import { ApplicationsRequestBuilder } from './applications/applicationsRequestBuilder';
import { ApplicationItemRequestBuilder } from './applications/item/applicationItemRequestBuilder';
import { ApplicationTemplatesRequestBuilder } from './applicationTemplates/applicationTemplatesRequestBuilder';
import { ApplicationTemplateItemRequestBuilder } from './applicationTemplates/item/applicationTemplateItemRequestBuilder';
import { AuditLogsRequestBuilder } from './auditLogs/auditLogsRequestBuilder';
import { AuthenticationMethodConfigurationsRequestBuilder } from './authenticationMethodConfigurations/authenticationMethodConfigurationsRequestBuilder';
import { AuthenticationMethodConfigurationItemRequestBuilder } from './authenticationMethodConfigurations/item/authenticationMethodConfigurationItemRequestBuilder';
import { AuthenticationMethodsPolicyRequestBuilder } from './authenticationMethodsPolicy/authenticationMethodsPolicyRequestBuilder';
import { BrandingRequestBuilder } from './branding/brandingRequestBuilder';
import { CertificateBasedAuthConfigurationRequestBuilder } from './certificateBasedAuthConfiguration/certificateBasedAuthConfigurationRequestBuilder';
import { CertificateBasedAuthConfigurationItemRequestBuilder } from './certificateBasedAuthConfiguration/item/certificateBasedAuthConfigurationItemRequestBuilder';
import { ChatsRequestBuilder } from './chats/chatsRequestBuilder';
import { ChatItemRequestBuilder } from './chats/item/chatItemRequestBuilder';
import { CommunicationsRequestBuilder } from './communications/communicationsRequestBuilder';
import { ComplianceRequestBuilder } from './compliance/complianceRequestBuilder';
import { ConnectionsRequestBuilder } from './connections/connectionsRequestBuilder';
import { ExternalConnectionItemRequestBuilder } from './connections/item/externalConnectionItemRequestBuilder';
import { ContactsRequestBuilder } from './contacts/contactsRequestBuilder';
import { OrgContactItemRequestBuilder } from './contacts/item/orgContactItemRequestBuilder';
import { ContractsRequestBuilder } from './contracts/contractsRequestBuilder';
import { ContractItemRequestBuilder } from './contracts/item/contractItemRequestBuilder';
import { DataPolicyOperationsRequestBuilder } from './dataPolicyOperations/dataPolicyOperationsRequestBuilder';
import { DataPolicyOperationItemRequestBuilder } from './dataPolicyOperations/item/dataPolicyOperationItemRequestBuilder';
import { DeviceAppManagementRequestBuilder } from './deviceAppManagement/deviceAppManagementRequestBuilder';
import { DeviceManagementRequestBuilder } from './deviceManagement/deviceManagementRequestBuilder';
import { DevicesRequestBuilder } from './devices/devicesRequestBuilder';
import { DeviceItemRequestBuilder } from './devices/item/deviceItemRequestBuilder';
import { DirectoryRequestBuilder } from './directory/directoryRequestBuilder';
import { DirectoryObjectsRequestBuilder } from './directoryObjects/directoryObjectsRequestBuilder';
import { DirectoryObjectItemRequestBuilder } from './directoryObjects/item/directoryObjectItemRequestBuilder';
import { DirectoryRolesRequestBuilder } from './directoryRoles/directoryRolesRequestBuilder';
import { DirectoryRoleItemRequestBuilder } from './directoryRoles/item/directoryRoleItemRequestBuilder';
import { DirectoryRoleTemplatesRequestBuilder } from './directoryRoleTemplates/directoryRoleTemplatesRequestBuilder';
import { DirectoryRoleTemplateItemRequestBuilder } from './directoryRoleTemplates/item/directoryRoleTemplateItemRequestBuilder';
import { DomainDnsRecordsRequestBuilder } from './domainDnsRecords/domainDnsRecordsRequestBuilder';
import { DomainDnsRecordItemRequestBuilder } from './domainDnsRecords/item/domainDnsRecordItemRequestBuilder';
import { DomainsRequestBuilder } from './domains/domainsRequestBuilder';
import { DomainItemRequestBuilder } from './domains/item/domainItemRequestBuilder';
import { DriveRequestBuilder } from './drive/driveRequestBuilder';
import { DrivesRequestBuilder } from './drives/drivesRequestBuilder';
import { DriveItemRequestBuilder } from './drives/item/driveItemRequestBuilder';
import { EducationRequestBuilder } from './education/educationRequestBuilder';
import { ExternalRequestBuilder } from './external/externalRequestBuilder';
import { GroupLifecyclePoliciesRequestBuilder } from './groupLifecyclePolicies/groupLifecyclePoliciesRequestBuilder';
import { GroupLifecyclePolicyItemRequestBuilder } from './groupLifecyclePolicies/item/groupLifecyclePolicyItemRequestBuilder';
import { GroupsRequestBuilder } from './groups/groupsRequestBuilder';
import { GroupItemRequestBuilder } from './groups/item/groupItemRequestBuilder';
import { GroupSettingsRequestBuilder } from './groupSettings/groupSettingsRequestBuilder';
import { GroupSettingItemRequestBuilder } from './groupSettings/item/groupSettingItemRequestBuilder';
import { GroupSettingTemplatesRequestBuilder } from './groupSettingTemplates/groupSettingTemplatesRequestBuilder';
import { GroupSettingTemplateItemRequestBuilder } from './groupSettingTemplates/item/groupSettingTemplateItemRequestBuilder';
import { IdentityRequestBuilder } from './identity/identityRequestBuilder';
import { IdentityGovernanceRequestBuilder } from './identityGovernance/identityGovernanceRequestBuilder';
import { IdentityProtectionRequestBuilder } from './identityProtection/identityProtectionRequestBuilder';
import { IdentityProvidersRequestBuilder } from './identityProviders/identityProvidersRequestBuilder';
import { IdentityProviderItemRequestBuilder } from './identityProviders/item/identityProviderItemRequestBuilder';
import { InformationProtectionRequestBuilder } from './informationProtection/informationProtectionRequestBuilder';
import { InvitationsRequestBuilder } from './invitations/invitationsRequestBuilder';
import { InvitationItemRequestBuilder } from './invitations/item/invitationItemRequestBuilder';
import { OrganizationalBrandingLocalizationItemRequestBuilder } from './localizations/item/organizationalBrandingLocalizationItemRequestBuilder';
import { LocalizationsRequestBuilder } from './localizations/localizationsRequestBuilder';
import { MeRequestBuilder } from './me/meRequestBuilder';
import { OAuth2PermissionGrantItemRequestBuilder } from './oauth2PermissionGrants/item/oAuth2PermissionGrantItemRequestBuilder';
import { Oauth2PermissionGrantsRequestBuilder } from './oauth2PermissionGrants/oauth2PermissionGrantsRequestBuilder';
import { OrganizationItemRequestBuilder } from './organization/item/organizationItemRequestBuilder';
import { OrganizationRequestBuilder } from './organization/organizationRequestBuilder';
import { ResourceSpecificPermissionGrantItemRequestBuilder } from './permissionGrants/item/resourceSpecificPermissionGrantItemRequestBuilder';
import { PermissionGrantsRequestBuilder } from './permissionGrants/permissionGrantsRequestBuilder';
import { PlaceItemRequestBuilder } from './places/item/placeItemRequestBuilder';
import { PlacesRequestBuilder } from './places/placesRequestBuilder';
import { PlannerRequestBuilder } from './planner/plannerRequestBuilder';
import { PoliciesRequestBuilder } from './policies/policiesRequestBuilder';
import { PrintRequestBuilder } from './print/printRequestBuilder';
import { PrivacyRequestBuilder } from './privacy/privacyRequestBuilder';
import { ReportsRequestBuilder } from './reports/reportsRequestBuilder';
import { RoleManagementRequestBuilder } from './roleManagement/roleManagementRequestBuilder';
import { SchemaExtensionItemRequestBuilder } from './schemaExtensions/item/schemaExtensionItemRequestBuilder';
import { SchemaExtensionsRequestBuilder } from './schemaExtensions/schemaExtensionsRequestBuilder';
import { ScopedRoleMembershipItemRequestBuilder } from './scopedRoleMemberships/item/scopedRoleMembershipItemRequestBuilder';
import { ScopedRoleMembershipsRequestBuilder } from './scopedRoleMemberships/scopedRoleMembershipsRequestBuilder';
import { SearchRequestBuilder } from './search/searchRequestBuilder';
import { SecurityRequestBuilder } from './security/securityRequestBuilder';
import { ServicePrincipalItemRequestBuilder } from './servicePrincipals/item/servicePrincipalItemRequestBuilder';
import { ServicePrincipalsRequestBuilder } from './servicePrincipals/servicePrincipalsRequestBuilder';
import { SharedDriveItemItemRequestBuilder } from './shares/item/sharedDriveItemItemRequestBuilder';
import { SharesRequestBuilder } from './shares/sharesRequestBuilder';
import { SiteItemRequestBuilder } from './sites/item/siteItemRequestBuilder';
import { SitesRequestBuilder } from './sites/sitesRequestBuilder';
import { SolutionsRequestBuilder } from './solutions/solutionsRequestBuilder';
import { SubscribedSkuItemRequestBuilder } from './subscribedSkus/item/subscribedSkuItemRequestBuilder';
import { SubscribedSkusRequestBuilder } from './subscribedSkus/subscribedSkusRequestBuilder';
import { SubscriptionItemRequestBuilder } from './subscriptions/item/subscriptionItemRequestBuilder';
import { SubscriptionsRequestBuilder } from './subscriptions/subscriptionsRequestBuilder';
import { TeamItemRequestBuilder } from './teams/item/teamItemRequestBuilder';
import { TeamsRequestBuilder } from './teams/teamsRequestBuilder';
import { TeamsTemplateItemRequestBuilder } from './teamsTemplates/item/teamsTemplateItemRequestBuilder';
import { TeamsTemplatesRequestBuilder } from './teamsTemplates/teamsTemplatesRequestBuilder';
import { TeamworkRequestBuilder } from './teamwork/teamworkRequestBuilder';
import { UserItemRequestBuilder } from './users/item/userItemRequestBuilder';
import { UsersRequestBuilder } from './users/usersRequestBuilder';
import { DriveItemItemRequestBuilder } from './workbooks/item/driveItemItemRequestBuilder';
import { WorkbooksRequestBuilder } from './workbooks/workbooksRequestBuilder';
import { RequestAdapter, RequestInformation, RequestOption, ResponseHandler } from '@microsoft/kiota-abstractions';
/** The main entry point of the SDK, exposes the configuration and the fluent API.  */
export declare class GraphBaseServiceClient {
    get admin(): AdminRequestBuilder;
    get agreementAcceptances(): AgreementAcceptancesRequestBuilder;
    get agreements(): AgreementsRequestBuilder;
    get appCatalogs(): AppCatalogsRequestBuilder;
    get applications(): ApplicationsRequestBuilder;
    get applicationTemplates(): ApplicationTemplatesRequestBuilder;
    get auditLogs(): AuditLogsRequestBuilder;
    get authenticationMethodConfigurations(): AuthenticationMethodConfigurationsRequestBuilder;
    get authenticationMethodsPolicy(): AuthenticationMethodsPolicyRequestBuilder;
    get branding(): BrandingRequestBuilder;
    get certificateBasedAuthConfiguration(): CertificateBasedAuthConfigurationRequestBuilder;
    get chats(): ChatsRequestBuilder;
    get communications(): CommunicationsRequestBuilder;
    get compliance(): ComplianceRequestBuilder;
    get connections(): ConnectionsRequestBuilder;
    get contacts(): ContactsRequestBuilder;
    get contracts(): ContractsRequestBuilder;
    get dataPolicyOperations(): DataPolicyOperationsRequestBuilder;
    get deviceAppManagement(): DeviceAppManagementRequestBuilder;
    get deviceManagement(): DeviceManagementRequestBuilder;
    get devices(): DevicesRequestBuilder;
    get directory(): DirectoryRequestBuilder;
    get directoryObjects(): DirectoryObjectsRequestBuilder;
    get directoryRoles(): DirectoryRolesRequestBuilder;
    get directoryRoleTemplates(): DirectoryRoleTemplatesRequestBuilder;
    get domainDnsRecords(): DomainDnsRecordsRequestBuilder;
    get domains(): DomainsRequestBuilder;
    get drive(): DriveRequestBuilder;
    get drives(): DrivesRequestBuilder;
    get education(): EducationRequestBuilder;
    get external(): ExternalRequestBuilder;
    get groupLifecyclePolicies(): GroupLifecyclePoliciesRequestBuilder;
    get groups(): GroupsRequestBuilder;
    get groupSettings(): GroupSettingsRequestBuilder;
    get groupSettingTemplates(): GroupSettingTemplatesRequestBuilder;
    get identity(): IdentityRequestBuilder;
    get identityGovernance(): IdentityGovernanceRequestBuilder;
    get identityProtection(): IdentityProtectionRequestBuilder;
    get identityProviders(): IdentityProvidersRequestBuilder;
    get informationProtection(): InformationProtectionRequestBuilder;
    get invitations(): InvitationsRequestBuilder;
    get localizations(): LocalizationsRequestBuilder;
    get me(): MeRequestBuilder;
    get oauth2PermissionGrants(): Oauth2PermissionGrantsRequestBuilder;
    get organization(): OrganizationRequestBuilder;
    /** Path parameters for the request  */
    private readonly pathParameters;
    get permissionGrants(): PermissionGrantsRequestBuilder;
    get places(): PlacesRequestBuilder;
    get planner(): PlannerRequestBuilder;
    get policies(): PoliciesRequestBuilder;
    get print(): PrintRequestBuilder;
    get privacy(): PrivacyRequestBuilder;
    get reports(): ReportsRequestBuilder;
    /** The request adapter to use to execute the requests.  */
    private readonly requestAdapter;
    get roleManagement(): RoleManagementRequestBuilder;
    get schemaExtensions(): SchemaExtensionsRequestBuilder;
    get scopedRoleMemberships(): ScopedRoleMembershipsRequestBuilder;
    get search(): SearchRequestBuilder;
    get security(): SecurityRequestBuilder;
    get servicePrincipals(): ServicePrincipalsRequestBuilder;
    get shares(): SharesRequestBuilder;
    get sites(): SitesRequestBuilder;
    get solutions(): SolutionsRequestBuilder;
    get subscribedSkus(): SubscribedSkusRequestBuilder;
    get subscriptions(): SubscriptionsRequestBuilder;
    get teams(): TeamsRequestBuilder;
    get teamsTemplates(): TeamsTemplatesRequestBuilder;
    get teamwork(): TeamworkRequestBuilder;
    /** Url template to use to build the URL for the current request builder  */
    private readonly urlTemplate;
    get users(): UsersRequestBuilder;
    get workbooks(): WorkbooksRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.agreementAcceptances.item collection
     * @param id Unique identifier of the item
     * @returns a agreementAcceptanceItemRequestBuilder
     */
    agreementAcceptancesById(id: string): AgreementAcceptanceItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.agreements.item collection
     * @param id Unique identifier of the item
     * @returns a agreementItemRequestBuilder
     */
    agreementsById(id: string): AgreementItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.applications.item collection
     * @param id Unique identifier of the item
     * @returns a applicationItemRequestBuilder
     */
    applicationsById(id: string): ApplicationItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.applicationTemplates.item collection
     * @param id Unique identifier of the item
     * @returns a applicationTemplateItemRequestBuilder
     */
    applicationTemplatesById(id: string): ApplicationTemplateItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.authenticationMethodConfigurations.item collection
     * @param id Unique identifier of the item
     * @returns a authenticationMethodConfigurationItemRequestBuilder
     */
    authenticationMethodConfigurationsById(id: string): AuthenticationMethodConfigurationItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.certificateBasedAuthConfiguration.item collection
     * @param id Unique identifier of the item
     * @returns a certificateBasedAuthConfigurationItemRequestBuilder
     */
    certificateBasedAuthConfigurationById(id: string): CertificateBasedAuthConfigurationItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.chats.item collection
     * @param id Unique identifier of the item
     * @returns a chatItemRequestBuilder
     */
    chatsById(id: string): ChatItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.connections.item collection
     * @param id Unique identifier of the item
     * @returns a externalConnectionItemRequestBuilder
     */
    connectionsById(id: string): ExternalConnectionItemRequestBuilder;
    /**
     * Instantiates a new GraphServiceClient and sets the default values.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(requestAdapter: RequestAdapter);
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.contacts.item collection
     * @param id Unique identifier of the item
     * @returns a orgContactItemRequestBuilder
     */
    contactsById(id: string): OrgContactItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.contracts.item collection
     * @param id Unique identifier of the item
     * @returns a contractItemRequestBuilder
     */
    contractsById(id: string): ContractItemRequestBuilder;
    createGetRequestInformation(h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.dataPolicyOperations.item collection
     * @param id Unique identifier of the item
     * @returns a dataPolicyOperationItemRequestBuilder
     */
    dataPolicyOperationsById(id: string): DataPolicyOperationItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.devices.item collection
     * @param id Unique identifier of the item
     * @returns a deviceItemRequestBuilder
     */
    devicesById(id: string): DeviceItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.directoryObjects.item collection
     * @param id Unique identifier of the item
     * @returns a directoryObjectItemRequestBuilder
     */
    directoryObjectsById(id: string): DirectoryObjectItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.directoryRoles.item collection
     * @param id Unique identifier of the item
     * @returns a directoryRoleItemRequestBuilder
     */
    directoryRolesById(id: string): DirectoryRoleItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.directoryRoleTemplates.item collection
     * @param id Unique identifier of the item
     * @returns a directoryRoleTemplateItemRequestBuilder
     */
    directoryRoleTemplatesById(id: string): DirectoryRoleTemplateItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.domainDnsRecords.item collection
     * @param id Unique identifier of the item
     * @returns a domainDnsRecordItemRequestBuilder
     */
    domainDnsRecordsById(id: string): DomainDnsRecordItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.domains.item collection
     * @param id Unique identifier of the item
     * @returns a domainItemRequestBuilder
     */
    domainsById(id: string): DomainItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.drives.item collection
     * @param id Unique identifier of the item
     * @returns a driveItemRequestBuilder
     */
    drivesById(id: string): DriveItemRequestBuilder;
    get(h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<void>;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.groupLifecyclePolicies.item collection
     * @param id Unique identifier of the item
     * @returns a groupLifecyclePolicyItemRequestBuilder
     */
    groupLifecyclePoliciesById(id: string): GroupLifecyclePolicyItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.groups.item collection
     * @param id Unique identifier of the item
     * @returns a groupItemRequestBuilder
     */
    groupsById(id: string): GroupItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.groupSettings.item collection
     * @param id Unique identifier of the item
     * @returns a groupSettingItemRequestBuilder
     */
    groupSettingsById(id: string): GroupSettingItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.groupSettingTemplates.item collection
     * @param id Unique identifier of the item
     * @returns a groupSettingTemplateItemRequestBuilder
     */
    groupSettingTemplatesById(id: string): GroupSettingTemplateItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.identityProviders.item collection
     * @param id Unique identifier of the item
     * @returns a identityProviderItemRequestBuilder
     */
    identityProvidersById(id: string): IdentityProviderItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.invitations.item collection
     * @param id Unique identifier of the item
     * @returns a invitationItemRequestBuilder
     */
    invitationsById(id: string): InvitationItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.localizations.item collection
     * @param id Unique identifier of the item
     * @returns a organizationalBrandingLocalizationItemRequestBuilder
     */
    localizationsById(id: string): OrganizationalBrandingLocalizationItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.oauth2PermissionGrants.item collection
     * @param id Unique identifier of the item
     * @returns a oAuth2PermissionGrantItemRequestBuilder
     */
    oauth2PermissionGrantsById(id: string): OAuth2PermissionGrantItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.organization.item collection
     * @param id Unique identifier of the item
     * @returns a organizationItemRequestBuilder
     */
    organizationById(id: string): OrganizationItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.permissionGrants.item collection
     * @param id Unique identifier of the item
     * @returns a resourceSpecificPermissionGrantItemRequestBuilder
     */
    permissionGrantsById(id: string): ResourceSpecificPermissionGrantItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.places.item collection
     * @param id Unique identifier of the item
     * @returns a placeItemRequestBuilder
     */
    placesById(id: string): PlaceItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.schemaExtensions.item collection
     * @param id Unique identifier of the item
     * @returns a schemaExtensionItemRequestBuilder
     */
    schemaExtensionsById(id: string): SchemaExtensionItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.scopedRoleMemberships.item collection
     * @param id Unique identifier of the item
     * @returns a scopedRoleMembershipItemRequestBuilder
     */
    scopedRoleMembershipsById(id: string): ScopedRoleMembershipItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.servicePrincipals.item collection
     * @param id Unique identifier of the item
     * @returns a servicePrincipalItemRequestBuilder
     */
    servicePrincipalsById(id: string): ServicePrincipalItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.shares.item collection
     * @param id Unique identifier of the item
     * @returns a sharedDriveItemItemRequestBuilder
     */
    sharesById(id: string): SharedDriveItemItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.sites.item collection
     * @param id Unique identifier of the item
     * @returns a siteItemRequestBuilder
     */
    sitesById(id: string): SiteItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.subscribedSkus.item collection
     * @param id Unique identifier of the item
     * @returns a subscribedSkuItemRequestBuilder
     */
    subscribedSkusById(id: string): SubscribedSkuItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.subscriptions.item collection
     * @param id Unique identifier of the item
     * @returns a subscriptionItemRequestBuilder
     */
    subscriptionsById(id: string): SubscriptionItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.teams.item collection
     * @param id Unique identifier of the item
     * @returns a teamItemRequestBuilder
     */
    teamsById(id: string): TeamItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.teamsTemplates.item collection
     * @param id Unique identifier of the item
     * @returns a teamsTemplateItemRequestBuilder
     */
    teamsTemplatesById(id: string): TeamsTemplateItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.users.item collection
     * @param id Unique identifier of the item
     * @returns a userItemRequestBuilder
     */
    usersById(id: string): UserItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.workbooks.item collection
     * @param id Unique identifier of the item
     * @returns a driveItemItemRequestBuilder
     */
    workbooksById(id: string): DriveItemItemRequestBuilder;
}
