"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ForwardRequestBody = void 0;
const createRecipientFromDiscriminatorValue_1 = require("../../../../../../../../models/microsoft/graph/createRecipientFromDiscriminatorValue");
/** Provides operations to call the forward method.  */
class ForwardRequestBody {
    /**
     * Instantiates a new forwardRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the comment property value.
     * @returns a string
     */
    get comment() {
        return this._comment;
    }
    ;
    /**
     * Sets the comment property value.
     * @param value Value to set for the Comment property.
     */
    set comment(value) {
        this._comment = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "comment": (o, n) => { o.comment = n.getStringValue(); },
            "toRecipients": (o, n) => { o.toRecipients = n.getCollectionOfObjectValues(createRecipientFromDiscriminatorValue_1.createRecipientFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("comment", this.comment);
        writer.writeCollectionOfObjectValues("toRecipients", this.toRecipients);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the toRecipients property value.
     * @returns a recipient
     */
    get toRecipients() {
        return this._toRecipients;
    }
    ;
    /**
     * Sets the toRecipients property value.
     * @param value Value to set for the ToRecipients property.
     */
    set toRecipients(value) {
        this._toRecipients = value;
    }
    ;
}
exports.ForwardRequestBody = ForwardRequestBody;
