"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CopyToDefaultContentLocationRequestBody = void 0;
const createItemReferenceFromDiscriminatorValue_1 = require("../../../../../../../../models/microsoft/graph/createItemReferenceFromDiscriminatorValue");
/** Provides operations to call the copyToDefaultContentLocation method.  */
class CopyToDefaultContentLocationRequestBody {
    /**
     * Instantiates a new copyToDefaultContentLocationRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the destinationFileName property value.
     * @returns a string
     */
    get destinationFileName() {
        return this._destinationFileName;
    }
    ;
    /**
     * Sets the destinationFileName property value.
     * @param value Value to set for the destinationFileName property.
     */
    set destinationFileName(value) {
        this._destinationFileName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "destinationFileName": (o, n) => { o.destinationFileName = n.getStringValue(); },
            "sourceFile": (o, n) => { o.sourceFile = n.getObjectValue(createItemReferenceFromDiscriminatorValue_1.createItemReferenceFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("destinationFileName", this.destinationFileName);
        writer.writeObjectValue("sourceFile", this.sourceFile);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the sourceFile property value.
     * @returns a itemReference
     */
    get sourceFile() {
        return this._sourceFile;
    }
    ;
    /**
     * Sets the sourceFile property value.
     * @param value Value to set for the sourceFile property.
     */
    set sourceFile(value) {
        this._sourceFile = value;
    }
    ;
}
exports.CopyToDefaultContentLocationRequestBody = CopyToDefaultContentLocationRequestBody;
