"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CopyToSectionRequestBody = void 0;
/** Provides operations to call the copyToSection method.  */
class CopyToSectionRequestBody {
    /**
     * Instantiates a new copyToSectionRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "groupId": (o, n) => { o.groupId = n.getStringValue(); },
            "id": (o, n) => { o.id = n.getStringValue(); },
            "siteCollectionId": (o, n) => { o.siteCollectionId = n.getStringValue(); },
            "siteId": (o, n) => { o.siteId = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the groupId property value.
     * @returns a string
     */
    get groupId() {
        return this._groupId;
    }
    ;
    /**
     * Sets the groupId property value.
     * @param value Value to set for the groupId property.
     */
    set groupId(value) {
        this._groupId = value;
    }
    ;
    /**
     * Gets the id property value.
     * @returns a string
     */
    get id() {
        return this._id;
    }
    ;
    /**
     * Sets the id property value.
     * @param value Value to set for the id property.
     */
    set id(value) {
        this._id = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("groupId", this.groupId);
        writer.writeStringValue("id", this.id);
        writer.writeStringValue("siteCollectionId", this.siteCollectionId);
        writer.writeStringValue("siteId", this.siteId);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the siteCollectionId property value.
     * @returns a string
     */
    get siteCollectionId() {
        return this._siteCollectionId;
    }
    ;
    /**
     * Sets the siteCollectionId property value.
     * @param value Value to set for the siteCollectionId property.
     */
    set siteCollectionId(value) {
        this._siteCollectionId = value;
    }
    ;
    /**
     * Gets the siteId property value.
     * @returns a string
     */
    get siteId() {
        return this._siteId;
    }
    ;
    /**
     * Sets the siteId property value.
     * @param value Value to set for the siteId property.
     */
    set siteId(value) {
        this._siteId = value;
    }
    ;
}
exports.CopyToSectionRequestBody = CopyToSectionRequestBody;
