import { Site } from '../../../../models/microsoft/graph/';
import { AnalyticsRequestBuilder } from './analytics/analyticsRequestBuilder';
import { ColumnsRequestBuilder } from './columns/columnsRequestBuilder';
import { ColumnDefinitionItemRequestBuilder as ifd3560d84f5b0ef40078f14f9bc1ae61c10f6c0d625b4fe3e6d905ed48fb19c8 } from './columns/item/columnDefinitionItemRequestBuilder';
import { ContentTypesRequestBuilder } from './contentTypes/contentTypesRequestBuilder';
import { ContentTypeItemRequestBuilder } from './contentTypes/item/contentTypeItemRequestBuilder';
import { DriveRequestBuilder } from './drive/driveRequestBuilder';
import { DrivesRequestBuilder } from './drives/drivesRequestBuilder';
import { DriveItemRequestBuilder } from './drives/item/driveItemRequestBuilder';
import { ExternalColumnsRequestBuilder } from './externalColumns/externalColumnsRequestBuilder';
import { ColumnDefinitionItemRequestBuilder as id7b2885ecb4143d97925da6866e18018e906b5aee422692d97345d3a9c7c0d0a } from './externalColumns/item/columnDefinitionItemRequestBuilder';
import { BaseItemItemRequestBuilder } from './items/item/baseItemItemRequestBuilder';
import { ItemsRequestBuilder } from './items/itemsRequestBuilder';
import { ListItemRequestBuilder } from './lists/item/listItemRequestBuilder';
import { ListsRequestBuilder } from './lists/listsRequestBuilder';
import { OnenoteRequestBuilder } from './onenote/onenoteRequestBuilder';
import { PermissionItemRequestBuilder } from './permissions/item/permissionItemRequestBuilder';
import { PermissionsRequestBuilder } from './permissions/permissionsRequestBuilder';
import { SiteItemRequestBuilder as i270eddd6b9ccf703fcddbc9dabbd75da7ad93a172ddeecc374dfa558384646d4 } from './sites/item/siteItemRequestBuilder';
import { SitesRequestBuilder } from './sites/sitesRequestBuilder';
import { TermStoreRequestBuilder } from './termStore/termStoreRequestBuilder';
import { StoreItemRequestBuilder } from './termStores/item/storeItemRequestBuilder';
import { TermStoresRequestBuilder } from './termStores/termStoresRequestBuilder';
import { RequestAdapter, RequestInformation, RequestOption, ResponseHandler } from '@microsoft/kiota-abstractions';
/** Provides operations to manage the sites property of the microsoft.graph.group entity.  */
export declare class SiteItemRequestBuilder {
    get analytics(): AnalyticsRequestBuilder;
    get columns(): ColumnsRequestBuilder;
    get contentTypes(): ContentTypesRequestBuilder;
    get drive(): DriveRequestBuilder;
    get drives(): DrivesRequestBuilder;
    get externalColumns(): ExternalColumnsRequestBuilder;
    get items(): ItemsRequestBuilder;
    get lists(): ListsRequestBuilder;
    get onenote(): OnenoteRequestBuilder;
    /** Path parameters for the request  */
    private readonly pathParameters;
    get permissions(): PermissionsRequestBuilder;
    /** The request adapter to use to execute the requests.  */
    private readonly requestAdapter;
    get sites(): SitesRequestBuilder;
    get termStore(): TermStoreRequestBuilder;
    get termStores(): TermStoresRequestBuilder;
    /** Url template to use to build the URL for the current request builder  */
    private readonly urlTemplate;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.groups.item.sites.item.columns.item collection
     * @param id Unique identifier of the item
     * @returns a columnDefinitionItemRequestBuilder
     */
    columnsById(id: string): ifd3560d84f5b0ef40078f14f9bc1ae61c10f6c0d625b4fe3e6d905ed48fb19c8;
    /**
     * Instantiates a new SiteItemRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters: Record<string, unknown> | string | undefined, requestAdapter: RequestAdapter);
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.groups.item.sites.item.contentTypes.item collection
     * @param id Unique identifier of the item
     * @returns a contentTypeItemRequestBuilder
     */
    contentTypesById(id: string): ContentTypeItemRequestBuilder;
    /**
     * Delete navigation property sites for groups
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createDeleteRequestInformation(h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * The list of SharePoint sites in this group. Access the default site with /sites/root.
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @returns a RequestInformation
     */
    createGetRequestInformation(q?: {
        expand?: string[];
        select?: string[];
    } | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Update the navigation property sites in groups
     * @param body
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createPatchRequestInformation(body: Site | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Delete navigation property sites for groups
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    delete(h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<void>;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.groups.item.sites.item.drives.item collection
     * @param id Unique identifier of the item
     * @returns a driveItemRequestBuilder
     */
    drivesById(id: string): DriveItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.groups.item.sites.item.externalColumns.item collection
     * @param id Unique identifier of the item
     * @returns a columnDefinitionItemRequestBuilder
     */
    externalColumnsById(id: string): id7b2885ecb4143d97925da6866e18018e906b5aee422692d97345d3a9c7c0d0a;
    /**
     * The list of SharePoint sites in this group. Access the default site with /sites/root.
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     * @returns a Promise of Site
     */
    get(q?: {
        expand?: string[];
        select?: string[];
    } | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<Site | undefined>;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.groups.item.sites.item.items.item collection
     * @param id Unique identifier of the item
     * @returns a baseItemItemRequestBuilder
     */
    itemsById(id: string): BaseItemItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.groups.item.sites.item.lists.item collection
     * @param id Unique identifier of the item
     * @returns a listItemRequestBuilder
     */
    listsById(id: string): ListItemRequestBuilder;
    /**
     * Update the navigation property sites in groups
     * @param body
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    patch(body: Site | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<void>;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.groups.item.sites.item.permissions.item collection
     * @param id Unique identifier of the item
     * @returns a permissionItemRequestBuilder
     */
    permissionsById(id: string): PermissionItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.groups.item.sites.item.sites.item collection
     * @param id Unique identifier of the item
     * @returns a siteItemRequestBuilder
     */
    sitesById(id: string): i270eddd6b9ccf703fcddbc9dabbd75da7ad93a172ddeecc374dfa558384646d4;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.groups.item.sites.item.termStores.item collection
     * @param id Unique identifier of the item
     * @returns a storeItemRequestBuilder
     */
    termStoresById(id: string): StoreItemRequestBuilder;
}
