"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValidatePropertiesRequestBody = void 0;
/** Provides operations to call the validateProperties method.  */
class ValidatePropertiesRequestBody {
    /**
     * Instantiates a new validatePropertiesRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the displayName property value.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "displayName": (o, n) => { o.displayName = n.getStringValue(); },
            "mailNickname": (o, n) => { o.mailNickname = n.getStringValue(); },
            "onBehalfOfUserId": (o, n) => { o.onBehalfOfUserId = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the mailNickname property value.
     * @returns a string
     */
    get mailNickname() {
        return this._mailNickname;
    }
    ;
    /**
     * Sets the mailNickname property value.
     * @param value Value to set for the mailNickname property.
     */
    set mailNickname(value) {
        this._mailNickname = value;
    }
    ;
    /**
     * Gets the onBehalfOfUserId property value.
     * @returns a string
     */
    get onBehalfOfUserId() {
        return this._onBehalfOfUserId;
    }
    ;
    /**
     * Sets the onBehalfOfUserId property value.
     * @param value Value to set for the onBehalfOfUserId property.
     */
    set onBehalfOfUserId(value) {
        this._onBehalfOfUserId = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("displayName", this.displayName);
        writer.writeStringValue("mailNickname", this.mailNickname);
        writer.writeStringValue("onBehalfOfUserId", this.onBehalfOfUserId);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ValidatePropertiesRequestBody = ValidatePropertiesRequestBody;
