"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UploadClientCertificateRequestBody = void 0;
/** Provides operations to call the uploadClientCertificate method.  */
class UploadClientCertificateRequestBody {
    /**
     * Instantiates a new uploadClientCertificateRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "password": (o, n) => { o.password = n.getStringValue(); },
            "pkcs12Value": (o, n) => { o.pkcs12Value = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the password property value.
     * @returns a string
     */
    get password() {
        return this._password;
    }
    ;
    /**
     * Sets the password property value.
     * @param value Value to set for the password property.
     */
    set password(value) {
        this._password = value;
    }
    ;
    /**
     * Gets the pkcs12Value property value.
     * @returns a string
     */
    get pkcs12Value() {
        return this._pkcs12Value;
    }
    ;
    /**
     * Sets the pkcs12Value property value.
     * @param value Value to set for the pkcs12Value property.
     */
    set pkcs12Value(value) {
        this._pkcs12Value = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("password", this.password);
        writer.writeStringValue("pkcs12Value", this.pkcs12Value);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.UploadClientCertificateRequestBody = UploadClientCertificateRequestBody;
