import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the batchRecordDecisions method.  */
export declare class BatchRecordDecisionsRequestBody implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _decision?;
    private _justification?;
    private _principalId?;
    private _resourceId?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new batchRecordDecisionsRequestBody and sets the default values.
     */
    constructor();
    /**
     * Gets the decision property value.
     * @returns a string
     */
    get decision(): string | undefined;
    /**
     * Sets the decision property value.
     * @param value Value to set for the decision property.
     */
    set decision(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the justification property value.
     * @returns a string
     */
    get justification(): string | undefined;
    /**
     * Sets the justification property value.
     * @param value Value to set for the justification property.
     */
    set justification(value: string | undefined);
    /**
     * Gets the principalId property value.
     * @returns a string
     */
    get principalId(): string | undefined;
    /**
     * Sets the principalId property value.
     * @param value Value to set for the principalId property.
     */
    set principalId(value: string | undefined);
    /**
     * Gets the resourceId property value.
     * @returns a string
     */
    get resourceId(): string | undefined;
    /**
     * Sets the resourceId property value.
     * @param value Value to set for the resourceId property.
     */
    set resourceId(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
