import { AssignedLicense } from '../../models/microsoft/graph/';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the assignLicense method.  */
export declare class AssignLicenseRequestBody implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _addLicenses?;
    private _removeLicenses?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the addLicenses property value.
     * @returns a assignedLicense
     */
    get addLicenses(): AssignedLicense[] | undefined;
    /**
     * Sets the addLicenses property value.
     * @param value Value to set for the addLicenses property.
     */
    set addLicenses(value: AssignedLicense[] | undefined);
    /**
     * Instantiates a new assignLicenseRequestBody and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the removeLicenses property value.
     * @returns a string
     */
    get removeLicenses(): string[] | undefined;
    /**
     * Sets the removeLicenses property value.
     * @param value Value to set for the removeLicenses property.
     */
    set removeLicenses(value: string[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
