import { DateTimeTimeZone } from '../../../../../../models/microsoft/graph/';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the getSchedule method.  */
export declare class GetScheduleRequestBody implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _availabilityViewInterval?;
    private _endTime?;
    private _schedules?;
    private _startTime?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the availabilityViewInterval property value.
     * @returns a integer
     */
    get availabilityViewInterval(): number | undefined;
    /**
     * Sets the availabilityViewInterval property value.
     * @param value Value to set for the AvailabilityViewInterval property.
     */
    set availabilityViewInterval(value: number | undefined);
    /**
     * Instantiates a new getScheduleRequestBody and sets the default values.
     */
    constructor();
    /**
     * Gets the endTime property value.
     * @returns a dateTimeTimeZone
     */
    get endTime(): DateTimeTimeZone | undefined;
    /**
     * Sets the endTime property value.
     * @param value Value to set for the EndTime property.
     */
    set endTime(value: DateTimeTimeZone | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the schedules property value.
     * @returns a string
     */
    get schedules(): string[] | undefined;
    /**
     * Sets the schedules property value.
     * @param value Value to set for the Schedules property.
     */
    set schedules(value: string[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the startTime property value.
     * @returns a dateTimeTimeZone
     */
    get startTime(): DateTimeTimeZone | undefined;
    /**
     * Sets the startTime property value.
     * @param value Value to set for the StartTime property.
     */
    set startTime(value: DateTimeTimeZone | undefined);
}
