"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateUploadSessionRequestBody = void 0;
const createAttachmentItemFromDiscriminatorValue_1 = require("../../../../../models/microsoft/graph/createAttachmentItemFromDiscriminatorValue");
/** Provides operations to call the createUploadSession method.  */
class CreateUploadSessionRequestBody {
    /**
     * Instantiates a new createUploadSessionRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the attachmentItem property value.
     * @returns a attachmentItem
     */
    get attachmentItem() {
        return this._attachmentItem;
    }
    ;
    /**
     * Sets the attachmentItem property value.
     * @param value Value to set for the AttachmentItem property.
     */
    set attachmentItem(value) {
        this._attachmentItem = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "attachmentItem": (o, n) => { o.attachmentItem = n.getObjectValue(createAttachmentItemFromDiscriminatorValue_1.createAttachmentItemFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("attachmentItem", this.attachmentItem);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.CreateUploadSessionRequestBody = CreateUploadSessionRequestBody;
