import { ContentType } from '../../../../../../models/microsoft/graph/';
import { AssociateWithHubSitesRequestBuilder } from './associateWithHubSites/associateWithHubSitesRequestBuilder';
import { BaseRequestBuilder } from './base/baseRequestBuilder';
import { BaseTypesRequestBuilder } from './baseTypes/baseTypesRequestBuilder';
import { ContentTypeItemRequestBuilder as ief32609912716a70a09abd89cad61f2f5545224f741b5f241967a6ff9f8acb09 } from './baseTypes/item/contentTypeItemRequestBuilder';
import { ColumnLinksRequestBuilder } from './columnLinks/columnLinksRequestBuilder';
import { ColumnLinkItemRequestBuilder } from './columnLinks/item/columnLinkItemRequestBuilder';
import { ColumnPositionsRequestBuilder } from './columnPositions/columnPositionsRequestBuilder';
import { ColumnDefinitionItemRequestBuilder as ieca3c8d5139592e6bd73a5c720a39b0b86f0c4da76257700d0bf2cecdb2d24b4 } from './columnPositions/item/columnDefinitionItemRequestBuilder';
import { ColumnsRequestBuilder } from './columns/columnsRequestBuilder';
import { ColumnDefinitionItemRequestBuilder as i710802058528a4fa0b2fffc8bff28afe81b17ef73fdc339d5200367d6a8b3394 } from './columns/item/columnDefinitionItemRequestBuilder';
import { CopyToDefaultContentLocationRequestBuilder } from './copyToDefaultContentLocation/copyToDefaultContentLocationRequestBuilder';
import { IsPublishedRequestBuilder } from './isPublished/isPublishedRequestBuilder';
import { PublishRequestBuilder } from './publish/publishRequestBuilder';
import { UnpublishRequestBuilder } from './unpublish/unpublishRequestBuilder';
import { RequestAdapter, RequestInformation, RequestOption, ResponseHandler } from '@microsoft/kiota-abstractions';
/** Provides operations to manage the contentTypes property of the microsoft.graph.list entity.  */
export declare class ContentTypeItemRequestBuilder {
    get associateWithHubSites(): AssociateWithHubSitesRequestBuilder;
    get base(): BaseRequestBuilder;
    get baseTypes(): BaseTypesRequestBuilder;
    get columnLinks(): ColumnLinksRequestBuilder;
    get columnPositions(): ColumnPositionsRequestBuilder;
    get columns(): ColumnsRequestBuilder;
    get copyToDefaultContentLocation(): CopyToDefaultContentLocationRequestBuilder;
    /** Path parameters for the request  */
    private readonly pathParameters;
    get publish(): PublishRequestBuilder;
    /** The request adapter to use to execute the requests.  */
    private readonly requestAdapter;
    get unpublish(): UnpublishRequestBuilder;
    /** Url template to use to build the URL for the current request builder  */
    private readonly urlTemplate;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.me.drives.item.list.contentTypes.item.baseTypes.item collection
     * @param id Unique identifier of the item
     * @returns a contentTypeItemRequestBuilder
     */
    baseTypesById(id: string): ief32609912716a70a09abd89cad61f2f5545224f741b5f241967a6ff9f8acb09;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.me.drives.item.list.contentTypes.item.columnLinks.item collection
     * @param id Unique identifier of the item
     * @returns a columnLinkItemRequestBuilder
     */
    columnLinksById(id: string): ColumnLinkItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.me.drives.item.list.contentTypes.item.columnPositions.item collection
     * @param id Unique identifier of the item
     * @returns a columnDefinitionItemRequestBuilder
     */
    columnPositionsById(id: string): ieca3c8d5139592e6bd73a5c720a39b0b86f0c4da76257700d0bf2cecdb2d24b4;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.me.drives.item.list.contentTypes.item.columns.item collection
     * @param id Unique identifier of the item
     * @returns a columnDefinitionItemRequestBuilder
     */
    columnsById(id: string): i710802058528a4fa0b2fffc8bff28afe81b17ef73fdc339d5200367d6a8b3394;
    /**
     * Instantiates a new ContentTypeItemRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters: Record<string, unknown> | string | undefined, requestAdapter: RequestAdapter);
    /**
     * Delete navigation property contentTypes for me
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createDeleteRequestInformation(h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * The collection of content types present in this list.
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @returns a RequestInformation
     */
    createGetRequestInformation(q?: {
        expand?: string[];
        select?: string[];
    } | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Update the navigation property contentTypes in me
     * @param body
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createPatchRequestInformation(body: ContentType | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Delete navigation property contentTypes for me
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    delete(h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<void>;
    /**
     * The collection of content types present in this list.
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     * @returns a Promise of ContentType
     */
    get(q?: {
        expand?: string[];
        select?: string[];
    } | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<ContentType | undefined>;
    /**
     * Provides operations to call the isPublished method.
     * @returns a isPublishedRequestBuilder
     */
    isPublished(): IsPublishedRequestBuilder;
    /**
     * Update the navigation property contentTypes in me
     * @param body
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    patch(body: ContentType | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<void>;
}
