import { TimeSlot } from '../../../../../../models/microsoft/graph/';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the tentativelyAccept method.  */
export declare class TentativelyAcceptRequestBody implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _comment?;
    private _proposedNewTime?;
    private _sendResponse?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the comment property value.
     * @returns a string
     */
    get comment(): string | undefined;
    /**
     * Sets the comment property value.
     * @param value Value to set for the Comment property.
     */
    set comment(value: string | undefined);
    /**
     * Instantiates a new tentativelyAcceptRequestBody and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the proposedNewTime property value.
     * @returns a timeSlot
     */
    get proposedNewTime(): TimeSlot | undefined;
    /**
     * Sets the proposedNewTime property value.
     * @param value Value to set for the ProposedNewTime property.
     */
    set proposedNewTime(value: TimeSlot | undefined);
    /**
     * Gets the sendResponse property value.
     * @returns a boolean
     */
    get sendResponse(): boolean | undefined;
    /**
     * Sets the sendResponse property value.
     * @param value Value to set for the SendResponse property.
     */
    set sendResponse(value: boolean | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
