"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SnoozeReminderRequestBody = void 0;
const createDateTimeTimeZoneFromDiscriminatorValue_1 = require("../../../../models/microsoft/graph/createDateTimeTimeZoneFromDiscriminatorValue");
/** Provides operations to call the snoozeReminder method.  */
class SnoozeReminderRequestBody {
    /**
     * Instantiates a new snoozeReminderRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "newReminderTime": (o, n) => { o.newReminderTime = n.getObjectValue(createDateTimeTimeZoneFromDiscriminatorValue_1.createDateTimeTimeZoneFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the newReminderTime property value.
     * @returns a dateTimeTimeZone
     */
    get newReminderTime() {
        return this._newReminderTime;
    }
    ;
    /**
     * Sets the newReminderTime property value.
     * @param value Value to set for the NewReminderTime property.
     */
    set newReminderTime(value) {
        this._newReminderTime = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("newReminderTime", this.newReminderTime);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.SnoozeReminderRequestBody = SnoozeReminderRequestBody;
