import { ManagedDevice } from '../../../models/microsoft/graph/';
import { BypassActivationLockRequestBuilder } from './bypassActivationLock/bypassActivationLockRequestBuilder';
import { CleanWindowsDeviceRequestBuilder } from './cleanWindowsDevice/cleanWindowsDeviceRequestBuilder';
import { DeleteUserFromSharedAppleDeviceRequestBuilder } from './deleteUserFromSharedAppleDevice/deleteUserFromSharedAppleDeviceRequestBuilder';
import { DeviceCategoryRequestBuilder } from './deviceCategory/deviceCategoryRequestBuilder';
import { DeviceCompliancePolicyStatesRequestBuilder } from './deviceCompliancePolicyStates/deviceCompliancePolicyStatesRequestBuilder';
import { DeviceCompliancePolicyStateItemRequestBuilder } from './deviceCompliancePolicyStates/item/deviceCompliancePolicyStateItemRequestBuilder';
import { DeviceConfigurationStatesRequestBuilder } from './deviceConfigurationStates/deviceConfigurationStatesRequestBuilder';
import { DeviceConfigurationStateItemRequestBuilder } from './deviceConfigurationStates/item/deviceConfigurationStateItemRequestBuilder';
import { DisableLostModeRequestBuilder } from './disableLostMode/disableLostModeRequestBuilder';
import { LocateDeviceRequestBuilder } from './locateDevice/locateDeviceRequestBuilder';
import { LogoutSharedAppleDeviceActiveUserRequestBuilder } from './logoutSharedAppleDeviceActiveUser/logoutSharedAppleDeviceActiveUserRequestBuilder';
import { RebootNowRequestBuilder } from './rebootNow/rebootNowRequestBuilder';
import { RecoverPasscodeRequestBuilder } from './recoverPasscode/recoverPasscodeRequestBuilder';
import { RemoteLockRequestBuilder } from './remoteLock/remoteLockRequestBuilder';
import { RequestRemoteAssistanceRequestBuilder } from './requestRemoteAssistance/requestRemoteAssistanceRequestBuilder';
import { ResetPasscodeRequestBuilder } from './resetPasscode/resetPasscodeRequestBuilder';
import { RetireRequestBuilder } from './retire/retireRequestBuilder';
import { ShutDownRequestBuilder } from './shutDown/shutDownRequestBuilder';
import { SyncDeviceRequestBuilder } from './syncDevice/syncDeviceRequestBuilder';
import { UpdateWindowsDeviceAccountRequestBuilder } from './updateWindowsDeviceAccount/updateWindowsDeviceAccountRequestBuilder';
import { WindowsDefenderScanRequestBuilder } from './windowsDefenderScan/windowsDefenderScanRequestBuilder';
import { WindowsDefenderUpdateSignaturesRequestBuilder } from './windowsDefenderUpdateSignatures/windowsDefenderUpdateSignaturesRequestBuilder';
import { WipeRequestBuilder } from './wipe/wipeRequestBuilder';
import { RequestAdapter, RequestInformation, RequestOption, ResponseHandler } from '@microsoft/kiota-abstractions';
/** Provides operations to manage the managedDevices property of the microsoft.graph.user entity.  */
export declare class ManagedDeviceItemRequestBuilder {
    get bypassActivationLock(): BypassActivationLockRequestBuilder;
    get cleanWindowsDevice(): CleanWindowsDeviceRequestBuilder;
    get deleteUserFromSharedAppleDevice(): DeleteUserFromSharedAppleDeviceRequestBuilder;
    get deviceCategory(): DeviceCategoryRequestBuilder;
    get deviceCompliancePolicyStates(): DeviceCompliancePolicyStatesRequestBuilder;
    get deviceConfigurationStates(): DeviceConfigurationStatesRequestBuilder;
    get disableLostMode(): DisableLostModeRequestBuilder;
    get locateDevice(): LocateDeviceRequestBuilder;
    get logoutSharedAppleDeviceActiveUser(): LogoutSharedAppleDeviceActiveUserRequestBuilder;
    /** Path parameters for the request  */
    private readonly pathParameters;
    get rebootNow(): RebootNowRequestBuilder;
    get recoverPasscode(): RecoverPasscodeRequestBuilder;
    get remoteLock(): RemoteLockRequestBuilder;
    /** The request adapter to use to execute the requests.  */
    private readonly requestAdapter;
    get requestRemoteAssistance(): RequestRemoteAssistanceRequestBuilder;
    get resetPasscode(): ResetPasscodeRequestBuilder;
    get retire(): RetireRequestBuilder;
    get shutDown(): ShutDownRequestBuilder;
    get syncDevice(): SyncDeviceRequestBuilder;
    get updateWindowsDeviceAccount(): UpdateWindowsDeviceAccountRequestBuilder;
    /** Url template to use to build the URL for the current request builder  */
    private readonly urlTemplate;
    get windowsDefenderScan(): WindowsDefenderScanRequestBuilder;
    get windowsDefenderUpdateSignatures(): WindowsDefenderUpdateSignaturesRequestBuilder;
    get wipe(): WipeRequestBuilder;
    /**
     * Instantiates a new ManagedDeviceItemRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters: Record<string, unknown> | string | undefined, requestAdapter: RequestAdapter);
    /**
     * Delete navigation property managedDevices for me
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createDeleteRequestInformation(h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * The managed devices associated with the user.
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @returns a RequestInformation
     */
    createGetRequestInformation(q?: {
        expand?: string[];
        select?: string[];
    } | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Update the navigation property managedDevices in me
     * @param body
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createPatchRequestInformation(body: ManagedDevice | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Delete navigation property managedDevices for me
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    delete(h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<void>;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.me.managedDevices.item.deviceCompliancePolicyStates.item collection
     * @param id Unique identifier of the item
     * @returns a deviceCompliancePolicyStateItemRequestBuilder
     */
    deviceCompliancePolicyStatesById(id: string): DeviceCompliancePolicyStateItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.me.managedDevices.item.deviceConfigurationStates.item collection
     * @param id Unique identifier of the item
     * @returns a deviceConfigurationStateItemRequestBuilder
     */
    deviceConfigurationStatesById(id: string): DeviceConfigurationStateItemRequestBuilder;
    /**
     * The managed devices associated with the user.
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     * @returns a Promise of ManagedDevice
     */
    get(q?: {
        expand?: string[];
        select?: string[];
    } | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<ManagedDevice | undefined>;
    /**
     * Update the navigation property managedDevices in me
     * @param body
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    patch(body: ManagedDevice | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<void>;
}
