"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ManagedDeviceItemRequestBuilder = void 0;
const createManagedDeviceFromDiscriminatorValue_1 = require("../../../models/microsoft/graph/createManagedDeviceFromDiscriminatorValue");
const createODataErrorFromDiscriminatorValue_1 = require("../../../models/microsoft/graph/oDataErrors/createODataErrorFromDiscriminatorValue");
const bypassActivationLockRequestBuilder_1 = require("./bypassActivationLock/bypassActivationLockRequestBuilder");
const cleanWindowsDeviceRequestBuilder_1 = require("./cleanWindowsDevice/cleanWindowsDeviceRequestBuilder");
const deleteUserFromSharedAppleDeviceRequestBuilder_1 = require("./deleteUserFromSharedAppleDevice/deleteUserFromSharedAppleDeviceRequestBuilder");
const deviceCategoryRequestBuilder_1 = require("./deviceCategory/deviceCategoryRequestBuilder");
const deviceCompliancePolicyStatesRequestBuilder_1 = require("./deviceCompliancePolicyStates/deviceCompliancePolicyStatesRequestBuilder");
const deviceCompliancePolicyStateItemRequestBuilder_1 = require("./deviceCompliancePolicyStates/item/deviceCompliancePolicyStateItemRequestBuilder");
const deviceConfigurationStatesRequestBuilder_1 = require("./deviceConfigurationStates/deviceConfigurationStatesRequestBuilder");
const deviceConfigurationStateItemRequestBuilder_1 = require("./deviceConfigurationStates/item/deviceConfigurationStateItemRequestBuilder");
const disableLostModeRequestBuilder_1 = require("./disableLostMode/disableLostModeRequestBuilder");
const locateDeviceRequestBuilder_1 = require("./locateDevice/locateDeviceRequestBuilder");
const logoutSharedAppleDeviceActiveUserRequestBuilder_1 = require("./logoutSharedAppleDeviceActiveUser/logoutSharedAppleDeviceActiveUserRequestBuilder");
const rebootNowRequestBuilder_1 = require("./rebootNow/rebootNowRequestBuilder");
const recoverPasscodeRequestBuilder_1 = require("./recoverPasscode/recoverPasscodeRequestBuilder");
const remoteLockRequestBuilder_1 = require("./remoteLock/remoteLockRequestBuilder");
const requestRemoteAssistanceRequestBuilder_1 = require("./requestRemoteAssistance/requestRemoteAssistanceRequestBuilder");
const resetPasscodeRequestBuilder_1 = require("./resetPasscode/resetPasscodeRequestBuilder");
const retireRequestBuilder_1 = require("./retire/retireRequestBuilder");
const shutDownRequestBuilder_1 = require("./shutDown/shutDownRequestBuilder");
const syncDeviceRequestBuilder_1 = require("./syncDevice/syncDeviceRequestBuilder");
const updateWindowsDeviceAccountRequestBuilder_1 = require("./updateWindowsDeviceAccount/updateWindowsDeviceAccountRequestBuilder");
const windowsDefenderScanRequestBuilder_1 = require("./windowsDefenderScan/windowsDefenderScanRequestBuilder");
const windowsDefenderUpdateSignaturesRequestBuilder_1 = require("./windowsDefenderUpdateSignatures/windowsDefenderUpdateSignaturesRequestBuilder");
const wipeRequestBuilder_1 = require("./wipe/wipeRequestBuilder");
const kiota_abstractions_1 = require("@microsoft/kiota-abstractions");
/** Provides operations to manage the managedDevices property of the microsoft.graph.user entity.  */
class ManagedDeviceItemRequestBuilder {
    /**
     * Instantiates a new ManagedDeviceItemRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters, requestAdapter) {
        if (!pathParameters)
            throw new Error("pathParameters cannot be undefined");
        if (!requestAdapter)
            throw new Error("requestAdapter cannot be undefined");
        this.urlTemplate = "{+baseurl}/me/managedDevices/{managedDevice_id}{?select,expand}";
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(pathParameters);
        this.pathParameters = urlTplParams;
        this.requestAdapter = requestAdapter;
    }
    get bypassActivationLock() {
        return new bypassActivationLockRequestBuilder_1.BypassActivationLockRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get cleanWindowsDevice() {
        return new cleanWindowsDeviceRequestBuilder_1.CleanWindowsDeviceRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get deleteUserFromSharedAppleDevice() {
        return new deleteUserFromSharedAppleDeviceRequestBuilder_1.DeleteUserFromSharedAppleDeviceRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get deviceCategory() {
        return new deviceCategoryRequestBuilder_1.DeviceCategoryRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get deviceCompliancePolicyStates() {
        return new deviceCompliancePolicyStatesRequestBuilder_1.DeviceCompliancePolicyStatesRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get deviceConfigurationStates() {
        return new deviceConfigurationStatesRequestBuilder_1.DeviceConfigurationStatesRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get disableLostMode() {
        return new disableLostModeRequestBuilder_1.DisableLostModeRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get locateDevice() {
        return new locateDeviceRequestBuilder_1.LocateDeviceRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get logoutSharedAppleDeviceActiveUser() {
        return new logoutSharedAppleDeviceActiveUserRequestBuilder_1.LogoutSharedAppleDeviceActiveUserRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get rebootNow() {
        return new rebootNowRequestBuilder_1.RebootNowRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get recoverPasscode() {
        return new recoverPasscodeRequestBuilder_1.RecoverPasscodeRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get remoteLock() {
        return new remoteLockRequestBuilder_1.RemoteLockRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get requestRemoteAssistance() {
        return new requestRemoteAssistanceRequestBuilder_1.RequestRemoteAssistanceRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get resetPasscode() {
        return new resetPasscodeRequestBuilder_1.ResetPasscodeRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get retire() {
        return new retireRequestBuilder_1.RetireRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get shutDown() {
        return new shutDownRequestBuilder_1.ShutDownRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get syncDevice() {
        return new syncDeviceRequestBuilder_1.SyncDeviceRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get updateWindowsDeviceAccount() {
        return new updateWindowsDeviceAccountRequestBuilder_1.UpdateWindowsDeviceAccountRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get windowsDefenderScan() {
        return new windowsDefenderScanRequestBuilder_1.WindowsDefenderScanRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get windowsDefenderUpdateSignatures() {
        return new windowsDefenderUpdateSignaturesRequestBuilder_1.WindowsDefenderUpdateSignaturesRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get wipe() {
        return new wipeRequestBuilder_1.WipeRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    ;
    /**
     * Delete navigation property managedDevices for me
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createDeleteRequestInformation(h, o) {
        const requestInfo = new kiota_abstractions_1.RequestInformation();
        requestInfo.urlTemplate = this.urlTemplate;
        requestInfo.pathParameters = this.pathParameters;
        requestInfo.httpMethod = kiota_abstractions_1.HttpMethod.DELETE;
        if (h)
            requestInfo.headers = h;
        o && requestInfo.addRequestOptions(...o);
        return requestInfo;
    }
    ;
    /**
     * The managed devices associated with the user.
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @returns a RequestInformation
     */
    createGetRequestInformation(q, h, o) {
        const requestInfo = new kiota_abstractions_1.RequestInformation();
        requestInfo.urlTemplate = this.urlTemplate;
        requestInfo.pathParameters = this.pathParameters;
        requestInfo.httpMethod = kiota_abstractions_1.HttpMethod.GET;
        if (h)
            requestInfo.headers = h;
        q && requestInfo.setQueryStringParametersFromRawObject(q);
        o && requestInfo.addRequestOptions(...o);
        return requestInfo;
    }
    ;
    /**
     * Update the navigation property managedDevices in me
     * @param body
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createPatchRequestInformation(body, h, o) {
        if (!body)
            throw new Error("body cannot be undefined");
        const requestInfo = new kiota_abstractions_1.RequestInformation();
        requestInfo.urlTemplate = this.urlTemplate;
        requestInfo.pathParameters = this.pathParameters;
        requestInfo.httpMethod = kiota_abstractions_1.HttpMethod.PATCH;
        if (h)
            requestInfo.headers = h;
        requestInfo.setContentFromParsable(this.requestAdapter, "application/json", body);
        o && requestInfo.addRequestOptions(...o);
        return requestInfo;
    }
    ;
    /**
     * Delete navigation property managedDevices for me
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    delete(h, o, responseHandler) {
        var _a, _b;
        const requestInfo = this.createDeleteRequestInformation(h, o);
        const errorMapping = {
            "4XX": createODataErrorFromDiscriminatorValue_1.createODataErrorFromDiscriminatorValue,
            "5XX": createODataErrorFromDiscriminatorValue_1.createODataErrorFromDiscriminatorValue,
        };
        return (_b = (_a = this.requestAdapter) === null || _a === void 0 ? void 0 : _a.sendNoResponseContentAsync(requestInfo, responseHandler, errorMapping)) !== null && _b !== void 0 ? _b : Promise.reject(new Error('http core is null'));
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.me.managedDevices.item.deviceCompliancePolicyStates.item collection
     * @param id Unique identifier of the item
     * @returns a deviceCompliancePolicyStateItemRequestBuilder
     */
    deviceCompliancePolicyStatesById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["deviceCompliancePolicyState_id"] = id;
        return new deviceCompliancePolicyStateItemRequestBuilder_1.DeviceCompliancePolicyStateItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.me.managedDevices.item.deviceConfigurationStates.item collection
     * @param id Unique identifier of the item
     * @returns a deviceConfigurationStateItemRequestBuilder
     */
    deviceConfigurationStatesById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["deviceConfigurationState_id"] = id;
        return new deviceConfigurationStateItemRequestBuilder_1.DeviceConfigurationStateItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * The managed devices associated with the user.
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     * @returns a Promise of ManagedDevice
     */
    get(q, h, o, responseHandler) {
        var _a, _b;
        const requestInfo = this.createGetRequestInformation(q, h, o);
        const errorMapping = {
            "4XX": createODataErrorFromDiscriminatorValue_1.createODataErrorFromDiscriminatorValue,
            "5XX": createODataErrorFromDiscriminatorValue_1.createODataErrorFromDiscriminatorValue,
        };
        return (_b = (_a = this.requestAdapter) === null || _a === void 0 ? void 0 : _a.sendAsync(requestInfo, createManagedDeviceFromDiscriminatorValue_1.createManagedDeviceFromDiscriminatorValue, responseHandler, errorMapping)) !== null && _b !== void 0 ? _b : Promise.reject(new Error('http core is null'));
    }
    ;
    /**
     * Update the navigation property managedDevices in me
     * @param body
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    patch(body, h, o, responseHandler) {
        var _a, _b;
        if (!body)
            throw new Error("body cannot be undefined");
        const requestInfo = this.createPatchRequestInformation(body, h, o);
        const errorMapping = {
            "4XX": createODataErrorFromDiscriminatorValue_1.createODataErrorFromDiscriminatorValue,
            "5XX": createODataErrorFromDiscriminatorValue_1.createODataErrorFromDiscriminatorValue,
        };
        return (_b = (_a = this.requestAdapter) === null || _a === void 0 ? void 0 : _a.sendNoResponseContentAsync(requestInfo, responseHandler, errorMapping)) !== null && _b !== void 0 ? _b : Promise.reject(new Error('http core is null'));
    }
    ;
}
exports.ManagedDeviceItemRequestBuilder = ManagedDeviceItemRequestBuilder;
