import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the copyToSectionGroup method.  */
export declare class CopyToSectionGroupRequestBody implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _groupId?;
    private _id?;
    private _renameAs?;
    private _siteCollectionId?;
    private _siteId?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new copyToSectionGroupRequestBody and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the groupId property value.
     * @returns a string
     */
    get groupId(): string | undefined;
    /**
     * Sets the groupId property value.
     * @param value Value to set for the groupId property.
     */
    set groupId(value: string | undefined);
    /**
     * Gets the id property value.
     * @returns a string
     */
    get id(): string | undefined;
    /**
     * Sets the id property value.
     * @param value Value to set for the id property.
     */
    set id(value: string | undefined);
    /**
     * Gets the renameAs property value.
     * @returns a string
     */
    get renameAs(): string | undefined;
    /**
     * Sets the renameAs property value.
     * @param value Value to set for the renameAs property.
     */
    set renameAs(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the siteCollectionId property value.
     * @returns a string
     */
    get siteCollectionId(): string | undefined;
    /**
     * Sets the siteCollectionId property value.
     * @param value Value to set for the siteCollectionId property.
     */
    set siteCollectionId(value: string | undefined);
    /**
     * Gets the siteId property value.
     * @returns a string
     */
    get siteId(): string | undefined;
    /**
     * Sets the siteId property value.
     * @param value Value to set for the siteId property.
     */
    set siteId(value: string | undefined);
}
