"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OnenotePatchContentRequestBody = void 0;
const createOnenotePatchContentCommandFromDiscriminatorValue_1 = require("../../../../../../../models/microsoft/graph/createOnenotePatchContentCommandFromDiscriminatorValue");
/** Provides operations to call the onenotePatchContent method.  */
class OnenotePatchContentRequestBody {
    /**
     * Instantiates a new onenotePatchContentRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the commands property value.
     * @returns a onenotePatchContentCommand
     */
    get commands() {
        return this._commands;
    }
    ;
    /**
     * Sets the commands property value.
     * @param value Value to set for the commands property.
     */
    set commands(value) {
        this._commands = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "commands": (o, n) => { o.commands = n.getCollectionOfObjectValues(createOnenotePatchContentCommandFromDiscriminatorValue_1.createOnenotePatchContentCommandFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfObjectValues("commands", this.commands);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.OnenotePatchContentRequestBody = OnenotePatchContentRequestBody;
