"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccessPackage = void 0;
const createAccessPackageAssignmentPolicyFromDiscriminatorValue_1 = require("./createAccessPackageAssignmentPolicyFromDiscriminatorValue");
const createAccessPackageCatalogFromDiscriminatorValue_1 = require("./createAccessPackageCatalogFromDiscriminatorValue");
const index_1 = require("./index");
class AccessPackage extends index_1.Entity {
    /**
     * Instantiates a new accessPackage and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the assignmentPolicies property value.
     * @returns a accessPackageAssignmentPolicy
     */
    get assignmentPolicies() {
        return this._assignmentPolicies;
    }
    ;
    /**
     * Sets the assignmentPolicies property value.
     * @param value Value to set for the assignmentPolicies property.
     */
    set assignmentPolicies(value) {
        this._assignmentPolicies = value;
    }
    ;
    /**
     * Gets the catalog property value. Read-only. Nullable.
     * @returns a accessPackageCatalog
     */
    get catalog() {
        return this._catalog;
    }
    ;
    /**
     * Sets the catalog property value. Read-only. Nullable.
     * @param value Value to set for the catalog property.
     */
    set catalog(value) {
        this._catalog = value;
    }
    ;
    ;
    /**
     * Gets the createdDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * Gets the description property value. The description of the access package.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. The description of the access package.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the displayName property value. The display name of the access package. Supports $filter (eq, contains).
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The display name of the access package. Supports $filter (eq, contains).
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "assignmentPolicies": (o, n) => { o.assignmentPolicies = n.getCollectionOfObjectValues(createAccessPackageAssignmentPolicyFromDiscriminatorValue_1.createAccessPackageAssignmentPolicyFromDiscriminatorValue); }, "catalog": (o, n) => { o.catalog = n.getObjectValue(createAccessPackageCatalogFromDiscriminatorValue_1.createAccessPackageCatalogFromDiscriminatorValue); }, "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); }, "description": (o, n) => { o.description = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "isHidden": (o, n) => { o.isHidden = n.getBooleanValue(); }, "modifiedDateTime": (o, n) => { o.modifiedDateTime = n.getDateValue(); } });
    }
    ;
    /**
     * Gets the isHidden property value. Whether the access package is hidden from the requestor.
     * @returns a boolean
     */
    get isHidden() {
        return this._isHidden;
    }
    ;
    /**
     * Sets the isHidden property value. Whether the access package is hidden from the requestor.
     * @param value Value to set for the isHidden property.
     */
    set isHidden(value) {
        this._isHidden = value;
    }
    ;
    /**
     * Gets the modifiedDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
     * @returns a Date
     */
    get modifiedDateTime() {
        return this._modifiedDateTime;
    }
    ;
    /**
     * Sets the modifiedDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
     * @param value Value to set for the modifiedDateTime property.
     */
    set modifiedDateTime(value) {
        this._modifiedDateTime = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("assignmentPolicies", this.assignmentPolicies);
        writer.writeObjectValue("catalog", this.catalog);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeStringValue("description", this.description);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeBooleanValue("isHidden", this.isHidden);
        writer.writeDateValue("modifiedDateTime", this.modifiedDateTime);
    }
    ;
}
exports.AccessPackage = AccessPackage;
