import { SubjectSet } from './index';
import { AdditionalDataHolder, Duration, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class AccessPackageApprovalStage implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _durationBeforeAutomaticDenial?;
    private _durationBeforeEscalation?;
    private _escalationApprovers?;
    private _fallbackEscalationApprovers?;
    private _fallbackPrimaryApprovers?;
    private _isApproverJustificationRequired?;
    private _isEscalationEnabled?;
    private _primaryApprovers?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new accessPackageApprovalStage and sets the default values.
     */
    constructor();
    /**
     * Gets the durationBeforeAutomaticDenial property value.
     * @returns a Duration
     */
    get durationBeforeAutomaticDenial(): Duration | undefined;
    /**
     * Sets the durationBeforeAutomaticDenial property value.
     * @param value Value to set for the durationBeforeAutomaticDenial property.
     */
    set durationBeforeAutomaticDenial(value: Duration | undefined);
    /**
     * Gets the durationBeforeEscalation property value.
     * @returns a Duration
     */
    get durationBeforeEscalation(): Duration | undefined;
    /**
     * Sets the durationBeforeEscalation property value.
     * @param value Value to set for the durationBeforeEscalation property.
     */
    set durationBeforeEscalation(value: Duration | undefined);
    /**
     * Gets the escalationApprovers property value.
     * @returns a subjectSet
     */
    get escalationApprovers(): SubjectSet[] | undefined;
    /**
     * Sets the escalationApprovers property value.
     * @param value Value to set for the escalationApprovers property.
     */
    set escalationApprovers(value: SubjectSet[] | undefined);
    /**
     * Gets the fallbackEscalationApprovers property value.
     * @returns a subjectSet
     */
    get fallbackEscalationApprovers(): SubjectSet[] | undefined;
    /**
     * Sets the fallbackEscalationApprovers property value.
     * @param value Value to set for the fallbackEscalationApprovers property.
     */
    set fallbackEscalationApprovers(value: SubjectSet[] | undefined);
    /**
     * Gets the fallbackPrimaryApprovers property value.
     * @returns a subjectSet
     */
    get fallbackPrimaryApprovers(): SubjectSet[] | undefined;
    /**
     * Sets the fallbackPrimaryApprovers property value.
     * @param value Value to set for the fallbackPrimaryApprovers property.
     */
    set fallbackPrimaryApprovers(value: SubjectSet[] | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the isApproverJustificationRequired property value.
     * @returns a boolean
     */
    get isApproverJustificationRequired(): boolean | undefined;
    /**
     * Sets the isApproverJustificationRequired property value.
     * @param value Value to set for the isApproverJustificationRequired property.
     */
    set isApproverJustificationRequired(value: boolean | undefined);
    /**
     * Gets the isEscalationEnabled property value.
     * @returns a boolean
     */
    get isEscalationEnabled(): boolean | undefined;
    /**
     * Sets the isEscalationEnabled property value.
     * @param value Value to set for the isEscalationEnabled property.
     */
    set isEscalationEnabled(value: boolean | undefined);
    /**
     * Gets the primaryApprovers property value.
     * @returns a subjectSet
     */
    get primaryApprovers(): SubjectSet[] | undefined;
    /**
     * Sets the primaryApprovers property value.
     * @param value Value to set for the primaryApprovers property.
     */
    set primaryApprovers(value: SubjectSet[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
