"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccessPackageApprovalStage = void 0;
const createSubjectSetFromDiscriminatorValue_1 = require("./createSubjectSetFromDiscriminatorValue");
class AccessPackageApprovalStage {
    /**
     * Instantiates a new accessPackageApprovalStage and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the durationBeforeAutomaticDenial property value.
     * @returns a Duration
     */
    get durationBeforeAutomaticDenial() {
        return this._durationBeforeAutomaticDenial;
    }
    ;
    /**
     * Sets the durationBeforeAutomaticDenial property value.
     * @param value Value to set for the durationBeforeAutomaticDenial property.
     */
    set durationBeforeAutomaticDenial(value) {
        this._durationBeforeAutomaticDenial = value;
    }
    ;
    /**
     * Gets the durationBeforeEscalation property value.
     * @returns a Duration
     */
    get durationBeforeEscalation() {
        return this._durationBeforeEscalation;
    }
    ;
    /**
     * Sets the durationBeforeEscalation property value.
     * @param value Value to set for the durationBeforeEscalation property.
     */
    set durationBeforeEscalation(value) {
        this._durationBeforeEscalation = value;
    }
    ;
    /**
     * Gets the escalationApprovers property value.
     * @returns a subjectSet
     */
    get escalationApprovers() {
        return this._escalationApprovers;
    }
    ;
    /**
     * Sets the escalationApprovers property value.
     * @param value Value to set for the escalationApprovers property.
     */
    set escalationApprovers(value) {
        this._escalationApprovers = value;
    }
    ;
    /**
     * Gets the fallbackEscalationApprovers property value.
     * @returns a subjectSet
     */
    get fallbackEscalationApprovers() {
        return this._fallbackEscalationApprovers;
    }
    ;
    /**
     * Sets the fallbackEscalationApprovers property value.
     * @param value Value to set for the fallbackEscalationApprovers property.
     */
    set fallbackEscalationApprovers(value) {
        this._fallbackEscalationApprovers = value;
    }
    ;
    /**
     * Gets the fallbackPrimaryApprovers property value.
     * @returns a subjectSet
     */
    get fallbackPrimaryApprovers() {
        return this._fallbackPrimaryApprovers;
    }
    ;
    /**
     * Sets the fallbackPrimaryApprovers property value.
     * @param value Value to set for the fallbackPrimaryApprovers property.
     */
    set fallbackPrimaryApprovers(value) {
        this._fallbackPrimaryApprovers = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "durationBeforeAutomaticDenial": (o, n) => { o.durationBeforeAutomaticDenial = n.getDurationValue(); },
            "durationBeforeEscalation": (o, n) => { o.durationBeforeEscalation = n.getDurationValue(); },
            "escalationApprovers": (o, n) => { o.escalationApprovers = n.getCollectionOfObjectValues(createSubjectSetFromDiscriminatorValue_1.createSubjectSetFromDiscriminatorValue); },
            "fallbackEscalationApprovers": (o, n) => { o.fallbackEscalationApprovers = n.getCollectionOfObjectValues(createSubjectSetFromDiscriminatorValue_1.createSubjectSetFromDiscriminatorValue); },
            "fallbackPrimaryApprovers": (o, n) => { o.fallbackPrimaryApprovers = n.getCollectionOfObjectValues(createSubjectSetFromDiscriminatorValue_1.createSubjectSetFromDiscriminatorValue); },
            "isApproverJustificationRequired": (o, n) => { o.isApproverJustificationRequired = n.getBooleanValue(); },
            "isEscalationEnabled": (o, n) => { o.isEscalationEnabled = n.getBooleanValue(); },
            "primaryApprovers": (o, n) => { o.primaryApprovers = n.getCollectionOfObjectValues(createSubjectSetFromDiscriminatorValue_1.createSubjectSetFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the isApproverJustificationRequired property value.
     * @returns a boolean
     */
    get isApproverJustificationRequired() {
        return this._isApproverJustificationRequired;
    }
    ;
    /**
     * Sets the isApproverJustificationRequired property value.
     * @param value Value to set for the isApproverJustificationRequired property.
     */
    set isApproverJustificationRequired(value) {
        this._isApproverJustificationRequired = value;
    }
    ;
    /**
     * Gets the isEscalationEnabled property value.
     * @returns a boolean
     */
    get isEscalationEnabled() {
        return this._isEscalationEnabled;
    }
    ;
    /**
     * Sets the isEscalationEnabled property value.
     * @param value Value to set for the isEscalationEnabled property.
     */
    set isEscalationEnabled(value) {
        this._isEscalationEnabled = value;
    }
    ;
    /**
     * Gets the primaryApprovers property value.
     * @returns a subjectSet
     */
    get primaryApprovers() {
        return this._primaryApprovers;
    }
    ;
    /**
     * Sets the primaryApprovers property value.
     * @param value Value to set for the primaryApprovers property.
     */
    set primaryApprovers(value) {
        this._primaryApprovers = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeDurationValue("durationBeforeAutomaticDenial", this.durationBeforeAutomaticDenial);
        writer.writeDurationValue("durationBeforeEscalation", this.durationBeforeEscalation);
        writer.writeCollectionOfObjectValues("escalationApprovers", this.escalationApprovers);
        writer.writeCollectionOfObjectValues("fallbackEscalationApprovers", this.fallbackEscalationApprovers);
        writer.writeCollectionOfObjectValues("fallbackPrimaryApprovers", this.fallbackPrimaryApprovers);
        writer.writeBooleanValue("isApproverJustificationRequired", this.isApproverJustificationRequired);
        writer.writeBooleanValue("isEscalationEnabled", this.isEscalationEnabled);
        writer.writeCollectionOfObjectValues("primaryApprovers", this.primaryApprovers);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.AccessPackageApprovalStage = AccessPackageApprovalStage;
