import { AccessPackageApprovalStage } from './index';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class AccessPackageAssignmentApprovalSettings implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _isApprovalRequiredForAdd?;
    private _isApprovalRequiredForUpdate?;
    private _stages?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new accessPackageAssignmentApprovalSettings and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the isApprovalRequiredForAdd property value.
     * @returns a boolean
     */
    get isApprovalRequiredForAdd(): boolean | undefined;
    /**
     * Sets the isApprovalRequiredForAdd property value.
     * @param value Value to set for the isApprovalRequiredForAdd property.
     */
    set isApprovalRequiredForAdd(value: boolean | undefined);
    /**
     * Gets the isApprovalRequiredForUpdate property value.
     * @returns a boolean
     */
    get isApprovalRequiredForUpdate(): boolean | undefined;
    /**
     * Sets the isApprovalRequiredForUpdate property value.
     * @param value Value to set for the isApprovalRequiredForUpdate property.
     */
    set isApprovalRequiredForUpdate(value: boolean | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the stages property value.
     * @returns a accessPackageApprovalStage
     */
    get stages(): AccessPackageApprovalStage[] | undefined;
    /**
     * Sets the stages property value.
     * @param value Value to set for the stages property.
     */
    set stages(value: AccessPackageApprovalStage[] | undefined);
}
