"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccessPackageAssignmentApprovalSettings = void 0;
const createAccessPackageApprovalStageFromDiscriminatorValue_1 = require("./createAccessPackageApprovalStageFromDiscriminatorValue");
class AccessPackageAssignmentApprovalSettings {
    /**
     * Instantiates a new accessPackageAssignmentApprovalSettings and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "isApprovalRequiredForAdd": (o, n) => { o.isApprovalRequiredForAdd = n.getBooleanValue(); },
            "isApprovalRequiredForUpdate": (o, n) => { o.isApprovalRequiredForUpdate = n.getBooleanValue(); },
            "stages": (o, n) => { o.stages = n.getCollectionOfObjectValues(createAccessPackageApprovalStageFromDiscriminatorValue_1.createAccessPackageApprovalStageFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the isApprovalRequiredForAdd property value.
     * @returns a boolean
     */
    get isApprovalRequiredForAdd() {
        return this._isApprovalRequiredForAdd;
    }
    ;
    /**
     * Sets the isApprovalRequiredForAdd property value.
     * @param value Value to set for the isApprovalRequiredForAdd property.
     */
    set isApprovalRequiredForAdd(value) {
        this._isApprovalRequiredForAdd = value;
    }
    ;
    /**
     * Gets the isApprovalRequiredForUpdate property value.
     * @returns a boolean
     */
    get isApprovalRequiredForUpdate() {
        return this._isApprovalRequiredForUpdate;
    }
    ;
    /**
     * Sets the isApprovalRequiredForUpdate property value.
     * @param value Value to set for the isApprovalRequiredForUpdate property.
     */
    set isApprovalRequiredForUpdate(value) {
        this._isApprovalRequiredForUpdate = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("isApprovalRequiredForAdd", this.isApprovalRequiredForAdd);
        writer.writeBooleanValue("isApprovalRequiredForUpdate", this.isApprovalRequiredForUpdate);
        writer.writeCollectionOfObjectValues("stages", this.stages);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the stages property value.
     * @returns a accessPackageApprovalStage
     */
    get stages() {
        return this._stages;
    }
    ;
    /**
     * Sets the stages property value.
     * @param value Value to set for the stages property.
     */
    set stages(value) {
        this._stages = value;
    }
    ;
}
exports.AccessPackageAssignmentApprovalSettings = AccessPackageAssignmentApprovalSettings;
