"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccessPackageAssignmentPolicy = void 0;
const allowedTargetScope_1 = require("./allowedTargetScope");
const createAccessPackageAssignmentApprovalSettingsFromDiscriminatorValue_1 = require("./createAccessPackageAssignmentApprovalSettingsFromDiscriminatorValue");
const createAccessPackageAssignmentRequestorSettingsFromDiscriminatorValue_1 = require("./createAccessPackageAssignmentRequestorSettingsFromDiscriminatorValue");
const createAccessPackageAssignmentReviewSettingsFromDiscriminatorValue_1 = require("./createAccessPackageAssignmentReviewSettingsFromDiscriminatorValue");
const createAccessPackageCatalogFromDiscriminatorValue_1 = require("./createAccessPackageCatalogFromDiscriminatorValue");
const createAccessPackageFromDiscriminatorValue_1 = require("./createAccessPackageFromDiscriminatorValue");
const createExpirationPatternFromDiscriminatorValue_1 = require("./createExpirationPatternFromDiscriminatorValue");
const createSubjectSetFromDiscriminatorValue_1 = require("./createSubjectSetFromDiscriminatorValue");
const index_1 = require("./index");
class AccessPackageAssignmentPolicy extends index_1.Entity {
    /**
     * Instantiates a new accessPackageAssignmentPolicy and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the accessPackage property value. The access package with this policy. Read-only. Nullable. Supports $expand.
     * @returns a accessPackage
     */
    get accessPackage() {
        return this._accessPackage;
    }
    ;
    /**
     * Sets the accessPackage property value. The access package with this policy. Read-only. Nullable. Supports $expand.
     * @param value Value to set for the accessPackage property.
     */
    set accessPackage(value) {
        this._accessPackage = value;
    }
    ;
    /**
     * Gets the allowedTargetScope property value.
     * @returns a allowedTargetScope
     */
    get allowedTargetScope() {
        return this._allowedTargetScope;
    }
    ;
    /**
     * Sets the allowedTargetScope property value.
     * @param value Value to set for the allowedTargetScope property.
     */
    set allowedTargetScope(value) {
        this._allowedTargetScope = value;
    }
    ;
    /**
     * Gets the catalog property value.
     * @returns a accessPackageCatalog
     */
    get catalog() {
        return this._catalog;
    }
    ;
    /**
     * Sets the catalog property value.
     * @param value Value to set for the catalog property.
     */
    set catalog(value) {
        this._catalog = value;
    }
    ;
    ;
    /**
     * Gets the createdDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * Gets the description property value. The description of the policy.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. The description of the policy.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the displayName property value. The display name of the policy. Supports $filter (eq).
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The display name of the policy. Supports $filter (eq).
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * Gets the expiration property value.
     * @returns a expirationPattern
     */
    get expiration() {
        return this._expiration;
    }
    ;
    /**
     * Sets the expiration property value.
     * @param value Value to set for the expiration property.
     */
    set expiration(value) {
        this._expiration = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "accessPackage": (o, n) => { o.accessPackage = n.getObjectValue(createAccessPackageFromDiscriminatorValue_1.createAccessPackageFromDiscriminatorValue); }, "allowedTargetScope": (o, n) => { o.allowedTargetScope = n.getEnumValue(allowedTargetScope_1.AllowedTargetScope); }, "catalog": (o, n) => { o.catalog = n.getObjectValue(createAccessPackageCatalogFromDiscriminatorValue_1.createAccessPackageCatalogFromDiscriminatorValue); }, "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); }, "description": (o, n) => { o.description = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "expiration": (o, n) => { o.expiration = n.getObjectValue(createExpirationPatternFromDiscriminatorValue_1.createExpirationPatternFromDiscriminatorValue); }, "modifiedDateTime": (o, n) => { o.modifiedDateTime = n.getDateValue(); }, "requestApprovalSettings": (o, n) => { o.requestApprovalSettings = n.getObjectValue(createAccessPackageAssignmentApprovalSettingsFromDiscriminatorValue_1.createAccessPackageAssignmentApprovalSettingsFromDiscriminatorValue); }, "requestorSettings": (o, n) => { o.requestorSettings = n.getObjectValue(createAccessPackageAssignmentRequestorSettingsFromDiscriminatorValue_1.createAccessPackageAssignmentRequestorSettingsFromDiscriminatorValue); }, "reviewSettings": (o, n) => { o.reviewSettings = n.getObjectValue(createAccessPackageAssignmentReviewSettingsFromDiscriminatorValue_1.createAccessPackageAssignmentReviewSettingsFromDiscriminatorValue); }, "specificAllowedTargets": (o, n) => { o.specificAllowedTargets = n.getCollectionOfObjectValues(createSubjectSetFromDiscriminatorValue_1.createSubjectSetFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the modifiedDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @returns a Date
     */
    get modifiedDateTime() {
        return this._modifiedDateTime;
    }
    ;
    /**
     * Sets the modifiedDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @param value Value to set for the modifiedDateTime property.
     */
    set modifiedDateTime(value) {
        this._modifiedDateTime = value;
    }
    ;
    /**
     * Gets the requestApprovalSettings property value. Who must approve requests for access package in this policy.
     * @returns a accessPackageAssignmentApprovalSettings
     */
    get requestApprovalSettings() {
        return this._requestApprovalSettings;
    }
    ;
    /**
     * Sets the requestApprovalSettings property value. Who must approve requests for access package in this policy.
     * @param value Value to set for the requestApprovalSettings property.
     */
    set requestApprovalSettings(value) {
        this._requestApprovalSettings = value;
    }
    ;
    /**
     * Gets the requestorSettings property value. Who can request this access package from this policy.
     * @returns a accessPackageAssignmentRequestorSettings
     */
    get requestorSettings() {
        return this._requestorSettings;
    }
    ;
    /**
     * Sets the requestorSettings property value. Who can request this access package from this policy.
     * @param value Value to set for the requestorSettings property.
     */
    set requestorSettings(value) {
        this._requestorSettings = value;
    }
    ;
    /**
     * Gets the reviewSettings property value.
     * @returns a accessPackageAssignmentReviewSettings
     */
    get reviewSettings() {
        return this._reviewSettings;
    }
    ;
    /**
     * Sets the reviewSettings property value.
     * @param value Value to set for the reviewSettings property.
     */
    set reviewSettings(value) {
        this._reviewSettings = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("accessPackage", this.accessPackage);
        writer.writeEnumValue("allowedTargetScope", this.allowedTargetScope);
        writer.writeObjectValue("catalog", this.catalog);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeStringValue("description", this.description);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeObjectValue("expiration", this.expiration);
        writer.writeDateValue("modifiedDateTime", this.modifiedDateTime);
        writer.writeObjectValue("requestApprovalSettings", this.requestApprovalSettings);
        writer.writeObjectValue("requestorSettings", this.requestorSettings);
        writer.writeObjectValue("reviewSettings", this.reviewSettings);
        writer.writeCollectionOfObjectValues("specificAllowedTargets", this.specificAllowedTargets);
    }
    ;
    /**
     * Gets the specificAllowedTargets property value.
     * @returns a subjectSet
     */
    get specificAllowedTargets() {
        return this._specificAllowedTargets;
    }
    ;
    /**
     * Sets the specificAllowedTargets property value.
     * @param value Value to set for the specificAllowedTargets property.
     */
    set specificAllowedTargets(value) {
        this._specificAllowedTargets = value;
    }
    ;
}
exports.AccessPackageAssignmentPolicy = AccessPackageAssignmentPolicy;
