"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccessPackageAssignmentRequest = void 0;
const accessPackageRequestState_1 = require("./accessPackageRequestState");
const accessPackageRequestType_1 = require("./accessPackageRequestType");
const createAccessPackageAssignmentFromDiscriminatorValue_1 = require("./createAccessPackageAssignmentFromDiscriminatorValue");
const createAccessPackageFromDiscriminatorValue_1 = require("./createAccessPackageFromDiscriminatorValue");
const createAccessPackageSubjectFromDiscriminatorValue_1 = require("./createAccessPackageSubjectFromDiscriminatorValue");
const createEntitlementManagementScheduleFromDiscriminatorValue_1 = require("./createEntitlementManagementScheduleFromDiscriminatorValue");
const index_1 = require("./index");
class AccessPackageAssignmentRequest extends index_1.Entity {
    /**
     * Instantiates a new accessPackageAssignmentRequest and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the accessPackage property value. The access package associated with the accessPackageAssignmentRequest. An access package defines the collections of resource roles and the policies for how one or more users can get access to those resources. Read-only. Nullable.  Supports $expand.
     * @returns a accessPackage
     */
    get accessPackage() {
        return this._accessPackage;
    }
    ;
    /**
     * Sets the accessPackage property value. The access package associated with the accessPackageAssignmentRequest. An access package defines the collections of resource roles and the policies for how one or more users can get access to those resources. Read-only. Nullable.  Supports $expand.
     * @param value Value to set for the accessPackage property.
     */
    set accessPackage(value) {
        this._accessPackage = value;
    }
    ;
    /**
     * Gets the assignment property value. For a requestType of UserAdd or AdminAdd, this is an access package assignment requested to be created.  For a requestType of UserRemove, AdminRemove or SystemRemove, this has the id property of an existing assignment to be removed.   Supports $expand.
     * @returns a accessPackageAssignment
     */
    get assignment() {
        return this._assignment;
    }
    ;
    /**
     * Sets the assignment property value. For a requestType of UserAdd or AdminAdd, this is an access package assignment requested to be created.  For a requestType of UserRemove, AdminRemove or SystemRemove, this has the id property of an existing assignment to be removed.   Supports $expand.
     * @param value Value to set for the assignment property.
     */
    set assignment(value) {
        this._assignment = value;
    }
    ;
    /**
     * Gets the completedDateTime property value. The date of the end of processing, either successful or failure, of a request. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
     * @returns a Date
     */
    get completedDateTime() {
        return this._completedDateTime;
    }
    ;
    /**
     * Sets the completedDateTime property value. The date of the end of processing, either successful or failure, of a request. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
     * @param value Value to set for the completedDateTime property.
     */
    set completedDateTime(value) {
        this._completedDateTime = value;
    }
    ;
    ;
    /**
     * Gets the createdDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "accessPackage": (o, n) => { o.accessPackage = n.getObjectValue(createAccessPackageFromDiscriminatorValue_1.createAccessPackageFromDiscriminatorValue); }, "assignment": (o, n) => { o.assignment = n.getObjectValue(createAccessPackageAssignmentFromDiscriminatorValue_1.createAccessPackageAssignmentFromDiscriminatorValue); }, "completedDateTime": (o, n) => { o.completedDateTime = n.getDateValue(); }, "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); }, "requestor": (o, n) => { o.requestor = n.getObjectValue(createAccessPackageSubjectFromDiscriminatorValue_1.createAccessPackageSubjectFromDiscriminatorValue); }, "requestType": (o, n) => { o.requestType = n.getEnumValue(accessPackageRequestType_1.AccessPackageRequestType); }, "schedule": (o, n) => { o.schedule = n.getObjectValue(createEntitlementManagementScheduleFromDiscriminatorValue_1.createEntitlementManagementScheduleFromDiscriminatorValue); }, "state": (o, n) => { o.state = n.getEnumValue(accessPackageRequestState_1.AccessPackageRequestState); }, "status": (o, n) => { o.status = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the requestor property value. The subject who requested or, if a direct assignment, was assigned. Read-only. Nullable. Supports $expand.
     * @returns a accessPackageSubject
     */
    get requestor() {
        return this._requestor;
    }
    ;
    /**
     * Sets the requestor property value. The subject who requested or, if a direct assignment, was assigned. Read-only. Nullable. Supports $expand.
     * @param value Value to set for the requestor property.
     */
    set requestor(value) {
        this._requestor = value;
    }
    ;
    /**
     * Gets the requestType property value. The type of the request. The possible values are: notSpecified, userAdd, userUpdate, userRemove, adminAdd, adminUpdate, adminRemove, systemAdd, systemUpdate, systemRemove, onBehalfAdd, unknownFutureValue. A request from the user themselves would have requestType of UserAdd or UserRemove. This property cannot be changed once set.
     * @returns a accessPackageRequestType
     */
    get requestType() {
        return this._requestType;
    }
    ;
    /**
     * Sets the requestType property value. The type of the request. The possible values are: notSpecified, userAdd, userUpdate, userRemove, adminAdd, adminUpdate, adminRemove, systemAdd, systemUpdate, systemRemove, onBehalfAdd, unknownFutureValue. A request from the user themselves would have requestType of UserAdd or UserRemove. This property cannot be changed once set.
     * @param value Value to set for the requestType property.
     */
    set requestType(value) {
        this._requestType = value;
    }
    ;
    /**
     * Gets the schedule property value. The range of dates that access is to be assigned to the requestor. This property cannot be changed once set.
     * @returns a entitlementManagementSchedule
     */
    get schedule() {
        return this._schedule;
    }
    ;
    /**
     * Sets the schedule property value. The range of dates that access is to be assigned to the requestor. This property cannot be changed once set.
     * @param value Value to set for the schedule property.
     */
    set schedule(value) {
        this._schedule = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("accessPackage", this.accessPackage);
        writer.writeObjectValue("assignment", this.assignment);
        writer.writeDateValue("completedDateTime", this.completedDateTime);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeObjectValue("requestor", this.requestor);
        writer.writeEnumValue("requestType", this.requestType);
        writer.writeObjectValue("schedule", this.schedule);
        writer.writeEnumValue("state", this.state);
        writer.writeStringValue("status", this.status);
    }
    ;
    /**
     * Gets the state property value. The state of the request. The possible values are: submitted, pendingApproval, delivering, delivered, deliveryFailed, denied, scheduled, canceled, partiallyDelivered, unknownFutureValue. Read-only.
     * @returns a accessPackageRequestState
     */
    get state() {
        return this._state;
    }
    ;
    /**
     * Sets the state property value. The state of the request. The possible values are: submitted, pendingApproval, delivering, delivered, deliveryFailed, denied, scheduled, canceled, partiallyDelivered, unknownFutureValue. Read-only.
     * @param value Value to set for the state property.
     */
    set state(value) {
        this._state = value;
    }
    ;
    /**
     * Gets the status property value. More information on the request processing status. Read-only.
     * @returns a string
     */
    get status() {
        return this._status;
    }
    ;
    /**
     * Sets the status property value. More information on the request processing status. Read-only.
     * @param value Value to set for the status property.
     */
    set status(value) {
        this._status = value;
    }
    ;
}
exports.AccessPackageAssignmentRequest = AccessPackageAssignmentRequest;
