"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccessPackageAssignmentRequestRequirements = void 0;
const createEntitlementManagementScheduleFromDiscriminatorValue_1 = require("./createEntitlementManagementScheduleFromDiscriminatorValue");
class AccessPackageAssignmentRequestRequirements {
    /**
     * Instantiates a new accessPackageAssignmentRequestRequirements and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the allowCustomAssignmentSchedule property value. Indicates whether the requestor is allowed to set a custom schedule.
     * @returns a boolean
     */
    get allowCustomAssignmentSchedule() {
        return this._allowCustomAssignmentSchedule;
    }
    ;
    /**
     * Sets the allowCustomAssignmentSchedule property value. Indicates whether the requestor is allowed to set a custom schedule.
     * @param value Value to set for the allowCustomAssignmentSchedule property.
     */
    set allowCustomAssignmentSchedule(value) {
        this._allowCustomAssignmentSchedule = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "allowCustomAssignmentSchedule": (o, n) => { o.allowCustomAssignmentSchedule = n.getBooleanValue(); },
            "isApprovalRequiredForAdd": (o, n) => { o.isApprovalRequiredForAdd = n.getBooleanValue(); },
            "isApprovalRequiredForUpdate": (o, n) => { o.isApprovalRequiredForUpdate = n.getBooleanValue(); },
            "policyDescription": (o, n) => { o.policyDescription = n.getStringValue(); },
            "policyDisplayName": (o, n) => { o.policyDisplayName = n.getStringValue(); },
            "policyId": (o, n) => { o.policyId = n.getStringValue(); },
            "schedule": (o, n) => { o.schedule = n.getObjectValue(createEntitlementManagementScheduleFromDiscriminatorValue_1.createEntitlementManagementScheduleFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the isApprovalRequiredForAdd property value. Indicates whether a request to add must be approved by an approver.
     * @returns a boolean
     */
    get isApprovalRequiredForAdd() {
        return this._isApprovalRequiredForAdd;
    }
    ;
    /**
     * Sets the isApprovalRequiredForAdd property value. Indicates whether a request to add must be approved by an approver.
     * @param value Value to set for the isApprovalRequiredForAdd property.
     */
    set isApprovalRequiredForAdd(value) {
        this._isApprovalRequiredForAdd = value;
    }
    ;
    /**
     * Gets the isApprovalRequiredForUpdate property value. Indicates whether a request to update must be approved by an approver.
     * @returns a boolean
     */
    get isApprovalRequiredForUpdate() {
        return this._isApprovalRequiredForUpdate;
    }
    ;
    /**
     * Sets the isApprovalRequiredForUpdate property value. Indicates whether a request to update must be approved by an approver.
     * @param value Value to set for the isApprovalRequiredForUpdate property.
     */
    set isApprovalRequiredForUpdate(value) {
        this._isApprovalRequiredForUpdate = value;
    }
    ;
    /**
     * Gets the policyDescription property value. The description of the policy that the user is trying to request access using.
     * @returns a string
     */
    get policyDescription() {
        return this._policyDescription;
    }
    ;
    /**
     * Sets the policyDescription property value. The description of the policy that the user is trying to request access using.
     * @param value Value to set for the policyDescription property.
     */
    set policyDescription(value) {
        this._policyDescription = value;
    }
    ;
    /**
     * Gets the policyDisplayName property value. The display name of the policy that the user is trying to request access using.
     * @returns a string
     */
    get policyDisplayName() {
        return this._policyDisplayName;
    }
    ;
    /**
     * Sets the policyDisplayName property value. The display name of the policy that the user is trying to request access using.
     * @param value Value to set for the policyDisplayName property.
     */
    set policyDisplayName(value) {
        this._policyDisplayName = value;
    }
    ;
    /**
     * Gets the policyId property value. The identifier of the policy that these requirements are associated with. This identifier can be used when creating a new assignment request.
     * @returns a string
     */
    get policyId() {
        return this._policyId;
    }
    ;
    /**
     * Sets the policyId property value. The identifier of the policy that these requirements are associated with. This identifier can be used when creating a new assignment request.
     * @param value Value to set for the policyId property.
     */
    set policyId(value) {
        this._policyId = value;
    }
    ;
    /**
     * Gets the schedule property value. Schedule restrictions enforced, if any.
     * @returns a entitlementManagementSchedule
     */
    get schedule() {
        return this._schedule;
    }
    ;
    /**
     * Sets the schedule property value. Schedule restrictions enforced, if any.
     * @param value Value to set for the schedule property.
     */
    set schedule(value) {
        this._schedule = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("allowCustomAssignmentSchedule", this.allowCustomAssignmentSchedule);
        writer.writeBooleanValue("isApprovalRequiredForAdd", this.isApprovalRequiredForAdd);
        writer.writeBooleanValue("isApprovalRequiredForUpdate", this.isApprovalRequiredForUpdate);
        writer.writeStringValue("policyDescription", this.policyDescription);
        writer.writeStringValue("policyDisplayName", this.policyDisplayName);
        writer.writeStringValue("policyId", this.policyId);
        writer.writeObjectValue("schedule", this.schedule);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.AccessPackageAssignmentRequestRequirements = AccessPackageAssignmentRequestRequirements;
