import { SubjectSet } from './index';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class AccessPackageAssignmentRequestorSettings implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _allowCustomAssignmentSchedule?;
    private _enableOnBehalfRequestorsToAddAccess?;
    private _enableOnBehalfRequestorsToRemoveAccess?;
    private _enableOnBehalfRequestorsToUpdateAccess?;
    private _enableTargetsToSelfAddAccess?;
    private _enableTargetsToSelfRemoveAccess?;
    private _enableTargetsToSelfUpdateAccess?;
    private _onBehalfRequestors?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the allowCustomAssignmentSchedule property value.
     * @returns a boolean
     */
    get allowCustomAssignmentSchedule(): boolean | undefined;
    /**
     * Sets the allowCustomAssignmentSchedule property value.
     * @param value Value to set for the allowCustomAssignmentSchedule property.
     */
    set allowCustomAssignmentSchedule(value: boolean | undefined);
    /**
     * Instantiates a new accessPackageAssignmentRequestorSettings and sets the default values.
     */
    constructor();
    /**
     * Gets the enableOnBehalfRequestorsToAddAccess property value.
     * @returns a boolean
     */
    get enableOnBehalfRequestorsToAddAccess(): boolean | undefined;
    /**
     * Sets the enableOnBehalfRequestorsToAddAccess property value.
     * @param value Value to set for the enableOnBehalfRequestorsToAddAccess property.
     */
    set enableOnBehalfRequestorsToAddAccess(value: boolean | undefined);
    /**
     * Gets the enableOnBehalfRequestorsToRemoveAccess property value.
     * @returns a boolean
     */
    get enableOnBehalfRequestorsToRemoveAccess(): boolean | undefined;
    /**
     * Sets the enableOnBehalfRequestorsToRemoveAccess property value.
     * @param value Value to set for the enableOnBehalfRequestorsToRemoveAccess property.
     */
    set enableOnBehalfRequestorsToRemoveAccess(value: boolean | undefined);
    /**
     * Gets the enableOnBehalfRequestorsToUpdateAccess property value.
     * @returns a boolean
     */
    get enableOnBehalfRequestorsToUpdateAccess(): boolean | undefined;
    /**
     * Sets the enableOnBehalfRequestorsToUpdateAccess property value.
     * @param value Value to set for the enableOnBehalfRequestorsToUpdateAccess property.
     */
    set enableOnBehalfRequestorsToUpdateAccess(value: boolean | undefined);
    /**
     * Gets the enableTargetsToSelfAddAccess property value.
     * @returns a boolean
     */
    get enableTargetsToSelfAddAccess(): boolean | undefined;
    /**
     * Sets the enableTargetsToSelfAddAccess property value.
     * @param value Value to set for the enableTargetsToSelfAddAccess property.
     */
    set enableTargetsToSelfAddAccess(value: boolean | undefined);
    /**
     * Gets the enableTargetsToSelfRemoveAccess property value.
     * @returns a boolean
     */
    get enableTargetsToSelfRemoveAccess(): boolean | undefined;
    /**
     * Sets the enableTargetsToSelfRemoveAccess property value.
     * @param value Value to set for the enableTargetsToSelfRemoveAccess property.
     */
    set enableTargetsToSelfRemoveAccess(value: boolean | undefined);
    /**
     * Gets the enableTargetsToSelfUpdateAccess property value.
     * @returns a boolean
     */
    get enableTargetsToSelfUpdateAccess(): boolean | undefined;
    /**
     * Sets the enableTargetsToSelfUpdateAccess property value.
     * @param value Value to set for the enableTargetsToSelfUpdateAccess property.
     */
    set enableTargetsToSelfUpdateAccess(value: boolean | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the onBehalfRequestors property value.
     * @returns a subjectSet
     */
    get onBehalfRequestors(): SubjectSet[] | undefined;
    /**
     * Sets the onBehalfRequestors property value.
     * @param value Value to set for the onBehalfRequestors property.
     */
    set onBehalfRequestors(value: SubjectSet[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
