import { AccessReviewExpirationBehavior } from './accessReviewExpirationBehavior';
import { EntitlementManagementSchedule, SubjectSet } from './index';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class AccessPackageAssignmentReviewSettings implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _expirationBehavior?;
    private _fallbackReviewers?;
    private _isEnabled?;
    private _isRecommendationEnabled?;
    private _isReviewerJustificationRequired?;
    private _isSelfReview?;
    private _primaryReviewers?;
    private _schedule?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new accessPackageAssignmentReviewSettings and sets the default values.
     */
    constructor();
    /**
     * Gets the expirationBehavior property value.
     * @returns a accessReviewExpirationBehavior
     */
    get expirationBehavior(): AccessReviewExpirationBehavior | undefined;
    /**
     * Sets the expirationBehavior property value.
     * @param value Value to set for the expirationBehavior property.
     */
    set expirationBehavior(value: AccessReviewExpirationBehavior | undefined);
    /**
     * Gets the fallbackReviewers property value.
     * @returns a subjectSet
     */
    get fallbackReviewers(): SubjectSet[] | undefined;
    /**
     * Sets the fallbackReviewers property value.
     * @param value Value to set for the fallbackReviewers property.
     */
    set fallbackReviewers(value: SubjectSet[] | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the isEnabled property value.
     * @returns a boolean
     */
    get isEnabled(): boolean | undefined;
    /**
     * Sets the isEnabled property value.
     * @param value Value to set for the isEnabled property.
     */
    set isEnabled(value: boolean | undefined);
    /**
     * Gets the isRecommendationEnabled property value.
     * @returns a boolean
     */
    get isRecommendationEnabled(): boolean | undefined;
    /**
     * Sets the isRecommendationEnabled property value.
     * @param value Value to set for the isRecommendationEnabled property.
     */
    set isRecommendationEnabled(value: boolean | undefined);
    /**
     * Gets the isReviewerJustificationRequired property value.
     * @returns a boolean
     */
    get isReviewerJustificationRequired(): boolean | undefined;
    /**
     * Sets the isReviewerJustificationRequired property value.
     * @param value Value to set for the isReviewerJustificationRequired property.
     */
    set isReviewerJustificationRequired(value: boolean | undefined);
    /**
     * Gets the isSelfReview property value.
     * @returns a boolean
     */
    get isSelfReview(): boolean | undefined;
    /**
     * Sets the isSelfReview property value.
     * @param value Value to set for the isSelfReview property.
     */
    set isSelfReview(value: boolean | undefined);
    /**
     * Gets the primaryReviewers property value.
     * @returns a subjectSet
     */
    get primaryReviewers(): SubjectSet[] | undefined;
    /**
     * Sets the primaryReviewers property value.
     * @param value Value to set for the primaryReviewers property.
     */
    set primaryReviewers(value: SubjectSet[] | undefined);
    /**
     * Gets the schedule property value.
     * @returns a entitlementManagementSchedule
     */
    get schedule(): EntitlementManagementSchedule | undefined;
    /**
     * Sets the schedule property value.
     * @param value Value to set for the schedule property.
     */
    set schedule(value: EntitlementManagementSchedule | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
