"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccessPackageAssignmentReviewSettings = void 0;
const accessReviewExpirationBehavior_1 = require("./accessReviewExpirationBehavior");
const createEntitlementManagementScheduleFromDiscriminatorValue_1 = require("./createEntitlementManagementScheduleFromDiscriminatorValue");
const createSubjectSetFromDiscriminatorValue_1 = require("./createSubjectSetFromDiscriminatorValue");
class AccessPackageAssignmentReviewSettings {
    /**
     * Instantiates a new accessPackageAssignmentReviewSettings and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the expirationBehavior property value.
     * @returns a accessReviewExpirationBehavior
     */
    get expirationBehavior() {
        return this._expirationBehavior;
    }
    ;
    /**
     * Sets the expirationBehavior property value.
     * @param value Value to set for the expirationBehavior property.
     */
    set expirationBehavior(value) {
        this._expirationBehavior = value;
    }
    ;
    /**
     * Gets the fallbackReviewers property value.
     * @returns a subjectSet
     */
    get fallbackReviewers() {
        return this._fallbackReviewers;
    }
    ;
    /**
     * Sets the fallbackReviewers property value.
     * @param value Value to set for the fallbackReviewers property.
     */
    set fallbackReviewers(value) {
        this._fallbackReviewers = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "expirationBehavior": (o, n) => { o.expirationBehavior = n.getEnumValue(accessReviewExpirationBehavior_1.AccessReviewExpirationBehavior); },
            "fallbackReviewers": (o, n) => { o.fallbackReviewers = n.getCollectionOfObjectValues(createSubjectSetFromDiscriminatorValue_1.createSubjectSetFromDiscriminatorValue); },
            "isEnabled": (o, n) => { o.isEnabled = n.getBooleanValue(); },
            "isRecommendationEnabled": (o, n) => { o.isRecommendationEnabled = n.getBooleanValue(); },
            "isReviewerJustificationRequired": (o, n) => { o.isReviewerJustificationRequired = n.getBooleanValue(); },
            "isSelfReview": (o, n) => { o.isSelfReview = n.getBooleanValue(); },
            "primaryReviewers": (o, n) => { o.primaryReviewers = n.getCollectionOfObjectValues(createSubjectSetFromDiscriminatorValue_1.createSubjectSetFromDiscriminatorValue); },
            "schedule": (o, n) => { o.schedule = n.getObjectValue(createEntitlementManagementScheduleFromDiscriminatorValue_1.createEntitlementManagementScheduleFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the isEnabled property value.
     * @returns a boolean
     */
    get isEnabled() {
        return this._isEnabled;
    }
    ;
    /**
     * Sets the isEnabled property value.
     * @param value Value to set for the isEnabled property.
     */
    set isEnabled(value) {
        this._isEnabled = value;
    }
    ;
    /**
     * Gets the isRecommendationEnabled property value.
     * @returns a boolean
     */
    get isRecommendationEnabled() {
        return this._isRecommendationEnabled;
    }
    ;
    /**
     * Sets the isRecommendationEnabled property value.
     * @param value Value to set for the isRecommendationEnabled property.
     */
    set isRecommendationEnabled(value) {
        this._isRecommendationEnabled = value;
    }
    ;
    /**
     * Gets the isReviewerJustificationRequired property value.
     * @returns a boolean
     */
    get isReviewerJustificationRequired() {
        return this._isReviewerJustificationRequired;
    }
    ;
    /**
     * Sets the isReviewerJustificationRequired property value.
     * @param value Value to set for the isReviewerJustificationRequired property.
     */
    set isReviewerJustificationRequired(value) {
        this._isReviewerJustificationRequired = value;
    }
    ;
    /**
     * Gets the isSelfReview property value.
     * @returns a boolean
     */
    get isSelfReview() {
        return this._isSelfReview;
    }
    ;
    /**
     * Sets the isSelfReview property value.
     * @param value Value to set for the isSelfReview property.
     */
    set isSelfReview(value) {
        this._isSelfReview = value;
    }
    ;
    /**
     * Gets the primaryReviewers property value.
     * @returns a subjectSet
     */
    get primaryReviewers() {
        return this._primaryReviewers;
    }
    ;
    /**
     * Sets the primaryReviewers property value.
     * @param value Value to set for the primaryReviewers property.
     */
    set primaryReviewers(value) {
        this._primaryReviewers = value;
    }
    ;
    /**
     * Gets the schedule property value.
     * @returns a entitlementManagementSchedule
     */
    get schedule() {
        return this._schedule;
    }
    ;
    /**
     * Sets the schedule property value.
     * @param value Value to set for the schedule property.
     */
    set schedule(value) {
        this._schedule = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeEnumValue("expirationBehavior", this.expirationBehavior);
        writer.writeCollectionOfObjectValues("fallbackReviewers", this.fallbackReviewers);
        writer.writeBooleanValue("isEnabled", this.isEnabled);
        writer.writeBooleanValue("isRecommendationEnabled", this.isRecommendationEnabled);
        writer.writeBooleanValue("isReviewerJustificationRequired", this.isReviewerJustificationRequired);
        writer.writeBooleanValue("isSelfReview", this.isSelfReview);
        writer.writeCollectionOfObjectValues("primaryReviewers", this.primaryReviewers);
        writer.writeObjectValue("schedule", this.schedule);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.AccessPackageAssignmentReviewSettings = AccessPackageAssignmentReviewSettings;
