"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccessPackageSubject = void 0;
const accessPackageSubjectType_1 = require("./accessPackageSubjectType");
const createConnectedOrganizationFromDiscriminatorValue_1 = require("./createConnectedOrganizationFromDiscriminatorValue");
const index_1 = require("./index");
class AccessPackageSubject extends index_1.Entity {
    /**
     * Instantiates a new accessPackageSubject and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the connectedOrganization property value. The connected organization of the subject. Read-only. Nullable.
     * @returns a connectedOrganization
     */
    get connectedOrganization() {
        return this._connectedOrganization;
    }
    ;
    /**
     * Sets the connectedOrganization property value. The connected organization of the subject. Read-only. Nullable.
     * @param value Value to set for the connectedOrganization property.
     */
    set connectedOrganization(value) {
        this._connectedOrganization = value;
    }
    ;
    ;
    /**
     * Gets the displayName property value. The display name of the subject.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The display name of the subject.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * Gets the email property value. The email address of the subject.
     * @returns a string
     */
    get email() {
        return this._email;
    }
    ;
    /**
     * Sets the email property value. The email address of the subject.
     * @param value Value to set for the email property.
     */
    set email(value) {
        this._email = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "connectedOrganization": (o, n) => { o.connectedOrganization = n.getObjectValue(createConnectedOrganizationFromDiscriminatorValue_1.createConnectedOrganizationFromDiscriminatorValue); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "email": (o, n) => { o.email = n.getStringValue(); }, "objectId": (o, n) => { o.objectId = n.getStringValue(); }, "onPremisesSecurityIdentifier": (o, n) => { o.onPremisesSecurityIdentifier = n.getStringValue(); }, "principalName": (o, n) => { o.principalName = n.getStringValue(); }, "subjectType": (o, n) => { o.subjectType = n.getEnumValue(accessPackageSubjectType_1.AccessPackageSubjectType); } });
    }
    ;
    /**
     * Gets the objectId property value. The object identifier of the subject. null if the subject is not yet a user in the tenant.
     * @returns a string
     */
    get objectId() {
        return this._objectId;
    }
    ;
    /**
     * Sets the objectId property value. The object identifier of the subject. null if the subject is not yet a user in the tenant.
     * @param value Value to set for the objectId property.
     */
    set objectId(value) {
        this._objectId = value;
    }
    ;
    /**
     * Gets the onPremisesSecurityIdentifier property value. A string representation of the principal's security identifier, if known, or null if the subject does not have a security identifier.
     * @returns a string
     */
    get onPremisesSecurityIdentifier() {
        return this._onPremisesSecurityIdentifier;
    }
    ;
    /**
     * Sets the onPremisesSecurityIdentifier property value. A string representation of the principal's security identifier, if known, or null if the subject does not have a security identifier.
     * @param value Value to set for the onPremisesSecurityIdentifier property.
     */
    set onPremisesSecurityIdentifier(value) {
        this._onPremisesSecurityIdentifier = value;
    }
    ;
    /**
     * Gets the principalName property value. The principal name, if known, of the subject.
     * @returns a string
     */
    get principalName() {
        return this._principalName;
    }
    ;
    /**
     * Sets the principalName property value. The principal name, if known, of the subject.
     * @param value Value to set for the principalName property.
     */
    set principalName(value) {
        this._principalName = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("connectedOrganization", this.connectedOrganization);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeStringValue("email", this.email);
        writer.writeStringValue("objectId", this.objectId);
        writer.writeStringValue("onPremisesSecurityIdentifier", this.onPremisesSecurityIdentifier);
        writer.writeStringValue("principalName", this.principalName);
        writer.writeEnumValue("subjectType", this.subjectType);
    }
    ;
    /**
     * Gets the subjectType property value. The resource type of the subject. The possible values are: notSpecified, user, servicePrincipal, unknownFutureValue.
     * @returns a accessPackageSubjectType
     */
    get subjectType() {
        return this._subjectType;
    }
    ;
    /**
     * Sets the subjectType property value. The resource type of the subject. The possible values are: notSpecified, user, servicePrincipal, unknownFutureValue.
     * @param value Value to set for the subjectType property.
     */
    set subjectType(value) {
        this._subjectType = value;
    }
    ;
}
exports.AccessPackageSubject = AccessPackageSubject;
