"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccessReviewHistoryDefinition = void 0;
const accessReviewHistoryDecisionFilter_1 = require("./accessReviewHistoryDecisionFilter");
const accessReviewHistoryStatus_1 = require("./accessReviewHistoryStatus");
const createAccessReviewHistoryInstanceFromDiscriminatorValue_1 = require("./createAccessReviewHistoryInstanceFromDiscriminatorValue");
const createAccessReviewHistoryScheduleSettingsFromDiscriminatorValue_1 = require("./createAccessReviewHistoryScheduleSettingsFromDiscriminatorValue");
const createAccessReviewScopeFromDiscriminatorValue_1 = require("./createAccessReviewScopeFromDiscriminatorValue");
const createUserIdentityFromDiscriminatorValue_1 = require("./createUserIdentityFromDiscriminatorValue");
const index_1 = require("./index");
class AccessReviewHistoryDefinition extends index_1.Entity {
    /**
     * Instantiates a new accessReviewHistoryDefinition and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the createdBy property value.
     * @returns a userIdentity
     */
    get createdBy() {
        return this._createdBy;
    }
    ;
    /**
     * Sets the createdBy property value.
     * @param value Value to set for the createdBy property.
     */
    set createdBy(value) {
        this._createdBy = value;
    }
    ;
    /**
     * Gets the createdDateTime property value. Timestamp when the access review definition was created.
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. Timestamp when the access review definition was created.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * Gets the decisions property value. Determines which review decisions will be included in the fetched review history data if specified. Optional on create. All decisions will be included by default if no decisions are provided on create. Possible values are: approve, deny, dontKnow, notReviewed, and notNotified.
     * @returns a accessReviewHistoryDecisionFilter
     */
    get decisions() {
        return this._decisions;
    }
    ;
    /**
     * Sets the decisions property value. Determines which review decisions will be included in the fetched review history data if specified. Optional on create. All decisions will be included by default if no decisions are provided on create. Possible values are: approve, deny, dontKnow, notReviewed, and notNotified.
     * @param value Value to set for the decisions property.
     */
    set decisions(value) {
        this._decisions = value;
    }
    ;
    /**
     * Gets the displayName property value. Name for the access review history data collection. Required.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. Name for the access review history data collection. Required.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "createdBy": (o, n) => { o.createdBy = n.getObjectValue(createUserIdentityFromDiscriminatorValue_1.createUserIdentityFromDiscriminatorValue); }, "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); }, "decisions": (o, n) => { o.decisions = n.getEnumValues(accessReviewHistoryDecisionFilter_1.AccessReviewHistoryDecisionFilter); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "instances": (o, n) => { o.instances = n.getCollectionOfObjectValues(createAccessReviewHistoryInstanceFromDiscriminatorValue_1.createAccessReviewHistoryInstanceFromDiscriminatorValue); }, "reviewHistoryPeriodEndDateTime": (o, n) => { o.reviewHistoryPeriodEndDateTime = n.getDateValue(); }, "reviewHistoryPeriodStartDateTime": (o, n) => { o.reviewHistoryPeriodStartDateTime = n.getDateValue(); }, "scheduleSettings": (o, n) => { o.scheduleSettings = n.getObjectValue(createAccessReviewHistoryScheduleSettingsFromDiscriminatorValue_1.createAccessReviewHistoryScheduleSettingsFromDiscriminatorValue); }, "scopes": (o, n) => { o.scopes = n.getCollectionOfObjectValues(createAccessReviewScopeFromDiscriminatorValue_1.createAccessReviewScopeFromDiscriminatorValue); }, "status": (o, n) => { o.status = n.getEnumValue(accessReviewHistoryStatus_1.AccessReviewHistoryStatus); } });
    }
    ;
    /**
     * Gets the instances property value. If the accessReviewHistoryDefinition is a recurring definition, instances represent each recurrence. A definition that does not recur will have exactly one instance.
     * @returns a accessReviewHistoryInstance
     */
    get instances() {
        return this._instances;
    }
    ;
    /**
     * Sets the instances property value. If the accessReviewHistoryDefinition is a recurring definition, instances represent each recurrence. A definition that does not recur will have exactly one instance.
     * @param value Value to set for the instances property.
     */
    set instances(value) {
        this._instances = value;
    }
    ;
    /**
     * Gets the reviewHistoryPeriodEndDateTime property value. A timestamp. Reviews ending on or before this date will be included in the fetched history data. Only required if scheduleSettings is not defined.
     * @returns a Date
     */
    get reviewHistoryPeriodEndDateTime() {
        return this._reviewHistoryPeriodEndDateTime;
    }
    ;
    /**
     * Sets the reviewHistoryPeriodEndDateTime property value. A timestamp. Reviews ending on or before this date will be included in the fetched history data. Only required if scheduleSettings is not defined.
     * @param value Value to set for the reviewHistoryPeriodEndDateTime property.
     */
    set reviewHistoryPeriodEndDateTime(value) {
        this._reviewHistoryPeriodEndDateTime = value;
    }
    ;
    /**
     * Gets the reviewHistoryPeriodStartDateTime property value. A timestamp. Reviews starting on or before this date will be included in the fetched history data. Only required if scheduleSettings is not defined.
     * @returns a Date
     */
    get reviewHistoryPeriodStartDateTime() {
        return this._reviewHistoryPeriodStartDateTime;
    }
    ;
    /**
     * Sets the reviewHistoryPeriodStartDateTime property value. A timestamp. Reviews starting on or before this date will be included in the fetched history data. Only required if scheduleSettings is not defined.
     * @param value Value to set for the reviewHistoryPeriodStartDateTime property.
     */
    set reviewHistoryPeriodStartDateTime(value) {
        this._reviewHistoryPeriodStartDateTime = value;
    }
    ;
    /**
     * Gets the scheduleSettings property value. The settings for a recurring access review history definition series. Only required if reviewHistoryPeriodStartDateTime or reviewHistoryPeriodEndDateTime are not defined.
     * @returns a accessReviewHistoryScheduleSettings
     */
    get scheduleSettings() {
        return this._scheduleSettings;
    }
    ;
    /**
     * Sets the scheduleSettings property value. The settings for a recurring access review history definition series. Only required if reviewHistoryPeriodStartDateTime or reviewHistoryPeriodEndDateTime are not defined.
     * @param value Value to set for the scheduleSettings property.
     */
    set scheduleSettings(value) {
        this._scheduleSettings = value;
    }
    ;
    /**
     * Gets the scopes property value. Used to scope what reviews are included in the fetched history data. Fetches reviews whose scope matches with this provided scope. Required.
     * @returns a accessReviewScope
     */
    get scopes() {
        return this._scopes;
    }
    ;
    /**
     * Sets the scopes property value. Used to scope what reviews are included in the fetched history data. Fetches reviews whose scope matches with this provided scope. Required.
     * @param value Value to set for the scopes property.
     */
    set scopes(value) {
        this._scopes = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("createdBy", this.createdBy);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        this.decisions && writer.writeEnumValue("decisions", ...this.decisions);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeCollectionOfObjectValues("instances", this.instances);
        writer.writeDateValue("reviewHistoryPeriodEndDateTime", this.reviewHistoryPeriodEndDateTime);
        writer.writeDateValue("reviewHistoryPeriodStartDateTime", this.reviewHistoryPeriodStartDateTime);
        writer.writeObjectValue("scheduleSettings", this.scheduleSettings);
        writer.writeCollectionOfObjectValues("scopes", this.scopes);
        writer.writeEnumValue("status", this.status);
    }
    ;
    /**
     * Gets the status property value. Represents the status of the review history data collection. The possible values are: done, inProgress, error, requested, unknownFutureValue.
     * @returns a accessReviewHistoryStatus
     */
    get status() {
        return this._status;
    }
    ;
    /**
     * Sets the status property value. Represents the status of the review history data collection. The possible values are: done, inProgress, error, requested, unknownFutureValue.
     * @param value Value to set for the status property.
     */
    set status(value) {
        this._status = value;
    }
    ;
}
exports.AccessReviewHistoryDefinition = AccessReviewHistoryDefinition;
