"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccessReviewNotificationRecipientItem = void 0;
const createAccessReviewNotificationRecipientScopeFromDiscriminatorValue_1 = require("./createAccessReviewNotificationRecipientScopeFromDiscriminatorValue");
class AccessReviewNotificationRecipientItem {
    /**
     * Instantiates a new accessReviewNotificationRecipientItem and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "notificationRecipientScope": (o, n) => { o.notificationRecipientScope = n.getObjectValue(createAccessReviewNotificationRecipientScopeFromDiscriminatorValue_1.createAccessReviewNotificationRecipientScopeFromDiscriminatorValue); },
            "notificationTemplateType": (o, n) => { o.notificationTemplateType = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the notificationRecipientScope property value. Determines the recipient of the notification email.
     * @returns a accessReviewNotificationRecipientScope
     */
    get notificationRecipientScope() {
        return this._notificationRecipientScope;
    }
    ;
    /**
     * Sets the notificationRecipientScope property value. Determines the recipient of the notification email.
     * @param value Value to set for the notificationRecipientScope property.
     */
    set notificationRecipientScope(value) {
        this._notificationRecipientScope = value;
    }
    ;
    /**
     * Gets the notificationTemplateType property value. Indicates the type of access review email to be sent. Supported template type is CompletedAdditionalRecipients, which sends review completion notifications to the recipients.
     * @returns a string
     */
    get notificationTemplateType() {
        return this._notificationTemplateType;
    }
    ;
    /**
     * Sets the notificationTemplateType property value. Indicates the type of access review email to be sent. Supported template type is CompletedAdditionalRecipients, which sends review completion notifications to the recipients.
     * @param value Value to set for the notificationTemplateType property.
     */
    set notificationTemplateType(value) {
        this._notificationTemplateType = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("notificationRecipientScope", this.notificationRecipientScope);
        writer.writeStringValue("notificationTemplateType", this.notificationTemplateType);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.AccessReviewNotificationRecipientItem = AccessReviewNotificationRecipientItem;
