"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccessReviewReviewerScope = void 0;
class AccessReviewReviewerScope {
    /**
     * Instantiates a new accessReviewReviewerScope and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "query": (o, n) => { o.query = n.getStringValue(); },
            "queryRoot": (o, n) => { o.queryRoot = n.getStringValue(); },
            "queryType": (o, n) => { o.queryType = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the query property value. The query specifying who will be the reviewer. See table for examples.
     * @returns a string
     */
    get query() {
        return this._query;
    }
    ;
    /**
     * Sets the query property value. The query specifying who will be the reviewer. See table for examples.
     * @param value Value to set for the query property.
     */
    set query(value) {
        this._query = value;
    }
    ;
    /**
     * Gets the queryRoot property value. In the scenario where reviewers need to be specified dynamically, this property is used to indicate the relative source of the query. This property is only required if a relative query, for example, ./manager, is specified. Possible value: decisions.
     * @returns a string
     */
    get queryRoot() {
        return this._queryRoot;
    }
    ;
    /**
     * Sets the queryRoot property value. In the scenario where reviewers need to be specified dynamically, this property is used to indicate the relative source of the query. This property is only required if a relative query, for example, ./manager, is specified. Possible value: decisions.
     * @param value Value to set for the queryRoot property.
     */
    set queryRoot(value) {
        this._queryRoot = value;
    }
    ;
    /**
     * Gets the queryType property value. The type of query. Examples include MicrosoftGraph and ARM.
     * @returns a string
     */
    get queryType() {
        return this._queryType;
    }
    ;
    /**
     * Sets the queryType property value. The type of query. Examples include MicrosoftGraph and ARM.
     * @param value Value to set for the queryType property.
     */
    set queryType(value) {
        this._queryType = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("query", this.query);
        writer.writeStringValue("queryRoot", this.queryRoot);
        writer.writeStringValue("queryType", this.queryType);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.AccessReviewReviewerScope = AccessReviewReviewerScope;
