"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccessReviewScheduleSettings = void 0;
const createAccessReviewApplyActionFromDiscriminatorValue_1 = require("./createAccessReviewApplyActionFromDiscriminatorValue");
const createPatternedRecurrenceFromDiscriminatorValue_1 = require("./createPatternedRecurrenceFromDiscriminatorValue");
class AccessReviewScheduleSettings {
    /**
     * Instantiates a new accessReviewScheduleSettings and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the applyActions property value. Optional field. Describes the  actions to take once a review is complete. There are two types that are currently supported: removeAccessApplyAction (default) and disableAndDeleteUserApplyAction. Field only needs to be specified in the case of disableAndDeleteUserApplyAction.
     * @returns a accessReviewApplyAction
     */
    get applyActions() {
        return this._applyActions;
    }
    ;
    /**
     * Sets the applyActions property value. Optional field. Describes the  actions to take once a review is complete. There are two types that are currently supported: removeAccessApplyAction (default) and disableAndDeleteUserApplyAction. Field only needs to be specified in the case of disableAndDeleteUserApplyAction.
     * @param value Value to set for the applyActions property.
     */
    set applyActions(value) {
        this._applyActions = value;
    }
    ;
    /**
     * Gets the autoApplyDecisionsEnabled property value. Indicates whether decisions are automatically applied. When set to false, an admin must apply the decisions manually once the reviewer completes the access review. When set to true, decisions are applied automatically after the access review instance duration ends, whether or not the reviewers have responded. Default value is false.
     * @returns a boolean
     */
    get autoApplyDecisionsEnabled() {
        return this._autoApplyDecisionsEnabled;
    }
    ;
    /**
     * Sets the autoApplyDecisionsEnabled property value. Indicates whether decisions are automatically applied. When set to false, an admin must apply the decisions manually once the reviewer completes the access review. When set to true, decisions are applied automatically after the access review instance duration ends, whether or not the reviewers have responded. Default value is false.
     * @param value Value to set for the autoApplyDecisionsEnabled property.
     */
    set autoApplyDecisionsEnabled(value) {
        this._autoApplyDecisionsEnabled = value;
    }
    ;
    ;
    /**
     * Gets the defaultDecision property value. Decision chosen if defaultDecisionEnabled is true. Can be one of Approve, Deny, or Recommendation.
     * @returns a string
     */
    get defaultDecision() {
        return this._defaultDecision;
    }
    ;
    /**
     * Sets the defaultDecision property value. Decision chosen if defaultDecisionEnabled is true. Can be one of Approve, Deny, or Recommendation.
     * @param value Value to set for the defaultDecision property.
     */
    set defaultDecision(value) {
        this._defaultDecision = value;
    }
    ;
    /**
     * Gets the defaultDecisionEnabled property value. Indicates whether the default decision is enabled or disabled when reviewers do not respond. Default value is false.
     * @returns a boolean
     */
    get defaultDecisionEnabled() {
        return this._defaultDecisionEnabled;
    }
    ;
    /**
     * Sets the defaultDecisionEnabled property value. Indicates whether the default decision is enabled or disabled when reviewers do not respond. Default value is false.
     * @param value Value to set for the defaultDecisionEnabled property.
     */
    set defaultDecisionEnabled(value) {
        this._defaultDecisionEnabled = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "applyActions": (o, n) => { o.applyActions = n.getCollectionOfObjectValues(createAccessReviewApplyActionFromDiscriminatorValue_1.createAccessReviewApplyActionFromDiscriminatorValue); },
            "autoApplyDecisionsEnabled": (o, n) => { o.autoApplyDecisionsEnabled = n.getBooleanValue(); },
            "defaultDecision": (o, n) => { o.defaultDecision = n.getStringValue(); },
            "defaultDecisionEnabled": (o, n) => { o.defaultDecisionEnabled = n.getBooleanValue(); },
            "instanceDurationInDays": (o, n) => { o.instanceDurationInDays = n.getNumberValue(); },
            "justificationRequiredOnApproval": (o, n) => { o.justificationRequiredOnApproval = n.getBooleanValue(); },
            "mailNotificationsEnabled": (o, n) => { o.mailNotificationsEnabled = n.getBooleanValue(); },
            "recommendationsEnabled": (o, n) => { o.recommendationsEnabled = n.getBooleanValue(); },
            "recurrence": (o, n) => { o.recurrence = n.getObjectValue(createPatternedRecurrenceFromDiscriminatorValue_1.createPatternedRecurrenceFromDiscriminatorValue); },
            "reminderNotificationsEnabled": (o, n) => { o.reminderNotificationsEnabled = n.getBooleanValue(); },
        };
    }
    ;
    /**
     * Gets the instanceDurationInDays property value. Duration of each recurrence of review (accessReviewInstance) in number of days.
     * @returns a integer
     */
    get instanceDurationInDays() {
        return this._instanceDurationInDays;
    }
    ;
    /**
     * Sets the instanceDurationInDays property value. Duration of each recurrence of review (accessReviewInstance) in number of days.
     * @param value Value to set for the instanceDurationInDays property.
     */
    set instanceDurationInDays(value) {
        this._instanceDurationInDays = value;
    }
    ;
    /**
     * Gets the justificationRequiredOnApproval property value. Indicates whether reviewers are required to provide justification with their decision. Default value is false.
     * @returns a boolean
     */
    get justificationRequiredOnApproval() {
        return this._justificationRequiredOnApproval;
    }
    ;
    /**
     * Sets the justificationRequiredOnApproval property value. Indicates whether reviewers are required to provide justification with their decision. Default value is false.
     * @param value Value to set for the justificationRequiredOnApproval property.
     */
    set justificationRequiredOnApproval(value) {
        this._justificationRequiredOnApproval = value;
    }
    ;
    /**
     * Gets the mailNotificationsEnabled property value. Indicates whether emails are enabled or disabled. Default value is false.
     * @returns a boolean
     */
    get mailNotificationsEnabled() {
        return this._mailNotificationsEnabled;
    }
    ;
    /**
     * Sets the mailNotificationsEnabled property value. Indicates whether emails are enabled or disabled. Default value is false.
     * @param value Value to set for the mailNotificationsEnabled property.
     */
    set mailNotificationsEnabled(value) {
        this._mailNotificationsEnabled = value;
    }
    ;
    /**
     * Gets the recommendationsEnabled property value. Indicates whether decision recommendations are enabled or disabled.
     * @returns a boolean
     */
    get recommendationsEnabled() {
        return this._recommendationsEnabled;
    }
    ;
    /**
     * Sets the recommendationsEnabled property value. Indicates whether decision recommendations are enabled or disabled.
     * @param value Value to set for the recommendationsEnabled property.
     */
    set recommendationsEnabled(value) {
        this._recommendationsEnabled = value;
    }
    ;
    /**
     * Gets the recurrence property value. Detailed settings for recurrence using the standard Outlook recurrence object.  Note: Only dayOfMonth, interval, and type (weekly, absoluteMonthly) properties are supported. Use the property startDate on recurrenceRange to determine the day the review starts.
     * @returns a patternedRecurrence
     */
    get recurrence() {
        return this._recurrence;
    }
    ;
    /**
     * Sets the recurrence property value. Detailed settings for recurrence using the standard Outlook recurrence object.  Note: Only dayOfMonth, interval, and type (weekly, absoluteMonthly) properties are supported. Use the property startDate on recurrenceRange to determine the day the review starts.
     * @param value Value to set for the recurrence property.
     */
    set recurrence(value) {
        this._recurrence = value;
    }
    ;
    /**
     * Gets the reminderNotificationsEnabled property value. Indicates whether reminders are enabled or disabled. Default value is false.
     * @returns a boolean
     */
    get reminderNotificationsEnabled() {
        return this._reminderNotificationsEnabled;
    }
    ;
    /**
     * Sets the reminderNotificationsEnabled property value. Indicates whether reminders are enabled or disabled. Default value is false.
     * @param value Value to set for the reminderNotificationsEnabled property.
     */
    set reminderNotificationsEnabled(value) {
        this._reminderNotificationsEnabled = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfObjectValues("applyActions", this.applyActions);
        writer.writeBooleanValue("autoApplyDecisionsEnabled", this.autoApplyDecisionsEnabled);
        writer.writeStringValue("defaultDecision", this.defaultDecision);
        writer.writeBooleanValue("defaultDecisionEnabled", this.defaultDecisionEnabled);
        writer.writeNumberValue("instanceDurationInDays", this.instanceDurationInDays);
        writer.writeBooleanValue("justificationRequiredOnApproval", this.justificationRequiredOnApproval);
        writer.writeBooleanValue("mailNotificationsEnabled", this.mailNotificationsEnabled);
        writer.writeBooleanValue("recommendationsEnabled", this.recommendationsEnabled);
        writer.writeObjectValue("recurrence", this.recurrence);
        writer.writeBooleanValue("reminderNotificationsEnabled", this.reminderNotificationsEnabled);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.AccessReviewScheduleSettings = AccessReviewScheduleSettings;
