"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AlterationResponse = void 0;
const createSearchAlterationFromDiscriminatorValue_1 = require("./createSearchAlterationFromDiscriminatorValue");
const searchAlterationType_1 = require("./searchAlterationType");
class AlterationResponse {
    /**
     * Instantiates a new alterationResponse and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "originalQueryString": (o, n) => { o.originalQueryString = n.getStringValue(); },
            "queryAlteration": (o, n) => { o.queryAlteration = n.getObjectValue(createSearchAlterationFromDiscriminatorValue_1.createSearchAlterationFromDiscriminatorValue); },
            "queryAlterationType": (o, n) => { o.queryAlterationType = n.getEnumValue(searchAlterationType_1.SearchAlterationType); },
        };
    }
    ;
    /**
     * Gets the originalQueryString property value. Defines the original user query string.
     * @returns a string
     */
    get originalQueryString() {
        return this._originalQueryString;
    }
    ;
    /**
     * Sets the originalQueryString property value. Defines the original user query string.
     * @param value Value to set for the originalQueryString property.
     */
    set originalQueryString(value) {
        this._originalQueryString = value;
    }
    ;
    /**
     * Gets the queryAlteration property value. Defines the details of the alteration information for the spelling correction.
     * @returns a searchAlteration
     */
    get queryAlteration() {
        return this._queryAlteration;
    }
    ;
    /**
     * Sets the queryAlteration property value. Defines the details of the alteration information for the spelling correction.
     * @param value Value to set for the queryAlteration property.
     */
    set queryAlteration(value) {
        this._queryAlteration = value;
    }
    ;
    /**
     * Gets the queryAlterationType property value. Defines the type of the spelling correction. Possible values are: suggestion, modification.
     * @returns a searchAlterationType
     */
    get queryAlterationType() {
        return this._queryAlterationType;
    }
    ;
    /**
     * Sets the queryAlterationType property value. Defines the type of the spelling correction. Possible values are: suggestion, modification.
     * @param value Value to set for the queryAlterationType property.
     */
    set queryAlterationType(value) {
        this._queryAlterationType = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("originalQueryString", this.originalQueryString);
        writer.writeObjectValue("queryAlteration", this.queryAlteration);
        writer.writeEnumValue("queryAlterationType", this.queryAlterationType);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.AlterationResponse = AlterationResponse;
