"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AndroidManagedAppProtection = void 0;
const createManagedAppPolicyDeploymentSummaryFromDiscriminatorValue_1 = require("./createManagedAppPolicyDeploymentSummaryFromDiscriminatorValue");
const createManagedMobileAppFromDiscriminatorValue_1 = require("./createManagedMobileAppFromDiscriminatorValue");
const index_1 = require("./index");
class AndroidManagedAppProtection extends index_1.TargetedManagedAppProtection {
    /**
     * Instantiates a new androidManagedAppProtection and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the apps property value. List of apps to which the policy is deployed.
     * @returns a managedMobileApp
     */
    get apps() {
        return this._apps;
    }
    ;
    /**
     * Sets the apps property value. List of apps to which the policy is deployed.
     * @param value Value to set for the apps property.
     */
    set apps(value) {
        this._apps = value;
    }
    ;
    ;
    /**
     * Gets the customBrowserDisplayName property value. Friendly name of the preferred custom browser to open weblink on Android. When this property is configured, ManagedBrowserToOpenLinksRequired should be true.
     * @returns a string
     */
    get customBrowserDisplayName() {
        return this._customBrowserDisplayName;
    }
    ;
    /**
     * Sets the customBrowserDisplayName property value. Friendly name of the preferred custom browser to open weblink on Android. When this property is configured, ManagedBrowserToOpenLinksRequired should be true.
     * @param value Value to set for the customBrowserDisplayName property.
     */
    set customBrowserDisplayName(value) {
        this._customBrowserDisplayName = value;
    }
    ;
    /**
     * Gets the customBrowserPackageId property value. Unique identifier of the preferred custom browser to open weblink on Android. When this property is configured, ManagedBrowserToOpenLinksRequired should be true.
     * @returns a string
     */
    get customBrowserPackageId() {
        return this._customBrowserPackageId;
    }
    ;
    /**
     * Sets the customBrowserPackageId property value. Unique identifier of the preferred custom browser to open weblink on Android. When this property is configured, ManagedBrowserToOpenLinksRequired should be true.
     * @param value Value to set for the customBrowserPackageId property.
     */
    set customBrowserPackageId(value) {
        this._customBrowserPackageId = value;
    }
    ;
    /**
     * Gets the deployedAppCount property value. Count of apps to which the current policy is deployed.
     * @returns a integer
     */
    get deployedAppCount() {
        return this._deployedAppCount;
    }
    ;
    /**
     * Sets the deployedAppCount property value. Count of apps to which the current policy is deployed.
     * @param value Value to set for the deployedAppCount property.
     */
    set deployedAppCount(value) {
        this._deployedAppCount = value;
    }
    ;
    /**
     * Gets the deploymentSummary property value. Navigation property to deployment summary of the configuration.
     * @returns a managedAppPolicyDeploymentSummary
     */
    get deploymentSummary() {
        return this._deploymentSummary;
    }
    ;
    /**
     * Sets the deploymentSummary property value. Navigation property to deployment summary of the configuration.
     * @param value Value to set for the deploymentSummary property.
     */
    set deploymentSummary(value) {
        this._deploymentSummary = value;
    }
    ;
    /**
     * Gets the disableAppEncryptionIfDeviceEncryptionIsEnabled property value. When this setting is enabled, app level encryption is disabled if device level encryption is enabled
     * @returns a boolean
     */
    get disableAppEncryptionIfDeviceEncryptionIsEnabled() {
        return this._disableAppEncryptionIfDeviceEncryptionIsEnabled;
    }
    ;
    /**
     * Sets the disableAppEncryptionIfDeviceEncryptionIsEnabled property value. When this setting is enabled, app level encryption is disabled if device level encryption is enabled
     * @param value Value to set for the disableAppEncryptionIfDeviceEncryptionIsEnabled property.
     */
    set disableAppEncryptionIfDeviceEncryptionIsEnabled(value) {
        this._disableAppEncryptionIfDeviceEncryptionIsEnabled = value;
    }
    ;
    /**
     * Gets the encryptAppData property value. Indicates whether application data for managed apps should be encrypted
     * @returns a boolean
     */
    get encryptAppData() {
        return this._encryptAppData;
    }
    ;
    /**
     * Sets the encryptAppData property value. Indicates whether application data for managed apps should be encrypted
     * @param value Value to set for the encryptAppData property.
     */
    set encryptAppData(value) {
        this._encryptAppData = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "apps": (o, n) => { o.apps = n.getCollectionOfObjectValues(createManagedMobileAppFromDiscriminatorValue_1.createManagedMobileAppFromDiscriminatorValue); }, "customBrowserDisplayName": (o, n) => { o.customBrowserDisplayName = n.getStringValue(); }, "customBrowserPackageId": (o, n) => { o.customBrowserPackageId = n.getStringValue(); }, "deployedAppCount": (o, n) => { o.deployedAppCount = n.getNumberValue(); }, "deploymentSummary": (o, n) => { o.deploymentSummary = n.getObjectValue(createManagedAppPolicyDeploymentSummaryFromDiscriminatorValue_1.createManagedAppPolicyDeploymentSummaryFromDiscriminatorValue); }, "disableAppEncryptionIfDeviceEncryptionIsEnabled": (o, n) => { o.disableAppEncryptionIfDeviceEncryptionIsEnabled = n.getBooleanValue(); }, "encryptAppData": (o, n) => { o.encryptAppData = n.getBooleanValue(); }, "minimumRequiredPatchVersion": (o, n) => { o.minimumRequiredPatchVersion = n.getStringValue(); }, "minimumWarningPatchVersion": (o, n) => { o.minimumWarningPatchVersion = n.getStringValue(); }, "screenCaptureBlocked": (o, n) => { o.screenCaptureBlocked = n.getBooleanValue(); } });
    }
    ;
    /**
     * Gets the minimumRequiredPatchVersion property value. Define the oldest required Android security patch level a user can have to gain secure access to the app.
     * @returns a string
     */
    get minimumRequiredPatchVersion() {
        return this._minimumRequiredPatchVersion;
    }
    ;
    /**
     * Sets the minimumRequiredPatchVersion property value. Define the oldest required Android security patch level a user can have to gain secure access to the app.
     * @param value Value to set for the minimumRequiredPatchVersion property.
     */
    set minimumRequiredPatchVersion(value) {
        this._minimumRequiredPatchVersion = value;
    }
    ;
    /**
     * Gets the minimumWarningPatchVersion property value. Define the oldest recommended Android security patch level a user can have for secure access to the app.
     * @returns a string
     */
    get minimumWarningPatchVersion() {
        return this._minimumWarningPatchVersion;
    }
    ;
    /**
     * Sets the minimumWarningPatchVersion property value. Define the oldest recommended Android security patch level a user can have for secure access to the app.
     * @param value Value to set for the minimumWarningPatchVersion property.
     */
    set minimumWarningPatchVersion(value) {
        this._minimumWarningPatchVersion = value;
    }
    ;
    /**
     * Gets the screenCaptureBlocked property value. Indicates whether a managed user can take screen captures of managed apps
     * @returns a boolean
     */
    get screenCaptureBlocked() {
        return this._screenCaptureBlocked;
    }
    ;
    /**
     * Sets the screenCaptureBlocked property value. Indicates whether a managed user can take screen captures of managed apps
     * @param value Value to set for the screenCaptureBlocked property.
     */
    set screenCaptureBlocked(value) {
        this._screenCaptureBlocked = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("apps", this.apps);
        writer.writeStringValue("customBrowserDisplayName", this.customBrowserDisplayName);
        writer.writeStringValue("customBrowserPackageId", this.customBrowserPackageId);
        writer.writeNumberValue("deployedAppCount", this.deployedAppCount);
        writer.writeObjectValue("deploymentSummary", this.deploymentSummary);
        writer.writeBooleanValue("disableAppEncryptionIfDeviceEncryptionIsEnabled", this.disableAppEncryptionIfDeviceEncryptionIsEnabled);
        writer.writeBooleanValue("encryptAppData", this.encryptAppData);
        writer.writeStringValue("minimumRequiredPatchVersion", this.minimumRequiredPatchVersion);
        writer.writeStringValue("minimumWarningPatchVersion", this.minimumWarningPatchVersion);
        writer.writeBooleanValue("screenCaptureBlocked", this.screenCaptureBlocked);
    }
    ;
}
exports.AndroidManagedAppProtection = AndroidManagedAppProtection;
