import { AppConsentRequestScope, Entity, UserConsentRequest } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class AppConsentRequest extends Entity implements Parsable {
    /** The display name of the app for which consent is requested. Required. Supports $filter (eq only) and $orderby.  */
    private _appDisplayName?;
    /** The identifier of the application. Required. Supports $filter (eq only) and $orderby.  */
    private _appId?;
    /** A list of pending scopes waiting for approval. Required.  */
    private _pendingScopes?;
    /** A list of pending user consent requests.  */
    private _userConsentRequests?;
    /**
     * Gets the appDisplayName property value. The display name of the app for which consent is requested. Required. Supports $filter (eq only) and $orderby.
     * @returns a string
     */
    get appDisplayName(): string | undefined;
    /**
     * Sets the appDisplayName property value. The display name of the app for which consent is requested. Required. Supports $filter (eq only) and $orderby.
     * @param value Value to set for the appDisplayName property.
     */
    set appDisplayName(value: string | undefined);
    /**
     * Gets the appId property value. The identifier of the application. Required. Supports $filter (eq only) and $orderby.
     * @returns a string
     */
    get appId(): string | undefined;
    /**
     * Sets the appId property value. The identifier of the application. Required. Supports $filter (eq only) and $orderby.
     * @param value Value to set for the appId property.
     */
    set appId(value: string | undefined);
    /**
     * Instantiates a new appConsentRequest and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the pendingScopes property value. A list of pending scopes waiting for approval. Required.
     * @returns a appConsentRequestScope
     */
    get pendingScopes(): AppConsentRequestScope[] | undefined;
    /**
     * Sets the pendingScopes property value. A list of pending scopes waiting for approval. Required.
     * @param value Value to set for the pendingScopes property.
     */
    set pendingScopes(value: AppConsentRequestScope[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the userConsentRequests property value. A list of pending user consent requests.
     * @returns a userConsentRequest
     */
    get userConsentRequests(): UserConsentRequest[] | undefined;
    /**
     * Sets the userConsentRequests property value. A list of pending user consent requests.
     * @param value Value to set for the userConsentRequests property.
     */
    set userConsentRequests(value: UserConsentRequest[] | undefined);
}
