"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppConsentRequest = void 0;
const createAppConsentRequestScopeFromDiscriminatorValue_1 = require("./createAppConsentRequestScopeFromDiscriminatorValue");
const createUserConsentRequestFromDiscriminatorValue_1 = require("./createUserConsentRequestFromDiscriminatorValue");
const index_1 = require("./index");
class AppConsentRequest extends index_1.Entity {
    /**
     * Instantiates a new appConsentRequest and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the appDisplayName property value. The display name of the app for which consent is requested. Required. Supports $filter (eq only) and $orderby.
     * @returns a string
     */
    get appDisplayName() {
        return this._appDisplayName;
    }
    ;
    /**
     * Sets the appDisplayName property value. The display name of the app for which consent is requested. Required. Supports $filter (eq only) and $orderby.
     * @param value Value to set for the appDisplayName property.
     */
    set appDisplayName(value) {
        this._appDisplayName = value;
    }
    ;
    /**
     * Gets the appId property value. The identifier of the application. Required. Supports $filter (eq only) and $orderby.
     * @returns a string
     */
    get appId() {
        return this._appId;
    }
    ;
    /**
     * Sets the appId property value. The identifier of the application. Required. Supports $filter (eq only) and $orderby.
     * @param value Value to set for the appId property.
     */
    set appId(value) {
        this._appId = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "appDisplayName": (o, n) => { o.appDisplayName = n.getStringValue(); }, "appId": (o, n) => { o.appId = n.getStringValue(); }, "pendingScopes": (o, n) => { o.pendingScopes = n.getCollectionOfObjectValues(createAppConsentRequestScopeFromDiscriminatorValue_1.createAppConsentRequestScopeFromDiscriminatorValue); }, "userConsentRequests": (o, n) => { o.userConsentRequests = n.getCollectionOfObjectValues(createUserConsentRequestFromDiscriminatorValue_1.createUserConsentRequestFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the pendingScopes property value. A list of pending scopes waiting for approval. Required.
     * @returns a appConsentRequestScope
     */
    get pendingScopes() {
        return this._pendingScopes;
    }
    ;
    /**
     * Sets the pendingScopes property value. A list of pending scopes waiting for approval. Required.
     * @param value Value to set for the pendingScopes property.
     */
    set pendingScopes(value) {
        this._pendingScopes = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("appDisplayName", this.appDisplayName);
        writer.writeStringValue("appId", this.appId);
        writer.writeCollectionOfObjectValues("pendingScopes", this.pendingScopes);
        writer.writeCollectionOfObjectValues("userConsentRequests", this.userConsentRequests);
    }
    ;
    /**
     * Gets the userConsentRequests property value. A list of pending user consent requests.
     * @returns a userConsentRequest
     */
    get userConsentRequests() {
        return this._userConsentRequests;
    }
    ;
    /**
     * Sets the userConsentRequests property value. A list of pending user consent requests.
     * @param value Value to set for the userConsentRequests property.
     */
    set userConsentRequests(value) {
        this._userConsentRequests = value;
    }
    ;
}
exports.AppConsentRequest = AppConsentRequest;
