"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppIdentity = void 0;
class AppIdentity {
    /**
     * Instantiates a new appIdentity and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the appId property value. Refers to the Unique GUID representing Application Id in the Azure Active Directory.
     * @returns a string
     */
    get appId() {
        return this._appId;
    }
    ;
    /**
     * Sets the appId property value. Refers to the Unique GUID representing Application Id in the Azure Active Directory.
     * @param value Value to set for the appId property.
     */
    set appId(value) {
        this._appId = value;
    }
    ;
    ;
    /**
     * Gets the displayName property value. Refers to the Application Name displayed in the Azure Portal.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. Refers to the Application Name displayed in the Azure Portal.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "appId": (o, n) => { o.appId = n.getStringValue(); },
            "displayName": (o, n) => { o.displayName = n.getStringValue(); },
            "servicePrincipalId": (o, n) => { o.servicePrincipalId = n.getStringValue(); },
            "servicePrincipalName": (o, n) => { o.servicePrincipalName = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("appId", this.appId);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeStringValue("servicePrincipalId", this.servicePrincipalId);
        writer.writeStringValue("servicePrincipalName", this.servicePrincipalName);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the servicePrincipalId property value. Refers to the Unique GUID indicating Service Principal Id in Azure Active Directory for the corresponding App.
     * @returns a string
     */
    get servicePrincipalId() {
        return this._servicePrincipalId;
    }
    ;
    /**
     * Sets the servicePrincipalId property value. Refers to the Unique GUID indicating Service Principal Id in Azure Active Directory for the corresponding App.
     * @param value Value to set for the servicePrincipalId property.
     */
    set servicePrincipalId(value) {
        this._servicePrincipalId = value;
    }
    ;
    /**
     * Gets the servicePrincipalName property value. Refers to the Service Principal Name is the Application name in the tenant.
     * @returns a string
     */
    get servicePrincipalName() {
        return this._servicePrincipalName;
    }
    ;
    /**
     * Sets the servicePrincipalName property value. Refers to the Service Principal Name is the Application name in the tenant.
     * @param value Value to set for the servicePrincipalName property.
     */
    set servicePrincipalName(value) {
        this._servicePrincipalName = value;
    }
    ;
}
exports.AppIdentity = AppIdentity;
