"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApplePushNotificationCertificate = void 0;
const index_1 = require("./index");
class ApplePushNotificationCertificate extends index_1.Entity {
    /**
     * Instantiates a new applePushNotificationCertificate and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the appleIdentifier property value. Apple Id of the account used to create the MDM push certificate.
     * @returns a string
     */
    get appleIdentifier() {
        return this._appleIdentifier;
    }
    ;
    /**
     * Sets the appleIdentifier property value. Apple Id of the account used to create the MDM push certificate.
     * @param value Value to set for the appleIdentifier property.
     */
    set appleIdentifier(value) {
        this._appleIdentifier = value;
    }
    ;
    /**
     * Gets the certificate property value. Not yet documented
     * @returns a string
     */
    get certificate() {
        return this._certificate;
    }
    ;
    /**
     * Sets the certificate property value. Not yet documented
     * @param value Value to set for the certificate property.
     */
    set certificate(value) {
        this._certificate = value;
    }
    ;
    /**
     * Gets the certificateSerialNumber property value. Certificate serial number. This property is read-only.
     * @returns a string
     */
    get certificateSerialNumber() {
        return this._certificateSerialNumber;
    }
    ;
    /**
     * Sets the certificateSerialNumber property value. Certificate serial number. This property is read-only.
     * @param value Value to set for the certificateSerialNumber property.
     */
    set certificateSerialNumber(value) {
        this._certificateSerialNumber = value;
    }
    ;
    ;
    /**
     * Gets the expirationDateTime property value. The expiration date and time for Apple push notification certificate.
     * @returns a Date
     */
    get expirationDateTime() {
        return this._expirationDateTime;
    }
    ;
    /**
     * Sets the expirationDateTime property value. The expiration date and time for Apple push notification certificate.
     * @param value Value to set for the expirationDateTime property.
     */
    set expirationDateTime(value) {
        this._expirationDateTime = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "appleIdentifier": (o, n) => { o.appleIdentifier = n.getStringValue(); }, "certificate": (o, n) => { o.certificate = n.getStringValue(); }, "certificateSerialNumber": (o, n) => { o.certificateSerialNumber = n.getStringValue(); }, "expirationDateTime": (o, n) => { o.expirationDateTime = n.getDateValue(); }, "lastModifiedDateTime": (o, n) => { o.lastModifiedDateTime = n.getDateValue(); }, "topicIdentifier": (o, n) => { o.topicIdentifier = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the lastModifiedDateTime property value. Last modified date and time for Apple push notification certificate.
     * @returns a Date
     */
    get lastModifiedDateTime() {
        return this._lastModifiedDateTime;
    }
    ;
    /**
     * Sets the lastModifiedDateTime property value. Last modified date and time for Apple push notification certificate.
     * @param value Value to set for the lastModifiedDateTime property.
     */
    set lastModifiedDateTime(value) {
        this._lastModifiedDateTime = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("appleIdentifier", this.appleIdentifier);
        writer.writeStringValue("certificate", this.certificate);
        writer.writeStringValue("certificateSerialNumber", this.certificateSerialNumber);
        writer.writeDateValue("expirationDateTime", this.expirationDateTime);
        writer.writeDateValue("lastModifiedDateTime", this.lastModifiedDateTime);
        writer.writeStringValue("topicIdentifier", this.topicIdentifier);
    }
    ;
    /**
     * Gets the topicIdentifier property value. Topic Id.
     * @returns a string
     */
    get topicIdentifier() {
        return this._topicIdentifier;
    }
    ;
    /**
     * Sets the topicIdentifier property value. Topic Id.
     * @param value Value to set for the topicIdentifier property.
     */
    set topicIdentifier(value) {
        this._topicIdentifier = value;
    }
    ;
}
exports.ApplePushNotificationCertificate = ApplePushNotificationCertificate;
