import { Application, ServicePrincipal } from './index';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ApplicationServicePrincipal implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _application?;
    private _servicePrincipal?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the application property value.
     * @returns a application
     */
    get application(): Application | undefined;
    /**
     * Sets the application property value.
     * @param value Value to set for the application property.
     */
    set application(value: Application | undefined);
    /**
     * Instantiates a new applicationServicePrincipal and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the servicePrincipal property value.
     * @returns a servicePrincipal
     */
    get servicePrincipal(): ServicePrincipal | undefined;
    /**
     * Sets the servicePrincipal property value.
     * @param value Value to set for the servicePrincipal property.
     */
    set servicePrincipal(value: ServicePrincipal | undefined);
}
