"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApplicationTemplate = void 0;
const index_1 = require("./index");
class ApplicationTemplate extends index_1.Entity {
    /**
     * Instantiates a new applicationTemplate and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the categories property value. The list of categories for the application. Supported values can be: Collaboration, Business Management, Consumer, Content management, CRM, Data services, Developer services, E-commerce, Education, ERP, Finance, Health, Human resources, IT infrastructure, Mail, Management, Marketing, Media, Productivity, Project management, Telecommunications, Tools, Travel, and Web design & hosting.
     * @returns a string
     */
    get categories() {
        return this._categories;
    }
    ;
    /**
     * Sets the categories property value. The list of categories for the application. Supported values can be: Collaboration, Business Management, Consumer, Content management, CRM, Data services, Developer services, E-commerce, Education, ERP, Finance, Health, Human resources, IT infrastructure, Mail, Management, Marketing, Media, Productivity, Project management, Telecommunications, Tools, Travel, and Web design & hosting.
     * @param value Value to set for the categories property.
     */
    set categories(value) {
        this._categories = value;
    }
    ;
    ;
    /**
     * Gets the description property value. A description of the application.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. A description of the application.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the displayName property value. The name of the application.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The name of the application.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "categories": (o, n) => { o.categories = n.getCollectionOfPrimitiveValues(); }, "description": (o, n) => { o.description = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "homePageUrl": (o, n) => { o.homePageUrl = n.getStringValue(); }, "logoUrl": (o, n) => { o.logoUrl = n.getStringValue(); }, "publisher": (o, n) => { o.publisher = n.getStringValue(); }, "supportedProvisioningTypes": (o, n) => { o.supportedProvisioningTypes = n.getCollectionOfPrimitiveValues(); }, "supportedSingleSignOnModes": (o, n) => { o.supportedSingleSignOnModes = n.getCollectionOfPrimitiveValues(); } });
    }
    ;
    /**
     * Gets the homePageUrl property value. The home page URL of the application.
     * @returns a string
     */
    get homePageUrl() {
        return this._homePageUrl;
    }
    ;
    /**
     * Sets the homePageUrl property value. The home page URL of the application.
     * @param value Value to set for the homePageUrl property.
     */
    set homePageUrl(value) {
        this._homePageUrl = value;
    }
    ;
    /**
     * Gets the logoUrl property value. The URL to get the logo for this application.
     * @returns a string
     */
    get logoUrl() {
        return this._logoUrl;
    }
    ;
    /**
     * Sets the logoUrl property value. The URL to get the logo for this application.
     * @param value Value to set for the logoUrl property.
     */
    set logoUrl(value) {
        this._logoUrl = value;
    }
    ;
    /**
     * Gets the publisher property value. The name of the publisher for this application.
     * @returns a string
     */
    get publisher() {
        return this._publisher;
    }
    ;
    /**
     * Sets the publisher property value. The name of the publisher for this application.
     * @param value Value to set for the publisher property.
     */
    set publisher(value) {
        this._publisher = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfPrimitiveValues("categories", this.categories);
        writer.writeStringValue("description", this.description);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeStringValue("homePageUrl", this.homePageUrl);
        writer.writeStringValue("logoUrl", this.logoUrl);
        writer.writeStringValue("publisher", this.publisher);
        writer.writeCollectionOfPrimitiveValues("supportedProvisioningTypes", this.supportedProvisioningTypes);
        writer.writeCollectionOfPrimitiveValues("supportedSingleSignOnModes", this.supportedSingleSignOnModes);
    }
    ;
    /**
     * Gets the supportedProvisioningTypes property value. The list of provisioning modes supported by this application. The only valid value is sync.
     * @returns a string
     */
    get supportedProvisioningTypes() {
        return this._supportedProvisioningTypes;
    }
    ;
    /**
     * Sets the supportedProvisioningTypes property value. The list of provisioning modes supported by this application. The only valid value is sync.
     * @param value Value to set for the supportedProvisioningTypes property.
     */
    set supportedProvisioningTypes(value) {
        this._supportedProvisioningTypes = value;
    }
    ;
    /**
     * Gets the supportedSingleSignOnModes property value. The list of single sign-on modes supported by this application. The supported values are oidc, password, saml, and notSupported.
     * @returns a string
     */
    get supportedSingleSignOnModes() {
        return this._supportedSingleSignOnModes;
    }
    ;
    /**
     * Sets the supportedSingleSignOnModes property value. The list of single sign-on modes supported by this application. The supported values are oidc, password, saml, and notSupported.
     * @param value Value to set for the supportedSingleSignOnModes property.
     */
    set supportedSingleSignOnModes(value) {
        this._supportedSingleSignOnModes = value;
    }
    ;
}
exports.ApplicationTemplate = ApplicationTemplate;
