"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppliedConditionalAccessPolicy = void 0;
const appliedConditionalAccessPolicyResult_1 = require("./appliedConditionalAccessPolicyResult");
class AppliedConditionalAccessPolicy {
    /**
     * Instantiates a new appliedConditionalAccessPolicy and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the displayName property value. Refers to the Name of the conditional access policy (example: 'Require MFA for Salesforce').
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. Refers to the Name of the conditional access policy (example: 'Require MFA for Salesforce').
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * Gets the enforcedGrantControls property value. Refers to the grant controls enforced by the conditional access policy (example: 'Require multi-factor authentication').
     * @returns a string
     */
    get enforcedGrantControls() {
        return this._enforcedGrantControls;
    }
    ;
    /**
     * Sets the enforcedGrantControls property value. Refers to the grant controls enforced by the conditional access policy (example: 'Require multi-factor authentication').
     * @param value Value to set for the enforcedGrantControls property.
     */
    set enforcedGrantControls(value) {
        this._enforcedGrantControls = value;
    }
    ;
    /**
     * Gets the enforcedSessionControls property value. Refers to the session controls enforced by the conditional access policy (example: 'Require app enforced controls').
     * @returns a string
     */
    get enforcedSessionControls() {
        return this._enforcedSessionControls;
    }
    ;
    /**
     * Sets the enforcedSessionControls property value. Refers to the session controls enforced by the conditional access policy (example: 'Require app enforced controls').
     * @param value Value to set for the enforcedSessionControls property.
     */
    set enforcedSessionControls(value) {
        this._enforcedSessionControls = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "displayName": (o, n) => { o.displayName = n.getStringValue(); },
            "enforcedGrantControls": (o, n) => { o.enforcedGrantControls = n.getCollectionOfPrimitiveValues(); },
            "enforcedSessionControls": (o, n) => { o.enforcedSessionControls = n.getCollectionOfPrimitiveValues(); },
            "id": (o, n) => { o.id = n.getStringValue(); },
            "result": (o, n) => { o.result = n.getEnumValue(appliedConditionalAccessPolicyResult_1.AppliedConditionalAccessPolicyResult); },
        };
    }
    ;
    /**
     * Gets the id property value. An identifier of the conditional access policy.
     * @returns a string
     */
    get id() {
        return this._id;
    }
    ;
    /**
     * Sets the id property value. An identifier of the conditional access policy.
     * @param value Value to set for the id property.
     */
    set id(value) {
        this._id = value;
    }
    ;
    /**
     * Gets the result property value. Indicates the result of the CA policy that was triggered. Possible values are: success, failure, notApplied (Policy isn't applied because policy conditions were not met),notEnabled (This is due to the policy in disabled state), unknown, unknownFutureValue.
     * @returns a appliedConditionalAccessPolicyResult
     */
    get result() {
        return this._result;
    }
    ;
    /**
     * Sets the result property value. Indicates the result of the CA policy that was triggered. Possible values are: success, failure, notApplied (Policy isn't applied because policy conditions were not met),notEnabled (This is due to the policy in disabled state), unknown, unknownFutureValue.
     * @param value Value to set for the result property.
     */
    set result(value) {
        this._result = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("displayName", this.displayName);
        writer.writeCollectionOfPrimitiveValues("enforcedGrantControls", this.enforcedGrantControls);
        writer.writeCollectionOfPrimitiveValues("enforcedSessionControls", this.enforcedSessionControls);
        writer.writeStringValue("id", this.id);
        writer.writeEnumValue("result", this.result);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.AppliedConditionalAccessPolicy = AppliedConditionalAccessPolicy;
