import { ApprovalStage, Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class Approval extends Entity implements Parsable {
    /** A collection of stages in the approval decision.  */
    private _stages?;
    /**
     * Instantiates a new approval and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the stages property value. A collection of stages in the approval decision.
     * @returns a approvalStage
     */
    get stages(): ApprovalStage[] | undefined;
    /**
     * Sets the stages property value. A collection of stages in the approval decision.
     * @param value Value to set for the stages property.
     */
    set stages(value: ApprovalStage[] | undefined);
}
