"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApprovalStage = void 0;
const createIdentityFromDiscriminatorValue_1 = require("./createIdentityFromDiscriminatorValue");
const index_1 = require("./index");
class ApprovalStage extends index_1.Entity {
    /**
     * Instantiates a new approvalStage and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the assignedToMe property value. Indicates whether the stage is assigned to the calling user to review. Read-only.
     * @returns a boolean
     */
    get assignedToMe() {
        return this._assignedToMe;
    }
    ;
    /**
     * Sets the assignedToMe property value. Indicates whether the stage is assigned to the calling user to review. Read-only.
     * @param value Value to set for the assignedToMe property.
     */
    set assignedToMe(value) {
        this._assignedToMe = value;
    }
    ;
    ;
    /**
     * Gets the displayName property value. The label provided by the policy creator to identify an approval stage. Read-only.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The label provided by the policy creator to identify an approval stage. Read-only.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "assignedToMe": (o, n) => { o.assignedToMe = n.getBooleanValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "justification": (o, n) => { o.justification = n.getStringValue(); }, "reviewedBy": (o, n) => { o.reviewedBy = n.getObjectValue(createIdentityFromDiscriminatorValue_1.createIdentityFromDiscriminatorValue); }, "reviewedDateTime": (o, n) => { o.reviewedDateTime = n.getDateValue(); }, "reviewResult": (o, n) => { o.reviewResult = n.getStringValue(); }, "status": (o, n) => { o.status = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the justification property value. The justification associated with the approval stage decision.
     * @returns a string
     */
    get justification() {
        return this._justification;
    }
    ;
    /**
     * Sets the justification property value. The justification associated with the approval stage decision.
     * @param value Value to set for the justification property.
     */
    set justification(value) {
        this._justification = value;
    }
    ;
    /**
     * Gets the reviewedBy property value. The identifier of the reviewer. Read-only.
     * @returns a identity
     */
    get reviewedBy() {
        return this._reviewedBy;
    }
    ;
    /**
     * Sets the reviewedBy property value. The identifier of the reviewer. Read-only.
     * @param value Value to set for the reviewedBy property.
     */
    set reviewedBy(value) {
        this._reviewedBy = value;
    }
    ;
    /**
     * Gets the reviewedDateTime property value. The date and time when a decision was recorded. The date and time information uses ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
     * @returns a Date
     */
    get reviewedDateTime() {
        return this._reviewedDateTime;
    }
    ;
    /**
     * Sets the reviewedDateTime property value. The date and time when a decision was recorded. The date and time information uses ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
     * @param value Value to set for the reviewedDateTime property.
     */
    set reviewedDateTime(value) {
        this._reviewedDateTime = value;
    }
    ;
    /**
     * Gets the reviewResult property value. The result of this approval record. Possible values include: NotReviewed, Approved, Denied.
     * @returns a string
     */
    get reviewResult() {
        return this._reviewResult;
    }
    ;
    /**
     * Sets the reviewResult property value. The result of this approval record. Possible values include: NotReviewed, Approved, Denied.
     * @param value Value to set for the reviewResult property.
     */
    set reviewResult(value) {
        this._reviewResult = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeBooleanValue("assignedToMe", this.assignedToMe);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeStringValue("justification", this.justification);
        writer.writeObjectValue("reviewedBy", this.reviewedBy);
        writer.writeDateValue("reviewedDateTime", this.reviewedDateTime);
        writer.writeStringValue("reviewResult", this.reviewResult);
        writer.writeStringValue("status", this.status);
    }
    ;
    /**
     * Gets the status property value. The stage status. Possible values: InProgress, Initializing, Completed, Expired. Read-only.
     * @returns a string
     */
    get status() {
        return this._status;
    }
    ;
    /**
     * Sets the status property value. The stage status. Possible values: InProgress, Initializing, Completed, Expired. Read-only.
     * @param value Value to set for the status property.
     */
    set status(value) {
        this._status = value;
    }
    ;
}
exports.ApprovalStage = ApprovalStage;
