"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AssignedLicense = void 0;
class AssignedLicense {
    /**
     * Instantiates a new assignedLicense and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the disabledPlans property value. A collection of the unique identifiers for plans that have been disabled.
     * @returns a string
     */
    get disabledPlans() {
        return this._disabledPlans;
    }
    ;
    /**
     * Sets the disabledPlans property value. A collection of the unique identifiers for plans that have been disabled.
     * @param value Value to set for the disabledPlans property.
     */
    set disabledPlans(value) {
        this._disabledPlans = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "disabledPlans": (o, n) => { o.disabledPlans = n.getCollectionOfPrimitiveValues(); },
            "skuId": (o, n) => { o.skuId = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfPrimitiveValues("disabledPlans", this.disabledPlans);
        writer.writeStringValue("skuId", this.skuId);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the skuId property value. The unique identifier for the SKU.
     * @returns a string
     */
    get skuId() {
        return this._skuId;
    }
    ;
    /**
     * Sets the skuId property value. The unique identifier for the SKU.
     * @param value Value to set for the skuId property.
     */
    set skuId(value) {
        this._skuId = value;
    }
    ;
}
exports.AssignedLicense = AssignedLicense;
