"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AssignedPlan = void 0;
class AssignedPlan {
    /**
     * Instantiates a new assignedPlan and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the assignedDateTime property value. The date and time at which the plan was assigned. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z.
     * @returns a Date
     */
    get assignedDateTime() {
        return this._assignedDateTime;
    }
    ;
    /**
     * Sets the assignedDateTime property value. The date and time at which the plan was assigned. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z.
     * @param value Value to set for the assignedDateTime property.
     */
    set assignedDateTime(value) {
        this._assignedDateTime = value;
    }
    ;
    /**
     * Gets the capabilityStatus property value. Condition of the capability assignment. The possible values are Enabled, Warning, Suspended, Deleted, LockedOut. See a detailed description of each value.
     * @returns a string
     */
    get capabilityStatus() {
        return this._capabilityStatus;
    }
    ;
    /**
     * Sets the capabilityStatus property value. Condition of the capability assignment. The possible values are Enabled, Warning, Suspended, Deleted, LockedOut. See a detailed description of each value.
     * @param value Value to set for the capabilityStatus property.
     */
    set capabilityStatus(value) {
        this._capabilityStatus = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "assignedDateTime": (o, n) => { o.assignedDateTime = n.getDateValue(); },
            "capabilityStatus": (o, n) => { o.capabilityStatus = n.getStringValue(); },
            "service": (o, n) => { o.service = n.getStringValue(); },
            "servicePlanId": (o, n) => { o.servicePlanId = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeDateValue("assignedDateTime", this.assignedDateTime);
        writer.writeStringValue("capabilityStatus", this.capabilityStatus);
        writer.writeStringValue("service", this.service);
        writer.writeStringValue("servicePlanId", this.servicePlanId);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the service property value. The name of the service; for example, exchange.
     * @returns a string
     */
    get service() {
        return this._service;
    }
    ;
    /**
     * Sets the service property value. The name of the service; for example, exchange.
     * @param value Value to set for the service property.
     */
    set service(value) {
        this._service = value;
    }
    ;
    /**
     * Gets the servicePlanId property value. A GUID that identifies the service plan. For a complete list of GUIDs and their equivalent friendly service names, see Product names and service plan identifiers for licensing.
     * @returns a string
     */
    get servicePlanId() {
        return this._servicePlanId;
    }
    ;
    /**
     * Sets the servicePlanId property value. A GUID that identifies the service plan. For a complete list of GUIDs and their equivalent friendly service names, see Product names and service plan identifiers for licensing.
     * @param value Value to set for the servicePlanId property.
     */
    set servicePlanId(value) {
        this._servicePlanId = value;
    }
    ;
}
exports.AssignedPlan = AssignedPlan;
