"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AttachmentItem = void 0;
const attachmentType_1 = require("./attachmentType");
class AttachmentItem {
    /**
     * Instantiates a new attachmentItem and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the attachmentType property value. The type of attachment. Possible values are: file, item, reference. Required.
     * @returns a attachmentType
     */
    get attachmentType() {
        return this._attachmentType;
    }
    ;
    /**
     * Sets the attachmentType property value. The type of attachment. Possible values are: file, item, reference. Required.
     * @param value Value to set for the attachmentType property.
     */
    set attachmentType(value) {
        this._attachmentType = value;
    }
    ;
    ;
    /**
     * Gets the contentId property value. The CID or Content-Id of the attachment for referencing in case of in-line attachments using <img src='cid:contentId'> tag in HTML messages. Optional.
     * @returns a string
     */
    get contentId() {
        return this._contentId;
    }
    ;
    /**
     * Sets the contentId property value. The CID or Content-Id of the attachment for referencing in case of in-line attachments using <img src='cid:contentId'> tag in HTML messages. Optional.
     * @param value Value to set for the contentId property.
     */
    set contentId(value) {
        this._contentId = value;
    }
    ;
    /**
     * Gets the contentType property value. The nature of the data in the attachment. Optional.
     * @returns a string
     */
    get contentType() {
        return this._contentType;
    }
    ;
    /**
     * Sets the contentType property value. The nature of the data in the attachment. Optional.
     * @param value Value to set for the contentType property.
     */
    set contentType(value) {
        this._contentType = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "attachmentType": (o, n) => { o.attachmentType = n.getEnumValue(attachmentType_1.AttachmentType); },
            "contentId": (o, n) => { o.contentId = n.getStringValue(); },
            "contentType": (o, n) => { o.contentType = n.getStringValue(); },
            "isInline": (o, n) => { o.isInline = n.getBooleanValue(); },
            "name": (o, n) => { o.name = n.getStringValue(); },
            "size": (o, n) => { o.size = n.getNumberValue(); },
        };
    }
    ;
    /**
     * Gets the isInline property value. true if the attachment is an inline attachment; otherwise, false. Optional.
     * @returns a boolean
     */
    get isInline() {
        return this._isInline;
    }
    ;
    /**
     * Sets the isInline property value. true if the attachment is an inline attachment; otherwise, false. Optional.
     * @param value Value to set for the isInline property.
     */
    set isInline(value) {
        this._isInline = value;
    }
    ;
    /**
     * Gets the name property value. The display name of the attachment. This can be a descriptive string and does not have to be the actual file name. Required.
     * @returns a string
     */
    get name() {
        return this._name;
    }
    ;
    /**
     * Sets the name property value. The display name of the attachment. This can be a descriptive string and does not have to be the actual file name. Required.
     * @param value Value to set for the name property.
     */
    set name(value) {
        this._name = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeEnumValue("attachmentType", this.attachmentType);
        writer.writeStringValue("contentId", this.contentId);
        writer.writeStringValue("contentType", this.contentType);
        writer.writeBooleanValue("isInline", this.isInline);
        writer.writeStringValue("name", this.name);
        writer.writeNumberValue("size", this.size);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the size property value. The length of the attachment in bytes. Required.
     * @returns a int64
     */
    get size() {
        return this._size;
    }
    ;
    /**
     * Sets the size property value. The length of the attachment in bytes. Required.
     * @param value Value to set for the size property.
     */
    set size(value) {
        this._size = value;
    }
    ;
}
exports.AttachmentItem = AttachmentItem;
