"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AttendanceInterval = void 0;
class AttendanceInterval {
    /**
     * Instantiates a new attendanceInterval and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the durationInSeconds property value. Duration of the meeting interval in seconds; that is, the difference between joinDateTime and leaveDateTime.
     * @returns a integer
     */
    get durationInSeconds() {
        return this._durationInSeconds;
    }
    ;
    /**
     * Sets the durationInSeconds property value. Duration of the meeting interval in seconds; that is, the difference between joinDateTime and leaveDateTime.
     * @param value Value to set for the durationInSeconds property.
     */
    set durationInSeconds(value) {
        this._durationInSeconds = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "durationInSeconds": (o, n) => { o.durationInSeconds = n.getNumberValue(); },
            "joinDateTime": (o, n) => { o.joinDateTime = n.getDateValue(); },
            "leaveDateTime": (o, n) => { o.leaveDateTime = n.getDateValue(); },
        };
    }
    ;
    /**
     * Gets the joinDateTime property value. The time the attendee joined in UTC.
     * @returns a Date
     */
    get joinDateTime() {
        return this._joinDateTime;
    }
    ;
    /**
     * Sets the joinDateTime property value. The time the attendee joined in UTC.
     * @param value Value to set for the joinDateTime property.
     */
    set joinDateTime(value) {
        this._joinDateTime = value;
    }
    ;
    /**
     * Gets the leaveDateTime property value. The time the attendee left in UTC.
     * @returns a Date
     */
    get leaveDateTime() {
        return this._leaveDateTime;
    }
    ;
    /**
     * Sets the leaveDateTime property value. The time the attendee left in UTC.
     * @param value Value to set for the leaveDateTime property.
     */
    set leaveDateTime(value) {
        this._leaveDateTime = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeNumberValue("durationInSeconds", this.durationInSeconds);
        writer.writeDateValue("joinDateTime", this.joinDateTime);
        writer.writeDateValue("leaveDateTime", this.leaveDateTime);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.AttendanceInterval = AttendanceInterval;
