import { AttendanceInterval, Entity, Identity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class AttendanceRecord extends Entity implements Parsable {
    /** List of time periods between joining and leaving a meeting.  */
    private _attendanceIntervals?;
    /** Email address of the user associated with this atttendance record.  */
    private _emailAddress?;
    /** Identity of the user associated with this atttendance record.  */
    private _identity?;
    /** Role of the attendee. Possible values are: None, Attendee, Presenter, and Organizer.  */
    private _role?;
    /** Total duration of the attendances in seconds.  */
    private _totalAttendanceInSeconds?;
    /**
     * Gets the attendanceIntervals property value. List of time periods between joining and leaving a meeting.
     * @returns a attendanceInterval
     */
    get attendanceIntervals(): AttendanceInterval[] | undefined;
    /**
     * Sets the attendanceIntervals property value. List of time periods between joining and leaving a meeting.
     * @param value Value to set for the attendanceIntervals property.
     */
    set attendanceIntervals(value: AttendanceInterval[] | undefined);
    /**
     * Instantiates a new attendanceRecord and sets the default values.
     */
    constructor();
    /**
     * Gets the emailAddress property value. Email address of the user associated with this atttendance record.
     * @returns a string
     */
    get emailAddress(): string | undefined;
    /**
     * Sets the emailAddress property value. Email address of the user associated with this atttendance record.
     * @param value Value to set for the emailAddress property.
     */
    set emailAddress(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the identity property value. Identity of the user associated with this atttendance record.
     * @returns a identity
     */
    get identity(): Identity | undefined;
    /**
     * Sets the identity property value. Identity of the user associated with this atttendance record.
     * @param value Value to set for the identity property.
     */
    set identity(value: Identity | undefined);
    /**
     * Gets the role property value. Role of the attendee. Possible values are: None, Attendee, Presenter, and Organizer.
     * @returns a string
     */
    get role(): string | undefined;
    /**
     * Sets the role property value. Role of the attendee. Possible values are: None, Attendee, Presenter, and Organizer.
     * @param value Value to set for the role property.
     */
    set role(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the totalAttendanceInSeconds property value. Total duration of the attendances in seconds.
     * @returns a integer
     */
    get totalAttendanceInSeconds(): number | undefined;
    /**
     * Sets the totalAttendanceInSeconds property value. Total duration of the attendances in seconds.
     * @param value Value to set for the totalAttendanceInSeconds property.
     */
    set totalAttendanceInSeconds(value: number | undefined);
}
