"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AttendanceRecord = void 0;
const createAttendanceIntervalFromDiscriminatorValue_1 = require("./createAttendanceIntervalFromDiscriminatorValue");
const createIdentityFromDiscriminatorValue_1 = require("./createIdentityFromDiscriminatorValue");
const index_1 = require("./index");
class AttendanceRecord extends index_1.Entity {
    /**
     * Instantiates a new attendanceRecord and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the attendanceIntervals property value. List of time periods between joining and leaving a meeting.
     * @returns a attendanceInterval
     */
    get attendanceIntervals() {
        return this._attendanceIntervals;
    }
    ;
    /**
     * Sets the attendanceIntervals property value. List of time periods between joining and leaving a meeting.
     * @param value Value to set for the attendanceIntervals property.
     */
    set attendanceIntervals(value) {
        this._attendanceIntervals = value;
    }
    ;
    ;
    /**
     * Gets the emailAddress property value. Email address of the user associated with this atttendance record.
     * @returns a string
     */
    get emailAddress() {
        return this._emailAddress;
    }
    ;
    /**
     * Sets the emailAddress property value. Email address of the user associated with this atttendance record.
     * @param value Value to set for the emailAddress property.
     */
    set emailAddress(value) {
        this._emailAddress = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "attendanceIntervals": (o, n) => { o.attendanceIntervals = n.getCollectionOfObjectValues(createAttendanceIntervalFromDiscriminatorValue_1.createAttendanceIntervalFromDiscriminatorValue); }, "emailAddress": (o, n) => { o.emailAddress = n.getStringValue(); }, "identity": (o, n) => { o.identity = n.getObjectValue(createIdentityFromDiscriminatorValue_1.createIdentityFromDiscriminatorValue); }, "role": (o, n) => { o.role = n.getStringValue(); }, "totalAttendanceInSeconds": (o, n) => { o.totalAttendanceInSeconds = n.getNumberValue(); } });
    }
    ;
    /**
     * Gets the identity property value. Identity of the user associated with this atttendance record.
     * @returns a identity
     */
    get identity() {
        return this._identity;
    }
    ;
    /**
     * Sets the identity property value. Identity of the user associated with this atttendance record.
     * @param value Value to set for the identity property.
     */
    set identity(value) {
        this._identity = value;
    }
    ;
    /**
     * Gets the role property value. Role of the attendee. Possible values are: None, Attendee, Presenter, and Organizer.
     * @returns a string
     */
    get role() {
        return this._role;
    }
    ;
    /**
     * Sets the role property value. Role of the attendee. Possible values are: None, Attendee, Presenter, and Organizer.
     * @param value Value to set for the role property.
     */
    set role(value) {
        this._role = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("attendanceIntervals", this.attendanceIntervals);
        writer.writeStringValue("emailAddress", this.emailAddress);
        writer.writeObjectValue("identity", this.identity);
        writer.writeStringValue("role", this.role);
        writer.writeNumberValue("totalAttendanceInSeconds", this.totalAttendanceInSeconds);
    }
    ;
    /**
     * Gets the totalAttendanceInSeconds property value. Total duration of the attendances in seconds.
     * @returns a integer
     */
    get totalAttendanceInSeconds() {
        return this._totalAttendanceInSeconds;
    }
    ;
    /**
     * Sets the totalAttendanceInSeconds property value. Total duration of the attendances in seconds.
     * @param value Value to set for the totalAttendanceInSeconds property.
     */
    set totalAttendanceInSeconds(value) {
        this._totalAttendanceInSeconds = value;
    }
    ;
}
exports.AttendanceRecord = AttendanceRecord;
