"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AttendeeAvailability = void 0;
const createAttendeeBaseFromDiscriminatorValue_1 = require("./createAttendeeBaseFromDiscriminatorValue");
const freeBusyStatus_1 = require("./freeBusyStatus");
class AttendeeAvailability {
    /**
     * Instantiates a new attendeeAvailability and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the attendee property value. The email address and type of attendee - whether it's a person or a resource, and whether required or optional if it's a person.
     * @returns a attendeeBase
     */
    get attendee() {
        return this._attendee;
    }
    ;
    /**
     * Sets the attendee property value. The email address and type of attendee - whether it's a person or a resource, and whether required or optional if it's a person.
     * @param value Value to set for the attendee property.
     */
    set attendee(value) {
        this._attendee = value;
    }
    ;
    /**
     * Gets the availability property value. The availability status of the attendee. The possible values are: free, tentative, busy, oof, workingElsewhere, unknown.
     * @returns a freeBusyStatus
     */
    get availability() {
        return this._availability;
    }
    ;
    /**
     * Sets the availability property value. The availability status of the attendee. The possible values are: free, tentative, busy, oof, workingElsewhere, unknown.
     * @param value Value to set for the availability property.
     */
    set availability(value) {
        this._availability = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "attendee": (o, n) => { o.attendee = n.getObjectValue(createAttendeeBaseFromDiscriminatorValue_1.createAttendeeBaseFromDiscriminatorValue); },
            "availability": (o, n) => { o.availability = n.getEnumValue(freeBusyStatus_1.FreeBusyStatus); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("attendee", this.attendee);
        writer.writeEnumValue("availability", this.availability);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.AttendeeAvailability = AttendeeAvailability;
