"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AttendeeBase = void 0;
const attendeeType_1 = require("./attendeeType");
const index_1 = require("./index");
class AttendeeBase extends index_1.Recipient {
    /**
     * Instantiates a new attendeeBase and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "type": (o, n) => { o.type = n.getEnumValue(attendeeType_1.AttendeeType); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeEnumValue("type", this.type);
    }
    ;
    /**
     * Gets the type property value. The type of attendee. The possible values are: required, optional, resource. Currently if the attendee is a person, findMeetingTimes always considers the person is of the Required type.
     * @returns a attendeeType
     */
    get type() {
        return this._type;
    }
    ;
    /**
     * Sets the type property value. The type of attendee. The possible values are: required, optional, resource. Currently if the attendee is a person, findMeetingTimes always considers the person is of the Required type.
     * @param value Value to set for the type property.
     */
    set type(value) {
        this._type = value;
    }
    ;
}
exports.AttendeeBase = AttendeeBase;
