import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class Audio implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** The title of the album for this audio file.  */
    private _album?;
    /** The artist named on the album for the audio file.  */
    private _albumArtist?;
    /** The performing artist for the audio file.  */
    private _artist?;
    /** Bitrate expressed in kbps.  */
    private _bitrate?;
    /** The name of the composer of the audio file.  */
    private _composers?;
    /** Copyright information for the audio file.  */
    private _copyright?;
    /** The number of the disc this audio file came from.  */
    private _disc?;
    /** The total number of discs in this album.  */
    private _discCount?;
    /** Duration of the audio file, expressed in milliseconds  */
    private _duration?;
    /** The genre of this audio file.  */
    private _genre?;
    /** Indicates if the file is protected with digital rights management.  */
    private _hasDrm?;
    /** Indicates if the file is encoded with a variable bitrate.  */
    private _isVariableBitrate?;
    /** The title of the audio file.  */
    private _title?;
    /** The number of the track on the original disc for this audio file.  */
    private _track?;
    /** The total number of tracks on the original disc for this audio file.  */
    private _trackCount?;
    /** The year the audio file was recorded.  */
    private _year?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the album property value. The title of the album for this audio file.
     * @returns a string
     */
    get album(): string | undefined;
    /**
     * Sets the album property value. The title of the album for this audio file.
     * @param value Value to set for the album property.
     */
    set album(value: string | undefined);
    /**
     * Gets the albumArtist property value. The artist named on the album for the audio file.
     * @returns a string
     */
    get albumArtist(): string | undefined;
    /**
     * Sets the albumArtist property value. The artist named on the album for the audio file.
     * @param value Value to set for the albumArtist property.
     */
    set albumArtist(value: string | undefined);
    /**
     * Gets the artist property value. The performing artist for the audio file.
     * @returns a string
     */
    get artist(): string | undefined;
    /**
     * Sets the artist property value. The performing artist for the audio file.
     * @param value Value to set for the artist property.
     */
    set artist(value: string | undefined);
    /**
     * Gets the bitrate property value. Bitrate expressed in kbps.
     * @returns a int64
     */
    get bitrate(): number | undefined;
    /**
     * Sets the bitrate property value. Bitrate expressed in kbps.
     * @param value Value to set for the bitrate property.
     */
    set bitrate(value: number | undefined);
    /**
     * Gets the composers property value. The name of the composer of the audio file.
     * @returns a string
     */
    get composers(): string | undefined;
    /**
     * Sets the composers property value. The name of the composer of the audio file.
     * @param value Value to set for the composers property.
     */
    set composers(value: string | undefined);
    /**
     * Instantiates a new audio and sets the default values.
     */
    constructor();
    /**
     * Gets the copyright property value. Copyright information for the audio file.
     * @returns a string
     */
    get copyright(): string | undefined;
    /**
     * Sets the copyright property value. Copyright information for the audio file.
     * @param value Value to set for the copyright property.
     */
    set copyright(value: string | undefined);
    /**
     * Gets the disc property value. The number of the disc this audio file came from.
     * @returns a integer
     */
    get disc(): number | undefined;
    /**
     * Sets the disc property value. The number of the disc this audio file came from.
     * @param value Value to set for the disc property.
     */
    set disc(value: number | undefined);
    /**
     * Gets the discCount property value. The total number of discs in this album.
     * @returns a integer
     */
    get discCount(): number | undefined;
    /**
     * Sets the discCount property value. The total number of discs in this album.
     * @param value Value to set for the discCount property.
     */
    set discCount(value: number | undefined);
    /**
     * Gets the duration property value. Duration of the audio file, expressed in milliseconds
     * @returns a int64
     */
    get duration(): number | undefined;
    /**
     * Sets the duration property value. Duration of the audio file, expressed in milliseconds
     * @param value Value to set for the duration property.
     */
    set duration(value: number | undefined);
    /**
     * Gets the genre property value. The genre of this audio file.
     * @returns a string
     */
    get genre(): string | undefined;
    /**
     * Sets the genre property value. The genre of this audio file.
     * @param value Value to set for the genre property.
     */
    set genre(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the hasDrm property value. Indicates if the file is protected with digital rights management.
     * @returns a boolean
     */
    get hasDrm(): boolean | undefined;
    /**
     * Sets the hasDrm property value. Indicates if the file is protected with digital rights management.
     * @param value Value to set for the hasDrm property.
     */
    set hasDrm(value: boolean | undefined);
    /**
     * Gets the isVariableBitrate property value. Indicates if the file is encoded with a variable bitrate.
     * @returns a boolean
     */
    get isVariableBitrate(): boolean | undefined;
    /**
     * Sets the isVariableBitrate property value. Indicates if the file is encoded with a variable bitrate.
     * @param value Value to set for the isVariableBitrate property.
     */
    set isVariableBitrate(value: boolean | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the title property value. The title of the audio file.
     * @returns a string
     */
    get title(): string | undefined;
    /**
     * Sets the title property value. The title of the audio file.
     * @param value Value to set for the title property.
     */
    set title(value: string | undefined);
    /**
     * Gets the track property value. The number of the track on the original disc for this audio file.
     * @returns a integer
     */
    get track(): number | undefined;
    /**
     * Sets the track property value. The number of the track on the original disc for this audio file.
     * @param value Value to set for the track property.
     */
    set track(value: number | undefined);
    /**
     * Gets the trackCount property value. The total number of tracks on the original disc for this audio file.
     * @returns a integer
     */
    get trackCount(): number | undefined;
    /**
     * Sets the trackCount property value. The total number of tracks on the original disc for this audio file.
     * @param value Value to set for the trackCount property.
     */
    set trackCount(value: number | undefined);
    /**
     * Gets the year property value. The year the audio file was recorded.
     * @returns a integer
     */
    get year(): number | undefined;
    /**
     * Sets the year property value. The year the audio file was recorded.
     * @param value Value to set for the year property.
     */
    set year(value: number | undefined);
}
