"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AudioRoutingGroup = void 0;
const index_1 = require("./index");
const routingMode_1 = require("./routingMode");
class AudioRoutingGroup extends index_1.Entity {
    /**
     * Instantiates a new audioRoutingGroup and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "receivers": (o, n) => { o.receivers = n.getCollectionOfPrimitiveValues(); }, "routingMode": (o, n) => { o.routingMode = n.getEnumValue(routingMode_1.RoutingMode); }, "sources": (o, n) => { o.sources = n.getCollectionOfPrimitiveValues(); } });
    }
    ;
    /**
     * Gets the receivers property value. List of receiving participant ids.
     * @returns a string
     */
    get receivers() {
        return this._receivers;
    }
    ;
    /**
     * Sets the receivers property value. List of receiving participant ids.
     * @param value Value to set for the receivers property.
     */
    set receivers(value) {
        this._receivers = value;
    }
    ;
    /**
     * Gets the routingMode property value. Routing group mode.  Possible values are: oneToOne, multicast.
     * @returns a routingMode
     */
    get routingMode() {
        return this._routingMode;
    }
    ;
    /**
     * Sets the routingMode property value. Routing group mode.  Possible values are: oneToOne, multicast.
     * @param value Value to set for the routingMode property.
     */
    set routingMode(value) {
        this._routingMode = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfPrimitiveValues("receivers", this.receivers);
        writer.writeEnumValue("routingMode", this.routingMode);
        writer.writeCollectionOfPrimitiveValues("sources", this.sources);
    }
    ;
    /**
     * Gets the sources property value. List of source participant ids.
     * @returns a string
     */
    get sources() {
        return this._sources;
    }
    ;
    /**
     * Sets the sources property value. List of source participant ids.
     * @param value Value to set for the sources property.
     */
    set sources(value) {
        this._sources = value;
    }
    ;
}
exports.AudioRoutingGroup = AudioRoutingGroup;
