"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuditActivityInitiator = void 0;
const createAppIdentityFromDiscriminatorValue_1 = require("./createAppIdentityFromDiscriminatorValue");
const createUserIdentityFromDiscriminatorValue_1 = require("./createUserIdentityFromDiscriminatorValue");
class AuditActivityInitiator {
    /**
     * Instantiates a new auditActivityInitiator and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the app property value. If the resource initiating the activity is an app, this property indicates all the app related information like appId, Name, servicePrincipalId, Name.
     * @returns a appIdentity
     */
    get app() {
        return this._app;
    }
    ;
    /**
     * Sets the app property value. If the resource initiating the activity is an app, this property indicates all the app related information like appId, Name, servicePrincipalId, Name.
     * @param value Value to set for the app property.
     */
    set app(value) {
        this._app = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "app": (o, n) => { o.app = n.getObjectValue(createAppIdentityFromDiscriminatorValue_1.createAppIdentityFromDiscriminatorValue); },
            "user": (o, n) => { o.user = n.getObjectValue(createUserIdentityFromDiscriminatorValue_1.createUserIdentityFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("app", this.app);
        writer.writeObjectValue("user", this.user);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the user property value. If the resource initiating the activity is a user, this property Indicates all the user related information like userId, Name, UserPrinicpalName.
     * @returns a userIdentity
     */
    get user() {
        return this._user;
    }
    ;
    /**
     * Sets the user property value. If the resource initiating the activity is a user, this property Indicates all the user related information like userId, Name, UserPrinicpalName.
     * @param value Value to set for the user property.
     */
    set user(value) {
        this._user = value;
    }
    ;
}
exports.AuditActivityInitiator = AuditActivityInitiator;
