import { DirectoryAudit, Entity, ProvisioningObjectSummary, RestrictedSignIn, SignIn } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to manage the auditLogRoot singleton.  */
export declare class AuditLogRoot extends Entity implements Parsable {
    /** Read-only. Nullable.  */
    private _directoryAudits?;
    private _provisioning?;
    private _restrictedSignIns?;
    /** Read-only. Nullable.  */
    private _signIns?;
    /**
     * Instantiates a new auditLogRoot and sets the default values.
     */
    constructor();
    /**
     * Gets the directoryAudits property value. Read-only. Nullable.
     * @returns a directoryAudit
     */
    get directoryAudits(): DirectoryAudit[] | undefined;
    /**
     * Sets the directoryAudits property value. Read-only. Nullable.
     * @param value Value to set for the directoryAudits property.
     */
    set directoryAudits(value: DirectoryAudit[] | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the provisioning property value.
     * @returns a provisioningObjectSummary
     */
    get provisioning(): ProvisioningObjectSummary[] | undefined;
    /**
     * Sets the provisioning property value.
     * @param value Value to set for the provisioning property.
     */
    set provisioning(value: ProvisioningObjectSummary[] | undefined);
    /**
     * Gets the restrictedSignIns property value.
     * @returns a restrictedSignIn
     */
    get restrictedSignIns(): RestrictedSignIn[] | undefined;
    /**
     * Sets the restrictedSignIns property value.
     * @param value Value to set for the restrictedSignIns property.
     */
    set restrictedSignIns(value: RestrictedSignIn[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the signIns property value. Read-only. Nullable.
     * @returns a signIn
     */
    get signIns(): SignIn[] | undefined;
    /**
     * Sets the signIns property value. Read-only. Nullable.
     * @param value Value to set for the signIns property.
     */
    set signIns(value: SignIn[] | undefined);
}
