import { AuthenticationMethod, Entity, Fido2AuthenticationMethod, MicrosoftAuthenticatorAuthenticationMethod, WindowsHelloForBusinessAuthenticationMethod } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class Authentication extends Entity implements Parsable {
    private _fido2Methods?;
    private _methods?;
    private _microsoftAuthenticatorMethods?;
    private _windowsHelloForBusinessMethods?;
    /**
     * Instantiates a new authentication and sets the default values.
     */
    constructor();
    /**
     * Gets the fido2Methods property value.
     * @returns a fido2AuthenticationMethod
     */
    get fido2Methods(): Fido2AuthenticationMethod[] | undefined;
    /**
     * Sets the fido2Methods property value.
     * @param value Value to set for the fido2Methods property.
     */
    set fido2Methods(value: Fido2AuthenticationMethod[] | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the methods property value.
     * @returns a authenticationMethod
     */
    get methods(): AuthenticationMethod[] | undefined;
    /**
     * Sets the methods property value.
     * @param value Value to set for the methods property.
     */
    set methods(value: AuthenticationMethod[] | undefined);
    /**
     * Gets the microsoftAuthenticatorMethods property value.
     * @returns a microsoftAuthenticatorAuthenticationMethod
     */
    get microsoftAuthenticatorMethods(): MicrosoftAuthenticatorAuthenticationMethod[] | undefined;
    /**
     * Sets the microsoftAuthenticatorMethods property value.
     * @param value Value to set for the microsoftAuthenticatorMethods property.
     */
    set microsoftAuthenticatorMethods(value: MicrosoftAuthenticatorAuthenticationMethod[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the windowsHelloForBusinessMethods property value.
     * @returns a windowsHelloForBusinessAuthenticationMethod
     */
    get windowsHelloForBusinessMethods(): WindowsHelloForBusinessAuthenticationMethod[] | undefined;
    /**
     * Sets the windowsHelloForBusinessMethods property value.
     * @param value Value to set for the windowsHelloForBusinessMethods property.
     */
    set windowsHelloForBusinessMethods(value: WindowsHelloForBusinessAuthenticationMethod[] | undefined);
}
