"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Authentication = void 0;
const createAuthenticationMethodFromDiscriminatorValue_1 = require("./createAuthenticationMethodFromDiscriminatorValue");
const createFido2AuthenticationMethodFromDiscriminatorValue_1 = require("./createFido2AuthenticationMethodFromDiscriminatorValue");
const createMicrosoftAuthenticatorAuthenticationMethodFromDiscriminatorValue_1 = require("./createMicrosoftAuthenticatorAuthenticationMethodFromDiscriminatorValue");
const createWindowsHelloForBusinessAuthenticationMethodFromDiscriminatorValue_1 = require("./createWindowsHelloForBusinessAuthenticationMethodFromDiscriminatorValue");
const index_1 = require("./index");
class Authentication extends index_1.Entity {
    /**
     * Instantiates a new authentication and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the fido2Methods property value.
     * @returns a fido2AuthenticationMethod
     */
    get fido2Methods() {
        return this._fido2Methods;
    }
    ;
    /**
     * Sets the fido2Methods property value.
     * @param value Value to set for the fido2Methods property.
     */
    set fido2Methods(value) {
        this._fido2Methods = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "fido2Methods": (o, n) => { o.fido2Methods = n.getCollectionOfObjectValues(createFido2AuthenticationMethodFromDiscriminatorValue_1.createFido2AuthenticationMethodFromDiscriminatorValue); }, "methods": (o, n) => { o.methods = n.getCollectionOfObjectValues(createAuthenticationMethodFromDiscriminatorValue_1.createAuthenticationMethodFromDiscriminatorValue); }, "microsoftAuthenticatorMethods": (o, n) => { o.microsoftAuthenticatorMethods = n.getCollectionOfObjectValues(createMicrosoftAuthenticatorAuthenticationMethodFromDiscriminatorValue_1.createMicrosoftAuthenticatorAuthenticationMethodFromDiscriminatorValue); }, "windowsHelloForBusinessMethods": (o, n) => { o.windowsHelloForBusinessMethods = n.getCollectionOfObjectValues(createWindowsHelloForBusinessAuthenticationMethodFromDiscriminatorValue_1.createWindowsHelloForBusinessAuthenticationMethodFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the methods property value.
     * @returns a authenticationMethod
     */
    get methods() {
        return this._methods;
    }
    ;
    /**
     * Sets the methods property value.
     * @param value Value to set for the methods property.
     */
    set methods(value) {
        this._methods = value;
    }
    ;
    /**
     * Gets the microsoftAuthenticatorMethods property value.
     * @returns a microsoftAuthenticatorAuthenticationMethod
     */
    get microsoftAuthenticatorMethods() {
        return this._microsoftAuthenticatorMethods;
    }
    ;
    /**
     * Sets the microsoftAuthenticatorMethods property value.
     * @param value Value to set for the microsoftAuthenticatorMethods property.
     */
    set microsoftAuthenticatorMethods(value) {
        this._microsoftAuthenticatorMethods = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("fido2Methods", this.fido2Methods);
        writer.writeCollectionOfObjectValues("methods", this.methods);
        writer.writeCollectionOfObjectValues("microsoftAuthenticatorMethods", this.microsoftAuthenticatorMethods);
        writer.writeCollectionOfObjectValues("windowsHelloForBusinessMethods", this.windowsHelloForBusinessMethods);
    }
    ;
    /**
     * Gets the windowsHelloForBusinessMethods property value.
     * @returns a windowsHelloForBusinessAuthenticationMethod
     */
    get windowsHelloForBusinessMethods() {
        return this._windowsHelloForBusinessMethods;
    }
    ;
    /**
     * Sets the windowsHelloForBusinessMethods property value.
     * @param value Value to set for the windowsHelloForBusinessMethods property.
     */
    set windowsHelloForBusinessMethods(value) {
        this._windowsHelloForBusinessMethods = value;
    }
    ;
}
exports.Authentication = Authentication;
