import { Entity, SelfServiceSignUpAuthenticationFlowConfiguration } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class AuthenticationFlowsPolicy extends Entity implements Parsable {
    /** Inherited property. A description of the policy. Optional. Read-only.  */
    private _description?;
    /** Inherited property. The human-readable name of the policy. Optional. Read-only.  */
    private _displayName?;
    /** Contains selfServiceSignUpAuthenticationFlowConfiguration settings that convey whether self-service sign-up is enabled or disabled. Optional. Read-only.  */
    private _selfServiceSignUp?;
    /**
     * Instantiates a new authenticationFlowsPolicy and sets the default values.
     */
    constructor();
    /**
     * Gets the description property value. Inherited property. A description of the policy. Optional. Read-only.
     * @returns a string
     */
    get description(): string | undefined;
    /**
     * Sets the description property value. Inherited property. A description of the policy. Optional. Read-only.
     * @param value Value to set for the description property.
     */
    set description(value: string | undefined);
    /**
     * Gets the displayName property value. Inherited property. The human-readable name of the policy. Optional. Read-only.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. Inherited property. The human-readable name of the policy. Optional. Read-only.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the selfServiceSignUp property value. Contains selfServiceSignUpAuthenticationFlowConfiguration settings that convey whether self-service sign-up is enabled or disabled. Optional. Read-only.
     * @returns a selfServiceSignUpAuthenticationFlowConfiguration
     */
    get selfServiceSignUp(): SelfServiceSignUpAuthenticationFlowConfiguration | undefined;
    /**
     * Sets the selfServiceSignUp property value. Contains selfServiceSignUpAuthenticationFlowConfiguration settings that convey whether self-service sign-up is enabled or disabled. Optional. Read-only.
     * @param value Value to set for the selfServiceSignUp property.
     */
    set selfServiceSignUp(value: SelfServiceSignUpAuthenticationFlowConfiguration | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
