import { AuthenticationMethodState } from './authenticationMethodState';
import { Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class AuthenticationMethodConfiguration extends Entity implements Parsable {
    /** The state of the policy. Possible values are: enabled, disabled.  */
    private _state?;
    /**
     * Instantiates a new authenticationMethodConfiguration and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the state property value. The state of the policy. Possible values are: enabled, disabled.
     * @returns a authenticationMethodState
     */
    get state(): AuthenticationMethodState | undefined;
    /**
     * Sets the state property value. The state of the policy. Possible values are: enabled, disabled.
     * @param value Value to set for the state property.
     */
    set state(value: AuthenticationMethodState | undefined);
}
