"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthenticationMethodConfiguration = void 0;
const authenticationMethodState_1 = require("./authenticationMethodState");
const index_1 = require("./index");
class AuthenticationMethodConfiguration extends index_1.Entity {
    /**
     * Instantiates a new authenticationMethodConfiguration and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "state": (o, n) => { o.state = n.getEnumValue(authenticationMethodState_1.AuthenticationMethodState); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeEnumValue("state", this.state);
    }
    ;
    /**
     * Gets the state property value. The state of the policy. Possible values are: enabled, disabled.
     * @returns a authenticationMethodState
     */
    get state() {
        return this._state;
    }
    ;
    /**
     * Sets the state property value. The state of the policy. Possible values are: enabled, disabled.
     * @param value Value to set for the state property.
     */
    set state(value) {
        this._state = value;
    }
    ;
}
exports.AuthenticationMethodConfiguration = AuthenticationMethodConfiguration;
