"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthenticationMethodsPolicy = void 0;
const createAuthenticationMethodConfigurationFromDiscriminatorValue_1 = require("./createAuthenticationMethodConfigurationFromDiscriminatorValue");
const createRegistrationEnforcementFromDiscriminatorValue_1 = require("./createRegistrationEnforcementFromDiscriminatorValue");
const index_1 = require("./index");
/** Provides operations to manage the authenticationMethodsPolicy singleton.  */
class AuthenticationMethodsPolicy extends index_1.Entity {
    /**
     * Instantiates a new authenticationMethodsPolicy and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the authenticationMethodConfigurations property value. Represents the settings for each authentication method. Automatically expanded on GET /policies/authenticationMethodsPolicy.
     * @returns a authenticationMethodConfiguration
     */
    get authenticationMethodConfigurations() {
        return this._authenticationMethodConfigurations;
    }
    ;
    /**
     * Sets the authenticationMethodConfigurations property value. Represents the settings for each authentication method. Automatically expanded on GET /policies/authenticationMethodsPolicy.
     * @param value Value to set for the authenticationMethodConfigurations property.
     */
    set authenticationMethodConfigurations(value) {
        this._authenticationMethodConfigurations = value;
    }
    ;
    ;
    /**
     * Gets the description property value. A description of the policy. Read-only.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. A description of the policy. Read-only.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the displayName property value. The name of the policy. Read-only.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The name of the policy. Read-only.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "authenticationMethodConfigurations": (o, n) => { o.authenticationMethodConfigurations = n.getCollectionOfObjectValues(createAuthenticationMethodConfigurationFromDiscriminatorValue_1.createAuthenticationMethodConfigurationFromDiscriminatorValue); }, "description": (o, n) => { o.description = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "lastModifiedDateTime": (o, n) => { o.lastModifiedDateTime = n.getDateValue(); }, "policyVersion": (o, n) => { o.policyVersion = n.getStringValue(); }, "reconfirmationInDays": (o, n) => { o.reconfirmationInDays = n.getNumberValue(); }, "registrationEnforcement": (o, n) => { o.registrationEnforcement = n.getObjectValue(createRegistrationEnforcementFromDiscriminatorValue_1.createRegistrationEnforcementFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the lastModifiedDateTime property value. The date and time of the last update to the policy. Read-only.
     * @returns a Date
     */
    get lastModifiedDateTime() {
        return this._lastModifiedDateTime;
    }
    ;
    /**
     * Sets the lastModifiedDateTime property value. The date and time of the last update to the policy. Read-only.
     * @param value Value to set for the lastModifiedDateTime property.
     */
    set lastModifiedDateTime(value) {
        this._lastModifiedDateTime = value;
    }
    ;
    /**
     * Gets the policyVersion property value. The version of the policy in use. Read-only.
     * @returns a string
     */
    get policyVersion() {
        return this._policyVersion;
    }
    ;
    /**
     * Sets the policyVersion property value. The version of the policy in use. Read-only.
     * @param value Value to set for the policyVersion property.
     */
    set policyVersion(value) {
        this._policyVersion = value;
    }
    ;
    /**
     * Gets the reconfirmationInDays property value.
     * @returns a integer
     */
    get reconfirmationInDays() {
        return this._reconfirmationInDays;
    }
    ;
    /**
     * Sets the reconfirmationInDays property value.
     * @param value Value to set for the reconfirmationInDays property.
     */
    set reconfirmationInDays(value) {
        this._reconfirmationInDays = value;
    }
    ;
    /**
     * Gets the registrationEnforcement property value. Enforce registration at sign-in time. This property can be used to remind users to set up targeted authentication methods.
     * @returns a registrationEnforcement
     */
    get registrationEnforcement() {
        return this._registrationEnforcement;
    }
    ;
    /**
     * Sets the registrationEnforcement property value. Enforce registration at sign-in time. This property can be used to remind users to set up targeted authentication methods.
     * @param value Value to set for the registrationEnforcement property.
     */
    set registrationEnforcement(value) {
        this._registrationEnforcement = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("authenticationMethodConfigurations", this.authenticationMethodConfigurations);
        writer.writeStringValue("description", this.description);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeDateValue("lastModifiedDateTime", this.lastModifiedDateTime);
        writer.writeStringValue("policyVersion", this.policyVersion);
        writer.writeNumberValue("reconfirmationInDays", this.reconfirmationInDays);
        writer.writeObjectValue("registrationEnforcement", this.registrationEnforcement);
    }
    ;
}
exports.AuthenticationMethodsPolicy = AuthenticationMethodsPolicy;
