"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthoredNote = void 0;
const createIdentityFromDiscriminatorValue_1 = require("./createIdentityFromDiscriminatorValue");
const createItemBodyFromDiscriminatorValue_1 = require("./createItemBodyFromDiscriminatorValue");
const index_1 = require("./index");
class AuthoredNote extends index_1.Entity {
    /**
     * Instantiates a new authoredNote and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the author property value. Identity information about the note's author.
     * @returns a identity
     */
    get author() {
        return this._author;
    }
    ;
    /**
     * Sets the author property value. Identity information about the note's author.
     * @param value Value to set for the author property.
     */
    set author(value) {
        this._author = value;
    }
    ;
    ;
    /**
     * Gets the content property value. The content of the note.
     * @returns a itemBody
     */
    get content() {
        return this._content;
    }
    ;
    /**
     * Sets the content property value. The content of the note.
     * @param value Value to set for the content property.
     */
    set content(value) {
        this._content = value;
    }
    ;
    /**
     * Gets the createdDateTime property value. The date and time when the entity was created. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z.
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. The date and time when the entity was created. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "author": (o, n) => { o.author = n.getObjectValue(createIdentityFromDiscriminatorValue_1.createIdentityFromDiscriminatorValue); }, "content": (o, n) => { o.content = n.getObjectValue(createItemBodyFromDiscriminatorValue_1.createItemBodyFromDiscriminatorValue); }, "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("author", this.author);
        writer.writeObjectValue("content", this.content);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
    }
    ;
}
exports.AuthoredNote = AuthoredNote;
