"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthorizationPolicy = void 0;
const allowInvitesFrom_1 = require("./allowInvitesFrom");
const createDefaultUserRolePermissionsFromDiscriminatorValue_1 = require("./createDefaultUserRolePermissionsFromDiscriminatorValue");
const index_1 = require("./index");
class AuthorizationPolicy extends index_1.PolicyBase {
    /**
     * Instantiates a new authorizationPolicy and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the allowedToSignUpEmailBasedSubscriptions property value. Indicates whether users can sign up for email based subscriptions.
     * @returns a boolean
     */
    get allowedToSignUpEmailBasedSubscriptions() {
        return this._allowedToSignUpEmailBasedSubscriptions;
    }
    ;
    /**
     * Sets the allowedToSignUpEmailBasedSubscriptions property value. Indicates whether users can sign up for email based subscriptions.
     * @param value Value to set for the allowedToSignUpEmailBasedSubscriptions property.
     */
    set allowedToSignUpEmailBasedSubscriptions(value) {
        this._allowedToSignUpEmailBasedSubscriptions = value;
    }
    ;
    /**
     * Gets the allowedToUseSSPR property value. Indicates whether the Self-Serve Password Reset feature can be used by users on the tenant.
     * @returns a boolean
     */
    get allowedToUseSSPR() {
        return this._allowedToUseSSPR;
    }
    ;
    /**
     * Sets the allowedToUseSSPR property value. Indicates whether the Self-Serve Password Reset feature can be used by users on the tenant.
     * @param value Value to set for the allowedToUseSSPR property.
     */
    set allowedToUseSSPR(value) {
        this._allowedToUseSSPR = value;
    }
    ;
    /**
     * Gets the allowEmailVerifiedUsersToJoinOrganization property value. Indicates whether a user can join the tenant by email validation.
     * @returns a boolean
     */
    get allowEmailVerifiedUsersToJoinOrganization() {
        return this._allowEmailVerifiedUsersToJoinOrganization;
    }
    ;
    /**
     * Sets the allowEmailVerifiedUsersToJoinOrganization property value. Indicates whether a user can join the tenant by email validation.
     * @param value Value to set for the allowEmailVerifiedUsersToJoinOrganization property.
     */
    set allowEmailVerifiedUsersToJoinOrganization(value) {
        this._allowEmailVerifiedUsersToJoinOrganization = value;
    }
    ;
    /**
     * Gets the allowInvitesFrom property value. Indicates who can invite external users to the organization. Possible values are: none, adminsAndGuestInviters, adminsGuestInvitersAndAllMembers, everyone.  everyone is the default setting for all cloud environments except US Government. See more in the table below.
     * @returns a allowInvitesFrom
     */
    get allowInvitesFrom() {
        return this._allowInvitesFrom;
    }
    ;
    /**
     * Sets the allowInvitesFrom property value. Indicates who can invite external users to the organization. Possible values are: none, adminsAndGuestInviters, adminsGuestInvitersAndAllMembers, everyone.  everyone is the default setting for all cloud environments except US Government. See more in the table below.
     * @param value Value to set for the allowInvitesFrom property.
     */
    set allowInvitesFrom(value) {
        this._allowInvitesFrom = value;
    }
    ;
    /**
     * Gets the blockMsolPowerShell property value. To disable the use of MSOL PowerShell set this property to true. This will also disable user-based access to the legacy service endpoint used by MSOL PowerShell. This does not affect Azure AD Connect or Microsoft Graph.
     * @returns a boolean
     */
    get blockMsolPowerShell() {
        return this._blockMsolPowerShell;
    }
    ;
    /**
     * Sets the blockMsolPowerShell property value. To disable the use of MSOL PowerShell set this property to true. This will also disable user-based access to the legacy service endpoint used by MSOL PowerShell. This does not affect Azure AD Connect or Microsoft Graph.
     * @param value Value to set for the blockMsolPowerShell property.
     */
    set blockMsolPowerShell(value) {
        this._blockMsolPowerShell = value;
    }
    ;
    ;
    /**
     * Gets the defaultUserRolePermissions property value.
     * @returns a defaultUserRolePermissions
     */
    get defaultUserRolePermissions() {
        return this._defaultUserRolePermissions;
    }
    ;
    /**
     * Sets the defaultUserRolePermissions property value.
     * @param value Value to set for the defaultUserRolePermissions property.
     */
    set defaultUserRolePermissions(value) {
        this._defaultUserRolePermissions = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "allowedToSignUpEmailBasedSubscriptions": (o, n) => { o.allowedToSignUpEmailBasedSubscriptions = n.getBooleanValue(); }, "allowedToUseSSPR": (o, n) => { o.allowedToUseSSPR = n.getBooleanValue(); }, "allowEmailVerifiedUsersToJoinOrganization": (o, n) => { o.allowEmailVerifiedUsersToJoinOrganization = n.getBooleanValue(); }, "allowInvitesFrom": (o, n) => { o.allowInvitesFrom = n.getEnumValue(allowInvitesFrom_1.AllowInvitesFrom); }, "blockMsolPowerShell": (o, n) => { o.blockMsolPowerShell = n.getBooleanValue(); }, "defaultUserRolePermissions": (o, n) => { o.defaultUserRolePermissions = n.getObjectValue(createDefaultUserRolePermissionsFromDiscriminatorValue_1.createDefaultUserRolePermissionsFromDiscriminatorValue); }, "guestUserRoleId": (o, n) => { o.guestUserRoleId = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the guestUserRoleId property value. Represents role templateId for the role that should be granted to guest user. Currently following roles are supported:  User (a0b1b346-4d3e-4e8b-98f8-753987be4970), Guest User (10dae51f-b6af-4016-8d66-8c2a99b929b3), and Restricted Guest User (2af84b1e-32c8-42b7-82bc-daa82404023b).
     * @returns a string
     */
    get guestUserRoleId() {
        return this._guestUserRoleId;
    }
    ;
    /**
     * Sets the guestUserRoleId property value. Represents role templateId for the role that should be granted to guest user. Currently following roles are supported:  User (a0b1b346-4d3e-4e8b-98f8-753987be4970), Guest User (10dae51f-b6af-4016-8d66-8c2a99b929b3), and Restricted Guest User (2af84b1e-32c8-42b7-82bc-daa82404023b).
     * @param value Value to set for the guestUserRoleId property.
     */
    set guestUserRoleId(value) {
        this._guestUserRoleId = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeBooleanValue("allowedToSignUpEmailBasedSubscriptions", this.allowedToSignUpEmailBasedSubscriptions);
        writer.writeBooleanValue("allowedToUseSSPR", this.allowedToUseSSPR);
        writer.writeBooleanValue("allowEmailVerifiedUsersToJoinOrganization", this.allowEmailVerifiedUsersToJoinOrganization);
        writer.writeEnumValue("allowInvitesFrom", this.allowInvitesFrom);
        writer.writeBooleanValue("blockMsolPowerShell", this.blockMsolPowerShell);
        writer.writeObjectValue("defaultUserRolePermissions", this.defaultUserRolePermissions);
        writer.writeStringValue("guestUserRoleId", this.guestUserRoleId);
    }
    ;
}
exports.AuthorizationPolicy = AuthorizationPolicy;
