"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AutomaticRepliesMailTips = void 0;
const createDateTimeTimeZoneFromDiscriminatorValue_1 = require("./createDateTimeTimeZoneFromDiscriminatorValue");
const createLocaleInfoFromDiscriminatorValue_1 = require("./createLocaleInfoFromDiscriminatorValue");
class AutomaticRepliesMailTips {
    /**
     * Instantiates a new automaticRepliesMailTips and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "message": (o, n) => { o.message = n.getStringValue(); },
            "messageLanguage": (o, n) => { o.messageLanguage = n.getObjectValue(createLocaleInfoFromDiscriminatorValue_1.createLocaleInfoFromDiscriminatorValue); },
            "scheduledEndTime": (o, n) => { o.scheduledEndTime = n.getObjectValue(createDateTimeTimeZoneFromDiscriminatorValue_1.createDateTimeTimeZoneFromDiscriminatorValue); },
            "scheduledStartTime": (o, n) => { o.scheduledStartTime = n.getObjectValue(createDateTimeTimeZoneFromDiscriminatorValue_1.createDateTimeTimeZoneFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the message property value. The automatic reply message.
     * @returns a string
     */
    get message() {
        return this._message;
    }
    ;
    /**
     * Sets the message property value. The automatic reply message.
     * @param value Value to set for the message property.
     */
    set message(value) {
        this._message = value;
    }
    ;
    /**
     * Gets the messageLanguage property value. The language that the automatic reply message is in.
     * @returns a localeInfo
     */
    get messageLanguage() {
        return this._messageLanguage;
    }
    ;
    /**
     * Sets the messageLanguage property value. The language that the automatic reply message is in.
     * @param value Value to set for the messageLanguage property.
     */
    set messageLanguage(value) {
        this._messageLanguage = value;
    }
    ;
    /**
     * Gets the scheduledEndTime property value. The date and time that automatic replies are set to end.
     * @returns a dateTimeTimeZone
     */
    get scheduledEndTime() {
        return this._scheduledEndTime;
    }
    ;
    /**
     * Sets the scheduledEndTime property value. The date and time that automatic replies are set to end.
     * @param value Value to set for the scheduledEndTime property.
     */
    set scheduledEndTime(value) {
        this._scheduledEndTime = value;
    }
    ;
    /**
     * Gets the scheduledStartTime property value. The date and time that automatic replies are set to begin.
     * @returns a dateTimeTimeZone
     */
    get scheduledStartTime() {
        return this._scheduledStartTime;
    }
    ;
    /**
     * Sets the scheduledStartTime property value. The date and time that automatic replies are set to begin.
     * @param value Value to set for the scheduledStartTime property.
     */
    set scheduledStartTime(value) {
        this._scheduledStartTime = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("message", this.message);
        writer.writeObjectValue("messageLanguage", this.messageLanguage);
        writer.writeObjectValue("scheduledEndTime", this.scheduledEndTime);
        writer.writeObjectValue("scheduledStartTime", this.scheduledStartTime);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.AutomaticRepliesMailTips = AutomaticRepliesMailTips;
