"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AutomaticRepliesSetting = void 0;
const automaticRepliesStatus_1 = require("./automaticRepliesStatus");
const createDateTimeTimeZoneFromDiscriminatorValue_1 = require("./createDateTimeTimeZoneFromDiscriminatorValue");
const externalAudienceScope_1 = require("./externalAudienceScope");
class AutomaticRepliesSetting {
    /**
     * Instantiates a new automaticRepliesSetting and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the externalAudience property value. The set of audience external to the signed-in user's organization who will receive the ExternalReplyMessage, if Status is AlwaysEnabled or Scheduled. The possible values are: none, contactsOnly, all.
     * @returns a externalAudienceScope
     */
    get externalAudience() {
        return this._externalAudience;
    }
    ;
    /**
     * Sets the externalAudience property value. The set of audience external to the signed-in user's organization who will receive the ExternalReplyMessage, if Status is AlwaysEnabled or Scheduled. The possible values are: none, contactsOnly, all.
     * @param value Value to set for the externalAudience property.
     */
    set externalAudience(value) {
        this._externalAudience = value;
    }
    ;
    /**
     * Gets the externalReplyMessage property value. The automatic reply to send to the specified external audience, if Status is AlwaysEnabled or Scheduled.
     * @returns a string
     */
    get externalReplyMessage() {
        return this._externalReplyMessage;
    }
    ;
    /**
     * Sets the externalReplyMessage property value. The automatic reply to send to the specified external audience, if Status is AlwaysEnabled or Scheduled.
     * @param value Value to set for the externalReplyMessage property.
     */
    set externalReplyMessage(value) {
        this._externalReplyMessage = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "externalAudience": (o, n) => { o.externalAudience = n.getEnumValue(externalAudienceScope_1.ExternalAudienceScope); },
            "externalReplyMessage": (o, n) => { o.externalReplyMessage = n.getStringValue(); },
            "internalReplyMessage": (o, n) => { o.internalReplyMessage = n.getStringValue(); },
            "scheduledEndDateTime": (o, n) => { o.scheduledEndDateTime = n.getObjectValue(createDateTimeTimeZoneFromDiscriminatorValue_1.createDateTimeTimeZoneFromDiscriminatorValue); },
            "scheduledStartDateTime": (o, n) => { o.scheduledStartDateTime = n.getObjectValue(createDateTimeTimeZoneFromDiscriminatorValue_1.createDateTimeTimeZoneFromDiscriminatorValue); },
            "status": (o, n) => { o.status = n.getEnumValue(automaticRepliesStatus_1.AutomaticRepliesStatus); },
        };
    }
    ;
    /**
     * Gets the internalReplyMessage property value. The automatic reply to send to the audience internal to the signed-in user's organization, if Status is AlwaysEnabled or Scheduled.
     * @returns a string
     */
    get internalReplyMessage() {
        return this._internalReplyMessage;
    }
    ;
    /**
     * Sets the internalReplyMessage property value. The automatic reply to send to the audience internal to the signed-in user's organization, if Status is AlwaysEnabled or Scheduled.
     * @param value Value to set for the internalReplyMessage property.
     */
    set internalReplyMessage(value) {
        this._internalReplyMessage = value;
    }
    ;
    /**
     * Gets the scheduledEndDateTime property value. The date and time that automatic replies are set to end, if Status is set to Scheduled.
     * @returns a dateTimeTimeZone
     */
    get scheduledEndDateTime() {
        return this._scheduledEndDateTime;
    }
    ;
    /**
     * Sets the scheduledEndDateTime property value. The date and time that automatic replies are set to end, if Status is set to Scheduled.
     * @param value Value to set for the scheduledEndDateTime property.
     */
    set scheduledEndDateTime(value) {
        this._scheduledEndDateTime = value;
    }
    ;
    /**
     * Gets the scheduledStartDateTime property value. The date and time that automatic replies are set to begin, if Status is set to Scheduled.
     * @returns a dateTimeTimeZone
     */
    get scheduledStartDateTime() {
        return this._scheduledStartDateTime;
    }
    ;
    /**
     * Sets the scheduledStartDateTime property value. The date and time that automatic replies are set to begin, if Status is set to Scheduled.
     * @param value Value to set for the scheduledStartDateTime property.
     */
    set scheduledStartDateTime(value) {
        this._scheduledStartDateTime = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeEnumValue("externalAudience", this.externalAudience);
        writer.writeStringValue("externalReplyMessage", this.externalReplyMessage);
        writer.writeStringValue("internalReplyMessage", this.internalReplyMessage);
        writer.writeObjectValue("scheduledEndDateTime", this.scheduledEndDateTime);
        writer.writeObjectValue("scheduledStartDateTime", this.scheduledStartDateTime);
        writer.writeEnumValue("status", this.status);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the status property value. Configurations status for automatic replies. The possible values are: disabled, alwaysEnabled, scheduled.
     * @returns a automaticRepliesStatus
     */
    get status() {
        return this._status;
    }
    ;
    /**
     * Sets the status property value. Configurations status for automatic replies. The possible values are: disabled, alwaysEnabled, scheduled.
     * @param value Value to set for the status property.
     */
    set status(value) {
        this._status = value;
    }
    ;
}
exports.AutomaticRepliesSetting = AutomaticRepliesSetting;
