"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseItemVersion = void 0;
const createIdentitySetFromDiscriminatorValue_1 = require("./createIdentitySetFromDiscriminatorValue");
const createPublicationFacetFromDiscriminatorValue_1 = require("./createPublicationFacetFromDiscriminatorValue");
const index_1 = require("./index");
class BaseItemVersion extends index_1.Entity {
    /**
     * Instantiates a new baseItemVersion and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "lastModifiedBy": (o, n) => { o.lastModifiedBy = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); }, "lastModifiedDateTime": (o, n) => { o.lastModifiedDateTime = n.getDateValue(); }, "publication": (o, n) => { o.publication = n.getObjectValue(createPublicationFacetFromDiscriminatorValue_1.createPublicationFacetFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the lastModifiedBy property value. Identity of the user which last modified the version. Read-only.
     * @returns a identitySet
     */
    get lastModifiedBy() {
        return this._lastModifiedBy;
    }
    ;
    /**
     * Sets the lastModifiedBy property value. Identity of the user which last modified the version. Read-only.
     * @param value Value to set for the lastModifiedBy property.
     */
    set lastModifiedBy(value) {
        this._lastModifiedBy = value;
    }
    ;
    /**
     * Gets the lastModifiedDateTime property value. Date and time the version was last modified. Read-only.
     * @returns a Date
     */
    get lastModifiedDateTime() {
        return this._lastModifiedDateTime;
    }
    ;
    /**
     * Sets the lastModifiedDateTime property value. Date and time the version was last modified. Read-only.
     * @param value Value to set for the lastModifiedDateTime property.
     */
    set lastModifiedDateTime(value) {
        this._lastModifiedDateTime = value;
    }
    ;
    /**
     * Gets the publication property value. Indicates the publication status of this particular version. Read-only.
     * @returns a publicationFacet
     */
    get publication() {
        return this._publication;
    }
    ;
    /**
     * Sets the publication property value. Indicates the publication status of this particular version. Read-only.
     * @param value Value to set for the publication property.
     */
    set publication(value) {
        this._publication = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("lastModifiedBy", this.lastModifiedBy);
        writer.writeDateValue("lastModifiedDateTime", this.lastModifiedDateTime);
        writer.writeObjectValue("publication", this.publication);
    }
    ;
}
exports.BaseItemVersion = BaseItemVersion;
