"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BookingCurrency = void 0;
const index_1 = require("./index");
class BookingCurrency extends index_1.Entity {
    /**
     * Instantiates a new bookingCurrency and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "symbol": (o, n) => { o.symbol = n.getStringValue(); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("symbol", this.symbol);
    }
    ;
    /**
     * Gets the symbol property value. The currency symbol. For example, the currency symbol for the US dollar and for the Australian dollar is $.
     * @returns a string
     */
    get symbol() {
        return this._symbol;
    }
    ;
    /**
     * Sets the symbol property value. The currency symbol. For example, the currency symbol for the US dollar and for the Australian dollar is $.
     * @param value Value to set for the symbol property.
     */
    set symbol(value) {
        this._symbol = value;
    }
    ;
}
exports.BookingCurrency = BookingCurrency;
