"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BookingCustomQuestion = void 0;
const answerInputType_1 = require("./answerInputType");
const index_1 = require("./index");
class BookingCustomQuestion extends index_1.Entity {
    /**
     * Instantiates a new bookingCustomQuestion and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the answerInputType property value. The expected answer type. The possible values are: text, radioButton, unknownFutureValue.
     * @returns a answerInputType
     */
    get answerInputType() {
        return this._answerInputType;
    }
    ;
    /**
     * Sets the answerInputType property value. The expected answer type. The possible values are: text, radioButton, unknownFutureValue.
     * @param value Value to set for the answerInputType property.
     */
    set answerInputType(value) {
        this._answerInputType = value;
    }
    ;
    /**
     * Gets the answerOptions property value. List of possible answer values.
     * @returns a string
     */
    get answerOptions() {
        return this._answerOptions;
    }
    ;
    /**
     * Sets the answerOptions property value. List of possible answer values.
     * @param value Value to set for the answerOptions property.
     */
    set answerOptions(value) {
        this._answerOptions = value;
    }
    ;
    ;
    /**
     * Gets the displayName property value. Display name of this entity.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. Display name of this entity.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "answerInputType": (o, n) => { o.answerInputType = n.getEnumValue(answerInputType_1.AnswerInputType); }, "answerOptions": (o, n) => { o.answerOptions = n.getCollectionOfPrimitiveValues(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeEnumValue("answerInputType", this.answerInputType);
        writer.writeCollectionOfPrimitiveValues("answerOptions", this.answerOptions);
        writer.writeStringValue("displayName", this.displayName);
    }
    ;
}
exports.BookingCustomQuestion = BookingCustomQuestion;
