import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class BookingQuestionAssignment implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** The ID of the custom question.  */
    private _isRequired?;
    /** Indicates whether it is mandatory to answer the custom question.  */
    private _questionId?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new bookingQuestionAssignment and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the isRequired property value. The ID of the custom question.
     * @returns a boolean
     */
    get isRequired(): boolean | undefined;
    /**
     * Sets the isRequired property value. The ID of the custom question.
     * @param value Value to set for the isRequired property.
     */
    set isRequired(value: boolean | undefined);
    /**
     * Gets the questionId property value. Indicates whether it is mandatory to answer the custom question.
     * @returns a string
     */
    get questionId(): string | undefined;
    /**
     * Sets the questionId property value. Indicates whether it is mandatory to answer the custom question.
     * @param value Value to set for the questionId property.
     */
    set questionId(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
