import { BookingReminderRecipients } from './bookingReminderRecipients';
import { AdditionalDataHolder, Duration, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** This type represents when and to whom to send an e-mail reminder.  */
export declare class BookingReminder implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** The message in the reminder.  */
    private _message?;
    /** The amount of time before the start of an appointment that the reminder should be sent. It's denoted in ISO 8601 format.  */
    private _offset?;
    /** The persons who should receive the reminder. Possible values are: allAttendees, staff, customer, unknownFutureValue.  */
    private _recipients?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new bookingReminder and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the message property value. The message in the reminder.
     * @returns a string
     */
    get message(): string | undefined;
    /**
     * Sets the message property value. The message in the reminder.
     * @param value Value to set for the message property.
     */
    set message(value: string | undefined);
    /**
     * Gets the offset property value. The amount of time before the start of an appointment that the reminder should be sent. It's denoted in ISO 8601 format.
     * @returns a Duration
     */
    get offset(): Duration | undefined;
    /**
     * Sets the offset property value. The amount of time before the start of an appointment that the reminder should be sent. It's denoted in ISO 8601 format.
     * @param value Value to set for the offset property.
     */
    set offset(value: Duration | undefined);
    /**
     * Gets the recipients property value. The persons who should receive the reminder. Possible values are: allAttendees, staff, customer, unknownFutureValue.
     * @returns a bookingReminderRecipients
     */
    get recipients(): BookingReminderRecipients | undefined;
    /**
     * Sets the recipients property value. The persons who should receive the reminder. Possible values are: allAttendees, staff, customer, unknownFutureValue.
     * @param value Value to set for the recipients property.
     */
    set recipients(value: BookingReminderRecipients | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
