"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BookingService = void 0;
const bookingPriceType_1 = require("./bookingPriceType");
const createBookingQuestionAssignmentFromDiscriminatorValue_1 = require("./createBookingQuestionAssignmentFromDiscriminatorValue");
const createBookingReminderFromDiscriminatorValue_1 = require("./createBookingReminderFromDiscriminatorValue");
const createBookingSchedulingPolicyFromDiscriminatorValue_1 = require("./createBookingSchedulingPolicyFromDiscriminatorValue");
const createLocationFromDiscriminatorValue_1 = require("./createLocationFromDiscriminatorValue");
const index_1 = require("./index");
class BookingService extends index_1.Entity {
    /**
     * Instantiates a new bookingService and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the additionalInformation property value. Additional information that is sent to the customer when an appointment is confirmed.
     * @returns a string
     */
    get additionalInformation() {
        return this._additionalInformation;
    }
    ;
    /**
     * Sets the additionalInformation property value. Additional information that is sent to the customer when an appointment is confirmed.
     * @param value Value to set for the additionalInformation property.
     */
    set additionalInformation(value) {
        this._additionalInformation = value;
    }
    ;
    ;
    /**
     * Gets the customQuestions property value. Contains the set of custom questions associated with a particular service.
     * @returns a bookingQuestionAssignment
     */
    get customQuestions() {
        return this._customQuestions;
    }
    ;
    /**
     * Sets the customQuestions property value. Contains the set of custom questions associated with a particular service.
     * @param value Value to set for the customQuestions property.
     */
    set customQuestions(value) {
        this._customQuestions = value;
    }
    ;
    /**
     * Gets the defaultDuration property value. The default length of the service, represented in numbers of days, hours, minutes, and seconds. For example, P11D23H59M59.999999999999S.
     * @returns a Duration
     */
    get defaultDuration() {
        return this._defaultDuration;
    }
    ;
    /**
     * Sets the defaultDuration property value. The default length of the service, represented in numbers of days, hours, minutes, and seconds. For example, P11D23H59M59.999999999999S.
     * @param value Value to set for the defaultDuration property.
     */
    set defaultDuration(value) {
        this._defaultDuration = value;
    }
    ;
    /**
     * Gets the defaultLocation property value. The default physical location for the service.
     * @returns a location
     */
    get defaultLocation() {
        return this._defaultLocation;
    }
    ;
    /**
     * Sets the defaultLocation property value. The default physical location for the service.
     * @param value Value to set for the defaultLocation property.
     */
    set defaultLocation(value) {
        this._defaultLocation = value;
    }
    ;
    /**
     * Gets the defaultPrice property value. The default monetary price for the service.
     * @returns a double
     */
    get defaultPrice() {
        return this._defaultPrice;
    }
    ;
    /**
     * Sets the defaultPrice property value. The default monetary price for the service.
     * @param value Value to set for the defaultPrice property.
     */
    set defaultPrice(value) {
        this._defaultPrice = value;
    }
    ;
    /**
     * Gets the defaultPriceType property value. The default way the service is charged. Possible values are: undefined, fixedPrice, startingAt, hourly, free, priceVaries, callUs, notSet, unknownFutureValue.
     * @returns a bookingPriceType
     */
    get defaultPriceType() {
        return this._defaultPriceType;
    }
    ;
    /**
     * Sets the defaultPriceType property value. The default way the service is charged. Possible values are: undefined, fixedPrice, startingAt, hourly, free, priceVaries, callUs, notSet, unknownFutureValue.
     * @param value Value to set for the defaultPriceType property.
     */
    set defaultPriceType(value) {
        this._defaultPriceType = value;
    }
    ;
    /**
     * Gets the defaultReminders property value. The default set of reminders for an appointment of this service. The value of this property is available only when reading this bookingService by its ID.
     * @returns a bookingReminder
     */
    get defaultReminders() {
        return this._defaultReminders;
    }
    ;
    /**
     * Sets the defaultReminders property value. The default set of reminders for an appointment of this service. The value of this property is available only when reading this bookingService by its ID.
     * @param value Value to set for the defaultReminders property.
     */
    set defaultReminders(value) {
        this._defaultReminders = value;
    }
    ;
    /**
     * Gets the description property value. A text description for the service.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. A text description for the service.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the displayName property value. A service name.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. A service name.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "additionalInformation": (o, n) => { o.additionalInformation = n.getStringValue(); }, "customQuestions": (o, n) => { o.customQuestions = n.getCollectionOfObjectValues(createBookingQuestionAssignmentFromDiscriminatorValue_1.createBookingQuestionAssignmentFromDiscriminatorValue); }, "defaultDuration": (o, n) => { o.defaultDuration = n.getDurationValue(); }, "defaultLocation": (o, n) => { o.defaultLocation = n.getObjectValue(createLocationFromDiscriminatorValue_1.createLocationFromDiscriminatorValue); }, "defaultPrice": (o, n) => { o.defaultPrice = n.getNumberValue(); }, "defaultPriceType": (o, n) => { o.defaultPriceType = n.getEnumValue(bookingPriceType_1.BookingPriceType); }, "defaultReminders": (o, n) => { o.defaultReminders = n.getCollectionOfObjectValues(createBookingReminderFromDiscriminatorValue_1.createBookingReminderFromDiscriminatorValue); }, "description": (o, n) => { o.description = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "isHiddenFromCustomers": (o, n) => { o.isHiddenFromCustomers = n.getBooleanValue(); }, "isLocationOnline": (o, n) => { o.isLocationOnline = n.getBooleanValue(); }, "maximumAttendeesCount": (o, n) => { o.maximumAttendeesCount = n.getNumberValue(); }, "notes": (o, n) => { o.notes = n.getStringValue(); }, "postBuffer": (o, n) => { o.postBuffer = n.getDurationValue(); }, "preBuffer": (o, n) => { o.preBuffer = n.getDurationValue(); }, "schedulingPolicy": (o, n) => { o.schedulingPolicy = n.getObjectValue(createBookingSchedulingPolicyFromDiscriminatorValue_1.createBookingSchedulingPolicyFromDiscriminatorValue); }, "smsNotificationsEnabled": (o, n) => { o.smsNotificationsEnabled = n.getBooleanValue(); }, "staffMemberIds": (o, n) => { o.staffMemberIds = n.getCollectionOfPrimitiveValues(); }, "webUrl": (o, n) => { o.webUrl = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the isHiddenFromCustomers property value. True means this service is not available to customers for booking.
     * @returns a boolean
     */
    get isHiddenFromCustomers() {
        return this._isHiddenFromCustomers;
    }
    ;
    /**
     * Sets the isHiddenFromCustomers property value. True means this service is not available to customers for booking.
     * @param value Value to set for the isHiddenFromCustomers property.
     */
    set isHiddenFromCustomers(value) {
        this._isHiddenFromCustomers = value;
    }
    ;
    /**
     * Gets the isLocationOnline property value. True indicates that the appointments for the service will be held online. Default value is false.
     * @returns a boolean
     */
    get isLocationOnline() {
        return this._isLocationOnline;
    }
    ;
    /**
     * Sets the isLocationOnline property value. True indicates that the appointments for the service will be held online. Default value is false.
     * @param value Value to set for the isLocationOnline property.
     */
    set isLocationOnline(value) {
        this._isLocationOnline = value;
    }
    ;
    /**
     * Gets the maximumAttendeesCount property value. The maximum number of customers allowed in a service. If maximumAttendeesCount of the service is greater than 1, pass valid customer IDs while creating or updating an appointment. To create a customer, use the Create bookingCustomer operation.
     * @returns a integer
     */
    get maximumAttendeesCount() {
        return this._maximumAttendeesCount;
    }
    ;
    /**
     * Sets the maximumAttendeesCount property value. The maximum number of customers allowed in a service. If maximumAttendeesCount of the service is greater than 1, pass valid customer IDs while creating or updating an appointment. To create a customer, use the Create bookingCustomer operation.
     * @param value Value to set for the maximumAttendeesCount property.
     */
    set maximumAttendeesCount(value) {
        this._maximumAttendeesCount = value;
    }
    ;
    /**
     * Gets the notes property value. Additional information about this service.
     * @returns a string
     */
    get notes() {
        return this._notes;
    }
    ;
    /**
     * Sets the notes property value. Additional information about this service.
     * @param value Value to set for the notes property.
     */
    set notes(value) {
        this._notes = value;
    }
    ;
    /**
     * Gets the postBuffer property value. The time to buffer after an appointment for this service ends, and before the next customer appointment can be booked.
     * @returns a Duration
     */
    get postBuffer() {
        return this._postBuffer;
    }
    ;
    /**
     * Sets the postBuffer property value. The time to buffer after an appointment for this service ends, and before the next customer appointment can be booked.
     * @param value Value to set for the postBuffer property.
     */
    set postBuffer(value) {
        this._postBuffer = value;
    }
    ;
    /**
     * Gets the preBuffer property value. The time to buffer before an appointment for this service can start.
     * @returns a Duration
     */
    get preBuffer() {
        return this._preBuffer;
    }
    ;
    /**
     * Sets the preBuffer property value. The time to buffer before an appointment for this service can start.
     * @param value Value to set for the preBuffer property.
     */
    set preBuffer(value) {
        this._preBuffer = value;
    }
    ;
    /**
     * Gets the schedulingPolicy property value. The set of policies that determine how appointments for this type of service should be created and managed.
     * @returns a bookingSchedulingPolicy
     */
    get schedulingPolicy() {
        return this._schedulingPolicy;
    }
    ;
    /**
     * Sets the schedulingPolicy property value. The set of policies that determine how appointments for this type of service should be created and managed.
     * @param value Value to set for the schedulingPolicy property.
     */
    set schedulingPolicy(value) {
        this._schedulingPolicy = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("additionalInformation", this.additionalInformation);
        writer.writeCollectionOfObjectValues("customQuestions", this.customQuestions);
        writer.writeDurationValue("defaultDuration", this.defaultDuration);
        writer.writeObjectValue("defaultLocation", this.defaultLocation);
        writer.writeNumberValue("defaultPrice", this.defaultPrice);
        writer.writeEnumValue("defaultPriceType", this.defaultPriceType);
        writer.writeCollectionOfObjectValues("defaultReminders", this.defaultReminders);
        writer.writeStringValue("description", this.description);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeBooleanValue("isHiddenFromCustomers", this.isHiddenFromCustomers);
        writer.writeBooleanValue("isLocationOnline", this.isLocationOnline);
        writer.writeNumberValue("maximumAttendeesCount", this.maximumAttendeesCount);
        writer.writeStringValue("notes", this.notes);
        writer.writeDurationValue("postBuffer", this.postBuffer);
        writer.writeDurationValue("preBuffer", this.preBuffer);
        writer.writeObjectValue("schedulingPolicy", this.schedulingPolicy);
        writer.writeBooleanValue("smsNotificationsEnabled", this.smsNotificationsEnabled);
        writer.writeCollectionOfPrimitiveValues("staffMemberIds", this.staffMemberIds);
        writer.writeStringValue("webUrl", this.webUrl);
    }
    ;
    /**
     * Gets the smsNotificationsEnabled property value. True indicates SMS notifications can be sent to the customers for the appointment of the service. Default value is false.
     * @returns a boolean
     */
    get smsNotificationsEnabled() {
        return this._smsNotificationsEnabled;
    }
    ;
    /**
     * Sets the smsNotificationsEnabled property value. True indicates SMS notifications can be sent to the customers for the appointment of the service. Default value is false.
     * @param value Value to set for the smsNotificationsEnabled property.
     */
    set smsNotificationsEnabled(value) {
        this._smsNotificationsEnabled = value;
    }
    ;
    /**
     * Gets the staffMemberIds property value. Represents those staff members who provide this service.
     * @returns a string
     */
    get staffMemberIds() {
        return this._staffMemberIds;
    }
    ;
    /**
     * Sets the staffMemberIds property value. Represents those staff members who provide this service.
     * @param value Value to set for the staffMemberIds property.
     */
    set staffMemberIds(value) {
        this._staffMemberIds = value;
    }
    ;
    /**
     * Gets the webUrl property value. The URL a customer uses to access the service.
     * @returns a string
     */
    get webUrl() {
        return this._webUrl;
    }
    ;
    /**
     * Sets the webUrl property value. The URL a customer uses to access the service.
     * @param value Value to set for the webUrl property.
     */
    set webUrl(value) {
        this._webUrl = value;
    }
    ;
}
exports.BookingService = BookingService;
