"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BookingWorkHours = void 0;
const createBookingWorkTimeSlotFromDiscriminatorValue_1 = require("./createBookingWorkTimeSlotFromDiscriminatorValue");
const dayOfWeek_1 = require("./dayOfWeek");
/** This type represents the set of working hours in a single day of the week.  */
class BookingWorkHours {
    /**
     * Instantiates a new bookingWorkHours and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the day property value. The day of the week represented by this instance. Possible values are: sunday, monday, tuesday, wednesday, thursday, friday, saturday.
     * @returns a dayOfWeek
     */
    get day() {
        return this._day;
    }
    ;
    /**
     * Sets the day property value. The day of the week represented by this instance. Possible values are: sunday, monday, tuesday, wednesday, thursday, friday, saturday.
     * @param value Value to set for the day property.
     */
    set day(value) {
        this._day = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "day": (o, n) => { o.day = n.getEnumValue(dayOfWeek_1.DayOfWeek); },
            "timeSlots": (o, n) => { o.timeSlots = n.getCollectionOfObjectValues(createBookingWorkTimeSlotFromDiscriminatorValue_1.createBookingWorkTimeSlotFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeEnumValue("day", this.day);
        writer.writeCollectionOfObjectValues("timeSlots", this.timeSlots);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the timeSlots property value. A list of start/end times during a day.
     * @returns a bookingWorkTimeSlot
     */
    get timeSlots() {
        return this._timeSlots;
    }
    ;
    /**
     * Sets the timeSlots property value. A list of start/end times during a day.
     * @param value Value to set for the timeSlots property.
     */
    set timeSlots(value) {
        this._timeSlots = value;
    }
    ;
}
exports.BookingWorkHours = BookingWorkHours;
