import { BroadcastMeetingAudience } from './broadcastMeetingAudience';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class BroadcastMeetingSettings implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Defines who can join the Teams live event. Possible values are listed in the following table.  */
    private _allowedAudience?;
    /** Indicates whether attendee report is enabled for this Teams live event. Default value is false.  */
    private _isAttendeeReportEnabled?;
    /** Indicates whether Q&A is enabled for this Teams live event. Default value is false.  */
    private _isQuestionAndAnswerEnabled?;
    /** Indicates whether recording is enabled for this Teams live event. Default value is false.  */
    private _isRecordingEnabled?;
    /** Indicates whether video on demand is enabled for this Teams live event. Default value is false.  */
    private _isVideoOnDemandEnabled?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the allowedAudience property value. Defines who can join the Teams live event. Possible values are listed in the following table.
     * @returns a broadcastMeetingAudience
     */
    get allowedAudience(): BroadcastMeetingAudience | undefined;
    /**
     * Sets the allowedAudience property value. Defines who can join the Teams live event. Possible values are listed in the following table.
     * @param value Value to set for the allowedAudience property.
     */
    set allowedAudience(value: BroadcastMeetingAudience | undefined);
    /**
     * Instantiates a new broadcastMeetingSettings and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the isAttendeeReportEnabled property value. Indicates whether attendee report is enabled for this Teams live event. Default value is false.
     * @returns a boolean
     */
    get isAttendeeReportEnabled(): boolean | undefined;
    /**
     * Sets the isAttendeeReportEnabled property value. Indicates whether attendee report is enabled for this Teams live event. Default value is false.
     * @param value Value to set for the isAttendeeReportEnabled property.
     */
    set isAttendeeReportEnabled(value: boolean | undefined);
    /**
     * Gets the isQuestionAndAnswerEnabled property value. Indicates whether Q&A is enabled for this Teams live event. Default value is false.
     * @returns a boolean
     */
    get isQuestionAndAnswerEnabled(): boolean | undefined;
    /**
     * Sets the isQuestionAndAnswerEnabled property value. Indicates whether Q&A is enabled for this Teams live event. Default value is false.
     * @param value Value to set for the isQuestionAndAnswerEnabled property.
     */
    set isQuestionAndAnswerEnabled(value: boolean | undefined);
    /**
     * Gets the isRecordingEnabled property value. Indicates whether recording is enabled for this Teams live event. Default value is false.
     * @returns a boolean
     */
    get isRecordingEnabled(): boolean | undefined;
    /**
     * Sets the isRecordingEnabled property value. Indicates whether recording is enabled for this Teams live event. Default value is false.
     * @param value Value to set for the isRecordingEnabled property.
     */
    set isRecordingEnabled(value: boolean | undefined);
    /**
     * Gets the isVideoOnDemandEnabled property value. Indicates whether video on demand is enabled for this Teams live event. Default value is false.
     * @returns a boolean
     */
    get isVideoOnDemandEnabled(): boolean | undefined;
    /**
     * Sets the isVideoOnDemandEnabled property value. Indicates whether video on demand is enabled for this Teams live event. Default value is false.
     * @param value Value to set for the isVideoOnDemandEnabled property.
     */
    set isVideoOnDemandEnabled(value: boolean | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
