"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BroadcastMeetingSettings = void 0;
const broadcastMeetingAudience_1 = require("./broadcastMeetingAudience");
class BroadcastMeetingSettings {
    /**
     * Instantiates a new broadcastMeetingSettings and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the allowedAudience property value. Defines who can join the Teams live event. Possible values are listed in the following table.
     * @returns a broadcastMeetingAudience
     */
    get allowedAudience() {
        return this._allowedAudience;
    }
    ;
    /**
     * Sets the allowedAudience property value. Defines who can join the Teams live event. Possible values are listed in the following table.
     * @param value Value to set for the allowedAudience property.
     */
    set allowedAudience(value) {
        this._allowedAudience = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "allowedAudience": (o, n) => { o.allowedAudience = n.getEnumValue(broadcastMeetingAudience_1.BroadcastMeetingAudience); },
            "isAttendeeReportEnabled": (o, n) => { o.isAttendeeReportEnabled = n.getBooleanValue(); },
            "isQuestionAndAnswerEnabled": (o, n) => { o.isQuestionAndAnswerEnabled = n.getBooleanValue(); },
            "isRecordingEnabled": (o, n) => { o.isRecordingEnabled = n.getBooleanValue(); },
            "isVideoOnDemandEnabled": (o, n) => { o.isVideoOnDemandEnabled = n.getBooleanValue(); },
        };
    }
    ;
    /**
     * Gets the isAttendeeReportEnabled property value. Indicates whether attendee report is enabled for this Teams live event. Default value is false.
     * @returns a boolean
     */
    get isAttendeeReportEnabled() {
        return this._isAttendeeReportEnabled;
    }
    ;
    /**
     * Sets the isAttendeeReportEnabled property value. Indicates whether attendee report is enabled for this Teams live event. Default value is false.
     * @param value Value to set for the isAttendeeReportEnabled property.
     */
    set isAttendeeReportEnabled(value) {
        this._isAttendeeReportEnabled = value;
    }
    ;
    /**
     * Gets the isQuestionAndAnswerEnabled property value. Indicates whether Q&A is enabled for this Teams live event. Default value is false.
     * @returns a boolean
     */
    get isQuestionAndAnswerEnabled() {
        return this._isQuestionAndAnswerEnabled;
    }
    ;
    /**
     * Sets the isQuestionAndAnswerEnabled property value. Indicates whether Q&A is enabled for this Teams live event. Default value is false.
     * @param value Value to set for the isQuestionAndAnswerEnabled property.
     */
    set isQuestionAndAnswerEnabled(value) {
        this._isQuestionAndAnswerEnabled = value;
    }
    ;
    /**
     * Gets the isRecordingEnabled property value. Indicates whether recording is enabled for this Teams live event. Default value is false.
     * @returns a boolean
     */
    get isRecordingEnabled() {
        return this._isRecordingEnabled;
    }
    ;
    /**
     * Sets the isRecordingEnabled property value. Indicates whether recording is enabled for this Teams live event. Default value is false.
     * @param value Value to set for the isRecordingEnabled property.
     */
    set isRecordingEnabled(value) {
        this._isRecordingEnabled = value;
    }
    ;
    /**
     * Gets the isVideoOnDemandEnabled property value. Indicates whether video on demand is enabled for this Teams live event. Default value is false.
     * @returns a boolean
     */
    get isVideoOnDemandEnabled() {
        return this._isVideoOnDemandEnabled;
    }
    ;
    /**
     * Sets the isVideoOnDemandEnabled property value. Indicates whether video on demand is enabled for this Teams live event. Default value is false.
     * @param value Value to set for the isVideoOnDemandEnabled property.
     */
    set isVideoOnDemandEnabled(value) {
        this._isVideoOnDemandEnabled = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeEnumValue("allowedAudience", this.allowedAudience);
        writer.writeBooleanValue("isAttendeeReportEnabled", this.isAttendeeReportEnabled);
        writer.writeBooleanValue("isQuestionAndAnswerEnabled", this.isQuestionAndAnswerEnabled);
        writer.writeBooleanValue("isRecordingEnabled", this.isRecordingEnabled);
        writer.writeBooleanValue("isVideoOnDemandEnabled", this.isVideoOnDemandEnabled);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.BroadcastMeetingSettings = BroadcastMeetingSettings;
