"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Bundle = void 0;
const createAlbumFromDiscriminatorValue_1 = require("./createAlbumFromDiscriminatorValue");
class Bundle {
    /**
     * Instantiates a new bundle and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the album property value. If the bundle is an [album][], then the album property is included
     * @returns a album
     */
    get album() {
        return this._album;
    }
    ;
    /**
     * Sets the album property value. If the bundle is an [album][], then the album property is included
     * @param value Value to set for the album property.
     */
    set album(value) {
        this._album = value;
    }
    ;
    /**
     * Gets the childCount property value. Number of children contained immediately within this container.
     * @returns a integer
     */
    get childCount() {
        return this._childCount;
    }
    ;
    /**
     * Sets the childCount property value. Number of children contained immediately within this container.
     * @param value Value to set for the childCount property.
     */
    set childCount(value) {
        this._childCount = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "album": (o, n) => { o.album = n.getObjectValue(createAlbumFromDiscriminatorValue_1.createAlbumFromDiscriminatorValue); },
            "childCount": (o, n) => { o.childCount = n.getNumberValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("album", this.album);
        writer.writeNumberValue("childCount", this.childCount);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.Bundle = Bundle;
