"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CalendarGroup = void 0;
const createCalendarFromDiscriminatorValue_1 = require("./createCalendarFromDiscriminatorValue");
const index_1 = require("./index");
class CalendarGroup extends index_1.Entity {
    /**
     * Instantiates a new calendarGroup and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the calendars property value. The calendars in the calendar group. Navigation property. Read-only. Nullable.
     * @returns a calendar
     */
    get calendars() {
        return this._calendars;
    }
    ;
    /**
     * Sets the calendars property value. The calendars in the calendar group. Navigation property. Read-only. Nullable.
     * @param value Value to set for the calendars property.
     */
    set calendars(value) {
        this._calendars = value;
    }
    ;
    /**
     * Gets the changeKey property value. Identifies the version of the calendar group. Every time the calendar group is changed, ChangeKey changes as well. This allows Exchange to apply changes to the correct version of the object. Read-only.
     * @returns a string
     */
    get changeKey() {
        return this._changeKey;
    }
    ;
    /**
     * Sets the changeKey property value. Identifies the version of the calendar group. Every time the calendar group is changed, ChangeKey changes as well. This allows Exchange to apply changes to the correct version of the object. Read-only.
     * @param value Value to set for the changeKey property.
     */
    set changeKey(value) {
        this._changeKey = value;
    }
    ;
    /**
     * Gets the classId property value. The class identifier. Read-only.
     * @returns a string
     */
    get classId() {
        return this._classId;
    }
    ;
    /**
     * Sets the classId property value. The class identifier. Read-only.
     * @param value Value to set for the classId property.
     */
    set classId(value) {
        this._classId = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "calendars": (o, n) => { o.calendars = n.getCollectionOfObjectValues(createCalendarFromDiscriminatorValue_1.createCalendarFromDiscriminatorValue); }, "changeKey": (o, n) => { o.changeKey = n.getStringValue(); }, "classId": (o, n) => { o.classId = n.getStringValue(); }, "name": (o, n) => { o.name = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the name property value. The group name.
     * @returns a string
     */
    get name() {
        return this._name;
    }
    ;
    /**
     * Sets the name property value. The group name.
     * @param value Value to set for the name property.
     */
    set name(value) {
        this._name = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("calendars", this.calendars);
        writer.writeStringValue("changeKey", this.changeKey);
        writer.writeStringValue("classId", this.classId);
        writer.writeStringValue("name", this.name);
    }
    ;
}
exports.CalendarGroup = CalendarGroup;
