"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CallMediaState = void 0;
const mediaState_1 = require("./mediaState");
class CallMediaState {
    /**
     * Instantiates a new callMediaState and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the audio property value. The audio media state. Possible values are: active, inactive, unknownFutureValue.
     * @returns a mediaState
     */
    get audio() {
        return this._audio;
    }
    ;
    /**
     * Sets the audio property value. The audio media state. Possible values are: active, inactive, unknownFutureValue.
     * @param value Value to set for the audio property.
     */
    set audio(value) {
        this._audio = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "audio": (o, n) => { o.audio = n.getEnumValue(mediaState_1.MediaState); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeEnumValue("audio", this.audio);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.CallMediaState = CallMediaState;
