"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Endpoint = void 0;
const createUserAgentFromDiscriminatorValue_1 = require("./createUserAgentFromDiscriminatorValue");
class Endpoint {
    /**
     * Instantiates a new endpoint and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "userAgent": (o, n) => { o.userAgent = n.getObjectValue(createUserAgentFromDiscriminatorValue_1.createUserAgentFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("userAgent", this.userAgent);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the userAgent property value. User-agent reported by this endpoint.
     * @returns a userAgent
     */
    get userAgent() {
        return this._userAgent;
    }
    ;
    /**
     * Sets the userAgent property value. User-agent reported by this endpoint.
     * @param value Value to set for the userAgent property.
     */
    set userAgent(value) {
        this._userAgent = value;
    }
    ;
}
exports.Endpoint = Endpoint;
