"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FailureInfo = void 0;
const failureStage_1 = require("./failureStage");
class FailureInfo {
    /**
     * Instantiates a new failureInfo and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "reason": (o, n) => { o.reason = n.getStringValue(); },
            "stage": (o, n) => { o.stage = n.getEnumValue(failureStage_1.FailureStage); },
        };
    }
    ;
    /**
     * Gets the reason property value. Classification of why a call or portion of a call failed.
     * @returns a string
     */
    get reason() {
        return this._reason;
    }
    ;
    /**
     * Sets the reason property value. Classification of why a call or portion of a call failed.
     * @param value Value to set for the reason property.
     */
    set reason(value) {
        this._reason = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("reason", this.reason);
        writer.writeEnumValue("stage", this.stage);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the stage property value. The stage when the failure occurred. Possible values are: unknown, callSetup, midcall, unknownFutureValue.
     * @returns a failureStage
     */
    get stage() {
        return this._stage;
    }
    ;
    /**
     * Sets the stage property value. The stage when the failure occurred. Possible values are: unknown, callSetup, midcall, unknownFutureValue.
     * @param value Value to set for the stage property.
     */
    set stage(value) {
        this._stage = value;
    }
    ;
}
exports.FailureInfo = FailureInfo;
