"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MediaStream = void 0;
const mediaStreamDirection_1 = require("./mediaStreamDirection");
class MediaStream {
    /**
     * Instantiates a new mediaStream and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the averageAudioDegradation property value. Average Network Mean Opinion Score degradation for stream. Represents how much the network loss and jitter has impacted the quality of received audio.
     * @returns a float
     */
    get averageAudioDegradation() {
        return this._averageAudioDegradation;
    }
    ;
    /**
     * Sets the averageAudioDegradation property value. Average Network Mean Opinion Score degradation for stream. Represents how much the network loss and jitter has impacted the quality of received audio.
     * @param value Value to set for the averageAudioDegradation property.
     */
    set averageAudioDegradation(value) {
        this._averageAudioDegradation = value;
    }
    ;
    /**
     * Gets the averageAudioNetworkJitter property value. Average jitter for the stream computed as specified in [RFC 3550][], denoted in [ISO 8601][] format. For example, 1 second is denoted as 'PT1S', where 'P' is the duration designator, 'T' is the time designator, and 'S' is the second designator.
     * @returns a Duration
     */
    get averageAudioNetworkJitter() {
        return this._averageAudioNetworkJitter;
    }
    ;
    /**
     * Sets the averageAudioNetworkJitter property value. Average jitter for the stream computed as specified in [RFC 3550][], denoted in [ISO 8601][] format. For example, 1 second is denoted as 'PT1S', where 'P' is the duration designator, 'T' is the time designator, and 'S' is the second designator.
     * @param value Value to set for the averageAudioNetworkJitter property.
     */
    set averageAudioNetworkJitter(value) {
        this._averageAudioNetworkJitter = value;
    }
    ;
    /**
     * Gets the averageBandwidthEstimate property value. Average estimated bandwidth available between two endpoints in bits per second.
     * @returns a int64
     */
    get averageBandwidthEstimate() {
        return this._averageBandwidthEstimate;
    }
    ;
    /**
     * Sets the averageBandwidthEstimate property value. Average estimated bandwidth available between two endpoints in bits per second.
     * @param value Value to set for the averageBandwidthEstimate property.
     */
    set averageBandwidthEstimate(value) {
        this._averageBandwidthEstimate = value;
    }
    ;
    /**
     * Gets the averageJitter property value. Average jitter for the stream computed as specified in [RFC 3550][], denoted in [ISO 8601][] format. For example, 1 second is denoted as 'PT1S', where 'P' is the duration designator, 'T' is the time designator, and 'S' is the second designator.
     * @returns a Duration
     */
    get averageJitter() {
        return this._averageJitter;
    }
    ;
    /**
     * Sets the averageJitter property value. Average jitter for the stream computed as specified in [RFC 3550][], denoted in [ISO 8601][] format. For example, 1 second is denoted as 'PT1S', where 'P' is the duration designator, 'T' is the time designator, and 'S' is the second designator.
     * @param value Value to set for the averageJitter property.
     */
    set averageJitter(value) {
        this._averageJitter = value;
    }
    ;
    /**
     * Gets the averagePacketLossRate property value. Average packet loss rate for stream.
     * @returns a float
     */
    get averagePacketLossRate() {
        return this._averagePacketLossRate;
    }
    ;
    /**
     * Sets the averagePacketLossRate property value. Average packet loss rate for stream.
     * @param value Value to set for the averagePacketLossRate property.
     */
    set averagePacketLossRate(value) {
        this._averagePacketLossRate = value;
    }
    ;
    /**
     * Gets the averageRatioOfConcealedSamples property value. Ratio of the number of audio frames with samples generated by packet loss concealment to the total number of audio frames.
     * @returns a float
     */
    get averageRatioOfConcealedSamples() {
        return this._averageRatioOfConcealedSamples;
    }
    ;
    /**
     * Sets the averageRatioOfConcealedSamples property value. Ratio of the number of audio frames with samples generated by packet loss concealment to the total number of audio frames.
     * @param value Value to set for the averageRatioOfConcealedSamples property.
     */
    set averageRatioOfConcealedSamples(value) {
        this._averageRatioOfConcealedSamples = value;
    }
    ;
    /**
     * Gets the averageReceivedFrameRate property value. Average frames per second received for all video streams computed over the duration of the session.
     * @returns a float
     */
    get averageReceivedFrameRate() {
        return this._averageReceivedFrameRate;
    }
    ;
    /**
     * Sets the averageReceivedFrameRate property value. Average frames per second received for all video streams computed over the duration of the session.
     * @param value Value to set for the averageReceivedFrameRate property.
     */
    set averageReceivedFrameRate(value) {
        this._averageReceivedFrameRate = value;
    }
    ;
    /**
     * Gets the averageRoundTripTime property value. Average network propagation round-trip time computed as specified in [RFC 3550][], denoted in [ISO 8601][] format. For example, 1 second is denoted as 'PT1S', where 'P' is the duration designator, 'T' is the time designator, and 'S' is the second designator.
     * @returns a Duration
     */
    get averageRoundTripTime() {
        return this._averageRoundTripTime;
    }
    ;
    /**
     * Sets the averageRoundTripTime property value. Average network propagation round-trip time computed as specified in [RFC 3550][], denoted in [ISO 8601][] format. For example, 1 second is denoted as 'PT1S', where 'P' is the duration designator, 'T' is the time designator, and 'S' is the second designator.
     * @param value Value to set for the averageRoundTripTime property.
     */
    set averageRoundTripTime(value) {
        this._averageRoundTripTime = value;
    }
    ;
    /**
     * Gets the averageVideoFrameLossPercentage property value. Average percentage of video frames lost as displayed to the user.
     * @returns a float
     */
    get averageVideoFrameLossPercentage() {
        return this._averageVideoFrameLossPercentage;
    }
    ;
    /**
     * Sets the averageVideoFrameLossPercentage property value. Average percentage of video frames lost as displayed to the user.
     * @param value Value to set for the averageVideoFrameLossPercentage property.
     */
    set averageVideoFrameLossPercentage(value) {
        this._averageVideoFrameLossPercentage = value;
    }
    ;
    /**
     * Gets the averageVideoFrameRate property value. Average frames per second received for a video stream, computed over the duration of the session.
     * @returns a float
     */
    get averageVideoFrameRate() {
        return this._averageVideoFrameRate;
    }
    ;
    /**
     * Sets the averageVideoFrameRate property value. Average frames per second received for a video stream, computed over the duration of the session.
     * @param value Value to set for the averageVideoFrameRate property.
     */
    set averageVideoFrameRate(value) {
        this._averageVideoFrameRate = value;
    }
    ;
    /**
     * Gets the averageVideoPacketLossRate property value. Average fraction of packets lost, as specified in [RFC 3550][], computed over the duration of the session.
     * @returns a float
     */
    get averageVideoPacketLossRate() {
        return this._averageVideoPacketLossRate;
    }
    ;
    /**
     * Sets the averageVideoPacketLossRate property value. Average fraction of packets lost, as specified in [RFC 3550][], computed over the duration of the session.
     * @param value Value to set for the averageVideoPacketLossRate property.
     */
    set averageVideoPacketLossRate(value) {
        this._averageVideoPacketLossRate = value;
    }
    ;
    ;
    /**
     * Gets the endDateTime property value. UTC time when the stream ended. The DateTimeOffset type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @returns a Date
     */
    get endDateTime() {
        return this._endDateTime;
    }
    ;
    /**
     * Sets the endDateTime property value. UTC time when the stream ended. The DateTimeOffset type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @param value Value to set for the endDateTime property.
     */
    set endDateTime(value) {
        this._endDateTime = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "averageAudioDegradation": (o, n) => { o.averageAudioDegradation = n.getNumberValue(); },
            "averageAudioNetworkJitter": (o, n) => { o.averageAudioNetworkJitter = n.getDurationValue(); },
            "averageBandwidthEstimate": (o, n) => { o.averageBandwidthEstimate = n.getNumberValue(); },
            "averageJitter": (o, n) => { o.averageJitter = n.getDurationValue(); },
            "averagePacketLossRate": (o, n) => { o.averagePacketLossRate = n.getNumberValue(); },
            "averageRatioOfConcealedSamples": (o, n) => { o.averageRatioOfConcealedSamples = n.getNumberValue(); },
            "averageReceivedFrameRate": (o, n) => { o.averageReceivedFrameRate = n.getNumberValue(); },
            "averageRoundTripTime": (o, n) => { o.averageRoundTripTime = n.getDurationValue(); },
            "averageVideoFrameLossPercentage": (o, n) => { o.averageVideoFrameLossPercentage = n.getNumberValue(); },
            "averageVideoFrameRate": (o, n) => { o.averageVideoFrameRate = n.getNumberValue(); },
            "averageVideoPacketLossRate": (o, n) => { o.averageVideoPacketLossRate = n.getNumberValue(); },
            "endDateTime": (o, n) => { o.endDateTime = n.getDateValue(); },
            "lowFrameRateRatio": (o, n) => { o.lowFrameRateRatio = n.getNumberValue(); },
            "lowVideoProcessingCapabilityRatio": (o, n) => { o.lowVideoProcessingCapabilityRatio = n.getNumberValue(); },
            "maxAudioNetworkJitter": (o, n) => { o.maxAudioNetworkJitter = n.getDurationValue(); },
            "maxJitter": (o, n) => { o.maxJitter = n.getDurationValue(); },
            "maxPacketLossRate": (o, n) => { o.maxPacketLossRate = n.getNumberValue(); },
            "maxRatioOfConcealedSamples": (o, n) => { o.maxRatioOfConcealedSamples = n.getNumberValue(); },
            "maxRoundTripTime": (o, n) => { o.maxRoundTripTime = n.getDurationValue(); },
            "packetUtilization": (o, n) => { o.packetUtilization = n.getNumberValue(); },
            "postForwardErrorCorrectionPacketLossRate": (o, n) => { o.postForwardErrorCorrectionPacketLossRate = n.getNumberValue(); },
            "startDateTime": (o, n) => { o.startDateTime = n.getDateValue(); },
            "streamDirection": (o, n) => { o.streamDirection = n.getEnumValue(mediaStreamDirection_1.MediaStreamDirection); },
            "streamId": (o, n) => { o.streamId = n.getStringValue(); },
            "wasMediaBypassed": (o, n) => { o.wasMediaBypassed = n.getBooleanValue(); },
        };
    }
    ;
    /**
     * Gets the lowFrameRateRatio property value. Fraction of the call where frame rate is less than 7.5 frames per second.
     * @returns a float
     */
    get lowFrameRateRatio() {
        return this._lowFrameRateRatio;
    }
    ;
    /**
     * Sets the lowFrameRateRatio property value. Fraction of the call where frame rate is less than 7.5 frames per second.
     * @param value Value to set for the lowFrameRateRatio property.
     */
    set lowFrameRateRatio(value) {
        this._lowFrameRateRatio = value;
    }
    ;
    /**
     * Gets the lowVideoProcessingCapabilityRatio property value. Fraction of the call that the client is running less than 70% expected video processing capability.
     * @returns a float
     */
    get lowVideoProcessingCapabilityRatio() {
        return this._lowVideoProcessingCapabilityRatio;
    }
    ;
    /**
     * Sets the lowVideoProcessingCapabilityRatio property value. Fraction of the call that the client is running less than 70% expected video processing capability.
     * @param value Value to set for the lowVideoProcessingCapabilityRatio property.
     */
    set lowVideoProcessingCapabilityRatio(value) {
        this._lowVideoProcessingCapabilityRatio = value;
    }
    ;
    /**
     * Gets the maxAudioNetworkJitter property value. Maximum of audio network jitter computed over each of the 20 second windows during the session, denoted in [ISO 8601][] format. For example, 1 second is denoted as 'PT1S', where 'P' is the duration designator, 'T' is the time designator, and 'S' is the second designator.
     * @returns a Duration
     */
    get maxAudioNetworkJitter() {
        return this._maxAudioNetworkJitter;
    }
    ;
    /**
     * Sets the maxAudioNetworkJitter property value. Maximum of audio network jitter computed over each of the 20 second windows during the session, denoted in [ISO 8601][] format. For example, 1 second is denoted as 'PT1S', where 'P' is the duration designator, 'T' is the time designator, and 'S' is the second designator.
     * @param value Value to set for the maxAudioNetworkJitter property.
     */
    set maxAudioNetworkJitter(value) {
        this._maxAudioNetworkJitter = value;
    }
    ;
    /**
     * Gets the maxJitter property value. Maximum jitter for the stream computed as specified in RFC 3550, denoted in [ISO 8601][] format. For example, 1 second is denoted as 'PT1S', where 'P' is the duration designator, 'T' is the time designator, and 'S' is the second designator.
     * @returns a Duration
     */
    get maxJitter() {
        return this._maxJitter;
    }
    ;
    /**
     * Sets the maxJitter property value. Maximum jitter for the stream computed as specified in RFC 3550, denoted in [ISO 8601][] format. For example, 1 second is denoted as 'PT1S', where 'P' is the duration designator, 'T' is the time designator, and 'S' is the second designator.
     * @param value Value to set for the maxJitter property.
     */
    set maxJitter(value) {
        this._maxJitter = value;
    }
    ;
    /**
     * Gets the maxPacketLossRate property value. Maximum packet loss rate for the stream.
     * @returns a float
     */
    get maxPacketLossRate() {
        return this._maxPacketLossRate;
    }
    ;
    /**
     * Sets the maxPacketLossRate property value. Maximum packet loss rate for the stream.
     * @param value Value to set for the maxPacketLossRate property.
     */
    set maxPacketLossRate(value) {
        this._maxPacketLossRate = value;
    }
    ;
    /**
     * Gets the maxRatioOfConcealedSamples property value. Maximum ratio of packets concealed by the healer.
     * @returns a float
     */
    get maxRatioOfConcealedSamples() {
        return this._maxRatioOfConcealedSamples;
    }
    ;
    /**
     * Sets the maxRatioOfConcealedSamples property value. Maximum ratio of packets concealed by the healer.
     * @param value Value to set for the maxRatioOfConcealedSamples property.
     */
    set maxRatioOfConcealedSamples(value) {
        this._maxRatioOfConcealedSamples = value;
    }
    ;
    /**
     * Gets the maxRoundTripTime property value. Maximum network propagation round-trip time computed as specified in [RFC 3550][], denoted in [ISO 8601][] format. For example, 1 second is denoted as 'PT1S', where 'P' is the duration designator, 'T' is the time designator, and 'S' is the second designator.
     * @returns a Duration
     */
    get maxRoundTripTime() {
        return this._maxRoundTripTime;
    }
    ;
    /**
     * Sets the maxRoundTripTime property value. Maximum network propagation round-trip time computed as specified in [RFC 3550][], denoted in [ISO 8601][] format. For example, 1 second is denoted as 'PT1S', where 'P' is the duration designator, 'T' is the time designator, and 'S' is the second designator.
     * @param value Value to set for the maxRoundTripTime property.
     */
    set maxRoundTripTime(value) {
        this._maxRoundTripTime = value;
    }
    ;
    /**
     * Gets the packetUtilization property value. Packet count for the stream.
     * @returns a int64
     */
    get packetUtilization() {
        return this._packetUtilization;
    }
    ;
    /**
     * Sets the packetUtilization property value. Packet count for the stream.
     * @param value Value to set for the packetUtilization property.
     */
    set packetUtilization(value) {
        this._packetUtilization = value;
    }
    ;
    /**
     * Gets the postForwardErrorCorrectionPacketLossRate property value. Packet loss rate after FEC has been applied aggregated across all video streams and codecs.
     * @returns a float
     */
    get postForwardErrorCorrectionPacketLossRate() {
        return this._postForwardErrorCorrectionPacketLossRate;
    }
    ;
    /**
     * Sets the postForwardErrorCorrectionPacketLossRate property value. Packet loss rate after FEC has been applied aggregated across all video streams and codecs.
     * @param value Value to set for the postForwardErrorCorrectionPacketLossRate property.
     */
    set postForwardErrorCorrectionPacketLossRate(value) {
        this._postForwardErrorCorrectionPacketLossRate = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeNumberValue("averageAudioDegradation", this.averageAudioDegradation);
        writer.writeDurationValue("averageAudioNetworkJitter", this.averageAudioNetworkJitter);
        writer.writeNumberValue("averageBandwidthEstimate", this.averageBandwidthEstimate);
        writer.writeDurationValue("averageJitter", this.averageJitter);
        writer.writeNumberValue("averagePacketLossRate", this.averagePacketLossRate);
        writer.writeNumberValue("averageRatioOfConcealedSamples", this.averageRatioOfConcealedSamples);
        writer.writeNumberValue("averageReceivedFrameRate", this.averageReceivedFrameRate);
        writer.writeDurationValue("averageRoundTripTime", this.averageRoundTripTime);
        writer.writeNumberValue("averageVideoFrameLossPercentage", this.averageVideoFrameLossPercentage);
        writer.writeNumberValue("averageVideoFrameRate", this.averageVideoFrameRate);
        writer.writeNumberValue("averageVideoPacketLossRate", this.averageVideoPacketLossRate);
        writer.writeDateValue("endDateTime", this.endDateTime);
        writer.writeNumberValue("lowFrameRateRatio", this.lowFrameRateRatio);
        writer.writeNumberValue("lowVideoProcessingCapabilityRatio", this.lowVideoProcessingCapabilityRatio);
        writer.writeDurationValue("maxAudioNetworkJitter", this.maxAudioNetworkJitter);
        writer.writeDurationValue("maxJitter", this.maxJitter);
        writer.writeNumberValue("maxPacketLossRate", this.maxPacketLossRate);
        writer.writeNumberValue("maxRatioOfConcealedSamples", this.maxRatioOfConcealedSamples);
        writer.writeDurationValue("maxRoundTripTime", this.maxRoundTripTime);
        writer.writeNumberValue("packetUtilization", this.packetUtilization);
        writer.writeNumberValue("postForwardErrorCorrectionPacketLossRate", this.postForwardErrorCorrectionPacketLossRate);
        writer.writeDateValue("startDateTime", this.startDateTime);
        writer.writeEnumValue("streamDirection", this.streamDirection);
        writer.writeStringValue("streamId", this.streamId);
        writer.writeBooleanValue("wasMediaBypassed", this.wasMediaBypassed);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the startDateTime property value. UTC time when the stream started. The DateTimeOffset type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @returns a Date
     */
    get startDateTime() {
        return this._startDateTime;
    }
    ;
    /**
     * Sets the startDateTime property value. UTC time when the stream started. The DateTimeOffset type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @param value Value to set for the startDateTime property.
     */
    set startDateTime(value) {
        this._startDateTime = value;
    }
    ;
    /**
     * Gets the streamDirection property value. Indicates the direction of the media stream. Possible values are: callerToCallee, calleeToCaller.
     * @returns a mediaStreamDirection
     */
    get streamDirection() {
        return this._streamDirection;
    }
    ;
    /**
     * Sets the streamDirection property value. Indicates the direction of the media stream. Possible values are: callerToCallee, calleeToCaller.
     * @param value Value to set for the streamDirection property.
     */
    set streamDirection(value) {
        this._streamDirection = value;
    }
    ;
    /**
     * Gets the streamId property value. Unique identifier for the stream.
     * @returns a string
     */
    get streamId() {
        return this._streamId;
    }
    ;
    /**
     * Sets the streamId property value. Unique identifier for the stream.
     * @param value Value to set for the streamId property.
     */
    set streamId(value) {
        this._streamId = value;
    }
    ;
    /**
     * Gets the wasMediaBypassed property value. True if the media stream bypassed the Mediation Server and went straight between client and PSTN Gateway/PBX, false otherwise.
     * @returns a boolean
     */
    get wasMediaBypassed() {
        return this._wasMediaBypassed;
    }
    ;
    /**
     * Sets the wasMediaBypassed property value. True if the media stream bypassed the Mediation Server and went straight between client and PSTN Gateway/PBX, false otherwise.
     * @param value Value to set for the wasMediaBypassed property.
     */
    set wasMediaBypassed(value) {
        this._wasMediaBypassed = value;
    }
    ;
}
exports.MediaStream = MediaStream;
