"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NetworkInfo = void 0;
const networkConnectionType_1 = require("./networkConnectionType");
const wifiBand_1 = require("./wifiBand");
const wifiRadioType_1 = require("./wifiRadioType");
class NetworkInfo {
    /**
     * Instantiates a new networkInfo and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the bandwidthLowEventRatio property value. Fraction of the call that the media endpoint detected the available bandwidth or bandwidth policy was low enough to cause poor quality of the audio sent.
     * @returns a float
     */
    get bandwidthLowEventRatio() {
        return this._bandwidthLowEventRatio;
    }
    ;
    /**
     * Sets the bandwidthLowEventRatio property value. Fraction of the call that the media endpoint detected the available bandwidth or bandwidth policy was low enough to cause poor quality of the audio sent.
     * @param value Value to set for the bandwidthLowEventRatio property.
     */
    set bandwidthLowEventRatio(value) {
        this._bandwidthLowEventRatio = value;
    }
    ;
    /**
     * Gets the basicServiceSetIdentifier property value. The wireless LAN basic service set identifier of the media endpoint used to connect to the network.
     * @returns a string
     */
    get basicServiceSetIdentifier() {
        return this._basicServiceSetIdentifier;
    }
    ;
    /**
     * Sets the basicServiceSetIdentifier property value. The wireless LAN basic service set identifier of the media endpoint used to connect to the network.
     * @param value Value to set for the basicServiceSetIdentifier property.
     */
    set basicServiceSetIdentifier(value) {
        this._basicServiceSetIdentifier = value;
    }
    ;
    /**
     * Gets the connectionType property value. Type of network used by the media endpoint. Possible values are: unknown, wired, wifi, mobile, tunnel, unknownFutureValue.
     * @returns a networkConnectionType
     */
    get connectionType() {
        return this._connectionType;
    }
    ;
    /**
     * Sets the connectionType property value. Type of network used by the media endpoint. Possible values are: unknown, wired, wifi, mobile, tunnel, unknownFutureValue.
     * @param value Value to set for the connectionType property.
     */
    set connectionType(value) {
        this._connectionType = value;
    }
    ;
    ;
    /**
     * Gets the delayEventRatio property value. Fraction of the call that the media endpoint detected the network delay was significant enough to impact the ability to have real-time two-way communication.
     * @returns a float
     */
    get delayEventRatio() {
        return this._delayEventRatio;
    }
    ;
    /**
     * Sets the delayEventRatio property value. Fraction of the call that the media endpoint detected the network delay was significant enough to impact the ability to have real-time two-way communication.
     * @param value Value to set for the delayEventRatio property.
     */
    set delayEventRatio(value) {
        this._delayEventRatio = value;
    }
    ;
    /**
     * Gets the dnsSuffix property value. DNS suffix associated with the network adapter of the media endpoint.
     * @returns a string
     */
    get dnsSuffix() {
        return this._dnsSuffix;
    }
    ;
    /**
     * Sets the dnsSuffix property value. DNS suffix associated with the network adapter of the media endpoint.
     * @param value Value to set for the dnsSuffix property.
     */
    set dnsSuffix(value) {
        this._dnsSuffix = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "bandwidthLowEventRatio": (o, n) => { o.bandwidthLowEventRatio = n.getNumberValue(); },
            "basicServiceSetIdentifier": (o, n) => { o.basicServiceSetIdentifier = n.getStringValue(); },
            "connectionType": (o, n) => { o.connectionType = n.getEnumValue(networkConnectionType_1.NetworkConnectionType); },
            "delayEventRatio": (o, n) => { o.delayEventRatio = n.getNumberValue(); },
            "dnsSuffix": (o, n) => { o.dnsSuffix = n.getStringValue(); },
            "ipAddress": (o, n) => { o.ipAddress = n.getStringValue(); },
            "linkSpeed": (o, n) => { o.linkSpeed = n.getNumberValue(); },
            "macAddress": (o, n) => { o.macAddress = n.getStringValue(); },
            "port": (o, n) => { o.port = n.getNumberValue(); },
            "receivedQualityEventRatio": (o, n) => { o.receivedQualityEventRatio = n.getNumberValue(); },
            "reflexiveIPAddress": (o, n) => { o.reflexiveIPAddress = n.getStringValue(); },
            "relayIPAddress": (o, n) => { o.relayIPAddress = n.getStringValue(); },
            "relayPort": (o, n) => { o.relayPort = n.getNumberValue(); },
            "sentQualityEventRatio": (o, n) => { o.sentQualityEventRatio = n.getNumberValue(); },
            "subnet": (o, n) => { o.subnet = n.getStringValue(); },
            "wifiBand": (o, n) => { o.wifiBand = n.getEnumValue(wifiBand_1.WifiBand); },
            "wifiBatteryCharge": (o, n) => { o.wifiBatteryCharge = n.getNumberValue(); },
            "wifiChannel": (o, n) => { o.wifiChannel = n.getNumberValue(); },
            "wifiMicrosoftDriver": (o, n) => { o.wifiMicrosoftDriver = n.getStringValue(); },
            "wifiMicrosoftDriverVersion": (o, n) => { o.wifiMicrosoftDriverVersion = n.getStringValue(); },
            "wifiRadioType": (o, n) => { o.wifiRadioType = n.getEnumValue(wifiRadioType_1.WifiRadioType); },
            "wifiSignalStrength": (o, n) => { o.wifiSignalStrength = n.getNumberValue(); },
            "wifiVendorDriver": (o, n) => { o.wifiVendorDriver = n.getStringValue(); },
            "wifiVendorDriverVersion": (o, n) => { o.wifiVendorDriverVersion = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the ipAddress property value. IP address of the media endpoint.
     * @returns a string
     */
    get ipAddress() {
        return this._ipAddress;
    }
    ;
    /**
     * Sets the ipAddress property value. IP address of the media endpoint.
     * @param value Value to set for the ipAddress property.
     */
    set ipAddress(value) {
        this._ipAddress = value;
    }
    ;
    /**
     * Gets the linkSpeed property value. Link speed in bits per second reported by the network adapter used by the media endpoint.
     * @returns a int64
     */
    get linkSpeed() {
        return this._linkSpeed;
    }
    ;
    /**
     * Sets the linkSpeed property value. Link speed in bits per second reported by the network adapter used by the media endpoint.
     * @param value Value to set for the linkSpeed property.
     */
    set linkSpeed(value) {
        this._linkSpeed = value;
    }
    ;
    /**
     * Gets the macAddress property value. The media access control (MAC) address of the media endpoint's network device.
     * @returns a string
     */
    get macAddress() {
        return this._macAddress;
    }
    ;
    /**
     * Sets the macAddress property value. The media access control (MAC) address of the media endpoint's network device.
     * @param value Value to set for the macAddress property.
     */
    set macAddress(value) {
        this._macAddress = value;
    }
    ;
    /**
     * Gets the port property value. Network port number used by media endpoint.
     * @returns a integer
     */
    get port() {
        return this._port;
    }
    ;
    /**
     * Sets the port property value. Network port number used by media endpoint.
     * @param value Value to set for the port property.
     */
    set port(value) {
        this._port = value;
    }
    ;
    /**
     * Gets the receivedQualityEventRatio property value. Fraction of the call that the media endpoint detected the network was causing poor quality of the audio received.
     * @returns a float
     */
    get receivedQualityEventRatio() {
        return this._receivedQualityEventRatio;
    }
    ;
    /**
     * Sets the receivedQualityEventRatio property value. Fraction of the call that the media endpoint detected the network was causing poor quality of the audio received.
     * @param value Value to set for the receivedQualityEventRatio property.
     */
    set receivedQualityEventRatio(value) {
        this._receivedQualityEventRatio = value;
    }
    ;
    /**
     * Gets the reflexiveIPAddress property value. IP address of the media endpoint as seen by the media relay server. This is typically the public internet IP address associated to the endpoint.
     * @returns a string
     */
    get reflexiveIPAddress() {
        return this._reflexiveIPAddress;
    }
    ;
    /**
     * Sets the reflexiveIPAddress property value. IP address of the media endpoint as seen by the media relay server. This is typically the public internet IP address associated to the endpoint.
     * @param value Value to set for the reflexiveIPAddress property.
     */
    set reflexiveIPAddress(value) {
        this._reflexiveIPAddress = value;
    }
    ;
    /**
     * Gets the relayIPAddress property value. IP address of the media relay server allocated by the media endpoint.
     * @returns a string
     */
    get relayIPAddress() {
        return this._relayIPAddress;
    }
    ;
    /**
     * Sets the relayIPAddress property value. IP address of the media relay server allocated by the media endpoint.
     * @param value Value to set for the relayIPAddress property.
     */
    set relayIPAddress(value) {
        this._relayIPAddress = value;
    }
    ;
    /**
     * Gets the relayPort property value. Network port number allocated on the media relay server by the media endpoint.
     * @returns a integer
     */
    get relayPort() {
        return this._relayPort;
    }
    ;
    /**
     * Sets the relayPort property value. Network port number allocated on the media relay server by the media endpoint.
     * @param value Value to set for the relayPort property.
     */
    set relayPort(value) {
        this._relayPort = value;
    }
    ;
    /**
     * Gets the sentQualityEventRatio property value. Fraction of the call that the media endpoint detected the network was causing poor quality of the audio sent.
     * @returns a float
     */
    get sentQualityEventRatio() {
        return this._sentQualityEventRatio;
    }
    ;
    /**
     * Sets the sentQualityEventRatio property value. Fraction of the call that the media endpoint detected the network was causing poor quality of the audio sent.
     * @param value Value to set for the sentQualityEventRatio property.
     */
    set sentQualityEventRatio(value) {
        this._sentQualityEventRatio = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeNumberValue("bandwidthLowEventRatio", this.bandwidthLowEventRatio);
        writer.writeStringValue("basicServiceSetIdentifier", this.basicServiceSetIdentifier);
        writer.writeEnumValue("connectionType", this.connectionType);
        writer.writeNumberValue("delayEventRatio", this.delayEventRatio);
        writer.writeStringValue("dnsSuffix", this.dnsSuffix);
        writer.writeStringValue("ipAddress", this.ipAddress);
        writer.writeNumberValue("linkSpeed", this.linkSpeed);
        writer.writeStringValue("macAddress", this.macAddress);
        writer.writeNumberValue("port", this.port);
        writer.writeNumberValue("receivedQualityEventRatio", this.receivedQualityEventRatio);
        writer.writeStringValue("reflexiveIPAddress", this.reflexiveIPAddress);
        writer.writeStringValue("relayIPAddress", this.relayIPAddress);
        writer.writeNumberValue("relayPort", this.relayPort);
        writer.writeNumberValue("sentQualityEventRatio", this.sentQualityEventRatio);
        writer.writeStringValue("subnet", this.subnet);
        writer.writeEnumValue("wifiBand", this.wifiBand);
        writer.writeNumberValue("wifiBatteryCharge", this.wifiBatteryCharge);
        writer.writeNumberValue("wifiChannel", this.wifiChannel);
        writer.writeStringValue("wifiMicrosoftDriver", this.wifiMicrosoftDriver);
        writer.writeStringValue("wifiMicrosoftDriverVersion", this.wifiMicrosoftDriverVersion);
        writer.writeEnumValue("wifiRadioType", this.wifiRadioType);
        writer.writeNumberValue("wifiSignalStrength", this.wifiSignalStrength);
        writer.writeStringValue("wifiVendorDriver", this.wifiVendorDriver);
        writer.writeStringValue("wifiVendorDriverVersion", this.wifiVendorDriverVersion);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the subnet property value. Subnet used for media stream by the media endpoint.
     * @returns a string
     */
    get subnet() {
        return this._subnet;
    }
    ;
    /**
     * Sets the subnet property value. Subnet used for media stream by the media endpoint.
     * @param value Value to set for the subnet property.
     */
    set subnet(value) {
        this._subnet = value;
    }
    ;
    /**
     * Gets the wifiBand property value. WiFi band used by the media endpoint. Possible values are: unknown, frequency24GHz, frequency50GHz, frequency60GHz, unknownFutureValue.
     * @returns a wifiBand
     */
    get wifiBand() {
        return this._wifiBand;
    }
    ;
    /**
     * Sets the wifiBand property value. WiFi band used by the media endpoint. Possible values are: unknown, frequency24GHz, frequency50GHz, frequency60GHz, unknownFutureValue.
     * @param value Value to set for the wifiBand property.
     */
    set wifiBand(value) {
        this._wifiBand = value;
    }
    ;
    /**
     * Gets the wifiBatteryCharge property value. Estimated remaining battery charge in percentage reported by the media endpoint.
     * @returns a integer
     */
    get wifiBatteryCharge() {
        return this._wifiBatteryCharge;
    }
    ;
    /**
     * Sets the wifiBatteryCharge property value. Estimated remaining battery charge in percentage reported by the media endpoint.
     * @param value Value to set for the wifiBatteryCharge property.
     */
    set wifiBatteryCharge(value) {
        this._wifiBatteryCharge = value;
    }
    ;
    /**
     * Gets the wifiChannel property value. WiFi channel used by the media endpoint.
     * @returns a integer
     */
    get wifiChannel() {
        return this._wifiChannel;
    }
    ;
    /**
     * Sets the wifiChannel property value. WiFi channel used by the media endpoint.
     * @param value Value to set for the wifiChannel property.
     */
    set wifiChannel(value) {
        this._wifiChannel = value;
    }
    ;
    /**
     * Gets the wifiMicrosoftDriver property value. Name of the Microsoft WiFi driver used by the media endpoint. Value may be localized based on the language used by endpoint.
     * @returns a string
     */
    get wifiMicrosoftDriver() {
        return this._wifiMicrosoftDriver;
    }
    ;
    /**
     * Sets the wifiMicrosoftDriver property value. Name of the Microsoft WiFi driver used by the media endpoint. Value may be localized based on the language used by endpoint.
     * @param value Value to set for the wifiMicrosoftDriver property.
     */
    set wifiMicrosoftDriver(value) {
        this._wifiMicrosoftDriver = value;
    }
    ;
    /**
     * Gets the wifiMicrosoftDriverVersion property value. Version of the Microsoft WiFi driver used by the media endpoint.
     * @returns a string
     */
    get wifiMicrosoftDriverVersion() {
        return this._wifiMicrosoftDriverVersion;
    }
    ;
    /**
     * Sets the wifiMicrosoftDriverVersion property value. Version of the Microsoft WiFi driver used by the media endpoint.
     * @param value Value to set for the wifiMicrosoftDriverVersion property.
     */
    set wifiMicrosoftDriverVersion(value) {
        this._wifiMicrosoftDriverVersion = value;
    }
    ;
    /**
     * Gets the wifiRadioType property value. Type of WiFi radio used by the media endpoint. Possible values are: unknown, wifi80211a, wifi80211b, wifi80211g, wifi80211n, wifi80211ac, wifi80211ax, unknownFutureValue.
     * @returns a wifiRadioType
     */
    get wifiRadioType() {
        return this._wifiRadioType;
    }
    ;
    /**
     * Sets the wifiRadioType property value. Type of WiFi radio used by the media endpoint. Possible values are: unknown, wifi80211a, wifi80211b, wifi80211g, wifi80211n, wifi80211ac, wifi80211ax, unknownFutureValue.
     * @param value Value to set for the wifiRadioType property.
     */
    set wifiRadioType(value) {
        this._wifiRadioType = value;
    }
    ;
    /**
     * Gets the wifiSignalStrength property value. WiFi signal strength in percentage reported by the media endpoint.
     * @returns a integer
     */
    get wifiSignalStrength() {
        return this._wifiSignalStrength;
    }
    ;
    /**
     * Sets the wifiSignalStrength property value. WiFi signal strength in percentage reported by the media endpoint.
     * @param value Value to set for the wifiSignalStrength property.
     */
    set wifiSignalStrength(value) {
        this._wifiSignalStrength = value;
    }
    ;
    /**
     * Gets the wifiVendorDriver property value. Name of the WiFi driver used by the media endpoint. Value may be localized based on the language used by endpoint.
     * @returns a string
     */
    get wifiVendorDriver() {
        return this._wifiVendorDriver;
    }
    ;
    /**
     * Sets the wifiVendorDriver property value. Name of the WiFi driver used by the media endpoint. Value may be localized based on the language used by endpoint.
     * @param value Value to set for the wifiVendorDriver property.
     */
    set wifiVendorDriver(value) {
        this._wifiVendorDriver = value;
    }
    ;
    /**
     * Gets the wifiVendorDriverVersion property value. Version of the WiFi driver used by the media endpoint.
     * @returns a string
     */
    get wifiVendorDriverVersion() {
        return this._wifiVendorDriverVersion;
    }
    ;
    /**
     * Sets the wifiVendorDriverVersion property value. Version of the WiFi driver used by the media endpoint.
     * @param value Value to set for the wifiVendorDriverVersion property.
     */
    set wifiVendorDriverVersion(value) {
        this._wifiVendorDriverVersion = value;
    }
    ;
}
exports.NetworkInfo = NetworkInfo;
