"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserAgent = void 0;
class UserAgent {
    /**
     * Instantiates a new userAgent and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the applicationVersion property value. Identifies the version of application software used by this endpoint.
     * @returns a string
     */
    get applicationVersion() {
        return this._applicationVersion;
    }
    ;
    /**
     * Sets the applicationVersion property value. Identifies the version of application software used by this endpoint.
     * @param value Value to set for the applicationVersion property.
     */
    set applicationVersion(value) {
        this._applicationVersion = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "applicationVersion": (o, n) => { o.applicationVersion = n.getStringValue(); },
            "headerValue": (o, n) => { o.headerValue = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the headerValue property value. User-agent header value reported by this endpoint.
     * @returns a string
     */
    get headerValue() {
        return this._headerValue;
    }
    ;
    /**
     * Sets the headerValue property value. User-agent header value reported by this endpoint.
     * @param value Value to set for the headerValue property.
     */
    set headerValue(value) {
        this._headerValue = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("applicationVersion", this.applicationVersion);
        writer.writeStringValue("headerValue", this.headerValue);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.UserAgent = UserAgent;
