"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CallRoute = void 0;
const createIdentitySetFromDiscriminatorValue_1 = require("./createIdentitySetFromDiscriminatorValue");
const routingType_1 = require("./routingType");
class CallRoute {
    /**
     * Instantiates a new callRoute and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the final property value.
     * @returns a identitySet
     */
    get final() {
        return this._final;
    }
    ;
    /**
     * Sets the final property value.
     * @param value Value to set for the final property.
     */
    set final(value) {
        this._final = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "final": (o, n) => { o.final = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); },
            "original": (o, n) => { o.original = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); },
            "routingType": (o, n) => { o.routingType = n.getEnumValue(routingType_1.RoutingType); },
        };
    }
    ;
    /**
     * Gets the original property value.
     * @returns a identitySet
     */
    get original() {
        return this._original;
    }
    ;
    /**
     * Sets the original property value.
     * @param value Value to set for the original property.
     */
    set original(value) {
        this._original = value;
    }
    ;
    /**
     * Gets the routingType property value. Possible values are: forwarded, lookup, selfFork.
     * @returns a routingType
     */
    get routingType() {
        return this._routingType;
    }
    ;
    /**
     * Sets the routingType property value. Possible values are: forwarded, lookup, selfFork.
     * @param value Value to set for the routingType property.
     */
    set routingType(value) {
        this._routingType = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("final", this.final);
        writer.writeObjectValue("original", this.original);
        writer.writeEnumValue("routingType", this.routingType);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.CallRoute = CallRoute;
