"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CertificateBasedAuthConfiguration = void 0;
const createCertificateAuthorityFromDiscriminatorValue_1 = require("./createCertificateAuthorityFromDiscriminatorValue");
const index_1 = require("./index");
class CertificateBasedAuthConfiguration extends index_1.Entity {
    /**
     * Instantiates a new certificateBasedAuthConfiguration and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the certificateAuthorities property value. Collection of certificate authorities which creates a trusted certificate chain.
     * @returns a certificateAuthority
     */
    get certificateAuthorities() {
        return this._certificateAuthorities;
    }
    ;
    /**
     * Sets the certificateAuthorities property value. Collection of certificate authorities which creates a trusted certificate chain.
     * @param value Value to set for the certificateAuthorities property.
     */
    set certificateAuthorities(value) {
        this._certificateAuthorities = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "certificateAuthorities": (o, n) => { o.certificateAuthorities = n.getCollectionOfObjectValues(createCertificateAuthorityFromDiscriminatorValue_1.createCertificateAuthorityFromDiscriminatorValue); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("certificateAuthorities", this.certificateAuthorities);
    }
    ;
}
exports.CertificateBasedAuthConfiguration = CertificateBasedAuthConfiguration;
