"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChatMessageMentionedIdentitySet = void 0;
const createTeamworkConversationIdentityFromDiscriminatorValue_1 = require("./createTeamworkConversationIdentityFromDiscriminatorValue");
const index_1 = require("./index");
class ChatMessageMentionedIdentitySet extends index_1.IdentitySet {
    /**
     * Instantiates a new chatMessageMentionedIdentitySet and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the conversation property value. If present, represents a conversation (for example, team or channel) @mentioned in a message.
     * @returns a teamworkConversationIdentity
     */
    get conversation() {
        return this._conversation;
    }
    ;
    /**
     * Sets the conversation property value. If present, represents a conversation (for example, team or channel) @mentioned in a message.
     * @param value Value to set for the conversation property.
     */
    set conversation(value) {
        this._conversation = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "conversation": (o, n) => { o.conversation = n.getObjectValue(createTeamworkConversationIdentityFromDiscriminatorValue_1.createTeamworkConversationIdentityFromDiscriminatorValue); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("conversation", this.conversation);
    }
    ;
}
exports.ChatMessageMentionedIdentitySet = ChatMessageMentionedIdentitySet;
