"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChatMessagePolicyViolation = void 0;
const chatMessagePolicyViolationDlpActionTypes_1 = require("./chatMessagePolicyViolationDlpActionTypes");
const chatMessagePolicyViolationUserActionTypes_1 = require("./chatMessagePolicyViolationUserActionTypes");
const chatMessagePolicyViolationVerdictDetailsTypes_1 = require("./chatMessagePolicyViolationVerdictDetailsTypes");
const createChatMessagePolicyViolationPolicyTipFromDiscriminatorValue_1 = require("./createChatMessagePolicyViolationPolicyTipFromDiscriminatorValue");
class ChatMessagePolicyViolation {
    /**
     * Instantiates a new chatMessagePolicyViolation and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the dlpAction property value. The action taken by the DLP provider on the message with sensitive content. Supported values are: NoneNotifySender -- Inform the sender of the violation but allow readers to read the message.BlockAccess -- Block readers from reading the message.BlockAccessExternal -- Block users outside the organization from reading the message, while allowing users within the organization to read the message.
     * @returns a chatMessagePolicyViolationDlpActionTypes
     */
    get dlpAction() {
        return this._dlpAction;
    }
    ;
    /**
     * Sets the dlpAction property value. The action taken by the DLP provider on the message with sensitive content. Supported values are: NoneNotifySender -- Inform the sender of the violation but allow readers to read the message.BlockAccess -- Block readers from reading the message.BlockAccessExternal -- Block users outside the organization from reading the message, while allowing users within the organization to read the message.
     * @param value Value to set for the dlpAction property.
     */
    set dlpAction(value) {
        this._dlpAction = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "dlpAction": (o, n) => { o.dlpAction = n.getEnumValue(chatMessagePolicyViolationDlpActionTypes_1.ChatMessagePolicyViolationDlpActionTypes); },
            "justificationText": (o, n) => { o.justificationText = n.getStringValue(); },
            "policyTip": (o, n) => { o.policyTip = n.getObjectValue(createChatMessagePolicyViolationPolicyTipFromDiscriminatorValue_1.createChatMessagePolicyViolationPolicyTipFromDiscriminatorValue); },
            "userAction": (o, n) => { o.userAction = n.getEnumValue(chatMessagePolicyViolationUserActionTypes_1.ChatMessagePolicyViolationUserActionTypes); },
            "verdictDetails": (o, n) => { o.verdictDetails = n.getEnumValue(chatMessagePolicyViolationVerdictDetailsTypes_1.ChatMessagePolicyViolationVerdictDetailsTypes); },
        };
    }
    ;
    /**
     * Gets the justificationText property value. Justification text provided by the sender of the message when overriding a policy violation.
     * @returns a string
     */
    get justificationText() {
        return this._justificationText;
    }
    ;
    /**
     * Sets the justificationText property value. Justification text provided by the sender of the message when overriding a policy violation.
     * @param value Value to set for the justificationText property.
     */
    set justificationText(value) {
        this._justificationText = value;
    }
    ;
    /**
     * Gets the policyTip property value. Information to display to the message sender about why the message was flagged as a violation.
     * @returns a chatMessagePolicyViolationPolicyTip
     */
    get policyTip() {
        return this._policyTip;
    }
    ;
    /**
     * Sets the policyTip property value. Information to display to the message sender about why the message was flagged as a violation.
     * @param value Value to set for the policyTip property.
     */
    set policyTip(value) {
        this._policyTip = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeEnumValue("dlpAction", this.dlpAction);
        writer.writeStringValue("justificationText", this.justificationText);
        writer.writeObjectValue("policyTip", this.policyTip);
        writer.writeEnumValue("userAction", this.userAction);
        writer.writeEnumValue("verdictDetails", this.verdictDetails);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the userAction property value. Indicates the action taken by the user on a message blocked by the DLP provider. Supported values are: NoneOverrideReportFalsePositiveWhen the DLP provider is updating the message for blocking sensitive content, userAction is not required.
     * @returns a chatMessagePolicyViolationUserActionTypes
     */
    get userAction() {
        return this._userAction;
    }
    ;
    /**
     * Sets the userAction property value. Indicates the action taken by the user on a message blocked by the DLP provider. Supported values are: NoneOverrideReportFalsePositiveWhen the DLP provider is updating the message for blocking sensitive content, userAction is not required.
     * @param value Value to set for the userAction property.
     */
    set userAction(value) {
        this._userAction = value;
    }
    ;
    /**
     * Gets the verdictDetails property value. Indicates what actions the sender may take in response to the policy violation. Supported values are: NoneAllowFalsePositiveOverride -- Allows the sender to declare the policyViolation to be an error in the DLP app and its rules, and allow readers to see the message again if the dlpAction had hidden it.AllowOverrideWithoutJustification -- Allows the sender to overriide the DLP violation and allow readers to see the message again if the dlpAction had hidden it, without needing to provide an explanation for doing so. AllowOverrideWithJustification -- Allows the sender to overriide the DLP violation and allow readers to see the message again if the dlpAction had hidden it, after providing an explanation for doing so.AllowOverrideWithoutJustification and AllowOverrideWithJustification are mutually exclusive.
     * @returns a chatMessagePolicyViolationVerdictDetailsTypes
     */
    get verdictDetails() {
        return this._verdictDetails;
    }
    ;
    /**
     * Sets the verdictDetails property value. Indicates what actions the sender may take in response to the policy violation. Supported values are: NoneAllowFalsePositiveOverride -- Allows the sender to declare the policyViolation to be an error in the DLP app and its rules, and allow readers to see the message again if the dlpAction had hidden it.AllowOverrideWithoutJustification -- Allows the sender to overriide the DLP violation and allow readers to see the message again if the dlpAction had hidden it, without needing to provide an explanation for doing so. AllowOverrideWithJustification -- Allows the sender to overriide the DLP violation and allow readers to see the message again if the dlpAction had hidden it, after providing an explanation for doing so.AllowOverrideWithoutJustification and AllowOverrideWithJustification are mutually exclusive.
     * @param value Value to set for the verdictDetails property.
     */
    set verdictDetails(value) {
        this._verdictDetails = value;
    }
    ;
}
exports.ChatMessagePolicyViolation = ChatMessagePolicyViolation;
