"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChatMessagePolicyViolationPolicyTip = void 0;
class ChatMessagePolicyViolationPolicyTip {
    /**
     * Instantiates a new chatMessagePolicyViolationPolicyTip and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the complianceUrl property value. The URL a user can visit to read about the data loss prevention policies for the organization. (ie, policies about what users shouldn't say in chats)
     * @returns a string
     */
    get complianceUrl() {
        return this._complianceUrl;
    }
    ;
    /**
     * Sets the complianceUrl property value. The URL a user can visit to read about the data loss prevention policies for the organization. (ie, policies about what users shouldn't say in chats)
     * @param value Value to set for the complianceUrl property.
     */
    set complianceUrl(value) {
        this._complianceUrl = value;
    }
    ;
    ;
    /**
     * Gets the generalText property value. Explanatory text shown to the sender of the message.
     * @returns a string
     */
    get generalText() {
        return this._generalText;
    }
    ;
    /**
     * Sets the generalText property value. Explanatory text shown to the sender of the message.
     * @param value Value to set for the generalText property.
     */
    set generalText(value) {
        this._generalText = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "complianceUrl": (o, n) => { o.complianceUrl = n.getStringValue(); },
            "generalText": (o, n) => { o.generalText = n.getStringValue(); },
            "matchedConditionDescriptions": (o, n) => { o.matchedConditionDescriptions = n.getCollectionOfPrimitiveValues(); },
        };
    }
    ;
    /**
     * Gets the matchedConditionDescriptions property value. The list of improper data in the message that was detected by the data loss prevention app. Each DLP app defines its own conditions, examples include 'Credit Card Number' and 'Social Security Number'.
     * @returns a string
     */
    get matchedConditionDescriptions() {
        return this._matchedConditionDescriptions;
    }
    ;
    /**
     * Sets the matchedConditionDescriptions property value. The list of improper data in the message that was detected by the data loss prevention app. Each DLP app defines its own conditions, examples include 'Credit Card Number' and 'Social Security Number'.
     * @param value Value to set for the matchedConditionDescriptions property.
     */
    set matchedConditionDescriptions(value) {
        this._matchedConditionDescriptions = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("complianceUrl", this.complianceUrl);
        writer.writeStringValue("generalText", this.generalText);
        writer.writeCollectionOfPrimitiveValues("matchedConditionDescriptions", this.matchedConditionDescriptions);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ChatMessagePolicyViolationPolicyTip = ChatMessagePolicyViolationPolicyTip;
