"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChatMessageReaction = void 0;
const createChatMessageReactionIdentitySetFromDiscriminatorValue_1 = require("./createChatMessageReactionIdentitySetFromDiscriminatorValue");
class ChatMessageReaction {
    /**
     * Instantiates a new chatMessageReaction and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the createdDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); },
            "reactionType": (o, n) => { o.reactionType = n.getStringValue(); },
            "user": (o, n) => { o.user = n.getObjectValue(createChatMessageReactionIdentitySetFromDiscriminatorValue_1.createChatMessageReactionIdentitySetFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the reactionType property value. Supported values are like, angry, sad, laugh, heart, surprised.
     * @returns a string
     */
    get reactionType() {
        return this._reactionType;
    }
    ;
    /**
     * Sets the reactionType property value. Supported values are like, angry, sad, laugh, heart, surprised.
     * @param value Value to set for the reactionType property.
     */
    set reactionType(value) {
        this._reactionType = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeStringValue("reactionType", this.reactionType);
        writer.writeObjectValue("user", this.user);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the user property value.
     * @returns a chatMessageReactionIdentitySet
     */
    get user() {
        return this._user;
    }
    ;
    /**
     * Sets the user property value.
     * @param value Value to set for the user property.
     */
    set user(value) {
        this._user = value;
    }
    ;
}
exports.ChatMessageReaction = ChatMessageReaction;
