"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChoiceColumn = void 0;
class ChoiceColumn {
    /**
     * Instantiates a new choiceColumn and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the allowTextEntry property value. If true, allows custom values that aren't in the configured choices.
     * @returns a boolean
     */
    get allowTextEntry() {
        return this._allowTextEntry;
    }
    ;
    /**
     * Sets the allowTextEntry property value. If true, allows custom values that aren't in the configured choices.
     * @param value Value to set for the allowTextEntry property.
     */
    set allowTextEntry(value) {
        this._allowTextEntry = value;
    }
    ;
    /**
     * Gets the choices property value. The list of values available for this column.
     * @returns a string
     */
    get choices() {
        return this._choices;
    }
    ;
    /**
     * Sets the choices property value. The list of values available for this column.
     * @param value Value to set for the choices property.
     */
    set choices(value) {
        this._choices = value;
    }
    ;
    ;
    /**
     * Gets the displayAs property value. How the choices are to be presented in the UX. Must be one of checkBoxes, dropDownMenu, or radioButtons
     * @returns a string
     */
    get displayAs() {
        return this._displayAs;
    }
    ;
    /**
     * Sets the displayAs property value. How the choices are to be presented in the UX. Must be one of checkBoxes, dropDownMenu, or radioButtons
     * @param value Value to set for the displayAs property.
     */
    set displayAs(value) {
        this._displayAs = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "allowTextEntry": (o, n) => { o.allowTextEntry = n.getBooleanValue(); },
            "choices": (o, n) => { o.choices = n.getCollectionOfPrimitiveValues(); },
            "displayAs": (o, n) => { o.displayAs = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("allowTextEntry", this.allowTextEntry);
        writer.writeCollectionOfPrimitiveValues("choices", this.choices);
        writer.writeStringValue("displayAs", this.displayAs);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ChoiceColumn = ChoiceColumn;
