"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CloudAppSecurityState = void 0;
class CloudAppSecurityState {
    /**
     * Instantiates a new cloudAppSecurityState and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the destinationServiceIp property value. Destination IP Address of the connection to the cloud application/service.
     * @returns a string
     */
    get destinationServiceIp() {
        return this._destinationServiceIp;
    }
    ;
    /**
     * Sets the destinationServiceIp property value. Destination IP Address of the connection to the cloud application/service.
     * @param value Value to set for the destinationServiceIp property.
     */
    set destinationServiceIp(value) {
        this._destinationServiceIp = value;
    }
    ;
    /**
     * Gets the destinationServiceName property value. Cloud application/service name (for example 'Salesforce', 'DropBox', etc.).
     * @returns a string
     */
    get destinationServiceName() {
        return this._destinationServiceName;
    }
    ;
    /**
     * Sets the destinationServiceName property value. Cloud application/service name (for example 'Salesforce', 'DropBox', etc.).
     * @param value Value to set for the destinationServiceName property.
     */
    set destinationServiceName(value) {
        this._destinationServiceName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "destinationServiceIp": (o, n) => { o.destinationServiceIp = n.getStringValue(); },
            "destinationServiceName": (o, n) => { o.destinationServiceName = n.getStringValue(); },
            "riskScore": (o, n) => { o.riskScore = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the riskScore property value. Provider-generated/calculated risk score of the Cloud Application/Service. Recommended value range of 0-1, which equates to a percentage.
     * @returns a string
     */
    get riskScore() {
        return this._riskScore;
    }
    ;
    /**
     * Sets the riskScore property value. Provider-generated/calculated risk score of the Cloud Application/Service. Recommended value range of 0-1, which equates to a percentage.
     * @param value Value to set for the riskScore property.
     */
    set riskScore(value) {
        this._riskScore = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("destinationServiceIp", this.destinationServiceIp);
        writer.writeStringValue("destinationServiceName", this.destinationServiceName);
        writer.writeStringValue("riskScore", this.riskScore);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.CloudAppSecurityState = CloudAppSecurityState;
