import { CallRecord } from './callRecords/';
import { Call, Entity, OnlineMeeting, Presence } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to manage the cloudCommunications singleton.  */
export declare class CloudCommunications extends Entity implements Parsable {
    private _callRecords?;
    private _calls?;
    private _onlineMeetings?;
    private _presences?;
    /**
     * Gets the callRecords property value.
     * @returns a callRecord
     */
    get callRecords(): CallRecord[] | undefined;
    /**
     * Sets the callRecords property value.
     * @param value Value to set for the callRecords property.
     */
    set callRecords(value: CallRecord[] | undefined);
    /**
     * Gets the calls property value.
     * @returns a call
     */
    get calls(): Call[] | undefined;
    /**
     * Sets the calls property value.
     * @param value Value to set for the calls property.
     */
    set calls(value: Call[] | undefined);
    /**
     * Instantiates a new cloudCommunications and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the onlineMeetings property value.
     * @returns a onlineMeeting
     */
    get onlineMeetings(): OnlineMeeting[] | undefined;
    /**
     * Sets the onlineMeetings property value.
     * @param value Value to set for the onlineMeetings property.
     */
    set onlineMeetings(value: OnlineMeeting[] | undefined);
    /**
     * Gets the presences property value.
     * @returns a presence
     */
    get presences(): Presence[] | undefined;
    /**
     * Sets the presences property value.
     * @param value Value to set for the presences property.
     */
    set presences(value: Presence[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
