"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CloudCommunications = void 0;
const createCallRecordFromDiscriminatorValue_1 = require("./callRecords/createCallRecordFromDiscriminatorValue");
const createCallFromDiscriminatorValue_1 = require("./createCallFromDiscriminatorValue");
const createOnlineMeetingFromDiscriminatorValue_1 = require("./createOnlineMeetingFromDiscriminatorValue");
const createPresenceFromDiscriminatorValue_1 = require("./createPresenceFromDiscriminatorValue");
const index_1 = require("./index");
/** Provides operations to manage the cloudCommunications singleton.  */
class CloudCommunications extends index_1.Entity {
    /**
     * Instantiates a new cloudCommunications and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the callRecords property value.
     * @returns a callRecord
     */
    get callRecords() {
        return this._callRecords;
    }
    ;
    /**
     * Sets the callRecords property value.
     * @param value Value to set for the callRecords property.
     */
    set callRecords(value) {
        this._callRecords = value;
    }
    ;
    /**
     * Gets the calls property value.
     * @returns a call
     */
    get calls() {
        return this._calls;
    }
    ;
    /**
     * Sets the calls property value.
     * @param value Value to set for the calls property.
     */
    set calls(value) {
        this._calls = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "callRecords": (o, n) => { o.callRecords = n.getCollectionOfObjectValues(createCallRecordFromDiscriminatorValue_1.createCallRecordFromDiscriminatorValue); }, "calls": (o, n) => { o.calls = n.getCollectionOfObjectValues(createCallFromDiscriminatorValue_1.createCallFromDiscriminatorValue); }, "onlineMeetings": (o, n) => { o.onlineMeetings = n.getCollectionOfObjectValues(createOnlineMeetingFromDiscriminatorValue_1.createOnlineMeetingFromDiscriminatorValue); }, "presences": (o, n) => { o.presences = n.getCollectionOfObjectValues(createPresenceFromDiscriminatorValue_1.createPresenceFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the onlineMeetings property value.
     * @returns a onlineMeeting
     */
    get onlineMeetings() {
        return this._onlineMeetings;
    }
    ;
    /**
     * Sets the onlineMeetings property value.
     * @param value Value to set for the onlineMeetings property.
     */
    set onlineMeetings(value) {
        this._onlineMeetings = value;
    }
    ;
    /**
     * Gets the presences property value.
     * @returns a presence
     */
    get presences() {
        return this._presences;
    }
    ;
    /**
     * Sets the presences property value.
     * @param value Value to set for the presences property.
     */
    set presences(value) {
        this._presences = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("callRecords", this.callRecords);
        writer.writeCollectionOfObjectValues("calls", this.calls);
        writer.writeCollectionOfObjectValues("onlineMeetings", this.onlineMeetings);
        writer.writeCollectionOfObjectValues("presences", this.presences);
    }
    ;
}
exports.CloudCommunications = CloudCommunications;
