"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ColumnValidation = void 0;
const createDisplayNameLocalizationFromDiscriminatorValue_1 = require("./createDisplayNameLocalizationFromDiscriminatorValue");
class ColumnValidation {
    /**
     * Instantiates a new columnValidation and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the defaultLanguage property value. Default BCP 47 language tag for the description.
     * @returns a string
     */
    get defaultLanguage() {
        return this._defaultLanguage;
    }
    ;
    /**
     * Sets the defaultLanguage property value. Default BCP 47 language tag for the description.
     * @param value Value to set for the defaultLanguage property.
     */
    set defaultLanguage(value) {
        this._defaultLanguage = value;
    }
    ;
    /**
     * Gets the descriptions property value. Localized messages that explain what is needed for this column's value to be considered valid. User will be prompted with this message if validation fails.
     * @returns a displayNameLocalization
     */
    get descriptions() {
        return this._descriptions;
    }
    ;
    /**
     * Sets the descriptions property value. Localized messages that explain what is needed for this column's value to be considered valid. User will be prompted with this message if validation fails.
     * @param value Value to set for the descriptions property.
     */
    set descriptions(value) {
        this._descriptions = value;
    }
    ;
    /**
     * Gets the formula property value. The formula to validate column value. For examples, see Examples of common formulas in lists.
     * @returns a string
     */
    get formula() {
        return this._formula;
    }
    ;
    /**
     * Sets the formula property value. The formula to validate column value. For examples, see Examples of common formulas in lists.
     * @param value Value to set for the formula property.
     */
    set formula(value) {
        this._formula = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "defaultLanguage": (o, n) => { o.defaultLanguage = n.getStringValue(); },
            "descriptions": (o, n) => { o.descriptions = n.getCollectionOfObjectValues(createDisplayNameLocalizationFromDiscriminatorValue_1.createDisplayNameLocalizationFromDiscriminatorValue); },
            "formula": (o, n) => { o.formula = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("defaultLanguage", this.defaultLanguage);
        writer.writeCollectionOfObjectValues("descriptions", this.descriptions);
        writer.writeStringValue("formula", this.formula);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ColumnValidation = ColumnValidation;
