import { Entity, ResultInfo } from './index';
import { OperationStatus } from './operationStatus';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class CommsOperation extends Entity implements Parsable {
    /** Unique Client Context string. Max limit is 256 chars.  */
    private _clientContext?;
    /** The result information. Read-only.  */
    private _resultInfo?;
    /** Possible values are: notStarted, running, completed, failed. Read-only.  */
    private _status?;
    /**
     * Gets the clientContext property value. Unique Client Context string. Max limit is 256 chars.
     * @returns a string
     */
    get clientContext(): string | undefined;
    /**
     * Sets the clientContext property value. Unique Client Context string. Max limit is 256 chars.
     * @param value Value to set for the clientContext property.
     */
    set clientContext(value: string | undefined);
    /**
     * Instantiates a new commsOperation and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the resultInfo property value. The result information. Read-only.
     * @returns a resultInfo
     */
    get resultInfo(): ResultInfo | undefined;
    /**
     * Sets the resultInfo property value. The result information. Read-only.
     * @param value Value to set for the resultInfo property.
     */
    set resultInfo(value: ResultInfo | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the status property value. Possible values are: notStarted, running, completed, failed. Read-only.
     * @returns a operationStatus
     */
    get status(): OperationStatus | undefined;
    /**
     * Sets the status property value. Possible values are: notStarted, running, completed, failed. Read-only.
     * @param value Value to set for the status property.
     */
    set status(value: OperationStatus | undefined);
}
