"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommsOperation = void 0;
const createResultInfoFromDiscriminatorValue_1 = require("./createResultInfoFromDiscriminatorValue");
const index_1 = require("./index");
const operationStatus_1 = require("./operationStatus");
class CommsOperation extends index_1.Entity {
    /**
     * Instantiates a new commsOperation and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the clientContext property value. Unique Client Context string. Max limit is 256 chars.
     * @returns a string
     */
    get clientContext() {
        return this._clientContext;
    }
    ;
    /**
     * Sets the clientContext property value. Unique Client Context string. Max limit is 256 chars.
     * @param value Value to set for the clientContext property.
     */
    set clientContext(value) {
        this._clientContext = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "clientContext": (o, n) => { o.clientContext = n.getStringValue(); }, "resultInfo": (o, n) => { o.resultInfo = n.getObjectValue(createResultInfoFromDiscriminatorValue_1.createResultInfoFromDiscriminatorValue); }, "status": (o, n) => { o.status = n.getEnumValue(operationStatus_1.OperationStatus); } });
    }
    ;
    /**
     * Gets the resultInfo property value. The result information. Read-only.
     * @returns a resultInfo
     */
    get resultInfo() {
        return this._resultInfo;
    }
    ;
    /**
     * Sets the resultInfo property value. The result information. Read-only.
     * @param value Value to set for the resultInfo property.
     */
    set resultInfo(value) {
        this._resultInfo = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("clientContext", this.clientContext);
        writer.writeObjectValue("resultInfo", this.resultInfo);
        writer.writeEnumValue("status", this.status);
    }
    ;
    /**
     * Gets the status property value. Possible values are: notStarted, running, completed, failed. Read-only.
     * @returns a operationStatus
     */
    get status() {
        return this._status;
    }
    ;
    /**
     * Sets the status property value. Possible values are: notStarted, running, completed, failed. Read-only.
     * @param value Value to set for the status property.
     */
    set status(value) {
        this._status = value;
    }
    ;
}
exports.CommsOperation = CommsOperation;
