"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComplianceInformation = void 0;
const createCertificationControlFromDiscriminatorValue_1 = require("./createCertificationControlFromDiscriminatorValue");
class ComplianceInformation {
    /**
     * Instantiates a new complianceInformation and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the certificationControls property value. Collection of the certification controls associated with certification
     * @returns a certificationControl
     */
    get certificationControls() {
        return this._certificationControls;
    }
    ;
    /**
     * Sets the certificationControls property value. Collection of the certification controls associated with certification
     * @param value Value to set for the certificationControls property.
     */
    set certificationControls(value) {
        this._certificationControls = value;
    }
    ;
    /**
     * Gets the certificationName property value. Compliance certification name (for example, ISO 27018:2014, GDPR, FedRAMP, NIST 800-171)
     * @returns a string
     */
    get certificationName() {
        return this._certificationName;
    }
    ;
    /**
     * Sets the certificationName property value. Compliance certification name (for example, ISO 27018:2014, GDPR, FedRAMP, NIST 800-171)
     * @param value Value to set for the certificationName property.
     */
    set certificationName(value) {
        this._certificationName = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "certificationControls": (o, n) => { o.certificationControls = n.getCollectionOfObjectValues(createCertificationControlFromDiscriminatorValue_1.createCertificationControlFromDiscriminatorValue); },
            "certificationName": (o, n) => { o.certificationName = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfObjectValues("certificationControls", this.certificationControls);
        writer.writeStringValue("certificationName", this.certificationName);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ComplianceInformation = ComplianceInformation;
