import { DeviceManagementPartnerTenantState } from './deviceManagementPartnerTenantState';
import { ComplianceManagementPartnerAssignment, Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ComplianceManagementPartner extends Entity implements Parsable {
    /** User groups which enroll Android devices through partner.  */
    private _androidEnrollmentAssignments?;
    /** Partner onboarded for Android devices.  */
    private _androidOnboarded?;
    /** Partner display name  */
    private _displayName?;
    /** User groups which enroll ios devices through partner.  */
    private _iosEnrollmentAssignments?;
    /** Partner onboarded for ios devices.  */
    private _iosOnboarded?;
    /** Timestamp of last heartbeat after admin onboarded to the compliance management partner  */
    private _lastHeartbeatDateTime?;
    /** User groups which enroll Mac devices through partner.  */
    private _macOsEnrollmentAssignments?;
    /** Partner onboarded for Mac devices.  */
    private _macOsOnboarded?;
    /** Partner state of this tenant. Possible values are: unknown, unavailable, enabled, terminated, rejected, unresponsive.  */
    private _partnerState?;
    /**
     * Gets the androidEnrollmentAssignments property value. User groups which enroll Android devices through partner.
     * @returns a complianceManagementPartnerAssignment
     */
    get androidEnrollmentAssignments(): ComplianceManagementPartnerAssignment[] | undefined;
    /**
     * Sets the androidEnrollmentAssignments property value. User groups which enroll Android devices through partner.
     * @param value Value to set for the androidEnrollmentAssignments property.
     */
    set androidEnrollmentAssignments(value: ComplianceManagementPartnerAssignment[] | undefined);
    /**
     * Gets the androidOnboarded property value. Partner onboarded for Android devices.
     * @returns a boolean
     */
    get androidOnboarded(): boolean | undefined;
    /**
     * Sets the androidOnboarded property value. Partner onboarded for Android devices.
     * @param value Value to set for the androidOnboarded property.
     */
    set androidOnboarded(value: boolean | undefined);
    /**
     * Instantiates a new complianceManagementPartner and sets the default values.
     */
    constructor();
    /**
     * Gets the displayName property value. Partner display name
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. Partner display name
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the iosEnrollmentAssignments property value. User groups which enroll ios devices through partner.
     * @returns a complianceManagementPartnerAssignment
     */
    get iosEnrollmentAssignments(): ComplianceManagementPartnerAssignment[] | undefined;
    /**
     * Sets the iosEnrollmentAssignments property value. User groups which enroll ios devices through partner.
     * @param value Value to set for the iosEnrollmentAssignments property.
     */
    set iosEnrollmentAssignments(value: ComplianceManagementPartnerAssignment[] | undefined);
    /**
     * Gets the iosOnboarded property value. Partner onboarded for ios devices.
     * @returns a boolean
     */
    get iosOnboarded(): boolean | undefined;
    /**
     * Sets the iosOnboarded property value. Partner onboarded for ios devices.
     * @param value Value to set for the iosOnboarded property.
     */
    set iosOnboarded(value: boolean | undefined);
    /**
     * Gets the lastHeartbeatDateTime property value. Timestamp of last heartbeat after admin onboarded to the compliance management partner
     * @returns a Date
     */
    get lastHeartbeatDateTime(): Date | undefined;
    /**
     * Sets the lastHeartbeatDateTime property value. Timestamp of last heartbeat after admin onboarded to the compliance management partner
     * @param value Value to set for the lastHeartbeatDateTime property.
     */
    set lastHeartbeatDateTime(value: Date | undefined);
    /**
     * Gets the macOsEnrollmentAssignments property value. User groups which enroll Mac devices through partner.
     * @returns a complianceManagementPartnerAssignment
     */
    get macOsEnrollmentAssignments(): ComplianceManagementPartnerAssignment[] | undefined;
    /**
     * Sets the macOsEnrollmentAssignments property value. User groups which enroll Mac devices through partner.
     * @param value Value to set for the macOsEnrollmentAssignments property.
     */
    set macOsEnrollmentAssignments(value: ComplianceManagementPartnerAssignment[] | undefined);
    /**
     * Gets the macOsOnboarded property value. Partner onboarded for Mac devices.
     * @returns a boolean
     */
    get macOsOnboarded(): boolean | undefined;
    /**
     * Sets the macOsOnboarded property value. Partner onboarded for Mac devices.
     * @param value Value to set for the macOsOnboarded property.
     */
    set macOsOnboarded(value: boolean | undefined);
    /**
     * Gets the partnerState property value. Partner state of this tenant. Possible values are: unknown, unavailable, enabled, terminated, rejected, unresponsive.
     * @returns a deviceManagementPartnerTenantState
     */
    get partnerState(): DeviceManagementPartnerTenantState | undefined;
    /**
     * Sets the partnerState property value. Partner state of this tenant. Possible values are: unknown, unavailable, enabled, terminated, rejected, unresponsive.
     * @param value Value to set for the partnerState property.
     */
    set partnerState(value: DeviceManagementPartnerTenantState | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
