"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComplianceManagementPartner = void 0;
const createComplianceManagementPartnerAssignmentFromDiscriminatorValue_1 = require("./createComplianceManagementPartnerAssignmentFromDiscriminatorValue");
const deviceManagementPartnerTenantState_1 = require("./deviceManagementPartnerTenantState");
const index_1 = require("./index");
class ComplianceManagementPartner extends index_1.Entity {
    /**
     * Instantiates a new complianceManagementPartner and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the androidEnrollmentAssignments property value. User groups which enroll Android devices through partner.
     * @returns a complianceManagementPartnerAssignment
     */
    get androidEnrollmentAssignments() {
        return this._androidEnrollmentAssignments;
    }
    ;
    /**
     * Sets the androidEnrollmentAssignments property value. User groups which enroll Android devices through partner.
     * @param value Value to set for the androidEnrollmentAssignments property.
     */
    set androidEnrollmentAssignments(value) {
        this._androidEnrollmentAssignments = value;
    }
    ;
    /**
     * Gets the androidOnboarded property value. Partner onboarded for Android devices.
     * @returns a boolean
     */
    get androidOnboarded() {
        return this._androidOnboarded;
    }
    ;
    /**
     * Sets the androidOnboarded property value. Partner onboarded for Android devices.
     * @param value Value to set for the androidOnboarded property.
     */
    set androidOnboarded(value) {
        this._androidOnboarded = value;
    }
    ;
    ;
    /**
     * Gets the displayName property value. Partner display name
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. Partner display name
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "androidEnrollmentAssignments": (o, n) => { o.androidEnrollmentAssignments = n.getCollectionOfObjectValues(createComplianceManagementPartnerAssignmentFromDiscriminatorValue_1.createComplianceManagementPartnerAssignmentFromDiscriminatorValue); }, "androidOnboarded": (o, n) => { o.androidOnboarded = n.getBooleanValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "iosEnrollmentAssignments": (o, n) => { o.iosEnrollmentAssignments = n.getCollectionOfObjectValues(createComplianceManagementPartnerAssignmentFromDiscriminatorValue_1.createComplianceManagementPartnerAssignmentFromDiscriminatorValue); }, "iosOnboarded": (o, n) => { o.iosOnboarded = n.getBooleanValue(); }, "lastHeartbeatDateTime": (o, n) => { o.lastHeartbeatDateTime = n.getDateValue(); }, "macOsEnrollmentAssignments": (o, n) => { o.macOsEnrollmentAssignments = n.getCollectionOfObjectValues(createComplianceManagementPartnerAssignmentFromDiscriminatorValue_1.createComplianceManagementPartnerAssignmentFromDiscriminatorValue); }, "macOsOnboarded": (o, n) => { o.macOsOnboarded = n.getBooleanValue(); }, "partnerState": (o, n) => { o.partnerState = n.getEnumValue(deviceManagementPartnerTenantState_1.DeviceManagementPartnerTenantState); } });
    }
    ;
    /**
     * Gets the iosEnrollmentAssignments property value. User groups which enroll ios devices through partner.
     * @returns a complianceManagementPartnerAssignment
     */
    get iosEnrollmentAssignments() {
        return this._iosEnrollmentAssignments;
    }
    ;
    /**
     * Sets the iosEnrollmentAssignments property value. User groups which enroll ios devices through partner.
     * @param value Value to set for the iosEnrollmentAssignments property.
     */
    set iosEnrollmentAssignments(value) {
        this._iosEnrollmentAssignments = value;
    }
    ;
    /**
     * Gets the iosOnboarded property value. Partner onboarded for ios devices.
     * @returns a boolean
     */
    get iosOnboarded() {
        return this._iosOnboarded;
    }
    ;
    /**
     * Sets the iosOnboarded property value. Partner onboarded for ios devices.
     * @param value Value to set for the iosOnboarded property.
     */
    set iosOnboarded(value) {
        this._iosOnboarded = value;
    }
    ;
    /**
     * Gets the lastHeartbeatDateTime property value. Timestamp of last heartbeat after admin onboarded to the compliance management partner
     * @returns a Date
     */
    get lastHeartbeatDateTime() {
        return this._lastHeartbeatDateTime;
    }
    ;
    /**
     * Sets the lastHeartbeatDateTime property value. Timestamp of last heartbeat after admin onboarded to the compliance management partner
     * @param value Value to set for the lastHeartbeatDateTime property.
     */
    set lastHeartbeatDateTime(value) {
        this._lastHeartbeatDateTime = value;
    }
    ;
    /**
     * Gets the macOsEnrollmentAssignments property value. User groups which enroll Mac devices through partner.
     * @returns a complianceManagementPartnerAssignment
     */
    get macOsEnrollmentAssignments() {
        return this._macOsEnrollmentAssignments;
    }
    ;
    /**
     * Sets the macOsEnrollmentAssignments property value. User groups which enroll Mac devices through partner.
     * @param value Value to set for the macOsEnrollmentAssignments property.
     */
    set macOsEnrollmentAssignments(value) {
        this._macOsEnrollmentAssignments = value;
    }
    ;
    /**
     * Gets the macOsOnboarded property value. Partner onboarded for Mac devices.
     * @returns a boolean
     */
    get macOsOnboarded() {
        return this._macOsOnboarded;
    }
    ;
    /**
     * Sets the macOsOnboarded property value. Partner onboarded for Mac devices.
     * @param value Value to set for the macOsOnboarded property.
     */
    set macOsOnboarded(value) {
        this._macOsOnboarded = value;
    }
    ;
    /**
     * Gets the partnerState property value. Partner state of this tenant. Possible values are: unknown, unavailable, enabled, terminated, rejected, unresponsive.
     * @returns a deviceManagementPartnerTenantState
     */
    get partnerState() {
        return this._partnerState;
    }
    ;
    /**
     * Sets the partnerState property value. Partner state of this tenant. Possible values are: unknown, unavailable, enabled, terminated, rejected, unresponsive.
     * @param value Value to set for the partnerState property.
     */
    set partnerState(value) {
        this._partnerState = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("androidEnrollmentAssignments", this.androidEnrollmentAssignments);
        writer.writeBooleanValue("androidOnboarded", this.androidOnboarded);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeCollectionOfObjectValues("iosEnrollmentAssignments", this.iosEnrollmentAssignments);
        writer.writeBooleanValue("iosOnboarded", this.iosOnboarded);
        writer.writeDateValue("lastHeartbeatDateTime", this.lastHeartbeatDateTime);
        writer.writeCollectionOfObjectValues("macOsEnrollmentAssignments", this.macOsEnrollmentAssignments);
        writer.writeBooleanValue("macOsOnboarded", this.macOsOnboarded);
        writer.writeEnumValue("partnerState", this.partnerState);
    }
    ;
}
exports.ComplianceManagementPartner = ComplianceManagementPartner;
