import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ConditionalAccessApplications implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** The list of application IDs explicitly excluded from the policy.  */
    private _excludeApplications?;
    /** The list of application IDs the policy applies to, unless explicitly excluded (in excludeApplications). Can also be set to All.  */
    private _includeApplications?;
    /** Authentication context class references include. Supported values are c1 through c25.  */
    private _includeAuthenticationContextClassReferences?;
    /** User actions to include. Supported values are urn:user:registersecurityinfo and urn:user:registerdevice  */
    private _includeUserActions?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new conditionalAccessApplications and sets the default values.
     */
    constructor();
    /**
     * Gets the excludeApplications property value. The list of application IDs explicitly excluded from the policy.
     * @returns a string
     */
    get excludeApplications(): string[] | undefined;
    /**
     * Sets the excludeApplications property value. The list of application IDs explicitly excluded from the policy.
     * @param value Value to set for the excludeApplications property.
     */
    set excludeApplications(value: string[] | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the includeApplications property value. The list of application IDs the policy applies to, unless explicitly excluded (in excludeApplications). Can also be set to All.
     * @returns a string
     */
    get includeApplications(): string[] | undefined;
    /**
     * Sets the includeApplications property value. The list of application IDs the policy applies to, unless explicitly excluded (in excludeApplications). Can also be set to All.
     * @param value Value to set for the includeApplications property.
     */
    set includeApplications(value: string[] | undefined);
    /**
     * Gets the includeAuthenticationContextClassReferences property value. Authentication context class references include. Supported values are c1 through c25.
     * @returns a string
     */
    get includeAuthenticationContextClassReferences(): string[] | undefined;
    /**
     * Sets the includeAuthenticationContextClassReferences property value. Authentication context class references include. Supported values are c1 through c25.
     * @param value Value to set for the includeAuthenticationContextClassReferences property.
     */
    set includeAuthenticationContextClassReferences(value: string[] | undefined);
    /**
     * Gets the includeUserActions property value. User actions to include. Supported values are urn:user:registersecurityinfo and urn:user:registerdevice
     * @returns a string
     */
    get includeUserActions(): string[] | undefined;
    /**
     * Sets the includeUserActions property value. User actions to include. Supported values are urn:user:registersecurityinfo and urn:user:registerdevice
     * @param value Value to set for the includeUserActions property.
     */
    set includeUserActions(value: string[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
