"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConditionalAccessClientApplications = void 0;
class ConditionalAccessClientApplications {
    /**
     * Instantiates a new conditionalAccessClientApplications and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the excludeServicePrincipals property value. Service principal IDs excluded from the policy scope.
     * @returns a string
     */
    get excludeServicePrincipals() {
        return this._excludeServicePrincipals;
    }
    ;
    /**
     * Sets the excludeServicePrincipals property value. Service principal IDs excluded from the policy scope.
     * @param value Value to set for the excludeServicePrincipals property.
     */
    set excludeServicePrincipals(value) {
        this._excludeServicePrincipals = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "excludeServicePrincipals": (o, n) => { o.excludeServicePrincipals = n.getCollectionOfPrimitiveValues(); },
            "includeServicePrincipals": (o, n) => { o.includeServicePrincipals = n.getCollectionOfPrimitiveValues(); },
        };
    }
    ;
    /**
     * Gets the includeServicePrincipals property value. Service principal IDs included in the policy scope, or ServicePrincipalsInMyTenant.
     * @returns a string
     */
    get includeServicePrincipals() {
        return this._includeServicePrincipals;
    }
    ;
    /**
     * Sets the includeServicePrincipals property value. Service principal IDs included in the policy scope, or ServicePrincipalsInMyTenant.
     * @param value Value to set for the includeServicePrincipals property.
     */
    set includeServicePrincipals(value) {
        this._includeServicePrincipals = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfPrimitiveValues("excludeServicePrincipals", this.excludeServicePrincipals);
        writer.writeCollectionOfPrimitiveValues("includeServicePrincipals", this.includeServicePrincipals);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ConditionalAccessClientApplications = ConditionalAccessClientApplications;
