"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConditionalAccessConditionSet = void 0;
const conditionalAccessClientApp_1 = require("./conditionalAccessClientApp");
const createConditionalAccessApplicationsFromDiscriminatorValue_1 = require("./createConditionalAccessApplicationsFromDiscriminatorValue");
const createConditionalAccessClientApplicationsFromDiscriminatorValue_1 = require("./createConditionalAccessClientApplicationsFromDiscriminatorValue");
const createConditionalAccessDevicesFromDiscriminatorValue_1 = require("./createConditionalAccessDevicesFromDiscriminatorValue");
const createConditionalAccessLocationsFromDiscriminatorValue_1 = require("./createConditionalAccessLocationsFromDiscriminatorValue");
const createConditionalAccessPlatformsFromDiscriminatorValue_1 = require("./createConditionalAccessPlatformsFromDiscriminatorValue");
const createConditionalAccessUsersFromDiscriminatorValue_1 = require("./createConditionalAccessUsersFromDiscriminatorValue");
const riskLevel_1 = require("./riskLevel");
class ConditionalAccessConditionSet {
    /**
     * Instantiates a new conditionalAccessConditionSet and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the applications property value. Applications and user actions included in and excluded from the policy. Required.
     * @returns a conditionalAccessApplications
     */
    get applications() {
        return this._applications;
    }
    ;
    /**
     * Sets the applications property value. Applications and user actions included in and excluded from the policy. Required.
     * @param value Value to set for the applications property.
     */
    set applications(value) {
        this._applications = value;
    }
    ;
    /**
     * Gets the clientApplications property value. Client applications (service principals and workload identities) included in and excluded from the policy. Either users or clientApplications is required.
     * @returns a conditionalAccessClientApplications
     */
    get clientApplications() {
        return this._clientApplications;
    }
    ;
    /**
     * Sets the clientApplications property value. Client applications (service principals and workload identities) included in and excluded from the policy. Either users or clientApplications is required.
     * @param value Value to set for the clientApplications property.
     */
    set clientApplications(value) {
        this._clientApplications = value;
    }
    ;
    /**
     * Gets the clientAppTypes property value. Client application types included in the policy. Possible values are: all, browser, mobileAppsAndDesktopClients, exchangeActiveSync, easSupported, other. Required.
     * @returns a conditionalAccessClientApp
     */
    get clientAppTypes() {
        return this._clientAppTypes;
    }
    ;
    /**
     * Sets the clientAppTypes property value. Client application types included in the policy. Possible values are: all, browser, mobileAppsAndDesktopClients, exchangeActiveSync, easSupported, other. Required.
     * @param value Value to set for the clientAppTypes property.
     */
    set clientAppTypes(value) {
        this._clientAppTypes = value;
    }
    ;
    ;
    /**
     * Gets the devices property value. Devices in the policy.
     * @returns a conditionalAccessDevices
     */
    get devices() {
        return this._devices;
    }
    ;
    /**
     * Sets the devices property value. Devices in the policy.
     * @param value Value to set for the devices property.
     */
    set devices(value) {
        this._devices = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "applications": (o, n) => { o.applications = n.getObjectValue(createConditionalAccessApplicationsFromDiscriminatorValue_1.createConditionalAccessApplicationsFromDiscriminatorValue); },
            "clientApplications": (o, n) => { o.clientApplications = n.getObjectValue(createConditionalAccessClientApplicationsFromDiscriminatorValue_1.createConditionalAccessClientApplicationsFromDiscriminatorValue); },
            "clientAppTypes": (o, n) => { o.clientAppTypes = n.getEnumValues(conditionalAccessClientApp_1.ConditionalAccessClientApp); },
            "devices": (o, n) => { o.devices = n.getObjectValue(createConditionalAccessDevicesFromDiscriminatorValue_1.createConditionalAccessDevicesFromDiscriminatorValue); },
            "locations": (o, n) => { o.locations = n.getObjectValue(createConditionalAccessLocationsFromDiscriminatorValue_1.createConditionalAccessLocationsFromDiscriminatorValue); },
            "platforms": (o, n) => { o.platforms = n.getObjectValue(createConditionalAccessPlatformsFromDiscriminatorValue_1.createConditionalAccessPlatformsFromDiscriminatorValue); },
            "signInRiskLevels": (o, n) => { o.signInRiskLevels = n.getEnumValues(riskLevel_1.RiskLevel); },
            "userRiskLevels": (o, n) => { o.userRiskLevels = n.getEnumValues(riskLevel_1.RiskLevel); },
            "users": (o, n) => { o.users = n.getObjectValue(createConditionalAccessUsersFromDiscriminatorValue_1.createConditionalAccessUsersFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the locations property value. Locations included in and excluded from the policy.
     * @returns a conditionalAccessLocations
     */
    get locations() {
        return this._locations;
    }
    ;
    /**
     * Sets the locations property value. Locations included in and excluded from the policy.
     * @param value Value to set for the locations property.
     */
    set locations(value) {
        this._locations = value;
    }
    ;
    /**
     * Gets the platforms property value. Platforms included in and excluded from the policy.
     * @returns a conditionalAccessPlatforms
     */
    get platforms() {
        return this._platforms;
    }
    ;
    /**
     * Sets the platforms property value. Platforms included in and excluded from the policy.
     * @param value Value to set for the platforms property.
     */
    set platforms(value) {
        this._platforms = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("applications", this.applications);
        writer.writeObjectValue("clientApplications", this.clientApplications);
        this.clientAppTypes && writer.writeEnumValue("clientAppTypes", ...this.clientAppTypes);
        writer.writeObjectValue("devices", this.devices);
        writer.writeObjectValue("locations", this.locations);
        writer.writeObjectValue("platforms", this.platforms);
        this.signInRiskLevels && writer.writeEnumValue("signInRiskLevels", ...this.signInRiskLevels);
        this.userRiskLevels && writer.writeEnumValue("userRiskLevels", ...this.userRiskLevels);
        writer.writeObjectValue("users", this.users);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the signInRiskLevels property value. Sign-in risk levels included in the policy. Possible values are: low, medium, high, hidden, none, unknownFutureValue. Required.
     * @returns a riskLevel
     */
    get signInRiskLevels() {
        return this._signInRiskLevels;
    }
    ;
    /**
     * Sets the signInRiskLevels property value. Sign-in risk levels included in the policy. Possible values are: low, medium, high, hidden, none, unknownFutureValue. Required.
     * @param value Value to set for the signInRiskLevels property.
     */
    set signInRiskLevels(value) {
        this._signInRiskLevels = value;
    }
    ;
    /**
     * Gets the userRiskLevels property value. User risk levels included in the policy. Possible values are: low, medium, high, hidden, none, unknownFutureValue. Required.
     * @returns a riskLevel
     */
    get userRiskLevels() {
        return this._userRiskLevels;
    }
    ;
    /**
     * Sets the userRiskLevels property value. User risk levels included in the policy. Possible values are: low, medium, high, hidden, none, unknownFutureValue. Required.
     * @param value Value to set for the userRiskLevels property.
     */
    set userRiskLevels(value) {
        this._userRiskLevels = value;
    }
    ;
    /**
     * Gets the users property value. Users, groups, and roles included in and excluded from the policy. Required.
     * @returns a conditionalAccessUsers
     */
    get users() {
        return this._users;
    }
    ;
    /**
     * Sets the users property value. Users, groups, and roles included in and excluded from the policy. Required.
     * @param value Value to set for the users property.
     */
    set users(value) {
        this._users = value;
    }
    ;
}
exports.ConditionalAccessConditionSet = ConditionalAccessConditionSet;
