"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConditionalAccessDevices = void 0;
const createConditionalAccessFilterFromDiscriminatorValue_1 = require("./createConditionalAccessFilterFromDiscriminatorValue");
class ConditionalAccessDevices {
    /**
     * Instantiates a new conditionalAccessDevices and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the deviceFilter property value. Filter that defines the dynamic-device-syntax rule to include/exclude devices. A filter can use device properties (such as extension attributes) to include/exclude them.
     * @returns a conditionalAccessFilter
     */
    get deviceFilter() {
        return this._deviceFilter;
    }
    ;
    /**
     * Sets the deviceFilter property value. Filter that defines the dynamic-device-syntax rule to include/exclude devices. A filter can use device properties (such as extension attributes) to include/exclude them.
     * @param value Value to set for the deviceFilter property.
     */
    set deviceFilter(value) {
        this._deviceFilter = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "deviceFilter": (o, n) => { o.deviceFilter = n.getObjectValue(createConditionalAccessFilterFromDiscriminatorValue_1.createConditionalAccessFilterFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("deviceFilter", this.deviceFilter);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ConditionalAccessDevices = ConditionalAccessDevices;
