"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConditionalAccessLocations = void 0;
class ConditionalAccessLocations {
    /**
     * Instantiates a new conditionalAccessLocations and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the excludeLocations property value. Location IDs excluded from scope of policy.
     * @returns a string
     */
    get excludeLocations() {
        return this._excludeLocations;
    }
    ;
    /**
     * Sets the excludeLocations property value. Location IDs excluded from scope of policy.
     * @param value Value to set for the excludeLocations property.
     */
    set excludeLocations(value) {
        this._excludeLocations = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "excludeLocations": (o, n) => { o.excludeLocations = n.getCollectionOfPrimitiveValues(); },
            "includeLocations": (o, n) => { o.includeLocations = n.getCollectionOfPrimitiveValues(); },
        };
    }
    ;
    /**
     * Gets the includeLocations property value. Location IDs in scope of policy unless explicitly excluded, All, or AllTrusted.
     * @returns a string
     */
    get includeLocations() {
        return this._includeLocations;
    }
    ;
    /**
     * Sets the includeLocations property value. Location IDs in scope of policy unless explicitly excluded, All, or AllTrusted.
     * @param value Value to set for the includeLocations property.
     */
    set includeLocations(value) {
        this._includeLocations = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfPrimitiveValues("excludeLocations", this.excludeLocations);
        writer.writeCollectionOfPrimitiveValues("includeLocations", this.includeLocations);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ConditionalAccessLocations = ConditionalAccessLocations;
