import { ConditionalAccessDevicePlatform } from './conditionalAccessDevicePlatform';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ConditionalAccessPlatforms implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Possible values are: android, iOS, windows, windowsPhone, macOS, linux, all, unknownFutureValue.  */
    private _excludePlatforms?;
    /** Possible values are: android, iOS, windows, windowsPhone, macOS, linux, all, unknownFutureValue.  */
    private _includePlatforms?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new conditionalAccessPlatforms and sets the default values.
     */
    constructor();
    /**
     * Gets the excludePlatforms property value. Possible values are: android, iOS, windows, windowsPhone, macOS, linux, all, unknownFutureValue.
     * @returns a conditionalAccessDevicePlatform
     */
    get excludePlatforms(): ConditionalAccessDevicePlatform[] | undefined;
    /**
     * Sets the excludePlatforms property value. Possible values are: android, iOS, windows, windowsPhone, macOS, linux, all, unknownFutureValue.
     * @param value Value to set for the excludePlatforms property.
     */
    set excludePlatforms(value: ConditionalAccessDevicePlatform[] | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the includePlatforms property value. Possible values are: android, iOS, windows, windowsPhone, macOS, linux, all, unknownFutureValue.
     * @returns a conditionalAccessDevicePlatform
     */
    get includePlatforms(): ConditionalAccessDevicePlatform[] | undefined;
    /**
     * Sets the includePlatforms property value. Possible values are: android, iOS, windows, windowsPhone, macOS, linux, all, unknownFutureValue.
     * @param value Value to set for the includePlatforms property.
     */
    set includePlatforms(value: ConditionalAccessDevicePlatform[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
