"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConditionalAccessPlatforms = void 0;
const conditionalAccessDevicePlatform_1 = require("./conditionalAccessDevicePlatform");
class ConditionalAccessPlatforms {
    /**
     * Instantiates a new conditionalAccessPlatforms and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the excludePlatforms property value. Possible values are: android, iOS, windows, windowsPhone, macOS, linux, all, unknownFutureValue.
     * @returns a conditionalAccessDevicePlatform
     */
    get excludePlatforms() {
        return this._excludePlatforms;
    }
    ;
    /**
     * Sets the excludePlatforms property value. Possible values are: android, iOS, windows, windowsPhone, macOS, linux, all, unknownFutureValue.
     * @param value Value to set for the excludePlatforms property.
     */
    set excludePlatforms(value) {
        this._excludePlatforms = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "excludePlatforms": (o, n) => { o.excludePlatforms = n.getEnumValues(conditionalAccessDevicePlatform_1.ConditionalAccessDevicePlatform); },
            "includePlatforms": (o, n) => { o.includePlatforms = n.getEnumValues(conditionalAccessDevicePlatform_1.ConditionalAccessDevicePlatform); },
        };
    }
    ;
    /**
     * Gets the includePlatforms property value. Possible values are: android, iOS, windows, windowsPhone, macOS, linux, all, unknownFutureValue.
     * @returns a conditionalAccessDevicePlatform
     */
    get includePlatforms() {
        return this._includePlatforms;
    }
    ;
    /**
     * Sets the includePlatforms property value. Possible values are: android, iOS, windows, windowsPhone, macOS, linux, all, unknownFutureValue.
     * @param value Value to set for the includePlatforms property.
     */
    set includePlatforms(value) {
        this._includePlatforms = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        this.excludePlatforms && writer.writeEnumValue("excludePlatforms", ...this.excludePlatforms);
        this.includePlatforms && writer.writeEnumValue("includePlatforms", ...this.includePlatforms);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ConditionalAccessPlatforms = ConditionalAccessPlatforms;
