import { ConditionalAccessPolicyState } from './conditionalAccessPolicyState';
import { ConditionalAccessConditionSet, ConditionalAccessGrantControls, ConditionalAccessSessionControls, Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ConditionalAccessPolicy extends Entity implements Parsable {
    private _conditions?;
    /** The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Readonly.  */
    private _createdDateTime?;
    /** Not used.  */
    private _description?;
    /** Specifies a display name for the conditionalAccessPolicy object.  */
    private _displayName?;
    /** Specifies the grant controls that must be fulfilled to pass the policy.  */
    private _grantControls?;
    /** The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Readonly.  */
    private _modifiedDateTime?;
    /** Specifies the session controls that are enforced after sign-in.  */
    private _sessionControls?;
    /** Specifies the state of the conditionalAccessPolicy object. Possible values are: enabled, disabled, enabledForReportingButNotEnforced. Required.  */
    private _state?;
    /**
     * Gets the conditions property value.
     * @returns a conditionalAccessConditionSet
     */
    get conditions(): ConditionalAccessConditionSet | undefined;
    /**
     * Sets the conditions property value.
     * @param value Value to set for the conditions property.
     */
    set conditions(value: ConditionalAccessConditionSet | undefined);
    /**
     * Instantiates a new conditionalAccessPolicy and sets the default values.
     */
    constructor();
    /**
     * Gets the createdDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Readonly.
     * @returns a Date
     */
    get createdDateTime(): Date | undefined;
    /**
     * Sets the createdDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Readonly.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value: Date | undefined);
    /**
     * Gets the description property value. Not used.
     * @returns a string
     */
    get description(): string | undefined;
    /**
     * Sets the description property value. Not used.
     * @param value Value to set for the description property.
     */
    set description(value: string | undefined);
    /**
     * Gets the displayName property value. Specifies a display name for the conditionalAccessPolicy object.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. Specifies a display name for the conditionalAccessPolicy object.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the grantControls property value. Specifies the grant controls that must be fulfilled to pass the policy.
     * @returns a conditionalAccessGrantControls
     */
    get grantControls(): ConditionalAccessGrantControls | undefined;
    /**
     * Sets the grantControls property value. Specifies the grant controls that must be fulfilled to pass the policy.
     * @param value Value to set for the grantControls property.
     */
    set grantControls(value: ConditionalAccessGrantControls | undefined);
    /**
     * Gets the modifiedDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Readonly.
     * @returns a Date
     */
    get modifiedDateTime(): Date | undefined;
    /**
     * Sets the modifiedDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Readonly.
     * @param value Value to set for the modifiedDateTime property.
     */
    set modifiedDateTime(value: Date | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the sessionControls property value. Specifies the session controls that are enforced after sign-in.
     * @returns a conditionalAccessSessionControls
     */
    get sessionControls(): ConditionalAccessSessionControls | undefined;
    /**
     * Sets the sessionControls property value. Specifies the session controls that are enforced after sign-in.
     * @param value Value to set for the sessionControls property.
     */
    set sessionControls(value: ConditionalAccessSessionControls | undefined);
    /**
     * Gets the state property value. Specifies the state of the conditionalAccessPolicy object. Possible values are: enabled, disabled, enabledForReportingButNotEnforced. Required.
     * @returns a conditionalAccessPolicyState
     */
    get state(): ConditionalAccessPolicyState | undefined;
    /**
     * Sets the state property value. Specifies the state of the conditionalAccessPolicy object. Possible values are: enabled, disabled, enabledForReportingButNotEnforced. Required.
     * @param value Value to set for the state property.
     */
    set state(value: ConditionalAccessPolicyState | undefined);
}
