"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConditionalAccessPolicy = void 0;
const conditionalAccessPolicyState_1 = require("./conditionalAccessPolicyState");
const createConditionalAccessConditionSetFromDiscriminatorValue_1 = require("./createConditionalAccessConditionSetFromDiscriminatorValue");
const createConditionalAccessGrantControlsFromDiscriminatorValue_1 = require("./createConditionalAccessGrantControlsFromDiscriminatorValue");
const createConditionalAccessSessionControlsFromDiscriminatorValue_1 = require("./createConditionalAccessSessionControlsFromDiscriminatorValue");
const index_1 = require("./index");
class ConditionalAccessPolicy extends index_1.Entity {
    /**
     * Instantiates a new conditionalAccessPolicy and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the conditions property value.
     * @returns a conditionalAccessConditionSet
     */
    get conditions() {
        return this._conditions;
    }
    ;
    /**
     * Sets the conditions property value.
     * @param value Value to set for the conditions property.
     */
    set conditions(value) {
        this._conditions = value;
    }
    ;
    ;
    /**
     * Gets the createdDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Readonly.
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Readonly.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * Gets the description property value. Not used.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. Not used.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the displayName property value. Specifies a display name for the conditionalAccessPolicy object.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. Specifies a display name for the conditionalAccessPolicy object.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "conditions": (o, n) => { o.conditions = n.getObjectValue(createConditionalAccessConditionSetFromDiscriminatorValue_1.createConditionalAccessConditionSetFromDiscriminatorValue); }, "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); }, "description": (o, n) => { o.description = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "grantControls": (o, n) => { o.grantControls = n.getObjectValue(createConditionalAccessGrantControlsFromDiscriminatorValue_1.createConditionalAccessGrantControlsFromDiscriminatorValue); }, "modifiedDateTime": (o, n) => { o.modifiedDateTime = n.getDateValue(); }, "sessionControls": (o, n) => { o.sessionControls = n.getObjectValue(createConditionalAccessSessionControlsFromDiscriminatorValue_1.createConditionalAccessSessionControlsFromDiscriminatorValue); }, "state": (o, n) => { o.state = n.getEnumValue(conditionalAccessPolicyState_1.ConditionalAccessPolicyState); } });
    }
    ;
    /**
     * Gets the grantControls property value. Specifies the grant controls that must be fulfilled to pass the policy.
     * @returns a conditionalAccessGrantControls
     */
    get grantControls() {
        return this._grantControls;
    }
    ;
    /**
     * Sets the grantControls property value. Specifies the grant controls that must be fulfilled to pass the policy.
     * @param value Value to set for the grantControls property.
     */
    set grantControls(value) {
        this._grantControls = value;
    }
    ;
    /**
     * Gets the modifiedDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Readonly.
     * @returns a Date
     */
    get modifiedDateTime() {
        return this._modifiedDateTime;
    }
    ;
    /**
     * Sets the modifiedDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Readonly.
     * @param value Value to set for the modifiedDateTime property.
     */
    set modifiedDateTime(value) {
        this._modifiedDateTime = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("conditions", this.conditions);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeStringValue("description", this.description);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeObjectValue("grantControls", this.grantControls);
        writer.writeDateValue("modifiedDateTime", this.modifiedDateTime);
        writer.writeObjectValue("sessionControls", this.sessionControls);
        writer.writeEnumValue("state", this.state);
    }
    ;
    /**
     * Gets the sessionControls property value. Specifies the session controls that are enforced after sign-in.
     * @returns a conditionalAccessSessionControls
     */
    get sessionControls() {
        return this._sessionControls;
    }
    ;
    /**
     * Sets the sessionControls property value. Specifies the session controls that are enforced after sign-in.
     * @param value Value to set for the sessionControls property.
     */
    set sessionControls(value) {
        this._sessionControls = value;
    }
    ;
    /**
     * Gets the state property value. Specifies the state of the conditionalAccessPolicy object. Possible values are: enabled, disabled, enabledForReportingButNotEnforced. Required.
     * @returns a conditionalAccessPolicyState
     */
    get state() {
        return this._state;
    }
    ;
    /**
     * Sets the state property value. Specifies the state of the conditionalAccessPolicy object. Possible values are: enabled, disabled, enabledForReportingButNotEnforced. Required.
     * @param value Value to set for the state property.
     */
    set state(value) {
        this._state = value;
    }
    ;
}
exports.ConditionalAccessPolicy = ConditionalAccessPolicy;
