import { ConditionalAccessPolicy, Entity, NamedLocation } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ConditionalAccessRoot extends Entity implements Parsable {
    /** Read-only. Nullable. Returns a collection of the specified named locations.  */
    private _namedLocations?;
    /** Read-only. Nullable. Returns a collection of the specified Conditional Access (CA) policies.  */
    private _policies?;
    /**
     * Instantiates a new conditionalAccessRoot and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the namedLocations property value. Read-only. Nullable. Returns a collection of the specified named locations.
     * @returns a namedLocation
     */
    get namedLocations(): NamedLocation[] | undefined;
    /**
     * Sets the namedLocations property value. Read-only. Nullable. Returns a collection of the specified named locations.
     * @param value Value to set for the namedLocations property.
     */
    set namedLocations(value: NamedLocation[] | undefined);
    /**
     * Gets the policies property value. Read-only. Nullable. Returns a collection of the specified Conditional Access (CA) policies.
     * @returns a conditionalAccessPolicy
     */
    get policies(): ConditionalAccessPolicy[] | undefined;
    /**
     * Sets the policies property value. Read-only. Nullable. Returns a collection of the specified Conditional Access (CA) policies.
     * @param value Value to set for the policies property.
     */
    set policies(value: ConditionalAccessPolicy[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
