"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConditionalAccessRoot = void 0;
const createConditionalAccessPolicyFromDiscriminatorValue_1 = require("./createConditionalAccessPolicyFromDiscriminatorValue");
const createNamedLocationFromDiscriminatorValue_1 = require("./createNamedLocationFromDiscriminatorValue");
const index_1 = require("./index");
class ConditionalAccessRoot extends index_1.Entity {
    /**
     * Instantiates a new conditionalAccessRoot and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "namedLocations": (o, n) => { o.namedLocations = n.getCollectionOfObjectValues(createNamedLocationFromDiscriminatorValue_1.createNamedLocationFromDiscriminatorValue); }, "policies": (o, n) => { o.policies = n.getCollectionOfObjectValues(createConditionalAccessPolicyFromDiscriminatorValue_1.createConditionalAccessPolicyFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the namedLocations property value. Read-only. Nullable. Returns a collection of the specified named locations.
     * @returns a namedLocation
     */
    get namedLocations() {
        return this._namedLocations;
    }
    ;
    /**
     * Sets the namedLocations property value. Read-only. Nullable. Returns a collection of the specified named locations.
     * @param value Value to set for the namedLocations property.
     */
    set namedLocations(value) {
        this._namedLocations = value;
    }
    ;
    /**
     * Gets the policies property value. Read-only. Nullable. Returns a collection of the specified Conditional Access (CA) policies.
     * @returns a conditionalAccessPolicy
     */
    get policies() {
        return this._policies;
    }
    ;
    /**
     * Sets the policies property value. Read-only. Nullable. Returns a collection of the specified Conditional Access (CA) policies.
     * @param value Value to set for the policies property.
     */
    set policies(value) {
        this._policies = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("namedLocations", this.namedLocations);
        writer.writeCollectionOfObjectValues("policies", this.policies);
    }
    ;
}
exports.ConditionalAccessRoot = ConditionalAccessRoot;
