"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConditionalAccessSessionControl = void 0;
class ConditionalAccessSessionControl {
    /**
     * Instantiates a new conditionalAccessSessionControl and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "isEnabled": (o, n) => { o.isEnabled = n.getBooleanValue(); },
        };
    }
    ;
    /**
     * Gets the isEnabled property value. Specifies whether the session control is enabled.
     * @returns a boolean
     */
    get isEnabled() {
        return this._isEnabled;
    }
    ;
    /**
     * Sets the isEnabled property value. Specifies whether the session control is enabled.
     * @param value Value to set for the isEnabled property.
     */
    set isEnabled(value) {
        this._isEnabled = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("isEnabled", this.isEnabled);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ConditionalAccessSessionControl = ConditionalAccessSessionControl;
