"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConditionalAccessSessionControls = void 0;
const createApplicationEnforcedRestrictionsSessionControlFromDiscriminatorValue_1 = require("./createApplicationEnforcedRestrictionsSessionControlFromDiscriminatorValue");
const createCloudAppSecuritySessionControlFromDiscriminatorValue_1 = require("./createCloudAppSecuritySessionControlFromDiscriminatorValue");
const createPersistentBrowserSessionControlFromDiscriminatorValue_1 = require("./createPersistentBrowserSessionControlFromDiscriminatorValue");
const createSignInFrequencySessionControlFromDiscriminatorValue_1 = require("./createSignInFrequencySessionControlFromDiscriminatorValue");
class ConditionalAccessSessionControls {
    /**
     * Instantiates a new conditionalAccessSessionControls and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the applicationEnforcedRestrictions property value. Session control to enforce application restrictions. Only Exchange Online and Sharepoint Online support this session control.
     * @returns a applicationEnforcedRestrictionsSessionControl
     */
    get applicationEnforcedRestrictions() {
        return this._applicationEnforcedRestrictions;
    }
    ;
    /**
     * Sets the applicationEnforcedRestrictions property value. Session control to enforce application restrictions. Only Exchange Online and Sharepoint Online support this session control.
     * @param value Value to set for the applicationEnforcedRestrictions property.
     */
    set applicationEnforcedRestrictions(value) {
        this._applicationEnforcedRestrictions = value;
    }
    ;
    /**
     * Gets the cloudAppSecurity property value. Session control to apply cloud app security.
     * @returns a cloudAppSecuritySessionControl
     */
    get cloudAppSecurity() {
        return this._cloudAppSecurity;
    }
    ;
    /**
     * Sets the cloudAppSecurity property value. Session control to apply cloud app security.
     * @param value Value to set for the cloudAppSecurity property.
     */
    set cloudAppSecurity(value) {
        this._cloudAppSecurity = value;
    }
    ;
    ;
    /**
     * Gets the disableResilienceDefaults property value. Session control that determines whether it is acceptable for Azure AD to extend existing sessions based on information collected prior to an outage or not.
     * @returns a boolean
     */
    get disableResilienceDefaults() {
        return this._disableResilienceDefaults;
    }
    ;
    /**
     * Sets the disableResilienceDefaults property value. Session control that determines whether it is acceptable for Azure AD to extend existing sessions based on information collected prior to an outage or not.
     * @param value Value to set for the disableResilienceDefaults property.
     */
    set disableResilienceDefaults(value) {
        this._disableResilienceDefaults = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "applicationEnforcedRestrictions": (o, n) => { o.applicationEnforcedRestrictions = n.getObjectValue(createApplicationEnforcedRestrictionsSessionControlFromDiscriminatorValue_1.createApplicationEnforcedRestrictionsSessionControlFromDiscriminatorValue); },
            "cloudAppSecurity": (o, n) => { o.cloudAppSecurity = n.getObjectValue(createCloudAppSecuritySessionControlFromDiscriminatorValue_1.createCloudAppSecuritySessionControlFromDiscriminatorValue); },
            "disableResilienceDefaults": (o, n) => { o.disableResilienceDefaults = n.getBooleanValue(); },
            "persistentBrowser": (o, n) => { o.persistentBrowser = n.getObjectValue(createPersistentBrowserSessionControlFromDiscriminatorValue_1.createPersistentBrowserSessionControlFromDiscriminatorValue); },
            "signInFrequency": (o, n) => { o.signInFrequency = n.getObjectValue(createSignInFrequencySessionControlFromDiscriminatorValue_1.createSignInFrequencySessionControlFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the persistentBrowser property value. Session control to define whether to persist cookies or not. All apps should be selected for this session control to work correctly.
     * @returns a persistentBrowserSessionControl
     */
    get persistentBrowser() {
        return this._persistentBrowser;
    }
    ;
    /**
     * Sets the persistentBrowser property value. Session control to define whether to persist cookies or not. All apps should be selected for this session control to work correctly.
     * @param value Value to set for the persistentBrowser property.
     */
    set persistentBrowser(value) {
        this._persistentBrowser = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("applicationEnforcedRestrictions", this.applicationEnforcedRestrictions);
        writer.writeObjectValue("cloudAppSecurity", this.cloudAppSecurity);
        writer.writeBooleanValue("disableResilienceDefaults", this.disableResilienceDefaults);
        writer.writeObjectValue("persistentBrowser", this.persistentBrowser);
        writer.writeObjectValue("signInFrequency", this.signInFrequency);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the signInFrequency property value. Session control to enforce signin frequency.
     * @returns a signInFrequencySessionControl
     */
    get signInFrequency() {
        return this._signInFrequency;
    }
    ;
    /**
     * Sets the signInFrequency property value. Session control to enforce signin frequency.
     * @param value Value to set for the signInFrequency property.
     */
    set signInFrequency(value) {
        this._signInFrequency = value;
    }
    ;
}
exports.ConditionalAccessSessionControls = ConditionalAccessSessionControls;
