import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ConditionalAccessUsers implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Group IDs excluded from scope of policy.  */
    private _excludeGroups?;
    /** Role IDs excluded from scope of policy.  */
    private _excludeRoles?;
    /** User IDs excluded from scope of policy and/or GuestsOrExternalUsers.  */
    private _excludeUsers?;
    /** Group IDs in scope of policy unless explicitly excluded, or All.  */
    private _includeGroups?;
    /** Role IDs in scope of policy unless explicitly excluded, or All.  */
    private _includeRoles?;
    /** User IDs in scope of policy unless explicitly excluded, or None or All or GuestsOrExternalUsers.  */
    private _includeUsers?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new conditionalAccessUsers and sets the default values.
     */
    constructor();
    /**
     * Gets the excludeGroups property value. Group IDs excluded from scope of policy.
     * @returns a string
     */
    get excludeGroups(): string[] | undefined;
    /**
     * Sets the excludeGroups property value. Group IDs excluded from scope of policy.
     * @param value Value to set for the excludeGroups property.
     */
    set excludeGroups(value: string[] | undefined);
    /**
     * Gets the excludeRoles property value. Role IDs excluded from scope of policy.
     * @returns a string
     */
    get excludeRoles(): string[] | undefined;
    /**
     * Sets the excludeRoles property value. Role IDs excluded from scope of policy.
     * @param value Value to set for the excludeRoles property.
     */
    set excludeRoles(value: string[] | undefined);
    /**
     * Gets the excludeUsers property value. User IDs excluded from scope of policy and/or GuestsOrExternalUsers.
     * @returns a string
     */
    get excludeUsers(): string[] | undefined;
    /**
     * Sets the excludeUsers property value. User IDs excluded from scope of policy and/or GuestsOrExternalUsers.
     * @param value Value to set for the excludeUsers property.
     */
    set excludeUsers(value: string[] | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the includeGroups property value. Group IDs in scope of policy unless explicitly excluded, or All.
     * @returns a string
     */
    get includeGroups(): string[] | undefined;
    /**
     * Sets the includeGroups property value. Group IDs in scope of policy unless explicitly excluded, or All.
     * @param value Value to set for the includeGroups property.
     */
    set includeGroups(value: string[] | undefined);
    /**
     * Gets the includeRoles property value. Role IDs in scope of policy unless explicitly excluded, or All.
     * @returns a string
     */
    get includeRoles(): string[] | undefined;
    /**
     * Sets the includeRoles property value. Role IDs in scope of policy unless explicitly excluded, or All.
     * @param value Value to set for the includeRoles property.
     */
    set includeRoles(value: string[] | undefined);
    /**
     * Gets the includeUsers property value. User IDs in scope of policy unless explicitly excluded, or None or All or GuestsOrExternalUsers.
     * @returns a string
     */
    get includeUsers(): string[] | undefined;
    /**
     * Sets the includeUsers property value. User IDs in scope of policy unless explicitly excluded, or None or All or GuestsOrExternalUsers.
     * @param value Value to set for the includeUsers property.
     */
    set includeUsers(value: string[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
