"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConditionalAccessUsers = void 0;
class ConditionalAccessUsers {
    /**
     * Instantiates a new conditionalAccessUsers and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the excludeGroups property value. Group IDs excluded from scope of policy.
     * @returns a string
     */
    get excludeGroups() {
        return this._excludeGroups;
    }
    ;
    /**
     * Sets the excludeGroups property value. Group IDs excluded from scope of policy.
     * @param value Value to set for the excludeGroups property.
     */
    set excludeGroups(value) {
        this._excludeGroups = value;
    }
    ;
    /**
     * Gets the excludeRoles property value. Role IDs excluded from scope of policy.
     * @returns a string
     */
    get excludeRoles() {
        return this._excludeRoles;
    }
    ;
    /**
     * Sets the excludeRoles property value. Role IDs excluded from scope of policy.
     * @param value Value to set for the excludeRoles property.
     */
    set excludeRoles(value) {
        this._excludeRoles = value;
    }
    ;
    /**
     * Gets the excludeUsers property value. User IDs excluded from scope of policy and/or GuestsOrExternalUsers.
     * @returns a string
     */
    get excludeUsers() {
        return this._excludeUsers;
    }
    ;
    /**
     * Sets the excludeUsers property value. User IDs excluded from scope of policy and/or GuestsOrExternalUsers.
     * @param value Value to set for the excludeUsers property.
     */
    set excludeUsers(value) {
        this._excludeUsers = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "excludeGroups": (o, n) => { o.excludeGroups = n.getCollectionOfPrimitiveValues(); },
            "excludeRoles": (o, n) => { o.excludeRoles = n.getCollectionOfPrimitiveValues(); },
            "excludeUsers": (o, n) => { o.excludeUsers = n.getCollectionOfPrimitiveValues(); },
            "includeGroups": (o, n) => { o.includeGroups = n.getCollectionOfPrimitiveValues(); },
            "includeRoles": (o, n) => { o.includeRoles = n.getCollectionOfPrimitiveValues(); },
            "includeUsers": (o, n) => { o.includeUsers = n.getCollectionOfPrimitiveValues(); },
        };
    }
    ;
    /**
     * Gets the includeGroups property value. Group IDs in scope of policy unless explicitly excluded, or All.
     * @returns a string
     */
    get includeGroups() {
        return this._includeGroups;
    }
    ;
    /**
     * Sets the includeGroups property value. Group IDs in scope of policy unless explicitly excluded, or All.
     * @param value Value to set for the includeGroups property.
     */
    set includeGroups(value) {
        this._includeGroups = value;
    }
    ;
    /**
     * Gets the includeRoles property value. Role IDs in scope of policy unless explicitly excluded, or All.
     * @returns a string
     */
    get includeRoles() {
        return this._includeRoles;
    }
    ;
    /**
     * Sets the includeRoles property value. Role IDs in scope of policy unless explicitly excluded, or All.
     * @param value Value to set for the includeRoles property.
     */
    set includeRoles(value) {
        this._includeRoles = value;
    }
    ;
    /**
     * Gets the includeUsers property value. User IDs in scope of policy unless explicitly excluded, or None or All or GuestsOrExternalUsers.
     * @returns a string
     */
    get includeUsers() {
        return this._includeUsers;
    }
    ;
    /**
     * Sets the includeUsers property value. User IDs in scope of policy unless explicitly excluded, or None or All or GuestsOrExternalUsers.
     * @param value Value to set for the includeUsers property.
     */
    set includeUsers(value) {
        this._includeUsers = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfPrimitiveValues("excludeGroups", this.excludeGroups);
        writer.writeCollectionOfPrimitiveValues("excludeRoles", this.excludeRoles);
        writer.writeCollectionOfPrimitiveValues("excludeUsers", this.excludeUsers);
        writer.writeCollectionOfPrimitiveValues("includeGroups", this.includeGroups);
        writer.writeCollectionOfPrimitiveValues("includeRoles", this.includeRoles);
        writer.writeCollectionOfPrimitiveValues("includeUsers", this.includeUsers);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ConditionalAccessUsers = ConditionalAccessUsers;
