"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfigurationManagerClientEnabledFeatures = void 0;
/** configuration Manager client enabled features  */
class ConfigurationManagerClientEnabledFeatures {
    /**
     * Instantiates a new configurationManagerClientEnabledFeatures and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the compliancePolicy property value. Whether compliance policy is managed by Intune
     * @returns a boolean
     */
    get compliancePolicy() {
        return this._compliancePolicy;
    }
    ;
    /**
     * Sets the compliancePolicy property value. Whether compliance policy is managed by Intune
     * @param value Value to set for the compliancePolicy property.
     */
    set compliancePolicy(value) {
        this._compliancePolicy = value;
    }
    ;
    ;
    /**
     * Gets the deviceConfiguration property value. Whether device configuration is managed by Intune
     * @returns a boolean
     */
    get deviceConfiguration() {
        return this._deviceConfiguration;
    }
    ;
    /**
     * Sets the deviceConfiguration property value. Whether device configuration is managed by Intune
     * @param value Value to set for the deviceConfiguration property.
     */
    set deviceConfiguration(value) {
        this._deviceConfiguration = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "compliancePolicy": (o, n) => { o.compliancePolicy = n.getBooleanValue(); },
            "deviceConfiguration": (o, n) => { o.deviceConfiguration = n.getBooleanValue(); },
            "inventory": (o, n) => { o.inventory = n.getBooleanValue(); },
            "modernApps": (o, n) => { o.modernApps = n.getBooleanValue(); },
            "resourceAccess": (o, n) => { o.resourceAccess = n.getBooleanValue(); },
            "windowsUpdateForBusiness": (o, n) => { o.windowsUpdateForBusiness = n.getBooleanValue(); },
        };
    }
    ;
    /**
     * Gets the inventory property value. Whether inventory is managed by Intune
     * @returns a boolean
     */
    get inventory() {
        return this._inventory;
    }
    ;
    /**
     * Sets the inventory property value. Whether inventory is managed by Intune
     * @param value Value to set for the inventory property.
     */
    set inventory(value) {
        this._inventory = value;
    }
    ;
    /**
     * Gets the modernApps property value. Whether modern application is managed by Intune
     * @returns a boolean
     */
    get modernApps() {
        return this._modernApps;
    }
    ;
    /**
     * Sets the modernApps property value. Whether modern application is managed by Intune
     * @param value Value to set for the modernApps property.
     */
    set modernApps(value) {
        this._modernApps = value;
    }
    ;
    /**
     * Gets the resourceAccess property value. Whether resource access is managed by Intune
     * @returns a boolean
     */
    get resourceAccess() {
        return this._resourceAccess;
    }
    ;
    /**
     * Sets the resourceAccess property value. Whether resource access is managed by Intune
     * @param value Value to set for the resourceAccess property.
     */
    set resourceAccess(value) {
        this._resourceAccess = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("compliancePolicy", this.compliancePolicy);
        writer.writeBooleanValue("deviceConfiguration", this.deviceConfiguration);
        writer.writeBooleanValue("inventory", this.inventory);
        writer.writeBooleanValue("modernApps", this.modernApps);
        writer.writeBooleanValue("resourceAccess", this.resourceAccess);
        writer.writeBooleanValue("windowsUpdateForBusiness", this.windowsUpdateForBusiness);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the windowsUpdateForBusiness property value. Whether Windows Update for Business is managed by Intune
     * @returns a boolean
     */
    get windowsUpdateForBusiness() {
        return this._windowsUpdateForBusiness;
    }
    ;
    /**
     * Sets the windowsUpdateForBusiness property value. Whether Windows Update for Business is managed by Intune
     * @param value Value to set for the windowsUpdateForBusiness property.
     */
    set windowsUpdateForBusiness(value) {
        this._windowsUpdateForBusiness = value;
    }
    ;
}
exports.ConfigurationManagerClientEnabledFeatures = ConfigurationManagerClientEnabledFeatures;
