"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContactFolder = void 0;
const createContactFolderFromDiscriminatorValue_1 = require("./createContactFolderFromDiscriminatorValue");
const createContactFromDiscriminatorValue_1 = require("./createContactFromDiscriminatorValue");
const createMultiValueLegacyExtendedPropertyFromDiscriminatorValue_1 = require("./createMultiValueLegacyExtendedPropertyFromDiscriminatorValue");
const createSingleValueLegacyExtendedPropertyFromDiscriminatorValue_1 = require("./createSingleValueLegacyExtendedPropertyFromDiscriminatorValue");
const index_1 = require("./index");
class ContactFolder extends index_1.Entity {
    /**
     * Instantiates a new contactFolder and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the childFolders property value. The collection of child folders in the folder. Navigation property. Read-only. Nullable.
     * @returns a contactFolder
     */
    get childFolders() {
        return this._childFolders;
    }
    ;
    /**
     * Sets the childFolders property value. The collection of child folders in the folder. Navigation property. Read-only. Nullable.
     * @param value Value to set for the childFolders property.
     */
    set childFolders(value) {
        this._childFolders = value;
    }
    ;
    ;
    /**
     * Gets the contacts property value. The contacts in the folder. Navigation property. Read-only. Nullable.
     * @returns a contact
     */
    get contacts() {
        return this._contacts;
    }
    ;
    /**
     * Sets the contacts property value. The contacts in the folder. Navigation property. Read-only. Nullable.
     * @param value Value to set for the contacts property.
     */
    set contacts(value) {
        this._contacts = value;
    }
    ;
    /**
     * Gets the displayName property value. The folder's display name.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The folder's display name.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "childFolders": (o, n) => { o.childFolders = n.getCollectionOfObjectValues(createContactFolderFromDiscriminatorValue_1.createContactFolderFromDiscriminatorValue); }, "contacts": (o, n) => { o.contacts = n.getCollectionOfObjectValues(createContactFromDiscriminatorValue_1.createContactFromDiscriminatorValue); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "multiValueExtendedProperties": (o, n) => { o.multiValueExtendedProperties = n.getCollectionOfObjectValues(createMultiValueLegacyExtendedPropertyFromDiscriminatorValue_1.createMultiValueLegacyExtendedPropertyFromDiscriminatorValue); }, "parentFolderId": (o, n) => { o.parentFolderId = n.getStringValue(); }, "singleValueExtendedProperties": (o, n) => { o.singleValueExtendedProperties = n.getCollectionOfObjectValues(createSingleValueLegacyExtendedPropertyFromDiscriminatorValue_1.createSingleValueLegacyExtendedPropertyFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the multiValueExtendedProperties property value. The collection of multi-value extended properties defined for the contactFolder. Read-only. Nullable.
     * @returns a multiValueLegacyExtendedProperty
     */
    get multiValueExtendedProperties() {
        return this._multiValueExtendedProperties;
    }
    ;
    /**
     * Sets the multiValueExtendedProperties property value. The collection of multi-value extended properties defined for the contactFolder. Read-only. Nullable.
     * @param value Value to set for the multiValueExtendedProperties property.
     */
    set multiValueExtendedProperties(value) {
        this._multiValueExtendedProperties = value;
    }
    ;
    /**
     * Gets the parentFolderId property value. The ID of the folder's parent folder.
     * @returns a string
     */
    get parentFolderId() {
        return this._parentFolderId;
    }
    ;
    /**
     * Sets the parentFolderId property value. The ID of the folder's parent folder.
     * @param value Value to set for the parentFolderId property.
     */
    set parentFolderId(value) {
        this._parentFolderId = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("childFolders", this.childFolders);
        writer.writeCollectionOfObjectValues("contacts", this.contacts);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeCollectionOfObjectValues("multiValueExtendedProperties", this.multiValueExtendedProperties);
        writer.writeStringValue("parentFolderId", this.parentFolderId);
        writer.writeCollectionOfObjectValues("singleValueExtendedProperties", this.singleValueExtendedProperties);
    }
    ;
    /**
     * Gets the singleValueExtendedProperties property value. The collection of single-value extended properties defined for the contactFolder. Read-only. Nullable.
     * @returns a singleValueLegacyExtendedProperty
     */
    get singleValueExtendedProperties() {
        return this._singleValueExtendedProperties;
    }
    ;
    /**
     * Sets the singleValueExtendedProperties property value. The collection of single-value extended properties defined for the contactFolder. Read-only. Nullable.
     * @param value Value to set for the singleValueExtendedProperties property.
     */
    set singleValueExtendedProperties(value) {
        this._singleValueExtendedProperties = value;
    }
    ;
}
exports.ContactFolder = ContactFolder;
