import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ContentTypeOrder implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Whether this is the default Content Type  */
    private _default_escaped?;
    /** Specifies the position in which the Content Type appears in the selection UI.  */
    private _position?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new contentTypeOrder and sets the default values.
     */
    constructor();
    /**
     * Gets the default property value. Whether this is the default Content Type
     * @returns a boolean
     */
    get default_escaped(): boolean | undefined;
    /**
     * Sets the default property value. Whether this is the default Content Type
     * @param value Value to set for the default_escaped property.
     */
    set default_escaped(value: boolean | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the position property value. Specifies the position in which the Content Type appears in the selection UI.
     * @returns a integer
     */
    get position(): number | undefined;
    /**
     * Sets the position property value. Specifies the position in which the Content Type appears in the selection UI.
     * @param value Value to set for the position property.
     */
    set position(value: number | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
