"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContentTypeOrder = void 0;
class ContentTypeOrder {
    /**
     * Instantiates a new contentTypeOrder and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the default property value. Whether this is the default Content Type
     * @returns a boolean
     */
    get default_escaped() {
        return this._default_escaped;
    }
    ;
    /**
     * Sets the default property value. Whether this is the default Content Type
     * @param value Value to set for the default_escaped property.
     */
    set default_escaped(value) {
        this._default_escaped = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "default": (o, n) => { o.default_escaped = n.getBooleanValue(); },
            "position": (o, n) => { o.position = n.getNumberValue(); },
        };
    }
    ;
    /**
     * Gets the position property value. Specifies the position in which the Content Type appears in the selection UI.
     * @returns a integer
     */
    get position() {
        return this._position;
    }
    ;
    /**
     * Sets the position property value. Specifies the position in which the Content Type appears in the selection UI.
     * @param value Value to set for the position property.
     */
    set position(value) {
        this._position = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("default", this.default_escaped);
        writer.writeNumberValue("position", this.position);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ContentTypeOrder = ContentTypeOrder;
