import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ControlScore implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Control action category (Identity, Data, Device, Apps, Infrastructure).  */
    private _controlCategory?;
    /** Control unique name.  */
    private _controlName?;
    /** Description of the control.  */
    private _description?;
    /** Tenant achieved score for the control (it varies day by day depending on tenant operations on the control).  */
    private _score?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new controlScore and sets the default values.
     */
    constructor();
    /**
     * Gets the controlCategory property value. Control action category (Identity, Data, Device, Apps, Infrastructure).
     * @returns a string
     */
    get controlCategory(): string | undefined;
    /**
     * Sets the controlCategory property value. Control action category (Identity, Data, Device, Apps, Infrastructure).
     * @param value Value to set for the controlCategory property.
     */
    set controlCategory(value: string | undefined);
    /**
     * Gets the controlName property value. Control unique name.
     * @returns a string
     */
    get controlName(): string | undefined;
    /**
     * Sets the controlName property value. Control unique name.
     * @param value Value to set for the controlName property.
     */
    set controlName(value: string | undefined);
    /**
     * Gets the description property value. Description of the control.
     * @returns a string
     */
    get description(): string | undefined;
    /**
     * Sets the description property value. Description of the control.
     * @param value Value to set for the description property.
     */
    set description(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the score property value. Tenant achieved score for the control (it varies day by day depending on tenant operations on the control).
     * @returns a double
     */
    get score(): number | undefined;
    /**
     * Sets the score property value. Tenant achieved score for the control (it varies day by day depending on tenant operations on the control).
     * @param value Value to set for the score property.
     */
    set score(value: number | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
