"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ControlScore = void 0;
class ControlScore {
    /**
     * Instantiates a new controlScore and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the controlCategory property value. Control action category (Identity, Data, Device, Apps, Infrastructure).
     * @returns a string
     */
    get controlCategory() {
        return this._controlCategory;
    }
    ;
    /**
     * Sets the controlCategory property value. Control action category (Identity, Data, Device, Apps, Infrastructure).
     * @param value Value to set for the controlCategory property.
     */
    set controlCategory(value) {
        this._controlCategory = value;
    }
    ;
    /**
     * Gets the controlName property value. Control unique name.
     * @returns a string
     */
    get controlName() {
        return this._controlName;
    }
    ;
    /**
     * Sets the controlName property value. Control unique name.
     * @param value Value to set for the controlName property.
     */
    set controlName(value) {
        this._controlName = value;
    }
    ;
    /**
     * Gets the description property value. Description of the control.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. Description of the control.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "controlCategory": (o, n) => { o.controlCategory = n.getStringValue(); },
            "controlName": (o, n) => { o.controlName = n.getStringValue(); },
            "description": (o, n) => { o.description = n.getStringValue(); },
            "score": (o, n) => { o.score = n.getNumberValue(); },
        };
    }
    ;
    /**
     * Gets the score property value. Tenant achieved score for the control (it varies day by day depending on tenant operations on the control).
     * @returns a double
     */
    get score() {
        return this._score;
    }
    ;
    /**
     * Sets the score property value. Tenant achieved score for the control (it varies day by day depending on tenant operations on the control).
     * @param value Value to set for the score property.
     */
    set score(value) {
        this._score = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("controlCategory", this.controlCategory);
        writer.writeStringValue("controlName", this.controlName);
        writer.writeStringValue("description", this.description);
        writer.writeNumberValue("score", this.score);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ControlScore = ControlScore;
