"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Conversation = void 0;
const createConversationThreadFromDiscriminatorValue_1 = require("./createConversationThreadFromDiscriminatorValue");
const index_1 = require("./index");
class Conversation extends index_1.Entity {
    /**
     * Instantiates a new conversation and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "hasAttachments": (o, n) => { o.hasAttachments = n.getBooleanValue(); }, "lastDeliveredDateTime": (o, n) => { o.lastDeliveredDateTime = n.getDateValue(); }, "preview": (o, n) => { o.preview = n.getStringValue(); }, "threads": (o, n) => { o.threads = n.getCollectionOfObjectValues(createConversationThreadFromDiscriminatorValue_1.createConversationThreadFromDiscriminatorValue); }, "topic": (o, n) => { o.topic = n.getStringValue(); }, "uniqueSenders": (o, n) => { o.uniqueSenders = n.getCollectionOfPrimitiveValues(); } });
    }
    ;
    /**
     * Gets the hasAttachments property value. Indicates whether any of the posts within this Conversation has at least one attachment. Supports $filter (eq, ne) and $search.
     * @returns a boolean
     */
    get hasAttachments() {
        return this._hasAttachments;
    }
    ;
    /**
     * Sets the hasAttachments property value. Indicates whether any of the posts within this Conversation has at least one attachment. Supports $filter (eq, ne) and $search.
     * @param value Value to set for the hasAttachments property.
     */
    set hasAttachments(value) {
        this._hasAttachments = value;
    }
    ;
    /**
     * Gets the lastDeliveredDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @returns a Date
     */
    get lastDeliveredDateTime() {
        return this._lastDeliveredDateTime;
    }
    ;
    /**
     * Sets the lastDeliveredDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @param value Value to set for the lastDeliveredDateTime property.
     */
    set lastDeliveredDateTime(value) {
        this._lastDeliveredDateTime = value;
    }
    ;
    /**
     * Gets the preview property value. A short summary from the body of the latest post in this conversation. Supports $filter (eq, ne, le, ge).
     * @returns a string
     */
    get preview() {
        return this._preview;
    }
    ;
    /**
     * Sets the preview property value. A short summary from the body of the latest post in this conversation. Supports $filter (eq, ne, le, ge).
     * @param value Value to set for the preview property.
     */
    set preview(value) {
        this._preview = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeBooleanValue("hasAttachments", this.hasAttachments);
        writer.writeDateValue("lastDeliveredDateTime", this.lastDeliveredDateTime);
        writer.writeStringValue("preview", this.preview);
        writer.writeCollectionOfObjectValues("threads", this.threads);
        writer.writeStringValue("topic", this.topic);
        writer.writeCollectionOfPrimitiveValues("uniqueSenders", this.uniqueSenders);
    }
    ;
    /**
     * Gets the threads property value. A collection of all the conversation threads in the conversation. A navigation property. Read-only. Nullable.
     * @returns a conversationThread
     */
    get threads() {
        return this._threads;
    }
    ;
    /**
     * Sets the threads property value. A collection of all the conversation threads in the conversation. A navigation property. Read-only. Nullable.
     * @param value Value to set for the threads property.
     */
    set threads(value) {
        this._threads = value;
    }
    ;
    /**
     * Gets the topic property value. The topic of the conversation. This property can be set when the conversation is created, but it cannot be updated.
     * @returns a string
     */
    get topic() {
        return this._topic;
    }
    ;
    /**
     * Sets the topic property value. The topic of the conversation. This property can be set when the conversation is created, but it cannot be updated.
     * @param value Value to set for the topic property.
     */
    set topic(value) {
        this._topic = value;
    }
    ;
    /**
     * Gets the uniqueSenders property value. All the users that sent a message to this Conversation.
     * @returns a string
     */
    get uniqueSenders() {
        return this._uniqueSenders;
    }
    ;
    /**
     * Sets the uniqueSenders property value. All the users that sent a message to this Conversation.
     * @param value Value to set for the uniqueSenders property.
     */
    set uniqueSenders(value) {
        this._uniqueSenders = value;
    }
    ;
}
exports.Conversation = Conversation;
