import { Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ConversationMember extends Entity implements Parsable {
    /** The display name of the user.  */
    private _displayName?;
    /** The roles for that user.  */
    private _roles?;
    /** The timestamp denoting how far back a conversation's history is shared with the conversation member. This property is settable only for members of a chat.  */
    private _visibleHistoryStartDateTime?;
    /**
     * Instantiates a new conversationMember and sets the default values.
     */
    constructor();
    /**
     * Gets the displayName property value. The display name of the user.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. The display name of the user.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the roles property value. The roles for that user.
     * @returns a string
     */
    get roles(): string[] | undefined;
    /**
     * Sets the roles property value. The roles for that user.
     * @param value Value to set for the roles property.
     */
    set roles(value: string[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the visibleHistoryStartDateTime property value. The timestamp denoting how far back a conversation's history is shared with the conversation member. This property is settable only for members of a chat.
     * @returns a Date
     */
    get visibleHistoryStartDateTime(): Date | undefined;
    /**
     * Sets the visibleHistoryStartDateTime property value. The timestamp denoting how far back a conversation's history is shared with the conversation member. This property is settable only for members of a chat.
     * @param value Value to set for the visibleHistoryStartDateTime property.
     */
    set visibleHistoryStartDateTime(value: Date | undefined);
}
