"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConversationMember = void 0;
const index_1 = require("./index");
class ConversationMember extends index_1.Entity {
    /**
     * Instantiates a new conversationMember and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the displayName property value. The display name of the user.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The display name of the user.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "roles": (o, n) => { o.roles = n.getCollectionOfPrimitiveValues(); }, "visibleHistoryStartDateTime": (o, n) => { o.visibleHistoryStartDateTime = n.getDateValue(); } });
    }
    ;
    /**
     * Gets the roles property value. The roles for that user.
     * @returns a string
     */
    get roles() {
        return this._roles;
    }
    ;
    /**
     * Sets the roles property value. The roles for that user.
     * @param value Value to set for the roles property.
     */
    set roles(value) {
        this._roles = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeCollectionOfPrimitiveValues("roles", this.roles);
        writer.writeDateValue("visibleHistoryStartDateTime", this.visibleHistoryStartDateTime);
    }
    ;
    /**
     * Gets the visibleHistoryStartDateTime property value. The timestamp denoting how far back a conversation's history is shared with the conversation member. This property is settable only for members of a chat.
     * @returns a Date
     */
    get visibleHistoryStartDateTime() {
        return this._visibleHistoryStartDateTime;
    }
    ;
    /**
     * Sets the visibleHistoryStartDateTime property value. The timestamp denoting how far back a conversation's history is shared with the conversation member. This property is settable only for members of a chat.
     * @param value Value to set for the visibleHistoryStartDateTime property.
     */
    set visibleHistoryStartDateTime(value) {
        this._visibleHistoryStartDateTime = value;
    }
    ;
}
exports.ConversationMember = ConversationMember;
