"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CopyNotebookModel = void 0;
const createIdentitySetFromDiscriminatorValue_1 = require("./createIdentitySetFromDiscriminatorValue");
const createNotebookLinksFromDiscriminatorValue_1 = require("./createNotebookLinksFromDiscriminatorValue");
const onenoteUserRole_1 = require("./onenoteUserRole");
class CopyNotebookModel {
    /**
     * Instantiates a new CopyNotebookModel and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the createdBy property value.
     * @returns a string
     */
    get createdBy() {
        return this._createdBy;
    }
    ;
    /**
     * Sets the createdBy property value.
     * @param value Value to set for the createdBy property.
     */
    set createdBy(value) {
        this._createdBy = value;
    }
    ;
    /**
     * Gets the createdByIdentity property value.
     * @returns a identitySet
     */
    get createdByIdentity() {
        return this._createdByIdentity;
    }
    ;
    /**
     * Sets the createdByIdentity property value.
     * @param value Value to set for the createdByIdentity property.
     */
    set createdByIdentity(value) {
        this._createdByIdentity = value;
    }
    ;
    /**
     * Gets the createdTime property value.
     * @returns a Date
     */
    get createdTime() {
        return this._createdTime;
    }
    ;
    /**
     * Sets the createdTime property value.
     * @param value Value to set for the createdTime property.
     */
    set createdTime(value) {
        this._createdTime = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "createdBy": (o, n) => { o.createdBy = n.getStringValue(); },
            "createdByIdentity": (o, n) => { o.createdByIdentity = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); },
            "createdTime": (o, n) => { o.createdTime = n.getDateValue(); },
            "id": (o, n) => { o.id = n.getStringValue(); },
            "isDefault": (o, n) => { o.isDefault = n.getBooleanValue(); },
            "isShared": (o, n) => { o.isShared = n.getBooleanValue(); },
            "lastModifiedBy": (o, n) => { o.lastModifiedBy = n.getStringValue(); },
            "lastModifiedByIdentity": (o, n) => { o.lastModifiedByIdentity = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); },
            "lastModifiedTime": (o, n) => { o.lastModifiedTime = n.getDateValue(); },
            "links": (o, n) => { o.links = n.getObjectValue(createNotebookLinksFromDiscriminatorValue_1.createNotebookLinksFromDiscriminatorValue); },
            "name": (o, n) => { o.name = n.getStringValue(); },
            "sectionGroupsUrl": (o, n) => { o.sectionGroupsUrl = n.getStringValue(); },
            "sectionsUrl": (o, n) => { o.sectionsUrl = n.getStringValue(); },
            "self": (o, n) => { o.self = n.getStringValue(); },
            "userRole": (o, n) => { o.userRole = n.getEnumValue(onenoteUserRole_1.OnenoteUserRole); },
        };
    }
    ;
    /**
     * Gets the id property value.
     * @returns a string
     */
    get id() {
        return this._id;
    }
    ;
    /**
     * Sets the id property value.
     * @param value Value to set for the id property.
     */
    set id(value) {
        this._id = value;
    }
    ;
    /**
     * Gets the isDefault property value.
     * @returns a boolean
     */
    get isDefault() {
        return this._isDefault;
    }
    ;
    /**
     * Sets the isDefault property value.
     * @param value Value to set for the isDefault property.
     */
    set isDefault(value) {
        this._isDefault = value;
    }
    ;
    /**
     * Gets the isShared property value.
     * @returns a boolean
     */
    get isShared() {
        return this._isShared;
    }
    ;
    /**
     * Sets the isShared property value.
     * @param value Value to set for the isShared property.
     */
    set isShared(value) {
        this._isShared = value;
    }
    ;
    /**
     * Gets the lastModifiedBy property value.
     * @returns a string
     */
    get lastModifiedBy() {
        return this._lastModifiedBy;
    }
    ;
    /**
     * Sets the lastModifiedBy property value.
     * @param value Value to set for the lastModifiedBy property.
     */
    set lastModifiedBy(value) {
        this._lastModifiedBy = value;
    }
    ;
    /**
     * Gets the lastModifiedByIdentity property value.
     * @returns a identitySet
     */
    get lastModifiedByIdentity() {
        return this._lastModifiedByIdentity;
    }
    ;
    /**
     * Sets the lastModifiedByIdentity property value.
     * @param value Value to set for the lastModifiedByIdentity property.
     */
    set lastModifiedByIdentity(value) {
        this._lastModifiedByIdentity = value;
    }
    ;
    /**
     * Gets the lastModifiedTime property value.
     * @returns a Date
     */
    get lastModifiedTime() {
        return this._lastModifiedTime;
    }
    ;
    /**
     * Sets the lastModifiedTime property value.
     * @param value Value to set for the lastModifiedTime property.
     */
    set lastModifiedTime(value) {
        this._lastModifiedTime = value;
    }
    ;
    /**
     * Gets the links property value.
     * @returns a notebookLinks
     */
    get links() {
        return this._links;
    }
    ;
    /**
     * Sets the links property value.
     * @param value Value to set for the links property.
     */
    set links(value) {
        this._links = value;
    }
    ;
    /**
     * Gets the name property value.
     * @returns a string
     */
    get name() {
        return this._name;
    }
    ;
    /**
     * Sets the name property value.
     * @param value Value to set for the name property.
     */
    set name(value) {
        this._name = value;
    }
    ;
    /**
     * Gets the sectionGroupsUrl property value.
     * @returns a string
     */
    get sectionGroupsUrl() {
        return this._sectionGroupsUrl;
    }
    ;
    /**
     * Sets the sectionGroupsUrl property value.
     * @param value Value to set for the sectionGroupsUrl property.
     */
    set sectionGroupsUrl(value) {
        this._sectionGroupsUrl = value;
    }
    ;
    /**
     * Gets the sectionsUrl property value.
     * @returns a string
     */
    get sectionsUrl() {
        return this._sectionsUrl;
    }
    ;
    /**
     * Sets the sectionsUrl property value.
     * @param value Value to set for the sectionsUrl property.
     */
    set sectionsUrl(value) {
        this._sectionsUrl = value;
    }
    ;
    /**
     * Gets the self property value.
     * @returns a string
     */
    get self() {
        return this._self;
    }
    ;
    /**
     * Sets the self property value.
     * @param value Value to set for the self property.
     */
    set self(value) {
        this._self = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("createdBy", this.createdBy);
        writer.writeObjectValue("createdByIdentity", this.createdByIdentity);
        writer.writeDateValue("createdTime", this.createdTime);
        writer.writeStringValue("id", this.id);
        writer.writeBooleanValue("isDefault", this.isDefault);
        writer.writeBooleanValue("isShared", this.isShared);
        writer.writeStringValue("lastModifiedBy", this.lastModifiedBy);
        writer.writeObjectValue("lastModifiedByIdentity", this.lastModifiedByIdentity);
        writer.writeDateValue("lastModifiedTime", this.lastModifiedTime);
        writer.writeObjectValue("links", this.links);
        writer.writeStringValue("name", this.name);
        writer.writeStringValue("sectionGroupsUrl", this.sectionGroupsUrl);
        writer.writeStringValue("sectionsUrl", this.sectionsUrl);
        writer.writeStringValue("self", this.self);
        writer.writeEnumValue("userRole", this.userRole);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the userRole property value.
     * @returns a onenoteUserRole
     */
    get userRole() {
        return this._userRole;
    }
    ;
    /**
     * Sets the userRole property value.
     * @param value Value to set for the userRole property.
     */
    set userRole(value) {
        this._userRole = value;
    }
    ;
}
exports.CopyNotebookModel = CopyNotebookModel;
