"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DateTimeColumn = void 0;
class DateTimeColumn {
    /**
     * Instantiates a new dateTimeColumn and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the displayAs property value. How the value should be presented in the UX. Must be one of default, friendly, or standard. See below for more details. If unspecified, treated as default.
     * @returns a string
     */
    get displayAs() {
        return this._displayAs;
    }
    ;
    /**
     * Sets the displayAs property value. How the value should be presented in the UX. Must be one of default, friendly, or standard. See below for more details. If unspecified, treated as default.
     * @param value Value to set for the displayAs property.
     */
    set displayAs(value) {
        this._displayAs = value;
    }
    ;
    /**
     * Gets the format property value. Indicates whether the value should be presented as a date only or a date and time. Must be one of dateOnly or dateTime
     * @returns a string
     */
    get format() {
        return this._format;
    }
    ;
    /**
     * Sets the format property value. Indicates whether the value should be presented as a date only or a date and time. Must be one of dateOnly or dateTime
     * @param value Value to set for the format property.
     */
    set format(value) {
        this._format = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "displayAs": (o, n) => { o.displayAs = n.getStringValue(); },
            "format": (o, n) => { o.format = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("displayAs", this.displayAs);
        writer.writeStringValue("format", this.format);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.DateTimeColumn = DateTimeColumn;
