"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultColumnValue = void 0;
class DefaultColumnValue {
    /**
     * Instantiates a new defaultColumnValue and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the formula property value. The formula used to compute the default value for this column.
     * @returns a string
     */
    get formula() {
        return this._formula;
    }
    ;
    /**
     * Sets the formula property value. The formula used to compute the default value for this column.
     * @param value Value to set for the formula property.
     */
    set formula(value) {
        this._formula = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "formula": (o, n) => { o.formula = n.getStringValue(); },
            "value": (o, n) => { o.value = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("formula", this.formula);
        writer.writeStringValue("value", this.value);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the value property value. The direct value to use as the default value for this column.
     * @returns a string
     */
    get value() {
        return this._value;
    }
    ;
    /**
     * Sets the value property value. The direct value to use as the default value for this column.
     * @param value Value to set for the value property.
     */
    set value(value) {
        this._value = value;
    }
    ;
}
exports.DefaultColumnValue = DefaultColumnValue;
