"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultUserRolePermissions = void 0;
class DefaultUserRolePermissions {
    /**
     * Instantiates a new defaultUserRolePermissions and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the allowedToCreateApps property value. Indicates whether the default user role can create applications.
     * @returns a boolean
     */
    get allowedToCreateApps() {
        return this._allowedToCreateApps;
    }
    ;
    /**
     * Sets the allowedToCreateApps property value. Indicates whether the default user role can create applications.
     * @param value Value to set for the allowedToCreateApps property.
     */
    set allowedToCreateApps(value) {
        this._allowedToCreateApps = value;
    }
    ;
    /**
     * Gets the allowedToCreateSecurityGroups property value. Indicates whether the default user role can create security groups.
     * @returns a boolean
     */
    get allowedToCreateSecurityGroups() {
        return this._allowedToCreateSecurityGroups;
    }
    ;
    /**
     * Sets the allowedToCreateSecurityGroups property value. Indicates whether the default user role can create security groups.
     * @param value Value to set for the allowedToCreateSecurityGroups property.
     */
    set allowedToCreateSecurityGroups(value) {
        this._allowedToCreateSecurityGroups = value;
    }
    ;
    /**
     * Gets the allowedToReadOtherUsers property value. Indicates whether the default user role can read other users.
     * @returns a boolean
     */
    get allowedToReadOtherUsers() {
        return this._allowedToReadOtherUsers;
    }
    ;
    /**
     * Sets the allowedToReadOtherUsers property value. Indicates whether the default user role can read other users.
     * @param value Value to set for the allowedToReadOtherUsers property.
     */
    set allowedToReadOtherUsers(value) {
        this._allowedToReadOtherUsers = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "allowedToCreateApps": (o, n) => { o.allowedToCreateApps = n.getBooleanValue(); },
            "allowedToCreateSecurityGroups": (o, n) => { o.allowedToCreateSecurityGroups = n.getBooleanValue(); },
            "allowedToReadOtherUsers": (o, n) => { o.allowedToReadOtherUsers = n.getBooleanValue(); },
            "permissionGrantPoliciesAssigned": (o, n) => { o.permissionGrantPoliciesAssigned = n.getCollectionOfPrimitiveValues(); },
        };
    }
    ;
    /**
     * Gets the permissionGrantPoliciesAssigned property value. Indicates if user consent to apps is allowed, and if it is, which permission to grant consent and which app consent policy (permissionGrantPolicy) govern the permission for users to grant consent. Value should be in the format managePermissionGrantsForSelf.{id}, where {id} is the id of a built-in or custom app consent policy. An empty list indicates user consent to apps is disabled.
     * @returns a string
     */
    get permissionGrantPoliciesAssigned() {
        return this._permissionGrantPoliciesAssigned;
    }
    ;
    /**
     * Sets the permissionGrantPoliciesAssigned property value. Indicates if user consent to apps is allowed, and if it is, which permission to grant consent and which app consent policy (permissionGrantPolicy) govern the permission for users to grant consent. Value should be in the format managePermissionGrantsForSelf.{id}, where {id} is the id of a built-in or custom app consent policy. An empty list indicates user consent to apps is disabled.
     * @param value Value to set for the permissionGrantPoliciesAssigned property.
     */
    set permissionGrantPoliciesAssigned(value) {
        this._permissionGrantPoliciesAssigned = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("allowedToCreateApps", this.allowedToCreateApps);
        writer.writeBooleanValue("allowedToCreateSecurityGroups", this.allowedToCreateSecurityGroups);
        writer.writeBooleanValue("allowedToReadOtherUsers", this.allowedToReadOtherUsers);
        writer.writeCollectionOfPrimitiveValues("permissionGrantPoliciesAssigned", this.permissionGrantPoliciesAssigned);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.DefaultUserRolePermissions = DefaultUserRolePermissions;
