"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DelegatedPermissionClassification = void 0;
const index_1 = require("./index");
const permissionClassificationType_1 = require("./permissionClassificationType");
class DelegatedPermissionClassification extends index_1.Entity {
    /**
     * Instantiates a new delegatedPermissionClassification and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the classification property value. The classification value being given. Possible value: low. Does not support $filter.
     * @returns a permissionClassificationType
     */
    get classification() {
        return this._classification;
    }
    ;
    /**
     * Sets the classification property value. The classification value being given. Possible value: low. Does not support $filter.
     * @param value Value to set for the classification property.
     */
    set classification(value) {
        this._classification = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "classification": (o, n) => { o.classification = n.getEnumValue(permissionClassificationType_1.PermissionClassificationType); }, "permissionId": (o, n) => { o.permissionId = n.getStringValue(); }, "permissionName": (o, n) => { o.permissionName = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the permissionId property value. The unique identifier (id) for the delegated permission listed in the oauth2PermissionScopes collection of the servicePrincipal. Required on create. Does not support $filter.
     * @returns a string
     */
    get permissionId() {
        return this._permissionId;
    }
    ;
    /**
     * Sets the permissionId property value. The unique identifier (id) for the delegated permission listed in the oauth2PermissionScopes collection of the servicePrincipal. Required on create. Does not support $filter.
     * @param value Value to set for the permissionId property.
     */
    set permissionId(value) {
        this._permissionId = value;
    }
    ;
    /**
     * Gets the permissionName property value. The claim value (value) for the delegated permission listed in the oauth2PermissionScopes collection of the servicePrincipal. Does not support $filter.
     * @returns a string
     */
    get permissionName() {
        return this._permissionName;
    }
    ;
    /**
     * Sets the permissionName property value. The claim value (value) for the delegated permission listed in the oauth2PermissionScopes collection of the servicePrincipal. Does not support $filter.
     * @param value Value to set for the permissionName property.
     */
    set permissionName(value) {
        this._permissionName = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeEnumValue("classification", this.classification);
        writer.writeStringValue("permissionId", this.permissionId);
        writer.writeStringValue("permissionName", this.permissionName);
    }
    ;
}
exports.DelegatedPermissionClassification = DelegatedPermissionClassification;
