"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Device = void 0;
const createAlternativeSecurityIdFromDiscriminatorValue_1 = require("./createAlternativeSecurityIdFromDiscriminatorValue");
const createDirectoryObjectFromDiscriminatorValue_1 = require("./createDirectoryObjectFromDiscriminatorValue");
const createExtensionFromDiscriminatorValue_1 = require("./createExtensionFromDiscriminatorValue");
const index_1 = require("./index");
class Device extends index_1.DirectoryObject {
    /**
     * Instantiates a new device and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the accountEnabled property value. true if the account is enabled; otherwise, false. Required. Default is true.  Supports $filter (eq, ne, not, in). Only callers in Global Administrator and Cloud Device Administrator roles can set this property.
     * @returns a boolean
     */
    get accountEnabled() {
        return this._accountEnabled;
    }
    ;
    /**
     * Sets the accountEnabled property value. true if the account is enabled; otherwise, false. Required. Default is true.  Supports $filter (eq, ne, not, in). Only callers in Global Administrator and Cloud Device Administrator roles can set this property.
     * @param value Value to set for the accountEnabled property.
     */
    set accountEnabled(value) {
        this._accountEnabled = value;
    }
    ;
    /**
     * Gets the alternativeSecurityIds property value. For internal use only. Not nullable. Supports $filter (eq, not, ge, le).
     * @returns a alternativeSecurityId
     */
    get alternativeSecurityIds() {
        return this._alternativeSecurityIds;
    }
    ;
    /**
     * Sets the alternativeSecurityIds property value. For internal use only. Not nullable. Supports $filter (eq, not, ge, le).
     * @param value Value to set for the alternativeSecurityIds property.
     */
    set alternativeSecurityIds(value) {
        this._alternativeSecurityIds = value;
    }
    ;
    /**
     * Gets the approximateLastSignInDateTime property value. The timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only. Supports $filter (eq, ne, not, ge, le, and eq on null values) and $orderBy.
     * @returns a Date
     */
    get approximateLastSignInDateTime() {
        return this._approximateLastSignInDateTime;
    }
    ;
    /**
     * Sets the approximateLastSignInDateTime property value. The timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only. Supports $filter (eq, ne, not, ge, le, and eq on null values) and $orderBy.
     * @param value Value to set for the approximateLastSignInDateTime property.
     */
    set approximateLastSignInDateTime(value) {
        this._approximateLastSignInDateTime = value;
    }
    ;
    /**
     * Gets the complianceExpirationDateTime property value. The timestamp when the device is no longer deemed compliant. The timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
     * @returns a Date
     */
    get complianceExpirationDateTime() {
        return this._complianceExpirationDateTime;
    }
    ;
    /**
     * Sets the complianceExpirationDateTime property value. The timestamp when the device is no longer deemed compliant. The timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
     * @param value Value to set for the complianceExpirationDateTime property.
     */
    set complianceExpirationDateTime(value) {
        this._complianceExpirationDateTime = value;
    }
    ;
    ;
    /**
     * Gets the deviceId property value. Unique identifier set by Azure Device Registration Service at the time of registration. Supports $filter (eq, ne, not, startsWith).
     * @returns a string
     */
    get deviceId() {
        return this._deviceId;
    }
    ;
    /**
     * Sets the deviceId property value. Unique identifier set by Azure Device Registration Service at the time of registration. Supports $filter (eq, ne, not, startsWith).
     * @param value Value to set for the deviceId property.
     */
    set deviceId(value) {
        this._deviceId = value;
    }
    ;
    /**
     * Gets the deviceMetadata property value. For internal use only. Set to null.
     * @returns a string
     */
    get deviceMetadata() {
        return this._deviceMetadata;
    }
    ;
    /**
     * Sets the deviceMetadata property value. For internal use only. Set to null.
     * @param value Value to set for the deviceMetadata property.
     */
    set deviceMetadata(value) {
        this._deviceMetadata = value;
    }
    ;
    /**
     * Gets the deviceVersion property value. For internal use only.
     * @returns a integer
     */
    get deviceVersion() {
        return this._deviceVersion;
    }
    ;
    /**
     * Sets the deviceVersion property value. For internal use only.
     * @param value Value to set for the deviceVersion property.
     */
    set deviceVersion(value) {
        this._deviceVersion = value;
    }
    ;
    /**
     * Gets the displayName property value. The display name for the device. Required. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values), $search, and $orderBy.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The display name for the device. Required. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values), $search, and $orderBy.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * Gets the extensions property value. The collection of open extensions defined for the device. Read-only. Nullable.
     * @returns a extension
     */
    get extensions() {
        return this._extensions;
    }
    ;
    /**
     * Sets the extensions property value. The collection of open extensions defined for the device. Read-only. Nullable.
     * @param value Value to set for the extensions property.
     */
    set extensions(value) {
        this._extensions = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "accountEnabled": (o, n) => { o.accountEnabled = n.getBooleanValue(); }, "alternativeSecurityIds": (o, n) => { o.alternativeSecurityIds = n.getCollectionOfObjectValues(createAlternativeSecurityIdFromDiscriminatorValue_1.createAlternativeSecurityIdFromDiscriminatorValue); }, "approximateLastSignInDateTime": (o, n) => { o.approximateLastSignInDateTime = n.getDateValue(); }, "complianceExpirationDateTime": (o, n) => { o.complianceExpirationDateTime = n.getDateValue(); }, "deviceId": (o, n) => { o.deviceId = n.getStringValue(); }, "deviceMetadata": (o, n) => { o.deviceMetadata = n.getStringValue(); }, "deviceVersion": (o, n) => { o.deviceVersion = n.getNumberValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "extensions": (o, n) => { o.extensions = n.getCollectionOfObjectValues(createExtensionFromDiscriminatorValue_1.createExtensionFromDiscriminatorValue); }, "isCompliant": (o, n) => { o.isCompliant = n.getBooleanValue(); }, "isManaged": (o, n) => { o.isManaged = n.getBooleanValue(); }, "mdmAppId": (o, n) => { o.mdmAppId = n.getStringValue(); }, "memberOf": (o, n) => { o.memberOf = n.getCollectionOfObjectValues(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "onPremisesLastSyncDateTime": (o, n) => { o.onPremisesLastSyncDateTime = n.getDateValue(); }, "onPremisesSyncEnabled": (o, n) => { o.onPremisesSyncEnabled = n.getBooleanValue(); }, "operatingSystem": (o, n) => { o.operatingSystem = n.getStringValue(); }, "operatingSystemVersion": (o, n) => { o.operatingSystemVersion = n.getStringValue(); }, "physicalIds": (o, n) => { o.physicalIds = n.getCollectionOfPrimitiveValues(); }, "profileType": (o, n) => { o.profileType = n.getStringValue(); }, "registeredOwners": (o, n) => { o.registeredOwners = n.getCollectionOfObjectValues(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "registeredUsers": (o, n) => { o.registeredUsers = n.getCollectionOfObjectValues(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "systemLabels": (o, n) => { o.systemLabels = n.getCollectionOfPrimitiveValues(); }, "transitiveMemberOf": (o, n) => { o.transitiveMemberOf = n.getCollectionOfObjectValues(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "trustType": (o, n) => { o.trustType = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the isCompliant property value. true if the device complies with Mobile Device Management (MDM) policies; otherwise, false. Read-only. This can only be updated by Intune for any device OS type or by an approved MDM app for Windows OS devices. Supports $filter (eq, ne, not).
     * @returns a boolean
     */
    get isCompliant() {
        return this._isCompliant;
    }
    ;
    /**
     * Sets the isCompliant property value. true if the device complies with Mobile Device Management (MDM) policies; otherwise, false. Read-only. This can only be updated by Intune for any device OS type or by an approved MDM app for Windows OS devices. Supports $filter (eq, ne, not).
     * @param value Value to set for the isCompliant property.
     */
    set isCompliant(value) {
        this._isCompliant = value;
    }
    ;
    /**
     * Gets the isManaged property value. true if the device is managed by a Mobile Device Management (MDM) app; otherwise, false. This can only be updated by Intune for any device OS type or by an approved MDM app for Windows OS devices. Supports $filter (eq, ne, not).
     * @returns a boolean
     */
    get isManaged() {
        return this._isManaged;
    }
    ;
    /**
     * Sets the isManaged property value. true if the device is managed by a Mobile Device Management (MDM) app; otherwise, false. This can only be updated by Intune for any device OS type or by an approved MDM app for Windows OS devices. Supports $filter (eq, ne, not).
     * @param value Value to set for the isManaged property.
     */
    set isManaged(value) {
        this._isManaged = value;
    }
    ;
    /**
     * Gets the mdmAppId property value. Application identifier used to register device into MDM. Read-only. Supports $filter (eq, ne, not, startsWith).
     * @returns a string
     */
    get mdmAppId() {
        return this._mdmAppId;
    }
    ;
    /**
     * Sets the mdmAppId property value. Application identifier used to register device into MDM. Read-only. Supports $filter (eq, ne, not, startsWith).
     * @param value Value to set for the mdmAppId property.
     */
    set mdmAppId(value) {
        this._mdmAppId = value;
    }
    ;
    /**
     * Gets the memberOf property value. Groups that this device is a member of. Read-only. Nullable. Supports $expand.
     * @returns a directoryObject
     */
    get memberOf() {
        return this._memberOf;
    }
    ;
    /**
     * Sets the memberOf property value. Groups that this device is a member of. Read-only. Nullable. Supports $expand.
     * @param value Value to set for the memberOf property.
     */
    set memberOf(value) {
        this._memberOf = value;
    }
    ;
    /**
     * Gets the onPremisesLastSyncDateTime property value. The last time at which the object was synced with the on-premises directory. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z Read-only. Supports $filter (eq, ne, not, ge, le, in).
     * @returns a Date
     */
    get onPremisesLastSyncDateTime() {
        return this._onPremisesLastSyncDateTime;
    }
    ;
    /**
     * Sets the onPremisesLastSyncDateTime property value. The last time at which the object was synced with the on-premises directory. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z Read-only. Supports $filter (eq, ne, not, ge, le, in).
     * @param value Value to set for the onPremisesLastSyncDateTime property.
     */
    set onPremisesLastSyncDateTime(value) {
        this._onPremisesLastSyncDateTime = value;
    }
    ;
    /**
     * Gets the onPremisesSyncEnabled property value. true if this object is synced from an on-premises directory; false if this object was originally synced from an on-premises directory but is no longer synced; null if this object has never been synced from an on-premises directory (default). Read-only. Supports $filter (eq, ne, not, in, and eq on null values).
     * @returns a boolean
     */
    get onPremisesSyncEnabled() {
        return this._onPremisesSyncEnabled;
    }
    ;
    /**
     * Sets the onPremisesSyncEnabled property value. true if this object is synced from an on-premises directory; false if this object was originally synced from an on-premises directory but is no longer synced; null if this object has never been synced from an on-premises directory (default). Read-only. Supports $filter (eq, ne, not, in, and eq on null values).
     * @param value Value to set for the onPremisesSyncEnabled property.
     */
    set onPremisesSyncEnabled(value) {
        this._onPremisesSyncEnabled = value;
    }
    ;
    /**
     * Gets the operatingSystem property value. The type of operating system on the device. Required. Supports $filter (eq, ne, not, ge, le, startsWith, and eq on null values).
     * @returns a string
     */
    get operatingSystem() {
        return this._operatingSystem;
    }
    ;
    /**
     * Sets the operatingSystem property value. The type of operating system on the device. Required. Supports $filter (eq, ne, not, ge, le, startsWith, and eq on null values).
     * @param value Value to set for the operatingSystem property.
     */
    set operatingSystem(value) {
        this._operatingSystem = value;
    }
    ;
    /**
     * Gets the operatingSystemVersion property value. The version of the operating system on the device. Required. Supports $filter (eq, ne, not, ge, le, startsWith, and eq on null values).
     * @returns a string
     */
    get operatingSystemVersion() {
        return this._operatingSystemVersion;
    }
    ;
    /**
     * Sets the operatingSystemVersion property value. The version of the operating system on the device. Required. Supports $filter (eq, ne, not, ge, le, startsWith, and eq on null values).
     * @param value Value to set for the operatingSystemVersion property.
     */
    set operatingSystemVersion(value) {
        this._operatingSystemVersion = value;
    }
    ;
    /**
     * Gets the physicalIds property value. For internal use only. Not nullable. Supports $filter (eq, not, ge, le, startsWith).
     * @returns a string
     */
    get physicalIds() {
        return this._physicalIds;
    }
    ;
    /**
     * Sets the physicalIds property value. For internal use only. Not nullable. Supports $filter (eq, not, ge, le, startsWith).
     * @param value Value to set for the physicalIds property.
     */
    set physicalIds(value) {
        this._physicalIds = value;
    }
    ;
    /**
     * Gets the profileType property value. The profile type of the device. Possible values: RegisteredDevice (default), SecureVM, Printer, Shared, IoT.
     * @returns a string
     */
    get profileType() {
        return this._profileType;
    }
    ;
    /**
     * Sets the profileType property value. The profile type of the device. Possible values: RegisteredDevice (default), SecureVM, Printer, Shared, IoT.
     * @param value Value to set for the profileType property.
     */
    set profileType(value) {
        this._profileType = value;
    }
    ;
    /**
     * Gets the registeredOwners property value. The user that cloud joined the device or registered their personal device. The registered owner is set at the time of registration. Currently, there can be only one owner. Read-only. Nullable. Supports $expand.
     * @returns a directoryObject
     */
    get registeredOwners() {
        return this._registeredOwners;
    }
    ;
    /**
     * Sets the registeredOwners property value. The user that cloud joined the device or registered their personal device. The registered owner is set at the time of registration. Currently, there can be only one owner. Read-only. Nullable. Supports $expand.
     * @param value Value to set for the registeredOwners property.
     */
    set registeredOwners(value) {
        this._registeredOwners = value;
    }
    ;
    /**
     * Gets the registeredUsers property value. Collection of registered users of the device. For cloud joined devices and registered personal devices, registered users are set to the same value as registered owners at the time of registration. Read-only. Nullable. Supports $expand.
     * @returns a directoryObject
     */
    get registeredUsers() {
        return this._registeredUsers;
    }
    ;
    /**
     * Sets the registeredUsers property value. Collection of registered users of the device. For cloud joined devices and registered personal devices, registered users are set to the same value as registered owners at the time of registration. Read-only. Nullable. Supports $expand.
     * @param value Value to set for the registeredUsers property.
     */
    set registeredUsers(value) {
        this._registeredUsers = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeBooleanValue("accountEnabled", this.accountEnabled);
        writer.writeCollectionOfObjectValues("alternativeSecurityIds", this.alternativeSecurityIds);
        writer.writeDateValue("approximateLastSignInDateTime", this.approximateLastSignInDateTime);
        writer.writeDateValue("complianceExpirationDateTime", this.complianceExpirationDateTime);
        writer.writeStringValue("deviceId", this.deviceId);
        writer.writeStringValue("deviceMetadata", this.deviceMetadata);
        writer.writeNumberValue("deviceVersion", this.deviceVersion);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeCollectionOfObjectValues("extensions", this.extensions);
        writer.writeBooleanValue("isCompliant", this.isCompliant);
        writer.writeBooleanValue("isManaged", this.isManaged);
        writer.writeStringValue("mdmAppId", this.mdmAppId);
        writer.writeCollectionOfObjectValues("memberOf", this.memberOf);
        writer.writeDateValue("onPremisesLastSyncDateTime", this.onPremisesLastSyncDateTime);
        writer.writeBooleanValue("onPremisesSyncEnabled", this.onPremisesSyncEnabled);
        writer.writeStringValue("operatingSystem", this.operatingSystem);
        writer.writeStringValue("operatingSystemVersion", this.operatingSystemVersion);
        writer.writeCollectionOfPrimitiveValues("physicalIds", this.physicalIds);
        writer.writeStringValue("profileType", this.profileType);
        writer.writeCollectionOfObjectValues("registeredOwners", this.registeredOwners);
        writer.writeCollectionOfObjectValues("registeredUsers", this.registeredUsers);
        writer.writeCollectionOfPrimitiveValues("systemLabels", this.systemLabels);
        writer.writeCollectionOfObjectValues("transitiveMemberOf", this.transitiveMemberOf);
        writer.writeStringValue("trustType", this.trustType);
    }
    ;
    /**
     * Gets the systemLabels property value. List of labels applied to the device by the system.
     * @returns a string
     */
    get systemLabels() {
        return this._systemLabels;
    }
    ;
    /**
     * Sets the systemLabels property value. List of labels applied to the device by the system.
     * @param value Value to set for the systemLabels property.
     */
    set systemLabels(value) {
        this._systemLabels = value;
    }
    ;
    /**
     * Gets the transitiveMemberOf property value. Groups that the device is a member of. This operation is transitive. Supports $expand.
     * @returns a directoryObject
     */
    get transitiveMemberOf() {
        return this._transitiveMemberOf;
    }
    ;
    /**
     * Sets the transitiveMemberOf property value. Groups that the device is a member of. This operation is transitive. Supports $expand.
     * @param value Value to set for the transitiveMemberOf property.
     */
    set transitiveMemberOf(value) {
        this._transitiveMemberOf = value;
    }
    ;
    /**
     * Gets the trustType property value. Type of trust for the joined device. Read-only. Possible values:  Workplace (indicates bring your own personal devices), AzureAd (Cloud only joined devices), ServerAd (on-premises domain joined devices joined to Azure AD). For more details, see Introduction to device management in Azure Active Directory
     * @returns a string
     */
    get trustType() {
        return this._trustType;
    }
    ;
    /**
     * Sets the trustType property value. Type of trust for the joined device. Read-only. Possible values:  Workplace (indicates bring your own personal devices), AzureAd (Cloud only joined devices), ServerAd (on-premises domain joined devices joined to Azure AD). For more details, see Introduction to device management in Azure Active Directory
     * @param value Value to set for the trustType property.
     */
    set trustType(value) {
        this._trustType = value;
    }
    ;
}
exports.Device = Device;
