import { ActionState } from './actionState';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Device action result  */
export declare class DeviceActionResult implements AdditionalDataHolder, Parsable {
    /** Action name  */
    private _actionName?;
    /** State of the action. Possible values are: none, pending, canceled, active, done, failed, notSupported.  */
    private _actionState?;
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Time the action state was last updated  */
    private _lastUpdatedDateTime?;
    /** Time the action was initiated  */
    private _startDateTime?;
    /**
     * Gets the actionName property value. Action name
     * @returns a string
     */
    get actionName(): string | undefined;
    /**
     * Sets the actionName property value. Action name
     * @param value Value to set for the actionName property.
     */
    set actionName(value: string | undefined);
    /**
     * Gets the actionState property value. State of the action. Possible values are: none, pending, canceled, active, done, failed, notSupported.
     * @returns a actionState
     */
    get actionState(): ActionState | undefined;
    /**
     * Sets the actionState property value. State of the action. Possible values are: none, pending, canceled, active, done, failed, notSupported.
     * @param value Value to set for the actionState property.
     */
    set actionState(value: ActionState | undefined);
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new deviceActionResult and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the lastUpdatedDateTime property value. Time the action state was last updated
     * @returns a Date
     */
    get lastUpdatedDateTime(): Date | undefined;
    /**
     * Sets the lastUpdatedDateTime property value. Time the action state was last updated
     * @param value Value to set for the lastUpdatedDateTime property.
     */
    set lastUpdatedDateTime(value: Date | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the startDateTime property value. Time the action was initiated
     * @returns a Date
     */
    get startDateTime(): Date | undefined;
    /**
     * Sets the startDateTime property value. Time the action was initiated
     * @param value Value to set for the startDateTime property.
     */
    set startDateTime(value: Date | undefined);
}
