import { Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class DeviceCategory extends Entity implements Parsable {
    /** Optional description for the device category.  */
    private _description?;
    /** Display name for the device category.  */
    private _displayName?;
    /**
     * Instantiates a new deviceCategory and sets the default values.
     */
    constructor();
    /**
     * Gets the description property value. Optional description for the device category.
     * @returns a string
     */
    get description(): string | undefined;
    /**
     * Sets the description property value. Optional description for the device category.
     * @param value Value to set for the description property.
     */
    set description(value: string | undefined);
    /**
     * Gets the displayName property value. Display name for the device category.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. Display name for the device category.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
