import { DeviceComplianceActionType } from './deviceComplianceActionType';
import { Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class DeviceComplianceActionItem extends Entity implements Parsable {
    /** What action to take. Possible values are: noAction, notification, block, retire, wipe, removeResourceAccessProfiles, pushNotification.  */
    private _actionType?;
    /** Number of hours to wait till the action will be enforced. Valid values 0 to 8760  */
    private _gracePeriodHours?;
    /** A list of group IDs to speicify who to CC this notification message to.  */
    private _notificationMessageCCList?;
    /** What notification Message template to use  */
    private _notificationTemplateId?;
    /**
     * Gets the actionType property value. What action to take. Possible values are: noAction, notification, block, retire, wipe, removeResourceAccessProfiles, pushNotification.
     * @returns a deviceComplianceActionType
     */
    get actionType(): DeviceComplianceActionType | undefined;
    /**
     * Sets the actionType property value. What action to take. Possible values are: noAction, notification, block, retire, wipe, removeResourceAccessProfiles, pushNotification.
     * @param value Value to set for the actionType property.
     */
    set actionType(value: DeviceComplianceActionType | undefined);
    /**
     * Instantiates a new deviceComplianceActionItem and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the gracePeriodHours property value. Number of hours to wait till the action will be enforced. Valid values 0 to 8760
     * @returns a integer
     */
    get gracePeriodHours(): number | undefined;
    /**
     * Sets the gracePeriodHours property value. Number of hours to wait till the action will be enforced. Valid values 0 to 8760
     * @param value Value to set for the gracePeriodHours property.
     */
    set gracePeriodHours(value: number | undefined);
    /**
     * Gets the notificationMessageCCList property value. A list of group IDs to speicify who to CC this notification message to.
     * @returns a string
     */
    get notificationMessageCCList(): string[] | undefined;
    /**
     * Sets the notificationMessageCCList property value. A list of group IDs to speicify who to CC this notification message to.
     * @param value Value to set for the notificationMessageCCList property.
     */
    set notificationMessageCCList(value: string[] | undefined);
    /**
     * Gets the notificationTemplateId property value. What notification Message template to use
     * @returns a string
     */
    get notificationTemplateId(): string | undefined;
    /**
     * Sets the notificationTemplateId property value. What notification Message template to use
     * @param value Value to set for the notificationTemplateId property.
     */
    set notificationTemplateId(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
