"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeviceComplianceActionItem = void 0;
const deviceComplianceActionType_1 = require("./deviceComplianceActionType");
const index_1 = require("./index");
class DeviceComplianceActionItem extends index_1.Entity {
    /**
     * Instantiates a new deviceComplianceActionItem and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the actionType property value. What action to take. Possible values are: noAction, notification, block, retire, wipe, removeResourceAccessProfiles, pushNotification.
     * @returns a deviceComplianceActionType
     */
    get actionType() {
        return this._actionType;
    }
    ;
    /**
     * Sets the actionType property value. What action to take. Possible values are: noAction, notification, block, retire, wipe, removeResourceAccessProfiles, pushNotification.
     * @param value Value to set for the actionType property.
     */
    set actionType(value) {
        this._actionType = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "actionType": (o, n) => { o.actionType = n.getEnumValue(deviceComplianceActionType_1.DeviceComplianceActionType); }, "gracePeriodHours": (o, n) => { o.gracePeriodHours = n.getNumberValue(); }, "notificationMessageCCList": (o, n) => { o.notificationMessageCCList = n.getCollectionOfPrimitiveValues(); }, "notificationTemplateId": (o, n) => { o.notificationTemplateId = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the gracePeriodHours property value. Number of hours to wait till the action will be enforced. Valid values 0 to 8760
     * @returns a integer
     */
    get gracePeriodHours() {
        return this._gracePeriodHours;
    }
    ;
    /**
     * Sets the gracePeriodHours property value. Number of hours to wait till the action will be enforced. Valid values 0 to 8760
     * @param value Value to set for the gracePeriodHours property.
     */
    set gracePeriodHours(value) {
        this._gracePeriodHours = value;
    }
    ;
    /**
     * Gets the notificationMessageCCList property value. A list of group IDs to speicify who to CC this notification message to.
     * @returns a string
     */
    get notificationMessageCCList() {
        return this._notificationMessageCCList;
    }
    ;
    /**
     * Sets the notificationMessageCCList property value. A list of group IDs to speicify who to CC this notification message to.
     * @param value Value to set for the notificationMessageCCList property.
     */
    set notificationMessageCCList(value) {
        this._notificationMessageCCList = value;
    }
    ;
    /**
     * Gets the notificationTemplateId property value. What notification Message template to use
     * @returns a string
     */
    get notificationTemplateId() {
        return this._notificationTemplateId;
    }
    ;
    /**
     * Sets the notificationTemplateId property value. What notification Message template to use
     * @param value Value to set for the notificationTemplateId property.
     */
    set notificationTemplateId(value) {
        this._notificationTemplateId = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeEnumValue("actionType", this.actionType);
        writer.writeNumberValue("gracePeriodHours", this.gracePeriodHours);
        writer.writeCollectionOfPrimitiveValues("notificationMessageCCList", this.notificationMessageCCList);
        writer.writeStringValue("notificationTemplateId", this.notificationTemplateId);
    }
    ;
}
exports.DeviceComplianceActionItem = DeviceComplianceActionItem;
