import { ComplianceStatus } from './complianceStatus';
import { Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class DeviceComplianceDeviceStatus extends Entity implements Parsable {
    /** The DateTime when device compliance grace period expires  */
    private _complianceGracePeriodExpirationDateTime?;
    /** Device name of the DevicePolicyStatus.  */
    private _deviceDisplayName?;
    /** The device model that is being reported  */
    private _deviceModel?;
    /** Last modified date time of the policy report.  */
    private _lastReportedDateTime?;
    /** Compliance status of the policy report. Possible values are: unknown, notApplicable, compliant, remediated, nonCompliant, error, conflict, notAssigned.  */
    private _status?;
    /** The User Name that is being reported  */
    private _userName?;
    /** UserPrincipalName.  */
    private _userPrincipalName?;
    /**
     * Gets the complianceGracePeriodExpirationDateTime property value. The DateTime when device compliance grace period expires
     * @returns a Date
     */
    get complianceGracePeriodExpirationDateTime(): Date | undefined;
    /**
     * Sets the complianceGracePeriodExpirationDateTime property value. The DateTime when device compliance grace period expires
     * @param value Value to set for the complianceGracePeriodExpirationDateTime property.
     */
    set complianceGracePeriodExpirationDateTime(value: Date | undefined);
    /**
     * Instantiates a new deviceComplianceDeviceStatus and sets the default values.
     */
    constructor();
    /**
     * Gets the deviceDisplayName property value. Device name of the DevicePolicyStatus.
     * @returns a string
     */
    get deviceDisplayName(): string | undefined;
    /**
     * Sets the deviceDisplayName property value. Device name of the DevicePolicyStatus.
     * @param value Value to set for the deviceDisplayName property.
     */
    set deviceDisplayName(value: string | undefined);
    /**
     * Gets the deviceModel property value. The device model that is being reported
     * @returns a string
     */
    get deviceModel(): string | undefined;
    /**
     * Sets the deviceModel property value. The device model that is being reported
     * @param value Value to set for the deviceModel property.
     */
    set deviceModel(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the lastReportedDateTime property value. Last modified date time of the policy report.
     * @returns a Date
     */
    get lastReportedDateTime(): Date | undefined;
    /**
     * Sets the lastReportedDateTime property value. Last modified date time of the policy report.
     * @param value Value to set for the lastReportedDateTime property.
     */
    set lastReportedDateTime(value: Date | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the status property value. Compliance status of the policy report. Possible values are: unknown, notApplicable, compliant, remediated, nonCompliant, error, conflict, notAssigned.
     * @returns a complianceStatus
     */
    get status(): ComplianceStatus | undefined;
    /**
     * Sets the status property value. Compliance status of the policy report. Possible values are: unknown, notApplicable, compliant, remediated, nonCompliant, error, conflict, notAssigned.
     * @param value Value to set for the status property.
     */
    set status(value: ComplianceStatus | undefined);
    /**
     * Gets the userName property value. The User Name that is being reported
     * @returns a string
     */
    get userName(): string | undefined;
    /**
     * Sets the userName property value. The User Name that is being reported
     * @param value Value to set for the userName property.
     */
    set userName(value: string | undefined);
    /**
     * Gets the userPrincipalName property value. UserPrincipalName.
     * @returns a string
     */
    get userPrincipalName(): string | undefined;
    /**
     * Sets the userPrincipalName property value. UserPrincipalName.
     * @param value Value to set for the userPrincipalName property.
     */
    set userPrincipalName(value: string | undefined);
}
