import { Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class DeviceCompliancePolicyDeviceStateSummary extends Entity implements Parsable {
    /** Number of compliant devices  */
    private _compliantDeviceCount?;
    /** Number of devices that have compliance managed by System Center Configuration Manager  */
    private _configManagerCount?;
    /** Number of conflict devices  */
    private _conflictDeviceCount?;
    /** Number of error devices  */
    private _errorDeviceCount?;
    /** Number of devices that are in grace period  */
    private _inGracePeriodCount?;
    /** Number of NonCompliant devices  */
    private _nonCompliantDeviceCount?;
    /** Number of not applicable devices  */
    private _notApplicableDeviceCount?;
    /** Number of remediated devices  */
    private _remediatedDeviceCount?;
    /** Number of unknown devices  */
    private _unknownDeviceCount?;
    /**
     * Gets the compliantDeviceCount property value. Number of compliant devices
     * @returns a integer
     */
    get compliantDeviceCount(): number | undefined;
    /**
     * Sets the compliantDeviceCount property value. Number of compliant devices
     * @param value Value to set for the compliantDeviceCount property.
     */
    set compliantDeviceCount(value: number | undefined);
    /**
     * Gets the configManagerCount property value. Number of devices that have compliance managed by System Center Configuration Manager
     * @returns a integer
     */
    get configManagerCount(): number | undefined;
    /**
     * Sets the configManagerCount property value. Number of devices that have compliance managed by System Center Configuration Manager
     * @param value Value to set for the configManagerCount property.
     */
    set configManagerCount(value: number | undefined);
    /**
     * Gets the conflictDeviceCount property value. Number of conflict devices
     * @returns a integer
     */
    get conflictDeviceCount(): number | undefined;
    /**
     * Sets the conflictDeviceCount property value. Number of conflict devices
     * @param value Value to set for the conflictDeviceCount property.
     */
    set conflictDeviceCount(value: number | undefined);
    /**
     * Instantiates a new deviceCompliancePolicyDeviceStateSummary and sets the default values.
     */
    constructor();
    /**
     * Gets the errorDeviceCount property value. Number of error devices
     * @returns a integer
     */
    get errorDeviceCount(): number | undefined;
    /**
     * Sets the errorDeviceCount property value. Number of error devices
     * @param value Value to set for the errorDeviceCount property.
     */
    set errorDeviceCount(value: number | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the inGracePeriodCount property value. Number of devices that are in grace period
     * @returns a integer
     */
    get inGracePeriodCount(): number | undefined;
    /**
     * Sets the inGracePeriodCount property value. Number of devices that are in grace period
     * @param value Value to set for the inGracePeriodCount property.
     */
    set inGracePeriodCount(value: number | undefined);
    /**
     * Gets the nonCompliantDeviceCount property value. Number of NonCompliant devices
     * @returns a integer
     */
    get nonCompliantDeviceCount(): number | undefined;
    /**
     * Sets the nonCompliantDeviceCount property value. Number of NonCompliant devices
     * @param value Value to set for the nonCompliantDeviceCount property.
     */
    set nonCompliantDeviceCount(value: number | undefined);
    /**
     * Gets the notApplicableDeviceCount property value. Number of not applicable devices
     * @returns a integer
     */
    get notApplicableDeviceCount(): number | undefined;
    /**
     * Sets the notApplicableDeviceCount property value. Number of not applicable devices
     * @param value Value to set for the notApplicableDeviceCount property.
     */
    set notApplicableDeviceCount(value: number | undefined);
    /**
     * Gets the remediatedDeviceCount property value. Number of remediated devices
     * @returns a integer
     */
    get remediatedDeviceCount(): number | undefined;
    /**
     * Sets the remediatedDeviceCount property value. Number of remediated devices
     * @param value Value to set for the remediatedDeviceCount property.
     */
    set remediatedDeviceCount(value: number | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the unknownDeviceCount property value. Number of unknown devices
     * @returns a integer
     */
    get unknownDeviceCount(): number | undefined;
    /**
     * Sets the unknownDeviceCount property value. Number of unknown devices
     * @param value Value to set for the unknownDeviceCount property.
     */
    set unknownDeviceCount(value: number | undefined);
}
