"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeviceCompliancePolicyDeviceStateSummary = void 0;
const index_1 = require("./index");
class DeviceCompliancePolicyDeviceStateSummary extends index_1.Entity {
    /**
     * Instantiates a new deviceCompliancePolicyDeviceStateSummary and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the compliantDeviceCount property value. Number of compliant devices
     * @returns a integer
     */
    get compliantDeviceCount() {
        return this._compliantDeviceCount;
    }
    ;
    /**
     * Sets the compliantDeviceCount property value. Number of compliant devices
     * @param value Value to set for the compliantDeviceCount property.
     */
    set compliantDeviceCount(value) {
        this._compliantDeviceCount = value;
    }
    ;
    /**
     * Gets the configManagerCount property value. Number of devices that have compliance managed by System Center Configuration Manager
     * @returns a integer
     */
    get configManagerCount() {
        return this._configManagerCount;
    }
    ;
    /**
     * Sets the configManagerCount property value. Number of devices that have compliance managed by System Center Configuration Manager
     * @param value Value to set for the configManagerCount property.
     */
    set configManagerCount(value) {
        this._configManagerCount = value;
    }
    ;
    /**
     * Gets the conflictDeviceCount property value. Number of conflict devices
     * @returns a integer
     */
    get conflictDeviceCount() {
        return this._conflictDeviceCount;
    }
    ;
    /**
     * Sets the conflictDeviceCount property value. Number of conflict devices
     * @param value Value to set for the conflictDeviceCount property.
     */
    set conflictDeviceCount(value) {
        this._conflictDeviceCount = value;
    }
    ;
    ;
    /**
     * Gets the errorDeviceCount property value. Number of error devices
     * @returns a integer
     */
    get errorDeviceCount() {
        return this._errorDeviceCount;
    }
    ;
    /**
     * Sets the errorDeviceCount property value. Number of error devices
     * @param value Value to set for the errorDeviceCount property.
     */
    set errorDeviceCount(value) {
        this._errorDeviceCount = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "compliantDeviceCount": (o, n) => { o.compliantDeviceCount = n.getNumberValue(); }, "configManagerCount": (o, n) => { o.configManagerCount = n.getNumberValue(); }, "conflictDeviceCount": (o, n) => { o.conflictDeviceCount = n.getNumberValue(); }, "errorDeviceCount": (o, n) => { o.errorDeviceCount = n.getNumberValue(); }, "inGracePeriodCount": (o, n) => { o.inGracePeriodCount = n.getNumberValue(); }, "nonCompliantDeviceCount": (o, n) => { o.nonCompliantDeviceCount = n.getNumberValue(); }, "notApplicableDeviceCount": (o, n) => { o.notApplicableDeviceCount = n.getNumberValue(); }, "remediatedDeviceCount": (o, n) => { o.remediatedDeviceCount = n.getNumberValue(); }, "unknownDeviceCount": (o, n) => { o.unknownDeviceCount = n.getNumberValue(); } });
    }
    ;
    /**
     * Gets the inGracePeriodCount property value. Number of devices that are in grace period
     * @returns a integer
     */
    get inGracePeriodCount() {
        return this._inGracePeriodCount;
    }
    ;
    /**
     * Sets the inGracePeriodCount property value. Number of devices that are in grace period
     * @param value Value to set for the inGracePeriodCount property.
     */
    set inGracePeriodCount(value) {
        this._inGracePeriodCount = value;
    }
    ;
    /**
     * Gets the nonCompliantDeviceCount property value. Number of NonCompliant devices
     * @returns a integer
     */
    get nonCompliantDeviceCount() {
        return this._nonCompliantDeviceCount;
    }
    ;
    /**
     * Sets the nonCompliantDeviceCount property value. Number of NonCompliant devices
     * @param value Value to set for the nonCompliantDeviceCount property.
     */
    set nonCompliantDeviceCount(value) {
        this._nonCompliantDeviceCount = value;
    }
    ;
    /**
     * Gets the notApplicableDeviceCount property value. Number of not applicable devices
     * @returns a integer
     */
    get notApplicableDeviceCount() {
        return this._notApplicableDeviceCount;
    }
    ;
    /**
     * Sets the notApplicableDeviceCount property value. Number of not applicable devices
     * @param value Value to set for the notApplicableDeviceCount property.
     */
    set notApplicableDeviceCount(value) {
        this._notApplicableDeviceCount = value;
    }
    ;
    /**
     * Gets the remediatedDeviceCount property value. Number of remediated devices
     * @returns a integer
     */
    get remediatedDeviceCount() {
        return this._remediatedDeviceCount;
    }
    ;
    /**
     * Sets the remediatedDeviceCount property value. Number of remediated devices
     * @param value Value to set for the remediatedDeviceCount property.
     */
    set remediatedDeviceCount(value) {
        this._remediatedDeviceCount = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeNumberValue("compliantDeviceCount", this.compliantDeviceCount);
        writer.writeNumberValue("configManagerCount", this.configManagerCount);
        writer.writeNumberValue("conflictDeviceCount", this.conflictDeviceCount);
        writer.writeNumberValue("errorDeviceCount", this.errorDeviceCount);
        writer.writeNumberValue("inGracePeriodCount", this.inGracePeriodCount);
        writer.writeNumberValue("nonCompliantDeviceCount", this.nonCompliantDeviceCount);
        writer.writeNumberValue("notApplicableDeviceCount", this.notApplicableDeviceCount);
        writer.writeNumberValue("remediatedDeviceCount", this.remediatedDeviceCount);
        writer.writeNumberValue("unknownDeviceCount", this.unknownDeviceCount);
    }
    ;
    /**
     * Gets the unknownDeviceCount property value. Number of unknown devices
     * @returns a integer
     */
    get unknownDeviceCount() {
        return this._unknownDeviceCount;
    }
    ;
    /**
     * Sets the unknownDeviceCount property value. Number of unknown devices
     * @param value Value to set for the unknownDeviceCount property.
     */
    set unknownDeviceCount(value) {
        this._unknownDeviceCount = value;
    }
    ;
}
exports.DeviceCompliancePolicyDeviceStateSummary = DeviceCompliancePolicyDeviceStateSummary;
