"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeviceCompliancePolicySettingState = void 0;
const complianceStatus_1 = require("./complianceStatus");
const createSettingSourceFromDiscriminatorValue_1 = require("./createSettingSourceFromDiscriminatorValue");
/** Device Compilance Policy Setting State for a given device.  */
class DeviceCompliancePolicySettingState {
    /**
     * Instantiates a new deviceCompliancePolicySettingState and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the currentValue property value. Current value of setting on device
     * @returns a string
     */
    get currentValue() {
        return this._currentValue;
    }
    ;
    /**
     * Sets the currentValue property value. Current value of setting on device
     * @param value Value to set for the currentValue property.
     */
    set currentValue(value) {
        this._currentValue = value;
    }
    ;
    /**
     * Gets the errorCode property value. Error code for the setting
     * @returns a int64
     */
    get errorCode() {
        return this._errorCode;
    }
    ;
    /**
     * Sets the errorCode property value. Error code for the setting
     * @param value Value to set for the errorCode property.
     */
    set errorCode(value) {
        this._errorCode = value;
    }
    ;
    /**
     * Gets the errorDescription property value. Error description
     * @returns a string
     */
    get errorDescription() {
        return this._errorDescription;
    }
    ;
    /**
     * Sets the errorDescription property value. Error description
     * @param value Value to set for the errorDescription property.
     */
    set errorDescription(value) {
        this._errorDescription = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "currentValue": (o, n) => { o.currentValue = n.getStringValue(); },
            "errorCode": (o, n) => { o.errorCode = n.getNumberValue(); },
            "errorDescription": (o, n) => { o.errorDescription = n.getStringValue(); },
            "instanceDisplayName": (o, n) => { o.instanceDisplayName = n.getStringValue(); },
            "setting": (o, n) => { o.setting = n.getStringValue(); },
            "settingName": (o, n) => { o.settingName = n.getStringValue(); },
            "sources": (o, n) => { o.sources = n.getCollectionOfObjectValues(createSettingSourceFromDiscriminatorValue_1.createSettingSourceFromDiscriminatorValue); },
            "state": (o, n) => { o.state = n.getEnumValue(complianceStatus_1.ComplianceStatus); },
            "userEmail": (o, n) => { o.userEmail = n.getStringValue(); },
            "userId": (o, n) => { o.userId = n.getStringValue(); },
            "userName": (o, n) => { o.userName = n.getStringValue(); },
            "userPrincipalName": (o, n) => { o.userPrincipalName = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the instanceDisplayName property value. Name of setting instance that is being reported.
     * @returns a string
     */
    get instanceDisplayName() {
        return this._instanceDisplayName;
    }
    ;
    /**
     * Sets the instanceDisplayName property value. Name of setting instance that is being reported.
     * @param value Value to set for the instanceDisplayName property.
     */
    set instanceDisplayName(value) {
        this._instanceDisplayName = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("currentValue", this.currentValue);
        writer.writeNumberValue("errorCode", this.errorCode);
        writer.writeStringValue("errorDescription", this.errorDescription);
        writer.writeStringValue("instanceDisplayName", this.instanceDisplayName);
        writer.writeStringValue("setting", this.setting);
        writer.writeStringValue("settingName", this.settingName);
        writer.writeCollectionOfObjectValues("sources", this.sources);
        writer.writeEnumValue("state", this.state);
        writer.writeStringValue("userEmail", this.userEmail);
        writer.writeStringValue("userId", this.userId);
        writer.writeStringValue("userName", this.userName);
        writer.writeStringValue("userPrincipalName", this.userPrincipalName);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the setting property value. The setting that is being reported
     * @returns a string
     */
    get setting() {
        return this._setting;
    }
    ;
    /**
     * Sets the setting property value. The setting that is being reported
     * @param value Value to set for the setting property.
     */
    set setting(value) {
        this._setting = value;
    }
    ;
    /**
     * Gets the settingName property value. Localized/user friendly setting name that is being reported
     * @returns a string
     */
    get settingName() {
        return this._settingName;
    }
    ;
    /**
     * Sets the settingName property value. Localized/user friendly setting name that is being reported
     * @param value Value to set for the settingName property.
     */
    set settingName(value) {
        this._settingName = value;
    }
    ;
    /**
     * Gets the sources property value. Contributing policies
     * @returns a settingSource
     */
    get sources() {
        return this._sources;
    }
    ;
    /**
     * Sets the sources property value. Contributing policies
     * @param value Value to set for the sources property.
     */
    set sources(value) {
        this._sources = value;
    }
    ;
    /**
     * Gets the state property value. The compliance state of the setting. Possible values are: unknown, notApplicable, compliant, remediated, nonCompliant, error, conflict, notAssigned.
     * @returns a complianceStatus
     */
    get state() {
        return this._state;
    }
    ;
    /**
     * Sets the state property value. The compliance state of the setting. Possible values are: unknown, notApplicable, compliant, remediated, nonCompliant, error, conflict, notAssigned.
     * @param value Value to set for the state property.
     */
    set state(value) {
        this._state = value;
    }
    ;
    /**
     * Gets the userEmail property value. UserEmail
     * @returns a string
     */
    get userEmail() {
        return this._userEmail;
    }
    ;
    /**
     * Sets the userEmail property value. UserEmail
     * @param value Value to set for the userEmail property.
     */
    set userEmail(value) {
        this._userEmail = value;
    }
    ;
    /**
     * Gets the userId property value. UserId
     * @returns a string
     */
    get userId() {
        return this._userId;
    }
    ;
    /**
     * Sets the userId property value. UserId
     * @param value Value to set for the userId property.
     */
    set userId(value) {
        this._userId = value;
    }
    ;
    /**
     * Gets the userName property value. UserName
     * @returns a string
     */
    get userName() {
        return this._userName;
    }
    ;
    /**
     * Sets the userName property value. UserName
     * @param value Value to set for the userName property.
     */
    set userName(value) {
        this._userName = value;
    }
    ;
    /**
     * Gets the userPrincipalName property value. UserPrincipalName.
     * @returns a string
     */
    get userPrincipalName() {
        return this._userPrincipalName;
    }
    ;
    /**
     * Sets the userPrincipalName property value. UserPrincipalName.
     * @param value Value to set for the userPrincipalName property.
     */
    set userPrincipalName(value) {
        this._userPrincipalName = value;
    }
    ;
}
exports.DeviceCompliancePolicySettingState = DeviceCompliancePolicySettingState;
