"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeviceCompliancePolicySettingStateSummary = void 0;
const createDeviceComplianceSettingStateFromDiscriminatorValue_1 = require("./createDeviceComplianceSettingStateFromDiscriminatorValue");
const index_1 = require("./index");
const policyPlatformType_1 = require("./policyPlatformType");
class DeviceCompliancePolicySettingStateSummary extends index_1.Entity {
    /**
     * Instantiates a new deviceCompliancePolicySettingStateSummary and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the compliantDeviceCount property value. Number of compliant devices
     * @returns a integer
     */
    get compliantDeviceCount() {
        return this._compliantDeviceCount;
    }
    ;
    /**
     * Sets the compliantDeviceCount property value. Number of compliant devices
     * @param value Value to set for the compliantDeviceCount property.
     */
    set compliantDeviceCount(value) {
        this._compliantDeviceCount = value;
    }
    ;
    /**
     * Gets the conflictDeviceCount property value. Number of conflict devices
     * @returns a integer
     */
    get conflictDeviceCount() {
        return this._conflictDeviceCount;
    }
    ;
    /**
     * Sets the conflictDeviceCount property value. Number of conflict devices
     * @param value Value to set for the conflictDeviceCount property.
     */
    set conflictDeviceCount(value) {
        this._conflictDeviceCount = value;
    }
    ;
    ;
    /**
     * Gets the deviceComplianceSettingStates property value. Not yet documented
     * @returns a deviceComplianceSettingState
     */
    get deviceComplianceSettingStates() {
        return this._deviceComplianceSettingStates;
    }
    ;
    /**
     * Sets the deviceComplianceSettingStates property value. Not yet documented
     * @param value Value to set for the deviceComplianceSettingStates property.
     */
    set deviceComplianceSettingStates(value) {
        this._deviceComplianceSettingStates = value;
    }
    ;
    /**
     * Gets the errorDeviceCount property value. Number of error devices
     * @returns a integer
     */
    get errorDeviceCount() {
        return this._errorDeviceCount;
    }
    ;
    /**
     * Sets the errorDeviceCount property value. Number of error devices
     * @param value Value to set for the errorDeviceCount property.
     */
    set errorDeviceCount(value) {
        this._errorDeviceCount = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "compliantDeviceCount": (o, n) => { o.compliantDeviceCount = n.getNumberValue(); }, "conflictDeviceCount": (o, n) => { o.conflictDeviceCount = n.getNumberValue(); }, "deviceComplianceSettingStates": (o, n) => { o.deviceComplianceSettingStates = n.getCollectionOfObjectValues(createDeviceComplianceSettingStateFromDiscriminatorValue_1.createDeviceComplianceSettingStateFromDiscriminatorValue); }, "errorDeviceCount": (o, n) => { o.errorDeviceCount = n.getNumberValue(); }, "nonCompliantDeviceCount": (o, n) => { o.nonCompliantDeviceCount = n.getNumberValue(); }, "notApplicableDeviceCount": (o, n) => { o.notApplicableDeviceCount = n.getNumberValue(); }, "platformType": (o, n) => { o.platformType = n.getEnumValue(policyPlatformType_1.PolicyPlatformType); }, "remediatedDeviceCount": (o, n) => { o.remediatedDeviceCount = n.getNumberValue(); }, "setting": (o, n) => { o.setting = n.getStringValue(); }, "settingName": (o, n) => { o.settingName = n.getStringValue(); }, "unknownDeviceCount": (o, n) => { o.unknownDeviceCount = n.getNumberValue(); } });
    }
    ;
    /**
     * Gets the nonCompliantDeviceCount property value. Number of NonCompliant devices
     * @returns a integer
     */
    get nonCompliantDeviceCount() {
        return this._nonCompliantDeviceCount;
    }
    ;
    /**
     * Sets the nonCompliantDeviceCount property value. Number of NonCompliant devices
     * @param value Value to set for the nonCompliantDeviceCount property.
     */
    set nonCompliantDeviceCount(value) {
        this._nonCompliantDeviceCount = value;
    }
    ;
    /**
     * Gets the notApplicableDeviceCount property value. Number of not applicable devices
     * @returns a integer
     */
    get notApplicableDeviceCount() {
        return this._notApplicableDeviceCount;
    }
    ;
    /**
     * Sets the notApplicableDeviceCount property value. Number of not applicable devices
     * @param value Value to set for the notApplicableDeviceCount property.
     */
    set notApplicableDeviceCount(value) {
        this._notApplicableDeviceCount = value;
    }
    ;
    /**
     * Gets the platformType property value. Setting platform. Possible values are: android, iOS, macOS, windowsPhone81, windows81AndLater, windows10AndLater, androidWorkProfile, all.
     * @returns a policyPlatformType
     */
    get platformType() {
        return this._platformType;
    }
    ;
    /**
     * Sets the platformType property value. Setting platform. Possible values are: android, iOS, macOS, windowsPhone81, windows81AndLater, windows10AndLater, androidWorkProfile, all.
     * @param value Value to set for the platformType property.
     */
    set platformType(value) {
        this._platformType = value;
    }
    ;
    /**
     * Gets the remediatedDeviceCount property value. Number of remediated devices
     * @returns a integer
     */
    get remediatedDeviceCount() {
        return this._remediatedDeviceCount;
    }
    ;
    /**
     * Sets the remediatedDeviceCount property value. Number of remediated devices
     * @param value Value to set for the remediatedDeviceCount property.
     */
    set remediatedDeviceCount(value) {
        this._remediatedDeviceCount = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeNumberValue("compliantDeviceCount", this.compliantDeviceCount);
        writer.writeNumberValue("conflictDeviceCount", this.conflictDeviceCount);
        writer.writeCollectionOfObjectValues("deviceComplianceSettingStates", this.deviceComplianceSettingStates);
        writer.writeNumberValue("errorDeviceCount", this.errorDeviceCount);
        writer.writeNumberValue("nonCompliantDeviceCount", this.nonCompliantDeviceCount);
        writer.writeNumberValue("notApplicableDeviceCount", this.notApplicableDeviceCount);
        writer.writeEnumValue("platformType", this.platformType);
        writer.writeNumberValue("remediatedDeviceCount", this.remediatedDeviceCount);
        writer.writeStringValue("setting", this.setting);
        writer.writeStringValue("settingName", this.settingName);
        writer.writeNumberValue("unknownDeviceCount", this.unknownDeviceCount);
    }
    ;
    /**
     * Gets the setting property value. The setting class name and property name.
     * @returns a string
     */
    get setting() {
        return this._setting;
    }
    ;
    /**
     * Sets the setting property value. The setting class name and property name.
     * @param value Value to set for the setting property.
     */
    set setting(value) {
        this._setting = value;
    }
    ;
    /**
     * Gets the settingName property value. Name of the setting.
     * @returns a string
     */
    get settingName() {
        return this._settingName;
    }
    ;
    /**
     * Sets the settingName property value. Name of the setting.
     * @param value Value to set for the settingName property.
     */
    set settingName(value) {
        this._settingName = value;
    }
    ;
    /**
     * Gets the unknownDeviceCount property value. Number of unknown devices
     * @returns a integer
     */
    get unknownDeviceCount() {
        return this._unknownDeviceCount;
    }
    ;
    /**
     * Sets the unknownDeviceCount property value. Number of unknown devices
     * @param value Value to set for the unknownDeviceCount property.
     */
    set unknownDeviceCount(value) {
        this._unknownDeviceCount = value;
    }
    ;
}
exports.DeviceCompliancePolicySettingStateSummary = DeviceCompliancePolicySettingStateSummary;
