import { ComplianceStatus } from './complianceStatus';
import { Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class DeviceComplianceSettingState extends Entity implements Parsable {
    /** The DateTime when device compliance grace period expires  */
    private _complianceGracePeriodExpirationDateTime?;
    /** The Device Id that is being reported  */
    private _deviceId?;
    /** The device model that is being reported  */
    private _deviceModel?;
    /** The Device Name that is being reported  */
    private _deviceName?;
    /** The setting class name and property name.  */
    private _setting?;
    /** The Setting Name that is being reported  */
    private _settingName?;
    /** The compliance state of the setting. Possible values are: unknown, notApplicable, compliant, remediated, nonCompliant, error, conflict, notAssigned.  */
    private _state?;
    /** The User email address that is being reported  */
    private _userEmail?;
    /** The user Id that is being reported  */
    private _userId?;
    /** The User Name that is being reported  */
    private _userName?;
    /** The User PrincipalName that is being reported  */
    private _userPrincipalName?;
    /**
     * Gets the complianceGracePeriodExpirationDateTime property value. The DateTime when device compliance grace period expires
     * @returns a Date
     */
    get complianceGracePeriodExpirationDateTime(): Date | undefined;
    /**
     * Sets the complianceGracePeriodExpirationDateTime property value. The DateTime when device compliance grace period expires
     * @param value Value to set for the complianceGracePeriodExpirationDateTime property.
     */
    set complianceGracePeriodExpirationDateTime(value: Date | undefined);
    /**
     * Instantiates a new deviceComplianceSettingState and sets the default values.
     */
    constructor();
    /**
     * Gets the deviceId property value. The Device Id that is being reported
     * @returns a string
     */
    get deviceId(): string | undefined;
    /**
     * Sets the deviceId property value. The Device Id that is being reported
     * @param value Value to set for the deviceId property.
     */
    set deviceId(value: string | undefined);
    /**
     * Gets the deviceModel property value. The device model that is being reported
     * @returns a string
     */
    get deviceModel(): string | undefined;
    /**
     * Sets the deviceModel property value. The device model that is being reported
     * @param value Value to set for the deviceModel property.
     */
    set deviceModel(value: string | undefined);
    /**
     * Gets the deviceName property value. The Device Name that is being reported
     * @returns a string
     */
    get deviceName(): string | undefined;
    /**
     * Sets the deviceName property value. The Device Name that is being reported
     * @param value Value to set for the deviceName property.
     */
    set deviceName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the setting property value. The setting class name and property name.
     * @returns a string
     */
    get setting(): string | undefined;
    /**
     * Sets the setting property value. The setting class name and property name.
     * @param value Value to set for the setting property.
     */
    set setting(value: string | undefined);
    /**
     * Gets the settingName property value. The Setting Name that is being reported
     * @returns a string
     */
    get settingName(): string | undefined;
    /**
     * Sets the settingName property value. The Setting Name that is being reported
     * @param value Value to set for the settingName property.
     */
    set settingName(value: string | undefined);
    /**
     * Gets the state property value. The compliance state of the setting. Possible values are: unknown, notApplicable, compliant, remediated, nonCompliant, error, conflict, notAssigned.
     * @returns a complianceStatus
     */
    get state(): ComplianceStatus | undefined;
    /**
     * Sets the state property value. The compliance state of the setting. Possible values are: unknown, notApplicable, compliant, remediated, nonCompliant, error, conflict, notAssigned.
     * @param value Value to set for the state property.
     */
    set state(value: ComplianceStatus | undefined);
    /**
     * Gets the userEmail property value. The User email address that is being reported
     * @returns a string
     */
    get userEmail(): string | undefined;
    /**
     * Sets the userEmail property value. The User email address that is being reported
     * @param value Value to set for the userEmail property.
     */
    set userEmail(value: string | undefined);
    /**
     * Gets the userId property value. The user Id that is being reported
     * @returns a string
     */
    get userId(): string | undefined;
    /**
     * Sets the userId property value. The user Id that is being reported
     * @param value Value to set for the userId property.
     */
    set userId(value: string | undefined);
    /**
     * Gets the userName property value. The User Name that is being reported
     * @returns a string
     */
    get userName(): string | undefined;
    /**
     * Sets the userName property value. The User Name that is being reported
     * @param value Value to set for the userName property.
     */
    set userName(value: string | undefined);
    /**
     * Gets the userPrincipalName property value. The User PrincipalName that is being reported
     * @returns a string
     */
    get userPrincipalName(): string | undefined;
    /**
     * Sets the userPrincipalName property value. The User PrincipalName that is being reported
     * @param value Value to set for the userPrincipalName property.
     */
    set userPrincipalName(value: string | undefined);
}
