"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeviceConfiguration = void 0;
const createDeviceConfigurationAssignmentFromDiscriminatorValue_1 = require("./createDeviceConfigurationAssignmentFromDiscriminatorValue");
const createDeviceConfigurationDeviceOverviewFromDiscriminatorValue_1 = require("./createDeviceConfigurationDeviceOverviewFromDiscriminatorValue");
const createDeviceConfigurationDeviceStatusFromDiscriminatorValue_1 = require("./createDeviceConfigurationDeviceStatusFromDiscriminatorValue");
const createDeviceConfigurationUserOverviewFromDiscriminatorValue_1 = require("./createDeviceConfigurationUserOverviewFromDiscriminatorValue");
const createDeviceConfigurationUserStatusFromDiscriminatorValue_1 = require("./createDeviceConfigurationUserStatusFromDiscriminatorValue");
const createSettingStateDeviceSummaryFromDiscriminatorValue_1 = require("./createSettingStateDeviceSummaryFromDiscriminatorValue");
const index_1 = require("./index");
class DeviceConfiguration extends index_1.Entity {
    /**
     * Instantiates a new deviceConfiguration and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the assignments property value. The list of assignments for the device configuration profile.
     * @returns a deviceConfigurationAssignment
     */
    get assignments() {
        return this._assignments;
    }
    ;
    /**
     * Sets the assignments property value. The list of assignments for the device configuration profile.
     * @param value Value to set for the assignments property.
     */
    set assignments(value) {
        this._assignments = value;
    }
    ;
    ;
    /**
     * Gets the createdDateTime property value. DateTime the object was created.
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. DateTime the object was created.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * Gets the description property value. Admin provided description of the Device Configuration.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. Admin provided description of the Device Configuration.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the deviceSettingStateSummaries property value. Device Configuration Setting State Device Summary
     * @returns a settingStateDeviceSummary
     */
    get deviceSettingStateSummaries() {
        return this._deviceSettingStateSummaries;
    }
    ;
    /**
     * Sets the deviceSettingStateSummaries property value. Device Configuration Setting State Device Summary
     * @param value Value to set for the deviceSettingStateSummaries property.
     */
    set deviceSettingStateSummaries(value) {
        this._deviceSettingStateSummaries = value;
    }
    ;
    /**
     * Gets the deviceStatuses property value. Device configuration installation status by device.
     * @returns a deviceConfigurationDeviceStatus
     */
    get deviceStatuses() {
        return this._deviceStatuses;
    }
    ;
    /**
     * Sets the deviceStatuses property value. Device configuration installation status by device.
     * @param value Value to set for the deviceStatuses property.
     */
    set deviceStatuses(value) {
        this._deviceStatuses = value;
    }
    ;
    /**
     * Gets the deviceStatusOverview property value. Device Configuration devices status overview
     * @returns a deviceConfigurationDeviceOverview
     */
    get deviceStatusOverview() {
        return this._deviceStatusOverview;
    }
    ;
    /**
     * Sets the deviceStatusOverview property value. Device Configuration devices status overview
     * @param value Value to set for the deviceStatusOverview property.
     */
    set deviceStatusOverview(value) {
        this._deviceStatusOverview = value;
    }
    ;
    /**
     * Gets the displayName property value. Admin provided name of the device configuration.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. Admin provided name of the device configuration.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "assignments": (o, n) => { o.assignments = n.getCollectionOfObjectValues(createDeviceConfigurationAssignmentFromDiscriminatorValue_1.createDeviceConfigurationAssignmentFromDiscriminatorValue); }, "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); }, "description": (o, n) => { o.description = n.getStringValue(); }, "deviceSettingStateSummaries": (o, n) => { o.deviceSettingStateSummaries = n.getCollectionOfObjectValues(createSettingStateDeviceSummaryFromDiscriminatorValue_1.createSettingStateDeviceSummaryFromDiscriminatorValue); }, "deviceStatuses": (o, n) => { o.deviceStatuses = n.getCollectionOfObjectValues(createDeviceConfigurationDeviceStatusFromDiscriminatorValue_1.createDeviceConfigurationDeviceStatusFromDiscriminatorValue); }, "deviceStatusOverview": (o, n) => { o.deviceStatusOverview = n.getObjectValue(createDeviceConfigurationDeviceOverviewFromDiscriminatorValue_1.createDeviceConfigurationDeviceOverviewFromDiscriminatorValue); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "lastModifiedDateTime": (o, n) => { o.lastModifiedDateTime = n.getDateValue(); }, "userStatuses": (o, n) => { o.userStatuses = n.getCollectionOfObjectValues(createDeviceConfigurationUserStatusFromDiscriminatorValue_1.createDeviceConfigurationUserStatusFromDiscriminatorValue); }, "userStatusOverview": (o, n) => { o.userStatusOverview = n.getObjectValue(createDeviceConfigurationUserOverviewFromDiscriminatorValue_1.createDeviceConfigurationUserOverviewFromDiscriminatorValue); }, "version": (o, n) => { o.version = n.getNumberValue(); } });
    }
    ;
    /**
     * Gets the lastModifiedDateTime property value. DateTime the object was last modified.
     * @returns a Date
     */
    get lastModifiedDateTime() {
        return this._lastModifiedDateTime;
    }
    ;
    /**
     * Sets the lastModifiedDateTime property value. DateTime the object was last modified.
     * @param value Value to set for the lastModifiedDateTime property.
     */
    set lastModifiedDateTime(value) {
        this._lastModifiedDateTime = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("assignments", this.assignments);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeStringValue("description", this.description);
        writer.writeCollectionOfObjectValues("deviceSettingStateSummaries", this.deviceSettingStateSummaries);
        writer.writeCollectionOfObjectValues("deviceStatuses", this.deviceStatuses);
        writer.writeObjectValue("deviceStatusOverview", this.deviceStatusOverview);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeDateValue("lastModifiedDateTime", this.lastModifiedDateTime);
        writer.writeCollectionOfObjectValues("userStatuses", this.userStatuses);
        writer.writeObjectValue("userStatusOverview", this.userStatusOverview);
        writer.writeNumberValue("version", this.version);
    }
    ;
    /**
     * Gets the userStatuses property value. Device configuration installation status by user.
     * @returns a deviceConfigurationUserStatus
     */
    get userStatuses() {
        return this._userStatuses;
    }
    ;
    /**
     * Sets the userStatuses property value. Device configuration installation status by user.
     * @param value Value to set for the userStatuses property.
     */
    set userStatuses(value) {
        this._userStatuses = value;
    }
    ;
    /**
     * Gets the userStatusOverview property value. Device Configuration users status overview
     * @returns a deviceConfigurationUserOverview
     */
    get userStatusOverview() {
        return this._userStatusOverview;
    }
    ;
    /**
     * Sets the userStatusOverview property value. Device Configuration users status overview
     * @param value Value to set for the userStatusOverview property.
     */
    set userStatusOverview(value) {
        this._userStatusOverview = value;
    }
    ;
    /**
     * Gets the version property value. Version of the device configuration.
     * @returns a integer
     */
    get version() {
        return this._version;
    }
    ;
    /**
     * Sets the version property value. Version of the device configuration.
     * @param value Value to set for the version property.
     */
    set version(value) {
        this._version = value;
    }
    ;
}
exports.DeviceConfiguration = DeviceConfiguration;
