"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeviceDetail = void 0;
class DeviceDetail {
    /**
     * Instantiates a new deviceDetail and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the browser property value. Indicates the browser information of the used for signing in.
     * @returns a string
     */
    get browser() {
        return this._browser;
    }
    ;
    /**
     * Sets the browser property value. Indicates the browser information of the used for signing in.
     * @param value Value to set for the browser property.
     */
    set browser(value) {
        this._browser = value;
    }
    ;
    ;
    /**
     * Gets the deviceId property value. Refers to the UniqueID of the device used for signing in.
     * @returns a string
     */
    get deviceId() {
        return this._deviceId;
    }
    ;
    /**
     * Sets the deviceId property value. Refers to the UniqueID of the device used for signing in.
     * @param value Value to set for the deviceId property.
     */
    set deviceId(value) {
        this._deviceId = value;
    }
    ;
    /**
     * Gets the displayName property value. Refers to the name of the device used for signing in.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. Refers to the name of the device used for signing in.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "browser": (o, n) => { o.browser = n.getStringValue(); },
            "deviceId": (o, n) => { o.deviceId = n.getStringValue(); },
            "displayName": (o, n) => { o.displayName = n.getStringValue(); },
            "isCompliant": (o, n) => { o.isCompliant = n.getBooleanValue(); },
            "isManaged": (o, n) => { o.isManaged = n.getBooleanValue(); },
            "operatingSystem": (o, n) => { o.operatingSystem = n.getStringValue(); },
            "trustType": (o, n) => { o.trustType = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the isCompliant property value. Indicates whether the device is compliant.
     * @returns a boolean
     */
    get isCompliant() {
        return this._isCompliant;
    }
    ;
    /**
     * Sets the isCompliant property value. Indicates whether the device is compliant.
     * @param value Value to set for the isCompliant property.
     */
    set isCompliant(value) {
        this._isCompliant = value;
    }
    ;
    /**
     * Gets the isManaged property value. Indicates whether the device is managed.
     * @returns a boolean
     */
    get isManaged() {
        return this._isManaged;
    }
    ;
    /**
     * Sets the isManaged property value. Indicates whether the device is managed.
     * @param value Value to set for the isManaged property.
     */
    set isManaged(value) {
        this._isManaged = value;
    }
    ;
    /**
     * Gets the operatingSystem property value. Indicates the operating system name and version used for signing in.
     * @returns a string
     */
    get operatingSystem() {
        return this._operatingSystem;
    }
    ;
    /**
     * Sets the operatingSystem property value. Indicates the operating system name and version used for signing in.
     * @param value Value to set for the operatingSystem property.
     */
    set operatingSystem(value) {
        this._operatingSystem = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("browser", this.browser);
        writer.writeStringValue("deviceId", this.deviceId);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeBooleanValue("isCompliant", this.isCompliant);
        writer.writeBooleanValue("isManaged", this.isManaged);
        writer.writeStringValue("operatingSystem", this.operatingSystem);
        writer.writeStringValue("trustType", this.trustType);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the trustType property value. Provides information about whether the signed-in device is Workplace Joined, AzureAD Joined, Domain Joined.
     * @returns a string
     */
    get trustType() {
        return this._trustType;
    }
    ;
    /**
     * Sets the trustType property value. Provides information about whether the signed-in device is Workplace Joined, AzureAD Joined, Domain Joined.
     * @param value Value to set for the trustType property.
     */
    set trustType(value) {
        this._trustType = value;
    }
    ;
}
exports.DeviceDetail = DeviceDetail;
