import { EnrollmentConfigurationAssignment, Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class DeviceEnrollmentConfiguration extends Entity implements Parsable {
    /** The list of group assignments for the device configuration profile  */
    private _assignments?;
    /** Created date time in UTC of the device enrollment configuration  */
    private _createdDateTime?;
    /** The description of the device enrollment configuration  */
    private _description?;
    /** The display name of the device enrollment configuration  */
    private _displayName?;
    /** Last modified date time in UTC of the device enrollment configuration  */
    private _lastModifiedDateTime?;
    /** Priority is used when a user exists in multiple groups that are assigned enrollment configuration. Users are subject only to the configuration with the lowest priority value.  */
    private _priority?;
    /** The version of the device enrollment configuration  */
    private _version?;
    /**
     * Gets the assignments property value. The list of group assignments for the device configuration profile
     * @returns a enrollmentConfigurationAssignment
     */
    get assignments(): EnrollmentConfigurationAssignment[] | undefined;
    /**
     * Sets the assignments property value. The list of group assignments for the device configuration profile
     * @param value Value to set for the assignments property.
     */
    set assignments(value: EnrollmentConfigurationAssignment[] | undefined);
    /**
     * Instantiates a new deviceEnrollmentConfiguration and sets the default values.
     */
    constructor();
    /**
     * Gets the createdDateTime property value. Created date time in UTC of the device enrollment configuration
     * @returns a Date
     */
    get createdDateTime(): Date | undefined;
    /**
     * Sets the createdDateTime property value. Created date time in UTC of the device enrollment configuration
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value: Date | undefined);
    /**
     * Gets the description property value. The description of the device enrollment configuration
     * @returns a string
     */
    get description(): string | undefined;
    /**
     * Sets the description property value. The description of the device enrollment configuration
     * @param value Value to set for the description property.
     */
    set description(value: string | undefined);
    /**
     * Gets the displayName property value. The display name of the device enrollment configuration
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. The display name of the device enrollment configuration
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the lastModifiedDateTime property value. Last modified date time in UTC of the device enrollment configuration
     * @returns a Date
     */
    get lastModifiedDateTime(): Date | undefined;
    /**
     * Sets the lastModifiedDateTime property value. Last modified date time in UTC of the device enrollment configuration
     * @param value Value to set for the lastModifiedDateTime property.
     */
    set lastModifiedDateTime(value: Date | undefined);
    /**
     * Gets the priority property value. Priority is used when a user exists in multiple groups that are assigned enrollment configuration. Users are subject only to the configuration with the lowest priority value.
     * @returns a integer
     */
    get priority(): number | undefined;
    /**
     * Sets the priority property value. Priority is used when a user exists in multiple groups that are assigned enrollment configuration. Users are subject only to the configuration with the lowest priority value.
     * @param value Value to set for the priority property.
     */
    set priority(value: number | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the version property value. The version of the device enrollment configuration
     * @returns a integer
     */
    get version(): number | undefined;
    /**
     * Sets the version property value. The version of the device enrollment configuration
     * @param value Value to set for the version property.
     */
    set version(value: number | undefined);
}
