import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Device Exchange Access State summary  */
export declare class DeviceExchangeAccessStateSummary implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Total count of devices with Exchange Access State: Allowed.  */
    private _allowedDeviceCount?;
    /** Total count of devices with Exchange Access State: Blocked.  */
    private _blockedDeviceCount?;
    /** Total count of devices with Exchange Access State: Quarantined.  */
    private _quarantinedDeviceCount?;
    /** Total count of devices for which no Exchange Access State could be found.  */
    private _unavailableDeviceCount?;
    /** Total count of devices with Exchange Access State: Unknown.  */
    private _unknownDeviceCount?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the allowedDeviceCount property value. Total count of devices with Exchange Access State: Allowed.
     * @returns a integer
     */
    get allowedDeviceCount(): number | undefined;
    /**
     * Sets the allowedDeviceCount property value. Total count of devices with Exchange Access State: Allowed.
     * @param value Value to set for the allowedDeviceCount property.
     */
    set allowedDeviceCount(value: number | undefined);
    /**
     * Gets the blockedDeviceCount property value. Total count of devices with Exchange Access State: Blocked.
     * @returns a integer
     */
    get blockedDeviceCount(): number | undefined;
    /**
     * Sets the blockedDeviceCount property value. Total count of devices with Exchange Access State: Blocked.
     * @param value Value to set for the blockedDeviceCount property.
     */
    set blockedDeviceCount(value: number | undefined);
    /**
     * Instantiates a new deviceExchangeAccessStateSummary and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the quarantinedDeviceCount property value. Total count of devices with Exchange Access State: Quarantined.
     * @returns a integer
     */
    get quarantinedDeviceCount(): number | undefined;
    /**
     * Sets the quarantinedDeviceCount property value. Total count of devices with Exchange Access State: Quarantined.
     * @param value Value to set for the quarantinedDeviceCount property.
     */
    set quarantinedDeviceCount(value: number | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the unavailableDeviceCount property value. Total count of devices for which no Exchange Access State could be found.
     * @returns a integer
     */
    get unavailableDeviceCount(): number | undefined;
    /**
     * Sets the unavailableDeviceCount property value. Total count of devices for which no Exchange Access State could be found.
     * @param value Value to set for the unavailableDeviceCount property.
     */
    set unavailableDeviceCount(value: number | undefined);
    /**
     * Gets the unknownDeviceCount property value. Total count of devices with Exchange Access State: Unknown.
     * @returns a integer
     */
    get unknownDeviceCount(): number | undefined;
    /**
     * Sets the unknownDeviceCount property value. Total count of devices with Exchange Access State: Unknown.
     * @param value Value to set for the unknownDeviceCount property.
     */
    set unknownDeviceCount(value: number | undefined);
}
