"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeviceExchangeAccessStateSummary = void 0;
/** Device Exchange Access State summary  */
class DeviceExchangeAccessStateSummary {
    /**
     * Instantiates a new deviceExchangeAccessStateSummary and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the allowedDeviceCount property value. Total count of devices with Exchange Access State: Allowed.
     * @returns a integer
     */
    get allowedDeviceCount() {
        return this._allowedDeviceCount;
    }
    ;
    /**
     * Sets the allowedDeviceCount property value. Total count of devices with Exchange Access State: Allowed.
     * @param value Value to set for the allowedDeviceCount property.
     */
    set allowedDeviceCount(value) {
        this._allowedDeviceCount = value;
    }
    ;
    /**
     * Gets the blockedDeviceCount property value. Total count of devices with Exchange Access State: Blocked.
     * @returns a integer
     */
    get blockedDeviceCount() {
        return this._blockedDeviceCount;
    }
    ;
    /**
     * Sets the blockedDeviceCount property value. Total count of devices with Exchange Access State: Blocked.
     * @param value Value to set for the blockedDeviceCount property.
     */
    set blockedDeviceCount(value) {
        this._blockedDeviceCount = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "allowedDeviceCount": (o, n) => { o.allowedDeviceCount = n.getNumberValue(); },
            "blockedDeviceCount": (o, n) => { o.blockedDeviceCount = n.getNumberValue(); },
            "quarantinedDeviceCount": (o, n) => { o.quarantinedDeviceCount = n.getNumberValue(); },
            "unavailableDeviceCount": (o, n) => { o.unavailableDeviceCount = n.getNumberValue(); },
            "unknownDeviceCount": (o, n) => { o.unknownDeviceCount = n.getNumberValue(); },
        };
    }
    ;
    /**
     * Gets the quarantinedDeviceCount property value. Total count of devices with Exchange Access State: Quarantined.
     * @returns a integer
     */
    get quarantinedDeviceCount() {
        return this._quarantinedDeviceCount;
    }
    ;
    /**
     * Sets the quarantinedDeviceCount property value. Total count of devices with Exchange Access State: Quarantined.
     * @param value Value to set for the quarantinedDeviceCount property.
     */
    set quarantinedDeviceCount(value) {
        this._quarantinedDeviceCount = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeNumberValue("allowedDeviceCount", this.allowedDeviceCount);
        writer.writeNumberValue("blockedDeviceCount", this.blockedDeviceCount);
        writer.writeNumberValue("quarantinedDeviceCount", this.quarantinedDeviceCount);
        writer.writeNumberValue("unavailableDeviceCount", this.unavailableDeviceCount);
        writer.writeNumberValue("unknownDeviceCount", this.unknownDeviceCount);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the unavailableDeviceCount property value. Total count of devices for which no Exchange Access State could be found.
     * @returns a integer
     */
    get unavailableDeviceCount() {
        return this._unavailableDeviceCount;
    }
    ;
    /**
     * Sets the unavailableDeviceCount property value. Total count of devices for which no Exchange Access State could be found.
     * @param value Value to set for the unavailableDeviceCount property.
     */
    set unavailableDeviceCount(value) {
        this._unavailableDeviceCount = value;
    }
    ;
    /**
     * Gets the unknownDeviceCount property value. Total count of devices with Exchange Access State: Unknown.
     * @returns a integer
     */
    get unknownDeviceCount() {
        return this._unknownDeviceCount;
    }
    ;
    /**
     * Sets the unknownDeviceCount property value. Total count of devices with Exchange Access State: Unknown.
     * @param value Value to set for the unknownDeviceCount property.
     */
    set unknownDeviceCount(value) {
        this._unknownDeviceCount = value;
    }
    ;
}
exports.DeviceExchangeAccessStateSummary = DeviceExchangeAccessStateSummary;
