import { Entity } from './index';
import { InstallState } from './installState';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class DeviceInstallState extends Entity implements Parsable {
    /** Device Id.  */
    private _deviceId?;
    /** Device name.  */
    private _deviceName?;
    /** The error code for install failures.  */
    private _errorCode?;
    /** The install state of the eBook. Possible values are: notApplicable, installed, failed, notInstalled, uninstallFailed, unknown.  */
    private _installState?;
    /** Last sync date and time.  */
    private _lastSyncDateTime?;
    /** OS Description.  */
    private _osDescription?;
    /** OS Version.  */
    private _osVersion?;
    /** Device User Name.  */
    private _userName?;
    /**
     * Instantiates a new deviceInstallState and sets the default values.
     */
    constructor();
    /**
     * Gets the deviceId property value. Device Id.
     * @returns a string
     */
    get deviceId(): string | undefined;
    /**
     * Sets the deviceId property value. Device Id.
     * @param value Value to set for the deviceId property.
     */
    set deviceId(value: string | undefined);
    /**
     * Gets the deviceName property value. Device name.
     * @returns a string
     */
    get deviceName(): string | undefined;
    /**
     * Sets the deviceName property value. Device name.
     * @param value Value to set for the deviceName property.
     */
    set deviceName(value: string | undefined);
    /**
     * Gets the errorCode property value. The error code for install failures.
     * @returns a string
     */
    get errorCode(): string | undefined;
    /**
     * Sets the errorCode property value. The error code for install failures.
     * @param value Value to set for the errorCode property.
     */
    set errorCode(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the installState property value. The install state of the eBook. Possible values are: notApplicable, installed, failed, notInstalled, uninstallFailed, unknown.
     * @returns a installState
     */
    get installState(): InstallState | undefined;
    /**
     * Sets the installState property value. The install state of the eBook. Possible values are: notApplicable, installed, failed, notInstalled, uninstallFailed, unknown.
     * @param value Value to set for the installState property.
     */
    set installState(value: InstallState | undefined);
    /**
     * Gets the lastSyncDateTime property value. Last sync date and time.
     * @returns a Date
     */
    get lastSyncDateTime(): Date | undefined;
    /**
     * Sets the lastSyncDateTime property value. Last sync date and time.
     * @param value Value to set for the lastSyncDateTime property.
     */
    set lastSyncDateTime(value: Date | undefined);
    /**
     * Gets the osDescription property value. OS Description.
     * @returns a string
     */
    get osDescription(): string | undefined;
    /**
     * Sets the osDescription property value. OS Description.
     * @param value Value to set for the osDescription property.
     */
    set osDescription(value: string | undefined);
    /**
     * Gets the osVersion property value. OS Version.
     * @returns a string
     */
    get osVersion(): string | undefined;
    /**
     * Sets the osVersion property value. OS Version.
     * @param value Value to set for the osVersion property.
     */
    set osVersion(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the userName property value. Device User Name.
     * @returns a string
     */
    get userName(): string | undefined;
    /**
     * Sets the userName property value. Device User Name.
     * @param value Value to set for the userName property.
     */
    set userName(value: string | undefined);
}
