"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeviceInstallState = void 0;
const index_1 = require("./index");
const installState_1 = require("./installState");
class DeviceInstallState extends index_1.Entity {
    /**
     * Instantiates a new deviceInstallState and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the deviceId property value. Device Id.
     * @returns a string
     */
    get deviceId() {
        return this._deviceId;
    }
    ;
    /**
     * Sets the deviceId property value. Device Id.
     * @param value Value to set for the deviceId property.
     */
    set deviceId(value) {
        this._deviceId = value;
    }
    ;
    /**
     * Gets the deviceName property value. Device name.
     * @returns a string
     */
    get deviceName() {
        return this._deviceName;
    }
    ;
    /**
     * Sets the deviceName property value. Device name.
     * @param value Value to set for the deviceName property.
     */
    set deviceName(value) {
        this._deviceName = value;
    }
    ;
    /**
     * Gets the errorCode property value. The error code for install failures.
     * @returns a string
     */
    get errorCode() {
        return this._errorCode;
    }
    ;
    /**
     * Sets the errorCode property value. The error code for install failures.
     * @param value Value to set for the errorCode property.
     */
    set errorCode(value) {
        this._errorCode = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "deviceId": (o, n) => { o.deviceId = n.getStringValue(); }, "deviceName": (o, n) => { o.deviceName = n.getStringValue(); }, "errorCode": (o, n) => { o.errorCode = n.getStringValue(); }, "installState": (o, n) => { o.installState = n.getEnumValue(installState_1.InstallState); }, "lastSyncDateTime": (o, n) => { o.lastSyncDateTime = n.getDateValue(); }, "osDescription": (o, n) => { o.osDescription = n.getStringValue(); }, "osVersion": (o, n) => { o.osVersion = n.getStringValue(); }, "userName": (o, n) => { o.userName = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the installState property value. The install state of the eBook. Possible values are: notApplicable, installed, failed, notInstalled, uninstallFailed, unknown.
     * @returns a installState
     */
    get installState() {
        return this._installState;
    }
    ;
    /**
     * Sets the installState property value. The install state of the eBook. Possible values are: notApplicable, installed, failed, notInstalled, uninstallFailed, unknown.
     * @param value Value to set for the installState property.
     */
    set installState(value) {
        this._installState = value;
    }
    ;
    /**
     * Gets the lastSyncDateTime property value. Last sync date and time.
     * @returns a Date
     */
    get lastSyncDateTime() {
        return this._lastSyncDateTime;
    }
    ;
    /**
     * Sets the lastSyncDateTime property value. Last sync date and time.
     * @param value Value to set for the lastSyncDateTime property.
     */
    set lastSyncDateTime(value) {
        this._lastSyncDateTime = value;
    }
    ;
    /**
     * Gets the osDescription property value. OS Description.
     * @returns a string
     */
    get osDescription() {
        return this._osDescription;
    }
    ;
    /**
     * Sets the osDescription property value. OS Description.
     * @param value Value to set for the osDescription property.
     */
    set osDescription(value) {
        this._osDescription = value;
    }
    ;
    /**
     * Gets the osVersion property value. OS Version.
     * @returns a string
     */
    get osVersion() {
        return this._osVersion;
    }
    ;
    /**
     * Sets the osVersion property value. OS Version.
     * @param value Value to set for the osVersion property.
     */
    set osVersion(value) {
        this._osVersion = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("deviceId", this.deviceId);
        writer.writeStringValue("deviceName", this.deviceName);
        writer.writeStringValue("errorCode", this.errorCode);
        writer.writeEnumValue("installState", this.installState);
        writer.writeDateValue("lastSyncDateTime", this.lastSyncDateTime);
        writer.writeStringValue("osDescription", this.osDescription);
        writer.writeStringValue("osVersion", this.osVersion);
        writer.writeStringValue("userName", this.userName);
    }
    ;
    /**
     * Gets the userName property value. Device User Name.
     * @returns a string
     */
    get userName() {
        return this._userName;
    }
    ;
    /**
     * Sets the userName property value. Device User Name.
     * @param value Value to set for the userName property.
     */
    set userName(value) {
        this._userName = value;
    }
    ;
}
exports.DeviceInstallState = DeviceInstallState;
