"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeviceManagement = void 0;
const createApplePushNotificationCertificateFromDiscriminatorValue_1 = require("./createApplePushNotificationCertificateFromDiscriminatorValue");
const createComplianceManagementPartnerFromDiscriminatorValue_1 = require("./createComplianceManagementPartnerFromDiscriminatorValue");
const createDetectedAppFromDiscriminatorValue_1 = require("./createDetectedAppFromDiscriminatorValue");
const createDeviceAndAppManagementRoleAssignmentFromDiscriminatorValue_1 = require("./createDeviceAndAppManagementRoleAssignmentFromDiscriminatorValue");
const createDeviceCategoryFromDiscriminatorValue_1 = require("./createDeviceCategoryFromDiscriminatorValue");
const createDeviceCompliancePolicyDeviceStateSummaryFromDiscriminatorValue_1 = require("./createDeviceCompliancePolicyDeviceStateSummaryFromDiscriminatorValue");
const createDeviceCompliancePolicyFromDiscriminatorValue_1 = require("./createDeviceCompliancePolicyFromDiscriminatorValue");
const createDeviceCompliancePolicySettingStateSummaryFromDiscriminatorValue_1 = require("./createDeviceCompliancePolicySettingStateSummaryFromDiscriminatorValue");
const createDeviceConfigurationDeviceStateSummaryFromDiscriminatorValue_1 = require("./createDeviceConfigurationDeviceStateSummaryFromDiscriminatorValue");
const createDeviceConfigurationFromDiscriminatorValue_1 = require("./createDeviceConfigurationFromDiscriminatorValue");
const createDeviceEnrollmentConfigurationFromDiscriminatorValue_1 = require("./createDeviceEnrollmentConfigurationFromDiscriminatorValue");
const createDeviceManagementExchangeConnectorFromDiscriminatorValue_1 = require("./createDeviceManagementExchangeConnectorFromDiscriminatorValue");
const createDeviceManagementPartnerFromDiscriminatorValue_1 = require("./createDeviceManagementPartnerFromDiscriminatorValue");
const createDeviceManagementReportsFromDiscriminatorValue_1 = require("./createDeviceManagementReportsFromDiscriminatorValue");
const createDeviceManagementSettingsFromDiscriminatorValue_1 = require("./createDeviceManagementSettingsFromDiscriminatorValue");
const createDeviceManagementTroubleshootingEventFromDiscriminatorValue_1 = require("./createDeviceManagementTroubleshootingEventFromDiscriminatorValue");
const createImportedWindowsAutopilotDeviceIdentityFromDiscriminatorValue_1 = require("./createImportedWindowsAutopilotDeviceIdentityFromDiscriminatorValue");
const createIntuneBrandFromDiscriminatorValue_1 = require("./createIntuneBrandFromDiscriminatorValue");
const createIosUpdateDeviceStatusFromDiscriminatorValue_1 = require("./createIosUpdateDeviceStatusFromDiscriminatorValue");
const createManagedDeviceFromDiscriminatorValue_1 = require("./createManagedDeviceFromDiscriminatorValue");
const createManagedDeviceOverviewFromDiscriminatorValue_1 = require("./createManagedDeviceOverviewFromDiscriminatorValue");
const createMobileThreatDefenseConnectorFromDiscriminatorValue_1 = require("./createMobileThreatDefenseConnectorFromDiscriminatorValue");
const createNotificationMessageTemplateFromDiscriminatorValue_1 = require("./createNotificationMessageTemplateFromDiscriminatorValue");
const createOnPremisesConditionalAccessSettingsFromDiscriminatorValue_1 = require("./createOnPremisesConditionalAccessSettingsFromDiscriminatorValue");
const createRemoteAssistancePartnerFromDiscriminatorValue_1 = require("./createRemoteAssistancePartnerFromDiscriminatorValue");
const createResourceOperationFromDiscriminatorValue_1 = require("./createResourceOperationFromDiscriminatorValue");
const createRoleDefinitionFromDiscriminatorValue_1 = require("./createRoleDefinitionFromDiscriminatorValue");
const createSoftwareUpdateStatusSummaryFromDiscriminatorValue_1 = require("./createSoftwareUpdateStatusSummaryFromDiscriminatorValue");
const createTelecomExpenseManagementPartnerFromDiscriminatorValue_1 = require("./createTelecomExpenseManagementPartnerFromDiscriminatorValue");
const createTermsAndConditionsFromDiscriminatorValue_1 = require("./createTermsAndConditionsFromDiscriminatorValue");
const createWindowsAutopilotDeviceIdentityFromDiscriminatorValue_1 = require("./createWindowsAutopilotDeviceIdentityFromDiscriminatorValue");
const createWindowsInformationProtectionAppLearningSummaryFromDiscriminatorValue_1 = require("./createWindowsInformationProtectionAppLearningSummaryFromDiscriminatorValue");
const createWindowsInformationProtectionNetworkLearningSummaryFromDiscriminatorValue_1 = require("./createWindowsInformationProtectionNetworkLearningSummaryFromDiscriminatorValue");
const deviceManagementSubscriptionState_1 = require("./deviceManagementSubscriptionState");
const index_1 = require("./index");
/** Singleton entity that acts as a container for all device management functionality.  */
class DeviceManagement extends index_1.Entity {
    /**
     * Instantiates a new deviceManagement and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the applePushNotificationCertificate property value. Apple push notification certificate.
     * @returns a applePushNotificationCertificate
     */
    get applePushNotificationCertificate() {
        return this._applePushNotificationCertificate;
    }
    ;
    /**
     * Sets the applePushNotificationCertificate property value. Apple push notification certificate.
     * @param value Value to set for the applePushNotificationCertificate property.
     */
    set applePushNotificationCertificate(value) {
        this._applePushNotificationCertificate = value;
    }
    ;
    /**
     * Gets the complianceManagementPartners property value. The list of Compliance Management Partners configured by the tenant.
     * @returns a complianceManagementPartner
     */
    get complianceManagementPartners() {
        return this._complianceManagementPartners;
    }
    ;
    /**
     * Sets the complianceManagementPartners property value. The list of Compliance Management Partners configured by the tenant.
     * @param value Value to set for the complianceManagementPartners property.
     */
    set complianceManagementPartners(value) {
        this._complianceManagementPartners = value;
    }
    ;
    /**
     * Gets the conditionalAccessSettings property value. The Exchange on premises conditional access settings. On premises conditional access will require devices to be both enrolled and compliant for mail access
     * @returns a onPremisesConditionalAccessSettings
     */
    get conditionalAccessSettings() {
        return this._conditionalAccessSettings;
    }
    ;
    /**
     * Sets the conditionalAccessSettings property value. The Exchange on premises conditional access settings. On premises conditional access will require devices to be both enrolled and compliant for mail access
     * @param value Value to set for the conditionalAccessSettings property.
     */
    set conditionalAccessSettings(value) {
        this._conditionalAccessSettings = value;
    }
    ;
    ;
    /**
     * Gets the detectedApps property value. The list of detected apps associated with a device.
     * @returns a detectedApp
     */
    get detectedApps() {
        return this._detectedApps;
    }
    ;
    /**
     * Sets the detectedApps property value. The list of detected apps associated with a device.
     * @param value Value to set for the detectedApps property.
     */
    set detectedApps(value) {
        this._detectedApps = value;
    }
    ;
    /**
     * Gets the deviceCategories property value. The list of device categories with the tenant.
     * @returns a deviceCategory
     */
    get deviceCategories() {
        return this._deviceCategories;
    }
    ;
    /**
     * Sets the deviceCategories property value. The list of device categories with the tenant.
     * @param value Value to set for the deviceCategories property.
     */
    set deviceCategories(value) {
        this._deviceCategories = value;
    }
    ;
    /**
     * Gets the deviceCompliancePolicies property value. The device compliance policies.
     * @returns a deviceCompliancePolicy
     */
    get deviceCompliancePolicies() {
        return this._deviceCompliancePolicies;
    }
    ;
    /**
     * Sets the deviceCompliancePolicies property value. The device compliance policies.
     * @param value Value to set for the deviceCompliancePolicies property.
     */
    set deviceCompliancePolicies(value) {
        this._deviceCompliancePolicies = value;
    }
    ;
    /**
     * Gets the deviceCompliancePolicyDeviceStateSummary property value. The device compliance state summary for this account.
     * @returns a deviceCompliancePolicyDeviceStateSummary
     */
    get deviceCompliancePolicyDeviceStateSummary() {
        return this._deviceCompliancePolicyDeviceStateSummary;
    }
    ;
    /**
     * Sets the deviceCompliancePolicyDeviceStateSummary property value. The device compliance state summary for this account.
     * @param value Value to set for the deviceCompliancePolicyDeviceStateSummary property.
     */
    set deviceCompliancePolicyDeviceStateSummary(value) {
        this._deviceCompliancePolicyDeviceStateSummary = value;
    }
    ;
    /**
     * Gets the deviceCompliancePolicySettingStateSummaries property value. The summary states of compliance policy settings for this account.
     * @returns a deviceCompliancePolicySettingStateSummary
     */
    get deviceCompliancePolicySettingStateSummaries() {
        return this._deviceCompliancePolicySettingStateSummaries;
    }
    ;
    /**
     * Sets the deviceCompliancePolicySettingStateSummaries property value. The summary states of compliance policy settings for this account.
     * @param value Value to set for the deviceCompliancePolicySettingStateSummaries property.
     */
    set deviceCompliancePolicySettingStateSummaries(value) {
        this._deviceCompliancePolicySettingStateSummaries = value;
    }
    ;
    /**
     * Gets the deviceConfigurationDeviceStateSummaries property value. The device configuration device state summary for this account.
     * @returns a deviceConfigurationDeviceStateSummary
     */
    get deviceConfigurationDeviceStateSummaries() {
        return this._deviceConfigurationDeviceStateSummaries;
    }
    ;
    /**
     * Sets the deviceConfigurationDeviceStateSummaries property value. The device configuration device state summary for this account.
     * @param value Value to set for the deviceConfigurationDeviceStateSummaries property.
     */
    set deviceConfigurationDeviceStateSummaries(value) {
        this._deviceConfigurationDeviceStateSummaries = value;
    }
    ;
    /**
     * Gets the deviceConfigurations property value. The device configurations.
     * @returns a deviceConfiguration
     */
    get deviceConfigurations() {
        return this._deviceConfigurations;
    }
    ;
    /**
     * Sets the deviceConfigurations property value. The device configurations.
     * @param value Value to set for the deviceConfigurations property.
     */
    set deviceConfigurations(value) {
        this._deviceConfigurations = value;
    }
    ;
    /**
     * Gets the deviceEnrollmentConfigurations property value. The list of device enrollment configurations
     * @returns a deviceEnrollmentConfiguration
     */
    get deviceEnrollmentConfigurations() {
        return this._deviceEnrollmentConfigurations;
    }
    ;
    /**
     * Sets the deviceEnrollmentConfigurations property value. The list of device enrollment configurations
     * @param value Value to set for the deviceEnrollmentConfigurations property.
     */
    set deviceEnrollmentConfigurations(value) {
        this._deviceEnrollmentConfigurations = value;
    }
    ;
    /**
     * Gets the deviceManagementPartners property value. The list of Device Management Partners configured by the tenant.
     * @returns a deviceManagementPartner
     */
    get deviceManagementPartners() {
        return this._deviceManagementPartners;
    }
    ;
    /**
     * Sets the deviceManagementPartners property value. The list of Device Management Partners configured by the tenant.
     * @param value Value to set for the deviceManagementPartners property.
     */
    set deviceManagementPartners(value) {
        this._deviceManagementPartners = value;
    }
    ;
    /**
     * Gets the exchangeConnectors property value. The list of Exchange Connectors configured by the tenant.
     * @returns a deviceManagementExchangeConnector
     */
    get exchangeConnectors() {
        return this._exchangeConnectors;
    }
    ;
    /**
     * Sets the exchangeConnectors property value. The list of Exchange Connectors configured by the tenant.
     * @param value Value to set for the exchangeConnectors property.
     */
    set exchangeConnectors(value) {
        this._exchangeConnectors = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "applePushNotificationCertificate": (o, n) => { o.applePushNotificationCertificate = n.getObjectValue(createApplePushNotificationCertificateFromDiscriminatorValue_1.createApplePushNotificationCertificateFromDiscriminatorValue); }, "complianceManagementPartners": (o, n) => { o.complianceManagementPartners = n.getCollectionOfObjectValues(createComplianceManagementPartnerFromDiscriminatorValue_1.createComplianceManagementPartnerFromDiscriminatorValue); }, "conditionalAccessSettings": (o, n) => { o.conditionalAccessSettings = n.getObjectValue(createOnPremisesConditionalAccessSettingsFromDiscriminatorValue_1.createOnPremisesConditionalAccessSettingsFromDiscriminatorValue); }, "detectedApps": (o, n) => { o.detectedApps = n.getCollectionOfObjectValues(createDetectedAppFromDiscriminatorValue_1.createDetectedAppFromDiscriminatorValue); }, "deviceCategories": (o, n) => { o.deviceCategories = n.getCollectionOfObjectValues(createDeviceCategoryFromDiscriminatorValue_1.createDeviceCategoryFromDiscriminatorValue); }, "deviceCompliancePolicies": (o, n) => { o.deviceCompliancePolicies = n.getCollectionOfObjectValues(createDeviceCompliancePolicyFromDiscriminatorValue_1.createDeviceCompliancePolicyFromDiscriminatorValue); }, "deviceCompliancePolicyDeviceStateSummary": (o, n) => { o.deviceCompliancePolicyDeviceStateSummary = n.getObjectValue(createDeviceCompliancePolicyDeviceStateSummaryFromDiscriminatorValue_1.createDeviceCompliancePolicyDeviceStateSummaryFromDiscriminatorValue); }, "deviceCompliancePolicySettingStateSummaries": (o, n) => { o.deviceCompliancePolicySettingStateSummaries = n.getCollectionOfObjectValues(createDeviceCompliancePolicySettingStateSummaryFromDiscriminatorValue_1.createDeviceCompliancePolicySettingStateSummaryFromDiscriminatorValue); }, "deviceConfigurationDeviceStateSummaries": (o, n) => { o.deviceConfigurationDeviceStateSummaries = n.getObjectValue(createDeviceConfigurationDeviceStateSummaryFromDiscriminatorValue_1.createDeviceConfigurationDeviceStateSummaryFromDiscriminatorValue); }, "deviceConfigurations": (o, n) => { o.deviceConfigurations = n.getCollectionOfObjectValues(createDeviceConfigurationFromDiscriminatorValue_1.createDeviceConfigurationFromDiscriminatorValue); }, "deviceEnrollmentConfigurations": (o, n) => { o.deviceEnrollmentConfigurations = n.getCollectionOfObjectValues(createDeviceEnrollmentConfigurationFromDiscriminatorValue_1.createDeviceEnrollmentConfigurationFromDiscriminatorValue); }, "deviceManagementPartners": (o, n) => { o.deviceManagementPartners = n.getCollectionOfObjectValues(createDeviceManagementPartnerFromDiscriminatorValue_1.createDeviceManagementPartnerFromDiscriminatorValue); }, "exchangeConnectors": (o, n) => { o.exchangeConnectors = n.getCollectionOfObjectValues(createDeviceManagementExchangeConnectorFromDiscriminatorValue_1.createDeviceManagementExchangeConnectorFromDiscriminatorValue); }, "importedWindowsAutopilotDeviceIdentities": (o, n) => { o.importedWindowsAutopilotDeviceIdentities = n.getCollectionOfObjectValues(createImportedWindowsAutopilotDeviceIdentityFromDiscriminatorValue_1.createImportedWindowsAutopilotDeviceIdentityFromDiscriminatorValue); }, "intuneAccountId": (o, n) => { o.intuneAccountId = n.getStringValue(); }, "intuneBrand": (o, n) => { o.intuneBrand = n.getObjectValue(createIntuneBrandFromDiscriminatorValue_1.createIntuneBrandFromDiscriminatorValue); }, "iosUpdateStatuses": (o, n) => { o.iosUpdateStatuses = n.getCollectionOfObjectValues(createIosUpdateDeviceStatusFromDiscriminatorValue_1.createIosUpdateDeviceStatusFromDiscriminatorValue); }, "managedDeviceOverview": (o, n) => { o.managedDeviceOverview = n.getObjectValue(createManagedDeviceOverviewFromDiscriminatorValue_1.createManagedDeviceOverviewFromDiscriminatorValue); }, "managedDevices": (o, n) => { o.managedDevices = n.getCollectionOfObjectValues(createManagedDeviceFromDiscriminatorValue_1.createManagedDeviceFromDiscriminatorValue); }, "mobileThreatDefenseConnectors": (o, n) => { o.mobileThreatDefenseConnectors = n.getCollectionOfObjectValues(createMobileThreatDefenseConnectorFromDiscriminatorValue_1.createMobileThreatDefenseConnectorFromDiscriminatorValue); }, "notificationMessageTemplates": (o, n) => { o.notificationMessageTemplates = n.getCollectionOfObjectValues(createNotificationMessageTemplateFromDiscriminatorValue_1.createNotificationMessageTemplateFromDiscriminatorValue); }, "remoteAssistancePartners": (o, n) => { o.remoteAssistancePartners = n.getCollectionOfObjectValues(createRemoteAssistancePartnerFromDiscriminatorValue_1.createRemoteAssistancePartnerFromDiscriminatorValue); }, "reports": (o, n) => { o.reports = n.getObjectValue(createDeviceManagementReportsFromDiscriminatorValue_1.createDeviceManagementReportsFromDiscriminatorValue); }, "resourceOperations": (o, n) => { o.resourceOperations = n.getCollectionOfObjectValues(createResourceOperationFromDiscriminatorValue_1.createResourceOperationFromDiscriminatorValue); }, "roleAssignments": (o, n) => { o.roleAssignments = n.getCollectionOfObjectValues(createDeviceAndAppManagementRoleAssignmentFromDiscriminatorValue_1.createDeviceAndAppManagementRoleAssignmentFromDiscriminatorValue); }, "roleDefinitions": (o, n) => { o.roleDefinitions = n.getCollectionOfObjectValues(createRoleDefinitionFromDiscriminatorValue_1.createRoleDefinitionFromDiscriminatorValue); }, "settings": (o, n) => { o.settings = n.getObjectValue(createDeviceManagementSettingsFromDiscriminatorValue_1.createDeviceManagementSettingsFromDiscriminatorValue); }, "softwareUpdateStatusSummary": (o, n) => { o.softwareUpdateStatusSummary = n.getObjectValue(createSoftwareUpdateStatusSummaryFromDiscriminatorValue_1.createSoftwareUpdateStatusSummaryFromDiscriminatorValue); }, "subscriptionState": (o, n) => { o.subscriptionState = n.getEnumValue(deviceManagementSubscriptionState_1.DeviceManagementSubscriptionState); }, "telecomExpenseManagementPartners": (o, n) => { o.telecomExpenseManagementPartners = n.getCollectionOfObjectValues(createTelecomExpenseManagementPartnerFromDiscriminatorValue_1.createTelecomExpenseManagementPartnerFromDiscriminatorValue); }, "termsAndConditions": (o, n) => { o.termsAndConditions = n.getCollectionOfObjectValues(createTermsAndConditionsFromDiscriminatorValue_1.createTermsAndConditionsFromDiscriminatorValue); }, "troubleshootingEvents": (o, n) => { o.troubleshootingEvents = n.getCollectionOfObjectValues(createDeviceManagementTroubleshootingEventFromDiscriminatorValue_1.createDeviceManagementTroubleshootingEventFromDiscriminatorValue); }, "windowsAutopilotDeviceIdentities": (o, n) => { o.windowsAutopilotDeviceIdentities = n.getCollectionOfObjectValues(createWindowsAutopilotDeviceIdentityFromDiscriminatorValue_1.createWindowsAutopilotDeviceIdentityFromDiscriminatorValue); }, "windowsInformationProtectionAppLearningSummaries": (o, n) => { o.windowsInformationProtectionAppLearningSummaries = n.getCollectionOfObjectValues(createWindowsInformationProtectionAppLearningSummaryFromDiscriminatorValue_1.createWindowsInformationProtectionAppLearningSummaryFromDiscriminatorValue); }, "windowsInformationProtectionNetworkLearningSummaries": (o, n) => { o.windowsInformationProtectionNetworkLearningSummaries = n.getCollectionOfObjectValues(createWindowsInformationProtectionNetworkLearningSummaryFromDiscriminatorValue_1.createWindowsInformationProtectionNetworkLearningSummaryFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the importedWindowsAutopilotDeviceIdentities property value. Collection of imported Windows autopilot devices.
     * @returns a importedWindowsAutopilotDeviceIdentity
     */
    get importedWindowsAutopilotDeviceIdentities() {
        return this._importedWindowsAutopilotDeviceIdentities;
    }
    ;
    /**
     * Sets the importedWindowsAutopilotDeviceIdentities property value. Collection of imported Windows autopilot devices.
     * @param value Value to set for the importedWindowsAutopilotDeviceIdentities property.
     */
    set importedWindowsAutopilotDeviceIdentities(value) {
        this._importedWindowsAutopilotDeviceIdentities = value;
    }
    ;
    /**
     * Gets the intuneAccountId property value. Intune Account Id for given tenant
     * @returns a string
     */
    get intuneAccountId() {
        return this._intuneAccountId;
    }
    ;
    /**
     * Sets the intuneAccountId property value. Intune Account Id for given tenant
     * @param value Value to set for the intuneAccountId property.
     */
    set intuneAccountId(value) {
        this._intuneAccountId = value;
    }
    ;
    /**
     * Gets the intuneBrand property value. intuneBrand contains data which is used in customizing the appearance of the Company Portal applications as well as the end user web portal.
     * @returns a intuneBrand
     */
    get intuneBrand() {
        return this._intuneBrand;
    }
    ;
    /**
     * Sets the intuneBrand property value. intuneBrand contains data which is used in customizing the appearance of the Company Portal applications as well as the end user web portal.
     * @param value Value to set for the intuneBrand property.
     */
    set intuneBrand(value) {
        this._intuneBrand = value;
    }
    ;
    /**
     * Gets the iosUpdateStatuses property value. The IOS software update installation statuses for this account.
     * @returns a iosUpdateDeviceStatus
     */
    get iosUpdateStatuses() {
        return this._iosUpdateStatuses;
    }
    ;
    /**
     * Sets the iosUpdateStatuses property value. The IOS software update installation statuses for this account.
     * @param value Value to set for the iosUpdateStatuses property.
     */
    set iosUpdateStatuses(value) {
        this._iosUpdateStatuses = value;
    }
    ;
    /**
     * Gets the managedDeviceOverview property value. Device overview
     * @returns a managedDeviceOverview
     */
    get managedDeviceOverview() {
        return this._managedDeviceOverview;
    }
    ;
    /**
     * Sets the managedDeviceOverview property value. Device overview
     * @param value Value to set for the managedDeviceOverview property.
     */
    set managedDeviceOverview(value) {
        this._managedDeviceOverview = value;
    }
    ;
    /**
     * Gets the managedDevices property value. The list of managed devices.
     * @returns a managedDevice
     */
    get managedDevices() {
        return this._managedDevices;
    }
    ;
    /**
     * Sets the managedDevices property value. The list of managed devices.
     * @param value Value to set for the managedDevices property.
     */
    set managedDevices(value) {
        this._managedDevices = value;
    }
    ;
    /**
     * Gets the mobileThreatDefenseConnectors property value. The list of Mobile threat Defense connectors configured by the tenant.
     * @returns a mobileThreatDefenseConnector
     */
    get mobileThreatDefenseConnectors() {
        return this._mobileThreatDefenseConnectors;
    }
    ;
    /**
     * Sets the mobileThreatDefenseConnectors property value. The list of Mobile threat Defense connectors configured by the tenant.
     * @param value Value to set for the mobileThreatDefenseConnectors property.
     */
    set mobileThreatDefenseConnectors(value) {
        this._mobileThreatDefenseConnectors = value;
    }
    ;
    /**
     * Gets the notificationMessageTemplates property value. The Notification Message Templates.
     * @returns a notificationMessageTemplate
     */
    get notificationMessageTemplates() {
        return this._notificationMessageTemplates;
    }
    ;
    /**
     * Sets the notificationMessageTemplates property value. The Notification Message Templates.
     * @param value Value to set for the notificationMessageTemplates property.
     */
    set notificationMessageTemplates(value) {
        this._notificationMessageTemplates = value;
    }
    ;
    /**
     * Gets the remoteAssistancePartners property value. The remote assist partners.
     * @returns a remoteAssistancePartner
     */
    get remoteAssistancePartners() {
        return this._remoteAssistancePartners;
    }
    ;
    /**
     * Sets the remoteAssistancePartners property value. The remote assist partners.
     * @param value Value to set for the remoteAssistancePartners property.
     */
    set remoteAssistancePartners(value) {
        this._remoteAssistancePartners = value;
    }
    ;
    /**
     * Gets the reports property value. Reports singleton
     * @returns a deviceManagementReports
     */
    get reports() {
        return this._reports;
    }
    ;
    /**
     * Sets the reports property value. Reports singleton
     * @param value Value to set for the reports property.
     */
    set reports(value) {
        this._reports = value;
    }
    ;
    /**
     * Gets the resourceOperations property value. The Resource Operations.
     * @returns a resourceOperation
     */
    get resourceOperations() {
        return this._resourceOperations;
    }
    ;
    /**
     * Sets the resourceOperations property value. The Resource Operations.
     * @param value Value to set for the resourceOperations property.
     */
    set resourceOperations(value) {
        this._resourceOperations = value;
    }
    ;
    /**
     * Gets the roleAssignments property value. The Role Assignments.
     * @returns a deviceAndAppManagementRoleAssignment
     */
    get roleAssignments() {
        return this._roleAssignments;
    }
    ;
    /**
     * Sets the roleAssignments property value. The Role Assignments.
     * @param value Value to set for the roleAssignments property.
     */
    set roleAssignments(value) {
        this._roleAssignments = value;
    }
    ;
    /**
     * Gets the roleDefinitions property value. The Role Definitions.
     * @returns a roleDefinition
     */
    get roleDefinitions() {
        return this._roleDefinitions;
    }
    ;
    /**
     * Sets the roleDefinitions property value. The Role Definitions.
     * @param value Value to set for the roleDefinitions property.
     */
    set roleDefinitions(value) {
        this._roleDefinitions = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("applePushNotificationCertificate", this.applePushNotificationCertificate);
        writer.writeCollectionOfObjectValues("complianceManagementPartners", this.complianceManagementPartners);
        writer.writeObjectValue("conditionalAccessSettings", this.conditionalAccessSettings);
        writer.writeCollectionOfObjectValues("detectedApps", this.detectedApps);
        writer.writeCollectionOfObjectValues("deviceCategories", this.deviceCategories);
        writer.writeCollectionOfObjectValues("deviceCompliancePolicies", this.deviceCompliancePolicies);
        writer.writeObjectValue("deviceCompliancePolicyDeviceStateSummary", this.deviceCompliancePolicyDeviceStateSummary);
        writer.writeCollectionOfObjectValues("deviceCompliancePolicySettingStateSummaries", this.deviceCompliancePolicySettingStateSummaries);
        writer.writeObjectValue("deviceConfigurationDeviceStateSummaries", this.deviceConfigurationDeviceStateSummaries);
        writer.writeCollectionOfObjectValues("deviceConfigurations", this.deviceConfigurations);
        writer.writeCollectionOfObjectValues("deviceEnrollmentConfigurations", this.deviceEnrollmentConfigurations);
        writer.writeCollectionOfObjectValues("deviceManagementPartners", this.deviceManagementPartners);
        writer.writeCollectionOfObjectValues("exchangeConnectors", this.exchangeConnectors);
        writer.writeCollectionOfObjectValues("importedWindowsAutopilotDeviceIdentities", this.importedWindowsAutopilotDeviceIdentities);
        writer.writeStringValue("intuneAccountId", this.intuneAccountId);
        writer.writeObjectValue("intuneBrand", this.intuneBrand);
        writer.writeCollectionOfObjectValues("iosUpdateStatuses", this.iosUpdateStatuses);
        writer.writeObjectValue("managedDeviceOverview", this.managedDeviceOverview);
        writer.writeCollectionOfObjectValues("managedDevices", this.managedDevices);
        writer.writeCollectionOfObjectValues("mobileThreatDefenseConnectors", this.mobileThreatDefenseConnectors);
        writer.writeCollectionOfObjectValues("notificationMessageTemplates", this.notificationMessageTemplates);
        writer.writeCollectionOfObjectValues("remoteAssistancePartners", this.remoteAssistancePartners);
        writer.writeObjectValue("reports", this.reports);
        writer.writeCollectionOfObjectValues("resourceOperations", this.resourceOperations);
        writer.writeCollectionOfObjectValues("roleAssignments", this.roleAssignments);
        writer.writeCollectionOfObjectValues("roleDefinitions", this.roleDefinitions);
        writer.writeObjectValue("settings", this.settings);
        writer.writeObjectValue("softwareUpdateStatusSummary", this.softwareUpdateStatusSummary);
        writer.writeEnumValue("subscriptionState", this.subscriptionState);
        writer.writeCollectionOfObjectValues("telecomExpenseManagementPartners", this.telecomExpenseManagementPartners);
        writer.writeCollectionOfObjectValues("termsAndConditions", this.termsAndConditions);
        writer.writeCollectionOfObjectValues("troubleshootingEvents", this.troubleshootingEvents);
        writer.writeCollectionOfObjectValues("windowsAutopilotDeviceIdentities", this.windowsAutopilotDeviceIdentities);
        writer.writeCollectionOfObjectValues("windowsInformationProtectionAppLearningSummaries", this.windowsInformationProtectionAppLearningSummaries);
        writer.writeCollectionOfObjectValues("windowsInformationProtectionNetworkLearningSummaries", this.windowsInformationProtectionNetworkLearningSummaries);
    }
    ;
    /**
     * Gets the settings property value. Account level settings.
     * @returns a deviceManagementSettings
     */
    get settings() {
        return this._settings;
    }
    ;
    /**
     * Sets the settings property value. Account level settings.
     * @param value Value to set for the settings property.
     */
    set settings(value) {
        this._settings = value;
    }
    ;
    /**
     * Gets the softwareUpdateStatusSummary property value. The software update status summary.
     * @returns a softwareUpdateStatusSummary
     */
    get softwareUpdateStatusSummary() {
        return this._softwareUpdateStatusSummary;
    }
    ;
    /**
     * Sets the softwareUpdateStatusSummary property value. The software update status summary.
     * @param value Value to set for the softwareUpdateStatusSummary property.
     */
    set softwareUpdateStatusSummary(value) {
        this._softwareUpdateStatusSummary = value;
    }
    ;
    /**
     * Gets the subscriptionState property value. Tenant mobile device management subscription state. Possible values are: pending, active, warning, disabled, deleted, blocked, lockedOut.
     * @returns a deviceManagementSubscriptionState
     */
    get subscriptionState() {
        return this._subscriptionState;
    }
    ;
    /**
     * Sets the subscriptionState property value. Tenant mobile device management subscription state. Possible values are: pending, active, warning, disabled, deleted, blocked, lockedOut.
     * @param value Value to set for the subscriptionState property.
     */
    set subscriptionState(value) {
        this._subscriptionState = value;
    }
    ;
    /**
     * Gets the telecomExpenseManagementPartners property value. The telecom expense management partners.
     * @returns a telecomExpenseManagementPartner
     */
    get telecomExpenseManagementPartners() {
        return this._telecomExpenseManagementPartners;
    }
    ;
    /**
     * Sets the telecomExpenseManagementPartners property value. The telecom expense management partners.
     * @param value Value to set for the telecomExpenseManagementPartners property.
     */
    set telecomExpenseManagementPartners(value) {
        this._telecomExpenseManagementPartners = value;
    }
    ;
    /**
     * Gets the termsAndConditions property value. The terms and conditions associated with device management of the company.
     * @returns a termsAndConditions
     */
    get termsAndConditions() {
        return this._termsAndConditions;
    }
    ;
    /**
     * Sets the termsAndConditions property value. The terms and conditions associated with device management of the company.
     * @param value Value to set for the termsAndConditions property.
     */
    set termsAndConditions(value) {
        this._termsAndConditions = value;
    }
    ;
    /**
     * Gets the troubleshootingEvents property value. The list of troubleshooting events for the tenant.
     * @returns a deviceManagementTroubleshootingEvent
     */
    get troubleshootingEvents() {
        return this._troubleshootingEvents;
    }
    ;
    /**
     * Sets the troubleshootingEvents property value. The list of troubleshooting events for the tenant.
     * @param value Value to set for the troubleshootingEvents property.
     */
    set troubleshootingEvents(value) {
        this._troubleshootingEvents = value;
    }
    ;
    /**
     * Gets the windowsAutopilotDeviceIdentities property value. The Windows autopilot device identities contained collection.
     * @returns a windowsAutopilotDeviceIdentity
     */
    get windowsAutopilotDeviceIdentities() {
        return this._windowsAutopilotDeviceIdentities;
    }
    ;
    /**
     * Sets the windowsAutopilotDeviceIdentities property value. The Windows autopilot device identities contained collection.
     * @param value Value to set for the windowsAutopilotDeviceIdentities property.
     */
    set windowsAutopilotDeviceIdentities(value) {
        this._windowsAutopilotDeviceIdentities = value;
    }
    ;
    /**
     * Gets the windowsInformationProtectionAppLearningSummaries property value. The windows information protection app learning summaries.
     * @returns a windowsInformationProtectionAppLearningSummary
     */
    get windowsInformationProtectionAppLearningSummaries() {
        return this._windowsInformationProtectionAppLearningSummaries;
    }
    ;
    /**
     * Sets the windowsInformationProtectionAppLearningSummaries property value. The windows information protection app learning summaries.
     * @param value Value to set for the windowsInformationProtectionAppLearningSummaries property.
     */
    set windowsInformationProtectionAppLearningSummaries(value) {
        this._windowsInformationProtectionAppLearningSummaries = value;
    }
    ;
    /**
     * Gets the windowsInformationProtectionNetworkLearningSummaries property value. The windows information protection network learning summaries.
     * @returns a windowsInformationProtectionNetworkLearningSummary
     */
    get windowsInformationProtectionNetworkLearningSummaries() {
        return this._windowsInformationProtectionNetworkLearningSummaries;
    }
    ;
    /**
     * Sets the windowsInformationProtectionNetworkLearningSummaries property value. The windows information protection network learning summaries.
     * @param value Value to set for the windowsInformationProtectionNetworkLearningSummaries property.
     */
    set windowsInformationProtectionNetworkLearningSummaries(value) {
        this._windowsInformationProtectionNetworkLearningSummaries = value;
    }
    ;
}
exports.DeviceManagement = DeviceManagement;
