"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeviceManagementExchangeConnector = void 0;
const deviceManagementExchangeConnectorStatus_1 = require("./deviceManagementExchangeConnectorStatus");
const deviceManagementExchangeConnectorType_1 = require("./deviceManagementExchangeConnectorType");
const index_1 = require("./index");
class DeviceManagementExchangeConnector extends index_1.Entity {
    /**
     * Instantiates a new deviceManagementExchangeConnector and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the connectorServerName property value. The name of the server hosting the Exchange Connector.
     * @returns a string
     */
    get connectorServerName() {
        return this._connectorServerName;
    }
    ;
    /**
     * Sets the connectorServerName property value. The name of the server hosting the Exchange Connector.
     * @param value Value to set for the connectorServerName property.
     */
    set connectorServerName(value) {
        this._connectorServerName = value;
    }
    ;
    ;
    /**
     * Gets the exchangeAlias property value. An alias assigned to the Exchange server
     * @returns a string
     */
    get exchangeAlias() {
        return this._exchangeAlias;
    }
    ;
    /**
     * Sets the exchangeAlias property value. An alias assigned to the Exchange server
     * @param value Value to set for the exchangeAlias property.
     */
    set exchangeAlias(value) {
        this._exchangeAlias = value;
    }
    ;
    /**
     * Gets the exchangeConnectorType property value. The type of Exchange Connector Configured. Possible values are: onPremises, hosted, serviceToService, dedicated.
     * @returns a deviceManagementExchangeConnectorType
     */
    get exchangeConnectorType() {
        return this._exchangeConnectorType;
    }
    ;
    /**
     * Sets the exchangeConnectorType property value. The type of Exchange Connector Configured. Possible values are: onPremises, hosted, serviceToService, dedicated.
     * @param value Value to set for the exchangeConnectorType property.
     */
    set exchangeConnectorType(value) {
        this._exchangeConnectorType = value;
    }
    ;
    /**
     * Gets the exchangeOrganization property value. Exchange Organization to the Exchange server
     * @returns a string
     */
    get exchangeOrganization() {
        return this._exchangeOrganization;
    }
    ;
    /**
     * Sets the exchangeOrganization property value. Exchange Organization to the Exchange server
     * @param value Value to set for the exchangeOrganization property.
     */
    set exchangeOrganization(value) {
        this._exchangeOrganization = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "connectorServerName": (o, n) => { o.connectorServerName = n.getStringValue(); }, "exchangeAlias": (o, n) => { o.exchangeAlias = n.getStringValue(); }, "exchangeConnectorType": (o, n) => { o.exchangeConnectorType = n.getEnumValue(deviceManagementExchangeConnectorType_1.DeviceManagementExchangeConnectorType); }, "exchangeOrganization": (o, n) => { o.exchangeOrganization = n.getStringValue(); }, "lastSyncDateTime": (o, n) => { o.lastSyncDateTime = n.getDateValue(); }, "primarySmtpAddress": (o, n) => { o.primarySmtpAddress = n.getStringValue(); }, "serverName": (o, n) => { o.serverName = n.getStringValue(); }, "status": (o, n) => { o.status = n.getEnumValue(deviceManagementExchangeConnectorStatus_1.DeviceManagementExchangeConnectorStatus); }, "version": (o, n) => { o.version = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the lastSyncDateTime property value. Last sync time for the Exchange Connector
     * @returns a Date
     */
    get lastSyncDateTime() {
        return this._lastSyncDateTime;
    }
    ;
    /**
     * Sets the lastSyncDateTime property value. Last sync time for the Exchange Connector
     * @param value Value to set for the lastSyncDateTime property.
     */
    set lastSyncDateTime(value) {
        this._lastSyncDateTime = value;
    }
    ;
    /**
     * Gets the primarySmtpAddress property value. Email address used to configure the Service To Service Exchange Connector.
     * @returns a string
     */
    get primarySmtpAddress() {
        return this._primarySmtpAddress;
    }
    ;
    /**
     * Sets the primarySmtpAddress property value. Email address used to configure the Service To Service Exchange Connector.
     * @param value Value to set for the primarySmtpAddress property.
     */
    set primarySmtpAddress(value) {
        this._primarySmtpAddress = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("connectorServerName", this.connectorServerName);
        writer.writeStringValue("exchangeAlias", this.exchangeAlias);
        writer.writeEnumValue("exchangeConnectorType", this.exchangeConnectorType);
        writer.writeStringValue("exchangeOrganization", this.exchangeOrganization);
        writer.writeDateValue("lastSyncDateTime", this.lastSyncDateTime);
        writer.writeStringValue("primarySmtpAddress", this.primarySmtpAddress);
        writer.writeStringValue("serverName", this.serverName);
        writer.writeEnumValue("status", this.status);
        writer.writeStringValue("version", this.version);
    }
    ;
    /**
     * Gets the serverName property value. The name of the Exchange server.
     * @returns a string
     */
    get serverName() {
        return this._serverName;
    }
    ;
    /**
     * Sets the serverName property value. The name of the Exchange server.
     * @param value Value to set for the serverName property.
     */
    set serverName(value) {
        this._serverName = value;
    }
    ;
    /**
     * Gets the status property value. Exchange Connector Status. Possible values are: none, connectionPending, connected, disconnected.
     * @returns a deviceManagementExchangeConnectorStatus
     */
    get status() {
        return this._status;
    }
    ;
    /**
     * Sets the status property value. Exchange Connector Status. Possible values are: none, connectionPending, connected, disconnected.
     * @param value Value to set for the status property.
     */
    set status(value) {
        this._status = value;
    }
    ;
    /**
     * Gets the version property value. The version of the ExchangeConnectorAgent
     * @returns a string
     */
    get version() {
        return this._version;
    }
    ;
    /**
     * Sets the version property value. The version of the ExchangeConnectorAgent
     * @param value Value to set for the version property.
     */
    set version(value) {
        this._version = value;
    }
    ;
}
exports.DeviceManagementExchangeConnector = DeviceManagementExchangeConnector;
