import { DeviceManagementPartnerAppType } from './deviceManagementPartnerAppType';
import { DeviceManagementPartnerTenantState } from './deviceManagementPartnerTenantState';
import { Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class DeviceManagementPartner extends Entity implements Parsable {
    /** Partner display name  */
    private _displayName?;
    /** Whether device management partner is configured or not  */
    private _isConfigured?;
    /** Timestamp of last heartbeat after admin enabled option Connect to Device management Partner  */
    private _lastHeartbeatDateTime?;
    /** Partner App type. Possible values are: unknown, singleTenantApp, multiTenantApp.  */
    private _partnerAppType?;
    /** Partner state of this tenant. Possible values are: unknown, unavailable, enabled, terminated, rejected, unresponsive.  */
    private _partnerState?;
    /** Partner Single tenant App id  */
    private _singleTenantAppId?;
    /** DateTime in UTC when PartnerDevices will be marked as NonCompliant  */
    private _whenPartnerDevicesWillBeMarkedAsNonCompliantDateTime?;
    /** DateTime in UTC when PartnerDevices will be removed  */
    private _whenPartnerDevicesWillBeRemovedDateTime?;
    /**
     * Instantiates a new deviceManagementPartner and sets the default values.
     */
    constructor();
    /**
     * Gets the displayName property value. Partner display name
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. Partner display name
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the isConfigured property value. Whether device management partner is configured or not
     * @returns a boolean
     */
    get isConfigured(): boolean | undefined;
    /**
     * Sets the isConfigured property value. Whether device management partner is configured or not
     * @param value Value to set for the isConfigured property.
     */
    set isConfigured(value: boolean | undefined);
    /**
     * Gets the lastHeartbeatDateTime property value. Timestamp of last heartbeat after admin enabled option Connect to Device management Partner
     * @returns a Date
     */
    get lastHeartbeatDateTime(): Date | undefined;
    /**
     * Sets the lastHeartbeatDateTime property value. Timestamp of last heartbeat after admin enabled option Connect to Device management Partner
     * @param value Value to set for the lastHeartbeatDateTime property.
     */
    set lastHeartbeatDateTime(value: Date | undefined);
    /**
     * Gets the partnerAppType property value. Partner App type. Possible values are: unknown, singleTenantApp, multiTenantApp.
     * @returns a deviceManagementPartnerAppType
     */
    get partnerAppType(): DeviceManagementPartnerAppType | undefined;
    /**
     * Sets the partnerAppType property value. Partner App type. Possible values are: unknown, singleTenantApp, multiTenantApp.
     * @param value Value to set for the partnerAppType property.
     */
    set partnerAppType(value: DeviceManagementPartnerAppType | undefined);
    /**
     * Gets the partnerState property value. Partner state of this tenant. Possible values are: unknown, unavailable, enabled, terminated, rejected, unresponsive.
     * @returns a deviceManagementPartnerTenantState
     */
    get partnerState(): DeviceManagementPartnerTenantState | undefined;
    /**
     * Sets the partnerState property value. Partner state of this tenant. Possible values are: unknown, unavailable, enabled, terminated, rejected, unresponsive.
     * @param value Value to set for the partnerState property.
     */
    set partnerState(value: DeviceManagementPartnerTenantState | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the singleTenantAppId property value. Partner Single tenant App id
     * @returns a string
     */
    get singleTenantAppId(): string | undefined;
    /**
     * Sets the singleTenantAppId property value. Partner Single tenant App id
     * @param value Value to set for the singleTenantAppId property.
     */
    set singleTenantAppId(value: string | undefined);
    /**
     * Gets the whenPartnerDevicesWillBeMarkedAsNonCompliantDateTime property value. DateTime in UTC when PartnerDevices will be marked as NonCompliant
     * @returns a Date
     */
    get whenPartnerDevicesWillBeMarkedAsNonCompliantDateTime(): Date | undefined;
    /**
     * Sets the whenPartnerDevicesWillBeMarkedAsNonCompliantDateTime property value. DateTime in UTC when PartnerDevices will be marked as NonCompliant
     * @param value Value to set for the whenPartnerDevicesWillBeMarkedAsNonCompliantDateTime property.
     */
    set whenPartnerDevicesWillBeMarkedAsNonCompliantDateTime(value: Date | undefined);
    /**
     * Gets the whenPartnerDevicesWillBeRemovedDateTime property value. DateTime in UTC when PartnerDevices will be removed
     * @returns a Date
     */
    get whenPartnerDevicesWillBeRemovedDateTime(): Date | undefined;
    /**
     * Sets the whenPartnerDevicesWillBeRemovedDateTime property value. DateTime in UTC when PartnerDevices will be removed
     * @param value Value to set for the whenPartnerDevicesWillBeRemovedDateTime property.
     */
    set whenPartnerDevicesWillBeRemovedDateTime(value: Date | undefined);
}
