"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeviceManagementPartner = void 0;
const deviceManagementPartnerAppType_1 = require("./deviceManagementPartnerAppType");
const deviceManagementPartnerTenantState_1 = require("./deviceManagementPartnerTenantState");
const index_1 = require("./index");
class DeviceManagementPartner extends index_1.Entity {
    /**
     * Instantiates a new deviceManagementPartner and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the displayName property value. Partner display name
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. Partner display name
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "isConfigured": (o, n) => { o.isConfigured = n.getBooleanValue(); }, "lastHeartbeatDateTime": (o, n) => { o.lastHeartbeatDateTime = n.getDateValue(); }, "partnerAppType": (o, n) => { o.partnerAppType = n.getEnumValue(deviceManagementPartnerAppType_1.DeviceManagementPartnerAppType); }, "partnerState": (o, n) => { o.partnerState = n.getEnumValue(deviceManagementPartnerTenantState_1.DeviceManagementPartnerTenantState); }, "singleTenantAppId": (o, n) => { o.singleTenantAppId = n.getStringValue(); }, "whenPartnerDevicesWillBeMarkedAsNonCompliantDateTime": (o, n) => { o.whenPartnerDevicesWillBeMarkedAsNonCompliantDateTime = n.getDateValue(); }, "whenPartnerDevicesWillBeRemovedDateTime": (o, n) => { o.whenPartnerDevicesWillBeRemovedDateTime = n.getDateValue(); } });
    }
    ;
    /**
     * Gets the isConfigured property value. Whether device management partner is configured or not
     * @returns a boolean
     */
    get isConfigured() {
        return this._isConfigured;
    }
    ;
    /**
     * Sets the isConfigured property value. Whether device management partner is configured or not
     * @param value Value to set for the isConfigured property.
     */
    set isConfigured(value) {
        this._isConfigured = value;
    }
    ;
    /**
     * Gets the lastHeartbeatDateTime property value. Timestamp of last heartbeat after admin enabled option Connect to Device management Partner
     * @returns a Date
     */
    get lastHeartbeatDateTime() {
        return this._lastHeartbeatDateTime;
    }
    ;
    /**
     * Sets the lastHeartbeatDateTime property value. Timestamp of last heartbeat after admin enabled option Connect to Device management Partner
     * @param value Value to set for the lastHeartbeatDateTime property.
     */
    set lastHeartbeatDateTime(value) {
        this._lastHeartbeatDateTime = value;
    }
    ;
    /**
     * Gets the partnerAppType property value. Partner App type. Possible values are: unknown, singleTenantApp, multiTenantApp.
     * @returns a deviceManagementPartnerAppType
     */
    get partnerAppType() {
        return this._partnerAppType;
    }
    ;
    /**
     * Sets the partnerAppType property value. Partner App type. Possible values are: unknown, singleTenantApp, multiTenantApp.
     * @param value Value to set for the partnerAppType property.
     */
    set partnerAppType(value) {
        this._partnerAppType = value;
    }
    ;
    /**
     * Gets the partnerState property value. Partner state of this tenant. Possible values are: unknown, unavailable, enabled, terminated, rejected, unresponsive.
     * @returns a deviceManagementPartnerTenantState
     */
    get partnerState() {
        return this._partnerState;
    }
    ;
    /**
     * Sets the partnerState property value. Partner state of this tenant. Possible values are: unknown, unavailable, enabled, terminated, rejected, unresponsive.
     * @param value Value to set for the partnerState property.
     */
    set partnerState(value) {
        this._partnerState = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeBooleanValue("isConfigured", this.isConfigured);
        writer.writeDateValue("lastHeartbeatDateTime", this.lastHeartbeatDateTime);
        writer.writeEnumValue("partnerAppType", this.partnerAppType);
        writer.writeEnumValue("partnerState", this.partnerState);
        writer.writeStringValue("singleTenantAppId", this.singleTenantAppId);
        writer.writeDateValue("whenPartnerDevicesWillBeMarkedAsNonCompliantDateTime", this.whenPartnerDevicesWillBeMarkedAsNonCompliantDateTime);
        writer.writeDateValue("whenPartnerDevicesWillBeRemovedDateTime", this.whenPartnerDevicesWillBeRemovedDateTime);
    }
    ;
    /**
     * Gets the singleTenantAppId property value. Partner Single tenant App id
     * @returns a string
     */
    get singleTenantAppId() {
        return this._singleTenantAppId;
    }
    ;
    /**
     * Sets the singleTenantAppId property value. Partner Single tenant App id
     * @param value Value to set for the singleTenantAppId property.
     */
    set singleTenantAppId(value) {
        this._singleTenantAppId = value;
    }
    ;
    /**
     * Gets the whenPartnerDevicesWillBeMarkedAsNonCompliantDateTime property value. DateTime in UTC when PartnerDevices will be marked as NonCompliant
     * @returns a Date
     */
    get whenPartnerDevicesWillBeMarkedAsNonCompliantDateTime() {
        return this._whenPartnerDevicesWillBeMarkedAsNonCompliantDateTime;
    }
    ;
    /**
     * Sets the whenPartnerDevicesWillBeMarkedAsNonCompliantDateTime property value. DateTime in UTC when PartnerDevices will be marked as NonCompliant
     * @param value Value to set for the whenPartnerDevicesWillBeMarkedAsNonCompliantDateTime property.
     */
    set whenPartnerDevicesWillBeMarkedAsNonCompliantDateTime(value) {
        this._whenPartnerDevicesWillBeMarkedAsNonCompliantDateTime = value;
    }
    ;
    /**
     * Gets the whenPartnerDevicesWillBeRemovedDateTime property value. DateTime in UTC when PartnerDevices will be removed
     * @returns a Date
     */
    get whenPartnerDevicesWillBeRemovedDateTime() {
        return this._whenPartnerDevicesWillBeRemovedDateTime;
    }
    ;
    /**
     * Sets the whenPartnerDevicesWillBeRemovedDateTime property value. DateTime in UTC when PartnerDevices will be removed
     * @param value Value to set for the whenPartnerDevicesWillBeRemovedDateTime property.
     */
    set whenPartnerDevicesWillBeRemovedDateTime(value) {
        this._whenPartnerDevicesWillBeRemovedDateTime = value;
    }
    ;
}
exports.DeviceManagementPartner = DeviceManagementPartner;
