"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeviceManagementSettings = void 0;
class DeviceManagementSettings {
    /**
     * Instantiates a new deviceManagementSettings and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the deviceComplianceCheckinThresholdDays property value. The number of days a device is allowed to go without checking in to remain compliant.
     * @returns a integer
     */
    get deviceComplianceCheckinThresholdDays() {
        return this._deviceComplianceCheckinThresholdDays;
    }
    ;
    /**
     * Sets the deviceComplianceCheckinThresholdDays property value. The number of days a device is allowed to go without checking in to remain compliant.
     * @param value Value to set for the deviceComplianceCheckinThresholdDays property.
     */
    set deviceComplianceCheckinThresholdDays(value) {
        this._deviceComplianceCheckinThresholdDays = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "deviceComplianceCheckinThresholdDays": (o, n) => { o.deviceComplianceCheckinThresholdDays = n.getNumberValue(); },
            "isScheduledActionEnabled": (o, n) => { o.isScheduledActionEnabled = n.getBooleanValue(); },
            "secureByDefault": (o, n) => { o.secureByDefault = n.getBooleanValue(); },
        };
    }
    ;
    /**
     * Gets the isScheduledActionEnabled property value. Is feature enabled or not for scheduled action for rule.
     * @returns a boolean
     */
    get isScheduledActionEnabled() {
        return this._isScheduledActionEnabled;
    }
    ;
    /**
     * Sets the isScheduledActionEnabled property value. Is feature enabled or not for scheduled action for rule.
     * @param value Value to set for the isScheduledActionEnabled property.
     */
    set isScheduledActionEnabled(value) {
        this._isScheduledActionEnabled = value;
    }
    ;
    /**
     * Gets the secureByDefault property value. Device should be noncompliant when there is no compliance policy targeted when this is true
     * @returns a boolean
     */
    get secureByDefault() {
        return this._secureByDefault;
    }
    ;
    /**
     * Sets the secureByDefault property value. Device should be noncompliant when there is no compliance policy targeted when this is true
     * @param value Value to set for the secureByDefault property.
     */
    set secureByDefault(value) {
        this._secureByDefault = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeNumberValue("deviceComplianceCheckinThresholdDays", this.deviceComplianceCheckinThresholdDays);
        writer.writeBooleanValue("isScheduledActionEnabled", this.isScheduledActionEnabled);
        writer.writeBooleanValue("secureByDefault", this.secureByDefault);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.DeviceManagementSettings = DeviceManagementSettings;
