"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DirectoryAudit = void 0;
const createAuditActivityInitiatorFromDiscriminatorValue_1 = require("./createAuditActivityInitiatorFromDiscriminatorValue");
const createKeyValueFromDiscriminatorValue_1 = require("./createKeyValueFromDiscriminatorValue");
const createTargetResourceFromDiscriminatorValue_1 = require("./createTargetResourceFromDiscriminatorValue");
const index_1 = require("./index");
const operationResult_1 = require("./operationResult");
class DirectoryAudit extends index_1.Entity {
    /**
     * Instantiates a new directoryAudit and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the activityDateTime property value. Indicates the date and time the activity was performed. The Timestamp type is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z.
     * @returns a Date
     */
    get activityDateTime() {
        return this._activityDateTime;
    }
    ;
    /**
     * Sets the activityDateTime property value. Indicates the date and time the activity was performed. The Timestamp type is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z.
     * @param value Value to set for the activityDateTime property.
     */
    set activityDateTime(value) {
        this._activityDateTime = value;
    }
    ;
    /**
     * Gets the activityDisplayName property value. Indicates the activity name or the operation name (examples: 'Create User' and 'Add member to group'). For full list, see Azure AD activity list.
     * @returns a string
     */
    get activityDisplayName() {
        return this._activityDisplayName;
    }
    ;
    /**
     * Sets the activityDisplayName property value. Indicates the activity name or the operation name (examples: 'Create User' and 'Add member to group'). For full list, see Azure AD activity list.
     * @param value Value to set for the activityDisplayName property.
     */
    set activityDisplayName(value) {
        this._activityDisplayName = value;
    }
    ;
    /**
     * Gets the additionalDetails property value. Indicates additional details on the activity.
     * @returns a keyValue
     */
    get additionalDetails() {
        return this._additionalDetails;
    }
    ;
    /**
     * Sets the additionalDetails property value. Indicates additional details on the activity.
     * @param value Value to set for the additionalDetails property.
     */
    set additionalDetails(value) {
        this._additionalDetails = value;
    }
    ;
    /**
     * Gets the category property value. Indicates which resource category that's targeted by the activity. (For example: User Management, Group Management etc..)
     * @returns a string
     */
    get category() {
        return this._category;
    }
    ;
    /**
     * Sets the category property value. Indicates which resource category that's targeted by the activity. (For example: User Management, Group Management etc..)
     * @param value Value to set for the category property.
     */
    set category(value) {
        this._category = value;
    }
    ;
    ;
    /**
     * Gets the correlationId property value. Indicates a unique ID that helps correlate activities that span across various services. Can be used to trace logs across services.
     * @returns a string
     */
    get correlationId() {
        return this._correlationId;
    }
    ;
    /**
     * Sets the correlationId property value. Indicates a unique ID that helps correlate activities that span across various services. Can be used to trace logs across services.
     * @param value Value to set for the correlationId property.
     */
    set correlationId(value) {
        this._correlationId = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "activityDateTime": (o, n) => { o.activityDateTime = n.getDateValue(); }, "activityDisplayName": (o, n) => { o.activityDisplayName = n.getStringValue(); }, "additionalDetails": (o, n) => { o.additionalDetails = n.getCollectionOfObjectValues(createKeyValueFromDiscriminatorValue_1.createKeyValueFromDiscriminatorValue); }, "category": (o, n) => { o.category = n.getStringValue(); }, "correlationId": (o, n) => { o.correlationId = n.getStringValue(); }, "initiatedBy": (o, n) => { o.initiatedBy = n.getObjectValue(createAuditActivityInitiatorFromDiscriminatorValue_1.createAuditActivityInitiatorFromDiscriminatorValue); }, "loggedByService": (o, n) => { o.loggedByService = n.getStringValue(); }, "operationType": (o, n) => { o.operationType = n.getStringValue(); }, "result": (o, n) => { o.result = n.getEnumValue(operationResult_1.OperationResult); }, "resultReason": (o, n) => { o.resultReason = n.getStringValue(); }, "targetResources": (o, n) => { o.targetResources = n.getCollectionOfObjectValues(createTargetResourceFromDiscriminatorValue_1.createTargetResourceFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the initiatedBy property value.
     * @returns a auditActivityInitiator
     */
    get initiatedBy() {
        return this._initiatedBy;
    }
    ;
    /**
     * Sets the initiatedBy property value.
     * @param value Value to set for the initiatedBy property.
     */
    set initiatedBy(value) {
        this._initiatedBy = value;
    }
    ;
    /**
     * Gets the loggedByService property value. Indicates information on which service initiated the activity (For example: Self-service Password Management, Core Directory, B2C, Invited Users, Microsoft Identity Manager, Privileged Identity Management.
     * @returns a string
     */
    get loggedByService() {
        return this._loggedByService;
    }
    ;
    /**
     * Sets the loggedByService property value. Indicates information on which service initiated the activity (For example: Self-service Password Management, Core Directory, B2C, Invited Users, Microsoft Identity Manager, Privileged Identity Management.
     * @param value Value to set for the loggedByService property.
     */
    set loggedByService(value) {
        this._loggedByService = value;
    }
    ;
    /**
     * Gets the operationType property value.
     * @returns a string
     */
    get operationType() {
        return this._operationType;
    }
    ;
    /**
     * Sets the operationType property value.
     * @param value Value to set for the operationType property.
     */
    set operationType(value) {
        this._operationType = value;
    }
    ;
    /**
     * Gets the result property value. Indicates the result of the activity. Possible values are: success, failure, timeout, unknownFutureValue.
     * @returns a operationResult
     */
    get result() {
        return this._result;
    }
    ;
    /**
     * Sets the result property value. Indicates the result of the activity. Possible values are: success, failure, timeout, unknownFutureValue.
     * @param value Value to set for the result property.
     */
    set result(value) {
        this._result = value;
    }
    ;
    /**
     * Gets the resultReason property value. Indicates the reason for failure if the result is failure or timeout.
     * @returns a string
     */
    get resultReason() {
        return this._resultReason;
    }
    ;
    /**
     * Sets the resultReason property value. Indicates the reason for failure if the result is failure or timeout.
     * @param value Value to set for the resultReason property.
     */
    set resultReason(value) {
        this._resultReason = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeDateValue("activityDateTime", this.activityDateTime);
        writer.writeStringValue("activityDisplayName", this.activityDisplayName);
        writer.writeCollectionOfObjectValues("additionalDetails", this.additionalDetails);
        writer.writeStringValue("category", this.category);
        writer.writeStringValue("correlationId", this.correlationId);
        writer.writeObjectValue("initiatedBy", this.initiatedBy);
        writer.writeStringValue("loggedByService", this.loggedByService);
        writer.writeStringValue("operationType", this.operationType);
        writer.writeEnumValue("result", this.result);
        writer.writeStringValue("resultReason", this.resultReason);
        writer.writeCollectionOfObjectValues("targetResources", this.targetResources);
    }
    ;
    /**
     * Gets the targetResources property value. Indicates information on which resource was changed due to the activity. Target Resource Type can be User, Device, Directory, App, Role, Group, Policy or Other.
     * @returns a targetResource
     */
    get targetResources() {
        return this._targetResources;
    }
    ;
    /**
     * Sets the targetResources property value. Indicates information on which resource was changed due to the activity. Target Resource Type can be User, Device, Directory, App, Role, Group, Policy or Other.
     * @param value Value to set for the targetResources property.
     */
    set targetResources(value) {
        this._targetResources = value;
    }
    ;
}
exports.DirectoryAudit = DirectoryAudit;
