"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DocumentSetContent = void 0;
const createContentTypeInfoFromDiscriminatorValue_1 = require("./createContentTypeInfoFromDiscriminatorValue");
class DocumentSetContent {
    /**
     * Instantiates a new documentSetContent and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the contentType property value. Content type information of the file.
     * @returns a contentTypeInfo
     */
    get contentType() {
        return this._contentType;
    }
    ;
    /**
     * Sets the contentType property value. Content type information of the file.
     * @param value Value to set for the contentType property.
     */
    set contentType(value) {
        this._contentType = value;
    }
    ;
    /**
     * Gets the fileName property value. Name of the file in resource folder that should be added as a default content or a template in the document set.
     * @returns a string
     */
    get fileName() {
        return this._fileName;
    }
    ;
    /**
     * Sets the fileName property value. Name of the file in resource folder that should be added as a default content or a template in the document set.
     * @param value Value to set for the fileName property.
     */
    set fileName(value) {
        this._fileName = value;
    }
    ;
    /**
     * Gets the folderName property value. Folder name in which the file will be placed when a new document set is created in the library.
     * @returns a string
     */
    get folderName() {
        return this._folderName;
    }
    ;
    /**
     * Sets the folderName property value. Folder name in which the file will be placed when a new document set is created in the library.
     * @param value Value to set for the folderName property.
     */
    set folderName(value) {
        this._folderName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "contentType": (o, n) => { o.contentType = n.getObjectValue(createContentTypeInfoFromDiscriminatorValue_1.createContentTypeInfoFromDiscriminatorValue); },
            "fileName": (o, n) => { o.fileName = n.getStringValue(); },
            "folderName": (o, n) => { o.folderName = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("contentType", this.contentType);
        writer.writeStringValue("fileName", this.fileName);
        writer.writeStringValue("folderName", this.folderName);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.DocumentSetContent = DocumentSetContent;
