"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DomainDnsRecord = void 0;
const index_1 = require("./index");
class DomainDnsRecord extends index_1.Entity {
    /**
     * Instantiates a new domainDnsRecord and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "isOptional": (o, n) => { o.isOptional = n.getBooleanValue(); }, "label": (o, n) => { o.label = n.getStringValue(); }, "recordType": (o, n) => { o.recordType = n.getStringValue(); }, "supportedService": (o, n) => { o.supportedService = n.getStringValue(); }, "ttl": (o, n) => { o.ttl = n.getNumberValue(); } });
    }
    ;
    /**
     * Gets the isOptional property value. If false, this record must be configured by the customer at the DNS host for Microsoft Online Services to operate correctly with the domain.
     * @returns a boolean
     */
    get isOptional() {
        return this._isOptional;
    }
    ;
    /**
     * Sets the isOptional property value. If false, this record must be configured by the customer at the DNS host for Microsoft Online Services to operate correctly with the domain.
     * @param value Value to set for the isOptional property.
     */
    set isOptional(value) {
        this._isOptional = value;
    }
    ;
    /**
     * Gets the label property value. Value used when configuring the name of the DNS record at the DNS host.
     * @returns a string
     */
    get label() {
        return this._label;
    }
    ;
    /**
     * Sets the label property value. Value used when configuring the name of the DNS record at the DNS host.
     * @param value Value to set for the label property.
     */
    set label(value) {
        this._label = value;
    }
    ;
    /**
     * Gets the recordType property value. Indicates what type of DNS record this entity represents.The value can be one of the following: CName, Mx, Srv, TxtKey
     * @returns a string
     */
    get recordType() {
        return this._recordType;
    }
    ;
    /**
     * Sets the recordType property value. Indicates what type of DNS record this entity represents.The value can be one of the following: CName, Mx, Srv, TxtKey
     * @param value Value to set for the recordType property.
     */
    set recordType(value) {
        this._recordType = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeBooleanValue("isOptional", this.isOptional);
        writer.writeStringValue("label", this.label);
        writer.writeStringValue("recordType", this.recordType);
        writer.writeStringValue("supportedService", this.supportedService);
        writer.writeNumberValue("ttl", this.ttl);
    }
    ;
    /**
     * Gets the supportedService property value. Microsoft Online Service or feature that has a dependency on this DNS record.Can be one of the following values: null, Email, Sharepoint, EmailInternalRelayOnly, OfficeCommunicationsOnline, SharePointDefaultDomain, FullRedelegation, SharePointPublic, OrgIdAuthentication, Yammer, Intune
     * @returns a string
     */
    get supportedService() {
        return this._supportedService;
    }
    ;
    /**
     * Sets the supportedService property value. Microsoft Online Service or feature that has a dependency on this DNS record.Can be one of the following values: null, Email, Sharepoint, EmailInternalRelayOnly, OfficeCommunicationsOnline, SharePointDefaultDomain, FullRedelegation, SharePointPublic, OrgIdAuthentication, Yammer, Intune
     * @param value Value to set for the supportedService property.
     */
    set supportedService(value) {
        this._supportedService = value;
    }
    ;
    /**
     * Gets the ttl property value. Value to use when configuring the time-to-live (ttl) property of the DNS record at the DNS host. Not nullable
     * @returns a integer
     */
    get ttl() {
        return this._ttl;
    }
    ;
    /**
     * Sets the ttl property value. Value to use when configuring the time-to-live (ttl) property of the DNS record at the DNS host. Not nullable
     * @param value Value to set for the ttl property.
     */
    set ttl(value) {
        this._ttl = value;
    }
    ;
}
exports.DomainDnsRecord = DomainDnsRecord;
