"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DriveItem = void 0;
const createAudioFromDiscriminatorValue_1 = require("./createAudioFromDiscriminatorValue");
const createBundleFromDiscriminatorValue_1 = require("./createBundleFromDiscriminatorValue");
const createDeletedFromDiscriminatorValue_1 = require("./createDeletedFromDiscriminatorValue");
const createDriveItemFromDiscriminatorValue_1 = require("./createDriveItemFromDiscriminatorValue");
const createDriveItemVersionFromDiscriminatorValue_1 = require("./createDriveItemVersionFromDiscriminatorValue");
const createFileFromDiscriminatorValue_1 = require("./createFileFromDiscriminatorValue");
const createFileSystemInfoFromDiscriminatorValue_1 = require("./createFileSystemInfoFromDiscriminatorValue");
const createFolderFromDiscriminatorValue_1 = require("./createFolderFromDiscriminatorValue");
const createGeoCoordinatesFromDiscriminatorValue_1 = require("./createGeoCoordinatesFromDiscriminatorValue");
const createImageFromDiscriminatorValue_1 = require("./createImageFromDiscriminatorValue");
const createItemAnalyticsFromDiscriminatorValue_1 = require("./createItemAnalyticsFromDiscriminatorValue");
const createListItemFromDiscriminatorValue_1 = require("./createListItemFromDiscriminatorValue");
const createMalwareFromDiscriminatorValue_1 = require("./createMalwareFromDiscriminatorValue");
const createPackageFromDiscriminatorValue_1 = require("./createPackageFromDiscriminatorValue");
const createPendingOperationsFromDiscriminatorValue_1 = require("./createPendingOperationsFromDiscriminatorValue");
const createPermissionFromDiscriminatorValue_1 = require("./createPermissionFromDiscriminatorValue");
const createPhotoFromDiscriminatorValue_1 = require("./createPhotoFromDiscriminatorValue");
const createPublicationFacetFromDiscriminatorValue_1 = require("./createPublicationFacetFromDiscriminatorValue");
const createRemoteItemFromDiscriminatorValue_1 = require("./createRemoteItemFromDiscriminatorValue");
const createRootFromDiscriminatorValue_1 = require("./createRootFromDiscriminatorValue");
const createSearchResultFromDiscriminatorValue_1 = require("./createSearchResultFromDiscriminatorValue");
const createSharedFromDiscriminatorValue_1 = require("./createSharedFromDiscriminatorValue");
const createSharepointIdsFromDiscriminatorValue_1 = require("./createSharepointIdsFromDiscriminatorValue");
const createSpecialFolderFromDiscriminatorValue_1 = require("./createSpecialFolderFromDiscriminatorValue");
const createSubscriptionFromDiscriminatorValue_1 = require("./createSubscriptionFromDiscriminatorValue");
const createThumbnailSetFromDiscriminatorValue_1 = require("./createThumbnailSetFromDiscriminatorValue");
const createVideoFromDiscriminatorValue_1 = require("./createVideoFromDiscriminatorValue");
const createWorkbookFromDiscriminatorValue_1 = require("./createWorkbookFromDiscriminatorValue");
const index_1 = require("./index");
class DriveItem extends index_1.BaseItem {
    /**
     * Instantiates a new driveItem and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the analytics property value. Analytics about the view activities that took place on this item.
     * @returns a itemAnalytics
     */
    get analytics() {
        return this._analytics;
    }
    ;
    /**
     * Sets the analytics property value. Analytics about the view activities that took place on this item.
     * @param value Value to set for the analytics property.
     */
    set analytics(value) {
        this._analytics = value;
    }
    ;
    /**
     * Gets the audio property value. Audio metadata, if the item is an audio file. Read-only. Read-only. Only on OneDrive Personal.
     * @returns a audio
     */
    get audio() {
        return this._audio;
    }
    ;
    /**
     * Sets the audio property value. Audio metadata, if the item is an audio file. Read-only. Read-only. Only on OneDrive Personal.
     * @param value Value to set for the audio property.
     */
    set audio(value) {
        this._audio = value;
    }
    ;
    /**
     * Gets the bundle property value. Bundle metadata, if the item is a bundle. Read-only.
     * @returns a bundle
     */
    get bundle() {
        return this._bundle;
    }
    ;
    /**
     * Sets the bundle property value. Bundle metadata, if the item is a bundle. Read-only.
     * @param value Value to set for the bundle property.
     */
    set bundle(value) {
        this._bundle = value;
    }
    ;
    /**
     * Gets the children property value. Collection containing Item objects for the immediate children of Item. Only items representing folders have children. Read-only. Nullable.
     * @returns a driveItem
     */
    get children() {
        return this._children;
    }
    ;
    /**
     * Sets the children property value. Collection containing Item objects for the immediate children of Item. Only items representing folders have children. Read-only. Nullable.
     * @param value Value to set for the children property.
     */
    set children(value) {
        this._children = value;
    }
    ;
    ;
    /**
     * Gets the content property value. The content stream, if the item represents a file.
     * @returns a binary
     */
    get content() {
        return this._content;
    }
    ;
    /**
     * Sets the content property value. The content stream, if the item represents a file.
     * @param value Value to set for the content property.
     */
    set content(value) {
        this._content = value;
    }
    ;
    /**
     * Gets the cTag property value. An eTag for the content of the item. This eTag is not changed if only the metadata is changed. Note This property is not returned if the item is a folder. Read-only.
     * @returns a string
     */
    get cTag() {
        return this._cTag;
    }
    ;
    /**
     * Sets the cTag property value. An eTag for the content of the item. This eTag is not changed if only the metadata is changed. Note This property is not returned if the item is a folder. Read-only.
     * @param value Value to set for the cTag property.
     */
    set cTag(value) {
        this._cTag = value;
    }
    ;
    /**
     * Gets the deleted property value. Information about the deleted state of the item. Read-only.
     * @returns a deleted
     */
    get deleted() {
        return this._deleted;
    }
    ;
    /**
     * Sets the deleted property value. Information about the deleted state of the item. Read-only.
     * @param value Value to set for the deleted property.
     */
    set deleted(value) {
        this._deleted = value;
    }
    ;
    /**
     * Gets the file property value. File metadata, if the item is a file. Read-only.
     * @returns a file
     */
    get file() {
        return this._file;
    }
    ;
    /**
     * Sets the file property value. File metadata, if the item is a file. Read-only.
     * @param value Value to set for the file property.
     */
    set file(value) {
        this._file = value;
    }
    ;
    /**
     * Gets the fileSystemInfo property value. File system information on client. Read-write.
     * @returns a fileSystemInfo
     */
    get fileSystemInfo() {
        return this._fileSystemInfo;
    }
    ;
    /**
     * Sets the fileSystemInfo property value. File system information on client. Read-write.
     * @param value Value to set for the fileSystemInfo property.
     */
    set fileSystemInfo(value) {
        this._fileSystemInfo = value;
    }
    ;
    /**
     * Gets the folder property value. Folder metadata, if the item is a folder. Read-only.
     * @returns a folder
     */
    get folder() {
        return this._folder;
    }
    ;
    /**
     * Sets the folder property value. Folder metadata, if the item is a folder. Read-only.
     * @param value Value to set for the folder property.
     */
    set folder(value) {
        this._folder = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "analytics": (o, n) => { o.analytics = n.getObjectValue(createItemAnalyticsFromDiscriminatorValue_1.createItemAnalyticsFromDiscriminatorValue); }, "audio": (o, n) => { o.audio = n.getObjectValue(createAudioFromDiscriminatorValue_1.createAudioFromDiscriminatorValue); }, "bundle": (o, n) => { o.bundle = n.getObjectValue(createBundleFromDiscriminatorValue_1.createBundleFromDiscriminatorValue); }, "children": (o, n) => { o.children = n.getCollectionOfObjectValues(createDriveItemFromDiscriminatorValue_1.createDriveItemFromDiscriminatorValue); }, "content": (o, n) => { o.content = n.getStringValue(); }, "cTag": (o, n) => { o.cTag = n.getStringValue(); }, "deleted": (o, n) => { o.deleted = n.getObjectValue(createDeletedFromDiscriminatorValue_1.createDeletedFromDiscriminatorValue); }, "file": (o, n) => { o.file = n.getObjectValue(createFileFromDiscriminatorValue_1.createFileFromDiscriminatorValue); }, "fileSystemInfo": (o, n) => { o.fileSystemInfo = n.getObjectValue(createFileSystemInfoFromDiscriminatorValue_1.createFileSystemInfoFromDiscriminatorValue); }, "folder": (o, n) => { o.folder = n.getObjectValue(createFolderFromDiscriminatorValue_1.createFolderFromDiscriminatorValue); }, "image": (o, n) => { o.image = n.getObjectValue(createImageFromDiscriminatorValue_1.createImageFromDiscriminatorValue); }, "listItem": (o, n) => { o.listItem = n.getObjectValue(createListItemFromDiscriminatorValue_1.createListItemFromDiscriminatorValue); }, "location": (o, n) => { o.location = n.getObjectValue(createGeoCoordinatesFromDiscriminatorValue_1.createGeoCoordinatesFromDiscriminatorValue); }, "malware": (o, n) => { o.malware = n.getObjectValue(createMalwareFromDiscriminatorValue_1.createMalwareFromDiscriminatorValue); }, "package": (o, n) => { o.package = n.getObjectValue(createPackageFromDiscriminatorValue_1.createPackageFromDiscriminatorValue); }, "pendingOperations": (o, n) => { o.pendingOperations = n.getObjectValue(createPendingOperationsFromDiscriminatorValue_1.createPendingOperationsFromDiscriminatorValue); }, "permissions": (o, n) => { o.permissions = n.getCollectionOfObjectValues(createPermissionFromDiscriminatorValue_1.createPermissionFromDiscriminatorValue); }, "photo": (o, n) => { o.photo = n.getObjectValue(createPhotoFromDiscriminatorValue_1.createPhotoFromDiscriminatorValue); }, "publication": (o, n) => { o.publication = n.getObjectValue(createPublicationFacetFromDiscriminatorValue_1.createPublicationFacetFromDiscriminatorValue); }, "remoteItem": (o, n) => { o.remoteItem = n.getObjectValue(createRemoteItemFromDiscriminatorValue_1.createRemoteItemFromDiscriminatorValue); }, "root": (o, n) => { o.root = n.getObjectValue(createRootFromDiscriminatorValue_1.createRootFromDiscriminatorValue); }, "searchResult": (o, n) => { o.searchResult = n.getObjectValue(createSearchResultFromDiscriminatorValue_1.createSearchResultFromDiscriminatorValue); }, "shared": (o, n) => { o.shared = n.getObjectValue(createSharedFromDiscriminatorValue_1.createSharedFromDiscriminatorValue); }, "sharepointIds": (o, n) => { o.sharepointIds = n.getObjectValue(createSharepointIdsFromDiscriminatorValue_1.createSharepointIdsFromDiscriminatorValue); }, "size": (o, n) => { o.size = n.getNumberValue(); }, "specialFolder": (o, n) => { o.specialFolder = n.getObjectValue(createSpecialFolderFromDiscriminatorValue_1.createSpecialFolderFromDiscriminatorValue); }, "subscriptions": (o, n) => { o.subscriptions = n.getCollectionOfObjectValues(createSubscriptionFromDiscriminatorValue_1.createSubscriptionFromDiscriminatorValue); }, "thumbnails": (o, n) => { o.thumbnails = n.getCollectionOfObjectValues(createThumbnailSetFromDiscriminatorValue_1.createThumbnailSetFromDiscriminatorValue); }, "versions": (o, n) => { o.versions = n.getCollectionOfObjectValues(createDriveItemVersionFromDiscriminatorValue_1.createDriveItemVersionFromDiscriminatorValue); }, "video": (o, n) => { o.video = n.getObjectValue(createVideoFromDiscriminatorValue_1.createVideoFromDiscriminatorValue); }, "webDavUrl": (o, n) => { o.webDavUrl = n.getStringValue(); }, "workbook": (o, n) => { o.workbook = n.getObjectValue(createWorkbookFromDiscriminatorValue_1.createWorkbookFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the image property value. Image metadata, if the item is an image. Read-only.
     * @returns a image
     */
    get image() {
        return this._image;
    }
    ;
    /**
     * Sets the image property value. Image metadata, if the item is an image. Read-only.
     * @param value Value to set for the image property.
     */
    set image(value) {
        this._image = value;
    }
    ;
    /**
     * Gets the listItem property value. For drives in SharePoint, the associated document library list item. Read-only. Nullable.
     * @returns a listItem
     */
    get listItem() {
        return this._listItem;
    }
    ;
    /**
     * Sets the listItem property value. For drives in SharePoint, the associated document library list item. Read-only. Nullable.
     * @param value Value to set for the listItem property.
     */
    set listItem(value) {
        this._listItem = value;
    }
    ;
    /**
     * Gets the location property value. Location metadata, if the item has location data. Read-only.
     * @returns a geoCoordinates
     */
    get location() {
        return this._location;
    }
    ;
    /**
     * Sets the location property value. Location metadata, if the item has location data. Read-only.
     * @param value Value to set for the location property.
     */
    set location(value) {
        this._location = value;
    }
    ;
    /**
     * Gets the malware property value. Malware metadata, if the item was detected to contain malware. Read-only.
     * @returns a malware
     */
    get malware() {
        return this._malware;
    }
    ;
    /**
     * Sets the malware property value. Malware metadata, if the item was detected to contain malware. Read-only.
     * @param value Value to set for the malware property.
     */
    set malware(value) {
        this._malware = value;
    }
    ;
    /**
     * Gets the package property value. If present, indicates that this item is a package instead of a folder or file. Packages are treated like files in some contexts and folders in others. Read-only.
     * @returns a package
     */
    get package() {
        return this._package;
    }
    ;
    /**
     * Sets the package property value. If present, indicates that this item is a package instead of a folder or file. Packages are treated like files in some contexts and folders in others. Read-only.
     * @param value Value to set for the package property.
     */
    set package(value) {
        this._package = value;
    }
    ;
    /**
     * Gets the pendingOperations property value. If present, indicates that one or more operations that might affect the state of the driveItem are pending completion. Read-only.
     * @returns a pendingOperations
     */
    get pendingOperations() {
        return this._pendingOperations;
    }
    ;
    /**
     * Sets the pendingOperations property value. If present, indicates that one or more operations that might affect the state of the driveItem are pending completion. Read-only.
     * @param value Value to set for the pendingOperations property.
     */
    set pendingOperations(value) {
        this._pendingOperations = value;
    }
    ;
    /**
     * Gets the permissions property value. The set of permissions for the item. Read-only. Nullable.
     * @returns a permission
     */
    get permissions() {
        return this._permissions;
    }
    ;
    /**
     * Sets the permissions property value. The set of permissions for the item. Read-only. Nullable.
     * @param value Value to set for the permissions property.
     */
    set permissions(value) {
        this._permissions = value;
    }
    ;
    /**
     * Gets the photo property value. Photo metadata, if the item is a photo. Read-only.
     * @returns a photo
     */
    get photo() {
        return this._photo;
    }
    ;
    /**
     * Sets the photo property value. Photo metadata, if the item is a photo. Read-only.
     * @param value Value to set for the photo property.
     */
    set photo(value) {
        this._photo = value;
    }
    ;
    /**
     * Gets the publication property value. Provides information about the published or checked-out state of an item, in locations that support such actions. This property is not returned by default. Read-only.
     * @returns a publicationFacet
     */
    get publication() {
        return this._publication;
    }
    ;
    /**
     * Sets the publication property value. Provides information about the published or checked-out state of an item, in locations that support such actions. This property is not returned by default. Read-only.
     * @param value Value to set for the publication property.
     */
    set publication(value) {
        this._publication = value;
    }
    ;
    /**
     * Gets the remoteItem property value. Remote item data, if the item is shared from a drive other than the one being accessed. Read-only.
     * @returns a remoteItem
     */
    get remoteItem() {
        return this._remoteItem;
    }
    ;
    /**
     * Sets the remoteItem property value. Remote item data, if the item is shared from a drive other than the one being accessed. Read-only.
     * @param value Value to set for the remoteItem property.
     */
    set remoteItem(value) {
        this._remoteItem = value;
    }
    ;
    /**
     * Gets the root property value. If this property is non-null, it indicates that the driveItem is the top-most driveItem in the drive.
     * @returns a root
     */
    get root() {
        return this._root;
    }
    ;
    /**
     * Sets the root property value. If this property is non-null, it indicates that the driveItem is the top-most driveItem in the drive.
     * @param value Value to set for the root property.
     */
    set root(value) {
        this._root = value;
    }
    ;
    /**
     * Gets the searchResult property value. Search metadata, if the item is from a search result. Read-only.
     * @returns a searchResult
     */
    get searchResult() {
        return this._searchResult;
    }
    ;
    /**
     * Sets the searchResult property value. Search metadata, if the item is from a search result. Read-only.
     * @param value Value to set for the searchResult property.
     */
    set searchResult(value) {
        this._searchResult = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("analytics", this.analytics);
        writer.writeObjectValue("audio", this.audio);
        writer.writeObjectValue("bundle", this.bundle);
        writer.writeCollectionOfObjectValues("children", this.children);
        writer.writeStringValue("content", this.content);
        writer.writeStringValue("cTag", this.cTag);
        writer.writeObjectValue("deleted", this.deleted);
        writer.writeObjectValue("file", this.file);
        writer.writeObjectValue("fileSystemInfo", this.fileSystemInfo);
        writer.writeObjectValue("folder", this.folder);
        writer.writeObjectValue("image", this.image);
        writer.writeObjectValue("listItem", this.listItem);
        writer.writeObjectValue("location", this.location);
        writer.writeObjectValue("malware", this.malware);
        writer.writeObjectValue("package", this.package);
        writer.writeObjectValue("pendingOperations", this.pendingOperations);
        writer.writeCollectionOfObjectValues("permissions", this.permissions);
        writer.writeObjectValue("photo", this.photo);
        writer.writeObjectValue("publication", this.publication);
        writer.writeObjectValue("remoteItem", this.remoteItem);
        writer.writeObjectValue("root", this.root);
        writer.writeObjectValue("searchResult", this.searchResult);
        writer.writeObjectValue("shared", this.shared);
        writer.writeObjectValue("sharepointIds", this.sharepointIds);
        writer.writeNumberValue("size", this.size);
        writer.writeObjectValue("specialFolder", this.specialFolder);
        writer.writeCollectionOfObjectValues("subscriptions", this.subscriptions);
        writer.writeCollectionOfObjectValues("thumbnails", this.thumbnails);
        writer.writeCollectionOfObjectValues("versions", this.versions);
        writer.writeObjectValue("video", this.video);
        writer.writeStringValue("webDavUrl", this.webDavUrl);
        writer.writeObjectValue("workbook", this.workbook);
    }
    ;
    /**
     * Gets the shared property value. Indicates that the item has been shared with others and provides information about the shared state of the item. Read-only.
     * @returns a shared
     */
    get shared() {
        return this._shared;
    }
    ;
    /**
     * Sets the shared property value. Indicates that the item has been shared with others and provides information about the shared state of the item. Read-only.
     * @param value Value to set for the shared property.
     */
    set shared(value) {
        this._shared = value;
    }
    ;
    /**
     * Gets the sharepointIds property value. Returns identifiers useful for SharePoint REST compatibility. Read-only.
     * @returns a sharepointIds
     */
    get sharepointIds() {
        return this._sharepointIds;
    }
    ;
    /**
     * Sets the sharepointIds property value. Returns identifiers useful for SharePoint REST compatibility. Read-only.
     * @param value Value to set for the sharepointIds property.
     */
    set sharepointIds(value) {
        this._sharepointIds = value;
    }
    ;
    /**
     * Gets the size property value. Size of the item in bytes. Read-only.
     * @returns a int64
     */
    get size() {
        return this._size;
    }
    ;
    /**
     * Sets the size property value. Size of the item in bytes. Read-only.
     * @param value Value to set for the size property.
     */
    set size(value) {
        this._size = value;
    }
    ;
    /**
     * Gets the specialFolder property value. If the current item is also available as a special folder, this facet is returned. Read-only.
     * @returns a specialFolder
     */
    get specialFolder() {
        return this._specialFolder;
    }
    ;
    /**
     * Sets the specialFolder property value. If the current item is also available as a special folder, this facet is returned. Read-only.
     * @param value Value to set for the specialFolder property.
     */
    set specialFolder(value) {
        this._specialFolder = value;
    }
    ;
    /**
     * Gets the subscriptions property value. The set of subscriptions on the item. Only supported on the root of a drive.
     * @returns a subscription
     */
    get subscriptions() {
        return this._subscriptions;
    }
    ;
    /**
     * Sets the subscriptions property value. The set of subscriptions on the item. Only supported on the root of a drive.
     * @param value Value to set for the subscriptions property.
     */
    set subscriptions(value) {
        this._subscriptions = value;
    }
    ;
    /**
     * Gets the thumbnails property value. Collection containing [ThumbnailSet][] objects associated with the item. For more info, see [getting thumbnails][]. Read-only. Nullable.
     * @returns a thumbnailSet
     */
    get thumbnails() {
        return this._thumbnails;
    }
    ;
    /**
     * Sets the thumbnails property value. Collection containing [ThumbnailSet][] objects associated with the item. For more info, see [getting thumbnails][]. Read-only. Nullable.
     * @param value Value to set for the thumbnails property.
     */
    set thumbnails(value) {
        this._thumbnails = value;
    }
    ;
    /**
     * Gets the versions property value. The list of previous versions of the item. For more info, see [getting previous versions][]. Read-only. Nullable.
     * @returns a driveItemVersion
     */
    get versions() {
        return this._versions;
    }
    ;
    /**
     * Sets the versions property value. The list of previous versions of the item. For more info, see [getting previous versions][]. Read-only. Nullable.
     * @param value Value to set for the versions property.
     */
    set versions(value) {
        this._versions = value;
    }
    ;
    /**
     * Gets the video property value. Video metadata, if the item is a video. Read-only.
     * @returns a video
     */
    get video() {
        return this._video;
    }
    ;
    /**
     * Sets the video property value. Video metadata, if the item is a video. Read-only.
     * @param value Value to set for the video property.
     */
    set video(value) {
        this._video = value;
    }
    ;
    /**
     * Gets the webDavUrl property value. WebDAV compatible URL for the item.
     * @returns a string
     */
    get webDavUrl() {
        return this._webDavUrl;
    }
    ;
    /**
     * Sets the webDavUrl property value. WebDAV compatible URL for the item.
     * @param value Value to set for the webDavUrl property.
     */
    set webDavUrl(value) {
        this._webDavUrl = value;
    }
    ;
    /**
     * Gets the workbook property value. For files that are Excel spreadsheets, accesses the workbook API to work with the spreadsheet's contents. Nullable.
     * @returns a workbook
     */
    get workbook() {
        return this._workbook;
    }
    ;
    /**
     * Sets the workbook property value. For files that are Excel spreadsheets, accesses the workbook API to work with the spreadsheet's contents. Nullable.
     * @param value Value to set for the workbook property.
     */
    set workbook(value) {
        this._workbook = value;
    }
    ;
}
exports.DriveItem = DriveItem;
