"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DriveItemUploadableProperties = void 0;
const createFileSystemInfoFromDiscriminatorValue_1 = require("./createFileSystemInfoFromDiscriminatorValue");
class DriveItemUploadableProperties {
    /**
     * Instantiates a new driveItemUploadableProperties and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the description property value. Provides a user-visible description of the item. Read-write. Only on OneDrive Personal.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. Provides a user-visible description of the item. Read-write. Only on OneDrive Personal.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the fileSize property value. Provides an expected file size to perform a quota check prior to upload. Only on OneDrive Personal.
     * @returns a int64
     */
    get fileSize() {
        return this._fileSize;
    }
    ;
    /**
     * Sets the fileSize property value. Provides an expected file size to perform a quota check prior to upload. Only on OneDrive Personal.
     * @param value Value to set for the fileSize property.
     */
    set fileSize(value) {
        this._fileSize = value;
    }
    ;
    /**
     * Gets the fileSystemInfo property value. File system information on client. Read-write.
     * @returns a fileSystemInfo
     */
    get fileSystemInfo() {
        return this._fileSystemInfo;
    }
    ;
    /**
     * Sets the fileSystemInfo property value. File system information on client. Read-write.
     * @param value Value to set for the fileSystemInfo property.
     */
    set fileSystemInfo(value) {
        this._fileSystemInfo = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "description": (o, n) => { o.description = n.getStringValue(); },
            "fileSize": (o, n) => { o.fileSize = n.getNumberValue(); },
            "fileSystemInfo": (o, n) => { o.fileSystemInfo = n.getObjectValue(createFileSystemInfoFromDiscriminatorValue_1.createFileSystemInfoFromDiscriminatorValue); },
            "name": (o, n) => { o.name = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the name property value. The name of the item (filename and extension). Read-write.
     * @returns a string
     */
    get name() {
        return this._name;
    }
    ;
    /**
     * Sets the name property value. The name of the item (filename and extension). Read-write.
     * @param value Value to set for the name property.
     */
    set name(value) {
        this._name = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("description", this.description);
        writer.writeNumberValue("fileSize", this.fileSize);
        writer.writeObjectValue("fileSystemInfo", this.fileSystemInfo);
        writer.writeStringValue("name", this.name);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.DriveItemUploadableProperties = DriveItemUploadableProperties;
