"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DriveItemVersion = void 0;
const index_1 = require("./index");
class DriveItemVersion extends index_1.BaseItemVersion {
    /**
     * Instantiates a new driveItemVersion and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the content property value. The content stream for this version of the item.
     * @returns a binary
     */
    get content() {
        return this._content;
    }
    ;
    /**
     * Sets the content property value. The content stream for this version of the item.
     * @param value Value to set for the content property.
     */
    set content(value) {
        this._content = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "content": (o, n) => { o.content = n.getStringValue(); }, "size": (o, n) => { o.size = n.getNumberValue(); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("content", this.content);
        writer.writeNumberValue("size", this.size);
    }
    ;
    /**
     * Gets the size property value. Indicates the size of the content stream for this version of the item.
     * @returns a int64
     */
    get size() {
        return this._size;
    }
    ;
    /**
     * Sets the size property value. Indicates the size of the content stream for this version of the item.
     * @param value Value to set for the size property.
     */
    set size(value) {
        this._size = value;
    }
    ;
}
exports.DriveItemVersion = DriveItemVersion;
