import { Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class EBookInstallSummary extends Entity implements Parsable {
    /** Number of Devices that have failed to install this book.  */
    private _failedDeviceCount?;
    /** Number of Users that have 1 or more device that failed to install this book.  */
    private _failedUserCount?;
    /** Number of Devices that have successfully installed this book.  */
    private _installedDeviceCount?;
    /** Number of Users whose devices have all succeeded to install this book.  */
    private _installedUserCount?;
    /** Number of Devices that does not have this book installed.  */
    private _notInstalledDeviceCount?;
    /** Number of Users that did not install this book.  */
    private _notInstalledUserCount?;
    /**
     * Instantiates a new eBookInstallSummary and sets the default values.
     */
    constructor();
    /**
     * Gets the failedDeviceCount property value. Number of Devices that have failed to install this book.
     * @returns a integer
     */
    get failedDeviceCount(): number | undefined;
    /**
     * Sets the failedDeviceCount property value. Number of Devices that have failed to install this book.
     * @param value Value to set for the failedDeviceCount property.
     */
    set failedDeviceCount(value: number | undefined);
    /**
     * Gets the failedUserCount property value. Number of Users that have 1 or more device that failed to install this book.
     * @returns a integer
     */
    get failedUserCount(): number | undefined;
    /**
     * Sets the failedUserCount property value. Number of Users that have 1 or more device that failed to install this book.
     * @param value Value to set for the failedUserCount property.
     */
    set failedUserCount(value: number | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the installedDeviceCount property value. Number of Devices that have successfully installed this book.
     * @returns a integer
     */
    get installedDeviceCount(): number | undefined;
    /**
     * Sets the installedDeviceCount property value. Number of Devices that have successfully installed this book.
     * @param value Value to set for the installedDeviceCount property.
     */
    set installedDeviceCount(value: number | undefined);
    /**
     * Gets the installedUserCount property value. Number of Users whose devices have all succeeded to install this book.
     * @returns a integer
     */
    get installedUserCount(): number | undefined;
    /**
     * Sets the installedUserCount property value. Number of Users whose devices have all succeeded to install this book.
     * @param value Value to set for the installedUserCount property.
     */
    set installedUserCount(value: number | undefined);
    /**
     * Gets the notInstalledDeviceCount property value. Number of Devices that does not have this book installed.
     * @returns a integer
     */
    get notInstalledDeviceCount(): number | undefined;
    /**
     * Sets the notInstalledDeviceCount property value. Number of Devices that does not have this book installed.
     * @param value Value to set for the notInstalledDeviceCount property.
     */
    set notInstalledDeviceCount(value: number | undefined);
    /**
     * Gets the notInstalledUserCount property value. Number of Users that did not install this book.
     * @returns a integer
     */
    get notInstalledUserCount(): number | undefined;
    /**
     * Sets the notInstalledUserCount property value. Number of Users that did not install this book.
     * @param value Value to set for the notInstalledUserCount property.
     */
    set notInstalledUserCount(value: number | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
