"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EducationAssignmentResource = void 0;
const createEducationResourceFromDiscriminatorValue_1 = require("./createEducationResourceFromDiscriminatorValue");
const index_1 = require("./index");
class EducationAssignmentResource extends index_1.Entity {
    /**
     * Instantiates a new educationAssignmentResource and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the distributeForStudentWork property value. Indicates whether this resource should be copied to each student submission for modification and submission. Required
     * @returns a boolean
     */
    get distributeForStudentWork() {
        return this._distributeForStudentWork;
    }
    ;
    /**
     * Sets the distributeForStudentWork property value. Indicates whether this resource should be copied to each student submission for modification and submission. Required
     * @param value Value to set for the distributeForStudentWork property.
     */
    set distributeForStudentWork(value) {
        this._distributeForStudentWork = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "distributeForStudentWork": (o, n) => { o.distributeForStudentWork = n.getBooleanValue(); }, "resource": (o, n) => { o.resource = n.getObjectValue(createEducationResourceFromDiscriminatorValue_1.createEducationResourceFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the resource property value. Resource object that has been associated with this assignment.
     * @returns a educationResource
     */
    get resource() {
        return this._resource;
    }
    ;
    /**
     * Sets the resource property value. Resource object that has been associated with this assignment.
     * @param value Value to set for the resource property.
     */
    set resource(value) {
        this._resource = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeBooleanValue("distributeForStudentWork", this.distributeForStudentWork);
        writer.writeObjectValue("resource", this.resource);
    }
    ;
}
exports.EducationAssignmentResource = EducationAssignmentResource;
