import { Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class EducationCategory extends Entity implements Parsable {
    /** Unique identifier for the category.  */
    private _displayName?;
    /**
     * Instantiates a new educationCategory and sets the default values.
     */
    constructor();
    /**
     * Gets the displayName property value. Unique identifier for the category.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. Unique identifier for the category.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
