import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class EducationCourse implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Unique identifier for the course.  */
    private _courseNumber?;
    /** Description of the course.  */
    private _description?;
    /** Name of the course.  */
    private _displayName?;
    /** ID of the course from the syncing system.  */
    private _externalId?;
    /** Subject of the course.  */
    private _subject?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new educationCourse and sets the default values.
     */
    constructor();
    /**
     * Gets the courseNumber property value. Unique identifier for the course.
     * @returns a string
     */
    get courseNumber(): string | undefined;
    /**
     * Sets the courseNumber property value. Unique identifier for the course.
     * @param value Value to set for the courseNumber property.
     */
    set courseNumber(value: string | undefined);
    /**
     * Gets the description property value. Description of the course.
     * @returns a string
     */
    get description(): string | undefined;
    /**
     * Sets the description property value. Description of the course.
     * @param value Value to set for the description property.
     */
    set description(value: string | undefined);
    /**
     * Gets the displayName property value. Name of the course.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. Name of the course.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * Gets the externalId property value. ID of the course from the syncing system.
     * @returns a string
     */
    get externalId(): string | undefined;
    /**
     * Sets the externalId property value. ID of the course from the syncing system.
     * @param value Value to set for the externalId property.
     */
    set externalId(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the subject property value. Subject of the course.
     * @returns a string
     */
    get subject(): string | undefined;
    /**
     * Sets the subject property value. Subject of the course.
     * @param value Value to set for the subject property.
     */
    set subject(value: string | undefined);
}
