import { EducationExternalSource } from './educationExternalSource';
import { Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class EducationOrganization extends Entity implements Parsable {
    /** Organization description.  */
    private _description?;
    /** Organization display name.  */
    private _displayName?;
    /** Source where this organization was created from. Possible values are: sis, manual.  */
    private _externalSource?;
    /** The name of the external source this resources was generated from.  */
    private _externalSourceDetail?;
    /**
     * Instantiates a new educationOrganization and sets the default values.
     */
    constructor();
    /**
     * Gets the description property value. Organization description.
     * @returns a string
     */
    get description(): string | undefined;
    /**
     * Sets the description property value. Organization description.
     * @param value Value to set for the description property.
     */
    set description(value: string | undefined);
    /**
     * Gets the displayName property value. Organization display name.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. Organization display name.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * Gets the externalSource property value. Source where this organization was created from. Possible values are: sis, manual.
     * @returns a educationExternalSource
     */
    get externalSource(): EducationExternalSource | undefined;
    /**
     * Sets the externalSource property value. Source where this organization was created from. Possible values are: sis, manual.
     * @param value Value to set for the externalSource property.
     */
    set externalSource(value: EducationExternalSource | undefined);
    /**
     * Gets the externalSourceDetail property value. The name of the external source this resources was generated from.
     * @returns a string
     */
    get externalSourceDetail(): string | undefined;
    /**
     * Sets the externalSourceDetail property value. The name of the external source this resources was generated from.
     * @param value Value to set for the externalSourceDetail property.
     */
    set externalSourceDetail(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
