"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EducationOrganization = void 0;
const educationExternalSource_1 = require("./educationExternalSource");
const index_1 = require("./index");
class EducationOrganization extends index_1.Entity {
    /**
     * Instantiates a new educationOrganization and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the description property value. Organization description.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. Organization description.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the displayName property value. Organization display name.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. Organization display name.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * Gets the externalSource property value. Source where this organization was created from. Possible values are: sis, manual.
     * @returns a educationExternalSource
     */
    get externalSource() {
        return this._externalSource;
    }
    ;
    /**
     * Sets the externalSource property value. Source where this organization was created from. Possible values are: sis, manual.
     * @param value Value to set for the externalSource property.
     */
    set externalSource(value) {
        this._externalSource = value;
    }
    ;
    /**
     * Gets the externalSourceDetail property value. The name of the external source this resources was generated from.
     * @returns a string
     */
    get externalSourceDetail() {
        return this._externalSourceDetail;
    }
    ;
    /**
     * Sets the externalSourceDetail property value. The name of the external source this resources was generated from.
     * @param value Value to set for the externalSourceDetail property.
     */
    set externalSourceDetail(value) {
        this._externalSourceDetail = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "description": (o, n) => { o.description = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "externalSource": (o, n) => { o.externalSource = n.getEnumValue(educationExternalSource_1.EducationExternalSource); }, "externalSourceDetail": (o, n) => { o.externalSourceDetail = n.getStringValue(); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("description", this.description);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeEnumValue("externalSource", this.externalSource);
        writer.writeStringValue("externalSourceDetail", this.externalSourceDetail);
    }
    ;
}
exports.EducationOrganization = EducationOrganization;
