"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EducationOutcome = void 0;
const createIdentitySetFromDiscriminatorValue_1 = require("./createIdentitySetFromDiscriminatorValue");
const index_1 = require("./index");
class EducationOutcome extends index_1.Entity {
    /**
     * Instantiates a new educationOutcome and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "lastModifiedBy": (o, n) => { o.lastModifiedBy = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); }, "lastModifiedDateTime": (o, n) => { o.lastModifiedDateTime = n.getDateValue(); } });
    }
    ;
    /**
     * Gets the lastModifiedBy property value. The individual who updated the resource.
     * @returns a identitySet
     */
    get lastModifiedBy() {
        return this._lastModifiedBy;
    }
    ;
    /**
     * Sets the lastModifiedBy property value. The individual who updated the resource.
     * @param value Value to set for the lastModifiedBy property.
     */
    set lastModifiedBy(value) {
        this._lastModifiedBy = value;
    }
    ;
    /**
     * Gets the lastModifiedDateTime property value. Moment in time when the resource was last modified.  The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2021 is 2021-01-01T00:00:00Z.
     * @returns a Date
     */
    get lastModifiedDateTime() {
        return this._lastModifiedDateTime;
    }
    ;
    /**
     * Sets the lastModifiedDateTime property value. Moment in time when the resource was last modified.  The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2021 is 2021-01-01T00:00:00Z.
     * @param value Value to set for the lastModifiedDateTime property.
     */
    set lastModifiedDateTime(value) {
        this._lastModifiedDateTime = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("lastModifiedBy", this.lastModifiedBy);
        writer.writeDateValue("lastModifiedDateTime", this.lastModifiedDateTime);
    }
    ;
}
exports.EducationOutcome = EducationOutcome;
