import { EducationClass, EducationSchool, EducationUser } from './index';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class EducationRoot implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _classes?;
    private _me?;
    private _schools?;
    private _users?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the classes property value.
     * @returns a educationClass
     */
    get classes(): EducationClass[] | undefined;
    /**
     * Sets the classes property value.
     * @param value Value to set for the classes property.
     */
    set classes(value: EducationClass[] | undefined);
    /**
     * Instantiates a new EducationRoot and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the me property value.
     * @returns a educationUser
     */
    get me(): EducationUser | undefined;
    /**
     * Sets the me property value.
     * @param value Value to set for the me property.
     */
    set me(value: EducationUser | undefined);
    /**
     * Gets the schools property value.
     * @returns a educationSchool
     */
    get schools(): EducationSchool[] | undefined;
    /**
     * Sets the schools property value.
     * @param value Value to set for the schools property.
     */
    set schools(value: EducationSchool[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the users property value.
     * @returns a educationUser
     */
    get users(): EducationUser[] | undefined;
    /**
     * Sets the users property value.
     * @param value Value to set for the users property.
     */
    set users(value: EducationUser[] | undefined);
}
