"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EducationRoot = void 0;
const createEducationClassFromDiscriminatorValue_1 = require("./createEducationClassFromDiscriminatorValue");
const createEducationSchoolFromDiscriminatorValue_1 = require("./createEducationSchoolFromDiscriminatorValue");
const createEducationUserFromDiscriminatorValue_1 = require("./createEducationUserFromDiscriminatorValue");
class EducationRoot {
    /**
     * Instantiates a new EducationRoot and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the classes property value.
     * @returns a educationClass
     */
    get classes() {
        return this._classes;
    }
    ;
    /**
     * Sets the classes property value.
     * @param value Value to set for the classes property.
     */
    set classes(value) {
        this._classes = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "classes": (o, n) => { o.classes = n.getCollectionOfObjectValues(createEducationClassFromDiscriminatorValue_1.createEducationClassFromDiscriminatorValue); },
            "me": (o, n) => { o.me = n.getObjectValue(createEducationUserFromDiscriminatorValue_1.createEducationUserFromDiscriminatorValue); },
            "schools": (o, n) => { o.schools = n.getCollectionOfObjectValues(createEducationSchoolFromDiscriminatorValue_1.createEducationSchoolFromDiscriminatorValue); },
            "users": (o, n) => { o.users = n.getCollectionOfObjectValues(createEducationUserFromDiscriminatorValue_1.createEducationUserFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the me property value.
     * @returns a educationUser
     */
    get me() {
        return this._me;
    }
    ;
    /**
     * Sets the me property value.
     * @param value Value to set for the me property.
     */
    set me(value) {
        this._me = value;
    }
    ;
    /**
     * Gets the schools property value.
     * @returns a educationSchool
     */
    get schools() {
        return this._schools;
    }
    ;
    /**
     * Sets the schools property value.
     * @param value Value to set for the schools property.
     */
    set schools(value) {
        this._schools = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfObjectValues("classes", this.classes);
        writer.writeObjectValue("me", this.me);
        writer.writeCollectionOfObjectValues("schools", this.schools);
        writer.writeCollectionOfObjectValues("users", this.users);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the users property value.
     * @returns a educationUser
     */
    get users() {
        return this._users;
    }
    ;
    /**
     * Sets the users property value.
     * @param value Value to set for the users property.
     */
    set users(value) {
        this._users = value;
    }
    ;
}
exports.EducationRoot = EducationRoot;
