"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EducationSchool = void 0;
const createAdministrativeUnitFromDiscriminatorValue_1 = require("./createAdministrativeUnitFromDiscriminatorValue");
const createEducationClassFromDiscriminatorValue_1 = require("./createEducationClassFromDiscriminatorValue");
const createEducationUserFromDiscriminatorValue_1 = require("./createEducationUserFromDiscriminatorValue");
const createIdentitySetFromDiscriminatorValue_1 = require("./createIdentitySetFromDiscriminatorValue");
const createPhysicalAddressFromDiscriminatorValue_1 = require("./createPhysicalAddressFromDiscriminatorValue");
const index_1 = require("./index");
class EducationSchool extends index_1.EducationOrganization {
    /**
     * Instantiates a new educationSchool and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the address property value. Address of the school.
     * @returns a physicalAddress
     */
    get address() {
        return this._address;
    }
    ;
    /**
     * Sets the address property value. Address of the school.
     * @param value Value to set for the address property.
     */
    set address(value) {
        this._address = value;
    }
    ;
    /**
     * Gets the administrativeUnit property value. The underlying administrativeUnit for this school.
     * @returns a administrativeUnit
     */
    get administrativeUnit() {
        return this._administrativeUnit;
    }
    ;
    /**
     * Sets the administrativeUnit property value. The underlying administrativeUnit for this school.
     * @param value Value to set for the administrativeUnit property.
     */
    set administrativeUnit(value) {
        this._administrativeUnit = value;
    }
    ;
    /**
     * Gets the classes property value. Classes taught at the school. Nullable.
     * @returns a educationClass
     */
    get classes() {
        return this._classes;
    }
    ;
    /**
     * Sets the classes property value. Classes taught at the school. Nullable.
     * @param value Value to set for the classes property.
     */
    set classes(value) {
        this._classes = value;
    }
    ;
    ;
    /**
     * Gets the createdBy property value. Entity who created the school.
     * @returns a identitySet
     */
    get createdBy() {
        return this._createdBy;
    }
    ;
    /**
     * Sets the createdBy property value. Entity who created the school.
     * @param value Value to set for the createdBy property.
     */
    set createdBy(value) {
        this._createdBy = value;
    }
    ;
    /**
     * Gets the externalId property value. ID of school in syncing system.
     * @returns a string
     */
    get externalId() {
        return this._externalId;
    }
    ;
    /**
     * Sets the externalId property value. ID of school in syncing system.
     * @param value Value to set for the externalId property.
     */
    set externalId(value) {
        this._externalId = value;
    }
    ;
    /**
     * Gets the externalPrincipalId property value. ID of principal in syncing system.
     * @returns a string
     */
    get externalPrincipalId() {
        return this._externalPrincipalId;
    }
    ;
    /**
     * Sets the externalPrincipalId property value. ID of principal in syncing system.
     * @param value Value to set for the externalPrincipalId property.
     */
    set externalPrincipalId(value) {
        this._externalPrincipalId = value;
    }
    ;
    /**
     * Gets the fax property value.
     * @returns a string
     */
    get fax() {
        return this._fax;
    }
    ;
    /**
     * Sets the fax property value.
     * @param value Value to set for the fax property.
     */
    set fax(value) {
        this._fax = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "address": (o, n) => { o.address = n.getObjectValue(createPhysicalAddressFromDiscriminatorValue_1.createPhysicalAddressFromDiscriminatorValue); }, "administrativeUnit": (o, n) => { o.administrativeUnit = n.getObjectValue(createAdministrativeUnitFromDiscriminatorValue_1.createAdministrativeUnitFromDiscriminatorValue); }, "classes": (o, n) => { o.classes = n.getCollectionOfObjectValues(createEducationClassFromDiscriminatorValue_1.createEducationClassFromDiscriminatorValue); }, "createdBy": (o, n) => { o.createdBy = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); }, "externalId": (o, n) => { o.externalId = n.getStringValue(); }, "externalPrincipalId": (o, n) => { o.externalPrincipalId = n.getStringValue(); }, "fax": (o, n) => { o.fax = n.getStringValue(); }, "highestGrade": (o, n) => { o.highestGrade = n.getStringValue(); }, "lowestGrade": (o, n) => { o.lowestGrade = n.getStringValue(); }, "phone": (o, n) => { o.phone = n.getStringValue(); }, "principalEmail": (o, n) => { o.principalEmail = n.getStringValue(); }, "principalName": (o, n) => { o.principalName = n.getStringValue(); }, "schoolNumber": (o, n) => { o.schoolNumber = n.getStringValue(); }, "users": (o, n) => { o.users = n.getCollectionOfObjectValues(createEducationUserFromDiscriminatorValue_1.createEducationUserFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the highestGrade property value. Highest grade taught.
     * @returns a string
     */
    get highestGrade() {
        return this._highestGrade;
    }
    ;
    /**
     * Sets the highestGrade property value. Highest grade taught.
     * @param value Value to set for the highestGrade property.
     */
    set highestGrade(value) {
        this._highestGrade = value;
    }
    ;
    /**
     * Gets the lowestGrade property value. Lowest grade taught.
     * @returns a string
     */
    get lowestGrade() {
        return this._lowestGrade;
    }
    ;
    /**
     * Sets the lowestGrade property value. Lowest grade taught.
     * @param value Value to set for the lowestGrade property.
     */
    set lowestGrade(value) {
        this._lowestGrade = value;
    }
    ;
    /**
     * Gets the phone property value. Phone number of school.
     * @returns a string
     */
    get phone() {
        return this._phone;
    }
    ;
    /**
     * Sets the phone property value. Phone number of school.
     * @param value Value to set for the phone property.
     */
    set phone(value) {
        this._phone = value;
    }
    ;
    /**
     * Gets the principalEmail property value. Email address of the principal.
     * @returns a string
     */
    get principalEmail() {
        return this._principalEmail;
    }
    ;
    /**
     * Sets the principalEmail property value. Email address of the principal.
     * @param value Value to set for the principalEmail property.
     */
    set principalEmail(value) {
        this._principalEmail = value;
    }
    ;
    /**
     * Gets the principalName property value. Name of the principal.
     * @returns a string
     */
    get principalName() {
        return this._principalName;
    }
    ;
    /**
     * Sets the principalName property value. Name of the principal.
     * @param value Value to set for the principalName property.
     */
    set principalName(value) {
        this._principalName = value;
    }
    ;
    /**
     * Gets the schoolNumber property value. School Number.
     * @returns a string
     */
    get schoolNumber() {
        return this._schoolNumber;
    }
    ;
    /**
     * Sets the schoolNumber property value. School Number.
     * @param value Value to set for the schoolNumber property.
     */
    set schoolNumber(value) {
        this._schoolNumber = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("address", this.address);
        writer.writeObjectValue("administrativeUnit", this.administrativeUnit);
        writer.writeCollectionOfObjectValues("classes", this.classes);
        writer.writeObjectValue("createdBy", this.createdBy);
        writer.writeStringValue("externalId", this.externalId);
        writer.writeStringValue("externalPrincipalId", this.externalPrincipalId);
        writer.writeStringValue("fax", this.fax);
        writer.writeStringValue("highestGrade", this.highestGrade);
        writer.writeStringValue("lowestGrade", this.lowestGrade);
        writer.writeStringValue("phone", this.phone);
        writer.writeStringValue("principalEmail", this.principalEmail);
        writer.writeStringValue("principalName", this.principalName);
        writer.writeStringValue("schoolNumber", this.schoolNumber);
        writer.writeCollectionOfObjectValues("users", this.users);
    }
    ;
    /**
     * Gets the users property value. Users in the school. Nullable.
     * @returns a educationUser
     */
    get users() {
        return this._users;
    }
    ;
    /**
     * Sets the users property value. Users in the school. Nullable.
     * @param value Value to set for the users property.
     */
    set users(value) {
        this._users = value;
    }
    ;
}
exports.EducationSchool = EducationSchool;
