"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EducationSubmission = void 0;
const createEducationOutcomeFromDiscriminatorValue_1 = require("./createEducationOutcomeFromDiscriminatorValue");
const createEducationSubmissionRecipientFromDiscriminatorValue_1 = require("./createEducationSubmissionRecipientFromDiscriminatorValue");
const createEducationSubmissionResourceFromDiscriminatorValue_1 = require("./createEducationSubmissionResourceFromDiscriminatorValue");
const createIdentitySetFromDiscriminatorValue_1 = require("./createIdentitySetFromDiscriminatorValue");
const educationSubmissionStatus_1 = require("./educationSubmissionStatus");
const index_1 = require("./index");
class EducationSubmission extends index_1.Entity {
    /**
     * Instantiates a new educationSubmission and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "outcomes": (o, n) => { o.outcomes = n.getCollectionOfObjectValues(createEducationOutcomeFromDiscriminatorValue_1.createEducationOutcomeFromDiscriminatorValue); }, "reassignedBy": (o, n) => { o.reassignedBy = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); }, "reassignedDateTime": (o, n) => { o.reassignedDateTime = n.getDateValue(); }, "recipient": (o, n) => { o.recipient = n.getObjectValue(createEducationSubmissionRecipientFromDiscriminatorValue_1.createEducationSubmissionRecipientFromDiscriminatorValue); }, "resources": (o, n) => { o.resources = n.getCollectionOfObjectValues(createEducationSubmissionResourceFromDiscriminatorValue_1.createEducationSubmissionResourceFromDiscriminatorValue); }, "resourcesFolderUrl": (o, n) => { o.resourcesFolderUrl = n.getStringValue(); }, "returnedBy": (o, n) => { o.returnedBy = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); }, "returnedDateTime": (o, n) => { o.returnedDateTime = n.getDateValue(); }, "status": (o, n) => { o.status = n.getEnumValue(educationSubmissionStatus_1.EducationSubmissionStatus); }, "submittedBy": (o, n) => { o.submittedBy = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); }, "submittedDateTime": (o, n) => { o.submittedDateTime = n.getDateValue(); }, "submittedResources": (o, n) => { o.submittedResources = n.getCollectionOfObjectValues(createEducationSubmissionResourceFromDiscriminatorValue_1.createEducationSubmissionResourceFromDiscriminatorValue); }, "unsubmittedBy": (o, n) => { o.unsubmittedBy = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); }, "unsubmittedDateTime": (o, n) => { o.unsubmittedDateTime = n.getDateValue(); } });
    }
    ;
    /**
     * Gets the outcomes property value. Read-Write. Nullable.
     * @returns a educationOutcome
     */
    get outcomes() {
        return this._outcomes;
    }
    ;
    /**
     * Sets the outcomes property value. Read-Write. Nullable.
     * @param value Value to set for the outcomes property.
     */
    set outcomes(value) {
        this._outcomes = value;
    }
    ;
    /**
     * Gets the reassignedBy property value. User who moved the status of this submission to reassigned.
     * @returns a identitySet
     */
    get reassignedBy() {
        return this._reassignedBy;
    }
    ;
    /**
     * Sets the reassignedBy property value. User who moved the status of this submission to reassigned.
     * @param value Value to set for the reassignedBy property.
     */
    set reassignedBy(value) {
        this._reassignedBy = value;
    }
    ;
    /**
     * Gets the reassignedDateTime property value. Moment in time when the submission was reassigned. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @returns a Date
     */
    get reassignedDateTime() {
        return this._reassignedDateTime;
    }
    ;
    /**
     * Sets the reassignedDateTime property value. Moment in time when the submission was reassigned. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @param value Value to set for the reassignedDateTime property.
     */
    set reassignedDateTime(value) {
        this._reassignedDateTime = value;
    }
    ;
    /**
     * Gets the recipient property value. Who this submission is assigned to.
     * @returns a educationSubmissionRecipient
     */
    get recipient() {
        return this._recipient;
    }
    ;
    /**
     * Sets the recipient property value. Who this submission is assigned to.
     * @param value Value to set for the recipient property.
     */
    set recipient(value) {
        this._recipient = value;
    }
    ;
    /**
     * Gets the resources property value. Nullable.
     * @returns a educationSubmissionResource
     */
    get resources() {
        return this._resources;
    }
    ;
    /**
     * Sets the resources property value. Nullable.
     * @param value Value to set for the resources property.
     */
    set resources(value) {
        this._resources = value;
    }
    ;
    /**
     * Gets the resourcesFolderUrl property value. Folder where all file resources for this submission need to be stored.
     * @returns a string
     */
    get resourcesFolderUrl() {
        return this._resourcesFolderUrl;
    }
    ;
    /**
     * Sets the resourcesFolderUrl property value. Folder where all file resources for this submission need to be stored.
     * @param value Value to set for the resourcesFolderUrl property.
     */
    set resourcesFolderUrl(value) {
        this._resourcesFolderUrl = value;
    }
    ;
    /**
     * Gets the returnedBy property value. User who moved the status of this submission to returned.
     * @returns a identitySet
     */
    get returnedBy() {
        return this._returnedBy;
    }
    ;
    /**
     * Sets the returnedBy property value. User who moved the status of this submission to returned.
     * @param value Value to set for the returnedBy property.
     */
    set returnedBy(value) {
        this._returnedBy = value;
    }
    ;
    /**
     * Gets the returnedDateTime property value. Moment in time when the submission was returned. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @returns a Date
     */
    get returnedDateTime() {
        return this._returnedDateTime;
    }
    ;
    /**
     * Sets the returnedDateTime property value. Moment in time when the submission was returned. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @param value Value to set for the returnedDateTime property.
     */
    set returnedDateTime(value) {
        this._returnedDateTime = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("outcomes", this.outcomes);
        writer.writeObjectValue("reassignedBy", this.reassignedBy);
        writer.writeDateValue("reassignedDateTime", this.reassignedDateTime);
        writer.writeObjectValue("recipient", this.recipient);
        writer.writeCollectionOfObjectValues("resources", this.resources);
        writer.writeStringValue("resourcesFolderUrl", this.resourcesFolderUrl);
        writer.writeObjectValue("returnedBy", this.returnedBy);
        writer.writeDateValue("returnedDateTime", this.returnedDateTime);
        writer.writeEnumValue("status", this.status);
        writer.writeObjectValue("submittedBy", this.submittedBy);
        writer.writeDateValue("submittedDateTime", this.submittedDateTime);
        writer.writeCollectionOfObjectValues("submittedResources", this.submittedResources);
        writer.writeObjectValue("unsubmittedBy", this.unsubmittedBy);
        writer.writeDateValue("unsubmittedDateTime", this.unsubmittedDateTime);
    }
    ;
    /**
     * Gets the status property value. Read-only. Possible values are: working, submitted, released, returned, and reassigned. Note that you must use the Prefer: include-unknown-enum-members request header to get the following value(s) in this evolvable enum: reassigned.
     * @returns a educationSubmissionStatus
     */
    get status() {
        return this._status;
    }
    ;
    /**
     * Sets the status property value. Read-only. Possible values are: working, submitted, released, returned, and reassigned. Note that you must use the Prefer: include-unknown-enum-members request header to get the following value(s) in this evolvable enum: reassigned.
     * @param value Value to set for the status property.
     */
    set status(value) {
        this._status = value;
    }
    ;
    /**
     * Gets the submittedBy property value. User who moved the resource into the submitted state.
     * @returns a identitySet
     */
    get submittedBy() {
        return this._submittedBy;
    }
    ;
    /**
     * Sets the submittedBy property value. User who moved the resource into the submitted state.
     * @param value Value to set for the submittedBy property.
     */
    set submittedBy(value) {
        this._submittedBy = value;
    }
    ;
    /**
     * Gets the submittedDateTime property value. Moment in time when the submission was moved into the submitted state. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @returns a Date
     */
    get submittedDateTime() {
        return this._submittedDateTime;
    }
    ;
    /**
     * Sets the submittedDateTime property value. Moment in time when the submission was moved into the submitted state. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @param value Value to set for the submittedDateTime property.
     */
    set submittedDateTime(value) {
        this._submittedDateTime = value;
    }
    ;
    /**
     * Gets the submittedResources property value. Read-only. Nullable.
     * @returns a educationSubmissionResource
     */
    get submittedResources() {
        return this._submittedResources;
    }
    ;
    /**
     * Sets the submittedResources property value. Read-only. Nullable.
     * @param value Value to set for the submittedResources property.
     */
    set submittedResources(value) {
        this._submittedResources = value;
    }
    ;
    /**
     * Gets the unsubmittedBy property value. User who moved the resource from submitted into the working state.
     * @returns a identitySet
     */
    get unsubmittedBy() {
        return this._unsubmittedBy;
    }
    ;
    /**
     * Sets the unsubmittedBy property value. User who moved the resource from submitted into the working state.
     * @param value Value to set for the unsubmittedBy property.
     */
    set unsubmittedBy(value) {
        this._unsubmittedBy = value;
    }
    ;
    /**
     * Gets the unsubmittedDateTime property value. Moment in time when the submission was moved from submitted into the working state. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @returns a Date
     */
    get unsubmittedDateTime() {
        return this._unsubmittedDateTime;
    }
    ;
    /**
     * Sets the unsubmittedDateTime property value. Moment in time when the submission was moved from submitted into the working state. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @param value Value to set for the unsubmittedDateTime property.
     */
    set unsubmittedDateTime(value) {
        this._unsubmittedDateTime = value;
    }
    ;
}
exports.EducationSubmission = EducationSubmission;
