"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EducationSubmissionResource = void 0;
const createEducationResourceFromDiscriminatorValue_1 = require("./createEducationResourceFromDiscriminatorValue");
const index_1 = require("./index");
class EducationSubmissionResource extends index_1.Entity {
    /**
     * Instantiates a new educationSubmissionResource and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the assignmentResourceUrl property value. Pointer to the assignment from which this resource was copied. If this is null, the student uploaded the resource.
     * @returns a string
     */
    get assignmentResourceUrl() {
        return this._assignmentResourceUrl;
    }
    ;
    /**
     * Sets the assignmentResourceUrl property value. Pointer to the assignment from which this resource was copied. If this is null, the student uploaded the resource.
     * @param value Value to set for the assignmentResourceUrl property.
     */
    set assignmentResourceUrl(value) {
        this._assignmentResourceUrl = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "assignmentResourceUrl": (o, n) => { o.assignmentResourceUrl = n.getStringValue(); }, "resource": (o, n) => { o.resource = n.getObjectValue(createEducationResourceFromDiscriminatorValue_1.createEducationResourceFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the resource property value. Resource object.
     * @returns a educationResource
     */
    get resource() {
        return this._resource;
    }
    ;
    /**
     * Sets the resource property value. Resource object.
     * @param value Value to set for the resource property.
     */
    set resource(value) {
        this._resource = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("assignmentResourceUrl", this.assignmentResourceUrl);
        writer.writeObjectValue("resource", this.resource);
    }
    ;
}
exports.EducationSubmissionResource = EducationSubmissionResource;
