import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class EducationTeacher implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** ID of the teacher in the source system.  */
    private _externalId?;
    /** Teacher number.  */
    private _teacherNumber?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new educationTeacher and sets the default values.
     */
    constructor();
    /**
     * Gets the externalId property value. ID of the teacher in the source system.
     * @returns a string
     */
    get externalId(): string | undefined;
    /**
     * Sets the externalId property value. ID of the teacher in the source system.
     * @param value Value to set for the externalId property.
     */
    set externalId(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the teacherNumber property value. Teacher number.
     * @returns a string
     */
    get teacherNumber(): string | undefined;
    /**
     * Sets the teacherNumber property value. Teacher number.
     * @param value Value to set for the teacherNumber property.
     */
    set teacherNumber(value: string | undefined);
}
