"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EducationTeacher = void 0;
class EducationTeacher {
    /**
     * Instantiates a new educationTeacher and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the externalId property value. ID of the teacher in the source system.
     * @returns a string
     */
    get externalId() {
        return this._externalId;
    }
    ;
    /**
     * Sets the externalId property value. ID of the teacher in the source system.
     * @param value Value to set for the externalId property.
     */
    set externalId(value) {
        this._externalId = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "externalId": (o, n) => { o.externalId = n.getStringValue(); },
            "teacherNumber": (o, n) => { o.teacherNumber = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("externalId", this.externalId);
        writer.writeStringValue("teacherNumber", this.teacherNumber);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the teacherNumber property value. Teacher number.
     * @returns a string
     */
    get teacherNumber() {
        return this._teacherNumber;
    }
    ;
    /**
     * Sets the teacherNumber property value. Teacher number.
     * @param value Value to set for the teacherNumber property.
     */
    set teacherNumber(value) {
        this._teacherNumber = value;
    }
    ;
}
exports.EducationTeacher = EducationTeacher;
