import { AdditionalDataHolder, DateOnly, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class EducationTerm implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Display name of the term.  */
    private _displayName?;
    /** End of the term.  */
    private _endDate?;
    /** ID of term in the syncing system.  */
    private _externalId?;
    /** Start of the term.  */
    private _startDate?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new educationTerm and sets the default values.
     */
    constructor();
    /**
     * Gets the displayName property value. Display name of the term.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. Display name of the term.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * Gets the endDate property value. End of the term.
     * @returns a DateOnly
     */
    get endDate(): DateOnly | undefined;
    /**
     * Sets the endDate property value. End of the term.
     * @param value Value to set for the endDate property.
     */
    set endDate(value: DateOnly | undefined);
    /**
     * Gets the externalId property value. ID of term in the syncing system.
     * @returns a string
     */
    get externalId(): string | undefined;
    /**
     * Sets the externalId property value. ID of term in the syncing system.
     * @param value Value to set for the externalId property.
     */
    set externalId(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the startDate property value. Start of the term.
     * @returns a DateOnly
     */
    get startDate(): DateOnly | undefined;
    /**
     * Sets the startDate property value. Start of the term.
     * @param value Value to set for the startDate property.
     */
    set startDate(value: DateOnly | undefined);
}
