"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EducationUser = void 0;
const createAssignedLicenseFromDiscriminatorValue_1 = require("./createAssignedLicenseFromDiscriminatorValue");
const createAssignedPlanFromDiscriminatorValue_1 = require("./createAssignedPlanFromDiscriminatorValue");
const createEducationAssignmentFromDiscriminatorValue_1 = require("./createEducationAssignmentFromDiscriminatorValue");
const createEducationClassFromDiscriminatorValue_1 = require("./createEducationClassFromDiscriminatorValue");
const createEducationOnPremisesInfoFromDiscriminatorValue_1 = require("./createEducationOnPremisesInfoFromDiscriminatorValue");
const createEducationRubricFromDiscriminatorValue_1 = require("./createEducationRubricFromDiscriminatorValue");
const createEducationSchoolFromDiscriminatorValue_1 = require("./createEducationSchoolFromDiscriminatorValue");
const createEducationStudentFromDiscriminatorValue_1 = require("./createEducationStudentFromDiscriminatorValue");
const createEducationTeacherFromDiscriminatorValue_1 = require("./createEducationTeacherFromDiscriminatorValue");
const createIdentitySetFromDiscriminatorValue_1 = require("./createIdentitySetFromDiscriminatorValue");
const createPasswordProfileFromDiscriminatorValue_1 = require("./createPasswordProfileFromDiscriminatorValue");
const createPhysicalAddressFromDiscriminatorValue_1 = require("./createPhysicalAddressFromDiscriminatorValue");
const createProvisionedPlanFromDiscriminatorValue_1 = require("./createProvisionedPlanFromDiscriminatorValue");
const createRelatedContactFromDiscriminatorValue_1 = require("./createRelatedContactFromDiscriminatorValue");
const createUserFromDiscriminatorValue_1 = require("./createUserFromDiscriminatorValue");
const educationExternalSource_1 = require("./educationExternalSource");
const educationUserRole_1 = require("./educationUserRole");
const index_1 = require("./index");
class EducationUser extends index_1.Entity {
    /**
     * Instantiates a new educationUser and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the accountEnabled property value. True if the account is enabled; otherwise, false. This property is required when a user is created. Supports $filter.
     * @returns a boolean
     */
    get accountEnabled() {
        return this._accountEnabled;
    }
    ;
    /**
     * Sets the accountEnabled property value. True if the account is enabled; otherwise, false. This property is required when a user is created. Supports $filter.
     * @param value Value to set for the accountEnabled property.
     */
    set accountEnabled(value) {
        this._accountEnabled = value;
    }
    ;
    /**
     * Gets the assignedLicenses property value. The licenses that are assigned to the user. Not nullable.
     * @returns a assignedLicense
     */
    get assignedLicenses() {
        return this._assignedLicenses;
    }
    ;
    /**
     * Sets the assignedLicenses property value. The licenses that are assigned to the user. Not nullable.
     * @param value Value to set for the assignedLicenses property.
     */
    set assignedLicenses(value) {
        this._assignedLicenses = value;
    }
    ;
    /**
     * Gets the assignedPlans property value. The plans that are assigned to the user. Read-only. Not nullable.
     * @returns a assignedPlan
     */
    get assignedPlans() {
        return this._assignedPlans;
    }
    ;
    /**
     * Sets the assignedPlans property value. The plans that are assigned to the user. Read-only. Not nullable.
     * @param value Value to set for the assignedPlans property.
     */
    set assignedPlans(value) {
        this._assignedPlans = value;
    }
    ;
    /**
     * Gets the assignments property value. Assignments belonging to the user.
     * @returns a educationAssignment
     */
    get assignments() {
        return this._assignments;
    }
    ;
    /**
     * Sets the assignments property value. Assignments belonging to the user.
     * @param value Value to set for the assignments property.
     */
    set assignments(value) {
        this._assignments = value;
    }
    ;
    /**
     * Gets the businessPhones property value. The telephone numbers for the user. Note: Although this is a string collection, only one number can be set for this property.
     * @returns a string
     */
    get businessPhones() {
        return this._businessPhones;
    }
    ;
    /**
     * Sets the businessPhones property value. The telephone numbers for the user. Note: Although this is a string collection, only one number can be set for this property.
     * @param value Value to set for the businessPhones property.
     */
    set businessPhones(value) {
        this._businessPhones = value;
    }
    ;
    /**
     * Gets the classes property value. Classes to which the user belongs. Nullable.
     * @returns a educationClass
     */
    get classes() {
        return this._classes;
    }
    ;
    /**
     * Sets the classes property value. Classes to which the user belongs. Nullable.
     * @param value Value to set for the classes property.
     */
    set classes(value) {
        this._classes = value;
    }
    ;
    ;
    /**
     * Gets the createdBy property value. Entity who created the user.
     * @returns a identitySet
     */
    get createdBy() {
        return this._createdBy;
    }
    ;
    /**
     * Sets the createdBy property value. Entity who created the user.
     * @param value Value to set for the createdBy property.
     */
    set createdBy(value) {
        this._createdBy = value;
    }
    ;
    /**
     * Gets the department property value. The name for the department in which the user works. Supports $filter.
     * @returns a string
     */
    get department() {
        return this._department;
    }
    ;
    /**
     * Sets the department property value. The name for the department in which the user works. Supports $filter.
     * @param value Value to set for the department property.
     */
    set department(value) {
        this._department = value;
    }
    ;
    /**
     * Gets the displayName property value. The name displayed in the address book for the user. This is usually the combination of the user's first name, middle initial, and last name. This property is required when a user is created and it cannot be cleared during updates. Supports $filter and $orderby.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The name displayed in the address book for the user. This is usually the combination of the user's first name, middle initial, and last name. This property is required when a user is created and it cannot be cleared during updates. Supports $filter and $orderby.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * Gets the externalSource property value. Where this user was created from. Possible values are: sis, manual.
     * @returns a educationExternalSource
     */
    get externalSource() {
        return this._externalSource;
    }
    ;
    /**
     * Sets the externalSource property value. Where this user was created from. Possible values are: sis, manual.
     * @param value Value to set for the externalSource property.
     */
    set externalSource(value) {
        this._externalSource = value;
    }
    ;
    /**
     * Gets the externalSourceDetail property value. The name of the external source this resources was generated from.
     * @returns a string
     */
    get externalSourceDetail() {
        return this._externalSourceDetail;
    }
    ;
    /**
     * Sets the externalSourceDetail property value. The name of the external source this resources was generated from.
     * @param value Value to set for the externalSourceDetail property.
     */
    set externalSourceDetail(value) {
        this._externalSourceDetail = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "accountEnabled": (o, n) => { o.accountEnabled = n.getBooleanValue(); }, "assignedLicenses": (o, n) => { o.assignedLicenses = n.getCollectionOfObjectValues(createAssignedLicenseFromDiscriminatorValue_1.createAssignedLicenseFromDiscriminatorValue); }, "assignedPlans": (o, n) => { o.assignedPlans = n.getCollectionOfObjectValues(createAssignedPlanFromDiscriminatorValue_1.createAssignedPlanFromDiscriminatorValue); }, "assignments": (o, n) => { o.assignments = n.getCollectionOfObjectValues(createEducationAssignmentFromDiscriminatorValue_1.createEducationAssignmentFromDiscriminatorValue); }, "businessPhones": (o, n) => { o.businessPhones = n.getCollectionOfPrimitiveValues(); }, "classes": (o, n) => { o.classes = n.getCollectionOfObjectValues(createEducationClassFromDiscriminatorValue_1.createEducationClassFromDiscriminatorValue); }, "createdBy": (o, n) => { o.createdBy = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); }, "department": (o, n) => { o.department = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "externalSource": (o, n) => { o.externalSource = n.getEnumValue(educationExternalSource_1.EducationExternalSource); }, "externalSourceDetail": (o, n) => { o.externalSourceDetail = n.getStringValue(); }, "givenName": (o, n) => { o.givenName = n.getStringValue(); }, "mail": (o, n) => { o.mail = n.getStringValue(); }, "mailingAddress": (o, n) => { o.mailingAddress = n.getObjectValue(createPhysicalAddressFromDiscriminatorValue_1.createPhysicalAddressFromDiscriminatorValue); }, "mailNickname": (o, n) => { o.mailNickname = n.getStringValue(); }, "middleName": (o, n) => { o.middleName = n.getStringValue(); }, "mobilePhone": (o, n) => { o.mobilePhone = n.getStringValue(); }, "officeLocation": (o, n) => { o.officeLocation = n.getStringValue(); }, "onPremisesInfo": (o, n) => { o.onPremisesInfo = n.getObjectValue(createEducationOnPremisesInfoFromDiscriminatorValue_1.createEducationOnPremisesInfoFromDiscriminatorValue); }, "passwordPolicies": (o, n) => { o.passwordPolicies = n.getStringValue(); }, "passwordProfile": (o, n) => { o.passwordProfile = n.getObjectValue(createPasswordProfileFromDiscriminatorValue_1.createPasswordProfileFromDiscriminatorValue); }, "preferredLanguage": (o, n) => { o.preferredLanguage = n.getStringValue(); }, "primaryRole": (o, n) => { o.primaryRole = n.getEnumValue(educationUserRole_1.EducationUserRole); }, "provisionedPlans": (o, n) => { o.provisionedPlans = n.getCollectionOfObjectValues(createProvisionedPlanFromDiscriminatorValue_1.createProvisionedPlanFromDiscriminatorValue); }, "refreshTokensValidFromDateTime": (o, n) => { o.refreshTokensValidFromDateTime = n.getDateValue(); }, "relatedContacts": (o, n) => { o.relatedContacts = n.getCollectionOfObjectValues(createRelatedContactFromDiscriminatorValue_1.createRelatedContactFromDiscriminatorValue); }, "residenceAddress": (o, n) => { o.residenceAddress = n.getObjectValue(createPhysicalAddressFromDiscriminatorValue_1.createPhysicalAddressFromDiscriminatorValue); }, "rubrics": (o, n) => { o.rubrics = n.getCollectionOfObjectValues(createEducationRubricFromDiscriminatorValue_1.createEducationRubricFromDiscriminatorValue); }, "schools": (o, n) => { o.schools = n.getCollectionOfObjectValues(createEducationSchoolFromDiscriminatorValue_1.createEducationSchoolFromDiscriminatorValue); }, "showInAddressList": (o, n) => { o.showInAddressList = n.getBooleanValue(); }, "student": (o, n) => { o.student = n.getObjectValue(createEducationStudentFromDiscriminatorValue_1.createEducationStudentFromDiscriminatorValue); }, "surname": (o, n) => { o.surname = n.getStringValue(); }, "taughtClasses": (o, n) => { o.taughtClasses = n.getCollectionOfObjectValues(createEducationClassFromDiscriminatorValue_1.createEducationClassFromDiscriminatorValue); }, "teacher": (o, n) => { o.teacher = n.getObjectValue(createEducationTeacherFromDiscriminatorValue_1.createEducationTeacherFromDiscriminatorValue); }, "usageLocation": (o, n) => { o.usageLocation = n.getStringValue(); }, "user": (o, n) => { o.user = n.getObjectValue(createUserFromDiscriminatorValue_1.createUserFromDiscriminatorValue); }, "userPrincipalName": (o, n) => { o.userPrincipalName = n.getStringValue(); }, "userType": (o, n) => { o.userType = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the givenName property value. The given name (first name) of the user. Supports $filter.
     * @returns a string
     */
    get givenName() {
        return this._givenName;
    }
    ;
    /**
     * Sets the givenName property value. The given name (first name) of the user. Supports $filter.
     * @param value Value to set for the givenName property.
     */
    set givenName(value) {
        this._givenName = value;
    }
    ;
    /**
     * Gets the mail property value. The SMTP address for the user; for example, jeff@contoso.onmicrosoft.com. Read-Only. Supports $filter.
     * @returns a string
     */
    get mail() {
        return this._mail;
    }
    ;
    /**
     * Sets the mail property value. The SMTP address for the user; for example, jeff@contoso.onmicrosoft.com. Read-Only. Supports $filter.
     * @param value Value to set for the mail property.
     */
    set mail(value) {
        this._mail = value;
    }
    ;
    /**
     * Gets the mailingAddress property value. Mail address of user.
     * @returns a physicalAddress
     */
    get mailingAddress() {
        return this._mailingAddress;
    }
    ;
    /**
     * Sets the mailingAddress property value. Mail address of user.
     * @param value Value to set for the mailingAddress property.
     */
    set mailingAddress(value) {
        this._mailingAddress = value;
    }
    ;
    /**
     * Gets the mailNickname property value. The mail alias for the user. This property must be specified when a user is created. Supports $filter.
     * @returns a string
     */
    get mailNickname() {
        return this._mailNickname;
    }
    ;
    /**
     * Sets the mailNickname property value. The mail alias for the user. This property must be specified when a user is created. Supports $filter.
     * @param value Value to set for the mailNickname property.
     */
    set mailNickname(value) {
        this._mailNickname = value;
    }
    ;
    /**
     * Gets the middleName property value. The middle name of user.
     * @returns a string
     */
    get middleName() {
        return this._middleName;
    }
    ;
    /**
     * Sets the middleName property value. The middle name of user.
     * @param value Value to set for the middleName property.
     */
    set middleName(value) {
        this._middleName = value;
    }
    ;
    /**
     * Gets the mobilePhone property value. The primary cellular telephone number for the user.
     * @returns a string
     */
    get mobilePhone() {
        return this._mobilePhone;
    }
    ;
    /**
     * Sets the mobilePhone property value. The primary cellular telephone number for the user.
     * @param value Value to set for the mobilePhone property.
     */
    set mobilePhone(value) {
        this._mobilePhone = value;
    }
    ;
    /**
     * Gets the officeLocation property value.
     * @returns a string
     */
    get officeLocation() {
        return this._officeLocation;
    }
    ;
    /**
     * Sets the officeLocation property value.
     * @param value Value to set for the officeLocation property.
     */
    set officeLocation(value) {
        this._officeLocation = value;
    }
    ;
    /**
     * Gets the onPremisesInfo property value. Additional information used to associate the Azure AD user with its Active Directory counterpart.
     * @returns a educationOnPremisesInfo
     */
    get onPremisesInfo() {
        return this._onPremisesInfo;
    }
    ;
    /**
     * Sets the onPremisesInfo property value. Additional information used to associate the Azure AD user with its Active Directory counterpart.
     * @param value Value to set for the onPremisesInfo property.
     */
    set onPremisesInfo(value) {
        this._onPremisesInfo = value;
    }
    ;
    /**
     * Gets the passwordPolicies property value. Specifies password policies for the user. This value is an enumeration with one possible value being DisableStrongPassword, which allows weaker passwords than the default policy to be specified. DisablePasswordExpiration can also be specified. The two can be specified together; for example: DisablePasswordExpiration, DisableStrongPassword.
     * @returns a string
     */
    get passwordPolicies() {
        return this._passwordPolicies;
    }
    ;
    /**
     * Sets the passwordPolicies property value. Specifies password policies for the user. This value is an enumeration with one possible value being DisableStrongPassword, which allows weaker passwords than the default policy to be specified. DisablePasswordExpiration can also be specified. The two can be specified together; for example: DisablePasswordExpiration, DisableStrongPassword.
     * @param value Value to set for the passwordPolicies property.
     */
    set passwordPolicies(value) {
        this._passwordPolicies = value;
    }
    ;
    /**
     * Gets the passwordProfile property value. Specifies the password profile for the user. The profile contains the user's password. This property is required when a user is created. The password in the profile must satisfy minimum requirements as specified by the passwordPolicies property. By default, a strong password is required.
     * @returns a passwordProfile
     */
    get passwordProfile() {
        return this._passwordProfile;
    }
    ;
    /**
     * Sets the passwordProfile property value. Specifies the password profile for the user. The profile contains the user's password. This property is required when a user is created. The password in the profile must satisfy minimum requirements as specified by the passwordPolicies property. By default, a strong password is required.
     * @param value Value to set for the passwordProfile property.
     */
    set passwordProfile(value) {
        this._passwordProfile = value;
    }
    ;
    /**
     * Gets the preferredLanguage property value. The preferred language for the user. Should follow ISO 639-1 Code; for example, 'en-US'.
     * @returns a string
     */
    get preferredLanguage() {
        return this._preferredLanguage;
    }
    ;
    /**
     * Sets the preferredLanguage property value. The preferred language for the user. Should follow ISO 639-1 Code; for example, 'en-US'.
     * @param value Value to set for the preferredLanguage property.
     */
    set preferredLanguage(value) {
        this._preferredLanguage = value;
    }
    ;
    /**
     * Gets the primaryRole property value. Default role for a user. The user's role might be different in an individual class. Possible values are: student, teacher, none, unknownFutureValue.
     * @returns a educationUserRole
     */
    get primaryRole() {
        return this._primaryRole;
    }
    ;
    /**
     * Sets the primaryRole property value. Default role for a user. The user's role might be different in an individual class. Possible values are: student, teacher, none, unknownFutureValue.
     * @param value Value to set for the primaryRole property.
     */
    set primaryRole(value) {
        this._primaryRole = value;
    }
    ;
    /**
     * Gets the provisionedPlans property value. The plans that are provisioned for the user. Read-only. Not nullable.
     * @returns a provisionedPlan
     */
    get provisionedPlans() {
        return this._provisionedPlans;
    }
    ;
    /**
     * Sets the provisionedPlans property value. The plans that are provisioned for the user. Read-only. Not nullable.
     * @param value Value to set for the provisionedPlans property.
     */
    set provisionedPlans(value) {
        this._provisionedPlans = value;
    }
    ;
    /**
     * Gets the refreshTokensValidFromDateTime property value.
     * @returns a Date
     */
    get refreshTokensValidFromDateTime() {
        return this._refreshTokensValidFromDateTime;
    }
    ;
    /**
     * Sets the refreshTokensValidFromDateTime property value.
     * @param value Value to set for the refreshTokensValidFromDateTime property.
     */
    set refreshTokensValidFromDateTime(value) {
        this._refreshTokensValidFromDateTime = value;
    }
    ;
    /**
     * Gets the relatedContacts property value. Related records related to the user. Possible relationships are parent, relative, aide, doctor, guardian, child, other, unknownFutureValue
     * @returns a relatedContact
     */
    get relatedContacts() {
        return this._relatedContacts;
    }
    ;
    /**
     * Sets the relatedContacts property value. Related records related to the user. Possible relationships are parent, relative, aide, doctor, guardian, child, other, unknownFutureValue
     * @param value Value to set for the relatedContacts property.
     */
    set relatedContacts(value) {
        this._relatedContacts = value;
    }
    ;
    /**
     * Gets the residenceAddress property value. Address where user lives.
     * @returns a physicalAddress
     */
    get residenceAddress() {
        return this._residenceAddress;
    }
    ;
    /**
     * Sets the residenceAddress property value. Address where user lives.
     * @param value Value to set for the residenceAddress property.
     */
    set residenceAddress(value) {
        this._residenceAddress = value;
    }
    ;
    /**
     * Gets the rubrics property value.
     * @returns a educationRubric
     */
    get rubrics() {
        return this._rubrics;
    }
    ;
    /**
     * Sets the rubrics property value.
     * @param value Value to set for the rubrics property.
     */
    set rubrics(value) {
        this._rubrics = value;
    }
    ;
    /**
     * Gets the schools property value. Schools to which the user belongs. Nullable.
     * @returns a educationSchool
     */
    get schools() {
        return this._schools;
    }
    ;
    /**
     * Sets the schools property value. Schools to which the user belongs. Nullable.
     * @param value Value to set for the schools property.
     */
    set schools(value) {
        this._schools = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeBooleanValue("accountEnabled", this.accountEnabled);
        writer.writeCollectionOfObjectValues("assignedLicenses", this.assignedLicenses);
        writer.writeCollectionOfObjectValues("assignedPlans", this.assignedPlans);
        writer.writeCollectionOfObjectValues("assignments", this.assignments);
        writer.writeCollectionOfPrimitiveValues("businessPhones", this.businessPhones);
        writer.writeCollectionOfObjectValues("classes", this.classes);
        writer.writeObjectValue("createdBy", this.createdBy);
        writer.writeStringValue("department", this.department);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeEnumValue("externalSource", this.externalSource);
        writer.writeStringValue("externalSourceDetail", this.externalSourceDetail);
        writer.writeStringValue("givenName", this.givenName);
        writer.writeStringValue("mail", this.mail);
        writer.writeObjectValue("mailingAddress", this.mailingAddress);
        writer.writeStringValue("mailNickname", this.mailNickname);
        writer.writeStringValue("middleName", this.middleName);
        writer.writeStringValue("mobilePhone", this.mobilePhone);
        writer.writeStringValue("officeLocation", this.officeLocation);
        writer.writeObjectValue("onPremisesInfo", this.onPremisesInfo);
        writer.writeStringValue("passwordPolicies", this.passwordPolicies);
        writer.writeObjectValue("passwordProfile", this.passwordProfile);
        writer.writeStringValue("preferredLanguage", this.preferredLanguage);
        writer.writeEnumValue("primaryRole", this.primaryRole);
        writer.writeCollectionOfObjectValues("provisionedPlans", this.provisionedPlans);
        writer.writeDateValue("refreshTokensValidFromDateTime", this.refreshTokensValidFromDateTime);
        writer.writeCollectionOfObjectValues("relatedContacts", this.relatedContacts);
        writer.writeObjectValue("residenceAddress", this.residenceAddress);
        writer.writeCollectionOfObjectValues("rubrics", this.rubrics);
        writer.writeCollectionOfObjectValues("schools", this.schools);
        writer.writeBooleanValue("showInAddressList", this.showInAddressList);
        writer.writeObjectValue("student", this.student);
        writer.writeStringValue("surname", this.surname);
        writer.writeCollectionOfObjectValues("taughtClasses", this.taughtClasses);
        writer.writeObjectValue("teacher", this.teacher);
        writer.writeStringValue("usageLocation", this.usageLocation);
        writer.writeObjectValue("user", this.user);
        writer.writeStringValue("userPrincipalName", this.userPrincipalName);
        writer.writeStringValue("userType", this.userType);
    }
    ;
    /**
     * Gets the showInAddressList property value. true if the Outlook global address list should contain this user, otherwise false. If not set, this will be treated as true. For users invited through the invitation manager, this property will be set to false.
     * @returns a boolean
     */
    get showInAddressList() {
        return this._showInAddressList;
    }
    ;
    /**
     * Sets the showInAddressList property value. true if the Outlook global address list should contain this user, otherwise false. If not set, this will be treated as true. For users invited through the invitation manager, this property will be set to false.
     * @param value Value to set for the showInAddressList property.
     */
    set showInAddressList(value) {
        this._showInAddressList = value;
    }
    ;
    /**
     * Gets the student property value. If the primary role is student, this block will contain student specific data.
     * @returns a educationStudent
     */
    get student() {
        return this._student;
    }
    ;
    /**
     * Sets the student property value. If the primary role is student, this block will contain student specific data.
     * @param value Value to set for the student property.
     */
    set student(value) {
        this._student = value;
    }
    ;
    /**
     * Gets the surname property value. The user's surname (family name or last name). Supports $filter.
     * @returns a string
     */
    get surname() {
        return this._surname;
    }
    ;
    /**
     * Sets the surname property value. The user's surname (family name or last name). Supports $filter.
     * @param value Value to set for the surname property.
     */
    set surname(value) {
        this._surname = value;
    }
    ;
    /**
     * Gets the taughtClasses property value. Classes for which the user is a teacher.
     * @returns a educationClass
     */
    get taughtClasses() {
        return this._taughtClasses;
    }
    ;
    /**
     * Sets the taughtClasses property value. Classes for which the user is a teacher.
     * @param value Value to set for the taughtClasses property.
     */
    set taughtClasses(value) {
        this._taughtClasses = value;
    }
    ;
    /**
     * Gets the teacher property value. If the primary role is teacher, this block will contain teacher specific data.
     * @returns a educationTeacher
     */
    get teacher() {
        return this._teacher;
    }
    ;
    /**
     * Sets the teacher property value. If the primary role is teacher, this block will contain teacher specific data.
     * @param value Value to set for the teacher property.
     */
    set teacher(value) {
        this._teacher = value;
    }
    ;
    /**
     * Gets the usageLocation property value. A two-letter country code (ISO standard 3166). Required for users who will be assigned licenses due to a legal requirement to check for availability of services in countries or regions. Examples include: 'US', 'JP', and 'GB'. Not nullable. Supports $filter.
     * @returns a string
     */
    get usageLocation() {
        return this._usageLocation;
    }
    ;
    /**
     * Sets the usageLocation property value. A two-letter country code (ISO standard 3166). Required for users who will be assigned licenses due to a legal requirement to check for availability of services in countries or regions. Examples include: 'US', 'JP', and 'GB'. Not nullable. Supports $filter.
     * @param value Value to set for the usageLocation property.
     */
    set usageLocation(value) {
        this._usageLocation = value;
    }
    ;
    /**
     * Gets the user property value. The directory user corresponding to this user.
     * @returns a user
     */
    get user() {
        return this._user;
    }
    ;
    /**
     * Sets the user property value. The directory user corresponding to this user.
     * @param value Value to set for the user property.
     */
    set user(value) {
        this._user = value;
    }
    ;
    /**
     * Gets the userPrincipalName property value. The user principal name (UPN) of the user. The UPN is an Internet-style login name for the user based on the Internet standard RFC 822. By convention, this should map to the user's email name. The general format is alias@domain, where domain must be present in the tenant's collection of verified domains. This property is required when a user is created. The verified domains for the tenant can be accessed from the verifiedDomains property of organization. Supports $filter and $orderby.
     * @returns a string
     */
    get userPrincipalName() {
        return this._userPrincipalName;
    }
    ;
    /**
     * Sets the userPrincipalName property value. The user principal name (UPN) of the user. The UPN is an Internet-style login name for the user based on the Internet standard RFC 822. By convention, this should map to the user's email name. The general format is alias@domain, where domain must be present in the tenant's collection of verified domains. This property is required when a user is created. The verified domains for the tenant can be accessed from the verifiedDomains property of organization. Supports $filter and $orderby.
     * @param value Value to set for the userPrincipalName property.
     */
    set userPrincipalName(value) {
        this._userPrincipalName = value;
    }
    ;
    /**
     * Gets the userType property value. A string value that can be used to classify user types in your directory, such as 'Member' and 'Guest'. Supports $filter.
     * @returns a string
     */
    get userType() {
        return this._userType;
    }
    ;
    /**
     * Sets the userType property value. A string value that can be used to classify user types in your directory, such as 'Member' and 'Guest'. Supports $filter.
     * @param value Value to set for the userType property.
     */
    set userType(value) {
        this._userType = value;
    }
    ;
}
exports.EducationUser = EducationUser;
