"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EmployeeOrgData = void 0;
class EmployeeOrgData {
    /**
     * Instantiates a new employeeOrgData and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the costCenter property value. The cost center associated with the user. Returned only on $select. Supports $filter.
     * @returns a string
     */
    get costCenter() {
        return this._costCenter;
    }
    ;
    /**
     * Sets the costCenter property value. The cost center associated with the user. Returned only on $select. Supports $filter.
     * @param value Value to set for the costCenter property.
     */
    set costCenter(value) {
        this._costCenter = value;
    }
    ;
    /**
     * Gets the division property value. The name of the division in which the user works. Returned only on $select. Supports $filter.
     * @returns a string
     */
    get division() {
        return this._division;
    }
    ;
    /**
     * Sets the division property value. The name of the division in which the user works. Returned only on $select. Supports $filter.
     * @param value Value to set for the division property.
     */
    set division(value) {
        this._division = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "costCenter": (o, n) => { o.costCenter = n.getStringValue(); },
            "division": (o, n) => { o.division = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("costCenter", this.costCenter);
        writer.writeStringValue("division", this.division);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.EmployeeOrgData = EmployeeOrgData;
