"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Endpoint = void 0;
const index_1 = require("./index");
class Endpoint extends index_1.DirectoryObject {
    /**
     * Instantiates a new endpoint and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the capability property value. Describes the capability that is associated with this resource. (e.g. Messages, Conversations, etc.)  Not nullable. Read-only.
     * @returns a string
     */
    get capability() {
        return this._capability;
    }
    ;
    /**
     * Sets the capability property value. Describes the capability that is associated with this resource. (e.g. Messages, Conversations, etc.)  Not nullable. Read-only.
     * @param value Value to set for the capability property.
     */
    set capability(value) {
        this._capability = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "capability": (o, n) => { o.capability = n.getStringValue(); }, "providerId": (o, n) => { o.providerId = n.getStringValue(); }, "providerName": (o, n) => { o.providerName = n.getStringValue(); }, "providerResourceId": (o, n) => { o.providerResourceId = n.getStringValue(); }, "uri": (o, n) => { o.uri = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the providerId property value. Application id of the publishing underlying service. Not nullable. Read-only.
     * @returns a string
     */
    get providerId() {
        return this._providerId;
    }
    ;
    /**
     * Sets the providerId property value. Application id of the publishing underlying service. Not nullable. Read-only.
     * @param value Value to set for the providerId property.
     */
    set providerId(value) {
        this._providerId = value;
    }
    ;
    /**
     * Gets the providerName property value. Name of the publishing underlying service. Read-only.
     * @returns a string
     */
    get providerName() {
        return this._providerName;
    }
    ;
    /**
     * Sets the providerName property value. Name of the publishing underlying service. Read-only.
     * @param value Value to set for the providerName property.
     */
    set providerName(value) {
        this._providerName = value;
    }
    ;
    /**
     * Gets the providerResourceId property value. For Microsoft 365 groups, this is set to a well-known name for the resource (e.g. Yammer.FeedURL etc.). Not nullable. Read-only.
     * @returns a string
     */
    get providerResourceId() {
        return this._providerResourceId;
    }
    ;
    /**
     * Sets the providerResourceId property value. For Microsoft 365 groups, this is set to a well-known name for the resource (e.g. Yammer.FeedURL etc.). Not nullable. Read-only.
     * @param value Value to set for the providerResourceId property.
     */
    set providerResourceId(value) {
        this._providerResourceId = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("capability", this.capability);
        writer.writeStringValue("providerId", this.providerId);
        writer.writeStringValue("providerName", this.providerName);
        writer.writeStringValue("providerResourceId", this.providerResourceId);
        writer.writeStringValue("uri", this.uri);
    }
    ;
    /**
     * Gets the uri property value. URL of the published resource. Not nullable. Read-only.
     * @returns a string
     */
    get uri() {
        return this._uri;
    }
    ;
    /**
     * Sets the uri property value. URL of the published resource. Not nullable. Read-only.
     * @param value Value to set for the uri property.
     */
    set uri(value) {
        this._uri = value;
    }
    ;
}
exports.Endpoint = Endpoint;
