import { DeviceAndAppManagementAssignmentTarget, Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class EnrollmentConfigurationAssignment extends Entity implements Parsable {
    /** Represents an assignment to managed devices in the tenant  */
    private _target?;
    /**
     * Instantiates a new enrollmentConfigurationAssignment and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the target property value. Represents an assignment to managed devices in the tenant
     * @returns a deviceAndAppManagementAssignmentTarget
     */
    get target(): DeviceAndAppManagementAssignmentTarget | undefined;
    /**
     * Sets the target property value. Represents an assignment to managed devices in the tenant
     * @param value Value to set for the target property.
     */
    set target(value: DeviceAndAppManagementAssignmentTarget | undefined);
}
