"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EntitlementManagementSettings = void 0;
const accessPackageExternalUserLifecycleAction_1 = require("./accessPackageExternalUserLifecycleAction");
const index_1 = require("./index");
class EntitlementManagementSettings extends index_1.Entity {
    /**
     * Instantiates a new entitlementManagementSettings and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the durationUntilExternalUserDeletedAfterBlocked property value. If externalUserLifecycleAction is blockSignInAndDelete, the duration, typically a number of days, after an external user is blocked from sign in before their account is deleted.
     * @returns a Duration
     */
    get durationUntilExternalUserDeletedAfterBlocked() {
        return this._durationUntilExternalUserDeletedAfterBlocked;
    }
    ;
    /**
     * Sets the durationUntilExternalUserDeletedAfterBlocked property value. If externalUserLifecycleAction is blockSignInAndDelete, the duration, typically a number of days, after an external user is blocked from sign in before their account is deleted.
     * @param value Value to set for the durationUntilExternalUserDeletedAfterBlocked property.
     */
    set durationUntilExternalUserDeletedAfterBlocked(value) {
        this._durationUntilExternalUserDeletedAfterBlocked = value;
    }
    ;
    /**
     * Gets the externalUserLifecycleAction property value. Automatic action that the service should take when an external user's last access package assignment is removed. The possible values are: none, blockSignIn, blockSignInAndDelete, unknownFutureValue.
     * @returns a accessPackageExternalUserLifecycleAction
     */
    get externalUserLifecycleAction() {
        return this._externalUserLifecycleAction;
    }
    ;
    /**
     * Sets the externalUserLifecycleAction property value. Automatic action that the service should take when an external user's last access package assignment is removed. The possible values are: none, blockSignIn, blockSignInAndDelete, unknownFutureValue.
     * @param value Value to set for the externalUserLifecycleAction property.
     */
    set externalUserLifecycleAction(value) {
        this._externalUserLifecycleAction = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "durationUntilExternalUserDeletedAfterBlocked": (o, n) => { o.durationUntilExternalUserDeletedAfterBlocked = n.getDurationValue(); }, "externalUserLifecycleAction": (o, n) => { o.externalUserLifecycleAction = n.getEnumValue(accessPackageExternalUserLifecycleAction_1.AccessPackageExternalUserLifecycleAction); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeDurationValue("durationUntilExternalUserDeletedAfterBlocked", this.durationUntilExternalUserDeletedAfterBlocked);
        writer.writeEnumValue("externalUserLifecycleAction", this.externalUserLifecycleAction);
    }
    ;
}
exports.EntitlementManagementSettings = EntitlementManagementSettings;
