"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Event = void 0;
const createAttachmentFromDiscriminatorValue_1 = require("./createAttachmentFromDiscriminatorValue");
const createAttendeeFromDiscriminatorValue_1 = require("./createAttendeeFromDiscriminatorValue");
const createCalendarFromDiscriminatorValue_1 = require("./createCalendarFromDiscriminatorValue");
const createDateTimeTimeZoneFromDiscriminatorValue_1 = require("./createDateTimeTimeZoneFromDiscriminatorValue");
const createEventFromDiscriminatorValue_1 = require("./createEventFromDiscriminatorValue");
const createExtensionFromDiscriminatorValue_1 = require("./createExtensionFromDiscriminatorValue");
const createItemBodyFromDiscriminatorValue_1 = require("./createItemBodyFromDiscriminatorValue");
const createLocationFromDiscriminatorValue_1 = require("./createLocationFromDiscriminatorValue");
const createMultiValueLegacyExtendedPropertyFromDiscriminatorValue_1 = require("./createMultiValueLegacyExtendedPropertyFromDiscriminatorValue");
const createOnlineMeetingInfoFromDiscriminatorValue_1 = require("./createOnlineMeetingInfoFromDiscriminatorValue");
const createPatternedRecurrenceFromDiscriminatorValue_1 = require("./createPatternedRecurrenceFromDiscriminatorValue");
const createRecipientFromDiscriminatorValue_1 = require("./createRecipientFromDiscriminatorValue");
const createResponseStatusFromDiscriminatorValue_1 = require("./createResponseStatusFromDiscriminatorValue");
const createSingleValueLegacyExtendedPropertyFromDiscriminatorValue_1 = require("./createSingleValueLegacyExtendedPropertyFromDiscriminatorValue");
const eventType_1 = require("./eventType");
const freeBusyStatus_1 = require("./freeBusyStatus");
const importance_1 = require("./importance");
const index_1 = require("./index");
const onlineMeetingProviderType_1 = require("./onlineMeetingProviderType");
const sensitivity_1 = require("./sensitivity");
class Event extends index_1.OutlookItem {
    /**
     * Instantiates a new event and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the allowNewTimeProposals property value. true if the meeting organizer allows invitees to propose a new time when responding; otherwise, false. Optional. Default is true.
     * @returns a boolean
     */
    get allowNewTimeProposals() {
        return this._allowNewTimeProposals;
    }
    ;
    /**
     * Sets the allowNewTimeProposals property value. true if the meeting organizer allows invitees to propose a new time when responding; otherwise, false. Optional. Default is true.
     * @param value Value to set for the allowNewTimeProposals property.
     */
    set allowNewTimeProposals(value) {
        this._allowNewTimeProposals = value;
    }
    ;
    /**
     * Gets the attachments property value. The collection of FileAttachment, ItemAttachment, and referenceAttachment attachments for the event. Navigation property. Read-only. Nullable.
     * @returns a attachment
     */
    get attachments() {
        return this._attachments;
    }
    ;
    /**
     * Sets the attachments property value. The collection of FileAttachment, ItemAttachment, and referenceAttachment attachments for the event. Navigation property. Read-only. Nullable.
     * @param value Value to set for the attachments property.
     */
    set attachments(value) {
        this._attachments = value;
    }
    ;
    /**
     * Gets the attendees property value. The collection of attendees for the event.
     * @returns a attendee
     */
    get attendees() {
        return this._attendees;
    }
    ;
    /**
     * Sets the attendees property value. The collection of attendees for the event.
     * @param value Value to set for the attendees property.
     */
    set attendees(value) {
        this._attendees = value;
    }
    ;
    /**
     * Gets the body property value. The body of the message associated with the event. It can be in HTML or text format.
     * @returns a itemBody
     */
    get body() {
        return this._body;
    }
    ;
    /**
     * Sets the body property value. The body of the message associated with the event. It can be in HTML or text format.
     * @param value Value to set for the body property.
     */
    set body(value) {
        this._body = value;
    }
    ;
    /**
     * Gets the bodyPreview property value. The preview of the message associated with the event. It is in text format.
     * @returns a string
     */
    get bodyPreview() {
        return this._bodyPreview;
    }
    ;
    /**
     * Sets the bodyPreview property value. The preview of the message associated with the event. It is in text format.
     * @param value Value to set for the bodyPreview property.
     */
    set bodyPreview(value) {
        this._bodyPreview = value;
    }
    ;
    /**
     * Gets the calendar property value. The calendar that contains the event. Navigation property. Read-only.
     * @returns a calendar
     */
    get calendar() {
        return this._calendar;
    }
    ;
    /**
     * Sets the calendar property value. The calendar that contains the event. Navigation property. Read-only.
     * @param value Value to set for the calendar property.
     */
    set calendar(value) {
        this._calendar = value;
    }
    ;
    ;
    /**
     * Gets the end property value. The date, time, and time zone that the event ends. By default, the end time is in UTC.
     * @returns a dateTimeTimeZone
     */
    get end() {
        return this._end;
    }
    ;
    /**
     * Sets the end property value. The date, time, and time zone that the event ends. By default, the end time is in UTC.
     * @param value Value to set for the end property.
     */
    set end(value) {
        this._end = value;
    }
    ;
    /**
     * Gets the extensions property value. The collection of open extensions defined for the event. Nullable.
     * @returns a extension
     */
    get extensions() {
        return this._extensions;
    }
    ;
    /**
     * Sets the extensions property value. The collection of open extensions defined for the event. Nullable.
     * @param value Value to set for the extensions property.
     */
    set extensions(value) {
        this._extensions = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "allowNewTimeProposals": (o, n) => { o.allowNewTimeProposals = n.getBooleanValue(); }, "attachments": (o, n) => { o.attachments = n.getCollectionOfObjectValues(createAttachmentFromDiscriminatorValue_1.createAttachmentFromDiscriminatorValue); }, "attendees": (o, n) => { o.attendees = n.getCollectionOfObjectValues(createAttendeeFromDiscriminatorValue_1.createAttendeeFromDiscriminatorValue); }, "body": (o, n) => { o.body = n.getObjectValue(createItemBodyFromDiscriminatorValue_1.createItemBodyFromDiscriminatorValue); }, "bodyPreview": (o, n) => { o.bodyPreview = n.getStringValue(); }, "calendar": (o, n) => { o.calendar = n.getObjectValue(createCalendarFromDiscriminatorValue_1.createCalendarFromDiscriminatorValue); }, "end": (o, n) => { o.end = n.getObjectValue(createDateTimeTimeZoneFromDiscriminatorValue_1.createDateTimeTimeZoneFromDiscriminatorValue); }, "extensions": (o, n) => { o.extensions = n.getCollectionOfObjectValues(createExtensionFromDiscriminatorValue_1.createExtensionFromDiscriminatorValue); }, "hasAttachments": (o, n) => { o.hasAttachments = n.getBooleanValue(); }, "hideAttendees": (o, n) => { o.hideAttendees = n.getBooleanValue(); }, "iCalUId": (o, n) => { o.iCalUId = n.getStringValue(); }, "importance": (o, n) => { o.importance = n.getEnumValue(importance_1.Importance); }, "instances": (o, n) => { o.instances = n.getCollectionOfObjectValues(createEventFromDiscriminatorValue_1.createEventFromDiscriminatorValue); }, "isAllDay": (o, n) => { o.isAllDay = n.getBooleanValue(); }, "isCancelled": (o, n) => { o.isCancelled = n.getBooleanValue(); }, "isDraft": (o, n) => { o.isDraft = n.getBooleanValue(); }, "isOnlineMeeting": (o, n) => { o.isOnlineMeeting = n.getBooleanValue(); }, "isOrganizer": (o, n) => { o.isOrganizer = n.getBooleanValue(); }, "isReminderOn": (o, n) => { o.isReminderOn = n.getBooleanValue(); }, "location": (o, n) => { o.location = n.getObjectValue(createLocationFromDiscriminatorValue_1.createLocationFromDiscriminatorValue); }, "locations": (o, n) => { o.locations = n.getCollectionOfObjectValues(createLocationFromDiscriminatorValue_1.createLocationFromDiscriminatorValue); }, "multiValueExtendedProperties": (o, n) => { o.multiValueExtendedProperties = n.getCollectionOfObjectValues(createMultiValueLegacyExtendedPropertyFromDiscriminatorValue_1.createMultiValueLegacyExtendedPropertyFromDiscriminatorValue); }, "onlineMeeting": (o, n) => { o.onlineMeeting = n.getObjectValue(createOnlineMeetingInfoFromDiscriminatorValue_1.createOnlineMeetingInfoFromDiscriminatorValue); }, "onlineMeetingProvider": (o, n) => { o.onlineMeetingProvider = n.getEnumValue(onlineMeetingProviderType_1.OnlineMeetingProviderType); }, "onlineMeetingUrl": (o, n) => { o.onlineMeetingUrl = n.getStringValue(); }, "organizer": (o, n) => { o.organizer = n.getObjectValue(createRecipientFromDiscriminatorValue_1.createRecipientFromDiscriminatorValue); }, "originalEndTimeZone": (o, n) => { o.originalEndTimeZone = n.getStringValue(); }, "originalStart": (o, n) => { o.originalStart = n.getDateValue(); }, "originalStartTimeZone": (o, n) => { o.originalStartTimeZone = n.getStringValue(); }, "recurrence": (o, n) => { o.recurrence = n.getObjectValue(createPatternedRecurrenceFromDiscriminatorValue_1.createPatternedRecurrenceFromDiscriminatorValue); }, "reminderMinutesBeforeStart": (o, n) => { o.reminderMinutesBeforeStart = n.getNumberValue(); }, "responseRequested": (o, n) => { o.responseRequested = n.getBooleanValue(); }, "responseStatus": (o, n) => { o.responseStatus = n.getObjectValue(createResponseStatusFromDiscriminatorValue_1.createResponseStatusFromDiscriminatorValue); }, "sensitivity": (o, n) => { o.sensitivity = n.getEnumValue(sensitivity_1.Sensitivity); }, "seriesMasterId": (o, n) => { o.seriesMasterId = n.getStringValue(); }, "showAs": (o, n) => { o.showAs = n.getEnumValue(freeBusyStatus_1.FreeBusyStatus); }, "singleValueExtendedProperties": (o, n) => { o.singleValueExtendedProperties = n.getCollectionOfObjectValues(createSingleValueLegacyExtendedPropertyFromDiscriminatorValue_1.createSingleValueLegacyExtendedPropertyFromDiscriminatorValue); }, "start": (o, n) => { o.start = n.getObjectValue(createDateTimeTimeZoneFromDiscriminatorValue_1.createDateTimeTimeZoneFromDiscriminatorValue); }, "subject": (o, n) => { o.subject = n.getStringValue(); }, "transactionId": (o, n) => { o.transactionId = n.getStringValue(); }, "type": (o, n) => { o.type = n.getEnumValue(eventType_1.EventType); }, "webLink": (o, n) => { o.webLink = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the hasAttachments property value. Set to true if the event has attachments.
     * @returns a boolean
     */
    get hasAttachments() {
        return this._hasAttachments;
    }
    ;
    /**
     * Sets the hasAttachments property value. Set to true if the event has attachments.
     * @param value Value to set for the hasAttachments property.
     */
    set hasAttachments(value) {
        this._hasAttachments = value;
    }
    ;
    /**
     * Gets the hideAttendees property value. When set to true, each attendee only sees themselves in the meeting request and meeting Tracking list. Default is false.
     * @returns a boolean
     */
    get hideAttendees() {
        return this._hideAttendees;
    }
    ;
    /**
     * Sets the hideAttendees property value. When set to true, each attendee only sees themselves in the meeting request and meeting Tracking list. Default is false.
     * @param value Value to set for the hideAttendees property.
     */
    set hideAttendees(value) {
        this._hideAttendees = value;
    }
    ;
    /**
     * Gets the iCalUId property value. A unique identifier for an event across calendars. This ID is different for each occurrence in a recurring series. Read-only.
     * @returns a string
     */
    get iCalUId() {
        return this._iCalUId;
    }
    ;
    /**
     * Sets the iCalUId property value. A unique identifier for an event across calendars. This ID is different for each occurrence in a recurring series. Read-only.
     * @param value Value to set for the iCalUId property.
     */
    set iCalUId(value) {
        this._iCalUId = value;
    }
    ;
    /**
     * Gets the importance property value.
     * @returns a importance
     */
    get importance() {
        return this._importance;
    }
    ;
    /**
     * Sets the importance property value.
     * @param value Value to set for the importance property.
     */
    set importance(value) {
        this._importance = value;
    }
    ;
    /**
     * Gets the instances property value. The occurrences of a recurring series, if the event is a series master. This property includes occurrences that are part of the recurrence pattern, and exceptions that have been modified, but does not include occurrences that have been cancelled from the series. Navigation property. Read-only. Nullable.
     * @returns a event
     */
    get instances() {
        return this._instances;
    }
    ;
    /**
     * Sets the instances property value. The occurrences of a recurring series, if the event is a series master. This property includes occurrences that are part of the recurrence pattern, and exceptions that have been modified, but does not include occurrences that have been cancelled from the series. Navigation property. Read-only. Nullable.
     * @param value Value to set for the instances property.
     */
    set instances(value) {
        this._instances = value;
    }
    ;
    /**
     * Gets the isAllDay property value.
     * @returns a boolean
     */
    get isAllDay() {
        return this._isAllDay;
    }
    ;
    /**
     * Sets the isAllDay property value.
     * @param value Value to set for the isAllDay property.
     */
    set isAllDay(value) {
        this._isAllDay = value;
    }
    ;
    /**
     * Gets the isCancelled property value.
     * @returns a boolean
     */
    get isCancelled() {
        return this._isCancelled;
    }
    ;
    /**
     * Sets the isCancelled property value.
     * @param value Value to set for the isCancelled property.
     */
    set isCancelled(value) {
        this._isCancelled = value;
    }
    ;
    /**
     * Gets the isDraft property value.
     * @returns a boolean
     */
    get isDraft() {
        return this._isDraft;
    }
    ;
    /**
     * Sets the isDraft property value.
     * @param value Value to set for the isDraft property.
     */
    set isDraft(value) {
        this._isDraft = value;
    }
    ;
    /**
     * Gets the isOnlineMeeting property value.
     * @returns a boolean
     */
    get isOnlineMeeting() {
        return this._isOnlineMeeting;
    }
    ;
    /**
     * Sets the isOnlineMeeting property value.
     * @param value Value to set for the isOnlineMeeting property.
     */
    set isOnlineMeeting(value) {
        this._isOnlineMeeting = value;
    }
    ;
    /**
     * Gets the isOrganizer property value.
     * @returns a boolean
     */
    get isOrganizer() {
        return this._isOrganizer;
    }
    ;
    /**
     * Sets the isOrganizer property value.
     * @param value Value to set for the isOrganizer property.
     */
    set isOrganizer(value) {
        this._isOrganizer = value;
    }
    ;
    /**
     * Gets the isReminderOn property value.
     * @returns a boolean
     */
    get isReminderOn() {
        return this._isReminderOn;
    }
    ;
    /**
     * Sets the isReminderOn property value.
     * @param value Value to set for the isReminderOn property.
     */
    set isReminderOn(value) {
        this._isReminderOn = value;
    }
    ;
    /**
     * Gets the location property value.
     * @returns a location
     */
    get location() {
        return this._location;
    }
    ;
    /**
     * Sets the location property value.
     * @param value Value to set for the location property.
     */
    set location(value) {
        this._location = value;
    }
    ;
    /**
     * Gets the locations property value.
     * @returns a location
     */
    get locations() {
        return this._locations;
    }
    ;
    /**
     * Sets the locations property value.
     * @param value Value to set for the locations property.
     */
    set locations(value) {
        this._locations = value;
    }
    ;
    /**
     * Gets the multiValueExtendedProperties property value. The collection of multi-value extended properties defined for the event. Read-only. Nullable.
     * @returns a multiValueLegacyExtendedProperty
     */
    get multiValueExtendedProperties() {
        return this._multiValueExtendedProperties;
    }
    ;
    /**
     * Sets the multiValueExtendedProperties property value. The collection of multi-value extended properties defined for the event. Read-only. Nullable.
     * @param value Value to set for the multiValueExtendedProperties property.
     */
    set multiValueExtendedProperties(value) {
        this._multiValueExtendedProperties = value;
    }
    ;
    /**
     * Gets the onlineMeeting property value.
     * @returns a onlineMeetingInfo
     */
    get onlineMeeting() {
        return this._onlineMeeting;
    }
    ;
    /**
     * Sets the onlineMeeting property value.
     * @param value Value to set for the onlineMeeting property.
     */
    set onlineMeeting(value) {
        this._onlineMeeting = value;
    }
    ;
    /**
     * Gets the onlineMeetingProvider property value.
     * @returns a onlineMeetingProviderType
     */
    get onlineMeetingProvider() {
        return this._onlineMeetingProvider;
    }
    ;
    /**
     * Sets the onlineMeetingProvider property value.
     * @param value Value to set for the onlineMeetingProvider property.
     */
    set onlineMeetingProvider(value) {
        this._onlineMeetingProvider = value;
    }
    ;
    /**
     * Gets the onlineMeetingUrl property value.
     * @returns a string
     */
    get onlineMeetingUrl() {
        return this._onlineMeetingUrl;
    }
    ;
    /**
     * Sets the onlineMeetingUrl property value.
     * @param value Value to set for the onlineMeetingUrl property.
     */
    set onlineMeetingUrl(value) {
        this._onlineMeetingUrl = value;
    }
    ;
    /**
     * Gets the organizer property value.
     * @returns a recipient
     */
    get organizer() {
        return this._organizer;
    }
    ;
    /**
     * Sets the organizer property value.
     * @param value Value to set for the organizer property.
     */
    set organizer(value) {
        this._organizer = value;
    }
    ;
    /**
     * Gets the originalEndTimeZone property value.
     * @returns a string
     */
    get originalEndTimeZone() {
        return this._originalEndTimeZone;
    }
    ;
    /**
     * Sets the originalEndTimeZone property value.
     * @param value Value to set for the originalEndTimeZone property.
     */
    set originalEndTimeZone(value) {
        this._originalEndTimeZone = value;
    }
    ;
    /**
     * Gets the originalStart property value.
     * @returns a Date
     */
    get originalStart() {
        return this._originalStart;
    }
    ;
    /**
     * Sets the originalStart property value.
     * @param value Value to set for the originalStart property.
     */
    set originalStart(value) {
        this._originalStart = value;
    }
    ;
    /**
     * Gets the originalStartTimeZone property value.
     * @returns a string
     */
    get originalStartTimeZone() {
        return this._originalStartTimeZone;
    }
    ;
    /**
     * Sets the originalStartTimeZone property value.
     * @param value Value to set for the originalStartTimeZone property.
     */
    set originalStartTimeZone(value) {
        this._originalStartTimeZone = value;
    }
    ;
    /**
     * Gets the recurrence property value.
     * @returns a patternedRecurrence
     */
    get recurrence() {
        return this._recurrence;
    }
    ;
    /**
     * Sets the recurrence property value.
     * @param value Value to set for the recurrence property.
     */
    set recurrence(value) {
        this._recurrence = value;
    }
    ;
    /**
     * Gets the reminderMinutesBeforeStart property value.
     * @returns a integer
     */
    get reminderMinutesBeforeStart() {
        return this._reminderMinutesBeforeStart;
    }
    ;
    /**
     * Sets the reminderMinutesBeforeStart property value.
     * @param value Value to set for the reminderMinutesBeforeStart property.
     */
    set reminderMinutesBeforeStart(value) {
        this._reminderMinutesBeforeStart = value;
    }
    ;
    /**
     * Gets the responseRequested property value.
     * @returns a boolean
     */
    get responseRequested() {
        return this._responseRequested;
    }
    ;
    /**
     * Sets the responseRequested property value.
     * @param value Value to set for the responseRequested property.
     */
    set responseRequested(value) {
        this._responseRequested = value;
    }
    ;
    /**
     * Gets the responseStatus property value.
     * @returns a responseStatus
     */
    get responseStatus() {
        return this._responseStatus;
    }
    ;
    /**
     * Sets the responseStatus property value.
     * @param value Value to set for the responseStatus property.
     */
    set responseStatus(value) {
        this._responseStatus = value;
    }
    ;
    /**
     * Gets the sensitivity property value.
     * @returns a sensitivity
     */
    get sensitivity() {
        return this._sensitivity;
    }
    ;
    /**
     * Sets the sensitivity property value.
     * @param value Value to set for the sensitivity property.
     */
    set sensitivity(value) {
        this._sensitivity = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeBooleanValue("allowNewTimeProposals", this.allowNewTimeProposals);
        writer.writeCollectionOfObjectValues("attachments", this.attachments);
        writer.writeCollectionOfObjectValues("attendees", this.attendees);
        writer.writeObjectValue("body", this.body);
        writer.writeStringValue("bodyPreview", this.bodyPreview);
        writer.writeObjectValue("calendar", this.calendar);
        writer.writeObjectValue("end", this.end);
        writer.writeCollectionOfObjectValues("extensions", this.extensions);
        writer.writeBooleanValue("hasAttachments", this.hasAttachments);
        writer.writeBooleanValue("hideAttendees", this.hideAttendees);
        writer.writeStringValue("iCalUId", this.iCalUId);
        writer.writeEnumValue("importance", this.importance);
        writer.writeCollectionOfObjectValues("instances", this.instances);
        writer.writeBooleanValue("isAllDay", this.isAllDay);
        writer.writeBooleanValue("isCancelled", this.isCancelled);
        writer.writeBooleanValue("isDraft", this.isDraft);
        writer.writeBooleanValue("isOnlineMeeting", this.isOnlineMeeting);
        writer.writeBooleanValue("isOrganizer", this.isOrganizer);
        writer.writeBooleanValue("isReminderOn", this.isReminderOn);
        writer.writeObjectValue("location", this.location);
        writer.writeCollectionOfObjectValues("locations", this.locations);
        writer.writeCollectionOfObjectValues("multiValueExtendedProperties", this.multiValueExtendedProperties);
        writer.writeObjectValue("onlineMeeting", this.onlineMeeting);
        writer.writeEnumValue("onlineMeetingProvider", this.onlineMeetingProvider);
        writer.writeStringValue("onlineMeetingUrl", this.onlineMeetingUrl);
        writer.writeObjectValue("organizer", this.organizer);
        writer.writeStringValue("originalEndTimeZone", this.originalEndTimeZone);
        writer.writeDateValue("originalStart", this.originalStart);
        writer.writeStringValue("originalStartTimeZone", this.originalStartTimeZone);
        writer.writeObjectValue("recurrence", this.recurrence);
        writer.writeNumberValue("reminderMinutesBeforeStart", this.reminderMinutesBeforeStart);
        writer.writeBooleanValue("responseRequested", this.responseRequested);
        writer.writeObjectValue("responseStatus", this.responseStatus);
        writer.writeEnumValue("sensitivity", this.sensitivity);
        writer.writeStringValue("seriesMasterId", this.seriesMasterId);
        writer.writeEnumValue("showAs", this.showAs);
        writer.writeCollectionOfObjectValues("singleValueExtendedProperties", this.singleValueExtendedProperties);
        writer.writeObjectValue("start", this.start);
        writer.writeStringValue("subject", this.subject);
        writer.writeStringValue("transactionId", this.transactionId);
        writer.writeEnumValue("type", this.type);
        writer.writeStringValue("webLink", this.webLink);
    }
    ;
    /**
     * Gets the seriesMasterId property value.
     * @returns a string
     */
    get seriesMasterId() {
        return this._seriesMasterId;
    }
    ;
    /**
     * Sets the seriesMasterId property value.
     * @param value Value to set for the seriesMasterId property.
     */
    set seriesMasterId(value) {
        this._seriesMasterId = value;
    }
    ;
    /**
     * Gets the showAs property value.
     * @returns a freeBusyStatus
     */
    get showAs() {
        return this._showAs;
    }
    ;
    /**
     * Sets the showAs property value.
     * @param value Value to set for the showAs property.
     */
    set showAs(value) {
        this._showAs = value;
    }
    ;
    /**
     * Gets the singleValueExtendedProperties property value. The collection of single-value extended properties defined for the event. Read-only. Nullable.
     * @returns a singleValueLegacyExtendedProperty
     */
    get singleValueExtendedProperties() {
        return this._singleValueExtendedProperties;
    }
    ;
    /**
     * Sets the singleValueExtendedProperties property value. The collection of single-value extended properties defined for the event. Read-only. Nullable.
     * @param value Value to set for the singleValueExtendedProperties property.
     */
    set singleValueExtendedProperties(value) {
        this._singleValueExtendedProperties = value;
    }
    ;
    /**
     * Gets the start property value.
     * @returns a dateTimeTimeZone
     */
    get start() {
        return this._start;
    }
    ;
    /**
     * Sets the start property value.
     * @param value Value to set for the start property.
     */
    set start(value) {
        this._start = value;
    }
    ;
    /**
     * Gets the subject property value.
     * @returns a string
     */
    get subject() {
        return this._subject;
    }
    ;
    /**
     * Sets the subject property value.
     * @param value Value to set for the subject property.
     */
    set subject(value) {
        this._subject = value;
    }
    ;
    /**
     * Gets the transactionId property value.
     * @returns a string
     */
    get transactionId() {
        return this._transactionId;
    }
    ;
    /**
     * Sets the transactionId property value.
     * @param value Value to set for the transactionId property.
     */
    set transactionId(value) {
        this._transactionId = value;
    }
    ;
    /**
     * Gets the type property value.
     * @returns a eventType
     */
    get type() {
        return this._type;
    }
    ;
    /**
     * Sets the type property value.
     * @param value Value to set for the type property.
     */
    set type(value) {
        this._type = value;
    }
    ;
    /**
     * Gets the webLink property value.
     * @returns a string
     */
    get webLink() {
        return this._webLink;
    }
    ;
    /**
     * Sets the webLink property value.
     * @param value Value to set for the webLink property.
     */
    set webLink(value) {
        this._webLink = value;
    }
    ;
}
exports.Event = Event;
