"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExtensionProperty = void 0;
const index_1 = require("./index");
class ExtensionProperty extends index_1.DirectoryObject {
    /**
     * Instantiates a new extensionProperty and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the appDisplayName property value. Display name of the application object on which this extension property is defined. Read-only.
     * @returns a string
     */
    get appDisplayName() {
        return this._appDisplayName;
    }
    ;
    /**
     * Sets the appDisplayName property value. Display name of the application object on which this extension property is defined. Read-only.
     * @param value Value to set for the appDisplayName property.
     */
    set appDisplayName(value) {
        this._appDisplayName = value;
    }
    ;
    ;
    /**
     * Gets the dataType property value. Specifies the data type of the value the extension property can hold. Following values are supported. Not nullable. Binary - 256 bytes maximumBooleanDateTime - Must be specified in ISO 8601 format. Will be stored in UTC.Integer - 32-bit value.LargeInteger - 64-bit value.String - 256 characters maximum
     * @returns a string
     */
    get dataType() {
        return this._dataType;
    }
    ;
    /**
     * Sets the dataType property value. Specifies the data type of the value the extension property can hold. Following values are supported. Not nullable. Binary - 256 bytes maximumBooleanDateTime - Must be specified in ISO 8601 format. Will be stored in UTC.Integer - 32-bit value.LargeInteger - 64-bit value.String - 256 characters maximum
     * @param value Value to set for the dataType property.
     */
    set dataType(value) {
        this._dataType = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "appDisplayName": (o, n) => { o.appDisplayName = n.getStringValue(); }, "dataType": (o, n) => { o.dataType = n.getStringValue(); }, "isSyncedFromOnPremises": (o, n) => { o.isSyncedFromOnPremises = n.getBooleanValue(); }, "name": (o, n) => { o.name = n.getStringValue(); }, "targetObjects": (o, n) => { o.targetObjects = n.getCollectionOfPrimitiveValues(); } });
    }
    ;
    /**
     * Gets the isSyncedFromOnPremises property value. Indicates if this extension property was synced from on-premises active directory using Azure AD Connect. Read-only.
     * @returns a boolean
     */
    get isSyncedFromOnPremises() {
        return this._isSyncedFromOnPremises;
    }
    ;
    /**
     * Sets the isSyncedFromOnPremises property value. Indicates if this extension property was synced from on-premises active directory using Azure AD Connect. Read-only.
     * @param value Value to set for the isSyncedFromOnPremises property.
     */
    set isSyncedFromOnPremises(value) {
        this._isSyncedFromOnPremises = value;
    }
    ;
    /**
     * Gets the name property value. Name of the extension property. Not nullable.
     * @returns a string
     */
    get name() {
        return this._name;
    }
    ;
    /**
     * Sets the name property value. Name of the extension property. Not nullable.
     * @param value Value to set for the name property.
     */
    set name(value) {
        this._name = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("appDisplayName", this.appDisplayName);
        writer.writeStringValue("dataType", this.dataType);
        writer.writeBooleanValue("isSyncedFromOnPremises", this.isSyncedFromOnPremises);
        writer.writeStringValue("name", this.name);
        writer.writeCollectionOfPrimitiveValues("targetObjects", this.targetObjects);
    }
    ;
    /**
     * Gets the targetObjects property value. Following values are supported. Not nullable. UserGroupOrganizationDeviceApplication
     * @returns a string
     */
    get targetObjects() {
        return this._targetObjects;
    }
    ;
    /**
     * Sets the targetObjects property value. Following values are supported. Not nullable. UserGroupOrganizationDeviceApplication
     * @param value Value to set for the targetObjects property.
     */
    set targetObjects(value) {
        this._targetObjects = value;
    }
    ;
}
exports.ExtensionProperty = ExtensionProperty;
