import { Entity, PublicError } from '../';
import { ConnectionOperationStatus } from './connectionOperationStatus';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ConnectionOperation extends Entity implements Parsable {
    /** If status is failed, provides more information about the error that caused the failure.  */
    private _error_escaped?;
    /** Indicates the status of the asynchronous operation. Possible values are: unspecified, inprogress, completed, failed, unknownFutureValue.  */
    private _status?;
    /**
     * Instantiates a new connectionOperation and sets the default values.
     */
    constructor();
    /**
     * Gets the error property value. If status is failed, provides more information about the error that caused the failure.
     * @returns a publicError
     */
    get error_escaped(): PublicError | undefined;
    /**
     * Sets the error property value. If status is failed, provides more information about the error that caused the failure.
     * @param value Value to set for the error_escaped property.
     */
    set error_escaped(value: PublicError | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the status property value. Indicates the status of the asynchronous operation. Possible values are: unspecified, inprogress, completed, failed, unknownFutureValue.
     * @returns a connectionOperationStatus
     */
    get status(): ConnectionOperationStatus | undefined;
    /**
     * Sets the status property value. Indicates the status of the asynchronous operation. Possible values are: unspecified, inprogress, completed, failed, unknownFutureValue.
     * @param value Value to set for the status property.
     */
    set status(value: ConnectionOperationStatus | undefined);
}
