"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.External = void 0;
const createExternalConnectionFromDiscriminatorValue_1 = require("./createExternalConnectionFromDiscriminatorValue");
class External {
    /**
     * Instantiates a new External and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the connections property value.
     * @returns a externalConnection
     */
    get connections() {
        return this._connections;
    }
    ;
    /**
     * Sets the connections property value.
     * @param value Value to set for the connections property.
     */
    set connections(value) {
        this._connections = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "connections": (o, n) => { o.connections = n.getCollectionOfObjectValues(createExternalConnectionFromDiscriminatorValue_1.createExternalConnectionFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfObjectValues("connections", this.connections);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.External = External;
