"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExternalGroup = void 0;
const __1 = require("../");
const createIdentityFromDiscriminatorValue_1 = require("./createIdentityFromDiscriminatorValue");
class ExternalGroup extends __1.Entity {
    /**
     * Instantiates a new externalGroup and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the description property value. The description of the external group. Optional.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. The description of the external group. Optional.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the displayName property value. The friendly name of the external group. Optional.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The friendly name of the external group. Optional.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "description": (o, n) => { o.description = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "members": (o, n) => { o.members = n.getCollectionOfObjectValues(createIdentityFromDiscriminatorValue_1.createIdentityFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the members property value. A member added to an externalGroup. You can add Azure Active Directory users, Azure Active Directory groups, or an externalGroup as members.
     * @returns a identity
     */
    get members() {
        return this._members;
    }
    ;
    /**
     * Sets the members property value. A member added to an externalGroup. You can add Azure Active Directory users, Azure Active Directory groups, or an externalGroup as members.
     * @param value Value to set for the members property.
     */
    set members(value) {
        this._members = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("description", this.description);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeCollectionOfObjectValues("members", this.members);
    }
    ;
}
exports.ExternalGroup = ExternalGroup;
