import { Entity } from '../';
import { IdentityType } from './identityType';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class Identity extends Entity implements Parsable {
    /** The type of identity. Possible values are: user or group for Azure AD identities and externalgroup for groups in an external system.  */
    private _type?;
    /**
     * Instantiates a new identity and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the type property value. The type of identity. Possible values are: user or group for Azure AD identities and externalgroup for groups in an external system.
     * @returns a identityType
     */
    get type(): IdentityType | undefined;
    /**
     * Sets the type property value. The type of identity. Possible values are: user or group for Azure AD identities and externalgroup for groups in an external system.
     * @param value Value to set for the type property.
     */
    set type(value: IdentityType | undefined);
}
