"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Property = void 0;
const label_1 = require("./label");
const propertyType_1 = require("./propertyType");
class Property {
    /**
     * Instantiates a new property and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the aliases property value. A set of aliases or a friendly names for the property. Maximum 32 characters. Only alphanumeric characters allowed. For example, each string may not contain control characters, whitespace, or any of the following: :, ;, ,, (, ), [, ], {, }, %, $, +, !, *, =, &, ?, @, #, /, ~, ', ', <, >, `, ^. Optional.
     * @returns a string
     */
    get aliases() {
        return this._aliases;
    }
    ;
    /**
     * Sets the aliases property value. A set of aliases or a friendly names for the property. Maximum 32 characters. Only alphanumeric characters allowed. For example, each string may not contain control characters, whitespace, or any of the following: :, ;, ,, (, ), [, ], {, }, %, $, +, !, *, =, &, ?, @, #, /, ~, ', ', <, >, `, ^. Optional.
     * @param value Value to set for the aliases property.
     */
    set aliases(value) {
        this._aliases = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "aliases": (o, n) => { o.aliases = n.getCollectionOfPrimitiveValues(); },
            "isQueryable": (o, n) => { o.isQueryable = n.getBooleanValue(); },
            "isRefinable": (o, n) => { o.isRefinable = n.getBooleanValue(); },
            "isRetrievable": (o, n) => { o.isRetrievable = n.getBooleanValue(); },
            "isSearchable": (o, n) => { o.isSearchable = n.getBooleanValue(); },
            "labels": (o, n) => { o.labels = n.getEnumValues(label_1.Label); },
            "name": (o, n) => { o.name = n.getStringValue(); },
            "type": (o, n) => { o.type = n.getEnumValue(propertyType_1.PropertyType); },
        };
    }
    ;
    /**
     * Gets the isQueryable property value. Specifies if the property is queryable. Queryable properties can be used in Keyword Query Language (KQL) queries. Optional.
     * @returns a boolean
     */
    get isQueryable() {
        return this._isQueryable;
    }
    ;
    /**
     * Sets the isQueryable property value. Specifies if the property is queryable. Queryable properties can be used in Keyword Query Language (KQL) queries. Optional.
     * @param value Value to set for the isQueryable property.
     */
    set isQueryable(value) {
        this._isQueryable = value;
    }
    ;
    /**
     * Gets the isRefinable property value. Specifies if the property is refinable.  Refinable properties can be used to filter search results in the Search API and add a refiner control in the Microsoft Search user experience. Optional.
     * @returns a boolean
     */
    get isRefinable() {
        return this._isRefinable;
    }
    ;
    /**
     * Sets the isRefinable property value. Specifies if the property is refinable.  Refinable properties can be used to filter search results in the Search API and add a refiner control in the Microsoft Search user experience. Optional.
     * @param value Value to set for the isRefinable property.
     */
    set isRefinable(value) {
        this._isRefinable = value;
    }
    ;
    /**
     * Gets the isRetrievable property value. Specifies if the property is retrievable. Retrievable properties are returned in the result set when items are returned by the search API. Retrievable properties are also available to add to the display template used to render search results. Optional.
     * @returns a boolean
     */
    get isRetrievable() {
        return this._isRetrievable;
    }
    ;
    /**
     * Sets the isRetrievable property value. Specifies if the property is retrievable. Retrievable properties are returned in the result set when items are returned by the search API. Retrievable properties are also available to add to the display template used to render search results. Optional.
     * @param value Value to set for the isRetrievable property.
     */
    set isRetrievable(value) {
        this._isRetrievable = value;
    }
    ;
    /**
     * Gets the isSearchable property value. Specifies if the property is searchable. Only properties of type String or StringCollection can be searchable. Non-searchable properties are not added to the search index. Optional.
     * @returns a boolean
     */
    get isSearchable() {
        return this._isSearchable;
    }
    ;
    /**
     * Sets the isSearchable property value. Specifies if the property is searchable. Only properties of type String or StringCollection can be searchable. Non-searchable properties are not added to the search index. Optional.
     * @param value Value to set for the isSearchable property.
     */
    set isSearchable(value) {
        this._isSearchable = value;
    }
    ;
    /**
     * Gets the labels property value. Specifies one or more well-known tags added against a property. Labels help Microsoft Search understand the semantics of the data in the connection. Adding appropriate labels would result in an enhanced search experience (e.g. better relevance). The possible values are: title, url, createdBy, lastModifiedBy, authors, createdDateTime, lastModifiedDateTime, fileName, fileExtension, unknownFutureValue. Optional.
     * @returns a label
     */
    get labels() {
        return this._labels;
    }
    ;
    /**
     * Sets the labels property value. Specifies one or more well-known tags added against a property. Labels help Microsoft Search understand the semantics of the data in the connection. Adding appropriate labels would result in an enhanced search experience (e.g. better relevance). The possible values are: title, url, createdBy, lastModifiedBy, authors, createdDateTime, lastModifiedDateTime, fileName, fileExtension, unknownFutureValue. Optional.
     * @param value Value to set for the labels property.
     */
    set labels(value) {
        this._labels = value;
    }
    ;
    /**
     * Gets the name property value. The name of the property. Maximum 32 characters. Only alphanumeric characters allowed. For example, each string may not contain control characters, whitespace, or any of the following: :, ;, ,, (, ), [, ], {, }, %, $, +, !, *, =, &, ?, @, #, /, ~, ', ', <, >, `, ^.  Required.
     * @returns a string
     */
    get name() {
        return this._name;
    }
    ;
    /**
     * Sets the name property value. The name of the property. Maximum 32 characters. Only alphanumeric characters allowed. For example, each string may not contain control characters, whitespace, or any of the following: :, ;, ,, (, ), [, ], {, }, %, $, +, !, *, =, &, ?, @, #, /, ~, ', ', <, >, `, ^.  Required.
     * @param value Value to set for the name property.
     */
    set name(value) {
        this._name = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfPrimitiveValues("aliases", this.aliases);
        writer.writeBooleanValue("isQueryable", this.isQueryable);
        writer.writeBooleanValue("isRefinable", this.isRefinable);
        writer.writeBooleanValue("isRetrievable", this.isRetrievable);
        writer.writeBooleanValue("isSearchable", this.isSearchable);
        this.labels && writer.writeEnumValue("labels", ...this.labels);
        writer.writeStringValue("name", this.name);
        writer.writeEnumValue("type", this.type);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the type property value. The data type of the property. Possible values are: string, int64, double, dateTime, boolean, stringCollection, int64Collection, doubleCollection, dateTimeCollection, unknownFutureValue.
     * @returns a propertyType
     */
    get type() {
        return this._type;
    }
    ;
    /**
     * Sets the type property value. The data type of the property. Possible values are: string, int64, double, dateTime, boolean, stringCollection, int64Collection, doubleCollection, dateTimeCollection, unknownFutureValue.
     * @param value Value to set for the type property.
     */
    set type(value) {
        this._type = value;
    }
    ;
}
exports.Property = Property;
