"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Schema = void 0;
const __1 = require("../");
const createPropertyFromDiscriminatorValue_1 = require("./createPropertyFromDiscriminatorValue");
class Schema extends __1.Entity {
    /**
     * Instantiates a new schema and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the baseType property value. Must be set to microsoft.graph.externalConnector.externalItem. Required.
     * @returns a string
     */
    get baseType() {
        return this._baseType;
    }
    ;
    /**
     * Sets the baseType property value. Must be set to microsoft.graph.externalConnector.externalItem. Required.
     * @param value Value to set for the baseType property.
     */
    set baseType(value) {
        this._baseType = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "baseType": (o, n) => { o.baseType = n.getStringValue(); }, "properties": (o, n) => { o.properties = n.getCollectionOfObjectValues(createPropertyFromDiscriminatorValue_1.createPropertyFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the properties property value. The properties defined for the items in the connection. The minimum number of properties is one, the maximum is 128.
     * @returns a property
     */
    get properties() {
        return this._properties;
    }
    ;
    /**
     * Sets the properties property value. The properties defined for the items in the connection. The minimum number of properties is one, the maximum is 128.
     * @param value Value to set for the properties property.
     */
    set properties(value) {
        this._properties = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("baseType", this.baseType);
        writer.writeCollectionOfObjectValues("properties", this.properties);
    }
    ;
}
exports.Schema = Schema;
