import { DirectoryObject, Entity } from './index';
import { StagedFeatureName } from './stagedFeatureName';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class FeatureRolloutPolicy extends Entity implements Parsable {
    /** Nullable. Specifies a list of directoryObjects that feature is enabled for.  */
    private _appliesTo?;
    /** A description for this feature rollout policy.  */
    private _description?;
    /** The display name for this  feature rollout policy.  */
    private _displayName?;
    /** Possible values are: passthroughAuthentication, seamlessSso, passwordHashSync, emailAsAlternateId, unknownFutureValue.  */
    private _feature?;
    /** Indicates whether this feature rollout policy should be applied to the entire organization.  */
    private _isAppliedToOrganization?;
    /** Indicates whether the feature rollout is enabled.  */
    private _isEnabled?;
    /**
     * Gets the appliesTo property value. Nullable. Specifies a list of directoryObjects that feature is enabled for.
     * @returns a directoryObject
     */
    get appliesTo(): DirectoryObject[] | undefined;
    /**
     * Sets the appliesTo property value. Nullable. Specifies a list of directoryObjects that feature is enabled for.
     * @param value Value to set for the appliesTo property.
     */
    set appliesTo(value: DirectoryObject[] | undefined);
    /**
     * Instantiates a new featureRolloutPolicy and sets the default values.
     */
    constructor();
    /**
     * Gets the description property value. A description for this feature rollout policy.
     * @returns a string
     */
    get description(): string | undefined;
    /**
     * Sets the description property value. A description for this feature rollout policy.
     * @param value Value to set for the description property.
     */
    set description(value: string | undefined);
    /**
     * Gets the displayName property value. The display name for this  feature rollout policy.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. The display name for this  feature rollout policy.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * Gets the feature property value. Possible values are: passthroughAuthentication, seamlessSso, passwordHashSync, emailAsAlternateId, unknownFutureValue.
     * @returns a stagedFeatureName
     */
    get feature(): StagedFeatureName | undefined;
    /**
     * Sets the feature property value. Possible values are: passthroughAuthentication, seamlessSso, passwordHashSync, emailAsAlternateId, unknownFutureValue.
     * @param value Value to set for the feature property.
     */
    set feature(value: StagedFeatureName | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the isAppliedToOrganization property value. Indicates whether this feature rollout policy should be applied to the entire organization.
     * @returns a boolean
     */
    get isAppliedToOrganization(): boolean | undefined;
    /**
     * Sets the isAppliedToOrganization property value. Indicates whether this feature rollout policy should be applied to the entire organization.
     * @param value Value to set for the isAppliedToOrganization property.
     */
    set isAppliedToOrganization(value: boolean | undefined);
    /**
     * Gets the isEnabled property value. Indicates whether the feature rollout is enabled.
     * @returns a boolean
     */
    get isEnabled(): boolean | undefined;
    /**
     * Sets the isEnabled property value. Indicates whether the feature rollout is enabled.
     * @param value Value to set for the isEnabled property.
     */
    set isEnabled(value: boolean | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
