"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FeatureRolloutPolicy = void 0;
const createDirectoryObjectFromDiscriminatorValue_1 = require("./createDirectoryObjectFromDiscriminatorValue");
const index_1 = require("./index");
const stagedFeatureName_1 = require("./stagedFeatureName");
class FeatureRolloutPolicy extends index_1.Entity {
    /**
     * Instantiates a new featureRolloutPolicy and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the appliesTo property value. Nullable. Specifies a list of directoryObjects that feature is enabled for.
     * @returns a directoryObject
     */
    get appliesTo() {
        return this._appliesTo;
    }
    ;
    /**
     * Sets the appliesTo property value. Nullable. Specifies a list of directoryObjects that feature is enabled for.
     * @param value Value to set for the appliesTo property.
     */
    set appliesTo(value) {
        this._appliesTo = value;
    }
    ;
    ;
    /**
     * Gets the description property value. A description for this feature rollout policy.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. A description for this feature rollout policy.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the displayName property value. The display name for this  feature rollout policy.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The display name for this  feature rollout policy.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * Gets the feature property value. Possible values are: passthroughAuthentication, seamlessSso, passwordHashSync, emailAsAlternateId, unknownFutureValue.
     * @returns a stagedFeatureName
     */
    get feature() {
        return this._feature;
    }
    ;
    /**
     * Sets the feature property value. Possible values are: passthroughAuthentication, seamlessSso, passwordHashSync, emailAsAlternateId, unknownFutureValue.
     * @param value Value to set for the feature property.
     */
    set feature(value) {
        this._feature = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "appliesTo": (o, n) => { o.appliesTo = n.getCollectionOfObjectValues(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "description": (o, n) => { o.description = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "feature": (o, n) => { o.feature = n.getEnumValue(stagedFeatureName_1.StagedFeatureName); }, "isAppliedToOrganization": (o, n) => { o.isAppliedToOrganization = n.getBooleanValue(); }, "isEnabled": (o, n) => { o.isEnabled = n.getBooleanValue(); } });
    }
    ;
    /**
     * Gets the isAppliedToOrganization property value. Indicates whether this feature rollout policy should be applied to the entire organization.
     * @returns a boolean
     */
    get isAppliedToOrganization() {
        return this._isAppliedToOrganization;
    }
    ;
    /**
     * Sets the isAppliedToOrganization property value. Indicates whether this feature rollout policy should be applied to the entire organization.
     * @param value Value to set for the isAppliedToOrganization property.
     */
    set isAppliedToOrganization(value) {
        this._isAppliedToOrganization = value;
    }
    ;
    /**
     * Gets the isEnabled property value. Indicates whether the feature rollout is enabled.
     * @returns a boolean
     */
    get isEnabled() {
        return this._isEnabled;
    }
    ;
    /**
     * Sets the isEnabled property value. Indicates whether the feature rollout is enabled.
     * @param value Value to set for the isEnabled property.
     */
    set isEnabled(value) {
        this._isEnabled = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("appliesTo", this.appliesTo);
        writer.writeStringValue("description", this.description);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeEnumValue("feature", this.feature);
        writer.writeBooleanValue("isAppliedToOrganization", this.isAppliedToOrganization);
        writer.writeBooleanValue("isEnabled", this.isEnabled);
    }
    ;
}
exports.FeatureRolloutPolicy = FeatureRolloutPolicy;
