"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FolderView = void 0;
class FolderView {
    /**
     * Instantiates a new folderView and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "sortBy": (o, n) => { o.sortBy = n.getStringValue(); },
            "sortOrder": (o, n) => { o.sortOrder = n.getStringValue(); },
            "viewType": (o, n) => { o.viewType = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("sortBy", this.sortBy);
        writer.writeStringValue("sortOrder", this.sortOrder);
        writer.writeStringValue("viewType", this.viewType);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the sortBy property value. The method by which the folder should be sorted.
     * @returns a string
     */
    get sortBy() {
        return this._sortBy;
    }
    ;
    /**
     * Sets the sortBy property value. The method by which the folder should be sorted.
     * @param value Value to set for the sortBy property.
     */
    set sortBy(value) {
        this._sortBy = value;
    }
    ;
    /**
     * Gets the sortOrder property value. If true, indicates that items should be sorted in descending order. Otherwise, items should be sorted ascending.
     * @returns a string
     */
    get sortOrder() {
        return this._sortOrder;
    }
    ;
    /**
     * Sets the sortOrder property value. If true, indicates that items should be sorted in descending order. Otherwise, items should be sorted ascending.
     * @param value Value to set for the sortOrder property.
     */
    set sortOrder(value) {
        this._sortOrder = value;
    }
    ;
    /**
     * Gets the viewType property value. The type of view that should be used to represent the folder.
     * @returns a string
     */
    get viewType() {
        return this._viewType;
    }
    ;
    /**
     * Sets the viewType property value. The type of view that should be used to represent the folder.
     * @param value Value to set for the viewType property.
     */
    set viewType(value) {
        this._viewType = value;
    }
    ;
}
exports.FolderView = FolderView;
