"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FreeBusyError = void 0;
class FreeBusyError {
    /**
     * Instantiates a new freeBusyError and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "message": (o, n) => { o.message = n.getStringValue(); },
            "responseCode": (o, n) => { o.responseCode = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the message property value. Describes the error.
     * @returns a string
     */
    get message() {
        return this._message;
    }
    ;
    /**
     * Sets the message property value. Describes the error.
     * @param value Value to set for the message property.
     */
    set message(value) {
        this._message = value;
    }
    ;
    /**
     * Gets the responseCode property value. The response code from querying for the availability of the user, distribution list, or resource.
     * @returns a string
     */
    get responseCode() {
        return this._responseCode;
    }
    ;
    /**
     * Sets the responseCode property value. The response code from querying for the availability of the user, distribution list, or resource.
     * @param value Value to set for the responseCode property.
     */
    set responseCode(value) {
        this._responseCode = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("message", this.message);
        writer.writeStringValue("responseCode", this.responseCode);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.FreeBusyError = FreeBusyError;
