"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GroupLifecyclePolicy = void 0;
const index_1 = require("./index");
class GroupLifecyclePolicy extends index_1.Entity {
    /**
     * Instantiates a new groupLifecyclePolicy and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the alternateNotificationEmails property value. List of email address to send notifications for groups without owners. Multiple email address can be defined by separating email address with a semicolon.
     * @returns a string
     */
    get alternateNotificationEmails() {
        return this._alternateNotificationEmails;
    }
    ;
    /**
     * Sets the alternateNotificationEmails property value. List of email address to send notifications for groups without owners. Multiple email address can be defined by separating email address with a semicolon.
     * @param value Value to set for the alternateNotificationEmails property.
     */
    set alternateNotificationEmails(value) {
        this._alternateNotificationEmails = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "alternateNotificationEmails": (o, n) => { o.alternateNotificationEmails = n.getStringValue(); }, "groupLifetimeInDays": (o, n) => { o.groupLifetimeInDays = n.getNumberValue(); }, "managedGroupTypes": (o, n) => { o.managedGroupTypes = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the groupLifetimeInDays property value. Number of days before a group expires and needs to be renewed. Once renewed, the group expiration is extended by the number of days defined.
     * @returns a integer
     */
    get groupLifetimeInDays() {
        return this._groupLifetimeInDays;
    }
    ;
    /**
     * Sets the groupLifetimeInDays property value. Number of days before a group expires and needs to be renewed. Once renewed, the group expiration is extended by the number of days defined.
     * @param value Value to set for the groupLifetimeInDays property.
     */
    set groupLifetimeInDays(value) {
        this._groupLifetimeInDays = value;
    }
    ;
    /**
     * Gets the managedGroupTypes property value. The group type for which the expiration policy applies. Possible values are All, Selected or None.
     * @returns a string
     */
    get managedGroupTypes() {
        return this._managedGroupTypes;
    }
    ;
    /**
     * Sets the managedGroupTypes property value. The group type for which the expiration policy applies. Possible values are All, Selected or None.
     * @param value Value to set for the managedGroupTypes property.
     */
    set managedGroupTypes(value) {
        this._managedGroupTypes = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("alternateNotificationEmails", this.alternateNotificationEmails);
        writer.writeNumberValue("groupLifetimeInDays", this.groupLifetimeInDays);
        writer.writeStringValue("managedGroupTypes", this.managedGroupTypes);
    }
    ;
}
exports.GroupLifecyclePolicy = GroupLifecyclePolicy;
