import { DirectoryObject, SettingTemplateValue } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class GroupSettingTemplate extends DirectoryObject implements Parsable {
    /** Description of the template.  */
    private _description?;
    /** Display name of the template. The template named Group.Unified can be used to configure tenant-wide Microsoft 365 group settings, while the template named Group.Unified.Guest can be used to configure group-specific settings.  */
    private _displayName?;
    /** Collection of settingTemplateValues that list the set of available settings, defaults and types that make up this template.  */
    private _values?;
    /**
     * Instantiates a new groupSettingTemplate and sets the default values.
     */
    constructor();
    /**
     * Gets the description property value. Description of the template.
     * @returns a string
     */
    get description(): string | undefined;
    /**
     * Sets the description property value. Description of the template.
     * @param value Value to set for the description property.
     */
    set description(value: string | undefined);
    /**
     * Gets the displayName property value. Display name of the template. The template named Group.Unified can be used to configure tenant-wide Microsoft 365 group settings, while the template named Group.Unified.Guest can be used to configure group-specific settings.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. Display name of the template. The template named Group.Unified can be used to configure tenant-wide Microsoft 365 group settings, while the template named Group.Unified.Guest can be used to configure group-specific settings.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the values property value. Collection of settingTemplateValues that list the set of available settings, defaults and types that make up this template.
     * @returns a settingTemplateValue
     */
    get values(): SettingTemplateValue[] | undefined;
    /**
     * Sets the values property value. Collection of settingTemplateValues that list the set of available settings, defaults and types that make up this template.
     * @param value Value to set for the values property.
     */
    set values(value: SettingTemplateValue[] | undefined);
}
