"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Hashes = void 0;
class Hashes {
    /**
     * Instantiates a new hashes and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the crc32Hash property value. The CRC32 value of the file in little endian (if available). Read-only.
     * @returns a string
     */
    get crc32Hash() {
        return this._crc32Hash;
    }
    ;
    /**
     * Sets the crc32Hash property value. The CRC32 value of the file in little endian (if available). Read-only.
     * @param value Value to set for the crc32Hash property.
     */
    set crc32Hash(value) {
        this._crc32Hash = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "crc32Hash": (o, n) => { o.crc32Hash = n.getStringValue(); },
            "quickXorHash": (o, n) => { o.quickXorHash = n.getStringValue(); },
            "sha1Hash": (o, n) => { o.sha1Hash = n.getStringValue(); },
            "sha256Hash": (o, n) => { o.sha256Hash = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the quickXorHash property value. A proprietary hash of the file that can be used to determine if the contents of the file have changed (if available). Read-only.
     * @returns a string
     */
    get quickXorHash() {
        return this._quickXorHash;
    }
    ;
    /**
     * Sets the quickXorHash property value. A proprietary hash of the file that can be used to determine if the contents of the file have changed (if available). Read-only.
     * @param value Value to set for the quickXorHash property.
     */
    set quickXorHash(value) {
        this._quickXorHash = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("crc32Hash", this.crc32Hash);
        writer.writeStringValue("quickXorHash", this.quickXorHash);
        writer.writeStringValue("sha1Hash", this.sha1Hash);
        writer.writeStringValue("sha256Hash", this.sha256Hash);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the sha1Hash property value. SHA1 hash for the contents of the file (if available). Read-only.
     * @returns a string
     */
    get sha1Hash() {
        return this._sha1Hash;
    }
    ;
    /**
     * Sets the sha1Hash property value. SHA1 hash for the contents of the file (if available). Read-only.
     * @param value Value to set for the sha1Hash property.
     */
    set sha1Hash(value) {
        this._sha1Hash = value;
    }
    ;
    /**
     * Gets the sha256Hash property value. SHA256 hash for the contents of the file (if available). Read-only.
     * @returns a string
     */
    get sha256Hash() {
        return this._sha256Hash;
    }
    ;
    /**
     * Sets the sha256Hash property value. SHA256 hash for the contents of the file (if available). Read-only.
     * @param value Value to set for the sha256Hash property.
     */
    set sha256Hash(value) {
        this._sha256Hash = value;
    }
    ;
}
exports.Hashes = Hashes;
