import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class HostSecurityState implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Host FQDN (Fully Qualified Domain Name) (for example, machine.company.com).  */
    private _fqdn?;
    private _isAzureAdJoined?;
    private _isAzureAdRegistered?;
    /** True if the host is domain joined to an on-premises Active Directory domain.  */
    private _isHybridAzureDomainJoined?;
    /** The local host name, without the DNS domain name.  */
    private _netBiosName?;
    /** Host Operating System. (For example, Windows10, MacOS, RHEL, etc.).  */
    private _os?;
    /** Private (not routable) IPv4 or IPv6 address (see RFC 1918) at the time of the alert.  */
    private _privateIpAddress?;
    /** Publicly routable IPv4 or IPv6 address (see RFC 1918) at time of the alert.  */
    private _publicIpAddress?;
    /** Provider-generated/calculated risk score of the host.  Recommended value range of 0-1, which equates to a percentage.  */
    private _riskScore?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new hostSecurityState and sets the default values.
     */
    constructor();
    /**
     * Gets the fqdn property value. Host FQDN (Fully Qualified Domain Name) (for example, machine.company.com).
     * @returns a string
     */
    get fqdn(): string | undefined;
    /**
     * Sets the fqdn property value. Host FQDN (Fully Qualified Domain Name) (for example, machine.company.com).
     * @param value Value to set for the fqdn property.
     */
    set fqdn(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the isAzureAdJoined property value.
     * @returns a boolean
     */
    get isAzureAdJoined(): boolean | undefined;
    /**
     * Sets the isAzureAdJoined property value.
     * @param value Value to set for the isAzureAdJoined property.
     */
    set isAzureAdJoined(value: boolean | undefined);
    /**
     * Gets the isAzureAdRegistered property value.
     * @returns a boolean
     */
    get isAzureAdRegistered(): boolean | undefined;
    /**
     * Sets the isAzureAdRegistered property value.
     * @param value Value to set for the isAzureAdRegistered property.
     */
    set isAzureAdRegistered(value: boolean | undefined);
    /**
     * Gets the isHybridAzureDomainJoined property value. True if the host is domain joined to an on-premises Active Directory domain.
     * @returns a boolean
     */
    get isHybridAzureDomainJoined(): boolean | undefined;
    /**
     * Sets the isHybridAzureDomainJoined property value. True if the host is domain joined to an on-premises Active Directory domain.
     * @param value Value to set for the isHybridAzureDomainJoined property.
     */
    set isHybridAzureDomainJoined(value: boolean | undefined);
    /**
     * Gets the netBiosName property value. The local host name, without the DNS domain name.
     * @returns a string
     */
    get netBiosName(): string | undefined;
    /**
     * Sets the netBiosName property value. The local host name, without the DNS domain name.
     * @param value Value to set for the netBiosName property.
     */
    set netBiosName(value: string | undefined);
    /**
     * Gets the os property value. Host Operating System. (For example, Windows10, MacOS, RHEL, etc.).
     * @returns a string
     */
    get os(): string | undefined;
    /**
     * Sets the os property value. Host Operating System. (For example, Windows10, MacOS, RHEL, etc.).
     * @param value Value to set for the os property.
     */
    set os(value: string | undefined);
    /**
     * Gets the privateIpAddress property value. Private (not routable) IPv4 or IPv6 address (see RFC 1918) at the time of the alert.
     * @returns a string
     */
    get privateIpAddress(): string | undefined;
    /**
     * Sets the privateIpAddress property value. Private (not routable) IPv4 or IPv6 address (see RFC 1918) at the time of the alert.
     * @param value Value to set for the privateIpAddress property.
     */
    set privateIpAddress(value: string | undefined);
    /**
     * Gets the publicIpAddress property value. Publicly routable IPv4 or IPv6 address (see RFC 1918) at time of the alert.
     * @returns a string
     */
    get publicIpAddress(): string | undefined;
    /**
     * Sets the publicIpAddress property value. Publicly routable IPv4 or IPv6 address (see RFC 1918) at time of the alert.
     * @param value Value to set for the publicIpAddress property.
     */
    set publicIpAddress(value: string | undefined);
    /**
     * Gets the riskScore property value. Provider-generated/calculated risk score of the host.  Recommended value range of 0-1, which equates to a percentage.
     * @returns a string
     */
    get riskScore(): string | undefined;
    /**
     * Sets the riskScore property value. Provider-generated/calculated risk score of the host.  Recommended value range of 0-1, which equates to a percentage.
     * @param value Value to set for the riskScore property.
     */
    set riskScore(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
