"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HostSecurityState = void 0;
class HostSecurityState {
    /**
     * Instantiates a new hostSecurityState and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the fqdn property value. Host FQDN (Fully Qualified Domain Name) (for example, machine.company.com).
     * @returns a string
     */
    get fqdn() {
        return this._fqdn;
    }
    ;
    /**
     * Sets the fqdn property value. Host FQDN (Fully Qualified Domain Name) (for example, machine.company.com).
     * @param value Value to set for the fqdn property.
     */
    set fqdn(value) {
        this._fqdn = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "fqdn": (o, n) => { o.fqdn = n.getStringValue(); },
            "isAzureAdJoined": (o, n) => { o.isAzureAdJoined = n.getBooleanValue(); },
            "isAzureAdRegistered": (o, n) => { o.isAzureAdRegistered = n.getBooleanValue(); },
            "isHybridAzureDomainJoined": (o, n) => { o.isHybridAzureDomainJoined = n.getBooleanValue(); },
            "netBiosName": (o, n) => { o.netBiosName = n.getStringValue(); },
            "os": (o, n) => { o.os = n.getStringValue(); },
            "privateIpAddress": (o, n) => { o.privateIpAddress = n.getStringValue(); },
            "publicIpAddress": (o, n) => { o.publicIpAddress = n.getStringValue(); },
            "riskScore": (o, n) => { o.riskScore = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the isAzureAdJoined property value.
     * @returns a boolean
     */
    get isAzureAdJoined() {
        return this._isAzureAdJoined;
    }
    ;
    /**
     * Sets the isAzureAdJoined property value.
     * @param value Value to set for the isAzureAdJoined property.
     */
    set isAzureAdJoined(value) {
        this._isAzureAdJoined = value;
    }
    ;
    /**
     * Gets the isAzureAdRegistered property value.
     * @returns a boolean
     */
    get isAzureAdRegistered() {
        return this._isAzureAdRegistered;
    }
    ;
    /**
     * Sets the isAzureAdRegistered property value.
     * @param value Value to set for the isAzureAdRegistered property.
     */
    set isAzureAdRegistered(value) {
        this._isAzureAdRegistered = value;
    }
    ;
    /**
     * Gets the isHybridAzureDomainJoined property value. True if the host is domain joined to an on-premises Active Directory domain.
     * @returns a boolean
     */
    get isHybridAzureDomainJoined() {
        return this._isHybridAzureDomainJoined;
    }
    ;
    /**
     * Sets the isHybridAzureDomainJoined property value. True if the host is domain joined to an on-premises Active Directory domain.
     * @param value Value to set for the isHybridAzureDomainJoined property.
     */
    set isHybridAzureDomainJoined(value) {
        this._isHybridAzureDomainJoined = value;
    }
    ;
    /**
     * Gets the netBiosName property value. The local host name, without the DNS domain name.
     * @returns a string
     */
    get netBiosName() {
        return this._netBiosName;
    }
    ;
    /**
     * Sets the netBiosName property value. The local host name, without the DNS domain name.
     * @param value Value to set for the netBiosName property.
     */
    set netBiosName(value) {
        this._netBiosName = value;
    }
    ;
    /**
     * Gets the os property value. Host Operating System. (For example, Windows10, MacOS, RHEL, etc.).
     * @returns a string
     */
    get os() {
        return this._os;
    }
    ;
    /**
     * Sets the os property value. Host Operating System. (For example, Windows10, MacOS, RHEL, etc.).
     * @param value Value to set for the os property.
     */
    set os(value) {
        this._os = value;
    }
    ;
    /**
     * Gets the privateIpAddress property value. Private (not routable) IPv4 or IPv6 address (see RFC 1918) at the time of the alert.
     * @returns a string
     */
    get privateIpAddress() {
        return this._privateIpAddress;
    }
    ;
    /**
     * Sets the privateIpAddress property value. Private (not routable) IPv4 or IPv6 address (see RFC 1918) at the time of the alert.
     * @param value Value to set for the privateIpAddress property.
     */
    set privateIpAddress(value) {
        this._privateIpAddress = value;
    }
    ;
    /**
     * Gets the publicIpAddress property value. Publicly routable IPv4 or IPv6 address (see RFC 1918) at time of the alert.
     * @returns a string
     */
    get publicIpAddress() {
        return this._publicIpAddress;
    }
    ;
    /**
     * Sets the publicIpAddress property value. Publicly routable IPv4 or IPv6 address (see RFC 1918) at time of the alert.
     * @param value Value to set for the publicIpAddress property.
     */
    set publicIpAddress(value) {
        this._publicIpAddress = value;
    }
    ;
    /**
     * Gets the riskScore property value. Provider-generated/calculated risk score of the host.  Recommended value range of 0-1, which equates to a percentage.
     * @returns a string
     */
    get riskScore() {
        return this._riskScore;
    }
    ;
    /**
     * Sets the riskScore property value. Provider-generated/calculated risk score of the host.  Recommended value range of 0-1, which equates to a percentage.
     * @param value Value to set for the riskScore property.
     */
    set riskScore(value) {
        this._riskScore = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("fqdn", this.fqdn);
        writer.writeBooleanValue("isAzureAdJoined", this.isAzureAdJoined);
        writer.writeBooleanValue("isAzureAdRegistered", this.isAzureAdRegistered);
        writer.writeBooleanValue("isHybridAzureDomainJoined", this.isHybridAzureDomainJoined);
        writer.writeStringValue("netBiosName", this.netBiosName);
        writer.writeStringValue("os", this.os);
        writer.writeStringValue("privateIpAddress", this.privateIpAddress);
        writer.writeStringValue("publicIpAddress", this.publicIpAddress);
        writer.writeStringValue("riskScore", this.riskScore);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.HostSecurityState = HostSecurityState;
