"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HyperlinkOrPictureColumn = void 0;
class HyperlinkOrPictureColumn {
    /**
     * Instantiates a new hyperlinkOrPictureColumn and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "isPicture": (o, n) => { o.isPicture = n.getBooleanValue(); },
        };
    }
    ;
    /**
     * Gets the isPicture property value. Specifies whether the display format used for URL columns is an image or a hyperlink.
     * @returns a boolean
     */
    get isPicture() {
        return this._isPicture;
    }
    ;
    /**
     * Sets the isPicture property value. Specifies whether the display format used for URL columns is an image or a hyperlink.
     * @param value Value to set for the isPicture property.
     */
    set isPicture(value) {
        this._isPicture = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("isPicture", this.isPicture);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.HyperlinkOrPictureColumn = HyperlinkOrPictureColumn;
