import { ApiAuthenticationConfigurationBase, Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class IdentityApiConnector extends Entity implements Parsable {
    /** The object which describes the authentication configuration details for calling the API. Basic and PKCS 12 client certificate are supported.  */
    private _authenticationConfiguration?;
    /** The name of the API connector.  */
    private _displayName?;
    /** The URL of the API endpoint to call.  */
    private _targetUrl?;
    /**
     * Gets the authenticationConfiguration property value. The object which describes the authentication configuration details for calling the API. Basic and PKCS 12 client certificate are supported.
     * @returns a apiAuthenticationConfigurationBase
     */
    get authenticationConfiguration(): ApiAuthenticationConfigurationBase | undefined;
    /**
     * Sets the authenticationConfiguration property value. The object which describes the authentication configuration details for calling the API. Basic and PKCS 12 client certificate are supported.
     * @param value Value to set for the authenticationConfiguration property.
     */
    set authenticationConfiguration(value: ApiAuthenticationConfigurationBase | undefined);
    /**
     * Instantiates a new identityApiConnector and sets the default values.
     */
    constructor();
    /**
     * Gets the displayName property value. The name of the API connector.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. The name of the API connector.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the targetUrl property value. The URL of the API endpoint to call.
     * @returns a string
     */
    get targetUrl(): string | undefined;
    /**
     * Sets the targetUrl property value. The URL of the API endpoint to call.
     * @param value Value to set for the targetUrl property.
     */
    set targetUrl(value: string | undefined);
}
