"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IdentityApiConnector = void 0;
const createApiAuthenticationConfigurationBaseFromDiscriminatorValue_1 = require("./createApiAuthenticationConfigurationBaseFromDiscriminatorValue");
const index_1 = require("./index");
class IdentityApiConnector extends index_1.Entity {
    /**
     * Instantiates a new identityApiConnector and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the authenticationConfiguration property value. The object which describes the authentication configuration details for calling the API. Basic and PKCS 12 client certificate are supported.
     * @returns a apiAuthenticationConfigurationBase
     */
    get authenticationConfiguration() {
        return this._authenticationConfiguration;
    }
    ;
    /**
     * Sets the authenticationConfiguration property value. The object which describes the authentication configuration details for calling the API. Basic and PKCS 12 client certificate are supported.
     * @param value Value to set for the authenticationConfiguration property.
     */
    set authenticationConfiguration(value) {
        this._authenticationConfiguration = value;
    }
    ;
    ;
    /**
     * Gets the displayName property value. The name of the API connector.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The name of the API connector.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "authenticationConfiguration": (o, n) => { o.authenticationConfiguration = n.getObjectValue(createApiAuthenticationConfigurationBaseFromDiscriminatorValue_1.createApiAuthenticationConfigurationBaseFromDiscriminatorValue); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "targetUrl": (o, n) => { o.targetUrl = n.getStringValue(); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("authenticationConfiguration", this.authenticationConfiguration);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeStringValue("targetUrl", this.targetUrl);
    }
    ;
    /**
     * Gets the targetUrl property value. The URL of the API endpoint to call.
     * @returns a string
     */
    get targetUrl() {
        return this._targetUrl;
    }
    ;
    /**
     * Sets the targetUrl property value. The URL of the API endpoint to call.
     * @param value Value to set for the targetUrl property.
     */
    set targetUrl(value) {
        this._targetUrl = value;
    }
    ;
}
exports.IdentityApiConnector = IdentityApiConnector;
