"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IdentityContainer = void 0;
const createB2xIdentityUserFlowFromDiscriminatorValue_1 = require("./createB2xIdentityUserFlowFromDiscriminatorValue");
const createConditionalAccessRootFromDiscriminatorValue_1 = require("./createConditionalAccessRootFromDiscriminatorValue");
const createIdentityApiConnectorFromDiscriminatorValue_1 = require("./createIdentityApiConnectorFromDiscriminatorValue");
const createIdentityProviderBaseFromDiscriminatorValue_1 = require("./createIdentityProviderBaseFromDiscriminatorValue");
const createIdentityUserFlowAttributeFromDiscriminatorValue_1 = require("./createIdentityUserFlowAttributeFromDiscriminatorValue");
const index_1 = require("./index");
/** Provides operations to manage the identityContainer singleton.  */
class IdentityContainer extends index_1.Entity {
    /**
     * Instantiates a new identityContainer and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the apiConnectors property value. Represents entry point for API connectors.
     * @returns a identityApiConnector
     */
    get apiConnectors() {
        return this._apiConnectors;
    }
    ;
    /**
     * Sets the apiConnectors property value. Represents entry point for API connectors.
     * @param value Value to set for the apiConnectors property.
     */
    set apiConnectors(value) {
        this._apiConnectors = value;
    }
    ;
    /**
     * Gets the b2xUserFlows property value. Represents entry point for B2X/self-service sign-up identity userflows.
     * @returns a b2xIdentityUserFlow
     */
    get b2xUserFlows() {
        return this._b2xUserFlows;
    }
    ;
    /**
     * Sets the b2xUserFlows property value. Represents entry point for B2X/self-service sign-up identity userflows.
     * @param value Value to set for the b2xUserFlows property.
     */
    set b2xUserFlows(value) {
        this._b2xUserFlows = value;
    }
    ;
    /**
     * Gets the conditionalAccess property value. the entry point for the Conditional Access (CA) object model.
     * @returns a conditionalAccessRoot
     */
    get conditionalAccess() {
        return this._conditionalAccess;
    }
    ;
    /**
     * Sets the conditionalAccess property value. the entry point for the Conditional Access (CA) object model.
     * @param value Value to set for the conditionalAccess property.
     */
    set conditionalAccess(value) {
        this._conditionalAccess = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "apiConnectors": (o, n) => { o.apiConnectors = n.getCollectionOfObjectValues(createIdentityApiConnectorFromDiscriminatorValue_1.createIdentityApiConnectorFromDiscriminatorValue); }, "b2xUserFlows": (o, n) => { o.b2xUserFlows = n.getCollectionOfObjectValues(createB2xIdentityUserFlowFromDiscriminatorValue_1.createB2xIdentityUserFlowFromDiscriminatorValue); }, "conditionalAccess": (o, n) => { o.conditionalAccess = n.getObjectValue(createConditionalAccessRootFromDiscriminatorValue_1.createConditionalAccessRootFromDiscriminatorValue); }, "identityProviders": (o, n) => { o.identityProviders = n.getCollectionOfObjectValues(createIdentityProviderBaseFromDiscriminatorValue_1.createIdentityProviderBaseFromDiscriminatorValue); }, "userFlowAttributes": (o, n) => { o.userFlowAttributes = n.getCollectionOfObjectValues(createIdentityUserFlowAttributeFromDiscriminatorValue_1.createIdentityUserFlowAttributeFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the identityProviders property value. Represents entry point for identity provider base.
     * @returns a identityProviderBase
     */
    get identityProviders() {
        return this._identityProviders;
    }
    ;
    /**
     * Sets the identityProviders property value. Represents entry point for identity provider base.
     * @param value Value to set for the identityProviders property.
     */
    set identityProviders(value) {
        this._identityProviders = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("apiConnectors", this.apiConnectors);
        writer.writeCollectionOfObjectValues("b2xUserFlows", this.b2xUserFlows);
        writer.writeObjectValue("conditionalAccess", this.conditionalAccess);
        writer.writeCollectionOfObjectValues("identityProviders", this.identityProviders);
        writer.writeCollectionOfObjectValues("userFlowAttributes", this.userFlowAttributes);
    }
    ;
    /**
     * Gets the userFlowAttributes property value. Represents entry point for identity userflow attributes.
     * @returns a identityUserFlowAttribute
     */
    get userFlowAttributes() {
        return this._userFlowAttributes;
    }
    ;
    /**
     * Sets the userFlowAttributes property value. Represents entry point for identity userflow attributes.
     * @param value Value to set for the userFlowAttributes property.
     */
    set userFlowAttributes(value) {
        this._userFlowAttributes = value;
    }
    ;
}
exports.IdentityContainer = IdentityContainer;
