import { AccessReviewSet, AppConsentApprovalRoute, EntitlementManagement, TermsOfUseContainer } from './index';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class IdentityGovernance implements AdditionalDataHolder, Parsable {
    private _accessReviews?;
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _appConsent?;
    private _entitlementManagement?;
    private _termsOfUse?;
    /**
     * Gets the accessReviews property value.
     * @returns a accessReviewSet
     */
    get accessReviews(): AccessReviewSet | undefined;
    /**
     * Sets the accessReviews property value.
     * @param value Value to set for the accessReviews property.
     */
    set accessReviews(value: AccessReviewSet | undefined);
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the appConsent property value.
     * @returns a appConsentApprovalRoute
     */
    get appConsent(): AppConsentApprovalRoute | undefined;
    /**
     * Sets the appConsent property value.
     * @param value Value to set for the appConsent property.
     */
    set appConsent(value: AppConsentApprovalRoute | undefined);
    /**
     * Instantiates a new IdentityGovernance and sets the default values.
     */
    constructor();
    /**
     * Gets the entitlementManagement property value.
     * @returns a entitlementManagement
     */
    get entitlementManagement(): EntitlementManagement | undefined;
    /**
     * Sets the entitlementManagement property value.
     * @param value Value to set for the entitlementManagement property.
     */
    set entitlementManagement(value: EntitlementManagement | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the termsOfUse property value.
     * @returns a termsOfUseContainer
     */
    get termsOfUse(): TermsOfUseContainer | undefined;
    /**
     * Sets the termsOfUse property value.
     * @param value Value to set for the termsOfUse property.
     */
    set termsOfUse(value: TermsOfUseContainer | undefined);
}
