"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IdentityGovernance = void 0;
const createAccessReviewSetFromDiscriminatorValue_1 = require("./createAccessReviewSetFromDiscriminatorValue");
const createAppConsentApprovalRouteFromDiscriminatorValue_1 = require("./createAppConsentApprovalRouteFromDiscriminatorValue");
const createEntitlementManagementFromDiscriminatorValue_1 = require("./createEntitlementManagementFromDiscriminatorValue");
const createTermsOfUseContainerFromDiscriminatorValue_1 = require("./createTermsOfUseContainerFromDiscriminatorValue");
class IdentityGovernance {
    /**
     * Instantiates a new IdentityGovernance and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the accessReviews property value.
     * @returns a accessReviewSet
     */
    get accessReviews() {
        return this._accessReviews;
    }
    ;
    /**
     * Sets the accessReviews property value.
     * @param value Value to set for the accessReviews property.
     */
    set accessReviews(value) {
        this._accessReviews = value;
    }
    ;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the appConsent property value.
     * @returns a appConsentApprovalRoute
     */
    get appConsent() {
        return this._appConsent;
    }
    ;
    /**
     * Sets the appConsent property value.
     * @param value Value to set for the appConsent property.
     */
    set appConsent(value) {
        this._appConsent = value;
    }
    ;
    ;
    /**
     * Gets the entitlementManagement property value.
     * @returns a entitlementManagement
     */
    get entitlementManagement() {
        return this._entitlementManagement;
    }
    ;
    /**
     * Sets the entitlementManagement property value.
     * @param value Value to set for the entitlementManagement property.
     */
    set entitlementManagement(value) {
        this._entitlementManagement = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "accessReviews": (o, n) => { o.accessReviews = n.getObjectValue(createAccessReviewSetFromDiscriminatorValue_1.createAccessReviewSetFromDiscriminatorValue); },
            "appConsent": (o, n) => { o.appConsent = n.getObjectValue(createAppConsentApprovalRouteFromDiscriminatorValue_1.createAppConsentApprovalRouteFromDiscriminatorValue); },
            "entitlementManagement": (o, n) => { o.entitlementManagement = n.getObjectValue(createEntitlementManagementFromDiscriminatorValue_1.createEntitlementManagementFromDiscriminatorValue); },
            "termsOfUse": (o, n) => { o.termsOfUse = n.getObjectValue(createTermsOfUseContainerFromDiscriminatorValue_1.createTermsOfUseContainerFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("accessReviews", this.accessReviews);
        writer.writeObjectValue("appConsent", this.appConsent);
        writer.writeObjectValue("entitlementManagement", this.entitlementManagement);
        writer.writeObjectValue("termsOfUse", this.termsOfUse);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the termsOfUse property value.
     * @returns a termsOfUseContainer
     */
    get termsOfUse() {
        return this._termsOfUse;
    }
    ;
    /**
     * Sets the termsOfUse property value.
     * @param value Value to set for the termsOfUse property.
     */
    set termsOfUse(value) {
        this._termsOfUse = value;
    }
    ;
}
exports.IdentityGovernance = IdentityGovernance;
