"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IdentityProvider = void 0;
const index_1 = require("./index");
class IdentityProvider extends index_1.Entity {
    /**
     * Instantiates a new identityProvider and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the clientId property value. The client ID for the application. This is the client ID obtained when registering the application with the identity provider. Required. Not nullable.
     * @returns a string
     */
    get clientId() {
        return this._clientId;
    }
    ;
    /**
     * Sets the clientId property value. The client ID for the application. This is the client ID obtained when registering the application with the identity provider. Required. Not nullable.
     * @param value Value to set for the clientId property.
     */
    set clientId(value) {
        this._clientId = value;
    }
    ;
    /**
     * Gets the clientSecret property value. The client secret for the application. This is the client secret obtained when registering the application with the identity provider. This is write-only. A read operation will return ****.  Required. Not nullable.
     * @returns a string
     */
    get clientSecret() {
        return this._clientSecret;
    }
    ;
    /**
     * Sets the clientSecret property value. The client secret for the application. This is the client secret obtained when registering the application with the identity provider. This is write-only. A read operation will return ****.  Required. Not nullable.
     * @param value Value to set for the clientSecret property.
     */
    set clientSecret(value) {
        this._clientSecret = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "clientId": (o, n) => { o.clientId = n.getStringValue(); }, "clientSecret": (o, n) => { o.clientSecret = n.getStringValue(); }, "name": (o, n) => { o.name = n.getStringValue(); }, "type": (o, n) => { o.type = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the name property value. The display name of the identity provider. Not nullable.
     * @returns a string
     */
    get name() {
        return this._name;
    }
    ;
    /**
     * Sets the name property value. The display name of the identity provider. Not nullable.
     * @param value Value to set for the name property.
     */
    set name(value) {
        this._name = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("clientId", this.clientId);
        writer.writeStringValue("clientSecret", this.clientSecret);
        writer.writeStringValue("name", this.name);
        writer.writeStringValue("type", this.type);
    }
    ;
    /**
     * Gets the type property value. The identity provider type is a required field. For B2B scenario: Google, Facebook. For B2C scenario: Microsoft, Google, Amazon, LinkedIn, Facebook, GitHub, Twitter, Weibo, QQ, WeChat, OpenIDConnect. Not nullable.
     * @returns a string
     */
    get type() {
        return this._type;
    }
    ;
    /**
     * Sets the type property value. The identity provider type is a required field. For B2B scenario: Google, Facebook. For B2C scenario: Microsoft, Google, Amazon, LinkedIn, Facebook, GitHub, Twitter, Weibo, QQ, WeChat, OpenIDConnect. Not nullable.
     * @param value Value to set for the type property.
     */
    set type(value) {
        this._type = value;
    }
    ;
}
exports.IdentityProvider = IdentityProvider;
