import { Identity } from './index';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class IdentitySet implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Optional. The application associated with this action.  */
    private _application?;
    /** Optional. The device associated with this action.  */
    private _device?;
    /** Optional. The user associated with this action.  */
    private _user?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the application property value. Optional. The application associated with this action.
     * @returns a identity
     */
    get application(): Identity | undefined;
    /**
     * Sets the application property value. Optional. The application associated with this action.
     * @param value Value to set for the application property.
     */
    set application(value: Identity | undefined);
    /**
     * Instantiates a new identitySet and sets the default values.
     */
    constructor();
    /**
     * Gets the device property value. Optional. The device associated with this action.
     * @returns a identity
     */
    get device(): Identity | undefined;
    /**
     * Sets the device property value. Optional. The device associated with this action.
     * @param value Value to set for the device property.
     */
    set device(value: Identity | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the user property value. Optional. The user associated with this action.
     * @returns a identity
     */
    get user(): Identity | undefined;
    /**
     * Sets the user property value. Optional. The user associated with this action.
     * @param value Value to set for the user property.
     */
    set user(value: Identity | undefined);
}
