import { Entity } from './index';
import { UserFlowType } from './userFlowType';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class IdentityUserFlow extends Entity implements Parsable {
    private _userFlowType?;
    private _userFlowTypeVersion?;
    /**
     * Instantiates a new identityUserFlow and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the userFlowType property value.
     * @returns a userFlowType
     */
    get userFlowType(): UserFlowType | undefined;
    /**
     * Sets the userFlowType property value.
     * @param value Value to set for the userFlowType property.
     */
    set userFlowType(value: UserFlowType | undefined);
    /**
     * Gets the userFlowTypeVersion property value.
     * @returns a float
     */
    get userFlowTypeVersion(): number | undefined;
    /**
     * Sets the userFlowTypeVersion property value.
     * @param value Value to set for the userFlowTypeVersion property.
     */
    set userFlowTypeVersion(value: number | undefined);
}
