import { IdentityUserFlowAttributeDataType } from './identityUserFlowAttributeDataType';
import { IdentityUserFlowAttributeType } from './identityUserFlowAttributeType';
import { Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class IdentityUserFlowAttribute extends Entity implements Parsable {
    /** The data type of the user flow attribute. This cannot be modified after the custom user flow attribute is created. The supported values for dataType are: string , boolean , int64 , stringCollection , dateTime.  */
    private _dataType?;
    /** The description of the user flow attribute that's shown to the user at the time of sign-up.  */
    private _description?;
    /** The display name of the user flow attribute.  */
    private _displayName?;
    /** The type of the user flow attribute. This is a read-only attribute that is automatically set. Depending on the type of attribute, the values for this property will be builtIn, custom, or required.  */
    private _userFlowAttributeType?;
    /**
     * Instantiates a new identityUserFlowAttribute and sets the default values.
     */
    constructor();
    /**
     * Gets the dataType property value. The data type of the user flow attribute. This cannot be modified after the custom user flow attribute is created. The supported values for dataType are: string , boolean , int64 , stringCollection , dateTime.
     * @returns a identityUserFlowAttributeDataType
     */
    get dataType(): IdentityUserFlowAttributeDataType | undefined;
    /**
     * Sets the dataType property value. The data type of the user flow attribute. This cannot be modified after the custom user flow attribute is created. The supported values for dataType are: string , boolean , int64 , stringCollection , dateTime.
     * @param value Value to set for the dataType property.
     */
    set dataType(value: IdentityUserFlowAttributeDataType | undefined);
    /**
     * Gets the description property value. The description of the user flow attribute that's shown to the user at the time of sign-up.
     * @returns a string
     */
    get description(): string | undefined;
    /**
     * Sets the description property value. The description of the user flow attribute that's shown to the user at the time of sign-up.
     * @param value Value to set for the description property.
     */
    set description(value: string | undefined);
    /**
     * Gets the displayName property value. The display name of the user flow attribute.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. The display name of the user flow attribute.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the userFlowAttributeType property value. The type of the user flow attribute. This is a read-only attribute that is automatically set. Depending on the type of attribute, the values for this property will be builtIn, custom, or required.
     * @returns a identityUserFlowAttributeType
     */
    get userFlowAttributeType(): IdentityUserFlowAttributeType | undefined;
    /**
     * Sets the userFlowAttributeType property value. The type of the user flow attribute. This is a read-only attribute that is automatically set. Depending on the type of attribute, the values for this property will be builtIn, custom, or required.
     * @param value Value to set for the userFlowAttributeType property.
     */
    set userFlowAttributeType(value: IdentityUserFlowAttributeType | undefined);
}
