import { IdentityUserFlowAttributeInputType } from './identityUserFlowAttributeInputType';
import { Entity, IdentityUserFlowAttribute, UserAttributeValuesItem } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class IdentityUserFlowAttributeAssignment extends Entity implements Parsable {
    /** The display name of the identityUserFlowAttribute within a user flow.  */
    private _displayName?;
    /** Determines whether the identityUserFlowAttribute is optional. true means the user doesn't have to provide a value. false means the user cannot complete sign-up without providing a value.  */
    private _isOptional?;
    /** Determines whether the identityUserFlowAttribute requires verification. This is only used for verifying the user's phone number or email address.  */
    private _requiresVerification?;
    /** The user attribute that you want to add to your user flow.  */
    private _userAttribute?;
    /** The input options for the user flow attribute. Only applicable when the userInputType is radioSingleSelect, dropdownSingleSelect, or checkboxMultiSelect.  */
    private _userAttributeValues?;
    /** The input type of the user flow attribute. Possible values are: textBox, dateTimeDropdown, radioSingleSelect, dropdownSingleSelect, emailBox, checkboxMultiSelect.  */
    private _userInputType?;
    /**
     * Instantiates a new identityUserFlowAttributeAssignment and sets the default values.
     */
    constructor();
    /**
     * Gets the displayName property value. The display name of the identityUserFlowAttribute within a user flow.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. The display name of the identityUserFlowAttribute within a user flow.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the isOptional property value. Determines whether the identityUserFlowAttribute is optional. true means the user doesn't have to provide a value. false means the user cannot complete sign-up without providing a value.
     * @returns a boolean
     */
    get isOptional(): boolean | undefined;
    /**
     * Sets the isOptional property value. Determines whether the identityUserFlowAttribute is optional. true means the user doesn't have to provide a value. false means the user cannot complete sign-up without providing a value.
     * @param value Value to set for the isOptional property.
     */
    set isOptional(value: boolean | undefined);
    /**
     * Gets the requiresVerification property value. Determines whether the identityUserFlowAttribute requires verification. This is only used for verifying the user's phone number or email address.
     * @returns a boolean
     */
    get requiresVerification(): boolean | undefined;
    /**
     * Sets the requiresVerification property value. Determines whether the identityUserFlowAttribute requires verification. This is only used for verifying the user's phone number or email address.
     * @param value Value to set for the requiresVerification property.
     */
    set requiresVerification(value: boolean | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the userAttribute property value. The user attribute that you want to add to your user flow.
     * @returns a identityUserFlowAttribute
     */
    get userAttribute(): IdentityUserFlowAttribute | undefined;
    /**
     * Sets the userAttribute property value. The user attribute that you want to add to your user flow.
     * @param value Value to set for the userAttribute property.
     */
    set userAttribute(value: IdentityUserFlowAttribute | undefined);
    /**
     * Gets the userAttributeValues property value. The input options for the user flow attribute. Only applicable when the userInputType is radioSingleSelect, dropdownSingleSelect, or checkboxMultiSelect.
     * @returns a userAttributeValuesItem
     */
    get userAttributeValues(): UserAttributeValuesItem[] | undefined;
    /**
     * Sets the userAttributeValues property value. The input options for the user flow attribute. Only applicable when the userInputType is radioSingleSelect, dropdownSingleSelect, or checkboxMultiSelect.
     * @param value Value to set for the userAttributeValues property.
     */
    set userAttributeValues(value: UserAttributeValuesItem[] | undefined);
    /**
     * Gets the userInputType property value. The input type of the user flow attribute. Possible values are: textBox, dateTimeDropdown, radioSingleSelect, dropdownSingleSelect, emailBox, checkboxMultiSelect.
     * @returns a identityUserFlowAttributeInputType
     */
    get userInputType(): IdentityUserFlowAttributeInputType | undefined;
    /**
     * Sets the userInputType property value. The input type of the user flow attribute. Possible values are: textBox, dateTimeDropdown, radioSingleSelect, dropdownSingleSelect, emailBox, checkboxMultiSelect.
     * @param value Value to set for the userInputType property.
     */
    set userInputType(value: IdentityUserFlowAttributeInputType | undefined);
}
