"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IdentityUserFlowAttributeAssignment = void 0;
const createIdentityUserFlowAttributeFromDiscriminatorValue_1 = require("./createIdentityUserFlowAttributeFromDiscriminatorValue");
const createUserAttributeValuesItemFromDiscriminatorValue_1 = require("./createUserAttributeValuesItemFromDiscriminatorValue");
const identityUserFlowAttributeInputType_1 = require("./identityUserFlowAttributeInputType");
const index_1 = require("./index");
class IdentityUserFlowAttributeAssignment extends index_1.Entity {
    /**
     * Instantiates a new identityUserFlowAttributeAssignment and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the displayName property value. The display name of the identityUserFlowAttribute within a user flow.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The display name of the identityUserFlowAttribute within a user flow.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "isOptional": (o, n) => { o.isOptional = n.getBooleanValue(); }, "requiresVerification": (o, n) => { o.requiresVerification = n.getBooleanValue(); }, "userAttribute": (o, n) => { o.userAttribute = n.getObjectValue(createIdentityUserFlowAttributeFromDiscriminatorValue_1.createIdentityUserFlowAttributeFromDiscriminatorValue); }, "userAttributeValues": (o, n) => { o.userAttributeValues = n.getCollectionOfObjectValues(createUserAttributeValuesItemFromDiscriminatorValue_1.createUserAttributeValuesItemFromDiscriminatorValue); }, "userInputType": (o, n) => { o.userInputType = n.getEnumValue(identityUserFlowAttributeInputType_1.IdentityUserFlowAttributeInputType); } });
    }
    ;
    /**
     * Gets the isOptional property value. Determines whether the identityUserFlowAttribute is optional. true means the user doesn't have to provide a value. false means the user cannot complete sign-up without providing a value.
     * @returns a boolean
     */
    get isOptional() {
        return this._isOptional;
    }
    ;
    /**
     * Sets the isOptional property value. Determines whether the identityUserFlowAttribute is optional. true means the user doesn't have to provide a value. false means the user cannot complete sign-up without providing a value.
     * @param value Value to set for the isOptional property.
     */
    set isOptional(value) {
        this._isOptional = value;
    }
    ;
    /**
     * Gets the requiresVerification property value. Determines whether the identityUserFlowAttribute requires verification. This is only used for verifying the user's phone number or email address.
     * @returns a boolean
     */
    get requiresVerification() {
        return this._requiresVerification;
    }
    ;
    /**
     * Sets the requiresVerification property value. Determines whether the identityUserFlowAttribute requires verification. This is only used for verifying the user's phone number or email address.
     * @param value Value to set for the requiresVerification property.
     */
    set requiresVerification(value) {
        this._requiresVerification = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeBooleanValue("isOptional", this.isOptional);
        writer.writeBooleanValue("requiresVerification", this.requiresVerification);
        writer.writeObjectValue("userAttribute", this.userAttribute);
        writer.writeCollectionOfObjectValues("userAttributeValues", this.userAttributeValues);
        writer.writeEnumValue("userInputType", this.userInputType);
    }
    ;
    /**
     * Gets the userAttribute property value. The user attribute that you want to add to your user flow.
     * @returns a identityUserFlowAttribute
     */
    get userAttribute() {
        return this._userAttribute;
    }
    ;
    /**
     * Sets the userAttribute property value. The user attribute that you want to add to your user flow.
     * @param value Value to set for the userAttribute property.
     */
    set userAttribute(value) {
        this._userAttribute = value;
    }
    ;
    /**
     * Gets the userAttributeValues property value. The input options for the user flow attribute. Only applicable when the userInputType is radioSingleSelect, dropdownSingleSelect, or checkboxMultiSelect.
     * @returns a userAttributeValuesItem
     */
    get userAttributeValues() {
        return this._userAttributeValues;
    }
    ;
    /**
     * Sets the userAttributeValues property value. The input options for the user flow attribute. Only applicable when the userInputType is radioSingleSelect, dropdownSingleSelect, or checkboxMultiSelect.
     * @param value Value to set for the userAttributeValues property.
     */
    set userAttributeValues(value) {
        this._userAttributeValues = value;
    }
    ;
    /**
     * Gets the userInputType property value. The input type of the user flow attribute. Possible values are: textBox, dateTimeDropdown, radioSingleSelect, dropdownSingleSelect, emailBox, checkboxMultiSelect.
     * @returns a identityUserFlowAttributeInputType
     */
    get userInputType() {
        return this._userInputType;
    }
    ;
    /**
     * Sets the userInputType property value. The input type of the user flow attribute. Possible values are: textBox, dateTimeDropdown, radioSingleSelect, dropdownSingleSelect, emailBox, checkboxMultiSelect.
     * @param value Value to set for the userInputType property.
     */
    set userInputType(value) {
        this._userInputType = value;
    }
    ;
}
exports.IdentityUserFlowAttributeAssignment = IdentityUserFlowAttributeAssignment;
