import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ImageInfo implements AdditionalDataHolder, Parsable {
    /** Optional; parameter used to indicate the server is able to render image dynamically in response to parameterization. For example – a high contrast image  */
    private _addImageQuery?;
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Optional; alt-text accessible content for the image  */
    private _alternateText?;
    private _alternativeText?;
    /** Optional; URI that points to an icon which represents the application used to generate the activity  */
    private _iconUrl?;
    /**
     * Gets the addImageQuery property value. Optional; parameter used to indicate the server is able to render image dynamically in response to parameterization. For example – a high contrast image
     * @returns a boolean
     */
    get addImageQuery(): boolean | undefined;
    /**
     * Sets the addImageQuery property value. Optional; parameter used to indicate the server is able to render image dynamically in response to parameterization. For example – a high contrast image
     * @param value Value to set for the addImageQuery property.
     */
    set addImageQuery(value: boolean | undefined);
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the alternateText property value. Optional; alt-text accessible content for the image
     * @returns a string
     */
    get alternateText(): string | undefined;
    /**
     * Sets the alternateText property value. Optional; alt-text accessible content for the image
     * @param value Value to set for the alternateText property.
     */
    set alternateText(value: string | undefined);
    /**
     * Gets the alternativeText property value.
     * @returns a string
     */
    get alternativeText(): string | undefined;
    /**
     * Sets the alternativeText property value.
     * @param value Value to set for the alternativeText property.
     */
    set alternativeText(value: string | undefined);
    /**
     * Instantiates a new imageInfo and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the iconUrl property value. Optional; URI that points to an icon which represents the application used to generate the activity
     * @returns a string
     */
    get iconUrl(): string | undefined;
    /**
     * Sets the iconUrl property value. Optional; URI that points to an icon which represents the application used to generate the activity
     * @param value Value to set for the iconUrl property.
     */
    set iconUrl(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
