"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImageInfo = void 0;
class ImageInfo {
    /**
     * Instantiates a new imageInfo and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the addImageQuery property value. Optional; parameter used to indicate the server is able to render image dynamically in response to parameterization. For example – a high contrast image
     * @returns a boolean
     */
    get addImageQuery() {
        return this._addImageQuery;
    }
    ;
    /**
     * Sets the addImageQuery property value. Optional; parameter used to indicate the server is able to render image dynamically in response to parameterization. For example – a high contrast image
     * @param value Value to set for the addImageQuery property.
     */
    set addImageQuery(value) {
        this._addImageQuery = value;
    }
    ;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the alternateText property value. Optional; alt-text accessible content for the image
     * @returns a string
     */
    get alternateText() {
        return this._alternateText;
    }
    ;
    /**
     * Sets the alternateText property value. Optional; alt-text accessible content for the image
     * @param value Value to set for the alternateText property.
     */
    set alternateText(value) {
        this._alternateText = value;
    }
    ;
    /**
     * Gets the alternativeText property value.
     * @returns a string
     */
    get alternativeText() {
        return this._alternativeText;
    }
    ;
    /**
     * Sets the alternativeText property value.
     * @param value Value to set for the alternativeText property.
     */
    set alternativeText(value) {
        this._alternativeText = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "addImageQuery": (o, n) => { o.addImageQuery = n.getBooleanValue(); },
            "alternateText": (o, n) => { o.alternateText = n.getStringValue(); },
            "alternativeText": (o, n) => { o.alternativeText = n.getStringValue(); },
            "iconUrl": (o, n) => { o.iconUrl = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the iconUrl property value. Optional; URI that points to an icon which represents the application used to generate the activity
     * @returns a string
     */
    get iconUrl() {
        return this._iconUrl;
    }
    ;
    /**
     * Sets the iconUrl property value. Optional; URI that points to an icon which represents the application used to generate the activity
     * @param value Value to set for the iconUrl property.
     */
    set iconUrl(value) {
        this._iconUrl = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("addImageQuery", this.addImageQuery);
        writer.writeStringValue("alternateText", this.alternateText);
        writer.writeStringValue("alternativeText", this.alternativeText);
        writer.writeStringValue("iconUrl", this.iconUrl);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ImageInfo = ImageInfo;
