"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImplicitGrantSettings = void 0;
class ImplicitGrantSettings {
    /**
     * Instantiates a new implicitGrantSettings and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the enableAccessTokenIssuance property value. Specifies whether this web application can request an access token using the OAuth 2.0 implicit flow.
     * @returns a boolean
     */
    get enableAccessTokenIssuance() {
        return this._enableAccessTokenIssuance;
    }
    ;
    /**
     * Sets the enableAccessTokenIssuance property value. Specifies whether this web application can request an access token using the OAuth 2.0 implicit flow.
     * @param value Value to set for the enableAccessTokenIssuance property.
     */
    set enableAccessTokenIssuance(value) {
        this._enableAccessTokenIssuance = value;
    }
    ;
    /**
     * Gets the enableIdTokenIssuance property value. Specifies whether this web application can request an ID token using the OAuth 2.0 implicit flow.
     * @returns a boolean
     */
    get enableIdTokenIssuance() {
        return this._enableIdTokenIssuance;
    }
    ;
    /**
     * Sets the enableIdTokenIssuance property value. Specifies whether this web application can request an ID token using the OAuth 2.0 implicit flow.
     * @param value Value to set for the enableIdTokenIssuance property.
     */
    set enableIdTokenIssuance(value) {
        this._enableIdTokenIssuance = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "enableAccessTokenIssuance": (o, n) => { o.enableAccessTokenIssuance = n.getBooleanValue(); },
            "enableIdTokenIssuance": (o, n) => { o.enableIdTokenIssuance = n.getBooleanValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("enableAccessTokenIssuance", this.enableAccessTokenIssuance);
        writer.writeBooleanValue("enableIdTokenIssuance", this.enableIdTokenIssuance);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ImplicitGrantSettings = ImplicitGrantSettings;
