import { ImportedWindowsAutopilotDeviceIdentityImportStatus } from './importedWindowsAutopilotDeviceIdentityImportStatus';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ImportedWindowsAutopilotDeviceIdentityState implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Device error code reported by Device Directory Service(DDS).  */
    private _deviceErrorCode?;
    /** Device error name reported by Device Directory Service(DDS).  */
    private _deviceErrorName?;
    /** Device status reported by Device Directory Service(DDS). Possible values are: unknown, pending, partial, complete, error.  */
    private _deviceImportStatus?;
    /** Device Registration ID for successfully added device reported by Device Directory Service(DDS).  */
    private _deviceRegistrationId?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new importedWindowsAutopilotDeviceIdentityState and sets the default values.
     */
    constructor();
    /**
     * Gets the deviceErrorCode property value. Device error code reported by Device Directory Service(DDS).
     * @returns a integer
     */
    get deviceErrorCode(): number | undefined;
    /**
     * Sets the deviceErrorCode property value. Device error code reported by Device Directory Service(DDS).
     * @param value Value to set for the deviceErrorCode property.
     */
    set deviceErrorCode(value: number | undefined);
    /**
     * Gets the deviceErrorName property value. Device error name reported by Device Directory Service(DDS).
     * @returns a string
     */
    get deviceErrorName(): string | undefined;
    /**
     * Sets the deviceErrorName property value. Device error name reported by Device Directory Service(DDS).
     * @param value Value to set for the deviceErrorName property.
     */
    set deviceErrorName(value: string | undefined);
    /**
     * Gets the deviceImportStatus property value. Device status reported by Device Directory Service(DDS). Possible values are: unknown, pending, partial, complete, error.
     * @returns a importedWindowsAutopilotDeviceIdentityImportStatus
     */
    get deviceImportStatus(): ImportedWindowsAutopilotDeviceIdentityImportStatus | undefined;
    /**
     * Sets the deviceImportStatus property value. Device status reported by Device Directory Service(DDS). Possible values are: unknown, pending, partial, complete, error.
     * @param value Value to set for the deviceImportStatus property.
     */
    set deviceImportStatus(value: ImportedWindowsAutopilotDeviceIdentityImportStatus | undefined);
    /**
     * Gets the deviceRegistrationId property value. Device Registration ID for successfully added device reported by Device Directory Service(DDS).
     * @returns a string
     */
    get deviceRegistrationId(): string | undefined;
    /**
     * Sets the deviceRegistrationId property value. Device Registration ID for successfully added device reported by Device Directory Service(DDS).
     * @param value Value to set for the deviceRegistrationId property.
     */
    set deviceRegistrationId(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
