"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImportedWindowsAutopilotDeviceIdentityState = void 0;
const importedWindowsAutopilotDeviceIdentityImportStatus_1 = require("./importedWindowsAutopilotDeviceIdentityImportStatus");
class ImportedWindowsAutopilotDeviceIdentityState {
    /**
     * Instantiates a new importedWindowsAutopilotDeviceIdentityState and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the deviceErrorCode property value. Device error code reported by Device Directory Service(DDS).
     * @returns a integer
     */
    get deviceErrorCode() {
        return this._deviceErrorCode;
    }
    ;
    /**
     * Sets the deviceErrorCode property value. Device error code reported by Device Directory Service(DDS).
     * @param value Value to set for the deviceErrorCode property.
     */
    set deviceErrorCode(value) {
        this._deviceErrorCode = value;
    }
    ;
    /**
     * Gets the deviceErrorName property value. Device error name reported by Device Directory Service(DDS).
     * @returns a string
     */
    get deviceErrorName() {
        return this._deviceErrorName;
    }
    ;
    /**
     * Sets the deviceErrorName property value. Device error name reported by Device Directory Service(DDS).
     * @param value Value to set for the deviceErrorName property.
     */
    set deviceErrorName(value) {
        this._deviceErrorName = value;
    }
    ;
    /**
     * Gets the deviceImportStatus property value. Device status reported by Device Directory Service(DDS). Possible values are: unknown, pending, partial, complete, error.
     * @returns a importedWindowsAutopilotDeviceIdentityImportStatus
     */
    get deviceImportStatus() {
        return this._deviceImportStatus;
    }
    ;
    /**
     * Sets the deviceImportStatus property value. Device status reported by Device Directory Service(DDS). Possible values are: unknown, pending, partial, complete, error.
     * @param value Value to set for the deviceImportStatus property.
     */
    set deviceImportStatus(value) {
        this._deviceImportStatus = value;
    }
    ;
    /**
     * Gets the deviceRegistrationId property value. Device Registration ID for successfully added device reported by Device Directory Service(DDS).
     * @returns a string
     */
    get deviceRegistrationId() {
        return this._deviceRegistrationId;
    }
    ;
    /**
     * Sets the deviceRegistrationId property value. Device Registration ID for successfully added device reported by Device Directory Service(DDS).
     * @param value Value to set for the deviceRegistrationId property.
     */
    set deviceRegistrationId(value) {
        this._deviceRegistrationId = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "deviceErrorCode": (o, n) => { o.deviceErrorCode = n.getNumberValue(); },
            "deviceErrorName": (o, n) => { o.deviceErrorName = n.getStringValue(); },
            "deviceImportStatus": (o, n) => { o.deviceImportStatus = n.getEnumValue(importedWindowsAutopilotDeviceIdentityImportStatus_1.ImportedWindowsAutopilotDeviceIdentityImportStatus); },
            "deviceRegistrationId": (o, n) => { o.deviceRegistrationId = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeNumberValue("deviceErrorCode", this.deviceErrorCode);
        writer.writeStringValue("deviceErrorName", this.deviceErrorName);
        writer.writeEnumValue("deviceImportStatus", this.deviceImportStatus);
        writer.writeStringValue("deviceRegistrationId", this.deviceRegistrationId);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ImportedWindowsAutopilotDeviceIdentityState = ImportedWindowsAutopilotDeviceIdentityState;
