import { IdentitySet } from './index';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class IncomingContext implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** The ID of the participant that is under observation. Read-only.  */
    private _observedParticipantId?;
    /** The identity that the call is happening on behalf of.  */
    private _onBehalfOf?;
    /** The ID of the participant that triggered the incoming call. Read-only.  */
    private _sourceParticipantId?;
    /** The identity that transferred the call.  */
    private _transferor?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new incomingContext and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the observedParticipantId property value. The ID of the participant that is under observation. Read-only.
     * @returns a string
     */
    get observedParticipantId(): string | undefined;
    /**
     * Sets the observedParticipantId property value. The ID of the participant that is under observation. Read-only.
     * @param value Value to set for the observedParticipantId property.
     */
    set observedParticipantId(value: string | undefined);
    /**
     * Gets the onBehalfOf property value. The identity that the call is happening on behalf of.
     * @returns a identitySet
     */
    get onBehalfOf(): IdentitySet | undefined;
    /**
     * Sets the onBehalfOf property value. The identity that the call is happening on behalf of.
     * @param value Value to set for the onBehalfOf property.
     */
    set onBehalfOf(value: IdentitySet | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the sourceParticipantId property value. The ID of the participant that triggered the incoming call. Read-only.
     * @returns a string
     */
    get sourceParticipantId(): string | undefined;
    /**
     * Sets the sourceParticipantId property value. The ID of the participant that triggered the incoming call. Read-only.
     * @param value Value to set for the sourceParticipantId property.
     */
    set sourceParticipantId(value: string | undefined);
    /**
     * Gets the transferor property value. The identity that transferred the call.
     * @returns a identitySet
     */
    get transferor(): IdentitySet | undefined;
    /**
     * Sets the transferor property value. The identity that transferred the call.
     * @param value Value to set for the transferor property.
     */
    set transferor(value: IdentitySet | undefined);
}
