"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IncomingContext = void 0;
const createIdentitySetFromDiscriminatorValue_1 = require("./createIdentitySetFromDiscriminatorValue");
class IncomingContext {
    /**
     * Instantiates a new incomingContext and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "observedParticipantId": (o, n) => { o.observedParticipantId = n.getStringValue(); },
            "onBehalfOf": (o, n) => { o.onBehalfOf = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); },
            "sourceParticipantId": (o, n) => { o.sourceParticipantId = n.getStringValue(); },
            "transferor": (o, n) => { o.transferor = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the observedParticipantId property value. The ID of the participant that is under observation. Read-only.
     * @returns a string
     */
    get observedParticipantId() {
        return this._observedParticipantId;
    }
    ;
    /**
     * Sets the observedParticipantId property value. The ID of the participant that is under observation. Read-only.
     * @param value Value to set for the observedParticipantId property.
     */
    set observedParticipantId(value) {
        this._observedParticipantId = value;
    }
    ;
    /**
     * Gets the onBehalfOf property value. The identity that the call is happening on behalf of.
     * @returns a identitySet
     */
    get onBehalfOf() {
        return this._onBehalfOf;
    }
    ;
    /**
     * Sets the onBehalfOf property value. The identity that the call is happening on behalf of.
     * @param value Value to set for the onBehalfOf property.
     */
    set onBehalfOf(value) {
        this._onBehalfOf = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("observedParticipantId", this.observedParticipantId);
        writer.writeObjectValue("onBehalfOf", this.onBehalfOf);
        writer.writeStringValue("sourceParticipantId", this.sourceParticipantId);
        writer.writeObjectValue("transferor", this.transferor);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the sourceParticipantId property value. The ID of the participant that triggered the incoming call. Read-only.
     * @returns a string
     */
    get sourceParticipantId() {
        return this._sourceParticipantId;
    }
    ;
    /**
     * Sets the sourceParticipantId property value. The ID of the participant that triggered the incoming call. Read-only.
     * @param value Value to set for the sourceParticipantId property.
     */
    set sourceParticipantId(value) {
        this._sourceParticipantId = value;
    }
    ;
    /**
     * Gets the transferor property value. The identity that transferred the call.
     * @returns a identitySet
     */
    get transferor() {
        return this._transferor;
    }
    ;
    /**
     * Sets the transferor property value. The identity that transferred the call.
     * @param value Value to set for the transferor property.
     */
    set transferor(value) {
        this._transferor = value;
    }
    ;
}
exports.IncomingContext = IncomingContext;
