import { EmailAddress, Entity } from './index';
import { InferenceClassificationType } from './inferenceClassificationType';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class InferenceClassificationOverride extends Entity implements Parsable {
    /** Specifies how incoming messages from a specific sender should always be classified as. The possible values are: focused, other.  */
    private _classifyAs?;
    /** The email address information of the sender for whom the override is created.  */
    private _senderEmailAddress?;
    /**
     * Gets the classifyAs property value. Specifies how incoming messages from a specific sender should always be classified as. The possible values are: focused, other.
     * @returns a inferenceClassificationType
     */
    get classifyAs(): InferenceClassificationType | undefined;
    /**
     * Sets the classifyAs property value. Specifies how incoming messages from a specific sender should always be classified as. The possible values are: focused, other.
     * @param value Value to set for the classifyAs property.
     */
    set classifyAs(value: InferenceClassificationType | undefined);
    /**
     * Instantiates a new inferenceClassificationOverride and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the senderEmailAddress property value. The email address information of the sender for whom the override is created.
     * @returns a emailAddress
     */
    get senderEmailAddress(): EmailAddress | undefined;
    /**
     * Sets the senderEmailAddress property value. The email address information of the sender for whom the override is created.
     * @param value Value to set for the senderEmailAddress property.
     */
    set senderEmailAddress(value: EmailAddress | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
