"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InformationProtection = void 0;
const createBitlockerFromDiscriminatorValue_1 = require("./createBitlockerFromDiscriminatorValue");
const createThreatAssessmentRequestFromDiscriminatorValue_1 = require("./createThreatAssessmentRequestFromDiscriminatorValue");
const index_1 = require("./index");
/** Provides operations to manage the informationProtection singleton.  */
class InformationProtection extends index_1.Entity {
    /**
     * Instantiates a new informationProtection and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the bitlocker property value.
     * @returns a bitlocker
     */
    get bitlocker() {
        return this._bitlocker;
    }
    ;
    /**
     * Sets the bitlocker property value.
     * @param value Value to set for the bitlocker property.
     */
    set bitlocker(value) {
        this._bitlocker = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "bitlocker": (o, n) => { o.bitlocker = n.getObjectValue(createBitlockerFromDiscriminatorValue_1.createBitlockerFromDiscriminatorValue); }, "threatAssessmentRequests": (o, n) => { o.threatAssessmentRequests = n.getCollectionOfObjectValues(createThreatAssessmentRequestFromDiscriminatorValue_1.createThreatAssessmentRequestFromDiscriminatorValue); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("bitlocker", this.bitlocker);
        writer.writeCollectionOfObjectValues("threatAssessmentRequests", this.threatAssessmentRequests);
    }
    ;
    /**
     * Gets the threatAssessmentRequests property value.
     * @returns a threatAssessmentRequest
     */
    get threatAssessmentRequests() {
        return this._threatAssessmentRequests;
    }
    ;
    /**
     * Sets the threatAssessmentRequests property value.
     * @param value Value to set for the threatAssessmentRequests property.
     */
    set threatAssessmentRequests(value) {
        this._threatAssessmentRequests = value;
    }
    ;
}
exports.InformationProtection = InformationProtection;
