"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InformationalUrl = void 0;
class InformationalUrl {
    /**
     * Instantiates a new informationalUrl and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "logoUrl": (o, n) => { o.logoUrl = n.getStringValue(); },
            "marketingUrl": (o, n) => { o.marketingUrl = n.getStringValue(); },
            "privacyStatementUrl": (o, n) => { o.privacyStatementUrl = n.getStringValue(); },
            "supportUrl": (o, n) => { o.supportUrl = n.getStringValue(); },
            "termsOfServiceUrl": (o, n) => { o.termsOfServiceUrl = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the logoUrl property value. CDN URL to the application's logo, Read-only.
     * @returns a string
     */
    get logoUrl() {
        return this._logoUrl;
    }
    ;
    /**
     * Sets the logoUrl property value. CDN URL to the application's logo, Read-only.
     * @param value Value to set for the logoUrl property.
     */
    set logoUrl(value) {
        this._logoUrl = value;
    }
    ;
    /**
     * Gets the marketingUrl property value. Link to the application's marketing page. For example, https://www.contoso.com/app/marketing
     * @returns a string
     */
    get marketingUrl() {
        return this._marketingUrl;
    }
    ;
    /**
     * Sets the marketingUrl property value. Link to the application's marketing page. For example, https://www.contoso.com/app/marketing
     * @param value Value to set for the marketingUrl property.
     */
    set marketingUrl(value) {
        this._marketingUrl = value;
    }
    ;
    /**
     * Gets the privacyStatementUrl property value. Link to the application's privacy statement. For example, https://www.contoso.com/app/privacy
     * @returns a string
     */
    get privacyStatementUrl() {
        return this._privacyStatementUrl;
    }
    ;
    /**
     * Sets the privacyStatementUrl property value. Link to the application's privacy statement. For example, https://www.contoso.com/app/privacy
     * @param value Value to set for the privacyStatementUrl property.
     */
    set privacyStatementUrl(value) {
        this._privacyStatementUrl = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("logoUrl", this.logoUrl);
        writer.writeStringValue("marketingUrl", this.marketingUrl);
        writer.writeStringValue("privacyStatementUrl", this.privacyStatementUrl);
        writer.writeStringValue("supportUrl", this.supportUrl);
        writer.writeStringValue("termsOfServiceUrl", this.termsOfServiceUrl);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the supportUrl property value. Link to the application's support page. For example, https://www.contoso.com/app/support
     * @returns a string
     */
    get supportUrl() {
        return this._supportUrl;
    }
    ;
    /**
     * Sets the supportUrl property value. Link to the application's support page. For example, https://www.contoso.com/app/support
     * @param value Value to set for the supportUrl property.
     */
    set supportUrl(value) {
        this._supportUrl = value;
    }
    ;
    /**
     * Gets the termsOfServiceUrl property value. Link to the application's terms of service statement. For example, https://www.contoso.com/app/termsofservice
     * @returns a string
     */
    get termsOfServiceUrl() {
        return this._termsOfServiceUrl;
    }
    ;
    /**
     * Sets the termsOfServiceUrl property value. Link to the application's terms of service statement. For example, https://www.contoso.com/app/termsofservice
     * @param value Value to set for the termsOfServiceUrl property.
     */
    set termsOfServiceUrl(value) {
        this._termsOfServiceUrl = value;
    }
    ;
}
exports.InformationalUrl = InformationalUrl;
