"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Invitation = void 0;
const createInvitedUserMessageInfoFromDiscriminatorValue_1 = require("./createInvitedUserMessageInfoFromDiscriminatorValue");
const createUserFromDiscriminatorValue_1 = require("./createUserFromDiscriminatorValue");
const index_1 = require("./index");
class Invitation extends index_1.Entity {
    /**
     * Instantiates a new invitation and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "invitedUser": (o, n) => { o.invitedUser = n.getObjectValue(createUserFromDiscriminatorValue_1.createUserFromDiscriminatorValue); }, "invitedUserDisplayName": (o, n) => { o.invitedUserDisplayName = n.getStringValue(); }, "invitedUserEmailAddress": (o, n) => { o.invitedUserEmailAddress = n.getStringValue(); }, "invitedUserMessageInfo": (o, n) => { o.invitedUserMessageInfo = n.getObjectValue(createInvitedUserMessageInfoFromDiscriminatorValue_1.createInvitedUserMessageInfoFromDiscriminatorValue); }, "invitedUserType": (o, n) => { o.invitedUserType = n.getStringValue(); }, "inviteRedeemUrl": (o, n) => { o.inviteRedeemUrl = n.getStringValue(); }, "inviteRedirectUrl": (o, n) => { o.inviteRedirectUrl = n.getStringValue(); }, "sendInvitationMessage": (o, n) => { o.sendInvitationMessage = n.getBooleanValue(); }, "status": (o, n) => { o.status = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the invitedUser property value. The user created as part of the invitation creation. Read-Only
     * @returns a user
     */
    get invitedUser() {
        return this._invitedUser;
    }
    ;
    /**
     * Sets the invitedUser property value. The user created as part of the invitation creation. Read-Only
     * @param value Value to set for the invitedUser property.
     */
    set invitedUser(value) {
        this._invitedUser = value;
    }
    ;
    /**
     * Gets the invitedUserDisplayName property value. The display name of the user being invited.
     * @returns a string
     */
    get invitedUserDisplayName() {
        return this._invitedUserDisplayName;
    }
    ;
    /**
     * Sets the invitedUserDisplayName property value. The display name of the user being invited.
     * @param value Value to set for the invitedUserDisplayName property.
     */
    set invitedUserDisplayName(value) {
        this._invitedUserDisplayName = value;
    }
    ;
    /**
     * Gets the invitedUserEmailAddress property value. The email address of the user being invited. Required. The following special characters are not permitted in the email address:Tilde (~)Exclamation point (!)Number sign (#)Dollar sign ($)Percent (%)Circumflex (^)Ampersand (&)Asterisk (*)Parentheses (( ))Plus sign (+)Equal sign (=)Brackets ([ ])Braces ({ })Backslash (/)Slash mark (/)Pipe (/|)Semicolon (;)Colon (:)Quotation marks (')Angle brackets (< >)Question mark (?)Comma (,)However, the following exceptions apply:A period (.) or a hyphen (-) is permitted anywhere in the user name, except at the beginning or end of the name.An underscore (_) is permitted anywhere in the user name. This includes at the beginning or end of the name.
     * @returns a string
     */
    get invitedUserEmailAddress() {
        return this._invitedUserEmailAddress;
    }
    ;
    /**
     * Sets the invitedUserEmailAddress property value. The email address of the user being invited. Required. The following special characters are not permitted in the email address:Tilde (~)Exclamation point (!)Number sign (#)Dollar sign ($)Percent (%)Circumflex (^)Ampersand (&)Asterisk (*)Parentheses (( ))Plus sign (+)Equal sign (=)Brackets ([ ])Braces ({ })Backslash (/)Slash mark (/)Pipe (/|)Semicolon (;)Colon (:)Quotation marks (')Angle brackets (< >)Question mark (?)Comma (,)However, the following exceptions apply:A period (.) or a hyphen (-) is permitted anywhere in the user name, except at the beginning or end of the name.An underscore (_) is permitted anywhere in the user name. This includes at the beginning or end of the name.
     * @param value Value to set for the invitedUserEmailAddress property.
     */
    set invitedUserEmailAddress(value) {
        this._invitedUserEmailAddress = value;
    }
    ;
    /**
     * Gets the invitedUserMessageInfo property value. Additional configuration for the message being sent to the invited user, including customizing message text, language and cc recipient list.
     * @returns a invitedUserMessageInfo
     */
    get invitedUserMessageInfo() {
        return this._invitedUserMessageInfo;
    }
    ;
    /**
     * Sets the invitedUserMessageInfo property value. Additional configuration for the message being sent to the invited user, including customizing message text, language and cc recipient list.
     * @param value Value to set for the invitedUserMessageInfo property.
     */
    set invitedUserMessageInfo(value) {
        this._invitedUserMessageInfo = value;
    }
    ;
    /**
     * Gets the invitedUserType property value. The userType of the user being invited. By default, this is Guest. You can invite as Member if you are a company administrator.
     * @returns a string
     */
    get invitedUserType() {
        return this._invitedUserType;
    }
    ;
    /**
     * Sets the invitedUserType property value. The userType of the user being invited. By default, this is Guest. You can invite as Member if you are a company administrator.
     * @param value Value to set for the invitedUserType property.
     */
    set invitedUserType(value) {
        this._invitedUserType = value;
    }
    ;
    /**
     * Gets the inviteRedeemUrl property value. The URL the user can use to redeem their invitation. Read-only.
     * @returns a string
     */
    get inviteRedeemUrl() {
        return this._inviteRedeemUrl;
    }
    ;
    /**
     * Sets the inviteRedeemUrl property value. The URL the user can use to redeem their invitation. Read-only.
     * @param value Value to set for the inviteRedeemUrl property.
     */
    set inviteRedeemUrl(value) {
        this._inviteRedeemUrl = value;
    }
    ;
    /**
     * Gets the inviteRedirectUrl property value. The URL the user should be redirected to once the invitation is redeemed. Required.
     * @returns a string
     */
    get inviteRedirectUrl() {
        return this._inviteRedirectUrl;
    }
    ;
    /**
     * Sets the inviteRedirectUrl property value. The URL the user should be redirected to once the invitation is redeemed. Required.
     * @param value Value to set for the inviteRedirectUrl property.
     */
    set inviteRedirectUrl(value) {
        this._inviteRedirectUrl = value;
    }
    ;
    /**
     * Gets the sendInvitationMessage property value. Indicates whether an email should be sent to the user being invited. The default is false.
     * @returns a boolean
     */
    get sendInvitationMessage() {
        return this._sendInvitationMessage;
    }
    ;
    /**
     * Sets the sendInvitationMessage property value. Indicates whether an email should be sent to the user being invited. The default is false.
     * @param value Value to set for the sendInvitationMessage property.
     */
    set sendInvitationMessage(value) {
        this._sendInvitationMessage = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("invitedUser", this.invitedUser);
        writer.writeStringValue("invitedUserDisplayName", this.invitedUserDisplayName);
        writer.writeStringValue("invitedUserEmailAddress", this.invitedUserEmailAddress);
        writer.writeObjectValue("invitedUserMessageInfo", this.invitedUserMessageInfo);
        writer.writeStringValue("invitedUserType", this.invitedUserType);
        writer.writeStringValue("inviteRedeemUrl", this.inviteRedeemUrl);
        writer.writeStringValue("inviteRedirectUrl", this.inviteRedirectUrl);
        writer.writeBooleanValue("sendInvitationMessage", this.sendInvitationMessage);
        writer.writeStringValue("status", this.status);
    }
    ;
    /**
     * Gets the status property value. The status of the invitation. Possible values are: PendingAcceptance, Completed, InProgress, and Error.
     * @returns a string
     */
    get status() {
        return this._status;
    }
    ;
    /**
     * Sets the status property value. The status of the invitation. Possible values are: PendingAcceptance, Completed, InProgress, and Error.
     * @param value Value to set for the status property.
     */
    set status(value) {
        this._status = value;
    }
    ;
}
exports.Invitation = Invitation;
