"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InvitationParticipantInfo = void 0;
const createIdentitySetFromDiscriminatorValue_1 = require("./createIdentitySetFromDiscriminatorValue");
class InvitationParticipantInfo {
    /**
     * Instantiates a new invitationParticipantInfo and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "hidden": (o, n) => { o.hidden = n.getBooleanValue(); },
            "identity": (o, n) => { o.identity = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); },
            "participantId": (o, n) => { o.participantId = n.getStringValue(); },
            "removeFromDefaultAudioRoutingGroup": (o, n) => { o.removeFromDefaultAudioRoutingGroup = n.getBooleanValue(); },
            "replacesCallId": (o, n) => { o.replacesCallId = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the hidden property value.
     * @returns a boolean
     */
    get hidden() {
        return this._hidden;
    }
    ;
    /**
     * Sets the hidden property value.
     * @param value Value to set for the hidden property.
     */
    set hidden(value) {
        this._hidden = value;
    }
    ;
    /**
     * Gets the identity property value.
     * @returns a identitySet
     */
    get identity() {
        return this._identity;
    }
    ;
    /**
     * Sets the identity property value.
     * @param value Value to set for the identity property.
     */
    set identity(value) {
        this._identity = value;
    }
    ;
    /**
     * Gets the participantId property value.
     * @returns a string
     */
    get participantId() {
        return this._participantId;
    }
    ;
    /**
     * Sets the participantId property value.
     * @param value Value to set for the participantId property.
     */
    set participantId(value) {
        this._participantId = value;
    }
    ;
    /**
     * Gets the removeFromDefaultAudioRoutingGroup property value.
     * @returns a boolean
     */
    get removeFromDefaultAudioRoutingGroup() {
        return this._removeFromDefaultAudioRoutingGroup;
    }
    ;
    /**
     * Sets the removeFromDefaultAudioRoutingGroup property value.
     * @param value Value to set for the removeFromDefaultAudioRoutingGroup property.
     */
    set removeFromDefaultAudioRoutingGroup(value) {
        this._removeFromDefaultAudioRoutingGroup = value;
    }
    ;
    /**
     * Gets the replacesCallId property value. Optional. The call which the target identity is currently a part of. This call will be dropped once the participant is added.
     * @returns a string
     */
    get replacesCallId() {
        return this._replacesCallId;
    }
    ;
    /**
     * Sets the replacesCallId property value. Optional. The call which the target identity is currently a part of. This call will be dropped once the participant is added.
     * @param value Value to set for the replacesCallId property.
     */
    set replacesCallId(value) {
        this._replacesCallId = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("hidden", this.hidden);
        writer.writeObjectValue("identity", this.identity);
        writer.writeStringValue("participantId", this.participantId);
        writer.writeBooleanValue("removeFromDefaultAudioRoutingGroup", this.removeFromDefaultAudioRoutingGroup);
        writer.writeStringValue("replacesCallId", this.replacesCallId);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.InvitationParticipantInfo = InvitationParticipantInfo;
