"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IosUpdateDeviceStatus = void 0;
const complianceStatus_1 = require("./complianceStatus");
const index_1 = require("./index");
const iosUpdatesInstallStatus_1 = require("./iosUpdatesInstallStatus");
class IosUpdateDeviceStatus extends index_1.Entity {
    /**
     * Instantiates a new iosUpdateDeviceStatus and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the complianceGracePeriodExpirationDateTime property value. The DateTime when device compliance grace period expires
     * @returns a Date
     */
    get complianceGracePeriodExpirationDateTime() {
        return this._complianceGracePeriodExpirationDateTime;
    }
    ;
    /**
     * Sets the complianceGracePeriodExpirationDateTime property value. The DateTime when device compliance grace period expires
     * @param value Value to set for the complianceGracePeriodExpirationDateTime property.
     */
    set complianceGracePeriodExpirationDateTime(value) {
        this._complianceGracePeriodExpirationDateTime = value;
    }
    ;
    ;
    /**
     * Gets the deviceDisplayName property value. Device name of the DevicePolicyStatus.
     * @returns a string
     */
    get deviceDisplayName() {
        return this._deviceDisplayName;
    }
    ;
    /**
     * Sets the deviceDisplayName property value. Device name of the DevicePolicyStatus.
     * @param value Value to set for the deviceDisplayName property.
     */
    set deviceDisplayName(value) {
        this._deviceDisplayName = value;
    }
    ;
    /**
     * Gets the deviceId property value. The device id that is being reported.
     * @returns a string
     */
    get deviceId() {
        return this._deviceId;
    }
    ;
    /**
     * Sets the deviceId property value. The device id that is being reported.
     * @param value Value to set for the deviceId property.
     */
    set deviceId(value) {
        this._deviceId = value;
    }
    ;
    /**
     * Gets the deviceModel property value. The device model that is being reported
     * @returns a string
     */
    get deviceModel() {
        return this._deviceModel;
    }
    ;
    /**
     * Sets the deviceModel property value. The device model that is being reported
     * @param value Value to set for the deviceModel property.
     */
    set deviceModel(value) {
        this._deviceModel = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "complianceGracePeriodExpirationDateTime": (o, n) => { o.complianceGracePeriodExpirationDateTime = n.getDateValue(); }, "deviceDisplayName": (o, n) => { o.deviceDisplayName = n.getStringValue(); }, "deviceId": (o, n) => { o.deviceId = n.getStringValue(); }, "deviceModel": (o, n) => { o.deviceModel = n.getStringValue(); }, "installStatus": (o, n) => { o.installStatus = n.getEnumValue(iosUpdatesInstallStatus_1.IosUpdatesInstallStatus); }, "lastReportedDateTime": (o, n) => { o.lastReportedDateTime = n.getDateValue(); }, "osVersion": (o, n) => { o.osVersion = n.getStringValue(); }, "status": (o, n) => { o.status = n.getEnumValue(complianceStatus_1.ComplianceStatus); }, "userId": (o, n) => { o.userId = n.getStringValue(); }, "userName": (o, n) => { o.userName = n.getStringValue(); }, "userPrincipalName": (o, n) => { o.userPrincipalName = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the installStatus property value. The installation status of the policy report. Possible values are: success, available, idle, unknown, downloading, downloadFailed, downloadRequiresComputer, downloadInsufficientSpace, downloadInsufficientPower, downloadInsufficientNetwork, installing, installInsufficientSpace, installInsufficientPower, installPhoneCallInProgress, installFailed, notSupportedOperation, sharedDeviceUserLoggedInError, deviceOsHigherThanDesiredOsVersion.
     * @returns a iosUpdatesInstallStatus
     */
    get installStatus() {
        return this._installStatus;
    }
    ;
    /**
     * Sets the installStatus property value. The installation status of the policy report. Possible values are: success, available, idle, unknown, downloading, downloadFailed, downloadRequiresComputer, downloadInsufficientSpace, downloadInsufficientPower, downloadInsufficientNetwork, installing, installInsufficientSpace, installInsufficientPower, installPhoneCallInProgress, installFailed, notSupportedOperation, sharedDeviceUserLoggedInError, deviceOsHigherThanDesiredOsVersion.
     * @param value Value to set for the installStatus property.
     */
    set installStatus(value) {
        this._installStatus = value;
    }
    ;
    /**
     * Gets the lastReportedDateTime property value. Last modified date time of the policy report.
     * @returns a Date
     */
    get lastReportedDateTime() {
        return this._lastReportedDateTime;
    }
    ;
    /**
     * Sets the lastReportedDateTime property value. Last modified date time of the policy report.
     * @param value Value to set for the lastReportedDateTime property.
     */
    set lastReportedDateTime(value) {
        this._lastReportedDateTime = value;
    }
    ;
    /**
     * Gets the osVersion property value. The device version that is being reported.
     * @returns a string
     */
    get osVersion() {
        return this._osVersion;
    }
    ;
    /**
     * Sets the osVersion property value. The device version that is being reported.
     * @param value Value to set for the osVersion property.
     */
    set osVersion(value) {
        this._osVersion = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeDateValue("complianceGracePeriodExpirationDateTime", this.complianceGracePeriodExpirationDateTime);
        writer.writeStringValue("deviceDisplayName", this.deviceDisplayName);
        writer.writeStringValue("deviceId", this.deviceId);
        writer.writeStringValue("deviceModel", this.deviceModel);
        writer.writeEnumValue("installStatus", this.installStatus);
        writer.writeDateValue("lastReportedDateTime", this.lastReportedDateTime);
        writer.writeStringValue("osVersion", this.osVersion);
        writer.writeEnumValue("status", this.status);
        writer.writeStringValue("userId", this.userId);
        writer.writeStringValue("userName", this.userName);
        writer.writeStringValue("userPrincipalName", this.userPrincipalName);
    }
    ;
    /**
     * Gets the status property value. Compliance status of the policy report. Possible values are: unknown, notApplicable, compliant, remediated, nonCompliant, error, conflict, notAssigned.
     * @returns a complianceStatus
     */
    get status() {
        return this._status;
    }
    ;
    /**
     * Sets the status property value. Compliance status of the policy report. Possible values are: unknown, notApplicable, compliant, remediated, nonCompliant, error, conflict, notAssigned.
     * @param value Value to set for the status property.
     */
    set status(value) {
        this._status = value;
    }
    ;
    /**
     * Gets the userId property value. The User id that is being reported.
     * @returns a string
     */
    get userId() {
        return this._userId;
    }
    ;
    /**
     * Sets the userId property value. The User id that is being reported.
     * @param value Value to set for the userId property.
     */
    set userId(value) {
        this._userId = value;
    }
    ;
    /**
     * Gets the userName property value. The User Name that is being reported
     * @returns a string
     */
    get userName() {
        return this._userName;
    }
    ;
    /**
     * Sets the userName property value. The User Name that is being reported
     * @param value Value to set for the userName property.
     */
    set userName(value) {
        this._userName = value;
    }
    ;
    /**
     * Gets the userPrincipalName property value. UserPrincipalName.
     * @returns a string
     */
    get userPrincipalName() {
        return this._userPrincipalName;
    }
    ;
    /**
     * Sets the userPrincipalName property value. UserPrincipalName.
     * @param value Value to set for the userPrincipalName property.
     */
    set userPrincipalName(value) {
        this._userPrincipalName = value;
    }
    ;
}
exports.IosUpdateDeviceStatus = IosUpdateDeviceStatus;
