"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ItemActionStat = void 0;
class ItemActionStat {
    /**
     * Instantiates a new itemActionStat and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the actionCount property value. The number of times the action took place. Read-only.
     * @returns a integer
     */
    get actionCount() {
        return this._actionCount;
    }
    ;
    /**
     * Sets the actionCount property value. The number of times the action took place. Read-only.
     * @param value Value to set for the actionCount property.
     */
    set actionCount(value) {
        this._actionCount = value;
    }
    ;
    /**
     * Gets the actorCount property value. The number of distinct actors that performed the action. Read-only.
     * @returns a integer
     */
    get actorCount() {
        return this._actorCount;
    }
    ;
    /**
     * Sets the actorCount property value. The number of distinct actors that performed the action. Read-only.
     * @param value Value to set for the actorCount property.
     */
    set actorCount(value) {
        this._actorCount = value;
    }
    ;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "actionCount": (o, n) => { o.actionCount = n.getNumberValue(); },
            "actorCount": (o, n) => { o.actorCount = n.getNumberValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeNumberValue("actionCount", this.actionCount);
        writer.writeNumberValue("actorCount", this.actorCount);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ItemActionStat = ItemActionStat;
