"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ItemActivity = void 0;
const createAccessActionFromDiscriminatorValue_1 = require("./createAccessActionFromDiscriminatorValue");
const createDriveItemFromDiscriminatorValue_1 = require("./createDriveItemFromDiscriminatorValue");
const createIdentitySetFromDiscriminatorValue_1 = require("./createIdentitySetFromDiscriminatorValue");
const index_1 = require("./index");
class ItemActivity extends index_1.Entity {
    /**
     * Instantiates a new itemActivity and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the access property value. An item was accessed.
     * @returns a accessAction
     */
    get access() {
        return this._access;
    }
    ;
    /**
     * Sets the access property value. An item was accessed.
     * @param value Value to set for the access property.
     */
    set access(value) {
        this._access = value;
    }
    ;
    /**
     * Gets the activityDateTime property value. Details about when the activity took place. Read-only.
     * @returns a Date
     */
    get activityDateTime() {
        return this._activityDateTime;
    }
    ;
    /**
     * Sets the activityDateTime property value. Details about when the activity took place. Read-only.
     * @param value Value to set for the activityDateTime property.
     */
    set activityDateTime(value) {
        this._activityDateTime = value;
    }
    ;
    /**
     * Gets the actor property value. Identity of who performed the action. Read-only.
     * @returns a identitySet
     */
    get actor() {
        return this._actor;
    }
    ;
    /**
     * Sets the actor property value. Identity of who performed the action. Read-only.
     * @param value Value to set for the actor property.
     */
    set actor(value) {
        this._actor = value;
    }
    ;
    ;
    /**
     * Gets the driveItem property value. Exposes the driveItem that was the target of this activity.
     * @returns a driveItem
     */
    get driveItem() {
        return this._driveItem;
    }
    ;
    /**
     * Sets the driveItem property value. Exposes the driveItem that was the target of this activity.
     * @param value Value to set for the driveItem property.
     */
    set driveItem(value) {
        this._driveItem = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "access": (o, n) => { o.access = n.getObjectValue(createAccessActionFromDiscriminatorValue_1.createAccessActionFromDiscriminatorValue); }, "activityDateTime": (o, n) => { o.activityDateTime = n.getDateValue(); }, "actor": (o, n) => { o.actor = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); }, "driveItem": (o, n) => { o.driveItem = n.getObjectValue(createDriveItemFromDiscriminatorValue_1.createDriveItemFromDiscriminatorValue); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("access", this.access);
        writer.writeDateValue("activityDateTime", this.activityDateTime);
        writer.writeObjectValue("actor", this.actor);
        writer.writeObjectValue("driveItem", this.driveItem);
    }
    ;
}
exports.ItemActivity = ItemActivity;
