import { Entity, ItemActivityStat } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ItemAnalytics extends Entity implements Parsable {
    private _allTime?;
    private _itemActivityStats?;
    private _lastSevenDays?;
    /**
     * Gets the allTime property value.
     * @returns a itemActivityStat
     */
    get allTime(): ItemActivityStat | undefined;
    /**
     * Sets the allTime property value.
     * @param value Value to set for the allTime property.
     */
    set allTime(value: ItemActivityStat | undefined);
    /**
     * Instantiates a new itemAnalytics and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the itemActivityStats property value.
     * @returns a itemActivityStat
     */
    get itemActivityStats(): ItemActivityStat[] | undefined;
    /**
     * Sets the itemActivityStats property value.
     * @param value Value to set for the itemActivityStats property.
     */
    set itemActivityStats(value: ItemActivityStat[] | undefined);
    /**
     * Gets the lastSevenDays property value.
     * @returns a itemActivityStat
     */
    get lastSevenDays(): ItemActivityStat | undefined;
    /**
     * Sets the lastSevenDays property value.
     * @param value Value to set for the lastSevenDays property.
     */
    set lastSevenDays(value: ItemActivityStat | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
