import { BodyType } from './bodyType';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ItemBody implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** The content of the item.  */
    private _content?;
    /** The type of the content. Possible values are text and html.  */
    private _contentType?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new itemBody and sets the default values.
     */
    constructor();
    /**
     * Gets the content property value. The content of the item.
     * @returns a string
     */
    get content(): string | undefined;
    /**
     * Sets the content property value. The content of the item.
     * @param value Value to set for the content property.
     */
    set content(value: string | undefined);
    /**
     * Gets the contentType property value. The type of the content. Possible values are text and html.
     * @returns a bodyType
     */
    get contentType(): BodyType | undefined;
    /**
     * Sets the contentType property value. The type of the content. Possible values are text and html.
     * @param value Value to set for the contentType property.
     */
    set contentType(value: BodyType | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
