import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ItemPreviewInfo implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _getUrl?;
    private _postParameters?;
    private _postUrl?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new itemPreviewInfo and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the getUrl property value.
     * @returns a string
     */
    get getUrl(): string | undefined;
    /**
     * Sets the getUrl property value.
     * @param value Value to set for the getUrl property.
     */
    set getUrl(value: string | undefined);
    /**
     * Gets the postParameters property value.
     * @returns a string
     */
    get postParameters(): string | undefined;
    /**
     * Sets the postParameters property value.
     * @param value Value to set for the postParameters property.
     */
    set postParameters(value: string | undefined);
    /**
     * Gets the postUrl property value.
     * @returns a string
     */
    get postUrl(): string | undefined;
    /**
     * Sets the postUrl property value.
     * @param value Value to set for the postUrl property.
     */
    set postUrl(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
