import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class LicenseAssignmentState implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** The id of the group that assigns this license. If the assignment is a direct-assigned license, this field will be Null. Read-Only.  */
    private _assignedByGroup?;
    /** The service plans that are disabled in this assignment. Read-Only.  */
    private _disabledPlans?;
    /** License assignment failure error. If the license is assigned successfully, this field will be Null. Read-Only. The possible values are CountViolation, MutuallyExclusiveViolation, DependencyViolation, ProhibitedInUsageLocationViolation, UniquenessViolation, and Other. For more information on how to identify and resolve license assignment errors see here.  */
    private _error_escaped?;
    /** The timestamp when the state of the license assignment was last updated.  */
    private _lastUpdatedDateTime?;
    /** The unique identifier for the SKU. Read-Only.  */
    private _skuId?;
    /** Indicate the current state of this assignment. Read-Only. The possible values are Active, ActiveWithError, Disabled, and Error.  */
    private _state?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the assignedByGroup property value. The id of the group that assigns this license. If the assignment is a direct-assigned license, this field will be Null. Read-Only.
     * @returns a string
     */
    get assignedByGroup(): string | undefined;
    /**
     * Sets the assignedByGroup property value. The id of the group that assigns this license. If the assignment is a direct-assigned license, this field will be Null. Read-Only.
     * @param value Value to set for the assignedByGroup property.
     */
    set assignedByGroup(value: string | undefined);
    /**
     * Instantiates a new licenseAssignmentState and sets the default values.
     */
    constructor();
    /**
     * Gets the disabledPlans property value. The service plans that are disabled in this assignment. Read-Only.
     * @returns a string
     */
    get disabledPlans(): string[] | undefined;
    /**
     * Sets the disabledPlans property value. The service plans that are disabled in this assignment. Read-Only.
     * @param value Value to set for the disabledPlans property.
     */
    set disabledPlans(value: string[] | undefined);
    /**
     * Gets the error property value. License assignment failure error. If the license is assigned successfully, this field will be Null. Read-Only. The possible values are CountViolation, MutuallyExclusiveViolation, DependencyViolation, ProhibitedInUsageLocationViolation, UniquenessViolation, and Other. For more information on how to identify and resolve license assignment errors see here.
     * @returns a string
     */
    get error_escaped(): string | undefined;
    /**
     * Sets the error property value. License assignment failure error. If the license is assigned successfully, this field will be Null. Read-Only. The possible values are CountViolation, MutuallyExclusiveViolation, DependencyViolation, ProhibitedInUsageLocationViolation, UniquenessViolation, and Other. For more information on how to identify and resolve license assignment errors see here.
     * @param value Value to set for the error_escaped property.
     */
    set error_escaped(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the lastUpdatedDateTime property value. The timestamp when the state of the license assignment was last updated.
     * @returns a Date
     */
    get lastUpdatedDateTime(): Date | undefined;
    /**
     * Sets the lastUpdatedDateTime property value. The timestamp when the state of the license assignment was last updated.
     * @param value Value to set for the lastUpdatedDateTime property.
     */
    set lastUpdatedDateTime(value: Date | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the skuId property value. The unique identifier for the SKU. Read-Only.
     * @returns a string
     */
    get skuId(): string | undefined;
    /**
     * Sets the skuId property value. The unique identifier for the SKU. Read-Only.
     * @param value Value to set for the skuId property.
     */
    set skuId(value: string | undefined);
    /**
     * Gets the state property value. Indicate the current state of this assignment. Read-Only. The possible values are Active, ActiveWithError, Disabled, and Error.
     * @returns a string
     */
    get state(): string | undefined;
    /**
     * Sets the state property value. Indicate the current state of this assignment. Read-Only. The possible values are Active, ActiveWithError, Disabled, and Error.
     * @param value Value to set for the state property.
     */
    set state(value: string | undefined);
}
