"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LicenseAssignmentState = void 0;
class LicenseAssignmentState {
    /**
     * Instantiates a new licenseAssignmentState and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the assignedByGroup property value. The id of the group that assigns this license. If the assignment is a direct-assigned license, this field will be Null. Read-Only.
     * @returns a string
     */
    get assignedByGroup() {
        return this._assignedByGroup;
    }
    ;
    /**
     * Sets the assignedByGroup property value. The id of the group that assigns this license. If the assignment is a direct-assigned license, this field will be Null. Read-Only.
     * @param value Value to set for the assignedByGroup property.
     */
    set assignedByGroup(value) {
        this._assignedByGroup = value;
    }
    ;
    ;
    /**
     * Gets the disabledPlans property value. The service plans that are disabled in this assignment. Read-Only.
     * @returns a string
     */
    get disabledPlans() {
        return this._disabledPlans;
    }
    ;
    /**
     * Sets the disabledPlans property value. The service plans that are disabled in this assignment. Read-Only.
     * @param value Value to set for the disabledPlans property.
     */
    set disabledPlans(value) {
        this._disabledPlans = value;
    }
    ;
    /**
     * Gets the error property value. License assignment failure error. If the license is assigned successfully, this field will be Null. Read-Only. The possible values are CountViolation, MutuallyExclusiveViolation, DependencyViolation, ProhibitedInUsageLocationViolation, UniquenessViolation, and Other. For more information on how to identify and resolve license assignment errors see here.
     * @returns a string
     */
    get error_escaped() {
        return this._error_escaped;
    }
    ;
    /**
     * Sets the error property value. License assignment failure error. If the license is assigned successfully, this field will be Null. Read-Only. The possible values are CountViolation, MutuallyExclusiveViolation, DependencyViolation, ProhibitedInUsageLocationViolation, UniquenessViolation, and Other. For more information on how to identify and resolve license assignment errors see here.
     * @param value Value to set for the error_escaped property.
     */
    set error_escaped(value) {
        this._error_escaped = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "assignedByGroup": (o, n) => { o.assignedByGroup = n.getStringValue(); },
            "disabledPlans": (o, n) => { o.disabledPlans = n.getCollectionOfPrimitiveValues(); },
            "error": (o, n) => { o.error_escaped = n.getStringValue(); },
            "lastUpdatedDateTime": (o, n) => { o.lastUpdatedDateTime = n.getDateValue(); },
            "skuId": (o, n) => { o.skuId = n.getStringValue(); },
            "state": (o, n) => { o.state = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the lastUpdatedDateTime property value. The timestamp when the state of the license assignment was last updated.
     * @returns a Date
     */
    get lastUpdatedDateTime() {
        return this._lastUpdatedDateTime;
    }
    ;
    /**
     * Sets the lastUpdatedDateTime property value. The timestamp when the state of the license assignment was last updated.
     * @param value Value to set for the lastUpdatedDateTime property.
     */
    set lastUpdatedDateTime(value) {
        this._lastUpdatedDateTime = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("assignedByGroup", this.assignedByGroup);
        writer.writeCollectionOfPrimitiveValues("disabledPlans", this.disabledPlans);
        writer.writeStringValue("error", this.error_escaped);
        writer.writeDateValue("lastUpdatedDateTime", this.lastUpdatedDateTime);
        writer.writeStringValue("skuId", this.skuId);
        writer.writeStringValue("state", this.state);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the skuId property value. The unique identifier for the SKU. Read-Only.
     * @returns a string
     */
    get skuId() {
        return this._skuId;
    }
    ;
    /**
     * Sets the skuId property value. The unique identifier for the SKU. Read-Only.
     * @param value Value to set for the skuId property.
     */
    set skuId(value) {
        this._skuId = value;
    }
    ;
    /**
     * Gets the state property value. Indicate the current state of this assignment. Read-Only. The possible values are Active, ActiveWithError, Disabled, and Error.
     * @returns a string
     */
    get state() {
        return this._state;
    }
    ;
    /**
     * Sets the state property value. Indicate the current state of this assignment. Read-Only. The possible values are Active, ActiveWithError, Disabled, and Error.
     * @param value Value to set for the state property.
     */
    set state(value) {
        this._state = value;
    }
    ;
}
exports.LicenseAssignmentState = LicenseAssignmentState;
