import { Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class LinkedResource extends Entity implements Parsable {
    /** Field indicating the app name of the source that is sending the linkedResource.  */
    private _applicationName?;
    /** Field indicating the title of the linkedResource.  */
    private _displayName?;
    /** Id of the object that is associated with this task on the third-party/partner system.  */
    private _externalId?;
    /** Deep link to the linkedResource.  */
    private _webUrl?;
    /**
     * Gets the applicationName property value. Field indicating the app name of the source that is sending the linkedResource.
     * @returns a string
     */
    get applicationName(): string | undefined;
    /**
     * Sets the applicationName property value. Field indicating the app name of the source that is sending the linkedResource.
     * @param value Value to set for the applicationName property.
     */
    set applicationName(value: string | undefined);
    /**
     * Instantiates a new linkedResource and sets the default values.
     */
    constructor();
    /**
     * Gets the displayName property value. Field indicating the title of the linkedResource.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. Field indicating the title of the linkedResource.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * Gets the externalId property value. Id of the object that is associated with this task on the third-party/partner system.
     * @returns a string
     */
    get externalId(): string | undefined;
    /**
     * Sets the externalId property value. Id of the object that is associated with this task on the third-party/partner system.
     * @param value Value to set for the externalId property.
     */
    set externalId(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the webUrl property value. Deep link to the linkedResource.
     * @returns a string
     */
    get webUrl(): string | undefined;
    /**
     * Sets the webUrl property value. Deep link to the linkedResource.
     * @param value Value to set for the webUrl property.
     */
    set webUrl(value: string | undefined);
}
