"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LinkedResource = void 0;
const index_1 = require("./index");
class LinkedResource extends index_1.Entity {
    /**
     * Instantiates a new linkedResource and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the applicationName property value. Field indicating the app name of the source that is sending the linkedResource.
     * @returns a string
     */
    get applicationName() {
        return this._applicationName;
    }
    ;
    /**
     * Sets the applicationName property value. Field indicating the app name of the source that is sending the linkedResource.
     * @param value Value to set for the applicationName property.
     */
    set applicationName(value) {
        this._applicationName = value;
    }
    ;
    ;
    /**
     * Gets the displayName property value. Field indicating the title of the linkedResource.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. Field indicating the title of the linkedResource.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * Gets the externalId property value. Id of the object that is associated with this task on the third-party/partner system.
     * @returns a string
     */
    get externalId() {
        return this._externalId;
    }
    ;
    /**
     * Sets the externalId property value. Id of the object that is associated with this task on the third-party/partner system.
     * @param value Value to set for the externalId property.
     */
    set externalId(value) {
        this._externalId = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "applicationName": (o, n) => { o.applicationName = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "externalId": (o, n) => { o.externalId = n.getStringValue(); }, "webUrl": (o, n) => { o.webUrl = n.getStringValue(); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("applicationName", this.applicationName);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeStringValue("externalId", this.externalId);
        writer.writeStringValue("webUrl", this.webUrl);
    }
    ;
    /**
     * Gets the webUrl property value. Deep link to the linkedResource.
     * @returns a string
     */
    get webUrl() {
        return this._webUrl;
    }
    ;
    /**
     * Sets the webUrl property value. Deep link to the linkedResource.
     * @param value Value to set for the webUrl property.
     */
    set webUrl(value) {
        this._webUrl = value;
    }
    ;
}
exports.LinkedResource = LinkedResource;
