"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListInfo = void 0;
class ListInfo {
    /**
     * Instantiates a new listInfo and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the contentTypesEnabled property value. If true, indicates that content types are enabled for this list.
     * @returns a boolean
     */
    get contentTypesEnabled() {
        return this._contentTypesEnabled;
    }
    ;
    /**
     * Sets the contentTypesEnabled property value. If true, indicates that content types are enabled for this list.
     * @param value Value to set for the contentTypesEnabled property.
     */
    set contentTypesEnabled(value) {
        this._contentTypesEnabled = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "contentTypesEnabled": (o, n) => { o.contentTypesEnabled = n.getBooleanValue(); },
            "hidden": (o, n) => { o.hidden = n.getBooleanValue(); },
            "template": (o, n) => { o.template = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the hidden property value. If true, indicates that the list is not normally visible in the SharePoint user experience.
     * @returns a boolean
     */
    get hidden() {
        return this._hidden;
    }
    ;
    /**
     * Sets the hidden property value. If true, indicates that the list is not normally visible in the SharePoint user experience.
     * @param value Value to set for the hidden property.
     */
    set hidden(value) {
        this._hidden = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("contentTypesEnabled", this.contentTypesEnabled);
        writer.writeBooleanValue("hidden", this.hidden);
        writer.writeStringValue("template", this.template);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the template property value. An enumerated value that represents the base list template used in creating the list. Possible values include documentLibrary, genericList, task, survey, announcements, contacts, and more.
     * @returns a string
     */
    get template() {
        return this._template;
    }
    ;
    /**
     * Sets the template property value. An enumerated value that represents the base list template used in creating the list. Possible values include documentLibrary, genericList, task, survey, announcements, contacts, and more.
     * @param value Value to set for the template property.
     */
    set template(value) {
        this._template = value;
    }
    ;
}
exports.ListInfo = ListInfo;
