import { BaseItemVersion, FieldValueSet } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ListItemVersion extends BaseItemVersion implements Parsable {
    /** A collection of the fields and values for this version of the list item.  */
    private _fields?;
    /**
     * Instantiates a new listItemVersion and sets the default values.
     */
    constructor();
    /**
     * Gets the fields property value. A collection of the fields and values for this version of the list item.
     * @returns a fieldValueSet
     */
    get fields(): FieldValueSet | undefined;
    /**
     * Sets the fields property value. A collection of the fields and values for this version of the list item.
     * @param value Value to set for the fields property.
     */
    set fields(value: FieldValueSet | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
