import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class LookupColumn implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Indicates whether multiple values can be selected from the source.  */
    private _allowMultipleValues?;
    /** Indicates whether values in the column should be able to exceed the standard limit of 255 characters.  */
    private _allowUnlimitedLength?;
    /** The name of the lookup source column.  */
    private _columnName?;
    /** The unique identifier of the lookup source list.  */
    private _listId?;
    /** If specified, this column is a secondary lookup, pulling an additional field from the list item looked up by the primary lookup. Use the list item looked up by the primary as the source for the column named here.  */
    private _primaryLookupColumnId?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the allowMultipleValues property value. Indicates whether multiple values can be selected from the source.
     * @returns a boolean
     */
    get allowMultipleValues(): boolean | undefined;
    /**
     * Sets the allowMultipleValues property value. Indicates whether multiple values can be selected from the source.
     * @param value Value to set for the allowMultipleValues property.
     */
    set allowMultipleValues(value: boolean | undefined);
    /**
     * Gets the allowUnlimitedLength property value. Indicates whether values in the column should be able to exceed the standard limit of 255 characters.
     * @returns a boolean
     */
    get allowUnlimitedLength(): boolean | undefined;
    /**
     * Sets the allowUnlimitedLength property value. Indicates whether values in the column should be able to exceed the standard limit of 255 characters.
     * @param value Value to set for the allowUnlimitedLength property.
     */
    set allowUnlimitedLength(value: boolean | undefined);
    /**
     * Gets the columnName property value. The name of the lookup source column.
     * @returns a string
     */
    get columnName(): string | undefined;
    /**
     * Sets the columnName property value. The name of the lookup source column.
     * @param value Value to set for the columnName property.
     */
    set columnName(value: string | undefined);
    /**
     * Instantiates a new lookupColumn and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the listId property value. The unique identifier of the lookup source list.
     * @returns a string
     */
    get listId(): string | undefined;
    /**
     * Sets the listId property value. The unique identifier of the lookup source list.
     * @param value Value to set for the listId property.
     */
    set listId(value: string | undefined);
    /**
     * Gets the primaryLookupColumnId property value. If specified, this column is a secondary lookup, pulling an additional field from the list item looked up by the primary lookup. Use the list item looked up by the primary as the source for the column named here.
     * @returns a string
     */
    get primaryLookupColumnId(): string | undefined;
    /**
     * Sets the primaryLookupColumnId property value. If specified, this column is a secondary lookup, pulling an additional field from the list item looked up by the primary lookup. Use the list item looked up by the primary as the source for the column named here.
     * @param value Value to set for the primaryLookupColumnId property.
     */
    set primaryLookupColumnId(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
