"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LookupColumn = void 0;
class LookupColumn {
    /**
     * Instantiates a new lookupColumn and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the allowMultipleValues property value. Indicates whether multiple values can be selected from the source.
     * @returns a boolean
     */
    get allowMultipleValues() {
        return this._allowMultipleValues;
    }
    ;
    /**
     * Sets the allowMultipleValues property value. Indicates whether multiple values can be selected from the source.
     * @param value Value to set for the allowMultipleValues property.
     */
    set allowMultipleValues(value) {
        this._allowMultipleValues = value;
    }
    ;
    /**
     * Gets the allowUnlimitedLength property value. Indicates whether values in the column should be able to exceed the standard limit of 255 characters.
     * @returns a boolean
     */
    get allowUnlimitedLength() {
        return this._allowUnlimitedLength;
    }
    ;
    /**
     * Sets the allowUnlimitedLength property value. Indicates whether values in the column should be able to exceed the standard limit of 255 characters.
     * @param value Value to set for the allowUnlimitedLength property.
     */
    set allowUnlimitedLength(value) {
        this._allowUnlimitedLength = value;
    }
    ;
    /**
     * Gets the columnName property value. The name of the lookup source column.
     * @returns a string
     */
    get columnName() {
        return this._columnName;
    }
    ;
    /**
     * Sets the columnName property value. The name of the lookup source column.
     * @param value Value to set for the columnName property.
     */
    set columnName(value) {
        this._columnName = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "allowMultipleValues": (o, n) => { o.allowMultipleValues = n.getBooleanValue(); },
            "allowUnlimitedLength": (o, n) => { o.allowUnlimitedLength = n.getBooleanValue(); },
            "columnName": (o, n) => { o.columnName = n.getStringValue(); },
            "listId": (o, n) => { o.listId = n.getStringValue(); },
            "primaryLookupColumnId": (o, n) => { o.primaryLookupColumnId = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the listId property value. The unique identifier of the lookup source list.
     * @returns a string
     */
    get listId() {
        return this._listId;
    }
    ;
    /**
     * Sets the listId property value. The unique identifier of the lookup source list.
     * @param value Value to set for the listId property.
     */
    set listId(value) {
        this._listId = value;
    }
    ;
    /**
     * Gets the primaryLookupColumnId property value. If specified, this column is a secondary lookup, pulling an additional field from the list item looked up by the primary lookup. Use the list item looked up by the primary as the source for the column named here.
     * @returns a string
     */
    get primaryLookupColumnId() {
        return this._primaryLookupColumnId;
    }
    ;
    /**
     * Sets the primaryLookupColumnId property value. If specified, this column is a secondary lookup, pulling an additional field from the list item looked up by the primary lookup. Use the list item looked up by the primary as the source for the column named here.
     * @param value Value to set for the primaryLookupColumnId property.
     */
    set primaryLookupColumnId(value) {
        this._primaryLookupColumnId = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("allowMultipleValues", this.allowMultipleValues);
        writer.writeBooleanValue("allowUnlimitedLength", this.allowUnlimitedLength);
        writer.writeStringValue("columnName", this.columnName);
        writer.writeStringValue("listId", this.listId);
        writer.writeStringValue("primaryLookupColumnId", this.primaryLookupColumnId);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.LookupColumn = LookupColumn;
