import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Represents diagnostics status.  */
export declare class ManagedAppDiagnosticStatus implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Instruction on how to mitigate a failed validation  */
    private _mitigationInstruction?;
    /** The state of the operation  */
    private _state?;
    /** The validation friendly name  */
    private _validationName?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new managedAppDiagnosticStatus and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the mitigationInstruction property value. Instruction on how to mitigate a failed validation
     * @returns a string
     */
    get mitigationInstruction(): string | undefined;
    /**
     * Sets the mitigationInstruction property value. Instruction on how to mitigate a failed validation
     * @param value Value to set for the mitigationInstruction property.
     */
    set mitigationInstruction(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the state property value. The state of the operation
     * @returns a string
     */
    get state(): string | undefined;
    /**
     * Sets the state property value. The state of the operation
     * @param value Value to set for the state property.
     */
    set state(value: string | undefined);
    /**
     * Gets the validationName property value. The validation friendly name
     * @returns a string
     */
    get validationName(): string | undefined;
    /**
     * Sets the validationName property value. The validation friendly name
     * @param value Value to set for the validationName property.
     */
    set validationName(value: string | undefined);
}
