"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ManagedAppOperation = void 0;
const index_1 = require("./index");
class ManagedAppOperation extends index_1.Entity {
    /**
     * Instantiates a new managedAppOperation and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the displayName property value. The operation name.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The operation name.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "lastModifiedDateTime": (o, n) => { o.lastModifiedDateTime = n.getDateValue(); }, "state": (o, n) => { o.state = n.getStringValue(); }, "version": (o, n) => { o.version = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the lastModifiedDateTime property value. The last time the app operation was modified.
     * @returns a Date
     */
    get lastModifiedDateTime() {
        return this._lastModifiedDateTime;
    }
    ;
    /**
     * Sets the lastModifiedDateTime property value. The last time the app operation was modified.
     * @param value Value to set for the lastModifiedDateTime property.
     */
    set lastModifiedDateTime(value) {
        this._lastModifiedDateTime = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeDateValue("lastModifiedDateTime", this.lastModifiedDateTime);
        writer.writeStringValue("state", this.state);
        writer.writeStringValue("version", this.version);
    }
    ;
    /**
     * Gets the state property value. The current state of the operation
     * @returns a string
     */
    get state() {
        return this._state;
    }
    ;
    /**
     * Sets the state property value. The current state of the operation
     * @param value Value to set for the state property.
     */
    set state(value) {
        this._state = value;
    }
    ;
    /**
     * Gets the version property value. Version of the entity.
     * @returns a string
     */
    get version() {
        return this._version;
    }
    ;
    /**
     * Sets the version property value. Version of the entity.
     * @param value Value to set for the version property.
     */
    set version(value) {
        this._version = value;
    }
    ;
}
exports.ManagedAppOperation = ManagedAppOperation;
