import { Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ManagedAppPolicy extends Entity implements Parsable {
    /** The date and time the policy was created.  */
    private _createdDateTime?;
    /** The policy's description.  */
    private _description?;
    /** Policy display name.  */
    private _displayName?;
    /** Last time the policy was modified.  */
    private _lastModifiedDateTime?;
    /** Version of the entity.  */
    private _version?;
    /**
     * Instantiates a new managedAppPolicy and sets the default values.
     */
    constructor();
    /**
     * Gets the createdDateTime property value. The date and time the policy was created.
     * @returns a Date
     */
    get createdDateTime(): Date | undefined;
    /**
     * Sets the createdDateTime property value. The date and time the policy was created.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value: Date | undefined);
    /**
     * Gets the description property value. The policy's description.
     * @returns a string
     */
    get description(): string | undefined;
    /**
     * Sets the description property value. The policy's description.
     * @param value Value to set for the description property.
     */
    set description(value: string | undefined);
    /**
     * Gets the displayName property value. Policy display name.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. Policy display name.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the lastModifiedDateTime property value. Last time the policy was modified.
     * @returns a Date
     */
    get lastModifiedDateTime(): Date | undefined;
    /**
     * Sets the lastModifiedDateTime property value. Last time the policy was modified.
     * @param value Value to set for the lastModifiedDateTime property.
     */
    set lastModifiedDateTime(value: Date | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the version property value. Version of the entity.
     * @returns a string
     */
    get version(): string | undefined;
    /**
     * Sets the version property value. Version of the entity.
     * @param value Value to set for the version property.
     */
    set version(value: string | undefined);
}
