"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ManagedAppPolicyDeploymentSummaryPerApp = void 0;
const createMobileAppIdentifierFromDiscriminatorValue_1 = require("./createMobileAppIdentifierFromDiscriminatorValue");
/** Represents policy deployment summary per app.  */
class ManagedAppPolicyDeploymentSummaryPerApp {
    /**
     * Instantiates a new managedAppPolicyDeploymentSummaryPerApp and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the configurationAppliedUserCount property value. Number of users the policy is applied.
     * @returns a integer
     */
    get configurationAppliedUserCount() {
        return this._configurationAppliedUserCount;
    }
    ;
    /**
     * Sets the configurationAppliedUserCount property value. Number of users the policy is applied.
     * @param value Value to set for the configurationAppliedUserCount property.
     */
    set configurationAppliedUserCount(value) {
        this._configurationAppliedUserCount = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "configurationAppliedUserCount": (o, n) => { o.configurationAppliedUserCount = n.getNumberValue(); },
            "mobileAppIdentifier": (o, n) => { o.mobileAppIdentifier = n.getObjectValue(createMobileAppIdentifierFromDiscriminatorValue_1.createMobileAppIdentifierFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the mobileAppIdentifier property value. Deployment of an app.
     * @returns a mobileAppIdentifier
     */
    get mobileAppIdentifier() {
        return this._mobileAppIdentifier;
    }
    ;
    /**
     * Sets the mobileAppIdentifier property value. Deployment of an app.
     * @param value Value to set for the mobileAppIdentifier property.
     */
    set mobileAppIdentifier(value) {
        this._mobileAppIdentifier = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeNumberValue("configurationAppliedUserCount", this.configurationAppliedUserCount);
        writer.writeObjectValue("mobileAppIdentifier", this.mobileAppIdentifier);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ManagedAppPolicyDeploymentSummaryPerApp = ManagedAppPolicyDeploymentSummaryPerApp;
