"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ManagedAppRegistration = void 0;
const createManagedAppOperationFromDiscriminatorValue_1 = require("./createManagedAppOperationFromDiscriminatorValue");
const createManagedAppPolicyFromDiscriminatorValue_1 = require("./createManagedAppPolicyFromDiscriminatorValue");
const createMobileAppIdentifierFromDiscriminatorValue_1 = require("./createMobileAppIdentifierFromDiscriminatorValue");
const index_1 = require("./index");
const managedAppFlaggedReason_1 = require("./managedAppFlaggedReason");
class ManagedAppRegistration extends index_1.Entity {
    /**
     * Instantiates a new managedAppRegistration and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the appIdentifier property value. The app package Identifier
     * @returns a mobileAppIdentifier
     */
    get appIdentifier() {
        return this._appIdentifier;
    }
    ;
    /**
     * Sets the appIdentifier property value. The app package Identifier
     * @param value Value to set for the appIdentifier property.
     */
    set appIdentifier(value) {
        this._appIdentifier = value;
    }
    ;
    /**
     * Gets the applicationVersion property value. App version
     * @returns a string
     */
    get applicationVersion() {
        return this._applicationVersion;
    }
    ;
    /**
     * Sets the applicationVersion property value. App version
     * @param value Value to set for the applicationVersion property.
     */
    set applicationVersion(value) {
        this._applicationVersion = value;
    }
    ;
    /**
     * Gets the appliedPolicies property value. Zero or more policys already applied on the registered app when it last synchronized with managment service.
     * @returns a managedAppPolicy
     */
    get appliedPolicies() {
        return this._appliedPolicies;
    }
    ;
    /**
     * Sets the appliedPolicies property value. Zero or more policys already applied on the registered app when it last synchronized with managment service.
     * @param value Value to set for the appliedPolicies property.
     */
    set appliedPolicies(value) {
        this._appliedPolicies = value;
    }
    ;
    ;
    /**
     * Gets the createdDateTime property value. Date and time of creation
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. Date and time of creation
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * Gets the deviceName property value. Host device name
     * @returns a string
     */
    get deviceName() {
        return this._deviceName;
    }
    ;
    /**
     * Sets the deviceName property value. Host device name
     * @param value Value to set for the deviceName property.
     */
    set deviceName(value) {
        this._deviceName = value;
    }
    ;
    /**
     * Gets the deviceTag property value. App management SDK generated tag, which helps relate apps hosted on the same device. Not guaranteed to relate apps in all conditions.
     * @returns a string
     */
    get deviceTag() {
        return this._deviceTag;
    }
    ;
    /**
     * Sets the deviceTag property value. App management SDK generated tag, which helps relate apps hosted on the same device. Not guaranteed to relate apps in all conditions.
     * @param value Value to set for the deviceTag property.
     */
    set deviceTag(value) {
        this._deviceTag = value;
    }
    ;
    /**
     * Gets the deviceType property value. Host device type
     * @returns a string
     */
    get deviceType() {
        return this._deviceType;
    }
    ;
    /**
     * Sets the deviceType property value. Host device type
     * @param value Value to set for the deviceType property.
     */
    set deviceType(value) {
        this._deviceType = value;
    }
    ;
    /**
     * Gets the flaggedReasons property value. Zero or more reasons an app registration is flagged. E.g. app running on rooted device
     * @returns a managedAppFlaggedReason
     */
    get flaggedReasons() {
        return this._flaggedReasons;
    }
    ;
    /**
     * Sets the flaggedReasons property value. Zero or more reasons an app registration is flagged. E.g. app running on rooted device
     * @param value Value to set for the flaggedReasons property.
     */
    set flaggedReasons(value) {
        this._flaggedReasons = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "appIdentifier": (o, n) => { o.appIdentifier = n.getObjectValue(createMobileAppIdentifierFromDiscriminatorValue_1.createMobileAppIdentifierFromDiscriminatorValue); }, "applicationVersion": (o, n) => { o.applicationVersion = n.getStringValue(); }, "appliedPolicies": (o, n) => { o.appliedPolicies = n.getCollectionOfObjectValues(createManagedAppPolicyFromDiscriminatorValue_1.createManagedAppPolicyFromDiscriminatorValue); }, "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); }, "deviceName": (o, n) => { o.deviceName = n.getStringValue(); }, "deviceTag": (o, n) => { o.deviceTag = n.getStringValue(); }, "deviceType": (o, n) => { o.deviceType = n.getStringValue(); }, "flaggedReasons": (o, n) => { o.flaggedReasons = n.getEnumValues(managedAppFlaggedReason_1.ManagedAppFlaggedReason); }, "intendedPolicies": (o, n) => { o.intendedPolicies = n.getCollectionOfObjectValues(createManagedAppPolicyFromDiscriminatorValue_1.createManagedAppPolicyFromDiscriminatorValue); }, "lastSyncDateTime": (o, n) => { o.lastSyncDateTime = n.getDateValue(); }, "managementSdkVersion": (o, n) => { o.managementSdkVersion = n.getStringValue(); }, "operations": (o, n) => { o.operations = n.getCollectionOfObjectValues(createManagedAppOperationFromDiscriminatorValue_1.createManagedAppOperationFromDiscriminatorValue); }, "platformVersion": (o, n) => { o.platformVersion = n.getStringValue(); }, "userId": (o, n) => { o.userId = n.getStringValue(); }, "version": (o, n) => { o.version = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the intendedPolicies property value. Zero or more policies admin intended for the app as of now.
     * @returns a managedAppPolicy
     */
    get intendedPolicies() {
        return this._intendedPolicies;
    }
    ;
    /**
     * Sets the intendedPolicies property value. Zero or more policies admin intended for the app as of now.
     * @param value Value to set for the intendedPolicies property.
     */
    set intendedPolicies(value) {
        this._intendedPolicies = value;
    }
    ;
    /**
     * Gets the lastSyncDateTime property value. Date and time of last the app synced with management service.
     * @returns a Date
     */
    get lastSyncDateTime() {
        return this._lastSyncDateTime;
    }
    ;
    /**
     * Sets the lastSyncDateTime property value. Date and time of last the app synced with management service.
     * @param value Value to set for the lastSyncDateTime property.
     */
    set lastSyncDateTime(value) {
        this._lastSyncDateTime = value;
    }
    ;
    /**
     * Gets the managementSdkVersion property value. App management SDK version
     * @returns a string
     */
    get managementSdkVersion() {
        return this._managementSdkVersion;
    }
    ;
    /**
     * Sets the managementSdkVersion property value. App management SDK version
     * @param value Value to set for the managementSdkVersion property.
     */
    set managementSdkVersion(value) {
        this._managementSdkVersion = value;
    }
    ;
    /**
     * Gets the operations property value. Zero or more long running operations triggered on the app registration.
     * @returns a managedAppOperation
     */
    get operations() {
        return this._operations;
    }
    ;
    /**
     * Sets the operations property value. Zero or more long running operations triggered on the app registration.
     * @param value Value to set for the operations property.
     */
    set operations(value) {
        this._operations = value;
    }
    ;
    /**
     * Gets the platformVersion property value. Operating System version
     * @returns a string
     */
    get platformVersion() {
        return this._platformVersion;
    }
    ;
    /**
     * Sets the platformVersion property value. Operating System version
     * @param value Value to set for the platformVersion property.
     */
    set platformVersion(value) {
        this._platformVersion = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("appIdentifier", this.appIdentifier);
        writer.writeStringValue("applicationVersion", this.applicationVersion);
        writer.writeCollectionOfObjectValues("appliedPolicies", this.appliedPolicies);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeStringValue("deviceName", this.deviceName);
        writer.writeStringValue("deviceTag", this.deviceTag);
        writer.writeStringValue("deviceType", this.deviceType);
        this.flaggedReasons && writer.writeEnumValue("flaggedReasons", ...this.flaggedReasons);
        writer.writeCollectionOfObjectValues("intendedPolicies", this.intendedPolicies);
        writer.writeDateValue("lastSyncDateTime", this.lastSyncDateTime);
        writer.writeStringValue("managementSdkVersion", this.managementSdkVersion);
        writer.writeCollectionOfObjectValues("operations", this.operations);
        writer.writeStringValue("platformVersion", this.platformVersion);
        writer.writeStringValue("userId", this.userId);
        writer.writeStringValue("version", this.version);
    }
    ;
    /**
     * Gets the userId property value. The user Id to who this app registration belongs.
     * @returns a string
     */
    get userId() {
        return this._userId;
    }
    ;
    /**
     * Sets the userId property value. The user Id to who this app registration belongs.
     * @param value Value to set for the userId property.
     */
    set userId(value) {
        this._userId = value;
    }
    ;
    /**
     * Gets the version property value. Version of the entity.
     * @returns a string
     */
    get version() {
        return this._version;
    }
    ;
    /**
     * Sets the version property value. Version of the entity.
     * @param value Value to set for the version property.
     */
    set version(value) {
        this._version = value;
    }
    ;
}
exports.ManagedAppRegistration = ManagedAppRegistration;
