import { Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ManagedAppStatus extends Entity implements Parsable {
    /** Friendly name of the status report.  */
    private _displayName?;
    /** Version of the entity.  */
    private _version?;
    /**
     * Instantiates a new managedAppStatus and sets the default values.
     */
    constructor();
    /**
     * Gets the displayName property value. Friendly name of the status report.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. Friendly name of the status report.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the version property value. Version of the entity.
     * @returns a string
     */
    get version(): string | undefined;
    /**
     * Sets the version property value. Version of the entity.
     * @param value Value to set for the version property.
     */
    set version(value: string | undefined);
}
