"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ManagedDeviceMobileAppConfigurationUserStatus = void 0;
const complianceStatus_1 = require("./complianceStatus");
const index_1 = require("./index");
class ManagedDeviceMobileAppConfigurationUserStatus extends index_1.Entity {
    /**
     * Instantiates a new managedDeviceMobileAppConfigurationUserStatus and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the devicesCount property value. Devices count for that user.
     * @returns a integer
     */
    get devicesCount() {
        return this._devicesCount;
    }
    ;
    /**
     * Sets the devicesCount property value. Devices count for that user.
     * @param value Value to set for the devicesCount property.
     */
    set devicesCount(value) {
        this._devicesCount = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "devicesCount": (o, n) => { o.devicesCount = n.getNumberValue(); }, "lastReportedDateTime": (o, n) => { o.lastReportedDateTime = n.getDateValue(); }, "status": (o, n) => { o.status = n.getEnumValue(complianceStatus_1.ComplianceStatus); }, "userDisplayName": (o, n) => { o.userDisplayName = n.getStringValue(); }, "userPrincipalName": (o, n) => { o.userPrincipalName = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the lastReportedDateTime property value. Last modified date time of the policy report.
     * @returns a Date
     */
    get lastReportedDateTime() {
        return this._lastReportedDateTime;
    }
    ;
    /**
     * Sets the lastReportedDateTime property value. Last modified date time of the policy report.
     * @param value Value to set for the lastReportedDateTime property.
     */
    set lastReportedDateTime(value) {
        this._lastReportedDateTime = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeNumberValue("devicesCount", this.devicesCount);
        writer.writeDateValue("lastReportedDateTime", this.lastReportedDateTime);
        writer.writeEnumValue("status", this.status);
        writer.writeStringValue("userDisplayName", this.userDisplayName);
        writer.writeStringValue("userPrincipalName", this.userPrincipalName);
    }
    ;
    /**
     * Gets the status property value. Compliance status of the policy report. Possible values are: unknown, notApplicable, compliant, remediated, nonCompliant, error, conflict, notAssigned.
     * @returns a complianceStatus
     */
    get status() {
        return this._status;
    }
    ;
    /**
     * Sets the status property value. Compliance status of the policy report. Possible values are: unknown, notApplicable, compliant, remediated, nonCompliant, error, conflict, notAssigned.
     * @param value Value to set for the status property.
     */
    set status(value) {
        this._status = value;
    }
    ;
    /**
     * Gets the userDisplayName property value. User name of the DevicePolicyStatus.
     * @returns a string
     */
    get userDisplayName() {
        return this._userDisplayName;
    }
    ;
    /**
     * Sets the userDisplayName property value. User name of the DevicePolicyStatus.
     * @param value Value to set for the userDisplayName property.
     */
    set userDisplayName(value) {
        this._userDisplayName = value;
    }
    ;
    /**
     * Gets the userPrincipalName property value. UserPrincipalName.
     * @returns a string
     */
    get userPrincipalName() {
        return this._userPrincipalName;
    }
    ;
    /**
     * Sets the userPrincipalName property value. UserPrincipalName.
     * @param value Value to set for the userPrincipalName property.
     */
    set userPrincipalName(value) {
        this._userPrincipalName = value;
    }
    ;
}
exports.ManagedDeviceMobileAppConfigurationUserStatus = ManagedDeviceMobileAppConfigurationUserStatus;
