import { DeviceInstallState, EBookInstallSummary, Entity, ManagedEBookAssignment, MimeContent, UserInstallStateSummary } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ManagedEBook extends Entity implements Parsable {
    /** The list of assignments for this eBook.  */
    private _assignments?;
    /** The date and time when the eBook file was created.  */
    private _createdDateTime?;
    /** Description.  */
    private _description?;
    /** The list of installation states for this eBook.  */
    private _deviceStates?;
    /** Name of the eBook.  */
    private _displayName?;
    /** The more information Url.  */
    private _informationUrl?;
    /** Mobile App Install Summary.  */
    private _installSummary?;
    /** Book cover.  */
    private _largeCover?;
    /** The date and time when the eBook was last modified.  */
    private _lastModifiedDateTime?;
    /** The privacy statement Url.  */
    private _privacyInformationUrl?;
    /** The date and time when the eBook was published.  */
    private _publishedDateTime?;
    /** Publisher.  */
    private _publisher?;
    /** The list of installation states for this eBook.  */
    private _userStateSummary?;
    /**
     * Gets the assignments property value. The list of assignments for this eBook.
     * @returns a managedEBookAssignment
     */
    get assignments(): ManagedEBookAssignment[] | undefined;
    /**
     * Sets the assignments property value. The list of assignments for this eBook.
     * @param value Value to set for the assignments property.
     */
    set assignments(value: ManagedEBookAssignment[] | undefined);
    /**
     * Instantiates a new managedEBook and sets the default values.
     */
    constructor();
    /**
     * Gets the createdDateTime property value. The date and time when the eBook file was created.
     * @returns a Date
     */
    get createdDateTime(): Date | undefined;
    /**
     * Sets the createdDateTime property value. The date and time when the eBook file was created.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value: Date | undefined);
    /**
     * Gets the description property value. Description.
     * @returns a string
     */
    get description(): string | undefined;
    /**
     * Sets the description property value. Description.
     * @param value Value to set for the description property.
     */
    set description(value: string | undefined);
    /**
     * Gets the deviceStates property value. The list of installation states for this eBook.
     * @returns a deviceInstallState
     */
    get deviceStates(): DeviceInstallState[] | undefined;
    /**
     * Sets the deviceStates property value. The list of installation states for this eBook.
     * @param value Value to set for the deviceStates property.
     */
    set deviceStates(value: DeviceInstallState[] | undefined);
    /**
     * Gets the displayName property value. Name of the eBook.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. Name of the eBook.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the informationUrl property value. The more information Url.
     * @returns a string
     */
    get informationUrl(): string | undefined;
    /**
     * Sets the informationUrl property value. The more information Url.
     * @param value Value to set for the informationUrl property.
     */
    set informationUrl(value: string | undefined);
    /**
     * Gets the installSummary property value. Mobile App Install Summary.
     * @returns a eBookInstallSummary
     */
    get installSummary(): EBookInstallSummary | undefined;
    /**
     * Sets the installSummary property value. Mobile App Install Summary.
     * @param value Value to set for the installSummary property.
     */
    set installSummary(value: EBookInstallSummary | undefined);
    /**
     * Gets the largeCover property value. Book cover.
     * @returns a mimeContent
     */
    get largeCover(): MimeContent | undefined;
    /**
     * Sets the largeCover property value. Book cover.
     * @param value Value to set for the largeCover property.
     */
    set largeCover(value: MimeContent | undefined);
    /**
     * Gets the lastModifiedDateTime property value. The date and time when the eBook was last modified.
     * @returns a Date
     */
    get lastModifiedDateTime(): Date | undefined;
    /**
     * Sets the lastModifiedDateTime property value. The date and time when the eBook was last modified.
     * @param value Value to set for the lastModifiedDateTime property.
     */
    set lastModifiedDateTime(value: Date | undefined);
    /**
     * Gets the privacyInformationUrl property value. The privacy statement Url.
     * @returns a string
     */
    get privacyInformationUrl(): string | undefined;
    /**
     * Sets the privacyInformationUrl property value. The privacy statement Url.
     * @param value Value to set for the privacyInformationUrl property.
     */
    set privacyInformationUrl(value: string | undefined);
    /**
     * Gets the publishedDateTime property value. The date and time when the eBook was published.
     * @returns a Date
     */
    get publishedDateTime(): Date | undefined;
    /**
     * Sets the publishedDateTime property value. The date and time when the eBook was published.
     * @param value Value to set for the publishedDateTime property.
     */
    set publishedDateTime(value: Date | undefined);
    /**
     * Gets the publisher property value. Publisher.
     * @returns a string
     */
    get publisher(): string | undefined;
    /**
     * Sets the publisher property value. Publisher.
     * @param value Value to set for the publisher property.
     */
    set publisher(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the userStateSummary property value. The list of installation states for this eBook.
     * @returns a userInstallStateSummary
     */
    get userStateSummary(): UserInstallStateSummary[] | undefined;
    /**
     * Sets the userStateSummary property value. The list of installation states for this eBook.
     * @param value Value to set for the userStateSummary property.
     */
    set userStateSummary(value: UserInstallStateSummary[] | undefined);
}
