"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ManagedEBook = void 0;
const createDeviceInstallStateFromDiscriminatorValue_1 = require("./createDeviceInstallStateFromDiscriminatorValue");
const createEBookInstallSummaryFromDiscriminatorValue_1 = require("./createEBookInstallSummaryFromDiscriminatorValue");
const createManagedEBookAssignmentFromDiscriminatorValue_1 = require("./createManagedEBookAssignmentFromDiscriminatorValue");
const createMimeContentFromDiscriminatorValue_1 = require("./createMimeContentFromDiscriminatorValue");
const createUserInstallStateSummaryFromDiscriminatorValue_1 = require("./createUserInstallStateSummaryFromDiscriminatorValue");
const index_1 = require("./index");
class ManagedEBook extends index_1.Entity {
    /**
     * Instantiates a new managedEBook and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the assignments property value. The list of assignments for this eBook.
     * @returns a managedEBookAssignment
     */
    get assignments() {
        return this._assignments;
    }
    ;
    /**
     * Sets the assignments property value. The list of assignments for this eBook.
     * @param value Value to set for the assignments property.
     */
    set assignments(value) {
        this._assignments = value;
    }
    ;
    ;
    /**
     * Gets the createdDateTime property value. The date and time when the eBook file was created.
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. The date and time when the eBook file was created.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * Gets the description property value. Description.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. Description.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the deviceStates property value. The list of installation states for this eBook.
     * @returns a deviceInstallState
     */
    get deviceStates() {
        return this._deviceStates;
    }
    ;
    /**
     * Sets the deviceStates property value. The list of installation states for this eBook.
     * @param value Value to set for the deviceStates property.
     */
    set deviceStates(value) {
        this._deviceStates = value;
    }
    ;
    /**
     * Gets the displayName property value. Name of the eBook.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. Name of the eBook.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "assignments": (o, n) => { o.assignments = n.getCollectionOfObjectValues(createManagedEBookAssignmentFromDiscriminatorValue_1.createManagedEBookAssignmentFromDiscriminatorValue); }, "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); }, "description": (o, n) => { o.description = n.getStringValue(); }, "deviceStates": (o, n) => { o.deviceStates = n.getCollectionOfObjectValues(createDeviceInstallStateFromDiscriminatorValue_1.createDeviceInstallStateFromDiscriminatorValue); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "informationUrl": (o, n) => { o.informationUrl = n.getStringValue(); }, "installSummary": (o, n) => { o.installSummary = n.getObjectValue(createEBookInstallSummaryFromDiscriminatorValue_1.createEBookInstallSummaryFromDiscriminatorValue); }, "largeCover": (o, n) => { o.largeCover = n.getObjectValue(createMimeContentFromDiscriminatorValue_1.createMimeContentFromDiscriminatorValue); }, "lastModifiedDateTime": (o, n) => { o.lastModifiedDateTime = n.getDateValue(); }, "privacyInformationUrl": (o, n) => { o.privacyInformationUrl = n.getStringValue(); }, "publishedDateTime": (o, n) => { o.publishedDateTime = n.getDateValue(); }, "publisher": (o, n) => { o.publisher = n.getStringValue(); }, "userStateSummary": (o, n) => { o.userStateSummary = n.getCollectionOfObjectValues(createUserInstallStateSummaryFromDiscriminatorValue_1.createUserInstallStateSummaryFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the informationUrl property value. The more information Url.
     * @returns a string
     */
    get informationUrl() {
        return this._informationUrl;
    }
    ;
    /**
     * Sets the informationUrl property value. The more information Url.
     * @param value Value to set for the informationUrl property.
     */
    set informationUrl(value) {
        this._informationUrl = value;
    }
    ;
    /**
     * Gets the installSummary property value. Mobile App Install Summary.
     * @returns a eBookInstallSummary
     */
    get installSummary() {
        return this._installSummary;
    }
    ;
    /**
     * Sets the installSummary property value. Mobile App Install Summary.
     * @param value Value to set for the installSummary property.
     */
    set installSummary(value) {
        this._installSummary = value;
    }
    ;
    /**
     * Gets the largeCover property value. Book cover.
     * @returns a mimeContent
     */
    get largeCover() {
        return this._largeCover;
    }
    ;
    /**
     * Sets the largeCover property value. Book cover.
     * @param value Value to set for the largeCover property.
     */
    set largeCover(value) {
        this._largeCover = value;
    }
    ;
    /**
     * Gets the lastModifiedDateTime property value. The date and time when the eBook was last modified.
     * @returns a Date
     */
    get lastModifiedDateTime() {
        return this._lastModifiedDateTime;
    }
    ;
    /**
     * Sets the lastModifiedDateTime property value. The date and time when the eBook was last modified.
     * @param value Value to set for the lastModifiedDateTime property.
     */
    set lastModifiedDateTime(value) {
        this._lastModifiedDateTime = value;
    }
    ;
    /**
     * Gets the privacyInformationUrl property value. The privacy statement Url.
     * @returns a string
     */
    get privacyInformationUrl() {
        return this._privacyInformationUrl;
    }
    ;
    /**
     * Sets the privacyInformationUrl property value. The privacy statement Url.
     * @param value Value to set for the privacyInformationUrl property.
     */
    set privacyInformationUrl(value) {
        this._privacyInformationUrl = value;
    }
    ;
    /**
     * Gets the publishedDateTime property value. The date and time when the eBook was published.
     * @returns a Date
     */
    get publishedDateTime() {
        return this._publishedDateTime;
    }
    ;
    /**
     * Sets the publishedDateTime property value. The date and time when the eBook was published.
     * @param value Value to set for the publishedDateTime property.
     */
    set publishedDateTime(value) {
        this._publishedDateTime = value;
    }
    ;
    /**
     * Gets the publisher property value. Publisher.
     * @returns a string
     */
    get publisher() {
        return this._publisher;
    }
    ;
    /**
     * Sets the publisher property value. Publisher.
     * @param value Value to set for the publisher property.
     */
    set publisher(value) {
        this._publisher = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("assignments", this.assignments);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeStringValue("description", this.description);
        writer.writeCollectionOfObjectValues("deviceStates", this.deviceStates);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeStringValue("informationUrl", this.informationUrl);
        writer.writeObjectValue("installSummary", this.installSummary);
        writer.writeObjectValue("largeCover", this.largeCover);
        writer.writeDateValue("lastModifiedDateTime", this.lastModifiedDateTime);
        writer.writeStringValue("privacyInformationUrl", this.privacyInformationUrl);
        writer.writeDateValue("publishedDateTime", this.publishedDateTime);
        writer.writeStringValue("publisher", this.publisher);
        writer.writeCollectionOfObjectValues("userStateSummary", this.userStateSummary);
    }
    ;
    /**
     * Gets the userStateSummary property value. The list of installation states for this eBook.
     * @returns a userInstallStateSummary
     */
    get userStateSummary() {
        return this._userStateSummary;
    }
    ;
    /**
     * Sets the userStateSummary property value. The list of installation states for this eBook.
     * @param value Value to set for the userStateSummary property.
     */
    set userStateSummary(value) {
        this._userStateSummary = value;
    }
    ;
}
exports.ManagedEBook = ManagedEBook;
