import { DeviceAndAppManagementAssignmentTarget, Entity } from './index';
import { InstallIntent } from './installIntent';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ManagedEBookAssignment extends Entity implements Parsable {
    /** The install intent for eBook. Possible values are: available, required, uninstall, availableWithoutEnrollment.  */
    private _installIntent?;
    /** The assignment target for eBook.  */
    private _target?;
    /**
     * Instantiates a new managedEBookAssignment and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the installIntent property value. The install intent for eBook. Possible values are: available, required, uninstall, availableWithoutEnrollment.
     * @returns a installIntent
     */
    get installIntent(): InstallIntent | undefined;
    /**
     * Sets the installIntent property value. The install intent for eBook. Possible values are: available, required, uninstall, availableWithoutEnrollment.
     * @param value Value to set for the installIntent property.
     */
    set installIntent(value: InstallIntent | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the target property value. The assignment target for eBook.
     * @returns a deviceAndAppManagementAssignmentTarget
     */
    get target(): DeviceAndAppManagementAssignmentTarget | undefined;
    /**
     * Sets the target property value. The assignment target for eBook.
     * @param value Value to set for the target property.
     */
    set target(value: DeviceAndAppManagementAssignmentTarget | undefined);
}
