"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ManagedMobileApp = void 0;
const createMobileAppIdentifierFromDiscriminatorValue_1 = require("./createMobileAppIdentifierFromDiscriminatorValue");
const index_1 = require("./index");
class ManagedMobileApp extends index_1.Entity {
    /**
     * Instantiates a new managedMobileApp and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "mobileAppIdentifier": (o, n) => { o.mobileAppIdentifier = n.getObjectValue(createMobileAppIdentifierFromDiscriminatorValue_1.createMobileAppIdentifierFromDiscriminatorValue); }, "version": (o, n) => { o.version = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the mobileAppIdentifier property value. The identifier for an app with it's operating system type.
     * @returns a mobileAppIdentifier
     */
    get mobileAppIdentifier() {
        return this._mobileAppIdentifier;
    }
    ;
    /**
     * Sets the mobileAppIdentifier property value. The identifier for an app with it's operating system type.
     * @param value Value to set for the mobileAppIdentifier property.
     */
    set mobileAppIdentifier(value) {
        this._mobileAppIdentifier = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("mobileAppIdentifier", this.mobileAppIdentifier);
        writer.writeStringValue("version", this.version);
    }
    ;
    /**
     * Gets the version property value. Version of the entity.
     * @returns a string
     */
    get version() {
        return this._version;
    }
    ;
    /**
     * Sets the version property value. Version of the entity.
     * @param value Value to set for the version property.
     */
    set version(value) {
        this._version = value;
    }
    ;
}
exports.ManagedMobileApp = ManagedMobileApp;
