import { MediaDirection } from './mediaDirection';
import { Modality } from './modality';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class MediaStream implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** The direction. The possible values are inactive, sendOnly, receiveOnly, sendReceive.  */
    private _direction?;
    /** The media stream label.  */
    private _label?;
    /** The media type. The possible value are unknown, audio, video, videoBasedScreenSharing, data.  */
    private _mediaType?;
    /** If the media is muted by the server.  */
    private _serverMuted?;
    /** The source ID.  */
    private _sourceId?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new mediaStream and sets the default values.
     */
    constructor();
    /**
     * Gets the direction property value. The direction. The possible values are inactive, sendOnly, receiveOnly, sendReceive.
     * @returns a mediaDirection
     */
    get direction(): MediaDirection | undefined;
    /**
     * Sets the direction property value. The direction. The possible values are inactive, sendOnly, receiveOnly, sendReceive.
     * @param value Value to set for the direction property.
     */
    set direction(value: MediaDirection | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the label property value. The media stream label.
     * @returns a string
     */
    get label(): string | undefined;
    /**
     * Sets the label property value. The media stream label.
     * @param value Value to set for the label property.
     */
    set label(value: string | undefined);
    /**
     * Gets the mediaType property value. The media type. The possible value are unknown, audio, video, videoBasedScreenSharing, data.
     * @returns a modality
     */
    get mediaType(): Modality | undefined;
    /**
     * Sets the mediaType property value. The media type. The possible value are unknown, audio, video, videoBasedScreenSharing, data.
     * @param value Value to set for the mediaType property.
     */
    set mediaType(value: Modality | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the serverMuted property value. If the media is muted by the server.
     * @returns a boolean
     */
    get serverMuted(): boolean | undefined;
    /**
     * Sets the serverMuted property value. If the media is muted by the server.
     * @param value Value to set for the serverMuted property.
     */
    set serverMuted(value: boolean | undefined);
    /**
     * Gets the sourceId property value. The source ID.
     * @returns a string
     */
    get sourceId(): string | undefined;
    /**
     * Sets the sourceId property value. The source ID.
     * @param value Value to set for the sourceId property.
     */
    set sourceId(value: string | undefined);
}
