"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MediaStream = void 0;
const mediaDirection_1 = require("./mediaDirection");
const modality_1 = require("./modality");
class MediaStream {
    /**
     * Instantiates a new mediaStream and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the direction property value. The direction. The possible values are inactive, sendOnly, receiveOnly, sendReceive.
     * @returns a mediaDirection
     */
    get direction() {
        return this._direction;
    }
    ;
    /**
     * Sets the direction property value. The direction. The possible values are inactive, sendOnly, receiveOnly, sendReceive.
     * @param value Value to set for the direction property.
     */
    set direction(value) {
        this._direction = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "direction": (o, n) => { o.direction = n.getEnumValue(mediaDirection_1.MediaDirection); },
            "label": (o, n) => { o.label = n.getStringValue(); },
            "mediaType": (o, n) => { o.mediaType = n.getEnumValue(modality_1.Modality); },
            "serverMuted": (o, n) => { o.serverMuted = n.getBooleanValue(); },
            "sourceId": (o, n) => { o.sourceId = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the label property value. The media stream label.
     * @returns a string
     */
    get label() {
        return this._label;
    }
    ;
    /**
     * Sets the label property value. The media stream label.
     * @param value Value to set for the label property.
     */
    set label(value) {
        this._label = value;
    }
    ;
    /**
     * Gets the mediaType property value. The media type. The possible value are unknown, audio, video, videoBasedScreenSharing, data.
     * @returns a modality
     */
    get mediaType() {
        return this._mediaType;
    }
    ;
    /**
     * Sets the mediaType property value. The media type. The possible value are unknown, audio, video, videoBasedScreenSharing, data.
     * @param value Value to set for the mediaType property.
     */
    set mediaType(value) {
        this._mediaType = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeEnumValue("direction", this.direction);
        writer.writeStringValue("label", this.label);
        writer.writeEnumValue("mediaType", this.mediaType);
        writer.writeBooleanValue("serverMuted", this.serverMuted);
        writer.writeStringValue("sourceId", this.sourceId);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the serverMuted property value. If the media is muted by the server.
     * @returns a boolean
     */
    get serverMuted() {
        return this._serverMuted;
    }
    ;
    /**
     * Sets the serverMuted property value. If the media is muted by the server.
     * @param value Value to set for the serverMuted property.
     */
    set serverMuted(value) {
        this._serverMuted = value;
    }
    ;
    /**
     * Gets the sourceId property value. The source ID.
     * @returns a string
     */
    get sourceId() {
        return this._sourceId;
    }
    ;
    /**
     * Sets the sourceId property value. The source ID.
     * @param value Value to set for the sourceId property.
     */
    set sourceId(value) {
        this._sourceId = value;
    }
    ;
}
exports.MediaStream = MediaStream;
