"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MeetingParticipantInfo = void 0;
const createIdentitySetFromDiscriminatorValue_1 = require("./createIdentitySetFromDiscriminatorValue");
const onlineMeetingRole_1 = require("./onlineMeetingRole");
class MeetingParticipantInfo {
    /**
     * Instantiates a new meetingParticipantInfo and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "identity": (o, n) => { o.identity = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); },
            "role": (o, n) => { o.role = n.getEnumValue(onlineMeetingRole_1.OnlineMeetingRole); },
            "upn": (o, n) => { o.upn = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the identity property value. Identity information of the participant.
     * @returns a identitySet
     */
    get identity() {
        return this._identity;
    }
    ;
    /**
     * Sets the identity property value. Identity information of the participant.
     * @param value Value to set for the identity property.
     */
    set identity(value) {
        this._identity = value;
    }
    ;
    /**
     * Gets the role property value. Specifies the participant's role in the meeting.  Possible values are attendee, presenter, producer, and unknownFutureValue.
     * @returns a onlineMeetingRole
     */
    get role() {
        return this._role;
    }
    ;
    /**
     * Sets the role property value. Specifies the participant's role in the meeting.  Possible values are attendee, presenter, producer, and unknownFutureValue.
     * @param value Value to set for the role property.
     */
    set role(value) {
        this._role = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("identity", this.identity);
        writer.writeEnumValue("role", this.role);
        writer.writeStringValue("upn", this.upn);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the upn property value. User principal name of the participant.
     * @returns a string
     */
    get upn() {
        return this._upn;
    }
    ;
    /**
     * Sets the upn property value. User principal name of the participant.
     * @param value Value to set for the upn property.
     */
    set upn(value) {
        this._upn = value;
    }
    ;
}
exports.MeetingParticipantInfo = MeetingParticipantInfo;
