import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class MessageSecurityState implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _connectingIP?;
    private _deliveryAction?;
    private _deliveryLocation?;
    private _directionality?;
    private _internetMessageId?;
    private _messageFingerprint?;
    private _messageReceivedDateTime?;
    private _messageSubject?;
    private _networkMessageId?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the connectingIP property value.
     * @returns a string
     */
    get connectingIP(): string | undefined;
    /**
     * Sets the connectingIP property value.
     * @param value Value to set for the connectingIP property.
     */
    set connectingIP(value: string | undefined);
    /**
     * Instantiates a new messageSecurityState and sets the default values.
     */
    constructor();
    /**
     * Gets the deliveryAction property value.
     * @returns a string
     */
    get deliveryAction(): string | undefined;
    /**
     * Sets the deliveryAction property value.
     * @param value Value to set for the deliveryAction property.
     */
    set deliveryAction(value: string | undefined);
    /**
     * Gets the deliveryLocation property value.
     * @returns a string
     */
    get deliveryLocation(): string | undefined;
    /**
     * Sets the deliveryLocation property value.
     * @param value Value to set for the deliveryLocation property.
     */
    set deliveryLocation(value: string | undefined);
    /**
     * Gets the directionality property value.
     * @returns a string
     */
    get directionality(): string | undefined;
    /**
     * Sets the directionality property value.
     * @param value Value to set for the directionality property.
     */
    set directionality(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the internetMessageId property value.
     * @returns a string
     */
    get internetMessageId(): string | undefined;
    /**
     * Sets the internetMessageId property value.
     * @param value Value to set for the internetMessageId property.
     */
    set internetMessageId(value: string | undefined);
    /**
     * Gets the messageFingerprint property value.
     * @returns a string
     */
    get messageFingerprint(): string | undefined;
    /**
     * Sets the messageFingerprint property value.
     * @param value Value to set for the messageFingerprint property.
     */
    set messageFingerprint(value: string | undefined);
    /**
     * Gets the messageReceivedDateTime property value.
     * @returns a Date
     */
    get messageReceivedDateTime(): Date | undefined;
    /**
     * Sets the messageReceivedDateTime property value.
     * @param value Value to set for the messageReceivedDateTime property.
     */
    set messageReceivedDateTime(value: Date | undefined);
    /**
     * Gets the messageSubject property value.
     * @returns a string
     */
    get messageSubject(): string | undefined;
    /**
     * Sets the messageSubject property value.
     * @param value Value to set for the messageSubject property.
     */
    set messageSubject(value: string | undefined);
    /**
     * Gets the networkMessageId property value.
     * @returns a string
     */
    get networkMessageId(): string | undefined;
    /**
     * Sets the networkMessageId property value.
     * @param value Value to set for the networkMessageId property.
     */
    set networkMessageId(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
