"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageSecurityState = void 0;
class MessageSecurityState {
    /**
     * Instantiates a new messageSecurityState and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the connectingIP property value.
     * @returns a string
     */
    get connectingIP() {
        return this._connectingIP;
    }
    ;
    /**
     * Sets the connectingIP property value.
     * @param value Value to set for the connectingIP property.
     */
    set connectingIP(value) {
        this._connectingIP = value;
    }
    ;
    ;
    /**
     * Gets the deliveryAction property value.
     * @returns a string
     */
    get deliveryAction() {
        return this._deliveryAction;
    }
    ;
    /**
     * Sets the deliveryAction property value.
     * @param value Value to set for the deliveryAction property.
     */
    set deliveryAction(value) {
        this._deliveryAction = value;
    }
    ;
    /**
     * Gets the deliveryLocation property value.
     * @returns a string
     */
    get deliveryLocation() {
        return this._deliveryLocation;
    }
    ;
    /**
     * Sets the deliveryLocation property value.
     * @param value Value to set for the deliveryLocation property.
     */
    set deliveryLocation(value) {
        this._deliveryLocation = value;
    }
    ;
    /**
     * Gets the directionality property value.
     * @returns a string
     */
    get directionality() {
        return this._directionality;
    }
    ;
    /**
     * Sets the directionality property value.
     * @param value Value to set for the directionality property.
     */
    set directionality(value) {
        this._directionality = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "connectingIP": (o, n) => { o.connectingIP = n.getStringValue(); },
            "deliveryAction": (o, n) => { o.deliveryAction = n.getStringValue(); },
            "deliveryLocation": (o, n) => { o.deliveryLocation = n.getStringValue(); },
            "directionality": (o, n) => { o.directionality = n.getStringValue(); },
            "internetMessageId": (o, n) => { o.internetMessageId = n.getStringValue(); },
            "messageFingerprint": (o, n) => { o.messageFingerprint = n.getStringValue(); },
            "messageReceivedDateTime": (o, n) => { o.messageReceivedDateTime = n.getDateValue(); },
            "messageSubject": (o, n) => { o.messageSubject = n.getStringValue(); },
            "networkMessageId": (o, n) => { o.networkMessageId = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the internetMessageId property value.
     * @returns a string
     */
    get internetMessageId() {
        return this._internetMessageId;
    }
    ;
    /**
     * Sets the internetMessageId property value.
     * @param value Value to set for the internetMessageId property.
     */
    set internetMessageId(value) {
        this._internetMessageId = value;
    }
    ;
    /**
     * Gets the messageFingerprint property value.
     * @returns a string
     */
    get messageFingerprint() {
        return this._messageFingerprint;
    }
    ;
    /**
     * Sets the messageFingerprint property value.
     * @param value Value to set for the messageFingerprint property.
     */
    set messageFingerprint(value) {
        this._messageFingerprint = value;
    }
    ;
    /**
     * Gets the messageReceivedDateTime property value.
     * @returns a Date
     */
    get messageReceivedDateTime() {
        return this._messageReceivedDateTime;
    }
    ;
    /**
     * Sets the messageReceivedDateTime property value.
     * @param value Value to set for the messageReceivedDateTime property.
     */
    set messageReceivedDateTime(value) {
        this._messageReceivedDateTime = value;
    }
    ;
    /**
     * Gets the messageSubject property value.
     * @returns a string
     */
    get messageSubject() {
        return this._messageSubject;
    }
    ;
    /**
     * Sets the messageSubject property value.
     * @param value Value to set for the messageSubject property.
     */
    set messageSubject(value) {
        this._messageSubject = value;
    }
    ;
    /**
     * Gets the networkMessageId property value.
     * @returns a string
     */
    get networkMessageId() {
        return this._networkMessageId;
    }
    ;
    /**
     * Sets the networkMessageId property value.
     * @param value Value to set for the networkMessageId property.
     */
    set networkMessageId(value) {
        this._networkMessageId = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("connectingIP", this.connectingIP);
        writer.writeStringValue("deliveryAction", this.deliveryAction);
        writer.writeStringValue("deliveryLocation", this.deliveryLocation);
        writer.writeStringValue("directionality", this.directionality);
        writer.writeStringValue("internetMessageId", this.internetMessageId);
        writer.writeStringValue("messageFingerprint", this.messageFingerprint);
        writer.writeDateValue("messageReceivedDateTime", this.messageReceivedDateTime);
        writer.writeStringValue("messageSubject", this.messageSubject);
        writer.writeStringValue("networkMessageId", this.networkMessageId);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.MessageSecurityState = MessageSecurityState;
