import { AuthenticationMethod, Device } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class MicrosoftAuthenticatorAuthenticationMethod extends AuthenticationMethod implements Parsable {
    /** The date and time that this app was registered. This property is null if the device is not registered for passwordless Phone Sign-In.  */
    private _createdDateTime?;
    /** The registered device on which Microsoft Authenticator resides. This property is null if the device is not registered for passwordless Phone Sign-In.  */
    private _device?;
    /** Tags containing app metadata.  */
    private _deviceTag?;
    /** The name of the device on which this app is registered.  */
    private _displayName?;
    /** Numerical version of this instance of the Authenticator app.  */
    private _phoneAppVersion?;
    /**
     * Instantiates a new microsoftAuthenticatorAuthenticationMethod and sets the default values.
     */
    constructor();
    /**
     * Gets the createdDateTime property value. The date and time that this app was registered. This property is null if the device is not registered for passwordless Phone Sign-In.
     * @returns a Date
     */
    get createdDateTime(): Date | undefined;
    /**
     * Sets the createdDateTime property value. The date and time that this app was registered. This property is null if the device is not registered for passwordless Phone Sign-In.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value: Date | undefined);
    /**
     * Gets the device property value. The registered device on which Microsoft Authenticator resides. This property is null if the device is not registered for passwordless Phone Sign-In.
     * @returns a device
     */
    get device(): Device | undefined;
    /**
     * Sets the device property value. The registered device on which Microsoft Authenticator resides. This property is null if the device is not registered for passwordless Phone Sign-In.
     * @param value Value to set for the device property.
     */
    set device(value: Device | undefined);
    /**
     * Gets the deviceTag property value. Tags containing app metadata.
     * @returns a string
     */
    get deviceTag(): string | undefined;
    /**
     * Sets the deviceTag property value. Tags containing app metadata.
     * @param value Value to set for the deviceTag property.
     */
    set deviceTag(value: string | undefined);
    /**
     * Gets the displayName property value. The name of the device on which this app is registered.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. The name of the device on which this app is registered.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the phoneAppVersion property value. Numerical version of this instance of the Authenticator app.
     * @returns a string
     */
    get phoneAppVersion(): string | undefined;
    /**
     * Sets the phoneAppVersion property value. Numerical version of this instance of the Authenticator app.
     * @param value Value to set for the phoneAppVersion property.
     */
    set phoneAppVersion(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
