import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Contains properties for a generic mime content.  */
export declare class MimeContent implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Indicates the content mime type.  */
    private _type?;
    /** The byte array that contains the actual content.  */
    private _value?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new mimeContent and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the type property value. Indicates the content mime type.
     * @returns a string
     */
    get type(): string | undefined;
    /**
     * Sets the type property value. Indicates the content mime type.
     * @param value Value to set for the type property.
     */
    set type(value: string | undefined);
    /**
     * Gets the value property value. The byte array that contains the actual content.
     * @returns a binary
     */
    get value(): string | undefined;
    /**
     * Sets the value property value. The byte array that contains the actual content.
     * @param value Value to set for the value property.
     */
    set value(value: string | undefined);
}
