"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MobileApp = void 0;
const createMimeContentFromDiscriminatorValue_1 = require("./createMimeContentFromDiscriminatorValue");
const createMobileAppAssignmentFromDiscriminatorValue_1 = require("./createMobileAppAssignmentFromDiscriminatorValue");
const createMobileAppCategoryFromDiscriminatorValue_1 = require("./createMobileAppCategoryFromDiscriminatorValue");
const index_1 = require("./index");
const mobileAppPublishingState_1 = require("./mobileAppPublishingState");
class MobileApp extends index_1.Entity {
    /**
     * Instantiates a new mobileApp and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the assignments property value. The list of group assignments for this mobile app.
     * @returns a mobileAppAssignment
     */
    get assignments() {
        return this._assignments;
    }
    ;
    /**
     * Sets the assignments property value. The list of group assignments for this mobile app.
     * @param value Value to set for the assignments property.
     */
    set assignments(value) {
        this._assignments = value;
    }
    ;
    /**
     * Gets the categories property value. The list of categories for this app.
     * @returns a mobileAppCategory
     */
    get categories() {
        return this._categories;
    }
    ;
    /**
     * Sets the categories property value. The list of categories for this app.
     * @param value Value to set for the categories property.
     */
    set categories(value) {
        this._categories = value;
    }
    ;
    ;
    /**
     * Gets the createdDateTime property value. The date and time the app was created.
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. The date and time the app was created.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * Gets the description property value. The description of the app.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. The description of the app.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the developer property value. The developer of the app.
     * @returns a string
     */
    get developer() {
        return this._developer;
    }
    ;
    /**
     * Sets the developer property value. The developer of the app.
     * @param value Value to set for the developer property.
     */
    set developer(value) {
        this._developer = value;
    }
    ;
    /**
     * Gets the displayName property value. The admin provided or imported title of the app.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The admin provided or imported title of the app.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "assignments": (o, n) => { o.assignments = n.getCollectionOfObjectValues(createMobileAppAssignmentFromDiscriminatorValue_1.createMobileAppAssignmentFromDiscriminatorValue); }, "categories": (o, n) => { o.categories = n.getCollectionOfObjectValues(createMobileAppCategoryFromDiscriminatorValue_1.createMobileAppCategoryFromDiscriminatorValue); }, "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); }, "description": (o, n) => { o.description = n.getStringValue(); }, "developer": (o, n) => { o.developer = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "informationUrl": (o, n) => { o.informationUrl = n.getStringValue(); }, "isFeatured": (o, n) => { o.isFeatured = n.getBooleanValue(); }, "largeIcon": (o, n) => { o.largeIcon = n.getObjectValue(createMimeContentFromDiscriminatorValue_1.createMimeContentFromDiscriminatorValue); }, "lastModifiedDateTime": (o, n) => { o.lastModifiedDateTime = n.getDateValue(); }, "notes": (o, n) => { o.notes = n.getStringValue(); }, "owner": (o, n) => { o.owner = n.getStringValue(); }, "privacyInformationUrl": (o, n) => { o.privacyInformationUrl = n.getStringValue(); }, "publisher": (o, n) => { o.publisher = n.getStringValue(); }, "publishingState": (o, n) => { o.publishingState = n.getEnumValue(mobileAppPublishingState_1.MobileAppPublishingState); } });
    }
    ;
    /**
     * Gets the informationUrl property value. The more information Url.
     * @returns a string
     */
    get informationUrl() {
        return this._informationUrl;
    }
    ;
    /**
     * Sets the informationUrl property value. The more information Url.
     * @param value Value to set for the informationUrl property.
     */
    set informationUrl(value) {
        this._informationUrl = value;
    }
    ;
    /**
     * Gets the isFeatured property value. The value indicating whether the app is marked as featured by the admin.
     * @returns a boolean
     */
    get isFeatured() {
        return this._isFeatured;
    }
    ;
    /**
     * Sets the isFeatured property value. The value indicating whether the app is marked as featured by the admin.
     * @param value Value to set for the isFeatured property.
     */
    set isFeatured(value) {
        this._isFeatured = value;
    }
    ;
    /**
     * Gets the largeIcon property value. The large icon, to be displayed in the app details and used for upload of the icon.
     * @returns a mimeContent
     */
    get largeIcon() {
        return this._largeIcon;
    }
    ;
    /**
     * Sets the largeIcon property value. The large icon, to be displayed in the app details and used for upload of the icon.
     * @param value Value to set for the largeIcon property.
     */
    set largeIcon(value) {
        this._largeIcon = value;
    }
    ;
    /**
     * Gets the lastModifiedDateTime property value. The date and time the app was last modified.
     * @returns a Date
     */
    get lastModifiedDateTime() {
        return this._lastModifiedDateTime;
    }
    ;
    /**
     * Sets the lastModifiedDateTime property value. The date and time the app was last modified.
     * @param value Value to set for the lastModifiedDateTime property.
     */
    set lastModifiedDateTime(value) {
        this._lastModifiedDateTime = value;
    }
    ;
    /**
     * Gets the notes property value. Notes for the app.
     * @returns a string
     */
    get notes() {
        return this._notes;
    }
    ;
    /**
     * Sets the notes property value. Notes for the app.
     * @param value Value to set for the notes property.
     */
    set notes(value) {
        this._notes = value;
    }
    ;
    /**
     * Gets the owner property value. The owner of the app.
     * @returns a string
     */
    get owner() {
        return this._owner;
    }
    ;
    /**
     * Sets the owner property value. The owner of the app.
     * @param value Value to set for the owner property.
     */
    set owner(value) {
        this._owner = value;
    }
    ;
    /**
     * Gets the privacyInformationUrl property value. The privacy statement Url.
     * @returns a string
     */
    get privacyInformationUrl() {
        return this._privacyInformationUrl;
    }
    ;
    /**
     * Sets the privacyInformationUrl property value. The privacy statement Url.
     * @param value Value to set for the privacyInformationUrl property.
     */
    set privacyInformationUrl(value) {
        this._privacyInformationUrl = value;
    }
    ;
    /**
     * Gets the publisher property value. The publisher of the app.
     * @returns a string
     */
    get publisher() {
        return this._publisher;
    }
    ;
    /**
     * Sets the publisher property value. The publisher of the app.
     * @param value Value to set for the publisher property.
     */
    set publisher(value) {
        this._publisher = value;
    }
    ;
    /**
     * Gets the publishingState property value. The publishing state for the app. The app cannot be assigned unless the app is published. Possible values are: notPublished, processing, published.
     * @returns a mobileAppPublishingState
     */
    get publishingState() {
        return this._publishingState;
    }
    ;
    /**
     * Sets the publishingState property value. The publishing state for the app. The app cannot be assigned unless the app is published. Possible values are: notPublished, processing, published.
     * @param value Value to set for the publishingState property.
     */
    set publishingState(value) {
        this._publishingState = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("assignments", this.assignments);
        writer.writeCollectionOfObjectValues("categories", this.categories);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeStringValue("description", this.description);
        writer.writeStringValue("developer", this.developer);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeStringValue("informationUrl", this.informationUrl);
        writer.writeBooleanValue("isFeatured", this.isFeatured);
        writer.writeObjectValue("largeIcon", this.largeIcon);
        writer.writeDateValue("lastModifiedDateTime", this.lastModifiedDateTime);
        writer.writeStringValue("notes", this.notes);
        writer.writeStringValue("owner", this.owner);
        writer.writeStringValue("privacyInformationUrl", this.privacyInformationUrl);
        writer.writeStringValue("publisher", this.publisher);
        writer.writeEnumValue("publishingState", this.publishingState);
    }
    ;
}
exports.MobileApp = MobileApp;
