import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ModifiedProperty implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Indicates the property name of the target attribute that was changed.  */
    private _displayName?;
    /** Indicates the updated value for the propery.  */
    private _newValue?;
    /** Indicates the previous value (before the update) for the property.  */
    private _oldValue?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new modifiedProperty and sets the default values.
     */
    constructor();
    /**
     * Gets the displayName property value. Indicates the property name of the target attribute that was changed.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. Indicates the property name of the target attribute that was changed.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the newValue property value. Indicates the updated value for the propery.
     * @returns a string
     */
    get newValue(): string | undefined;
    /**
     * Sets the newValue property value. Indicates the updated value for the propery.
     * @param value Value to set for the newValue property.
     */
    set newValue(value: string | undefined);
    /**
     * Gets the oldValue property value. Indicates the previous value (before the update) for the property.
     * @returns a string
     */
    get oldValue(): string | undefined;
    /**
     * Sets the oldValue property value. Indicates the previous value (before the update) for the property.
     * @param value Value to set for the oldValue property.
     */
    set oldValue(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
