"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Notebook = void 0;
const createNotebookLinksFromDiscriminatorValue_1 = require("./createNotebookLinksFromDiscriminatorValue");
const createOnenoteSectionFromDiscriminatorValue_1 = require("./createOnenoteSectionFromDiscriminatorValue");
const createSectionGroupFromDiscriminatorValue_1 = require("./createSectionGroupFromDiscriminatorValue");
const index_1 = require("./index");
const onenoteUserRole_1 = require("./onenoteUserRole");
class Notebook extends index_1.OnenoteEntityHierarchyModel {
    /**
     * Instantiates a new notebook and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "isDefault": (o, n) => { o.isDefault = n.getBooleanValue(); }, "isShared": (o, n) => { o.isShared = n.getBooleanValue(); }, "links": (o, n) => { o.links = n.getObjectValue(createNotebookLinksFromDiscriminatorValue_1.createNotebookLinksFromDiscriminatorValue); }, "sectionGroups": (o, n) => { o.sectionGroups = n.getCollectionOfObjectValues(createSectionGroupFromDiscriminatorValue_1.createSectionGroupFromDiscriminatorValue); }, "sectionGroupsUrl": (o, n) => { o.sectionGroupsUrl = n.getStringValue(); }, "sections": (o, n) => { o.sections = n.getCollectionOfObjectValues(createOnenoteSectionFromDiscriminatorValue_1.createOnenoteSectionFromDiscriminatorValue); }, "sectionsUrl": (o, n) => { o.sectionsUrl = n.getStringValue(); }, "userRole": (o, n) => { o.userRole = n.getEnumValue(onenoteUserRole_1.OnenoteUserRole); } });
    }
    ;
    /**
     * Gets the isDefault property value. Indicates whether this is the user's default notebook. Read-only.
     * @returns a boolean
     */
    get isDefault() {
        return this._isDefault;
    }
    ;
    /**
     * Sets the isDefault property value. Indicates whether this is the user's default notebook. Read-only.
     * @param value Value to set for the isDefault property.
     */
    set isDefault(value) {
        this._isDefault = value;
    }
    ;
    /**
     * Gets the isShared property value. Indicates whether the notebook is shared. If true, the contents of the notebook can be seen by people other than the owner. Read-only.
     * @returns a boolean
     */
    get isShared() {
        return this._isShared;
    }
    ;
    /**
     * Sets the isShared property value. Indicates whether the notebook is shared. If true, the contents of the notebook can be seen by people other than the owner. Read-only.
     * @param value Value to set for the isShared property.
     */
    set isShared(value) {
        this._isShared = value;
    }
    ;
    /**
     * Gets the links property value. Links for opening the notebook. The oneNoteClientURL link opens the notebook in the OneNote native client if it's installed. The oneNoteWebURL link opens the notebook in OneNote on the web.
     * @returns a notebookLinks
     */
    get links() {
        return this._links;
    }
    ;
    /**
     * Sets the links property value. Links for opening the notebook. The oneNoteClientURL link opens the notebook in the OneNote native client if it's installed. The oneNoteWebURL link opens the notebook in OneNote on the web.
     * @param value Value to set for the links property.
     */
    set links(value) {
        this._links = value;
    }
    ;
    /**
     * Gets the sectionGroups property value. The section groups in the notebook. Read-only. Nullable.
     * @returns a sectionGroup
     */
    get sectionGroups() {
        return this._sectionGroups;
    }
    ;
    /**
     * Sets the sectionGroups property value. The section groups in the notebook. Read-only. Nullable.
     * @param value Value to set for the sectionGroups property.
     */
    set sectionGroups(value) {
        this._sectionGroups = value;
    }
    ;
    /**
     * Gets the sectionGroupsUrl property value. The URL for the sectionGroups navigation property, which returns all the section groups in the notebook. Read-only.
     * @returns a string
     */
    get sectionGroupsUrl() {
        return this._sectionGroupsUrl;
    }
    ;
    /**
     * Sets the sectionGroupsUrl property value. The URL for the sectionGroups navigation property, which returns all the section groups in the notebook. Read-only.
     * @param value Value to set for the sectionGroupsUrl property.
     */
    set sectionGroupsUrl(value) {
        this._sectionGroupsUrl = value;
    }
    ;
    /**
     * Gets the sections property value. The sections in the notebook. Read-only. Nullable.
     * @returns a onenoteSection
     */
    get sections() {
        return this._sections;
    }
    ;
    /**
     * Sets the sections property value. The sections in the notebook. Read-only. Nullable.
     * @param value Value to set for the sections property.
     */
    set sections(value) {
        this._sections = value;
    }
    ;
    /**
     * Gets the sectionsUrl property value. The URL for the sections navigation property, which returns all the sections in the notebook. Read-only.
     * @returns a string
     */
    get sectionsUrl() {
        return this._sectionsUrl;
    }
    ;
    /**
     * Sets the sectionsUrl property value. The URL for the sections navigation property, which returns all the sections in the notebook. Read-only.
     * @param value Value to set for the sectionsUrl property.
     */
    set sectionsUrl(value) {
        this._sectionsUrl = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeBooleanValue("isDefault", this.isDefault);
        writer.writeBooleanValue("isShared", this.isShared);
        writer.writeObjectValue("links", this.links);
        writer.writeCollectionOfObjectValues("sectionGroups", this.sectionGroups);
        writer.writeStringValue("sectionGroupsUrl", this.sectionGroupsUrl);
        writer.writeCollectionOfObjectValues("sections", this.sections);
        writer.writeStringValue("sectionsUrl", this.sectionsUrl);
        writer.writeEnumValue("userRole", this.userRole);
    }
    ;
    /**
     * Gets the userRole property value. Possible values are: Owner, Contributor, Reader, None. Owner represents owner-level access to the notebook. Contributor represents read/write access to the notebook. Reader represents read-only access to the notebook. Read-only.
     * @returns a onenoteUserRole
     */
    get userRole() {
        return this._userRole;
    }
    ;
    /**
     * Sets the userRole property value. Possible values are: Owner, Contributor, Reader, None. Owner represents owner-level access to the notebook. Contributor represents read/write access to the notebook. Reader represents read-only access to the notebook. Read-only.
     * @param value Value to set for the userRole property.
     */
    set userRole(value) {
        this._userRole = value;
    }
    ;
}
exports.Notebook = Notebook;
