"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NotificationMessageTemplate = void 0;
const createLocalizedNotificationMessageFromDiscriminatorValue_1 = require("./createLocalizedNotificationMessageFromDiscriminatorValue");
const index_1 = require("./index");
const notificationTemplateBrandingOptions_1 = require("./notificationTemplateBrandingOptions");
class NotificationMessageTemplate extends index_1.Entity {
    /**
     * Instantiates a new notificationMessageTemplate and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the brandingOptions property value. The Message Template Branding Options. Branding is defined in the Intune Admin Console. Possible values are: none, includeCompanyLogo, includeCompanyName, includeContactInformation.
     * @returns a notificationTemplateBrandingOptions
     */
    get brandingOptions() {
        return this._brandingOptions;
    }
    ;
    /**
     * Sets the brandingOptions property value. The Message Template Branding Options. Branding is defined in the Intune Admin Console. Possible values are: none, includeCompanyLogo, includeCompanyName, includeContactInformation.
     * @param value Value to set for the brandingOptions property.
     */
    set brandingOptions(value) {
        this._brandingOptions = value;
    }
    ;
    ;
    /**
     * Gets the defaultLocale property value. The default locale to fallback onto when the requested locale is not available.
     * @returns a string
     */
    get defaultLocale() {
        return this._defaultLocale;
    }
    ;
    /**
     * Sets the defaultLocale property value. The default locale to fallback onto when the requested locale is not available.
     * @param value Value to set for the defaultLocale property.
     */
    set defaultLocale(value) {
        this._defaultLocale = value;
    }
    ;
    /**
     * Gets the displayName property value. Display name for the Notification Message Template.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. Display name for the Notification Message Template.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "brandingOptions": (o, n) => { o.brandingOptions = n.getEnumValue(notificationTemplateBrandingOptions_1.NotificationTemplateBrandingOptions); }, "defaultLocale": (o, n) => { o.defaultLocale = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "lastModifiedDateTime": (o, n) => { o.lastModifiedDateTime = n.getDateValue(); }, "localizedNotificationMessages": (o, n) => { o.localizedNotificationMessages = n.getCollectionOfObjectValues(createLocalizedNotificationMessageFromDiscriminatorValue_1.createLocalizedNotificationMessageFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the lastModifiedDateTime property value. DateTime the object was last modified.
     * @returns a Date
     */
    get lastModifiedDateTime() {
        return this._lastModifiedDateTime;
    }
    ;
    /**
     * Sets the lastModifiedDateTime property value. DateTime the object was last modified.
     * @param value Value to set for the lastModifiedDateTime property.
     */
    set lastModifiedDateTime(value) {
        this._lastModifiedDateTime = value;
    }
    ;
    /**
     * Gets the localizedNotificationMessages property value. The list of localized messages for this Notification Message Template.
     * @returns a localizedNotificationMessage
     */
    get localizedNotificationMessages() {
        return this._localizedNotificationMessages;
    }
    ;
    /**
     * Sets the localizedNotificationMessages property value. The list of localized messages for this Notification Message Template.
     * @param value Value to set for the localizedNotificationMessages property.
     */
    set localizedNotificationMessages(value) {
        this._localizedNotificationMessages = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeEnumValue("brandingOptions", this.brandingOptions);
        writer.writeStringValue("defaultLocale", this.defaultLocale);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeDateValue("lastModifiedDateTime", this.lastModifiedDateTime);
        writer.writeCollectionOfObjectValues("localizedNotificationMessages", this.localizedNotificationMessages);
    }
    ;
}
exports.NotificationMessageTemplate = NotificationMessageTemplate;
