import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class NumberColumn implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** How many decimal places to display. See below for information about the possible values.  */
    private _decimalPlaces?;
    /** How the value should be presented in the UX. Must be one of number or percentage. If unspecified, treated as number.  */
    private _displayAs?;
    /** The maximum permitted value.  */
    private _maximum?;
    /** The minimum permitted value.  */
    private _minimum?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new numberColumn and sets the default values.
     */
    constructor();
    /**
     * Gets the decimalPlaces property value. How many decimal places to display. See below for information about the possible values.
     * @returns a string
     */
    get decimalPlaces(): string | undefined;
    /**
     * Sets the decimalPlaces property value. How many decimal places to display. See below for information about the possible values.
     * @param value Value to set for the decimalPlaces property.
     */
    set decimalPlaces(value: string | undefined);
    /**
     * Gets the displayAs property value. How the value should be presented in the UX. Must be one of number or percentage. If unspecified, treated as number.
     * @returns a string
     */
    get displayAs(): string | undefined;
    /**
     * Sets the displayAs property value. How the value should be presented in the UX. Must be one of number or percentage. If unspecified, treated as number.
     * @param value Value to set for the displayAs property.
     */
    set displayAs(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the maximum property value. The maximum permitted value.
     * @returns a double
     */
    get maximum(): number | undefined;
    /**
     * Sets the maximum property value. The maximum permitted value.
     * @param value Value to set for the maximum property.
     */
    set maximum(value: number | undefined);
    /**
     * Gets the minimum property value. The minimum permitted value.
     * @returns a double
     */
    get minimum(): number | undefined;
    /**
     * Sets the minimum property value. The minimum permitted value.
     * @param value Value to set for the minimum property.
     */
    set minimum(value: number | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
