"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InnerError = void 0;
class InnerError {
    /**
     * Instantiates a new InnerError and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the client-request-id property value. Client request Id as sent by the client application.
     * @returns a string
     */
    get clientRequestId() {
        return this._clientRequestId;
    }
    ;
    /**
     * Sets the client-request-id property value. Client request Id as sent by the client application.
     * @param value Value to set for the clientRequestId property.
     */
    set clientRequestId(value) {
        this._clientRequestId = value;
    }
    ;
    ;
    /**
     * Gets the date property value. Date when the error occured.
     * @returns a Date
     */
    get date() {
        return this._date;
    }
    ;
    /**
     * Sets the date property value. Date when the error occured.
     * @param value Value to set for the Date property.
     */
    set date(value) {
        this._date = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "client-request-id": (o, n) => { o.clientRequestId = n.getStringValue(); },
            "date": (o, n) => { o.date = n.getDateValue(); },
            "request-id": (o, n) => { o.requestId = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the request-id property value. Request Id as tracked internally by the service
     * @returns a string
     */
    get requestId() {
        return this._requestId;
    }
    ;
    /**
     * Sets the request-id property value. Request Id as tracked internally by the service
     * @param value Value to set for the requestId property.
     */
    set requestId(value) {
        this._requestId = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("client-request-id", this.clientRequestId);
        writer.writeDateValue("date", this.date);
        writer.writeStringValue("request-id", this.requestId);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.InnerError = InnerError;
