"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MainError = void 0;
const createErrorDetailsFromDiscriminatorValue_1 = require("./createErrorDetailsFromDiscriminatorValue");
const createInnerErrorFromDiscriminatorValue_1 = require("./createInnerErrorFromDiscriminatorValue");
class MainError {
    /**
     * Instantiates a new MainError and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the code property value.
     * @returns a string
     */
    get code() {
        return this._code;
    }
    ;
    /**
     * Sets the code property value.
     * @param value Value to set for the code property.
     */
    set code(value) {
        this._code = value;
    }
    ;
    ;
    /**
     * Gets the details property value.
     * @returns a ErrorDetails
     */
    get details() {
        return this._details;
    }
    ;
    /**
     * Sets the details property value.
     * @param value Value to set for the details property.
     */
    set details(value) {
        this._details = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "code": (o, n) => { o.code = n.getStringValue(); },
            "details": (o, n) => { o.details = n.getCollectionOfObjectValues(createErrorDetailsFromDiscriminatorValue_1.createErrorDetailsFromDiscriminatorValue); },
            "innererror": (o, n) => { o.innererror = n.getObjectValue(createInnerErrorFromDiscriminatorValue_1.createInnerErrorFromDiscriminatorValue); },
            "message": (o, n) => { o.message = n.getStringValue(); },
            "target": (o, n) => { o.target = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the innererror property value.
     * @returns a InnerError
     */
    get innererror() {
        return this._innererror;
    }
    ;
    /**
     * Sets the innererror property value.
     * @param value Value to set for the innererror property.
     */
    set innererror(value) {
        this._innererror = value;
    }
    ;
    /**
     * Gets the message property value.
     * @returns a string
     */
    get message() {
        return this._message;
    }
    ;
    /**
     * Sets the message property value.
     * @param value Value to set for the message property.
     */
    set message(value) {
        this._message = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("code", this.code);
        writer.writeCollectionOfObjectValues("details", this.details);
        writer.writeObjectValue("innererror", this.innererror);
        writer.writeStringValue("message", this.message);
        writer.writeStringValue("target", this.target);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the target property value.
     * @returns a string
     */
    get target() {
        return this._target;
    }
    ;
    /**
     * Sets the target property value.
     * @param value Value to set for the target property.
     */
    set target(value) {
        this._target = value;
    }
    ;
}
exports.MainError = MainError;
