import { MainError } from './index';
import { AdditionalDataHolder, ApiError, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ODataError extends ApiError implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _error_escaped?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new ODataError and sets the default values.
     */
    constructor();
    /**
     * Gets the error property value.
     * @returns a MainError
     */
    get error_escaped(): MainError | undefined;
    /**
     * Sets the error property value.
     * @param value Value to set for the error_escaped property.
     */
    set error_escaped(value: MainError | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
