"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ODataError = void 0;
const createMainErrorFromDiscriminatorValue_1 = require("./createMainErrorFromDiscriminatorValue");
const kiota_abstractions_1 = require("@microsoft/kiota-abstractions");
class ODataError extends kiota_abstractions_1.ApiError {
    /**
     * Instantiates a new ODataError and sets the default values.
     */
    constructor() {
        super();
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the error property value.
     * @returns a MainError
     */
    get error_escaped() {
        return this._error_escaped;
    }
    ;
    /**
     * Sets the error property value.
     * @param value Value to set for the error_escaped property.
     */
    set error_escaped(value) {
        this._error_escaped = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "error": (o, n) => { o.error_escaped = n.getObjectValue(createMainErrorFromDiscriminatorValue_1.createMainErrorFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("error", this.error_escaped);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ODataError = ODataError;
