import { ScheduleChangeRequest } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class OfferShiftRequest extends ScheduleChangeRequest implements Parsable {
    /** The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z  */
    private _recipientActionDateTime?;
    /** Custom message sent by recipient of the offer shift request.  */
    private _recipientActionMessage?;
    /** User ID of the recipient of the offer shift request.  */
    private _recipientUserId?;
    /** User ID of the sender of the offer shift request.  */
    private _senderShiftId?;
    /**
     * Instantiates a new offerShiftRequest and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the recipientActionDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @returns a Date
     */
    get recipientActionDateTime(): Date | undefined;
    /**
     * Sets the recipientActionDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @param value Value to set for the recipientActionDateTime property.
     */
    set recipientActionDateTime(value: Date | undefined);
    /**
     * Gets the recipientActionMessage property value. Custom message sent by recipient of the offer shift request.
     * @returns a string
     */
    get recipientActionMessage(): string | undefined;
    /**
     * Sets the recipientActionMessage property value. Custom message sent by recipient of the offer shift request.
     * @param value Value to set for the recipientActionMessage property.
     */
    set recipientActionMessage(value: string | undefined);
    /**
     * Gets the recipientUserId property value. User ID of the recipient of the offer shift request.
     * @returns a string
     */
    get recipientUserId(): string | undefined;
    /**
     * Sets the recipientUserId property value. User ID of the recipient of the offer shift request.
     * @param value Value to set for the recipientUserId property.
     */
    set recipientUserId(value: string | undefined);
    /**
     * Gets the senderShiftId property value. User ID of the sender of the offer shift request.
     * @returns a string
     */
    get senderShiftId(): string | undefined;
    /**
     * Sets the senderShiftId property value. User ID of the sender of the offer shift request.
     * @param value Value to set for the senderShiftId property.
     */
    set senderShiftId(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
