"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OfficeGraphInsights = void 0;
const createSharedInsightFromDiscriminatorValue_1 = require("./createSharedInsightFromDiscriminatorValue");
const createTrendingFromDiscriminatorValue_1 = require("./createTrendingFromDiscriminatorValue");
const createUsedInsightFromDiscriminatorValue_1 = require("./createUsedInsightFromDiscriminatorValue");
const index_1 = require("./index");
class OfficeGraphInsights extends index_1.Entity {
    /**
     * Instantiates a new officeGraphInsights and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "shared": (o, n) => { o.shared = n.getCollectionOfObjectValues(createSharedInsightFromDiscriminatorValue_1.createSharedInsightFromDiscriminatorValue); }, "trending": (o, n) => { o.trending = n.getCollectionOfObjectValues(createTrendingFromDiscriminatorValue_1.createTrendingFromDiscriminatorValue); }, "used": (o, n) => { o.used = n.getCollectionOfObjectValues(createUsedInsightFromDiscriminatorValue_1.createUsedInsightFromDiscriminatorValue); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("shared", this.shared);
        writer.writeCollectionOfObjectValues("trending", this.trending);
        writer.writeCollectionOfObjectValues("used", this.used);
    }
    ;
    /**
     * Gets the shared property value. Calculated relationship identifying documents shared with or by the user. This includes URLs, file attachments, and reference attachments to OneDrive for Business and SharePoint files found in Outlook messages and meetings. This also includes URLs and reference attachments to Teams conversations. Ordered by recency of share.
     * @returns a sharedInsight
     */
    get shared() {
        return this._shared;
    }
    ;
    /**
     * Sets the shared property value. Calculated relationship identifying documents shared with or by the user. This includes URLs, file attachments, and reference attachments to OneDrive for Business and SharePoint files found in Outlook messages and meetings. This also includes URLs and reference attachments to Teams conversations. Ordered by recency of share.
     * @param value Value to set for the shared property.
     */
    set shared(value) {
        this._shared = value;
    }
    ;
    /**
     * Gets the trending property value. Calculated relationship identifying documents trending around a user. Trending documents are calculated based on activity of the user's closest network of people and include files stored in OneDrive for Business and SharePoint. Trending insights help the user to discover potentially useful content that the user has access to, but has never viewed before.
     * @returns a trending
     */
    get trending() {
        return this._trending;
    }
    ;
    /**
     * Sets the trending property value. Calculated relationship identifying documents trending around a user. Trending documents are calculated based on activity of the user's closest network of people and include files stored in OneDrive for Business and SharePoint. Trending insights help the user to discover potentially useful content that the user has access to, but has never viewed before.
     * @param value Value to set for the trending property.
     */
    set trending(value) {
        this._trending = value;
    }
    ;
    /**
     * Gets the used property value. Calculated relationship identifying the latest documents viewed or modified by a user, including OneDrive for Business and SharePoint documents, ranked by recency of use.
     * @returns a usedInsight
     */
    get used() {
        return this._used;
    }
    ;
    /**
     * Sets the used property value. Calculated relationship identifying the latest documents viewed or modified by a user, including OneDrive for Business and SharePoint documents, ranked by recency of use.
     * @param value Value to set for the used property.
     */
    set used(value) {
        this._used = value;
    }
    ;
}
exports.OfficeGraphInsights = OfficeGraphInsights;
