import { Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class OnPremisesConditionalAccessSettings extends Entity implements Parsable {
    /** Indicates if on premises conditional access is enabled for this organization  */
    private _enabled?;
    /** User groups that will be exempt by on premises conditional access. All users in these groups will be exempt from the conditional access policy.  */
    private _excludedGroups?;
    /** User groups that will be targeted by on premises conditional access. All users in these groups will be required to have mobile device managed and compliant for mail access.  */
    private _includedGroups?;
    /** Override the default access rule when allowing a device to ensure access is granted.  */
    private _overrideDefaultRule?;
    /**
     * Instantiates a new onPremisesConditionalAccessSettings and sets the default values.
     */
    constructor();
    /**
     * Gets the enabled property value. Indicates if on premises conditional access is enabled for this organization
     * @returns a boolean
     */
    get enabled(): boolean | undefined;
    /**
     * Sets the enabled property value. Indicates if on premises conditional access is enabled for this organization
     * @param value Value to set for the enabled property.
     */
    set enabled(value: boolean | undefined);
    /**
     * Gets the excludedGroups property value. User groups that will be exempt by on premises conditional access. All users in these groups will be exempt from the conditional access policy.
     * @returns a string
     */
    get excludedGroups(): string[] | undefined;
    /**
     * Sets the excludedGroups property value. User groups that will be exempt by on premises conditional access. All users in these groups will be exempt from the conditional access policy.
     * @param value Value to set for the excludedGroups property.
     */
    set excludedGroups(value: string[] | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the includedGroups property value. User groups that will be targeted by on premises conditional access. All users in these groups will be required to have mobile device managed and compliant for mail access.
     * @returns a string
     */
    get includedGroups(): string[] | undefined;
    /**
     * Sets the includedGroups property value. User groups that will be targeted by on premises conditional access. All users in these groups will be required to have mobile device managed and compliant for mail access.
     * @param value Value to set for the includedGroups property.
     */
    set includedGroups(value: string[] | undefined);
    /**
     * Gets the overrideDefaultRule property value. Override the default access rule when allowing a device to ensure access is granted.
     * @returns a boolean
     */
    get overrideDefaultRule(): boolean | undefined;
    /**
     * Sets the overrideDefaultRule property value. Override the default access rule when allowing a device to ensure access is granted.
     * @param value Value to set for the overrideDefaultRule property.
     */
    set overrideDefaultRule(value: boolean | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
