"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OnPremisesProvisioningError = void 0;
class OnPremisesProvisioningError {
    /**
     * Instantiates a new onPremisesProvisioningError and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the category property value. Category of the provisioning error. Note: Currently, there is only one possible value. Possible value: PropertyConflict - indicates a property value is not unique. Other objects contain the same value for the property.
     * @returns a string
     */
    get category() {
        return this._category;
    }
    ;
    /**
     * Sets the category property value. Category of the provisioning error. Note: Currently, there is only one possible value. Possible value: PropertyConflict - indicates a property value is not unique. Other objects contain the same value for the property.
     * @param value Value to set for the category property.
     */
    set category(value) {
        this._category = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "category": (o, n) => { o.category = n.getStringValue(); },
            "occurredDateTime": (o, n) => { o.occurredDateTime = n.getDateValue(); },
            "propertyCausingError": (o, n) => { o.propertyCausingError = n.getStringValue(); },
            "value": (o, n) => { o.value = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the occurredDateTime property value. The date and time at which the error occurred.
     * @returns a Date
     */
    get occurredDateTime() {
        return this._occurredDateTime;
    }
    ;
    /**
     * Sets the occurredDateTime property value. The date and time at which the error occurred.
     * @param value Value to set for the occurredDateTime property.
     */
    set occurredDateTime(value) {
        this._occurredDateTime = value;
    }
    ;
    /**
     * Gets the propertyCausingError property value. Name of the directory property causing the error. Current possible values: UserPrincipalName or ProxyAddress
     * @returns a string
     */
    get propertyCausingError() {
        return this._propertyCausingError;
    }
    ;
    /**
     * Sets the propertyCausingError property value. Name of the directory property causing the error. Current possible values: UserPrincipalName or ProxyAddress
     * @param value Value to set for the propertyCausingError property.
     */
    set propertyCausingError(value) {
        this._propertyCausingError = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("category", this.category);
        writer.writeDateValue("occurredDateTime", this.occurredDateTime);
        writer.writeStringValue("propertyCausingError", this.propertyCausingError);
        writer.writeStringValue("value", this.value);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the value property value. Value of the property causing the error.
     * @returns a string
     */
    get value() {
        return this._value;
    }
    ;
    /**
     * Sets the value property value. Value of the property causing the error.
     * @param value Value to set for the value property.
     */
    set value(value) {
        this._value = value;
    }
    ;
}
exports.OnPremisesProvisioningError = OnPremisesProvisioningError;
