"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Onenote = void 0;
const createNotebookFromDiscriminatorValue_1 = require("./createNotebookFromDiscriminatorValue");
const createOnenoteOperationFromDiscriminatorValue_1 = require("./createOnenoteOperationFromDiscriminatorValue");
const createOnenotePageFromDiscriminatorValue_1 = require("./createOnenotePageFromDiscriminatorValue");
const createOnenoteResourceFromDiscriminatorValue_1 = require("./createOnenoteResourceFromDiscriminatorValue");
const createOnenoteSectionFromDiscriminatorValue_1 = require("./createOnenoteSectionFromDiscriminatorValue");
const createSectionGroupFromDiscriminatorValue_1 = require("./createSectionGroupFromDiscriminatorValue");
const index_1 = require("./index");
class Onenote extends index_1.Entity {
    /**
     * Instantiates a new onenote and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "notebooks": (o, n) => { o.notebooks = n.getCollectionOfObjectValues(createNotebookFromDiscriminatorValue_1.createNotebookFromDiscriminatorValue); }, "operations": (o, n) => { o.operations = n.getCollectionOfObjectValues(createOnenoteOperationFromDiscriminatorValue_1.createOnenoteOperationFromDiscriminatorValue); }, "pages": (o, n) => { o.pages = n.getCollectionOfObjectValues(createOnenotePageFromDiscriminatorValue_1.createOnenotePageFromDiscriminatorValue); }, "resources": (o, n) => { o.resources = n.getCollectionOfObjectValues(createOnenoteResourceFromDiscriminatorValue_1.createOnenoteResourceFromDiscriminatorValue); }, "sectionGroups": (o, n) => { o.sectionGroups = n.getCollectionOfObjectValues(createSectionGroupFromDiscriminatorValue_1.createSectionGroupFromDiscriminatorValue); }, "sections": (o, n) => { o.sections = n.getCollectionOfObjectValues(createOnenoteSectionFromDiscriminatorValue_1.createOnenoteSectionFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the notebooks property value. The collection of OneNote notebooks that are owned by the user or group. Read-only. Nullable.
     * @returns a notebook
     */
    get notebooks() {
        return this._notebooks;
    }
    ;
    /**
     * Sets the notebooks property value. The collection of OneNote notebooks that are owned by the user or group. Read-only. Nullable.
     * @param value Value to set for the notebooks property.
     */
    set notebooks(value) {
        this._notebooks = value;
    }
    ;
    /**
     * Gets the operations property value. The status of OneNote operations. Getting an operations collection is not supported, but you can get the status of long-running operations if the Operation-Location header is returned in the response. Read-only. Nullable.
     * @returns a onenoteOperation
     */
    get operations() {
        return this._operations;
    }
    ;
    /**
     * Sets the operations property value. The status of OneNote operations. Getting an operations collection is not supported, but you can get the status of long-running operations if the Operation-Location header is returned in the response. Read-only. Nullable.
     * @param value Value to set for the operations property.
     */
    set operations(value) {
        this._operations = value;
    }
    ;
    /**
     * Gets the pages property value. The pages in all OneNote notebooks that are owned by the user or group.  Read-only. Nullable.
     * @returns a onenotePage
     */
    get pages() {
        return this._pages;
    }
    ;
    /**
     * Sets the pages property value. The pages in all OneNote notebooks that are owned by the user or group.  Read-only. Nullable.
     * @param value Value to set for the pages property.
     */
    set pages(value) {
        this._pages = value;
    }
    ;
    /**
     * Gets the resources property value. The image and other file resources in OneNote pages. Getting a resources collection is not supported, but you can get the binary content of a specific resource. Read-only. Nullable.
     * @returns a onenoteResource
     */
    get resources() {
        return this._resources;
    }
    ;
    /**
     * Sets the resources property value. The image and other file resources in OneNote pages. Getting a resources collection is not supported, but you can get the binary content of a specific resource. Read-only. Nullable.
     * @param value Value to set for the resources property.
     */
    set resources(value) {
        this._resources = value;
    }
    ;
    /**
     * Gets the sectionGroups property value. The section groups in all OneNote notebooks that are owned by the user or group.  Read-only. Nullable.
     * @returns a sectionGroup
     */
    get sectionGroups() {
        return this._sectionGroups;
    }
    ;
    /**
     * Sets the sectionGroups property value. The section groups in all OneNote notebooks that are owned by the user or group.  Read-only. Nullable.
     * @param value Value to set for the sectionGroups property.
     */
    set sectionGroups(value) {
        this._sectionGroups = value;
    }
    ;
    /**
     * Gets the sections property value. The sections in all OneNote notebooks that are owned by the user or group.  Read-only. Nullable.
     * @returns a onenoteSection
     */
    get sections() {
        return this._sections;
    }
    ;
    /**
     * Sets the sections property value. The sections in all OneNote notebooks that are owned by the user or group.  Read-only. Nullable.
     * @param value Value to set for the sections property.
     */
    set sections(value) {
        this._sections = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("notebooks", this.notebooks);
        writer.writeCollectionOfObjectValues("operations", this.operations);
        writer.writeCollectionOfObjectValues("pages", this.pages);
        writer.writeCollectionOfObjectValues("resources", this.resources);
        writer.writeCollectionOfObjectValues("sectionGroups", this.sectionGroups);
        writer.writeCollectionOfObjectValues("sections", this.sections);
    }
    ;
}
exports.Onenote = Onenote;
