import { OnenotePagePreviewLinks } from './index';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class OnenotePagePreview implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _links?;
    private _previewText?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new onenotePagePreview and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the links property value.
     * @returns a onenotePagePreviewLinks
     */
    get links(): OnenotePagePreviewLinks | undefined;
    /**
     * Sets the links property value.
     * @param value Value to set for the links property.
     */
    set links(value: OnenotePagePreviewLinks | undefined);
    /**
     * Gets the previewText property value.
     * @returns a string
     */
    get previewText(): string | undefined;
    /**
     * Sets the previewText property value.
     * @param value Value to set for the previewText property.
     */
    set previewText(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
