"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OnenotePatchContentCommand = void 0;
const onenotePatchActionType_1 = require("./onenotePatchActionType");
const onenotePatchInsertPosition_1 = require("./onenotePatchInsertPosition");
class OnenotePatchContentCommand {
    /**
     * Instantiates a new onenotePatchContentCommand and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the action property value. The action to perform on the target element. The possible values are: replace, append, delete, insert, or prepend.
     * @returns a onenotePatchActionType
     */
    get action() {
        return this._action;
    }
    ;
    /**
     * Sets the action property value. The action to perform on the target element. The possible values are: replace, append, delete, insert, or prepend.
     * @param value Value to set for the action property.
     */
    set action(value) {
        this._action = value;
    }
    ;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the content property value. A string of well-formed HTML to add to the page, and any image or file binary data. If the content contains binary data, the request must be sent using the multipart/form-data content type with a 'Commands' part.
     * @returns a string
     */
    get content() {
        return this._content;
    }
    ;
    /**
     * Sets the content property value. A string of well-formed HTML to add to the page, and any image or file binary data. If the content contains binary data, the request must be sent using the multipart/form-data content type with a 'Commands' part.
     * @param value Value to set for the content property.
     */
    set content(value) {
        this._content = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "action": (o, n) => { o.action = n.getEnumValue(onenotePatchActionType_1.OnenotePatchActionType); },
            "content": (o, n) => { o.content = n.getStringValue(); },
            "position": (o, n) => { o.position = n.getEnumValue(onenotePatchInsertPosition_1.OnenotePatchInsertPosition); },
            "target": (o, n) => { o.target = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the position property value. The location to add the supplied content, relative to the target element. The possible values are: after (default) or before.
     * @returns a onenotePatchInsertPosition
     */
    get position() {
        return this._position;
    }
    ;
    /**
     * Sets the position property value. The location to add the supplied content, relative to the target element. The possible values are: after (default) or before.
     * @param value Value to set for the position property.
     */
    set position(value) {
        this._position = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeEnumValue("action", this.action);
        writer.writeStringValue("content", this.content);
        writer.writeEnumValue("position", this.position);
        writer.writeStringValue("target", this.target);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the target property value. The element to update. Must be the #<data-id> or the generated <id> of the element, or the body or title keyword.
     * @returns a string
     */
    get target() {
        return this._target;
    }
    ;
    /**
     * Sets the target property value. The element to update. Must be the #<data-id> or the generated <id> of the element, or the body or title keyword.
     * @param value Value to set for the target property.
     */
    set target(value) {
        this._target = value;
    }
    ;
}
exports.OnenotePatchContentCommand = OnenotePatchContentCommand;
