import { OnenoteEntityBaseModel } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class OnenoteResource extends OnenoteEntityBaseModel implements Parsable {
    /** The content stream  */
    private _content?;
    /** The URL for downloading the content  */
    private _contentUrl?;
    /**
     * Instantiates a new onenoteResource and sets the default values.
     */
    constructor();
    /**
     * Gets the content property value. The content stream
     * @returns a binary
     */
    get content(): string | undefined;
    /**
     * Sets the content property value. The content stream
     * @param value Value to set for the content property.
     */
    set content(value: string | undefined);
    /**
     * Gets the contentUrl property value. The URL for downloading the content
     * @returns a string
     */
    get contentUrl(): string | undefined;
    /**
     * Sets the contentUrl property value. The URL for downloading the content
     * @param value Value to set for the contentUrl property.
     */
    set contentUrl(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
