import { Phone } from './index';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class OnlineMeetingInfo implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** The ID of the conference.  */
    private _conferenceId?;
    /** The external link that launches the online meeting. This is a URL that clients will launch into a browser and will redirect the user to join the meeting.  */
    private _joinUrl?;
    /** All of the phone numbers associated with this conference.  */
    private _phones?;
    /** The pre-formatted quickdial for this call.  */
    private _quickDial?;
    /** The toll free numbers that can be used to join the conference.  */
    private _tollFreeNumbers?;
    /** The toll number that can be used to join the conference.  */
    private _tollNumber?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the conferenceId property value. The ID of the conference.
     * @returns a string
     */
    get conferenceId(): string | undefined;
    /**
     * Sets the conferenceId property value. The ID of the conference.
     * @param value Value to set for the conferenceId property.
     */
    set conferenceId(value: string | undefined);
    /**
     * Instantiates a new onlineMeetingInfo and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the joinUrl property value. The external link that launches the online meeting. This is a URL that clients will launch into a browser and will redirect the user to join the meeting.
     * @returns a string
     */
    get joinUrl(): string | undefined;
    /**
     * Sets the joinUrl property value. The external link that launches the online meeting. This is a URL that clients will launch into a browser and will redirect the user to join the meeting.
     * @param value Value to set for the joinUrl property.
     */
    set joinUrl(value: string | undefined);
    /**
     * Gets the phones property value. All of the phone numbers associated with this conference.
     * @returns a phone
     */
    get phones(): Phone[] | undefined;
    /**
     * Sets the phones property value. All of the phone numbers associated with this conference.
     * @param value Value to set for the phones property.
     */
    set phones(value: Phone[] | undefined);
    /**
     * Gets the quickDial property value. The pre-formatted quickdial for this call.
     * @returns a string
     */
    get quickDial(): string | undefined;
    /**
     * Sets the quickDial property value. The pre-formatted quickdial for this call.
     * @param value Value to set for the quickDial property.
     */
    set quickDial(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the tollFreeNumbers property value. The toll free numbers that can be used to join the conference.
     * @returns a string
     */
    get tollFreeNumbers(): string[] | undefined;
    /**
     * Sets the tollFreeNumbers property value. The toll free numbers that can be used to join the conference.
     * @param value Value to set for the tollFreeNumbers property.
     */
    set tollFreeNumbers(value: string[] | undefined);
    /**
     * Gets the tollNumber property value. The toll number that can be used to join the conference.
     * @returns a string
     */
    get tollNumber(): string | undefined;
    /**
     * Sets the tollNumber property value. The toll number that can be used to join the conference.
     * @param value Value to set for the tollNumber property.
     */
    set tollNumber(value: string | undefined);
}
