"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OnlineMeetingInfo = void 0;
const createPhoneFromDiscriminatorValue_1 = require("./createPhoneFromDiscriminatorValue");
class OnlineMeetingInfo {
    /**
     * Instantiates a new onlineMeetingInfo and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the conferenceId property value. The ID of the conference.
     * @returns a string
     */
    get conferenceId() {
        return this._conferenceId;
    }
    ;
    /**
     * Sets the conferenceId property value. The ID of the conference.
     * @param value Value to set for the conferenceId property.
     */
    set conferenceId(value) {
        this._conferenceId = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "conferenceId": (o, n) => { o.conferenceId = n.getStringValue(); },
            "joinUrl": (o, n) => { o.joinUrl = n.getStringValue(); },
            "phones": (o, n) => { o.phones = n.getCollectionOfObjectValues(createPhoneFromDiscriminatorValue_1.createPhoneFromDiscriminatorValue); },
            "quickDial": (o, n) => { o.quickDial = n.getStringValue(); },
            "tollFreeNumbers": (o, n) => { o.tollFreeNumbers = n.getCollectionOfPrimitiveValues(); },
            "tollNumber": (o, n) => { o.tollNumber = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the joinUrl property value. The external link that launches the online meeting. This is a URL that clients will launch into a browser and will redirect the user to join the meeting.
     * @returns a string
     */
    get joinUrl() {
        return this._joinUrl;
    }
    ;
    /**
     * Sets the joinUrl property value. The external link that launches the online meeting. This is a URL that clients will launch into a browser and will redirect the user to join the meeting.
     * @param value Value to set for the joinUrl property.
     */
    set joinUrl(value) {
        this._joinUrl = value;
    }
    ;
    /**
     * Gets the phones property value. All of the phone numbers associated with this conference.
     * @returns a phone
     */
    get phones() {
        return this._phones;
    }
    ;
    /**
     * Sets the phones property value. All of the phone numbers associated with this conference.
     * @param value Value to set for the phones property.
     */
    set phones(value) {
        this._phones = value;
    }
    ;
    /**
     * Gets the quickDial property value. The pre-formatted quickdial for this call.
     * @returns a string
     */
    get quickDial() {
        return this._quickDial;
    }
    ;
    /**
     * Sets the quickDial property value. The pre-formatted quickdial for this call.
     * @param value Value to set for the quickDial property.
     */
    set quickDial(value) {
        this._quickDial = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("conferenceId", this.conferenceId);
        writer.writeStringValue("joinUrl", this.joinUrl);
        writer.writeCollectionOfObjectValues("phones", this.phones);
        writer.writeStringValue("quickDial", this.quickDial);
        writer.writeCollectionOfPrimitiveValues("tollFreeNumbers", this.tollFreeNumbers);
        writer.writeStringValue("tollNumber", this.tollNumber);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the tollFreeNumbers property value. The toll free numbers that can be used to join the conference.
     * @returns a string
     */
    get tollFreeNumbers() {
        return this._tollFreeNumbers;
    }
    ;
    /**
     * Sets the tollFreeNumbers property value. The toll free numbers that can be used to join the conference.
     * @param value Value to set for the tollFreeNumbers property.
     */
    set tollFreeNumbers(value) {
        this._tollFreeNumbers = value;
    }
    ;
    /**
     * Gets the tollNumber property value. The toll number that can be used to join the conference.
     * @returns a string
     */
    get tollNumber() {
        return this._tollNumber;
    }
    ;
    /**
     * Sets the tollNumber property value. The toll number that can be used to join the conference.
     * @param value Value to set for the tollNumber property.
     */
    set tollNumber(value) {
        this._tollNumber = value;
    }
    ;
}
exports.OnlineMeetingInfo = OnlineMeetingInfo;
