import { ChangeTrackedEntity, OpenShiftItem } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class OpenShift extends ChangeTrackedEntity implements Parsable {
    /** An unpublished open shift.  */
    private _draftOpenShift?;
    /** ID for the scheduling group that the open shift belongs to.  */
    private _schedulingGroupId?;
    /** A published open shift.  */
    private _sharedOpenShift?;
    /**
     * Instantiates a new openShift and sets the default values.
     */
    constructor();
    /**
     * Gets the draftOpenShift property value. An unpublished open shift.
     * @returns a openShiftItem
     */
    get draftOpenShift(): OpenShiftItem | undefined;
    /**
     * Sets the draftOpenShift property value. An unpublished open shift.
     * @param value Value to set for the draftOpenShift property.
     */
    set draftOpenShift(value: OpenShiftItem | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the schedulingGroupId property value. ID for the scheduling group that the open shift belongs to.
     * @returns a string
     */
    get schedulingGroupId(): string | undefined;
    /**
     * Sets the schedulingGroupId property value. ID for the scheduling group that the open shift belongs to.
     * @param value Value to set for the schedulingGroupId property.
     */
    set schedulingGroupId(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the sharedOpenShift property value. A published open shift.
     * @returns a openShiftItem
     */
    get sharedOpenShift(): OpenShiftItem | undefined;
    /**
     * Sets the sharedOpenShift property value. A published open shift.
     * @param value Value to set for the sharedOpenShift property.
     */
    set sharedOpenShift(value: OpenShiftItem | undefined);
}
