"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpenShift = void 0;
const createOpenShiftItemFromDiscriminatorValue_1 = require("./createOpenShiftItemFromDiscriminatorValue");
const index_1 = require("./index");
class OpenShift extends index_1.ChangeTrackedEntity {
    /**
     * Instantiates a new openShift and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the draftOpenShift property value. An unpublished open shift.
     * @returns a openShiftItem
     */
    get draftOpenShift() {
        return this._draftOpenShift;
    }
    ;
    /**
     * Sets the draftOpenShift property value. An unpublished open shift.
     * @param value Value to set for the draftOpenShift property.
     */
    set draftOpenShift(value) {
        this._draftOpenShift = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "draftOpenShift": (o, n) => { o.draftOpenShift = n.getObjectValue(createOpenShiftItemFromDiscriminatorValue_1.createOpenShiftItemFromDiscriminatorValue); }, "schedulingGroupId": (o, n) => { o.schedulingGroupId = n.getStringValue(); }, "sharedOpenShift": (o, n) => { o.sharedOpenShift = n.getObjectValue(createOpenShiftItemFromDiscriminatorValue_1.createOpenShiftItemFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the schedulingGroupId property value. ID for the scheduling group that the open shift belongs to.
     * @returns a string
     */
    get schedulingGroupId() {
        return this._schedulingGroupId;
    }
    ;
    /**
     * Sets the schedulingGroupId property value. ID for the scheduling group that the open shift belongs to.
     * @param value Value to set for the schedulingGroupId property.
     */
    set schedulingGroupId(value) {
        this._schedulingGroupId = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("draftOpenShift", this.draftOpenShift);
        writer.writeStringValue("schedulingGroupId", this.schedulingGroupId);
        writer.writeObjectValue("sharedOpenShift", this.sharedOpenShift);
    }
    ;
    /**
     * Gets the sharedOpenShift property value. A published open shift.
     * @returns a openShiftItem
     */
    get sharedOpenShift() {
        return this._sharedOpenShift;
    }
    ;
    /**
     * Sets the sharedOpenShift property value. A published open shift.
     * @param value Value to set for the sharedOpenShift property.
     */
    set sharedOpenShift(value) {
        this._sharedOpenShift = value;
    }
    ;
}
exports.OpenShift = OpenShift;
