import { ScheduleChangeRequest } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class OpenShiftChangeRequest extends ScheduleChangeRequest implements Parsable {
    /** ID for the open shift.  */
    private _openShiftId?;
    /**
     * Instantiates a new openShiftChangeRequest and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the openShiftId property value. ID for the open shift.
     * @returns a string
     */
    get openShiftId(): string | undefined;
    /**
     * Sets the openShiftId property value. ID for the open shift.
     * @param value Value to set for the openShiftId property.
     */
    set openShiftId(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
