import { Entity } from './index';
import { OperationStatus } from './operationStatus';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class Operation extends Entity implements Parsable {
    /** The start time of the operation.  */
    private _createdDateTime?;
    /** The time of the last action of the operation.  */
    private _lastActionDateTime?;
    /** The current status of the operation: notStarted, running, completed, failed  */
    private _status?;
    /**
     * Instantiates a new operation and sets the default values.
     */
    constructor();
    /**
     * Gets the createdDateTime property value. The start time of the operation.
     * @returns a Date
     */
    get createdDateTime(): Date | undefined;
    /**
     * Sets the createdDateTime property value. The start time of the operation.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value: Date | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the lastActionDateTime property value. The time of the last action of the operation.
     * @returns a Date
     */
    get lastActionDateTime(): Date | undefined;
    /**
     * Sets the lastActionDateTime property value. The time of the last action of the operation.
     * @param value Value to set for the lastActionDateTime property.
     */
    set lastActionDateTime(value: Date | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the status property value. The current status of the operation: notStarted, running, completed, failed
     * @returns a operationStatus
     */
    get status(): OperationStatus | undefined;
    /**
     * Sets the status property value. The current status of the operation: notStarted, running, completed, failed
     * @param value Value to set for the status property.
     */
    set status(value: OperationStatus | undefined);
}
