"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Operation = void 0;
const index_1 = require("./index");
const operationStatus_1 = require("./operationStatus");
class Operation extends index_1.Entity {
    /**
     * Instantiates a new operation and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the createdDateTime property value. The start time of the operation.
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. The start time of the operation.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); }, "lastActionDateTime": (o, n) => { o.lastActionDateTime = n.getDateValue(); }, "status": (o, n) => { o.status = n.getEnumValue(operationStatus_1.OperationStatus); } });
    }
    ;
    /**
     * Gets the lastActionDateTime property value. The time of the last action of the operation.
     * @returns a Date
     */
    get lastActionDateTime() {
        return this._lastActionDateTime;
    }
    ;
    /**
     * Sets the lastActionDateTime property value. The time of the last action of the operation.
     * @param value Value to set for the lastActionDateTime property.
     */
    set lastActionDateTime(value) {
        this._lastActionDateTime = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeDateValue("lastActionDateTime", this.lastActionDateTime);
        writer.writeEnumValue("status", this.status);
    }
    ;
    /**
     * Gets the status property value. The current status of the operation: notStarted, running, completed, failed
     * @returns a operationStatus
     */
    get status() {
        return this._status;
    }
    ;
    /**
     * Sets the status property value. The current status of the operation: notStarted, running, completed, failed
     * @param value Value to set for the status property.
     */
    set status(value) {
        this._status = value;
    }
    ;
}
exports.Operation = Operation;
