"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OptionalClaim = void 0;
class OptionalClaim {
    /**
     * Instantiates a new optionalClaim and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the additionalProperties property value. Additional properties of the claim. If a property exists in this collection, it modifies the behavior of the optional claim specified in the name property.
     * @returns a string
     */
    get additionalProperties() {
        return this._additionalProperties;
    }
    ;
    /**
     * Sets the additionalProperties property value. Additional properties of the claim. If a property exists in this collection, it modifies the behavior of the optional claim specified in the name property.
     * @param value Value to set for the additionalProperties property.
     */
    set additionalProperties(value) {
        this._additionalProperties = value;
    }
    ;
    ;
    /**
     * Gets the essential property value. If the value is true, the claim specified by the client is necessary to ensure a smooth authorization experience for the specific task requested by the end user. The default value is false.
     * @returns a boolean
     */
    get essential() {
        return this._essential;
    }
    ;
    /**
     * Sets the essential property value. If the value is true, the claim specified by the client is necessary to ensure a smooth authorization experience for the specific task requested by the end user. The default value is false.
     * @param value Value to set for the essential property.
     */
    set essential(value) {
        this._essential = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "additionalProperties": (o, n) => { o.additionalProperties = n.getCollectionOfPrimitiveValues(); },
            "essential": (o, n) => { o.essential = n.getBooleanValue(); },
            "name": (o, n) => { o.name = n.getStringValue(); },
            "source": (o, n) => { o.source = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the name property value. The name of the optional claim.
     * @returns a string
     */
    get name() {
        return this._name;
    }
    ;
    /**
     * Sets the name property value. The name of the optional claim.
     * @param value Value to set for the name property.
     */
    set name(value) {
        this._name = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfPrimitiveValues("additionalProperties", this.additionalProperties);
        writer.writeBooleanValue("essential", this.essential);
        writer.writeStringValue("name", this.name);
        writer.writeStringValue("source", this.source);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the source property value. The source (directory object) of the claim. There are predefined claims and user-defined claims from extension properties. If the source value is null, the claim is a predefined optional claim. If the source value is user, the value in the name property is the extension property from the user object.
     * @returns a string
     */
    get source() {
        return this._source;
    }
    ;
    /**
     * Sets the source property value. The source (directory object) of the claim. There are predefined claims and user-defined claims from extension properties. If the source value is null, the claim is a predefined optional claim. If the source value is user, the value in the name property is the extension property from the user object.
     * @param value Value to set for the source property.
     */
    set source(value) {
        this._source = value;
    }
    ;
}
exports.OptionalClaim = OptionalClaim;
