"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrgContact = void 0;
const createDirectoryObjectFromDiscriminatorValue_1 = require("./createDirectoryObjectFromDiscriminatorValue");
const createOnPremisesProvisioningErrorFromDiscriminatorValue_1 = require("./createOnPremisesProvisioningErrorFromDiscriminatorValue");
const createPhoneFromDiscriminatorValue_1 = require("./createPhoneFromDiscriminatorValue");
const createPhysicalOfficeAddressFromDiscriminatorValue_1 = require("./createPhysicalOfficeAddressFromDiscriminatorValue");
const index_1 = require("./index");
class OrgContact extends index_1.DirectoryObject {
    /**
     * Instantiates a new orgContact and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the addresses property value. Postal addresses for this organizational contact. For now a contact can only have one physical address.
     * @returns a physicalOfficeAddress
     */
    get addresses() {
        return this._addresses;
    }
    ;
    /**
     * Sets the addresses property value. Postal addresses for this organizational contact. For now a contact can only have one physical address.
     * @param value Value to set for the addresses property.
     */
    set addresses(value) {
        this._addresses = value;
    }
    ;
    /**
     * Gets the companyName property value. Name of the company that this organizational contact belong to. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get companyName() {
        return this._companyName;
    }
    ;
    /**
     * Sets the companyName property value. Name of the company that this organizational contact belong to. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the companyName property.
     */
    set companyName(value) {
        this._companyName = value;
    }
    ;
    ;
    /**
     * Gets the department property value. The name for the department in which the contact works. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get department() {
        return this._department;
    }
    ;
    /**
     * Sets the department property value. The name for the department in which the contact works. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the department property.
     */
    set department(value) {
        this._department = value;
    }
    ;
    /**
     * Gets the directReports property value. The contact's direct reports. (The users and contacts that have their manager property set to this contact.) Read-only. Nullable. Supports $expand.
     * @returns a directoryObject
     */
    get directReports() {
        return this._directReports;
    }
    ;
    /**
     * Sets the directReports property value. The contact's direct reports. (The users and contacts that have their manager property set to this contact.) Read-only. Nullable. Supports $expand.
     * @param value Value to set for the directReports property.
     */
    set directReports(value) {
        this._directReports = value;
    }
    ;
    /**
     * Gets the displayName property value. Display name for this organizational contact. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values), $search, and $orderBy.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. Display name for this organizational contact. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values), $search, and $orderBy.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "addresses": (o, n) => { o.addresses = n.getCollectionOfObjectValues(createPhysicalOfficeAddressFromDiscriminatorValue_1.createPhysicalOfficeAddressFromDiscriminatorValue); }, "companyName": (o, n) => { o.companyName = n.getStringValue(); }, "department": (o, n) => { o.department = n.getStringValue(); }, "directReports": (o, n) => { o.directReports = n.getCollectionOfObjectValues(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "givenName": (o, n) => { o.givenName = n.getStringValue(); }, "jobTitle": (o, n) => { o.jobTitle = n.getStringValue(); }, "mail": (o, n) => { o.mail = n.getStringValue(); }, "mailNickname": (o, n) => { o.mailNickname = n.getStringValue(); }, "manager": (o, n) => { o.manager = n.getObjectValue(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "memberOf": (o, n) => { o.memberOf = n.getCollectionOfObjectValues(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "onPremisesLastSyncDateTime": (o, n) => { o.onPremisesLastSyncDateTime = n.getDateValue(); }, "onPremisesProvisioningErrors": (o, n) => { o.onPremisesProvisioningErrors = n.getCollectionOfObjectValues(createOnPremisesProvisioningErrorFromDiscriminatorValue_1.createOnPremisesProvisioningErrorFromDiscriminatorValue); }, "onPremisesSyncEnabled": (o, n) => { o.onPremisesSyncEnabled = n.getBooleanValue(); }, "phones": (o, n) => { o.phones = n.getCollectionOfObjectValues(createPhoneFromDiscriminatorValue_1.createPhoneFromDiscriminatorValue); }, "proxyAddresses": (o, n) => { o.proxyAddresses = n.getCollectionOfPrimitiveValues(); }, "surname": (o, n) => { o.surname = n.getStringValue(); }, "transitiveMemberOf": (o, n) => { o.transitiveMemberOf = n.getCollectionOfObjectValues(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the givenName property value. First name for this organizational contact. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get givenName() {
        return this._givenName;
    }
    ;
    /**
     * Sets the givenName property value. First name for this organizational contact. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the givenName property.
     */
    set givenName(value) {
        this._givenName = value;
    }
    ;
    /**
     * Gets the jobTitle property value. Job title for this organizational contact. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get jobTitle() {
        return this._jobTitle;
    }
    ;
    /**
     * Sets the jobTitle property value. Job title for this organizational contact. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the jobTitle property.
     */
    set jobTitle(value) {
        this._jobTitle = value;
    }
    ;
    /**
     * Gets the mail property value. The SMTP address for the contact, for example, 'jeff@contoso.onmicrosoft.com'. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get mail() {
        return this._mail;
    }
    ;
    /**
     * Sets the mail property value. The SMTP address for the contact, for example, 'jeff@contoso.onmicrosoft.com'. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the mail property.
     */
    set mail(value) {
        this._mail = value;
    }
    ;
    /**
     * Gets the mailNickname property value. Email alias (portion of email address pre-pending the @ symbol) for this organizational contact. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get mailNickname() {
        return this._mailNickname;
    }
    ;
    /**
     * Sets the mailNickname property value. Email alias (portion of email address pre-pending the @ symbol) for this organizational contact. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the mailNickname property.
     */
    set mailNickname(value) {
        this._mailNickname = value;
    }
    ;
    /**
     * Gets the manager property value. The user or contact that is this contact's manager. Read-only. Supports $expand.
     * @returns a directoryObject
     */
    get manager() {
        return this._manager;
    }
    ;
    /**
     * Sets the manager property value. The user or contact that is this contact's manager. Read-only. Supports $expand.
     * @param value Value to set for the manager property.
     */
    set manager(value) {
        this._manager = value;
    }
    ;
    /**
     * Gets the memberOf property value. Groups that this contact is a member of. Read-only. Nullable. Supports $expand.
     * @returns a directoryObject
     */
    get memberOf() {
        return this._memberOf;
    }
    ;
    /**
     * Sets the memberOf property value. Groups that this contact is a member of. Read-only. Nullable. Supports $expand.
     * @param value Value to set for the memberOf property.
     */
    set memberOf(value) {
        this._memberOf = value;
    }
    ;
    /**
     * Gets the onPremisesLastSyncDateTime property value. Date and time when this organizational contact was last synchronized from on-premises AD. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Supports $filter (eq, ne, not, ge, le, in).
     * @returns a Date
     */
    get onPremisesLastSyncDateTime() {
        return this._onPremisesLastSyncDateTime;
    }
    ;
    /**
     * Sets the onPremisesLastSyncDateTime property value. Date and time when this organizational contact was last synchronized from on-premises AD. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Supports $filter (eq, ne, not, ge, le, in).
     * @param value Value to set for the onPremisesLastSyncDateTime property.
     */
    set onPremisesLastSyncDateTime(value) {
        this._onPremisesLastSyncDateTime = value;
    }
    ;
    /**
     * Gets the onPremisesProvisioningErrors property value. List of any synchronization provisioning errors for this organizational contact. Supports $filter (eq, not).
     * @returns a onPremisesProvisioningError
     */
    get onPremisesProvisioningErrors() {
        return this._onPremisesProvisioningErrors;
    }
    ;
    /**
     * Sets the onPremisesProvisioningErrors property value. List of any synchronization provisioning errors for this organizational contact. Supports $filter (eq, not).
     * @param value Value to set for the onPremisesProvisioningErrors property.
     */
    set onPremisesProvisioningErrors(value) {
        this._onPremisesProvisioningErrors = value;
    }
    ;
    /**
     * Gets the onPremisesSyncEnabled property value. true if this object is synced from an on-premises directory; false if this object was originally synced from an on-premises directory but is no longer synced and now mastered in Exchange; null if this object has never been synced from an on-premises directory (default).  Supports $filter (eq, ne, not, in, and eq on null values).
     * @returns a boolean
     */
    get onPremisesSyncEnabled() {
        return this._onPremisesSyncEnabled;
    }
    ;
    /**
     * Sets the onPremisesSyncEnabled property value. true if this object is synced from an on-premises directory; false if this object was originally synced from an on-premises directory but is no longer synced and now mastered in Exchange; null if this object has never been synced from an on-premises directory (default).  Supports $filter (eq, ne, not, in, and eq on null values).
     * @param value Value to set for the onPremisesSyncEnabled property.
     */
    set onPremisesSyncEnabled(value) {
        this._onPremisesSyncEnabled = value;
    }
    ;
    /**
     * Gets the phones property value. List of phones for this organizational contact. Phone types can be mobile, business, and businessFax. Only one of each type can ever be present in the collection. Supports $filter (eq, ne, not, in).
     * @returns a phone
     */
    get phones() {
        return this._phones;
    }
    ;
    /**
     * Sets the phones property value. List of phones for this organizational contact. Phone types can be mobile, business, and businessFax. Only one of each type can ever be present in the collection. Supports $filter (eq, ne, not, in).
     * @param value Value to set for the phones property.
     */
    set phones(value) {
        this._phones = value;
    }
    ;
    /**
     * Gets the proxyAddresses property value. For example: 'SMTP: bob@contoso.com', 'smtp: bob@sales.contoso.com'. The any operator is required for filter expressions on multi-valued properties. Supports $filter (eq, not, ge, le, startsWith).
     * @returns a string
     */
    get proxyAddresses() {
        return this._proxyAddresses;
    }
    ;
    /**
     * Sets the proxyAddresses property value. For example: 'SMTP: bob@contoso.com', 'smtp: bob@sales.contoso.com'. The any operator is required for filter expressions on multi-valued properties. Supports $filter (eq, not, ge, le, startsWith).
     * @param value Value to set for the proxyAddresses property.
     */
    set proxyAddresses(value) {
        this._proxyAddresses = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("addresses", this.addresses);
        writer.writeStringValue("companyName", this.companyName);
        writer.writeStringValue("department", this.department);
        writer.writeCollectionOfObjectValues("directReports", this.directReports);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeStringValue("givenName", this.givenName);
        writer.writeStringValue("jobTitle", this.jobTitle);
        writer.writeStringValue("mail", this.mail);
        writer.writeStringValue("mailNickname", this.mailNickname);
        writer.writeObjectValue("manager", this.manager);
        writer.writeCollectionOfObjectValues("memberOf", this.memberOf);
        writer.writeDateValue("onPremisesLastSyncDateTime", this.onPremisesLastSyncDateTime);
        writer.writeCollectionOfObjectValues("onPremisesProvisioningErrors", this.onPremisesProvisioningErrors);
        writer.writeBooleanValue("onPremisesSyncEnabled", this.onPremisesSyncEnabled);
        writer.writeCollectionOfObjectValues("phones", this.phones);
        writer.writeCollectionOfPrimitiveValues("proxyAddresses", this.proxyAddresses);
        writer.writeStringValue("surname", this.surname);
        writer.writeCollectionOfObjectValues("transitiveMemberOf", this.transitiveMemberOf);
    }
    ;
    /**
     * Gets the surname property value. Last name for this organizational contact. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values)
     * @returns a string
     */
    get surname() {
        return this._surname;
    }
    ;
    /**
     * Sets the surname property value. Last name for this organizational contact. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values)
     * @param value Value to set for the surname property.
     */
    set surname(value) {
        this._surname = value;
    }
    ;
    /**
     * Gets the transitiveMemberOf property value.
     * @returns a directoryObject
     */
    get transitiveMemberOf() {
        return this._transitiveMemberOf;
    }
    ;
    /**
     * Sets the transitiveMemberOf property value.
     * @param value Value to set for the transitiveMemberOf property.
     */
    set transitiveMemberOf(value) {
        this._transitiveMemberOf = value;
    }
    ;
}
exports.OrgContact = OrgContact;
