"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Organization = void 0;
const createAssignedPlanFromDiscriminatorValue_1 = require("./createAssignedPlanFromDiscriminatorValue");
const createCertificateBasedAuthConfigurationFromDiscriminatorValue_1 = require("./createCertificateBasedAuthConfigurationFromDiscriminatorValue");
const createExtensionFromDiscriminatorValue_1 = require("./createExtensionFromDiscriminatorValue");
const createOrganizationalBrandingFromDiscriminatorValue_1 = require("./createOrganizationalBrandingFromDiscriminatorValue");
const createPrivacyProfileFromDiscriminatorValue_1 = require("./createPrivacyProfileFromDiscriminatorValue");
const createProvisionedPlanFromDiscriminatorValue_1 = require("./createProvisionedPlanFromDiscriminatorValue");
const createVerifiedDomainFromDiscriminatorValue_1 = require("./createVerifiedDomainFromDiscriminatorValue");
const index_1 = require("./index");
const mdmAuthority_1 = require("./mdmAuthority");
class Organization extends index_1.DirectoryObject {
    /**
     * Instantiates a new organization and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the assignedPlans property value. The collection of service plans associated with the tenant. Not nullable.
     * @returns a assignedPlan
     */
    get assignedPlans() {
        return this._assignedPlans;
    }
    ;
    /**
     * Sets the assignedPlans property value. The collection of service plans associated with the tenant. Not nullable.
     * @param value Value to set for the assignedPlans property.
     */
    set assignedPlans(value) {
        this._assignedPlans = value;
    }
    ;
    /**
     * Gets the branding property value.
     * @returns a organizationalBranding
     */
    get branding() {
        return this._branding;
    }
    ;
    /**
     * Sets the branding property value.
     * @param value Value to set for the branding property.
     */
    set branding(value) {
        this._branding = value;
    }
    ;
    /**
     * Gets the businessPhones property value. Telephone number for the organization. Although this is a string collection, only one number can be set for this property.
     * @returns a string
     */
    get businessPhones() {
        return this._businessPhones;
    }
    ;
    /**
     * Sets the businessPhones property value. Telephone number for the organization. Although this is a string collection, only one number can be set for this property.
     * @param value Value to set for the businessPhones property.
     */
    set businessPhones(value) {
        this._businessPhones = value;
    }
    ;
    /**
     * Gets the certificateBasedAuthConfiguration property value. Navigation property to manage certificate-based authentication configuration. Only a single instance of certificateBasedAuthConfiguration can be created in the collection.
     * @returns a certificateBasedAuthConfiguration
     */
    get certificateBasedAuthConfiguration() {
        return this._certificateBasedAuthConfiguration;
    }
    ;
    /**
     * Sets the certificateBasedAuthConfiguration property value. Navigation property to manage certificate-based authentication configuration. Only a single instance of certificateBasedAuthConfiguration can be created in the collection.
     * @param value Value to set for the certificateBasedAuthConfiguration property.
     */
    set certificateBasedAuthConfiguration(value) {
        this._certificateBasedAuthConfiguration = value;
    }
    ;
    /**
     * Gets the city property value. City name of the address for the organization.
     * @returns a string
     */
    get city() {
        return this._city;
    }
    ;
    /**
     * Sets the city property value. City name of the address for the organization.
     * @param value Value to set for the city property.
     */
    set city(value) {
        this._city = value;
    }
    ;
    ;
    /**
     * Gets the country property value. Country/region name of the address for the organization.
     * @returns a string
     */
    get country() {
        return this._country;
    }
    ;
    /**
     * Sets the country property value. Country/region name of the address for the organization.
     * @param value Value to set for the country property.
     */
    set country(value) {
        this._country = value;
    }
    ;
    /**
     * Gets the countryLetterCode property value. Country or region abbreviation for the organization in ISO 3166-2 format.
     * @returns a string
     */
    get countryLetterCode() {
        return this._countryLetterCode;
    }
    ;
    /**
     * Sets the countryLetterCode property value. Country or region abbreviation for the organization in ISO 3166-2 format.
     * @param value Value to set for the countryLetterCode property.
     */
    set countryLetterCode(value) {
        this._countryLetterCode = value;
    }
    ;
    /**
     * Gets the createdDateTime property value. Timestamp of when the organization was created. The value cannot be modified and is automatically populated when the organization is created. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. Timestamp of when the organization was created. The value cannot be modified and is automatically populated when the organization is created. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * Gets the displayName property value. The display name for the tenant.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The display name for the tenant.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * Gets the extensions property value. The collection of open extensions defined for the organization. Read-only. Nullable.
     * @returns a extension
     */
    get extensions() {
        return this._extensions;
    }
    ;
    /**
     * Sets the extensions property value. The collection of open extensions defined for the organization. Read-only. Nullable.
     * @param value Value to set for the extensions property.
     */
    set extensions(value) {
        this._extensions = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "assignedPlans": (o, n) => { o.assignedPlans = n.getCollectionOfObjectValues(createAssignedPlanFromDiscriminatorValue_1.createAssignedPlanFromDiscriminatorValue); }, "branding": (o, n) => { o.branding = n.getObjectValue(createOrganizationalBrandingFromDiscriminatorValue_1.createOrganizationalBrandingFromDiscriminatorValue); }, "businessPhones": (o, n) => { o.businessPhones = n.getCollectionOfPrimitiveValues(); }, "certificateBasedAuthConfiguration": (o, n) => { o.certificateBasedAuthConfiguration = n.getCollectionOfObjectValues(createCertificateBasedAuthConfigurationFromDiscriminatorValue_1.createCertificateBasedAuthConfigurationFromDiscriminatorValue); }, "city": (o, n) => { o.city = n.getStringValue(); }, "country": (o, n) => { o.country = n.getStringValue(); }, "countryLetterCode": (o, n) => { o.countryLetterCode = n.getStringValue(); }, "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "extensions": (o, n) => { o.extensions = n.getCollectionOfObjectValues(createExtensionFromDiscriminatorValue_1.createExtensionFromDiscriminatorValue); }, "marketingNotificationEmails": (o, n) => { o.marketingNotificationEmails = n.getCollectionOfPrimitiveValues(); }, "mobileDeviceManagementAuthority": (o, n) => { o.mobileDeviceManagementAuthority = n.getEnumValue(mdmAuthority_1.MdmAuthority); }, "onPremisesLastSyncDateTime": (o, n) => { o.onPremisesLastSyncDateTime = n.getDateValue(); }, "onPremisesSyncEnabled": (o, n) => { o.onPremisesSyncEnabled = n.getBooleanValue(); }, "postalCode": (o, n) => { o.postalCode = n.getStringValue(); }, "preferredLanguage": (o, n) => { o.preferredLanguage = n.getStringValue(); }, "privacyProfile": (o, n) => { o.privacyProfile = n.getObjectValue(createPrivacyProfileFromDiscriminatorValue_1.createPrivacyProfileFromDiscriminatorValue); }, "provisionedPlans": (o, n) => { o.provisionedPlans = n.getCollectionOfObjectValues(createProvisionedPlanFromDiscriminatorValue_1.createProvisionedPlanFromDiscriminatorValue); }, "securityComplianceNotificationMails": (o, n) => { o.securityComplianceNotificationMails = n.getCollectionOfPrimitiveValues(); }, "securityComplianceNotificationPhones": (o, n) => { o.securityComplianceNotificationPhones = n.getCollectionOfPrimitiveValues(); }, "state": (o, n) => { o.state = n.getStringValue(); }, "street": (o, n) => { o.street = n.getStringValue(); }, "technicalNotificationMails": (o, n) => { o.technicalNotificationMails = n.getCollectionOfPrimitiveValues(); }, "tenantType": (o, n) => { o.tenantType = n.getStringValue(); }, "verifiedDomains": (o, n) => { o.verifiedDomains = n.getCollectionOfObjectValues(createVerifiedDomainFromDiscriminatorValue_1.createVerifiedDomainFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the marketingNotificationEmails property value. Not nullable.
     * @returns a string
     */
    get marketingNotificationEmails() {
        return this._marketingNotificationEmails;
    }
    ;
    /**
     * Sets the marketingNotificationEmails property value. Not nullable.
     * @param value Value to set for the marketingNotificationEmails property.
     */
    set marketingNotificationEmails(value) {
        this._marketingNotificationEmails = value;
    }
    ;
    /**
     * Gets the mobileDeviceManagementAuthority property value. Mobile device management authority. Possible values are: unknown, intune, sccm, office365.
     * @returns a mdmAuthority
     */
    get mobileDeviceManagementAuthority() {
        return this._mobileDeviceManagementAuthority;
    }
    ;
    /**
     * Sets the mobileDeviceManagementAuthority property value. Mobile device management authority. Possible values are: unknown, intune, sccm, office365.
     * @param value Value to set for the mobileDeviceManagementAuthority property.
     */
    set mobileDeviceManagementAuthority(value) {
        this._mobileDeviceManagementAuthority = value;
    }
    ;
    /**
     * Gets the onPremisesLastSyncDateTime property value. The time and date at which the tenant was last synced with the on-premises directory. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
     * @returns a Date
     */
    get onPremisesLastSyncDateTime() {
        return this._onPremisesLastSyncDateTime;
    }
    ;
    /**
     * Sets the onPremisesLastSyncDateTime property value. The time and date at which the tenant was last synced with the on-premises directory. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
     * @param value Value to set for the onPremisesLastSyncDateTime property.
     */
    set onPremisesLastSyncDateTime(value) {
        this._onPremisesLastSyncDateTime = value;
    }
    ;
    /**
     * Gets the onPremisesSyncEnabled property value. true if this object is synced from an on-premises directory; false if this object was originally synced from an on-premises directory but is no longer synced. Nullable. null if this object has never been synced from an on-premises directory (default).
     * @returns a boolean
     */
    get onPremisesSyncEnabled() {
        return this._onPremisesSyncEnabled;
    }
    ;
    /**
     * Sets the onPremisesSyncEnabled property value. true if this object is synced from an on-premises directory; false if this object was originally synced from an on-premises directory but is no longer synced. Nullable. null if this object has never been synced from an on-premises directory (default).
     * @param value Value to set for the onPremisesSyncEnabled property.
     */
    set onPremisesSyncEnabled(value) {
        this._onPremisesSyncEnabled = value;
    }
    ;
    /**
     * Gets the postalCode property value. Postal code of the address for the organization.
     * @returns a string
     */
    get postalCode() {
        return this._postalCode;
    }
    ;
    /**
     * Sets the postalCode property value. Postal code of the address for the organization.
     * @param value Value to set for the postalCode property.
     */
    set postalCode(value) {
        this._postalCode = value;
    }
    ;
    /**
     * Gets the preferredLanguage property value. The preferred language for the organization. Should follow ISO 639-1 Code; for example, en.
     * @returns a string
     */
    get preferredLanguage() {
        return this._preferredLanguage;
    }
    ;
    /**
     * Sets the preferredLanguage property value. The preferred language for the organization. Should follow ISO 639-1 Code; for example, en.
     * @param value Value to set for the preferredLanguage property.
     */
    set preferredLanguage(value) {
        this._preferredLanguage = value;
    }
    ;
    /**
     * Gets the privacyProfile property value. The privacy profile of an organization.
     * @returns a privacyProfile
     */
    get privacyProfile() {
        return this._privacyProfile;
    }
    ;
    /**
     * Sets the privacyProfile property value. The privacy profile of an organization.
     * @param value Value to set for the privacyProfile property.
     */
    set privacyProfile(value) {
        this._privacyProfile = value;
    }
    ;
    /**
     * Gets the provisionedPlans property value. Not nullable.
     * @returns a provisionedPlan
     */
    get provisionedPlans() {
        return this._provisionedPlans;
    }
    ;
    /**
     * Sets the provisionedPlans property value. Not nullable.
     * @param value Value to set for the provisionedPlans property.
     */
    set provisionedPlans(value) {
        this._provisionedPlans = value;
    }
    ;
    /**
     * Gets the securityComplianceNotificationMails property value.
     * @returns a string
     */
    get securityComplianceNotificationMails() {
        return this._securityComplianceNotificationMails;
    }
    ;
    /**
     * Sets the securityComplianceNotificationMails property value.
     * @param value Value to set for the securityComplianceNotificationMails property.
     */
    set securityComplianceNotificationMails(value) {
        this._securityComplianceNotificationMails = value;
    }
    ;
    /**
     * Gets the securityComplianceNotificationPhones property value.
     * @returns a string
     */
    get securityComplianceNotificationPhones() {
        return this._securityComplianceNotificationPhones;
    }
    ;
    /**
     * Sets the securityComplianceNotificationPhones property value.
     * @param value Value to set for the securityComplianceNotificationPhones property.
     */
    set securityComplianceNotificationPhones(value) {
        this._securityComplianceNotificationPhones = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("assignedPlans", this.assignedPlans);
        writer.writeObjectValue("branding", this.branding);
        writer.writeCollectionOfPrimitiveValues("businessPhones", this.businessPhones);
        writer.writeCollectionOfObjectValues("certificateBasedAuthConfiguration", this.certificateBasedAuthConfiguration);
        writer.writeStringValue("city", this.city);
        writer.writeStringValue("country", this.country);
        writer.writeStringValue("countryLetterCode", this.countryLetterCode);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeCollectionOfObjectValues("extensions", this.extensions);
        writer.writeCollectionOfPrimitiveValues("marketingNotificationEmails", this.marketingNotificationEmails);
        writer.writeEnumValue("mobileDeviceManagementAuthority", this.mobileDeviceManagementAuthority);
        writer.writeDateValue("onPremisesLastSyncDateTime", this.onPremisesLastSyncDateTime);
        writer.writeBooleanValue("onPremisesSyncEnabled", this.onPremisesSyncEnabled);
        writer.writeStringValue("postalCode", this.postalCode);
        writer.writeStringValue("preferredLanguage", this.preferredLanguage);
        writer.writeObjectValue("privacyProfile", this.privacyProfile);
        writer.writeCollectionOfObjectValues("provisionedPlans", this.provisionedPlans);
        writer.writeCollectionOfPrimitiveValues("securityComplianceNotificationMails", this.securityComplianceNotificationMails);
        writer.writeCollectionOfPrimitiveValues("securityComplianceNotificationPhones", this.securityComplianceNotificationPhones);
        writer.writeStringValue("state", this.state);
        writer.writeStringValue("street", this.street);
        writer.writeCollectionOfPrimitiveValues("technicalNotificationMails", this.technicalNotificationMails);
        writer.writeStringValue("tenantType", this.tenantType);
        writer.writeCollectionOfObjectValues("verifiedDomains", this.verifiedDomains);
    }
    ;
    /**
     * Gets the state property value. State name of the address for the organization.
     * @returns a string
     */
    get state() {
        return this._state;
    }
    ;
    /**
     * Sets the state property value. State name of the address for the organization.
     * @param value Value to set for the state property.
     */
    set state(value) {
        this._state = value;
    }
    ;
    /**
     * Gets the street property value. Street name of the address for organization.
     * @returns a string
     */
    get street() {
        return this._street;
    }
    ;
    /**
     * Sets the street property value. Street name of the address for organization.
     * @param value Value to set for the street property.
     */
    set street(value) {
        this._street = value;
    }
    ;
    /**
     * Gets the technicalNotificationMails property value. Not nullable.
     * @returns a string
     */
    get technicalNotificationMails() {
        return this._technicalNotificationMails;
    }
    ;
    /**
     * Sets the technicalNotificationMails property value. Not nullable.
     * @param value Value to set for the technicalNotificationMails property.
     */
    set technicalNotificationMails(value) {
        this._technicalNotificationMails = value;
    }
    ;
    /**
     * Gets the tenantType property value.
     * @returns a string
     */
    get tenantType() {
        return this._tenantType;
    }
    ;
    /**
     * Sets the tenantType property value.
     * @param value Value to set for the tenantType property.
     */
    set tenantType(value) {
        this._tenantType = value;
    }
    ;
    /**
     * Gets the verifiedDomains property value. The collection of domains associated with this tenant. Not nullable.
     * @returns a verifiedDomain
     */
    get verifiedDomains() {
        return this._verifiedDomains;
    }
    ;
    /**
     * Sets the verifiedDomains property value. The collection of domains associated with this tenant. Not nullable.
     * @param value Value to set for the verifiedDomains property.
     */
    set verifiedDomains(value) {
        this._verifiedDomains = value;
    }
    ;
}
exports.Organization = Organization;
