import { OrganizationalBrandingLocalization, OrganizationalBrandingProperties } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to manage the organizationalBranding singleton.  */
export declare class OrganizationalBranding extends OrganizationalBrandingProperties implements Parsable {
    /** Add different branding based on a locale.  */
    private _localizations?;
    /**
     * Instantiates a new organizationalBranding and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the localizations property value. Add different branding based on a locale.
     * @returns a organizationalBrandingLocalization
     */
    get localizations(): OrganizationalBrandingLocalization[] | undefined;
    /**
     * Sets the localizations property value. Add different branding based on a locale.
     * @param value Value to set for the localizations property.
     */
    set localizations(value: OrganizationalBrandingLocalization[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
