"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrganizationalBrandingProperties = void 0;
const index_1 = require("./index");
/** Provides operations to manage the organizationalBranding singleton.  */
class OrganizationalBrandingProperties extends index_1.Entity {
    /**
     * Instantiates a new organizationalBrandingProperties and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the backgroundColor property value. Color that will appear in place of the background image in low-bandwidth connections. We recommend that you use the primary color of your banner logo or your organization color. Specify this in hexadecimal format, for example, white is #FFFFFF.
     * @returns a string
     */
    get backgroundColor() {
        return this._backgroundColor;
    }
    ;
    /**
     * Sets the backgroundColor property value. Color that will appear in place of the background image in low-bandwidth connections. We recommend that you use the primary color of your banner logo or your organization color. Specify this in hexadecimal format, for example, white is #FFFFFF.
     * @param value Value to set for the backgroundColor property.
     */
    set backgroundColor(value) {
        this._backgroundColor = value;
    }
    ;
    /**
     * Gets the backgroundImage property value. Image that appears as the background of the sign-in page. The allowed types are PNG or JPEG not smaller than 300 KB and not larger than 1920 × 1080 pixels. A smaller image will reduce bandwidth requirements and make the page load faster.
     * @returns a binary
     */
    get backgroundImage() {
        return this._backgroundImage;
    }
    ;
    /**
     * Sets the backgroundImage property value. Image that appears as the background of the sign-in page. The allowed types are PNG or JPEG not smaller than 300 KB and not larger than 1920 × 1080 pixels. A smaller image will reduce bandwidth requirements and make the page load faster.
     * @param value Value to set for the backgroundImage property.
     */
    set backgroundImage(value) {
        this._backgroundImage = value;
    }
    ;
    /**
     * Gets the backgroundImageRelativeUrl property value. A relative URL for the backgroundImage property that is combined with a CDN base URL from the cdnList to provide the version served by a CDN. Read-only.
     * @returns a string
     */
    get backgroundImageRelativeUrl() {
        return this._backgroundImageRelativeUrl;
    }
    ;
    /**
     * Sets the backgroundImageRelativeUrl property value. A relative URL for the backgroundImage property that is combined with a CDN base URL from the cdnList to provide the version served by a CDN. Read-only.
     * @param value Value to set for the backgroundImageRelativeUrl property.
     */
    set backgroundImageRelativeUrl(value) {
        this._backgroundImageRelativeUrl = value;
    }
    ;
    /**
     * Gets the bannerLogo property value. A banner version of your company logo that appears on the sign-in page. The allowed types are PNG or JPEG no larger than 36 × 245 pixels. We recommend using a transparent image with no padding around the logo.
     * @returns a binary
     */
    get bannerLogo() {
        return this._bannerLogo;
    }
    ;
    /**
     * Sets the bannerLogo property value. A banner version of your company logo that appears on the sign-in page. The allowed types are PNG or JPEG no larger than 36 × 245 pixels. We recommend using a transparent image with no padding around the logo.
     * @param value Value to set for the bannerLogo property.
     */
    set bannerLogo(value) {
        this._bannerLogo = value;
    }
    ;
    /**
     * Gets the bannerLogoRelativeUrl property value. A relative url for the bannerLogo property that is combined with a CDN base URL from the cdnList to provide the read-only version served by a CDN. Read-only.
     * @returns a string
     */
    get bannerLogoRelativeUrl() {
        return this._bannerLogoRelativeUrl;
    }
    ;
    /**
     * Sets the bannerLogoRelativeUrl property value. A relative url for the bannerLogo property that is combined with a CDN base URL from the cdnList to provide the read-only version served by a CDN. Read-only.
     * @param value Value to set for the bannerLogoRelativeUrl property.
     */
    set bannerLogoRelativeUrl(value) {
        this._bannerLogoRelativeUrl = value;
    }
    ;
    /**
     * Gets the cdnList property value. A list of base URLs for all available CDN providers that are serving the assets of the current resource. Several CDN providers are used at the same time for high availability of read requests. Read-only.
     * @returns a string
     */
    get cdnList() {
        return this._cdnList;
    }
    ;
    /**
     * Sets the cdnList property value. A list of base URLs for all available CDN providers that are serving the assets of the current resource. Several CDN providers are used at the same time for high availability of read requests. Read-only.
     * @param value Value to set for the cdnList property.
     */
    set cdnList(value) {
        this._cdnList = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "backgroundColor": (o, n) => { o.backgroundColor = n.getStringValue(); }, "backgroundImage": (o, n) => { o.backgroundImage = n.getStringValue(); }, "backgroundImageRelativeUrl": (o, n) => { o.backgroundImageRelativeUrl = n.getStringValue(); }, "bannerLogo": (o, n) => { o.bannerLogo = n.getStringValue(); }, "bannerLogoRelativeUrl": (o, n) => { o.bannerLogoRelativeUrl = n.getStringValue(); }, "cdnList": (o, n) => { o.cdnList = n.getCollectionOfPrimitiveValues(); }, "signInPageText": (o, n) => { o.signInPageText = n.getStringValue(); }, "squareLogo": (o, n) => { o.squareLogo = n.getStringValue(); }, "squareLogoRelativeUrl": (o, n) => { o.squareLogoRelativeUrl = n.getStringValue(); }, "usernameHintText": (o, n) => { o.usernameHintText = n.getStringValue(); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("backgroundColor", this.backgroundColor);
        writer.writeStringValue("backgroundImage", this.backgroundImage);
        writer.writeStringValue("backgroundImageRelativeUrl", this.backgroundImageRelativeUrl);
        writer.writeStringValue("bannerLogo", this.bannerLogo);
        writer.writeStringValue("bannerLogoRelativeUrl", this.bannerLogoRelativeUrl);
        writer.writeCollectionOfPrimitiveValues("cdnList", this.cdnList);
        writer.writeStringValue("signInPageText", this.signInPageText);
        writer.writeStringValue("squareLogo", this.squareLogo);
        writer.writeStringValue("squareLogoRelativeUrl", this.squareLogoRelativeUrl);
        writer.writeStringValue("usernameHintText", this.usernameHintText);
    }
    ;
    /**
     * Gets the signInPageText property value. Text that appears at the bottom of the sign-in box. You can use this to communicate additional information, such as the phone number to your help desk or a legal statement. This text must be Unicode and not exceed 1024 characters.
     * @returns a string
     */
    get signInPageText() {
        return this._signInPageText;
    }
    ;
    /**
     * Sets the signInPageText property value. Text that appears at the bottom of the sign-in box. You can use this to communicate additional information, such as the phone number to your help desk or a legal statement. This text must be Unicode and not exceed 1024 characters.
     * @param value Value to set for the signInPageText property.
     */
    set signInPageText(value) {
        this._signInPageText = value;
    }
    ;
    /**
     * Gets the squareLogo property value. A square version of your company logo that appears in Windows 10 out-of-box experiences (OOBE) and when Windows Autopilot is enabled for deployment. Allowed types are PNG or JPEG no larger than 240 x 240 pixels and no more than 10 KB in size. We recommend using a transparent image with no padding around the logo.
     * @returns a binary
     */
    get squareLogo() {
        return this._squareLogo;
    }
    ;
    /**
     * Sets the squareLogo property value. A square version of your company logo that appears in Windows 10 out-of-box experiences (OOBE) and when Windows Autopilot is enabled for deployment. Allowed types are PNG or JPEG no larger than 240 x 240 pixels and no more than 10 KB in size. We recommend using a transparent image with no padding around the logo.
     * @param value Value to set for the squareLogo property.
     */
    set squareLogo(value) {
        this._squareLogo = value;
    }
    ;
    /**
     * Gets the squareLogoRelativeUrl property value. A relative url for the squareLogo property that is combined with a CDN base URL from the cdnList to provide the version served by a CDN. Read-only.
     * @returns a string
     */
    get squareLogoRelativeUrl() {
        return this._squareLogoRelativeUrl;
    }
    ;
    /**
     * Sets the squareLogoRelativeUrl property value. A relative url for the squareLogo property that is combined with a CDN base URL from the cdnList to provide the version served by a CDN. Read-only.
     * @param value Value to set for the squareLogoRelativeUrl property.
     */
    set squareLogoRelativeUrl(value) {
        this._squareLogoRelativeUrl = value;
    }
    ;
    /**
     * Gets the usernameHintText property value. String that shows as the hint in the username textbox on the sign-in screen. This text must be a Unicode, without links or code, and can't exceed 64 characters.
     * @returns a string
     */
    get usernameHintText() {
        return this._usernameHintText;
    }
    ;
    /**
     * Sets the usernameHintText property value. String that shows as the hint in the username textbox on the sign-in screen. This text must be a Unicode, without links or code, and can't exceed 64 characters.
     * @param value Value to set for the usernameHintText property.
     */
    set usernameHintText(value) {
        this._usernameHintText = value;
    }
    ;
}
exports.OrganizationalBrandingProperties = OrganizationalBrandingProperties;
