import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class OutlookGeoCoordinates implements AdditionalDataHolder, Parsable {
    /** The accuracy of the latitude and longitude. As an example, the accuracy can be measured in meters, such as the latitude and longitude are accurate to within 50 meters.  */
    private _accuracy?;
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** The altitude of the location.  */
    private _altitude?;
    /** The accuracy of the altitude.  */
    private _altitudeAccuracy?;
    /** The latitude of the location.  */
    private _latitude?;
    /** The longitude of the location.  */
    private _longitude?;
    /**
     * Gets the accuracy property value. The accuracy of the latitude and longitude. As an example, the accuracy can be measured in meters, such as the latitude and longitude are accurate to within 50 meters.
     * @returns a double
     */
    get accuracy(): number | undefined;
    /**
     * Sets the accuracy property value. The accuracy of the latitude and longitude. As an example, the accuracy can be measured in meters, such as the latitude and longitude are accurate to within 50 meters.
     * @param value Value to set for the accuracy property.
     */
    set accuracy(value: number | undefined);
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the altitude property value. The altitude of the location.
     * @returns a double
     */
    get altitude(): number | undefined;
    /**
     * Sets the altitude property value. The altitude of the location.
     * @param value Value to set for the altitude property.
     */
    set altitude(value: number | undefined);
    /**
     * Gets the altitudeAccuracy property value. The accuracy of the altitude.
     * @returns a double
     */
    get altitudeAccuracy(): number | undefined;
    /**
     * Sets the altitudeAccuracy property value. The accuracy of the altitude.
     * @param value Value to set for the altitudeAccuracy property.
     */
    set altitudeAccuracy(value: number | undefined);
    /**
     * Instantiates a new outlookGeoCoordinates and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the latitude property value. The latitude of the location.
     * @returns a double
     */
    get latitude(): number | undefined;
    /**
     * Sets the latitude property value. The latitude of the location.
     * @param value Value to set for the latitude property.
     */
    set latitude(value: number | undefined);
    /**
     * Gets the longitude property value. The longitude of the location.
     * @returns a double
     */
    get longitude(): number | undefined;
    /**
     * Sets the longitude property value. The longitude of the location.
     * @param value Value to set for the longitude property.
     */
    set longitude(value: number | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
