"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OutlookGeoCoordinates = void 0;
class OutlookGeoCoordinates {
    /**
     * Instantiates a new outlookGeoCoordinates and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the accuracy property value. The accuracy of the latitude and longitude. As an example, the accuracy can be measured in meters, such as the latitude and longitude are accurate to within 50 meters.
     * @returns a double
     */
    get accuracy() {
        return this._accuracy;
    }
    ;
    /**
     * Sets the accuracy property value. The accuracy of the latitude and longitude. As an example, the accuracy can be measured in meters, such as the latitude and longitude are accurate to within 50 meters.
     * @param value Value to set for the accuracy property.
     */
    set accuracy(value) {
        this._accuracy = value;
    }
    ;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the altitude property value. The altitude of the location.
     * @returns a double
     */
    get altitude() {
        return this._altitude;
    }
    ;
    /**
     * Sets the altitude property value. The altitude of the location.
     * @param value Value to set for the altitude property.
     */
    set altitude(value) {
        this._altitude = value;
    }
    ;
    /**
     * Gets the altitudeAccuracy property value. The accuracy of the altitude.
     * @returns a double
     */
    get altitudeAccuracy() {
        return this._altitudeAccuracy;
    }
    ;
    /**
     * Sets the altitudeAccuracy property value. The accuracy of the altitude.
     * @param value Value to set for the altitudeAccuracy property.
     */
    set altitudeAccuracy(value) {
        this._altitudeAccuracy = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "accuracy": (o, n) => { o.accuracy = n.getNumberValue(); },
            "altitude": (o, n) => { o.altitude = n.getNumberValue(); },
            "altitudeAccuracy": (o, n) => { o.altitudeAccuracy = n.getNumberValue(); },
            "latitude": (o, n) => { o.latitude = n.getNumberValue(); },
            "longitude": (o, n) => { o.longitude = n.getNumberValue(); },
        };
    }
    ;
    /**
     * Gets the latitude property value. The latitude of the location.
     * @returns a double
     */
    get latitude() {
        return this._latitude;
    }
    ;
    /**
     * Sets the latitude property value. The latitude of the location.
     * @param value Value to set for the latitude property.
     */
    set latitude(value) {
        this._latitude = value;
    }
    ;
    /**
     * Gets the longitude property value. The longitude of the location.
     * @returns a double
     */
    get longitude() {
        return this._longitude;
    }
    ;
    /**
     * Sets the longitude property value. The longitude of the location.
     * @param value Value to set for the longitude property.
     */
    set longitude(value) {
        this._longitude = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeNumberValue("accuracy", this.accuracy);
        writer.writeNumberValue("altitude", this.altitude);
        writer.writeNumberValue("altitudeAccuracy", this.altitudeAccuracy);
        writer.writeNumberValue("latitude", this.latitude);
        writer.writeNumberValue("longitude", this.longitude);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.OutlookGeoCoordinates = OutlookGeoCoordinates;
