import { Entity, OutlookCategory } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class OutlookUser extends Entity implements Parsable {
    /** A list of categories defined for the user.  */
    private _masterCategories?;
    /**
     * Instantiates a new outlookUser and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the masterCategories property value. A list of categories defined for the user.
     * @returns a outlookCategory
     */
    get masterCategories(): OutlookCategory[] | undefined;
    /**
     * Sets the masterCategories property value. A list of categories defined for the user.
     * @param value Value to set for the masterCategories property.
     */
    set masterCategories(value: OutlookCategory[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
