import { Entity, MediaStream, ParticipantInfo, RecordingInfo } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class Participant extends Entity implements Parsable {
    private _info?;
    /** true if the participant is in lobby.  */
    private _isInLobby?;
    /** true if the participant is muted (client or server muted).  */
    private _isMuted?;
    /** The list of media streams.  */
    private _mediaStreams?;
    /** A blob of data provided by the participant in the roster.  */
    private _metadata?;
    /** Information about whether the participant has recording capability.  */
    private _recordingInfo?;
    /**
     * Instantiates a new participant and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the info property value.
     * @returns a participantInfo
     */
    get info(): ParticipantInfo | undefined;
    /**
     * Sets the info property value.
     * @param value Value to set for the info property.
     */
    set info(value: ParticipantInfo | undefined);
    /**
     * Gets the isInLobby property value. true if the participant is in lobby.
     * @returns a boolean
     */
    get isInLobby(): boolean | undefined;
    /**
     * Sets the isInLobby property value. true if the participant is in lobby.
     * @param value Value to set for the isInLobby property.
     */
    set isInLobby(value: boolean | undefined);
    /**
     * Gets the isMuted property value. true if the participant is muted (client or server muted).
     * @returns a boolean
     */
    get isMuted(): boolean | undefined;
    /**
     * Sets the isMuted property value. true if the participant is muted (client or server muted).
     * @param value Value to set for the isMuted property.
     */
    set isMuted(value: boolean | undefined);
    /**
     * Gets the mediaStreams property value. The list of media streams.
     * @returns a mediaStream
     */
    get mediaStreams(): MediaStream[] | undefined;
    /**
     * Sets the mediaStreams property value. The list of media streams.
     * @param value Value to set for the mediaStreams property.
     */
    set mediaStreams(value: MediaStream[] | undefined);
    /**
     * Gets the metadata property value. A blob of data provided by the participant in the roster.
     * @returns a string
     */
    get metadata(): string | undefined;
    /**
     * Sets the metadata property value. A blob of data provided by the participant in the roster.
     * @param value Value to set for the metadata property.
     */
    set metadata(value: string | undefined);
    /**
     * Gets the recordingInfo property value. Information about whether the participant has recording capability.
     * @returns a recordingInfo
     */
    get recordingInfo(): RecordingInfo | undefined;
    /**
     * Sets the recordingInfo property value. Information about whether the participant has recording capability.
     * @param value Value to set for the recordingInfo property.
     */
    set recordingInfo(value: RecordingInfo | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
