"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParticipantInfo = void 0;
const createIdentitySetFromDiscriminatorValue_1 = require("./createIdentitySetFromDiscriminatorValue");
const endpointType_1 = require("./endpointType");
class ParticipantInfo {
    /**
     * Instantiates a new participantInfo and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the countryCode property value. The ISO 3166-1 Alpha-2 country code of the participant's best estimated physical location at the start of the call. Read-only.
     * @returns a string
     */
    get countryCode() {
        return this._countryCode;
    }
    ;
    /**
     * Sets the countryCode property value. The ISO 3166-1 Alpha-2 country code of the participant's best estimated physical location at the start of the call. Read-only.
     * @param value Value to set for the countryCode property.
     */
    set countryCode(value) {
        this._countryCode = value;
    }
    ;
    /**
     * Gets the endpointType property value. The type of endpoint the participant is using. Possible values are: default, skypeForBusiness, or skypeForBusinessVoipPhone. Read-only.
     * @returns a endpointType
     */
    get endpointType() {
        return this._endpointType;
    }
    ;
    /**
     * Sets the endpointType property value. The type of endpoint the participant is using. Possible values are: default, skypeForBusiness, or skypeForBusinessVoipPhone. Read-only.
     * @param value Value to set for the endpointType property.
     */
    set endpointType(value) {
        this._endpointType = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "countryCode": (o, n) => { o.countryCode = n.getStringValue(); },
            "endpointType": (o, n) => { o.endpointType = n.getEnumValue(endpointType_1.EndpointType); },
            "identity": (o, n) => { o.identity = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); },
            "languageId": (o, n) => { o.languageId = n.getStringValue(); },
            "participantId": (o, n) => { o.participantId = n.getStringValue(); },
            "region": (o, n) => { o.region = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the identity property value.
     * @returns a identitySet
     */
    get identity() {
        return this._identity;
    }
    ;
    /**
     * Sets the identity property value.
     * @param value Value to set for the identity property.
     */
    set identity(value) {
        this._identity = value;
    }
    ;
    /**
     * Gets the languageId property value. The language culture string. Read-only.
     * @returns a string
     */
    get languageId() {
        return this._languageId;
    }
    ;
    /**
     * Sets the languageId property value. The language culture string. Read-only.
     * @param value Value to set for the languageId property.
     */
    set languageId(value) {
        this._languageId = value;
    }
    ;
    /**
     * Gets the participantId property value. The participant ID of the participant. Read-only.
     * @returns a string
     */
    get participantId() {
        return this._participantId;
    }
    ;
    /**
     * Sets the participantId property value. The participant ID of the participant. Read-only.
     * @param value Value to set for the participantId property.
     */
    set participantId(value) {
        this._participantId = value;
    }
    ;
    /**
     * Gets the region property value. The home region of the participant. This can be a country, a continent, or a larger geographic region. This does not change based on the participant's current physical location. Read-only.
     * @returns a string
     */
    get region() {
        return this._region;
    }
    ;
    /**
     * Sets the region property value. The home region of the participant. This can be a country, a continent, or a larger geographic region. This does not change based on the participant's current physical location. Read-only.
     * @param value Value to set for the region property.
     */
    set region(value) {
        this._region = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("countryCode", this.countryCode);
        writer.writeEnumValue("endpointType", this.endpointType);
        writer.writeObjectValue("identity", this.identity);
        writer.writeStringValue("languageId", this.languageId);
        writer.writeStringValue("participantId", this.participantId);
        writer.writeStringValue("region", this.region);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ParticipantInfo = ParticipantInfo;
