"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PasswordCredential = void 0;
class PasswordCredential {
    /**
     * Instantiates a new passwordCredential and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the customKeyIdentifier property value. Do not use.
     * @returns a binary
     */
    get customKeyIdentifier() {
        return this._customKeyIdentifier;
    }
    ;
    /**
     * Sets the customKeyIdentifier property value. Do not use.
     * @param value Value to set for the customKeyIdentifier property.
     */
    set customKeyIdentifier(value) {
        this._customKeyIdentifier = value;
    }
    ;
    /**
     * Gets the displayName property value. Friendly name for the password. Optional.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. Friendly name for the password. Optional.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * Gets the endDateTime property value. The date and time at which the password expires represented using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Optional.
     * @returns a Date
     */
    get endDateTime() {
        return this._endDateTime;
    }
    ;
    /**
     * Sets the endDateTime property value. The date and time at which the password expires represented using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Optional.
     * @param value Value to set for the endDateTime property.
     */
    set endDateTime(value) {
        this._endDateTime = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "customKeyIdentifier": (o, n) => { o.customKeyIdentifier = n.getStringValue(); },
            "displayName": (o, n) => { o.displayName = n.getStringValue(); },
            "endDateTime": (o, n) => { o.endDateTime = n.getDateValue(); },
            "hint": (o, n) => { o.hint = n.getStringValue(); },
            "keyId": (o, n) => { o.keyId = n.getStringValue(); },
            "secretText": (o, n) => { o.secretText = n.getStringValue(); },
            "startDateTime": (o, n) => { o.startDateTime = n.getDateValue(); },
        };
    }
    ;
    /**
     * Gets the hint property value. Contains the first three characters of the password. Read-only.
     * @returns a string
     */
    get hint() {
        return this._hint;
    }
    ;
    /**
     * Sets the hint property value. Contains the first three characters of the password. Read-only.
     * @param value Value to set for the hint property.
     */
    set hint(value) {
        this._hint = value;
    }
    ;
    /**
     * Gets the keyId property value. The unique identifier for the password.
     * @returns a string
     */
    get keyId() {
        return this._keyId;
    }
    ;
    /**
     * Sets the keyId property value. The unique identifier for the password.
     * @param value Value to set for the keyId property.
     */
    set keyId(value) {
        this._keyId = value;
    }
    ;
    /**
     * Gets the secretText property value. Read-only; Contains the strong passwords generated by Azure AD that are 16-64 characters in length. The generated password value is only returned during the initial POST request to addPassword. There is no way to retrieve this password in the future.
     * @returns a string
     */
    get secretText() {
        return this._secretText;
    }
    ;
    /**
     * Sets the secretText property value. Read-only; Contains the strong passwords generated by Azure AD that are 16-64 characters in length. The generated password value is only returned during the initial POST request to addPassword. There is no way to retrieve this password in the future.
     * @param value Value to set for the secretText property.
     */
    set secretText(value) {
        this._secretText = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("customKeyIdentifier", this.customKeyIdentifier);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeDateValue("endDateTime", this.endDateTime);
        writer.writeStringValue("hint", this.hint);
        writer.writeStringValue("keyId", this.keyId);
        writer.writeStringValue("secretText", this.secretText);
        writer.writeDateValue("startDateTime", this.startDateTime);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the startDateTime property value. The date and time at which the password becomes valid. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Optional.
     * @returns a Date
     */
    get startDateTime() {
        return this._startDateTime;
    }
    ;
    /**
     * Sets the startDateTime property value. The date and time at which the password becomes valid. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Optional.
     * @param value Value to set for the startDateTime property.
     */
    set startDateTime(value) {
        this._startDateTime = value;
    }
    ;
}
exports.PasswordCredential = PasswordCredential;
