"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PatternedRecurrence = void 0;
const createRecurrencePatternFromDiscriminatorValue_1 = require("./createRecurrencePatternFromDiscriminatorValue");
const createRecurrenceRangeFromDiscriminatorValue_1 = require("./createRecurrenceRangeFromDiscriminatorValue");
class PatternedRecurrence {
    /**
     * Instantiates a new patternedRecurrence and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "pattern": (o, n) => { o.pattern = n.getObjectValue(createRecurrencePatternFromDiscriminatorValue_1.createRecurrencePatternFromDiscriminatorValue); },
            "range": (o, n) => { o.range = n.getObjectValue(createRecurrenceRangeFromDiscriminatorValue_1.createRecurrenceRangeFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the pattern property value. The frequency of an event.  For access reviews: Do not specify this property for a one-time access review.  Only interval, dayOfMonth, and type (weekly, absoluteMonthly) properties of recurrencePattern are supported.
     * @returns a recurrencePattern
     */
    get pattern() {
        return this._pattern;
    }
    ;
    /**
     * Sets the pattern property value. The frequency of an event.  For access reviews: Do not specify this property for a one-time access review.  Only interval, dayOfMonth, and type (weekly, absoluteMonthly) properties of recurrencePattern are supported.
     * @param value Value to set for the pattern property.
     */
    set pattern(value) {
        this._pattern = value;
    }
    ;
    /**
     * Gets the range property value. The duration of an event.
     * @returns a recurrenceRange
     */
    get range() {
        return this._range;
    }
    ;
    /**
     * Sets the range property value. The duration of an event.
     * @param value Value to set for the range property.
     */
    set range(value) {
        this._range = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("pattern", this.pattern);
        writer.writeObjectValue("range", this.range);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.PatternedRecurrence = PatternedRecurrence;
