"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PermissionGrantConditionSet = void 0;
const index_1 = require("./index");
const permissionType_1 = require("./permissionType");
class PermissionGrantConditionSet extends index_1.Entity {
    /**
     * Instantiates a new permissionGrantConditionSet and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the clientApplicationIds property value. A list of appId values for the client applications to match with, or a list with the single value all to match any client application. Default is the single value all.
     * @returns a string
     */
    get clientApplicationIds() {
        return this._clientApplicationIds;
    }
    ;
    /**
     * Sets the clientApplicationIds property value. A list of appId values for the client applications to match with, or a list with the single value all to match any client application. Default is the single value all.
     * @param value Value to set for the clientApplicationIds property.
     */
    set clientApplicationIds(value) {
        this._clientApplicationIds = value;
    }
    ;
    /**
     * Gets the clientApplicationPublisherIds property value. A list of Microsoft Partner Network (MPN) IDs for verified publishers of the client application, or a list with the single value all to match with client apps from any publisher. Default is the single value all.
     * @returns a string
     */
    get clientApplicationPublisherIds() {
        return this._clientApplicationPublisherIds;
    }
    ;
    /**
     * Sets the clientApplicationPublisherIds property value. A list of Microsoft Partner Network (MPN) IDs for verified publishers of the client application, or a list with the single value all to match with client apps from any publisher. Default is the single value all.
     * @param value Value to set for the clientApplicationPublisherIds property.
     */
    set clientApplicationPublisherIds(value) {
        this._clientApplicationPublisherIds = value;
    }
    ;
    /**
     * Gets the clientApplicationsFromVerifiedPublisherOnly property value. Set to true to only match on client applications with a verified publisher. Set to false to match on any client app, even if it does not have a verified publisher. Default is false.
     * @returns a boolean
     */
    get clientApplicationsFromVerifiedPublisherOnly() {
        return this._clientApplicationsFromVerifiedPublisherOnly;
    }
    ;
    /**
     * Sets the clientApplicationsFromVerifiedPublisherOnly property value. Set to true to only match on client applications with a verified publisher. Set to false to match on any client app, even if it does not have a verified publisher. Default is false.
     * @param value Value to set for the clientApplicationsFromVerifiedPublisherOnly property.
     */
    set clientApplicationsFromVerifiedPublisherOnly(value) {
        this._clientApplicationsFromVerifiedPublisherOnly = value;
    }
    ;
    /**
     * Gets the clientApplicationTenantIds property value. A list of Azure Active Directory tenant IDs in which the client application is registered, or a list with the single value all to match with client apps registered in any tenant. Default is the single value all.
     * @returns a string
     */
    get clientApplicationTenantIds() {
        return this._clientApplicationTenantIds;
    }
    ;
    /**
     * Sets the clientApplicationTenantIds property value. A list of Azure Active Directory tenant IDs in which the client application is registered, or a list with the single value all to match with client apps registered in any tenant. Default is the single value all.
     * @param value Value to set for the clientApplicationTenantIds property.
     */
    set clientApplicationTenantIds(value) {
        this._clientApplicationTenantIds = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "clientApplicationIds": (o, n) => { o.clientApplicationIds = n.getCollectionOfPrimitiveValues(); }, "clientApplicationPublisherIds": (o, n) => { o.clientApplicationPublisherIds = n.getCollectionOfPrimitiveValues(); }, "clientApplicationsFromVerifiedPublisherOnly": (o, n) => { o.clientApplicationsFromVerifiedPublisherOnly = n.getBooleanValue(); }, "clientApplicationTenantIds": (o, n) => { o.clientApplicationTenantIds = n.getCollectionOfPrimitiveValues(); }, "permissionClassification": (o, n) => { o.permissionClassification = n.getStringValue(); }, "permissions": (o, n) => { o.permissions = n.getCollectionOfPrimitiveValues(); }, "permissionType": (o, n) => { o.permissionType = n.getEnumValue(permissionType_1.PermissionType); }, "resourceApplication": (o, n) => { o.resourceApplication = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the permissionClassification property value. The permission classification for the permission being granted, or all to match with any permission classification (including permissions which are not classified). Default is all.
     * @returns a string
     */
    get permissionClassification() {
        return this._permissionClassification;
    }
    ;
    /**
     * Sets the permissionClassification property value. The permission classification for the permission being granted, or all to match with any permission classification (including permissions which are not classified). Default is all.
     * @param value Value to set for the permissionClassification property.
     */
    set permissionClassification(value) {
        this._permissionClassification = value;
    }
    ;
    /**
     * Gets the permissions property value. The list of id values for the specific permissions to match with, or a list with the single value all to match with any permission. The id of delegated permissions can be found in the oauth2PermissionScopes property of the API's **servicePrincipal** object. The id of application permissions can be found in the appRoles property of the API's **servicePrincipal** object. The id of resource-specific application permissions can be found in the resourceSpecificApplicationPermissions property of the API's **servicePrincipal** object. Default is the single value all.
     * @returns a string
     */
    get permissions() {
        return this._permissions;
    }
    ;
    /**
     * Sets the permissions property value. The list of id values for the specific permissions to match with, or a list with the single value all to match with any permission. The id of delegated permissions can be found in the oauth2PermissionScopes property of the API's **servicePrincipal** object. The id of application permissions can be found in the appRoles property of the API's **servicePrincipal** object. The id of resource-specific application permissions can be found in the resourceSpecificApplicationPermissions property of the API's **servicePrincipal** object. Default is the single value all.
     * @param value Value to set for the permissions property.
     */
    set permissions(value) {
        this._permissions = value;
    }
    ;
    /**
     * Gets the permissionType property value. The permission type of the permission being granted. Possible values: application for application permissions (e.g. app roles), or delegated for delegated permissions. The value delegatedUserConsentable indicates delegated permissions which have not been configured by the API publisher to require admin consent—this value may be used in built-in permission grant policies, but cannot be used in custom permission grant policies. Required.
     * @returns a permissionType
     */
    get permissionType() {
        return this._permissionType;
    }
    ;
    /**
     * Sets the permissionType property value. The permission type of the permission being granted. Possible values: application for application permissions (e.g. app roles), or delegated for delegated permissions. The value delegatedUserConsentable indicates delegated permissions which have not been configured by the API publisher to require admin consent—this value may be used in built-in permission grant policies, but cannot be used in custom permission grant policies. Required.
     * @param value Value to set for the permissionType property.
     */
    set permissionType(value) {
        this._permissionType = value;
    }
    ;
    /**
     * Gets the resourceApplication property value. The appId of the resource application (e.g. the API) for which a permission is being granted, or any to match with any resource application or API. Default is any.
     * @returns a string
     */
    get resourceApplication() {
        return this._resourceApplication;
    }
    ;
    /**
     * Sets the resourceApplication property value. The appId of the resource application (e.g. the API) for which a permission is being granted, or any to match with any resource application or API. Default is any.
     * @param value Value to set for the resourceApplication property.
     */
    set resourceApplication(value) {
        this._resourceApplication = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfPrimitiveValues("clientApplicationIds", this.clientApplicationIds);
        writer.writeCollectionOfPrimitiveValues("clientApplicationPublisherIds", this.clientApplicationPublisherIds);
        writer.writeBooleanValue("clientApplicationsFromVerifiedPublisherOnly", this.clientApplicationsFromVerifiedPublisherOnly);
        writer.writeCollectionOfPrimitiveValues("clientApplicationTenantIds", this.clientApplicationTenantIds);
        writer.writeStringValue("permissionClassification", this.permissionClassification);
        writer.writeCollectionOfPrimitiveValues("permissions", this.permissions);
        writer.writeEnumValue("permissionType", this.permissionType);
        writer.writeStringValue("resourceApplication", this.resourceApplication);
    }
    ;
}
exports.PermissionGrantConditionSet = PermissionGrantConditionSet;
