"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PermissionGrantPolicy = void 0;
const createPermissionGrantConditionSetFromDiscriminatorValue_1 = require("./createPermissionGrantConditionSetFromDiscriminatorValue");
const index_1 = require("./index");
class PermissionGrantPolicy extends index_1.PolicyBase {
    /**
     * Instantiates a new permissionGrantPolicy and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the excludes property value. Condition sets which are excluded in this permission grant policy. Automatically expanded on GET.
     * @returns a permissionGrantConditionSet
     */
    get excludes() {
        return this._excludes;
    }
    ;
    /**
     * Sets the excludes property value. Condition sets which are excluded in this permission grant policy. Automatically expanded on GET.
     * @param value Value to set for the excludes property.
     */
    set excludes(value) {
        this._excludes = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "excludes": (o, n) => { o.excludes = n.getCollectionOfObjectValues(createPermissionGrantConditionSetFromDiscriminatorValue_1.createPermissionGrantConditionSetFromDiscriminatorValue); }, "includes": (o, n) => { o.includes = n.getCollectionOfObjectValues(createPermissionGrantConditionSetFromDiscriminatorValue_1.createPermissionGrantConditionSetFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the includes property value. Condition sets which are included in this permission grant policy. Automatically expanded on GET.
     * @returns a permissionGrantConditionSet
     */
    get includes() {
        return this._includes;
    }
    ;
    /**
     * Sets the includes property value. Condition sets which are included in this permission grant policy. Automatically expanded on GET.
     * @param value Value to set for the includes property.
     */
    set includes(value) {
        this._includes = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("excludes", this.excludes);
        writer.writeCollectionOfObjectValues("includes", this.includes);
    }
    ;
}
exports.PermissionGrantPolicy = PermissionGrantPolicy;
