"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Person = void 0;
const createLocationFromDiscriminatorValue_1 = require("./createLocationFromDiscriminatorValue");
const createPersonTypeFromDiscriminatorValue_1 = require("./createPersonTypeFromDiscriminatorValue");
const createPhoneFromDiscriminatorValue_1 = require("./createPhoneFromDiscriminatorValue");
const createScoredEmailAddressFromDiscriminatorValue_1 = require("./createScoredEmailAddressFromDiscriminatorValue");
const createWebsiteFromDiscriminatorValue_1 = require("./createWebsiteFromDiscriminatorValue");
const index_1 = require("./index");
class Person extends index_1.Entity {
    /**
     * Instantiates a new person and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the birthday property value. The person's birthday.
     * @returns a string
     */
    get birthday() {
        return this._birthday;
    }
    ;
    /**
     * Sets the birthday property value. The person's birthday.
     * @param value Value to set for the birthday property.
     */
    set birthday(value) {
        this._birthday = value;
    }
    ;
    /**
     * Gets the companyName property value. The name of the person's company.
     * @returns a string
     */
    get companyName() {
        return this._companyName;
    }
    ;
    /**
     * Sets the companyName property value. The name of the person's company.
     * @param value Value to set for the companyName property.
     */
    set companyName(value) {
        this._companyName = value;
    }
    ;
    ;
    /**
     * Gets the department property value. The person's department.
     * @returns a string
     */
    get department() {
        return this._department;
    }
    ;
    /**
     * Sets the department property value. The person's department.
     * @param value Value to set for the department property.
     */
    set department(value) {
        this._department = value;
    }
    ;
    /**
     * Gets the displayName property value. The person's display name.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The person's display name.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "birthday": (o, n) => { o.birthday = n.getStringValue(); }, "companyName": (o, n) => { o.companyName = n.getStringValue(); }, "department": (o, n) => { o.department = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "givenName": (o, n) => { o.givenName = n.getStringValue(); }, "imAddress": (o, n) => { o.imAddress = n.getStringValue(); }, "isFavorite": (o, n) => { o.isFavorite = n.getBooleanValue(); }, "jobTitle": (o, n) => { o.jobTitle = n.getStringValue(); }, "officeLocation": (o, n) => { o.officeLocation = n.getStringValue(); }, "personNotes": (o, n) => { o.personNotes = n.getStringValue(); }, "personType": (o, n) => { o.personType = n.getObjectValue(createPersonTypeFromDiscriminatorValue_1.createPersonTypeFromDiscriminatorValue); }, "phones": (o, n) => { o.phones = n.getCollectionOfObjectValues(createPhoneFromDiscriminatorValue_1.createPhoneFromDiscriminatorValue); }, "postalAddresses": (o, n) => { o.postalAddresses = n.getCollectionOfObjectValues(createLocationFromDiscriminatorValue_1.createLocationFromDiscriminatorValue); }, "profession": (o, n) => { o.profession = n.getStringValue(); }, "scoredEmailAddresses": (o, n) => { o.scoredEmailAddresses = n.getCollectionOfObjectValues(createScoredEmailAddressFromDiscriminatorValue_1.createScoredEmailAddressFromDiscriminatorValue); }, "surname": (o, n) => { o.surname = n.getStringValue(); }, "userPrincipalName": (o, n) => { o.userPrincipalName = n.getStringValue(); }, "websites": (o, n) => { o.websites = n.getCollectionOfObjectValues(createWebsiteFromDiscriminatorValue_1.createWebsiteFromDiscriminatorValue); }, "yomiCompany": (o, n) => { o.yomiCompany = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the givenName property value. The person's given name.
     * @returns a string
     */
    get givenName() {
        return this._givenName;
    }
    ;
    /**
     * Sets the givenName property value. The person's given name.
     * @param value Value to set for the givenName property.
     */
    set givenName(value) {
        this._givenName = value;
    }
    ;
    /**
     * Gets the imAddress property value. The instant message voice over IP (VOIP) session initiation protocol (SIP) address for the user. Read-only.
     * @returns a string
     */
    get imAddress() {
        return this._imAddress;
    }
    ;
    /**
     * Sets the imAddress property value. The instant message voice over IP (VOIP) session initiation protocol (SIP) address for the user. Read-only.
     * @param value Value to set for the imAddress property.
     */
    set imAddress(value) {
        this._imAddress = value;
    }
    ;
    /**
     * Gets the isFavorite property value. true if the user has flagged this person as a favorite.
     * @returns a boolean
     */
    get isFavorite() {
        return this._isFavorite;
    }
    ;
    /**
     * Sets the isFavorite property value. true if the user has flagged this person as a favorite.
     * @param value Value to set for the isFavorite property.
     */
    set isFavorite(value) {
        this._isFavorite = value;
    }
    ;
    /**
     * Gets the jobTitle property value. The person's job title.
     * @returns a string
     */
    get jobTitle() {
        return this._jobTitle;
    }
    ;
    /**
     * Sets the jobTitle property value. The person's job title.
     * @param value Value to set for the jobTitle property.
     */
    set jobTitle(value) {
        this._jobTitle = value;
    }
    ;
    /**
     * Gets the officeLocation property value. The location of the person's office.
     * @returns a string
     */
    get officeLocation() {
        return this._officeLocation;
    }
    ;
    /**
     * Sets the officeLocation property value. The location of the person's office.
     * @param value Value to set for the officeLocation property.
     */
    set officeLocation(value) {
        this._officeLocation = value;
    }
    ;
    /**
     * Gets the personNotes property value. Free-form notes that the user has taken about this person.
     * @returns a string
     */
    get personNotes() {
        return this._personNotes;
    }
    ;
    /**
     * Sets the personNotes property value. Free-form notes that the user has taken about this person.
     * @param value Value to set for the personNotes property.
     */
    set personNotes(value) {
        this._personNotes = value;
    }
    ;
    /**
     * Gets the personType property value. The type of person.
     * @returns a personType
     */
    get personType() {
        return this._personType;
    }
    ;
    /**
     * Sets the personType property value. The type of person.
     * @param value Value to set for the personType property.
     */
    set personType(value) {
        this._personType = value;
    }
    ;
    /**
     * Gets the phones property value. The person's phone numbers.
     * @returns a phone
     */
    get phones() {
        return this._phones;
    }
    ;
    /**
     * Sets the phones property value. The person's phone numbers.
     * @param value Value to set for the phones property.
     */
    set phones(value) {
        this._phones = value;
    }
    ;
    /**
     * Gets the postalAddresses property value. The person's addresses.
     * @returns a location
     */
    get postalAddresses() {
        return this._postalAddresses;
    }
    ;
    /**
     * Sets the postalAddresses property value. The person's addresses.
     * @param value Value to set for the postalAddresses property.
     */
    set postalAddresses(value) {
        this._postalAddresses = value;
    }
    ;
    /**
     * Gets the profession property value. The person's profession.
     * @returns a string
     */
    get profession() {
        return this._profession;
    }
    ;
    /**
     * Sets the profession property value. The person's profession.
     * @param value Value to set for the profession property.
     */
    set profession(value) {
        this._profession = value;
    }
    ;
    /**
     * Gets the scoredEmailAddresses property value. The person's email addresses.
     * @returns a scoredEmailAddress
     */
    get scoredEmailAddresses() {
        return this._scoredEmailAddresses;
    }
    ;
    /**
     * Sets the scoredEmailAddresses property value. The person's email addresses.
     * @param value Value to set for the scoredEmailAddresses property.
     */
    set scoredEmailAddresses(value) {
        this._scoredEmailAddresses = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("birthday", this.birthday);
        writer.writeStringValue("companyName", this.companyName);
        writer.writeStringValue("department", this.department);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeStringValue("givenName", this.givenName);
        writer.writeStringValue("imAddress", this.imAddress);
        writer.writeBooleanValue("isFavorite", this.isFavorite);
        writer.writeStringValue("jobTitle", this.jobTitle);
        writer.writeStringValue("officeLocation", this.officeLocation);
        writer.writeStringValue("personNotes", this.personNotes);
        writer.writeObjectValue("personType", this.personType);
        writer.writeCollectionOfObjectValues("phones", this.phones);
        writer.writeCollectionOfObjectValues("postalAddresses", this.postalAddresses);
        writer.writeStringValue("profession", this.profession);
        writer.writeCollectionOfObjectValues("scoredEmailAddresses", this.scoredEmailAddresses);
        writer.writeStringValue("surname", this.surname);
        writer.writeStringValue("userPrincipalName", this.userPrincipalName);
        writer.writeCollectionOfObjectValues("websites", this.websites);
        writer.writeStringValue("yomiCompany", this.yomiCompany);
    }
    ;
    /**
     * Gets the surname property value. The person's surname.
     * @returns a string
     */
    get surname() {
        return this._surname;
    }
    ;
    /**
     * Sets the surname property value. The person's surname.
     * @param value Value to set for the surname property.
     */
    set surname(value) {
        this._surname = value;
    }
    ;
    /**
     * Gets the userPrincipalName property value. The user principal name (UPN) of the person. The UPN is an Internet-style login name for the person based on the Internet standard RFC 822. By convention, this should map to the person's email name. The general format is alias@domain.
     * @returns a string
     */
    get userPrincipalName() {
        return this._userPrincipalName;
    }
    ;
    /**
     * Sets the userPrincipalName property value. The user principal name (UPN) of the person. The UPN is an Internet-style login name for the person based on the Internet standard RFC 822. By convention, this should map to the person's email name. The general format is alias@domain.
     * @param value Value to set for the userPrincipalName property.
     */
    set userPrincipalName(value) {
        this._userPrincipalName = value;
    }
    ;
    /**
     * Gets the websites property value. The person's websites.
     * @returns a website
     */
    get websites() {
        return this._websites;
    }
    ;
    /**
     * Sets the websites property value. The person's websites.
     * @param value Value to set for the websites property.
     */
    set websites(value) {
        this._websites = value;
    }
    ;
    /**
     * Gets the yomiCompany property value. The phonetic Japanese name of the person's company.
     * @returns a string
     */
    get yomiCompany() {
        return this._yomiCompany;
    }
    ;
    /**
     * Sets the yomiCompany property value. The phonetic Japanese name of the person's company.
     * @param value Value to set for the yomiCompany property.
     */
    set yomiCompany(value) {
        this._yomiCompany = value;
    }
    ;
}
exports.Person = Person;
