"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PersonOrGroupColumn = void 0;
class PersonOrGroupColumn {
    /**
     * Instantiates a new personOrGroupColumn and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the allowMultipleSelection property value. Indicates whether multiple values can be selected from the source.
     * @returns a boolean
     */
    get allowMultipleSelection() {
        return this._allowMultipleSelection;
    }
    ;
    /**
     * Sets the allowMultipleSelection property value. Indicates whether multiple values can be selected from the source.
     * @param value Value to set for the allowMultipleSelection property.
     */
    set allowMultipleSelection(value) {
        this._allowMultipleSelection = value;
    }
    ;
    /**
     * Gets the chooseFromType property value. Whether to allow selection of people only, or people and groups. Must be one of peopleAndGroups or peopleOnly.
     * @returns a string
     */
    get chooseFromType() {
        return this._chooseFromType;
    }
    ;
    /**
     * Sets the chooseFromType property value. Whether to allow selection of people only, or people and groups. Must be one of peopleAndGroups or peopleOnly.
     * @param value Value to set for the chooseFromType property.
     */
    set chooseFromType(value) {
        this._chooseFromType = value;
    }
    ;
    ;
    /**
     * Gets the displayAs property value. How to display the information about the person or group chosen. See below.
     * @returns a string
     */
    get displayAs() {
        return this._displayAs;
    }
    ;
    /**
     * Sets the displayAs property value. How to display the information about the person or group chosen. See below.
     * @param value Value to set for the displayAs property.
     */
    set displayAs(value) {
        this._displayAs = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "allowMultipleSelection": (o, n) => { o.allowMultipleSelection = n.getBooleanValue(); },
            "chooseFromType": (o, n) => { o.chooseFromType = n.getStringValue(); },
            "displayAs": (o, n) => { o.displayAs = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("allowMultipleSelection", this.allowMultipleSelection);
        writer.writeStringValue("chooseFromType", this.chooseFromType);
        writer.writeStringValue("displayAs", this.displayAs);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.PersonOrGroupColumn = PersonOrGroupColumn;
