"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PersonType = void 0;
class PersonType {
    /**
     * Instantiates a new personType and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the class property value. The type of data source, such as Person.
     * @returns a string
     */
    get class_escaped() {
        return this._class_escaped;
    }
    ;
    /**
     * Sets the class property value. The type of data source, such as Person.
     * @param value Value to set for the class_escaped property.
     */
    set class_escaped(value) {
        this._class_escaped = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "class": (o, n) => { o.class_escaped = n.getStringValue(); },
            "subclass": (o, n) => { o.subclass = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("class", this.class_escaped);
        writer.writeStringValue("subclass", this.subclass);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the subclass property value. The secondary type of data source, such as OrganizationUser.
     * @returns a string
     */
    get subclass() {
        return this._subclass;
    }
    ;
    /**
     * Sets the subclass property value. The secondary type of data source, such as OrganizationUser.
     * @param value Value to set for the subclass property.
     */
    set subclass(value) {
        this._subclass = value;
    }
    ;
}
exports.PersonType = PersonType;
