import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class Photo implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Camera manufacturer. Read-only.  */
    private _cameraMake?;
    /** Camera model. Read-only.  */
    private _cameraModel?;
    /** The denominator for the exposure time fraction from the camera. Read-only.  */
    private _exposureDenominator?;
    /** The numerator for the exposure time fraction from the camera. Read-only.  */
    private _exposureNumerator?;
    /** The F-stop value from the camera. Read-only.  */
    private _fNumber?;
    /** The focal length from the camera. Read-only.  */
    private _focalLength?;
    /** The ISO value from the camera. Read-only.  */
    private _iso?;
    /** The orientation value from the camera. Writable on OneDrive Personal.  */
    private _orientation?;
    /** Represents the date and time the photo was taken. Read-only.  */
    private _takenDateTime?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the cameraMake property value. Camera manufacturer. Read-only.
     * @returns a string
     */
    get cameraMake(): string | undefined;
    /**
     * Sets the cameraMake property value. Camera manufacturer. Read-only.
     * @param value Value to set for the cameraMake property.
     */
    set cameraMake(value: string | undefined);
    /**
     * Gets the cameraModel property value. Camera model. Read-only.
     * @returns a string
     */
    get cameraModel(): string | undefined;
    /**
     * Sets the cameraModel property value. Camera model. Read-only.
     * @param value Value to set for the cameraModel property.
     */
    set cameraModel(value: string | undefined);
    /**
     * Instantiates a new photo and sets the default values.
     */
    constructor();
    /**
     * Gets the exposureDenominator property value. The denominator for the exposure time fraction from the camera. Read-only.
     * @returns a double
     */
    get exposureDenominator(): number | undefined;
    /**
     * Sets the exposureDenominator property value. The denominator for the exposure time fraction from the camera. Read-only.
     * @param value Value to set for the exposureDenominator property.
     */
    set exposureDenominator(value: number | undefined);
    /**
     * Gets the exposureNumerator property value. The numerator for the exposure time fraction from the camera. Read-only.
     * @returns a double
     */
    get exposureNumerator(): number | undefined;
    /**
     * Sets the exposureNumerator property value. The numerator for the exposure time fraction from the camera. Read-only.
     * @param value Value to set for the exposureNumerator property.
     */
    set exposureNumerator(value: number | undefined);
    /**
     * Gets the fNumber property value. The F-stop value from the camera. Read-only.
     * @returns a double
     */
    get fNumber(): number | undefined;
    /**
     * Sets the fNumber property value. The F-stop value from the camera. Read-only.
     * @param value Value to set for the fNumber property.
     */
    set fNumber(value: number | undefined);
    /**
     * Gets the focalLength property value. The focal length from the camera. Read-only.
     * @returns a double
     */
    get focalLength(): number | undefined;
    /**
     * Sets the focalLength property value. The focal length from the camera. Read-only.
     * @param value Value to set for the focalLength property.
     */
    set focalLength(value: number | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the iso property value. The ISO value from the camera. Read-only.
     * @returns a integer
     */
    get iso(): number | undefined;
    /**
     * Sets the iso property value. The ISO value from the camera. Read-only.
     * @param value Value to set for the iso property.
     */
    set iso(value: number | undefined);
    /**
     * Gets the orientation property value. The orientation value from the camera. Writable on OneDrive Personal.
     * @returns a integer
     */
    get orientation(): number | undefined;
    /**
     * Sets the orientation property value. The orientation value from the camera. Writable on OneDrive Personal.
     * @param value Value to set for the orientation property.
     */
    set orientation(value: number | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the takenDateTime property value. Represents the date and time the photo was taken. Read-only.
     * @returns a Date
     */
    get takenDateTime(): Date | undefined;
    /**
     * Sets the takenDateTime property value. Represents the date and time the photo was taken. Read-only.
     * @param value Value to set for the takenDateTime property.
     */
    set takenDateTime(value: Date | undefined);
}
