"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Photo = void 0;
class Photo {
    /**
     * Instantiates a new photo and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the cameraMake property value. Camera manufacturer. Read-only.
     * @returns a string
     */
    get cameraMake() {
        return this._cameraMake;
    }
    ;
    /**
     * Sets the cameraMake property value. Camera manufacturer. Read-only.
     * @param value Value to set for the cameraMake property.
     */
    set cameraMake(value) {
        this._cameraMake = value;
    }
    ;
    /**
     * Gets the cameraModel property value. Camera model. Read-only.
     * @returns a string
     */
    get cameraModel() {
        return this._cameraModel;
    }
    ;
    /**
     * Sets the cameraModel property value. Camera model. Read-only.
     * @param value Value to set for the cameraModel property.
     */
    set cameraModel(value) {
        this._cameraModel = value;
    }
    ;
    ;
    /**
     * Gets the exposureDenominator property value. The denominator for the exposure time fraction from the camera. Read-only.
     * @returns a double
     */
    get exposureDenominator() {
        return this._exposureDenominator;
    }
    ;
    /**
     * Sets the exposureDenominator property value. The denominator for the exposure time fraction from the camera. Read-only.
     * @param value Value to set for the exposureDenominator property.
     */
    set exposureDenominator(value) {
        this._exposureDenominator = value;
    }
    ;
    /**
     * Gets the exposureNumerator property value. The numerator for the exposure time fraction from the camera. Read-only.
     * @returns a double
     */
    get exposureNumerator() {
        return this._exposureNumerator;
    }
    ;
    /**
     * Sets the exposureNumerator property value. The numerator for the exposure time fraction from the camera. Read-only.
     * @param value Value to set for the exposureNumerator property.
     */
    set exposureNumerator(value) {
        this._exposureNumerator = value;
    }
    ;
    /**
     * Gets the fNumber property value. The F-stop value from the camera. Read-only.
     * @returns a double
     */
    get fNumber() {
        return this._fNumber;
    }
    ;
    /**
     * Sets the fNumber property value. The F-stop value from the camera. Read-only.
     * @param value Value to set for the fNumber property.
     */
    set fNumber(value) {
        this._fNumber = value;
    }
    ;
    /**
     * Gets the focalLength property value. The focal length from the camera. Read-only.
     * @returns a double
     */
    get focalLength() {
        return this._focalLength;
    }
    ;
    /**
     * Sets the focalLength property value. The focal length from the camera. Read-only.
     * @param value Value to set for the focalLength property.
     */
    set focalLength(value) {
        this._focalLength = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "cameraMake": (o, n) => { o.cameraMake = n.getStringValue(); },
            "cameraModel": (o, n) => { o.cameraModel = n.getStringValue(); },
            "exposureDenominator": (o, n) => { o.exposureDenominator = n.getNumberValue(); },
            "exposureNumerator": (o, n) => { o.exposureNumerator = n.getNumberValue(); },
            "fNumber": (o, n) => { o.fNumber = n.getNumberValue(); },
            "focalLength": (o, n) => { o.focalLength = n.getNumberValue(); },
            "iso": (o, n) => { o.iso = n.getNumberValue(); },
            "orientation": (o, n) => { o.orientation = n.getNumberValue(); },
            "takenDateTime": (o, n) => { o.takenDateTime = n.getDateValue(); },
        };
    }
    ;
    /**
     * Gets the iso property value. The ISO value from the camera. Read-only.
     * @returns a integer
     */
    get iso() {
        return this._iso;
    }
    ;
    /**
     * Sets the iso property value. The ISO value from the camera. Read-only.
     * @param value Value to set for the iso property.
     */
    set iso(value) {
        this._iso = value;
    }
    ;
    /**
     * Gets the orientation property value. The orientation value from the camera. Writable on OneDrive Personal.
     * @returns a integer
     */
    get orientation() {
        return this._orientation;
    }
    ;
    /**
     * Sets the orientation property value. The orientation value from the camera. Writable on OneDrive Personal.
     * @param value Value to set for the orientation property.
     */
    set orientation(value) {
        this._orientation = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("cameraMake", this.cameraMake);
        writer.writeStringValue("cameraModel", this.cameraModel);
        writer.writeNumberValue("exposureDenominator", this.exposureDenominator);
        writer.writeNumberValue("exposureNumerator", this.exposureNumerator);
        writer.writeNumberValue("fNumber", this.fNumber);
        writer.writeNumberValue("focalLength", this.focalLength);
        writer.writeNumberValue("iso", this.iso);
        writer.writeNumberValue("orientation", this.orientation);
        writer.writeDateValue("takenDateTime", this.takenDateTime);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the takenDateTime property value. Represents the date and time the photo was taken. Read-only.
     * @returns a Date
     */
    get takenDateTime() {
        return this._takenDateTime;
    }
    ;
    /**
     * Sets the takenDateTime property value. Represents the date and time the photo was taken. Read-only.
     * @param value Value to set for the takenDateTime property.
     */
    set takenDateTime(value) {
        this._takenDateTime = value;
    }
    ;
}
exports.Photo = Photo;
