"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PhysicalAddress = void 0;
class PhysicalAddress {
    /**
     * Instantiates a new physicalAddress and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the city property value. The city.
     * @returns a string
     */
    get city() {
        return this._city;
    }
    ;
    /**
     * Sets the city property value. The city.
     * @param value Value to set for the city property.
     */
    set city(value) {
        this._city = value;
    }
    ;
    ;
    /**
     * Gets the countryOrRegion property value. The country or region. It's a free-format string value, for example, 'United States'.
     * @returns a string
     */
    get countryOrRegion() {
        return this._countryOrRegion;
    }
    ;
    /**
     * Sets the countryOrRegion property value. The country or region. It's a free-format string value, for example, 'United States'.
     * @param value Value to set for the countryOrRegion property.
     */
    set countryOrRegion(value) {
        this._countryOrRegion = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "city": (o, n) => { o.city = n.getStringValue(); },
            "countryOrRegion": (o, n) => { o.countryOrRegion = n.getStringValue(); },
            "postalCode": (o, n) => { o.postalCode = n.getStringValue(); },
            "state": (o, n) => { o.state = n.getStringValue(); },
            "street": (o, n) => { o.street = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the postalCode property value. The postal code.
     * @returns a string
     */
    get postalCode() {
        return this._postalCode;
    }
    ;
    /**
     * Sets the postalCode property value. The postal code.
     * @param value Value to set for the postalCode property.
     */
    set postalCode(value) {
        this._postalCode = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("city", this.city);
        writer.writeStringValue("countryOrRegion", this.countryOrRegion);
        writer.writeStringValue("postalCode", this.postalCode);
        writer.writeStringValue("state", this.state);
        writer.writeStringValue("street", this.street);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the state property value. The state.
     * @returns a string
     */
    get state() {
        return this._state;
    }
    ;
    /**
     * Sets the state property value. The state.
     * @param value Value to set for the state property.
     */
    set state(value) {
        this._state = value;
    }
    ;
    /**
     * Gets the street property value. The street.
     * @returns a string
     */
    get street() {
        return this._street;
    }
    ;
    /**
     * Sets the street property value. The street.
     * @param value Value to set for the street property.
     */
    set street(value) {
        this._street = value;
    }
    ;
}
exports.PhysicalAddress = PhysicalAddress;
