import { Entity, OutlookGeoCoordinates, PhysicalAddress } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class Place extends Entity implements Parsable {
    /** The street address of the place.  */
    private _address?;
    /** The name associated with the place.  */
    private _displayName?;
    /** Specifies the place location in latitude, longitude and (optionally) altitude coordinates.  */
    private _geoCoordinates?;
    /** The phone number of the place.  */
    private _phone?;
    /**
     * Gets the address property value. The street address of the place.
     * @returns a physicalAddress
     */
    get address(): PhysicalAddress | undefined;
    /**
     * Sets the address property value. The street address of the place.
     * @param value Value to set for the address property.
     */
    set address(value: PhysicalAddress | undefined);
    /**
     * Instantiates a new place and sets the default values.
     */
    constructor();
    /**
     * Gets the displayName property value. The name associated with the place.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. The name associated with the place.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * Gets the geoCoordinates property value. Specifies the place location in latitude, longitude and (optionally) altitude coordinates.
     * @returns a outlookGeoCoordinates
     */
    get geoCoordinates(): OutlookGeoCoordinates | undefined;
    /**
     * Sets the geoCoordinates property value. Specifies the place location in latitude, longitude and (optionally) altitude coordinates.
     * @param value Value to set for the geoCoordinates property.
     */
    set geoCoordinates(value: OutlookGeoCoordinates | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the phone property value. The phone number of the place.
     * @returns a string
     */
    get phone(): string | undefined;
    /**
     * Sets the phone property value. The phone number of the place.
     * @param value Value to set for the phone property.
     */
    set phone(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
