"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Place = void 0;
const createOutlookGeoCoordinatesFromDiscriminatorValue_1 = require("./createOutlookGeoCoordinatesFromDiscriminatorValue");
const createPhysicalAddressFromDiscriminatorValue_1 = require("./createPhysicalAddressFromDiscriminatorValue");
const index_1 = require("./index");
class Place extends index_1.Entity {
    /**
     * Instantiates a new place and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the address property value. The street address of the place.
     * @returns a physicalAddress
     */
    get address() {
        return this._address;
    }
    ;
    /**
     * Sets the address property value. The street address of the place.
     * @param value Value to set for the address property.
     */
    set address(value) {
        this._address = value;
    }
    ;
    ;
    /**
     * Gets the displayName property value. The name associated with the place.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The name associated with the place.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * Gets the geoCoordinates property value. Specifies the place location in latitude, longitude and (optionally) altitude coordinates.
     * @returns a outlookGeoCoordinates
     */
    get geoCoordinates() {
        return this._geoCoordinates;
    }
    ;
    /**
     * Sets the geoCoordinates property value. Specifies the place location in latitude, longitude and (optionally) altitude coordinates.
     * @param value Value to set for the geoCoordinates property.
     */
    set geoCoordinates(value) {
        this._geoCoordinates = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "address": (o, n) => { o.address = n.getObjectValue(createPhysicalAddressFromDiscriminatorValue_1.createPhysicalAddressFromDiscriminatorValue); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "geoCoordinates": (o, n) => { o.geoCoordinates = n.getObjectValue(createOutlookGeoCoordinatesFromDiscriminatorValue_1.createOutlookGeoCoordinatesFromDiscriminatorValue); }, "phone": (o, n) => { o.phone = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the phone property value. The phone number of the place.
     * @returns a string
     */
    get phone() {
        return this._phone;
    }
    ;
    /**
     * Sets the phone property value. The phone number of the place.
     * @param value Value to set for the phone property.
     */
    set phone(value) {
        this._phone = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("address", this.address);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeObjectValue("geoCoordinates", this.geoCoordinates);
        writer.writeStringValue("phone", this.phone);
    }
    ;
}
exports.Place = Place;
