import { Entity, PlannerTask } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class PlannerBucket extends Entity implements Parsable {
    /** Name of the bucket.  */
    private _name?;
    /** Hint used to order items of this type in a list view. The format is defined as outlined here.  */
    private _orderHint?;
    /** Plan ID to which the bucket belongs.  */
    private _planId?;
    /** Read-only. Nullable. The collection of tasks in the bucket.  */
    private _tasks?;
    /**
     * Instantiates a new plannerBucket and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the name property value. Name of the bucket.
     * @returns a string
     */
    get name(): string | undefined;
    /**
     * Sets the name property value. Name of the bucket.
     * @param value Value to set for the name property.
     */
    set name(value: string | undefined);
    /**
     * Gets the orderHint property value. Hint used to order items of this type in a list view. The format is defined as outlined here.
     * @returns a string
     */
    get orderHint(): string | undefined;
    /**
     * Sets the orderHint property value. Hint used to order items of this type in a list view. The format is defined as outlined here.
     * @param value Value to set for the orderHint property.
     */
    set orderHint(value: string | undefined);
    /**
     * Gets the planId property value. Plan ID to which the bucket belongs.
     * @returns a string
     */
    get planId(): string | undefined;
    /**
     * Sets the planId property value. Plan ID to which the bucket belongs.
     * @param value Value to set for the planId property.
     */
    set planId(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the tasks property value. Read-only. Nullable. The collection of tasks in the bucket.
     * @returns a plannerTask
     */
    get tasks(): PlannerTask[] | undefined;
    /**
     * Sets the tasks property value. Read-only. Nullable. The collection of tasks in the bucket.
     * @param value Value to set for the tasks property.
     */
    set tasks(value: PlannerTask[] | undefined);
}
