import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class PlannerCategoryDescriptions implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** The label associated with Category 1  */
    private _category1?;
    /** The label associated with Category 2  */
    private _category2?;
    /** The label associated with Category 3  */
    private _category3?;
    /** The label associated with Category 4  */
    private _category4?;
    /** The label associated with Category 5  */
    private _category5?;
    /** The label associated with Category 6  */
    private _category6?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the category1 property value. The label associated with Category 1
     * @returns a string
     */
    get category1(): string | undefined;
    /**
     * Sets the category1 property value. The label associated with Category 1
     * @param value Value to set for the category1 property.
     */
    set category1(value: string | undefined);
    /**
     * Gets the category2 property value. The label associated with Category 2
     * @returns a string
     */
    get category2(): string | undefined;
    /**
     * Sets the category2 property value. The label associated with Category 2
     * @param value Value to set for the category2 property.
     */
    set category2(value: string | undefined);
    /**
     * Gets the category3 property value. The label associated with Category 3
     * @returns a string
     */
    get category3(): string | undefined;
    /**
     * Sets the category3 property value. The label associated with Category 3
     * @param value Value to set for the category3 property.
     */
    set category3(value: string | undefined);
    /**
     * Gets the category4 property value. The label associated with Category 4
     * @returns a string
     */
    get category4(): string | undefined;
    /**
     * Sets the category4 property value. The label associated with Category 4
     * @param value Value to set for the category4 property.
     */
    set category4(value: string | undefined);
    /**
     * Gets the category5 property value. The label associated with Category 5
     * @returns a string
     */
    get category5(): string | undefined;
    /**
     * Sets the category5 property value. The label associated with Category 5
     * @param value Value to set for the category5 property.
     */
    set category5(value: string | undefined);
    /**
     * Gets the category6 property value. The label associated with Category 6
     * @returns a string
     */
    get category6(): string | undefined;
    /**
     * Sets the category6 property value. The label associated with Category 6
     * @param value Value to set for the category6 property.
     */
    set category6(value: string | undefined);
    /**
     * Instantiates a new plannerCategoryDescriptions and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
