import { Entity, IdentitySet, PlannerBucket, PlannerPlanDetails, PlannerTask } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class PlannerPlan extends Entity implements Parsable {
    /** Read-only. Nullable. Collection of buckets in the plan.  */
    private _buckets?;
    /** Read-only. The user who created the plan.  */
    private _createdBy?;
    /** Read-only. Date and time at which the plan is created. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z  */
    private _createdDateTime?;
    /** Read-only. Nullable. Additional details about the plan.  */
    private _details?;
    /** ID of the Group that owns the plan. A valid group must exist before this field can be set. After it is set, this property can’t be updated.  */
    private _owner?;
    /** Read-only. Nullable. Collection of tasks in the plan.  */
    private _tasks?;
    /** Required. Title of the plan.  */
    private _title?;
    /**
     * Gets the buckets property value. Read-only. Nullable. Collection of buckets in the plan.
     * @returns a plannerBucket
     */
    get buckets(): PlannerBucket[] | undefined;
    /**
     * Sets the buckets property value. Read-only. Nullable. Collection of buckets in the plan.
     * @param value Value to set for the buckets property.
     */
    set buckets(value: PlannerBucket[] | undefined);
    /**
     * Instantiates a new plannerPlan and sets the default values.
     */
    constructor();
    /**
     * Gets the createdBy property value. Read-only. The user who created the plan.
     * @returns a identitySet
     */
    get createdBy(): IdentitySet | undefined;
    /**
     * Sets the createdBy property value. Read-only. The user who created the plan.
     * @param value Value to set for the createdBy property.
     */
    set createdBy(value: IdentitySet | undefined);
    /**
     * Gets the createdDateTime property value. Read-only. Date and time at which the plan is created. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @returns a Date
     */
    get createdDateTime(): Date | undefined;
    /**
     * Sets the createdDateTime property value. Read-only. Date and time at which the plan is created. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value: Date | undefined);
    /**
     * Gets the details property value. Read-only. Nullable. Additional details about the plan.
     * @returns a plannerPlanDetails
     */
    get details(): PlannerPlanDetails | undefined;
    /**
     * Sets the details property value. Read-only. Nullable. Additional details about the plan.
     * @param value Value to set for the details property.
     */
    set details(value: PlannerPlanDetails | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the owner property value. ID of the Group that owns the plan. A valid group must exist before this field can be set. After it is set, this property can’t be updated.
     * @returns a string
     */
    get owner(): string | undefined;
    /**
     * Sets the owner property value. ID of the Group that owns the plan. A valid group must exist before this field can be set. After it is set, this property can’t be updated.
     * @param value Value to set for the owner property.
     */
    set owner(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the tasks property value. Read-only. Nullable. Collection of tasks in the plan.
     * @returns a plannerTask
     */
    get tasks(): PlannerTask[] | undefined;
    /**
     * Sets the tasks property value. Read-only. Nullable. Collection of tasks in the plan.
     * @param value Value to set for the tasks property.
     */
    set tasks(value: PlannerTask[] | undefined);
    /**
     * Gets the title property value. Required. Title of the plan.
     * @returns a string
     */
    get title(): string | undefined;
    /**
     * Sets the title property value. Required. Title of the plan.
     * @param value Value to set for the title property.
     */
    set title(value: string | undefined);
}
