"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PlannerPlan = void 0;
const createIdentitySetFromDiscriminatorValue_1 = require("./createIdentitySetFromDiscriminatorValue");
const createPlannerBucketFromDiscriminatorValue_1 = require("./createPlannerBucketFromDiscriminatorValue");
const createPlannerPlanDetailsFromDiscriminatorValue_1 = require("./createPlannerPlanDetailsFromDiscriminatorValue");
const createPlannerTaskFromDiscriminatorValue_1 = require("./createPlannerTaskFromDiscriminatorValue");
const index_1 = require("./index");
class PlannerPlan extends index_1.Entity {
    /**
     * Instantiates a new plannerPlan and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the buckets property value. Read-only. Nullable. Collection of buckets in the plan.
     * @returns a plannerBucket
     */
    get buckets() {
        return this._buckets;
    }
    ;
    /**
     * Sets the buckets property value. Read-only. Nullable. Collection of buckets in the plan.
     * @param value Value to set for the buckets property.
     */
    set buckets(value) {
        this._buckets = value;
    }
    ;
    ;
    /**
     * Gets the createdBy property value. Read-only. The user who created the plan.
     * @returns a identitySet
     */
    get createdBy() {
        return this._createdBy;
    }
    ;
    /**
     * Sets the createdBy property value. Read-only. The user who created the plan.
     * @param value Value to set for the createdBy property.
     */
    set createdBy(value) {
        this._createdBy = value;
    }
    ;
    /**
     * Gets the createdDateTime property value. Read-only. Date and time at which the plan is created. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. Read-only. Date and time at which the plan is created. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * Gets the details property value. Read-only. Nullable. Additional details about the plan.
     * @returns a plannerPlanDetails
     */
    get details() {
        return this._details;
    }
    ;
    /**
     * Sets the details property value. Read-only. Nullable. Additional details about the plan.
     * @param value Value to set for the details property.
     */
    set details(value) {
        this._details = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "buckets": (o, n) => { o.buckets = n.getCollectionOfObjectValues(createPlannerBucketFromDiscriminatorValue_1.createPlannerBucketFromDiscriminatorValue); }, "createdBy": (o, n) => { o.createdBy = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); }, "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); }, "details": (o, n) => { o.details = n.getObjectValue(createPlannerPlanDetailsFromDiscriminatorValue_1.createPlannerPlanDetailsFromDiscriminatorValue); }, "owner": (o, n) => { o.owner = n.getStringValue(); }, "tasks": (o, n) => { o.tasks = n.getCollectionOfObjectValues(createPlannerTaskFromDiscriminatorValue_1.createPlannerTaskFromDiscriminatorValue); }, "title": (o, n) => { o.title = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the owner property value. ID of the Group that owns the plan. A valid group must exist before this field can be set. After it is set, this property can’t be updated.
     * @returns a string
     */
    get owner() {
        return this._owner;
    }
    ;
    /**
     * Sets the owner property value. ID of the Group that owns the plan. A valid group must exist before this field can be set. After it is set, this property can’t be updated.
     * @param value Value to set for the owner property.
     */
    set owner(value) {
        this._owner = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("buckets", this.buckets);
        writer.writeObjectValue("createdBy", this.createdBy);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeObjectValue("details", this.details);
        writer.writeStringValue("owner", this.owner);
        writer.writeCollectionOfObjectValues("tasks", this.tasks);
        writer.writeStringValue("title", this.title);
    }
    ;
    /**
     * Gets the tasks property value. Read-only. Nullable. Collection of tasks in the plan.
     * @returns a plannerTask
     */
    get tasks() {
        return this._tasks;
    }
    ;
    /**
     * Sets the tasks property value. Read-only. Nullable. Collection of tasks in the plan.
     * @param value Value to set for the tasks property.
     */
    set tasks(value) {
        this._tasks = value;
    }
    ;
    /**
     * Gets the title property value. Required. Title of the plan.
     * @returns a string
     */
    get title() {
        return this._title;
    }
    ;
    /**
     * Sets the title property value. Required. Title of the plan.
     * @param value Value to set for the title property.
     */
    set title(value) {
        this._title = value;
    }
    ;
}
exports.PlannerPlan = PlannerPlan;
