import { Entity, PlannerCategoryDescriptions, PlannerUserIds } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class PlannerPlanDetails extends Entity implements Parsable {
    /** An object that specifies the descriptions of the six categories that can be associated with tasks in the plan  */
    private _categoryDescriptions?;
    /** Set of user ids that this plan is shared with. If you are leveraging Microsoft 365 groups, use the Groups API to manage group membership to share the group's plan. You can also add existing members of the group to this collection though it is not required for them to access the plan owned by the group.  */
    private _sharedWith?;
    /**
     * Gets the categoryDescriptions property value. An object that specifies the descriptions of the six categories that can be associated with tasks in the plan
     * @returns a plannerCategoryDescriptions
     */
    get categoryDescriptions(): PlannerCategoryDescriptions | undefined;
    /**
     * Sets the categoryDescriptions property value. An object that specifies the descriptions of the six categories that can be associated with tasks in the plan
     * @param value Value to set for the categoryDescriptions property.
     */
    set categoryDescriptions(value: PlannerCategoryDescriptions | undefined);
    /**
     * Instantiates a new plannerPlanDetails and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the sharedWith property value. Set of user ids that this plan is shared with. If you are leveraging Microsoft 365 groups, use the Groups API to manage group membership to share the group's plan. You can also add existing members of the group to this collection though it is not required for them to access the plan owned by the group.
     * @returns a plannerUserIds
     */
    get sharedWith(): PlannerUserIds | undefined;
    /**
     * Sets the sharedWith property value. Set of user ids that this plan is shared with. If you are leveraging Microsoft 365 groups, use the Groups API to manage group membership to share the group's plan. You can also add existing members of the group to this collection though it is not required for them to access the plan owned by the group.
     * @param value Value to set for the sharedWith property.
     */
    set sharedWith(value: PlannerUserIds | undefined);
}
