"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PlannerPlanDetails = void 0;
const createPlannerCategoryDescriptionsFromDiscriminatorValue_1 = require("./createPlannerCategoryDescriptionsFromDiscriminatorValue");
const createPlannerUserIdsFromDiscriminatorValue_1 = require("./createPlannerUserIdsFromDiscriminatorValue");
const index_1 = require("./index");
class PlannerPlanDetails extends index_1.Entity {
    /**
     * Instantiates a new plannerPlanDetails and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the categoryDescriptions property value. An object that specifies the descriptions of the six categories that can be associated with tasks in the plan
     * @returns a plannerCategoryDescriptions
     */
    get categoryDescriptions() {
        return this._categoryDescriptions;
    }
    ;
    /**
     * Sets the categoryDescriptions property value. An object that specifies the descriptions of the six categories that can be associated with tasks in the plan
     * @param value Value to set for the categoryDescriptions property.
     */
    set categoryDescriptions(value) {
        this._categoryDescriptions = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "categoryDescriptions": (o, n) => { o.categoryDescriptions = n.getObjectValue(createPlannerCategoryDescriptionsFromDiscriminatorValue_1.createPlannerCategoryDescriptionsFromDiscriminatorValue); }, "sharedWith": (o, n) => { o.sharedWith = n.getObjectValue(createPlannerUserIdsFromDiscriminatorValue_1.createPlannerUserIdsFromDiscriminatorValue); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("categoryDescriptions", this.categoryDescriptions);
        writer.writeObjectValue("sharedWith", this.sharedWith);
    }
    ;
    /**
     * Gets the sharedWith property value. Set of user ids that this plan is shared with. If you are leveraging Microsoft 365 groups, use the Groups API to manage group membership to share the group's plan. You can also add existing members of the group to this collection though it is not required for them to access the plan owned by the group.
     * @returns a plannerUserIds
     */
    get sharedWith() {
        return this._sharedWith;
    }
    ;
    /**
     * Sets the sharedWith property value. Set of user ids that this plan is shared with. If you are leveraging Microsoft 365 groups, use the Groups API to manage group membership to share the group's plan. You can also add existing members of the group to this collection though it is not required for them to access the plan owned by the group.
     * @param value Value to set for the sharedWith property.
     */
    set sharedWith(value) {
        this._sharedWith = value;
    }
    ;
}
exports.PlannerPlanDetails = PlannerPlanDetails;
