import { Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class PlannerProgressTaskBoardTaskFormat extends Entity implements Parsable {
    /** Hint value used to order the task on the Progress view of the Task Board. The format is defined as outlined here.  */
    private _orderHint?;
    /**
     * Instantiates a new plannerProgressTaskBoardTaskFormat and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the orderHint property value. Hint value used to order the task on the Progress view of the Task Board. The format is defined as outlined here.
     * @returns a string
     */
    get orderHint(): string | undefined;
    /**
     * Sets the orderHint property value. Hint value used to order the task on the Progress view of the Task Board. The format is defined as outlined here.
     * @param value Value to set for the orderHint property.
     */
    set orderHint(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
