import { Entity, PlannerChecklistItems, PlannerExternalReferences } from './index';
import { PlannerPreviewType } from './plannerPreviewType';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class PlannerTaskDetails extends Entity implements Parsable {
    /** The collection of checklist items on the task.  */
    private _checklist?;
    /** Description of the task.  */
    private _description?;
    /** This sets the type of preview that shows up on the task. The possible values are: automatic, noPreview, checklist, description, reference. When set to automatic the displayed preview is chosen by the app viewing the task.  */
    private _previewType?;
    /** The collection of references on the task.  */
    private _references?;
    /**
     * Gets the checklist property value. The collection of checklist items on the task.
     * @returns a plannerChecklistItems
     */
    get checklist(): PlannerChecklistItems | undefined;
    /**
     * Sets the checklist property value. The collection of checklist items on the task.
     * @param value Value to set for the checklist property.
     */
    set checklist(value: PlannerChecklistItems | undefined);
    /**
     * Instantiates a new plannerTaskDetails and sets the default values.
     */
    constructor();
    /**
     * Gets the description property value. Description of the task.
     * @returns a string
     */
    get description(): string | undefined;
    /**
     * Sets the description property value. Description of the task.
     * @param value Value to set for the description property.
     */
    set description(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the previewType property value. This sets the type of preview that shows up on the task. The possible values are: automatic, noPreview, checklist, description, reference. When set to automatic the displayed preview is chosen by the app viewing the task.
     * @returns a plannerPreviewType
     */
    get previewType(): PlannerPreviewType | undefined;
    /**
     * Sets the previewType property value. This sets the type of preview that shows up on the task. The possible values are: automatic, noPreview, checklist, description, reference. When set to automatic the displayed preview is chosen by the app viewing the task.
     * @param value Value to set for the previewType property.
     */
    set previewType(value: PlannerPreviewType | undefined);
    /**
     * Gets the references property value. The collection of references on the task.
     * @returns a plannerExternalReferences
     */
    get references(): PlannerExternalReferences | undefined;
    /**
     * Sets the references property value. The collection of references on the task.
     * @param value Value to set for the references property.
     */
    set references(value: PlannerExternalReferences | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
