"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PlannerUser = void 0;
const createPlannerPlanFromDiscriminatorValue_1 = require("./createPlannerPlanFromDiscriminatorValue");
const createPlannerTaskFromDiscriminatorValue_1 = require("./createPlannerTaskFromDiscriminatorValue");
const index_1 = require("./index");
class PlannerUser extends index_1.Entity {
    /**
     * Instantiates a new plannerUser and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "plans": (o, n) => { o.plans = n.getCollectionOfObjectValues(createPlannerPlanFromDiscriminatorValue_1.createPlannerPlanFromDiscriminatorValue); }, "tasks": (o, n) => { o.tasks = n.getCollectionOfObjectValues(createPlannerTaskFromDiscriminatorValue_1.createPlannerTaskFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the plans property value. Read-only. Nullable. Returns the plannerTasks assigned to the user.
     * @returns a plannerPlan
     */
    get plans() {
        return this._plans;
    }
    ;
    /**
     * Sets the plans property value. Read-only. Nullable. Returns the plannerTasks assigned to the user.
     * @param value Value to set for the plans property.
     */
    set plans(value) {
        this._plans = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("plans", this.plans);
        writer.writeCollectionOfObjectValues("tasks", this.tasks);
    }
    ;
    /**
     * Gets the tasks property value. Read-only. Nullable. Returns the plannerPlans shared with the user.
     * @returns a plannerTask
     */
    get tasks() {
        return this._tasks;
    }
    ;
    /**
     * Sets the tasks property value. Read-only. Nullable. Returns the plannerPlans shared with the user.
     * @param value Value to set for the tasks property.
     */
    set tasks(value) {
        this._tasks = value;
    }
    ;
}
exports.PlannerUser = PlannerUser;
