"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Post = void 0;
const createAttachmentFromDiscriminatorValue_1 = require("./createAttachmentFromDiscriminatorValue");
const createExtensionFromDiscriminatorValue_1 = require("./createExtensionFromDiscriminatorValue");
const createItemBodyFromDiscriminatorValue_1 = require("./createItemBodyFromDiscriminatorValue");
const createMultiValueLegacyExtendedPropertyFromDiscriminatorValue_1 = require("./createMultiValueLegacyExtendedPropertyFromDiscriminatorValue");
const createPostFromDiscriminatorValue_1 = require("./createPostFromDiscriminatorValue");
const createRecipientFromDiscriminatorValue_1 = require("./createRecipientFromDiscriminatorValue");
const createSingleValueLegacyExtendedPropertyFromDiscriminatorValue_1 = require("./createSingleValueLegacyExtendedPropertyFromDiscriminatorValue");
const index_1 = require("./index");
class Post extends index_1.OutlookItem {
    /**
     * Instantiates a new post and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the attachments property value. Read-only. Nullable. Supports $expand.
     * @returns a attachment
     */
    get attachments() {
        return this._attachments;
    }
    ;
    /**
     * Sets the attachments property value. Read-only. Nullable. Supports $expand.
     * @param value Value to set for the attachments property.
     */
    set attachments(value) {
        this._attachments = value;
    }
    ;
    /**
     * Gets the body property value. The contents of the post. This is a default property. This property can be null.
     * @returns a itemBody
     */
    get body() {
        return this._body;
    }
    ;
    /**
     * Sets the body property value. The contents of the post. This is a default property. This property can be null.
     * @param value Value to set for the body property.
     */
    set body(value) {
        this._body = value;
    }
    ;
    ;
    /**
     * Gets the conversationId property value. Unique ID of the conversation. Read-only.
     * @returns a string
     */
    get conversationId() {
        return this._conversationId;
    }
    ;
    /**
     * Sets the conversationId property value. Unique ID of the conversation. Read-only.
     * @param value Value to set for the conversationId property.
     */
    set conversationId(value) {
        this._conversationId = value;
    }
    ;
    /**
     * Gets the conversationThreadId property value. Unique ID of the conversation thread. Read-only.
     * @returns a string
     */
    get conversationThreadId() {
        return this._conversationThreadId;
    }
    ;
    /**
     * Sets the conversationThreadId property value. Unique ID of the conversation thread. Read-only.
     * @param value Value to set for the conversationThreadId property.
     */
    set conversationThreadId(value) {
        this._conversationThreadId = value;
    }
    ;
    /**
     * Gets the extensions property value. The collection of open extensions defined for the post. Read-only. Nullable. Supports $expand.
     * @returns a extension
     */
    get extensions() {
        return this._extensions;
    }
    ;
    /**
     * Sets the extensions property value. The collection of open extensions defined for the post. Read-only. Nullable. Supports $expand.
     * @param value Value to set for the extensions property.
     */
    set extensions(value) {
        this._extensions = value;
    }
    ;
    /**
     * Gets the from property value.
     * @returns a recipient
     */
    get from() {
        return this._from;
    }
    ;
    /**
     * Sets the from property value.
     * @param value Value to set for the from property.
     */
    set from(value) {
        this._from = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "attachments": (o, n) => { o.attachments = n.getCollectionOfObjectValues(createAttachmentFromDiscriminatorValue_1.createAttachmentFromDiscriminatorValue); }, "body": (o, n) => { o.body = n.getObjectValue(createItemBodyFromDiscriminatorValue_1.createItemBodyFromDiscriminatorValue); }, "conversationId": (o, n) => { o.conversationId = n.getStringValue(); }, "conversationThreadId": (o, n) => { o.conversationThreadId = n.getStringValue(); }, "extensions": (o, n) => { o.extensions = n.getCollectionOfObjectValues(createExtensionFromDiscriminatorValue_1.createExtensionFromDiscriminatorValue); }, "from": (o, n) => { o.from = n.getObjectValue(createRecipientFromDiscriminatorValue_1.createRecipientFromDiscriminatorValue); }, "hasAttachments": (o, n) => { o.hasAttachments = n.getBooleanValue(); }, "inReplyTo": (o, n) => { o.inReplyTo = n.getObjectValue(createPostFromDiscriminatorValue_1.createPostFromDiscriminatorValue); }, "multiValueExtendedProperties": (o, n) => { o.multiValueExtendedProperties = n.getCollectionOfObjectValues(createMultiValueLegacyExtendedPropertyFromDiscriminatorValue_1.createMultiValueLegacyExtendedPropertyFromDiscriminatorValue); }, "newParticipants": (o, n) => { o.newParticipants = n.getCollectionOfObjectValues(createRecipientFromDiscriminatorValue_1.createRecipientFromDiscriminatorValue); }, "receivedDateTime": (o, n) => { o.receivedDateTime = n.getDateValue(); }, "sender": (o, n) => { o.sender = n.getObjectValue(createRecipientFromDiscriminatorValue_1.createRecipientFromDiscriminatorValue); }, "singleValueExtendedProperties": (o, n) => { o.singleValueExtendedProperties = n.getCollectionOfObjectValues(createSingleValueLegacyExtendedPropertyFromDiscriminatorValue_1.createSingleValueLegacyExtendedPropertyFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the hasAttachments property value. Indicates whether the post has at least one attachment. This is a default property.
     * @returns a boolean
     */
    get hasAttachments() {
        return this._hasAttachments;
    }
    ;
    /**
     * Sets the hasAttachments property value. Indicates whether the post has at least one attachment. This is a default property.
     * @param value Value to set for the hasAttachments property.
     */
    set hasAttachments(value) {
        this._hasAttachments = value;
    }
    ;
    /**
     * Gets the inReplyTo property value. Read-only. Supports $expand.
     * @returns a post
     */
    get inReplyTo() {
        return this._inReplyTo;
    }
    ;
    /**
     * Sets the inReplyTo property value. Read-only. Supports $expand.
     * @param value Value to set for the inReplyTo property.
     */
    set inReplyTo(value) {
        this._inReplyTo = value;
    }
    ;
    /**
     * Gets the multiValueExtendedProperties property value. The collection of multi-value extended properties defined for the post. Read-only. Nullable.
     * @returns a multiValueLegacyExtendedProperty
     */
    get multiValueExtendedProperties() {
        return this._multiValueExtendedProperties;
    }
    ;
    /**
     * Sets the multiValueExtendedProperties property value. The collection of multi-value extended properties defined for the post. Read-only. Nullable.
     * @param value Value to set for the multiValueExtendedProperties property.
     */
    set multiValueExtendedProperties(value) {
        this._multiValueExtendedProperties = value;
    }
    ;
    /**
     * Gets the newParticipants property value. Conversation participants that were added to the thread as part of this post.
     * @returns a recipient
     */
    get newParticipants() {
        return this._newParticipants;
    }
    ;
    /**
     * Sets the newParticipants property value. Conversation participants that were added to the thread as part of this post.
     * @param value Value to set for the newParticipants property.
     */
    set newParticipants(value) {
        this._newParticipants = value;
    }
    ;
    /**
     * Gets the receivedDateTime property value. Specifies when the post was received. The DateTimeOffset type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @returns a Date
     */
    get receivedDateTime() {
        return this._receivedDateTime;
    }
    ;
    /**
     * Sets the receivedDateTime property value. Specifies when the post was received. The DateTimeOffset type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @param value Value to set for the receivedDateTime property.
     */
    set receivedDateTime(value) {
        this._receivedDateTime = value;
    }
    ;
    /**
     * Gets the sender property value. Contains the address of the sender. The value of Sender is assumed to be the address of the authenticated user in the case when Sender is not specified. This is a default property.
     * @returns a recipient
     */
    get sender() {
        return this._sender;
    }
    ;
    /**
     * Sets the sender property value. Contains the address of the sender. The value of Sender is assumed to be the address of the authenticated user in the case when Sender is not specified. This is a default property.
     * @param value Value to set for the sender property.
     */
    set sender(value) {
        this._sender = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("attachments", this.attachments);
        writer.writeObjectValue("body", this.body);
        writer.writeStringValue("conversationId", this.conversationId);
        writer.writeStringValue("conversationThreadId", this.conversationThreadId);
        writer.writeCollectionOfObjectValues("extensions", this.extensions);
        writer.writeObjectValue("from", this.from);
        writer.writeBooleanValue("hasAttachments", this.hasAttachments);
        writer.writeObjectValue("inReplyTo", this.inReplyTo);
        writer.writeCollectionOfObjectValues("multiValueExtendedProperties", this.multiValueExtendedProperties);
        writer.writeCollectionOfObjectValues("newParticipants", this.newParticipants);
        writer.writeDateValue("receivedDateTime", this.receivedDateTime);
        writer.writeObjectValue("sender", this.sender);
        writer.writeCollectionOfObjectValues("singleValueExtendedProperties", this.singleValueExtendedProperties);
    }
    ;
    /**
     * Gets the singleValueExtendedProperties property value. The collection of single-value extended properties defined for the post. Read-only. Nullable.
     * @returns a singleValueLegacyExtendedProperty
     */
    get singleValueExtendedProperties() {
        return this._singleValueExtendedProperties;
    }
    ;
    /**
     * Sets the singleValueExtendedProperties property value. The collection of single-value extended properties defined for the post. Read-only. Nullable.
     * @param value Value to set for the singleValueExtendedProperties property.
     */
    set singleValueExtendedProperties(value) {
        this._singleValueExtendedProperties = value;
    }
    ;
}
exports.Post = Post;
