"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PreAuthorizedApplication = void 0;
class PreAuthorizedApplication {
    /**
     * Instantiates a new preAuthorizedApplication and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the appId property value. The unique identifier for the application.
     * @returns a string
     */
    get appId() {
        return this._appId;
    }
    ;
    /**
     * Sets the appId property value. The unique identifier for the application.
     * @param value Value to set for the appId property.
     */
    set appId(value) {
        this._appId = value;
    }
    ;
    ;
    /**
     * Gets the delegatedPermissionIds property value. The unique identifier for the oauth2PermissionScopes the application requires.
     * @returns a string
     */
    get delegatedPermissionIds() {
        return this._delegatedPermissionIds;
    }
    ;
    /**
     * Sets the delegatedPermissionIds property value. The unique identifier for the oauth2PermissionScopes the application requires.
     * @param value Value to set for the delegatedPermissionIds property.
     */
    set delegatedPermissionIds(value) {
        this._delegatedPermissionIds = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "appId": (o, n) => { o.appId = n.getStringValue(); },
            "delegatedPermissionIds": (o, n) => { o.delegatedPermissionIds = n.getCollectionOfPrimitiveValues(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("appId", this.appId);
        writer.writeCollectionOfPrimitiveValues("delegatedPermissionIds", this.delegatedPermissionIds);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.PreAuthorizedApplication = PreAuthorizedApplication;
