import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class PrintCertificateSigningRequest implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** A base64-encoded pkcs10 certificate request. Read-only.  */
    private _content?;
    /** The base64-encoded public portion of an asymmetric key that is generated by the client. Read-only.  */
    private _transportKey?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new printCertificateSigningRequest and sets the default values.
     */
    constructor();
    /**
     * Gets the content property value. A base64-encoded pkcs10 certificate request. Read-only.
     * @returns a string
     */
    get content(): string | undefined;
    /**
     * Sets the content property value. A base64-encoded pkcs10 certificate request. Read-only.
     * @param value Value to set for the content property.
     */
    set content(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the transportKey property value. The base64-encoded public portion of an asymmetric key that is generated by the client. Read-only.
     * @returns a string
     */
    get transportKey(): string | undefined;
    /**
     * Sets the transportKey property value. The base64-encoded public portion of an asymmetric key that is generated by the client. Read-only.
     * @param value Value to set for the transportKey property.
     */
    set transportKey(value: string | undefined);
}
