import { Entity, PrinterLocation } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class PrintConnector extends Entity implements Parsable {
    /** The connector's version.  */
    private _appVersion?;
    /** The name of the connector.  */
    private _displayName?;
    /** The connector machine's hostname.  */
    private _fullyQualifiedDomainName?;
    /** The physical and/or organizational location of the connector.  */
    private _location?;
    /** The connector machine's operating system version.  */
    private _operatingSystem?;
    /** The DateTimeOffset when the connector was registered.  */
    private _registeredDateTime?;
    /**
     * Gets the appVersion property value. The connector's version.
     * @returns a string
     */
    get appVersion(): string | undefined;
    /**
     * Sets the appVersion property value. The connector's version.
     * @param value Value to set for the appVersion property.
     */
    set appVersion(value: string | undefined);
    /**
     * Instantiates a new printConnector and sets the default values.
     */
    constructor();
    /**
     * Gets the displayName property value. The name of the connector.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. The name of the connector.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * Gets the fullyQualifiedDomainName property value. The connector machine's hostname.
     * @returns a string
     */
    get fullyQualifiedDomainName(): string | undefined;
    /**
     * Sets the fullyQualifiedDomainName property value. The connector machine's hostname.
     * @param value Value to set for the fullyQualifiedDomainName property.
     */
    set fullyQualifiedDomainName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the location property value. The physical and/or organizational location of the connector.
     * @returns a printerLocation
     */
    get location(): PrinterLocation | undefined;
    /**
     * Sets the location property value. The physical and/or organizational location of the connector.
     * @param value Value to set for the location property.
     */
    set location(value: PrinterLocation | undefined);
    /**
     * Gets the operatingSystem property value. The connector machine's operating system version.
     * @returns a string
     */
    get operatingSystem(): string | undefined;
    /**
     * Sets the operatingSystem property value. The connector machine's operating system version.
     * @param value Value to set for the operatingSystem property.
     */
    set operatingSystem(value: string | undefined);
    /**
     * Gets the registeredDateTime property value. The DateTimeOffset when the connector was registered.
     * @returns a Date
     */
    get registeredDateTime(): Date | undefined;
    /**
     * Sets the registeredDateTime property value. The DateTimeOffset when the connector was registered.
     * @param value Value to set for the registeredDateTime property.
     */
    set registeredDateTime(value: Date | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
