"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrintJob = void 0;
const createPrintDocumentFromDiscriminatorValue_1 = require("./createPrintDocumentFromDiscriminatorValue");
const createPrintJobConfigurationFromDiscriminatorValue_1 = require("./createPrintJobConfigurationFromDiscriminatorValue");
const createPrintJobStatusFromDiscriminatorValue_1 = require("./createPrintJobStatusFromDiscriminatorValue");
const createPrintTaskFromDiscriminatorValue_1 = require("./createPrintTaskFromDiscriminatorValue");
const createUserIdentityFromDiscriminatorValue_1 = require("./createUserIdentityFromDiscriminatorValue");
const index_1 = require("./index");
class PrintJob extends index_1.Entity {
    /**
     * Instantiates a new printJob and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the configuration property value.
     * @returns a printJobConfiguration
     */
    get configuration() {
        return this._configuration;
    }
    ;
    /**
     * Sets the configuration property value.
     * @param value Value to set for the configuration property.
     */
    set configuration(value) {
        this._configuration = value;
    }
    ;
    ;
    /**
     * Gets the createdBy property value. Read-only. Nullable.
     * @returns a userIdentity
     */
    get createdBy() {
        return this._createdBy;
    }
    ;
    /**
     * Sets the createdBy property value. Read-only. Nullable.
     * @param value Value to set for the createdBy property.
     */
    set createdBy(value) {
        this._createdBy = value;
    }
    ;
    /**
     * Gets the createdDateTime property value. The DateTimeOffset when the job was created. Read-only.
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. The DateTimeOffset when the job was created. Read-only.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * Gets the documents property value. Read-only.
     * @returns a printDocument
     */
    get documents() {
        return this._documents;
    }
    ;
    /**
     * Sets the documents property value. Read-only.
     * @param value Value to set for the documents property.
     */
    set documents(value) {
        this._documents = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "configuration": (o, n) => { o.configuration = n.getObjectValue(createPrintJobConfigurationFromDiscriminatorValue_1.createPrintJobConfigurationFromDiscriminatorValue); }, "createdBy": (o, n) => { o.createdBy = n.getObjectValue(createUserIdentityFromDiscriminatorValue_1.createUserIdentityFromDiscriminatorValue); }, "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); }, "documents": (o, n) => { o.documents = n.getCollectionOfObjectValues(createPrintDocumentFromDiscriminatorValue_1.createPrintDocumentFromDiscriminatorValue); }, "isFetchable": (o, n) => { o.isFetchable = n.getBooleanValue(); }, "redirectedFrom": (o, n) => { o.redirectedFrom = n.getStringValue(); }, "redirectedTo": (o, n) => { o.redirectedTo = n.getStringValue(); }, "status": (o, n) => { o.status = n.getObjectValue(createPrintJobStatusFromDiscriminatorValue_1.createPrintJobStatusFromDiscriminatorValue); }, "tasks": (o, n) => { o.tasks = n.getCollectionOfObjectValues(createPrintTaskFromDiscriminatorValue_1.createPrintTaskFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the isFetchable property value. If true, document can be fetched by printer.
     * @returns a boolean
     */
    get isFetchable() {
        return this._isFetchable;
    }
    ;
    /**
     * Sets the isFetchable property value. If true, document can be fetched by printer.
     * @param value Value to set for the isFetchable property.
     */
    set isFetchable(value) {
        this._isFetchable = value;
    }
    ;
    /**
     * Gets the redirectedFrom property value. Contains the source job URL, if the job has been redirected from another printer.
     * @returns a string
     */
    get redirectedFrom() {
        return this._redirectedFrom;
    }
    ;
    /**
     * Sets the redirectedFrom property value. Contains the source job URL, if the job has been redirected from another printer.
     * @param value Value to set for the redirectedFrom property.
     */
    set redirectedFrom(value) {
        this._redirectedFrom = value;
    }
    ;
    /**
     * Gets the redirectedTo property value. Contains the destination job URL, if the job has been redirected to another printer.
     * @returns a string
     */
    get redirectedTo() {
        return this._redirectedTo;
    }
    ;
    /**
     * Sets the redirectedTo property value. Contains the destination job URL, if the job has been redirected to another printer.
     * @param value Value to set for the redirectedTo property.
     */
    set redirectedTo(value) {
        this._redirectedTo = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("configuration", this.configuration);
        writer.writeObjectValue("createdBy", this.createdBy);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeCollectionOfObjectValues("documents", this.documents);
        writer.writeBooleanValue("isFetchable", this.isFetchable);
        writer.writeStringValue("redirectedFrom", this.redirectedFrom);
        writer.writeStringValue("redirectedTo", this.redirectedTo);
        writer.writeObjectValue("status", this.status);
        writer.writeCollectionOfObjectValues("tasks", this.tasks);
    }
    ;
    /**
     * Gets the status property value.
     * @returns a printJobStatus
     */
    get status() {
        return this._status;
    }
    ;
    /**
     * Sets the status property value.
     * @param value Value to set for the status property.
     */
    set status(value) {
        this._status = value;
    }
    ;
    /**
     * Gets the tasks property value. A list of printTasks that were triggered by this print job.
     * @returns a printTask
     */
    get tasks() {
        return this._tasks;
    }
    ;
    /**
     * Sets the tasks property value. A list of printTasks that were triggered by this print job.
     * @param value Value to set for the tasks property.
     */
    set tasks(value) {
        this._tasks = value;
    }
    ;
}
exports.PrintJob = PrintJob;
