import { PrintJobProcessingState } from './printJobProcessingState';
import { PrintJobStateDetail } from './printJobStateDetail';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class PrintJobStatus implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** A human-readable description of the print job's current processing state. Read-only.  */
    private _description?;
    /** Additional details for print job state. Valid values are described in the following table. Read-only.  */
    private _details?;
    /** True if the job was acknowledged by a printer; false otherwise. Read-only.  */
    private _isAcquiredByPrinter?;
    /** The print job's current processing state. Valid values are described in the following table. Read-only.  */
    private _state?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new printJobStatus and sets the default values.
     */
    constructor();
    /**
     * Gets the description property value. A human-readable description of the print job's current processing state. Read-only.
     * @returns a string
     */
    get description(): string | undefined;
    /**
     * Sets the description property value. A human-readable description of the print job's current processing state. Read-only.
     * @param value Value to set for the description property.
     */
    set description(value: string | undefined);
    /**
     * Gets the details property value. Additional details for print job state. Valid values are described in the following table. Read-only.
     * @returns a printJobStateDetail
     */
    get details(): PrintJobStateDetail[] | undefined;
    /**
     * Sets the details property value. Additional details for print job state. Valid values are described in the following table. Read-only.
     * @param value Value to set for the details property.
     */
    set details(value: PrintJobStateDetail[] | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the isAcquiredByPrinter property value. True if the job was acknowledged by a printer; false otherwise. Read-only.
     * @returns a boolean
     */
    get isAcquiredByPrinter(): boolean | undefined;
    /**
     * Sets the isAcquiredByPrinter property value. True if the job was acknowledged by a printer; false otherwise. Read-only.
     * @param value Value to set for the isAcquiredByPrinter property.
     */
    set isAcquiredByPrinter(value: boolean | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the state property value. The print job's current processing state. Valid values are described in the following table. Read-only.
     * @returns a printJobProcessingState
     */
    get state(): PrintJobProcessingState | undefined;
    /**
     * Sets the state property value. The print job's current processing state. Valid values are described in the following table. Read-only.
     * @param value Value to set for the state property.
     */
    set state(value: PrintJobProcessingState | undefined);
}
