"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrintJobStatus = void 0;
const printJobProcessingState_1 = require("./printJobProcessingState");
const printJobStateDetail_1 = require("./printJobStateDetail");
class PrintJobStatus {
    /**
     * Instantiates a new printJobStatus and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the description property value. A human-readable description of the print job's current processing state. Read-only.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. A human-readable description of the print job's current processing state. Read-only.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the details property value. Additional details for print job state. Valid values are described in the following table. Read-only.
     * @returns a printJobStateDetail
     */
    get details() {
        return this._details;
    }
    ;
    /**
     * Sets the details property value. Additional details for print job state. Valid values are described in the following table. Read-only.
     * @param value Value to set for the details property.
     */
    set details(value) {
        this._details = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "description": (o, n) => { o.description = n.getStringValue(); },
            "details": (o, n) => { o.details = n.getEnumValues(printJobStateDetail_1.PrintJobStateDetail); },
            "isAcquiredByPrinter": (o, n) => { o.isAcquiredByPrinter = n.getBooleanValue(); },
            "state": (o, n) => { o.state = n.getEnumValue(printJobProcessingState_1.PrintJobProcessingState); },
        };
    }
    ;
    /**
     * Gets the isAcquiredByPrinter property value. True if the job was acknowledged by a printer; false otherwise. Read-only.
     * @returns a boolean
     */
    get isAcquiredByPrinter() {
        return this._isAcquiredByPrinter;
    }
    ;
    /**
     * Sets the isAcquiredByPrinter property value. True if the job was acknowledged by a printer; false otherwise. Read-only.
     * @param value Value to set for the isAcquiredByPrinter property.
     */
    set isAcquiredByPrinter(value) {
        this._isAcquiredByPrinter = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("description", this.description);
        this.details && writer.writeEnumValue("details", ...this.details);
        writer.writeBooleanValue("isAcquiredByPrinter", this.isAcquiredByPrinter);
        writer.writeEnumValue("state", this.state);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the state property value. The print job's current processing state. Valid values are described in the following table. Read-only.
     * @returns a printJobProcessingState
     */
    get state() {
        return this._state;
    }
    ;
    /**
     * Sets the state property value. The print job's current processing state. Valid values are described in the following table. Read-only.
     * @param value Value to set for the state property.
     */
    set state(value) {
        this._state = value;
    }
    ;
}
exports.PrintJobStatus = PrintJobStatus;
