import { Entity, PrintOperationStatus } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class PrintOperation extends Entity implements Parsable {
    /** The DateTimeOffset when the operation was created. Read-only.  */
    private _createdDateTime?;
    private _status?;
    /**
     * Instantiates a new printOperation and sets the default values.
     */
    constructor();
    /**
     * Gets the createdDateTime property value. The DateTimeOffset when the operation was created. Read-only.
     * @returns a Date
     */
    get createdDateTime(): Date | undefined;
    /**
     * Sets the createdDateTime property value. The DateTimeOffset when the operation was created. Read-only.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value: Date | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the status property value.
     * @returns a printOperationStatus
     */
    get status(): PrintOperationStatus | undefined;
    /**
     * Sets the status property value.
     * @param value Value to set for the status property.
     */
    set status(value: PrintOperationStatus | undefined);
}
