"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrintOperationStatus = void 0;
const printOperationProcessingState_1 = require("./printOperationProcessingState");
class PrintOperationStatus {
    /**
     * Instantiates a new printOperationStatus and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the description property value. A human-readable description of the printOperation's current processing state. Read-only.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. A human-readable description of the printOperation's current processing state. Read-only.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "description": (o, n) => { o.description = n.getStringValue(); },
            "state": (o, n) => { o.state = n.getEnumValue(printOperationProcessingState_1.PrintOperationProcessingState); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("description", this.description);
        writer.writeEnumValue("state", this.state);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the state property value. The printOperation's current processing state. Valid values are described in the following table. Read-only.
     * @returns a printOperationProcessingState
     */
    get state() {
        return this._state;
    }
    ;
    /**
     * Sets the state property value. The printOperation's current processing state. Valid values are described in the following table. Read-only.
     * @param value Value to set for the state property.
     */
    set state(value) {
        this._state = value;
    }
    ;
}
exports.PrintOperationStatus = PrintOperationStatus;
