import { Entity, PrintServiceEndpoint } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class PrintService extends Entity implements Parsable {
    /** Endpoints that can be used to access the service. Read-only. Nullable.  */
    private _endpoints?;
    /**
     * Instantiates a new printService and sets the default values.
     */
    constructor();
    /**
     * Gets the endpoints property value. Endpoints that can be used to access the service. Read-only. Nullable.
     * @returns a printServiceEndpoint
     */
    get endpoints(): PrintServiceEndpoint[] | undefined;
    /**
     * Sets the endpoints property value. Endpoints that can be used to access the service. Read-only. Nullable.
     * @param value Value to set for the endpoints property.
     */
    set endpoints(value: PrintServiceEndpoint[] | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
