import { Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class PrintServiceEndpoint extends Entity implements Parsable {
    /** A human-readable display name for the endpoint.  */
    private _displayName?;
    /** The URI that can be used to access the service.  */
    private _uri?;
    /**
     * Instantiates a new printServiceEndpoint and sets the default values.
     */
    constructor();
    /**
     * Gets the displayName property value. A human-readable display name for the endpoint.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. A human-readable display name for the endpoint.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the uri property value. The URI that can be used to access the service.
     * @returns a string
     */
    get uri(): string | undefined;
    /**
     * Sets the uri property value. The URI that can be used to access the service.
     * @param value Value to set for the uri property.
     */
    set uri(value: string | undefined);
}
