"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrintSettings = void 0;
class PrintSettings {
    /**
     * Instantiates a new printSettings and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the documentConversionEnabled property value. Specifies whether document conversion is enabled for the tenant. If document conversion is enabled, Universal Print service will automatically convert documents into a format compatible with the printer (xps to pdf) when needed.
     * @returns a boolean
     */
    get documentConversionEnabled() {
        return this._documentConversionEnabled;
    }
    ;
    /**
     * Sets the documentConversionEnabled property value. Specifies whether document conversion is enabled for the tenant. If document conversion is enabled, Universal Print service will automatically convert documents into a format compatible with the printer (xps to pdf) when needed.
     * @param value Value to set for the documentConversionEnabled property.
     */
    set documentConversionEnabled(value) {
        this._documentConversionEnabled = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "documentConversionEnabled": (o, n) => { o.documentConversionEnabled = n.getBooleanValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("documentConversionEnabled", this.documentConversionEnabled);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.PrintSettings = PrintSettings;
