import { Entity, PrintTaskDefinition } from './index';
import { PrintEvent } from './printEvent';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class PrintTaskTrigger extends Entity implements Parsable {
    private _definition?;
    /** The Universal Print event that will cause a new printTask to be triggered. Valid values are described in the following table.  */
    private _event?;
    /**
     * Instantiates a new printTaskTrigger and sets the default values.
     */
    constructor();
    /**
     * Gets the definition property value.
     * @returns a printTaskDefinition
     */
    get definition(): PrintTaskDefinition | undefined;
    /**
     * Sets the definition property value.
     * @param value Value to set for the definition property.
     */
    set definition(value: PrintTaskDefinition | undefined);
    /**
     * Gets the event property value. The Universal Print event that will cause a new printTask to be triggered. Valid values are described in the following table.
     * @returns a printEvent
     */
    get event(): PrintEvent | undefined;
    /**
     * Sets the event property value. The Universal Print event that will cause a new printTask to be triggered. Valid values are described in the following table.
     * @param value Value to set for the event property.
     */
    set event(value: PrintEvent | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
