"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrintTaskTrigger = void 0;
const createPrintTaskDefinitionFromDiscriminatorValue_1 = require("./createPrintTaskDefinitionFromDiscriminatorValue");
const index_1 = require("./index");
const printEvent_1 = require("./printEvent");
class PrintTaskTrigger extends index_1.Entity {
    /**
     * Instantiates a new printTaskTrigger and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the definition property value.
     * @returns a printTaskDefinition
     */
    get definition() {
        return this._definition;
    }
    ;
    /**
     * Sets the definition property value.
     * @param value Value to set for the definition property.
     */
    set definition(value) {
        this._definition = value;
    }
    ;
    /**
     * Gets the event property value. The Universal Print event that will cause a new printTask to be triggered. Valid values are described in the following table.
     * @returns a printEvent
     */
    get event() {
        return this._event;
    }
    ;
    /**
     * Sets the event property value. The Universal Print event that will cause a new printTask to be triggered. Valid values are described in the following table.
     * @param value Value to set for the event property.
     */
    set event(value) {
        this._event = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "definition": (o, n) => { o.definition = n.getObjectValue(createPrintTaskDefinitionFromDiscriminatorValue_1.createPrintTaskDefinitionFromDiscriminatorValue); }, "event": (o, n) => { o.event = n.getEnumValue(printEvent_1.PrintEvent); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("definition", this.definition);
        writer.writeEnumValue("event", this.event);
    }
    ;
}
exports.PrintTaskTrigger = PrintTaskTrigger;
