import { Entity } from './index';
import { DateOnly, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class PrintUsage extends Entity implements Parsable {
    private _completedBlackAndWhiteJobCount?;
    private _completedColorJobCount?;
    private _incompleteJobCount?;
    private _usageDate?;
    /**
     * Gets the completedBlackAndWhiteJobCount property value.
     * @returns a int64
     */
    get completedBlackAndWhiteJobCount(): number | undefined;
    /**
     * Sets the completedBlackAndWhiteJobCount property value.
     * @param value Value to set for the completedBlackAndWhiteJobCount property.
     */
    set completedBlackAndWhiteJobCount(value: number | undefined);
    /**
     * Gets the completedColorJobCount property value.
     * @returns a int64
     */
    get completedColorJobCount(): number | undefined;
    /**
     * Sets the completedColorJobCount property value.
     * @param value Value to set for the completedColorJobCount property.
     */
    set completedColorJobCount(value: number | undefined);
    /**
     * Instantiates a new printUsage and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the incompleteJobCount property value.
     * @returns a int64
     */
    get incompleteJobCount(): number | undefined;
    /**
     * Sets the incompleteJobCount property value.
     * @param value Value to set for the incompleteJobCount property.
     */
    set incompleteJobCount(value: number | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the usageDate property value.
     * @returns a DateOnly
     */
    get usageDate(): DateOnly | undefined;
    /**
     * Sets the usageDate property value.
     * @param value Value to set for the usageDate property.
     */
    set usageDate(value: DateOnly | undefined);
}
