"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrinterShare = void 0;
const createGroupFromDiscriminatorValue_1 = require("./createGroupFromDiscriminatorValue");
const createPrinterFromDiscriminatorValue_1 = require("./createPrinterFromDiscriminatorValue");
const createUserFromDiscriminatorValue_1 = require("./createUserFromDiscriminatorValue");
const index_1 = require("./index");
class PrinterShare extends index_1.PrinterBase {
    /**
     * Instantiates a new printerShare and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the allowAllUsers property value. If true, all users and groups will be granted access to this printer share. This supersedes the allow lists defined by the allowedUsers and allowedGroups navigation properties.
     * @returns a boolean
     */
    get allowAllUsers() {
        return this._allowAllUsers;
    }
    ;
    /**
     * Sets the allowAllUsers property value. If true, all users and groups will be granted access to this printer share. This supersedes the allow lists defined by the allowedUsers and allowedGroups navigation properties.
     * @param value Value to set for the allowAllUsers property.
     */
    set allowAllUsers(value) {
        this._allowAllUsers = value;
    }
    ;
    /**
     * Gets the allowedGroups property value. The groups whose users have access to print using the printer.
     * @returns a group
     */
    get allowedGroups() {
        return this._allowedGroups;
    }
    ;
    /**
     * Sets the allowedGroups property value. The groups whose users have access to print using the printer.
     * @param value Value to set for the allowedGroups property.
     */
    set allowedGroups(value) {
        this._allowedGroups = value;
    }
    ;
    /**
     * Gets the allowedUsers property value. The users who have access to print using the printer.
     * @returns a user
     */
    get allowedUsers() {
        return this._allowedUsers;
    }
    ;
    /**
     * Sets the allowedUsers property value. The users who have access to print using the printer.
     * @param value Value to set for the allowedUsers property.
     */
    set allowedUsers(value) {
        this._allowedUsers = value;
    }
    ;
    ;
    /**
     * Gets the createdDateTime property value. The DateTimeOffset when the printer share was created. Read-only.
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. The DateTimeOffset when the printer share was created. Read-only.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "allowAllUsers": (o, n) => { o.allowAllUsers = n.getBooleanValue(); }, "allowedGroups": (o, n) => { o.allowedGroups = n.getCollectionOfObjectValues(createGroupFromDiscriminatorValue_1.createGroupFromDiscriminatorValue); }, "allowedUsers": (o, n) => { o.allowedUsers = n.getCollectionOfObjectValues(createUserFromDiscriminatorValue_1.createUserFromDiscriminatorValue); }, "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); }, "printer": (o, n) => { o.printer = n.getObjectValue(createPrinterFromDiscriminatorValue_1.createPrinterFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the printer property value. The printer that this printer share is related to.
     * @returns a printer
     */
    get printer() {
        return this._printer;
    }
    ;
    /**
     * Sets the printer property value. The printer that this printer share is related to.
     * @param value Value to set for the printer property.
     */
    set printer(value) {
        this._printer = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeBooleanValue("allowAllUsers", this.allowAllUsers);
        writer.writeCollectionOfObjectValues("allowedGroups", this.allowedGroups);
        writer.writeCollectionOfObjectValues("allowedUsers", this.allowedUsers);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeObjectValue("printer", this.printer);
    }
    ;
}
exports.PrinterShare = PrinterShare;
