import { PrinterProcessingState } from './printerProcessingState';
import { PrinterProcessingStateDetail } from './printerProcessingStateDetail';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class PrinterStatus implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** A human-readable description of the printer's current processing state. Read-only.  */
    private _description?;
    /** The list of details describing why the printer is in the current state. Valid values are described in the following table. Read-only.  */
    private _details?;
    /** The current processing state. Valid values are described in the following table. Read-only.  */
    private _state?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new printerStatus and sets the default values.
     */
    constructor();
    /**
     * Gets the description property value. A human-readable description of the printer's current processing state. Read-only.
     * @returns a string
     */
    get description(): string | undefined;
    /**
     * Sets the description property value. A human-readable description of the printer's current processing state. Read-only.
     * @param value Value to set for the description property.
     */
    set description(value: string | undefined);
    /**
     * Gets the details property value. The list of details describing why the printer is in the current state. Valid values are described in the following table. Read-only.
     * @returns a printerProcessingStateDetail
     */
    get details(): PrinterProcessingStateDetail[] | undefined;
    /**
     * Sets the details property value. The list of details describing why the printer is in the current state. Valid values are described in the following table. Read-only.
     * @param value Value to set for the details property.
     */
    set details(value: PrinterProcessingStateDetail[] | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the state property value. The current processing state. Valid values are described in the following table. Read-only.
     * @returns a printerProcessingState
     */
    get state(): PrinterProcessingState | undefined;
    /**
     * Sets the state property value. The current processing state. Valid values are described in the following table. Read-only.
     * @param value Value to set for the state property.
     */
    set state(value: PrinterProcessingState | undefined);
}
