"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrivacyProfile = void 0;
class PrivacyProfile {
    /**
     * Instantiates a new privacyProfile and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the contactEmail property value. A valid smtp email address for the privacy statement contact. Not required.
     * @returns a string
     */
    get contactEmail() {
        return this._contactEmail;
    }
    ;
    /**
     * Sets the contactEmail property value. A valid smtp email address for the privacy statement contact. Not required.
     * @param value Value to set for the contactEmail property.
     */
    set contactEmail(value) {
        this._contactEmail = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "contactEmail": (o, n) => { o.contactEmail = n.getStringValue(); },
            "statementUrl": (o, n) => { o.statementUrl = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("contactEmail", this.contactEmail);
        writer.writeStringValue("statementUrl", this.statementUrl);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the statementUrl property value. A valid URL format that begins with http:// or https://. Maximum length is 255 characters. The URL that directs to the company's privacy statement. Not required.
     * @returns a string
     */
    get statementUrl() {
        return this._statementUrl;
    }
    ;
    /**
     * Sets the statementUrl property value. A valid URL format that begins with http:// or https://. Maximum length is 255 characters. The URL that directs to the company's privacy statement. Not required.
     * @param value Value to set for the statementUrl property.
     */
    set statementUrl(value) {
        this._statementUrl = value;
    }
    ;
}
exports.PrivacyProfile = PrivacyProfile;
