import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ProvisionedPlan implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** For example, 'Enabled'.  */
    private _capabilityStatus?;
    /** For example, 'Success'.  */
    private _provisioningStatus?;
    /** The name of the service; for example, 'AccessControlS2S'  */
    private _service?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the capabilityStatus property value. For example, 'Enabled'.
     * @returns a string
     */
    get capabilityStatus(): string | undefined;
    /**
     * Sets the capabilityStatus property value. For example, 'Enabled'.
     * @param value Value to set for the capabilityStatus property.
     */
    set capabilityStatus(value: string | undefined);
    /**
     * Instantiates a new provisionedPlan and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the provisioningStatus property value. For example, 'Success'.
     * @returns a string
     */
    get provisioningStatus(): string | undefined;
    /**
     * Sets the provisioningStatus property value. For example, 'Success'.
     * @param value Value to set for the provisioningStatus property.
     */
    set provisioningStatus(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the service property value. The name of the service; for example, 'AccessControlS2S'
     * @returns a string
     */
    get service(): string | undefined;
    /**
     * Sets the service property value. The name of the service; for example, 'AccessControlS2S'
     * @param value Value to set for the service property.
     */
    set service(value: string | undefined);
}
