"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProvisionedPlan = void 0;
class ProvisionedPlan {
    /**
     * Instantiates a new provisionedPlan and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the capabilityStatus property value. For example, 'Enabled'.
     * @returns a string
     */
    get capabilityStatus() {
        return this._capabilityStatus;
    }
    ;
    /**
     * Sets the capabilityStatus property value. For example, 'Enabled'.
     * @param value Value to set for the capabilityStatus property.
     */
    set capabilityStatus(value) {
        this._capabilityStatus = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "capabilityStatus": (o, n) => { o.capabilityStatus = n.getStringValue(); },
            "provisioningStatus": (o, n) => { o.provisioningStatus = n.getStringValue(); },
            "service": (o, n) => { o.service = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the provisioningStatus property value. For example, 'Success'.
     * @returns a string
     */
    get provisioningStatus() {
        return this._provisioningStatus;
    }
    ;
    /**
     * Sets the provisioningStatus property value. For example, 'Success'.
     * @param value Value to set for the provisioningStatus property.
     */
    set provisioningStatus(value) {
        this._provisioningStatus = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("capabilityStatus", this.capabilityStatus);
        writer.writeStringValue("provisioningStatus", this.provisioningStatus);
        writer.writeStringValue("service", this.service);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the service property value. The name of the service; for example, 'AccessControlS2S'
     * @returns a string
     */
    get service() {
        return this._service;
    }
    ;
    /**
     * Sets the service property value. The name of the service; for example, 'AccessControlS2S'
     * @param value Value to set for the service property.
     */
    set service(value) {
        this._service = value;
    }
    ;
}
exports.ProvisionedPlan = ProvisionedPlan;
