"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProvisioningErrorInfo = void 0;
const provisioningStatusErrorCategory_1 = require("./provisioningStatusErrorCategory");
class ProvisioningErrorInfo {
    /**
     * Instantiates a new provisioningErrorInfo and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the additionalDetails property value. Additional details in case of error.
     * @returns a string
     */
    get additionalDetails() {
        return this._additionalDetails;
    }
    ;
    /**
     * Sets the additionalDetails property value. Additional details in case of error.
     * @param value Value to set for the additionalDetails property.
     */
    set additionalDetails(value) {
        this._additionalDetails = value;
    }
    ;
    ;
    /**
     * Gets the errorCategory property value. Categorizes the error code. Possible values are failure, nonServiceFailure, success, unknownFutureValue
     * @returns a provisioningStatusErrorCategory
     */
    get errorCategory() {
        return this._errorCategory;
    }
    ;
    /**
     * Sets the errorCategory property value. Categorizes the error code. Possible values are failure, nonServiceFailure, success, unknownFutureValue
     * @param value Value to set for the errorCategory property.
     */
    set errorCategory(value) {
        this._errorCategory = value;
    }
    ;
    /**
     * Gets the errorCode property value. Unique error code if any occurred. Learn more
     * @returns a string
     */
    get errorCode() {
        return this._errorCode;
    }
    ;
    /**
     * Sets the errorCode property value. Unique error code if any occurred. Learn more
     * @param value Value to set for the errorCode property.
     */
    set errorCode(value) {
        this._errorCode = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "additionalDetails": (o, n) => { o.additionalDetails = n.getStringValue(); },
            "errorCategory": (o, n) => { o.errorCategory = n.getEnumValue(provisioningStatusErrorCategory_1.ProvisioningStatusErrorCategory); },
            "errorCode": (o, n) => { o.errorCode = n.getStringValue(); },
            "reason": (o, n) => { o.reason = n.getStringValue(); },
            "recommendedAction": (o, n) => { o.recommendedAction = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the reason property value. Summarizes the status and describes why the status happened.
     * @returns a string
     */
    get reason() {
        return this._reason;
    }
    ;
    /**
     * Sets the reason property value. Summarizes the status and describes why the status happened.
     * @param value Value to set for the reason property.
     */
    set reason(value) {
        this._reason = value;
    }
    ;
    /**
     * Gets the recommendedAction property value. Provides the resolution for the corresponding error.
     * @returns a string
     */
    get recommendedAction() {
        return this._recommendedAction;
    }
    ;
    /**
     * Sets the recommendedAction property value. Provides the resolution for the corresponding error.
     * @param value Value to set for the recommendedAction property.
     */
    set recommendedAction(value) {
        this._recommendedAction = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("additionalDetails", this.additionalDetails);
        writer.writeEnumValue("errorCategory", this.errorCategory);
        writer.writeStringValue("errorCode", this.errorCode);
        writer.writeStringValue("reason", this.reason);
        writer.writeStringValue("recommendedAction", this.recommendedAction);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ProvisioningErrorInfo = ProvisioningErrorInfo;
