"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProvisioningStatusInfo = void 0;
const createProvisioningErrorInfoFromDiscriminatorValue_1 = require("./createProvisioningErrorInfoFromDiscriminatorValue");
const provisioningResult_1 = require("./provisioningResult");
class ProvisioningStatusInfo {
    /**
     * Instantiates a new provisioningStatusInfo and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the errorInformation property value.
     * @returns a provisioningErrorInfo
     */
    get errorInformation() {
        return this._errorInformation;
    }
    ;
    /**
     * Sets the errorInformation property value.
     * @param value Value to set for the errorInformation property.
     */
    set errorInformation(value) {
        this._errorInformation = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "errorInformation": (o, n) => { o.errorInformation = n.getObjectValue(createProvisioningErrorInfoFromDiscriminatorValue_1.createProvisioningErrorInfoFromDiscriminatorValue); },
            "status": (o, n) => { o.status = n.getEnumValue(provisioningResult_1.ProvisioningResult); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("errorInformation", this.errorInformation);
        writer.writeEnumValue("status", this.status);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the status property value. Possible values are: success, warning, failure, skipped, unknownFutureValue.
     * @returns a provisioningResult
     */
    get status() {
        return this._status;
    }
    ;
    /**
     * Sets the status property value. Possible values are: success, warning, failure, skipped, unknownFutureValue.
     * @param value Value to set for the status property.
     */
    set status(value) {
        this._status = value;
    }
    ;
}
exports.ProvisioningStatusInfo = ProvisioningStatusInfo;
