import { DetailsInfo } from './index';
import { ProvisioningResult } from './provisioningResult';
import { ProvisioningStepType } from './provisioningStepType';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ProvisioningStep implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Summary of what occurred during the step.  */
    private _description?;
    /** Details of what occurred during the step.  */
    private _details?;
    /** Name of the step.  */
    private _name?;
    /** Type of step. Possible values are: import, scoping, matching, processing, referenceResolution, export, unknownFutureValue.  */
    private _provisioningStepType?;
    /** Status of the step. Possible values are: success, warning,  failure, skipped, unknownFutureValue.  */
    private _status?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new provisioningStep and sets the default values.
     */
    constructor();
    /**
     * Gets the description property value. Summary of what occurred during the step.
     * @returns a string
     */
    get description(): string | undefined;
    /**
     * Sets the description property value. Summary of what occurred during the step.
     * @param value Value to set for the description property.
     */
    set description(value: string | undefined);
    /**
     * Gets the details property value. Details of what occurred during the step.
     * @returns a detailsInfo
     */
    get details(): DetailsInfo | undefined;
    /**
     * Sets the details property value. Details of what occurred during the step.
     * @param value Value to set for the details property.
     */
    set details(value: DetailsInfo | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the name property value. Name of the step.
     * @returns a string
     */
    get name(): string | undefined;
    /**
     * Sets the name property value. Name of the step.
     * @param value Value to set for the name property.
     */
    set name(value: string | undefined);
    /**
     * Gets the provisioningStepType property value. Type of step. Possible values are: import, scoping, matching, processing, referenceResolution, export, unknownFutureValue.
     * @returns a provisioningStepType
     */
    get provisioningStepType(): ProvisioningStepType | undefined;
    /**
     * Sets the provisioningStepType property value. Type of step. Possible values are: import, scoping, matching, processing, referenceResolution, export, unknownFutureValue.
     * @param value Value to set for the provisioningStepType property.
     */
    set provisioningStepType(value: ProvisioningStepType | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the status property value. Status of the step. Possible values are: success, warning,  failure, skipped, unknownFutureValue.
     * @returns a provisioningResult
     */
    get status(): ProvisioningResult | undefined;
    /**
     * Sets the status property value. Status of the step. Possible values are: success, warning,  failure, skipped, unknownFutureValue.
     * @param value Value to set for the status property.
     */
    set status(value: ProvisioningResult | undefined);
}
