"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProvisioningStep = void 0;
const createDetailsInfoFromDiscriminatorValue_1 = require("./createDetailsInfoFromDiscriminatorValue");
const provisioningResult_1 = require("./provisioningResult");
const provisioningStepType_1 = require("./provisioningStepType");
class ProvisioningStep {
    /**
     * Instantiates a new provisioningStep and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the description property value. Summary of what occurred during the step.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. Summary of what occurred during the step.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the details property value. Details of what occurred during the step.
     * @returns a detailsInfo
     */
    get details() {
        return this._details;
    }
    ;
    /**
     * Sets the details property value. Details of what occurred during the step.
     * @param value Value to set for the details property.
     */
    set details(value) {
        this._details = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "description": (o, n) => { o.description = n.getStringValue(); },
            "details": (o, n) => { o.details = n.getObjectValue(createDetailsInfoFromDiscriminatorValue_1.createDetailsInfoFromDiscriminatorValue); },
            "name": (o, n) => { o.name = n.getStringValue(); },
            "provisioningStepType": (o, n) => { o.provisioningStepType = n.getEnumValue(provisioningStepType_1.ProvisioningStepType); },
            "status": (o, n) => { o.status = n.getEnumValue(provisioningResult_1.ProvisioningResult); },
        };
    }
    ;
    /**
     * Gets the name property value. Name of the step.
     * @returns a string
     */
    get name() {
        return this._name;
    }
    ;
    /**
     * Sets the name property value. Name of the step.
     * @param value Value to set for the name property.
     */
    set name(value) {
        this._name = value;
    }
    ;
    /**
     * Gets the provisioningStepType property value. Type of step. Possible values are: import, scoping, matching, processing, referenceResolution, export, unknownFutureValue.
     * @returns a provisioningStepType
     */
    get provisioningStepType() {
        return this._provisioningStepType;
    }
    ;
    /**
     * Sets the provisioningStepType property value. Type of step. Possible values are: import, scoping, matching, processing, referenceResolution, export, unknownFutureValue.
     * @param value Value to set for the provisioningStepType property.
     */
    set provisioningStepType(value) {
        this._provisioningStepType = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("description", this.description);
        writer.writeObjectValue("details", this.details);
        writer.writeStringValue("name", this.name);
        writer.writeEnumValue("provisioningStepType", this.provisioningStepType);
        writer.writeEnumValue("status", this.status);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the status property value. Status of the step. Possible values are: success, warning,  failure, skipped, unknownFutureValue.
     * @returns a provisioningResult
     */
    get status() {
        return this._status;
    }
    ;
    /**
     * Sets the status property value. Status of the step. Possible values are: success, warning,  failure, skipped, unknownFutureValue.
     * @param value Value to set for the status property.
     */
    set status(value) {
        this._status = value;
    }
    ;
}
exports.ProvisioningStep = ProvisioningStep;
