import { DetailsInfo, Identity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ProvisioningSystem extends Identity implements Parsable {
    /** Details of the system.  */
    private _details?;
    /**
     * Instantiates a new provisioningSystem and sets the default values.
     */
    constructor();
    /**
     * Gets the details property value. Details of the system.
     * @returns a detailsInfo
     */
    get details(): DetailsInfo | undefined;
    /**
     * Sets the details property value. Details of the system.
     * @param value Value to set for the details property.
     */
    set details(value: DetailsInfo | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
