"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PublicError = void 0;
const createPublicErrorDetailFromDiscriminatorValue_1 = require("./createPublicErrorDetailFromDiscriminatorValue");
const createPublicInnerErrorFromDiscriminatorValue_1 = require("./createPublicInnerErrorFromDiscriminatorValue");
class PublicError {
    /**
     * Instantiates a new publicError and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the code property value. Represents the error code.
     * @returns a string
     */
    get code() {
        return this._code;
    }
    ;
    /**
     * Sets the code property value. Represents the error code.
     * @param value Value to set for the code property.
     */
    set code(value) {
        this._code = value;
    }
    ;
    ;
    /**
     * Gets the details property value. Details of the error.
     * @returns a publicErrorDetail
     */
    get details() {
        return this._details;
    }
    ;
    /**
     * Sets the details property value. Details of the error.
     * @param value Value to set for the details property.
     */
    set details(value) {
        this._details = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "code": (o, n) => { o.code = n.getStringValue(); },
            "details": (o, n) => { o.details = n.getCollectionOfObjectValues(createPublicErrorDetailFromDiscriminatorValue_1.createPublicErrorDetailFromDiscriminatorValue); },
            "innerError": (o, n) => { o.innerError = n.getObjectValue(createPublicInnerErrorFromDiscriminatorValue_1.createPublicInnerErrorFromDiscriminatorValue); },
            "message": (o, n) => { o.message = n.getStringValue(); },
            "target": (o, n) => { o.target = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the innerError property value. Details of the inner error.
     * @returns a publicInnerError
     */
    get innerError() {
        return this._innerError;
    }
    ;
    /**
     * Sets the innerError property value. Details of the inner error.
     * @param value Value to set for the innerError property.
     */
    set innerError(value) {
        this._innerError = value;
    }
    ;
    /**
     * Gets the message property value. A non-localized message for the developer.
     * @returns a string
     */
    get message() {
        return this._message;
    }
    ;
    /**
     * Sets the message property value. A non-localized message for the developer.
     * @param value Value to set for the message property.
     */
    set message(value) {
        this._message = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("code", this.code);
        writer.writeCollectionOfObjectValues("details", this.details);
        writer.writeObjectValue("innerError", this.innerError);
        writer.writeStringValue("message", this.message);
        writer.writeStringValue("target", this.target);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the target property value. The target of the error.
     * @returns a string
     */
    get target() {
        return this._target;
    }
    ;
    /**
     * Sets the target property value. The target of the error.
     * @param value Value to set for the target property.
     */
    set target(value) {
        this._target = value;
    }
    ;
}
exports.PublicError = PublicError;
