"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PublicErrorDetail = void 0;
class PublicErrorDetail {
    /**
     * Instantiates a new publicErrorDetail and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the code property value. The error code.
     * @returns a string
     */
    get code() {
        return this._code;
    }
    ;
    /**
     * Sets the code property value. The error code.
     * @param value Value to set for the code property.
     */
    set code(value) {
        this._code = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "code": (o, n) => { o.code = n.getStringValue(); },
            "message": (o, n) => { o.message = n.getStringValue(); },
            "target": (o, n) => { o.target = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the message property value. The error message.
     * @returns a string
     */
    get message() {
        return this._message;
    }
    ;
    /**
     * Sets the message property value. The error message.
     * @param value Value to set for the message property.
     */
    set message(value) {
        this._message = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("code", this.code);
        writer.writeStringValue("message", this.message);
        writer.writeStringValue("target", this.target);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the target property value. The target of the error.
     * @returns a string
     */
    get target() {
        return this._target;
    }
    ;
    /**
     * Sets the target property value. The target of the error.
     * @param value Value to set for the target property.
     */
    set target(value) {
        this._target = value;
    }
    ;
}
exports.PublicErrorDetail = PublicErrorDetail;
