import { PublicErrorDetail } from './index';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class PublicInnerError implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** The error code.  */
    private _code?;
    /** A collection of error details.  */
    private _details?;
    /** The error message.  */
    private _message?;
    /** The target of the error.  */
    private _target?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the code property value. The error code.
     * @returns a string
     */
    get code(): string | undefined;
    /**
     * Sets the code property value. The error code.
     * @param value Value to set for the code property.
     */
    set code(value: string | undefined);
    /**
     * Instantiates a new publicInnerError and sets the default values.
     */
    constructor();
    /**
     * Gets the details property value. A collection of error details.
     * @returns a publicErrorDetail
     */
    get details(): PublicErrorDetail[] | undefined;
    /**
     * Sets the details property value. A collection of error details.
     * @param value Value to set for the details property.
     */
    set details(value: PublicErrorDetail[] | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the message property value. The error message.
     * @returns a string
     */
    get message(): string | undefined;
    /**
     * Sets the message property value. The error message.
     * @param value Value to set for the message property.
     */
    set message(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the target property value. The target of the error.
     * @returns a string
     */
    get target(): string | undefined;
    /**
     * Sets the target property value. The target of the error.
     * @param value Value to set for the target property.
     */
    set target(value: string | undefined);
}
