"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PublicationFacet = void 0;
class PublicationFacet {
    /**
     * Instantiates a new publicationFacet and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "level": (o, n) => { o.level = n.getStringValue(); },
            "versionId": (o, n) => { o.versionId = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the level property value. The state of publication for this document. Either published or checkout. Read-only.
     * @returns a string
     */
    get level() {
        return this._level;
    }
    ;
    /**
     * Sets the level property value. The state of publication for this document. Either published or checkout. Read-only.
     * @param value Value to set for the level property.
     */
    set level(value) {
        this._level = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("level", this.level);
        writer.writeStringValue("versionId", this.versionId);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the versionId property value. The unique identifier for the version that is visible to the current caller. Read-only.
     * @returns a string
     */
    get versionId() {
        return this._versionId;
    }
    ;
    /**
     * Sets the versionId property value. The unique identifier for the version that is visible to the current caller. Read-only.
     * @param value Value to set for the versionId property.
     */
    set versionId(value) {
        this._versionId = value;
    }
    ;
}
exports.PublicationFacet = PublicationFacet;
