import { StoragePlanInformation } from './index';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class Quota implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Total space consumed by files in the recycle bin, in bytes. Read-only.  */
    private _deleted?;
    /** Total space remaining before reaching the quota limit, in bytes. Read-only.  */
    private _remaining?;
    /** Enumeration value that indicates the state of the storage space. Read-only.  */
    private _state?;
    /** Information about the drive's storage quota plans. Only in Personal OneDrive.  */
    private _storagePlanInformation?;
    /** Total allowed storage space, in bytes. Read-only.  */
    private _total?;
    /** Total space used, in bytes. Read-only.  */
    private _used?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new quota and sets the default values.
     */
    constructor();
    /**
     * Gets the deleted property value. Total space consumed by files in the recycle bin, in bytes. Read-only.
     * @returns a int64
     */
    get deleted(): number | undefined;
    /**
     * Sets the deleted property value. Total space consumed by files in the recycle bin, in bytes. Read-only.
     * @param value Value to set for the deleted property.
     */
    set deleted(value: number | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the remaining property value. Total space remaining before reaching the quota limit, in bytes. Read-only.
     * @returns a int64
     */
    get remaining(): number | undefined;
    /**
     * Sets the remaining property value. Total space remaining before reaching the quota limit, in bytes. Read-only.
     * @param value Value to set for the remaining property.
     */
    set remaining(value: number | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the state property value. Enumeration value that indicates the state of the storage space. Read-only.
     * @returns a string
     */
    get state(): string | undefined;
    /**
     * Sets the state property value. Enumeration value that indicates the state of the storage space. Read-only.
     * @param value Value to set for the state property.
     */
    set state(value: string | undefined);
    /**
     * Gets the storagePlanInformation property value. Information about the drive's storage quota plans. Only in Personal OneDrive.
     * @returns a storagePlanInformation
     */
    get storagePlanInformation(): StoragePlanInformation | undefined;
    /**
     * Sets the storagePlanInformation property value. Information about the drive's storage quota plans. Only in Personal OneDrive.
     * @param value Value to set for the storagePlanInformation property.
     */
    set storagePlanInformation(value: StoragePlanInformation | undefined);
    /**
     * Gets the total property value. Total allowed storage space, in bytes. Read-only.
     * @returns a int64
     */
    get total(): number | undefined;
    /**
     * Sets the total property value. Total allowed storage space, in bytes. Read-only.
     * @param value Value to set for the total property.
     */
    set total(value: number | undefined);
    /**
     * Gets the used property value. Total space used, in bytes. Read-only.
     * @returns a int64
     */
    get used(): number | undefined;
    /**
     * Sets the used property value. Total space used, in bytes. Read-only.
     * @param value Value to set for the used property.
     */
    set used(value: number | undefined);
}
