import { Entity, UnifiedRoleAssignment, UnifiedRoleDefinition } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class RbacApplication extends Entity implements Parsable {
    /** Resource to grant access to users or groups.  */
    private _roleAssignments?;
    /** Resource representing the roles allowed by RBAC providers and the permissions assigned to the roles.  */
    private _roleDefinitions?;
    /**
     * Instantiates a new rbacApplication and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the roleAssignments property value. Resource to grant access to users or groups.
     * @returns a unifiedRoleAssignment
     */
    get roleAssignments(): UnifiedRoleAssignment[] | undefined;
    /**
     * Sets the roleAssignments property value. Resource to grant access to users or groups.
     * @param value Value to set for the roleAssignments property.
     */
    set roleAssignments(value: UnifiedRoleAssignment[] | undefined);
    /**
     * Gets the roleDefinitions property value. Resource representing the roles allowed by RBAC providers and the permissions assigned to the roles.
     * @returns a unifiedRoleDefinition
     */
    get roleDefinitions(): UnifiedRoleDefinition[] | undefined;
    /**
     * Sets the roleDefinitions property value. Resource representing the roles allowed by RBAC providers and the permissions assigned to the roles.
     * @param value Value to set for the roleDefinitions property.
     */
    set roleDefinitions(value: UnifiedRoleDefinition[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
