"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RbacApplication = void 0;
const createUnifiedRoleAssignmentFromDiscriminatorValue_1 = require("./createUnifiedRoleAssignmentFromDiscriminatorValue");
const createUnifiedRoleDefinitionFromDiscriminatorValue_1 = require("./createUnifiedRoleDefinitionFromDiscriminatorValue");
const index_1 = require("./index");
class RbacApplication extends index_1.Entity {
    /**
     * Instantiates a new rbacApplication and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "roleAssignments": (o, n) => { o.roleAssignments = n.getCollectionOfObjectValues(createUnifiedRoleAssignmentFromDiscriminatorValue_1.createUnifiedRoleAssignmentFromDiscriminatorValue); }, "roleDefinitions": (o, n) => { o.roleDefinitions = n.getCollectionOfObjectValues(createUnifiedRoleDefinitionFromDiscriminatorValue_1.createUnifiedRoleDefinitionFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the roleAssignments property value. Resource to grant access to users or groups.
     * @returns a unifiedRoleAssignment
     */
    get roleAssignments() {
        return this._roleAssignments;
    }
    ;
    /**
     * Sets the roleAssignments property value. Resource to grant access to users or groups.
     * @param value Value to set for the roleAssignments property.
     */
    set roleAssignments(value) {
        this._roleAssignments = value;
    }
    ;
    /**
     * Gets the roleDefinitions property value. Resource representing the roles allowed by RBAC providers and the permissions assigned to the roles.
     * @returns a unifiedRoleDefinition
     */
    get roleDefinitions() {
        return this._roleDefinitions;
    }
    ;
    /**
     * Sets the roleDefinitions property value. Resource representing the roles allowed by RBAC providers and the permissions assigned to the roles.
     * @param value Value to set for the roleDefinitions property.
     */
    set roleDefinitions(value) {
        this._roleDefinitions = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("roleAssignments", this.roleAssignments);
        writer.writeCollectionOfObjectValues("roleDefinitions", this.roleDefinitions);
    }
    ;
}
exports.RbacApplication = RbacApplication;
