"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Recipient = void 0;
const createEmailAddressFromDiscriminatorValue_1 = require("./createEmailAddressFromDiscriminatorValue");
class Recipient {
    /**
     * Instantiates a new recipient and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the emailAddress property value. The recipient's email address.
     * @returns a emailAddress
     */
    get emailAddress() {
        return this._emailAddress;
    }
    ;
    /**
     * Sets the emailAddress property value. The recipient's email address.
     * @param value Value to set for the emailAddress property.
     */
    set emailAddress(value) {
        this._emailAddress = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "emailAddress": (o, n) => { o.emailAddress = n.getObjectValue(createEmailAddressFromDiscriminatorValue_1.createEmailAddressFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("emailAddress", this.emailAddress);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.Recipient = Recipient;
