import { IdentitySet } from './index';
import { RecordingStatus } from './recordingStatus';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class RecordingInfo implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** The identities of the recording initiator.  */
    private _initiator?;
    /** Possible values are: unknown, notRecording, recording, or failed.  */
    private _recordingStatus?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new recordingInfo and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the initiator property value. The identities of the recording initiator.
     * @returns a identitySet
     */
    get initiator(): IdentitySet | undefined;
    /**
     * Sets the initiator property value. The identities of the recording initiator.
     * @param value Value to set for the initiator property.
     */
    set initiator(value: IdentitySet | undefined);
    /**
     * Gets the recordingStatus property value. Possible values are: unknown, notRecording, recording, or failed.
     * @returns a recordingStatus
     */
    get recordingStatus(): RecordingStatus | undefined;
    /**
     * Sets the recordingStatus property value. Possible values are: unknown, notRecording, recording, or failed.
     * @param value Value to set for the recordingStatus property.
     */
    set recordingStatus(value: RecordingStatus | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
