"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RecurrenceRange = void 0;
const recurrenceRangeType_1 = require("./recurrenceRangeType");
class RecurrenceRange {
    /**
     * Instantiates a new recurrenceRange and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the endDate property value. The date to stop applying the recurrence pattern. Depending on the recurrence pattern of the event, the last occurrence of the meeting may not be this date. Required if type is endDate.
     * @returns a DateOnly
     */
    get endDate() {
        return this._endDate;
    }
    ;
    /**
     * Sets the endDate property value. The date to stop applying the recurrence pattern. Depending on the recurrence pattern of the event, the last occurrence of the meeting may not be this date. Required if type is endDate.
     * @param value Value to set for the endDate property.
     */
    set endDate(value) {
        this._endDate = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "endDate": (o, n) => { o.endDate = n.getDateOnlyValue(); },
            "numberOfOccurrences": (o, n) => { o.numberOfOccurrences = n.getNumberValue(); },
            "recurrenceTimeZone": (o, n) => { o.recurrenceTimeZone = n.getStringValue(); },
            "startDate": (o, n) => { o.startDate = n.getDateOnlyValue(); },
            "type": (o, n) => { o.type = n.getEnumValue(recurrenceRangeType_1.RecurrenceRangeType); },
        };
    }
    ;
    /**
     * Gets the numberOfOccurrences property value. The number of times to repeat the event. Required and must be positive if type is numbered.
     * @returns a integer
     */
    get numberOfOccurrences() {
        return this._numberOfOccurrences;
    }
    ;
    /**
     * Sets the numberOfOccurrences property value. The number of times to repeat the event. Required and must be positive if type is numbered.
     * @param value Value to set for the numberOfOccurrences property.
     */
    set numberOfOccurrences(value) {
        this._numberOfOccurrences = value;
    }
    ;
    /**
     * Gets the recurrenceTimeZone property value. Time zone for the startDate and endDate properties. Optional. If not specified, the time zone of the event is used.
     * @returns a string
     */
    get recurrenceTimeZone() {
        return this._recurrenceTimeZone;
    }
    ;
    /**
     * Sets the recurrenceTimeZone property value. Time zone for the startDate and endDate properties. Optional. If not specified, the time zone of the event is used.
     * @param value Value to set for the recurrenceTimeZone property.
     */
    set recurrenceTimeZone(value) {
        this._recurrenceTimeZone = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeDateOnlyValue("endDate", this.endDate);
        writer.writeNumberValue("numberOfOccurrences", this.numberOfOccurrences);
        writer.writeStringValue("recurrenceTimeZone", this.recurrenceTimeZone);
        writer.writeDateOnlyValue("startDate", this.startDate);
        writer.writeEnumValue("type", this.type);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the startDate property value. The date to start applying the recurrence pattern. The first occurrence of the meeting may be this date or later, depending on the recurrence pattern of the event. Must be the same value as the start property of the recurring event. Required.
     * @returns a DateOnly
     */
    get startDate() {
        return this._startDate;
    }
    ;
    /**
     * Sets the startDate property value. The date to start applying the recurrence pattern. The first occurrence of the meeting may be this date or later, depending on the recurrence pattern of the event. Must be the same value as the start property of the recurring event. Required.
     * @param value Value to set for the startDate property.
     */
    set startDate(value) {
        this._startDate = value;
    }
    ;
    /**
     * Gets the type property value. The recurrence range. The possible values are: endDate, noEnd, numbered. Required.
     * @returns a recurrenceRangeType
     */
    get type() {
        return this._type;
    }
    ;
    /**
     * Sets the type property value. The recurrence range. The possible values are: endDate, noEnd, numbered. Required.
     * @param value Value to set for the type property.
     */
    set type(value) {
        this._type = value;
    }
    ;
}
exports.RecurrenceRange = RecurrenceRange;
