"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RegistrationEnforcement = void 0;
const createAuthenticationMethodsRegistrationCampaignFromDiscriminatorValue_1 = require("./createAuthenticationMethodsRegistrationCampaignFromDiscriminatorValue");
class RegistrationEnforcement {
    /**
     * Instantiates a new registrationEnforcement and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the authenticationMethodsRegistrationCampaign property value. Run campaigns to remind users to set up targeted authentication methods.
     * @returns a authenticationMethodsRegistrationCampaign
     */
    get authenticationMethodsRegistrationCampaign() {
        return this._authenticationMethodsRegistrationCampaign;
    }
    ;
    /**
     * Sets the authenticationMethodsRegistrationCampaign property value. Run campaigns to remind users to set up targeted authentication methods.
     * @param value Value to set for the authenticationMethodsRegistrationCampaign property.
     */
    set authenticationMethodsRegistrationCampaign(value) {
        this._authenticationMethodsRegistrationCampaign = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "authenticationMethodsRegistrationCampaign": (o, n) => { o.authenticationMethodsRegistrationCampaign = n.getObjectValue(createAuthenticationMethodsRegistrationCampaignFromDiscriminatorValue_1.createAuthenticationMethodsRegistrationCampaignFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("authenticationMethodsRegistrationCampaign", this.authenticationMethodsRegistrationCampaign);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.RegistrationEnforcement = RegistrationEnforcement;
