import { DateTimeTimeZone, Location } from './index';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class Reminder implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Identifies the version of the reminder. Every time the reminder is changed, changeKey changes as well. This allows Exchange to apply changes to the correct version of the object.  */
    private _changeKey?;
    /** The date, time and time zone that the event ends.  */
    private _eventEndTime?;
    /** The unique ID of the event. Read only.  */
    private _eventId?;
    /** The location of the event.  */
    private _eventLocation?;
    /** The date, time, and time zone that the event starts.  */
    private _eventStartTime?;
    /** The text of the event's subject line.  */
    private _eventSubject?;
    /** The URL to open the event in Outlook on the web.The event will open in the browser if you are logged in to your mailbox via Outlook on the web. You will be prompted to login if you are not already logged in with the browser.This URL cannot be accessed from within an iFrame.  */
    private _eventWebLink?;
    /** The date, time, and time zone that the reminder is set to occur.  */
    private _reminderFireTime?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the changeKey property value. Identifies the version of the reminder. Every time the reminder is changed, changeKey changes as well. This allows Exchange to apply changes to the correct version of the object.
     * @returns a string
     */
    get changeKey(): string | undefined;
    /**
     * Sets the changeKey property value. Identifies the version of the reminder. Every time the reminder is changed, changeKey changes as well. This allows Exchange to apply changes to the correct version of the object.
     * @param value Value to set for the changeKey property.
     */
    set changeKey(value: string | undefined);
    /**
     * Instantiates a new reminder and sets the default values.
     */
    constructor();
    /**
     * Gets the eventEndTime property value. The date, time and time zone that the event ends.
     * @returns a dateTimeTimeZone
     */
    get eventEndTime(): DateTimeTimeZone | undefined;
    /**
     * Sets the eventEndTime property value. The date, time and time zone that the event ends.
     * @param value Value to set for the eventEndTime property.
     */
    set eventEndTime(value: DateTimeTimeZone | undefined);
    /**
     * Gets the eventId property value. The unique ID of the event. Read only.
     * @returns a string
     */
    get eventId(): string | undefined;
    /**
     * Sets the eventId property value. The unique ID of the event. Read only.
     * @param value Value to set for the eventId property.
     */
    set eventId(value: string | undefined);
    /**
     * Gets the eventLocation property value. The location of the event.
     * @returns a location
     */
    get eventLocation(): Location | undefined;
    /**
     * Sets the eventLocation property value. The location of the event.
     * @param value Value to set for the eventLocation property.
     */
    set eventLocation(value: Location | undefined);
    /**
     * Gets the eventStartTime property value. The date, time, and time zone that the event starts.
     * @returns a dateTimeTimeZone
     */
    get eventStartTime(): DateTimeTimeZone | undefined;
    /**
     * Sets the eventStartTime property value. The date, time, and time zone that the event starts.
     * @param value Value to set for the eventStartTime property.
     */
    set eventStartTime(value: DateTimeTimeZone | undefined);
    /**
     * Gets the eventSubject property value. The text of the event's subject line.
     * @returns a string
     */
    get eventSubject(): string | undefined;
    /**
     * Sets the eventSubject property value. The text of the event's subject line.
     * @param value Value to set for the eventSubject property.
     */
    set eventSubject(value: string | undefined);
    /**
     * Gets the eventWebLink property value. The URL to open the event in Outlook on the web.The event will open in the browser if you are logged in to your mailbox via Outlook on the web. You will be prompted to login if you are not already logged in with the browser.This URL cannot be accessed from within an iFrame.
     * @returns a string
     */
    get eventWebLink(): string | undefined;
    /**
     * Sets the eventWebLink property value. The URL to open the event in Outlook on the web.The event will open in the browser if you are logged in to your mailbox via Outlook on the web. You will be prompted to login if you are not already logged in with the browser.This URL cannot be accessed from within an iFrame.
     * @param value Value to set for the eventWebLink property.
     */
    set eventWebLink(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the reminderFireTime property value. The date, time, and time zone that the reminder is set to occur.
     * @returns a dateTimeTimeZone
     */
    get reminderFireTime(): DateTimeTimeZone | undefined;
    /**
     * Sets the reminderFireTime property value. The date, time, and time zone that the reminder is set to occur.
     * @param value Value to set for the reminderFireTime property.
     */
    set reminderFireTime(value: DateTimeTimeZone | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
