"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RemoteItem = void 0;
const createFileFromDiscriminatorValue_1 = require("./createFileFromDiscriminatorValue");
const createFileSystemInfoFromDiscriminatorValue_1 = require("./createFileSystemInfoFromDiscriminatorValue");
const createFolderFromDiscriminatorValue_1 = require("./createFolderFromDiscriminatorValue");
const createIdentitySetFromDiscriminatorValue_1 = require("./createIdentitySetFromDiscriminatorValue");
const createImageFromDiscriminatorValue_1 = require("./createImageFromDiscriminatorValue");
const createItemReferenceFromDiscriminatorValue_1 = require("./createItemReferenceFromDiscriminatorValue");
const createPackageFromDiscriminatorValue_1 = require("./createPackageFromDiscriminatorValue");
const createSharedFromDiscriminatorValue_1 = require("./createSharedFromDiscriminatorValue");
const createSharepointIdsFromDiscriminatorValue_1 = require("./createSharepointIdsFromDiscriminatorValue");
const createSpecialFolderFromDiscriminatorValue_1 = require("./createSpecialFolderFromDiscriminatorValue");
const createVideoFromDiscriminatorValue_1 = require("./createVideoFromDiscriminatorValue");
class RemoteItem {
    /**
     * Instantiates a new remoteItem and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the createdBy property value. Identity of the user, device, and application which created the item. Read-only.
     * @returns a identitySet
     */
    get createdBy() {
        return this._createdBy;
    }
    ;
    /**
     * Sets the createdBy property value. Identity of the user, device, and application which created the item. Read-only.
     * @param value Value to set for the createdBy property.
     */
    set createdBy(value) {
        this._createdBy = value;
    }
    ;
    /**
     * Gets the createdDateTime property value. Date and time of item creation. Read-only.
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. Date and time of item creation. Read-only.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * Gets the file property value. Indicates that the remote item is a file. Read-only.
     * @returns a file
     */
    get file() {
        return this._file;
    }
    ;
    /**
     * Sets the file property value. Indicates that the remote item is a file. Read-only.
     * @param value Value to set for the file property.
     */
    set file(value) {
        this._file = value;
    }
    ;
    /**
     * Gets the fileSystemInfo property value. Information about the remote item from the local file system. Read-only.
     * @returns a fileSystemInfo
     */
    get fileSystemInfo() {
        return this._fileSystemInfo;
    }
    ;
    /**
     * Sets the fileSystemInfo property value. Information about the remote item from the local file system. Read-only.
     * @param value Value to set for the fileSystemInfo property.
     */
    set fileSystemInfo(value) {
        this._fileSystemInfo = value;
    }
    ;
    /**
     * Gets the folder property value. Indicates that the remote item is a folder. Read-only.
     * @returns a folder
     */
    get folder() {
        return this._folder;
    }
    ;
    /**
     * Sets the folder property value. Indicates that the remote item is a folder. Read-only.
     * @param value Value to set for the folder property.
     */
    set folder(value) {
        this._folder = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "createdBy": (o, n) => { o.createdBy = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); },
            "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); },
            "file": (o, n) => { o.file = n.getObjectValue(createFileFromDiscriminatorValue_1.createFileFromDiscriminatorValue); },
            "fileSystemInfo": (o, n) => { o.fileSystemInfo = n.getObjectValue(createFileSystemInfoFromDiscriminatorValue_1.createFileSystemInfoFromDiscriminatorValue); },
            "folder": (o, n) => { o.folder = n.getObjectValue(createFolderFromDiscriminatorValue_1.createFolderFromDiscriminatorValue); },
            "id": (o, n) => { o.id = n.getStringValue(); },
            "image": (o, n) => { o.image = n.getObjectValue(createImageFromDiscriminatorValue_1.createImageFromDiscriminatorValue); },
            "lastModifiedBy": (o, n) => { o.lastModifiedBy = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); },
            "lastModifiedDateTime": (o, n) => { o.lastModifiedDateTime = n.getDateValue(); },
            "name": (o, n) => { o.name = n.getStringValue(); },
            "package": (o, n) => { o.package = n.getObjectValue(createPackageFromDiscriminatorValue_1.createPackageFromDiscriminatorValue); },
            "parentReference": (o, n) => { o.parentReference = n.getObjectValue(createItemReferenceFromDiscriminatorValue_1.createItemReferenceFromDiscriminatorValue); },
            "shared": (o, n) => { o.shared = n.getObjectValue(createSharedFromDiscriminatorValue_1.createSharedFromDiscriminatorValue); },
            "sharepointIds": (o, n) => { o.sharepointIds = n.getObjectValue(createSharepointIdsFromDiscriminatorValue_1.createSharepointIdsFromDiscriminatorValue); },
            "size": (o, n) => { o.size = n.getNumberValue(); },
            "specialFolder": (o, n) => { o.specialFolder = n.getObjectValue(createSpecialFolderFromDiscriminatorValue_1.createSpecialFolderFromDiscriminatorValue); },
            "video": (o, n) => { o.video = n.getObjectValue(createVideoFromDiscriminatorValue_1.createVideoFromDiscriminatorValue); },
            "webDavUrl": (o, n) => { o.webDavUrl = n.getStringValue(); },
            "webUrl": (o, n) => { o.webUrl = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the id property value. Unique identifier for the remote item in its drive. Read-only.
     * @returns a string
     */
    get id() {
        return this._id;
    }
    ;
    /**
     * Sets the id property value. Unique identifier for the remote item in its drive. Read-only.
     * @param value Value to set for the id property.
     */
    set id(value) {
        this._id = value;
    }
    ;
    /**
     * Gets the image property value. Image metadata, if the item is an image. Read-only.
     * @returns a image
     */
    get image() {
        return this._image;
    }
    ;
    /**
     * Sets the image property value. Image metadata, if the item is an image. Read-only.
     * @param value Value to set for the image property.
     */
    set image(value) {
        this._image = value;
    }
    ;
    /**
     * Gets the lastModifiedBy property value. Identity of the user, device, and application which last modified the item. Read-only.
     * @returns a identitySet
     */
    get lastModifiedBy() {
        return this._lastModifiedBy;
    }
    ;
    /**
     * Sets the lastModifiedBy property value. Identity of the user, device, and application which last modified the item. Read-only.
     * @param value Value to set for the lastModifiedBy property.
     */
    set lastModifiedBy(value) {
        this._lastModifiedBy = value;
    }
    ;
    /**
     * Gets the lastModifiedDateTime property value. Date and time the item was last modified. Read-only.
     * @returns a Date
     */
    get lastModifiedDateTime() {
        return this._lastModifiedDateTime;
    }
    ;
    /**
     * Sets the lastModifiedDateTime property value. Date and time the item was last modified. Read-only.
     * @param value Value to set for the lastModifiedDateTime property.
     */
    set lastModifiedDateTime(value) {
        this._lastModifiedDateTime = value;
    }
    ;
    /**
     * Gets the name property value. Optional. Filename of the remote item. Read-only.
     * @returns a string
     */
    get name() {
        return this._name;
    }
    ;
    /**
     * Sets the name property value. Optional. Filename of the remote item. Read-only.
     * @param value Value to set for the name property.
     */
    set name(value) {
        this._name = value;
    }
    ;
    /**
     * Gets the package property value. If present, indicates that this item is a package instead of a folder or file. Packages are treated like files in some contexts and folders in others. Read-only.
     * @returns a package
     */
    get package() {
        return this._package;
    }
    ;
    /**
     * Sets the package property value. If present, indicates that this item is a package instead of a folder or file. Packages are treated like files in some contexts and folders in others. Read-only.
     * @param value Value to set for the package property.
     */
    set package(value) {
        this._package = value;
    }
    ;
    /**
     * Gets the parentReference property value. Properties of the parent of the remote item. Read-only.
     * @returns a itemReference
     */
    get parentReference() {
        return this._parentReference;
    }
    ;
    /**
     * Sets the parentReference property value. Properties of the parent of the remote item. Read-only.
     * @param value Value to set for the parentReference property.
     */
    set parentReference(value) {
        this._parentReference = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("createdBy", this.createdBy);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeObjectValue("file", this.file);
        writer.writeObjectValue("fileSystemInfo", this.fileSystemInfo);
        writer.writeObjectValue("folder", this.folder);
        writer.writeStringValue("id", this.id);
        writer.writeObjectValue("image", this.image);
        writer.writeObjectValue("lastModifiedBy", this.lastModifiedBy);
        writer.writeDateValue("lastModifiedDateTime", this.lastModifiedDateTime);
        writer.writeStringValue("name", this.name);
        writer.writeObjectValue("package", this.package);
        writer.writeObjectValue("parentReference", this.parentReference);
        writer.writeObjectValue("shared", this.shared);
        writer.writeObjectValue("sharepointIds", this.sharepointIds);
        writer.writeNumberValue("size", this.size);
        writer.writeObjectValue("specialFolder", this.specialFolder);
        writer.writeObjectValue("video", this.video);
        writer.writeStringValue("webDavUrl", this.webDavUrl);
        writer.writeStringValue("webUrl", this.webUrl);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the shared property value. Indicates that the item has been shared with others and provides information about the shared state of the item. Read-only.
     * @returns a shared
     */
    get shared() {
        return this._shared;
    }
    ;
    /**
     * Sets the shared property value. Indicates that the item has been shared with others and provides information about the shared state of the item. Read-only.
     * @param value Value to set for the shared property.
     */
    set shared(value) {
        this._shared = value;
    }
    ;
    /**
     * Gets the sharepointIds property value. Provides interop between items in OneDrive for Business and SharePoint with the full set of item identifiers. Read-only.
     * @returns a sharepointIds
     */
    get sharepointIds() {
        return this._sharepointIds;
    }
    ;
    /**
     * Sets the sharepointIds property value. Provides interop between items in OneDrive for Business and SharePoint with the full set of item identifiers. Read-only.
     * @param value Value to set for the sharepointIds property.
     */
    set sharepointIds(value) {
        this._sharepointIds = value;
    }
    ;
    /**
     * Gets the size property value. Size of the remote item. Read-only.
     * @returns a int64
     */
    get size() {
        return this._size;
    }
    ;
    /**
     * Sets the size property value. Size of the remote item. Read-only.
     * @param value Value to set for the size property.
     */
    set size(value) {
        this._size = value;
    }
    ;
    /**
     * Gets the specialFolder property value. If the current item is also available as a special folder, this facet is returned. Read-only.
     * @returns a specialFolder
     */
    get specialFolder() {
        return this._specialFolder;
    }
    ;
    /**
     * Sets the specialFolder property value. If the current item is also available as a special folder, this facet is returned. Read-only.
     * @param value Value to set for the specialFolder property.
     */
    set specialFolder(value) {
        this._specialFolder = value;
    }
    ;
    /**
     * Gets the video property value. Video metadata, if the item is a video. Read-only.
     * @returns a video
     */
    get video() {
        return this._video;
    }
    ;
    /**
     * Sets the video property value. Video metadata, if the item is a video. Read-only.
     * @param value Value to set for the video property.
     */
    set video(value) {
        this._video = value;
    }
    ;
    /**
     * Gets the webDavUrl property value. DAV compatible URL for the item.
     * @returns a string
     */
    get webDavUrl() {
        return this._webDavUrl;
    }
    ;
    /**
     * Sets the webDavUrl property value. DAV compatible URL for the item.
     * @param value Value to set for the webDavUrl property.
     */
    set webDavUrl(value) {
        this._webDavUrl = value;
    }
    ;
    /**
     * Gets the webUrl property value. URL that displays the resource in the browser. Read-only.
     * @returns a string
     */
    get webUrl() {
        return this._webUrl;
    }
    ;
    /**
     * Sets the webUrl property value. URL that displays the resource in the browser. Read-only.
     * @param value Value to set for the webUrl property.
     */
    set webUrl(value) {
        this._webUrl = value;
    }
    ;
}
exports.RemoteItem = RemoteItem;
