import { Entity, IdentitySet } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class Request extends Entity implements Parsable {
    /** The identifier of the approval of the request.  */
    private _approvalId?;
    /** The request completion date time.  */
    private _completedDateTime?;
    /** The user who created this request.  */
    private _createdBy?;
    /** The request creation date time.  */
    private _createdDateTime?;
    /** Free text field to define any custom data for the request. Not used.  */
    private _customData?;
    /** The status of the request. Not nullable. The possible values are: Canceled, Denied, Failed, Granted, PendingAdminDecision, PendingApproval, PendingProvisioning, PendingScheduleCreation, Provisioned, Revoked, and ScheduleCreated. Not nullable.  */
    private _status?;
    /**
     * Gets the approvalId property value. The identifier of the approval of the request.
     * @returns a string
     */
    get approvalId(): string | undefined;
    /**
     * Sets the approvalId property value. The identifier of the approval of the request.
     * @param value Value to set for the approvalId property.
     */
    set approvalId(value: string | undefined);
    /**
     * Gets the completedDateTime property value. The request completion date time.
     * @returns a Date
     */
    get completedDateTime(): Date | undefined;
    /**
     * Sets the completedDateTime property value. The request completion date time.
     * @param value Value to set for the completedDateTime property.
     */
    set completedDateTime(value: Date | undefined);
    /**
     * Instantiates a new request and sets the default values.
     */
    constructor();
    /**
     * Gets the createdBy property value. The user who created this request.
     * @returns a identitySet
     */
    get createdBy(): IdentitySet | undefined;
    /**
     * Sets the createdBy property value. The user who created this request.
     * @param value Value to set for the createdBy property.
     */
    set createdBy(value: IdentitySet | undefined);
    /**
     * Gets the createdDateTime property value. The request creation date time.
     * @returns a Date
     */
    get createdDateTime(): Date | undefined;
    /**
     * Sets the createdDateTime property value. The request creation date time.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value: Date | undefined);
    /**
     * Gets the customData property value. Free text field to define any custom data for the request. Not used.
     * @returns a string
     */
    get customData(): string | undefined;
    /**
     * Sets the customData property value. Free text field to define any custom data for the request. Not used.
     * @param value Value to set for the customData property.
     */
    set customData(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the status property value. The status of the request. Not nullable. The possible values are: Canceled, Denied, Failed, Granted, PendingAdminDecision, PendingApproval, PendingProvisioning, PendingScheduleCreation, Provisioned, Revoked, and ScheduleCreated. Not nullable.
     * @returns a string
     */
    get status(): string | undefined;
    /**
     * Sets the status property value. The status of the request. Not nullable. The possible values are: Canceled, Denied, Failed, Granted, PendingAdminDecision, PendingApproval, PendingProvisioning, PendingScheduleCreation, Provisioned, Revoked, and ScheduleCreated. Not nullable.
     * @param value Value to set for the status property.
     */
    set status(value: string | undefined);
}
