"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RequiredResourceAccess = void 0;
const createResourceAccessFromDiscriminatorValue_1 = require("./createResourceAccessFromDiscriminatorValue");
class RequiredResourceAccess {
    /**
     * Instantiates a new requiredResourceAccess and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "resourceAccess": (o, n) => { o.resourceAccess = n.getCollectionOfObjectValues(createResourceAccessFromDiscriminatorValue_1.createResourceAccessFromDiscriminatorValue); },
            "resourceAppId": (o, n) => { o.resourceAppId = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the resourceAccess property value. The list of OAuth2.0 permission scopes and app roles that the application requires from the specified resource.
     * @returns a resourceAccess
     */
    get resourceAccess() {
        return this._resourceAccess;
    }
    ;
    /**
     * Sets the resourceAccess property value. The list of OAuth2.0 permission scopes and app roles that the application requires from the specified resource.
     * @param value Value to set for the resourceAccess property.
     */
    set resourceAccess(value) {
        this._resourceAccess = value;
    }
    ;
    /**
     * Gets the resourceAppId property value. The unique identifier for the resource that the application requires access to. This should be equal to the appId declared on the target resource application.
     * @returns a string
     */
    get resourceAppId() {
        return this._resourceAppId;
    }
    ;
    /**
     * Sets the resourceAppId property value. The unique identifier for the resource that the application requires access to. This should be equal to the appId declared on the target resource application.
     * @param value Value to set for the resourceAppId property.
     */
    set resourceAppId(value) {
        this._resourceAppId = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfObjectValues("resourceAccess", this.resourceAccess);
        writer.writeStringValue("resourceAppId", this.resourceAppId);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.RequiredResourceAccess = RequiredResourceAccess;
