"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResourceAction = void 0;
/** Set of allowed and not allowed actions for a resource.  */
class ResourceAction {
    /**
     * Instantiates a new resourceAction and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the allowedResourceActions property value. Allowed Actions
     * @returns a string
     */
    get allowedResourceActions() {
        return this._allowedResourceActions;
    }
    ;
    /**
     * Sets the allowedResourceActions property value. Allowed Actions
     * @param value Value to set for the allowedResourceActions property.
     */
    set allowedResourceActions(value) {
        this._allowedResourceActions = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "allowedResourceActions": (o, n) => { o.allowedResourceActions = n.getCollectionOfPrimitiveValues(); },
            "notAllowedResourceActions": (o, n) => { o.notAllowedResourceActions = n.getCollectionOfPrimitiveValues(); },
        };
    }
    ;
    /**
     * Gets the notAllowedResourceActions property value. Not Allowed Actions.
     * @returns a string
     */
    get notAllowedResourceActions() {
        return this._notAllowedResourceActions;
    }
    ;
    /**
     * Sets the notAllowedResourceActions property value. Not Allowed Actions.
     * @param value Value to set for the notAllowedResourceActions property.
     */
    set notAllowedResourceActions(value) {
        this._notAllowedResourceActions = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfPrimitiveValues("allowedResourceActions", this.allowedResourceActions);
        writer.writeCollectionOfPrimitiveValues("notAllowedResourceActions", this.notAllowedResourceActions);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ResourceAction = ResourceAction;
