"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResourceReference = void 0;
class ResourceReference {
    /**
     * Instantiates a new resourceReference and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "id": (o, n) => { o.id = n.getStringValue(); },
            "type": (o, n) => { o.type = n.getStringValue(); },
            "webUrl": (o, n) => { o.webUrl = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the id property value. The item's unique identifier.
     * @returns a string
     */
    get id() {
        return this._id;
    }
    ;
    /**
     * Sets the id property value. The item's unique identifier.
     * @param value Value to set for the id property.
     */
    set id(value) {
        this._id = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("id", this.id);
        writer.writeStringValue("type", this.type);
        writer.writeStringValue("webUrl", this.webUrl);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the type property value. A string value that can be used to classify the item, such as 'microsoft.graph.driveItem'
     * @returns a string
     */
    get type() {
        return this._type;
    }
    ;
    /**
     * Sets the type property value. A string value that can be used to classify the item, such as 'microsoft.graph.driveItem'
     * @param value Value to set for the type property.
     */
    set type(value) {
        this._type = value;
    }
    ;
    /**
     * Gets the webUrl property value. A URL leading to the referenced item.
     * @returns a string
     */
    get webUrl() {
        return this._webUrl;
    }
    ;
    /**
     * Sets the webUrl property value. A URL leading to the referenced item.
     * @param value Value to set for the webUrl property.
     */
    set webUrl(value) {
        this._webUrl = value;
    }
    ;
}
exports.ResourceReference = ResourceReference;
