import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ResourceSpecificPermission implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Describes the level of access that the resource-specific permission represents.  */
    private _description?;
    /** The display name for the resource-specific permission.  */
    private _displayName?;
    /** The unique identifier for the resource-specific application permission.  */
    private _id?;
    /** Indicates whether the permission is enabled.  */
    private _isEnabled?;
    /** The value of the permission.  */
    private _value?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new resourceSpecificPermission and sets the default values.
     */
    constructor();
    /**
     * Gets the description property value. Describes the level of access that the resource-specific permission represents.
     * @returns a string
     */
    get description(): string | undefined;
    /**
     * Sets the description property value. Describes the level of access that the resource-specific permission represents.
     * @param value Value to set for the description property.
     */
    set description(value: string | undefined);
    /**
     * Gets the displayName property value. The display name for the resource-specific permission.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. The display name for the resource-specific permission.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the id property value. The unique identifier for the resource-specific application permission.
     * @returns a string
     */
    get id(): string | undefined;
    /**
     * Sets the id property value. The unique identifier for the resource-specific application permission.
     * @param value Value to set for the id property.
     */
    set id(value: string | undefined);
    /**
     * Gets the isEnabled property value. Indicates whether the permission is enabled.
     * @returns a boolean
     */
    get isEnabled(): boolean | undefined;
    /**
     * Sets the isEnabled property value. Indicates whether the permission is enabled.
     * @param value Value to set for the isEnabled property.
     */
    set isEnabled(value: boolean | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the value property value. The value of the permission.
     * @returns a string
     */
    get value(): string | undefined;
    /**
     * Sets the value property value. The value of the permission.
     * @param value Value to set for the value property.
     */
    set value(value: string | undefined);
}
