import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ResultInfo implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** The result code.  */
    private _code?;
    /** The message.  */
    private _message?;
    /** The result sub-code.  */
    private _subcode?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the code property value. The result code.
     * @returns a integer
     */
    get code(): number | undefined;
    /**
     * Sets the code property value. The result code.
     * @param value Value to set for the code property.
     */
    set code(value: number | undefined);
    /**
     * Instantiates a new resultInfo and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the message property value. The message.
     * @returns a string
     */
    get message(): string | undefined;
    /**
     * Sets the message property value. The message.
     * @param value Value to set for the message property.
     */
    set message(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the subcode property value. The result sub-code.
     * @returns a integer
     */
    get subcode(): number | undefined;
    /**
     * Sets the subcode property value. The result sub-code.
     * @param value Value to set for the subcode property.
     */
    set subcode(value: number | undefined);
}
