"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResultTemplateOption = void 0;
class ResultTemplateOption {
    /**
     * Instantiates a new resultTemplateOption and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the enableResultTemplate property value. Indicates whether search display layouts are enabled. If enabled, the user will get the result template to render the search results content in the resultTemplates property of the response. The result template is based on Adaptive Cards. Optional.
     * @returns a boolean
     */
    get enableResultTemplate() {
        return this._enableResultTemplate;
    }
    ;
    /**
     * Sets the enableResultTemplate property value. Indicates whether search display layouts are enabled. If enabled, the user will get the result template to render the search results content in the resultTemplates property of the response. The result template is based on Adaptive Cards. Optional.
     * @param value Value to set for the enableResultTemplate property.
     */
    set enableResultTemplate(value) {
        this._enableResultTemplate = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "enableResultTemplate": (o, n) => { o.enableResultTemplate = n.getBooleanValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("enableResultTemplate", this.enableResultTemplate);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ResultTemplateOption = ResultTemplateOption;
