"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RgbColor = void 0;
/** Color in RGB.  */
class RgbColor {
    /**
     * Instantiates a new rgbColor and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the b property value. Blue value
     * @returns a byte
     */
    get b() {
        return this._b;
    }
    ;
    /**
     * Sets the b property value. Blue value
     * @param value Value to set for the b property.
     */
    set b(value) {
        this._b = value;
    }
    ;
    ;
    /**
     * Gets the g property value. Green value
     * @returns a byte
     */
    get g() {
        return this._g;
    }
    ;
    /**
     * Sets the g property value. Green value
     * @param value Value to set for the g property.
     */
    set g(value) {
        this._g = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "b": (o, n) => { o.b = n.getNumberValue(); },
            "g": (o, n) => { o.g = n.getNumberValue(); },
            "r": (o, n) => { o.r = n.getNumberValue(); },
        };
    }
    ;
    /**
     * Gets the r property value. Red value
     * @returns a byte
     */
    get r() {
        return this._r;
    }
    ;
    /**
     * Sets the r property value. Red value
     * @param value Value to set for the r property.
     */
    set r(value) {
        this._r = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeNumberValue("b", this.b);
        writer.writeNumberValue("g", this.g);
        writer.writeNumberValue("r", this.r);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.RgbColor = RgbColor;
