"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RiskUserActivity = void 0;
const riskDetail_1 = require("./riskDetail");
class RiskUserActivity {
    /**
     * Instantiates a new riskUserActivity and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the detail property value. Details of the detected risk. Possible values are: none, adminGeneratedTemporaryPassword, userPerformedSecuredPasswordChange, userPerformedSecuredPasswordReset, adminConfirmedSigninSafe, aiConfirmedSigninSafe, userPassedMFADrivenByRiskBasedPolicy, adminDismissedAllRiskForUser, adminConfirmedSigninCompromised, hidden, adminConfirmedUserCompromised, unknownFutureValue.
     * @returns a riskDetail
     */
    get detail() {
        return this._detail;
    }
    ;
    /**
     * Sets the detail property value. Details of the detected risk. Possible values are: none, adminGeneratedTemporaryPassword, userPerformedSecuredPasswordChange, userPerformedSecuredPasswordReset, adminConfirmedSigninSafe, aiConfirmedSigninSafe, userPassedMFADrivenByRiskBasedPolicy, adminDismissedAllRiskForUser, adminConfirmedSigninCompromised, hidden, adminConfirmedUserCompromised, unknownFutureValue.
     * @param value Value to set for the detail property.
     */
    set detail(value) {
        this._detail = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "detail": (o, n) => { o.detail = n.getEnumValue(riskDetail_1.RiskDetail); },
            "riskEventTypes": (o, n) => { o.riskEventTypes = n.getCollectionOfPrimitiveValues(); },
        };
    }
    ;
    /**
     * Gets the riskEventTypes property value. The type of risk event detected.
     * @returns a string
     */
    get riskEventTypes() {
        return this._riskEventTypes;
    }
    ;
    /**
     * Sets the riskEventTypes property value. The type of risk event detected.
     * @param value Value to set for the riskEventTypes property.
     */
    set riskEventTypes(value) {
        this._riskEventTypes = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeEnumValue("detail", this.detail);
        writer.writeCollectionOfPrimitiveValues("riskEventTypes", this.riskEventTypes);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.RiskUserActivity = RiskUserActivity;
