import { RiskUserActivity, RiskyUser } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class RiskyUserHistoryItem extends RiskyUser implements Parsable {
    /** The activity related to user risk level change.  */
    private _activity?;
    /** The id of actor that does the operation.  */
    private _initiatedBy?;
    /** The id of the user.  */
    private _userId?;
    /**
     * Gets the activity property value. The activity related to user risk level change.
     * @returns a riskUserActivity
     */
    get activity(): RiskUserActivity | undefined;
    /**
     * Sets the activity property value. The activity related to user risk level change.
     * @param value Value to set for the activity property.
     */
    set activity(value: RiskUserActivity | undefined);
    /**
     * Instantiates a new riskyUserHistoryItem and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the initiatedBy property value. The id of actor that does the operation.
     * @returns a string
     */
    get initiatedBy(): string | undefined;
    /**
     * Sets the initiatedBy property value. The id of actor that does the operation.
     * @param value Value to set for the initiatedBy property.
     */
    set initiatedBy(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the userId property value. The id of the user.
     * @returns a string
     */
    get userId(): string | undefined;
    /**
     * Sets the userId property value. The id of the user.
     * @param value Value to set for the userId property.
     */
    set userId(value: string | undefined);
}
