"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RoleAssignment = void 0;
const createRoleDefinitionFromDiscriminatorValue_1 = require("./createRoleDefinitionFromDiscriminatorValue");
const index_1 = require("./index");
class RoleAssignment extends index_1.Entity {
    /**
     * Instantiates a new roleAssignment and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the description property value. Description of the Role Assignment.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. Description of the Role Assignment.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the displayName property value. The display or friendly name of the role Assignment.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The display or friendly name of the role Assignment.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "description": (o, n) => { o.description = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "resourceScopes": (o, n) => { o.resourceScopes = n.getCollectionOfPrimitiveValues(); }, "roleDefinition": (o, n) => { o.roleDefinition = n.getObjectValue(createRoleDefinitionFromDiscriminatorValue_1.createRoleDefinitionFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the resourceScopes property value. List of ids of role scope member security groups.  These are IDs from Azure Active Directory.
     * @returns a string
     */
    get resourceScopes() {
        return this._resourceScopes;
    }
    ;
    /**
     * Sets the resourceScopes property value. List of ids of role scope member security groups.  These are IDs from Azure Active Directory.
     * @param value Value to set for the resourceScopes property.
     */
    set resourceScopes(value) {
        this._resourceScopes = value;
    }
    ;
    /**
     * Gets the roleDefinition property value. Role definition this assignment is part of.
     * @returns a roleDefinition
     */
    get roleDefinition() {
        return this._roleDefinition;
    }
    ;
    /**
     * Sets the roleDefinition property value. Role definition this assignment is part of.
     * @param value Value to set for the roleDefinition property.
     */
    set roleDefinition(value) {
        this._roleDefinition = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("description", this.description);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeCollectionOfPrimitiveValues("resourceScopes", this.resourceScopes);
        writer.writeObjectValue("roleDefinition", this.roleDefinition);
    }
    ;
}
exports.RoleAssignment = RoleAssignment;
