"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RoleManagement = void 0;
const createRbacApplicationFromDiscriminatorValue_1 = require("./createRbacApplicationFromDiscriminatorValue");
class RoleManagement {
    /**
     * Instantiates a new RoleManagement and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the directory property value. Read-only. Nullable.
     * @returns a rbacApplication
     */
    get directory() {
        return this._directory;
    }
    ;
    /**
     * Sets the directory property value. Read-only. Nullable.
     * @param value Value to set for the directory property.
     */
    set directory(value) {
        this._directory = value;
    }
    ;
    /**
     * Gets the entitlementManagement property value. Container for roles and assignments for entitlement management resources.
     * @returns a rbacApplication
     */
    get entitlementManagement() {
        return this._entitlementManagement;
    }
    ;
    /**
     * Sets the entitlementManagement property value. Container for roles and assignments for entitlement management resources.
     * @param value Value to set for the entitlementManagement property.
     */
    set entitlementManagement(value) {
        this._entitlementManagement = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "directory": (o, n) => { o.directory = n.getObjectValue(createRbacApplicationFromDiscriminatorValue_1.createRbacApplicationFromDiscriminatorValue); },
            "entitlementManagement": (o, n) => { o.entitlementManagement = n.getObjectValue(createRbacApplicationFromDiscriminatorValue_1.createRbacApplicationFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("directory", this.directory);
        writer.writeObjectValue("entitlementManagement", this.entitlementManagement);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.RoleManagement = RoleManagement;
