"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RolePermission = void 0;
const createResourceActionFromDiscriminatorValue_1 = require("./createResourceActionFromDiscriminatorValue");
/** Contains the set of ResourceActions determining the allowed and not allowed permissions for each role.  */
class RolePermission {
    /**
     * Instantiates a new rolePermission and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "resourceActions": (o, n) => { o.resourceActions = n.getCollectionOfObjectValues(createResourceActionFromDiscriminatorValue_1.createResourceActionFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the resourceActions property value. Resource Actions each containing a set of allowed and not allowed permissions.
     * @returns a resourceAction
     */
    get resourceActions() {
        return this._resourceActions;
    }
    ;
    /**
     * Sets the resourceActions property value. Resource Actions each containing a set of allowed and not allowed permissions.
     * @param value Value to set for the resourceActions property.
     */
    set resourceActions(value) {
        this._resourceActions = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfObjectValues("resourceActions", this.resourceActions);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.RolePermission = RolePermission;
