"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RubricQuality = void 0;
const createEducationItemBodyFromDiscriminatorValue_1 = require("./createEducationItemBodyFromDiscriminatorValue");
const createRubricCriterionFromDiscriminatorValue_1 = require("./createRubricCriterionFromDiscriminatorValue");
class RubricQuality {
    /**
     * Instantiates a new rubricQuality and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the criteria property value. The collection of criteria for this rubric quality.
     * @returns a rubricCriterion
     */
    get criteria() {
        return this._criteria;
    }
    ;
    /**
     * Sets the criteria property value. The collection of criteria for this rubric quality.
     * @param value Value to set for the criteria property.
     */
    set criteria(value) {
        this._criteria = value;
    }
    ;
    /**
     * Gets the description property value. The description of this rubric quality.
     * @returns a educationItemBody
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. The description of this rubric quality.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the displayName property value. The name of this rubric quality.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The name of this rubric quality.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "criteria": (o, n) => { o.criteria = n.getCollectionOfObjectValues(createRubricCriterionFromDiscriminatorValue_1.createRubricCriterionFromDiscriminatorValue); },
            "description": (o, n) => { o.description = n.getObjectValue(createEducationItemBodyFromDiscriminatorValue_1.createEducationItemBodyFromDiscriminatorValue); },
            "displayName": (o, n) => { o.displayName = n.getStringValue(); },
            "qualityId": (o, n) => { o.qualityId = n.getStringValue(); },
            "weight": (o, n) => { o.weight = n.getNumberValue(); },
        };
    }
    ;
    /**
     * Gets the qualityId property value. The ID of this resource.
     * @returns a string
     */
    get qualityId() {
        return this._qualityId;
    }
    ;
    /**
     * Sets the qualityId property value. The ID of this resource.
     * @param value Value to set for the qualityId property.
     */
    set qualityId(value) {
        this._qualityId = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfObjectValues("criteria", this.criteria);
        writer.writeObjectValue("description", this.description);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeStringValue("qualityId", this.qualityId);
        writer.writeNumberValue("weight", this.weight);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the weight property value. If present, a numerical weight for this quality.  Weights must add up to 100.
     * @returns a float
     */
    get weight() {
        return this._weight;
    }
    ;
    /**
     * Sets the weight property value. If present, a numerical weight for this quality.  Weights must add up to 100.
     * @param value Value to set for the weight property.
     */
    set weight(value) {
        this._weight = value;
    }
    ;
}
exports.RubricQuality = RubricQuality;
