import { ChangeTrackedEntity } from './index';
import { ScheduleChangeRequestActor } from './scheduleChangeRequestActor';
import { ScheduleChangeState } from './scheduleChangeState';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ScheduleChangeRequest extends ChangeTrackedEntity implements Parsable {
    private _assignedTo?;
    private _managerActionDateTime?;
    private _managerActionMessage?;
    private _managerUserId?;
    private _senderDateTime?;
    private _senderMessage?;
    private _senderUserId?;
    private _state?;
    /**
     * Gets the assignedTo property value.
     * @returns a scheduleChangeRequestActor
     */
    get assignedTo(): ScheduleChangeRequestActor | undefined;
    /**
     * Sets the assignedTo property value.
     * @param value Value to set for the assignedTo property.
     */
    set assignedTo(value: ScheduleChangeRequestActor | undefined);
    /**
     * Instantiates a new scheduleChangeRequest and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the managerActionDateTime property value.
     * @returns a Date
     */
    get managerActionDateTime(): Date | undefined;
    /**
     * Sets the managerActionDateTime property value.
     * @param value Value to set for the managerActionDateTime property.
     */
    set managerActionDateTime(value: Date | undefined);
    /**
     * Gets the managerActionMessage property value.
     * @returns a string
     */
    get managerActionMessage(): string | undefined;
    /**
     * Sets the managerActionMessage property value.
     * @param value Value to set for the managerActionMessage property.
     */
    set managerActionMessage(value: string | undefined);
    /**
     * Gets the managerUserId property value.
     * @returns a string
     */
    get managerUserId(): string | undefined;
    /**
     * Sets the managerUserId property value.
     * @param value Value to set for the managerUserId property.
     */
    set managerUserId(value: string | undefined);
    /**
     * Gets the senderDateTime property value.
     * @returns a Date
     */
    get senderDateTime(): Date | undefined;
    /**
     * Sets the senderDateTime property value.
     * @param value Value to set for the senderDateTime property.
     */
    set senderDateTime(value: Date | undefined);
    /**
     * Gets the senderMessage property value.
     * @returns a string
     */
    get senderMessage(): string | undefined;
    /**
     * Sets the senderMessage property value.
     * @param value Value to set for the senderMessage property.
     */
    set senderMessage(value: string | undefined);
    /**
     * Gets the senderUserId property value.
     * @returns a string
     */
    get senderUserId(): string | undefined;
    /**
     * Sets the senderUserId property value.
     * @param value Value to set for the senderUserId property.
     */
    set senderUserId(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the state property value.
     * @returns a scheduleChangeState
     */
    get state(): ScheduleChangeState | undefined;
    /**
     * Sets the state property value.
     * @param value Value to set for the state property.
     */
    set state(value: ScheduleChangeState | undefined);
}
