"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScheduleChangeRequest = void 0;
const index_1 = require("./index");
const scheduleChangeRequestActor_1 = require("./scheduleChangeRequestActor");
const scheduleChangeState_1 = require("./scheduleChangeState");
class ScheduleChangeRequest extends index_1.ChangeTrackedEntity {
    /**
     * Instantiates a new scheduleChangeRequest and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the assignedTo property value.
     * @returns a scheduleChangeRequestActor
     */
    get assignedTo() {
        return this._assignedTo;
    }
    ;
    /**
     * Sets the assignedTo property value.
     * @param value Value to set for the assignedTo property.
     */
    set assignedTo(value) {
        this._assignedTo = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "assignedTo": (o, n) => { o.assignedTo = n.getEnumValue(scheduleChangeRequestActor_1.ScheduleChangeRequestActor); }, "managerActionDateTime": (o, n) => { o.managerActionDateTime = n.getDateValue(); }, "managerActionMessage": (o, n) => { o.managerActionMessage = n.getStringValue(); }, "managerUserId": (o, n) => { o.managerUserId = n.getStringValue(); }, "senderDateTime": (o, n) => { o.senderDateTime = n.getDateValue(); }, "senderMessage": (o, n) => { o.senderMessage = n.getStringValue(); }, "senderUserId": (o, n) => { o.senderUserId = n.getStringValue(); }, "state": (o, n) => { o.state = n.getEnumValue(scheduleChangeState_1.ScheduleChangeState); } });
    }
    ;
    /**
     * Gets the managerActionDateTime property value.
     * @returns a Date
     */
    get managerActionDateTime() {
        return this._managerActionDateTime;
    }
    ;
    /**
     * Sets the managerActionDateTime property value.
     * @param value Value to set for the managerActionDateTime property.
     */
    set managerActionDateTime(value) {
        this._managerActionDateTime = value;
    }
    ;
    /**
     * Gets the managerActionMessage property value.
     * @returns a string
     */
    get managerActionMessage() {
        return this._managerActionMessage;
    }
    ;
    /**
     * Sets the managerActionMessage property value.
     * @param value Value to set for the managerActionMessage property.
     */
    set managerActionMessage(value) {
        this._managerActionMessage = value;
    }
    ;
    /**
     * Gets the managerUserId property value.
     * @returns a string
     */
    get managerUserId() {
        return this._managerUserId;
    }
    ;
    /**
     * Sets the managerUserId property value.
     * @param value Value to set for the managerUserId property.
     */
    set managerUserId(value) {
        this._managerUserId = value;
    }
    ;
    /**
     * Gets the senderDateTime property value.
     * @returns a Date
     */
    get senderDateTime() {
        return this._senderDateTime;
    }
    ;
    /**
     * Sets the senderDateTime property value.
     * @param value Value to set for the senderDateTime property.
     */
    set senderDateTime(value) {
        this._senderDateTime = value;
    }
    ;
    /**
     * Gets the senderMessage property value.
     * @returns a string
     */
    get senderMessage() {
        return this._senderMessage;
    }
    ;
    /**
     * Sets the senderMessage property value.
     * @param value Value to set for the senderMessage property.
     */
    set senderMessage(value) {
        this._senderMessage = value;
    }
    ;
    /**
     * Gets the senderUserId property value.
     * @returns a string
     */
    get senderUserId() {
        return this._senderUserId;
    }
    ;
    /**
     * Sets the senderUserId property value.
     * @param value Value to set for the senderUserId property.
     */
    set senderUserId(value) {
        this._senderUserId = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeEnumValue("assignedTo", this.assignedTo);
        writer.writeDateValue("managerActionDateTime", this.managerActionDateTime);
        writer.writeStringValue("managerActionMessage", this.managerActionMessage);
        writer.writeStringValue("managerUserId", this.managerUserId);
        writer.writeDateValue("senderDateTime", this.senderDateTime);
        writer.writeStringValue("senderMessage", this.senderMessage);
        writer.writeStringValue("senderUserId", this.senderUserId);
        writer.writeEnumValue("state", this.state);
    }
    ;
    /**
     * Gets the state property value.
     * @returns a scheduleChangeState
     */
    get state() {
        return this._state;
    }
    ;
    /**
     * Sets the state property value.
     * @param value Value to set for the state property.
     */
    set state(value) {
        this._state = value;
    }
    ;
}
exports.ScheduleChangeRequest = ScheduleChangeRequest;
