"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScheduleEntity = void 0;
const scheduleEntityTheme_1 = require("./scheduleEntityTheme");
class ScheduleEntity {
    /**
     * Instantiates a new scheduleEntity and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the endDateTime property value.
     * @returns a Date
     */
    get endDateTime() {
        return this._endDateTime;
    }
    ;
    /**
     * Sets the endDateTime property value.
     * @param value Value to set for the endDateTime property.
     */
    set endDateTime(value) {
        this._endDateTime = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "endDateTime": (o, n) => { o.endDateTime = n.getDateValue(); },
            "startDateTime": (o, n) => { o.startDateTime = n.getDateValue(); },
            "theme": (o, n) => { o.theme = n.getEnumValue(scheduleEntityTheme_1.ScheduleEntityTheme); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeDateValue("endDateTime", this.endDateTime);
        writer.writeDateValue("startDateTime", this.startDateTime);
        writer.writeEnumValue("theme", this.theme);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the startDateTime property value.
     * @returns a Date
     */
    get startDateTime() {
        return this._startDateTime;
    }
    ;
    /**
     * Sets the startDateTime property value.
     * @param value Value to set for the startDateTime property.
     */
    set startDateTime(value) {
        this._startDateTime = value;
    }
    ;
    /**
     * Gets the theme property value.
     * @returns a scheduleEntityTheme
     */
    get theme() {
        return this._theme;
    }
    ;
    /**
     * Sets the theme property value.
     * @param value Value to set for the theme property.
     */
    set theme(value) {
        this._theme = value;
    }
    ;
}
exports.ScheduleEntity = ScheduleEntity;
