"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScheduleInformation = void 0;
const createFreeBusyErrorFromDiscriminatorValue_1 = require("./createFreeBusyErrorFromDiscriminatorValue");
const createScheduleItemFromDiscriminatorValue_1 = require("./createScheduleItemFromDiscriminatorValue");
const createWorkingHoursFromDiscriminatorValue_1 = require("./createWorkingHoursFromDiscriminatorValue");
class ScheduleInformation {
    /**
     * Instantiates a new scheduleInformation and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the availabilityView property value. Represents a merged view of availability of all the items in scheduleItems. The view consists of time slots. Availability during each time slot is indicated with: 0= free, 1= tentative, 2= busy, 3= out of office, 4= working elsewhere.
     * @returns a string
     */
    get availabilityView() {
        return this._availabilityView;
    }
    ;
    /**
     * Sets the availabilityView property value. Represents a merged view of availability of all the items in scheduleItems. The view consists of time slots. Availability during each time slot is indicated with: 0= free, 1= tentative, 2= busy, 3= out of office, 4= working elsewhere.
     * @param value Value to set for the availabilityView property.
     */
    set availabilityView(value) {
        this._availabilityView = value;
    }
    ;
    ;
    /**
     * Gets the error property value. Error information from attempting to get the availability of the user, distribution list, or resource.
     * @returns a freeBusyError
     */
    get error_escaped() {
        return this._error_escaped;
    }
    ;
    /**
     * Sets the error property value. Error information from attempting to get the availability of the user, distribution list, or resource.
     * @param value Value to set for the error_escaped property.
     */
    set error_escaped(value) {
        this._error_escaped = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "availabilityView": (o, n) => { o.availabilityView = n.getStringValue(); },
            "error": (o, n) => { o.error_escaped = n.getObjectValue(createFreeBusyErrorFromDiscriminatorValue_1.createFreeBusyErrorFromDiscriminatorValue); },
            "scheduleId": (o, n) => { o.scheduleId = n.getStringValue(); },
            "scheduleItems": (o, n) => { o.scheduleItems = n.getCollectionOfObjectValues(createScheduleItemFromDiscriminatorValue_1.createScheduleItemFromDiscriminatorValue); },
            "workingHours": (o, n) => { o.workingHours = n.getObjectValue(createWorkingHoursFromDiscriminatorValue_1.createWorkingHoursFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the scheduleId property value. An SMTP address of the user, distribution list, or resource, identifying an instance of scheduleInformation.
     * @returns a string
     */
    get scheduleId() {
        return this._scheduleId;
    }
    ;
    /**
     * Sets the scheduleId property value. An SMTP address of the user, distribution list, or resource, identifying an instance of scheduleInformation.
     * @param value Value to set for the scheduleId property.
     */
    set scheduleId(value) {
        this._scheduleId = value;
    }
    ;
    /**
     * Gets the scheduleItems property value. Contains the items that describe the availability of the user or resource.
     * @returns a scheduleItem
     */
    get scheduleItems() {
        return this._scheduleItems;
    }
    ;
    /**
     * Sets the scheduleItems property value. Contains the items that describe the availability of the user or resource.
     * @param value Value to set for the scheduleItems property.
     */
    set scheduleItems(value) {
        this._scheduleItems = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("availabilityView", this.availabilityView);
        writer.writeObjectValue("error", this.error_escaped);
        writer.writeStringValue("scheduleId", this.scheduleId);
        writer.writeCollectionOfObjectValues("scheduleItems", this.scheduleItems);
        writer.writeObjectValue("workingHours", this.workingHours);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the workingHours property value. The days of the week and hours in a specific time zone that the user works. These are set as part of the user's mailboxSettings.
     * @returns a workingHours
     */
    get workingHours() {
        return this._workingHours;
    }
    ;
    /**
     * Sets the workingHours property value. The days of the week and hours in a specific time zone that the user works. These are set as part of the user's mailboxSettings.
     * @param value Value to set for the workingHours property.
     */
    set workingHours(value) {
        this._workingHours = value;
    }
    ;
}
exports.ScheduleInformation = ScheduleInformation;
