import { FreeBusyStatus } from './freeBusyStatus';
import { DateTimeTimeZone } from './index';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ScheduleItem implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** The date, time, and time zone that the corresponding event ends.  */
    private _end?;
    /** The sensitivity of the corresponding event. True if the event is marked private, false otherwise. Optional.  */
    private _isPrivate?;
    /** The location where the corresponding event is held or attended from. Optional.  */
    private _location?;
    /** The date, time, and time zone that the corresponding event starts.  */
    private _start?;
    /** The availability status of the user or resource during the corresponding event. The possible values are: free, tentative, busy, oof, workingElsewhere, unknown.  */
    private _status?;
    /** The corresponding event's subject line. Optional.  */
    private _subject?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new scheduleItem and sets the default values.
     */
    constructor();
    /**
     * Gets the end property value. The date, time, and time zone that the corresponding event ends.
     * @returns a dateTimeTimeZone
     */
    get end(): DateTimeTimeZone | undefined;
    /**
     * Sets the end property value. The date, time, and time zone that the corresponding event ends.
     * @param value Value to set for the end property.
     */
    set end(value: DateTimeTimeZone | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the isPrivate property value. The sensitivity of the corresponding event. True if the event is marked private, false otherwise. Optional.
     * @returns a boolean
     */
    get isPrivate(): boolean | undefined;
    /**
     * Sets the isPrivate property value. The sensitivity of the corresponding event. True if the event is marked private, false otherwise. Optional.
     * @param value Value to set for the isPrivate property.
     */
    set isPrivate(value: boolean | undefined);
    /**
     * Gets the location property value. The location where the corresponding event is held or attended from. Optional.
     * @returns a string
     */
    get location(): string | undefined;
    /**
     * Sets the location property value. The location where the corresponding event is held or attended from. Optional.
     * @param value Value to set for the location property.
     */
    set location(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the start property value. The date, time, and time zone that the corresponding event starts.
     * @returns a dateTimeTimeZone
     */
    get start(): DateTimeTimeZone | undefined;
    /**
     * Sets the start property value. The date, time, and time zone that the corresponding event starts.
     * @param value Value to set for the start property.
     */
    set start(value: DateTimeTimeZone | undefined);
    /**
     * Gets the status property value. The availability status of the user or resource during the corresponding event. The possible values are: free, tentative, busy, oof, workingElsewhere, unknown.
     * @returns a freeBusyStatus
     */
    get status(): FreeBusyStatus | undefined;
    /**
     * Sets the status property value. The availability status of the user or resource during the corresponding event. The possible values are: free, tentative, busy, oof, workingElsewhere, unknown.
     * @param value Value to set for the status property.
     */
    set status(value: FreeBusyStatus | undefined);
    /**
     * Gets the subject property value. The corresponding event's subject line. Optional.
     * @returns a string
     */
    get subject(): string | undefined;
    /**
     * Sets the subject property value. The corresponding event's subject line. Optional.
     * @param value Value to set for the subject property.
     */
    set subject(value: string | undefined);
}
