"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScheduleItem = void 0;
const createDateTimeTimeZoneFromDiscriminatorValue_1 = require("./createDateTimeTimeZoneFromDiscriminatorValue");
const freeBusyStatus_1 = require("./freeBusyStatus");
class ScheduleItem {
    /**
     * Instantiates a new scheduleItem and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the end property value. The date, time, and time zone that the corresponding event ends.
     * @returns a dateTimeTimeZone
     */
    get end() {
        return this._end;
    }
    ;
    /**
     * Sets the end property value. The date, time, and time zone that the corresponding event ends.
     * @param value Value to set for the end property.
     */
    set end(value) {
        this._end = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "end": (o, n) => { o.end = n.getObjectValue(createDateTimeTimeZoneFromDiscriminatorValue_1.createDateTimeTimeZoneFromDiscriminatorValue); },
            "isPrivate": (o, n) => { o.isPrivate = n.getBooleanValue(); },
            "location": (o, n) => { o.location = n.getStringValue(); },
            "start": (o, n) => { o.start = n.getObjectValue(createDateTimeTimeZoneFromDiscriminatorValue_1.createDateTimeTimeZoneFromDiscriminatorValue); },
            "status": (o, n) => { o.status = n.getEnumValue(freeBusyStatus_1.FreeBusyStatus); },
            "subject": (o, n) => { o.subject = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the isPrivate property value. The sensitivity of the corresponding event. True if the event is marked private, false otherwise. Optional.
     * @returns a boolean
     */
    get isPrivate() {
        return this._isPrivate;
    }
    ;
    /**
     * Sets the isPrivate property value. The sensitivity of the corresponding event. True if the event is marked private, false otherwise. Optional.
     * @param value Value to set for the isPrivate property.
     */
    set isPrivate(value) {
        this._isPrivate = value;
    }
    ;
    /**
     * Gets the location property value. The location where the corresponding event is held or attended from. Optional.
     * @returns a string
     */
    get location() {
        return this._location;
    }
    ;
    /**
     * Sets the location property value. The location where the corresponding event is held or attended from. Optional.
     * @param value Value to set for the location property.
     */
    set location(value) {
        this._location = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("end", this.end);
        writer.writeBooleanValue("isPrivate", this.isPrivate);
        writer.writeStringValue("location", this.location);
        writer.writeObjectValue("start", this.start);
        writer.writeEnumValue("status", this.status);
        writer.writeStringValue("subject", this.subject);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the start property value. The date, time, and time zone that the corresponding event starts.
     * @returns a dateTimeTimeZone
     */
    get start() {
        return this._start;
    }
    ;
    /**
     * Sets the start property value. The date, time, and time zone that the corresponding event starts.
     * @param value Value to set for the start property.
     */
    set start(value) {
        this._start = value;
    }
    ;
    /**
     * Gets the status property value. The availability status of the user or resource during the corresponding event. The possible values are: free, tentative, busy, oof, workingElsewhere, unknown.
     * @returns a freeBusyStatus
     */
    get status() {
        return this._status;
    }
    ;
    /**
     * Sets the status property value. The availability status of the user or resource during the corresponding event. The possible values are: free, tentative, busy, oof, workingElsewhere, unknown.
     * @param value Value to set for the status property.
     */
    set status(value) {
        this._status = value;
    }
    ;
    /**
     * Gets the subject property value. The corresponding event's subject line. Optional.
     * @returns a string
     */
    get subject() {
        return this._subject;
    }
    ;
    /**
     * Sets the subject property value. The corresponding event's subject line. Optional.
     * @param value Value to set for the subject property.
     */
    set subject(value) {
        this._subject = value;
    }
    ;
}
exports.ScheduleItem = ScheduleItem;
