"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScopedRoleMembership = void 0;
const createIdentityFromDiscriminatorValue_1 = require("./createIdentityFromDiscriminatorValue");
const index_1 = require("./index");
class ScopedRoleMembership extends index_1.Entity {
    /**
     * Instantiates a new scopedRoleMembership and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the administrativeUnitId property value. Unique identifier for the administrative unit that the directory role is scoped to
     * @returns a string
     */
    get administrativeUnitId() {
        return this._administrativeUnitId;
    }
    ;
    /**
     * Sets the administrativeUnitId property value. Unique identifier for the administrative unit that the directory role is scoped to
     * @param value Value to set for the administrativeUnitId property.
     */
    set administrativeUnitId(value) {
        this._administrativeUnitId = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "administrativeUnitId": (o, n) => { o.administrativeUnitId = n.getStringValue(); }, "roleId": (o, n) => { o.roleId = n.getStringValue(); }, "roleMemberInfo": (o, n) => { o.roleMemberInfo = n.getObjectValue(createIdentityFromDiscriminatorValue_1.createIdentityFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the roleId property value. Unique identifier for the directory role that the member is in.
     * @returns a string
     */
    get roleId() {
        return this._roleId;
    }
    ;
    /**
     * Sets the roleId property value. Unique identifier for the directory role that the member is in.
     * @param value Value to set for the roleId property.
     */
    set roleId(value) {
        this._roleId = value;
    }
    ;
    /**
     * Gets the roleMemberInfo property value.
     * @returns a identity
     */
    get roleMemberInfo() {
        return this._roleMemberInfo;
    }
    ;
    /**
     * Sets the roleMemberInfo property value.
     * @param value Value to set for the roleMemberInfo property.
     */
    set roleMemberInfo(value) {
        this._roleMemberInfo = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("administrativeUnitId", this.administrativeUnitId);
        writer.writeStringValue("roleId", this.roleId);
        writer.writeObjectValue("roleMemberInfo", this.roleMemberInfo);
    }
    ;
}
exports.ScopedRoleMembership = ScopedRoleMembership;
