import { SelectionLikelihoodInfo } from './selectionLikelihoodInfo';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ScoredEmailAddress implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** The email address.  */
    private _address?;
    private _itemId?;
    /** The relevance score of the email address. A relevance score is used as a sort key, in relation to the other returned results. A higher relevance score value corresponds to a more relevant result. Relevance is determined by the user’s communication and collaboration patterns and business relationships.  */
    private _relevanceScore?;
    private _selectionLikelihood?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the address property value. The email address.
     * @returns a string
     */
    get address(): string | undefined;
    /**
     * Sets the address property value. The email address.
     * @param value Value to set for the address property.
     */
    set address(value: string | undefined);
    /**
     * Instantiates a new scoredEmailAddress and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the itemId property value.
     * @returns a string
     */
    get itemId(): string | undefined;
    /**
     * Sets the itemId property value.
     * @param value Value to set for the itemId property.
     */
    set itemId(value: string | undefined);
    /**
     * Gets the relevanceScore property value. The relevance score of the email address. A relevance score is used as a sort key, in relation to the other returned results. A higher relevance score value corresponds to a more relevant result. Relevance is determined by the user’s communication and collaboration patterns and business relationships.
     * @returns a double
     */
    get relevanceScore(): number | undefined;
    /**
     * Sets the relevanceScore property value. The relevance score of the email address. A relevance score is used as a sort key, in relation to the other returned results. A higher relevance score value corresponds to a more relevant result. Relevance is determined by the user’s communication and collaboration patterns and business relationships.
     * @param value Value to set for the relevanceScore property.
     */
    set relevanceScore(value: number | undefined);
    /**
     * Gets the selectionLikelihood property value.
     * @returns a selectionLikelihoodInfo
     */
    get selectionLikelihood(): SelectionLikelihoodInfo | undefined;
    /**
     * Sets the selectionLikelihood property value.
     * @param value Value to set for the selectionLikelihood property.
     */
    set selectionLikelihood(value: SelectionLikelihoodInfo | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
