"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SearchBucket = void 0;
class SearchBucket {
    /**
     * Instantiates a new searchBucket and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the aggregationFilterToken property value. A token containing the encoded filter to aggregate search matches by the specific key value. To use the filter, pass the token as part of the aggregationFilter property in a searchRequest object, in the format '{field}:/'{aggregationFilterToken}/''. See an example.
     * @returns a string
     */
    get aggregationFilterToken() {
        return this._aggregationFilterToken;
    }
    ;
    /**
     * Sets the aggregationFilterToken property value. A token containing the encoded filter to aggregate search matches by the specific key value. To use the filter, pass the token as part of the aggregationFilter property in a searchRequest object, in the format '{field}:/'{aggregationFilterToken}/''. See an example.
     * @param value Value to set for the aggregationFilterToken property.
     */
    set aggregationFilterToken(value) {
        this._aggregationFilterToken = value;
    }
    ;
    ;
    /**
     * Gets the count property value. The approximate number of search matches that share the same value specified in the key property. Note that this number is not the exact number of matches.
     * @returns a integer
     */
    get count() {
        return this._count;
    }
    ;
    /**
     * Sets the count property value. The approximate number of search matches that share the same value specified in the key property. Note that this number is not the exact number of matches.
     * @param value Value to set for the count property.
     */
    set count(value) {
        this._count = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "aggregationFilterToken": (o, n) => { o.aggregationFilterToken = n.getStringValue(); },
            "count": (o, n) => { o.count = n.getNumberValue(); },
            "key": (o, n) => { o.key = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the key property value. The discrete value of the field that an aggregation was computed on.
     * @returns a string
     */
    get key() {
        return this._key;
    }
    ;
    /**
     * Sets the key property value. The discrete value of the field that an aggregation was computed on.
     * @param value Value to set for the key property.
     */
    set key(value) {
        this._key = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("aggregationFilterToken", this.aggregationFilterToken);
        writer.writeNumberValue("count", this.count);
        writer.writeStringValue("key", this.key);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.SearchBucket = SearchBucket;
