"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SearchHit = void 0;
const createEntityFromDiscriminatorValue_1 = require("./createEntityFromDiscriminatorValue");
class SearchHit {
    /**
     * Instantiates a new searchHit and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the contentSource property value. The name of the content source which the externalItem is part of .
     * @returns a string
     */
    get contentSource() {
        return this._contentSource;
    }
    ;
    /**
     * Sets the contentSource property value. The name of the content source which the externalItem is part of .
     * @param value Value to set for the contentSource property.
     */
    set contentSource(value) {
        this._contentSource = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "contentSource": (o, n) => { o.contentSource = n.getStringValue(); },
            "hitId": (o, n) => { o.hitId = n.getStringValue(); },
            "rank": (o, n) => { o.rank = n.getNumberValue(); },
            "resource": (o, n) => { o.resource = n.getObjectValue(createEntityFromDiscriminatorValue_1.createEntityFromDiscriminatorValue); },
            "resultTemplateId": (o, n) => { o.resultTemplateId = n.getStringValue(); },
            "summary": (o, n) => { o.summary = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the hitId property value. The internal identifier for the item.
     * @returns a string
     */
    get hitId() {
        return this._hitId;
    }
    ;
    /**
     * Sets the hitId property value. The internal identifier for the item.
     * @param value Value to set for the hitId property.
     */
    set hitId(value) {
        this._hitId = value;
    }
    ;
    /**
     * Gets the rank property value. The rank or the order of the result.
     * @returns a integer
     */
    get rank() {
        return this._rank;
    }
    ;
    /**
     * Sets the rank property value. The rank or the order of the result.
     * @param value Value to set for the rank property.
     */
    set rank(value) {
        this._rank = value;
    }
    ;
    /**
     * Gets the resource property value.
     * @returns a entity
     */
    get resource() {
        return this._resource;
    }
    ;
    /**
     * Sets the resource property value.
     * @param value Value to set for the resource property.
     */
    set resource(value) {
        this._resource = value;
    }
    ;
    /**
     * Gets the resultTemplateId property value. ID of the result template used to render the search result. This ID must map to a display layout in the resultTemplates dictionary that is also included in the searchResponse.
     * @returns a string
     */
    get resultTemplateId() {
        return this._resultTemplateId;
    }
    ;
    /**
     * Sets the resultTemplateId property value. ID of the result template used to render the search result. This ID must map to a display layout in the resultTemplates dictionary that is also included in the searchResponse.
     * @param value Value to set for the resultTemplateId property.
     */
    set resultTemplateId(value) {
        this._resultTemplateId = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("contentSource", this.contentSource);
        writer.writeStringValue("hitId", this.hitId);
        writer.writeNumberValue("rank", this.rank);
        writer.writeObjectValue("resource", this.resource);
        writer.writeStringValue("resultTemplateId", this.resultTemplateId);
        writer.writeStringValue("summary", this.summary);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the summary property value. A summary of the result, if a summary is available.
     * @returns a string
     */
    get summary() {
        return this._summary;
    }
    ;
    /**
     * Sets the summary property value. A summary of the result, if a summary is available.
     * @param value Value to set for the summary property.
     */
    set summary(value) {
        this._summary = value;
    }
    ;
}
exports.SearchHit = SearchHit;
