import { SearchAggregation, SearchHit } from './index';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class SearchHitsContainer implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Contains the collection of aggregations computed based on the provided aggregationOption specified in the request.  */
    private _aggregations?;
    /** A collection of the search results.  */
    private _hits?;
    /** Provides information if more results are available. Based on this information, you can adjust the from and size properties of the searchRequest accordingly.  */
    private _moreResultsAvailable?;
    /** The total number of results. Note this is not the number of results on the page, but the total number of results satisfying the query.  */
    private _total?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the aggregations property value. Contains the collection of aggregations computed based on the provided aggregationOption specified in the request.
     * @returns a searchAggregation
     */
    get aggregations(): SearchAggregation[] | undefined;
    /**
     * Sets the aggregations property value. Contains the collection of aggregations computed based on the provided aggregationOption specified in the request.
     * @param value Value to set for the aggregations property.
     */
    set aggregations(value: SearchAggregation[] | undefined);
    /**
     * Instantiates a new searchHitsContainer and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the hits property value. A collection of the search results.
     * @returns a searchHit
     */
    get hits(): SearchHit[] | undefined;
    /**
     * Sets the hits property value. A collection of the search results.
     * @param value Value to set for the hits property.
     */
    set hits(value: SearchHit[] | undefined);
    /**
     * Gets the moreResultsAvailable property value. Provides information if more results are available. Based on this information, you can adjust the from and size properties of the searchRequest accordingly.
     * @returns a boolean
     */
    get moreResultsAvailable(): boolean | undefined;
    /**
     * Sets the moreResultsAvailable property value. Provides information if more results are available. Based on this information, you can adjust the from and size properties of the searchRequest accordingly.
     * @param value Value to set for the moreResultsAvailable property.
     */
    set moreResultsAvailable(value: boolean | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the total property value. The total number of results. Note this is not the number of results on the page, but the total number of results satisfying the query.
     * @returns a integer
     */
    get total(): number | undefined;
    /**
     * Sets the total property value. The total number of results. Note this is not the number of results on the page, but the total number of results satisfying the query.
     * @param value Value to set for the total property.
     */
    set total(value: number | undefined);
}
