"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SearchQuery = void 0;
class SearchQuery {
    /**
     * Instantiates a new searchQuery and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "queryString": (o, n) => { o.queryString = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the queryString property value. The search query containing the search terms. Required.
     * @returns a string
     */
    get queryString() {
        return this._queryString;
    }
    ;
    /**
     * Sets the queryString property value. The search query containing the search terms. Required.
     * @param value Value to set for the queryString property.
     */
    set queryString(value) {
        this._queryString = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("queryString", this.queryString);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.SearchQuery = SearchQuery;
