"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SearchRequest = void 0;
const createAggregationOptionFromDiscriminatorValue_1 = require("./createAggregationOptionFromDiscriminatorValue");
const createResultTemplateOptionFromDiscriminatorValue_1 = require("./createResultTemplateOptionFromDiscriminatorValue");
const createSearchAlterationOptionsFromDiscriminatorValue_1 = require("./createSearchAlterationOptionsFromDiscriminatorValue");
const createSearchQueryFromDiscriminatorValue_1 = require("./createSearchQueryFromDiscriminatorValue");
const createSortPropertyFromDiscriminatorValue_1 = require("./createSortPropertyFromDiscriminatorValue");
const entityType_1 = require("./entityType");
class SearchRequest {
    /**
     * Instantiates a new searchRequest and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the aggregationFilters property value. Contains one or more filters to obtain search results aggregated and filtered to a specific value of a field. Optional.Build this filter based on a prior search that aggregates by the same field. From the response of the prior search, identify the searchBucket that filters results to the specific value of the field, use the string in its aggregationFilterToken property, and build an aggregation filter string in the format '{field}:/'{aggregationFilterToken}/''. If multiple values for the same field need to be provided, use the strings in its aggregationFilterToken property and build an aggregation filter string in the format '{field}:or(/'{aggregationFilterToken1}/',/'{aggregationFilterToken2}/')'. For example, searching and aggregating drive items by file type returns a searchBucket for the file type docx in the response. You can conveniently use the aggregationFilterToken returned for this searchBucket in a subsequent search query and filter matches down to drive items of the docx file type. Example 1 and example 2 show the actual requests and responses.
     * @returns a string
     */
    get aggregationFilters() {
        return this._aggregationFilters;
    }
    ;
    /**
     * Sets the aggregationFilters property value. Contains one or more filters to obtain search results aggregated and filtered to a specific value of a field. Optional.Build this filter based on a prior search that aggregates by the same field. From the response of the prior search, identify the searchBucket that filters results to the specific value of the field, use the string in its aggregationFilterToken property, and build an aggregation filter string in the format '{field}:/'{aggregationFilterToken}/''. If multiple values for the same field need to be provided, use the strings in its aggregationFilterToken property and build an aggregation filter string in the format '{field}:or(/'{aggregationFilterToken1}/',/'{aggregationFilterToken2}/')'. For example, searching and aggregating drive items by file type returns a searchBucket for the file type docx in the response. You can conveniently use the aggregationFilterToken returned for this searchBucket in a subsequent search query and filter matches down to drive items of the docx file type. Example 1 and example 2 show the actual requests and responses.
     * @param value Value to set for the aggregationFilters property.
     */
    set aggregationFilters(value) {
        this._aggregationFilters = value;
    }
    ;
    /**
     * Gets the aggregations property value. Specifies aggregations (also known as refiners) to be returned alongside search results. Optional.
     * @returns a aggregationOption
     */
    get aggregations() {
        return this._aggregations;
    }
    ;
    /**
     * Sets the aggregations property value. Specifies aggregations (also known as refiners) to be returned alongside search results. Optional.
     * @param value Value to set for the aggregations property.
     */
    set aggregations(value) {
        this._aggregations = value;
    }
    ;
    ;
    /**
     * Gets the contentSources property value. Contains the connection to be targeted. Respects the following format : /external/connections/connectionid where connectionid is the ConnectionId defined in the Connectors Administration.  Note: contentSource is only applicable when entityType=externalItem. Optional.
     * @returns a string
     */
    get contentSources() {
        return this._contentSources;
    }
    ;
    /**
     * Sets the contentSources property value. Contains the connection to be targeted. Respects the following format : /external/connections/connectionid where connectionid is the ConnectionId defined in the Connectors Administration.  Note: contentSource is only applicable when entityType=externalItem. Optional.
     * @param value Value to set for the contentSources property.
     */
    set contentSources(value) {
        this._contentSources = value;
    }
    ;
    /**
     * Gets the enableTopResults property value. This triggers hybrid sort for messages: the first 3 messages are the most relevant. This property is only applicable to entityType=message. Optional.
     * @returns a boolean
     */
    get enableTopResults() {
        return this._enableTopResults;
    }
    ;
    /**
     * Sets the enableTopResults property value. This triggers hybrid sort for messages: the first 3 messages are the most relevant. This property is only applicable to entityType=message. Optional.
     * @param value Value to set for the enableTopResults property.
     */
    set enableTopResults(value) {
        this._enableTopResults = value;
    }
    ;
    /**
     * Gets the entityTypes property value. One or more types of resources expected in the response. Possible values are: list, site, listItem, message, event, drive, driveItem, person, externalItem. See known limitations for those combinations of two or more entity types that are supported in the same search request. Required.
     * @returns a entityType
     */
    get entityTypes() {
        return this._entityTypes;
    }
    ;
    /**
     * Sets the entityTypes property value. One or more types of resources expected in the response. Possible values are: list, site, listItem, message, event, drive, driveItem, person, externalItem. See known limitations for those combinations of two or more entity types that are supported in the same search request. Required.
     * @param value Value to set for the entityTypes property.
     */
    set entityTypes(value) {
        this._entityTypes = value;
    }
    ;
    /**
     * Gets the fields property value. Contains the fields to be returned for each resource object specified in entityTypes, allowing customization of the fields returned by default otherwise, including additional fields such as custom managed properties from SharePoint and OneDrive, or custom fields in externalItem from content that Microsoft Graph connectors bring in. The fields property can be using the semantic labels applied to properties. For example, if a property is label as title, you can retrieve it using the following syntax : label_title.Optional.
     * @returns a string
     */
    get fields() {
        return this._fields;
    }
    ;
    /**
     * Sets the fields property value. Contains the fields to be returned for each resource object specified in entityTypes, allowing customization of the fields returned by default otherwise, including additional fields such as custom managed properties from SharePoint and OneDrive, or custom fields in externalItem from content that Microsoft Graph connectors bring in. The fields property can be using the semantic labels applied to properties. For example, if a property is label as title, you can retrieve it using the following syntax : label_title.Optional.
     * @param value Value to set for the fields property.
     */
    set fields(value) {
        this._fields = value;
    }
    ;
    /**
     * Gets the from property value. Specifies the offset for the search results. Offset 0 returns the very first result. Optional.
     * @returns a integer
     */
    get from() {
        return this._from;
    }
    ;
    /**
     * Sets the from property value. Specifies the offset for the search results. Offset 0 returns the very first result. Optional.
     * @param value Value to set for the from property.
     */
    set from(value) {
        this._from = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "aggregationFilters": (o, n) => { o.aggregationFilters = n.getCollectionOfPrimitiveValues(); },
            "aggregations": (o, n) => { o.aggregations = n.getCollectionOfObjectValues(createAggregationOptionFromDiscriminatorValue_1.createAggregationOptionFromDiscriminatorValue); },
            "contentSources": (o, n) => { o.contentSources = n.getCollectionOfPrimitiveValues(); },
            "enableTopResults": (o, n) => { o.enableTopResults = n.getBooleanValue(); },
            "entityTypes": (o, n) => { o.entityTypes = n.getEnumValues(entityType_1.EntityType); },
            "fields": (o, n) => { o.fields = n.getCollectionOfPrimitiveValues(); },
            "from": (o, n) => { o.from = n.getNumberValue(); },
            "query": (o, n) => { o.query = n.getObjectValue(createSearchQueryFromDiscriminatorValue_1.createSearchQueryFromDiscriminatorValue); },
            "queryAlterationOptions": (o, n) => { o.queryAlterationOptions = n.getObjectValue(createSearchAlterationOptionsFromDiscriminatorValue_1.createSearchAlterationOptionsFromDiscriminatorValue); },
            "resultTemplateOptions": (o, n) => { o.resultTemplateOptions = n.getObjectValue(createResultTemplateOptionFromDiscriminatorValue_1.createResultTemplateOptionFromDiscriminatorValue); },
            "size": (o, n) => { o.size = n.getNumberValue(); },
            "sortProperties": (o, n) => { o.sortProperties = n.getCollectionOfObjectValues(createSortPropertyFromDiscriminatorValue_1.createSortPropertyFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the query property value.
     * @returns a searchQuery
     */
    get query() {
        return this._query;
    }
    ;
    /**
     * Sets the query property value.
     * @param value Value to set for the query property.
     */
    set query(value) {
        this._query = value;
    }
    ;
    /**
     * Gets the queryAlterationOptions property value. Query alteration options formatted in a JSON blob that contains two optional flags related to spelling correction. Optional.
     * @returns a searchAlterationOptions
     */
    get queryAlterationOptions() {
        return this._queryAlterationOptions;
    }
    ;
    /**
     * Sets the queryAlterationOptions property value. Query alteration options formatted in a JSON blob that contains two optional flags related to spelling correction. Optional.
     * @param value Value to set for the queryAlterationOptions property.
     */
    set queryAlterationOptions(value) {
        this._queryAlterationOptions = value;
    }
    ;
    /**
     * Gets the resultTemplateOptions property value. Provides the search result templates options for rendering connectors search results.
     * @returns a resultTemplateOption
     */
    get resultTemplateOptions() {
        return this._resultTemplateOptions;
    }
    ;
    /**
     * Sets the resultTemplateOptions property value. Provides the search result templates options for rendering connectors search results.
     * @param value Value to set for the resultTemplateOptions property.
     */
    set resultTemplateOptions(value) {
        this._resultTemplateOptions = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfPrimitiveValues("aggregationFilters", this.aggregationFilters);
        writer.writeCollectionOfObjectValues("aggregations", this.aggregations);
        writer.writeCollectionOfPrimitiveValues("contentSources", this.contentSources);
        writer.writeBooleanValue("enableTopResults", this.enableTopResults);
        this.entityTypes && writer.writeEnumValue("entityTypes", ...this.entityTypes);
        writer.writeCollectionOfPrimitiveValues("fields", this.fields);
        writer.writeNumberValue("from", this.from);
        writer.writeObjectValue("query", this.query);
        writer.writeObjectValue("queryAlterationOptions", this.queryAlterationOptions);
        writer.writeObjectValue("resultTemplateOptions", this.resultTemplateOptions);
        writer.writeNumberValue("size", this.size);
        writer.writeCollectionOfObjectValues("sortProperties", this.sortProperties);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the size property value. The size of the page to be retrieved. Optional.
     * @returns a integer
     */
    get size() {
        return this._size;
    }
    ;
    /**
     * Sets the size property value. The size of the page to be retrieved. Optional.
     * @param value Value to set for the size property.
     */
    set size(value) {
        this._size = value;
    }
    ;
    /**
     * Gets the sortProperties property value. Contains the ordered collection of fields and direction to sort results. There can be at most 5 sort properties in the collection. Optional.
     * @returns a sortProperty
     */
    get sortProperties() {
        return this._sortProperties;
    }
    ;
    /**
     * Sets the sortProperties property value. Contains the ordered collection of fields and direction to sort results. There can be at most 5 sort properties in the collection. Optional.
     * @param value Value to set for the sortProperties property.
     */
    set sortProperties(value) {
        this._sortProperties = value;
    }
    ;
}
exports.SearchRequest = SearchRequest;
