"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SearchResponse = void 0;
const createAlterationResponseFromDiscriminatorValue_1 = require("./createAlterationResponseFromDiscriminatorValue");
const createResultTemplateDictionaryFromDiscriminatorValue_1 = require("./createResultTemplateDictionaryFromDiscriminatorValue");
const createSearchHitsContainerFromDiscriminatorValue_1 = require("./createSearchHitsContainerFromDiscriminatorValue");
class SearchResponse {
    /**
     * Instantiates a new searchResponse and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "hitsContainers": (o, n) => { o.hitsContainers = n.getCollectionOfObjectValues(createSearchHitsContainerFromDiscriminatorValue_1.createSearchHitsContainerFromDiscriminatorValue); },
            "queryAlterationResponse": (o, n) => { o.queryAlterationResponse = n.getObjectValue(createAlterationResponseFromDiscriminatorValue_1.createAlterationResponseFromDiscriminatorValue); },
            "resultTemplates": (o, n) => { o.resultTemplates = n.getObjectValue(createResultTemplateDictionaryFromDiscriminatorValue_1.createResultTemplateDictionaryFromDiscriminatorValue); },
            "searchTerms": (o, n) => { o.searchTerms = n.getCollectionOfPrimitiveValues(); },
        };
    }
    ;
    /**
     * Gets the hitsContainers property value. A collection of search results.
     * @returns a searchHitsContainer
     */
    get hitsContainers() {
        return this._hitsContainers;
    }
    ;
    /**
     * Sets the hitsContainers property value. A collection of search results.
     * @param value Value to set for the hitsContainers property.
     */
    set hitsContainers(value) {
        this._hitsContainers = value;
    }
    ;
    /**
     * Gets the queryAlterationResponse property value. Provides information related to spelling corrections in the alteration response.
     * @returns a alterationResponse
     */
    get queryAlterationResponse() {
        return this._queryAlterationResponse;
    }
    ;
    /**
     * Sets the queryAlterationResponse property value. Provides information related to spelling corrections in the alteration response.
     * @param value Value to set for the queryAlterationResponse property.
     */
    set queryAlterationResponse(value) {
        this._queryAlterationResponse = value;
    }
    ;
    /**
     * Gets the resultTemplates property value. A dictionary of resultTemplateIds and associated values, which include the name and JSON schema of the result templates.
     * @returns a resultTemplateDictionary
     */
    get resultTemplates() {
        return this._resultTemplates;
    }
    ;
    /**
     * Sets the resultTemplates property value. A dictionary of resultTemplateIds and associated values, which include the name and JSON schema of the result templates.
     * @param value Value to set for the resultTemplates property.
     */
    set resultTemplates(value) {
        this._resultTemplates = value;
    }
    ;
    /**
     * Gets the searchTerms property value. Contains the search terms sent in the initial search query.
     * @returns a string
     */
    get searchTerms() {
        return this._searchTerms;
    }
    ;
    /**
     * Sets the searchTerms property value. Contains the search terms sent in the initial search query.
     * @param value Value to set for the searchTerms property.
     */
    set searchTerms(value) {
        this._searchTerms = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfObjectValues("hitsContainers", this.hitsContainers);
        writer.writeObjectValue("queryAlterationResponse", this.queryAlterationResponse);
        writer.writeObjectValue("resultTemplates", this.resultTemplates);
        writer.writeCollectionOfPrimitiveValues("searchTerms", this.searchTerms);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.SearchResponse = SearchResponse;
