"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SearchResult = void 0;
class SearchResult {
    /**
     * Instantiates a new searchResult and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "onClickTelemetryUrl": (o, n) => { o.onClickTelemetryUrl = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the onClickTelemetryUrl property value. A callback URL that can be used to record telemetry information. The application should issue a GET on this URL if the user interacts with this item to improve the quality of results.
     * @returns a string
     */
    get onClickTelemetryUrl() {
        return this._onClickTelemetryUrl;
    }
    ;
    /**
     * Sets the onClickTelemetryUrl property value. A callback URL that can be used to record telemetry information. The application should issue a GET on this URL if the user interacts with this item to improve the quality of results.
     * @param value Value to set for the onClickTelemetryUrl property.
     */
    set onClickTelemetryUrl(value) {
        this._onClickTelemetryUrl = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("onClickTelemetryUrl", this.onClickTelemetryUrl);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.SearchResult = SearchResult;
