import { Notebook, OnenoteEntityHierarchyModel, OnenoteSection } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class SectionGroup extends OnenoteEntityHierarchyModel implements Parsable {
    /** The notebook that contains the section group. Read-only.  */
    private _parentNotebook?;
    /** The section group that contains the section group. Read-only.  */
    private _parentSectionGroup?;
    /** The section groups in the section. Read-only. Nullable.  */
    private _sectionGroups?;
    /** The URL for the sectionGroups navigation property, which returns all the section groups in the section group. Read-only.  */
    private _sectionGroupsUrl?;
    /** The sections in the section group. Read-only. Nullable.  */
    private _sections?;
    /** The URL for the sections navigation property, which returns all the sections in the section group. Read-only.  */
    private _sectionsUrl?;
    /**
     * Instantiates a new sectionGroup and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the parentNotebook property value. The notebook that contains the section group. Read-only.
     * @returns a notebook
     */
    get parentNotebook(): Notebook | undefined;
    /**
     * Sets the parentNotebook property value. The notebook that contains the section group. Read-only.
     * @param value Value to set for the parentNotebook property.
     */
    set parentNotebook(value: Notebook | undefined);
    /**
     * Gets the parentSectionGroup property value. The section group that contains the section group. Read-only.
     * @returns a sectionGroup
     */
    get parentSectionGroup(): SectionGroup | undefined;
    /**
     * Sets the parentSectionGroup property value. The section group that contains the section group. Read-only.
     * @param value Value to set for the parentSectionGroup property.
     */
    set parentSectionGroup(value: SectionGroup | undefined);
    /**
     * Gets the sectionGroups property value. The section groups in the section. Read-only. Nullable.
     * @returns a sectionGroup
     */
    get sectionGroups(): SectionGroup[] | undefined;
    /**
     * Sets the sectionGroups property value. The section groups in the section. Read-only. Nullable.
     * @param value Value to set for the sectionGroups property.
     */
    set sectionGroups(value: SectionGroup[] | undefined);
    /**
     * Gets the sectionGroupsUrl property value. The URL for the sectionGroups navigation property, which returns all the section groups in the section group. Read-only.
     * @returns a string
     */
    get sectionGroupsUrl(): string | undefined;
    /**
     * Sets the sectionGroupsUrl property value. The URL for the sectionGroups navigation property, which returns all the section groups in the section group. Read-only.
     * @param value Value to set for the sectionGroupsUrl property.
     */
    set sectionGroupsUrl(value: string | undefined);
    /**
     * Gets the sections property value. The sections in the section group. Read-only. Nullable.
     * @returns a onenoteSection
     */
    get sections(): OnenoteSection[] | undefined;
    /**
     * Sets the sections property value. The sections in the section group. Read-only. Nullable.
     * @param value Value to set for the sections property.
     */
    set sections(value: OnenoteSection[] | undefined);
    /**
     * Gets the sectionsUrl property value. The URL for the sections navigation property, which returns all the sections in the section group. Read-only.
     * @returns a string
     */
    get sectionsUrl(): string | undefined;
    /**
     * Sets the sectionsUrl property value. The URL for the sections navigation property, which returns all the sections in the section group. Read-only.
     * @param value Value to set for the sectionsUrl property.
     */
    set sectionsUrl(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
