"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SectionGroup = void 0;
const createNotebookFromDiscriminatorValue_1 = require("./createNotebookFromDiscriminatorValue");
const createOnenoteSectionFromDiscriminatorValue_1 = require("./createOnenoteSectionFromDiscriminatorValue");
const createSectionGroupFromDiscriminatorValue_1 = require("./createSectionGroupFromDiscriminatorValue");
const index_1 = require("./index");
class SectionGroup extends index_1.OnenoteEntityHierarchyModel {
    /**
     * Instantiates a new sectionGroup and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "parentNotebook": (o, n) => { o.parentNotebook = n.getObjectValue(createNotebookFromDiscriminatorValue_1.createNotebookFromDiscriminatorValue); }, "parentSectionGroup": (o, n) => { o.parentSectionGroup = n.getObjectValue(createSectionGroupFromDiscriminatorValue_1.createSectionGroupFromDiscriminatorValue); }, "sectionGroups": (o, n) => { o.sectionGroups = n.getCollectionOfObjectValues(createSectionGroupFromDiscriminatorValue_1.createSectionGroupFromDiscriminatorValue); }, "sectionGroupsUrl": (o, n) => { o.sectionGroupsUrl = n.getStringValue(); }, "sections": (o, n) => { o.sections = n.getCollectionOfObjectValues(createOnenoteSectionFromDiscriminatorValue_1.createOnenoteSectionFromDiscriminatorValue); }, "sectionsUrl": (o, n) => { o.sectionsUrl = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the parentNotebook property value. The notebook that contains the section group. Read-only.
     * @returns a notebook
     */
    get parentNotebook() {
        return this._parentNotebook;
    }
    ;
    /**
     * Sets the parentNotebook property value. The notebook that contains the section group. Read-only.
     * @param value Value to set for the parentNotebook property.
     */
    set parentNotebook(value) {
        this._parentNotebook = value;
    }
    ;
    /**
     * Gets the parentSectionGroup property value. The section group that contains the section group. Read-only.
     * @returns a sectionGroup
     */
    get parentSectionGroup() {
        return this._parentSectionGroup;
    }
    ;
    /**
     * Sets the parentSectionGroup property value. The section group that contains the section group. Read-only.
     * @param value Value to set for the parentSectionGroup property.
     */
    set parentSectionGroup(value) {
        this._parentSectionGroup = value;
    }
    ;
    /**
     * Gets the sectionGroups property value. The section groups in the section. Read-only. Nullable.
     * @returns a sectionGroup
     */
    get sectionGroups() {
        return this._sectionGroups;
    }
    ;
    /**
     * Sets the sectionGroups property value. The section groups in the section. Read-only. Nullable.
     * @param value Value to set for the sectionGroups property.
     */
    set sectionGroups(value) {
        this._sectionGroups = value;
    }
    ;
    /**
     * Gets the sectionGroupsUrl property value. The URL for the sectionGroups navigation property, which returns all the section groups in the section group. Read-only.
     * @returns a string
     */
    get sectionGroupsUrl() {
        return this._sectionGroupsUrl;
    }
    ;
    /**
     * Sets the sectionGroupsUrl property value. The URL for the sectionGroups navigation property, which returns all the section groups in the section group. Read-only.
     * @param value Value to set for the sectionGroupsUrl property.
     */
    set sectionGroupsUrl(value) {
        this._sectionGroupsUrl = value;
    }
    ;
    /**
     * Gets the sections property value. The sections in the section group. Read-only. Nullable.
     * @returns a onenoteSection
     */
    get sections() {
        return this._sections;
    }
    ;
    /**
     * Sets the sections property value. The sections in the section group. Read-only. Nullable.
     * @param value Value to set for the sections property.
     */
    set sections(value) {
        this._sections = value;
    }
    ;
    /**
     * Gets the sectionsUrl property value. The URL for the sections navigation property, which returns all the sections in the section group. Read-only.
     * @returns a string
     */
    get sectionsUrl() {
        return this._sectionsUrl;
    }
    ;
    /**
     * Sets the sectionsUrl property value. The URL for the sections navigation property, which returns all the sections in the section group. Read-only.
     * @param value Value to set for the sectionsUrl property.
     */
    set sectionsUrl(value) {
        this._sectionsUrl = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("parentNotebook", this.parentNotebook);
        writer.writeObjectValue("parentSectionGroup", this.parentSectionGroup);
        writer.writeCollectionOfObjectValues("sectionGroups", this.sectionGroups);
        writer.writeStringValue("sectionGroupsUrl", this.sectionGroupsUrl);
        writer.writeCollectionOfObjectValues("sections", this.sections);
        writer.writeStringValue("sectionsUrl", this.sectionsUrl);
    }
    ;
}
exports.SectionGroup = SectionGroup;
