"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SecureScore = void 0;
const createAverageComparativeScoreFromDiscriminatorValue_1 = require("./createAverageComparativeScoreFromDiscriminatorValue");
const createControlScoreFromDiscriminatorValue_1 = require("./createControlScoreFromDiscriminatorValue");
const createSecurityVendorInformationFromDiscriminatorValue_1 = require("./createSecurityVendorInformationFromDiscriminatorValue");
const index_1 = require("./index");
class SecureScore extends index_1.Entity {
    /**
     * Instantiates a new secureScore and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the activeUserCount property value. Active user count of the given tenant.
     * @returns a integer
     */
    get activeUserCount() {
        return this._activeUserCount;
    }
    ;
    /**
     * Sets the activeUserCount property value. Active user count of the given tenant.
     * @param value Value to set for the activeUserCount property.
     */
    set activeUserCount(value) {
        this._activeUserCount = value;
    }
    ;
    /**
     * Gets the averageComparativeScores property value. Average score by different scopes (for example, average by industry, average by seating) and control category (Identity, Data, Device, Apps, Infrastructure) within the scope.
     * @returns a averageComparativeScore
     */
    get averageComparativeScores() {
        return this._averageComparativeScores;
    }
    ;
    /**
     * Sets the averageComparativeScores property value. Average score by different scopes (for example, average by industry, average by seating) and control category (Identity, Data, Device, Apps, Infrastructure) within the scope.
     * @param value Value to set for the averageComparativeScores property.
     */
    set averageComparativeScores(value) {
        this._averageComparativeScores = value;
    }
    ;
    /**
     * Gets the azureTenantId property value. GUID string for tenant ID.
     * @returns a string
     */
    get azureTenantId() {
        return this._azureTenantId;
    }
    ;
    /**
     * Sets the azureTenantId property value. GUID string for tenant ID.
     * @param value Value to set for the azureTenantId property.
     */
    set azureTenantId(value) {
        this._azureTenantId = value;
    }
    ;
    ;
    /**
     * Gets the controlScores property value. Contains tenant scores for a set of controls.
     * @returns a controlScore
     */
    get controlScores() {
        return this._controlScores;
    }
    ;
    /**
     * Sets the controlScores property value. Contains tenant scores for a set of controls.
     * @param value Value to set for the controlScores property.
     */
    set controlScores(value) {
        this._controlScores = value;
    }
    ;
    /**
     * Gets the createdDateTime property value. The date when the entity is created.
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. The date when the entity is created.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * Gets the currentScore property value. Tenant current attained score on specified date.
     * @returns a double
     */
    get currentScore() {
        return this._currentScore;
    }
    ;
    /**
     * Sets the currentScore property value. Tenant current attained score on specified date.
     * @param value Value to set for the currentScore property.
     */
    set currentScore(value) {
        this._currentScore = value;
    }
    ;
    /**
     * Gets the enabledServices property value. Microsoft-provided services for the tenant (for example, Exchange online, Skype, Sharepoint).
     * @returns a string
     */
    get enabledServices() {
        return this._enabledServices;
    }
    ;
    /**
     * Sets the enabledServices property value. Microsoft-provided services for the tenant (for example, Exchange online, Skype, Sharepoint).
     * @param value Value to set for the enabledServices property.
     */
    set enabledServices(value) {
        this._enabledServices = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "activeUserCount": (o, n) => { o.activeUserCount = n.getNumberValue(); }, "averageComparativeScores": (o, n) => { o.averageComparativeScores = n.getCollectionOfObjectValues(createAverageComparativeScoreFromDiscriminatorValue_1.createAverageComparativeScoreFromDiscriminatorValue); }, "azureTenantId": (o, n) => { o.azureTenantId = n.getStringValue(); }, "controlScores": (o, n) => { o.controlScores = n.getCollectionOfObjectValues(createControlScoreFromDiscriminatorValue_1.createControlScoreFromDiscriminatorValue); }, "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); }, "currentScore": (o, n) => { o.currentScore = n.getNumberValue(); }, "enabledServices": (o, n) => { o.enabledServices = n.getCollectionOfPrimitiveValues(); }, "licensedUserCount": (o, n) => { o.licensedUserCount = n.getNumberValue(); }, "maxScore": (o, n) => { o.maxScore = n.getNumberValue(); }, "vendorInformation": (o, n) => { o.vendorInformation = n.getObjectValue(createSecurityVendorInformationFromDiscriminatorValue_1.createSecurityVendorInformationFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the licensedUserCount property value. Licensed user count of the given tenant.
     * @returns a integer
     */
    get licensedUserCount() {
        return this._licensedUserCount;
    }
    ;
    /**
     * Sets the licensedUserCount property value. Licensed user count of the given tenant.
     * @param value Value to set for the licensedUserCount property.
     */
    set licensedUserCount(value) {
        this._licensedUserCount = value;
    }
    ;
    /**
     * Gets the maxScore property value. Tenant maximum possible score on specified date.
     * @returns a double
     */
    get maxScore() {
        return this._maxScore;
    }
    ;
    /**
     * Sets the maxScore property value. Tenant maximum possible score on specified date.
     * @param value Value to set for the maxScore property.
     */
    set maxScore(value) {
        this._maxScore = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeNumberValue("activeUserCount", this.activeUserCount);
        writer.writeCollectionOfObjectValues("averageComparativeScores", this.averageComparativeScores);
        writer.writeStringValue("azureTenantId", this.azureTenantId);
        writer.writeCollectionOfObjectValues("controlScores", this.controlScores);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeNumberValue("currentScore", this.currentScore);
        writer.writeCollectionOfPrimitiveValues("enabledServices", this.enabledServices);
        writer.writeNumberValue("licensedUserCount", this.licensedUserCount);
        writer.writeNumberValue("maxScore", this.maxScore);
        writer.writeObjectValue("vendorInformation", this.vendorInformation);
    }
    ;
    /**
     * Gets the vendorInformation property value. Complex type containing details about the security product/service vendor, provider, and subprovider (for example, vendor=Microsoft; provider=SecureScore). Required.
     * @returns a securityVendorInformation
     */
    get vendorInformation() {
        return this._vendorInformation;
    }
    ;
    /**
     * Sets the vendorInformation property value. Complex type containing details about the security product/service vendor, provider, and subprovider (for example, vendor=Microsoft; provider=SecureScore). Required.
     * @param value Value to set for the vendorInformation property.
     */
    set vendorInformation(value) {
        this._vendorInformation = value;
    }
    ;
}
exports.SecureScore = SecureScore;
