"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SecureScoreControlProfile = void 0;
const createComplianceInformationFromDiscriminatorValue_1 = require("./createComplianceInformationFromDiscriminatorValue");
const createSecureScoreControlStateUpdateFromDiscriminatorValue_1 = require("./createSecureScoreControlStateUpdateFromDiscriminatorValue");
const createSecurityVendorInformationFromDiscriminatorValue_1 = require("./createSecurityVendorInformationFromDiscriminatorValue");
const index_1 = require("./index");
class SecureScoreControlProfile extends index_1.Entity {
    /**
     * Instantiates a new secureScoreControlProfile and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the actionType property value. Control action type (Config, Review, Behavior).
     * @returns a string
     */
    get actionType() {
        return this._actionType;
    }
    ;
    /**
     * Sets the actionType property value. Control action type (Config, Review, Behavior).
     * @param value Value to set for the actionType property.
     */
    set actionType(value) {
        this._actionType = value;
    }
    ;
    /**
     * Gets the actionUrl property value. URL to where the control can be actioned.
     * @returns a string
     */
    get actionUrl() {
        return this._actionUrl;
    }
    ;
    /**
     * Sets the actionUrl property value. URL to where the control can be actioned.
     * @param value Value to set for the actionUrl property.
     */
    set actionUrl(value) {
        this._actionUrl = value;
    }
    ;
    /**
     * Gets the azureTenantId property value. GUID string for tenant ID.
     * @returns a string
     */
    get azureTenantId() {
        return this._azureTenantId;
    }
    ;
    /**
     * Sets the azureTenantId property value. GUID string for tenant ID.
     * @param value Value to set for the azureTenantId property.
     */
    set azureTenantId(value) {
        this._azureTenantId = value;
    }
    ;
    /**
     * Gets the complianceInformation property value. The collection of compliance information associated with secure score control
     * @returns a complianceInformation
     */
    get complianceInformation() {
        return this._complianceInformation;
    }
    ;
    /**
     * Sets the complianceInformation property value. The collection of compliance information associated with secure score control
     * @param value Value to set for the complianceInformation property.
     */
    set complianceInformation(value) {
        this._complianceInformation = value;
    }
    ;
    ;
    /**
     * Gets the controlCategory property value. Control action category (Identity, Data, Device, Apps, Infrastructure).
     * @returns a string
     */
    get controlCategory() {
        return this._controlCategory;
    }
    ;
    /**
     * Sets the controlCategory property value. Control action category (Identity, Data, Device, Apps, Infrastructure).
     * @param value Value to set for the controlCategory property.
     */
    set controlCategory(value) {
        this._controlCategory = value;
    }
    ;
    /**
     * Gets the controlStateUpdates property value. Flag to indicate where the tenant has marked a control (ignore, thirdParty, reviewed) (supports update).
     * @returns a secureScoreControlStateUpdate
     */
    get controlStateUpdates() {
        return this._controlStateUpdates;
    }
    ;
    /**
     * Sets the controlStateUpdates property value. Flag to indicate where the tenant has marked a control (ignore, thirdParty, reviewed) (supports update).
     * @param value Value to set for the controlStateUpdates property.
     */
    set controlStateUpdates(value) {
        this._controlStateUpdates = value;
    }
    ;
    /**
     * Gets the deprecated property value. Flag to indicate if a control is depreciated.
     * @returns a boolean
     */
    get deprecated() {
        return this._deprecated;
    }
    ;
    /**
     * Sets the deprecated property value. Flag to indicate if a control is depreciated.
     * @param value Value to set for the deprecated property.
     */
    set deprecated(value) {
        this._deprecated = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "actionType": (o, n) => { o.actionType = n.getStringValue(); }, "actionUrl": (o, n) => { o.actionUrl = n.getStringValue(); }, "azureTenantId": (o, n) => { o.azureTenantId = n.getStringValue(); }, "complianceInformation": (o, n) => { o.complianceInformation = n.getCollectionOfObjectValues(createComplianceInformationFromDiscriminatorValue_1.createComplianceInformationFromDiscriminatorValue); }, "controlCategory": (o, n) => { o.controlCategory = n.getStringValue(); }, "controlStateUpdates": (o, n) => { o.controlStateUpdates = n.getCollectionOfObjectValues(createSecureScoreControlStateUpdateFromDiscriminatorValue_1.createSecureScoreControlStateUpdateFromDiscriminatorValue); }, "deprecated": (o, n) => { o.deprecated = n.getBooleanValue(); }, "implementationCost": (o, n) => { o.implementationCost = n.getStringValue(); }, "lastModifiedDateTime": (o, n) => { o.lastModifiedDateTime = n.getDateValue(); }, "maxScore": (o, n) => { o.maxScore = n.getNumberValue(); }, "rank": (o, n) => { o.rank = n.getNumberValue(); }, "remediation": (o, n) => { o.remediation = n.getStringValue(); }, "remediationImpact": (o, n) => { o.remediationImpact = n.getStringValue(); }, "service": (o, n) => { o.service = n.getStringValue(); }, "threats": (o, n) => { o.threats = n.getCollectionOfPrimitiveValues(); }, "tier": (o, n) => { o.tier = n.getStringValue(); }, "title": (o, n) => { o.title = n.getStringValue(); }, "userImpact": (o, n) => { o.userImpact = n.getStringValue(); }, "vendorInformation": (o, n) => { o.vendorInformation = n.getObjectValue(createSecurityVendorInformationFromDiscriminatorValue_1.createSecurityVendorInformationFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the implementationCost property value. Resource cost of implemmentating control (low, moderate, high).
     * @returns a string
     */
    get implementationCost() {
        return this._implementationCost;
    }
    ;
    /**
     * Sets the implementationCost property value. Resource cost of implemmentating control (low, moderate, high).
     * @param value Value to set for the implementationCost property.
     */
    set implementationCost(value) {
        this._implementationCost = value;
    }
    ;
    /**
     * Gets the lastModifiedDateTime property value. Time at which the control profile entity was last modified. The Timestamp type represents date and time
     * @returns a Date
     */
    get lastModifiedDateTime() {
        return this._lastModifiedDateTime;
    }
    ;
    /**
     * Sets the lastModifiedDateTime property value. Time at which the control profile entity was last modified. The Timestamp type represents date and time
     * @param value Value to set for the lastModifiedDateTime property.
     */
    set lastModifiedDateTime(value) {
        this._lastModifiedDateTime = value;
    }
    ;
    /**
     * Gets the maxScore property value. max attainable score for the control.
     * @returns a double
     */
    get maxScore() {
        return this._maxScore;
    }
    ;
    /**
     * Sets the maxScore property value. max attainable score for the control.
     * @param value Value to set for the maxScore property.
     */
    set maxScore(value) {
        this._maxScore = value;
    }
    ;
    /**
     * Gets the rank property value. Microsoft's stack ranking of control.
     * @returns a integer
     */
    get rank() {
        return this._rank;
    }
    ;
    /**
     * Sets the rank property value. Microsoft's stack ranking of control.
     * @param value Value to set for the rank property.
     */
    set rank(value) {
        this._rank = value;
    }
    ;
    /**
     * Gets the remediation property value. Description of what the control will help remediate.
     * @returns a string
     */
    get remediation() {
        return this._remediation;
    }
    ;
    /**
     * Sets the remediation property value. Description of what the control will help remediate.
     * @param value Value to set for the remediation property.
     */
    set remediation(value) {
        this._remediation = value;
    }
    ;
    /**
     * Gets the remediationImpact property value. Description of the impact on users of the remediation.
     * @returns a string
     */
    get remediationImpact() {
        return this._remediationImpact;
    }
    ;
    /**
     * Sets the remediationImpact property value. Description of the impact on users of the remediation.
     * @param value Value to set for the remediationImpact property.
     */
    set remediationImpact(value) {
        this._remediationImpact = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("actionType", this.actionType);
        writer.writeStringValue("actionUrl", this.actionUrl);
        writer.writeStringValue("azureTenantId", this.azureTenantId);
        writer.writeCollectionOfObjectValues("complianceInformation", this.complianceInformation);
        writer.writeStringValue("controlCategory", this.controlCategory);
        writer.writeCollectionOfObjectValues("controlStateUpdates", this.controlStateUpdates);
        writer.writeBooleanValue("deprecated", this.deprecated);
        writer.writeStringValue("implementationCost", this.implementationCost);
        writer.writeDateValue("lastModifiedDateTime", this.lastModifiedDateTime);
        writer.writeNumberValue("maxScore", this.maxScore);
        writer.writeNumberValue("rank", this.rank);
        writer.writeStringValue("remediation", this.remediation);
        writer.writeStringValue("remediationImpact", this.remediationImpact);
        writer.writeStringValue("service", this.service);
        writer.writeCollectionOfPrimitiveValues("threats", this.threats);
        writer.writeStringValue("tier", this.tier);
        writer.writeStringValue("title", this.title);
        writer.writeStringValue("userImpact", this.userImpact);
        writer.writeObjectValue("vendorInformation", this.vendorInformation);
    }
    ;
    /**
     * Gets the service property value. Service that owns the control (Exchange, Sharepoint, Azure AD).
     * @returns a string
     */
    get service() {
        return this._service;
    }
    ;
    /**
     * Sets the service property value. Service that owns the control (Exchange, Sharepoint, Azure AD).
     * @param value Value to set for the service property.
     */
    set service(value) {
        this._service = value;
    }
    ;
    /**
     * Gets the threats property value. List of threats the control mitigates (accountBreach,dataDeletion,dataExfiltration,dataSpillage,
     * @returns a string
     */
    get threats() {
        return this._threats;
    }
    ;
    /**
     * Sets the threats property value. List of threats the control mitigates (accountBreach,dataDeletion,dataExfiltration,dataSpillage,
     * @param value Value to set for the threats property.
     */
    set threats(value) {
        this._threats = value;
    }
    ;
    /**
     * Gets the tier property value. Control tier (Core, Defense in Depth, Advanced.)
     * @returns a string
     */
    get tier() {
        return this._tier;
    }
    ;
    /**
     * Sets the tier property value. Control tier (Core, Defense in Depth, Advanced.)
     * @param value Value to set for the tier property.
     */
    set tier(value) {
        this._tier = value;
    }
    ;
    /**
     * Gets the title property value. Title of the control.
     * @returns a string
     */
    get title() {
        return this._title;
    }
    ;
    /**
     * Sets the title property value. Title of the control.
     * @param value Value to set for the title property.
     */
    set title(value) {
        this._title = value;
    }
    ;
    /**
     * Gets the userImpact property value. User impact of implementing control (low, moderate, high).
     * @returns a string
     */
    get userImpact() {
        return this._userImpact;
    }
    ;
    /**
     * Sets the userImpact property value. User impact of implementing control (low, moderate, high).
     * @param value Value to set for the userImpact property.
     */
    set userImpact(value) {
        this._userImpact = value;
    }
    ;
    /**
     * Gets the vendorInformation property value.
     * @returns a securityVendorInformation
     */
    get vendorInformation() {
        return this._vendorInformation;
    }
    ;
    /**
     * Sets the vendorInformation property value.
     * @param value Value to set for the vendorInformation property.
     */
    set vendorInformation(value) {
        this._vendorInformation = value;
    }
    ;
}
exports.SecureScoreControlProfile = SecureScoreControlProfile;
