import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class SecureScoreControlStateUpdate implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Assigns the control to the user who will take the action.  */
    private _assignedTo?;
    /** Provides optional comment about the control.  */
    private _comment?;
    /** State of the control, which can be modified via a PATCH command (for example, ignored, thirdParty).  */
    private _state?;
    /** ID of the user who updated tenant state.  */
    private _updatedBy?;
    /** Time at which the control state was updated.  */
    private _updatedDateTime?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the assignedTo property value. Assigns the control to the user who will take the action.
     * @returns a string
     */
    get assignedTo(): string | undefined;
    /**
     * Sets the assignedTo property value. Assigns the control to the user who will take the action.
     * @param value Value to set for the assignedTo property.
     */
    set assignedTo(value: string | undefined);
    /**
     * Gets the comment property value. Provides optional comment about the control.
     * @returns a string
     */
    get comment(): string | undefined;
    /**
     * Sets the comment property value. Provides optional comment about the control.
     * @param value Value to set for the comment property.
     */
    set comment(value: string | undefined);
    /**
     * Instantiates a new secureScoreControlStateUpdate and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the state property value. State of the control, which can be modified via a PATCH command (for example, ignored, thirdParty).
     * @returns a string
     */
    get state(): string | undefined;
    /**
     * Sets the state property value. State of the control, which can be modified via a PATCH command (for example, ignored, thirdParty).
     * @param value Value to set for the state property.
     */
    set state(value: string | undefined);
    /**
     * Gets the updatedBy property value. ID of the user who updated tenant state.
     * @returns a string
     */
    get updatedBy(): string | undefined;
    /**
     * Sets the updatedBy property value. ID of the user who updated tenant state.
     * @param value Value to set for the updatedBy property.
     */
    set updatedBy(value: string | undefined);
    /**
     * Gets the updatedDateTime property value. Time at which the control state was updated.
     * @returns a Date
     */
    get updatedDateTime(): Date | undefined;
    /**
     * Sets the updatedDateTime property value. Time at which the control state was updated.
     * @param value Value to set for the updatedDateTime property.
     */
    set updatedDateTime(value: Date | undefined);
}
