import { Alert, Entity, SecureScore, SecureScoreControlProfile } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to manage the security singleton.  */
export declare class Security extends Entity implements Parsable {
    /** Read-only. Nullable.  */
    private _alerts?;
    private _secureScoreControlProfiles?;
    private _secureScores?;
    /**
     * Gets the alerts property value. Read-only. Nullable.
     * @returns a alert
     */
    get alerts(): Alert[] | undefined;
    /**
     * Sets the alerts property value. Read-only. Nullable.
     * @param value Value to set for the alerts property.
     */
    set alerts(value: Alert[] | undefined);
    /**
     * Instantiates a new security and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the secureScoreControlProfiles property value.
     * @returns a secureScoreControlProfile
     */
    get secureScoreControlProfiles(): SecureScoreControlProfile[] | undefined;
    /**
     * Sets the secureScoreControlProfiles property value.
     * @param value Value to set for the secureScoreControlProfiles property.
     */
    set secureScoreControlProfiles(value: SecureScoreControlProfile[] | undefined);
    /**
     * Gets the secureScores property value.
     * @returns a secureScore
     */
    get secureScores(): SecureScore[] | undefined;
    /**
     * Sets the secureScores property value.
     * @param value Value to set for the secureScores property.
     */
    set secureScores(value: SecureScore[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
