import { Entity, ServiceHealth, ServiceHealthIssue, ServiceUpdateMessage } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ServiceAnnouncement extends Entity implements Parsable {
    /** A collection of service health information for tenant. This property is a contained navigation property, it is nullable and readonly.  */
    private _healthOverviews?;
    /** A collection of service issues for tenant. This property is a contained navigation property, it is nullable and readonly.  */
    private _issues?;
    /** A collection of service messages for tenant. This property is a contained navigation property, it is nullable and readonly.  */
    private _messages?;
    /**
     * Instantiates a new serviceAnnouncement and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the healthOverviews property value. A collection of service health information for tenant. This property is a contained navigation property, it is nullable and readonly.
     * @returns a serviceHealth
     */
    get healthOverviews(): ServiceHealth[] | undefined;
    /**
     * Sets the healthOverviews property value. A collection of service health information for tenant. This property is a contained navigation property, it is nullable and readonly.
     * @param value Value to set for the healthOverviews property.
     */
    set healthOverviews(value: ServiceHealth[] | undefined);
    /**
     * Gets the issues property value. A collection of service issues for tenant. This property is a contained navigation property, it is nullable and readonly.
     * @returns a serviceHealthIssue
     */
    get issues(): ServiceHealthIssue[] | undefined;
    /**
     * Sets the issues property value. A collection of service issues for tenant. This property is a contained navigation property, it is nullable and readonly.
     * @param value Value to set for the issues property.
     */
    set issues(value: ServiceHealthIssue[] | undefined);
    /**
     * Gets the messages property value. A collection of service messages for tenant. This property is a contained navigation property, it is nullable and readonly.
     * @returns a serviceUpdateMessage
     */
    get messages(): ServiceUpdateMessage[] | undefined;
    /**
     * Sets the messages property value. A collection of service messages for tenant. This property is a contained navigation property, it is nullable and readonly.
     * @param value Value to set for the messages property.
     */
    set messages(value: ServiceUpdateMessage[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
