"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServiceAnnouncement = void 0;
const createServiceHealthFromDiscriminatorValue_1 = require("./createServiceHealthFromDiscriminatorValue");
const createServiceHealthIssueFromDiscriminatorValue_1 = require("./createServiceHealthIssueFromDiscriminatorValue");
const createServiceUpdateMessageFromDiscriminatorValue_1 = require("./createServiceUpdateMessageFromDiscriminatorValue");
const index_1 = require("./index");
class ServiceAnnouncement extends index_1.Entity {
    /**
     * Instantiates a new serviceAnnouncement and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "healthOverviews": (o, n) => { o.healthOverviews = n.getCollectionOfObjectValues(createServiceHealthFromDiscriminatorValue_1.createServiceHealthFromDiscriminatorValue); }, "issues": (o, n) => { o.issues = n.getCollectionOfObjectValues(createServiceHealthIssueFromDiscriminatorValue_1.createServiceHealthIssueFromDiscriminatorValue); }, "messages": (o, n) => { o.messages = n.getCollectionOfObjectValues(createServiceUpdateMessageFromDiscriminatorValue_1.createServiceUpdateMessageFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the healthOverviews property value. A collection of service health information for tenant. This property is a contained navigation property, it is nullable and readonly.
     * @returns a serviceHealth
     */
    get healthOverviews() {
        return this._healthOverviews;
    }
    ;
    /**
     * Sets the healthOverviews property value. A collection of service health information for tenant. This property is a contained navigation property, it is nullable and readonly.
     * @param value Value to set for the healthOverviews property.
     */
    set healthOverviews(value) {
        this._healthOverviews = value;
    }
    ;
    /**
     * Gets the issues property value. A collection of service issues for tenant. This property is a contained navigation property, it is nullable and readonly.
     * @returns a serviceHealthIssue
     */
    get issues() {
        return this._issues;
    }
    ;
    /**
     * Sets the issues property value. A collection of service issues for tenant. This property is a contained navigation property, it is nullable and readonly.
     * @param value Value to set for the issues property.
     */
    set issues(value) {
        this._issues = value;
    }
    ;
    /**
     * Gets the messages property value. A collection of service messages for tenant. This property is a contained navigation property, it is nullable and readonly.
     * @returns a serviceUpdateMessage
     */
    get messages() {
        return this._messages;
    }
    ;
    /**
     * Sets the messages property value. A collection of service messages for tenant. This property is a contained navigation property, it is nullable and readonly.
     * @param value Value to set for the messages property.
     */
    set messages(value) {
        this._messages = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("healthOverviews", this.healthOverviews);
        writer.writeCollectionOfObjectValues("issues", this.issues);
        writer.writeCollectionOfObjectValues("messages", this.messages);
    }
    ;
}
exports.ServiceAnnouncement = ServiceAnnouncement;
