import { Entity, KeyValuePair } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ServiceAnnouncementBase extends Entity implements Parsable {
    /** Additional details about service event. This property doesn't support filters.  */
    private _details?;
    /** The end time of the service event.  */
    private _endDateTime?;
    /** The last modified time of the service event.  */
    private _lastModifiedDateTime?;
    /** The start time of the service event.  */
    private _startDateTime?;
    /** The title of the service event.  */
    private _title?;
    /**
     * Instantiates a new serviceAnnouncementBase and sets the default values.
     */
    constructor();
    /**
     * Gets the details property value. Additional details about service event. This property doesn't support filters.
     * @returns a keyValuePair
     */
    get details(): KeyValuePair[] | undefined;
    /**
     * Sets the details property value. Additional details about service event. This property doesn't support filters.
     * @param value Value to set for the details property.
     */
    set details(value: KeyValuePair[] | undefined);
    /**
     * Gets the endDateTime property value. The end time of the service event.
     * @returns a Date
     */
    get endDateTime(): Date | undefined;
    /**
     * Sets the endDateTime property value. The end time of the service event.
     * @param value Value to set for the endDateTime property.
     */
    set endDateTime(value: Date | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the lastModifiedDateTime property value. The last modified time of the service event.
     * @returns a Date
     */
    get lastModifiedDateTime(): Date | undefined;
    /**
     * Sets the lastModifiedDateTime property value. The last modified time of the service event.
     * @param value Value to set for the lastModifiedDateTime property.
     */
    set lastModifiedDateTime(value: Date | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the startDateTime property value. The start time of the service event.
     * @returns a Date
     */
    get startDateTime(): Date | undefined;
    /**
     * Sets the startDateTime property value. The start time of the service event.
     * @param value Value to set for the startDateTime property.
     */
    set startDateTime(value: Date | undefined);
    /**
     * Gets the title property value. The title of the service event.
     * @returns a string
     */
    get title(): string | undefined;
    /**
     * Sets the title property value. The title of the service event.
     * @param value Value to set for the title property.
     */
    set title(value: string | undefined);
}
