"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServicePrincipal = void 0;
const createAddInFromDiscriminatorValue_1 = require("./createAddInFromDiscriminatorValue");
const createAppRoleAssignmentFromDiscriminatorValue_1 = require("./createAppRoleAssignmentFromDiscriminatorValue");
const createAppRoleFromDiscriminatorValue_1 = require("./createAppRoleFromDiscriminatorValue");
const createClaimsMappingPolicyFromDiscriminatorValue_1 = require("./createClaimsMappingPolicyFromDiscriminatorValue");
const createDelegatedPermissionClassificationFromDiscriminatorValue_1 = require("./createDelegatedPermissionClassificationFromDiscriminatorValue");
const createDirectoryObjectFromDiscriminatorValue_1 = require("./createDirectoryObjectFromDiscriminatorValue");
const createEndpointFromDiscriminatorValue_1 = require("./createEndpointFromDiscriminatorValue");
const createHomeRealmDiscoveryPolicyFromDiscriminatorValue_1 = require("./createHomeRealmDiscoveryPolicyFromDiscriminatorValue");
const createInformationalUrlFromDiscriminatorValue_1 = require("./createInformationalUrlFromDiscriminatorValue");
const createKeyCredentialFromDiscriminatorValue_1 = require("./createKeyCredentialFromDiscriminatorValue");
const createOAuth2PermissionGrantFromDiscriminatorValue_1 = require("./createOAuth2PermissionGrantFromDiscriminatorValue");
const createPasswordCredentialFromDiscriminatorValue_1 = require("./createPasswordCredentialFromDiscriminatorValue");
const createPermissionScopeFromDiscriminatorValue_1 = require("./createPermissionScopeFromDiscriminatorValue");
const createResourceSpecificPermissionFromDiscriminatorValue_1 = require("./createResourceSpecificPermissionFromDiscriminatorValue");
const createSamlSingleSignOnSettingsFromDiscriminatorValue_1 = require("./createSamlSingleSignOnSettingsFromDiscriminatorValue");
const createTokenIssuancePolicyFromDiscriminatorValue_1 = require("./createTokenIssuancePolicyFromDiscriminatorValue");
const createTokenLifetimePolicyFromDiscriminatorValue_1 = require("./createTokenLifetimePolicyFromDiscriminatorValue");
const index_1 = require("./index");
class ServicePrincipal extends index_1.DirectoryObject {
    /**
     * Instantiates a new servicePrincipal and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the accountEnabled property value. true if the service principal account is enabled; otherwise, false. Supports $filter (eq, ne, not, in).
     * @returns a boolean
     */
    get accountEnabled() {
        return this._accountEnabled;
    }
    ;
    /**
     * Sets the accountEnabled property value. true if the service principal account is enabled; otherwise, false. Supports $filter (eq, ne, not, in).
     * @param value Value to set for the accountEnabled property.
     */
    set accountEnabled(value) {
        this._accountEnabled = value;
    }
    ;
    /**
     * Gets the addIns property value. Defines custom behavior that a consuming service can use to call an app in specific contexts. For example, applications that can render file streams may set the addIns property for its 'FileHandler' functionality. This will let services like Microsoft 365 call the application in the context of a document the user is working on.
     * @returns a addIn
     */
    get addIns() {
        return this._addIns;
    }
    ;
    /**
     * Sets the addIns property value. Defines custom behavior that a consuming service can use to call an app in specific contexts. For example, applications that can render file streams may set the addIns property for its 'FileHandler' functionality. This will let services like Microsoft 365 call the application in the context of a document the user is working on.
     * @param value Value to set for the addIns property.
     */
    set addIns(value) {
        this._addIns = value;
    }
    ;
    /**
     * Gets the alternativeNames property value. Used to retrieve service principals by subscription, identify resource group and full resource ids for managed identities. Supports $filter (eq, not, ge, le, startsWith).
     * @returns a string
     */
    get alternativeNames() {
        return this._alternativeNames;
    }
    ;
    /**
     * Sets the alternativeNames property value. Used to retrieve service principals by subscription, identify resource group and full resource ids for managed identities. Supports $filter (eq, not, ge, le, startsWith).
     * @param value Value to set for the alternativeNames property.
     */
    set alternativeNames(value) {
        this._alternativeNames = value;
    }
    ;
    /**
     * Gets the appDescription property value. The description exposed by the associated application.
     * @returns a string
     */
    get appDescription() {
        return this._appDescription;
    }
    ;
    /**
     * Sets the appDescription property value. The description exposed by the associated application.
     * @param value Value to set for the appDescription property.
     */
    set appDescription(value) {
        this._appDescription = value;
    }
    ;
    /**
     * Gets the appDisplayName property value. The display name exposed by the associated application.
     * @returns a string
     */
    get appDisplayName() {
        return this._appDisplayName;
    }
    ;
    /**
     * Sets the appDisplayName property value. The display name exposed by the associated application.
     * @param value Value to set for the appDisplayName property.
     */
    set appDisplayName(value) {
        this._appDisplayName = value;
    }
    ;
    /**
     * Gets the appId property value. The unique identifier for the associated application (its appId property). Supports $filter (eq, ne, not, in, startsWith).
     * @returns a string
     */
    get appId() {
        return this._appId;
    }
    ;
    /**
     * Sets the appId property value. The unique identifier for the associated application (its appId property). Supports $filter (eq, ne, not, in, startsWith).
     * @param value Value to set for the appId property.
     */
    set appId(value) {
        this._appId = value;
    }
    ;
    /**
     * Gets the applicationTemplateId property value. Unique identifier of the applicationTemplate that the servicePrincipal was created from. Read-only. Supports $filter (eq, ne, NOT, startsWith).
     * @returns a string
     */
    get applicationTemplateId() {
        return this._applicationTemplateId;
    }
    ;
    /**
     * Sets the applicationTemplateId property value. Unique identifier of the applicationTemplate that the servicePrincipal was created from. Read-only. Supports $filter (eq, ne, NOT, startsWith).
     * @param value Value to set for the applicationTemplateId property.
     */
    set applicationTemplateId(value) {
        this._applicationTemplateId = value;
    }
    ;
    /**
     * Gets the appOwnerOrganizationId property value. Contains the tenant id where the application is registered. This is applicable only to service principals backed by applications. Supports $filter (eq, ne, NOT, ge, le).
     * @returns a string
     */
    get appOwnerOrganizationId() {
        return this._appOwnerOrganizationId;
    }
    ;
    /**
     * Sets the appOwnerOrganizationId property value. Contains the tenant id where the application is registered. This is applicable only to service principals backed by applications. Supports $filter (eq, ne, NOT, ge, le).
     * @param value Value to set for the appOwnerOrganizationId property.
     */
    set appOwnerOrganizationId(value) {
        this._appOwnerOrganizationId = value;
    }
    ;
    /**
     * Gets the appRoleAssignedTo property value. App role assignments for this app or service, granted to users, groups, and other service principals. Supports $expand.
     * @returns a appRoleAssignment
     */
    get appRoleAssignedTo() {
        return this._appRoleAssignedTo;
    }
    ;
    /**
     * Sets the appRoleAssignedTo property value. App role assignments for this app or service, granted to users, groups, and other service principals. Supports $expand.
     * @param value Value to set for the appRoleAssignedTo property.
     */
    set appRoleAssignedTo(value) {
        this._appRoleAssignedTo = value;
    }
    ;
    /**
     * Gets the appRoleAssignmentRequired property value. Specifies whether users or other service principals need to be granted an app role assignment for this service principal before users can sign in or apps can get tokens. The default value is false. Not nullable. Supports $filter (eq, ne, NOT).
     * @returns a boolean
     */
    get appRoleAssignmentRequired() {
        return this._appRoleAssignmentRequired;
    }
    ;
    /**
     * Sets the appRoleAssignmentRequired property value. Specifies whether users or other service principals need to be granted an app role assignment for this service principal before users can sign in or apps can get tokens. The default value is false. Not nullable. Supports $filter (eq, ne, NOT).
     * @param value Value to set for the appRoleAssignmentRequired property.
     */
    set appRoleAssignmentRequired(value) {
        this._appRoleAssignmentRequired = value;
    }
    ;
    /**
     * Gets the appRoleAssignments property value. App role assignment for another app or service, granted to this service principal. Supports $expand.
     * @returns a appRoleAssignment
     */
    get appRoleAssignments() {
        return this._appRoleAssignments;
    }
    ;
    /**
     * Sets the appRoleAssignments property value. App role assignment for another app or service, granted to this service principal. Supports $expand.
     * @param value Value to set for the appRoleAssignments property.
     */
    set appRoleAssignments(value) {
        this._appRoleAssignments = value;
    }
    ;
    /**
     * Gets the appRoles property value. The roles exposed by the application which this service principal represents. For more information see the appRoles property definition on the application entity. Not nullable.
     * @returns a appRole
     */
    get appRoles() {
        return this._appRoles;
    }
    ;
    /**
     * Sets the appRoles property value. The roles exposed by the application which this service principal represents. For more information see the appRoles property definition on the application entity. Not nullable.
     * @param value Value to set for the appRoles property.
     */
    set appRoles(value) {
        this._appRoles = value;
    }
    ;
    /**
     * Gets the claimsMappingPolicies property value. The claimsMappingPolicies assigned to this service principal. Supports $expand.
     * @returns a claimsMappingPolicy
     */
    get claimsMappingPolicies() {
        return this._claimsMappingPolicies;
    }
    ;
    /**
     * Sets the claimsMappingPolicies property value. The claimsMappingPolicies assigned to this service principal. Supports $expand.
     * @param value Value to set for the claimsMappingPolicies property.
     */
    set claimsMappingPolicies(value) {
        this._claimsMappingPolicies = value;
    }
    ;
    ;
    /**
     * Gets the createdObjects property value. Directory objects created by this service principal. Read-only. Nullable.
     * @returns a directoryObject
     */
    get createdObjects() {
        return this._createdObjects;
    }
    ;
    /**
     * Sets the createdObjects property value. Directory objects created by this service principal. Read-only. Nullable.
     * @param value Value to set for the createdObjects property.
     */
    set createdObjects(value) {
        this._createdObjects = value;
    }
    ;
    /**
     * Gets the delegatedPermissionClassifications property value. The permission classifications for delegated permissions exposed by the app that this service principal represents. Supports $expand.
     * @returns a delegatedPermissionClassification
     */
    get delegatedPermissionClassifications() {
        return this._delegatedPermissionClassifications;
    }
    ;
    /**
     * Sets the delegatedPermissionClassifications property value. The permission classifications for delegated permissions exposed by the app that this service principal represents. Supports $expand.
     * @param value Value to set for the delegatedPermissionClassifications property.
     */
    set delegatedPermissionClassifications(value) {
        this._delegatedPermissionClassifications = value;
    }
    ;
    /**
     * Gets the description property value. Free text field to provide an internal end-user facing description of the service principal. End-user portals such MyApps will display the application description in this field. The maximum allowed size is 1024 characters. Supports $filter (eq, ne, not, ge, le, startsWith) and $search.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. Free text field to provide an internal end-user facing description of the service principal. End-user portals such MyApps will display the application description in this field. The maximum allowed size is 1024 characters. Supports $filter (eq, ne, not, ge, le, startsWith) and $search.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the disabledByMicrosoftStatus property value. Specifies whether Microsoft has disabled the registered application. Possible values are: null (default value), NotDisabled, and DisabledDueToViolationOfServicesAgreement (reasons may include suspicious, abusive, or malicious activity, or a violation of the Microsoft Services Agreement).  Supports $filter (eq, ne, not).
     * @returns a string
     */
    get disabledByMicrosoftStatus() {
        return this._disabledByMicrosoftStatus;
    }
    ;
    /**
     * Sets the disabledByMicrosoftStatus property value. Specifies whether Microsoft has disabled the registered application. Possible values are: null (default value), NotDisabled, and DisabledDueToViolationOfServicesAgreement (reasons may include suspicious, abusive, or malicious activity, or a violation of the Microsoft Services Agreement).  Supports $filter (eq, ne, not).
     * @param value Value to set for the disabledByMicrosoftStatus property.
     */
    set disabledByMicrosoftStatus(value) {
        this._disabledByMicrosoftStatus = value;
    }
    ;
    /**
     * Gets the displayName property value. The display name for the service principal. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values), $search, and $orderBy.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The display name for the service principal. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values), $search, and $orderBy.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * Gets the endpoints property value. Endpoints available for discovery. Services like Sharepoint populate this property with a tenant specific SharePoint endpoints that other applications can discover and use in their experiences.
     * @returns a endpoint
     */
    get endpoints() {
        return this._endpoints;
    }
    ;
    /**
     * Sets the endpoints property value. Endpoints available for discovery. Services like Sharepoint populate this property with a tenant specific SharePoint endpoints that other applications can discover and use in their experiences.
     * @param value Value to set for the endpoints property.
     */
    set endpoints(value) {
        this._endpoints = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "accountEnabled": (o, n) => { o.accountEnabled = n.getBooleanValue(); }, "addIns": (o, n) => { o.addIns = n.getCollectionOfObjectValues(createAddInFromDiscriminatorValue_1.createAddInFromDiscriminatorValue); }, "alternativeNames": (o, n) => { o.alternativeNames = n.getCollectionOfPrimitiveValues(); }, "appDescription": (o, n) => { o.appDescription = n.getStringValue(); }, "appDisplayName": (o, n) => { o.appDisplayName = n.getStringValue(); }, "appId": (o, n) => { o.appId = n.getStringValue(); }, "applicationTemplateId": (o, n) => { o.applicationTemplateId = n.getStringValue(); }, "appOwnerOrganizationId": (o, n) => { o.appOwnerOrganizationId = n.getStringValue(); }, "appRoleAssignedTo": (o, n) => { o.appRoleAssignedTo = n.getCollectionOfObjectValues(createAppRoleAssignmentFromDiscriminatorValue_1.createAppRoleAssignmentFromDiscriminatorValue); }, "appRoleAssignmentRequired": (o, n) => { o.appRoleAssignmentRequired = n.getBooleanValue(); }, "appRoleAssignments": (o, n) => { o.appRoleAssignments = n.getCollectionOfObjectValues(createAppRoleAssignmentFromDiscriminatorValue_1.createAppRoleAssignmentFromDiscriminatorValue); }, "appRoles": (o, n) => { o.appRoles = n.getCollectionOfObjectValues(createAppRoleFromDiscriminatorValue_1.createAppRoleFromDiscriminatorValue); }, "claimsMappingPolicies": (o, n) => { o.claimsMappingPolicies = n.getCollectionOfObjectValues(createClaimsMappingPolicyFromDiscriminatorValue_1.createClaimsMappingPolicyFromDiscriminatorValue); }, "createdObjects": (o, n) => { o.createdObjects = n.getCollectionOfObjectValues(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "delegatedPermissionClassifications": (o, n) => { o.delegatedPermissionClassifications = n.getCollectionOfObjectValues(createDelegatedPermissionClassificationFromDiscriminatorValue_1.createDelegatedPermissionClassificationFromDiscriminatorValue); }, "description": (o, n) => { o.description = n.getStringValue(); }, "disabledByMicrosoftStatus": (o, n) => { o.disabledByMicrosoftStatus = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "endpoints": (o, n) => { o.endpoints = n.getCollectionOfObjectValues(createEndpointFromDiscriminatorValue_1.createEndpointFromDiscriminatorValue); }, "homepage": (o, n) => { o.homepage = n.getStringValue(); }, "homeRealmDiscoveryPolicies": (o, n) => { o.homeRealmDiscoveryPolicies = n.getCollectionOfObjectValues(createHomeRealmDiscoveryPolicyFromDiscriminatorValue_1.createHomeRealmDiscoveryPolicyFromDiscriminatorValue); }, "info": (o, n) => { o.info = n.getObjectValue(createInformationalUrlFromDiscriminatorValue_1.createInformationalUrlFromDiscriminatorValue); }, "keyCredentials": (o, n) => { o.keyCredentials = n.getCollectionOfObjectValues(createKeyCredentialFromDiscriminatorValue_1.createKeyCredentialFromDiscriminatorValue); }, "loginUrl": (o, n) => { o.loginUrl = n.getStringValue(); }, "logoutUrl": (o, n) => { o.logoutUrl = n.getStringValue(); }, "memberOf": (o, n) => { o.memberOf = n.getCollectionOfObjectValues(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "notes": (o, n) => { o.notes = n.getStringValue(); }, "notificationEmailAddresses": (o, n) => { o.notificationEmailAddresses = n.getCollectionOfPrimitiveValues(); }, "oauth2PermissionGrants": (o, n) => { o.oauth2PermissionGrants = n.getCollectionOfObjectValues(createOAuth2PermissionGrantFromDiscriminatorValue_1.createOAuth2PermissionGrantFromDiscriminatorValue); }, "oauth2PermissionScopes": (o, n) => { o.oauth2PermissionScopes = n.getCollectionOfObjectValues(createPermissionScopeFromDiscriminatorValue_1.createPermissionScopeFromDiscriminatorValue); }, "ownedObjects": (o, n) => { o.ownedObjects = n.getCollectionOfObjectValues(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "owners": (o, n) => { o.owners = n.getCollectionOfObjectValues(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "passwordCredentials": (o, n) => { o.passwordCredentials = n.getCollectionOfObjectValues(createPasswordCredentialFromDiscriminatorValue_1.createPasswordCredentialFromDiscriminatorValue); }, "preferredSingleSignOnMode": (o, n) => { o.preferredSingleSignOnMode = n.getStringValue(); }, "preferredTokenSigningKeyThumbprint": (o, n) => { o.preferredTokenSigningKeyThumbprint = n.getStringValue(); }, "replyUrls": (o, n) => { o.replyUrls = n.getCollectionOfPrimitiveValues(); }, "resourceSpecificApplicationPermissions": (o, n) => { o.resourceSpecificApplicationPermissions = n.getCollectionOfObjectValues(createResourceSpecificPermissionFromDiscriminatorValue_1.createResourceSpecificPermissionFromDiscriminatorValue); }, "samlSingleSignOnSettings": (o, n) => { o.samlSingleSignOnSettings = n.getObjectValue(createSamlSingleSignOnSettingsFromDiscriminatorValue_1.createSamlSingleSignOnSettingsFromDiscriminatorValue); }, "servicePrincipalNames": (o, n) => { o.servicePrincipalNames = n.getCollectionOfPrimitiveValues(); }, "servicePrincipalType": (o, n) => { o.servicePrincipalType = n.getStringValue(); }, "signInAudience": (o, n) => { o.signInAudience = n.getStringValue(); }, "tags": (o, n) => { o.tags = n.getCollectionOfPrimitiveValues(); }, "tokenEncryptionKeyId": (o, n) => { o.tokenEncryptionKeyId = n.getStringValue(); }, "tokenIssuancePolicies": (o, n) => { o.tokenIssuancePolicies = n.getCollectionOfObjectValues(createTokenIssuancePolicyFromDiscriminatorValue_1.createTokenIssuancePolicyFromDiscriminatorValue); }, "tokenLifetimePolicies": (o, n) => { o.tokenLifetimePolicies = n.getCollectionOfObjectValues(createTokenLifetimePolicyFromDiscriminatorValue_1.createTokenLifetimePolicyFromDiscriminatorValue); }, "transitiveMemberOf": (o, n) => { o.transitiveMemberOf = n.getCollectionOfObjectValues(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the homepage property value. Home page or landing page of the application.
     * @returns a string
     */
    get homepage() {
        return this._homepage;
    }
    ;
    /**
     * Sets the homepage property value. Home page or landing page of the application.
     * @param value Value to set for the homepage property.
     */
    set homepage(value) {
        this._homepage = value;
    }
    ;
    /**
     * Gets the homeRealmDiscoveryPolicies property value. The homeRealmDiscoveryPolicies assigned to this service principal. Supports $expand.
     * @returns a homeRealmDiscoveryPolicy
     */
    get homeRealmDiscoveryPolicies() {
        return this._homeRealmDiscoveryPolicies;
    }
    ;
    /**
     * Sets the homeRealmDiscoveryPolicies property value. The homeRealmDiscoveryPolicies assigned to this service principal. Supports $expand.
     * @param value Value to set for the homeRealmDiscoveryPolicies property.
     */
    set homeRealmDiscoveryPolicies(value) {
        this._homeRealmDiscoveryPolicies = value;
    }
    ;
    /**
     * Gets the info property value. Basic profile information of the acquired application such as app's marketing, support, terms of service and privacy statement URLs. The terms of service and privacy statement are surfaced to users through the user consent experience. For more info, see How to: Add Terms of service and privacy statement for registered Azure AD apps. Supports $filter (eq, ne, not, ge, le, and eq on null values).
     * @returns a informationalUrl
     */
    get info() {
        return this._info;
    }
    ;
    /**
     * Sets the info property value. Basic profile information of the acquired application such as app's marketing, support, terms of service and privacy statement URLs. The terms of service and privacy statement are surfaced to users through the user consent experience. For more info, see How to: Add Terms of service and privacy statement for registered Azure AD apps. Supports $filter (eq, ne, not, ge, le, and eq on null values).
     * @param value Value to set for the info property.
     */
    set info(value) {
        this._info = value;
    }
    ;
    /**
     * Gets the keyCredentials property value. The collection of key credentials associated with the service principal. Not nullable. Supports $filter (eq, not, ge, le).
     * @returns a keyCredential
     */
    get keyCredentials() {
        return this._keyCredentials;
    }
    ;
    /**
     * Sets the keyCredentials property value. The collection of key credentials associated with the service principal. Not nullable. Supports $filter (eq, not, ge, le).
     * @param value Value to set for the keyCredentials property.
     */
    set keyCredentials(value) {
        this._keyCredentials = value;
    }
    ;
    /**
     * Gets the loginUrl property value. Specifies the URL where the service provider redirects the user to Azure AD to authenticate. Azure AD uses the URL to launch the application from Microsoft 365 or the Azure AD My Apps. When blank, Azure AD performs IdP-initiated sign-on for applications configured with SAML-based single sign-on. The user launches the application from Microsoft 365, the Azure AD My Apps, or the Azure AD SSO URL.
     * @returns a string
     */
    get loginUrl() {
        return this._loginUrl;
    }
    ;
    /**
     * Sets the loginUrl property value. Specifies the URL where the service provider redirects the user to Azure AD to authenticate. Azure AD uses the URL to launch the application from Microsoft 365 or the Azure AD My Apps. When blank, Azure AD performs IdP-initiated sign-on for applications configured with SAML-based single sign-on. The user launches the application from Microsoft 365, the Azure AD My Apps, or the Azure AD SSO URL.
     * @param value Value to set for the loginUrl property.
     */
    set loginUrl(value) {
        this._loginUrl = value;
    }
    ;
    /**
     * Gets the logoutUrl property value. Specifies the URL that will be used by Microsoft's authorization service to logout an user using OpenId Connect front-channel, back-channel or SAML logout protocols.
     * @returns a string
     */
    get logoutUrl() {
        return this._logoutUrl;
    }
    ;
    /**
     * Sets the logoutUrl property value. Specifies the URL that will be used by Microsoft's authorization service to logout an user using OpenId Connect front-channel, back-channel or SAML logout protocols.
     * @param value Value to set for the logoutUrl property.
     */
    set logoutUrl(value) {
        this._logoutUrl = value;
    }
    ;
    /**
     * Gets the memberOf property value. Roles that this service principal is a member of. HTTP Methods: GET Read-only. Nullable. Supports $expand.
     * @returns a directoryObject
     */
    get memberOf() {
        return this._memberOf;
    }
    ;
    /**
     * Sets the memberOf property value. Roles that this service principal is a member of. HTTP Methods: GET Read-only. Nullable. Supports $expand.
     * @param value Value to set for the memberOf property.
     */
    set memberOf(value) {
        this._memberOf = value;
    }
    ;
    /**
     * Gets the notes property value. Free text field to capture information about the service principal, typically used for operational purposes. Maximum allowed size is 1024 characters.
     * @returns a string
     */
    get notes() {
        return this._notes;
    }
    ;
    /**
     * Sets the notes property value. Free text field to capture information about the service principal, typically used for operational purposes. Maximum allowed size is 1024 characters.
     * @param value Value to set for the notes property.
     */
    set notes(value) {
        this._notes = value;
    }
    ;
    /**
     * Gets the notificationEmailAddresses property value. Specifies the list of email addresses where Azure AD sends a notification when the active certificate is near the expiration date. This is only for the certificates used to sign the SAML token issued for Azure AD Gallery applications.
     * @returns a string
     */
    get notificationEmailAddresses() {
        return this._notificationEmailAddresses;
    }
    ;
    /**
     * Sets the notificationEmailAddresses property value. Specifies the list of email addresses where Azure AD sends a notification when the active certificate is near the expiration date. This is only for the certificates used to sign the SAML token issued for Azure AD Gallery applications.
     * @param value Value to set for the notificationEmailAddresses property.
     */
    set notificationEmailAddresses(value) {
        this._notificationEmailAddresses = value;
    }
    ;
    /**
     * Gets the oauth2PermissionGrants property value. Delegated permission grants authorizing this service principal to access an API on behalf of a signed-in user. Read-only. Nullable.
     * @returns a oAuth2PermissionGrant
     */
    get oauth2PermissionGrants() {
        return this._oauth2PermissionGrants;
    }
    ;
    /**
     * Sets the oauth2PermissionGrants property value. Delegated permission grants authorizing this service principal to access an API on behalf of a signed-in user. Read-only. Nullable.
     * @param value Value to set for the oauth2PermissionGrants property.
     */
    set oauth2PermissionGrants(value) {
        this._oauth2PermissionGrants = value;
    }
    ;
    /**
     * Gets the oauth2PermissionScopes property value. The delegated permissions exposed by the application. For more information see the oauth2PermissionScopes property on the application entity's api property. Not nullable.
     * @returns a permissionScope
     */
    get oauth2PermissionScopes() {
        return this._oauth2PermissionScopes;
    }
    ;
    /**
     * Sets the oauth2PermissionScopes property value. The delegated permissions exposed by the application. For more information see the oauth2PermissionScopes property on the application entity's api property. Not nullable.
     * @param value Value to set for the oauth2PermissionScopes property.
     */
    set oauth2PermissionScopes(value) {
        this._oauth2PermissionScopes = value;
    }
    ;
    /**
     * Gets the ownedObjects property value. Directory objects that are owned by this service principal. Read-only. Nullable. Supports $expand.
     * @returns a directoryObject
     */
    get ownedObjects() {
        return this._ownedObjects;
    }
    ;
    /**
     * Sets the ownedObjects property value. Directory objects that are owned by this service principal. Read-only. Nullable. Supports $expand.
     * @param value Value to set for the ownedObjects property.
     */
    set ownedObjects(value) {
        this._ownedObjects = value;
    }
    ;
    /**
     * Gets the owners property value. Directory objects that are owners of this servicePrincipal. The owners are a set of non-admin users or servicePrincipals who are allowed to modify this object. Read-only. Nullable. Supports $expand.
     * @returns a directoryObject
     */
    get owners() {
        return this._owners;
    }
    ;
    /**
     * Sets the owners property value. Directory objects that are owners of this servicePrincipal. The owners are a set of non-admin users or servicePrincipals who are allowed to modify this object. Read-only. Nullable. Supports $expand.
     * @param value Value to set for the owners property.
     */
    set owners(value) {
        this._owners = value;
    }
    ;
    /**
     * Gets the passwordCredentials property value. The collection of password credentials associated with the application. Not nullable.
     * @returns a passwordCredential
     */
    get passwordCredentials() {
        return this._passwordCredentials;
    }
    ;
    /**
     * Sets the passwordCredentials property value. The collection of password credentials associated with the application. Not nullable.
     * @param value Value to set for the passwordCredentials property.
     */
    set passwordCredentials(value) {
        this._passwordCredentials = value;
    }
    ;
    /**
     * Gets the preferredSingleSignOnMode property value. Specifies the single sign-on mode configured for this application. Azure AD uses the preferred single sign-on mode to launch the application from Microsoft 365 or the Azure AD My Apps. The supported values are password, saml, notSupported, and oidc.
     * @returns a string
     */
    get preferredSingleSignOnMode() {
        return this._preferredSingleSignOnMode;
    }
    ;
    /**
     * Sets the preferredSingleSignOnMode property value. Specifies the single sign-on mode configured for this application. Azure AD uses the preferred single sign-on mode to launch the application from Microsoft 365 or the Azure AD My Apps. The supported values are password, saml, notSupported, and oidc.
     * @param value Value to set for the preferredSingleSignOnMode property.
     */
    set preferredSingleSignOnMode(value) {
        this._preferredSingleSignOnMode = value;
    }
    ;
    /**
     * Gets the preferredTokenSigningKeyThumbprint property value. Reserved for internal use only. Do not write or otherwise rely on this property. May be removed in future versions.
     * @returns a string
     */
    get preferredTokenSigningKeyThumbprint() {
        return this._preferredTokenSigningKeyThumbprint;
    }
    ;
    /**
     * Sets the preferredTokenSigningKeyThumbprint property value. Reserved for internal use only. Do not write or otherwise rely on this property. May be removed in future versions.
     * @param value Value to set for the preferredTokenSigningKeyThumbprint property.
     */
    set preferredTokenSigningKeyThumbprint(value) {
        this._preferredTokenSigningKeyThumbprint = value;
    }
    ;
    /**
     * Gets the replyUrls property value. The URLs that user tokens are sent to for sign in with the associated application, or the redirect URIs that OAuth 2.0 authorization codes and access tokens are sent to for the associated application. Not nullable.
     * @returns a string
     */
    get replyUrls() {
        return this._replyUrls;
    }
    ;
    /**
     * Sets the replyUrls property value. The URLs that user tokens are sent to for sign in with the associated application, or the redirect URIs that OAuth 2.0 authorization codes and access tokens are sent to for the associated application. Not nullable.
     * @param value Value to set for the replyUrls property.
     */
    set replyUrls(value) {
        this._replyUrls = value;
    }
    ;
    /**
     * Gets the resourceSpecificApplicationPermissions property value. The resource-specific application permissions exposed by this application. Currently, resource-specific permissions are only supported for Teams apps accessing to specific chats and teams using Microsoft Graph. Read-only.
     * @returns a resourceSpecificPermission
     */
    get resourceSpecificApplicationPermissions() {
        return this._resourceSpecificApplicationPermissions;
    }
    ;
    /**
     * Sets the resourceSpecificApplicationPermissions property value. The resource-specific application permissions exposed by this application. Currently, resource-specific permissions are only supported for Teams apps accessing to specific chats and teams using Microsoft Graph. Read-only.
     * @param value Value to set for the resourceSpecificApplicationPermissions property.
     */
    set resourceSpecificApplicationPermissions(value) {
        this._resourceSpecificApplicationPermissions = value;
    }
    ;
    /**
     * Gets the samlSingleSignOnSettings property value. The collection for settings related to saml single sign-on.
     * @returns a samlSingleSignOnSettings
     */
    get samlSingleSignOnSettings() {
        return this._samlSingleSignOnSettings;
    }
    ;
    /**
     * Sets the samlSingleSignOnSettings property value. The collection for settings related to saml single sign-on.
     * @param value Value to set for the samlSingleSignOnSettings property.
     */
    set samlSingleSignOnSettings(value) {
        this._samlSingleSignOnSettings = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeBooleanValue("accountEnabled", this.accountEnabled);
        writer.writeCollectionOfObjectValues("addIns", this.addIns);
        writer.writeCollectionOfPrimitiveValues("alternativeNames", this.alternativeNames);
        writer.writeStringValue("appDescription", this.appDescription);
        writer.writeStringValue("appDisplayName", this.appDisplayName);
        writer.writeStringValue("appId", this.appId);
        writer.writeStringValue("applicationTemplateId", this.applicationTemplateId);
        writer.writeStringValue("appOwnerOrganizationId", this.appOwnerOrganizationId);
        writer.writeCollectionOfObjectValues("appRoleAssignedTo", this.appRoleAssignedTo);
        writer.writeBooleanValue("appRoleAssignmentRequired", this.appRoleAssignmentRequired);
        writer.writeCollectionOfObjectValues("appRoleAssignments", this.appRoleAssignments);
        writer.writeCollectionOfObjectValues("appRoles", this.appRoles);
        writer.writeCollectionOfObjectValues("claimsMappingPolicies", this.claimsMappingPolicies);
        writer.writeCollectionOfObjectValues("createdObjects", this.createdObjects);
        writer.writeCollectionOfObjectValues("delegatedPermissionClassifications", this.delegatedPermissionClassifications);
        writer.writeStringValue("description", this.description);
        writer.writeStringValue("disabledByMicrosoftStatus", this.disabledByMicrosoftStatus);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeCollectionOfObjectValues("endpoints", this.endpoints);
        writer.writeStringValue("homepage", this.homepage);
        writer.writeCollectionOfObjectValues("homeRealmDiscoveryPolicies", this.homeRealmDiscoveryPolicies);
        writer.writeObjectValue("info", this.info);
        writer.writeCollectionOfObjectValues("keyCredentials", this.keyCredentials);
        writer.writeStringValue("loginUrl", this.loginUrl);
        writer.writeStringValue("logoutUrl", this.logoutUrl);
        writer.writeCollectionOfObjectValues("memberOf", this.memberOf);
        writer.writeStringValue("notes", this.notes);
        writer.writeCollectionOfPrimitiveValues("notificationEmailAddresses", this.notificationEmailAddresses);
        writer.writeCollectionOfObjectValues("oauth2PermissionGrants", this.oauth2PermissionGrants);
        writer.writeCollectionOfObjectValues("oauth2PermissionScopes", this.oauth2PermissionScopes);
        writer.writeCollectionOfObjectValues("ownedObjects", this.ownedObjects);
        writer.writeCollectionOfObjectValues("owners", this.owners);
        writer.writeCollectionOfObjectValues("passwordCredentials", this.passwordCredentials);
        writer.writeStringValue("preferredSingleSignOnMode", this.preferredSingleSignOnMode);
        writer.writeStringValue("preferredTokenSigningKeyThumbprint", this.preferredTokenSigningKeyThumbprint);
        writer.writeCollectionOfPrimitiveValues("replyUrls", this.replyUrls);
        writer.writeCollectionOfObjectValues("resourceSpecificApplicationPermissions", this.resourceSpecificApplicationPermissions);
        writer.writeObjectValue("samlSingleSignOnSettings", this.samlSingleSignOnSettings);
        writer.writeCollectionOfPrimitiveValues("servicePrincipalNames", this.servicePrincipalNames);
        writer.writeStringValue("servicePrincipalType", this.servicePrincipalType);
        writer.writeStringValue("signInAudience", this.signInAudience);
        writer.writeCollectionOfPrimitiveValues("tags", this.tags);
        writer.writeStringValue("tokenEncryptionKeyId", this.tokenEncryptionKeyId);
        writer.writeCollectionOfObjectValues("tokenIssuancePolicies", this.tokenIssuancePolicies);
        writer.writeCollectionOfObjectValues("tokenLifetimePolicies", this.tokenLifetimePolicies);
        writer.writeCollectionOfObjectValues("transitiveMemberOf", this.transitiveMemberOf);
    }
    ;
    /**
     * Gets the servicePrincipalNames property value. Contains the list of identifiersUris, copied over from the associated application. Additional values can be added to hybrid applications. These values can be used to identify the permissions exposed by this app within Azure AD. For example,Client apps can specify a resource URI which is based on the values of this property to acquire an access token, which is the URI returned in the 'aud' claim.The any operator is required for filter expressions on multi-valued properties. Not nullable.  Supports $filter (eq, not, ge, le, startsWith).
     * @returns a string
     */
    get servicePrincipalNames() {
        return this._servicePrincipalNames;
    }
    ;
    /**
     * Sets the servicePrincipalNames property value. Contains the list of identifiersUris, copied over from the associated application. Additional values can be added to hybrid applications. These values can be used to identify the permissions exposed by this app within Azure AD. For example,Client apps can specify a resource URI which is based on the values of this property to acquire an access token, which is the URI returned in the 'aud' claim.The any operator is required for filter expressions on multi-valued properties. Not nullable.  Supports $filter (eq, not, ge, le, startsWith).
     * @param value Value to set for the servicePrincipalNames property.
     */
    set servicePrincipalNames(value) {
        this._servicePrincipalNames = value;
    }
    ;
    /**
     * Gets the servicePrincipalType property value. Identifies whether the service principal represents an application, a managed identity, or a legacy application. This is set by Azure AD internally. The servicePrincipalType property can be set to three different values: __Application - A service principal that represents an application or service. The appId property identifies the associated app registration, and matches the appId of an application, possibly from a different tenant. If the associated app registration is missing, tokens are not issued for the service principal.__ManagedIdentity - A service principal that represents a managed identity. Service principals representing managed identities can be granted access and permissions, but cannot be updated or modified directly.__Legacy - A service principal that represents an app created before app registrations, or through legacy experiences. Legacy service principal can have credentials, service principal names, reply URLs, and other properties which are editable by an authorized user, but does not have an associated app registration. The appId value does not associate the service principal with an app registration. The service principal can only be used in the tenant where it was created.__SocialIdp - For internal use.
     * @returns a string
     */
    get servicePrincipalType() {
        return this._servicePrincipalType;
    }
    ;
    /**
     * Sets the servicePrincipalType property value. Identifies whether the service principal represents an application, a managed identity, or a legacy application. This is set by Azure AD internally. The servicePrincipalType property can be set to three different values: __Application - A service principal that represents an application or service. The appId property identifies the associated app registration, and matches the appId of an application, possibly from a different tenant. If the associated app registration is missing, tokens are not issued for the service principal.__ManagedIdentity - A service principal that represents a managed identity. Service principals representing managed identities can be granted access and permissions, but cannot be updated or modified directly.__Legacy - A service principal that represents an app created before app registrations, or through legacy experiences. Legacy service principal can have credentials, service principal names, reply URLs, and other properties which are editable by an authorized user, but does not have an associated app registration. The appId value does not associate the service principal with an app registration. The service principal can only be used in the tenant where it was created.__SocialIdp - For internal use.
     * @param value Value to set for the servicePrincipalType property.
     */
    set servicePrincipalType(value) {
        this._servicePrincipalType = value;
    }
    ;
    /**
     * Gets the signInAudience property value. Specifies the Microsoft accounts that are supported for the current application. Read-only. Supported values are:AzureADMyOrg: Users with a Microsoft work or school account in my organization’s Azure AD tenant (single-tenant).AzureADMultipleOrgs: Users with a Microsoft work or school account in any organization’s Azure AD tenant (multi-tenant).AzureADandPersonalMicrosoftAccount: Users with a personal Microsoft account, or a work or school account in any organization’s Azure AD tenant.PersonalMicrosoftAccount: Users with a personal Microsoft account only.
     * @returns a string
     */
    get signInAudience() {
        return this._signInAudience;
    }
    ;
    /**
     * Sets the signInAudience property value. Specifies the Microsoft accounts that are supported for the current application. Read-only. Supported values are:AzureADMyOrg: Users with a Microsoft work or school account in my organization’s Azure AD tenant (single-tenant).AzureADMultipleOrgs: Users with a Microsoft work or school account in any organization’s Azure AD tenant (multi-tenant).AzureADandPersonalMicrosoftAccount: Users with a personal Microsoft account, or a work or school account in any organization’s Azure AD tenant.PersonalMicrosoftAccount: Users with a personal Microsoft account only.
     * @param value Value to set for the signInAudience property.
     */
    set signInAudience(value) {
        this._signInAudience = value;
    }
    ;
    /**
     * Gets the tags property value. Custom strings that can be used to categorize and identify the service principal. Not nullable. Supports $filter (eq, not, ge, le, startsWith).
     * @returns a string
     */
    get tags() {
        return this._tags;
    }
    ;
    /**
     * Sets the tags property value. Custom strings that can be used to categorize and identify the service principal. Not nullable. Supports $filter (eq, not, ge, le, startsWith).
     * @param value Value to set for the tags property.
     */
    set tags(value) {
        this._tags = value;
    }
    ;
    /**
     * Gets the tokenEncryptionKeyId property value. Specifies the keyId of a public key from the keyCredentials collection. When configured, Azure AD issues tokens for this application encrypted using the key specified by this property. The application code that receives the encrypted token must use the matching private key to decrypt the token before it can be used for the signed-in user.
     * @returns a string
     */
    get tokenEncryptionKeyId() {
        return this._tokenEncryptionKeyId;
    }
    ;
    /**
     * Sets the tokenEncryptionKeyId property value. Specifies the keyId of a public key from the keyCredentials collection. When configured, Azure AD issues tokens for this application encrypted using the key specified by this property. The application code that receives the encrypted token must use the matching private key to decrypt the token before it can be used for the signed-in user.
     * @param value Value to set for the tokenEncryptionKeyId property.
     */
    set tokenEncryptionKeyId(value) {
        this._tokenEncryptionKeyId = value;
    }
    ;
    /**
     * Gets the tokenIssuancePolicies property value. The tokenIssuancePolicies assigned to this service principal.
     * @returns a tokenIssuancePolicy
     */
    get tokenIssuancePolicies() {
        return this._tokenIssuancePolicies;
    }
    ;
    /**
     * Sets the tokenIssuancePolicies property value. The tokenIssuancePolicies assigned to this service principal.
     * @param value Value to set for the tokenIssuancePolicies property.
     */
    set tokenIssuancePolicies(value) {
        this._tokenIssuancePolicies = value;
    }
    ;
    /**
     * Gets the tokenLifetimePolicies property value. The tokenLifetimePolicies assigned to this service principal.
     * @returns a tokenLifetimePolicy
     */
    get tokenLifetimePolicies() {
        return this._tokenLifetimePolicies;
    }
    ;
    /**
     * Sets the tokenLifetimePolicies property value. The tokenLifetimePolicies assigned to this service principal.
     * @param value Value to set for the tokenLifetimePolicies property.
     */
    set tokenLifetimePolicies(value) {
        this._tokenLifetimePolicies = value;
    }
    ;
    /**
     * Gets the transitiveMemberOf property value.
     * @returns a directoryObject
     */
    get transitiveMemberOf() {
        return this._transitiveMemberOf;
    }
    ;
    /**
     * Sets the transitiveMemberOf property value.
     * @param value Value to set for the transitiveMemberOf property.
     */
    set transitiveMemberOf(value) {
        this._transitiveMemberOf = value;
    }
    ;
}
exports.ServicePrincipal = ServicePrincipal;
