"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServiceUpdateMessage = void 0;
const createItemBodyFromDiscriminatorValue_1 = require("./createItemBodyFromDiscriminatorValue");
const createServiceAnnouncementAttachmentFromDiscriminatorValue_1 = require("./createServiceAnnouncementAttachmentFromDiscriminatorValue");
const createServiceUpdateMessageViewpointFromDiscriminatorValue_1 = require("./createServiceUpdateMessageViewpointFromDiscriminatorValue");
const index_1 = require("./index");
const serviceUpdateCategory_1 = require("./serviceUpdateCategory");
const serviceUpdateSeverity_1 = require("./serviceUpdateSeverity");
class ServiceUpdateMessage extends index_1.ServiceAnnouncementBase {
    /**
     * Instantiates a new serviceUpdateMessage and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the actionRequiredByDateTime property value. The expected deadline of the action for the message.
     * @returns a Date
     */
    get actionRequiredByDateTime() {
        return this._actionRequiredByDateTime;
    }
    ;
    /**
     * Sets the actionRequiredByDateTime property value. The expected deadline of the action for the message.
     * @param value Value to set for the actionRequiredByDateTime property.
     */
    set actionRequiredByDateTime(value) {
        this._actionRequiredByDateTime = value;
    }
    ;
    /**
     * Gets the attachments property value. A collection of serviceAnnouncementAttachments.
     * @returns a serviceAnnouncementAttachment
     */
    get attachments() {
        return this._attachments;
    }
    ;
    /**
     * Sets the attachments property value. A collection of serviceAnnouncementAttachments.
     * @param value Value to set for the attachments property.
     */
    set attachments(value) {
        this._attachments = value;
    }
    ;
    /**
     * Gets the attachmentsArchive property value. The zip file that contains all attachments for a message.
     * @returns a binary
     */
    get attachmentsArchive() {
        return this._attachmentsArchive;
    }
    ;
    /**
     * Sets the attachmentsArchive property value. The zip file that contains all attachments for a message.
     * @param value Value to set for the attachmentsArchive property.
     */
    set attachmentsArchive(value) {
        this._attachmentsArchive = value;
    }
    ;
    /**
     * Gets the body property value.
     * @returns a itemBody
     */
    get body() {
        return this._body;
    }
    ;
    /**
     * Sets the body property value.
     * @param value Value to set for the body property.
     */
    set body(value) {
        this._body = value;
    }
    ;
    /**
     * Gets the category property value. The service message category. Possible values are: preventOrFixIssue, planForChange, stayInformed, unknownFutureValue.
     * @returns a serviceUpdateCategory
     */
    get category() {
        return this._category;
    }
    ;
    /**
     * Sets the category property value. The service message category. Possible values are: preventOrFixIssue, planForChange, stayInformed, unknownFutureValue.
     * @param value Value to set for the category property.
     */
    set category(value) {
        this._category = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "actionRequiredByDateTime": (o, n) => { o.actionRequiredByDateTime = n.getDateValue(); }, "attachments": (o, n) => { o.attachments = n.getCollectionOfObjectValues(createServiceAnnouncementAttachmentFromDiscriminatorValue_1.createServiceAnnouncementAttachmentFromDiscriminatorValue); }, "attachmentsArchive": (o, n) => { o.attachmentsArchive = n.getStringValue(); }, "body": (o, n) => { o.body = n.getObjectValue(createItemBodyFromDiscriminatorValue_1.createItemBodyFromDiscriminatorValue); }, "category": (o, n) => { o.category = n.getEnumValue(serviceUpdateCategory_1.ServiceUpdateCategory); }, "hasAttachments": (o, n) => { o.hasAttachments = n.getBooleanValue(); }, "isMajorChange": (o, n) => { o.isMajorChange = n.getBooleanValue(); }, "services": (o, n) => { o.services = n.getCollectionOfPrimitiveValues(); }, "severity": (o, n) => { o.severity = n.getEnumValue(serviceUpdateSeverity_1.ServiceUpdateSeverity); }, "tags": (o, n) => { o.tags = n.getCollectionOfPrimitiveValues(); }, "viewPoint": (o, n) => { o.viewPoint = n.getObjectValue(createServiceUpdateMessageViewpointFromDiscriminatorValue_1.createServiceUpdateMessageViewpointFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the hasAttachments property value. Indicates whether the message has any attachment.
     * @returns a boolean
     */
    get hasAttachments() {
        return this._hasAttachments;
    }
    ;
    /**
     * Sets the hasAttachments property value. Indicates whether the message has any attachment.
     * @param value Value to set for the hasAttachments property.
     */
    set hasAttachments(value) {
        this._hasAttachments = value;
    }
    ;
    /**
     * Gets the isMajorChange property value. Indicates whether the message describes a major update for the service.
     * @returns a boolean
     */
    get isMajorChange() {
        return this._isMajorChange;
    }
    ;
    /**
     * Sets the isMajorChange property value. Indicates whether the message describes a major update for the service.
     * @param value Value to set for the isMajorChange property.
     */
    set isMajorChange(value) {
        this._isMajorChange = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeDateValue("actionRequiredByDateTime", this.actionRequiredByDateTime);
        writer.writeCollectionOfObjectValues("attachments", this.attachments);
        writer.writeStringValue("attachmentsArchive", this.attachmentsArchive);
        writer.writeObjectValue("body", this.body);
        writer.writeEnumValue("category", this.category);
        writer.writeBooleanValue("hasAttachments", this.hasAttachments);
        writer.writeBooleanValue("isMajorChange", this.isMajorChange);
        writer.writeCollectionOfPrimitiveValues("services", this.services);
        writer.writeEnumValue("severity", this.severity);
        writer.writeCollectionOfPrimitiveValues("tags", this.tags);
        writer.writeObjectValue("viewPoint", this.viewPoint);
    }
    ;
    /**
     * Gets the services property value. The affected services by the service message.
     * @returns a string
     */
    get services() {
        return this._services;
    }
    ;
    /**
     * Sets the services property value. The affected services by the service message.
     * @param value Value to set for the services property.
     */
    set services(value) {
        this._services = value;
    }
    ;
    /**
     * Gets the severity property value. The severity of the service message. Possible values are: normal, high, critical, unknownFutureValue.
     * @returns a serviceUpdateSeverity
     */
    get severity() {
        return this._severity;
    }
    ;
    /**
     * Sets the severity property value. The severity of the service message. Possible values are: normal, high, critical, unknownFutureValue.
     * @param value Value to set for the severity property.
     */
    set severity(value) {
        this._severity = value;
    }
    ;
    /**
     * Gets the tags property value. A collection of tags for the service message. Tags are provided by the service team/support team who post the message to tell whether this message contains privacy data, or whether this message is for a service new feature update, and so on.
     * @returns a string
     */
    get tags() {
        return this._tags;
    }
    ;
    /**
     * Sets the tags property value. A collection of tags for the service message. Tags are provided by the service team/support team who post the message to tell whether this message contains privacy data, or whether this message is for a service new feature update, and so on.
     * @param value Value to set for the tags property.
     */
    set tags(value) {
        this._tags = value;
    }
    ;
    /**
     * Gets the viewPoint property value. Represents user viewpoints data of the service message. This data includes message status such as whether the user has archived, read, or marked the message as favorite. This property is null when accessed with application permissions.
     * @returns a serviceUpdateMessageViewpoint
     */
    get viewPoint() {
        return this._viewPoint;
    }
    ;
    /**
     * Sets the viewPoint property value. Represents user viewpoints data of the service message. This data includes message status such as whether the user has archived, read, or marked the message as favorite. This property is null when accessed with application permissions.
     * @param value Value to set for the viewPoint property.
     */
    set viewPoint(value) {
        this._viewPoint = value;
    }
    ;
}
exports.ServiceUpdateMessage = ServiceUpdateMessage;
