"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServiceUpdateMessageViewpoint = void 0;
class ServiceUpdateMessageViewpoint {
    /**
     * Instantiates a new serviceUpdateMessageViewpoint and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "isArchived": (o, n) => { o.isArchived = n.getBooleanValue(); },
            "isFavorited": (o, n) => { o.isFavorited = n.getBooleanValue(); },
            "isRead": (o, n) => { o.isRead = n.getBooleanValue(); },
        };
    }
    ;
    /**
     * Gets the isArchived property value. Indicates whether the user archived the message.
     * @returns a boolean
     */
    get isArchived() {
        return this._isArchived;
    }
    ;
    /**
     * Sets the isArchived property value. Indicates whether the user archived the message.
     * @param value Value to set for the isArchived property.
     */
    set isArchived(value) {
        this._isArchived = value;
    }
    ;
    /**
     * Gets the isFavorited property value. Indicates whether the user marked the message as favorite.
     * @returns a boolean
     */
    get isFavorited() {
        return this._isFavorited;
    }
    ;
    /**
     * Sets the isFavorited property value. Indicates whether the user marked the message as favorite.
     * @param value Value to set for the isFavorited property.
     */
    set isFavorited(value) {
        this._isFavorited = value;
    }
    ;
    /**
     * Gets the isRead property value. Indicates whether the user read the message.
     * @returns a boolean
     */
    get isRead() {
        return this._isRead;
    }
    ;
    /**
     * Sets the isRead property value. Indicates whether the user read the message.
     * @param value Value to set for the isRead property.
     */
    set isRead(value) {
        this._isRead = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("isArchived", this.isArchived);
        writer.writeBooleanValue("isFavorited", this.isFavorited);
        writer.writeBooleanValue("isRead", this.isRead);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ServiceUpdateMessageViewpoint = ServiceUpdateMessageViewpoint;
