"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SettingSource = void 0;
const settingSourceType_1 = require("./settingSourceType");
class SettingSource {
    /**
     * Instantiates a new settingSource and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the displayName property value. Not yet documented
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. Not yet documented
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "displayName": (o, n) => { o.displayName = n.getStringValue(); },
            "id": (o, n) => { o.id = n.getStringValue(); },
            "sourceType": (o, n) => { o.sourceType = n.getEnumValue(settingSourceType_1.SettingSourceType); },
        };
    }
    ;
    /**
     * Gets the id property value. Not yet documented
     * @returns a string
     */
    get id() {
        return this._id;
    }
    ;
    /**
     * Sets the id property value. Not yet documented
     * @param value Value to set for the id property.
     */
    set id(value) {
        this._id = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("displayName", this.displayName);
        writer.writeStringValue("id", this.id);
        writer.writeEnumValue("sourceType", this.sourceType);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the sourceType property value. Not yet documented. Possible values are: deviceConfiguration, deviceIntent.
     * @returns a settingSourceType
     */
    get sourceType() {
        return this._sourceType;
    }
    ;
    /**
     * Sets the sourceType property value. Not yet documented. Possible values are: deviceConfiguration, deviceIntent.
     * @param value Value to set for the sourceType property.
     */
    set sourceType(value) {
        this._sourceType = value;
    }
    ;
}
exports.SettingSource = SettingSource;
