import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class SettingTemplateValue implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Default value for the setting.  */
    private _defaultValue?;
    /** Description of the setting.  */
    private _description?;
    /** Name of the setting.  */
    private _name?;
    /** Type of the setting.  */
    private _type?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new settingTemplateValue and sets the default values.
     */
    constructor();
    /**
     * Gets the defaultValue property value. Default value for the setting.
     * @returns a string
     */
    get defaultValue(): string | undefined;
    /**
     * Sets the defaultValue property value. Default value for the setting.
     * @param value Value to set for the defaultValue property.
     */
    set defaultValue(value: string | undefined);
    /**
     * Gets the description property value. Description of the setting.
     * @returns a string
     */
    get description(): string | undefined;
    /**
     * Sets the description property value. Description of the setting.
     * @param value Value to set for the description property.
     */
    set description(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the name property value. Name of the setting.
     * @returns a string
     */
    get name(): string | undefined;
    /**
     * Sets the name property value. Name of the setting.
     * @param value Value to set for the name property.
     */
    set name(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the type property value. Type of the setting.
     * @returns a string
     */
    get type(): string | undefined;
    /**
     * Sets the type property value. Type of the setting.
     * @param value Value to set for the type property.
     */
    set type(value: string | undefined);
}
