import { Identity, IdentitySet, SharePointIdentity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class SharePointIdentitySet extends IdentitySet implements Parsable {
    /** The group associated with this action. Optional.  */
    private _group?;
    /** The SharePoint group associated with this action. Optional.  */
    private _siteGroup?;
    /** The SharePoint user associated with this action. Optional.  */
    private _siteUser?;
    /**
     * Instantiates a new sharePointIdentitySet and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the group property value. The group associated with this action. Optional.
     * @returns a identity
     */
    get group(): Identity | undefined;
    /**
     * Sets the group property value. The group associated with this action. Optional.
     * @param value Value to set for the group property.
     */
    set group(value: Identity | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the siteGroup property value. The SharePoint group associated with this action. Optional.
     * @returns a sharePointIdentity
     */
    get siteGroup(): SharePointIdentity | undefined;
    /**
     * Sets the siteGroup property value. The SharePoint group associated with this action. Optional.
     * @param value Value to set for the siteGroup property.
     */
    set siteGroup(value: SharePointIdentity | undefined);
    /**
     * Gets the siteUser property value. The SharePoint user associated with this action. Optional.
     * @returns a sharePointIdentity
     */
    get siteUser(): SharePointIdentity | undefined;
    /**
     * Sets the siteUser property value. The SharePoint user associated with this action. Optional.
     * @param value Value to set for the siteUser property.
     */
    set siteUser(value: SharePointIdentity | undefined);
}
