"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SharePointIdentitySet = void 0;
const createIdentityFromDiscriminatorValue_1 = require("./createIdentityFromDiscriminatorValue");
const createSharePointIdentityFromDiscriminatorValue_1 = require("./createSharePointIdentityFromDiscriminatorValue");
const index_1 = require("./index");
class SharePointIdentitySet extends index_1.IdentitySet {
    /**
     * Instantiates a new sharePointIdentitySet and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "group": (o, n) => { o.group = n.getObjectValue(createIdentityFromDiscriminatorValue_1.createIdentityFromDiscriminatorValue); }, "siteGroup": (o, n) => { o.siteGroup = n.getObjectValue(createSharePointIdentityFromDiscriminatorValue_1.createSharePointIdentityFromDiscriminatorValue); }, "siteUser": (o, n) => { o.siteUser = n.getObjectValue(createSharePointIdentityFromDiscriminatorValue_1.createSharePointIdentityFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the group property value. The group associated with this action. Optional.
     * @returns a identity
     */
    get group() {
        return this._group;
    }
    ;
    /**
     * Sets the group property value. The group associated with this action. Optional.
     * @param value Value to set for the group property.
     */
    set group(value) {
        this._group = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("group", this.group);
        writer.writeObjectValue("siteGroup", this.siteGroup);
        writer.writeObjectValue("siteUser", this.siteUser);
    }
    ;
    /**
     * Gets the siteGroup property value. The SharePoint group associated with this action. Optional.
     * @returns a sharePointIdentity
     */
    get siteGroup() {
        return this._siteGroup;
    }
    ;
    /**
     * Sets the siteGroup property value. The SharePoint group associated with this action. Optional.
     * @param value Value to set for the siteGroup property.
     */
    set siteGroup(value) {
        this._siteGroup = value;
    }
    ;
    /**
     * Gets the siteUser property value. The SharePoint user associated with this action. Optional.
     * @returns a sharePointIdentity
     */
    get siteUser() {
        return this._siteUser;
    }
    ;
    /**
     * Sets the siteUser property value. The SharePoint user associated with this action. Optional.
     * @param value Value to set for the siteUser property.
     */
    set siteUser(value) {
        this._siteUser = value;
    }
    ;
}
exports.SharePointIdentitySet = SharePointIdentitySet;
