"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Shared = void 0;
const createIdentitySetFromDiscriminatorValue_1 = require("./createIdentitySetFromDiscriminatorValue");
class Shared {
    /**
     * Instantiates a new shared and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "owner": (o, n) => { o.owner = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); },
            "scope": (o, n) => { o.scope = n.getStringValue(); },
            "sharedBy": (o, n) => { o.sharedBy = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); },
            "sharedDateTime": (o, n) => { o.sharedDateTime = n.getDateValue(); },
        };
    }
    ;
    /**
     * Gets the owner property value. The identity of the owner of the shared item. Read-only.
     * @returns a identitySet
     */
    get owner() {
        return this._owner;
    }
    ;
    /**
     * Sets the owner property value. The identity of the owner of the shared item. Read-only.
     * @param value Value to set for the owner property.
     */
    set owner(value) {
        this._owner = value;
    }
    ;
    /**
     * Gets the scope property value. Indicates the scope of how the item is shared: anonymous, organization, or users. Read-only.
     * @returns a string
     */
    get scope() {
        return this._scope;
    }
    ;
    /**
     * Sets the scope property value. Indicates the scope of how the item is shared: anonymous, organization, or users. Read-only.
     * @param value Value to set for the scope property.
     */
    set scope(value) {
        this._scope = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("owner", this.owner);
        writer.writeStringValue("scope", this.scope);
        writer.writeObjectValue("sharedBy", this.sharedBy);
        writer.writeDateValue("sharedDateTime", this.sharedDateTime);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the sharedBy property value. The identity of the user who shared the item. Read-only.
     * @returns a identitySet
     */
    get sharedBy() {
        return this._sharedBy;
    }
    ;
    /**
     * Sets the sharedBy property value. The identity of the user who shared the item. Read-only.
     * @param value Value to set for the sharedBy property.
     */
    set sharedBy(value) {
        this._sharedBy = value;
    }
    ;
    /**
     * Gets the sharedDateTime property value. The UTC date and time when the item was shared. Read-only.
     * @returns a Date
     */
    get sharedDateTime() {
        return this._sharedDateTime;
    }
    ;
    /**
     * Sets the sharedDateTime property value. The UTC date and time when the item was shared. Read-only.
     * @param value Value to set for the sharedDateTime property.
     */
    set sharedDateTime(value) {
        this._sharedDateTime = value;
    }
    ;
}
exports.Shared = Shared;
