"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SharedDriveItem = void 0;
const createDriveItemFromDiscriminatorValue_1 = require("./createDriveItemFromDiscriminatorValue");
const createIdentitySetFromDiscriminatorValue_1 = require("./createIdentitySetFromDiscriminatorValue");
const createListFromDiscriminatorValue_1 = require("./createListFromDiscriminatorValue");
const createListItemFromDiscriminatorValue_1 = require("./createListItemFromDiscriminatorValue");
const createPermissionFromDiscriminatorValue_1 = require("./createPermissionFromDiscriminatorValue");
const createSiteFromDiscriminatorValue_1 = require("./createSiteFromDiscriminatorValue");
const index_1 = require("./index");
class SharedDriveItem extends index_1.BaseItem {
    /**
     * Instantiates a new sharedDriveItem and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the driveItem property value. Used to access the underlying driveItem
     * @returns a driveItem
     */
    get driveItem() {
        return this._driveItem;
    }
    ;
    /**
     * Sets the driveItem property value. Used to access the underlying driveItem
     * @param value Value to set for the driveItem property.
     */
    set driveItem(value) {
        this._driveItem = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "driveItem": (o, n) => { o.driveItem = n.getObjectValue(createDriveItemFromDiscriminatorValue_1.createDriveItemFromDiscriminatorValue); }, "items": (o, n) => { o.items = n.getCollectionOfObjectValues(createDriveItemFromDiscriminatorValue_1.createDriveItemFromDiscriminatorValue); }, "list": (o, n) => { o.list = n.getObjectValue(createListFromDiscriminatorValue_1.createListFromDiscriminatorValue); }, "listItem": (o, n) => { o.listItem = n.getObjectValue(createListItemFromDiscriminatorValue_1.createListItemFromDiscriminatorValue); }, "owner": (o, n) => { o.owner = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); }, "permission": (o, n) => { o.permission = n.getObjectValue(createPermissionFromDiscriminatorValue_1.createPermissionFromDiscriminatorValue); }, "root": (o, n) => { o.root = n.getObjectValue(createDriveItemFromDiscriminatorValue_1.createDriveItemFromDiscriminatorValue); }, "site": (o, n) => { o.site = n.getObjectValue(createSiteFromDiscriminatorValue_1.createSiteFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the items property value. All driveItems contained in the sharing root. This collection cannot be enumerated.
     * @returns a driveItem
     */
    get items() {
        return this._items;
    }
    ;
    /**
     * Sets the items property value. All driveItems contained in the sharing root. This collection cannot be enumerated.
     * @param value Value to set for the items property.
     */
    set items(value) {
        this._items = value;
    }
    ;
    /**
     * Gets the list property value. Used to access the underlying list
     * @returns a list
     */
    get list() {
        return this._list;
    }
    ;
    /**
     * Sets the list property value. Used to access the underlying list
     * @param value Value to set for the list property.
     */
    set list(value) {
        this._list = value;
    }
    ;
    /**
     * Gets the listItem property value. Used to access the underlying listItem
     * @returns a listItem
     */
    get listItem() {
        return this._listItem;
    }
    ;
    /**
     * Sets the listItem property value. Used to access the underlying listItem
     * @param value Value to set for the listItem property.
     */
    set listItem(value) {
        this._listItem = value;
    }
    ;
    /**
     * Gets the owner property value. Information about the owner of the shared item being referenced.
     * @returns a identitySet
     */
    get owner() {
        return this._owner;
    }
    ;
    /**
     * Sets the owner property value. Information about the owner of the shared item being referenced.
     * @param value Value to set for the owner property.
     */
    set owner(value) {
        this._owner = value;
    }
    ;
    /**
     * Gets the permission property value. Used to access the permission representing the underlying sharing link
     * @returns a permission
     */
    get permission() {
        return this._permission;
    }
    ;
    /**
     * Sets the permission property value. Used to access the permission representing the underlying sharing link
     * @param value Value to set for the permission property.
     */
    set permission(value) {
        this._permission = value;
    }
    ;
    /**
     * Gets the root property value. Used to access the underlying driveItem. Deprecated -- use driveItem instead.
     * @returns a driveItem
     */
    get root() {
        return this._root;
    }
    ;
    /**
     * Sets the root property value. Used to access the underlying driveItem. Deprecated -- use driveItem instead.
     * @param value Value to set for the root property.
     */
    set root(value) {
        this._root = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("driveItem", this.driveItem);
        writer.writeCollectionOfObjectValues("items", this.items);
        writer.writeObjectValue("list", this.list);
        writer.writeObjectValue("listItem", this.listItem);
        writer.writeObjectValue("owner", this.owner);
        writer.writeObjectValue("permission", this.permission);
        writer.writeObjectValue("root", this.root);
        writer.writeObjectValue("site", this.site);
    }
    ;
    /**
     * Gets the site property value. Used to access the underlying site
     * @returns a site
     */
    get site() {
        return this._site;
    }
    ;
    /**
     * Sets the site property value. Used to access the underlying site
     * @param value Value to set for the site property.
     */
    set site(value) {
        this._site = value;
    }
    ;
}
exports.SharedDriveItem = SharedDriveItem;
