import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class SharepointIds implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** The unique identifier (guid) for the item's list in SharePoint.  */
    private _listId?;
    /** An integer identifier for the item within the containing list.  */
    private _listItemId?;
    /** The unique identifier (guid) for the item within OneDrive for Business or a SharePoint site.  */
    private _listItemUniqueId?;
    /** The unique identifier (guid) for the item's site collection (SPSite).  */
    private _siteId?;
    /** The SharePoint URL for the site that contains the item.  */
    private _siteUrl?;
    /** The unique identifier (guid) for the tenancy.  */
    private _tenantId?;
    /** The unique identifier (guid) for the item's site (SPWeb).  */
    private _webId?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new sharepointIds and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the listId property value. The unique identifier (guid) for the item's list in SharePoint.
     * @returns a string
     */
    get listId(): string | undefined;
    /**
     * Sets the listId property value. The unique identifier (guid) for the item's list in SharePoint.
     * @param value Value to set for the listId property.
     */
    set listId(value: string | undefined);
    /**
     * Gets the listItemId property value. An integer identifier for the item within the containing list.
     * @returns a string
     */
    get listItemId(): string | undefined;
    /**
     * Sets the listItemId property value. An integer identifier for the item within the containing list.
     * @param value Value to set for the listItemId property.
     */
    set listItemId(value: string | undefined);
    /**
     * Gets the listItemUniqueId property value. The unique identifier (guid) for the item within OneDrive for Business or a SharePoint site.
     * @returns a string
     */
    get listItemUniqueId(): string | undefined;
    /**
     * Sets the listItemUniqueId property value. The unique identifier (guid) for the item within OneDrive for Business or a SharePoint site.
     * @param value Value to set for the listItemUniqueId property.
     */
    set listItemUniqueId(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the siteId property value. The unique identifier (guid) for the item's site collection (SPSite).
     * @returns a string
     */
    get siteId(): string | undefined;
    /**
     * Sets the siteId property value. The unique identifier (guid) for the item's site collection (SPSite).
     * @param value Value to set for the siteId property.
     */
    set siteId(value: string | undefined);
    /**
     * Gets the siteUrl property value. The SharePoint URL for the site that contains the item.
     * @returns a string
     */
    get siteUrl(): string | undefined;
    /**
     * Sets the siteUrl property value. The SharePoint URL for the site that contains the item.
     * @param value Value to set for the siteUrl property.
     */
    set siteUrl(value: string | undefined);
    /**
     * Gets the tenantId property value. The unique identifier (guid) for the tenancy.
     * @returns a string
     */
    get tenantId(): string | undefined;
    /**
     * Sets the tenantId property value. The unique identifier (guid) for the tenancy.
     * @param value Value to set for the tenantId property.
     */
    set tenantId(value: string | undefined);
    /**
     * Gets the webId property value. The unique identifier (guid) for the item's site (SPWeb).
     * @returns a string
     */
    get webId(): string | undefined;
    /**
     * Sets the webId property value. The unique identifier (guid) for the item's site (SPWeb).
     * @param value Value to set for the webId property.
     */
    set webId(value: string | undefined);
}
