"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SharingDetail = void 0;
const createInsightIdentityFromDiscriminatorValue_1 = require("./createInsightIdentityFromDiscriminatorValue");
const createResourceReferenceFromDiscriminatorValue_1 = require("./createResourceReferenceFromDiscriminatorValue");
class SharingDetail {
    /**
     * Instantiates a new sharingDetail and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "sharedBy": (o, n) => { o.sharedBy = n.getObjectValue(createInsightIdentityFromDiscriminatorValue_1.createInsightIdentityFromDiscriminatorValue); },
            "sharedDateTime": (o, n) => { o.sharedDateTime = n.getDateValue(); },
            "sharingReference": (o, n) => { o.sharingReference = n.getObjectValue(createResourceReferenceFromDiscriminatorValue_1.createResourceReferenceFromDiscriminatorValue); },
            "sharingSubject": (o, n) => { o.sharingSubject = n.getStringValue(); },
            "sharingType": (o, n) => { o.sharingType = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("sharedBy", this.sharedBy);
        writer.writeDateValue("sharedDateTime", this.sharedDateTime);
        writer.writeObjectValue("sharingReference", this.sharingReference);
        writer.writeStringValue("sharingSubject", this.sharingSubject);
        writer.writeStringValue("sharingType", this.sharingType);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the sharedBy property value. The user who shared the document.
     * @returns a insightIdentity
     */
    get sharedBy() {
        return this._sharedBy;
    }
    ;
    /**
     * Sets the sharedBy property value. The user who shared the document.
     * @param value Value to set for the sharedBy property.
     */
    set sharedBy(value) {
        this._sharedBy = value;
    }
    ;
    /**
     * Gets the sharedDateTime property value. The date and time the file was last shared. The timestamp represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
     * @returns a Date
     */
    get sharedDateTime() {
        return this._sharedDateTime;
    }
    ;
    /**
     * Sets the sharedDateTime property value. The date and time the file was last shared. The timestamp represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
     * @param value Value to set for the sharedDateTime property.
     */
    set sharedDateTime(value) {
        this._sharedDateTime = value;
    }
    ;
    /**
     * Gets the sharingReference property value.
     * @returns a resourceReference
     */
    get sharingReference() {
        return this._sharingReference;
    }
    ;
    /**
     * Sets the sharingReference property value.
     * @param value Value to set for the sharingReference property.
     */
    set sharingReference(value) {
        this._sharingReference = value;
    }
    ;
    /**
     * Gets the sharingSubject property value. The subject with which the document was shared.
     * @returns a string
     */
    get sharingSubject() {
        return this._sharingSubject;
    }
    ;
    /**
     * Sets the sharingSubject property value. The subject with which the document was shared.
     * @param value Value to set for the sharingSubject property.
     */
    set sharingSubject(value) {
        this._sharingSubject = value;
    }
    ;
    /**
     * Gets the sharingType property value. Determines the way the document was shared, can be by a 'Link', 'Attachment', 'Group', 'Site'.
     * @returns a string
     */
    get sharingType() {
        return this._sharingType;
    }
    ;
    /**
     * Sets the sharingType property value. Determines the way the document was shared, can be by a 'Link', 'Attachment', 'Group', 'Site'.
     * @param value Value to set for the sharingType property.
     */
    set sharingType(value) {
        this._sharingType = value;
    }
    ;
}
exports.SharingDetail = SharingDetail;
