"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShiftActivity = void 0;
const scheduleEntityTheme_1 = require("./scheduleEntityTheme");
class ShiftActivity {
    /**
     * Instantiates a new shiftActivity and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the code property value. Customer defined code for the shiftActivity. Required.
     * @returns a string
     */
    get code() {
        return this._code;
    }
    ;
    /**
     * Sets the code property value. Customer defined code for the shiftActivity. Required.
     * @param value Value to set for the code property.
     */
    set code(value) {
        this._code = value;
    }
    ;
    ;
    /**
     * Gets the displayName property value. The name of the shiftActivity. Required.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The name of the shiftActivity. Required.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * Gets the endDateTime property value. The end date and time for the shiftActivity. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Required.
     * @returns a Date
     */
    get endDateTime() {
        return this._endDateTime;
    }
    ;
    /**
     * Sets the endDateTime property value. The end date and time for the shiftActivity. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Required.
     * @param value Value to set for the endDateTime property.
     */
    set endDateTime(value) {
        this._endDateTime = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "code": (o, n) => { o.code = n.getStringValue(); },
            "displayName": (o, n) => { o.displayName = n.getStringValue(); },
            "endDateTime": (o, n) => { o.endDateTime = n.getDateValue(); },
            "isPaid": (o, n) => { o.isPaid = n.getBooleanValue(); },
            "startDateTime": (o, n) => { o.startDateTime = n.getDateValue(); },
            "theme": (o, n) => { o.theme = n.getEnumValue(scheduleEntityTheme_1.ScheduleEntityTheme); },
        };
    }
    ;
    /**
     * Gets the isPaid property value. Indicates whether the microsoft.graph.user should be paid for the activity during their shift. Required.
     * @returns a boolean
     */
    get isPaid() {
        return this._isPaid;
    }
    ;
    /**
     * Sets the isPaid property value. Indicates whether the microsoft.graph.user should be paid for the activity during their shift. Required.
     * @param value Value to set for the isPaid property.
     */
    set isPaid(value) {
        this._isPaid = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("code", this.code);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeDateValue("endDateTime", this.endDateTime);
        writer.writeBooleanValue("isPaid", this.isPaid);
        writer.writeDateValue("startDateTime", this.startDateTime);
        writer.writeEnumValue("theme", this.theme);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the startDateTime property value. The start date and time for the shiftActivity. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Required.
     * @returns a Date
     */
    get startDateTime() {
        return this._startDateTime;
    }
    ;
    /**
     * Sets the startDateTime property value. The start date and time for the shiftActivity. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Required.
     * @param value Value to set for the startDateTime property.
     */
    set startDateTime(value) {
        this._startDateTime = value;
    }
    ;
    /**
     * Gets the theme property value.
     * @returns a scheduleEntityTheme
     */
    get theme() {
        return this._theme;
    }
    ;
    /**
     * Sets the theme property value.
     * @param value Value to set for the theme property.
     */
    set theme(value) {
        this._theme = value;
    }
    ;
}
exports.ShiftActivity = ShiftActivity;
