import { ScheduleEntity, ShiftActivity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class ShiftItem extends ScheduleEntity implements Parsable {
    /** An incremental part of a shift which can cover details of when and where an employee is during their shift. For example, an assignment or a scheduled break or lunch. Required.  */
    private _activities?;
    /** The shift label of the shiftItem.  */
    private _displayName?;
    /** The shift notes for the shiftItem.  */
    private _notes?;
    /**
     * Gets the activities property value. An incremental part of a shift which can cover details of when and where an employee is during their shift. For example, an assignment or a scheduled break or lunch. Required.
     * @returns a shiftActivity
     */
    get activities(): ShiftActivity[] | undefined;
    /**
     * Sets the activities property value. An incremental part of a shift which can cover details of when and where an employee is during their shift. For example, an assignment or a scheduled break or lunch. Required.
     * @param value Value to set for the activities property.
     */
    set activities(value: ShiftActivity[] | undefined);
    /**
     * Instantiates a new shiftItem and sets the default values.
     */
    constructor();
    /**
     * Gets the displayName property value. The shift label of the shiftItem.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. The shift label of the shiftItem.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the notes property value. The shift notes for the shiftItem.
     * @returns a string
     */
    get notes(): string | undefined;
    /**
     * Sets the notes property value. The shift notes for the shiftItem.
     * @param value Value to set for the notes property.
     */
    set notes(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
