"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShiftItem = void 0;
const createShiftActivityFromDiscriminatorValue_1 = require("./createShiftActivityFromDiscriminatorValue");
const index_1 = require("./index");
class ShiftItem extends index_1.ScheduleEntity {
    /**
     * Instantiates a new shiftItem and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the activities property value. An incremental part of a shift which can cover details of when and where an employee is during their shift. For example, an assignment or a scheduled break or lunch. Required.
     * @returns a shiftActivity
     */
    get activities() {
        return this._activities;
    }
    ;
    /**
     * Sets the activities property value. An incremental part of a shift which can cover details of when and where an employee is during their shift. For example, an assignment or a scheduled break or lunch. Required.
     * @param value Value to set for the activities property.
     */
    set activities(value) {
        this._activities = value;
    }
    ;
    ;
    /**
     * Gets the displayName property value. The shift label of the shiftItem.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The shift label of the shiftItem.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "activities": (o, n) => { o.activities = n.getCollectionOfObjectValues(createShiftActivityFromDiscriminatorValue_1.createShiftActivityFromDiscriminatorValue); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "notes": (o, n) => { o.notes = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the notes property value. The shift notes for the shiftItem.
     * @returns a string
     */
    get notes() {
        return this._notes;
    }
    ;
    /**
     * Sets the notes property value. The shift notes for the shiftItem.
     * @param value Value to set for the notes property.
     */
    set notes(value) {
        this._notes = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("activities", this.activities);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeStringValue("notes", this.notes);
    }
    ;
}
exports.ShiftItem = ShiftItem;
