"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShiftPreferences = void 0;
const createShiftAvailabilityFromDiscriminatorValue_1 = require("./createShiftAvailabilityFromDiscriminatorValue");
const index_1 = require("./index");
class ShiftPreferences extends index_1.ChangeTrackedEntity {
    /**
     * Instantiates a new shiftPreferences and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the availability property value. Availability of the user to be scheduled for work and its recurrence pattern.
     * @returns a shiftAvailability
     */
    get availability() {
        return this._availability;
    }
    ;
    /**
     * Sets the availability property value. Availability of the user to be scheduled for work and its recurrence pattern.
     * @param value Value to set for the availability property.
     */
    set availability(value) {
        this._availability = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "availability": (o, n) => { o.availability = n.getCollectionOfObjectValues(createShiftAvailabilityFromDiscriminatorValue_1.createShiftAvailabilityFromDiscriminatorValue); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("availability", this.availability);
    }
    ;
}
exports.ShiftPreferences = ShiftPreferences;
