"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiteCollection = void 0;
const createRootFromDiscriminatorValue_1 = require("./createRootFromDiscriminatorValue");
class SiteCollection {
    /**
     * Instantiates a new siteCollection and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the dataLocationCode property value. The geographic region code for where this site collection resides. Read-only.
     * @returns a string
     */
    get dataLocationCode() {
        return this._dataLocationCode;
    }
    ;
    /**
     * Sets the dataLocationCode property value. The geographic region code for where this site collection resides. Read-only.
     * @param value Value to set for the dataLocationCode property.
     */
    set dataLocationCode(value) {
        this._dataLocationCode = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "dataLocationCode": (o, n) => { o.dataLocationCode = n.getStringValue(); },
            "hostname": (o, n) => { o.hostname = n.getStringValue(); },
            "root": (o, n) => { o.root = n.getObjectValue(createRootFromDiscriminatorValue_1.createRootFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the hostname property value. The hostname for the site collection. Read-only.
     * @returns a string
     */
    get hostname() {
        return this._hostname;
    }
    ;
    /**
     * Sets the hostname property value. The hostname for the site collection. Read-only.
     * @param value Value to set for the hostname property.
     */
    set hostname(value) {
        this._hostname = value;
    }
    ;
    /**
     * Gets the root property value. If present, indicates that this is a root site collection in SharePoint. Read-only.
     * @returns a root
     */
    get root() {
        return this._root;
    }
    ;
    /**
     * Sets the root property value. If present, indicates that this is a root site collection in SharePoint. Read-only.
     * @param value Value to set for the root property.
     */
    set root(value) {
        this._root = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("dataLocationCode", this.dataLocationCode);
        writer.writeStringValue("hostname", this.hostname);
        writer.writeObjectValue("root", this.root);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.SiteCollection = SiteCollection;
