"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SoftwareUpdateStatusSummary = void 0;
const index_1 = require("./index");
class SoftwareUpdateStatusSummary extends index_1.Entity {
    /**
     * Instantiates a new softwareUpdateStatusSummary and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the compliantDeviceCount property value. Number of compliant devices.
     * @returns a integer
     */
    get compliantDeviceCount() {
        return this._compliantDeviceCount;
    }
    ;
    /**
     * Sets the compliantDeviceCount property value. Number of compliant devices.
     * @param value Value to set for the compliantDeviceCount property.
     */
    set compliantDeviceCount(value) {
        this._compliantDeviceCount = value;
    }
    ;
    /**
     * Gets the compliantUserCount property value. Number of compliant users.
     * @returns a integer
     */
    get compliantUserCount() {
        return this._compliantUserCount;
    }
    ;
    /**
     * Sets the compliantUserCount property value. Number of compliant users.
     * @param value Value to set for the compliantUserCount property.
     */
    set compliantUserCount(value) {
        this._compliantUserCount = value;
    }
    ;
    /**
     * Gets the conflictDeviceCount property value. Number of conflict devices.
     * @returns a integer
     */
    get conflictDeviceCount() {
        return this._conflictDeviceCount;
    }
    ;
    /**
     * Sets the conflictDeviceCount property value. Number of conflict devices.
     * @param value Value to set for the conflictDeviceCount property.
     */
    set conflictDeviceCount(value) {
        this._conflictDeviceCount = value;
    }
    ;
    /**
     * Gets the conflictUserCount property value. Number of conflict users.
     * @returns a integer
     */
    get conflictUserCount() {
        return this._conflictUserCount;
    }
    ;
    /**
     * Sets the conflictUserCount property value. Number of conflict users.
     * @param value Value to set for the conflictUserCount property.
     */
    set conflictUserCount(value) {
        this._conflictUserCount = value;
    }
    ;
    ;
    /**
     * Gets the displayName property value. The name of the policy.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The name of the policy.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * Gets the errorDeviceCount property value. Number of devices had error.
     * @returns a integer
     */
    get errorDeviceCount() {
        return this._errorDeviceCount;
    }
    ;
    /**
     * Sets the errorDeviceCount property value. Number of devices had error.
     * @param value Value to set for the errorDeviceCount property.
     */
    set errorDeviceCount(value) {
        this._errorDeviceCount = value;
    }
    ;
    /**
     * Gets the errorUserCount property value. Number of users had error.
     * @returns a integer
     */
    get errorUserCount() {
        return this._errorUserCount;
    }
    ;
    /**
     * Sets the errorUserCount property value. Number of users had error.
     * @param value Value to set for the errorUserCount property.
     */
    set errorUserCount(value) {
        this._errorUserCount = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "compliantDeviceCount": (o, n) => { o.compliantDeviceCount = n.getNumberValue(); }, "compliantUserCount": (o, n) => { o.compliantUserCount = n.getNumberValue(); }, "conflictDeviceCount": (o, n) => { o.conflictDeviceCount = n.getNumberValue(); }, "conflictUserCount": (o, n) => { o.conflictUserCount = n.getNumberValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "errorDeviceCount": (o, n) => { o.errorDeviceCount = n.getNumberValue(); }, "errorUserCount": (o, n) => { o.errorUserCount = n.getNumberValue(); }, "nonCompliantDeviceCount": (o, n) => { o.nonCompliantDeviceCount = n.getNumberValue(); }, "nonCompliantUserCount": (o, n) => { o.nonCompliantUserCount = n.getNumberValue(); }, "notApplicableDeviceCount": (o, n) => { o.notApplicableDeviceCount = n.getNumberValue(); }, "notApplicableUserCount": (o, n) => { o.notApplicableUserCount = n.getNumberValue(); }, "remediatedDeviceCount": (o, n) => { o.remediatedDeviceCount = n.getNumberValue(); }, "remediatedUserCount": (o, n) => { o.remediatedUserCount = n.getNumberValue(); }, "unknownDeviceCount": (o, n) => { o.unknownDeviceCount = n.getNumberValue(); }, "unknownUserCount": (o, n) => { o.unknownUserCount = n.getNumberValue(); } });
    }
    ;
    /**
     * Gets the nonCompliantDeviceCount property value. Number of non compliant devices.
     * @returns a integer
     */
    get nonCompliantDeviceCount() {
        return this._nonCompliantDeviceCount;
    }
    ;
    /**
     * Sets the nonCompliantDeviceCount property value. Number of non compliant devices.
     * @param value Value to set for the nonCompliantDeviceCount property.
     */
    set nonCompliantDeviceCount(value) {
        this._nonCompliantDeviceCount = value;
    }
    ;
    /**
     * Gets the nonCompliantUserCount property value. Number of non compliant users.
     * @returns a integer
     */
    get nonCompliantUserCount() {
        return this._nonCompliantUserCount;
    }
    ;
    /**
     * Sets the nonCompliantUserCount property value. Number of non compliant users.
     * @param value Value to set for the nonCompliantUserCount property.
     */
    set nonCompliantUserCount(value) {
        this._nonCompliantUserCount = value;
    }
    ;
    /**
     * Gets the notApplicableDeviceCount property value. Number of not applicable devices.
     * @returns a integer
     */
    get notApplicableDeviceCount() {
        return this._notApplicableDeviceCount;
    }
    ;
    /**
     * Sets the notApplicableDeviceCount property value. Number of not applicable devices.
     * @param value Value to set for the notApplicableDeviceCount property.
     */
    set notApplicableDeviceCount(value) {
        this._notApplicableDeviceCount = value;
    }
    ;
    /**
     * Gets the notApplicableUserCount property value. Number of not applicable users.
     * @returns a integer
     */
    get notApplicableUserCount() {
        return this._notApplicableUserCount;
    }
    ;
    /**
     * Sets the notApplicableUserCount property value. Number of not applicable users.
     * @param value Value to set for the notApplicableUserCount property.
     */
    set notApplicableUserCount(value) {
        this._notApplicableUserCount = value;
    }
    ;
    /**
     * Gets the remediatedDeviceCount property value. Number of remediated devices.
     * @returns a integer
     */
    get remediatedDeviceCount() {
        return this._remediatedDeviceCount;
    }
    ;
    /**
     * Sets the remediatedDeviceCount property value. Number of remediated devices.
     * @param value Value to set for the remediatedDeviceCount property.
     */
    set remediatedDeviceCount(value) {
        this._remediatedDeviceCount = value;
    }
    ;
    /**
     * Gets the remediatedUserCount property value. Number of remediated users.
     * @returns a integer
     */
    get remediatedUserCount() {
        return this._remediatedUserCount;
    }
    ;
    /**
     * Sets the remediatedUserCount property value. Number of remediated users.
     * @param value Value to set for the remediatedUserCount property.
     */
    set remediatedUserCount(value) {
        this._remediatedUserCount = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeNumberValue("compliantDeviceCount", this.compliantDeviceCount);
        writer.writeNumberValue("compliantUserCount", this.compliantUserCount);
        writer.writeNumberValue("conflictDeviceCount", this.conflictDeviceCount);
        writer.writeNumberValue("conflictUserCount", this.conflictUserCount);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeNumberValue("errorDeviceCount", this.errorDeviceCount);
        writer.writeNumberValue("errorUserCount", this.errorUserCount);
        writer.writeNumberValue("nonCompliantDeviceCount", this.nonCompliantDeviceCount);
        writer.writeNumberValue("nonCompliantUserCount", this.nonCompliantUserCount);
        writer.writeNumberValue("notApplicableDeviceCount", this.notApplicableDeviceCount);
        writer.writeNumberValue("notApplicableUserCount", this.notApplicableUserCount);
        writer.writeNumberValue("remediatedDeviceCount", this.remediatedDeviceCount);
        writer.writeNumberValue("remediatedUserCount", this.remediatedUserCount);
        writer.writeNumberValue("unknownDeviceCount", this.unknownDeviceCount);
        writer.writeNumberValue("unknownUserCount", this.unknownUserCount);
    }
    ;
    /**
     * Gets the unknownDeviceCount property value. Number of unknown devices.
     * @returns a integer
     */
    get unknownDeviceCount() {
        return this._unknownDeviceCount;
    }
    ;
    /**
     * Sets the unknownDeviceCount property value. Number of unknown devices.
     * @param value Value to set for the unknownDeviceCount property.
     */
    set unknownDeviceCount(value) {
        this._unknownDeviceCount = value;
    }
    ;
    /**
     * Gets the unknownUserCount property value. Number of unknown users.
     * @returns a integer
     */
    get unknownUserCount() {
        return this._unknownUserCount;
    }
    ;
    /**
     * Sets the unknownUserCount property value. Number of unknown users.
     * @param value Value to set for the unknownUserCount property.
     */
    set unknownUserCount(value) {
        this._unknownUserCount = value;
    }
    ;
}
exports.SoftwareUpdateStatusSummary = SoftwareUpdateStatusSummary;
