"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StoragePlanInformation = void 0;
class StoragePlanInformation {
    /**
     * Instantiates a new storagePlanInformation and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "upgradeAvailable": (o, n) => { o.upgradeAvailable = n.getBooleanValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("upgradeAvailable", this.upgradeAvailable);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the upgradeAvailable property value. Indicates whether there are higher storage quota plans available. Read-only.
     * @returns a boolean
     */
    get upgradeAvailable() {
        return this._upgradeAvailable;
    }
    ;
    /**
     * Sets the upgradeAvailable property value. Indicates whether there are higher storage quota plans available. Read-only.
     * @param value Value to set for the upgradeAvailable property.
     */
    set upgradeAvailable(value) {
        this._upgradeAvailable = value;
    }
    ;
}
exports.StoragePlanInformation = StoragePlanInformation;
