import { DirectoryObject, PolicyBase } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class StsPolicy extends PolicyBase implements Parsable {
    private _appliesTo?;
    /** A string collection containing a JSON string that defines the rules and settings for a policy. The syntax for the definition differs for each derived policy type. Required.  */
    private _definition?;
    /** If set to true, activates this policy. There can be many policies for the same policy type, but only one can be activated as the organization default. Optional, default value is false.  */
    private _isOrganizationDefault?;
    /**
     * Gets the appliesTo property value.
     * @returns a directoryObject
     */
    get appliesTo(): DirectoryObject[] | undefined;
    /**
     * Sets the appliesTo property value.
     * @param value Value to set for the appliesTo property.
     */
    set appliesTo(value: DirectoryObject[] | undefined);
    /**
     * Instantiates a new stsPolicy and sets the default values.
     */
    constructor();
    /**
     * Gets the definition property value. A string collection containing a JSON string that defines the rules and settings for a policy. The syntax for the definition differs for each derived policy type. Required.
     * @returns a string
     */
    get definition(): string[] | undefined;
    /**
     * Sets the definition property value. A string collection containing a JSON string that defines the rules and settings for a policy. The syntax for the definition differs for each derived policy type. Required.
     * @param value Value to set for the definition property.
     */
    set definition(value: string[] | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the isOrganizationDefault property value. If set to true, activates this policy. There can be many policies for the same policy type, but only one can be activated as the organization default. Optional, default value is false.
     * @returns a boolean
     */
    get isOrganizationDefault(): boolean | undefined;
    /**
     * Sets the isOrganizationDefault property value. If set to true, activates this policy. There can be many policies for the same policy type, but only one can be activated as the organization default. Optional, default value is false.
     * @param value Value to set for the isOrganizationDefault property.
     */
    set isOrganizationDefault(value: boolean | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
