"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SubjectRightsRequest = void 0;
const createAuthoredNoteFromDiscriminatorValue_1 = require("./createAuthoredNoteFromDiscriminatorValue");
const createDataSubjectFromDiscriminatorValue_1 = require("./createDataSubjectFromDiscriminatorValue");
const createIdentityFromDiscriminatorValue_1 = require("./createIdentityFromDiscriminatorValue");
const createIdentitySetFromDiscriminatorValue_1 = require("./createIdentitySetFromDiscriminatorValue");
const createSubjectRightsRequestDetailFromDiscriminatorValue_1 = require("./createSubjectRightsRequestDetailFromDiscriminatorValue");
const createSubjectRightsRequestHistoryFromDiscriminatorValue_1 = require("./createSubjectRightsRequestHistoryFromDiscriminatorValue");
const createSubjectRightsRequestStageDetailFromDiscriminatorValue_1 = require("./createSubjectRightsRequestStageDetailFromDiscriminatorValue");
const createTeamFromDiscriminatorValue_1 = require("./createTeamFromDiscriminatorValue");
const dataSubjectType_1 = require("./dataSubjectType");
const index_1 = require("./index");
const subjectRightsRequestStatus_1 = require("./subjectRightsRequestStatus");
const subjectRightsRequestType_1 = require("./subjectRightsRequestType");
class SubjectRightsRequest extends index_1.Entity {
    /**
     * Instantiates a new subjectRightsRequest and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the assignedTo property value. Identity that the request is assigned to.
     * @returns a identity
     */
    get assignedTo() {
        return this._assignedTo;
    }
    ;
    /**
     * Sets the assignedTo property value. Identity that the request is assigned to.
     * @param value Value to set for the assignedTo property.
     */
    set assignedTo(value) {
        this._assignedTo = value;
    }
    ;
    /**
     * Gets the closedDateTime property value. The date and time when the request was closed. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z.
     * @returns a Date
     */
    get closedDateTime() {
        return this._closedDateTime;
    }
    ;
    /**
     * Sets the closedDateTime property value. The date and time when the request was closed. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z.
     * @param value Value to set for the closedDateTime property.
     */
    set closedDateTime(value) {
        this._closedDateTime = value;
    }
    ;
    ;
    /**
     * Gets the createdBy property value. Identity information for the entity that created the request.
     * @returns a identitySet
     */
    get createdBy() {
        return this._createdBy;
    }
    ;
    /**
     * Sets the createdBy property value. Identity information for the entity that created the request.
     * @param value Value to set for the createdBy property.
     */
    set createdBy(value) {
        this._createdBy = value;
    }
    ;
    /**
     * Gets the createdDateTime property value. The date and time when the request was created. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z.
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. The date and time when the request was created. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * Gets the dataSubject property value. Information about the data subject.
     * @returns a dataSubject
     */
    get dataSubject() {
        return this._dataSubject;
    }
    ;
    /**
     * Sets the dataSubject property value. Information about the data subject.
     * @param value Value to set for the dataSubject property.
     */
    set dataSubject(value) {
        this._dataSubject = value;
    }
    ;
    /**
     * Gets the dataSubjectType property value. The type of the data subject. Possible values are: customer, currentEmployee, formerEmployee, prospectiveEmployee, student, teacher, faculty, other, unknownFutureValue.
     * @returns a dataSubjectType
     */
    get dataSubjectType() {
        return this._dataSubjectType;
    }
    ;
    /**
     * Sets the dataSubjectType property value. The type of the data subject. Possible values are: customer, currentEmployee, formerEmployee, prospectiveEmployee, student, teacher, faculty, other, unknownFutureValue.
     * @param value Value to set for the dataSubjectType property.
     */
    set dataSubjectType(value) {
        this._dataSubjectType = value;
    }
    ;
    /**
     * Gets the description property value. Description for the request.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. Description for the request.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the displayName property value. The name of the request.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The name of the request.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "assignedTo": (o, n) => { o.assignedTo = n.getObjectValue(createIdentityFromDiscriminatorValue_1.createIdentityFromDiscriminatorValue); }, "closedDateTime": (o, n) => { o.closedDateTime = n.getDateValue(); }, "createdBy": (o, n) => { o.createdBy = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); }, "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); }, "dataSubject": (o, n) => { o.dataSubject = n.getObjectValue(createDataSubjectFromDiscriminatorValue_1.createDataSubjectFromDiscriminatorValue); }, "dataSubjectType": (o, n) => { o.dataSubjectType = n.getEnumValue(dataSubjectType_1.DataSubjectType); }, "description": (o, n) => { o.description = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "history": (o, n) => { o.history = n.getCollectionOfObjectValues(createSubjectRightsRequestHistoryFromDiscriminatorValue_1.createSubjectRightsRequestHistoryFromDiscriminatorValue); }, "insight": (o, n) => { o.insight = n.getObjectValue(createSubjectRightsRequestDetailFromDiscriminatorValue_1.createSubjectRightsRequestDetailFromDiscriminatorValue); }, "internalDueDateTime": (o, n) => { o.internalDueDateTime = n.getDateValue(); }, "lastModifiedBy": (o, n) => { o.lastModifiedBy = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); }, "lastModifiedDateTime": (o, n) => { o.lastModifiedDateTime = n.getDateValue(); }, "notes": (o, n) => { o.notes = n.getCollectionOfObjectValues(createAuthoredNoteFromDiscriminatorValue_1.createAuthoredNoteFromDiscriminatorValue); }, "regulations": (o, n) => { o.regulations = n.getCollectionOfPrimitiveValues(); }, "stages": (o, n) => { o.stages = n.getCollectionOfObjectValues(createSubjectRightsRequestStageDetailFromDiscriminatorValue_1.createSubjectRightsRequestStageDetailFromDiscriminatorValue); }, "status": (o, n) => { o.status = n.getEnumValue(subjectRightsRequestStatus_1.SubjectRightsRequestStatus); }, "team": (o, n) => { o.team = n.getObjectValue(createTeamFromDiscriminatorValue_1.createTeamFromDiscriminatorValue); }, "type": (o, n) => { o.type = n.getEnumValue(subjectRightsRequestType_1.SubjectRightsRequestType); } });
    }
    ;
    /**
     * Gets the history property value. Collection of history change events.
     * @returns a subjectRightsRequestHistory
     */
    get history() {
        return this._history;
    }
    ;
    /**
     * Sets the history property value. Collection of history change events.
     * @param value Value to set for the history property.
     */
    set history(value) {
        this._history = value;
    }
    ;
    /**
     * Gets the insight property value. Insight about the request.
     * @returns a subjectRightsRequestDetail
     */
    get insight() {
        return this._insight;
    }
    ;
    /**
     * Sets the insight property value. Insight about the request.
     * @param value Value to set for the insight property.
     */
    set insight(value) {
        this._insight = value;
    }
    ;
    /**
     * Gets the internalDueDateTime property value. The date and time when the request is internally due. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z.
     * @returns a Date
     */
    get internalDueDateTime() {
        return this._internalDueDateTime;
    }
    ;
    /**
     * Sets the internalDueDateTime property value. The date and time when the request is internally due. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z.
     * @param value Value to set for the internalDueDateTime property.
     */
    set internalDueDateTime(value) {
        this._internalDueDateTime = value;
    }
    ;
    /**
     * Gets the lastModifiedBy property value. Identity information for the entity that last modified the request.
     * @returns a identitySet
     */
    get lastModifiedBy() {
        return this._lastModifiedBy;
    }
    ;
    /**
     * Sets the lastModifiedBy property value. Identity information for the entity that last modified the request.
     * @param value Value to set for the lastModifiedBy property.
     */
    set lastModifiedBy(value) {
        this._lastModifiedBy = value;
    }
    ;
    /**
     * Gets the lastModifiedDateTime property value. The date and time when the request was last modified. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z.
     * @returns a Date
     */
    get lastModifiedDateTime() {
        return this._lastModifiedDateTime;
    }
    ;
    /**
     * Sets the lastModifiedDateTime property value. The date and time when the request was last modified. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z.
     * @param value Value to set for the lastModifiedDateTime property.
     */
    set lastModifiedDateTime(value) {
        this._lastModifiedDateTime = value;
    }
    ;
    /**
     * Gets the notes property value. List of notes associcated with the request.
     * @returns a authoredNote
     */
    get notes() {
        return this._notes;
    }
    ;
    /**
     * Sets the notes property value. List of notes associcated with the request.
     * @param value Value to set for the notes property.
     */
    set notes(value) {
        this._notes = value;
    }
    ;
    /**
     * Gets the regulations property value. List of regulations that this request will fulfill.
     * @returns a string
     */
    get regulations() {
        return this._regulations;
    }
    ;
    /**
     * Sets the regulations property value. List of regulations that this request will fulfill.
     * @param value Value to set for the regulations property.
     */
    set regulations(value) {
        this._regulations = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("assignedTo", this.assignedTo);
        writer.writeDateValue("closedDateTime", this.closedDateTime);
        writer.writeObjectValue("createdBy", this.createdBy);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeObjectValue("dataSubject", this.dataSubject);
        writer.writeEnumValue("dataSubjectType", this.dataSubjectType);
        writer.writeStringValue("description", this.description);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeCollectionOfObjectValues("history", this.history);
        writer.writeObjectValue("insight", this.insight);
        writer.writeDateValue("internalDueDateTime", this.internalDueDateTime);
        writer.writeObjectValue("lastModifiedBy", this.lastModifiedBy);
        writer.writeDateValue("lastModifiedDateTime", this.lastModifiedDateTime);
        writer.writeCollectionOfObjectValues("notes", this.notes);
        writer.writeCollectionOfPrimitiveValues("regulations", this.regulations);
        writer.writeCollectionOfObjectValues("stages", this.stages);
        writer.writeEnumValue("status", this.status);
        writer.writeObjectValue("team", this.team);
        writer.writeEnumValue("type", this.type);
    }
    ;
    /**
     * Gets the stages property value. Information about the different stages for the request.
     * @returns a subjectRightsRequestStageDetail
     */
    get stages() {
        return this._stages;
    }
    ;
    /**
     * Sets the stages property value. Information about the different stages for the request.
     * @param value Value to set for the stages property.
     */
    set stages(value) {
        this._stages = value;
    }
    ;
    /**
     * Gets the status property value. The status of the request.. Possible values are: active, closed, unknownFutureValue.
     * @returns a subjectRightsRequestStatus
     */
    get status() {
        return this._status;
    }
    ;
    /**
     * Sets the status property value. The status of the request.. Possible values are: active, closed, unknownFutureValue.
     * @param value Value to set for the status property.
     */
    set status(value) {
        this._status = value;
    }
    ;
    /**
     * Gets the team property value. Information about the Microsoft Teams team that was created for the request.
     * @returns a team
     */
    get team() {
        return this._team;
    }
    ;
    /**
     * Sets the team property value. Information about the Microsoft Teams team that was created for the request.
     * @param value Value to set for the team property.
     */
    set team(value) {
        this._team = value;
    }
    ;
    /**
     * Gets the type property value. The type of the request. Possible values are: export, delete, access, tagForAction, unknownFutureValue.
     * @returns a subjectRightsRequestType
     */
    get type() {
        return this._type;
    }
    ;
    /**
     * Sets the type property value. The type of the request. Possible values are: export, delete, access, tagForAction, unknownFutureValue.
     * @param value Value to set for the type property.
     */
    set type(value) {
        this._type = value;
    }
    ;
}
exports.SubjectRightsRequest = SubjectRightsRequest;
