"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SubjectRightsRequestDetail = void 0;
const createKeyValuePairFromDiscriminatorValue_1 = require("./createKeyValuePairFromDiscriminatorValue");
class SubjectRightsRequestDetail {
    /**
     * Instantiates a new subjectRightsRequestDetail and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the excludedItemCount property value. Count of items that are excluded from the request.
     * @returns a int64
     */
    get excludedItemCount() {
        return this._excludedItemCount;
    }
    ;
    /**
     * Sets the excludedItemCount property value. Count of items that are excluded from the request.
     * @param value Value to set for the excludedItemCount property.
     */
    set excludedItemCount(value) {
        this._excludedItemCount = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "excludedItemCount": (o, n) => { o.excludedItemCount = n.getNumberValue(); },
            "insightCounts": (o, n) => { o.insightCounts = n.getCollectionOfObjectValues(createKeyValuePairFromDiscriminatorValue_1.createKeyValuePairFromDiscriminatorValue); },
            "itemCount": (o, n) => { o.itemCount = n.getNumberValue(); },
            "itemNeedReview": (o, n) => { o.itemNeedReview = n.getNumberValue(); },
            "productItemCounts": (o, n) => { o.productItemCounts = n.getCollectionOfObjectValues(createKeyValuePairFromDiscriminatorValue_1.createKeyValuePairFromDiscriminatorValue); },
            "signedOffItemCount": (o, n) => { o.signedOffItemCount = n.getNumberValue(); },
            "totalItemSize": (o, n) => { o.totalItemSize = n.getNumberValue(); },
        };
    }
    ;
    /**
     * Gets the insightCounts property value. Count of items per insight.
     * @returns a keyValuePair
     */
    get insightCounts() {
        return this._insightCounts;
    }
    ;
    /**
     * Sets the insightCounts property value. Count of items per insight.
     * @param value Value to set for the insightCounts property.
     */
    set insightCounts(value) {
        this._insightCounts = value;
    }
    ;
    /**
     * Gets the itemCount property value. Count of items found.
     * @returns a int64
     */
    get itemCount() {
        return this._itemCount;
    }
    ;
    /**
     * Sets the itemCount property value. Count of items found.
     * @param value Value to set for the itemCount property.
     */
    set itemCount(value) {
        this._itemCount = value;
    }
    ;
    /**
     * Gets the itemNeedReview property value. Count of item that need review.
     * @returns a int64
     */
    get itemNeedReview() {
        return this._itemNeedReview;
    }
    ;
    /**
     * Sets the itemNeedReview property value. Count of item that need review.
     * @param value Value to set for the itemNeedReview property.
     */
    set itemNeedReview(value) {
        this._itemNeedReview = value;
    }
    ;
    /**
     * Gets the productItemCounts property value. Count of items per product, such as Exchange, SharePoint, OneDrive, and Teams.
     * @returns a keyValuePair
     */
    get productItemCounts() {
        return this._productItemCounts;
    }
    ;
    /**
     * Sets the productItemCounts property value. Count of items per product, such as Exchange, SharePoint, OneDrive, and Teams.
     * @param value Value to set for the productItemCounts property.
     */
    set productItemCounts(value) {
        this._productItemCounts = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeNumberValue("excludedItemCount", this.excludedItemCount);
        writer.writeCollectionOfObjectValues("insightCounts", this.insightCounts);
        writer.writeNumberValue("itemCount", this.itemCount);
        writer.writeNumberValue("itemNeedReview", this.itemNeedReview);
        writer.writeCollectionOfObjectValues("productItemCounts", this.productItemCounts);
        writer.writeNumberValue("signedOffItemCount", this.signedOffItemCount);
        writer.writeNumberValue("totalItemSize", this.totalItemSize);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the signedOffItemCount property value. Count of items signed off by the administrator.
     * @returns a int64
     */
    get signedOffItemCount() {
        return this._signedOffItemCount;
    }
    ;
    /**
     * Sets the signedOffItemCount property value. Count of items signed off by the administrator.
     * @param value Value to set for the signedOffItemCount property.
     */
    set signedOffItemCount(value) {
        this._signedOffItemCount = value;
    }
    ;
    /**
     * Gets the totalItemSize property value. Total item size in bytes.
     * @returns a int64
     */
    get totalItemSize() {
        return this._totalItemSize;
    }
    ;
    /**
     * Sets the totalItemSize property value. Total item size in bytes.
     * @param value Value to set for the totalItemSize property.
     */
    set totalItemSize(value) {
        this._totalItemSize = value;
    }
    ;
}
exports.SubjectRightsRequestDetail = SubjectRightsRequestDetail;
