"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SubjectRightsRequestHistory = void 0;
const createIdentitySetFromDiscriminatorValue_1 = require("./createIdentitySetFromDiscriminatorValue");
const subjectRightsRequestStage_1 = require("./subjectRightsRequestStage");
const subjectRightsRequestStageStatus_1 = require("./subjectRightsRequestStageStatus");
class SubjectRightsRequestHistory {
    /**
     * Instantiates a new subjectRightsRequestHistory and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the changedBy property value. Identity of the user who changed the  subject rights request.
     * @returns a identitySet
     */
    get changedBy() {
        return this._changedBy;
    }
    ;
    /**
     * Sets the changedBy property value. Identity of the user who changed the  subject rights request.
     * @param value Value to set for the changedBy property.
     */
    set changedBy(value) {
        this._changedBy = value;
    }
    ;
    ;
    /**
     * Gets the eventDateTime property value. Data and time when the entity was changed.
     * @returns a Date
     */
    get eventDateTime() {
        return this._eventDateTime;
    }
    ;
    /**
     * Sets the eventDateTime property value. Data and time when the entity was changed.
     * @param value Value to set for the eventDateTime property.
     */
    set eventDateTime(value) {
        this._eventDateTime = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "changedBy": (o, n) => { o.changedBy = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); },
            "eventDateTime": (o, n) => { o.eventDateTime = n.getDateValue(); },
            "stage": (o, n) => { o.stage = n.getEnumValue(subjectRightsRequestStage_1.SubjectRightsRequestStage); },
            "stageStatus": (o, n) => { o.stageStatus = n.getEnumValue(subjectRightsRequestStageStatus_1.SubjectRightsRequestStageStatus); },
            "type": (o, n) => { o.type = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("changedBy", this.changedBy);
        writer.writeDateValue("eventDateTime", this.eventDateTime);
        writer.writeEnumValue("stage", this.stage);
        writer.writeEnumValue("stageStatus", this.stageStatus);
        writer.writeStringValue("type", this.type);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the stage property value. The stage when the entity was changed. Possible values are: contentRetrieval, contentReview, generateReport, contentDeletion, caseResolved, unknownFutureValue.
     * @returns a subjectRightsRequestStage
     */
    get stage() {
        return this._stage;
    }
    ;
    /**
     * Sets the stage property value. The stage when the entity was changed. Possible values are: contentRetrieval, contentReview, generateReport, contentDeletion, caseResolved, unknownFutureValue.
     * @param value Value to set for the stage property.
     */
    set stage(value) {
        this._stage = value;
    }
    ;
    /**
     * Gets the stageStatus property value. The status of the stage when the entity was changed. Possible values are: notStarted, current, completed, failed, unknownFutureValue.
     * @returns a subjectRightsRequestStageStatus
     */
    get stageStatus() {
        return this._stageStatus;
    }
    ;
    /**
     * Sets the stageStatus property value. The status of the stage when the entity was changed. Possible values are: notStarted, current, completed, failed, unknownFutureValue.
     * @param value Value to set for the stageStatus property.
     */
    set stageStatus(value) {
        this._stageStatus = value;
    }
    ;
    /**
     * Gets the type property value. Type of history.
     * @returns a string
     */
    get type() {
        return this._type;
    }
    ;
    /**
     * Sets the type property value. Type of history.
     * @param value Value to set for the type property.
     */
    set type(value) {
        this._type = value;
    }
    ;
}
exports.SubjectRightsRequestHistory = SubjectRightsRequestHistory;
