"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SubjectRightsRequestStageDetail = void 0;
const createPublicErrorFromDiscriminatorValue_1 = require("./createPublicErrorFromDiscriminatorValue");
const subjectRightsRequestStage_1 = require("./subjectRightsRequestStage");
const subjectRightsRequestStageStatus_1 = require("./subjectRightsRequestStageStatus");
class SubjectRightsRequestStageDetail {
    /**
     * Instantiates a new subjectRightsRequestStageDetail and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the error property value. Describes the error, if any, for the current stage.
     * @returns a publicError
     */
    get error_escaped() {
        return this._error_escaped;
    }
    ;
    /**
     * Sets the error property value. Describes the error, if any, for the current stage.
     * @param value Value to set for the error_escaped property.
     */
    set error_escaped(value) {
        this._error_escaped = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "error": (o, n) => { o.error_escaped = n.getObjectValue(createPublicErrorFromDiscriminatorValue_1.createPublicErrorFromDiscriminatorValue); },
            "stage": (o, n) => { o.stage = n.getEnumValue(subjectRightsRequestStage_1.SubjectRightsRequestStage); },
            "status": (o, n) => { o.status = n.getEnumValue(subjectRightsRequestStageStatus_1.SubjectRightsRequestStageStatus); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("error", this.error_escaped);
        writer.writeEnumValue("stage", this.stage);
        writer.writeEnumValue("status", this.status);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the stage property value. The stage of the subject rights request. Possible values are: contentRetrieval, contentReview, generateReport, contentDeletion, caseResolved, unknownFutureValue.
     * @returns a subjectRightsRequestStage
     */
    get stage() {
        return this._stage;
    }
    ;
    /**
     * Sets the stage property value. The stage of the subject rights request. Possible values are: contentRetrieval, contentReview, generateReport, contentDeletion, caseResolved, unknownFutureValue.
     * @param value Value to set for the stage property.
     */
    set stage(value) {
        this._stage = value;
    }
    ;
    /**
     * Gets the status property value. Status of the current stage. Possible values are: notStarted, current, completed, failed, unknownFutureValue.
     * @returns a subjectRightsRequestStageStatus
     */
    get status() {
        return this._status;
    }
    ;
    /**
     * Sets the status property value. Status of the current stage. Possible values are: notStarted, current, completed, failed, unknownFutureValue.
     * @param value Value to set for the status property.
     */
    set status(value) {
        this._status = value;
    }
    ;
}
exports.SubjectRightsRequestStageDetail = SubjectRightsRequestStageDetail;
