"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SubscribedSku = void 0;
const createLicenseUnitsDetailFromDiscriminatorValue_1 = require("./createLicenseUnitsDetailFromDiscriminatorValue");
const createServicePlanInfoFromDiscriminatorValue_1 = require("./createServicePlanInfoFromDiscriminatorValue");
const index_1 = require("./index");
class SubscribedSku extends index_1.Entity {
    /**
     * Instantiates a new subscribedSku and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the appliesTo property value. For example, 'User' or 'Company'.
     * @returns a string
     */
    get appliesTo() {
        return this._appliesTo;
    }
    ;
    /**
     * Sets the appliesTo property value. For example, 'User' or 'Company'.
     * @param value Value to set for the appliesTo property.
     */
    set appliesTo(value) {
        this._appliesTo = value;
    }
    ;
    /**
     * Gets the capabilityStatus property value. Possible values are: Enabled, Warning, Suspended, Deleted, LockedOut. The capabilityStatus is Enabled if the prepaidUnits property has at least 1 unit that is enabled, and LockedOut if the customer cancelled their subscription.
     * @returns a string
     */
    get capabilityStatus() {
        return this._capabilityStatus;
    }
    ;
    /**
     * Sets the capabilityStatus property value. Possible values are: Enabled, Warning, Suspended, Deleted, LockedOut. The capabilityStatus is Enabled if the prepaidUnits property has at least 1 unit that is enabled, and LockedOut if the customer cancelled their subscription.
     * @param value Value to set for the capabilityStatus property.
     */
    set capabilityStatus(value) {
        this._capabilityStatus = value;
    }
    ;
    ;
    /**
     * Gets the consumedUnits property value. The number of licenses that have been assigned.
     * @returns a integer
     */
    get consumedUnits() {
        return this._consumedUnits;
    }
    ;
    /**
     * Sets the consumedUnits property value. The number of licenses that have been assigned.
     * @param value Value to set for the consumedUnits property.
     */
    set consumedUnits(value) {
        this._consumedUnits = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "appliesTo": (o, n) => { o.appliesTo = n.getStringValue(); }, "capabilityStatus": (o, n) => { o.capabilityStatus = n.getStringValue(); }, "consumedUnits": (o, n) => { o.consumedUnits = n.getNumberValue(); }, "prepaidUnits": (o, n) => { o.prepaidUnits = n.getObjectValue(createLicenseUnitsDetailFromDiscriminatorValue_1.createLicenseUnitsDetailFromDiscriminatorValue); }, "servicePlans": (o, n) => { o.servicePlans = n.getCollectionOfObjectValues(createServicePlanInfoFromDiscriminatorValue_1.createServicePlanInfoFromDiscriminatorValue); }, "skuId": (o, n) => { o.skuId = n.getStringValue(); }, "skuPartNumber": (o, n) => { o.skuPartNumber = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the prepaidUnits property value. Information about the number and status of prepaid licenses.
     * @returns a licenseUnitsDetail
     */
    get prepaidUnits() {
        return this._prepaidUnits;
    }
    ;
    /**
     * Sets the prepaidUnits property value. Information about the number and status of prepaid licenses.
     * @param value Value to set for the prepaidUnits property.
     */
    set prepaidUnits(value) {
        this._prepaidUnits = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("appliesTo", this.appliesTo);
        writer.writeStringValue("capabilityStatus", this.capabilityStatus);
        writer.writeNumberValue("consumedUnits", this.consumedUnits);
        writer.writeObjectValue("prepaidUnits", this.prepaidUnits);
        writer.writeCollectionOfObjectValues("servicePlans", this.servicePlans);
        writer.writeStringValue("skuId", this.skuId);
        writer.writeStringValue("skuPartNumber", this.skuPartNumber);
    }
    ;
    /**
     * Gets the servicePlans property value. Information about the service plans that are available with the SKU. Not nullable
     * @returns a servicePlanInfo
     */
    get servicePlans() {
        return this._servicePlans;
    }
    ;
    /**
     * Sets the servicePlans property value. Information about the service plans that are available with the SKU. Not nullable
     * @param value Value to set for the servicePlans property.
     */
    set servicePlans(value) {
        this._servicePlans = value;
    }
    ;
    /**
     * Gets the skuId property value. The unique identifier (GUID) for the service SKU.
     * @returns a string
     */
    get skuId() {
        return this._skuId;
    }
    ;
    /**
     * Sets the skuId property value. The unique identifier (GUID) for the service SKU.
     * @param value Value to set for the skuId property.
     */
    set skuId(value) {
        this._skuId = value;
    }
    ;
    /**
     * Gets the skuPartNumber property value. The SKU part number; for example: 'AAD_PREMIUM' or 'RMSBASIC'. To get a list of commercial subscriptions that an organization has acquired, see List subscribedSkus.
     * @returns a string
     */
    get skuPartNumber() {
        return this._skuPartNumber;
    }
    ;
    /**
     * Sets the skuPartNumber property value. The SKU part number; for example: 'AAD_PREMIUM' or 'RMSBASIC'. To get a list of commercial subscriptions that an organization has acquired, see List subscribedSkus.
     * @param value Value to set for the skuPartNumber property.
     */
    set skuPartNumber(value) {
        this._skuPartNumber = value;
    }
    ;
}
exports.SubscribedSku = SubscribedSku;
