"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Subscription = void 0;
const index_1 = require("./index");
class Subscription extends index_1.Entity {
    /**
     * Instantiates a new subscription and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the applicationId property value. Optional. Identifier of the application used to create the subscription. Read-only.
     * @returns a string
     */
    get applicationId() {
        return this._applicationId;
    }
    ;
    /**
     * Sets the applicationId property value. Optional. Identifier of the application used to create the subscription. Read-only.
     * @param value Value to set for the applicationId property.
     */
    set applicationId(value) {
        this._applicationId = value;
    }
    ;
    /**
     * Gets the changeType property value. Required. Indicates the type of change in the subscribed resource that will raise a change notification. The supported values are: created, updated, deleted. Multiple values can be combined using a comma-separated list. Note:  Drive root item and list change notifications support only the updated changeType. User and group change notifications support updated and deleted changeType.
     * @returns a string
     */
    get changeType() {
        return this._changeType;
    }
    ;
    /**
     * Sets the changeType property value. Required. Indicates the type of change in the subscribed resource that will raise a change notification. The supported values are: created, updated, deleted. Multiple values can be combined using a comma-separated list. Note:  Drive root item and list change notifications support only the updated changeType. User and group change notifications support updated and deleted changeType.
     * @param value Value to set for the changeType property.
     */
    set changeType(value) {
        this._changeType = value;
    }
    ;
    /**
     * Gets the clientState property value. Optional. Specifies the value of the clientState property sent by the service in each change notification. The maximum length is 128 characters. The client can check that the change notification came from the service by comparing the value of the clientState property sent with the subscription with the value of the clientState property received with each change notification.
     * @returns a string
     */
    get clientState() {
        return this._clientState;
    }
    ;
    /**
     * Sets the clientState property value. Optional. Specifies the value of the clientState property sent by the service in each change notification. The maximum length is 128 characters. The client can check that the change notification came from the service by comparing the value of the clientState property sent with the subscription with the value of the clientState property received with each change notification.
     * @param value Value to set for the clientState property.
     */
    set clientState(value) {
        this._clientState = value;
    }
    ;
    ;
    /**
     * Gets the creatorId property value. Optional. Identifier of the user or service principal that created the subscription. If the app used delegated permissions to create the subscription, this field contains the id of the signed-in user the app called on behalf of. If the app used application permissions, this field contains the id of the service principal corresponding to the app. Read-only.
     * @returns a string
     */
    get creatorId() {
        return this._creatorId;
    }
    ;
    /**
     * Sets the creatorId property value. Optional. Identifier of the user or service principal that created the subscription. If the app used delegated permissions to create the subscription, this field contains the id of the signed-in user the app called on behalf of. If the app used application permissions, this field contains the id of the service principal corresponding to the app. Read-only.
     * @param value Value to set for the creatorId property.
     */
    set creatorId(value) {
        this._creatorId = value;
    }
    ;
    /**
     * Gets the encryptionCertificate property value. Optional. A base64-encoded representation of a certificate with a public key used to encrypt resource data in change notifications. Optional but required when includeResourceData is true.
     * @returns a string
     */
    get encryptionCertificate() {
        return this._encryptionCertificate;
    }
    ;
    /**
     * Sets the encryptionCertificate property value. Optional. A base64-encoded representation of a certificate with a public key used to encrypt resource data in change notifications. Optional but required when includeResourceData is true.
     * @param value Value to set for the encryptionCertificate property.
     */
    set encryptionCertificate(value) {
        this._encryptionCertificate = value;
    }
    ;
    /**
     * Gets the encryptionCertificateId property value. Optional. A custom app-provided identifier to help identify the certificate needed to decrypt resource data.
     * @returns a string
     */
    get encryptionCertificateId() {
        return this._encryptionCertificateId;
    }
    ;
    /**
     * Sets the encryptionCertificateId property value. Optional. A custom app-provided identifier to help identify the certificate needed to decrypt resource data.
     * @param value Value to set for the encryptionCertificateId property.
     */
    set encryptionCertificateId(value) {
        this._encryptionCertificateId = value;
    }
    ;
    /**
     * Gets the expirationDateTime property value. Required. Specifies the date and time when the webhook subscription expires. The time is in UTC, and can be an amount of time from subscription creation that varies for the resource subscribed to. For the maximum supported subscription length of time, see the table below.
     * @returns a Date
     */
    get expirationDateTime() {
        return this._expirationDateTime;
    }
    ;
    /**
     * Sets the expirationDateTime property value. Required. Specifies the date and time when the webhook subscription expires. The time is in UTC, and can be an amount of time from subscription creation that varies for the resource subscribed to. For the maximum supported subscription length of time, see the table below.
     * @param value Value to set for the expirationDateTime property.
     */
    set expirationDateTime(value) {
        this._expirationDateTime = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "applicationId": (o, n) => { o.applicationId = n.getStringValue(); }, "changeType": (o, n) => { o.changeType = n.getStringValue(); }, "clientState": (o, n) => { o.clientState = n.getStringValue(); }, "creatorId": (o, n) => { o.creatorId = n.getStringValue(); }, "encryptionCertificate": (o, n) => { o.encryptionCertificate = n.getStringValue(); }, "encryptionCertificateId": (o, n) => { o.encryptionCertificateId = n.getStringValue(); }, "expirationDateTime": (o, n) => { o.expirationDateTime = n.getDateValue(); }, "includeResourceData": (o, n) => { o.includeResourceData = n.getBooleanValue(); }, "latestSupportedTlsVersion": (o, n) => { o.latestSupportedTlsVersion = n.getStringValue(); }, "lifecycleNotificationUrl": (o, n) => { o.lifecycleNotificationUrl = n.getStringValue(); }, "notificationQueryOptions": (o, n) => { o.notificationQueryOptions = n.getStringValue(); }, "notificationUrl": (o, n) => { o.notificationUrl = n.getStringValue(); }, "notificationUrlAppId": (o, n) => { o.notificationUrlAppId = n.getStringValue(); }, "resource": (o, n) => { o.resource = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the includeResourceData property value. Optional. When set to true, change notifications include resource data (such as content of a chat message).
     * @returns a boolean
     */
    get includeResourceData() {
        return this._includeResourceData;
    }
    ;
    /**
     * Sets the includeResourceData property value. Optional. When set to true, change notifications include resource data (such as content of a chat message).
     * @param value Value to set for the includeResourceData property.
     */
    set includeResourceData(value) {
        this._includeResourceData = value;
    }
    ;
    /**
     * Gets the latestSupportedTlsVersion property value. Optional. Specifies the latest version of Transport Layer Security (TLS) that the notification endpoint, specified by notificationUrl, supports. The possible values are: v1_0, v1_1, v1_2, v1_3. For subscribers whose notification endpoint supports a version lower than the currently recommended version (TLS 1.2), specifying this property by a set timeline allows them to temporarily use their deprecated version of TLS before completing their upgrade to TLS 1.2. For these subscribers, not setting this property per the timeline would result in subscription operations failing. For subscribers whose notification endpoint already supports TLS 1.2, setting this property is optional. In such cases, Microsoft Graph defaults the property to v1_2.
     * @returns a string
     */
    get latestSupportedTlsVersion() {
        return this._latestSupportedTlsVersion;
    }
    ;
    /**
     * Sets the latestSupportedTlsVersion property value. Optional. Specifies the latest version of Transport Layer Security (TLS) that the notification endpoint, specified by notificationUrl, supports. The possible values are: v1_0, v1_1, v1_2, v1_3. For subscribers whose notification endpoint supports a version lower than the currently recommended version (TLS 1.2), specifying this property by a set timeline allows them to temporarily use their deprecated version of TLS before completing their upgrade to TLS 1.2. For these subscribers, not setting this property per the timeline would result in subscription operations failing. For subscribers whose notification endpoint already supports TLS 1.2, setting this property is optional. In such cases, Microsoft Graph defaults the property to v1_2.
     * @param value Value to set for the latestSupportedTlsVersion property.
     */
    set latestSupportedTlsVersion(value) {
        this._latestSupportedTlsVersion = value;
    }
    ;
    /**
     * Gets the lifecycleNotificationUrl property value. Optional. The URL of the endpoint that receives lifecycle notifications, including subscriptionRemoved and missed notifications. This URL must make use of the HTTPS protocol.
     * @returns a string
     */
    get lifecycleNotificationUrl() {
        return this._lifecycleNotificationUrl;
    }
    ;
    /**
     * Sets the lifecycleNotificationUrl property value. Optional. The URL of the endpoint that receives lifecycle notifications, including subscriptionRemoved and missed notifications. This URL must make use of the HTTPS protocol.
     * @param value Value to set for the lifecycleNotificationUrl property.
     */
    set lifecycleNotificationUrl(value) {
        this._lifecycleNotificationUrl = value;
    }
    ;
    /**
     * Gets the notificationQueryOptions property value. Optional. OData query options for specifying value for the targeting resource. Clients receive notifications when resource reaches the state matching the query options provided here. With this new property in the subscription creation payload along with all existing properties, Webhooks will deliver notifications whenever a resource reaches the desired state mentioned in the notificationQueryOptions property. For example, when the print job is completed or when a print job resource isFetchable property value becomes true etc.
     * @returns a string
     */
    get notificationQueryOptions() {
        return this._notificationQueryOptions;
    }
    ;
    /**
     * Sets the notificationQueryOptions property value. Optional. OData query options for specifying value for the targeting resource. Clients receive notifications when resource reaches the state matching the query options provided here. With this new property in the subscription creation payload along with all existing properties, Webhooks will deliver notifications whenever a resource reaches the desired state mentioned in the notificationQueryOptions property. For example, when the print job is completed or when a print job resource isFetchable property value becomes true etc.
     * @param value Value to set for the notificationQueryOptions property.
     */
    set notificationQueryOptions(value) {
        this._notificationQueryOptions = value;
    }
    ;
    /**
     * Gets the notificationUrl property value. Required. The URL of the endpoint that will receive the change notifications. This URL must make use of the HTTPS protocol.
     * @returns a string
     */
    get notificationUrl() {
        return this._notificationUrl;
    }
    ;
    /**
     * Sets the notificationUrl property value. Required. The URL of the endpoint that will receive the change notifications. This URL must make use of the HTTPS protocol.
     * @param value Value to set for the notificationUrl property.
     */
    set notificationUrl(value) {
        this._notificationUrl = value;
    }
    ;
    /**
     * Gets the notificationUrlAppId property value. Optional. The app ID that the subscription service can use to generate the validation token. This allows the client to validate the authenticity of the notification received.
     * @returns a string
     */
    get notificationUrlAppId() {
        return this._notificationUrlAppId;
    }
    ;
    /**
     * Sets the notificationUrlAppId property value. Optional. The app ID that the subscription service can use to generate the validation token. This allows the client to validate the authenticity of the notification received.
     * @param value Value to set for the notificationUrlAppId property.
     */
    set notificationUrlAppId(value) {
        this._notificationUrlAppId = value;
    }
    ;
    /**
     * Gets the resource property value. Required. Specifies the resource that will be monitored for changes. Do not include the base URL (https://graph.microsoft.com/v1.0/). See the possible resource path values for each supported resource.
     * @returns a string
     */
    get resource() {
        return this._resource;
    }
    ;
    /**
     * Sets the resource property value. Required. Specifies the resource that will be monitored for changes. Do not include the base URL (https://graph.microsoft.com/v1.0/). See the possible resource path values for each supported resource.
     * @param value Value to set for the resource property.
     */
    set resource(value) {
        this._resource = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("applicationId", this.applicationId);
        writer.writeStringValue("changeType", this.changeType);
        writer.writeStringValue("clientState", this.clientState);
        writer.writeStringValue("creatorId", this.creatorId);
        writer.writeStringValue("encryptionCertificate", this.encryptionCertificate);
        writer.writeStringValue("encryptionCertificateId", this.encryptionCertificateId);
        writer.writeDateValue("expirationDateTime", this.expirationDateTime);
        writer.writeBooleanValue("includeResourceData", this.includeResourceData);
        writer.writeStringValue("latestSupportedTlsVersion", this.latestSupportedTlsVersion);
        writer.writeStringValue("lifecycleNotificationUrl", this.lifecycleNotificationUrl);
        writer.writeStringValue("notificationQueryOptions", this.notificationQueryOptions);
        writer.writeStringValue("notificationUrl", this.notificationUrl);
        writer.writeStringValue("notificationUrlAppId", this.notificationUrlAppId);
        writer.writeStringValue("resource", this.resource);
    }
    ;
}
exports.Subscription = Subscription;
