"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TargetedManagedAppConfiguration = void 0;
const createManagedAppPolicyDeploymentSummaryFromDiscriminatorValue_1 = require("./createManagedAppPolicyDeploymentSummaryFromDiscriminatorValue");
const createManagedMobileAppFromDiscriminatorValue_1 = require("./createManagedMobileAppFromDiscriminatorValue");
const createTargetedManagedAppPolicyAssignmentFromDiscriminatorValue_1 = require("./createTargetedManagedAppPolicyAssignmentFromDiscriminatorValue");
const index_1 = require("./index");
class TargetedManagedAppConfiguration extends index_1.ManagedAppConfiguration {
    /**
     * Instantiates a new targetedManagedAppConfiguration and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the apps property value. List of apps to which the policy is deployed.
     * @returns a managedMobileApp
     */
    get apps() {
        return this._apps;
    }
    ;
    /**
     * Sets the apps property value. List of apps to which the policy is deployed.
     * @param value Value to set for the apps property.
     */
    set apps(value) {
        this._apps = value;
    }
    ;
    /**
     * Gets the assignments property value. Navigation property to list of inclusion and exclusion groups to which the policy is deployed.
     * @returns a targetedManagedAppPolicyAssignment
     */
    get assignments() {
        return this._assignments;
    }
    ;
    /**
     * Sets the assignments property value. Navigation property to list of inclusion and exclusion groups to which the policy is deployed.
     * @param value Value to set for the assignments property.
     */
    set assignments(value) {
        this._assignments = value;
    }
    ;
    ;
    /**
     * Gets the deployedAppCount property value. Count of apps to which the current policy is deployed.
     * @returns a integer
     */
    get deployedAppCount() {
        return this._deployedAppCount;
    }
    ;
    /**
     * Sets the deployedAppCount property value. Count of apps to which the current policy is deployed.
     * @param value Value to set for the deployedAppCount property.
     */
    set deployedAppCount(value) {
        this._deployedAppCount = value;
    }
    ;
    /**
     * Gets the deploymentSummary property value. Navigation property to deployment summary of the configuration.
     * @returns a managedAppPolicyDeploymentSummary
     */
    get deploymentSummary() {
        return this._deploymentSummary;
    }
    ;
    /**
     * Sets the deploymentSummary property value. Navigation property to deployment summary of the configuration.
     * @param value Value to set for the deploymentSummary property.
     */
    set deploymentSummary(value) {
        this._deploymentSummary = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "apps": (o, n) => { o.apps = n.getCollectionOfObjectValues(createManagedMobileAppFromDiscriminatorValue_1.createManagedMobileAppFromDiscriminatorValue); }, "assignments": (o, n) => { o.assignments = n.getCollectionOfObjectValues(createTargetedManagedAppPolicyAssignmentFromDiscriminatorValue_1.createTargetedManagedAppPolicyAssignmentFromDiscriminatorValue); }, "deployedAppCount": (o, n) => { o.deployedAppCount = n.getNumberValue(); }, "deploymentSummary": (o, n) => { o.deploymentSummary = n.getObjectValue(createManagedAppPolicyDeploymentSummaryFromDiscriminatorValue_1.createManagedAppPolicyDeploymentSummaryFromDiscriminatorValue); }, "isAssigned": (o, n) => { o.isAssigned = n.getBooleanValue(); } });
    }
    ;
    /**
     * Gets the isAssigned property value. Indicates if the policy is deployed to any inclusion groups or not.
     * @returns a boolean
     */
    get isAssigned() {
        return this._isAssigned;
    }
    ;
    /**
     * Sets the isAssigned property value. Indicates if the policy is deployed to any inclusion groups or not.
     * @param value Value to set for the isAssigned property.
     */
    set isAssigned(value) {
        this._isAssigned = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("apps", this.apps);
        writer.writeCollectionOfObjectValues("assignments", this.assignments);
        writer.writeNumberValue("deployedAppCount", this.deployedAppCount);
        writer.writeObjectValue("deploymentSummary", this.deploymentSummary);
        writer.writeBooleanValue("isAssigned", this.isAssigned);
    }
    ;
}
exports.TargetedManagedAppConfiguration = TargetedManagedAppConfiguration;
