"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Team = void 0;
const createChannelFromDiscriminatorValue_1 = require("./createChannelFromDiscriminatorValue");
const createConversationMemberFromDiscriminatorValue_1 = require("./createConversationMemberFromDiscriminatorValue");
const createGroupFromDiscriminatorValue_1 = require("./createGroupFromDiscriminatorValue");
const createScheduleFromDiscriminatorValue_1 = require("./createScheduleFromDiscriminatorValue");
const createTeamFunSettingsFromDiscriminatorValue_1 = require("./createTeamFunSettingsFromDiscriminatorValue");
const createTeamGuestSettingsFromDiscriminatorValue_1 = require("./createTeamGuestSettingsFromDiscriminatorValue");
const createTeamMemberSettingsFromDiscriminatorValue_1 = require("./createTeamMemberSettingsFromDiscriminatorValue");
const createTeamMessagingSettingsFromDiscriminatorValue_1 = require("./createTeamMessagingSettingsFromDiscriminatorValue");
const createTeamsAppInstallationFromDiscriminatorValue_1 = require("./createTeamsAppInstallationFromDiscriminatorValue");
const createTeamsAsyncOperationFromDiscriminatorValue_1 = require("./createTeamsAsyncOperationFromDiscriminatorValue");
const createTeamsTemplateFromDiscriminatorValue_1 = require("./createTeamsTemplateFromDiscriminatorValue");
const index_1 = require("./index");
const teamSpecialization_1 = require("./teamSpecialization");
const teamVisibilityType_1 = require("./teamVisibilityType");
class Team extends index_1.Entity {
    /**
     * Instantiates a new team and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the channels property value. The collection of channels and messages associated with the team.
     * @returns a channel
     */
    get channels() {
        return this._channels;
    }
    ;
    /**
     * Sets the channels property value. The collection of channels and messages associated with the team.
     * @param value Value to set for the channels property.
     */
    set channels(value) {
        this._channels = value;
    }
    ;
    /**
     * Gets the classification property value. An optional label. Typically describes the data or business sensitivity of the team. Must match one of a pre-configured set in the tenant's directory.
     * @returns a string
     */
    get classification() {
        return this._classification;
    }
    ;
    /**
     * Sets the classification property value. An optional label. Typically describes the data or business sensitivity of the team. Must match one of a pre-configured set in the tenant's directory.
     * @param value Value to set for the classification property.
     */
    set classification(value) {
        this._classification = value;
    }
    ;
    ;
    /**
     * Gets the createdDateTime property value. Timestamp at which the team was created.
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. Timestamp at which the team was created.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * Gets the description property value. An optional description for the team. Maximum length: 1024 characters.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. An optional description for the team. Maximum length: 1024 characters.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the displayName property value. The name of the team.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The name of the team.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * Gets the funSettings property value. Settings to configure use of Giphy, memes, and stickers in the team.
     * @returns a teamFunSettings
     */
    get funSettings() {
        return this._funSettings;
    }
    ;
    /**
     * Sets the funSettings property value. Settings to configure use of Giphy, memes, and stickers in the team.
     * @param value Value to set for the funSettings property.
     */
    set funSettings(value) {
        this._funSettings = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "channels": (o, n) => { o.channels = n.getCollectionOfObjectValues(createChannelFromDiscriminatorValue_1.createChannelFromDiscriminatorValue); }, "classification": (o, n) => { o.classification = n.getStringValue(); }, "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); }, "description": (o, n) => { o.description = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "funSettings": (o, n) => { o.funSettings = n.getObjectValue(createTeamFunSettingsFromDiscriminatorValue_1.createTeamFunSettingsFromDiscriminatorValue); }, "group": (o, n) => { o.group = n.getObjectValue(createGroupFromDiscriminatorValue_1.createGroupFromDiscriminatorValue); }, "guestSettings": (o, n) => { o.guestSettings = n.getObjectValue(createTeamGuestSettingsFromDiscriminatorValue_1.createTeamGuestSettingsFromDiscriminatorValue); }, "installedApps": (o, n) => { o.installedApps = n.getCollectionOfObjectValues(createTeamsAppInstallationFromDiscriminatorValue_1.createTeamsAppInstallationFromDiscriminatorValue); }, "internalId": (o, n) => { o.internalId = n.getStringValue(); }, "isArchived": (o, n) => { o.isArchived = n.getBooleanValue(); }, "members": (o, n) => { o.members = n.getCollectionOfObjectValues(createConversationMemberFromDiscriminatorValue_1.createConversationMemberFromDiscriminatorValue); }, "memberSettings": (o, n) => { o.memberSettings = n.getObjectValue(createTeamMemberSettingsFromDiscriminatorValue_1.createTeamMemberSettingsFromDiscriminatorValue); }, "messagingSettings": (o, n) => { o.messagingSettings = n.getObjectValue(createTeamMessagingSettingsFromDiscriminatorValue_1.createTeamMessagingSettingsFromDiscriminatorValue); }, "operations": (o, n) => { o.operations = n.getCollectionOfObjectValues(createTeamsAsyncOperationFromDiscriminatorValue_1.createTeamsAsyncOperationFromDiscriminatorValue); }, "primaryChannel": (o, n) => { o.primaryChannel = n.getObjectValue(createChannelFromDiscriminatorValue_1.createChannelFromDiscriminatorValue); }, "schedule": (o, n) => { o.schedule = n.getObjectValue(createScheduleFromDiscriminatorValue_1.createScheduleFromDiscriminatorValue); }, "specialization": (o, n) => { o.specialization = n.getEnumValue(teamSpecialization_1.TeamSpecialization); }, "template": (o, n) => { o.template = n.getObjectValue(createTeamsTemplateFromDiscriminatorValue_1.createTeamsTemplateFromDiscriminatorValue); }, "visibility": (o, n) => { o.visibility = n.getEnumValue(teamVisibilityType_1.TeamVisibilityType); }, "webUrl": (o, n) => { o.webUrl = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the group property value.
     * @returns a group
     */
    get group() {
        return this._group;
    }
    ;
    /**
     * Sets the group property value.
     * @param value Value to set for the group property.
     */
    set group(value) {
        this._group = value;
    }
    ;
    /**
     * Gets the guestSettings property value. Settings to configure whether guests can create, update, or delete channels in the team.
     * @returns a teamGuestSettings
     */
    get guestSettings() {
        return this._guestSettings;
    }
    ;
    /**
     * Sets the guestSettings property value. Settings to configure whether guests can create, update, or delete channels in the team.
     * @param value Value to set for the guestSettings property.
     */
    set guestSettings(value) {
        this._guestSettings = value;
    }
    ;
    /**
     * Gets the installedApps property value. The apps installed in this team.
     * @returns a teamsAppInstallation
     */
    get installedApps() {
        return this._installedApps;
    }
    ;
    /**
     * Sets the installedApps property value. The apps installed in this team.
     * @param value Value to set for the installedApps property.
     */
    set installedApps(value) {
        this._installedApps = value;
    }
    ;
    /**
     * Gets the internalId property value. A unique ID for the team that has been used in a few places such as the audit log/Office 365 Management Activity API.
     * @returns a string
     */
    get internalId() {
        return this._internalId;
    }
    ;
    /**
     * Sets the internalId property value. A unique ID for the team that has been used in a few places such as the audit log/Office 365 Management Activity API.
     * @param value Value to set for the internalId property.
     */
    set internalId(value) {
        this._internalId = value;
    }
    ;
    /**
     * Gets the isArchived property value. Whether this team is in read-only mode.
     * @returns a boolean
     */
    get isArchived() {
        return this._isArchived;
    }
    ;
    /**
     * Sets the isArchived property value. Whether this team is in read-only mode.
     * @param value Value to set for the isArchived property.
     */
    set isArchived(value) {
        this._isArchived = value;
    }
    ;
    /**
     * Gets the members property value. Members and owners of the team.
     * @returns a conversationMember
     */
    get members() {
        return this._members;
    }
    ;
    /**
     * Sets the members property value. Members and owners of the team.
     * @param value Value to set for the members property.
     */
    set members(value) {
        this._members = value;
    }
    ;
    /**
     * Gets the memberSettings property value. Settings to configure whether members can perform certain actions, for example, create channels and add bots, in the team.
     * @returns a teamMemberSettings
     */
    get memberSettings() {
        return this._memberSettings;
    }
    ;
    /**
     * Sets the memberSettings property value. Settings to configure whether members can perform certain actions, for example, create channels and add bots, in the team.
     * @param value Value to set for the memberSettings property.
     */
    set memberSettings(value) {
        this._memberSettings = value;
    }
    ;
    /**
     * Gets the messagingSettings property value. Settings to configure messaging and mentions in the team.
     * @returns a teamMessagingSettings
     */
    get messagingSettings() {
        return this._messagingSettings;
    }
    ;
    /**
     * Sets the messagingSettings property value. Settings to configure messaging and mentions in the team.
     * @param value Value to set for the messagingSettings property.
     */
    set messagingSettings(value) {
        this._messagingSettings = value;
    }
    ;
    /**
     * Gets the operations property value. The async operations that ran or are running on this team.
     * @returns a teamsAsyncOperation
     */
    get operations() {
        return this._operations;
    }
    ;
    /**
     * Sets the operations property value. The async operations that ran or are running on this team.
     * @param value Value to set for the operations property.
     */
    set operations(value) {
        this._operations = value;
    }
    ;
    /**
     * Gets the primaryChannel property value. The general channel for the team.
     * @returns a channel
     */
    get primaryChannel() {
        return this._primaryChannel;
    }
    ;
    /**
     * Sets the primaryChannel property value. The general channel for the team.
     * @param value Value to set for the primaryChannel property.
     */
    set primaryChannel(value) {
        this._primaryChannel = value;
    }
    ;
    /**
     * Gets the schedule property value. The schedule of shifts for this team.
     * @returns a schedule
     */
    get schedule() {
        return this._schedule;
    }
    ;
    /**
     * Sets the schedule property value. The schedule of shifts for this team.
     * @param value Value to set for the schedule property.
     */
    set schedule(value) {
        this._schedule = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("channels", this.channels);
        writer.writeStringValue("classification", this.classification);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeStringValue("description", this.description);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeObjectValue("funSettings", this.funSettings);
        writer.writeObjectValue("group", this.group);
        writer.writeObjectValue("guestSettings", this.guestSettings);
        writer.writeCollectionOfObjectValues("installedApps", this.installedApps);
        writer.writeStringValue("internalId", this.internalId);
        writer.writeBooleanValue("isArchived", this.isArchived);
        writer.writeCollectionOfObjectValues("members", this.members);
        writer.writeObjectValue("memberSettings", this.memberSettings);
        writer.writeObjectValue("messagingSettings", this.messagingSettings);
        writer.writeCollectionOfObjectValues("operations", this.operations);
        writer.writeObjectValue("primaryChannel", this.primaryChannel);
        writer.writeObjectValue("schedule", this.schedule);
        writer.writeEnumValue("specialization", this.specialization);
        writer.writeObjectValue("template", this.template);
        writer.writeEnumValue("visibility", this.visibility);
        writer.writeStringValue("webUrl", this.webUrl);
    }
    ;
    /**
     * Gets the specialization property value. Optional. Indicates whether the team is intended for a particular use case.  Each team specialization has access to unique behaviors and experiences targeted to its use case.
     * @returns a teamSpecialization
     */
    get specialization() {
        return this._specialization;
    }
    ;
    /**
     * Sets the specialization property value. Optional. Indicates whether the team is intended for a particular use case.  Each team specialization has access to unique behaviors and experiences targeted to its use case.
     * @param value Value to set for the specialization property.
     */
    set specialization(value) {
        this._specialization = value;
    }
    ;
    /**
     * Gets the template property value. The template this team was created from. See available templates.
     * @returns a teamsTemplate
     */
    get template() {
        return this._template;
    }
    ;
    /**
     * Sets the template property value. The template this team was created from. See available templates.
     * @param value Value to set for the template property.
     */
    set template(value) {
        this._template = value;
    }
    ;
    /**
     * Gets the visibility property value. The visibility of the group and team. Defaults to Public.
     * @returns a teamVisibilityType
     */
    get visibility() {
        return this._visibility;
    }
    ;
    /**
     * Sets the visibility property value. The visibility of the group and team. Defaults to Public.
     * @param value Value to set for the visibility property.
     */
    set visibility(value) {
        this._visibility = value;
    }
    ;
    /**
     * Gets the webUrl property value. A hyperlink that will go to the team in the Microsoft Teams client. This is the URL that you get when you right-click a team in the Microsoft Teams client and select Get link to team. This URL should be treated as an opaque blob, and not parsed.
     * @returns a string
     */
    get webUrl() {
        return this._webUrl;
    }
    ;
    /**
     * Sets the webUrl property value. A hyperlink that will go to the team in the Microsoft Teams client. This is the URL that you get when you right-click a team in the Microsoft Teams client and select Get link to team. This URL should be treated as an opaque blob, and not parsed.
     * @param value Value to set for the webUrl property.
     */
    set webUrl(value) {
        this._webUrl = value;
    }
    ;
}
exports.Team = Team;
