import { GiphyRatingType } from './giphyRatingType';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class TeamFunSettings implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** If set to true, enables users to include custom memes.  */
    private _allowCustomMemes?;
    /** If set to true, enables Giphy use.  */
    private _allowGiphy?;
    /** If set to true, enables users to include stickers and memes.  */
    private _allowStickersAndMemes?;
    /** Giphy content rating. Possible values are: moderate, strict.  */
    private _giphyContentRating?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the allowCustomMemes property value. If set to true, enables users to include custom memes.
     * @returns a boolean
     */
    get allowCustomMemes(): boolean | undefined;
    /**
     * Sets the allowCustomMemes property value. If set to true, enables users to include custom memes.
     * @param value Value to set for the allowCustomMemes property.
     */
    set allowCustomMemes(value: boolean | undefined);
    /**
     * Gets the allowGiphy property value. If set to true, enables Giphy use.
     * @returns a boolean
     */
    get allowGiphy(): boolean | undefined;
    /**
     * Sets the allowGiphy property value. If set to true, enables Giphy use.
     * @param value Value to set for the allowGiphy property.
     */
    set allowGiphy(value: boolean | undefined);
    /**
     * Gets the allowStickersAndMemes property value. If set to true, enables users to include stickers and memes.
     * @returns a boolean
     */
    get allowStickersAndMemes(): boolean | undefined;
    /**
     * Sets the allowStickersAndMemes property value. If set to true, enables users to include stickers and memes.
     * @param value Value to set for the allowStickersAndMemes property.
     */
    set allowStickersAndMemes(value: boolean | undefined);
    /**
     * Instantiates a new teamFunSettings and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the giphyContentRating property value. Giphy content rating. Possible values are: moderate, strict.
     * @returns a giphyRatingType
     */
    get giphyContentRating(): GiphyRatingType | undefined;
    /**
     * Sets the giphyContentRating property value. Giphy content rating. Possible values are: moderate, strict.
     * @param value Value to set for the giphyContentRating property.
     */
    set giphyContentRating(value: GiphyRatingType | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
