"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TeamFunSettings = void 0;
const giphyRatingType_1 = require("./giphyRatingType");
class TeamFunSettings {
    /**
     * Instantiates a new teamFunSettings and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the allowCustomMemes property value. If set to true, enables users to include custom memes.
     * @returns a boolean
     */
    get allowCustomMemes() {
        return this._allowCustomMemes;
    }
    ;
    /**
     * Sets the allowCustomMemes property value. If set to true, enables users to include custom memes.
     * @param value Value to set for the allowCustomMemes property.
     */
    set allowCustomMemes(value) {
        this._allowCustomMemes = value;
    }
    ;
    /**
     * Gets the allowGiphy property value. If set to true, enables Giphy use.
     * @returns a boolean
     */
    get allowGiphy() {
        return this._allowGiphy;
    }
    ;
    /**
     * Sets the allowGiphy property value. If set to true, enables Giphy use.
     * @param value Value to set for the allowGiphy property.
     */
    set allowGiphy(value) {
        this._allowGiphy = value;
    }
    ;
    /**
     * Gets the allowStickersAndMemes property value. If set to true, enables users to include stickers and memes.
     * @returns a boolean
     */
    get allowStickersAndMemes() {
        return this._allowStickersAndMemes;
    }
    ;
    /**
     * Sets the allowStickersAndMemes property value. If set to true, enables users to include stickers and memes.
     * @param value Value to set for the allowStickersAndMemes property.
     */
    set allowStickersAndMemes(value) {
        this._allowStickersAndMemes = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "allowCustomMemes": (o, n) => { o.allowCustomMemes = n.getBooleanValue(); },
            "allowGiphy": (o, n) => { o.allowGiphy = n.getBooleanValue(); },
            "allowStickersAndMemes": (o, n) => { o.allowStickersAndMemes = n.getBooleanValue(); },
            "giphyContentRating": (o, n) => { o.giphyContentRating = n.getEnumValue(giphyRatingType_1.GiphyRatingType); },
        };
    }
    ;
    /**
     * Gets the giphyContentRating property value. Giphy content rating. Possible values are: moderate, strict.
     * @returns a giphyRatingType
     */
    get giphyContentRating() {
        return this._giphyContentRating;
    }
    ;
    /**
     * Sets the giphyContentRating property value. Giphy content rating. Possible values are: moderate, strict.
     * @param value Value to set for the giphyContentRating property.
     */
    set giphyContentRating(value) {
        this._giphyContentRating = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("allowCustomMemes", this.allowCustomMemes);
        writer.writeBooleanValue("allowGiphy", this.allowGiphy);
        writer.writeBooleanValue("allowStickersAndMemes", this.allowStickersAndMemes);
        writer.writeEnumValue("giphyContentRating", this.giphyContentRating);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.TeamFunSettings = TeamFunSettings;
