import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class TeamMemberSettings implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** If set to true, members can add and remove apps.  */
    private _allowAddRemoveApps?;
    /** If set to true, members can add and update private channels.  */
    private _allowCreatePrivateChannels?;
    /** If set to true, members can add and update channels.  */
    private _allowCreateUpdateChannels?;
    /** If set to true, members can add, update, and remove connectors.  */
    private _allowCreateUpdateRemoveConnectors?;
    /** If set to true, members can add, update, and remove tabs.  */
    private _allowCreateUpdateRemoveTabs?;
    /** If set to true, members can delete channels.  */
    private _allowDeleteChannels?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the allowAddRemoveApps property value. If set to true, members can add and remove apps.
     * @returns a boolean
     */
    get allowAddRemoveApps(): boolean | undefined;
    /**
     * Sets the allowAddRemoveApps property value. If set to true, members can add and remove apps.
     * @param value Value to set for the allowAddRemoveApps property.
     */
    set allowAddRemoveApps(value: boolean | undefined);
    /**
     * Gets the allowCreatePrivateChannels property value. If set to true, members can add and update private channels.
     * @returns a boolean
     */
    get allowCreatePrivateChannels(): boolean | undefined;
    /**
     * Sets the allowCreatePrivateChannels property value. If set to true, members can add and update private channels.
     * @param value Value to set for the allowCreatePrivateChannels property.
     */
    set allowCreatePrivateChannels(value: boolean | undefined);
    /**
     * Gets the allowCreateUpdateChannels property value. If set to true, members can add and update channels.
     * @returns a boolean
     */
    get allowCreateUpdateChannels(): boolean | undefined;
    /**
     * Sets the allowCreateUpdateChannels property value. If set to true, members can add and update channels.
     * @param value Value to set for the allowCreateUpdateChannels property.
     */
    set allowCreateUpdateChannels(value: boolean | undefined);
    /**
     * Gets the allowCreateUpdateRemoveConnectors property value. If set to true, members can add, update, and remove connectors.
     * @returns a boolean
     */
    get allowCreateUpdateRemoveConnectors(): boolean | undefined;
    /**
     * Sets the allowCreateUpdateRemoveConnectors property value. If set to true, members can add, update, and remove connectors.
     * @param value Value to set for the allowCreateUpdateRemoveConnectors property.
     */
    set allowCreateUpdateRemoveConnectors(value: boolean | undefined);
    /**
     * Gets the allowCreateUpdateRemoveTabs property value. If set to true, members can add, update, and remove tabs.
     * @returns a boolean
     */
    get allowCreateUpdateRemoveTabs(): boolean | undefined;
    /**
     * Sets the allowCreateUpdateRemoveTabs property value. If set to true, members can add, update, and remove tabs.
     * @param value Value to set for the allowCreateUpdateRemoveTabs property.
     */
    set allowCreateUpdateRemoveTabs(value: boolean | undefined);
    /**
     * Gets the allowDeleteChannels property value. If set to true, members can delete channels.
     * @returns a boolean
     */
    get allowDeleteChannels(): boolean | undefined;
    /**
     * Sets the allowDeleteChannels property value. If set to true, members can delete channels.
     * @param value Value to set for the allowDeleteChannels property.
     */
    set allowDeleteChannels(value: boolean | undefined);
    /**
     * Instantiates a new teamMemberSettings and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
