"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TeamMemberSettings = void 0;
class TeamMemberSettings {
    /**
     * Instantiates a new teamMemberSettings and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the allowAddRemoveApps property value. If set to true, members can add and remove apps.
     * @returns a boolean
     */
    get allowAddRemoveApps() {
        return this._allowAddRemoveApps;
    }
    ;
    /**
     * Sets the allowAddRemoveApps property value. If set to true, members can add and remove apps.
     * @param value Value to set for the allowAddRemoveApps property.
     */
    set allowAddRemoveApps(value) {
        this._allowAddRemoveApps = value;
    }
    ;
    /**
     * Gets the allowCreatePrivateChannels property value. If set to true, members can add and update private channels.
     * @returns a boolean
     */
    get allowCreatePrivateChannels() {
        return this._allowCreatePrivateChannels;
    }
    ;
    /**
     * Sets the allowCreatePrivateChannels property value. If set to true, members can add and update private channels.
     * @param value Value to set for the allowCreatePrivateChannels property.
     */
    set allowCreatePrivateChannels(value) {
        this._allowCreatePrivateChannels = value;
    }
    ;
    /**
     * Gets the allowCreateUpdateChannels property value. If set to true, members can add and update channels.
     * @returns a boolean
     */
    get allowCreateUpdateChannels() {
        return this._allowCreateUpdateChannels;
    }
    ;
    /**
     * Sets the allowCreateUpdateChannels property value. If set to true, members can add and update channels.
     * @param value Value to set for the allowCreateUpdateChannels property.
     */
    set allowCreateUpdateChannels(value) {
        this._allowCreateUpdateChannels = value;
    }
    ;
    /**
     * Gets the allowCreateUpdateRemoveConnectors property value. If set to true, members can add, update, and remove connectors.
     * @returns a boolean
     */
    get allowCreateUpdateRemoveConnectors() {
        return this._allowCreateUpdateRemoveConnectors;
    }
    ;
    /**
     * Sets the allowCreateUpdateRemoveConnectors property value. If set to true, members can add, update, and remove connectors.
     * @param value Value to set for the allowCreateUpdateRemoveConnectors property.
     */
    set allowCreateUpdateRemoveConnectors(value) {
        this._allowCreateUpdateRemoveConnectors = value;
    }
    ;
    /**
     * Gets the allowCreateUpdateRemoveTabs property value. If set to true, members can add, update, and remove tabs.
     * @returns a boolean
     */
    get allowCreateUpdateRemoveTabs() {
        return this._allowCreateUpdateRemoveTabs;
    }
    ;
    /**
     * Sets the allowCreateUpdateRemoveTabs property value. If set to true, members can add, update, and remove tabs.
     * @param value Value to set for the allowCreateUpdateRemoveTabs property.
     */
    set allowCreateUpdateRemoveTabs(value) {
        this._allowCreateUpdateRemoveTabs = value;
    }
    ;
    /**
     * Gets the allowDeleteChannels property value. If set to true, members can delete channels.
     * @returns a boolean
     */
    get allowDeleteChannels() {
        return this._allowDeleteChannels;
    }
    ;
    /**
     * Sets the allowDeleteChannels property value. If set to true, members can delete channels.
     * @param value Value to set for the allowDeleteChannels property.
     */
    set allowDeleteChannels(value) {
        this._allowDeleteChannels = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "allowAddRemoveApps": (o, n) => { o.allowAddRemoveApps = n.getBooleanValue(); },
            "allowCreatePrivateChannels": (o, n) => { o.allowCreatePrivateChannels = n.getBooleanValue(); },
            "allowCreateUpdateChannels": (o, n) => { o.allowCreateUpdateChannels = n.getBooleanValue(); },
            "allowCreateUpdateRemoveConnectors": (o, n) => { o.allowCreateUpdateRemoveConnectors = n.getBooleanValue(); },
            "allowCreateUpdateRemoveTabs": (o, n) => { o.allowCreateUpdateRemoveTabs = n.getBooleanValue(); },
            "allowDeleteChannels": (o, n) => { o.allowDeleteChannels = n.getBooleanValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("allowAddRemoveApps", this.allowAddRemoveApps);
        writer.writeBooleanValue("allowCreatePrivateChannels", this.allowCreatePrivateChannels);
        writer.writeBooleanValue("allowCreateUpdateChannels", this.allowCreateUpdateChannels);
        writer.writeBooleanValue("allowCreateUpdateRemoveConnectors", this.allowCreateUpdateRemoveConnectors);
        writer.writeBooleanValue("allowCreateUpdateRemoveTabs", this.allowCreateUpdateRemoveTabs);
        writer.writeBooleanValue("allowDeleteChannels", this.allowDeleteChannels);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.TeamMemberSettings = TeamMemberSettings;
