import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class TeamMessagingSettings implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** If set to true, @channel mentions are allowed.  */
    private _allowChannelMentions?;
    /** If set to true, owners can delete any message.  */
    private _allowOwnerDeleteMessages?;
    /** If set to true, @team mentions are allowed.  */
    private _allowTeamMentions?;
    /** If set to true, users can delete their messages.  */
    private _allowUserDeleteMessages?;
    /** If set to true, users can edit their messages.  */
    private _allowUserEditMessages?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the allowChannelMentions property value. If set to true, @channel mentions are allowed.
     * @returns a boolean
     */
    get allowChannelMentions(): boolean | undefined;
    /**
     * Sets the allowChannelMentions property value. If set to true, @channel mentions are allowed.
     * @param value Value to set for the allowChannelMentions property.
     */
    set allowChannelMentions(value: boolean | undefined);
    /**
     * Gets the allowOwnerDeleteMessages property value. If set to true, owners can delete any message.
     * @returns a boolean
     */
    get allowOwnerDeleteMessages(): boolean | undefined;
    /**
     * Sets the allowOwnerDeleteMessages property value. If set to true, owners can delete any message.
     * @param value Value to set for the allowOwnerDeleteMessages property.
     */
    set allowOwnerDeleteMessages(value: boolean | undefined);
    /**
     * Gets the allowTeamMentions property value. If set to true, @team mentions are allowed.
     * @returns a boolean
     */
    get allowTeamMentions(): boolean | undefined;
    /**
     * Sets the allowTeamMentions property value. If set to true, @team mentions are allowed.
     * @param value Value to set for the allowTeamMentions property.
     */
    set allowTeamMentions(value: boolean | undefined);
    /**
     * Gets the allowUserDeleteMessages property value. If set to true, users can delete their messages.
     * @returns a boolean
     */
    get allowUserDeleteMessages(): boolean | undefined;
    /**
     * Sets the allowUserDeleteMessages property value. If set to true, users can delete their messages.
     * @param value Value to set for the allowUserDeleteMessages property.
     */
    set allowUserDeleteMessages(value: boolean | undefined);
    /**
     * Gets the allowUserEditMessages property value. If set to true, users can edit their messages.
     * @returns a boolean
     */
    get allowUserEditMessages(): boolean | undefined;
    /**
     * Sets the allowUserEditMessages property value. If set to true, users can edit their messages.
     * @param value Value to set for the allowUserEditMessages property.
     */
    set allowUserEditMessages(value: boolean | undefined);
    /**
     * Instantiates a new teamMessagingSettings and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
