"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TeamMessagingSettings = void 0;
class TeamMessagingSettings {
    /**
     * Instantiates a new teamMessagingSettings and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the allowChannelMentions property value. If set to true, @channel mentions are allowed.
     * @returns a boolean
     */
    get allowChannelMentions() {
        return this._allowChannelMentions;
    }
    ;
    /**
     * Sets the allowChannelMentions property value. If set to true, @channel mentions are allowed.
     * @param value Value to set for the allowChannelMentions property.
     */
    set allowChannelMentions(value) {
        this._allowChannelMentions = value;
    }
    ;
    /**
     * Gets the allowOwnerDeleteMessages property value. If set to true, owners can delete any message.
     * @returns a boolean
     */
    get allowOwnerDeleteMessages() {
        return this._allowOwnerDeleteMessages;
    }
    ;
    /**
     * Sets the allowOwnerDeleteMessages property value. If set to true, owners can delete any message.
     * @param value Value to set for the allowOwnerDeleteMessages property.
     */
    set allowOwnerDeleteMessages(value) {
        this._allowOwnerDeleteMessages = value;
    }
    ;
    /**
     * Gets the allowTeamMentions property value. If set to true, @team mentions are allowed.
     * @returns a boolean
     */
    get allowTeamMentions() {
        return this._allowTeamMentions;
    }
    ;
    /**
     * Sets the allowTeamMentions property value. If set to true, @team mentions are allowed.
     * @param value Value to set for the allowTeamMentions property.
     */
    set allowTeamMentions(value) {
        this._allowTeamMentions = value;
    }
    ;
    /**
     * Gets the allowUserDeleteMessages property value. If set to true, users can delete their messages.
     * @returns a boolean
     */
    get allowUserDeleteMessages() {
        return this._allowUserDeleteMessages;
    }
    ;
    /**
     * Sets the allowUserDeleteMessages property value. If set to true, users can delete their messages.
     * @param value Value to set for the allowUserDeleteMessages property.
     */
    set allowUserDeleteMessages(value) {
        this._allowUserDeleteMessages = value;
    }
    ;
    /**
     * Gets the allowUserEditMessages property value. If set to true, users can edit their messages.
     * @returns a boolean
     */
    get allowUserEditMessages() {
        return this._allowUserEditMessages;
    }
    ;
    /**
     * Sets the allowUserEditMessages property value. If set to true, users can edit their messages.
     * @param value Value to set for the allowUserEditMessages property.
     */
    set allowUserEditMessages(value) {
        this._allowUserEditMessages = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "allowChannelMentions": (o, n) => { o.allowChannelMentions = n.getBooleanValue(); },
            "allowOwnerDeleteMessages": (o, n) => { o.allowOwnerDeleteMessages = n.getBooleanValue(); },
            "allowTeamMentions": (o, n) => { o.allowTeamMentions = n.getBooleanValue(); },
            "allowUserDeleteMessages": (o, n) => { o.allowUserDeleteMessages = n.getBooleanValue(); },
            "allowUserEditMessages": (o, n) => { o.allowUserEditMessages = n.getBooleanValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("allowChannelMentions", this.allowChannelMentions);
        writer.writeBooleanValue("allowOwnerDeleteMessages", this.allowOwnerDeleteMessages);
        writer.writeBooleanValue("allowTeamMentions", this.allowTeamMentions);
        writer.writeBooleanValue("allowUserDeleteMessages", this.allowUserDeleteMessages);
        writer.writeBooleanValue("allowUserEditMessages", this.allowUserEditMessages);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.TeamMessagingSettings = TeamMessagingSettings;
