"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TeamsApp = void 0;
const createTeamsAppDefinitionFromDiscriminatorValue_1 = require("./createTeamsAppDefinitionFromDiscriminatorValue");
const index_1 = require("./index");
const teamsAppDistributionMethod_1 = require("./teamsAppDistributionMethod");
class TeamsApp extends index_1.Entity {
    /**
     * Instantiates a new teamsApp and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the appDefinitions property value. The details for each version of the app.
     * @returns a teamsAppDefinition
     */
    get appDefinitions() {
        return this._appDefinitions;
    }
    ;
    /**
     * Sets the appDefinitions property value. The details for each version of the app.
     * @param value Value to set for the appDefinitions property.
     */
    set appDefinitions(value) {
        this._appDefinitions = value;
    }
    ;
    ;
    /**
     * Gets the displayName property value. The name of the catalog app provided by the app developer in the Microsoft Teams zip app package.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The name of the catalog app provided by the app developer in the Microsoft Teams zip app package.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * Gets the distributionMethod property value. The method of distribution for the app. Read-only.
     * @returns a teamsAppDistributionMethod
     */
    get distributionMethod() {
        return this._distributionMethod;
    }
    ;
    /**
     * Sets the distributionMethod property value. The method of distribution for the app. Read-only.
     * @param value Value to set for the distributionMethod property.
     */
    set distributionMethod(value) {
        this._distributionMethod = value;
    }
    ;
    /**
     * Gets the externalId property value. The ID of the catalog provided by the app developer in the Microsoft Teams zip app package.
     * @returns a string
     */
    get externalId() {
        return this._externalId;
    }
    ;
    /**
     * Sets the externalId property value. The ID of the catalog provided by the app developer in the Microsoft Teams zip app package.
     * @param value Value to set for the externalId property.
     */
    set externalId(value) {
        this._externalId = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "appDefinitions": (o, n) => { o.appDefinitions = n.getCollectionOfObjectValues(createTeamsAppDefinitionFromDiscriminatorValue_1.createTeamsAppDefinitionFromDiscriminatorValue); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "distributionMethod": (o, n) => { o.distributionMethod = n.getEnumValue(teamsAppDistributionMethod_1.TeamsAppDistributionMethod); }, "externalId": (o, n) => { o.externalId = n.getStringValue(); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("appDefinitions", this.appDefinitions);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeEnumValue("distributionMethod", this.distributionMethod);
        writer.writeStringValue("externalId", this.externalId);
    }
    ;
}
exports.TeamsApp = TeamsApp;
