"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TeamsAppDefinition = void 0;
const createIdentitySetFromDiscriminatorValue_1 = require("./createIdentitySetFromDiscriminatorValue");
const createTeamworkBotFromDiscriminatorValue_1 = require("./createTeamworkBotFromDiscriminatorValue");
const index_1 = require("./index");
const teamsAppPublishingState_1 = require("./teamsAppPublishingState");
class TeamsAppDefinition extends index_1.Entity {
    /**
     * Instantiates a new teamsAppDefinition and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the bot property value. The details of the bot specified in the Teams app manifest.
     * @returns a teamworkBot
     */
    get bot() {
        return this._bot;
    }
    ;
    /**
     * Sets the bot property value. The details of the bot specified in the Teams app manifest.
     * @param value Value to set for the bot property.
     */
    set bot(value) {
        this._bot = value;
    }
    ;
    ;
    /**
     * Gets the createdBy property value.
     * @returns a identitySet
     */
    get createdBy() {
        return this._createdBy;
    }
    ;
    /**
     * Sets the createdBy property value.
     * @param value Value to set for the createdBy property.
     */
    set createdBy(value) {
        this._createdBy = value;
    }
    ;
    /**
     * Gets the description property value. Verbose description of the application.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. Verbose description of the application.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the displayName property value. The name of the app provided by the app developer.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The name of the app provided by the app developer.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "bot": (o, n) => { o.bot = n.getObjectValue(createTeamworkBotFromDiscriminatorValue_1.createTeamworkBotFromDiscriminatorValue); }, "createdBy": (o, n) => { o.createdBy = n.getObjectValue(createIdentitySetFromDiscriminatorValue_1.createIdentitySetFromDiscriminatorValue); }, "description": (o, n) => { o.description = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "lastModifiedDateTime": (o, n) => { o.lastModifiedDateTime = n.getDateValue(); }, "publishingState": (o, n) => { o.publishingState = n.getEnumValue(teamsAppPublishingState_1.TeamsAppPublishingState); }, "shortDescription": (o, n) => { o.shortDescription = n.getStringValue(); }, "teamsAppId": (o, n) => { o.teamsAppId = n.getStringValue(); }, "version": (o, n) => { o.version = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the lastModifiedDateTime property value.
     * @returns a Date
     */
    get lastModifiedDateTime() {
        return this._lastModifiedDateTime;
    }
    ;
    /**
     * Sets the lastModifiedDateTime property value.
     * @param value Value to set for the lastModifiedDateTime property.
     */
    set lastModifiedDateTime(value) {
        this._lastModifiedDateTime = value;
    }
    ;
    /**
     * Gets the publishingState property value. The published status of a specific version of a Teams app. Possible values are:submitted — The specific version of the Teams app has been submitted and is under review. published  — The request to publish the specific version of the Teams app has been approved by the admin and the app is published.  rejected — The request to publish the specific version of the Teams app was rejected by the admin.
     * @returns a teamsAppPublishingState
     */
    get publishingState() {
        return this._publishingState;
    }
    ;
    /**
     * Sets the publishingState property value. The published status of a specific version of a Teams app. Possible values are:submitted — The specific version of the Teams app has been submitted and is under review. published  — The request to publish the specific version of the Teams app has been approved by the admin and the app is published.  rejected — The request to publish the specific version of the Teams app was rejected by the admin.
     * @param value Value to set for the publishingState property.
     */
    set publishingState(value) {
        this._publishingState = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("bot", this.bot);
        writer.writeObjectValue("createdBy", this.createdBy);
        writer.writeStringValue("description", this.description);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeDateValue("lastModifiedDateTime", this.lastModifiedDateTime);
        writer.writeEnumValue("publishingState", this.publishingState);
        writer.writeStringValue("shortDescription", this.shortDescription);
        writer.writeStringValue("teamsAppId", this.teamsAppId);
        writer.writeStringValue("version", this.version);
    }
    ;
    /**
     * Gets the shortDescription property value. Short description of the application.
     * @returns a string
     */
    get shortDescription() {
        return this._shortDescription;
    }
    ;
    /**
     * Sets the shortDescription property value. Short description of the application.
     * @param value Value to set for the shortDescription property.
     */
    set shortDescription(value) {
        this._shortDescription = value;
    }
    ;
    /**
     * Gets the teamsAppId property value. The ID from the Teams app manifest.
     * @returns a string
     */
    get teamsAppId() {
        return this._teamsAppId;
    }
    ;
    /**
     * Sets the teamsAppId property value. The ID from the Teams app manifest.
     * @param value Value to set for the teamsAppId property.
     */
    set teamsAppId(value) {
        this._teamsAppId = value;
    }
    ;
    /**
     * Gets the version property value. The version number of the application.
     * @returns a string
     */
    get version() {
        return this._version;
    }
    ;
    /**
     * Sets the version property value. The version number of the application.
     * @param value Value to set for the version property.
     */
    set version(value) {
        this._version = value;
    }
    ;
}
exports.TeamsAppDefinition = TeamsAppDefinition;
