import { Entity, TeamsApp, TeamsAppDefinition } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class TeamsAppInstallation extends Entity implements Parsable {
    /** The app that is installed.  */
    private _teamsApp?;
    /** The details of this version of the app.  */
    private _teamsAppDefinition?;
    /**
     * Instantiates a new teamsAppInstallation and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the teamsApp property value. The app that is installed.
     * @returns a teamsApp
     */
    get teamsApp(): TeamsApp | undefined;
    /**
     * Sets the teamsApp property value. The app that is installed.
     * @param value Value to set for the teamsApp property.
     */
    set teamsApp(value: TeamsApp | undefined);
    /**
     * Gets the teamsAppDefinition property value. The details of this version of the app.
     * @returns a teamsAppDefinition
     */
    get teamsAppDefinition(): TeamsAppDefinition | undefined;
    /**
     * Sets the teamsAppDefinition property value. The details of this version of the app.
     * @param value Value to set for the teamsAppDefinition property.
     */
    set teamsAppDefinition(value: TeamsAppDefinition | undefined);
}
