import { Entity, OperationError } from './index';
import { TeamsAsyncOperationStatus } from './teamsAsyncOperationStatus';
import { TeamsAsyncOperationType } from './teamsAsyncOperationType';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class TeamsAsyncOperation extends Entity implements Parsable {
    /** Number of times the operation was attempted before being marked successful or failed.  */
    private _attemptsCount?;
    /** Time when the operation was created.  */
    private _createdDateTime?;
    /** Any error that causes the async operation to fail.  */
    private _error_escaped?;
    /** Time when the async operation was last updated.  */
    private _lastActionDateTime?;
    /** Denotes which type of operation is being described.  */
    private _operationType?;
    /** Operation status.  */
    private _status?;
    /** The ID of the object that's created or modified as result of this async operation, typically a team.  */
    private _targetResourceId?;
    /** The location of the object that's created or modified as result of this async operation. This URL should be treated as an opaque value and not parsed into its component paths.  */
    private _targetResourceLocation?;
    /**
     * Gets the attemptsCount property value. Number of times the operation was attempted before being marked successful or failed.
     * @returns a integer
     */
    get attemptsCount(): number | undefined;
    /**
     * Sets the attemptsCount property value. Number of times the operation was attempted before being marked successful or failed.
     * @param value Value to set for the attemptsCount property.
     */
    set attemptsCount(value: number | undefined);
    /**
     * Instantiates a new teamsAsyncOperation and sets the default values.
     */
    constructor();
    /**
     * Gets the createdDateTime property value. Time when the operation was created.
     * @returns a Date
     */
    get createdDateTime(): Date | undefined;
    /**
     * Sets the createdDateTime property value. Time when the operation was created.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value: Date | undefined);
    /**
     * Gets the error property value. Any error that causes the async operation to fail.
     * @returns a operationError
     */
    get error_escaped(): OperationError | undefined;
    /**
     * Sets the error property value. Any error that causes the async operation to fail.
     * @param value Value to set for the error_escaped property.
     */
    set error_escaped(value: OperationError | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the lastActionDateTime property value. Time when the async operation was last updated.
     * @returns a Date
     */
    get lastActionDateTime(): Date | undefined;
    /**
     * Sets the lastActionDateTime property value. Time when the async operation was last updated.
     * @param value Value to set for the lastActionDateTime property.
     */
    set lastActionDateTime(value: Date | undefined);
    /**
     * Gets the operationType property value. Denotes which type of operation is being described.
     * @returns a teamsAsyncOperationType
     */
    get operationType(): TeamsAsyncOperationType | undefined;
    /**
     * Sets the operationType property value. Denotes which type of operation is being described.
     * @param value Value to set for the operationType property.
     */
    set operationType(value: TeamsAsyncOperationType | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the status property value. Operation status.
     * @returns a teamsAsyncOperationStatus
     */
    get status(): TeamsAsyncOperationStatus | undefined;
    /**
     * Sets the status property value. Operation status.
     * @param value Value to set for the status property.
     */
    set status(value: TeamsAsyncOperationStatus | undefined);
    /**
     * Gets the targetResourceId property value. The ID of the object that's created or modified as result of this async operation, typically a team.
     * @returns a string
     */
    get targetResourceId(): string | undefined;
    /**
     * Sets the targetResourceId property value. The ID of the object that's created or modified as result of this async operation, typically a team.
     * @param value Value to set for the targetResourceId property.
     */
    set targetResourceId(value: string | undefined);
    /**
     * Gets the targetResourceLocation property value. The location of the object that's created or modified as result of this async operation. This URL should be treated as an opaque value and not parsed into its component paths.
     * @returns a string
     */
    get targetResourceLocation(): string | undefined;
    /**
     * Sets the targetResourceLocation property value. The location of the object that's created or modified as result of this async operation. This URL should be treated as an opaque value and not parsed into its component paths.
     * @param value Value to set for the targetResourceLocation property.
     */
    set targetResourceLocation(value: string | undefined);
}
