import { Entity, TeamsApp, TeamsTabConfiguration } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class TeamsTab extends Entity implements Parsable {
    /** Container for custom settings applied to a tab. The tab is considered configured only once this property is set.  */
    private _configuration?;
    /** Name of the tab.  */
    private _displayName?;
    /** The application that is linked to the tab. This cannot be changed after tab creation.  */
    private _teamsApp?;
    /** Deep link URL of the tab instance. Read only.  */
    private _webUrl?;
    /**
     * Gets the configuration property value. Container for custom settings applied to a tab. The tab is considered configured only once this property is set.
     * @returns a teamsTabConfiguration
     */
    get configuration(): TeamsTabConfiguration | undefined;
    /**
     * Sets the configuration property value. Container for custom settings applied to a tab. The tab is considered configured only once this property is set.
     * @param value Value to set for the configuration property.
     */
    set configuration(value: TeamsTabConfiguration | undefined);
    /**
     * Instantiates a new teamsTab and sets the default values.
     */
    constructor();
    /**
     * Gets the displayName property value. Name of the tab.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. Name of the tab.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the teamsApp property value. The application that is linked to the tab. This cannot be changed after tab creation.
     * @returns a teamsApp
     */
    get teamsApp(): TeamsApp | undefined;
    /**
     * Sets the teamsApp property value. The application that is linked to the tab. This cannot be changed after tab creation.
     * @param value Value to set for the teamsApp property.
     */
    set teamsApp(value: TeamsApp | undefined);
    /**
     * Gets the webUrl property value. Deep link URL of the tab instance. Read only.
     * @returns a string
     */
    get webUrl(): string | undefined;
    /**
     * Sets the webUrl property value. Deep link URL of the tab instance. Read only.
     * @param value Value to set for the webUrl property.
     */
    set webUrl(value: string | undefined);
}
