"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TeamsTab = void 0;
const createTeamsAppFromDiscriminatorValue_1 = require("./createTeamsAppFromDiscriminatorValue");
const createTeamsTabConfigurationFromDiscriminatorValue_1 = require("./createTeamsTabConfigurationFromDiscriminatorValue");
const index_1 = require("./index");
class TeamsTab extends index_1.Entity {
    /**
     * Instantiates a new teamsTab and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the configuration property value. Container for custom settings applied to a tab. The tab is considered configured only once this property is set.
     * @returns a teamsTabConfiguration
     */
    get configuration() {
        return this._configuration;
    }
    ;
    /**
     * Sets the configuration property value. Container for custom settings applied to a tab. The tab is considered configured only once this property is set.
     * @param value Value to set for the configuration property.
     */
    set configuration(value) {
        this._configuration = value;
    }
    ;
    ;
    /**
     * Gets the displayName property value. Name of the tab.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. Name of the tab.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "configuration": (o, n) => { o.configuration = n.getObjectValue(createTeamsTabConfigurationFromDiscriminatorValue_1.createTeamsTabConfigurationFromDiscriminatorValue); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "teamsApp": (o, n) => { o.teamsApp = n.getObjectValue(createTeamsAppFromDiscriminatorValue_1.createTeamsAppFromDiscriminatorValue); }, "webUrl": (o, n) => { o.webUrl = n.getStringValue(); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("configuration", this.configuration);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeObjectValue("teamsApp", this.teamsApp);
        writer.writeStringValue("webUrl", this.webUrl);
    }
    ;
    /**
     * Gets the teamsApp property value. The application that is linked to the tab. This cannot be changed after tab creation.
     * @returns a teamsApp
     */
    get teamsApp() {
        return this._teamsApp;
    }
    ;
    /**
     * Sets the teamsApp property value. The application that is linked to the tab. This cannot be changed after tab creation.
     * @param value Value to set for the teamsApp property.
     */
    set teamsApp(value) {
        this._teamsApp = value;
    }
    ;
    /**
     * Gets the webUrl property value. Deep link URL of the tab instance. Read only.
     * @returns a string
     */
    get webUrl() {
        return this._webUrl;
    }
    ;
    /**
     * Sets the webUrl property value. Deep link URL of the tab instance. Read only.
     * @param value Value to set for the webUrl property.
     */
    set webUrl(value) {
        this._webUrl = value;
    }
    ;
}
exports.TeamsTab = TeamsTab;
