"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TeamsTabConfiguration = void 0;
class TeamsTabConfiguration {
    /**
     * Instantiates a new teamsTabConfiguration and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the contentUrl property value. Url used for rendering tab contents in Teams. Required.
     * @returns a string
     */
    get contentUrl() {
        return this._contentUrl;
    }
    ;
    /**
     * Sets the contentUrl property value. Url used for rendering tab contents in Teams. Required.
     * @param value Value to set for the contentUrl property.
     */
    set contentUrl(value) {
        this._contentUrl = value;
    }
    ;
    /**
     * Gets the entityId property value. Identifier for the entity hosted by the tab provider.
     * @returns a string
     */
    get entityId() {
        return this._entityId;
    }
    ;
    /**
     * Sets the entityId property value. Identifier for the entity hosted by the tab provider.
     * @param value Value to set for the entityId property.
     */
    set entityId(value) {
        this._entityId = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "contentUrl": (o, n) => { o.contentUrl = n.getStringValue(); },
            "entityId": (o, n) => { o.entityId = n.getStringValue(); },
            "removeUrl": (o, n) => { o.removeUrl = n.getStringValue(); },
            "websiteUrl": (o, n) => { o.websiteUrl = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the removeUrl property value. Url called by Teams client when a Tab is removed using the Teams Client.
     * @returns a string
     */
    get removeUrl() {
        return this._removeUrl;
    }
    ;
    /**
     * Sets the removeUrl property value. Url called by Teams client when a Tab is removed using the Teams Client.
     * @param value Value to set for the removeUrl property.
     */
    set removeUrl(value) {
        this._removeUrl = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("contentUrl", this.contentUrl);
        writer.writeStringValue("entityId", this.entityId);
        writer.writeStringValue("removeUrl", this.removeUrl);
        writer.writeStringValue("websiteUrl", this.websiteUrl);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the websiteUrl property value. Url for showing tab contents outside of Teams.
     * @returns a string
     */
    get websiteUrl() {
        return this._websiteUrl;
    }
    ;
    /**
     * Sets the websiteUrl property value. Url for showing tab contents outside of Teams.
     * @param value Value to set for the websiteUrl property.
     */
    set websiteUrl(value) {
        this._websiteUrl = value;
    }
    ;
}
exports.TeamsTabConfiguration = TeamsTabConfiguration;
