import { Identity } from './index';
import { TeamworkConversationIdentityType } from './teamworkConversationIdentityType';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class TeamworkConversationIdentity extends Identity implements Parsable {
    /** Type of conversation. Possible values are: team, channel, chat, and unknownFutureValue.  */
    private _conversationIdentityType?;
    /**
     * Instantiates a new teamworkConversationIdentity and sets the default values.
     */
    constructor();
    /**
     * Gets the conversationIdentityType property value. Type of conversation. Possible values are: team, channel, chat, and unknownFutureValue.
     * @returns a teamworkConversationIdentityType
     */
    get conversationIdentityType(): TeamworkConversationIdentityType | undefined;
    /**
     * Sets the conversationIdentityType property value. Type of conversation. Possible values are: team, channel, chat, and unknownFutureValue.
     * @param value Value to set for the conversationIdentityType property.
     */
    set conversationIdentityType(value: TeamworkConversationIdentityType | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
