import { Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class TeamworkHostedContent extends Entity implements Parsable {
    /** Write only. Bytes for the hosted content (such as images).  */
    private _contentBytes?;
    /** Write only. Content type. sicj as image/png, image/jpg.  */
    private _contentType?;
    /**
     * Instantiates a new teamworkHostedContent and sets the default values.
     */
    constructor();
    /**
     * Gets the contentBytes property value. Write only. Bytes for the hosted content (such as images).
     * @returns a binary
     */
    get contentBytes(): string | undefined;
    /**
     * Sets the contentBytes property value. Write only. Bytes for the hosted content (such as images).
     * @param value Value to set for the contentBytes property.
     */
    set contentBytes(value: string | undefined);
    /**
     * Gets the contentType property value. Write only. Content type. sicj as image/png, image/jpg.
     * @returns a string
     */
    get contentType(): string | undefined;
    /**
     * Sets the contentType property value. Write only. Content type. sicj as image/png, image/jpg.
     * @param value Value to set for the contentType property.
     */
    set contentType(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
