"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TeamworkOnlineMeetingInfo = void 0;
const createTeamworkUserIdentityFromDiscriminatorValue_1 = require("./createTeamworkUserIdentityFromDiscriminatorValue");
class TeamworkOnlineMeetingInfo {
    /**
     * Instantiates a new teamworkOnlineMeetingInfo and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the calendarEventId property value. The identifier of the calendar event associated with the meeting.
     * @returns a string
     */
    get calendarEventId() {
        return this._calendarEventId;
    }
    ;
    /**
     * Sets the calendarEventId property value. The identifier of the calendar event associated with the meeting.
     * @param value Value to set for the calendarEventId property.
     */
    set calendarEventId(value) {
        this._calendarEventId = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "calendarEventId": (o, n) => { o.calendarEventId = n.getStringValue(); },
            "joinWebUrl": (o, n) => { o.joinWebUrl = n.getStringValue(); },
            "organizer": (o, n) => { o.organizer = n.getObjectValue(createTeamworkUserIdentityFromDiscriminatorValue_1.createTeamworkUserIdentityFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the joinWebUrl property value. The URL that users click to join or uniquely identify the meeting.
     * @returns a string
     */
    get joinWebUrl() {
        return this._joinWebUrl;
    }
    ;
    /**
     * Sets the joinWebUrl property value. The URL that users click to join or uniquely identify the meeting.
     * @param value Value to set for the joinWebUrl property.
     */
    set joinWebUrl(value) {
        this._joinWebUrl = value;
    }
    ;
    /**
     * Gets the organizer property value. The organizer of the meeting.
     * @returns a teamworkUserIdentity
     */
    get organizer() {
        return this._organizer;
    }
    ;
    /**
     * Sets the organizer property value. The organizer of the meeting.
     * @param value Value to set for the organizer property.
     */
    set organizer(value) {
        this._organizer = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("calendarEventId", this.calendarEventId);
        writer.writeStringValue("joinWebUrl", this.joinWebUrl);
        writer.writeObjectValue("organizer", this.organizer);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.TeamworkOnlineMeetingInfo = TeamworkOnlineMeetingInfo;
