import { TeleconferenceDeviceMediaQuality } from './index';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class TeleconferenceDeviceQuality implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** A unique identifier for all  the participant calls in a conference or a unique identifier for two participant calls in P2P call. This needs to be copied over from Microsoft.Graph.Call.CallChainId.  */
    private _callChainId?;
    /** A geo-region where the service is deployed, such as ProdNoam.  */
    private _cloudServiceDeploymentEnvironment?;
    /** A unique deployment identifier assigned by Azure.  */
    private _cloudServiceDeploymentId?;
    /** The Azure deployed cloud service instance name, such as FrontEnd_IN_3.  */
    private _cloudServiceInstanceName?;
    /** The Azure deployed cloud service name, such as contoso.cloudapp.net.  */
    private _cloudServiceName?;
    /** Any additional description, such as VTC Bldg 30/21.  */
    private _deviceDescription?;
    /** The user media agent name, such as Cisco SX80.  */
    private _deviceName?;
    /** A unique identifier for a specific media leg of a participant in a conference.  One participant can have multiple media leg identifiers if retargeting happens. CVI partner assigns this value.  */
    private _mediaLegId?;
    /** The list of media qualities in a media session (call), such as audio quality, video quality, and/or screen sharing quality.  */
    private _mediaQualityList?;
    /** A unique identifier for a specific participant in a conference. The CVI partner needs to copy over Call.MyParticipantId to this property.  */
    private _participantId?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the callChainId property value. A unique identifier for all  the participant calls in a conference or a unique identifier for two participant calls in P2P call. This needs to be copied over from Microsoft.Graph.Call.CallChainId.
     * @returns a string
     */
    get callChainId(): string | undefined;
    /**
     * Sets the callChainId property value. A unique identifier for all  the participant calls in a conference or a unique identifier for two participant calls in P2P call. This needs to be copied over from Microsoft.Graph.Call.CallChainId.
     * @param value Value to set for the callChainId property.
     */
    set callChainId(value: string | undefined);
    /**
     * Gets the cloudServiceDeploymentEnvironment property value. A geo-region where the service is deployed, such as ProdNoam.
     * @returns a string
     */
    get cloudServiceDeploymentEnvironment(): string | undefined;
    /**
     * Sets the cloudServiceDeploymentEnvironment property value. A geo-region where the service is deployed, such as ProdNoam.
     * @param value Value to set for the cloudServiceDeploymentEnvironment property.
     */
    set cloudServiceDeploymentEnvironment(value: string | undefined);
    /**
     * Gets the cloudServiceDeploymentId property value. A unique deployment identifier assigned by Azure.
     * @returns a string
     */
    get cloudServiceDeploymentId(): string | undefined;
    /**
     * Sets the cloudServiceDeploymentId property value. A unique deployment identifier assigned by Azure.
     * @param value Value to set for the cloudServiceDeploymentId property.
     */
    set cloudServiceDeploymentId(value: string | undefined);
    /**
     * Gets the cloudServiceInstanceName property value. The Azure deployed cloud service instance name, such as FrontEnd_IN_3.
     * @returns a string
     */
    get cloudServiceInstanceName(): string | undefined;
    /**
     * Sets the cloudServiceInstanceName property value. The Azure deployed cloud service instance name, such as FrontEnd_IN_3.
     * @param value Value to set for the cloudServiceInstanceName property.
     */
    set cloudServiceInstanceName(value: string | undefined);
    /**
     * Gets the cloudServiceName property value. The Azure deployed cloud service name, such as contoso.cloudapp.net.
     * @returns a string
     */
    get cloudServiceName(): string | undefined;
    /**
     * Sets the cloudServiceName property value. The Azure deployed cloud service name, such as contoso.cloudapp.net.
     * @param value Value to set for the cloudServiceName property.
     */
    set cloudServiceName(value: string | undefined);
    /**
     * Instantiates a new teleconferenceDeviceQuality and sets the default values.
     */
    constructor();
    /**
     * Gets the deviceDescription property value. Any additional description, such as VTC Bldg 30/21.
     * @returns a string
     */
    get deviceDescription(): string | undefined;
    /**
     * Sets the deviceDescription property value. Any additional description, such as VTC Bldg 30/21.
     * @param value Value to set for the deviceDescription property.
     */
    set deviceDescription(value: string | undefined);
    /**
     * Gets the deviceName property value. The user media agent name, such as Cisco SX80.
     * @returns a string
     */
    get deviceName(): string | undefined;
    /**
     * Sets the deviceName property value. The user media agent name, such as Cisco SX80.
     * @param value Value to set for the deviceName property.
     */
    set deviceName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the mediaLegId property value. A unique identifier for a specific media leg of a participant in a conference.  One participant can have multiple media leg identifiers if retargeting happens. CVI partner assigns this value.
     * @returns a string
     */
    get mediaLegId(): string | undefined;
    /**
     * Sets the mediaLegId property value. A unique identifier for a specific media leg of a participant in a conference.  One participant can have multiple media leg identifiers if retargeting happens. CVI partner assigns this value.
     * @param value Value to set for the mediaLegId property.
     */
    set mediaLegId(value: string | undefined);
    /**
     * Gets the mediaQualityList property value. The list of media qualities in a media session (call), such as audio quality, video quality, and/or screen sharing quality.
     * @returns a teleconferenceDeviceMediaQuality
     */
    get mediaQualityList(): TeleconferenceDeviceMediaQuality[] | undefined;
    /**
     * Sets the mediaQualityList property value. The list of media qualities in a media session (call), such as audio quality, video quality, and/or screen sharing quality.
     * @param value Value to set for the mediaQualityList property.
     */
    set mediaQualityList(value: TeleconferenceDeviceMediaQuality[] | undefined);
    /**
     * Gets the participantId property value. A unique identifier for a specific participant in a conference. The CVI partner needs to copy over Call.MyParticipantId to this property.
     * @returns a string
     */
    get participantId(): string | undefined;
    /**
     * Sets the participantId property value. A unique identifier for a specific participant in a conference. The CVI partner needs to copy over Call.MyParticipantId to this property.
     * @param value Value to set for the participantId property.
     */
    set participantId(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
