"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TermColumn = void 0;
const createSetFromDiscriminatorValue_1 = require("./termStore/createSetFromDiscriminatorValue");
const createTermFromDiscriminatorValue_1 = require("./termStore/createTermFromDiscriminatorValue");
class TermColumn {
    /**
     * Instantiates a new termColumn and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the allowMultipleValues property value. Specifies whether the column will allow more than one value.
     * @returns a boolean
     */
    get allowMultipleValues() {
        return this._allowMultipleValues;
    }
    ;
    /**
     * Sets the allowMultipleValues property value. Specifies whether the column will allow more than one value.
     * @param value Value to set for the allowMultipleValues property.
     */
    set allowMultipleValues(value) {
        this._allowMultipleValues = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "allowMultipleValues": (o, n) => { o.allowMultipleValues = n.getBooleanValue(); },
            "parentTerm": (o, n) => { o.parentTerm = n.getObjectValue(createTermFromDiscriminatorValue_1.createTermFromDiscriminatorValue); },
            "showFullyQualifiedName": (o, n) => { o.showFullyQualifiedName = n.getBooleanValue(); },
            "termSet": (o, n) => { o.termSet = n.getObjectValue(createSetFromDiscriminatorValue_1.createSetFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the parentTerm property value.
     * @returns a term
     */
    get parentTerm() {
        return this._parentTerm;
    }
    ;
    /**
     * Sets the parentTerm property value.
     * @param value Value to set for the parentTerm property.
     */
    set parentTerm(value) {
        this._parentTerm = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("allowMultipleValues", this.allowMultipleValues);
        writer.writeObjectValue("parentTerm", this.parentTerm);
        writer.writeBooleanValue("showFullyQualifiedName", this.showFullyQualifiedName);
        writer.writeObjectValue("termSet", this.termSet);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the showFullyQualifiedName property value. Specifies whether to display the entire term path or only the term label.
     * @returns a boolean
     */
    get showFullyQualifiedName() {
        return this._showFullyQualifiedName;
    }
    ;
    /**
     * Sets the showFullyQualifiedName property value. Specifies whether to display the entire term path or only the term label.
     * @param value Value to set for the showFullyQualifiedName property.
     */
    set showFullyQualifiedName(value) {
        this._showFullyQualifiedName = value;
    }
    ;
    /**
     * Gets the termSet property value.
     * @returns a set
     */
    get termSet() {
        return this._termSet;
    }
    ;
    /**
     * Sets the termSet property value.
     * @param value Value to set for the termSet property.
     */
    set termSet(value) {
        this._termSet = value;
    }
    ;
}
exports.TermColumn = TermColumn;
