"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Group = void 0;
const __1 = require("../");
const createSetFromDiscriminatorValue_1 = require("./createSetFromDiscriminatorValue");
const termGroupScope_1 = require("./termGroupScope");
class Group extends __1.Entity {
    /**
     * Instantiates a new group and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the createdDateTime property value. Date and time of the group creation. Read-only.
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. Date and time of the group creation. Read-only.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * Gets the description property value. Description that gives details on the term usage.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. Description that gives details on the term usage.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the displayName property value. Name of the group.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. Name of the group.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); }, "description": (o, n) => { o.description = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "parentSiteId": (o, n) => { o.parentSiteId = n.getStringValue(); }, "scope": (o, n) => { o.scope = n.getEnumValue(termGroupScope_1.TermGroupScope); }, "sets": (o, n) => { o.sets = n.getCollectionOfObjectValues(createSetFromDiscriminatorValue_1.createSetFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the parentSiteId property value. ID of the parent site of this group.
     * @returns a string
     */
    get parentSiteId() {
        return this._parentSiteId;
    }
    ;
    /**
     * Sets the parentSiteId property value. ID of the parent site of this group.
     * @param value Value to set for the parentSiteId property.
     */
    set parentSiteId(value) {
        this._parentSiteId = value;
    }
    ;
    /**
     * Gets the scope property value. Returns the type of the group. Possible values are global, system, and siteCollection.
     * @returns a termGroupScope
     */
    get scope() {
        return this._scope;
    }
    ;
    /**
     * Sets the scope property value. Returns the type of the group. Possible values are global, system, and siteCollection.
     * @param value Value to set for the scope property.
     */
    set scope(value) {
        this._scope = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeStringValue("description", this.description);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeStringValue("parentSiteId", this.parentSiteId);
        writer.writeEnumValue("scope", this.scope);
        writer.writeCollectionOfObjectValues("sets", this.sets);
    }
    ;
    /**
     * Gets the sets property value. All sets under the group in a term [store].
     * @returns a set
     */
    get sets() {
        return this._sets;
    }
    ;
    /**
     * Sets the sets property value. All sets under the group in a term [store].
     * @param value Value to set for the sets property.
     */
    set sets(value) {
        this._sets = value;
    }
    ;
}
exports.Group = Group;
