"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LocalizedDescription = void 0;
class LocalizedDescription {
    /**
     * Instantiates a new localizedDescription and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the description property value. The description in the localized language.
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. The description in the localized language.
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "description": (o, n) => { o.description = n.getStringValue(); },
            "languageTag": (o, n) => { o.languageTag = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the languageTag property value. The language tag for the label.
     * @returns a string
     */
    get languageTag() {
        return this._languageTag;
    }
    ;
    /**
     * Sets the languageTag property value. The language tag for the label.
     * @param value Value to set for the languageTag property.
     */
    set languageTag(value) {
        this._languageTag = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("description", this.description);
        writer.writeStringValue("languageTag", this.languageTag);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.LocalizedDescription = LocalizedDescription;
