"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LocalizedName = void 0;
class LocalizedName {
    /**
     * Instantiates a new localizedName and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "languageTag": (o, n) => { o.languageTag = n.getStringValue(); },
            "name": (o, n) => { o.name = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the languageTag property value. The language tag for the label.
     * @returns a string
     */
    get languageTag() {
        return this._languageTag;
    }
    ;
    /**
     * Sets the languageTag property value. The language tag for the label.
     * @param value Value to set for the languageTag property.
     */
    set languageTag(value) {
        this._languageTag = value;
    }
    ;
    /**
     * Gets the name property value. The name in the localized language.
     * @returns a string
     */
    get name() {
        return this._name;
    }
    ;
    /**
     * Sets the name property value. The name in the localized language.
     * @param value Value to set for the name property.
     */
    set name(value) {
        this._name = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("languageTag", this.languageTag);
        writer.writeStringValue("name", this.name);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.LocalizedName = LocalizedName;
