import { Entity } from '../';
import { Set, Term } from './index';
import { RelationType } from './relationType';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class Relation extends Entity implements Parsable {
    /** The from [term] of the relation. The term from which the relationship is defined. A null value would indicate the relation is directly with the [set].  */
    private _fromTerm?;
    /** The type of relation. Possible values are: pin, reuse.  */
    private _relationship?;
    /** The [set] in which the relation is relevant.  */
    private _set?;
    /** The to [term] of the relation. The term to which the relationship is defined.  */
    private _toTerm?;
    /**
     * Instantiates a new relation and sets the default values.
     */
    constructor();
    /**
     * Gets the fromTerm property value. The from [term] of the relation. The term from which the relationship is defined. A null value would indicate the relation is directly with the [set].
     * @returns a term
     */
    get fromTerm(): Term | undefined;
    /**
     * Sets the fromTerm property value. The from [term] of the relation. The term from which the relationship is defined. A null value would indicate the relation is directly with the [set].
     * @param value Value to set for the fromTerm property.
     */
    set fromTerm(value: Term | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the relationship property value. The type of relation. Possible values are: pin, reuse.
     * @returns a relationType
     */
    get relationship(): RelationType | undefined;
    /**
     * Sets the relationship property value. The type of relation. Possible values are: pin, reuse.
     * @param value Value to set for the relationship property.
     */
    set relationship(value: RelationType | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the set property value. The [set] in which the relation is relevant.
     * @returns a set
     */
    get set(): Set | undefined;
    /**
     * Sets the set property value. The [set] in which the relation is relevant.
     * @param value Value to set for the set property.
     */
    set set(value: Set | undefined);
    /**
     * Gets the toTerm property value. The to [term] of the relation. The term to which the relationship is defined.
     * @returns a term
     */
    get toTerm(): Term | undefined;
    /**
     * Sets the toTerm property value. The to [term] of the relation. The term to which the relationship is defined.
     * @param value Value to set for the toTerm property.
     */
    set toTerm(value: Term | undefined);
}
