import { Entity } from '../';
import { Group, Set } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class Store extends Entity implements Parsable {
    /** Default language of the term store.  */
    private _defaultLanguageTag?;
    /** Collection of all groups available in the term store.  */
    private _groups?;
    /** List of languages for the term store.  */
    private _languageTags?;
    /** Collection of all sets available in the term store.  */
    private _sets?;
    /**
     * Instantiates a new store and sets the default values.
     */
    constructor();
    /**
     * Gets the defaultLanguageTag property value. Default language of the term store.
     * @returns a string
     */
    get defaultLanguageTag(): string | undefined;
    /**
     * Sets the defaultLanguageTag property value. Default language of the term store.
     * @param value Value to set for the defaultLanguageTag property.
     */
    set defaultLanguageTag(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the groups property value. Collection of all groups available in the term store.
     * @returns a group
     */
    get groups(): Group[] | undefined;
    /**
     * Sets the groups property value. Collection of all groups available in the term store.
     * @param value Value to set for the groups property.
     */
    set groups(value: Group[] | undefined);
    /**
     * Gets the languageTags property value. List of languages for the term store.
     * @returns a string
     */
    get languageTags(): string[] | undefined;
    /**
     * Sets the languageTags property value. List of languages for the term store.
     * @param value Value to set for the languageTags property.
     */
    set languageTags(value: string[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the sets property value. Collection of all sets available in the term store.
     * @returns a set
     */
    get sets(): Set[] | undefined;
    /**
     * Sets the sets property value. Collection of all sets available in the term store.
     * @param value Value to set for the sets property.
     */
    set sets(value: Set[] | undefined);
}
