"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Store = void 0;
const __1 = require("../");
const createGroupFromDiscriminatorValue_1 = require("./createGroupFromDiscriminatorValue");
const createSetFromDiscriminatorValue_1 = require("./createSetFromDiscriminatorValue");
class Store extends __1.Entity {
    /**
     * Instantiates a new store and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the defaultLanguageTag property value. Default language of the term store.
     * @returns a string
     */
    get defaultLanguageTag() {
        return this._defaultLanguageTag;
    }
    ;
    /**
     * Sets the defaultLanguageTag property value. Default language of the term store.
     * @param value Value to set for the defaultLanguageTag property.
     */
    set defaultLanguageTag(value) {
        this._defaultLanguageTag = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "defaultLanguageTag": (o, n) => { o.defaultLanguageTag = n.getStringValue(); }, "groups": (o, n) => { o.groups = n.getCollectionOfObjectValues(createGroupFromDiscriminatorValue_1.createGroupFromDiscriminatorValue); }, "languageTags": (o, n) => { o.languageTags = n.getCollectionOfPrimitiveValues(); }, "sets": (o, n) => { o.sets = n.getCollectionOfObjectValues(createSetFromDiscriminatorValue_1.createSetFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the groups property value. Collection of all groups available in the term store.
     * @returns a group
     */
    get groups() {
        return this._groups;
    }
    ;
    /**
     * Sets the groups property value. Collection of all groups available in the term store.
     * @param value Value to set for the groups property.
     */
    set groups(value) {
        this._groups = value;
    }
    ;
    /**
     * Gets the languageTags property value. List of languages for the term store.
     * @returns a string
     */
    get languageTags() {
        return this._languageTags;
    }
    ;
    /**
     * Sets the languageTags property value. List of languages for the term store.
     * @param value Value to set for the languageTags property.
     */
    set languageTags(value) {
        this._languageTags = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("defaultLanguageTag", this.defaultLanguageTag);
        writer.writeCollectionOfObjectValues("groups", this.groups);
        writer.writeCollectionOfPrimitiveValues("languageTags", this.languageTags);
        writer.writeCollectionOfObjectValues("sets", this.sets);
    }
    ;
    /**
     * Gets the sets property value. Collection of all sets available in the term store.
     * @returns a set
     */
    get sets() {
        return this._sets;
    }
    ;
    /**
     * Sets the sets property value. Collection of all sets available in the term store.
     * @param value Value to set for the sets property.
     */
    set sets(value) {
        this._sets = value;
    }
    ;
}
exports.Store = Store;
