import { Entity, TermsAndConditions } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class TermsAndConditionsAcceptanceStatus extends Entity implements Parsable {
    /** DateTime when the terms were last accepted by the user.  */
    private _acceptedDateTime?;
    /** Most recent version number of the T&C accepted by the user.  */
    private _acceptedVersion?;
    /** Navigation link to the terms and conditions that are assigned.  */
    private _termsAndConditions?;
    /** Display name of the user whose acceptance the entity represents.  */
    private _userDisplayName?;
    /** The userPrincipalName of the User that accepted the term.  */
    private _userPrincipalName?;
    /**
     * Gets the acceptedDateTime property value. DateTime when the terms were last accepted by the user.
     * @returns a Date
     */
    get acceptedDateTime(): Date | undefined;
    /**
     * Sets the acceptedDateTime property value. DateTime when the terms were last accepted by the user.
     * @param value Value to set for the acceptedDateTime property.
     */
    set acceptedDateTime(value: Date | undefined);
    /**
     * Gets the acceptedVersion property value. Most recent version number of the T&C accepted by the user.
     * @returns a integer
     */
    get acceptedVersion(): number | undefined;
    /**
     * Sets the acceptedVersion property value. Most recent version number of the T&C accepted by the user.
     * @param value Value to set for the acceptedVersion property.
     */
    set acceptedVersion(value: number | undefined);
    /**
     * Instantiates a new termsAndConditionsAcceptanceStatus and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the termsAndConditions property value. Navigation link to the terms and conditions that are assigned.
     * @returns a termsAndConditions
     */
    get termsAndConditions(): TermsAndConditions | undefined;
    /**
     * Sets the termsAndConditions property value. Navigation link to the terms and conditions that are assigned.
     * @param value Value to set for the termsAndConditions property.
     */
    set termsAndConditions(value: TermsAndConditions | undefined);
    /**
     * Gets the userDisplayName property value. Display name of the user whose acceptance the entity represents.
     * @returns a string
     */
    get userDisplayName(): string | undefined;
    /**
     * Sets the userDisplayName property value. Display name of the user whose acceptance the entity represents.
     * @param value Value to set for the userDisplayName property.
     */
    set userDisplayName(value: string | undefined);
    /**
     * Gets the userPrincipalName property value. The userPrincipalName of the User that accepted the term.
     * @returns a string
     */
    get userPrincipalName(): string | undefined;
    /**
     * Sets the userPrincipalName property value. The userPrincipalName of the User that accepted the term.
     * @param value Value to set for the userPrincipalName property.
     */
    set userPrincipalName(value: string | undefined);
}
