"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextColumn = void 0;
class TextColumn {
    /**
     * Instantiates a new textColumn and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the allowMultipleLines property value. Whether to allow multiple lines of text.
     * @returns a boolean
     */
    get allowMultipleLines() {
        return this._allowMultipleLines;
    }
    ;
    /**
     * Sets the allowMultipleLines property value. Whether to allow multiple lines of text.
     * @param value Value to set for the allowMultipleLines property.
     */
    set allowMultipleLines(value) {
        this._allowMultipleLines = value;
    }
    ;
    /**
     * Gets the appendChangesToExistingText property value. Whether updates to this column should replace existing text, or append to it.
     * @returns a boolean
     */
    get appendChangesToExistingText() {
        return this._appendChangesToExistingText;
    }
    ;
    /**
     * Sets the appendChangesToExistingText property value. Whether updates to this column should replace existing text, or append to it.
     * @param value Value to set for the appendChangesToExistingText property.
     */
    set appendChangesToExistingText(value) {
        this._appendChangesToExistingText = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "allowMultipleLines": (o, n) => { o.allowMultipleLines = n.getBooleanValue(); },
            "appendChangesToExistingText": (o, n) => { o.appendChangesToExistingText = n.getBooleanValue(); },
            "linesForEditing": (o, n) => { o.linesForEditing = n.getNumberValue(); },
            "maxLength": (o, n) => { o.maxLength = n.getNumberValue(); },
            "textType": (o, n) => { o.textType = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the linesForEditing property value. The size of the text box.
     * @returns a integer
     */
    get linesForEditing() {
        return this._linesForEditing;
    }
    ;
    /**
     * Sets the linesForEditing property value. The size of the text box.
     * @param value Value to set for the linesForEditing property.
     */
    set linesForEditing(value) {
        this._linesForEditing = value;
    }
    ;
    /**
     * Gets the maxLength property value. The maximum number of characters for the value.
     * @returns a integer
     */
    get maxLength() {
        return this._maxLength;
    }
    ;
    /**
     * Sets the maxLength property value. The maximum number of characters for the value.
     * @param value Value to set for the maxLength property.
     */
    set maxLength(value) {
        this._maxLength = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("allowMultipleLines", this.allowMultipleLines);
        writer.writeBooleanValue("appendChangesToExistingText", this.appendChangesToExistingText);
        writer.writeNumberValue("linesForEditing", this.linesForEditing);
        writer.writeNumberValue("maxLength", this.maxLength);
        writer.writeStringValue("textType", this.textType);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the textType property value. The type of text being stored. Must be one of plain or richText
     * @returns a string
     */
    get textType() {
        return this._textType;
    }
    ;
    /**
     * Sets the textType property value. The type of text being stored. Must be one of plain or richText
     * @param value Value to set for the textType property.
     */
    set textType(value) {
        this._textType = value;
    }
    ;
}
exports.TextColumn = TextColumn;
