"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ThumbnailSetCollectionResponse = void 0;
const createThumbnailSetFromDiscriminatorValue_1 = require("./createThumbnailSetFromDiscriminatorValue");
class ThumbnailSetCollectionResponse {
    /**
     * Instantiates a new ThumbnailSetCollectionResponse and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "@odata.nextLink": (o, n) => { o.nextLink = n.getStringValue(); },
            "value": (o, n) => { o.value = n.getCollectionOfObjectValues(createThumbnailSetFromDiscriminatorValue_1.createThumbnailSetFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the @odata.nextLink property value.
     * @returns a string
     */
    get nextLink() {
        return this._nextLink;
    }
    ;
    /**
     * Sets the @odata.nextLink property value.
     * @param value Value to set for the nextLink property.
     */
    set nextLink(value) {
        this._nextLink = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("@odata.nextLink", this.nextLink);
        writer.writeCollectionOfObjectValues("value", this.value);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the value property value.
     * @returns a thumbnailSet
     */
    get value() {
        return this._value;
    }
    ;
    /**
     * Sets the value property value.
     * @param value Value to set for the value property.
     */
    set value(value) {
        this._value = value;
    }
    ;
}
exports.ThumbnailSetCollectionResponse = ThumbnailSetCollectionResponse;
