import { ActivityDomain } from './activityDomain';
import { TimeSlot } from './index';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class TimeConstraint implements AdditionalDataHolder, Parsable {
    /** The nature of the activity, optional. The possible values are: work, personal, unrestricted, or unknown.  */
    private _activityDomain?;
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _timeSlots?;
    /**
     * Gets the activityDomain property value. The nature of the activity, optional. The possible values are: work, personal, unrestricted, or unknown.
     * @returns a activityDomain
     */
    get activityDomain(): ActivityDomain | undefined;
    /**
     * Sets the activityDomain property value. The nature of the activity, optional. The possible values are: work, personal, unrestricted, or unknown.
     * @param value Value to set for the activityDomain property.
     */
    set activityDomain(value: ActivityDomain | undefined);
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new timeConstraint and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the timeSlots property value.
     * @returns a timeSlot
     */
    get timeSlots(): TimeSlot[] | undefined;
    /**
     * Sets the timeSlots property value.
     * @param value Value to set for the timeSlots property.
     */
    set timeSlots(value: TimeSlot[] | undefined);
}
