import { ChangeTrackedEntity, TimeOffItem } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class TimeOff extends ChangeTrackedEntity implements Parsable {
    /** The draft version of this timeOff that is viewable by managers. Required.  */
    private _draftTimeOff?;
    /** The shared version of this timeOff that is viewable by both employees and managers. Required.  */
    private _sharedTimeOff?;
    /** ID of the user assigned to the timeOff. Required.  */
    private _userId?;
    /**
     * Instantiates a new timeOff and sets the default values.
     */
    constructor();
    /**
     * Gets the draftTimeOff property value. The draft version of this timeOff that is viewable by managers. Required.
     * @returns a timeOffItem
     */
    get draftTimeOff(): TimeOffItem | undefined;
    /**
     * Sets the draftTimeOff property value. The draft version of this timeOff that is viewable by managers. Required.
     * @param value Value to set for the draftTimeOff property.
     */
    set draftTimeOff(value: TimeOffItem | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the sharedTimeOff property value. The shared version of this timeOff that is viewable by both employees and managers. Required.
     * @returns a timeOffItem
     */
    get sharedTimeOff(): TimeOffItem | undefined;
    /**
     * Sets the sharedTimeOff property value. The shared version of this timeOff that is viewable by both employees and managers. Required.
     * @param value Value to set for the sharedTimeOff property.
     */
    set sharedTimeOff(value: TimeOffItem | undefined);
    /**
     * Gets the userId property value. ID of the user assigned to the timeOff. Required.
     * @returns a string
     */
    get userId(): string | undefined;
    /**
     * Sets the userId property value. ID of the user assigned to the timeOff. Required.
     * @param value Value to set for the userId property.
     */
    set userId(value: string | undefined);
}
