"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TimeOffReason = void 0;
const index_1 = require("./index");
const timeOffReasonIconType_1 = require("./timeOffReasonIconType");
class TimeOffReason extends index_1.ChangeTrackedEntity {
    /**
     * Instantiates a new timeOffReason and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the displayName property value. The name of the timeOffReason. Required.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The name of the timeOffReason. Required.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "iconType": (o, n) => { o.iconType = n.getEnumValue(timeOffReasonIconType_1.TimeOffReasonIconType); }, "isActive": (o, n) => { o.isActive = n.getBooleanValue(); } });
    }
    ;
    /**
     * Gets the iconType property value. Supported icon types: none; car; calendar; running; plane; firstAid; doctor; notWorking; clock; juryDuty; globe; cup; phone; weather; umbrella; piggyBank; dog; cake; trafficCone; pin; sunny. Required.
     * @returns a timeOffReasonIconType
     */
    get iconType() {
        return this._iconType;
    }
    ;
    /**
     * Sets the iconType property value. Supported icon types: none; car; calendar; running; plane; firstAid; doctor; notWorking; clock; juryDuty; globe; cup; phone; weather; umbrella; piggyBank; dog; cake; trafficCone; pin; sunny. Required.
     * @param value Value to set for the iconType property.
     */
    set iconType(value) {
        this._iconType = value;
    }
    ;
    /**
     * Gets the isActive property value. Indicates whether the timeOffReason can be used when creating new entities or updating existing ones. Required.
     * @returns a boolean
     */
    get isActive() {
        return this._isActive;
    }
    ;
    /**
     * Sets the isActive property value. Indicates whether the timeOffReason can be used when creating new entities or updating existing ones. Required.
     * @param value Value to set for the isActive property.
     */
    set isActive(value) {
        this._isActive = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeEnumValue("iconType", this.iconType);
        writer.writeBooleanValue("isActive", this.isActive);
    }
    ;
}
exports.TimeOffReason = TimeOffReason;
