"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TimeOffRequest = void 0;
const index_1 = require("./index");
class TimeOffRequest extends index_1.ScheduleChangeRequest {
    /**
     * Instantiates a new timeOffRequest and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the endDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @returns a Date
     */
    get endDateTime() {
        return this._endDateTime;
    }
    ;
    /**
     * Sets the endDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @param value Value to set for the endDateTime property.
     */
    set endDateTime(value) {
        this._endDateTime = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "endDateTime": (o, n) => { o.endDateTime = n.getDateValue(); }, "startDateTime": (o, n) => { o.startDateTime = n.getDateValue(); }, "timeOffReasonId": (o, n) => { o.timeOffReasonId = n.getStringValue(); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeDateValue("endDateTime", this.endDateTime);
        writer.writeDateValue("startDateTime", this.startDateTime);
        writer.writeStringValue("timeOffReasonId", this.timeOffReasonId);
    }
    ;
    /**
     * Gets the startDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @returns a Date
     */
    get startDateTime() {
        return this._startDateTime;
    }
    ;
    /**
     * Sets the startDateTime property value. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
     * @param value Value to set for the startDateTime property.
     */
    set startDateTime(value) {
        this._startDateTime = value;
    }
    ;
    /**
     * Gets the timeOffReasonId property value. The reason for the time off.
     * @returns a string
     */
    get timeOffReasonId() {
        return this._timeOffReasonId;
    }
    ;
    /**
     * Sets the timeOffReasonId property value. The reason for the time off.
     * @param value Value to set for the timeOffReasonId property.
     */
    set timeOffReasonId(value) {
        this._timeOffReasonId = value;
    }
    ;
}
exports.TimeOffRequest = TimeOffRequest;
