import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class TimeZoneInformation implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** An identifier for the time zone.  */
    private _alias?;
    /** A display string that represents the time zone.  */
    private _displayName?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the alias property value. An identifier for the time zone.
     * @returns a string
     */
    get alias(): string | undefined;
    /**
     * Sets the alias property value. An identifier for the time zone.
     * @param value Value to set for the alias property.
     */
    set alias(value: string | undefined);
    /**
     * Instantiates a new timeZoneInformation and sets the default values.
     */
    constructor();
    /**
     * Gets the displayName property value. A display string that represents the time zone.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. A display string that represents the time zone.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
