"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TimeZoneInformation = void 0;
class TimeZoneInformation {
    /**
     * Instantiates a new timeZoneInformation and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the alias property value. An identifier for the time zone.
     * @returns a string
     */
    get alias() {
        return this._alias;
    }
    ;
    /**
     * Sets the alias property value. An identifier for the time zone.
     * @param value Value to set for the alias property.
     */
    set alias(value) {
        this._alias = value;
    }
    ;
    ;
    /**
     * Gets the displayName property value. A display string that represents the time zone.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. A display string that represents the time zone.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "alias": (o, n) => { o.alias = n.getStringValue(); },
            "displayName": (o, n) => { o.displayName = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("alias", this.alias);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.TimeZoneInformation = TimeZoneInformation;
