import { Entity, TodoTaskList } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class Todo extends Entity implements Parsable {
    /** The task lists in the users mailbox.  */
    private _lists?;
    /**
     * Instantiates a new todo and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the lists property value. The task lists in the users mailbox.
     * @returns a todoTaskList
     */
    get lists(): TodoTaskList[] | undefined;
    /**
     * Sets the lists property value. The task lists in the users mailbox.
     * @param value Value to set for the lists property.
     */
    set lists(value: TodoTaskList[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
