"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnifiedRoleAssignment = void 0;
const createAppScopeFromDiscriminatorValue_1 = require("./createAppScopeFromDiscriminatorValue");
const createDirectoryObjectFromDiscriminatorValue_1 = require("./createDirectoryObjectFromDiscriminatorValue");
const createUnifiedRoleDefinitionFromDiscriminatorValue_1 = require("./createUnifiedRoleDefinitionFromDiscriminatorValue");
const index_1 = require("./index");
class UnifiedRoleAssignment extends index_1.Entity {
    /**
     * Instantiates a new unifiedRoleAssignment and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the appScope property value. Read-only property with details of the app specific scope when the assignment scope is app specific. Containment entity. Supports $expand.
     * @returns a appScope
     */
    get appScope() {
        return this._appScope;
    }
    ;
    /**
     * Sets the appScope property value. Read-only property with details of the app specific scope when the assignment scope is app specific. Containment entity. Supports $expand.
     * @param value Value to set for the appScope property.
     */
    set appScope(value) {
        this._appScope = value;
    }
    ;
    /**
     * Gets the appScopeId property value. Identifier of the app-specific scope when the assignment scope is app-specific.  Either this property or directoryScopeId is required. App scopes are scopes that are defined and understood by this application only. Use / for tenant-wide app scopes. Use directoryScopeId to limit the scope to particular directory objects, for example, administrative units. Supports $filter (eq, in).
     * @returns a string
     */
    get appScopeId() {
        return this._appScopeId;
    }
    ;
    /**
     * Sets the appScopeId property value. Identifier of the app-specific scope when the assignment scope is app-specific.  Either this property or directoryScopeId is required. App scopes are scopes that are defined and understood by this application only. Use / for tenant-wide app scopes. Use directoryScopeId to limit the scope to particular directory objects, for example, administrative units. Supports $filter (eq, in).
     * @param value Value to set for the appScopeId property.
     */
    set appScopeId(value) {
        this._appScopeId = value;
    }
    ;
    /**
     * Gets the condition property value.
     * @returns a string
     */
    get condition() {
        return this._condition;
    }
    ;
    /**
     * Sets the condition property value.
     * @param value Value to set for the condition property.
     */
    set condition(value) {
        this._condition = value;
    }
    ;
    ;
    /**
     * Gets the directoryScope property value. The directory object that is the scope of the assignment. Read-only. Supports $expand.
     * @returns a directoryObject
     */
    get directoryScope() {
        return this._directoryScope;
    }
    ;
    /**
     * Sets the directoryScope property value. The directory object that is the scope of the assignment. Read-only. Supports $expand.
     * @param value Value to set for the directoryScope property.
     */
    set directoryScope(value) {
        this._directoryScope = value;
    }
    ;
    /**
     * Gets the directoryScopeId property value. Identifier of the directory object representing the scope of the assignment.  Either this property or appScopeId is required. The scope of an assignment determines the set of resources for which the principal has been granted access. Directory scopes are shared scopes stored in the directory that are understood by multiple applications. Use / for tenant-wide scope. Use appScopeId to limit the scope to an application only. Supports $filter (eq, in).
     * @returns a string
     */
    get directoryScopeId() {
        return this._directoryScopeId;
    }
    ;
    /**
     * Sets the directoryScopeId property value. Identifier of the directory object representing the scope of the assignment.  Either this property or appScopeId is required. The scope of an assignment determines the set of resources for which the principal has been granted access. Directory scopes are shared scopes stored in the directory that are understood by multiple applications. Use / for tenant-wide scope. Use appScopeId to limit the scope to an application only. Supports $filter (eq, in).
     * @param value Value to set for the directoryScopeId property.
     */
    set directoryScopeId(value) {
        this._directoryScopeId = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "appScope": (o, n) => { o.appScope = n.getObjectValue(createAppScopeFromDiscriminatorValue_1.createAppScopeFromDiscriminatorValue); }, "appScopeId": (o, n) => { o.appScopeId = n.getStringValue(); }, "condition": (o, n) => { o.condition = n.getStringValue(); }, "directoryScope": (o, n) => { o.directoryScope = n.getObjectValue(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "directoryScopeId": (o, n) => { o.directoryScopeId = n.getStringValue(); }, "principal": (o, n) => { o.principal = n.getObjectValue(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "principalId": (o, n) => { o.principalId = n.getStringValue(); }, "roleDefinition": (o, n) => { o.roleDefinition = n.getObjectValue(createUnifiedRoleDefinitionFromDiscriminatorValue_1.createUnifiedRoleDefinitionFromDiscriminatorValue); }, "roleDefinitionId": (o, n) => { o.roleDefinitionId = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the principal property value. Referencing the assigned principal. Read-only. Supports $expand.
     * @returns a directoryObject
     */
    get principal() {
        return this._principal;
    }
    ;
    /**
     * Sets the principal property value. Referencing the assigned principal. Read-only. Supports $expand.
     * @param value Value to set for the principal property.
     */
    set principal(value) {
        this._principal = value;
    }
    ;
    /**
     * Gets the principalId property value. Identifier of the principal to which the assignment is granted. Supports $filter (eq, in).
     * @returns a string
     */
    get principalId() {
        return this._principalId;
    }
    ;
    /**
     * Sets the principalId property value. Identifier of the principal to which the assignment is granted. Supports $filter (eq, in).
     * @param value Value to set for the principalId property.
     */
    set principalId(value) {
        this._principalId = value;
    }
    ;
    /**
     * Gets the roleDefinition property value. The roleDefinition the assignment is for.  Supports $expand. roleDefinition.Id will be auto expanded.
     * @returns a unifiedRoleDefinition
     */
    get roleDefinition() {
        return this._roleDefinition;
    }
    ;
    /**
     * Sets the roleDefinition property value. The roleDefinition the assignment is for.  Supports $expand. roleDefinition.Id will be auto expanded.
     * @param value Value to set for the roleDefinition property.
     */
    set roleDefinition(value) {
        this._roleDefinition = value;
    }
    ;
    /**
     * Gets the roleDefinitionId property value. Identifier of the role definition the assignment is for. Read only. Supports $filter (eq, in).
     * @returns a string
     */
    get roleDefinitionId() {
        return this._roleDefinitionId;
    }
    ;
    /**
     * Sets the roleDefinitionId property value. Identifier of the role definition the assignment is for. Read only. Supports $filter (eq, in).
     * @param value Value to set for the roleDefinitionId property.
     */
    set roleDefinitionId(value) {
        this._roleDefinitionId = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("appScope", this.appScope);
        writer.writeStringValue("appScopeId", this.appScopeId);
        writer.writeStringValue("condition", this.condition);
        writer.writeObjectValue("directoryScope", this.directoryScope);
        writer.writeStringValue("directoryScopeId", this.directoryScopeId);
        writer.writeObjectValue("principal", this.principal);
        writer.writeStringValue("principalId", this.principalId);
        writer.writeObjectValue("roleDefinition", this.roleDefinition);
        writer.writeStringValue("roleDefinitionId", this.roleDefinitionId);
    }
    ;
}
exports.UnifiedRoleAssignment = UnifiedRoleAssignment;
