"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnifiedRolePermission = void 0;
class UnifiedRolePermission {
    /**
     * Instantiates a new unifiedRolePermission and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the allowedResourceActions property value. Set of tasks that can be performed on a resource. Required.
     * @returns a string
     */
    get allowedResourceActions() {
        return this._allowedResourceActions;
    }
    ;
    /**
     * Sets the allowedResourceActions property value. Set of tasks that can be performed on a resource. Required.
     * @param value Value to set for the allowedResourceActions property.
     */
    set allowedResourceActions(value) {
        this._allowedResourceActions = value;
    }
    ;
    /**
     * Gets the condition property value. Optional constraints that must be met for the permission to be effective.
     * @returns a string
     */
    get condition() {
        return this._condition;
    }
    ;
    /**
     * Sets the condition property value. Optional constraints that must be met for the permission to be effective.
     * @param value Value to set for the condition property.
     */
    set condition(value) {
        this._condition = value;
    }
    ;
    ;
    /**
     * Gets the excludedResourceActions property value. Set of tasks that may not be performed on a resource. Not yet supported.
     * @returns a string
     */
    get excludedResourceActions() {
        return this._excludedResourceActions;
    }
    ;
    /**
     * Sets the excludedResourceActions property value. Set of tasks that may not be performed on a resource. Not yet supported.
     * @param value Value to set for the excludedResourceActions property.
     */
    set excludedResourceActions(value) {
        this._excludedResourceActions = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "allowedResourceActions": (o, n) => { o.allowedResourceActions = n.getCollectionOfPrimitiveValues(); },
            "condition": (o, n) => { o.condition = n.getStringValue(); },
            "excludedResourceActions": (o, n) => { o.excludedResourceActions = n.getCollectionOfPrimitiveValues(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfPrimitiveValues("allowedResourceActions", this.allowedResourceActions);
        writer.writeStringValue("condition", this.condition);
        writer.writeCollectionOfPrimitiveValues("excludedResourceActions", this.excludedResourceActions);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.UnifiedRolePermission = UnifiedRolePermission;
