"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UploadSession = void 0;
class UploadSession {
    /**
     * Instantiates a new uploadSession and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the expirationDateTime property value. The date and time in UTC that the upload session will expire. The complete file must be uploaded before this expiration time is reached.
     * @returns a Date
     */
    get expirationDateTime() {
        return this._expirationDateTime;
    }
    ;
    /**
     * Sets the expirationDateTime property value. The date and time in UTC that the upload session will expire. The complete file must be uploaded before this expiration time is reached.
     * @param value Value to set for the expirationDateTime property.
     */
    set expirationDateTime(value) {
        this._expirationDateTime = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "expirationDateTime": (o, n) => { o.expirationDateTime = n.getDateValue(); },
            "nextExpectedRanges": (o, n) => { o.nextExpectedRanges = n.getCollectionOfPrimitiveValues(); },
            "uploadUrl": (o, n) => { o.uploadUrl = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the nextExpectedRanges property value. A collection of byte ranges that the server is missing for the file. These ranges are zero indexed and of the format 'start-end' (e.g. '0-26' to indicate the first 27 bytes of the file). When uploading files as Outlook attachments, instead of a collection of ranges, this property always indicates a single value '{start}', the location in the file where the next upload should begin.
     * @returns a string
     */
    get nextExpectedRanges() {
        return this._nextExpectedRanges;
    }
    ;
    /**
     * Sets the nextExpectedRanges property value. A collection of byte ranges that the server is missing for the file. These ranges are zero indexed and of the format 'start-end' (e.g. '0-26' to indicate the first 27 bytes of the file). When uploading files as Outlook attachments, instead of a collection of ranges, this property always indicates a single value '{start}', the location in the file where the next upload should begin.
     * @param value Value to set for the nextExpectedRanges property.
     */
    set nextExpectedRanges(value) {
        this._nextExpectedRanges = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeDateValue("expirationDateTime", this.expirationDateTime);
        writer.writeCollectionOfPrimitiveValues("nextExpectedRanges", this.nextExpectedRanges);
        writer.writeStringValue("uploadUrl", this.uploadUrl);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the uploadUrl property value. The URL endpoint that accepts PUT requests for byte ranges of the file.
     * @returns a string
     */
    get uploadUrl() {
        return this._uploadUrl;
    }
    ;
    /**
     * Sets the uploadUrl property value. The URL endpoint that accepts PUT requests for byte ranges of the file.
     * @param value Value to set for the uploadUrl property.
     */
    set uploadUrl(value) {
        this._uploadUrl = value;
    }
    ;
}
exports.UploadSession = UploadSession;
