import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class UriClickSecurityState implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _clickAction?;
    private _clickDateTime?;
    private _id?;
    private _sourceId?;
    private _uriDomain?;
    private _verdict?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the clickAction property value.
     * @returns a string
     */
    get clickAction(): string | undefined;
    /**
     * Sets the clickAction property value.
     * @param value Value to set for the clickAction property.
     */
    set clickAction(value: string | undefined);
    /**
     * Gets the clickDateTime property value.
     * @returns a Date
     */
    get clickDateTime(): Date | undefined;
    /**
     * Sets the clickDateTime property value.
     * @param value Value to set for the clickDateTime property.
     */
    set clickDateTime(value: Date | undefined);
    /**
     * Instantiates a new uriClickSecurityState and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the id property value.
     * @returns a string
     */
    get id(): string | undefined;
    /**
     * Sets the id property value.
     * @param value Value to set for the id property.
     */
    set id(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the sourceId property value.
     * @returns a string
     */
    get sourceId(): string | undefined;
    /**
     * Sets the sourceId property value.
     * @param value Value to set for the sourceId property.
     */
    set sourceId(value: string | undefined);
    /**
     * Gets the uriDomain property value.
     * @returns a string
     */
    get uriDomain(): string | undefined;
    /**
     * Sets the uriDomain property value.
     * @param value Value to set for the uriDomain property.
     */
    set uriDomain(value: string | undefined);
    /**
     * Gets the verdict property value.
     * @returns a string
     */
    get verdict(): string | undefined;
    /**
     * Sets the verdict property value.
     * @param value Value to set for the verdict property.
     */
    set verdict(value: string | undefined);
}
