"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.User = void 0;
const createAgreementAcceptanceFromDiscriminatorValue_1 = require("./createAgreementAcceptanceFromDiscriminatorValue");
const createAppRoleAssignmentFromDiscriminatorValue_1 = require("./createAppRoleAssignmentFromDiscriminatorValue");
const createAssignedLicenseFromDiscriminatorValue_1 = require("./createAssignedLicenseFromDiscriminatorValue");
const createAssignedPlanFromDiscriminatorValue_1 = require("./createAssignedPlanFromDiscriminatorValue");
const createAuthenticationFromDiscriminatorValue_1 = require("./createAuthenticationFromDiscriminatorValue");
const createCalendarFromDiscriminatorValue_1 = require("./createCalendarFromDiscriminatorValue");
const createCalendarGroupFromDiscriminatorValue_1 = require("./createCalendarGroupFromDiscriminatorValue");
const createChatFromDiscriminatorValue_1 = require("./createChatFromDiscriminatorValue");
const createContactFolderFromDiscriminatorValue_1 = require("./createContactFolderFromDiscriminatorValue");
const createContactFromDiscriminatorValue_1 = require("./createContactFromDiscriminatorValue");
const createDeviceManagementTroubleshootingEventFromDiscriminatorValue_1 = require("./createDeviceManagementTroubleshootingEventFromDiscriminatorValue");
const createDirectoryObjectFromDiscriminatorValue_1 = require("./createDirectoryObjectFromDiscriminatorValue");
const createDriveFromDiscriminatorValue_1 = require("./createDriveFromDiscriminatorValue");
const createEmployeeOrgDataFromDiscriminatorValue_1 = require("./createEmployeeOrgDataFromDiscriminatorValue");
const createEventFromDiscriminatorValue_1 = require("./createEventFromDiscriminatorValue");
const createExtensionFromDiscriminatorValue_1 = require("./createExtensionFromDiscriminatorValue");
const createInferenceClassificationFromDiscriminatorValue_1 = require("./createInferenceClassificationFromDiscriminatorValue");
const createLicenseAssignmentStateFromDiscriminatorValue_1 = require("./createLicenseAssignmentStateFromDiscriminatorValue");
const createLicenseDetailsFromDiscriminatorValue_1 = require("./createLicenseDetailsFromDiscriminatorValue");
const createMailboxSettingsFromDiscriminatorValue_1 = require("./createMailboxSettingsFromDiscriminatorValue");
const createMailFolderFromDiscriminatorValue_1 = require("./createMailFolderFromDiscriminatorValue");
const createManagedAppRegistrationFromDiscriminatorValue_1 = require("./createManagedAppRegistrationFromDiscriminatorValue");
const createManagedDeviceFromDiscriminatorValue_1 = require("./createManagedDeviceFromDiscriminatorValue");
const createMessageFromDiscriminatorValue_1 = require("./createMessageFromDiscriminatorValue");
const createOAuth2PermissionGrantFromDiscriminatorValue_1 = require("./createOAuth2PermissionGrantFromDiscriminatorValue");
const createObjectIdentityFromDiscriminatorValue_1 = require("./createObjectIdentityFromDiscriminatorValue");
const createOfficeGraphInsightsFromDiscriminatorValue_1 = require("./createOfficeGraphInsightsFromDiscriminatorValue");
const createOnenoteFromDiscriminatorValue_1 = require("./createOnenoteFromDiscriminatorValue");
const createOnlineMeetingFromDiscriminatorValue_1 = require("./createOnlineMeetingFromDiscriminatorValue");
const createOnPremisesExtensionAttributesFromDiscriminatorValue_1 = require("./createOnPremisesExtensionAttributesFromDiscriminatorValue");
const createOnPremisesProvisioningErrorFromDiscriminatorValue_1 = require("./createOnPremisesProvisioningErrorFromDiscriminatorValue");
const createOutlookUserFromDiscriminatorValue_1 = require("./createOutlookUserFromDiscriminatorValue");
const createPasswordProfileFromDiscriminatorValue_1 = require("./createPasswordProfileFromDiscriminatorValue");
const createPersonFromDiscriminatorValue_1 = require("./createPersonFromDiscriminatorValue");
const createPlannerUserFromDiscriminatorValue_1 = require("./createPlannerUserFromDiscriminatorValue");
const createPresenceFromDiscriminatorValue_1 = require("./createPresenceFromDiscriminatorValue");
const createProfilePhotoFromDiscriminatorValue_1 = require("./createProfilePhotoFromDiscriminatorValue");
const createProvisionedPlanFromDiscriminatorValue_1 = require("./createProvisionedPlanFromDiscriminatorValue");
const createScopedRoleMembershipFromDiscriminatorValue_1 = require("./createScopedRoleMembershipFromDiscriminatorValue");
const createSiteFromDiscriminatorValue_1 = require("./createSiteFromDiscriminatorValue");
const createTeamFromDiscriminatorValue_1 = require("./createTeamFromDiscriminatorValue");
const createTodoFromDiscriminatorValue_1 = require("./createTodoFromDiscriminatorValue");
const createUserActivityFromDiscriminatorValue_1 = require("./createUserActivityFromDiscriminatorValue");
const createUserSettingsFromDiscriminatorValue_1 = require("./createUserSettingsFromDiscriminatorValue");
const createUserTeamworkFromDiscriminatorValue_1 = require("./createUserTeamworkFromDiscriminatorValue");
const index_1 = require("./index");
class User extends index_1.DirectoryObject {
    /**
     * Instantiates a new user and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the aboutMe property value. A freeform text entry field for the user to describe themselves. Returned only on $select.
     * @returns a string
     */
    get aboutMe() {
        return this._aboutMe;
    }
    ;
    /**
     * Sets the aboutMe property value. A freeform text entry field for the user to describe themselves. Returned only on $select.
     * @param value Value to set for the aboutMe property.
     */
    set aboutMe(value) {
        this._aboutMe = value;
    }
    ;
    /**
     * Gets the accountEnabled property value. true if the account is enabled; otherwise, false. This property is required when a user is created. Returned only on $select. Supports $filter (eq, ne, not, and in).
     * @returns a boolean
     */
    get accountEnabled() {
        return this._accountEnabled;
    }
    ;
    /**
     * Sets the accountEnabled property value. true if the account is enabled; otherwise, false. This property is required when a user is created. Returned only on $select. Supports $filter (eq, ne, not, and in).
     * @param value Value to set for the accountEnabled property.
     */
    set accountEnabled(value) {
        this._accountEnabled = value;
    }
    ;
    /**
     * Gets the activities property value. The user's activities across devices. Read-only. Nullable.
     * @returns a userActivity
     */
    get activities() {
        return this._activities;
    }
    ;
    /**
     * Sets the activities property value. The user's activities across devices. Read-only. Nullable.
     * @param value Value to set for the activities property.
     */
    set activities(value) {
        this._activities = value;
    }
    ;
    /**
     * Gets the ageGroup property value. Sets the age group of the user. Allowed values: null, Minor, NotAdult and Adult. Refer to the legal age group property definitions for further information. Returned only on $select. Supports $filter (eq, ne, not, and in).
     * @returns a string
     */
    get ageGroup() {
        return this._ageGroup;
    }
    ;
    /**
     * Sets the ageGroup property value. Sets the age group of the user. Allowed values: null, Minor, NotAdult and Adult. Refer to the legal age group property definitions for further information. Returned only on $select. Supports $filter (eq, ne, not, and in).
     * @param value Value to set for the ageGroup property.
     */
    set ageGroup(value) {
        this._ageGroup = value;
    }
    ;
    /**
     * Gets the agreementAcceptances property value. The user's terms of use acceptance statuses. Read-only. Nullable.
     * @returns a agreementAcceptance
     */
    get agreementAcceptances() {
        return this._agreementAcceptances;
    }
    ;
    /**
     * Sets the agreementAcceptances property value. The user's terms of use acceptance statuses. Read-only. Nullable.
     * @param value Value to set for the agreementAcceptances property.
     */
    set agreementAcceptances(value) {
        this._agreementAcceptances = value;
    }
    ;
    /**
     * Gets the appRoleAssignments property value. Represents the app roles a user has been granted for an application. Supports $expand.
     * @returns a appRoleAssignment
     */
    get appRoleAssignments() {
        return this._appRoleAssignments;
    }
    ;
    /**
     * Sets the appRoleAssignments property value. Represents the app roles a user has been granted for an application. Supports $expand.
     * @param value Value to set for the appRoleAssignments property.
     */
    set appRoleAssignments(value) {
        this._appRoleAssignments = value;
    }
    ;
    /**
     * Gets the assignedLicenses property value. The licenses that are assigned to the user, including inherited (group-based) licenses.  Not nullable. Returned only on $select. Supports $filter (eq and not).
     * @returns a assignedLicense
     */
    get assignedLicenses() {
        return this._assignedLicenses;
    }
    ;
    /**
     * Sets the assignedLicenses property value. The licenses that are assigned to the user, including inherited (group-based) licenses.  Not nullable. Returned only on $select. Supports $filter (eq and not).
     * @param value Value to set for the assignedLicenses property.
     */
    set assignedLicenses(value) {
        this._assignedLicenses = value;
    }
    ;
    /**
     * Gets the assignedPlans property value. The plans that are assigned to the user. Read-only. Not nullable. Returned only on $select. Supports $filter (eq and not).
     * @returns a assignedPlan
     */
    get assignedPlans() {
        return this._assignedPlans;
    }
    ;
    /**
     * Sets the assignedPlans property value. The plans that are assigned to the user. Read-only. Not nullable. Returned only on $select. Supports $filter (eq and not).
     * @param value Value to set for the assignedPlans property.
     */
    set assignedPlans(value) {
        this._assignedPlans = value;
    }
    ;
    /**
     * Gets the authentication property value.
     * @returns a authentication
     */
    get authentication() {
        return this._authentication;
    }
    ;
    /**
     * Sets the authentication property value.
     * @param value Value to set for the authentication property.
     */
    set authentication(value) {
        this._authentication = value;
    }
    ;
    /**
     * Gets the birthday property value. The birthday of the user. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Returned only on $select.
     * @returns a Date
     */
    get birthday() {
        return this._birthday;
    }
    ;
    /**
     * Sets the birthday property value. The birthday of the user. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Returned only on $select.
     * @param value Value to set for the birthday property.
     */
    set birthday(value) {
        this._birthday = value;
    }
    ;
    /**
     * Gets the businessPhones property value. The telephone numbers for the user. NOTE: Although this is a string collection, only one number can be set for this property. Read-only for users synced from on-premises directory. Returned by default. Supports $filter (eq, not, ge, le, startsWith).
     * @returns a string
     */
    get businessPhones() {
        return this._businessPhones;
    }
    ;
    /**
     * Sets the businessPhones property value. The telephone numbers for the user. NOTE: Although this is a string collection, only one number can be set for this property. Read-only for users synced from on-premises directory. Returned by default. Supports $filter (eq, not, ge, le, startsWith).
     * @param value Value to set for the businessPhones property.
     */
    set businessPhones(value) {
        this._businessPhones = value;
    }
    ;
    /**
     * Gets the calendar property value. The user's primary calendar. Read-only.
     * @returns a calendar
     */
    get calendar() {
        return this._calendar;
    }
    ;
    /**
     * Sets the calendar property value. The user's primary calendar. Read-only.
     * @param value Value to set for the calendar property.
     */
    set calendar(value) {
        this._calendar = value;
    }
    ;
    /**
     * Gets the calendarGroups property value. The user's calendar groups. Read-only. Nullable.
     * @returns a calendarGroup
     */
    get calendarGroups() {
        return this._calendarGroups;
    }
    ;
    /**
     * Sets the calendarGroups property value. The user's calendar groups. Read-only. Nullable.
     * @param value Value to set for the calendarGroups property.
     */
    set calendarGroups(value) {
        this._calendarGroups = value;
    }
    ;
    /**
     * Gets the calendars property value. The user's calendars. Read-only. Nullable.
     * @returns a calendar
     */
    get calendars() {
        return this._calendars;
    }
    ;
    /**
     * Sets the calendars property value. The user's calendars. Read-only. Nullable.
     * @param value Value to set for the calendars property.
     */
    set calendars(value) {
        this._calendars = value;
    }
    ;
    /**
     * Gets the calendarView property value. The calendar view for the calendar. Read-only. Nullable.
     * @returns a event
     */
    get calendarView() {
        return this._calendarView;
    }
    ;
    /**
     * Sets the calendarView property value. The calendar view for the calendar. Read-only. Nullable.
     * @param value Value to set for the calendarView property.
     */
    set calendarView(value) {
        this._calendarView = value;
    }
    ;
    /**
     * Gets the chats property value.
     * @returns a chat
     */
    get chats() {
        return this._chats;
    }
    ;
    /**
     * Sets the chats property value.
     * @param value Value to set for the chats property.
     */
    set chats(value) {
        this._chats = value;
    }
    ;
    /**
     * Gets the city property value. The city in which the user is located. Maximum length is 128 characters. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get city() {
        return this._city;
    }
    ;
    /**
     * Sets the city property value. The city in which the user is located. Maximum length is 128 characters. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the city property.
     */
    set city(value) {
        this._city = value;
    }
    ;
    /**
     * Gets the companyName property value. The company name which the user is associated. This property can be useful for describing the company that an external user comes from. The maximum length is 64 characters.Returned only on $select. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get companyName() {
        return this._companyName;
    }
    ;
    /**
     * Sets the companyName property value. The company name which the user is associated. This property can be useful for describing the company that an external user comes from. The maximum length is 64 characters.Returned only on $select. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the companyName property.
     */
    set companyName(value) {
        this._companyName = value;
    }
    ;
    /**
     * Gets the consentProvidedForMinor property value. Sets whether consent has been obtained for minors. Allowed values: null, Granted, Denied and NotRequired. Refer to the legal age group property definitions for further information. Returned only on $select. Supports $filter (eq, ne, not, and in).
     * @returns a string
     */
    get consentProvidedForMinor() {
        return this._consentProvidedForMinor;
    }
    ;
    /**
     * Sets the consentProvidedForMinor property value. Sets whether consent has been obtained for minors. Allowed values: null, Granted, Denied and NotRequired. Refer to the legal age group property definitions for further information. Returned only on $select. Supports $filter (eq, ne, not, and in).
     * @param value Value to set for the consentProvidedForMinor property.
     */
    set consentProvidedForMinor(value) {
        this._consentProvidedForMinor = value;
    }
    ;
    ;
    /**
     * Gets the contactFolders property value. The user's contacts folders. Read-only. Nullable.
     * @returns a contactFolder
     */
    get contactFolders() {
        return this._contactFolders;
    }
    ;
    /**
     * Sets the contactFolders property value. The user's contacts folders. Read-only. Nullable.
     * @param value Value to set for the contactFolders property.
     */
    set contactFolders(value) {
        this._contactFolders = value;
    }
    ;
    /**
     * Gets the contacts property value. The user's contacts. Read-only. Nullable.
     * @returns a contact
     */
    get contacts() {
        return this._contacts;
    }
    ;
    /**
     * Sets the contacts property value. The user's contacts. Read-only. Nullable.
     * @param value Value to set for the contacts property.
     */
    set contacts(value) {
        this._contacts = value;
    }
    ;
    /**
     * Gets the country property value. The country/region in which the user is located; for example, US or UK. Maximum length is 128 characters. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get country() {
        return this._country;
    }
    ;
    /**
     * Sets the country property value. The country/region in which the user is located; for example, US or UK. Maximum length is 128 characters. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the country property.
     */
    set country(value) {
        this._country = value;
    }
    ;
    /**
     * Gets the createdDateTime property value. The created date of the user object. Read-only. Returned only on $select. Supports $filter (eq, ne, not , ge, le, in).
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. The created date of the user object. Read-only. Returned only on $select. Supports $filter (eq, ne, not , ge, le, in).
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * Gets the createdObjects property value. Directory objects that were created by the user. Read-only. Nullable.
     * @returns a directoryObject
     */
    get createdObjects() {
        return this._createdObjects;
    }
    ;
    /**
     * Sets the createdObjects property value. Directory objects that were created by the user. Read-only. Nullable.
     * @param value Value to set for the createdObjects property.
     */
    set createdObjects(value) {
        this._createdObjects = value;
    }
    ;
    /**
     * Gets the creationType property value. Indicates whether the user account was created through one of the following methods:  As a regular school or work account (null). As an external account (Invitation). As a local account for an Azure Active Directory B2C tenant (LocalAccount). Through self-service sign-up by an internal user using email verification (EmailVerified). Through self-service sign-up by an external user signing up through a link that is part of a user flow (SelfServiceSignUp). Read-only.Returned only on $select. Supports $filter (eq, ne, not, in).
     * @returns a string
     */
    get creationType() {
        return this._creationType;
    }
    ;
    /**
     * Sets the creationType property value. Indicates whether the user account was created through one of the following methods:  As a regular school or work account (null). As an external account (Invitation). As a local account for an Azure Active Directory B2C tenant (LocalAccount). Through self-service sign-up by an internal user using email verification (EmailVerified). Through self-service sign-up by an external user signing up through a link that is part of a user flow (SelfServiceSignUp). Read-only.Returned only on $select. Supports $filter (eq, ne, not, in).
     * @param value Value to set for the creationType property.
     */
    set creationType(value) {
        this._creationType = value;
    }
    ;
    /**
     * Gets the department property value. The name for the department in which the user works. Maximum length is 64 characters. Returned only on $select. Supports $filter (eq, ne, not , ge, le, in, and eq on null values).
     * @returns a string
     */
    get department() {
        return this._department;
    }
    ;
    /**
     * Sets the department property value. The name for the department in which the user works. Maximum length is 64 characters. Returned only on $select. Supports $filter (eq, ne, not , ge, le, in, and eq on null values).
     * @param value Value to set for the department property.
     */
    set department(value) {
        this._department = value;
    }
    ;
    /**
     * Gets the deviceEnrollmentLimit property value. The limit on the maximum number of devices that the user is permitted to enroll. Allowed values are 5 or 1000.
     * @returns a integer
     */
    get deviceEnrollmentLimit() {
        return this._deviceEnrollmentLimit;
    }
    ;
    /**
     * Sets the deviceEnrollmentLimit property value. The limit on the maximum number of devices that the user is permitted to enroll. Allowed values are 5 or 1000.
     * @param value Value to set for the deviceEnrollmentLimit property.
     */
    set deviceEnrollmentLimit(value) {
        this._deviceEnrollmentLimit = value;
    }
    ;
    /**
     * Gets the deviceManagementTroubleshootingEvents property value. The list of troubleshooting events for this user.
     * @returns a deviceManagementTroubleshootingEvent
     */
    get deviceManagementTroubleshootingEvents() {
        return this._deviceManagementTroubleshootingEvents;
    }
    ;
    /**
     * Sets the deviceManagementTroubleshootingEvents property value. The list of troubleshooting events for this user.
     * @param value Value to set for the deviceManagementTroubleshootingEvents property.
     */
    set deviceManagementTroubleshootingEvents(value) {
        this._deviceManagementTroubleshootingEvents = value;
    }
    ;
    /**
     * Gets the directReports property value. The users and contacts that report to the user. (The users and contacts that have their manager property set to this user.) Read-only. Nullable. Supports $expand.
     * @returns a directoryObject
     */
    get directReports() {
        return this._directReports;
    }
    ;
    /**
     * Sets the directReports property value. The users and contacts that report to the user. (The users and contacts that have their manager property set to this user.) Read-only. Nullable. Supports $expand.
     * @param value Value to set for the directReports property.
     */
    set directReports(value) {
        this._directReports = value;
    }
    ;
    /**
     * Gets the displayName property value. The name displayed in the address book for the user. This is usually the combination of the user's first name, middle initial and last name. This property is required when a user is created and it cannot be cleared during updates. Maximum length is 256 characters. Returned by default. Supports $filter (eq, ne, not , ge, le, in, startsWith, and eq on null values), $orderBy, and $search.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The name displayed in the address book for the user. This is usually the combination of the user's first name, middle initial and last name. This property is required when a user is created and it cannot be cleared during updates. Maximum length is 256 characters. Returned by default. Supports $filter (eq, ne, not , ge, le, in, startsWith, and eq on null values), $orderBy, and $search.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * Gets the drive property value. The user's OneDrive. Read-only.
     * @returns a drive
     */
    get drive() {
        return this._drive;
    }
    ;
    /**
     * Sets the drive property value. The user's OneDrive. Read-only.
     * @param value Value to set for the drive property.
     */
    set drive(value) {
        this._drive = value;
    }
    ;
    /**
     * Gets the drives property value. A collection of drives available for this user. Read-only.
     * @returns a drive
     */
    get drives() {
        return this._drives;
    }
    ;
    /**
     * Sets the drives property value. A collection of drives available for this user. Read-only.
     * @param value Value to set for the drives property.
     */
    set drives(value) {
        this._drives = value;
    }
    ;
    /**
     * Gets the employeeHireDate property value. The date and time when the user was hired or will start work in case of a future hire. Returned only on $select. Supports $filter (eq, ne, not , ge, le, in).
     * @returns a Date
     */
    get employeeHireDate() {
        return this._employeeHireDate;
    }
    ;
    /**
     * Sets the employeeHireDate property value. The date and time when the user was hired or will start work in case of a future hire. Returned only on $select. Supports $filter (eq, ne, not , ge, le, in).
     * @param value Value to set for the employeeHireDate property.
     */
    set employeeHireDate(value) {
        this._employeeHireDate = value;
    }
    ;
    /**
     * Gets the employeeId property value. The employee identifier assigned to the user by the organization. The maximum length is 16 characters. Returned only on $select. Supports $filter (eq, ne, not , ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get employeeId() {
        return this._employeeId;
    }
    ;
    /**
     * Sets the employeeId property value. The employee identifier assigned to the user by the organization. The maximum length is 16 characters. Returned only on $select. Supports $filter (eq, ne, not , ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the employeeId property.
     */
    set employeeId(value) {
        this._employeeId = value;
    }
    ;
    /**
     * Gets the employeeOrgData property value. Represents organization data (e.g. division and costCenter) associated with a user. Returned only on $select. Supports $filter (eq, ne, not , ge, le, in).
     * @returns a employeeOrgData
     */
    get employeeOrgData() {
        return this._employeeOrgData;
    }
    ;
    /**
     * Sets the employeeOrgData property value. Represents organization data (e.g. division and costCenter) associated with a user. Returned only on $select. Supports $filter (eq, ne, not , ge, le, in).
     * @param value Value to set for the employeeOrgData property.
     */
    set employeeOrgData(value) {
        this._employeeOrgData = value;
    }
    ;
    /**
     * Gets the employeeType property value. Captures enterprise worker type. For example, Employee, Contractor, Consultant, or Vendor. Returned only on $select. Supports $filter (eq, ne, not , ge, le, in, startsWith).
     * @returns a string
     */
    get employeeType() {
        return this._employeeType;
    }
    ;
    /**
     * Sets the employeeType property value. Captures enterprise worker type. For example, Employee, Contractor, Consultant, or Vendor. Returned only on $select. Supports $filter (eq, ne, not , ge, le, in, startsWith).
     * @param value Value to set for the employeeType property.
     */
    set employeeType(value) {
        this._employeeType = value;
    }
    ;
    /**
     * Gets the events property value. The user's events. Default is to show Events under the Default Calendar. Read-only. Nullable.
     * @returns a event
     */
    get events() {
        return this._events;
    }
    ;
    /**
     * Sets the events property value. The user's events. Default is to show Events under the Default Calendar. Read-only. Nullable.
     * @param value Value to set for the events property.
     */
    set events(value) {
        this._events = value;
    }
    ;
    /**
     * Gets the extensions property value. The collection of open extensions defined for the user. Read-only. Nullable.
     * @returns a extension
     */
    get extensions() {
        return this._extensions;
    }
    ;
    /**
     * Sets the extensions property value. The collection of open extensions defined for the user. Read-only. Nullable.
     * @param value Value to set for the extensions property.
     */
    set extensions(value) {
        this._extensions = value;
    }
    ;
    /**
     * Gets the externalUserState property value. For an external user invited to the tenant using the invitation API, this property represents the invited user's invitation status. For invited users, the state can be PendingAcceptance or Accepted, or null for all other users. Returned only on $select. Supports $filter (eq, ne, not , in).
     * @returns a string
     */
    get externalUserState() {
        return this._externalUserState;
    }
    ;
    /**
     * Sets the externalUserState property value. For an external user invited to the tenant using the invitation API, this property represents the invited user's invitation status. For invited users, the state can be PendingAcceptance or Accepted, or null for all other users. Returned only on $select. Supports $filter (eq, ne, not , in).
     * @param value Value to set for the externalUserState property.
     */
    set externalUserState(value) {
        this._externalUserState = value;
    }
    ;
    /**
     * Gets the externalUserStateChangeDateTime property value. Shows the timestamp for the latest change to the externalUserState property. Returned only on $select. Supports $filter (eq, ne, not , in).
     * @returns a Date
     */
    get externalUserStateChangeDateTime() {
        return this._externalUserStateChangeDateTime;
    }
    ;
    /**
     * Sets the externalUserStateChangeDateTime property value. Shows the timestamp for the latest change to the externalUserState property. Returned only on $select. Supports $filter (eq, ne, not , in).
     * @param value Value to set for the externalUserStateChangeDateTime property.
     */
    set externalUserStateChangeDateTime(value) {
        this._externalUserStateChangeDateTime = value;
    }
    ;
    /**
     * Gets the faxNumber property value. The fax number of the user. Returned only on $select. Supports $filter (eq, ne, not , ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get faxNumber() {
        return this._faxNumber;
    }
    ;
    /**
     * Sets the faxNumber property value. The fax number of the user. Returned only on $select. Supports $filter (eq, ne, not , ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the faxNumber property.
     */
    set faxNumber(value) {
        this._faxNumber = value;
    }
    ;
    /**
     * Gets the followedSites property value.
     * @returns a site
     */
    get followedSites() {
        return this._followedSites;
    }
    ;
    /**
     * Sets the followedSites property value.
     * @param value Value to set for the followedSites property.
     */
    set followedSites(value) {
        this._followedSites = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "aboutMe": (o, n) => { o.aboutMe = n.getStringValue(); }, "accountEnabled": (o, n) => { o.accountEnabled = n.getBooleanValue(); }, "activities": (o, n) => { o.activities = n.getCollectionOfObjectValues(createUserActivityFromDiscriminatorValue_1.createUserActivityFromDiscriminatorValue); }, "ageGroup": (o, n) => { o.ageGroup = n.getStringValue(); }, "agreementAcceptances": (o, n) => { o.agreementAcceptances = n.getCollectionOfObjectValues(createAgreementAcceptanceFromDiscriminatorValue_1.createAgreementAcceptanceFromDiscriminatorValue); }, "appRoleAssignments": (o, n) => { o.appRoleAssignments = n.getCollectionOfObjectValues(createAppRoleAssignmentFromDiscriminatorValue_1.createAppRoleAssignmentFromDiscriminatorValue); }, "assignedLicenses": (o, n) => { o.assignedLicenses = n.getCollectionOfObjectValues(createAssignedLicenseFromDiscriminatorValue_1.createAssignedLicenseFromDiscriminatorValue); }, "assignedPlans": (o, n) => { o.assignedPlans = n.getCollectionOfObjectValues(createAssignedPlanFromDiscriminatorValue_1.createAssignedPlanFromDiscriminatorValue); }, "authentication": (o, n) => { o.authentication = n.getObjectValue(createAuthenticationFromDiscriminatorValue_1.createAuthenticationFromDiscriminatorValue); }, "birthday": (o, n) => { o.birthday = n.getDateValue(); }, "businessPhones": (o, n) => { o.businessPhones = n.getCollectionOfPrimitiveValues(); }, "calendar": (o, n) => { o.calendar = n.getObjectValue(createCalendarFromDiscriminatorValue_1.createCalendarFromDiscriminatorValue); }, "calendarGroups": (o, n) => { o.calendarGroups = n.getCollectionOfObjectValues(createCalendarGroupFromDiscriminatorValue_1.createCalendarGroupFromDiscriminatorValue); }, "calendars": (o, n) => { o.calendars = n.getCollectionOfObjectValues(createCalendarFromDiscriminatorValue_1.createCalendarFromDiscriminatorValue); }, "calendarView": (o, n) => { o.calendarView = n.getCollectionOfObjectValues(createEventFromDiscriminatorValue_1.createEventFromDiscriminatorValue); }, "chats": (o, n) => { o.chats = n.getCollectionOfObjectValues(createChatFromDiscriminatorValue_1.createChatFromDiscriminatorValue); }, "city": (o, n) => { o.city = n.getStringValue(); }, "companyName": (o, n) => { o.companyName = n.getStringValue(); }, "consentProvidedForMinor": (o, n) => { o.consentProvidedForMinor = n.getStringValue(); }, "contactFolders": (o, n) => { o.contactFolders = n.getCollectionOfObjectValues(createContactFolderFromDiscriminatorValue_1.createContactFolderFromDiscriminatorValue); }, "contacts": (o, n) => { o.contacts = n.getCollectionOfObjectValues(createContactFromDiscriminatorValue_1.createContactFromDiscriminatorValue); }, "country": (o, n) => { o.country = n.getStringValue(); }, "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); }, "createdObjects": (o, n) => { o.createdObjects = n.getCollectionOfObjectValues(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "creationType": (o, n) => { o.creationType = n.getStringValue(); }, "department": (o, n) => { o.department = n.getStringValue(); }, "deviceEnrollmentLimit": (o, n) => { o.deviceEnrollmentLimit = n.getNumberValue(); }, "deviceManagementTroubleshootingEvents": (o, n) => { o.deviceManagementTroubleshootingEvents = n.getCollectionOfObjectValues(createDeviceManagementTroubleshootingEventFromDiscriminatorValue_1.createDeviceManagementTroubleshootingEventFromDiscriminatorValue); }, "directReports": (o, n) => { o.directReports = n.getCollectionOfObjectValues(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "drive": (o, n) => { o.drive = n.getObjectValue(createDriveFromDiscriminatorValue_1.createDriveFromDiscriminatorValue); }, "drives": (o, n) => { o.drives = n.getCollectionOfObjectValues(createDriveFromDiscriminatorValue_1.createDriveFromDiscriminatorValue); }, "employeeHireDate": (o, n) => { o.employeeHireDate = n.getDateValue(); }, "employeeId": (o, n) => { o.employeeId = n.getStringValue(); }, "employeeOrgData": (o, n) => { o.employeeOrgData = n.getObjectValue(createEmployeeOrgDataFromDiscriminatorValue_1.createEmployeeOrgDataFromDiscriminatorValue); }, "employeeType": (o, n) => { o.employeeType = n.getStringValue(); }, "events": (o, n) => { o.events = n.getCollectionOfObjectValues(createEventFromDiscriminatorValue_1.createEventFromDiscriminatorValue); }, "extensions": (o, n) => { o.extensions = n.getCollectionOfObjectValues(createExtensionFromDiscriminatorValue_1.createExtensionFromDiscriminatorValue); }, "externalUserState": (o, n) => { o.externalUserState = n.getStringValue(); }, "externalUserStateChangeDateTime": (o, n) => { o.externalUserStateChangeDateTime = n.getDateValue(); }, "faxNumber": (o, n) => { o.faxNumber = n.getStringValue(); }, "followedSites": (o, n) => { o.followedSites = n.getCollectionOfObjectValues(createSiteFromDiscriminatorValue_1.createSiteFromDiscriminatorValue); }, "givenName": (o, n) => { o.givenName = n.getStringValue(); }, "hireDate": (o, n) => { o.hireDate = n.getDateValue(); }, "identities": (o, n) => { o.identities = n.getCollectionOfObjectValues(createObjectIdentityFromDiscriminatorValue_1.createObjectIdentityFromDiscriminatorValue); }, "imAddresses": (o, n) => { o.imAddresses = n.getCollectionOfPrimitiveValues(); }, "inferenceClassification": (o, n) => { o.inferenceClassification = n.getObjectValue(createInferenceClassificationFromDiscriminatorValue_1.createInferenceClassificationFromDiscriminatorValue); }, "insights": (o, n) => { o.insights = n.getObjectValue(createOfficeGraphInsightsFromDiscriminatorValue_1.createOfficeGraphInsightsFromDiscriminatorValue); }, "interests": (o, n) => { o.interests = n.getCollectionOfPrimitiveValues(); }, "isResourceAccount": (o, n) => { o.isResourceAccount = n.getBooleanValue(); }, "jobTitle": (o, n) => { o.jobTitle = n.getStringValue(); }, "joinedTeams": (o, n) => { o.joinedTeams = n.getCollectionOfObjectValues(createTeamFromDiscriminatorValue_1.createTeamFromDiscriminatorValue); }, "lastPasswordChangeDateTime": (o, n) => { o.lastPasswordChangeDateTime = n.getDateValue(); }, "legalAgeGroupClassification": (o, n) => { o.legalAgeGroupClassification = n.getStringValue(); }, "licenseAssignmentStates": (o, n) => { o.licenseAssignmentStates = n.getCollectionOfObjectValues(createLicenseAssignmentStateFromDiscriminatorValue_1.createLicenseAssignmentStateFromDiscriminatorValue); }, "licenseDetails": (o, n) => { o.licenseDetails = n.getCollectionOfObjectValues(createLicenseDetailsFromDiscriminatorValue_1.createLicenseDetailsFromDiscriminatorValue); }, "mail": (o, n) => { o.mail = n.getStringValue(); }, "mailboxSettings": (o, n) => { o.mailboxSettings = n.getObjectValue(createMailboxSettingsFromDiscriminatorValue_1.createMailboxSettingsFromDiscriminatorValue); }, "mailFolders": (o, n) => { o.mailFolders = n.getCollectionOfObjectValues(createMailFolderFromDiscriminatorValue_1.createMailFolderFromDiscriminatorValue); }, "mailNickname": (o, n) => { o.mailNickname = n.getStringValue(); }, "managedAppRegistrations": (o, n) => { o.managedAppRegistrations = n.getCollectionOfObjectValues(createManagedAppRegistrationFromDiscriminatorValue_1.createManagedAppRegistrationFromDiscriminatorValue); }, "managedDevices": (o, n) => { o.managedDevices = n.getCollectionOfObjectValues(createManagedDeviceFromDiscriminatorValue_1.createManagedDeviceFromDiscriminatorValue); }, "manager": (o, n) => { o.manager = n.getObjectValue(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "memberOf": (o, n) => { o.memberOf = n.getCollectionOfObjectValues(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "messages": (o, n) => { o.messages = n.getCollectionOfObjectValues(createMessageFromDiscriminatorValue_1.createMessageFromDiscriminatorValue); }, "mobilePhone": (o, n) => { o.mobilePhone = n.getStringValue(); }, "mySite": (o, n) => { o.mySite = n.getStringValue(); }, "oauth2PermissionGrants": (o, n) => { o.oauth2PermissionGrants = n.getCollectionOfObjectValues(createOAuth2PermissionGrantFromDiscriminatorValue_1.createOAuth2PermissionGrantFromDiscriminatorValue); }, "officeLocation": (o, n) => { o.officeLocation = n.getStringValue(); }, "onenote": (o, n) => { o.onenote = n.getObjectValue(createOnenoteFromDiscriminatorValue_1.createOnenoteFromDiscriminatorValue); }, "onlineMeetings": (o, n) => { o.onlineMeetings = n.getCollectionOfObjectValues(createOnlineMeetingFromDiscriminatorValue_1.createOnlineMeetingFromDiscriminatorValue); }, "onPremisesDistinguishedName": (o, n) => { o.onPremisesDistinguishedName = n.getStringValue(); }, "onPremisesDomainName": (o, n) => { o.onPremisesDomainName = n.getStringValue(); }, "onPremisesExtensionAttributes": (o, n) => { o.onPremisesExtensionAttributes = n.getObjectValue(createOnPremisesExtensionAttributesFromDiscriminatorValue_1.createOnPremisesExtensionAttributesFromDiscriminatorValue); }, "onPremisesImmutableId": (o, n) => { o.onPremisesImmutableId = n.getStringValue(); }, "onPremisesLastSyncDateTime": (o, n) => { o.onPremisesLastSyncDateTime = n.getDateValue(); }, "onPremisesProvisioningErrors": (o, n) => { o.onPremisesProvisioningErrors = n.getCollectionOfObjectValues(createOnPremisesProvisioningErrorFromDiscriminatorValue_1.createOnPremisesProvisioningErrorFromDiscriminatorValue); }, "onPremisesSamAccountName": (o, n) => { o.onPremisesSamAccountName = n.getStringValue(); }, "onPremisesSecurityIdentifier": (o, n) => { o.onPremisesSecurityIdentifier = n.getStringValue(); }, "onPremisesSyncEnabled": (o, n) => { o.onPremisesSyncEnabled = n.getBooleanValue(); }, "onPremisesUserPrincipalName": (o, n) => { o.onPremisesUserPrincipalName = n.getStringValue(); }, "otherMails": (o, n) => { o.otherMails = n.getCollectionOfPrimitiveValues(); }, "outlook": (o, n) => { o.outlook = n.getObjectValue(createOutlookUserFromDiscriminatorValue_1.createOutlookUserFromDiscriminatorValue); }, "ownedDevices": (o, n) => { o.ownedDevices = n.getCollectionOfObjectValues(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "ownedObjects": (o, n) => { o.ownedObjects = n.getCollectionOfObjectValues(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "passwordPolicies": (o, n) => { o.passwordPolicies = n.getStringValue(); }, "passwordProfile": (o, n) => { o.passwordProfile = n.getObjectValue(createPasswordProfileFromDiscriminatorValue_1.createPasswordProfileFromDiscriminatorValue); }, "pastProjects": (o, n) => { o.pastProjects = n.getCollectionOfPrimitiveValues(); }, "people": (o, n) => { o.people = n.getCollectionOfObjectValues(createPersonFromDiscriminatorValue_1.createPersonFromDiscriminatorValue); }, "photo": (o, n) => { o.photo = n.getObjectValue(createProfilePhotoFromDiscriminatorValue_1.createProfilePhotoFromDiscriminatorValue); }, "photos": (o, n) => { o.photos = n.getCollectionOfObjectValues(createProfilePhotoFromDiscriminatorValue_1.createProfilePhotoFromDiscriminatorValue); }, "planner": (o, n) => { o.planner = n.getObjectValue(createPlannerUserFromDiscriminatorValue_1.createPlannerUserFromDiscriminatorValue); }, "postalCode": (o, n) => { o.postalCode = n.getStringValue(); }, "preferredLanguage": (o, n) => { o.preferredLanguage = n.getStringValue(); }, "preferredName": (o, n) => { o.preferredName = n.getStringValue(); }, "presence": (o, n) => { o.presence = n.getObjectValue(createPresenceFromDiscriminatorValue_1.createPresenceFromDiscriminatorValue); }, "provisionedPlans": (o, n) => { o.provisionedPlans = n.getCollectionOfObjectValues(createProvisionedPlanFromDiscriminatorValue_1.createProvisionedPlanFromDiscriminatorValue); }, "proxyAddresses": (o, n) => { o.proxyAddresses = n.getCollectionOfPrimitiveValues(); }, "registeredDevices": (o, n) => { o.registeredDevices = n.getCollectionOfObjectValues(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "responsibilities": (o, n) => { o.responsibilities = n.getCollectionOfPrimitiveValues(); }, "schools": (o, n) => { o.schools = n.getCollectionOfPrimitiveValues(); }, "scopedRoleMemberOf": (o, n) => { o.scopedRoleMemberOf = n.getCollectionOfObjectValues(createScopedRoleMembershipFromDiscriminatorValue_1.createScopedRoleMembershipFromDiscriminatorValue); }, "settings": (o, n) => { o.settings = n.getObjectValue(createUserSettingsFromDiscriminatorValue_1.createUserSettingsFromDiscriminatorValue); }, "showInAddressList": (o, n) => { o.showInAddressList = n.getBooleanValue(); }, "signInSessionsValidFromDateTime": (o, n) => { o.signInSessionsValidFromDateTime = n.getDateValue(); }, "skills": (o, n) => { o.skills = n.getCollectionOfPrimitiveValues(); }, "state": (o, n) => { o.state = n.getStringValue(); }, "streetAddress": (o, n) => { o.streetAddress = n.getStringValue(); }, "surname": (o, n) => { o.surname = n.getStringValue(); }, "teamwork": (o, n) => { o.teamwork = n.getObjectValue(createUserTeamworkFromDiscriminatorValue_1.createUserTeamworkFromDiscriminatorValue); }, "todo": (o, n) => { o.todo = n.getObjectValue(createTodoFromDiscriminatorValue_1.createTodoFromDiscriminatorValue); }, "transitiveMemberOf": (o, n) => { o.transitiveMemberOf = n.getCollectionOfObjectValues(createDirectoryObjectFromDiscriminatorValue_1.createDirectoryObjectFromDiscriminatorValue); }, "usageLocation": (o, n) => { o.usageLocation = n.getStringValue(); }, "userPrincipalName": (o, n) => { o.userPrincipalName = n.getStringValue(); }, "userType": (o, n) => { o.userType = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the givenName property value. The given name (first name) of the user. Maximum length is 64 characters. Returned by default. Supports $filter (eq, ne, not , ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get givenName() {
        return this._givenName;
    }
    ;
    /**
     * Sets the givenName property value. The given name (first name) of the user. Maximum length is 64 characters. Returned by default. Supports $filter (eq, ne, not , ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the givenName property.
     */
    set givenName(value) {
        this._givenName = value;
    }
    ;
    /**
     * Gets the hireDate property value. The hire date of the user. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Returned only on $select.  Note: This property is specific to SharePoint Online. We recommend using the native employeeHireDate property to set and update hire date values using Microsoft Graph APIs.
     * @returns a Date
     */
    get hireDate() {
        return this._hireDate;
    }
    ;
    /**
     * Sets the hireDate property value. The hire date of the user. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Returned only on $select.  Note: This property is specific to SharePoint Online. We recommend using the native employeeHireDate property to set and update hire date values using Microsoft Graph APIs.
     * @param value Value to set for the hireDate property.
     */
    set hireDate(value) {
        this._hireDate = value;
    }
    ;
    /**
     * Gets the identities property value. Represents the identities that can be used to sign in to this user account. An identity can be provided by Microsoft (also known as a local account), by organizations, or by social identity providers such as Facebook, Google, and Microsoft, and tied to a user account. May contain multiple items with the same signInType value. Returned only on $select. Supports $filter (eq) including on null values, only where the signInType is not userPrincipalName.
     * @returns a objectIdentity
     */
    get identities() {
        return this._identities;
    }
    ;
    /**
     * Sets the identities property value. Represents the identities that can be used to sign in to this user account. An identity can be provided by Microsoft (also known as a local account), by organizations, or by social identity providers such as Facebook, Google, and Microsoft, and tied to a user account. May contain multiple items with the same signInType value. Returned only on $select. Supports $filter (eq) including on null values, only where the signInType is not userPrincipalName.
     * @param value Value to set for the identities property.
     */
    set identities(value) {
        this._identities = value;
    }
    ;
    /**
     * Gets the imAddresses property value. The instant message voice over IP (VOIP) session initiation protocol (SIP) addresses for the user. Read-only. Returned only on $select. Supports $filter (eq, not, ge, le, startsWith).
     * @returns a string
     */
    get imAddresses() {
        return this._imAddresses;
    }
    ;
    /**
     * Sets the imAddresses property value. The instant message voice over IP (VOIP) session initiation protocol (SIP) addresses for the user. Read-only. Returned only on $select. Supports $filter (eq, not, ge, le, startsWith).
     * @param value Value to set for the imAddresses property.
     */
    set imAddresses(value) {
        this._imAddresses = value;
    }
    ;
    /**
     * Gets the inferenceClassification property value. Relevance classification of the user's messages based on explicit designations which override inferred relevance or importance.
     * @returns a inferenceClassification
     */
    get inferenceClassification() {
        return this._inferenceClassification;
    }
    ;
    /**
     * Sets the inferenceClassification property value. Relevance classification of the user's messages based on explicit designations which override inferred relevance or importance.
     * @param value Value to set for the inferenceClassification property.
     */
    set inferenceClassification(value) {
        this._inferenceClassification = value;
    }
    ;
    /**
     * Gets the insights property value. Read-only. Nullable.
     * @returns a officeGraphInsights
     */
    get insights() {
        return this._insights;
    }
    ;
    /**
     * Sets the insights property value. Read-only. Nullable.
     * @param value Value to set for the insights property.
     */
    set insights(value) {
        this._insights = value;
    }
    ;
    /**
     * Gets the interests property value. A list for the user to describe their interests. Returned only on $select.
     * @returns a string
     */
    get interests() {
        return this._interests;
    }
    ;
    /**
     * Sets the interests property value. A list for the user to describe their interests. Returned only on $select.
     * @param value Value to set for the interests property.
     */
    set interests(value) {
        this._interests = value;
    }
    ;
    /**
     * Gets the isResourceAccount property value. Do not use – reserved for future use.
     * @returns a boolean
     */
    get isResourceAccount() {
        return this._isResourceAccount;
    }
    ;
    /**
     * Sets the isResourceAccount property value. Do not use – reserved for future use.
     * @param value Value to set for the isResourceAccount property.
     */
    set isResourceAccount(value) {
        this._isResourceAccount = value;
    }
    ;
    /**
     * Gets the jobTitle property value. The user's job title. Maximum length is 128 characters. Returned by default. Supports $filter (eq, ne, not , ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get jobTitle() {
        return this._jobTitle;
    }
    ;
    /**
     * Sets the jobTitle property value. The user's job title. Maximum length is 128 characters. Returned by default. Supports $filter (eq, ne, not , ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the jobTitle property.
     */
    set jobTitle(value) {
        this._jobTitle = value;
    }
    ;
    /**
     * Gets the joinedTeams property value. The Microsoft Teams teams that the user is a member of. Read-only. Nullable.
     * @returns a team
     */
    get joinedTeams() {
        return this._joinedTeams;
    }
    ;
    /**
     * Sets the joinedTeams property value. The Microsoft Teams teams that the user is a member of. Read-only. Nullable.
     * @param value Value to set for the joinedTeams property.
     */
    set joinedTeams(value) {
        this._joinedTeams = value;
    }
    ;
    /**
     * Gets the lastPasswordChangeDateTime property value. The time when this Azure AD user last changed their password or when their password was created, whichever date the latest action was performed. The date and time information uses ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Returned only on $select.
     * @returns a Date
     */
    get lastPasswordChangeDateTime() {
        return this._lastPasswordChangeDateTime;
    }
    ;
    /**
     * Sets the lastPasswordChangeDateTime property value. The time when this Azure AD user last changed their password or when their password was created, whichever date the latest action was performed. The date and time information uses ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Returned only on $select.
     * @param value Value to set for the lastPasswordChangeDateTime property.
     */
    set lastPasswordChangeDateTime(value) {
        this._lastPasswordChangeDateTime = value;
    }
    ;
    /**
     * Gets the legalAgeGroupClassification property value. Used by enterprise applications to determine the legal age group of the user. This property is read-only and calculated based on ageGroup and consentProvidedForMinor properties. Allowed values: null, MinorWithOutParentalConsent, MinorWithParentalConsent, MinorNoParentalConsentRequired, NotAdult and Adult. Refer to the legal age group property definitions for further information. Returned only on $select.
     * @returns a string
     */
    get legalAgeGroupClassification() {
        return this._legalAgeGroupClassification;
    }
    ;
    /**
     * Sets the legalAgeGroupClassification property value. Used by enterprise applications to determine the legal age group of the user. This property is read-only and calculated based on ageGroup and consentProvidedForMinor properties. Allowed values: null, MinorWithOutParentalConsent, MinorWithParentalConsent, MinorNoParentalConsentRequired, NotAdult and Adult. Refer to the legal age group property definitions for further information. Returned only on $select.
     * @param value Value to set for the legalAgeGroupClassification property.
     */
    set legalAgeGroupClassification(value) {
        this._legalAgeGroupClassification = value;
    }
    ;
    /**
     * Gets the licenseAssignmentStates property value. State of license assignments for this user. Read-only. Returned only on $select.
     * @returns a licenseAssignmentState
     */
    get licenseAssignmentStates() {
        return this._licenseAssignmentStates;
    }
    ;
    /**
     * Sets the licenseAssignmentStates property value. State of license assignments for this user. Read-only. Returned only on $select.
     * @param value Value to set for the licenseAssignmentStates property.
     */
    set licenseAssignmentStates(value) {
        this._licenseAssignmentStates = value;
    }
    ;
    /**
     * Gets the licenseDetails property value. A collection of this user's license details. Read-only.
     * @returns a licenseDetails
     */
    get licenseDetails() {
        return this._licenseDetails;
    }
    ;
    /**
     * Sets the licenseDetails property value. A collection of this user's license details. Read-only.
     * @param value Value to set for the licenseDetails property.
     */
    set licenseDetails(value) {
        this._licenseDetails = value;
    }
    ;
    /**
     * Gets the mail property value. The SMTP address for the user, for example, jeff@contoso.onmicrosoft.com.Changes to this property will also update the user's proxyAddresses collection to include the value as an SMTP address. For Azure AD B2C accounts, this property can be updated up to only ten times with unique SMTP addresses. This property cannot contain accent characters.Returned by default. Supports $filter (eq, ne, not, ge, le, in, startsWith, endsWith, and eq on null values).
     * @returns a string
     */
    get mail() {
        return this._mail;
    }
    ;
    /**
     * Sets the mail property value. The SMTP address for the user, for example, jeff@contoso.onmicrosoft.com.Changes to this property will also update the user's proxyAddresses collection to include the value as an SMTP address. For Azure AD B2C accounts, this property can be updated up to only ten times with unique SMTP addresses. This property cannot contain accent characters.Returned by default. Supports $filter (eq, ne, not, ge, le, in, startsWith, endsWith, and eq on null values).
     * @param value Value to set for the mail property.
     */
    set mail(value) {
        this._mail = value;
    }
    ;
    /**
     * Gets the mailboxSettings property value. Settings for the primary mailbox of the signed-in user. You can get or update settings for sending automatic replies to incoming messages, locale and time zone. Returned only on $select.
     * @returns a mailboxSettings
     */
    get mailboxSettings() {
        return this._mailboxSettings;
    }
    ;
    /**
     * Sets the mailboxSettings property value. Settings for the primary mailbox of the signed-in user. You can get or update settings for sending automatic replies to incoming messages, locale and time zone. Returned only on $select.
     * @param value Value to set for the mailboxSettings property.
     */
    set mailboxSettings(value) {
        this._mailboxSettings = value;
    }
    ;
    /**
     * Gets the mailFolders property value. The user's mail folders. Read-only. Nullable.
     * @returns a mailFolder
     */
    get mailFolders() {
        return this._mailFolders;
    }
    ;
    /**
     * Sets the mailFolders property value. The user's mail folders. Read-only. Nullable.
     * @param value Value to set for the mailFolders property.
     */
    set mailFolders(value) {
        this._mailFolders = value;
    }
    ;
    /**
     * Gets the mailNickname property value. The mail alias for the user. This property must be specified when a user is created. Maximum length is 64 characters. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get mailNickname() {
        return this._mailNickname;
    }
    ;
    /**
     * Sets the mailNickname property value. The mail alias for the user. This property must be specified when a user is created. Maximum length is 64 characters. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the mailNickname property.
     */
    set mailNickname(value) {
        this._mailNickname = value;
    }
    ;
    /**
     * Gets the managedAppRegistrations property value. Zero or more managed app registrations that belong to the user.
     * @returns a managedAppRegistration
     */
    get managedAppRegistrations() {
        return this._managedAppRegistrations;
    }
    ;
    /**
     * Sets the managedAppRegistrations property value. Zero or more managed app registrations that belong to the user.
     * @param value Value to set for the managedAppRegistrations property.
     */
    set managedAppRegistrations(value) {
        this._managedAppRegistrations = value;
    }
    ;
    /**
     * Gets the managedDevices property value. The managed devices associated with the user.
     * @returns a managedDevice
     */
    get managedDevices() {
        return this._managedDevices;
    }
    ;
    /**
     * Sets the managedDevices property value. The managed devices associated with the user.
     * @param value Value to set for the managedDevices property.
     */
    set managedDevices(value) {
        this._managedDevices = value;
    }
    ;
    /**
     * Gets the manager property value. The user or contact that is this user's manager. Read-only. (HTTP Methods: GET, PUT, DELETE.). Supports $expand.
     * @returns a directoryObject
     */
    get manager() {
        return this._manager;
    }
    ;
    /**
     * Sets the manager property value. The user or contact that is this user's manager. Read-only. (HTTP Methods: GET, PUT, DELETE.). Supports $expand.
     * @param value Value to set for the manager property.
     */
    set manager(value) {
        this._manager = value;
    }
    ;
    /**
     * Gets the memberOf property value. The groups and directory roles that the user is a member of. Read-only. Nullable. Supports $expand.
     * @returns a directoryObject
     */
    get memberOf() {
        return this._memberOf;
    }
    ;
    /**
     * Sets the memberOf property value. The groups and directory roles that the user is a member of. Read-only. Nullable. Supports $expand.
     * @param value Value to set for the memberOf property.
     */
    set memberOf(value) {
        this._memberOf = value;
    }
    ;
    /**
     * Gets the messages property value. The messages in a mailbox or folder. Read-only. Nullable.
     * @returns a message
     */
    get messages() {
        return this._messages;
    }
    ;
    /**
     * Sets the messages property value. The messages in a mailbox or folder. Read-only. Nullable.
     * @param value Value to set for the messages property.
     */
    set messages(value) {
        this._messages = value;
    }
    ;
    /**
     * Gets the mobilePhone property value. The primary cellular telephone number for the user. Read-only for users synced from on-premises directory. Maximum length is 64 characters. Returned by default. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get mobilePhone() {
        return this._mobilePhone;
    }
    ;
    /**
     * Sets the mobilePhone property value. The primary cellular telephone number for the user. Read-only for users synced from on-premises directory. Maximum length is 64 characters. Returned by default. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the mobilePhone property.
     */
    set mobilePhone(value) {
        this._mobilePhone = value;
    }
    ;
    /**
     * Gets the mySite property value. The URL for the user's personal site. Returned only on $select.
     * @returns a string
     */
    get mySite() {
        return this._mySite;
    }
    ;
    /**
     * Sets the mySite property value. The URL for the user's personal site. Returned only on $select.
     * @param value Value to set for the mySite property.
     */
    set mySite(value) {
        this._mySite = value;
    }
    ;
    /**
     * Gets the oauth2PermissionGrants property value.
     * @returns a oAuth2PermissionGrant
     */
    get oauth2PermissionGrants() {
        return this._oauth2PermissionGrants;
    }
    ;
    /**
     * Sets the oauth2PermissionGrants property value.
     * @param value Value to set for the oauth2PermissionGrants property.
     */
    set oauth2PermissionGrants(value) {
        this._oauth2PermissionGrants = value;
    }
    ;
    /**
     * Gets the officeLocation property value. The office location in the user's place of business. Returned by default. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get officeLocation() {
        return this._officeLocation;
    }
    ;
    /**
     * Sets the officeLocation property value. The office location in the user's place of business. Returned by default. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the officeLocation property.
     */
    set officeLocation(value) {
        this._officeLocation = value;
    }
    ;
    /**
     * Gets the onenote property value. Read-only.
     * @returns a onenote
     */
    get onenote() {
        return this._onenote;
    }
    ;
    /**
     * Sets the onenote property value. Read-only.
     * @param value Value to set for the onenote property.
     */
    set onenote(value) {
        this._onenote = value;
    }
    ;
    /**
     * Gets the onlineMeetings property value.
     * @returns a onlineMeeting
     */
    get onlineMeetings() {
        return this._onlineMeetings;
    }
    ;
    /**
     * Sets the onlineMeetings property value.
     * @param value Value to set for the onlineMeetings property.
     */
    set onlineMeetings(value) {
        this._onlineMeetings = value;
    }
    ;
    /**
     * Gets the onPremisesDistinguishedName property value. Contains the on-premises Active Directory distinguished name or DN. The property is only populated for customers who are synchronizing their on-premises directory to Azure Active Directory via Azure AD Connect. Read-only. Returned only on $select.
     * @returns a string
     */
    get onPremisesDistinguishedName() {
        return this._onPremisesDistinguishedName;
    }
    ;
    /**
     * Sets the onPremisesDistinguishedName property value. Contains the on-premises Active Directory distinguished name or DN. The property is only populated for customers who are synchronizing their on-premises directory to Azure Active Directory via Azure AD Connect. Read-only. Returned only on $select.
     * @param value Value to set for the onPremisesDistinguishedName property.
     */
    set onPremisesDistinguishedName(value) {
        this._onPremisesDistinguishedName = value;
    }
    ;
    /**
     * Gets the onPremisesDomainName property value. Contains the on-premises domainFQDN, also called dnsDomainName synchronized from the on-premises directory. The property is only populated for customers who are synchronizing their on-premises directory to Azure Active Directory via Azure AD Connect. Read-only. Returned only on $select.
     * @returns a string
     */
    get onPremisesDomainName() {
        return this._onPremisesDomainName;
    }
    ;
    /**
     * Sets the onPremisesDomainName property value. Contains the on-premises domainFQDN, also called dnsDomainName synchronized from the on-premises directory. The property is only populated for customers who are synchronizing their on-premises directory to Azure Active Directory via Azure AD Connect. Read-only. Returned only on $select.
     * @param value Value to set for the onPremisesDomainName property.
     */
    set onPremisesDomainName(value) {
        this._onPremisesDomainName = value;
    }
    ;
    /**
     * Gets the onPremisesExtensionAttributes property value. Contains extensionAttributes1-15 for the user. The individual extension attributes are neither selectable nor filterable. For an onPremisesSyncEnabled user, the source of authority for this set of properties is the on-premises and is read-only. For a cloud-only user (where onPremisesSyncEnabled is false), these properties can be set during creation or update of a user object.  For a cloud-only user previously synced from on-premises Active Directory, these properties are read-only in Microsoft Graph but can be fully managed through the Exchange Admin Center or the Exchange Online V2 module in PowerShell. These extension attributes are also known as Exchange custom attributes 1-15.
     * @returns a onPremisesExtensionAttributes
     */
    get onPremisesExtensionAttributes() {
        return this._onPremisesExtensionAttributes;
    }
    ;
    /**
     * Sets the onPremisesExtensionAttributes property value. Contains extensionAttributes1-15 for the user. The individual extension attributes are neither selectable nor filterable. For an onPremisesSyncEnabled user, the source of authority for this set of properties is the on-premises and is read-only. For a cloud-only user (where onPremisesSyncEnabled is false), these properties can be set during creation or update of a user object.  For a cloud-only user previously synced from on-premises Active Directory, these properties are read-only in Microsoft Graph but can be fully managed through the Exchange Admin Center or the Exchange Online V2 module in PowerShell. These extension attributes are also known as Exchange custom attributes 1-15.
     * @param value Value to set for the onPremisesExtensionAttributes property.
     */
    set onPremisesExtensionAttributes(value) {
        this._onPremisesExtensionAttributes = value;
    }
    ;
    /**
     * Gets the onPremisesImmutableId property value. This property is used to associate an on-premises Active Directory user account to their Azure AD user object. This property must be specified when creating a new user account in the Graph if you are using a federated domain for the user's userPrincipalName (UPN) property. NOTE: The $ and _ characters cannot be used when specifying this property. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in)..
     * @returns a string
     */
    get onPremisesImmutableId() {
        return this._onPremisesImmutableId;
    }
    ;
    /**
     * Sets the onPremisesImmutableId property value. This property is used to associate an on-premises Active Directory user account to their Azure AD user object. This property must be specified when creating a new user account in the Graph if you are using a federated domain for the user's userPrincipalName (UPN) property. NOTE: The $ and _ characters cannot be used when specifying this property. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in)..
     * @param value Value to set for the onPremisesImmutableId property.
     */
    set onPremisesImmutableId(value) {
        this._onPremisesImmutableId = value;
    }
    ;
    /**
     * Gets the onPremisesLastSyncDateTime property value. Indicates the last time at which the object was synced with the on-premises directory; for example: 2013-02-16T03:04:54Z. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in).
     * @returns a Date
     */
    get onPremisesLastSyncDateTime() {
        return this._onPremisesLastSyncDateTime;
    }
    ;
    /**
     * Sets the onPremisesLastSyncDateTime property value. Indicates the last time at which the object was synced with the on-premises directory; for example: 2013-02-16T03:04:54Z. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in).
     * @param value Value to set for the onPremisesLastSyncDateTime property.
     */
    set onPremisesLastSyncDateTime(value) {
        this._onPremisesLastSyncDateTime = value;
    }
    ;
    /**
     * Gets the onPremisesProvisioningErrors property value. Errors when using Microsoft synchronization product during provisioning. Returned only on $select. Supports $filter (eq, not, ge, le).
     * @returns a onPremisesProvisioningError
     */
    get onPremisesProvisioningErrors() {
        return this._onPremisesProvisioningErrors;
    }
    ;
    /**
     * Sets the onPremisesProvisioningErrors property value. Errors when using Microsoft synchronization product during provisioning. Returned only on $select. Supports $filter (eq, not, ge, le).
     * @param value Value to set for the onPremisesProvisioningErrors property.
     */
    set onPremisesProvisioningErrors(value) {
        this._onPremisesProvisioningErrors = value;
    }
    ;
    /**
     * Gets the onPremisesSamAccountName property value. Contains the on-premises samAccountName synchronized from the on-premises directory. The property is only populated for customers who are synchronizing their on-premises directory to Azure Active Directory via Azure AD Connect. Read-only. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in, startsWith).
     * @returns a string
     */
    get onPremisesSamAccountName() {
        return this._onPremisesSamAccountName;
    }
    ;
    /**
     * Sets the onPremisesSamAccountName property value. Contains the on-premises samAccountName synchronized from the on-premises directory. The property is only populated for customers who are synchronizing their on-premises directory to Azure Active Directory via Azure AD Connect. Read-only. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in, startsWith).
     * @param value Value to set for the onPremisesSamAccountName property.
     */
    set onPremisesSamAccountName(value) {
        this._onPremisesSamAccountName = value;
    }
    ;
    /**
     * Gets the onPremisesSecurityIdentifier property value. Contains the on-premises security identifier (SID) for the user that was synchronized from on-premises to the cloud. Read-only. Returned only on $select. Supports $filter (eq) on null values only.
     * @returns a string
     */
    get onPremisesSecurityIdentifier() {
        return this._onPremisesSecurityIdentifier;
    }
    ;
    /**
     * Sets the onPremisesSecurityIdentifier property value. Contains the on-premises security identifier (SID) for the user that was synchronized from on-premises to the cloud. Read-only. Returned only on $select. Supports $filter (eq) on null values only.
     * @param value Value to set for the onPremisesSecurityIdentifier property.
     */
    set onPremisesSecurityIdentifier(value) {
        this._onPremisesSecurityIdentifier = value;
    }
    ;
    /**
     * Gets the onPremisesSyncEnabled property value. true if this object is synced from an on-premises directory; false if this object was originally synced from an on-premises directory but is no longer synced; null if this object has never been synced from an on-premises directory (default). Read-only. Returned only on $select. Supports $filter (eq, ne, not, in, and eq on null values).
     * @returns a boolean
     */
    get onPremisesSyncEnabled() {
        return this._onPremisesSyncEnabled;
    }
    ;
    /**
     * Sets the onPremisesSyncEnabled property value. true if this object is synced from an on-premises directory; false if this object was originally synced from an on-premises directory but is no longer synced; null if this object has never been synced from an on-premises directory (default). Read-only. Returned only on $select. Supports $filter (eq, ne, not, in, and eq on null values).
     * @param value Value to set for the onPremisesSyncEnabled property.
     */
    set onPremisesSyncEnabled(value) {
        this._onPremisesSyncEnabled = value;
    }
    ;
    /**
     * Gets the onPremisesUserPrincipalName property value. Contains the on-premises userPrincipalName synchronized from the on-premises directory. The property is only populated for customers who are synchronizing their on-premises directory to Azure Active Directory via Azure AD Connect. Read-only. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in, startsWith).
     * @returns a string
     */
    get onPremisesUserPrincipalName() {
        return this._onPremisesUserPrincipalName;
    }
    ;
    /**
     * Sets the onPremisesUserPrincipalName property value. Contains the on-premises userPrincipalName synchronized from the on-premises directory. The property is only populated for customers who are synchronizing their on-premises directory to Azure Active Directory via Azure AD Connect. Read-only. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in, startsWith).
     * @param value Value to set for the onPremisesUserPrincipalName property.
     */
    set onPremisesUserPrincipalName(value) {
        this._onPremisesUserPrincipalName = value;
    }
    ;
    /**
     * Gets the otherMails property value. A list of additional email addresses for the user; for example: ['bob@contoso.com', 'Robert@fabrikam.com']. NOTE: This property cannot contain accent characters. Returned only on $select. Supports $filter (eq, not, ge, le, in, startsWith).
     * @returns a string
     */
    get otherMails() {
        return this._otherMails;
    }
    ;
    /**
     * Sets the otherMails property value. A list of additional email addresses for the user; for example: ['bob@contoso.com', 'Robert@fabrikam.com']. NOTE: This property cannot contain accent characters. Returned only on $select. Supports $filter (eq, not, ge, le, in, startsWith).
     * @param value Value to set for the otherMails property.
     */
    set otherMails(value) {
        this._otherMails = value;
    }
    ;
    /**
     * Gets the outlook property value. Read-only.
     * @returns a outlookUser
     */
    get outlook() {
        return this._outlook;
    }
    ;
    /**
     * Sets the outlook property value. Read-only.
     * @param value Value to set for the outlook property.
     */
    set outlook(value) {
        this._outlook = value;
    }
    ;
    /**
     * Gets the ownedDevices property value. Devices that are owned by the user. Read-only. Nullable. Supports $expand.
     * @returns a directoryObject
     */
    get ownedDevices() {
        return this._ownedDevices;
    }
    ;
    /**
     * Sets the ownedDevices property value. Devices that are owned by the user. Read-only. Nullable. Supports $expand.
     * @param value Value to set for the ownedDevices property.
     */
    set ownedDevices(value) {
        this._ownedDevices = value;
    }
    ;
    /**
     * Gets the ownedObjects property value. Directory objects that are owned by the user. Read-only. Nullable. Supports $expand.
     * @returns a directoryObject
     */
    get ownedObjects() {
        return this._ownedObjects;
    }
    ;
    /**
     * Sets the ownedObjects property value. Directory objects that are owned by the user. Read-only. Nullable. Supports $expand.
     * @param value Value to set for the ownedObjects property.
     */
    set ownedObjects(value) {
        this._ownedObjects = value;
    }
    ;
    /**
     * Gets the passwordPolicies property value. Specifies password policies for the user. This value is an enumeration with one possible value being DisableStrongPassword, which allows weaker passwords than the default policy to be specified. DisablePasswordExpiration can also be specified. The two may be specified together; for example: DisablePasswordExpiration, DisableStrongPassword. Returned only on $select. For more information on the default password policies, see Azure AD pasword policies. Supports $filter (ne, not, and eq on null values).
     * @returns a string
     */
    get passwordPolicies() {
        return this._passwordPolicies;
    }
    ;
    /**
     * Sets the passwordPolicies property value. Specifies password policies for the user. This value is an enumeration with one possible value being DisableStrongPassword, which allows weaker passwords than the default policy to be specified. DisablePasswordExpiration can also be specified. The two may be specified together; for example: DisablePasswordExpiration, DisableStrongPassword. Returned only on $select. For more information on the default password policies, see Azure AD pasword policies. Supports $filter (ne, not, and eq on null values).
     * @param value Value to set for the passwordPolicies property.
     */
    set passwordPolicies(value) {
        this._passwordPolicies = value;
    }
    ;
    /**
     * Gets the passwordProfile property value. Specifies the password profile for the user. The profile contains the user’s password. This property is required when a user is created. The password in the profile must satisfy minimum requirements as specified by the passwordPolicies property. By default, a strong password is required. NOTE: For Azure B2C tenants, the forceChangePasswordNextSignIn property should be set to false and instead use custom policies and user flows to force password reset at first logon. See Force password reset at first logon.Returned only on $select. Supports $filter (eq, ne, not, in, and eq on null values).
     * @returns a passwordProfile
     */
    get passwordProfile() {
        return this._passwordProfile;
    }
    ;
    /**
     * Sets the passwordProfile property value. Specifies the password profile for the user. The profile contains the user’s password. This property is required when a user is created. The password in the profile must satisfy minimum requirements as specified by the passwordPolicies property. By default, a strong password is required. NOTE: For Azure B2C tenants, the forceChangePasswordNextSignIn property should be set to false and instead use custom policies and user flows to force password reset at first logon. See Force password reset at first logon.Returned only on $select. Supports $filter (eq, ne, not, in, and eq on null values).
     * @param value Value to set for the passwordProfile property.
     */
    set passwordProfile(value) {
        this._passwordProfile = value;
    }
    ;
    /**
     * Gets the pastProjects property value. A list for the user to enumerate their past projects. Returned only on $select.
     * @returns a string
     */
    get pastProjects() {
        return this._pastProjects;
    }
    ;
    /**
     * Sets the pastProjects property value. A list for the user to enumerate their past projects. Returned only on $select.
     * @param value Value to set for the pastProjects property.
     */
    set pastProjects(value) {
        this._pastProjects = value;
    }
    ;
    /**
     * Gets the people property value. People that are relevant to the user. Read-only. Nullable.
     * @returns a person
     */
    get people() {
        return this._people;
    }
    ;
    /**
     * Sets the people property value. People that are relevant to the user. Read-only. Nullable.
     * @param value Value to set for the people property.
     */
    set people(value) {
        this._people = value;
    }
    ;
    /**
     * Gets the photo property value. The user's profile photo. Read-only.
     * @returns a profilePhoto
     */
    get photo() {
        return this._photo;
    }
    ;
    /**
     * Sets the photo property value. The user's profile photo. Read-only.
     * @param value Value to set for the photo property.
     */
    set photo(value) {
        this._photo = value;
    }
    ;
    /**
     * Gets the photos property value. Read-only. Nullable.
     * @returns a profilePhoto
     */
    get photos() {
        return this._photos;
    }
    ;
    /**
     * Sets the photos property value. Read-only. Nullable.
     * @param value Value to set for the photos property.
     */
    set photos(value) {
        this._photos = value;
    }
    ;
    /**
     * Gets the planner property value. Entry-point to the Planner resource that might exist for a user. Read-only.
     * @returns a plannerUser
     */
    get planner() {
        return this._planner;
    }
    ;
    /**
     * Sets the planner property value. Entry-point to the Planner resource that might exist for a user. Read-only.
     * @param value Value to set for the planner property.
     */
    set planner(value) {
        this._planner = value;
    }
    ;
    /**
     * Gets the postalCode property value. The postal code for the user's postal address. The postal code is specific to the user's country/region. In the United States of America, this attribute contains the ZIP code. Maximum length is 40 characters. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get postalCode() {
        return this._postalCode;
    }
    ;
    /**
     * Sets the postalCode property value. The postal code for the user's postal address. The postal code is specific to the user's country/region. In the United States of America, this attribute contains the ZIP code. Maximum length is 40 characters. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the postalCode property.
     */
    set postalCode(value) {
        this._postalCode = value;
    }
    ;
    /**
     * Gets the preferredLanguage property value. The preferred language for the user. Should follow ISO 639-1 Code; for example en-US. Returned by default. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values)
     * @returns a string
     */
    get preferredLanguage() {
        return this._preferredLanguage;
    }
    ;
    /**
     * Sets the preferredLanguage property value. The preferred language for the user. Should follow ISO 639-1 Code; for example en-US. Returned by default. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values)
     * @param value Value to set for the preferredLanguage property.
     */
    set preferredLanguage(value) {
        this._preferredLanguage = value;
    }
    ;
    /**
     * Gets the preferredName property value. The preferred name for the user. Returned only on $select.
     * @returns a string
     */
    get preferredName() {
        return this._preferredName;
    }
    ;
    /**
     * Sets the preferredName property value. The preferred name for the user. Returned only on $select.
     * @param value Value to set for the preferredName property.
     */
    set preferredName(value) {
        this._preferredName = value;
    }
    ;
    /**
     * Gets the presence property value.
     * @returns a presence
     */
    get presence() {
        return this._presence;
    }
    ;
    /**
     * Sets the presence property value.
     * @param value Value to set for the presence property.
     */
    set presence(value) {
        this._presence = value;
    }
    ;
    /**
     * Gets the provisionedPlans property value. The plans that are provisioned for the user. Read-only. Not nullable. Returned only on $select. Supports $filter (eq, not, ge, le).
     * @returns a provisionedPlan
     */
    get provisionedPlans() {
        return this._provisionedPlans;
    }
    ;
    /**
     * Sets the provisionedPlans property value. The plans that are provisioned for the user. Read-only. Not nullable. Returned only on $select. Supports $filter (eq, not, ge, le).
     * @param value Value to set for the provisionedPlans property.
     */
    set provisionedPlans(value) {
        this._provisionedPlans = value;
    }
    ;
    /**
     * Gets the proxyAddresses property value. For example: ['SMTP: bob@contoso.com', 'smtp: bob@sales.contoso.com']. Changes to the mail property will also update this collection to include the value as an SMTP address. For more information, see mail and proxyAddresses properties. The proxy address prefixed with SMTP (capitalized) is the primary proxy address while those prefixed with smtp are the secondary proxy addresses. For Azure AD B2C accounts, this property has a limit of ten unique addresses. Read-only in Microsoft Graph; you can update this property only through the Microsoft 365 admin center. Not nullable. Returned only on $select. Supports $filter (eq, not, ge, le, startsWith).
     * @returns a string
     */
    get proxyAddresses() {
        return this._proxyAddresses;
    }
    ;
    /**
     * Sets the proxyAddresses property value. For example: ['SMTP: bob@contoso.com', 'smtp: bob@sales.contoso.com']. Changes to the mail property will also update this collection to include the value as an SMTP address. For more information, see mail and proxyAddresses properties. The proxy address prefixed with SMTP (capitalized) is the primary proxy address while those prefixed with smtp are the secondary proxy addresses. For Azure AD B2C accounts, this property has a limit of ten unique addresses. Read-only in Microsoft Graph; you can update this property only through the Microsoft 365 admin center. Not nullable. Returned only on $select. Supports $filter (eq, not, ge, le, startsWith).
     * @param value Value to set for the proxyAddresses property.
     */
    set proxyAddresses(value) {
        this._proxyAddresses = value;
    }
    ;
    /**
     * Gets the registeredDevices property value. Devices that are registered for the user. Read-only. Nullable. Supports $expand.
     * @returns a directoryObject
     */
    get registeredDevices() {
        return this._registeredDevices;
    }
    ;
    /**
     * Sets the registeredDevices property value. Devices that are registered for the user. Read-only. Nullable. Supports $expand.
     * @param value Value to set for the registeredDevices property.
     */
    set registeredDevices(value) {
        this._registeredDevices = value;
    }
    ;
    /**
     * Gets the responsibilities property value. A list for the user to enumerate their responsibilities. Returned only on $select.
     * @returns a string
     */
    get responsibilities() {
        return this._responsibilities;
    }
    ;
    /**
     * Sets the responsibilities property value. A list for the user to enumerate their responsibilities. Returned only on $select.
     * @param value Value to set for the responsibilities property.
     */
    set responsibilities(value) {
        this._responsibilities = value;
    }
    ;
    /**
     * Gets the schools property value. A list for the user to enumerate the schools they have attended. Returned only on $select.
     * @returns a string
     */
    get schools() {
        return this._schools;
    }
    ;
    /**
     * Sets the schools property value. A list for the user to enumerate the schools they have attended. Returned only on $select.
     * @param value Value to set for the schools property.
     */
    set schools(value) {
        this._schools = value;
    }
    ;
    /**
     * Gets the scopedRoleMemberOf property value. The scoped-role administrative unit memberships for this user. Read-only. Nullable.
     * @returns a scopedRoleMembership
     */
    get scopedRoleMemberOf() {
        return this._scopedRoleMemberOf;
    }
    ;
    /**
     * Sets the scopedRoleMemberOf property value. The scoped-role administrative unit memberships for this user. Read-only. Nullable.
     * @param value Value to set for the scopedRoleMemberOf property.
     */
    set scopedRoleMemberOf(value) {
        this._scopedRoleMemberOf = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("aboutMe", this.aboutMe);
        writer.writeBooleanValue("accountEnabled", this.accountEnabled);
        writer.writeCollectionOfObjectValues("activities", this.activities);
        writer.writeStringValue("ageGroup", this.ageGroup);
        writer.writeCollectionOfObjectValues("agreementAcceptances", this.agreementAcceptances);
        writer.writeCollectionOfObjectValues("appRoleAssignments", this.appRoleAssignments);
        writer.writeCollectionOfObjectValues("assignedLicenses", this.assignedLicenses);
        writer.writeCollectionOfObjectValues("assignedPlans", this.assignedPlans);
        writer.writeObjectValue("authentication", this.authentication);
        writer.writeDateValue("birthday", this.birthday);
        writer.writeCollectionOfPrimitiveValues("businessPhones", this.businessPhones);
        writer.writeObjectValue("calendar", this.calendar);
        writer.writeCollectionOfObjectValues("calendarGroups", this.calendarGroups);
        writer.writeCollectionOfObjectValues("calendars", this.calendars);
        writer.writeCollectionOfObjectValues("calendarView", this.calendarView);
        writer.writeCollectionOfObjectValues("chats", this.chats);
        writer.writeStringValue("city", this.city);
        writer.writeStringValue("companyName", this.companyName);
        writer.writeStringValue("consentProvidedForMinor", this.consentProvidedForMinor);
        writer.writeCollectionOfObjectValues("contactFolders", this.contactFolders);
        writer.writeCollectionOfObjectValues("contacts", this.contacts);
        writer.writeStringValue("country", this.country);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeCollectionOfObjectValues("createdObjects", this.createdObjects);
        writer.writeStringValue("creationType", this.creationType);
        writer.writeStringValue("department", this.department);
        writer.writeNumberValue("deviceEnrollmentLimit", this.deviceEnrollmentLimit);
        writer.writeCollectionOfObjectValues("deviceManagementTroubleshootingEvents", this.deviceManagementTroubleshootingEvents);
        writer.writeCollectionOfObjectValues("directReports", this.directReports);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeObjectValue("drive", this.drive);
        writer.writeCollectionOfObjectValues("drives", this.drives);
        writer.writeDateValue("employeeHireDate", this.employeeHireDate);
        writer.writeStringValue("employeeId", this.employeeId);
        writer.writeObjectValue("employeeOrgData", this.employeeOrgData);
        writer.writeStringValue("employeeType", this.employeeType);
        writer.writeCollectionOfObjectValues("events", this.events);
        writer.writeCollectionOfObjectValues("extensions", this.extensions);
        writer.writeStringValue("externalUserState", this.externalUserState);
        writer.writeDateValue("externalUserStateChangeDateTime", this.externalUserStateChangeDateTime);
        writer.writeStringValue("faxNumber", this.faxNumber);
        writer.writeCollectionOfObjectValues("followedSites", this.followedSites);
        writer.writeStringValue("givenName", this.givenName);
        writer.writeDateValue("hireDate", this.hireDate);
        writer.writeCollectionOfObjectValues("identities", this.identities);
        writer.writeCollectionOfPrimitiveValues("imAddresses", this.imAddresses);
        writer.writeObjectValue("inferenceClassification", this.inferenceClassification);
        writer.writeObjectValue("insights", this.insights);
        writer.writeCollectionOfPrimitiveValues("interests", this.interests);
        writer.writeBooleanValue("isResourceAccount", this.isResourceAccount);
        writer.writeStringValue("jobTitle", this.jobTitle);
        writer.writeCollectionOfObjectValues("joinedTeams", this.joinedTeams);
        writer.writeDateValue("lastPasswordChangeDateTime", this.lastPasswordChangeDateTime);
        writer.writeStringValue("legalAgeGroupClassification", this.legalAgeGroupClassification);
        writer.writeCollectionOfObjectValues("licenseAssignmentStates", this.licenseAssignmentStates);
        writer.writeCollectionOfObjectValues("licenseDetails", this.licenseDetails);
        writer.writeStringValue("mail", this.mail);
        writer.writeObjectValue("mailboxSettings", this.mailboxSettings);
        writer.writeCollectionOfObjectValues("mailFolders", this.mailFolders);
        writer.writeStringValue("mailNickname", this.mailNickname);
        writer.writeCollectionOfObjectValues("managedAppRegistrations", this.managedAppRegistrations);
        writer.writeCollectionOfObjectValues("managedDevices", this.managedDevices);
        writer.writeObjectValue("manager", this.manager);
        writer.writeCollectionOfObjectValues("memberOf", this.memberOf);
        writer.writeCollectionOfObjectValues("messages", this.messages);
        writer.writeStringValue("mobilePhone", this.mobilePhone);
        writer.writeStringValue("mySite", this.mySite);
        writer.writeCollectionOfObjectValues("oauth2PermissionGrants", this.oauth2PermissionGrants);
        writer.writeStringValue("officeLocation", this.officeLocation);
        writer.writeObjectValue("onenote", this.onenote);
        writer.writeCollectionOfObjectValues("onlineMeetings", this.onlineMeetings);
        writer.writeStringValue("onPremisesDistinguishedName", this.onPremisesDistinguishedName);
        writer.writeStringValue("onPremisesDomainName", this.onPremisesDomainName);
        writer.writeObjectValue("onPremisesExtensionAttributes", this.onPremisesExtensionAttributes);
        writer.writeStringValue("onPremisesImmutableId", this.onPremisesImmutableId);
        writer.writeDateValue("onPremisesLastSyncDateTime", this.onPremisesLastSyncDateTime);
        writer.writeCollectionOfObjectValues("onPremisesProvisioningErrors", this.onPremisesProvisioningErrors);
        writer.writeStringValue("onPremisesSamAccountName", this.onPremisesSamAccountName);
        writer.writeStringValue("onPremisesSecurityIdentifier", this.onPremisesSecurityIdentifier);
        writer.writeBooleanValue("onPremisesSyncEnabled", this.onPremisesSyncEnabled);
        writer.writeStringValue("onPremisesUserPrincipalName", this.onPremisesUserPrincipalName);
        writer.writeCollectionOfPrimitiveValues("otherMails", this.otherMails);
        writer.writeObjectValue("outlook", this.outlook);
        writer.writeCollectionOfObjectValues("ownedDevices", this.ownedDevices);
        writer.writeCollectionOfObjectValues("ownedObjects", this.ownedObjects);
        writer.writeStringValue("passwordPolicies", this.passwordPolicies);
        writer.writeObjectValue("passwordProfile", this.passwordProfile);
        writer.writeCollectionOfPrimitiveValues("pastProjects", this.pastProjects);
        writer.writeCollectionOfObjectValues("people", this.people);
        writer.writeObjectValue("photo", this.photo);
        writer.writeCollectionOfObjectValues("photos", this.photos);
        writer.writeObjectValue("planner", this.planner);
        writer.writeStringValue("postalCode", this.postalCode);
        writer.writeStringValue("preferredLanguage", this.preferredLanguage);
        writer.writeStringValue("preferredName", this.preferredName);
        writer.writeObjectValue("presence", this.presence);
        writer.writeCollectionOfObjectValues("provisionedPlans", this.provisionedPlans);
        writer.writeCollectionOfPrimitiveValues("proxyAddresses", this.proxyAddresses);
        writer.writeCollectionOfObjectValues("registeredDevices", this.registeredDevices);
        writer.writeCollectionOfPrimitiveValues("responsibilities", this.responsibilities);
        writer.writeCollectionOfPrimitiveValues("schools", this.schools);
        writer.writeCollectionOfObjectValues("scopedRoleMemberOf", this.scopedRoleMemberOf);
        writer.writeObjectValue("settings", this.settings);
        writer.writeBooleanValue("showInAddressList", this.showInAddressList);
        writer.writeDateValue("signInSessionsValidFromDateTime", this.signInSessionsValidFromDateTime);
        writer.writeCollectionOfPrimitiveValues("skills", this.skills);
        writer.writeStringValue("state", this.state);
        writer.writeStringValue("streetAddress", this.streetAddress);
        writer.writeStringValue("surname", this.surname);
        writer.writeObjectValue("teamwork", this.teamwork);
        writer.writeObjectValue("todo", this.todo);
        writer.writeCollectionOfObjectValues("transitiveMemberOf", this.transitiveMemberOf);
        writer.writeStringValue("usageLocation", this.usageLocation);
        writer.writeStringValue("userPrincipalName", this.userPrincipalName);
        writer.writeStringValue("userType", this.userType);
    }
    ;
    /**
     * Gets the settings property value. Read-only. Nullable.
     * @returns a userSettings
     */
    get settings() {
        return this._settings;
    }
    ;
    /**
     * Sets the settings property value. Read-only. Nullable.
     * @param value Value to set for the settings property.
     */
    set settings(value) {
        this._settings = value;
    }
    ;
    /**
     * Gets the showInAddressList property value. true if the Outlook global address list should contain this user, otherwise false. If not set, this will be treated as true. For users invited through the invitation manager, this property will be set to false. Returned only on $select. Supports $filter (eq, ne, not, in).
     * @returns a boolean
     */
    get showInAddressList() {
        return this._showInAddressList;
    }
    ;
    /**
     * Sets the showInAddressList property value. true if the Outlook global address list should contain this user, otherwise false. If not set, this will be treated as true. For users invited through the invitation manager, this property will be set to false. Returned only on $select. Supports $filter (eq, ne, not, in).
     * @param value Value to set for the showInAddressList property.
     */
    set showInAddressList(value) {
        this._showInAddressList = value;
    }
    ;
    /**
     * Gets the signInSessionsValidFromDateTime property value. Any refresh tokens or sessions tokens (session cookies) issued before this time are invalid, and applications will get an error when using an invalid refresh or sessions token to acquire a delegated access token (to access APIs such as Microsoft Graph).  If this happens, the application will need to acquire a new refresh token by making a request to the authorize endpoint. Read-only. Use revokeSignInSessions to reset. Returned only on $select.
     * @returns a Date
     */
    get signInSessionsValidFromDateTime() {
        return this._signInSessionsValidFromDateTime;
    }
    ;
    /**
     * Sets the signInSessionsValidFromDateTime property value. Any refresh tokens or sessions tokens (session cookies) issued before this time are invalid, and applications will get an error when using an invalid refresh or sessions token to acquire a delegated access token (to access APIs such as Microsoft Graph).  If this happens, the application will need to acquire a new refresh token by making a request to the authorize endpoint. Read-only. Use revokeSignInSessions to reset. Returned only on $select.
     * @param value Value to set for the signInSessionsValidFromDateTime property.
     */
    set signInSessionsValidFromDateTime(value) {
        this._signInSessionsValidFromDateTime = value;
    }
    ;
    /**
     * Gets the skills property value. A list for the user to enumerate their skills. Returned only on $select.
     * @returns a string
     */
    get skills() {
        return this._skills;
    }
    ;
    /**
     * Sets the skills property value. A list for the user to enumerate their skills. Returned only on $select.
     * @param value Value to set for the skills property.
     */
    set skills(value) {
        this._skills = value;
    }
    ;
    /**
     * Gets the state property value. The state or province in the user's address. Maximum length is 128 characters. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get state() {
        return this._state;
    }
    ;
    /**
     * Sets the state property value. The state or province in the user's address. Maximum length is 128 characters. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the state property.
     */
    set state(value) {
        this._state = value;
    }
    ;
    /**
     * Gets the streetAddress property value. The street address of the user's place of business. Maximum length is 1024 characters. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get streetAddress() {
        return this._streetAddress;
    }
    ;
    /**
     * Sets the streetAddress property value. The street address of the user's place of business. Maximum length is 1024 characters. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the streetAddress property.
     */
    set streetAddress(value) {
        this._streetAddress = value;
    }
    ;
    /**
     * Gets the surname property value. The user's surname (family name or last name). Maximum length is 64 characters. Returned by default. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get surname() {
        return this._surname;
    }
    ;
    /**
     * Sets the surname property value. The user's surname (family name or last name). Maximum length is 64 characters. Returned by default. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the surname property.
     */
    set surname(value) {
        this._surname = value;
    }
    ;
    /**
     * Gets the teamwork property value. A container for Microsoft Teams features available for the user. Read-only. Nullable.
     * @returns a userTeamwork
     */
    get teamwork() {
        return this._teamwork;
    }
    ;
    /**
     * Sets the teamwork property value. A container for Microsoft Teams features available for the user. Read-only. Nullable.
     * @param value Value to set for the teamwork property.
     */
    set teamwork(value) {
        this._teamwork = value;
    }
    ;
    /**
     * Gets the todo property value. Represents the To Do services available to a user.
     * @returns a todo
     */
    get todo() {
        return this._todo;
    }
    ;
    /**
     * Sets the todo property value. Represents the To Do services available to a user.
     * @param value Value to set for the todo property.
     */
    set todo(value) {
        this._todo = value;
    }
    ;
    /**
     * Gets the transitiveMemberOf property value.
     * @returns a directoryObject
     */
    get transitiveMemberOf() {
        return this._transitiveMemberOf;
    }
    ;
    /**
     * Sets the transitiveMemberOf property value.
     * @param value Value to set for the transitiveMemberOf property.
     */
    set transitiveMemberOf(value) {
        this._transitiveMemberOf = value;
    }
    ;
    /**
     * Gets the usageLocation property value. A two letter country code (ISO standard 3166). Required for users that will be assigned licenses due to legal requirement to check for availability of services in countries.  Examples include: US, JP, and GB. Not nullable. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @returns a string
     */
    get usageLocation() {
        return this._usageLocation;
    }
    ;
    /**
     * Sets the usageLocation property value. A two letter country code (ISO standard 3166). Required for users that will be assigned licenses due to legal requirement to check for availability of services in countries.  Examples include: US, JP, and GB. Not nullable. Returned only on $select. Supports $filter (eq, ne, not, ge, le, in, startsWith, and eq on null values).
     * @param value Value to set for the usageLocation property.
     */
    set usageLocation(value) {
        this._usageLocation = value;
    }
    ;
    /**
     * Gets the userPrincipalName property value. The user principal name (UPN) of the user. The UPN is an Internet-style login name for the user based on the Internet standard RFC 822. By convention, this should map to the user's email name. The general format is alias@domain, where domain must be present in the tenant's collection of verified domains. This property is required when a user is created. The verified domains for the tenant can be accessed from the verifiedDomains property of organization.NOTE: This property cannot contain accent characters. Only the following characters are allowed A - Z, a - z, 0 - 9, ' . - _ ! # ^ ~. For the complete list of allowed characters, see username policies. Returned by default. Supports $filter (eq, ne, not, ge, le, in, startsWith, endsWith) and $orderBy.
     * @returns a string
     */
    get userPrincipalName() {
        return this._userPrincipalName;
    }
    ;
    /**
     * Sets the userPrincipalName property value. The user principal name (UPN) of the user. The UPN is an Internet-style login name for the user based on the Internet standard RFC 822. By convention, this should map to the user's email name. The general format is alias@domain, where domain must be present in the tenant's collection of verified domains. This property is required when a user is created. The verified domains for the tenant can be accessed from the verifiedDomains property of organization.NOTE: This property cannot contain accent characters. Only the following characters are allowed A - Z, a - z, 0 - 9, ' . - _ ! # ^ ~. For the complete list of allowed characters, see username policies. Returned by default. Supports $filter (eq, ne, not, ge, le, in, startsWith, endsWith) and $orderBy.
     * @param value Value to set for the userPrincipalName property.
     */
    set userPrincipalName(value) {
        this._userPrincipalName = value;
    }
    ;
    /**
     * Gets the userType property value. A string value that can be used to classify user types in your directory, such as Member and Guest. Returned only on $select. Supports $filter (eq, ne, not, in, and eq on null values). NOTE: For more information about the permissions for member and guest users, see What are the default user permissions in Azure Active Directory?
     * @returns a string
     */
    get userType() {
        return this._userType;
    }
    ;
    /**
     * Sets the userType property value. A string value that can be used to classify user types in your directory, such as Member and Guest. Returned only on $select. Supports $filter (eq, ne, not, in, and eq on null values). NOTE: For more information about the permissions for member and guest users, see What are the default user permissions in Azure Active Directory?
     * @param value Value to set for the userType property.
     */
    set userType(value) {
        this._userType = value;
    }
    ;
}
exports.User = User;
