"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserActivity = void 0;
const createActivityHistoryItemFromDiscriminatorValue_1 = require("./createActivityHistoryItemFromDiscriminatorValue");
const createJsonFromDiscriminatorValue_1 = require("./createJsonFromDiscriminatorValue");
const createVisualInfoFromDiscriminatorValue_1 = require("./createVisualInfoFromDiscriminatorValue");
const index_1 = require("./index");
const status_1 = require("./status");
class UserActivity extends index_1.Entity {
    /**
     * Instantiates a new userActivity and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the activationUrl property value. Required. URL used to launch the activity in the best native experience represented by the appId. Might launch a web-based app if no native app exists.
     * @returns a string
     */
    get activationUrl() {
        return this._activationUrl;
    }
    ;
    /**
     * Sets the activationUrl property value. Required. URL used to launch the activity in the best native experience represented by the appId. Might launch a web-based app if no native app exists.
     * @param value Value to set for the activationUrl property.
     */
    set activationUrl(value) {
        this._activationUrl = value;
    }
    ;
    /**
     * Gets the activitySourceHost property value. Required. URL for the domain representing the cross-platform identity mapping for the app. Mapping is stored either as a JSON file hosted on the domain or configurable via Windows Dev Center. The JSON file is named cross-platform-app-identifiers and is hosted at root of your HTTPS domain, either at the top level domain or include a sub domain. For example: https://contoso.com or https://myapp.contoso.com but NOT https://myapp.contoso.com/somepath. You must have a unique file and domain (or sub domain) per cross-platform app identity. For example, a separate file and domain is needed for Word vs. PowerPoint.
     * @returns a string
     */
    get activitySourceHost() {
        return this._activitySourceHost;
    }
    ;
    /**
     * Sets the activitySourceHost property value. Required. URL for the domain representing the cross-platform identity mapping for the app. Mapping is stored either as a JSON file hosted on the domain or configurable via Windows Dev Center. The JSON file is named cross-platform-app-identifiers and is hosted at root of your HTTPS domain, either at the top level domain or include a sub domain. For example: https://contoso.com or https://myapp.contoso.com but NOT https://myapp.contoso.com/somepath. You must have a unique file and domain (or sub domain) per cross-platform app identity. For example, a separate file and domain is needed for Word vs. PowerPoint.
     * @param value Value to set for the activitySourceHost property.
     */
    set activitySourceHost(value) {
        this._activitySourceHost = value;
    }
    ;
    /**
     * Gets the appActivityId property value. Required. The unique activity ID in the context of the app - supplied by caller and immutable thereafter.
     * @returns a string
     */
    get appActivityId() {
        return this._appActivityId;
    }
    ;
    /**
     * Sets the appActivityId property value. Required. The unique activity ID in the context of the app - supplied by caller and immutable thereafter.
     * @param value Value to set for the appActivityId property.
     */
    set appActivityId(value) {
        this._appActivityId = value;
    }
    ;
    /**
     * Gets the appDisplayName property value. Optional. Short text description of the app used to generate the activity for use in cases when the app is not installed on the user’s local device.
     * @returns a string
     */
    get appDisplayName() {
        return this._appDisplayName;
    }
    ;
    /**
     * Sets the appDisplayName property value. Optional. Short text description of the app used to generate the activity for use in cases when the app is not installed on the user’s local device.
     * @param value Value to set for the appDisplayName property.
     */
    set appDisplayName(value) {
        this._appDisplayName = value;
    }
    ;
    ;
    /**
     * Gets the contentInfo property value. Optional. A custom piece of data - JSON-LD extensible description of content according to schema.org syntax.
     * @returns a Json
     */
    get contentInfo() {
        return this._contentInfo;
    }
    ;
    /**
     * Sets the contentInfo property value. Optional. A custom piece of data - JSON-LD extensible description of content according to schema.org syntax.
     * @param value Value to set for the contentInfo property.
     */
    set contentInfo(value) {
        this._contentInfo = value;
    }
    ;
    /**
     * Gets the contentUrl property value. Optional. Used in the event the content can be rendered outside of a native or web-based app experience (for example, a pointer to an item in an RSS feed).
     * @returns a string
     */
    get contentUrl() {
        return this._contentUrl;
    }
    ;
    /**
     * Sets the contentUrl property value. Optional. Used in the event the content can be rendered outside of a native or web-based app experience (for example, a pointer to an item in an RSS feed).
     * @param value Value to set for the contentUrl property.
     */
    set contentUrl(value) {
        this._contentUrl = value;
    }
    ;
    /**
     * Gets the createdDateTime property value. Set by the server. DateTime in UTC when the object was created on the server.
     * @returns a Date
     */
    get createdDateTime() {
        return this._createdDateTime;
    }
    ;
    /**
     * Sets the createdDateTime property value. Set by the server. DateTime in UTC when the object was created on the server.
     * @param value Value to set for the createdDateTime property.
     */
    set createdDateTime(value) {
        this._createdDateTime = value;
    }
    ;
    /**
     * Gets the expirationDateTime property value. Set by the server. DateTime in UTC when the object expired on the server.
     * @returns a Date
     */
    get expirationDateTime() {
        return this._expirationDateTime;
    }
    ;
    /**
     * Sets the expirationDateTime property value. Set by the server. DateTime in UTC when the object expired on the server.
     * @param value Value to set for the expirationDateTime property.
     */
    set expirationDateTime(value) {
        this._expirationDateTime = value;
    }
    ;
    /**
     * Gets the fallbackUrl property value. Optional. URL used to launch the activity in a web-based app, if available.
     * @returns a string
     */
    get fallbackUrl() {
        return this._fallbackUrl;
    }
    ;
    /**
     * Sets the fallbackUrl property value. Optional. URL used to launch the activity in a web-based app, if available.
     * @param value Value to set for the fallbackUrl property.
     */
    set fallbackUrl(value) {
        this._fallbackUrl = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "activationUrl": (o, n) => { o.activationUrl = n.getStringValue(); }, "activitySourceHost": (o, n) => { o.activitySourceHost = n.getStringValue(); }, "appActivityId": (o, n) => { o.appActivityId = n.getStringValue(); }, "appDisplayName": (o, n) => { o.appDisplayName = n.getStringValue(); }, "contentInfo": (o, n) => { o.contentInfo = n.getObjectValue(createJsonFromDiscriminatorValue_1.createJsonFromDiscriminatorValue); }, "contentUrl": (o, n) => { o.contentUrl = n.getStringValue(); }, "createdDateTime": (o, n) => { o.createdDateTime = n.getDateValue(); }, "expirationDateTime": (o, n) => { o.expirationDateTime = n.getDateValue(); }, "fallbackUrl": (o, n) => { o.fallbackUrl = n.getStringValue(); }, "historyItems": (o, n) => { o.historyItems = n.getCollectionOfObjectValues(createActivityHistoryItemFromDiscriminatorValue_1.createActivityHistoryItemFromDiscriminatorValue); }, "lastModifiedDateTime": (o, n) => { o.lastModifiedDateTime = n.getDateValue(); }, "status": (o, n) => { o.status = n.getEnumValue(status_1.Status); }, "userTimezone": (o, n) => { o.userTimezone = n.getStringValue(); }, "visualElements": (o, n) => { o.visualElements = n.getObjectValue(createVisualInfoFromDiscriminatorValue_1.createVisualInfoFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the historyItems property value. Optional. NavigationProperty/Containment; navigation property to the activity's historyItems.
     * @returns a activityHistoryItem
     */
    get historyItems() {
        return this._historyItems;
    }
    ;
    /**
     * Sets the historyItems property value. Optional. NavigationProperty/Containment; navigation property to the activity's historyItems.
     * @param value Value to set for the historyItems property.
     */
    set historyItems(value) {
        this._historyItems = value;
    }
    ;
    /**
     * Gets the lastModifiedDateTime property value. Set by the server. DateTime in UTC when the object was modified on the server.
     * @returns a Date
     */
    get lastModifiedDateTime() {
        return this._lastModifiedDateTime;
    }
    ;
    /**
     * Sets the lastModifiedDateTime property value. Set by the server. DateTime in UTC when the object was modified on the server.
     * @param value Value to set for the lastModifiedDateTime property.
     */
    set lastModifiedDateTime(value) {
        this._lastModifiedDateTime = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("activationUrl", this.activationUrl);
        writer.writeStringValue("activitySourceHost", this.activitySourceHost);
        writer.writeStringValue("appActivityId", this.appActivityId);
        writer.writeStringValue("appDisplayName", this.appDisplayName);
        writer.writeObjectValue("contentInfo", this.contentInfo);
        writer.writeStringValue("contentUrl", this.contentUrl);
        writer.writeDateValue("createdDateTime", this.createdDateTime);
        writer.writeDateValue("expirationDateTime", this.expirationDateTime);
        writer.writeStringValue("fallbackUrl", this.fallbackUrl);
        writer.writeCollectionOfObjectValues("historyItems", this.historyItems);
        writer.writeDateValue("lastModifiedDateTime", this.lastModifiedDateTime);
        writer.writeEnumValue("status", this.status);
        writer.writeStringValue("userTimezone", this.userTimezone);
        writer.writeObjectValue("visualElements", this.visualElements);
    }
    ;
    /**
     * Gets the status property value. Set by the server. A status code used to identify valid objects. Values: active, updated, deleted, ignored.
     * @returns a status
     */
    get status() {
        return this._status;
    }
    ;
    /**
     * Sets the status property value. Set by the server. A status code used to identify valid objects. Values: active, updated, deleted, ignored.
     * @param value Value to set for the status property.
     */
    set status(value) {
        this._status = value;
    }
    ;
    /**
     * Gets the userTimezone property value. Optional. The timezone in which the user's device used to generate the activity was located at activity creation time; values supplied as Olson IDs in order to support cross-platform representation.
     * @returns a string
     */
    get userTimezone() {
        return this._userTimezone;
    }
    ;
    /**
     * Sets the userTimezone property value. Optional. The timezone in which the user's device used to generate the activity was located at activity creation time; values supplied as Olson IDs in order to support cross-platform representation.
     * @param value Value to set for the userTimezone property.
     */
    set userTimezone(value) {
        this._userTimezone = value;
    }
    ;
    /**
     * Gets the visualElements property value.
     * @returns a visualInfo
     */
    get visualElements() {
        return this._visualElements;
    }
    ;
    /**
     * Sets the visualElements property value.
     * @param value Value to set for the visualElements property.
     */
    set visualElements(value) {
        this._visualElements = value;
    }
    ;
}
exports.UserActivity = UserActivity;
