"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserAttributeValuesItem = void 0;
class UserAttributeValuesItem {
    /**
     * Instantiates a new userAttributeValuesItem and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "isDefault": (o, n) => { o.isDefault = n.getBooleanValue(); },
            "name": (o, n) => { o.name = n.getStringValue(); },
            "value": (o, n) => { o.value = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the isDefault property value. Determines whether the value is set as the default.
     * @returns a boolean
     */
    get isDefault() {
        return this._isDefault;
    }
    ;
    /**
     * Sets the isDefault property value. Determines whether the value is set as the default.
     * @param value Value to set for the isDefault property.
     */
    set isDefault(value) {
        this._isDefault = value;
    }
    ;
    /**
     * Gets the name property value. The display name of the property displayed to the user in the user flow.
     * @returns a string
     */
    get name() {
        return this._name;
    }
    ;
    /**
     * Sets the name property value. The display name of the property displayed to the user in the user flow.
     * @param value Value to set for the name property.
     */
    set name(value) {
        this._name = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeBooleanValue("isDefault", this.isDefault);
        writer.writeStringValue("name", this.name);
        writer.writeStringValue("value", this.value);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the value property value. The value that is set when this item is selected.
     * @returns a string
     */
    get value() {
        return this._value;
    }
    ;
    /**
     * Sets the value property value. The value that is set when this item is selected.
     * @param value Value to set for the value property.
     */
    set value(value) {
        this._value = value;
    }
    ;
}
exports.UserAttributeValuesItem = UserAttributeValuesItem;
