"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserConsentRequest = void 0;
const createApprovalFromDiscriminatorValue_1 = require("./createApprovalFromDiscriminatorValue");
const index_1 = require("./index");
class UserConsentRequest extends index_1.Request {
    /**
     * Instantiates a new userConsentRequest and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the approval property value. Approval decisions associated with a request.
     * @returns a approval
     */
    get approval() {
        return this._approval;
    }
    ;
    /**
     * Sets the approval property value. Approval decisions associated with a request.
     * @param value Value to set for the approval property.
     */
    set approval(value) {
        this._approval = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "approval": (o, n) => { o.approval = n.getObjectValue(createApprovalFromDiscriminatorValue_1.createApprovalFromDiscriminatorValue); }, "reason": (o, n) => { o.reason = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the reason property value. The user's justification for requiring access to the app. Supports $filter (eq only) and $orderby.
     * @returns a string
     */
    get reason() {
        return this._reason;
    }
    ;
    /**
     * Sets the reason property value. The user's justification for requiring access to the app. Supports $filter (eq only) and $orderby.
     * @param value Value to set for the reason property.
     */
    set reason(value) {
        this._reason = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("approval", this.approval);
        writer.writeStringValue("reason", this.reason);
    }
    ;
}
exports.UserConsentRequest = UserConsentRequest;
