"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserFlowLanguageConfiguration = void 0;
const createUserFlowLanguagePageFromDiscriminatorValue_1 = require("./createUserFlowLanguagePageFromDiscriminatorValue");
const index_1 = require("./index");
class UserFlowLanguageConfiguration extends index_1.Entity {
    /**
     * Instantiates a new userFlowLanguageConfiguration and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the defaultPages property value. Collection of pages with the default content to display in a user flow for a specified language. This collection does not allow any kind of modification.
     * @returns a userFlowLanguagePage
     */
    get defaultPages() {
        return this._defaultPages;
    }
    ;
    /**
     * Sets the defaultPages property value. Collection of pages with the default content to display in a user flow for a specified language. This collection does not allow any kind of modification.
     * @param value Value to set for the defaultPages property.
     */
    set defaultPages(value) {
        this._defaultPages = value;
    }
    ;
    /**
     * Gets the displayName property value. The language name to display. This property is read-only.
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. The language name to display. This property is read-only.
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "defaultPages": (o, n) => { o.defaultPages = n.getCollectionOfObjectValues(createUserFlowLanguagePageFromDiscriminatorValue_1.createUserFlowLanguagePageFromDiscriminatorValue); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "isEnabled": (o, n) => { o.isEnabled = n.getBooleanValue(); }, "overridesPages": (o, n) => { o.overridesPages = n.getCollectionOfObjectValues(createUserFlowLanguagePageFromDiscriminatorValue_1.createUserFlowLanguagePageFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the isEnabled property value. Indicates whether the language is enabled within the user flow.
     * @returns a boolean
     */
    get isEnabled() {
        return this._isEnabled;
    }
    ;
    /**
     * Sets the isEnabled property value. Indicates whether the language is enabled within the user flow.
     * @param value Value to set for the isEnabled property.
     */
    set isEnabled(value) {
        this._isEnabled = value;
    }
    ;
    /**
     * Gets the overridesPages property value. Collection of pages with the overrides messages to display in a user flow for a specified language. This collection only allows to modify the content of the page, any other modification is not allowed (creation or deletion of pages).
     * @returns a userFlowLanguagePage
     */
    get overridesPages() {
        return this._overridesPages;
    }
    ;
    /**
     * Sets the overridesPages property value. Collection of pages with the overrides messages to display in a user flow for a specified language. This collection only allows to modify the content of the page, any other modification is not allowed (creation or deletion of pages).
     * @param value Value to set for the overridesPages property.
     */
    set overridesPages(value) {
        this._overridesPages = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("defaultPages", this.defaultPages);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeBooleanValue("isEnabled", this.isEnabled);
        writer.writeCollectionOfObjectValues("overridesPages", this.overridesPages);
    }
    ;
}
exports.UserFlowLanguageConfiguration = UserFlowLanguageConfiguration;
