import { Chat, TeamsAppInstallation } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class UserScopeTeamsAppInstallation extends TeamsAppInstallation implements Parsable {
    /** The chat between the user and Teams app.  */
    private _chat?;
    /**
     * Gets the chat property value. The chat between the user and Teams app.
     * @returns a chat
     */
    get chat(): Chat | undefined;
    /**
     * Sets the chat property value. The chat between the user and Teams app.
     * @param value Value to set for the chat property.
     */
    set chat(value: Chat | undefined);
    /**
     * Instantiates a new userScopeTeamsAppInstallation and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
