import { Entity, ShiftPreferences } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class UserSettings extends Entity implements Parsable {
    /** Reflects the Office Delve organization level setting. When set to true, the organization doesn't have access to Office Delve. This setting is read-only and can only be changed by administrators in the SharePoint admin center.  */
    private _contributionToContentDiscoveryAsOrganizationDisabled?;
    /** When set to true, documents in the user's Office Delve are disabled. Users can control this setting in Office Delve.  */
    private _contributionToContentDiscoveryDisabled?;
    /** The shift preferences for the user.  */
    private _shiftPreferences?;
    /**
     * Instantiates a new userSettings and sets the default values.
     */
    constructor();
    /**
     * Gets the contributionToContentDiscoveryAsOrganizationDisabled property value. Reflects the Office Delve organization level setting. When set to true, the organization doesn't have access to Office Delve. This setting is read-only and can only be changed by administrators in the SharePoint admin center.
     * @returns a boolean
     */
    get contributionToContentDiscoveryAsOrganizationDisabled(): boolean | undefined;
    /**
     * Sets the contributionToContentDiscoveryAsOrganizationDisabled property value. Reflects the Office Delve organization level setting. When set to true, the organization doesn't have access to Office Delve. This setting is read-only and can only be changed by administrators in the SharePoint admin center.
     * @param value Value to set for the contributionToContentDiscoveryAsOrganizationDisabled property.
     */
    set contributionToContentDiscoveryAsOrganizationDisabled(value: boolean | undefined);
    /**
     * Gets the contributionToContentDiscoveryDisabled property value. When set to true, documents in the user's Office Delve are disabled. Users can control this setting in Office Delve.
     * @returns a boolean
     */
    get contributionToContentDiscoveryDisabled(): boolean | undefined;
    /**
     * Sets the contributionToContentDiscoveryDisabled property value. When set to true, documents in the user's Office Delve are disabled. Users can control this setting in Office Delve.
     * @param value Value to set for the contributionToContentDiscoveryDisabled property.
     */
    set contributionToContentDiscoveryDisabled(value: boolean | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the shiftPreferences property value. The shift preferences for the user.
     * @returns a shiftPreferences
     */
    get shiftPreferences(): ShiftPreferences | undefined;
    /**
     * Sets the shiftPreferences property value. The shift preferences for the user.
     * @param value Value to set for the shiftPreferences property.
     */
    set shiftPreferences(value: ShiftPreferences | undefined);
}
