"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserSettings = void 0;
const createShiftPreferencesFromDiscriminatorValue_1 = require("./createShiftPreferencesFromDiscriminatorValue");
const index_1 = require("./index");
class UserSettings extends index_1.Entity {
    /**
     * Instantiates a new userSettings and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the contributionToContentDiscoveryAsOrganizationDisabled property value. Reflects the Office Delve organization level setting. When set to true, the organization doesn't have access to Office Delve. This setting is read-only and can only be changed by administrators in the SharePoint admin center.
     * @returns a boolean
     */
    get contributionToContentDiscoveryAsOrganizationDisabled() {
        return this._contributionToContentDiscoveryAsOrganizationDisabled;
    }
    ;
    /**
     * Sets the contributionToContentDiscoveryAsOrganizationDisabled property value. Reflects the Office Delve organization level setting. When set to true, the organization doesn't have access to Office Delve. This setting is read-only and can only be changed by administrators in the SharePoint admin center.
     * @param value Value to set for the contributionToContentDiscoveryAsOrganizationDisabled property.
     */
    set contributionToContentDiscoveryAsOrganizationDisabled(value) {
        this._contributionToContentDiscoveryAsOrganizationDisabled = value;
    }
    ;
    /**
     * Gets the contributionToContentDiscoveryDisabled property value. When set to true, documents in the user's Office Delve are disabled. Users can control this setting in Office Delve.
     * @returns a boolean
     */
    get contributionToContentDiscoveryDisabled() {
        return this._contributionToContentDiscoveryDisabled;
    }
    ;
    /**
     * Sets the contributionToContentDiscoveryDisabled property value. When set to true, documents in the user's Office Delve are disabled. Users can control this setting in Office Delve.
     * @param value Value to set for the contributionToContentDiscoveryDisabled property.
     */
    set contributionToContentDiscoveryDisabled(value) {
        this._contributionToContentDiscoveryDisabled = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "contributionToContentDiscoveryAsOrganizationDisabled": (o, n) => { o.contributionToContentDiscoveryAsOrganizationDisabled = n.getBooleanValue(); }, "contributionToContentDiscoveryDisabled": (o, n) => { o.contributionToContentDiscoveryDisabled = n.getBooleanValue(); }, "shiftPreferences": (o, n) => { o.shiftPreferences = n.getObjectValue(createShiftPreferencesFromDiscriminatorValue_1.createShiftPreferencesFromDiscriminatorValue); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeBooleanValue("contributionToContentDiscoveryAsOrganizationDisabled", this.contributionToContentDiscoveryAsOrganizationDisabled);
        writer.writeBooleanValue("contributionToContentDiscoveryDisabled", this.contributionToContentDiscoveryDisabled);
        writer.writeObjectValue("shiftPreferences", this.shiftPreferences);
    }
    ;
    /**
     * Gets the shiftPreferences property value. The shift preferences for the user.
     * @returns a shiftPreferences
     */
    get shiftPreferences() {
        return this._shiftPreferences;
    }
    ;
    /**
     * Sets the shiftPreferences property value. The shift preferences for the user.
     * @param value Value to set for the shiftPreferences property.
     */
    set shiftPreferences(value) {
        this._shiftPreferences = value;
    }
    ;
}
exports.UserSettings = UserSettings;
