import { Entity, UserScopeTeamsAppInstallation } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class UserTeamwork extends Entity implements Parsable {
    /** The apps installed in the personal scope of this user.  */
    private _installedApps?;
    /**
     * Instantiates a new userTeamwork and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the installedApps property value. The apps installed in the personal scope of this user.
     * @returns a userScopeTeamsAppInstallation
     */
    get installedApps(): UserScopeTeamsAppInstallation[] | undefined;
    /**
     * Sets the installedApps property value. The apps installed in the personal scope of this user.
     * @param value Value to set for the installedApps property.
     */
    set installedApps(value: UserScopeTeamsAppInstallation[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
