import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class Video implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Number of audio bits per sample.  */
    private _audioBitsPerSample?;
    /** Number of audio channels.  */
    private _audioChannels?;
    /** Name of the audio format (AAC, MP3, etc.).  */
    private _audioFormat?;
    /** Number of audio samples per second.  */
    private _audioSamplesPerSecond?;
    /** Bit rate of the video in bits per second.  */
    private _bitrate?;
    /** Duration of the file in milliseconds.  */
    private _duration?;
    /** 'Four character code' name of the video format.  */
    private _fourCC?;
    /** Frame rate of the video.  */
    private _frameRate?;
    /** Height of the video, in pixels.  */
    private _height?;
    /** Width of the video, in pixels.  */
    private _width?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the audioBitsPerSample property value. Number of audio bits per sample.
     * @returns a integer
     */
    get audioBitsPerSample(): number | undefined;
    /**
     * Sets the audioBitsPerSample property value. Number of audio bits per sample.
     * @param value Value to set for the audioBitsPerSample property.
     */
    set audioBitsPerSample(value: number | undefined);
    /**
     * Gets the audioChannels property value. Number of audio channels.
     * @returns a integer
     */
    get audioChannels(): number | undefined;
    /**
     * Sets the audioChannels property value. Number of audio channels.
     * @param value Value to set for the audioChannels property.
     */
    set audioChannels(value: number | undefined);
    /**
     * Gets the audioFormat property value. Name of the audio format (AAC, MP3, etc.).
     * @returns a string
     */
    get audioFormat(): string | undefined;
    /**
     * Sets the audioFormat property value. Name of the audio format (AAC, MP3, etc.).
     * @param value Value to set for the audioFormat property.
     */
    set audioFormat(value: string | undefined);
    /**
     * Gets the audioSamplesPerSecond property value. Number of audio samples per second.
     * @returns a integer
     */
    get audioSamplesPerSecond(): number | undefined;
    /**
     * Sets the audioSamplesPerSecond property value. Number of audio samples per second.
     * @param value Value to set for the audioSamplesPerSecond property.
     */
    set audioSamplesPerSecond(value: number | undefined);
    /**
     * Gets the bitrate property value. Bit rate of the video in bits per second.
     * @returns a integer
     */
    get bitrate(): number | undefined;
    /**
     * Sets the bitrate property value. Bit rate of the video in bits per second.
     * @param value Value to set for the bitrate property.
     */
    set bitrate(value: number | undefined);
    /**
     * Instantiates a new video and sets the default values.
     */
    constructor();
    /**
     * Gets the duration property value. Duration of the file in milliseconds.
     * @returns a int64
     */
    get duration(): number | undefined;
    /**
     * Sets the duration property value. Duration of the file in milliseconds.
     * @param value Value to set for the duration property.
     */
    set duration(value: number | undefined);
    /**
     * Gets the fourCC property value. 'Four character code' name of the video format.
     * @returns a string
     */
    get fourCC(): string | undefined;
    /**
     * Sets the fourCC property value. 'Four character code' name of the video format.
     * @param value Value to set for the fourCC property.
     */
    set fourCC(value: string | undefined);
    /**
     * Gets the frameRate property value. Frame rate of the video.
     * @returns a double
     */
    get frameRate(): number | undefined;
    /**
     * Sets the frameRate property value. Frame rate of the video.
     * @param value Value to set for the frameRate property.
     */
    set frameRate(value: number | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the height property value. Height of the video, in pixels.
     * @returns a integer
     */
    get height(): number | undefined;
    /**
     * Sets the height property value. Height of the video, in pixels.
     * @param value Value to set for the height property.
     */
    set height(value: number | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the width property value. Width of the video, in pixels.
     * @returns a integer
     */
    get width(): number | undefined;
    /**
     * Sets the width property value. Width of the video, in pixels.
     * @param value Value to set for the width property.
     */
    set width(value: number | undefined);
}
