"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Video = void 0;
class Video {
    /**
     * Instantiates a new video and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the audioBitsPerSample property value. Number of audio bits per sample.
     * @returns a integer
     */
    get audioBitsPerSample() {
        return this._audioBitsPerSample;
    }
    ;
    /**
     * Sets the audioBitsPerSample property value. Number of audio bits per sample.
     * @param value Value to set for the audioBitsPerSample property.
     */
    set audioBitsPerSample(value) {
        this._audioBitsPerSample = value;
    }
    ;
    /**
     * Gets the audioChannels property value. Number of audio channels.
     * @returns a integer
     */
    get audioChannels() {
        return this._audioChannels;
    }
    ;
    /**
     * Sets the audioChannels property value. Number of audio channels.
     * @param value Value to set for the audioChannels property.
     */
    set audioChannels(value) {
        this._audioChannels = value;
    }
    ;
    /**
     * Gets the audioFormat property value. Name of the audio format (AAC, MP3, etc.).
     * @returns a string
     */
    get audioFormat() {
        return this._audioFormat;
    }
    ;
    /**
     * Sets the audioFormat property value. Name of the audio format (AAC, MP3, etc.).
     * @param value Value to set for the audioFormat property.
     */
    set audioFormat(value) {
        this._audioFormat = value;
    }
    ;
    /**
     * Gets the audioSamplesPerSecond property value. Number of audio samples per second.
     * @returns a integer
     */
    get audioSamplesPerSecond() {
        return this._audioSamplesPerSecond;
    }
    ;
    /**
     * Sets the audioSamplesPerSecond property value. Number of audio samples per second.
     * @param value Value to set for the audioSamplesPerSecond property.
     */
    set audioSamplesPerSecond(value) {
        this._audioSamplesPerSecond = value;
    }
    ;
    /**
     * Gets the bitrate property value. Bit rate of the video in bits per second.
     * @returns a integer
     */
    get bitrate() {
        return this._bitrate;
    }
    ;
    /**
     * Sets the bitrate property value. Bit rate of the video in bits per second.
     * @param value Value to set for the bitrate property.
     */
    set bitrate(value) {
        this._bitrate = value;
    }
    ;
    ;
    /**
     * Gets the duration property value. Duration of the file in milliseconds.
     * @returns a int64
     */
    get duration() {
        return this._duration;
    }
    ;
    /**
     * Sets the duration property value. Duration of the file in milliseconds.
     * @param value Value to set for the duration property.
     */
    set duration(value) {
        this._duration = value;
    }
    ;
    /**
     * Gets the fourCC property value. 'Four character code' name of the video format.
     * @returns a string
     */
    get fourCC() {
        return this._fourCC;
    }
    ;
    /**
     * Sets the fourCC property value. 'Four character code' name of the video format.
     * @param value Value to set for the fourCC property.
     */
    set fourCC(value) {
        this._fourCC = value;
    }
    ;
    /**
     * Gets the frameRate property value. Frame rate of the video.
     * @returns a double
     */
    get frameRate() {
        return this._frameRate;
    }
    ;
    /**
     * Sets the frameRate property value. Frame rate of the video.
     * @param value Value to set for the frameRate property.
     */
    set frameRate(value) {
        this._frameRate = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "audioBitsPerSample": (o, n) => { o.audioBitsPerSample = n.getNumberValue(); },
            "audioChannels": (o, n) => { o.audioChannels = n.getNumberValue(); },
            "audioFormat": (o, n) => { o.audioFormat = n.getStringValue(); },
            "audioSamplesPerSecond": (o, n) => { o.audioSamplesPerSecond = n.getNumberValue(); },
            "bitrate": (o, n) => { o.bitrate = n.getNumberValue(); },
            "duration": (o, n) => { o.duration = n.getNumberValue(); },
            "fourCC": (o, n) => { o.fourCC = n.getStringValue(); },
            "frameRate": (o, n) => { o.frameRate = n.getNumberValue(); },
            "height": (o, n) => { o.height = n.getNumberValue(); },
            "width": (o, n) => { o.width = n.getNumberValue(); },
        };
    }
    ;
    /**
     * Gets the height property value. Height of the video, in pixels.
     * @returns a integer
     */
    get height() {
        return this._height;
    }
    ;
    /**
     * Sets the height property value. Height of the video, in pixels.
     * @param value Value to set for the height property.
     */
    set height(value) {
        this._height = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeNumberValue("audioBitsPerSample", this.audioBitsPerSample);
        writer.writeNumberValue("audioChannels", this.audioChannels);
        writer.writeStringValue("audioFormat", this.audioFormat);
        writer.writeNumberValue("audioSamplesPerSecond", this.audioSamplesPerSecond);
        writer.writeNumberValue("bitrate", this.bitrate);
        writer.writeNumberValue("duration", this.duration);
        writer.writeStringValue("fourCC", this.fourCC);
        writer.writeNumberValue("frameRate", this.frameRate);
        writer.writeNumberValue("height", this.height);
        writer.writeNumberValue("width", this.width);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the width property value. Width of the video, in pixels.
     * @returns a integer
     */
    get width() {
        return this._width;
    }
    ;
    /**
     * Sets the width property value. Width of the video, in pixels.
     * @param value Value to set for the width property.
     */
    set width(value) {
        this._width = value;
    }
    ;
}
exports.Video = Video;
