"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebApplication = void 0;
const createImplicitGrantSettingsFromDiscriminatorValue_1 = require("./createImplicitGrantSettingsFromDiscriminatorValue");
class WebApplication {
    /**
     * Instantiates a new webApplication and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "homePageUrl": (o, n) => { o.homePageUrl = n.getStringValue(); },
            "implicitGrantSettings": (o, n) => { o.implicitGrantSettings = n.getObjectValue(createImplicitGrantSettingsFromDiscriminatorValue_1.createImplicitGrantSettingsFromDiscriminatorValue); },
            "logoutUrl": (o, n) => { o.logoutUrl = n.getStringValue(); },
            "redirectUris": (o, n) => { o.redirectUris = n.getCollectionOfPrimitiveValues(); },
        };
    }
    ;
    /**
     * Gets the homePageUrl property value. Home page or landing page of the application.
     * @returns a string
     */
    get homePageUrl() {
        return this._homePageUrl;
    }
    ;
    /**
     * Sets the homePageUrl property value. Home page or landing page of the application.
     * @param value Value to set for the homePageUrl property.
     */
    set homePageUrl(value) {
        this._homePageUrl = value;
    }
    ;
    /**
     * Gets the implicitGrantSettings property value. Specifies whether this web application can request tokens using the OAuth 2.0 implicit flow.
     * @returns a implicitGrantSettings
     */
    get implicitGrantSettings() {
        return this._implicitGrantSettings;
    }
    ;
    /**
     * Sets the implicitGrantSettings property value. Specifies whether this web application can request tokens using the OAuth 2.0 implicit flow.
     * @param value Value to set for the implicitGrantSettings property.
     */
    set implicitGrantSettings(value) {
        this._implicitGrantSettings = value;
    }
    ;
    /**
     * Gets the logoutUrl property value. Specifies the URL that will be used by Microsoft's authorization service to logout an user using front-channel, back-channel or SAML logout protocols.
     * @returns a string
     */
    get logoutUrl() {
        return this._logoutUrl;
    }
    ;
    /**
     * Sets the logoutUrl property value. Specifies the URL that will be used by Microsoft's authorization service to logout an user using front-channel, back-channel or SAML logout protocols.
     * @param value Value to set for the logoutUrl property.
     */
    set logoutUrl(value) {
        this._logoutUrl = value;
    }
    ;
    /**
     * Gets the redirectUris property value. Specifies the URLs where user tokens are sent for sign-in, or the redirect URIs where OAuth 2.0 authorization codes and access tokens are sent.
     * @returns a string
     */
    get redirectUris() {
        return this._redirectUris;
    }
    ;
    /**
     * Sets the redirectUris property value. Specifies the URLs where user tokens are sent for sign-in, or the redirect URIs where OAuth 2.0 authorization codes and access tokens are sent.
     * @param value Value to set for the redirectUris property.
     */
    set redirectUris(value) {
        this._redirectUris = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("homePageUrl", this.homePageUrl);
        writer.writeObjectValue("implicitGrantSettings", this.implicitGrantSettings);
        writer.writeStringValue("logoutUrl", this.logoutUrl);
        writer.writeCollectionOfPrimitiveValues("redirectUris", this.redirectUris);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.WebApplication = WebApplication;
