import { EnrollmentState } from './enrollmentState';
import { Entity } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class WindowsAutopilotDeviceIdentity extends Entity implements Parsable {
    /** Addressable user name.  */
    private _addressableUserName?;
    /** AAD Device ID - to be deprecated  */
    private _azureActiveDirectoryDeviceId?;
    /** Display Name  */
    private _displayName?;
    /** Intune enrollment state of the Windows autopilot device. Possible values are: unknown, enrolled, pendingReset, failed, notContacted.  */
    private _enrollmentState?;
    /** Group Tag of the Windows autopilot device.  */
    private _groupTag?;
    /** Intune Last Contacted Date Time of the Windows autopilot device.  */
    private _lastContactedDateTime?;
    /** Managed Device ID  */
    private _managedDeviceId?;
    /** Oem manufacturer of the Windows autopilot device.  */
    private _manufacturer?;
    /** Model name of the Windows autopilot device.  */
    private _model?;
    /** Product Key of the Windows autopilot device.  */
    private _productKey?;
    /** Purchase Order Identifier of the Windows autopilot device.  */
    private _purchaseOrderIdentifier?;
    /** Resource Name.  */
    private _resourceName?;
    /** Serial number of the Windows autopilot device.  */
    private _serialNumber?;
    /** SKU Number  */
    private _skuNumber?;
    /** System Family  */
    private _systemFamily?;
    /** User Principal Name.  */
    private _userPrincipalName?;
    /**
     * Gets the addressableUserName property value. Addressable user name.
     * @returns a string
     */
    get addressableUserName(): string | undefined;
    /**
     * Sets the addressableUserName property value. Addressable user name.
     * @param value Value to set for the addressableUserName property.
     */
    set addressableUserName(value: string | undefined);
    /**
     * Gets the azureActiveDirectoryDeviceId property value. AAD Device ID - to be deprecated
     * @returns a string
     */
    get azureActiveDirectoryDeviceId(): string | undefined;
    /**
     * Sets the azureActiveDirectoryDeviceId property value. AAD Device ID - to be deprecated
     * @param value Value to set for the azureActiveDirectoryDeviceId property.
     */
    set azureActiveDirectoryDeviceId(value: string | undefined);
    /**
     * Instantiates a new windowsAutopilotDeviceIdentity and sets the default values.
     */
    constructor();
    /**
     * Gets the displayName property value. Display Name
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value. Display Name
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * Gets the enrollmentState property value. Intune enrollment state of the Windows autopilot device. Possible values are: unknown, enrolled, pendingReset, failed, notContacted.
     * @returns a enrollmentState
     */
    get enrollmentState(): EnrollmentState | undefined;
    /**
     * Sets the enrollmentState property value. Intune enrollment state of the Windows autopilot device. Possible values are: unknown, enrolled, pendingReset, failed, notContacted.
     * @param value Value to set for the enrollmentState property.
     */
    set enrollmentState(value: EnrollmentState | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the groupTag property value. Group Tag of the Windows autopilot device.
     * @returns a string
     */
    get groupTag(): string | undefined;
    /**
     * Sets the groupTag property value. Group Tag of the Windows autopilot device.
     * @param value Value to set for the groupTag property.
     */
    set groupTag(value: string | undefined);
    /**
     * Gets the lastContactedDateTime property value. Intune Last Contacted Date Time of the Windows autopilot device.
     * @returns a Date
     */
    get lastContactedDateTime(): Date | undefined;
    /**
     * Sets the lastContactedDateTime property value. Intune Last Contacted Date Time of the Windows autopilot device.
     * @param value Value to set for the lastContactedDateTime property.
     */
    set lastContactedDateTime(value: Date | undefined);
    /**
     * Gets the managedDeviceId property value. Managed Device ID
     * @returns a string
     */
    get managedDeviceId(): string | undefined;
    /**
     * Sets the managedDeviceId property value. Managed Device ID
     * @param value Value to set for the managedDeviceId property.
     */
    set managedDeviceId(value: string | undefined);
    /**
     * Gets the manufacturer property value. Oem manufacturer of the Windows autopilot device.
     * @returns a string
     */
    get manufacturer(): string | undefined;
    /**
     * Sets the manufacturer property value. Oem manufacturer of the Windows autopilot device.
     * @param value Value to set for the manufacturer property.
     */
    set manufacturer(value: string | undefined);
    /**
     * Gets the model property value. Model name of the Windows autopilot device.
     * @returns a string
     */
    get model(): string | undefined;
    /**
     * Sets the model property value. Model name of the Windows autopilot device.
     * @param value Value to set for the model property.
     */
    set model(value: string | undefined);
    /**
     * Gets the productKey property value. Product Key of the Windows autopilot device.
     * @returns a string
     */
    get productKey(): string | undefined;
    /**
     * Sets the productKey property value. Product Key of the Windows autopilot device.
     * @param value Value to set for the productKey property.
     */
    set productKey(value: string | undefined);
    /**
     * Gets the purchaseOrderIdentifier property value. Purchase Order Identifier of the Windows autopilot device.
     * @returns a string
     */
    get purchaseOrderIdentifier(): string | undefined;
    /**
     * Sets the purchaseOrderIdentifier property value. Purchase Order Identifier of the Windows autopilot device.
     * @param value Value to set for the purchaseOrderIdentifier property.
     */
    set purchaseOrderIdentifier(value: string | undefined);
    /**
     * Gets the resourceName property value. Resource Name.
     * @returns a string
     */
    get resourceName(): string | undefined;
    /**
     * Sets the resourceName property value. Resource Name.
     * @param value Value to set for the resourceName property.
     */
    set resourceName(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the serialNumber property value. Serial number of the Windows autopilot device.
     * @returns a string
     */
    get serialNumber(): string | undefined;
    /**
     * Sets the serialNumber property value. Serial number of the Windows autopilot device.
     * @param value Value to set for the serialNumber property.
     */
    set serialNumber(value: string | undefined);
    /**
     * Gets the skuNumber property value. SKU Number
     * @returns a string
     */
    get skuNumber(): string | undefined;
    /**
     * Sets the skuNumber property value. SKU Number
     * @param value Value to set for the skuNumber property.
     */
    set skuNumber(value: string | undefined);
    /**
     * Gets the systemFamily property value. System Family
     * @returns a string
     */
    get systemFamily(): string | undefined;
    /**
     * Sets the systemFamily property value. System Family
     * @param value Value to set for the systemFamily property.
     */
    set systemFamily(value: string | undefined);
    /**
     * Gets the userPrincipalName property value. User Principal Name.
     * @returns a string
     */
    get userPrincipalName(): string | undefined;
    /**
     * Sets the userPrincipalName property value. User Principal Name.
     * @param value Value to set for the userPrincipalName property.
     */
    set userPrincipalName(value: string | undefined);
}
