"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WindowsAutopilotDeviceIdentity = void 0;
const enrollmentState_1 = require("./enrollmentState");
const index_1 = require("./index");
class WindowsAutopilotDeviceIdentity extends index_1.Entity {
    /**
     * Instantiates a new windowsAutopilotDeviceIdentity and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the addressableUserName property value. Addressable user name.
     * @returns a string
     */
    get addressableUserName() {
        return this._addressableUserName;
    }
    ;
    /**
     * Sets the addressableUserName property value. Addressable user name.
     * @param value Value to set for the addressableUserName property.
     */
    set addressableUserName(value) {
        this._addressableUserName = value;
    }
    ;
    /**
     * Gets the azureActiveDirectoryDeviceId property value. AAD Device ID - to be deprecated
     * @returns a string
     */
    get azureActiveDirectoryDeviceId() {
        return this._azureActiveDirectoryDeviceId;
    }
    ;
    /**
     * Sets the azureActiveDirectoryDeviceId property value. AAD Device ID - to be deprecated
     * @param value Value to set for the azureActiveDirectoryDeviceId property.
     */
    set azureActiveDirectoryDeviceId(value) {
        this._azureActiveDirectoryDeviceId = value;
    }
    ;
    ;
    /**
     * Gets the displayName property value. Display Name
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. Display Name
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * Gets the enrollmentState property value. Intune enrollment state of the Windows autopilot device. Possible values are: unknown, enrolled, pendingReset, failed, notContacted.
     * @returns a enrollmentState
     */
    get enrollmentState() {
        return this._enrollmentState;
    }
    ;
    /**
     * Sets the enrollmentState property value. Intune enrollment state of the Windows autopilot device. Possible values are: unknown, enrolled, pendingReset, failed, notContacted.
     * @param value Value to set for the enrollmentState property.
     */
    set enrollmentState(value) {
        this._enrollmentState = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "addressableUserName": (o, n) => { o.addressableUserName = n.getStringValue(); }, "azureActiveDirectoryDeviceId": (o, n) => { o.azureActiveDirectoryDeviceId = n.getStringValue(); }, "displayName": (o, n) => { o.displayName = n.getStringValue(); }, "enrollmentState": (o, n) => { o.enrollmentState = n.getEnumValue(enrollmentState_1.EnrollmentState); }, "groupTag": (o, n) => { o.groupTag = n.getStringValue(); }, "lastContactedDateTime": (o, n) => { o.lastContactedDateTime = n.getDateValue(); }, "managedDeviceId": (o, n) => { o.managedDeviceId = n.getStringValue(); }, "manufacturer": (o, n) => { o.manufacturer = n.getStringValue(); }, "model": (o, n) => { o.model = n.getStringValue(); }, "productKey": (o, n) => { o.productKey = n.getStringValue(); }, "purchaseOrderIdentifier": (o, n) => { o.purchaseOrderIdentifier = n.getStringValue(); }, "resourceName": (o, n) => { o.resourceName = n.getStringValue(); }, "serialNumber": (o, n) => { o.serialNumber = n.getStringValue(); }, "skuNumber": (o, n) => { o.skuNumber = n.getStringValue(); }, "systemFamily": (o, n) => { o.systemFamily = n.getStringValue(); }, "userPrincipalName": (o, n) => { o.userPrincipalName = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the groupTag property value. Group Tag of the Windows autopilot device.
     * @returns a string
     */
    get groupTag() {
        return this._groupTag;
    }
    ;
    /**
     * Sets the groupTag property value. Group Tag of the Windows autopilot device.
     * @param value Value to set for the groupTag property.
     */
    set groupTag(value) {
        this._groupTag = value;
    }
    ;
    /**
     * Gets the lastContactedDateTime property value. Intune Last Contacted Date Time of the Windows autopilot device.
     * @returns a Date
     */
    get lastContactedDateTime() {
        return this._lastContactedDateTime;
    }
    ;
    /**
     * Sets the lastContactedDateTime property value. Intune Last Contacted Date Time of the Windows autopilot device.
     * @param value Value to set for the lastContactedDateTime property.
     */
    set lastContactedDateTime(value) {
        this._lastContactedDateTime = value;
    }
    ;
    /**
     * Gets the managedDeviceId property value. Managed Device ID
     * @returns a string
     */
    get managedDeviceId() {
        return this._managedDeviceId;
    }
    ;
    /**
     * Sets the managedDeviceId property value. Managed Device ID
     * @param value Value to set for the managedDeviceId property.
     */
    set managedDeviceId(value) {
        this._managedDeviceId = value;
    }
    ;
    /**
     * Gets the manufacturer property value. Oem manufacturer of the Windows autopilot device.
     * @returns a string
     */
    get manufacturer() {
        return this._manufacturer;
    }
    ;
    /**
     * Sets the manufacturer property value. Oem manufacturer of the Windows autopilot device.
     * @param value Value to set for the manufacturer property.
     */
    set manufacturer(value) {
        this._manufacturer = value;
    }
    ;
    /**
     * Gets the model property value. Model name of the Windows autopilot device.
     * @returns a string
     */
    get model() {
        return this._model;
    }
    ;
    /**
     * Sets the model property value. Model name of the Windows autopilot device.
     * @param value Value to set for the model property.
     */
    set model(value) {
        this._model = value;
    }
    ;
    /**
     * Gets the productKey property value. Product Key of the Windows autopilot device.
     * @returns a string
     */
    get productKey() {
        return this._productKey;
    }
    ;
    /**
     * Sets the productKey property value. Product Key of the Windows autopilot device.
     * @param value Value to set for the productKey property.
     */
    set productKey(value) {
        this._productKey = value;
    }
    ;
    /**
     * Gets the purchaseOrderIdentifier property value. Purchase Order Identifier of the Windows autopilot device.
     * @returns a string
     */
    get purchaseOrderIdentifier() {
        return this._purchaseOrderIdentifier;
    }
    ;
    /**
     * Sets the purchaseOrderIdentifier property value. Purchase Order Identifier of the Windows autopilot device.
     * @param value Value to set for the purchaseOrderIdentifier property.
     */
    set purchaseOrderIdentifier(value) {
        this._purchaseOrderIdentifier = value;
    }
    ;
    /**
     * Gets the resourceName property value. Resource Name.
     * @returns a string
     */
    get resourceName() {
        return this._resourceName;
    }
    ;
    /**
     * Sets the resourceName property value. Resource Name.
     * @param value Value to set for the resourceName property.
     */
    set resourceName(value) {
        this._resourceName = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeStringValue("addressableUserName", this.addressableUserName);
        writer.writeStringValue("azureActiveDirectoryDeviceId", this.azureActiveDirectoryDeviceId);
        writer.writeStringValue("displayName", this.displayName);
        writer.writeEnumValue("enrollmentState", this.enrollmentState);
        writer.writeStringValue("groupTag", this.groupTag);
        writer.writeDateValue("lastContactedDateTime", this.lastContactedDateTime);
        writer.writeStringValue("managedDeviceId", this.managedDeviceId);
        writer.writeStringValue("manufacturer", this.manufacturer);
        writer.writeStringValue("model", this.model);
        writer.writeStringValue("productKey", this.productKey);
        writer.writeStringValue("purchaseOrderIdentifier", this.purchaseOrderIdentifier);
        writer.writeStringValue("resourceName", this.resourceName);
        writer.writeStringValue("serialNumber", this.serialNumber);
        writer.writeStringValue("skuNumber", this.skuNumber);
        writer.writeStringValue("systemFamily", this.systemFamily);
        writer.writeStringValue("userPrincipalName", this.userPrincipalName);
    }
    ;
    /**
     * Gets the serialNumber property value. Serial number of the Windows autopilot device.
     * @returns a string
     */
    get serialNumber() {
        return this._serialNumber;
    }
    ;
    /**
     * Sets the serialNumber property value. Serial number of the Windows autopilot device.
     * @param value Value to set for the serialNumber property.
     */
    set serialNumber(value) {
        this._serialNumber = value;
    }
    ;
    /**
     * Gets the skuNumber property value. SKU Number
     * @returns a string
     */
    get skuNumber() {
        return this._skuNumber;
    }
    ;
    /**
     * Sets the skuNumber property value. SKU Number
     * @param value Value to set for the skuNumber property.
     */
    set skuNumber(value) {
        this._skuNumber = value;
    }
    ;
    /**
     * Gets the systemFamily property value. System Family
     * @returns a string
     */
    get systemFamily() {
        return this._systemFamily;
    }
    ;
    /**
     * Sets the systemFamily property value. System Family
     * @param value Value to set for the systemFamily property.
     */
    set systemFamily(value) {
        this._systemFamily = value;
    }
    ;
    /**
     * Gets the userPrincipalName property value. User Principal Name.
     * @returns a string
     */
    get userPrincipalName() {
        return this._userPrincipalName;
    }
    ;
    /**
     * Sets the userPrincipalName property value. User Principal Name.
     * @param value Value to set for the userPrincipalName property.
     */
    set userPrincipalName(value) {
        this._userPrincipalName = value;
    }
    ;
}
exports.WindowsAutopilotDeviceIdentity = WindowsAutopilotDeviceIdentity;
