import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Windows Information Protection DataRecoveryCertificate  */
export declare class WindowsInformationProtectionDataRecoveryCertificate implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Data recovery Certificate  */
    private _certificate?;
    /** Data recovery Certificate description  */
    private _description?;
    /** Data recovery Certificate expiration datetime  */
    private _expirationDateTime?;
    /** Data recovery Certificate subject name  */
    private _subjectName?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the certificate property value. Data recovery Certificate
     * @returns a binary
     */
    get certificate(): string | undefined;
    /**
     * Sets the certificate property value. Data recovery Certificate
     * @param value Value to set for the certificate property.
     */
    set certificate(value: string | undefined);
    /**
     * Instantiates a new windowsInformationProtectionDataRecoveryCertificate and sets the default values.
     */
    constructor();
    /**
     * Gets the description property value. Data recovery Certificate description
     * @returns a string
     */
    get description(): string | undefined;
    /**
     * Sets the description property value. Data recovery Certificate description
     * @param value Value to set for the description property.
     */
    set description(value: string | undefined);
    /**
     * Gets the expirationDateTime property value. Data recovery Certificate expiration datetime
     * @returns a Date
     */
    get expirationDateTime(): Date | undefined;
    /**
     * Sets the expirationDateTime property value. Data recovery Certificate expiration datetime
     * @param value Value to set for the expirationDateTime property.
     */
    set expirationDateTime(value: Date | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the subjectName property value. Data recovery Certificate subject name
     * @returns a string
     */
    get subjectName(): string | undefined;
    /**
     * Sets the subjectName property value. Data recovery Certificate subject name
     * @param value Value to set for the subjectName property.
     */
    set subjectName(value: string | undefined);
}
