"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WindowsInformationProtectionDataRecoveryCertificate = void 0;
/** Windows Information Protection DataRecoveryCertificate  */
class WindowsInformationProtectionDataRecoveryCertificate {
    /**
     * Instantiates a new windowsInformationProtectionDataRecoveryCertificate and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the certificate property value. Data recovery Certificate
     * @returns a binary
     */
    get certificate() {
        return this._certificate;
    }
    ;
    /**
     * Sets the certificate property value. Data recovery Certificate
     * @param value Value to set for the certificate property.
     */
    set certificate(value) {
        this._certificate = value;
    }
    ;
    ;
    /**
     * Gets the description property value. Data recovery Certificate description
     * @returns a string
     */
    get description() {
        return this._description;
    }
    ;
    /**
     * Sets the description property value. Data recovery Certificate description
     * @param value Value to set for the description property.
     */
    set description(value) {
        this._description = value;
    }
    ;
    /**
     * Gets the expirationDateTime property value. Data recovery Certificate expiration datetime
     * @returns a Date
     */
    get expirationDateTime() {
        return this._expirationDateTime;
    }
    ;
    /**
     * Sets the expirationDateTime property value. Data recovery Certificate expiration datetime
     * @param value Value to set for the expirationDateTime property.
     */
    set expirationDateTime(value) {
        this._expirationDateTime = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "certificate": (o, n) => { o.certificate = n.getStringValue(); },
            "description": (o, n) => { o.description = n.getStringValue(); },
            "expirationDateTime": (o, n) => { o.expirationDateTime = n.getDateValue(); },
            "subjectName": (o, n) => { o.subjectName = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("certificate", this.certificate);
        writer.writeStringValue("description", this.description);
        writer.writeDateValue("expirationDateTime", this.expirationDateTime);
        writer.writeStringValue("subjectName", this.subjectName);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the subjectName property value. Data recovery Certificate subject name
     * @returns a string
     */
    get subjectName() {
        return this._subjectName;
    }
    ;
    /**
     * Sets the subjectName property value. Data recovery Certificate subject name
     * @param value Value to set for the subjectName property.
     */
    set subjectName(value) {
        this._subjectName = value;
    }
    ;
}
exports.WindowsInformationProtectionDataRecoveryCertificate = WindowsInformationProtectionDataRecoveryCertificate;
