"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WindowsInformationProtectionResourceCollection = void 0;
/** Windows Information Protection Resource Collection  */
class WindowsInformationProtectionResourceCollection {
    /**
     * Instantiates a new windowsInformationProtectionResourceCollection and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the displayName property value. Display name
     * @returns a string
     */
    get displayName() {
        return this._displayName;
    }
    ;
    /**
     * Sets the displayName property value. Display name
     * @param value Value to set for the displayName property.
     */
    set displayName(value) {
        this._displayName = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "displayName": (o, n) => { o.displayName = n.getStringValue(); },
            "resources": (o, n) => { o.resources = n.getCollectionOfPrimitiveValues(); },
        };
    }
    ;
    /**
     * Gets the resources property value. Collection of resources
     * @returns a string
     */
    get resources() {
        return this._resources;
    }
    ;
    /**
     * Sets the resources property value. Collection of resources
     * @param value Value to set for the resources property.
     */
    set resources(value) {
        this._resources = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("displayName", this.displayName);
        writer.writeCollectionOfPrimitiveValues("resources", this.resources);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.WindowsInformationProtectionResourceCollection = WindowsInformationProtectionResourceCollection;
