import { Entity, WorkbookApplication, WorkbookComment, WorkbookFunctions, WorkbookNamedItem, WorkbookOperation, WorkbookTable, WorkbookWorksheet } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class Workbook extends Entity implements Parsable {
    private _application?;
    private _comments?;
    private _functions?;
    /** Represents a collection of workbooks scoped named items (named ranges and constants). Read-only.  */
    private _names?;
    /** The status of workbook operations. Getting an operation collection is not supported, but you can get the status of a long-running operation if the Location header is returned in the response. Read-only.  */
    private _operations?;
    /** Represents a collection of tables associated with the workbook. Read-only.  */
    private _tables?;
    /** Represents a collection of worksheets associated with the workbook. Read-only.  */
    private _worksheets?;
    /**
     * Gets the application property value.
     * @returns a workbookApplication
     */
    get application(): WorkbookApplication | undefined;
    /**
     * Sets the application property value.
     * @param value Value to set for the application property.
     */
    set application(value: WorkbookApplication | undefined);
    /**
     * Gets the comments property value.
     * @returns a workbookComment
     */
    get comments(): WorkbookComment[] | undefined;
    /**
     * Sets the comments property value.
     * @param value Value to set for the comments property.
     */
    set comments(value: WorkbookComment[] | undefined);
    /**
     * Instantiates a new workbook and sets the default values.
     */
    constructor();
    /**
     * Gets the functions property value.
     * @returns a workbookFunctions
     */
    get functions(): WorkbookFunctions | undefined;
    /**
     * Sets the functions property value.
     * @param value Value to set for the functions property.
     */
    set functions(value: WorkbookFunctions | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the names property value. Represents a collection of workbooks scoped named items (named ranges and constants). Read-only.
     * @returns a workbookNamedItem
     */
    get names(): WorkbookNamedItem[] | undefined;
    /**
     * Sets the names property value. Represents a collection of workbooks scoped named items (named ranges and constants). Read-only.
     * @param value Value to set for the names property.
     */
    set names(value: WorkbookNamedItem[] | undefined);
    /**
     * Gets the operations property value. The status of workbook operations. Getting an operation collection is not supported, but you can get the status of a long-running operation if the Location header is returned in the response. Read-only.
     * @returns a workbookOperation
     */
    get operations(): WorkbookOperation[] | undefined;
    /**
     * Sets the operations property value. The status of workbook operations. Getting an operation collection is not supported, but you can get the status of a long-running operation if the Location header is returned in the response. Read-only.
     * @param value Value to set for the operations property.
     */
    set operations(value: WorkbookOperation[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the tables property value. Represents a collection of tables associated with the workbook. Read-only.
     * @returns a workbookTable
     */
    get tables(): WorkbookTable[] | undefined;
    /**
     * Sets the tables property value. Represents a collection of tables associated with the workbook. Read-only.
     * @param value Value to set for the tables property.
     */
    set tables(value: WorkbookTable[] | undefined);
    /**
     * Gets the worksheets property value. Represents a collection of worksheets associated with the workbook. Read-only.
     * @returns a workbookWorksheet
     */
    get worksheets(): WorkbookWorksheet[] | undefined;
    /**
     * Sets the worksheets property value. Represents a collection of worksheets associated with the workbook. Read-only.
     * @param value Value to set for the worksheets property.
     */
    set worksheets(value: WorkbookWorksheet[] | undefined);
}
