"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Workbook = void 0;
const createWorkbookApplicationFromDiscriminatorValue_1 = require("./createWorkbookApplicationFromDiscriminatorValue");
const createWorkbookCommentFromDiscriminatorValue_1 = require("./createWorkbookCommentFromDiscriminatorValue");
const createWorkbookFunctionsFromDiscriminatorValue_1 = require("./createWorkbookFunctionsFromDiscriminatorValue");
const createWorkbookNamedItemFromDiscriminatorValue_1 = require("./createWorkbookNamedItemFromDiscriminatorValue");
const createWorkbookOperationFromDiscriminatorValue_1 = require("./createWorkbookOperationFromDiscriminatorValue");
const createWorkbookTableFromDiscriminatorValue_1 = require("./createWorkbookTableFromDiscriminatorValue");
const createWorkbookWorksheetFromDiscriminatorValue_1 = require("./createWorkbookWorksheetFromDiscriminatorValue");
const index_1 = require("./index");
class Workbook extends index_1.Entity {
    /**
     * Instantiates a new workbook and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the application property value.
     * @returns a workbookApplication
     */
    get application() {
        return this._application;
    }
    ;
    /**
     * Sets the application property value.
     * @param value Value to set for the application property.
     */
    set application(value) {
        this._application = value;
    }
    ;
    /**
     * Gets the comments property value.
     * @returns a workbookComment
     */
    get comments() {
        return this._comments;
    }
    ;
    /**
     * Sets the comments property value.
     * @param value Value to set for the comments property.
     */
    set comments(value) {
        this._comments = value;
    }
    ;
    ;
    /**
     * Gets the functions property value.
     * @returns a workbookFunctions
     */
    get functions() {
        return this._functions;
    }
    ;
    /**
     * Sets the functions property value.
     * @param value Value to set for the functions property.
     */
    set functions(value) {
        this._functions = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "application": (o, n) => { o.application = n.getObjectValue(createWorkbookApplicationFromDiscriminatorValue_1.createWorkbookApplicationFromDiscriminatorValue); }, "comments": (o, n) => { o.comments = n.getCollectionOfObjectValues(createWorkbookCommentFromDiscriminatorValue_1.createWorkbookCommentFromDiscriminatorValue); }, "functions": (o, n) => { o.functions = n.getObjectValue(createWorkbookFunctionsFromDiscriminatorValue_1.createWorkbookFunctionsFromDiscriminatorValue); }, "names": (o, n) => { o.names = n.getCollectionOfObjectValues(createWorkbookNamedItemFromDiscriminatorValue_1.createWorkbookNamedItemFromDiscriminatorValue); }, "operations": (o, n) => { o.operations = n.getCollectionOfObjectValues(createWorkbookOperationFromDiscriminatorValue_1.createWorkbookOperationFromDiscriminatorValue); }, "tables": (o, n) => { o.tables = n.getCollectionOfObjectValues(createWorkbookTableFromDiscriminatorValue_1.createWorkbookTableFromDiscriminatorValue); }, "worksheets": (o, n) => { o.worksheets = n.getCollectionOfObjectValues(createWorkbookWorksheetFromDiscriminatorValue_1.createWorkbookWorksheetFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the names property value. Represents a collection of workbooks scoped named items (named ranges and constants). Read-only.
     * @returns a workbookNamedItem
     */
    get names() {
        return this._names;
    }
    ;
    /**
     * Sets the names property value. Represents a collection of workbooks scoped named items (named ranges and constants). Read-only.
     * @param value Value to set for the names property.
     */
    set names(value) {
        this._names = value;
    }
    ;
    /**
     * Gets the operations property value. The status of workbook operations. Getting an operation collection is not supported, but you can get the status of a long-running operation if the Location header is returned in the response. Read-only.
     * @returns a workbookOperation
     */
    get operations() {
        return this._operations;
    }
    ;
    /**
     * Sets the operations property value. The status of workbook operations. Getting an operation collection is not supported, but you can get the status of a long-running operation if the Location header is returned in the response. Read-only.
     * @param value Value to set for the operations property.
     */
    set operations(value) {
        this._operations = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("application", this.application);
        writer.writeCollectionOfObjectValues("comments", this.comments);
        writer.writeObjectValue("functions", this.functions);
        writer.writeCollectionOfObjectValues("names", this.names);
        writer.writeCollectionOfObjectValues("operations", this.operations);
        writer.writeCollectionOfObjectValues("tables", this.tables);
        writer.writeCollectionOfObjectValues("worksheets", this.worksheets);
    }
    ;
    /**
     * Gets the tables property value. Represents a collection of tables associated with the workbook. Read-only.
     * @returns a workbookTable
     */
    get tables() {
        return this._tables;
    }
    ;
    /**
     * Sets the tables property value. Represents a collection of tables associated with the workbook. Read-only.
     * @param value Value to set for the tables property.
     */
    set tables(value) {
        this._tables = value;
    }
    ;
    /**
     * Gets the worksheets property value. Represents a collection of worksheets associated with the workbook. Read-only.
     * @returns a workbookWorksheet
     */
    get worksheets() {
        return this._worksheets;
    }
    ;
    /**
     * Sets the worksheets property value. Represents a collection of worksheets associated with the workbook. Read-only.
     * @param value Value to set for the worksheets property.
     */
    set worksheets(value) {
        this._worksheets = value;
    }
    ;
}
exports.Workbook = Workbook;
