"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkbookChart = void 0;
const createWorkbookChartAreaFormatFromDiscriminatorValue_1 = require("./createWorkbookChartAreaFormatFromDiscriminatorValue");
const createWorkbookChartAxesFromDiscriminatorValue_1 = require("./createWorkbookChartAxesFromDiscriminatorValue");
const createWorkbookChartDataLabelsFromDiscriminatorValue_1 = require("./createWorkbookChartDataLabelsFromDiscriminatorValue");
const createWorkbookChartLegendFromDiscriminatorValue_1 = require("./createWorkbookChartLegendFromDiscriminatorValue");
const createWorkbookChartSeriesFromDiscriminatorValue_1 = require("./createWorkbookChartSeriesFromDiscriminatorValue");
const createWorkbookChartTitleFromDiscriminatorValue_1 = require("./createWorkbookChartTitleFromDiscriminatorValue");
const createWorkbookWorksheetFromDiscriminatorValue_1 = require("./createWorkbookWorksheetFromDiscriminatorValue");
const index_1 = require("./index");
class WorkbookChart extends index_1.Entity {
    /**
     * Instantiates a new workbookChart and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the axes property value. Represents chart axes. Read-only.
     * @returns a workbookChartAxes
     */
    get axes() {
        return this._axes;
    }
    ;
    /**
     * Sets the axes property value. Represents chart axes. Read-only.
     * @param value Value to set for the axes property.
     */
    set axes(value) {
        this._axes = value;
    }
    ;
    ;
    /**
     * Gets the dataLabels property value. Represents the datalabels on the chart. Read-only.
     * @returns a workbookChartDataLabels
     */
    get dataLabels() {
        return this._dataLabels;
    }
    ;
    /**
     * Sets the dataLabels property value. Represents the datalabels on the chart. Read-only.
     * @param value Value to set for the dataLabels property.
     */
    set dataLabels(value) {
        this._dataLabels = value;
    }
    ;
    /**
     * Gets the format property value. Encapsulates the format properties for the chart area. Read-only.
     * @returns a workbookChartAreaFormat
     */
    get format() {
        return this._format;
    }
    ;
    /**
     * Sets the format property value. Encapsulates the format properties for the chart area. Read-only.
     * @param value Value to set for the format property.
     */
    set format(value) {
        this._format = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "axes": (o, n) => { o.axes = n.getObjectValue(createWorkbookChartAxesFromDiscriminatorValue_1.createWorkbookChartAxesFromDiscriminatorValue); }, "dataLabels": (o, n) => { o.dataLabels = n.getObjectValue(createWorkbookChartDataLabelsFromDiscriminatorValue_1.createWorkbookChartDataLabelsFromDiscriminatorValue); }, "format": (o, n) => { o.format = n.getObjectValue(createWorkbookChartAreaFormatFromDiscriminatorValue_1.createWorkbookChartAreaFormatFromDiscriminatorValue); }, "height": (o, n) => { o.height = n.getNumberValue(); }, "left": (o, n) => { o.left = n.getNumberValue(); }, "legend": (o, n) => { o.legend = n.getObjectValue(createWorkbookChartLegendFromDiscriminatorValue_1.createWorkbookChartLegendFromDiscriminatorValue); }, "name": (o, n) => { o.name = n.getStringValue(); }, "series": (o, n) => { o.series = n.getCollectionOfObjectValues(createWorkbookChartSeriesFromDiscriminatorValue_1.createWorkbookChartSeriesFromDiscriminatorValue); }, "title": (o, n) => { o.title = n.getObjectValue(createWorkbookChartTitleFromDiscriminatorValue_1.createWorkbookChartTitleFromDiscriminatorValue); }, "top": (o, n) => { o.top = n.getNumberValue(); }, "width": (o, n) => { o.width = n.getNumberValue(); }, "worksheet": (o, n) => { o.worksheet = n.getObjectValue(createWorkbookWorksheetFromDiscriminatorValue_1.createWorkbookWorksheetFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the height property value. Represents the height, in points, of the chart object.
     * @returns a double
     */
    get height() {
        return this._height;
    }
    ;
    /**
     * Sets the height property value. Represents the height, in points, of the chart object.
     * @param value Value to set for the height property.
     */
    set height(value) {
        this._height = value;
    }
    ;
    /**
     * Gets the left property value. The distance, in points, from the left side of the chart to the worksheet origin.
     * @returns a double
     */
    get left() {
        return this._left;
    }
    ;
    /**
     * Sets the left property value. The distance, in points, from the left side of the chart to the worksheet origin.
     * @param value Value to set for the left property.
     */
    set left(value) {
        this._left = value;
    }
    ;
    /**
     * Gets the legend property value. Represents the legend for the chart. Read-only.
     * @returns a workbookChartLegend
     */
    get legend() {
        return this._legend;
    }
    ;
    /**
     * Sets the legend property value. Represents the legend for the chart. Read-only.
     * @param value Value to set for the legend property.
     */
    set legend(value) {
        this._legend = value;
    }
    ;
    /**
     * Gets the name property value. Represents the name of a chart object.
     * @returns a string
     */
    get name() {
        return this._name;
    }
    ;
    /**
     * Sets the name property value. Represents the name of a chart object.
     * @param value Value to set for the name property.
     */
    set name(value) {
        this._name = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("axes", this.axes);
        writer.writeObjectValue("dataLabels", this.dataLabels);
        writer.writeObjectValue("format", this.format);
        writer.writeNumberValue("height", this.height);
        writer.writeNumberValue("left", this.left);
        writer.writeObjectValue("legend", this.legend);
        writer.writeStringValue("name", this.name);
        writer.writeCollectionOfObjectValues("series", this.series);
        writer.writeObjectValue("title", this.title);
        writer.writeNumberValue("top", this.top);
        writer.writeNumberValue("width", this.width);
        writer.writeObjectValue("worksheet", this.worksheet);
    }
    ;
    /**
     * Gets the series property value. Represents either a single series or collection of series in the chart. Read-only.
     * @returns a workbookChartSeries
     */
    get series() {
        return this._series;
    }
    ;
    /**
     * Sets the series property value. Represents either a single series or collection of series in the chart. Read-only.
     * @param value Value to set for the series property.
     */
    set series(value) {
        this._series = value;
    }
    ;
    /**
     * Gets the title property value. Represents the title of the specified chart, including the text, visibility, position and formating of the title. Read-only.
     * @returns a workbookChartTitle
     */
    get title() {
        return this._title;
    }
    ;
    /**
     * Sets the title property value. Represents the title of the specified chart, including the text, visibility, position and formating of the title. Read-only.
     * @param value Value to set for the title property.
     */
    set title(value) {
        this._title = value;
    }
    ;
    /**
     * Gets the top property value. Represents the distance, in points, from the top edge of the object to the top of row 1 (on a worksheet) or the top of the chart area (on a chart).
     * @returns a double
     */
    get top() {
        return this._top;
    }
    ;
    /**
     * Sets the top property value. Represents the distance, in points, from the top edge of the object to the top of row 1 (on a worksheet) or the top of the chart area (on a chart).
     * @param value Value to set for the top property.
     */
    set top(value) {
        this._top = value;
    }
    ;
    /**
     * Gets the width property value. Represents the width, in points, of the chart object.
     * @returns a double
     */
    get width() {
        return this._width;
    }
    ;
    /**
     * Sets the width property value. Represents the width, in points, of the chart object.
     * @param value Value to set for the width property.
     */
    set width(value) {
        this._width = value;
    }
    ;
    /**
     * Gets the worksheet property value. The worksheet containing the current chart. Read-only.
     * @returns a workbookWorksheet
     */
    get worksheet() {
        return this._worksheet;
    }
    ;
    /**
     * Sets the worksheet property value. The worksheet containing the current chart. Read-only.
     * @param value Value to set for the worksheet property.
     */
    set worksheet(value) {
        this._worksheet = value;
    }
    ;
}
exports.WorkbookChart = WorkbookChart;
