import { Entity, WorkbookChartFont, WorkbookChartLineFormat } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class WorkbookChartAxisFormat extends Entity implements Parsable {
    /** Represents the font attributes (font name, font size, color, etc.) for a chart axis element. Read-only.  */
    private _font?;
    /** Represents chart line formatting. Read-only.  */
    private _line?;
    /**
     * Instantiates a new workbookChartAxisFormat and sets the default values.
     */
    constructor();
    /**
     * Gets the font property value. Represents the font attributes (font name, font size, color, etc.) for a chart axis element. Read-only.
     * @returns a workbookChartFont
     */
    get font(): WorkbookChartFont | undefined;
    /**
     * Sets the font property value. Represents the font attributes (font name, font size, color, etc.) for a chart axis element. Read-only.
     * @param value Value to set for the font property.
     */
    set font(value: WorkbookChartFont | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the line property value. Represents chart line formatting. Read-only.
     * @returns a workbookChartLineFormat
     */
    get line(): WorkbookChartLineFormat | undefined;
    /**
     * Sets the line property value. Represents chart line formatting. Read-only.
     * @param value Value to set for the line property.
     */
    set line(value: WorkbookChartLineFormat | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
