import { Entity, WorkbookChartAxisTitleFormat } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class WorkbookChartAxisTitle extends Entity implements Parsable {
    /** Represents the formatting of chart axis title. Read-only.  */
    private _format?;
    /** Represents the axis title.  */
    private _text?;
    /** A boolean that specifies the visibility of an axis title.  */
    private _visible?;
    /**
     * Instantiates a new workbookChartAxisTitle and sets the default values.
     */
    constructor();
    /**
     * Gets the format property value. Represents the formatting of chart axis title. Read-only.
     * @returns a workbookChartAxisTitleFormat
     */
    get format(): WorkbookChartAxisTitleFormat | undefined;
    /**
     * Sets the format property value. Represents the formatting of chart axis title. Read-only.
     * @param value Value to set for the format property.
     */
    set format(value: WorkbookChartAxisTitleFormat | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the text property value. Represents the axis title.
     * @returns a string
     */
    get text(): string | undefined;
    /**
     * Sets the text property value. Represents the axis title.
     * @param value Value to set for the text property.
     */
    set text(value: string | undefined);
    /**
     * Gets the visible property value. A boolean that specifies the visibility of an axis title.
     * @returns a boolean
     */
    get visible(): boolean | undefined;
    /**
     * Sets the visible property value. A boolean that specifies the visibility of an axis title.
     * @param value Value to set for the visible property.
     */
    set visible(value: boolean | undefined);
}
