"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkbookChartAxisTitle = void 0;
const createWorkbookChartAxisTitleFormatFromDiscriminatorValue_1 = require("./createWorkbookChartAxisTitleFormatFromDiscriminatorValue");
const index_1 = require("./index");
class WorkbookChartAxisTitle extends index_1.Entity {
    /**
     * Instantiates a new workbookChartAxisTitle and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the format property value. Represents the formatting of chart axis title. Read-only.
     * @returns a workbookChartAxisTitleFormat
     */
    get format() {
        return this._format;
    }
    ;
    /**
     * Sets the format property value. Represents the formatting of chart axis title. Read-only.
     * @param value Value to set for the format property.
     */
    set format(value) {
        this._format = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "format": (o, n) => { o.format = n.getObjectValue(createWorkbookChartAxisTitleFormatFromDiscriminatorValue_1.createWorkbookChartAxisTitleFormatFromDiscriminatorValue); }, "text": (o, n) => { o.text = n.getStringValue(); }, "visible": (o, n) => { o.visible = n.getBooleanValue(); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("format", this.format);
        writer.writeStringValue("text", this.text);
        writer.writeBooleanValue("visible", this.visible);
    }
    ;
    /**
     * Gets the text property value. Represents the axis title.
     * @returns a string
     */
    get text() {
        return this._text;
    }
    ;
    /**
     * Sets the text property value. Represents the axis title.
     * @param value Value to set for the text property.
     */
    set text(value) {
        this._text = value;
    }
    ;
    /**
     * Gets the visible property value. A boolean that specifies the visibility of an axis title.
     * @returns a boolean
     */
    get visible() {
        return this._visible;
    }
    ;
    /**
     * Sets the visible property value. A boolean that specifies the visibility of an axis title.
     * @param value Value to set for the visible property.
     */
    set visible(value) {
        this._visible = value;
    }
    ;
}
exports.WorkbookChartAxisTitle = WorkbookChartAxisTitle;
