"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkbookChartAxisTitleFormat = void 0;
const createWorkbookChartFontFromDiscriminatorValue_1 = require("./createWorkbookChartFontFromDiscriminatorValue");
const index_1 = require("./index");
class WorkbookChartAxisTitleFormat extends index_1.Entity {
    /**
     * Instantiates a new workbookChartAxisTitleFormat and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the font property value. Represents the font attributes, such as font name, font size, color, etc. of chart axis title object. Read-only.
     * @returns a workbookChartFont
     */
    get font() {
        return this._font;
    }
    ;
    /**
     * Sets the font property value. Represents the font attributes, such as font name, font size, color, etc. of chart axis title object. Read-only.
     * @param value Value to set for the font property.
     */
    set font(value) {
        this._font = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "font": (o, n) => { o.font = n.getObjectValue(createWorkbookChartFontFromDiscriminatorValue_1.createWorkbookChartFontFromDiscriminatorValue); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("font", this.font);
    }
    ;
}
exports.WorkbookChartAxisTitleFormat = WorkbookChartAxisTitleFormat;
