import { Entity, WorkbookChartFill, WorkbookChartFont } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class WorkbookChartDataLabelFormat extends Entity implements Parsable {
    /** Represents the fill format of the current chart data label. Read-only.  */
    private _fill?;
    /** Represents the font attributes (font name, font size, color, etc.) for a chart data label. Read-only.  */
    private _font?;
    /**
     * Instantiates a new workbookChartDataLabelFormat and sets the default values.
     */
    constructor();
    /**
     * Gets the fill property value. Represents the fill format of the current chart data label. Read-only.
     * @returns a workbookChartFill
     */
    get fill(): WorkbookChartFill | undefined;
    /**
     * Sets the fill property value. Represents the fill format of the current chart data label. Read-only.
     * @param value Value to set for the fill property.
     */
    set fill(value: WorkbookChartFill | undefined);
    /**
     * Gets the font property value. Represents the font attributes (font name, font size, color, etc.) for a chart data label. Read-only.
     * @returns a workbookChartFont
     */
    get font(): WorkbookChartFont | undefined;
    /**
     * Sets the font property value. Represents the font attributes (font name, font size, color, etc.) for a chart data label. Read-only.
     * @param value Value to set for the font property.
     */
    set font(value: WorkbookChartFont | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
