import { Entity, WorkbookChartDataLabelFormat } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class WorkbookChartDataLabels extends Entity implements Parsable {
    /** Represents the format of chart data labels, which includes fill and font formatting. Read-only.  */
    private _format?;
    /** DataLabelPosition value that represents the position of the data label. The possible values are: None, Center, InsideEnd, InsideBase, OutsideEnd, Left, Right, Top, Bottom, BestFit, Callout.  */
    private _position?;
    /** String representing the separator used for the data labels on a chart.  */
    private _separator?;
    /** Boolean value representing if the data label bubble size is visible or not.  */
    private _showBubbleSize?;
    /** Boolean value representing if the data label category name is visible or not.  */
    private _showCategoryName?;
    /** Boolean value representing if the data label legend key is visible or not.  */
    private _showLegendKey?;
    /** Boolean value representing if the data label percentage is visible or not.  */
    private _showPercentage?;
    /** Boolean value representing if the data label series name is visible or not.  */
    private _showSeriesName?;
    /** Boolean value representing if the data label value is visible or not.  */
    private _showValue?;
    /**
     * Instantiates a new workbookChartDataLabels and sets the default values.
     */
    constructor();
    /**
     * Gets the format property value. Represents the format of chart data labels, which includes fill and font formatting. Read-only.
     * @returns a workbookChartDataLabelFormat
     */
    get format(): WorkbookChartDataLabelFormat | undefined;
    /**
     * Sets the format property value. Represents the format of chart data labels, which includes fill and font formatting. Read-only.
     * @param value Value to set for the format property.
     */
    set format(value: WorkbookChartDataLabelFormat | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the position property value. DataLabelPosition value that represents the position of the data label. The possible values are: None, Center, InsideEnd, InsideBase, OutsideEnd, Left, Right, Top, Bottom, BestFit, Callout.
     * @returns a string
     */
    get position(): string | undefined;
    /**
     * Sets the position property value. DataLabelPosition value that represents the position of the data label. The possible values are: None, Center, InsideEnd, InsideBase, OutsideEnd, Left, Right, Top, Bottom, BestFit, Callout.
     * @param value Value to set for the position property.
     */
    set position(value: string | undefined);
    /**
     * Gets the separator property value. String representing the separator used for the data labels on a chart.
     * @returns a string
     */
    get separator(): string | undefined;
    /**
     * Sets the separator property value. String representing the separator used for the data labels on a chart.
     * @param value Value to set for the separator property.
     */
    set separator(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the showBubbleSize property value. Boolean value representing if the data label bubble size is visible or not.
     * @returns a boolean
     */
    get showBubbleSize(): boolean | undefined;
    /**
     * Sets the showBubbleSize property value. Boolean value representing if the data label bubble size is visible or not.
     * @param value Value to set for the showBubbleSize property.
     */
    set showBubbleSize(value: boolean | undefined);
    /**
     * Gets the showCategoryName property value. Boolean value representing if the data label category name is visible or not.
     * @returns a boolean
     */
    get showCategoryName(): boolean | undefined;
    /**
     * Sets the showCategoryName property value. Boolean value representing if the data label category name is visible or not.
     * @param value Value to set for the showCategoryName property.
     */
    set showCategoryName(value: boolean | undefined);
    /**
     * Gets the showLegendKey property value. Boolean value representing if the data label legend key is visible or not.
     * @returns a boolean
     */
    get showLegendKey(): boolean | undefined;
    /**
     * Sets the showLegendKey property value. Boolean value representing if the data label legend key is visible or not.
     * @param value Value to set for the showLegendKey property.
     */
    set showLegendKey(value: boolean | undefined);
    /**
     * Gets the showPercentage property value. Boolean value representing if the data label percentage is visible or not.
     * @returns a boolean
     */
    get showPercentage(): boolean | undefined;
    /**
     * Sets the showPercentage property value. Boolean value representing if the data label percentage is visible or not.
     * @param value Value to set for the showPercentage property.
     */
    set showPercentage(value: boolean | undefined);
    /**
     * Gets the showSeriesName property value. Boolean value representing if the data label series name is visible or not.
     * @returns a boolean
     */
    get showSeriesName(): boolean | undefined;
    /**
     * Sets the showSeriesName property value. Boolean value representing if the data label series name is visible or not.
     * @param value Value to set for the showSeriesName property.
     */
    set showSeriesName(value: boolean | undefined);
    /**
     * Gets the showValue property value. Boolean value representing if the data label value is visible or not.
     * @returns a boolean
     */
    get showValue(): boolean | undefined;
    /**
     * Sets the showValue property value. Boolean value representing if the data label value is visible or not.
     * @param value Value to set for the showValue property.
     */
    set showValue(value: boolean | undefined);
}
