"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkbookChartDataLabels = void 0;
const createWorkbookChartDataLabelFormatFromDiscriminatorValue_1 = require("./createWorkbookChartDataLabelFormatFromDiscriminatorValue");
const index_1 = require("./index");
class WorkbookChartDataLabels extends index_1.Entity {
    /**
     * Instantiates a new workbookChartDataLabels and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the format property value. Represents the format of chart data labels, which includes fill and font formatting. Read-only.
     * @returns a workbookChartDataLabelFormat
     */
    get format() {
        return this._format;
    }
    ;
    /**
     * Sets the format property value. Represents the format of chart data labels, which includes fill and font formatting. Read-only.
     * @param value Value to set for the format property.
     */
    set format(value) {
        this._format = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "format": (o, n) => { o.format = n.getObjectValue(createWorkbookChartDataLabelFormatFromDiscriminatorValue_1.createWorkbookChartDataLabelFormatFromDiscriminatorValue); }, "position": (o, n) => { o.position = n.getStringValue(); }, "separator": (o, n) => { o.separator = n.getStringValue(); }, "showBubbleSize": (o, n) => { o.showBubbleSize = n.getBooleanValue(); }, "showCategoryName": (o, n) => { o.showCategoryName = n.getBooleanValue(); }, "showLegendKey": (o, n) => { o.showLegendKey = n.getBooleanValue(); }, "showPercentage": (o, n) => { o.showPercentage = n.getBooleanValue(); }, "showSeriesName": (o, n) => { o.showSeriesName = n.getBooleanValue(); }, "showValue": (o, n) => { o.showValue = n.getBooleanValue(); } });
    }
    ;
    /**
     * Gets the position property value. DataLabelPosition value that represents the position of the data label. The possible values are: None, Center, InsideEnd, InsideBase, OutsideEnd, Left, Right, Top, Bottom, BestFit, Callout.
     * @returns a string
     */
    get position() {
        return this._position;
    }
    ;
    /**
     * Sets the position property value. DataLabelPosition value that represents the position of the data label. The possible values are: None, Center, InsideEnd, InsideBase, OutsideEnd, Left, Right, Top, Bottom, BestFit, Callout.
     * @param value Value to set for the position property.
     */
    set position(value) {
        this._position = value;
    }
    ;
    /**
     * Gets the separator property value. String representing the separator used for the data labels on a chart.
     * @returns a string
     */
    get separator() {
        return this._separator;
    }
    ;
    /**
     * Sets the separator property value. String representing the separator used for the data labels on a chart.
     * @param value Value to set for the separator property.
     */
    set separator(value) {
        this._separator = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("format", this.format);
        writer.writeStringValue("position", this.position);
        writer.writeStringValue("separator", this.separator);
        writer.writeBooleanValue("showBubbleSize", this.showBubbleSize);
        writer.writeBooleanValue("showCategoryName", this.showCategoryName);
        writer.writeBooleanValue("showLegendKey", this.showLegendKey);
        writer.writeBooleanValue("showPercentage", this.showPercentage);
        writer.writeBooleanValue("showSeriesName", this.showSeriesName);
        writer.writeBooleanValue("showValue", this.showValue);
    }
    ;
    /**
     * Gets the showBubbleSize property value. Boolean value representing if the data label bubble size is visible or not.
     * @returns a boolean
     */
    get showBubbleSize() {
        return this._showBubbleSize;
    }
    ;
    /**
     * Sets the showBubbleSize property value. Boolean value representing if the data label bubble size is visible or not.
     * @param value Value to set for the showBubbleSize property.
     */
    set showBubbleSize(value) {
        this._showBubbleSize = value;
    }
    ;
    /**
     * Gets the showCategoryName property value. Boolean value representing if the data label category name is visible or not.
     * @returns a boolean
     */
    get showCategoryName() {
        return this._showCategoryName;
    }
    ;
    /**
     * Sets the showCategoryName property value. Boolean value representing if the data label category name is visible or not.
     * @param value Value to set for the showCategoryName property.
     */
    set showCategoryName(value) {
        this._showCategoryName = value;
    }
    ;
    /**
     * Gets the showLegendKey property value. Boolean value representing if the data label legend key is visible or not.
     * @returns a boolean
     */
    get showLegendKey() {
        return this._showLegendKey;
    }
    ;
    /**
     * Sets the showLegendKey property value. Boolean value representing if the data label legend key is visible or not.
     * @param value Value to set for the showLegendKey property.
     */
    set showLegendKey(value) {
        this._showLegendKey = value;
    }
    ;
    /**
     * Gets the showPercentage property value. Boolean value representing if the data label percentage is visible or not.
     * @returns a boolean
     */
    get showPercentage() {
        return this._showPercentage;
    }
    ;
    /**
     * Sets the showPercentage property value. Boolean value representing if the data label percentage is visible or not.
     * @param value Value to set for the showPercentage property.
     */
    set showPercentage(value) {
        this._showPercentage = value;
    }
    ;
    /**
     * Gets the showSeriesName property value. Boolean value representing if the data label series name is visible or not.
     * @returns a boolean
     */
    get showSeriesName() {
        return this._showSeriesName;
    }
    ;
    /**
     * Sets the showSeriesName property value. Boolean value representing if the data label series name is visible or not.
     * @param value Value to set for the showSeriesName property.
     */
    set showSeriesName(value) {
        this._showSeriesName = value;
    }
    ;
    /**
     * Gets the showValue property value. Boolean value representing if the data label value is visible or not.
     * @returns a boolean
     */
    get showValue() {
        return this._showValue;
    }
    ;
    /**
     * Sets the showValue property value. Boolean value representing if the data label value is visible or not.
     * @param value Value to set for the showValue property.
     */
    set showValue(value) {
        this._showValue = value;
    }
    ;
}
exports.WorkbookChartDataLabels = WorkbookChartDataLabels;
