import { Entity, WorkbookChartLegendFormat } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class WorkbookChartLegend extends Entity implements Parsable {
    /** Represents the formatting of a chart legend, which includes fill and font formatting. Read-only.  */
    private _format?;
    /** Boolean value for whether the chart legend should overlap with the main body of the chart.  */
    private _overlay?;
    /** Represents the position of the legend on the chart. The possible values are: Top, Bottom, Left, Right, Corner, Custom.  */
    private _position?;
    /** A boolean value the represents the visibility of a ChartLegend object.  */
    private _visible?;
    /**
     * Instantiates a new workbookChartLegend and sets the default values.
     */
    constructor();
    /**
     * Gets the format property value. Represents the formatting of a chart legend, which includes fill and font formatting. Read-only.
     * @returns a workbookChartLegendFormat
     */
    get format(): WorkbookChartLegendFormat | undefined;
    /**
     * Sets the format property value. Represents the formatting of a chart legend, which includes fill and font formatting. Read-only.
     * @param value Value to set for the format property.
     */
    set format(value: WorkbookChartLegendFormat | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the overlay property value. Boolean value for whether the chart legend should overlap with the main body of the chart.
     * @returns a boolean
     */
    get overlay(): boolean | undefined;
    /**
     * Sets the overlay property value. Boolean value for whether the chart legend should overlap with the main body of the chart.
     * @param value Value to set for the overlay property.
     */
    set overlay(value: boolean | undefined);
    /**
     * Gets the position property value. Represents the position of the legend on the chart. The possible values are: Top, Bottom, Left, Right, Corner, Custom.
     * @returns a string
     */
    get position(): string | undefined;
    /**
     * Sets the position property value. Represents the position of the legend on the chart. The possible values are: Top, Bottom, Left, Right, Corner, Custom.
     * @param value Value to set for the position property.
     */
    set position(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the visible property value. A boolean value the represents the visibility of a ChartLegend object.
     * @returns a boolean
     */
    get visible(): boolean | undefined;
    /**
     * Sets the visible property value. A boolean value the represents the visibility of a ChartLegend object.
     * @param value Value to set for the visible property.
     */
    set visible(value: boolean | undefined);
}
