"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkbookChartLegend = void 0;
const createWorkbookChartLegendFormatFromDiscriminatorValue_1 = require("./createWorkbookChartLegendFormatFromDiscriminatorValue");
const index_1 = require("./index");
class WorkbookChartLegend extends index_1.Entity {
    /**
     * Instantiates a new workbookChartLegend and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the format property value. Represents the formatting of a chart legend, which includes fill and font formatting. Read-only.
     * @returns a workbookChartLegendFormat
     */
    get format() {
        return this._format;
    }
    ;
    /**
     * Sets the format property value. Represents the formatting of a chart legend, which includes fill and font formatting. Read-only.
     * @param value Value to set for the format property.
     */
    set format(value) {
        this._format = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "format": (o, n) => { o.format = n.getObjectValue(createWorkbookChartLegendFormatFromDiscriminatorValue_1.createWorkbookChartLegendFormatFromDiscriminatorValue); }, "overlay": (o, n) => { o.overlay = n.getBooleanValue(); }, "position": (o, n) => { o.position = n.getStringValue(); }, "visible": (o, n) => { o.visible = n.getBooleanValue(); } });
    }
    ;
    /**
     * Gets the overlay property value. Boolean value for whether the chart legend should overlap with the main body of the chart.
     * @returns a boolean
     */
    get overlay() {
        return this._overlay;
    }
    ;
    /**
     * Sets the overlay property value. Boolean value for whether the chart legend should overlap with the main body of the chart.
     * @param value Value to set for the overlay property.
     */
    set overlay(value) {
        this._overlay = value;
    }
    ;
    /**
     * Gets the position property value. Represents the position of the legend on the chart. The possible values are: Top, Bottom, Left, Right, Corner, Custom.
     * @returns a string
     */
    get position() {
        return this._position;
    }
    ;
    /**
     * Sets the position property value. Represents the position of the legend on the chart. The possible values are: Top, Bottom, Left, Right, Corner, Custom.
     * @param value Value to set for the position property.
     */
    set position(value) {
        this._position = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("format", this.format);
        writer.writeBooleanValue("overlay", this.overlay);
        writer.writeStringValue("position", this.position);
        writer.writeBooleanValue("visible", this.visible);
    }
    ;
    /**
     * Gets the visible property value. A boolean value the represents the visibility of a ChartLegend object.
     * @returns a boolean
     */
    get visible() {
        return this._visible;
    }
    ;
    /**
     * Sets the visible property value. A boolean value the represents the visibility of a ChartLegend object.
     * @param value Value to set for the visible property.
     */
    set visible(value) {
        this._visible = value;
    }
    ;
}
exports.WorkbookChartLegend = WorkbookChartLegend;
