"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkbookChartPoint = void 0;
const createJsonFromDiscriminatorValue_1 = require("./createJsonFromDiscriminatorValue");
const createWorkbookChartPointFormatFromDiscriminatorValue_1 = require("./createWorkbookChartPointFormatFromDiscriminatorValue");
const index_1 = require("./index");
class WorkbookChartPoint extends index_1.Entity {
    /**
     * Instantiates a new workbookChartPoint and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the format property value. Encapsulates the format properties chart point. Read-only.
     * @returns a workbookChartPointFormat
     */
    get format() {
        return this._format;
    }
    ;
    /**
     * Sets the format property value. Encapsulates the format properties chart point. Read-only.
     * @param value Value to set for the format property.
     */
    set format(value) {
        this._format = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "format": (o, n) => { o.format = n.getObjectValue(createWorkbookChartPointFormatFromDiscriminatorValue_1.createWorkbookChartPointFormatFromDiscriminatorValue); }, "value": (o, n) => { o.value = n.getObjectValue(createJsonFromDiscriminatorValue_1.createJsonFromDiscriminatorValue); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("format", this.format);
        writer.writeObjectValue("value", this.value);
    }
    ;
    /**
     * Gets the value property value. Returns the value of a chart point. Read-only.
     * @returns a Json
     */
    get value() {
        return this._value;
    }
    ;
    /**
     * Sets the value property value. Returns the value of a chart point. Read-only.
     * @param value Value to set for the value property.
     */
    set value(value) {
        this._value = value;
    }
    ;
}
exports.WorkbookChartPoint = WorkbookChartPoint;
