import { Entity, WorkbookChartFill } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class WorkbookChartPointFormat extends Entity implements Parsable {
    /** Represents the fill format of a chart, which includes background formating information. Read-only.  */
    private _fill?;
    /**
     * Instantiates a new workbookChartPointFormat and sets the default values.
     */
    constructor();
    /**
     * Gets the fill property value. Represents the fill format of a chart, which includes background formating information. Read-only.
     * @returns a workbookChartFill
     */
    get fill(): WorkbookChartFill | undefined;
    /**
     * Sets the fill property value. Represents the fill format of a chart, which includes background formating information. Read-only.
     * @param value Value to set for the fill property.
     */
    set fill(value: WorkbookChartFill | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
