import { Entity, WorkbookChartPoint, WorkbookChartSeriesFormat } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class WorkbookChartSeries extends Entity implements Parsable {
    /** Represents the formatting of a chart series, which includes fill and line formatting. Read-only.  */
    private _format?;
    /** Represents the name of a series in a chart.  */
    private _name?;
    /** Represents a collection of all points in the series. Read-only.  */
    private _points?;
    /**
     * Instantiates a new workbookChartSeries and sets the default values.
     */
    constructor();
    /**
     * Gets the format property value. Represents the formatting of a chart series, which includes fill and line formatting. Read-only.
     * @returns a workbookChartSeriesFormat
     */
    get format(): WorkbookChartSeriesFormat | undefined;
    /**
     * Sets the format property value. Represents the formatting of a chart series, which includes fill and line formatting. Read-only.
     * @param value Value to set for the format property.
     */
    set format(value: WorkbookChartSeriesFormat | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the name property value. Represents the name of a series in a chart.
     * @returns a string
     */
    get name(): string | undefined;
    /**
     * Sets the name property value. Represents the name of a series in a chart.
     * @param value Value to set for the name property.
     */
    set name(value: string | undefined);
    /**
     * Gets the points property value. Represents a collection of all points in the series. Read-only.
     * @returns a workbookChartPoint
     */
    get points(): WorkbookChartPoint[] | undefined;
    /**
     * Sets the points property value. Represents a collection of all points in the series. Read-only.
     * @param value Value to set for the points property.
     */
    set points(value: WorkbookChartPoint[] | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
