import { Entity, WorkbookChartFill, WorkbookChartLineFormat } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class WorkbookChartSeriesFormat extends Entity implements Parsable {
    /** Represents the fill format of a chart series, which includes background formating information. Read-only.  */
    private _fill?;
    /** Represents line formatting. Read-only.  */
    private _line?;
    /**
     * Instantiates a new workbookChartSeriesFormat and sets the default values.
     */
    constructor();
    /**
     * Gets the fill property value. Represents the fill format of a chart series, which includes background formating information. Read-only.
     * @returns a workbookChartFill
     */
    get fill(): WorkbookChartFill | undefined;
    /**
     * Sets the fill property value. Represents the fill format of a chart series, which includes background formating information. Read-only.
     * @param value Value to set for the fill property.
     */
    set fill(value: WorkbookChartFill | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the line property value. Represents line formatting. Read-only.
     * @returns a workbookChartLineFormat
     */
    get line(): WorkbookChartLineFormat | undefined;
    /**
     * Sets the line property value. Represents line formatting. Read-only.
     * @param value Value to set for the line property.
     */
    set line(value: WorkbookChartLineFormat | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
