"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkbookChartSeriesFormat = void 0;
const createWorkbookChartFillFromDiscriminatorValue_1 = require("./createWorkbookChartFillFromDiscriminatorValue");
const createWorkbookChartLineFormatFromDiscriminatorValue_1 = require("./createWorkbookChartLineFormatFromDiscriminatorValue");
const index_1 = require("./index");
class WorkbookChartSeriesFormat extends index_1.Entity {
    /**
     * Instantiates a new workbookChartSeriesFormat and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the fill property value. Represents the fill format of a chart series, which includes background formating information. Read-only.
     * @returns a workbookChartFill
     */
    get fill() {
        return this._fill;
    }
    ;
    /**
     * Sets the fill property value. Represents the fill format of a chart series, which includes background formating information. Read-only.
     * @param value Value to set for the fill property.
     */
    set fill(value) {
        this._fill = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "fill": (o, n) => { o.fill = n.getObjectValue(createWorkbookChartFillFromDiscriminatorValue_1.createWorkbookChartFillFromDiscriminatorValue); }, "line": (o, n) => { o.line = n.getObjectValue(createWorkbookChartLineFormatFromDiscriminatorValue_1.createWorkbookChartLineFormatFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the line property value. Represents line formatting. Read-only.
     * @returns a workbookChartLineFormat
     */
    get line() {
        return this._line;
    }
    ;
    /**
     * Sets the line property value. Represents line formatting. Read-only.
     * @param value Value to set for the line property.
     */
    set line(value) {
        this._line = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("fill", this.fill);
        writer.writeObjectValue("line", this.line);
    }
    ;
}
exports.WorkbookChartSeriesFormat = WorkbookChartSeriesFormat;
