import { Entity, WorkbookChartTitleFormat } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class WorkbookChartTitle extends Entity implements Parsable {
    /** Represents the formatting of a chart title, which includes fill and font formatting. Read-only.  */
    private _format?;
    /** Boolean value representing if the chart title will overlay the chart or not.  */
    private _overlay?;
    /** Represents the title text of a chart.  */
    private _text?;
    /** A boolean value the represents the visibility of a chart title object.  */
    private _visible?;
    /**
     * Instantiates a new workbookChartTitle and sets the default values.
     */
    constructor();
    /**
     * Gets the format property value. Represents the formatting of a chart title, which includes fill and font formatting. Read-only.
     * @returns a workbookChartTitleFormat
     */
    get format(): WorkbookChartTitleFormat | undefined;
    /**
     * Sets the format property value. Represents the formatting of a chart title, which includes fill and font formatting. Read-only.
     * @param value Value to set for the format property.
     */
    set format(value: WorkbookChartTitleFormat | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the overlay property value. Boolean value representing if the chart title will overlay the chart or not.
     * @returns a boolean
     */
    get overlay(): boolean | undefined;
    /**
     * Sets the overlay property value. Boolean value representing if the chart title will overlay the chart or not.
     * @param value Value to set for the overlay property.
     */
    set overlay(value: boolean | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the text property value. Represents the title text of a chart.
     * @returns a string
     */
    get text(): string | undefined;
    /**
     * Sets the text property value. Represents the title text of a chart.
     * @param value Value to set for the text property.
     */
    set text(value: string | undefined);
    /**
     * Gets the visible property value. A boolean value the represents the visibility of a chart title object.
     * @returns a boolean
     */
    get visible(): boolean | undefined;
    /**
     * Sets the visible property value. A boolean value the represents the visibility of a chart title object.
     * @param value Value to set for the visible property.
     */
    set visible(value: boolean | undefined);
}
