"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkbookChartTitle = void 0;
const createWorkbookChartTitleFormatFromDiscriminatorValue_1 = require("./createWorkbookChartTitleFormatFromDiscriminatorValue");
const index_1 = require("./index");
class WorkbookChartTitle extends index_1.Entity {
    /**
     * Instantiates a new workbookChartTitle and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the format property value. Represents the formatting of a chart title, which includes fill and font formatting. Read-only.
     * @returns a workbookChartTitleFormat
     */
    get format() {
        return this._format;
    }
    ;
    /**
     * Sets the format property value. Represents the formatting of a chart title, which includes fill and font formatting. Read-only.
     * @param value Value to set for the format property.
     */
    set format(value) {
        this._format = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "format": (o, n) => { o.format = n.getObjectValue(createWorkbookChartTitleFormatFromDiscriminatorValue_1.createWorkbookChartTitleFormatFromDiscriminatorValue); }, "overlay": (o, n) => { o.overlay = n.getBooleanValue(); }, "text": (o, n) => { o.text = n.getStringValue(); }, "visible": (o, n) => { o.visible = n.getBooleanValue(); } });
    }
    ;
    /**
     * Gets the overlay property value. Boolean value representing if the chart title will overlay the chart or not.
     * @returns a boolean
     */
    get overlay() {
        return this._overlay;
    }
    ;
    /**
     * Sets the overlay property value. Boolean value representing if the chart title will overlay the chart or not.
     * @param value Value to set for the overlay property.
     */
    set overlay(value) {
        this._overlay = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("format", this.format);
        writer.writeBooleanValue("overlay", this.overlay);
        writer.writeStringValue("text", this.text);
        writer.writeBooleanValue("visible", this.visible);
    }
    ;
    /**
     * Gets the text property value. Represents the title text of a chart.
     * @returns a string
     */
    get text() {
        return this._text;
    }
    ;
    /**
     * Sets the text property value. Represents the title text of a chart.
     * @param value Value to set for the text property.
     */
    set text(value) {
        this._text = value;
    }
    ;
    /**
     * Gets the visible property value. A boolean value the represents the visibility of a chart title object.
     * @returns a boolean
     */
    get visible() {
        return this._visible;
    }
    ;
    /**
     * Sets the visible property value. A boolean value the represents the visibility of a chart title object.
     * @param value Value to set for the visible property.
     */
    set visible(value) {
        this._visible = value;
    }
    ;
}
exports.WorkbookChartTitle = WorkbookChartTitle;
