import { Entity, WorkbookFilterCriteria } from './index';
import { Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class WorkbookFilter extends Entity implements Parsable {
    /** The currently applied filter on the given column. Read-only.  */
    private _criteria?;
    /**
     * Instantiates a new workbookFilter and sets the default values.
     */
    constructor();
    /**
     * Gets the criteria property value. The currently applied filter on the given column. Read-only.
     * @returns a workbookFilterCriteria
     */
    get criteria(): WorkbookFilterCriteria | undefined;
    /**
     * Sets the criteria property value. The currently applied filter on the given column. Read-only.
     * @param value Value to set for the criteria property.
     */
    set criteria(value: WorkbookFilterCriteria | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
