"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkbookFilter = void 0;
const createWorkbookFilterCriteriaFromDiscriminatorValue_1 = require("./createWorkbookFilterCriteriaFromDiscriminatorValue");
const index_1 = require("./index");
class WorkbookFilter extends index_1.Entity {
    /**
     * Instantiates a new workbookFilter and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the criteria property value. The currently applied filter on the given column. Read-only.
     * @returns a workbookFilterCriteria
     */
    get criteria() {
        return this._criteria;
    }
    ;
    /**
     * Sets the criteria property value. The currently applied filter on the given column. Read-only.
     * @param value Value to set for the criteria property.
     */
    set criteria(value) {
        this._criteria = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "criteria": (o, n) => { o.criteria = n.getObjectValue(createWorkbookFilterCriteriaFromDiscriminatorValue_1.createWorkbookFilterCriteriaFromDiscriminatorValue); } });
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("criteria", this.criteria);
    }
    ;
}
exports.WorkbookFilter = WorkbookFilter;
