"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkbookFilterCriteria = void 0;
const createJsonFromDiscriminatorValue_1 = require("./createJsonFromDiscriminatorValue");
const createWorkbookIconFromDiscriminatorValue_1 = require("./createWorkbookIconFromDiscriminatorValue");
class WorkbookFilterCriteria {
    /**
     * Instantiates a new workbookFilterCriteria and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the color property value.
     * @returns a string
     */
    get color() {
        return this._color;
    }
    ;
    /**
     * Sets the color property value.
     * @param value Value to set for the color property.
     */
    set color(value) {
        this._color = value;
    }
    ;
    ;
    /**
     * Gets the criterion1 property value.
     * @returns a string
     */
    get criterion1() {
        return this._criterion1;
    }
    ;
    /**
     * Sets the criterion1 property value.
     * @param value Value to set for the criterion1 property.
     */
    set criterion1(value) {
        this._criterion1 = value;
    }
    ;
    /**
     * Gets the criterion2 property value.
     * @returns a string
     */
    get criterion2() {
        return this._criterion2;
    }
    ;
    /**
     * Sets the criterion2 property value.
     * @param value Value to set for the criterion2 property.
     */
    set criterion2(value) {
        this._criterion2 = value;
    }
    ;
    /**
     * Gets the dynamicCriteria property value.
     * @returns a string
     */
    get dynamicCriteria() {
        return this._dynamicCriteria;
    }
    ;
    /**
     * Sets the dynamicCriteria property value.
     * @param value Value to set for the dynamicCriteria property.
     */
    set dynamicCriteria(value) {
        this._dynamicCriteria = value;
    }
    ;
    /**
     * Gets the filterOn property value.
     * @returns a string
     */
    get filterOn() {
        return this._filterOn;
    }
    ;
    /**
     * Sets the filterOn property value.
     * @param value Value to set for the filterOn property.
     */
    set filterOn(value) {
        this._filterOn = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "color": (o, n) => { o.color = n.getStringValue(); },
            "criterion1": (o, n) => { o.criterion1 = n.getStringValue(); },
            "criterion2": (o, n) => { o.criterion2 = n.getStringValue(); },
            "dynamicCriteria": (o, n) => { o.dynamicCriteria = n.getStringValue(); },
            "filterOn": (o, n) => { o.filterOn = n.getStringValue(); },
            "icon": (o, n) => { o.icon = n.getObjectValue(createWorkbookIconFromDiscriminatorValue_1.createWorkbookIconFromDiscriminatorValue); },
            "operator": (o, n) => { o.operator = n.getStringValue(); },
            "values": (o, n) => { o.values = n.getObjectValue(createJsonFromDiscriminatorValue_1.createJsonFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the icon property value.
     * @returns a workbookIcon
     */
    get icon() {
        return this._icon;
    }
    ;
    /**
     * Sets the icon property value.
     * @param value Value to set for the icon property.
     */
    set icon(value) {
        this._icon = value;
    }
    ;
    /**
     * Gets the operator property value.
     * @returns a string
     */
    get operator() {
        return this._operator;
    }
    ;
    /**
     * Sets the operator property value.
     * @param value Value to set for the operator property.
     */
    set operator(value) {
        this._operator = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("color", this.color);
        writer.writeStringValue("criterion1", this.criterion1);
        writer.writeStringValue("criterion2", this.criterion2);
        writer.writeStringValue("dynamicCriteria", this.dynamicCriteria);
        writer.writeStringValue("filterOn", this.filterOn);
        writer.writeObjectValue("icon", this.icon);
        writer.writeStringValue("operator", this.operator);
        writer.writeObjectValue("values", this.values);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the values property value.
     * @returns a Json
     */
    get values() {
        return this._values;
    }
    ;
    /**
     * Sets the values property value.
     * @param value Value to set for the values property.
     */
    set values(value) {
        this._values = value;
    }
    ;
}
exports.WorkbookFilterCriteria = WorkbookFilterCriteria;
