"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkbookIcon = void 0;
class WorkbookIcon {
    /**
     * Instantiates a new workbookIcon and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "index": (o, n) => { o.index = n.getNumberValue(); },
            "set": (o, n) => { o.set = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the index property value. Represents the index of the icon in the given set.
     * @returns a integer
     */
    get index() {
        return this._index;
    }
    ;
    /**
     * Sets the index property value. Represents the index of the icon in the given set.
     * @param value Value to set for the index property.
     */
    set index(value) {
        this._index = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeNumberValue("index", this.index);
        writer.writeStringValue("set", this.set);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the set property value. Represents the set that the icon is part of. The possible values are: Invalid, ThreeArrows, ThreeArrowsGray, ThreeFlags, ThreeTrafficLights1, ThreeTrafficLights2, ThreeSigns, ThreeSymbols, ThreeSymbols2, FourArrows, FourArrowsGray, FourRedToBlack, FourRating, FourTrafficLights, FiveArrows, FiveArrowsGray, FiveRating, FiveQuarters, ThreeStars, ThreeTriangles, FiveBoxes.
     * @returns a string
     */
    get set() {
        return this._set;
    }
    ;
    /**
     * Sets the set property value. Represents the set that the icon is part of. The possible values are: Invalid, ThreeArrows, ThreeArrowsGray, ThreeFlags, ThreeTrafficLights1, ThreeTrafficLights2, ThreeSigns, ThreeSymbols, ThreeSymbols2, FourArrows, FourArrowsGray, FourRedToBlack, FourRating, FourTrafficLights, FiveArrows, FiveArrowsGray, FiveRating, FiveQuarters, ThreeStars, ThreeTriangles, FiveBoxes.
     * @param value Value to set for the set property.
     */
    set set(value) {
        this._set = value;
    }
    ;
}
exports.WorkbookIcon = WorkbookIcon;
