"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkbookTable = void 0;
const createWorkbookTableColumnFromDiscriminatorValue_1 = require("./createWorkbookTableColumnFromDiscriminatorValue");
const createWorkbookTableRowFromDiscriminatorValue_1 = require("./createWorkbookTableRowFromDiscriminatorValue");
const createWorkbookTableSortFromDiscriminatorValue_1 = require("./createWorkbookTableSortFromDiscriminatorValue");
const createWorkbookWorksheetFromDiscriminatorValue_1 = require("./createWorkbookWorksheetFromDiscriminatorValue");
const index_1 = require("./index");
class WorkbookTable extends index_1.Entity {
    /**
     * Instantiates a new workbookTable and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the columns property value. Represents a collection of all the columns in the table. Read-only.
     * @returns a workbookTableColumn
     */
    get columns() {
        return this._columns;
    }
    ;
    /**
     * Sets the columns property value. Represents a collection of all the columns in the table. Read-only.
     * @param value Value to set for the columns property.
     */
    set columns(value) {
        this._columns = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "columns": (o, n) => { o.columns = n.getCollectionOfObjectValues(createWorkbookTableColumnFromDiscriminatorValue_1.createWorkbookTableColumnFromDiscriminatorValue); }, "highlightFirstColumn": (o, n) => { o.highlightFirstColumn = n.getBooleanValue(); }, "highlightLastColumn": (o, n) => { o.highlightLastColumn = n.getBooleanValue(); }, "legacyId": (o, n) => { o.legacyId = n.getStringValue(); }, "name": (o, n) => { o.name = n.getStringValue(); }, "rows": (o, n) => { o.rows = n.getCollectionOfObjectValues(createWorkbookTableRowFromDiscriminatorValue_1.createWorkbookTableRowFromDiscriminatorValue); }, "showBandedColumns": (o, n) => { o.showBandedColumns = n.getBooleanValue(); }, "showBandedRows": (o, n) => { o.showBandedRows = n.getBooleanValue(); }, "showFilterButton": (o, n) => { o.showFilterButton = n.getBooleanValue(); }, "showHeaders": (o, n) => { o.showHeaders = n.getBooleanValue(); }, "showTotals": (o, n) => { o.showTotals = n.getBooleanValue(); }, "sort": (o, n) => { o.sort = n.getObjectValue(createWorkbookTableSortFromDiscriminatorValue_1.createWorkbookTableSortFromDiscriminatorValue); }, "style": (o, n) => { o.style = n.getStringValue(); }, "worksheet": (o, n) => { o.worksheet = n.getObjectValue(createWorkbookWorksheetFromDiscriminatorValue_1.createWorkbookWorksheetFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the highlightFirstColumn property value. Indicates whether the first column contains special formatting.
     * @returns a boolean
     */
    get highlightFirstColumn() {
        return this._highlightFirstColumn;
    }
    ;
    /**
     * Sets the highlightFirstColumn property value. Indicates whether the first column contains special formatting.
     * @param value Value to set for the highlightFirstColumn property.
     */
    set highlightFirstColumn(value) {
        this._highlightFirstColumn = value;
    }
    ;
    /**
     * Gets the highlightLastColumn property value. Indicates whether the last column contains special formatting.
     * @returns a boolean
     */
    get highlightLastColumn() {
        return this._highlightLastColumn;
    }
    ;
    /**
     * Sets the highlightLastColumn property value. Indicates whether the last column contains special formatting.
     * @param value Value to set for the highlightLastColumn property.
     */
    set highlightLastColumn(value) {
        this._highlightLastColumn = value;
    }
    ;
    /**
     * Gets the legacyId property value. Legacy Id used in older Excle clients. The value of the identifier remains the same even when the table is renamed. This property should be interpreted as an opaque string value and should not be parsed to any other type. Read-only.
     * @returns a string
     */
    get legacyId() {
        return this._legacyId;
    }
    ;
    /**
     * Sets the legacyId property value. Legacy Id used in older Excle clients. The value of the identifier remains the same even when the table is renamed. This property should be interpreted as an opaque string value and should not be parsed to any other type. Read-only.
     * @param value Value to set for the legacyId property.
     */
    set legacyId(value) {
        this._legacyId = value;
    }
    ;
    /**
     * Gets the name property value. Name of the table.
     * @returns a string
     */
    get name() {
        return this._name;
    }
    ;
    /**
     * Sets the name property value. Name of the table.
     * @param value Value to set for the name property.
     */
    set name(value) {
        this._name = value;
    }
    ;
    /**
     * Gets the rows property value. Represents a collection of all the rows in the table. Read-only.
     * @returns a workbookTableRow
     */
    get rows() {
        return this._rows;
    }
    ;
    /**
     * Sets the rows property value. Represents a collection of all the rows in the table. Read-only.
     * @param value Value to set for the rows property.
     */
    set rows(value) {
        this._rows = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("columns", this.columns);
        writer.writeBooleanValue("highlightFirstColumn", this.highlightFirstColumn);
        writer.writeBooleanValue("highlightLastColumn", this.highlightLastColumn);
        writer.writeStringValue("legacyId", this.legacyId);
        writer.writeStringValue("name", this.name);
        writer.writeCollectionOfObjectValues("rows", this.rows);
        writer.writeBooleanValue("showBandedColumns", this.showBandedColumns);
        writer.writeBooleanValue("showBandedRows", this.showBandedRows);
        writer.writeBooleanValue("showFilterButton", this.showFilterButton);
        writer.writeBooleanValue("showHeaders", this.showHeaders);
        writer.writeBooleanValue("showTotals", this.showTotals);
        writer.writeObjectValue("sort", this.sort);
        writer.writeStringValue("style", this.style);
        writer.writeObjectValue("worksheet", this.worksheet);
    }
    ;
    /**
     * Gets the showBandedColumns property value. Indicates whether the columns show banded formatting in which odd columns are highlighted differently from even ones to make reading the table easier.
     * @returns a boolean
     */
    get showBandedColumns() {
        return this._showBandedColumns;
    }
    ;
    /**
     * Sets the showBandedColumns property value. Indicates whether the columns show banded formatting in which odd columns are highlighted differently from even ones to make reading the table easier.
     * @param value Value to set for the showBandedColumns property.
     */
    set showBandedColumns(value) {
        this._showBandedColumns = value;
    }
    ;
    /**
     * Gets the showBandedRows property value. Indicates whether the rows show banded formatting in which odd rows are highlighted differently from even ones to make reading the table easier.
     * @returns a boolean
     */
    get showBandedRows() {
        return this._showBandedRows;
    }
    ;
    /**
     * Sets the showBandedRows property value. Indicates whether the rows show banded formatting in which odd rows are highlighted differently from even ones to make reading the table easier.
     * @param value Value to set for the showBandedRows property.
     */
    set showBandedRows(value) {
        this._showBandedRows = value;
    }
    ;
    /**
     * Gets the showFilterButton property value. Indicates whether the filter buttons are visible at the top of each column header. Setting this is only allowed if the table contains a header row.
     * @returns a boolean
     */
    get showFilterButton() {
        return this._showFilterButton;
    }
    ;
    /**
     * Sets the showFilterButton property value. Indicates whether the filter buttons are visible at the top of each column header. Setting this is only allowed if the table contains a header row.
     * @param value Value to set for the showFilterButton property.
     */
    set showFilterButton(value) {
        this._showFilterButton = value;
    }
    ;
    /**
     * Gets the showHeaders property value. Indicates whether the header row is visible or not. This value can be set to show or remove the header row.
     * @returns a boolean
     */
    get showHeaders() {
        return this._showHeaders;
    }
    ;
    /**
     * Sets the showHeaders property value. Indicates whether the header row is visible or not. This value can be set to show or remove the header row.
     * @param value Value to set for the showHeaders property.
     */
    set showHeaders(value) {
        this._showHeaders = value;
    }
    ;
    /**
     * Gets the showTotals property value. Indicates whether the total row is visible or not. This value can be set to show or remove the total row.
     * @returns a boolean
     */
    get showTotals() {
        return this._showTotals;
    }
    ;
    /**
     * Sets the showTotals property value. Indicates whether the total row is visible or not. This value can be set to show or remove the total row.
     * @param value Value to set for the showTotals property.
     */
    set showTotals(value) {
        this._showTotals = value;
    }
    ;
    /**
     * Gets the sort property value. Represents the sorting for the table. Read-only.
     * @returns a workbookTableSort
     */
    get sort() {
        return this._sort;
    }
    ;
    /**
     * Sets the sort property value. Represents the sorting for the table. Read-only.
     * @param value Value to set for the sort property.
     */
    set sort(value) {
        this._sort = value;
    }
    ;
    /**
     * Gets the style property value. Constant value that represents the Table style. The possible values are: TableStyleLight1 thru TableStyleLight21, TableStyleMedium1 thru TableStyleMedium28, TableStyleStyleDark1 thru TableStyleStyleDark11. A custom user-defined style present in the workbook can also be specified.
     * @returns a string
     */
    get style() {
        return this._style;
    }
    ;
    /**
     * Sets the style property value. Constant value that represents the Table style. The possible values are: TableStyleLight1 thru TableStyleLight21, TableStyleMedium1 thru TableStyleMedium28, TableStyleStyleDark1 thru TableStyleStyleDark11. A custom user-defined style present in the workbook can also be specified.
     * @param value Value to set for the style property.
     */
    set style(value) {
        this._style = value;
    }
    ;
    /**
     * Gets the worksheet property value. The worksheet containing the current table. Read-only.
     * @returns a workbookWorksheet
     */
    get worksheet() {
        return this._worksheet;
    }
    ;
    /**
     * Sets the worksheet property value. The worksheet containing the current table. Read-only.
     * @param value Value to set for the worksheet property.
     */
    set worksheet(value) {
        this._worksheet = value;
    }
    ;
}
exports.WorkbookTable = WorkbookTable;
