"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkbookTableColumn = void 0;
const createJsonFromDiscriminatorValue_1 = require("./createJsonFromDiscriminatorValue");
const createWorkbookFilterFromDiscriminatorValue_1 = require("./createWorkbookFilterFromDiscriminatorValue");
const index_1 = require("./index");
class WorkbookTableColumn extends index_1.Entity {
    /**
     * Instantiates a new workbookTableColumn and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * Gets the filter property value. Retrieve the filter applied to the column. Read-only.
     * @returns a workbookFilter
     */
    get filter() {
        return this._filter;
    }
    ;
    /**
     * Sets the filter property value. Retrieve the filter applied to the column. Read-only.
     * @param value Value to set for the filter property.
     */
    set filter(value) {
        this._filter = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "filter": (o, n) => { o.filter = n.getObjectValue(createWorkbookFilterFromDiscriminatorValue_1.createWorkbookFilterFromDiscriminatorValue); }, "index": (o, n) => { o.index = n.getNumberValue(); }, "name": (o, n) => { o.name = n.getStringValue(); }, "values": (o, n) => { o.values = n.getObjectValue(createJsonFromDiscriminatorValue_1.createJsonFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the index property value. Returns the index number of the column within the columns collection of the table. Zero-indexed. Read-only.
     * @returns a integer
     */
    get index() {
        return this._index;
    }
    ;
    /**
     * Sets the index property value. Returns the index number of the column within the columns collection of the table. Zero-indexed. Read-only.
     * @param value Value to set for the index property.
     */
    set index(value) {
        this._index = value;
    }
    ;
    /**
     * Gets the name property value. Returns the name of the table column.
     * @returns a string
     */
    get name() {
        return this._name;
    }
    ;
    /**
     * Sets the name property value. Returns the name of the table column.
     * @param value Value to set for the name property.
     */
    set name(value) {
        this._name = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeObjectValue("filter", this.filter);
        writer.writeNumberValue("index", this.index);
        writer.writeStringValue("name", this.name);
        writer.writeObjectValue("values", this.values);
    }
    ;
    /**
     * Gets the values property value. Represents the raw values of the specified range. The data returned could be of type string, number, or a boolean. Cell that contain an error will return the error string.
     * @returns a Json
     */
    get values() {
        return this._values;
    }
    ;
    /**
     * Sets the values property value. Represents the raw values of the specified range. The data returned could be of type string, number, or a boolean. Cell that contain an error will return the error string.
     * @param value Value to set for the values property.
     */
    set values(value) {
        this._values = value;
    }
    ;
}
exports.WorkbookTableColumn = WorkbookTableColumn;
