"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkbookTableRow = void 0;
const createJsonFromDiscriminatorValue_1 = require("./createJsonFromDiscriminatorValue");
const index_1 = require("./index");
class WorkbookTableRow extends index_1.Entity {
    /**
     * Instantiates a new workbookTableRow and sets the default values.
     */
    constructor() {
        super();
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "index": (o, n) => { o.index = n.getNumberValue(); }, "values": (o, n) => { o.values = n.getObjectValue(createJsonFromDiscriminatorValue_1.createJsonFromDiscriminatorValue); } });
    }
    ;
    /**
     * Gets the index property value. Returns the index number of the row within the rows collection of the table. Zero-indexed. Read-only.
     * @returns a integer
     */
    get index() {
        return this._index;
    }
    ;
    /**
     * Sets the index property value. Returns the index number of the row within the rows collection of the table. Zero-indexed. Read-only.
     * @param value Value to set for the index property.
     */
    set index(value) {
        this._index = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeNumberValue("index", this.index);
        writer.writeObjectValue("values", this.values);
    }
    ;
    /**
     * Gets the values property value. Represents the raw values of the specified range. The data returned could be of type string, number, or a boolean. Cell that contain an error will return the error string.
     * @returns a Json
     */
    get values() {
        return this._values;
    }
    ;
    /**
     * Sets the values property value. Represents the raw values of the specified range. The data returned could be of type string, number, or a boolean. Cell that contain an error will return the error string.
     * @param value Value to set for the values property.
     */
    set values(value) {
        this._values = value;
    }
    ;
}
exports.WorkbookTableRow = WorkbookTableRow;
