"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkbookWorksheet = void 0;
const createWorkbookChartFromDiscriminatorValue_1 = require("./createWorkbookChartFromDiscriminatorValue");
const createWorkbookNamedItemFromDiscriminatorValue_1 = require("./createWorkbookNamedItemFromDiscriminatorValue");
const createWorkbookPivotTableFromDiscriminatorValue_1 = require("./createWorkbookPivotTableFromDiscriminatorValue");
const createWorkbookTableFromDiscriminatorValue_1 = require("./createWorkbookTableFromDiscriminatorValue");
const createWorkbookWorksheetProtectionFromDiscriminatorValue_1 = require("./createWorkbookWorksheetProtectionFromDiscriminatorValue");
const index_1 = require("./index");
class WorkbookWorksheet extends index_1.Entity {
    /**
     * Instantiates a new workbookWorksheet and sets the default values.
     */
    constructor() {
        super();
    }
    /**
     * Gets the charts property value. Returns collection of charts that are part of the worksheet. Read-only.
     * @returns a workbookChart
     */
    get charts() {
        return this._charts;
    }
    ;
    /**
     * Sets the charts property value. Returns collection of charts that are part of the worksheet. Read-only.
     * @param value Value to set for the charts property.
     */
    set charts(value) {
        this._charts = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return Object.assign(Object.assign({}, super.getFieldDeserializers()), { "charts": (o, n) => { o.charts = n.getCollectionOfObjectValues(createWorkbookChartFromDiscriminatorValue_1.createWorkbookChartFromDiscriminatorValue); }, "name": (o, n) => { o.name = n.getStringValue(); }, "names": (o, n) => { o.names = n.getCollectionOfObjectValues(createWorkbookNamedItemFromDiscriminatorValue_1.createWorkbookNamedItemFromDiscriminatorValue); }, "pivotTables": (o, n) => { o.pivotTables = n.getCollectionOfObjectValues(createWorkbookPivotTableFromDiscriminatorValue_1.createWorkbookPivotTableFromDiscriminatorValue); }, "position": (o, n) => { o.position = n.getNumberValue(); }, "protection": (o, n) => { o.protection = n.getObjectValue(createWorkbookWorksheetProtectionFromDiscriminatorValue_1.createWorkbookWorksheetProtectionFromDiscriminatorValue); }, "tables": (o, n) => { o.tables = n.getCollectionOfObjectValues(createWorkbookTableFromDiscriminatorValue_1.createWorkbookTableFromDiscriminatorValue); }, "visibility": (o, n) => { o.visibility = n.getStringValue(); } });
    }
    ;
    /**
     * Gets the name property value. The display name of the worksheet.
     * @returns a string
     */
    get name() {
        return this._name;
    }
    ;
    /**
     * Sets the name property value. The display name of the worksheet.
     * @param value Value to set for the name property.
     */
    set name(value) {
        this._name = value;
    }
    ;
    /**
     * Gets the names property value. Returns collection of names that are associated with the worksheet. Read-only.
     * @returns a workbookNamedItem
     */
    get names() {
        return this._names;
    }
    ;
    /**
     * Sets the names property value. Returns collection of names that are associated with the worksheet. Read-only.
     * @param value Value to set for the names property.
     */
    set names(value) {
        this._names = value;
    }
    ;
    /**
     * Gets the pivotTables property value. Collection of PivotTables that are part of the worksheet.
     * @returns a workbookPivotTable
     */
    get pivotTables() {
        return this._pivotTables;
    }
    ;
    /**
     * Sets the pivotTables property value. Collection of PivotTables that are part of the worksheet.
     * @param value Value to set for the pivotTables property.
     */
    set pivotTables(value) {
        this._pivotTables = value;
    }
    ;
    /**
     * Gets the position property value. The zero-based position of the worksheet within the workbook.
     * @returns a integer
     */
    get position() {
        return this._position;
    }
    ;
    /**
     * Sets the position property value. The zero-based position of the worksheet within the workbook.
     * @param value Value to set for the position property.
     */
    set position(value) {
        this._position = value;
    }
    ;
    /**
     * Gets the protection property value. Returns sheet protection object for a worksheet. Read-only.
     * @returns a workbookWorksheetProtection
     */
    get protection() {
        return this._protection;
    }
    ;
    /**
     * Sets the protection property value. Returns sheet protection object for a worksheet. Read-only.
     * @param value Value to set for the protection property.
     */
    set protection(value) {
        this._protection = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        super.serialize(writer);
        writer.writeCollectionOfObjectValues("charts", this.charts);
        writer.writeStringValue("name", this.name);
        writer.writeCollectionOfObjectValues("names", this.names);
        writer.writeCollectionOfObjectValues("pivotTables", this.pivotTables);
        writer.writeNumberValue("position", this.position);
        writer.writeObjectValue("protection", this.protection);
        writer.writeCollectionOfObjectValues("tables", this.tables);
        writer.writeStringValue("visibility", this.visibility);
    }
    ;
    /**
     * Gets the tables property value. Collection of tables that are part of the worksheet. Read-only.
     * @returns a workbookTable
     */
    get tables() {
        return this._tables;
    }
    ;
    /**
     * Sets the tables property value. Collection of tables that are part of the worksheet. Read-only.
     * @param value Value to set for the tables property.
     */
    set tables(value) {
        this._tables = value;
    }
    ;
    /**
     * Gets the visibility property value. The Visibility of the worksheet. The possible values are: Visible, Hidden, VeryHidden.
     * @returns a string
     */
    get visibility() {
        return this._visibility;
    }
    ;
    /**
     * Sets the visibility property value. The Visibility of the worksheet. The possible values are: Visible, Hidden, VeryHidden.
     * @param value Value to set for the visibility property.
     */
    set visibility(value) {
        this._visibility = value;
    }
    ;
}
exports.WorkbookWorksheet = WorkbookWorksheet;
