"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkforceIntegrationEncryption = void 0;
const workforceIntegrationEncryptionProtocol_1 = require("./workforceIntegrationEncryptionProtocol");
class WorkforceIntegrationEncryption {
    /**
     * Instantiates a new workforceIntegrationEncryption and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "protocol": (o, n) => { o.protocol = n.getEnumValue(workforceIntegrationEncryptionProtocol_1.WorkforceIntegrationEncryptionProtocol); },
            "secret": (o, n) => { o.secret = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the protocol property value. Possible values are: sharedSecret, unknownFutureValue.
     * @returns a workforceIntegrationEncryptionProtocol
     */
    get protocol() {
        return this._protocol;
    }
    ;
    /**
     * Sets the protocol property value. Possible values are: sharedSecret, unknownFutureValue.
     * @param value Value to set for the protocol property.
     */
    set protocol(value) {
        this._protocol = value;
    }
    ;
    /**
     * Gets the secret property value. Encryption shared secret.
     * @returns a string
     */
    get secret() {
        return this._secret;
    }
    ;
    /**
     * Sets the secret property value. Encryption shared secret.
     * @param value Value to set for the secret property.
     */
    set secret(value) {
        this._secret = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeEnumValue("protocol", this.protocol);
        writer.writeStringValue("secret", this.secret);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.WorkforceIntegrationEncryption = WorkforceIntegrationEncryption;
