"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PoliciesRequestBuilder = void 0;
const createPolicyRootFromDiscriminatorValue_1 = require("../models/microsoft/graph/createPolicyRootFromDiscriminatorValue");
const createODataErrorFromDiscriminatorValue_1 = require("../models/microsoft/graph/oDataErrors/createODataErrorFromDiscriminatorValue");
const activityBasedTimeoutPoliciesRequestBuilder_1 = require("./activityBasedTimeoutPolicies/activityBasedTimeoutPoliciesRequestBuilder");
const activityBasedTimeoutPolicyItemRequestBuilder_1 = require("./activityBasedTimeoutPolicies/item/activityBasedTimeoutPolicyItemRequestBuilder");
const adminConsentRequestPolicyRequestBuilder_1 = require("./adminConsentRequestPolicy/adminConsentRequestPolicyRequestBuilder");
const authenticationFlowsPolicyRequestBuilder_1 = require("./authenticationFlowsPolicy/authenticationFlowsPolicyRequestBuilder");
const authenticationMethodsPolicyRequestBuilder_1 = require("./authenticationMethodsPolicy/authenticationMethodsPolicyRequestBuilder");
const authorizationPolicyRequestBuilder_1 = require("./authorizationPolicy/authorizationPolicyRequestBuilder");
const claimsMappingPoliciesRequestBuilder_1 = require("./claimsMappingPolicies/claimsMappingPoliciesRequestBuilder");
const claimsMappingPolicyItemRequestBuilder_1 = require("./claimsMappingPolicies/item/claimsMappingPolicyItemRequestBuilder");
const conditionalAccessPoliciesRequestBuilder_1 = require("./conditionalAccessPolicies/conditionalAccessPoliciesRequestBuilder");
const conditionalAccessPolicyItemRequestBuilder_1 = require("./conditionalAccessPolicies/item/conditionalAccessPolicyItemRequestBuilder");
const featureRolloutPoliciesRequestBuilder_1 = require("./featureRolloutPolicies/featureRolloutPoliciesRequestBuilder");
const featureRolloutPolicyItemRequestBuilder_1 = require("./featureRolloutPolicies/item/featureRolloutPolicyItemRequestBuilder");
const homeRealmDiscoveryPoliciesRequestBuilder_1 = require("./homeRealmDiscoveryPolicies/homeRealmDiscoveryPoliciesRequestBuilder");
const homeRealmDiscoveryPolicyItemRequestBuilder_1 = require("./homeRealmDiscoveryPolicies/item/homeRealmDiscoveryPolicyItemRequestBuilder");
const identitySecurityDefaultsEnforcementPolicyRequestBuilder_1 = require("./identitySecurityDefaultsEnforcementPolicy/identitySecurityDefaultsEnforcementPolicyRequestBuilder");
const permissionGrantPolicyItemRequestBuilder_1 = require("./permissionGrantPolicies/item/permissionGrantPolicyItemRequestBuilder");
const permissionGrantPoliciesRequestBuilder_1 = require("./permissionGrantPolicies/permissionGrantPoliciesRequestBuilder");
const tokenIssuancePolicyItemRequestBuilder_1 = require("./tokenIssuancePolicies/item/tokenIssuancePolicyItemRequestBuilder");
const tokenIssuancePoliciesRequestBuilder_1 = require("./tokenIssuancePolicies/tokenIssuancePoliciesRequestBuilder");
const tokenLifetimePolicyItemRequestBuilder_1 = require("./tokenLifetimePolicies/item/tokenLifetimePolicyItemRequestBuilder");
const tokenLifetimePoliciesRequestBuilder_1 = require("./tokenLifetimePolicies/tokenLifetimePoliciesRequestBuilder");
const kiota_abstractions_1 = require("@microsoft/kiota-abstractions");
/** Provides operations to manage the policyRoot singleton.  */
class PoliciesRequestBuilder {
    /**
     * Instantiates a new PoliciesRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters, requestAdapter) {
        if (!pathParameters)
            throw new Error("pathParameters cannot be undefined");
        if (!requestAdapter)
            throw new Error("requestAdapter cannot be undefined");
        this.urlTemplate = "{+baseurl}/policies{?select,expand}";
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(pathParameters);
        this.pathParameters = urlTplParams;
        this.requestAdapter = requestAdapter;
    }
    get activityBasedTimeoutPolicies() {
        return new activityBasedTimeoutPoliciesRequestBuilder_1.ActivityBasedTimeoutPoliciesRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get adminConsentRequestPolicy() {
        return new adminConsentRequestPolicyRequestBuilder_1.AdminConsentRequestPolicyRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get authenticationFlowsPolicy() {
        return new authenticationFlowsPolicyRequestBuilder_1.AuthenticationFlowsPolicyRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get authenticationMethodsPolicy() {
        return new authenticationMethodsPolicyRequestBuilder_1.AuthenticationMethodsPolicyRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get authorizationPolicy() {
        return new authorizationPolicyRequestBuilder_1.AuthorizationPolicyRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get claimsMappingPolicies() {
        return new claimsMappingPoliciesRequestBuilder_1.ClaimsMappingPoliciesRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get conditionalAccessPolicies() {
        return new conditionalAccessPoliciesRequestBuilder_1.ConditionalAccessPoliciesRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get featureRolloutPolicies() {
        return new featureRolloutPoliciesRequestBuilder_1.FeatureRolloutPoliciesRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get homeRealmDiscoveryPolicies() {
        return new homeRealmDiscoveryPoliciesRequestBuilder_1.HomeRealmDiscoveryPoliciesRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get identitySecurityDefaultsEnforcementPolicy() {
        return new identitySecurityDefaultsEnforcementPolicyRequestBuilder_1.IdentitySecurityDefaultsEnforcementPolicyRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get permissionGrantPolicies() {
        return new permissionGrantPoliciesRequestBuilder_1.PermissionGrantPoliciesRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get tokenIssuancePolicies() {
        return new tokenIssuancePoliciesRequestBuilder_1.TokenIssuancePoliciesRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    get tokenLifetimePolicies() {
        return new tokenLifetimePoliciesRequestBuilder_1.TokenLifetimePoliciesRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.policies.activityBasedTimeoutPolicies.item collection
     * @param id Unique identifier of the item
     * @returns a activityBasedTimeoutPolicyItemRequestBuilder
     */
    activityBasedTimeoutPoliciesById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["activityBasedTimeoutPolicy_id"] = id;
        return new activityBasedTimeoutPolicyItemRequestBuilder_1.ActivityBasedTimeoutPolicyItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.policies.claimsMappingPolicies.item collection
     * @param id Unique identifier of the item
     * @returns a claimsMappingPolicyItemRequestBuilder
     */
    claimsMappingPoliciesById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["claimsMappingPolicy_id"] = id;
        return new claimsMappingPolicyItemRequestBuilder_1.ClaimsMappingPolicyItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.policies.conditionalAccessPolicies.item collection
     * @param id Unique identifier of the item
     * @returns a conditionalAccessPolicyItemRequestBuilder
     */
    conditionalAccessPoliciesById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["conditionalAccessPolicy_id"] = id;
        return new conditionalAccessPolicyItemRequestBuilder_1.ConditionalAccessPolicyItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    ;
    /**
     * Get policies
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @returns a RequestInformation
     */
    createGetRequestInformation(q, h, o) {
        const requestInfo = new kiota_abstractions_1.RequestInformation();
        requestInfo.urlTemplate = this.urlTemplate;
        requestInfo.pathParameters = this.pathParameters;
        requestInfo.httpMethod = kiota_abstractions_1.HttpMethod.GET;
        if (h)
            requestInfo.headers = h;
        q && requestInfo.setQueryStringParametersFromRawObject(q);
        o && requestInfo.addRequestOptions(...o);
        return requestInfo;
    }
    ;
    /**
     * Update policies
     * @param body
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createPatchRequestInformation(body, h, o) {
        if (!body)
            throw new Error("body cannot be undefined");
        const requestInfo = new kiota_abstractions_1.RequestInformation();
        requestInfo.urlTemplate = this.urlTemplate;
        requestInfo.pathParameters = this.pathParameters;
        requestInfo.httpMethod = kiota_abstractions_1.HttpMethod.PATCH;
        if (h)
            requestInfo.headers = h;
        requestInfo.setContentFromParsable(this.requestAdapter, "application/json", body);
        o && requestInfo.addRequestOptions(...o);
        return requestInfo;
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.policies.featureRolloutPolicies.item collection
     * @param id Unique identifier of the item
     * @returns a featureRolloutPolicyItemRequestBuilder
     */
    featureRolloutPoliciesById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["featureRolloutPolicy_id"] = id;
        return new featureRolloutPolicyItemRequestBuilder_1.FeatureRolloutPolicyItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Get policies
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     * @returns a Promise of PolicyRoot
     */
    get(q, h, o, responseHandler) {
        var _a, _b;
        const requestInfo = this.createGetRequestInformation(q, h, o);
        const errorMapping = {
            "4XX": createODataErrorFromDiscriminatorValue_1.createODataErrorFromDiscriminatorValue,
            "5XX": createODataErrorFromDiscriminatorValue_1.createODataErrorFromDiscriminatorValue,
        };
        return (_b = (_a = this.requestAdapter) === null || _a === void 0 ? void 0 : _a.sendAsync(requestInfo, createPolicyRootFromDiscriminatorValue_1.createPolicyRootFromDiscriminatorValue, responseHandler, errorMapping)) !== null && _b !== void 0 ? _b : Promise.reject(new Error('http core is null'));
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.policies.homeRealmDiscoveryPolicies.item collection
     * @param id Unique identifier of the item
     * @returns a homeRealmDiscoveryPolicyItemRequestBuilder
     */
    homeRealmDiscoveryPoliciesById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["homeRealmDiscoveryPolicy_id"] = id;
        return new homeRealmDiscoveryPolicyItemRequestBuilder_1.HomeRealmDiscoveryPolicyItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Update policies
     * @param body
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    patch(body, h, o, responseHandler) {
        var _a, _b;
        if (!body)
            throw new Error("body cannot be undefined");
        const requestInfo = this.createPatchRequestInformation(body, h, o);
        const errorMapping = {
            "4XX": createODataErrorFromDiscriminatorValue_1.createODataErrorFromDiscriminatorValue,
            "5XX": createODataErrorFromDiscriminatorValue_1.createODataErrorFromDiscriminatorValue,
        };
        return (_b = (_a = this.requestAdapter) === null || _a === void 0 ? void 0 : _a.sendNoResponseContentAsync(requestInfo, responseHandler, errorMapping)) !== null && _b !== void 0 ? _b : Promise.reject(new Error('http core is null'));
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.policies.permissionGrantPolicies.item collection
     * @param id Unique identifier of the item
     * @returns a permissionGrantPolicyItemRequestBuilder
     */
    permissionGrantPoliciesById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["permissionGrantPolicy_id"] = id;
        return new permissionGrantPolicyItemRequestBuilder_1.PermissionGrantPolicyItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.policies.tokenIssuancePolicies.item collection
     * @param id Unique identifier of the item
     * @returns a tokenIssuancePolicyItemRequestBuilder
     */
    tokenIssuancePoliciesById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["tokenIssuancePolicy_id"] = id;
        return new tokenIssuancePolicyItemRequestBuilder_1.TokenIssuancePolicyItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.policies.tokenLifetimePolicies.item collection
     * @param id Unique identifier of the item
     * @returns a tokenLifetimePolicyItemRequestBuilder
     */
    tokenLifetimePoliciesById(id) {
        if (!id)
            throw new Error("id cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["tokenLifetimePolicy_id"] = id;
        return new tokenLifetimePolicyItemRequestBuilder_1.TokenLifetimePolicyItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
}
exports.PoliciesRequestBuilder = PoliciesRequestBuilder;
