import { PrintCertificateSigningRequest } from '../../../models/microsoft/graph/';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the create method.  */
export declare class CreateRequestBody implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _certificateSigningRequest?;
    private _connectorId?;
    private _displayName?;
    private _hasPhysicalDevice?;
    private _manufacturer?;
    private _model?;
    private _physicalDeviceId?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the certificateSigningRequest property value.
     * @returns a printCertificateSigningRequest
     */
    get certificateSigningRequest(): PrintCertificateSigningRequest | undefined;
    /**
     * Sets the certificateSigningRequest property value.
     * @param value Value to set for the certificateSigningRequest property.
     */
    set certificateSigningRequest(value: PrintCertificateSigningRequest | undefined);
    /**
     * Gets the connectorId property value.
     * @returns a string
     */
    get connectorId(): string | undefined;
    /**
     * Sets the connectorId property value.
     * @param value Value to set for the connectorId property.
     */
    set connectorId(value: string | undefined);
    /**
     * Instantiates a new createRequestBody and sets the default values.
     */
    constructor();
    /**
     * Gets the displayName property value.
     * @returns a string
     */
    get displayName(): string | undefined;
    /**
     * Sets the displayName property value.
     * @param value Value to set for the displayName property.
     */
    set displayName(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the hasPhysicalDevice property value.
     * @returns a boolean
     */
    get hasPhysicalDevice(): boolean | undefined;
    /**
     * Sets the hasPhysicalDevice property value.
     * @param value Value to set for the hasPhysicalDevice property.
     */
    set hasPhysicalDevice(value: boolean | undefined);
    /**
     * Gets the manufacturer property value.
     * @returns a string
     */
    get manufacturer(): string | undefined;
    /**
     * Sets the manufacturer property value.
     * @param value Value to set for the manufacturer property.
     */
    set manufacturer(value: string | undefined);
    /**
     * Gets the model property value.
     * @returns a string
     */
    get model(): string | undefined;
    /**
     * Sets the model property value.
     * @param value Value to set for the model property.
     */
    set model(value: string | undefined);
    /**
     * Gets the physicalDeviceId property value.
     * @returns a string
     */
    get physicalDeviceId(): string | undefined;
    /**
     * Sets the physicalDeviceId property value.
     * @param value Value to set for the physicalDeviceId property.
     */
    set physicalDeviceId(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
