"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetSharePointSiteUsageDetailWithDateRequestBuilder = void 0;
const createReportFromDiscriminatorValue_1 = require("../../models/microsoft/graph/createReportFromDiscriminatorValue");
const kiota_abstractions_1 = require("@microsoft/kiota-abstractions");
/** Provides operations to call the getSharePointSiteUsageDetail method.  */
class GetSharePointSiteUsageDetailWithDateRequestBuilder {
    /**
     * Instantiates a new GetSharePointSiteUsageDetailWithDateRequestBuilder and sets the default values.
     * @param date Usage: date={date}
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters, requestAdapter, date) {
        if (!pathParameters)
            throw new Error("pathParameters cannot be undefined");
        if (!requestAdapter)
            throw new Error("requestAdapter cannot be undefined");
        this.urlTemplate = "{+baseurl}/reports/microsoft.graph.getSharePointSiteUsageDetail(date={date})";
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(pathParameters);
        urlTplParams["date"] = date;
        this.pathParameters = urlTplParams;
        this.requestAdapter = requestAdapter;
    }
    ;
    /**
     * Invoke function getSharePointSiteUsageDetail
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createGetRequestInformation(h, o) {
        const requestInfo = new kiota_abstractions_1.RequestInformation();
        requestInfo.urlTemplate = this.urlTemplate;
        requestInfo.pathParameters = this.pathParameters;
        requestInfo.httpMethod = kiota_abstractions_1.HttpMethod.GET;
        if (h)
            requestInfo.headers = h;
        o && requestInfo.addRequestOptions(...o);
        return requestInfo;
    }
    ;
    /**
     * Invoke function getSharePointSiteUsageDetail
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     * @returns a Promise of Report
     */
    get(h, o, responseHandler) {
        var _a, _b;
        const requestInfo = this.createGetRequestInformation(h, o);
        return (_b = (_a = this.requestAdapter) === null || _a === void 0 ? void 0 : _a.sendAsync(requestInfo, createReportFromDiscriminatorValue_1.createReportFromDiscriminatorValue, responseHandler, undefined)) !== null && _b !== void 0 ? _b : Promise.reject(new Error('http core is null'));
    }
    ;
}
exports.GetSharePointSiteUsageDetailWithDateRequestBuilder = GetSharePointSiteUsageDetailWithDateRequestBuilder;
