"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PasswordCredentialRequestBody = void 0;
const createPasswordCredentialFromDiscriminatorValue_1 = require("../../../models/microsoft/graph/createPasswordCredentialFromDiscriminatorValue");
/** Provides operations to call the addPassword method.  */
class PasswordCredentialRequestBody {
    /**
     * Instantiates a new PasswordCredentialRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "passwordCredential": (o, n) => { o.passwordCredential = n.getObjectValue(createPasswordCredentialFromDiscriminatorValue_1.createPasswordCredentialFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the passwordCredential property value.
     * @returns a passwordCredential
     */
    get passwordCredential() {
        return this._passwordCredential;
    }
    ;
    /**
     * Sets the passwordCredential property value.
     * @param value Value to set for the passwordCredential property.
     */
    set passwordCredential(value) {
        this._passwordCredential = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeObjectValue("passwordCredential", this.passwordCredential);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.PasswordCredentialRequestBody = PasswordCredentialRequestBody;
