import { Set } from '../../../../../models/microsoft/graph/termStore/';
import { ChildrenRequestBuilder } from './children/childrenRequestBuilder';
import { TermItemRequestBuilder as i8c485d5c92fa73ff573a33e3e5b758c43fc74b689d5b6cd70d7b3f228585bea1 } from './children/item/termItemRequestBuilder';
import { ParentGroupRequestBuilder } from './parentGroup/parentGroupRequestBuilder';
import { RelationItemRequestBuilder } from './relations/item/relationItemRequestBuilder';
import { RelationsRequestBuilder } from './relations/relationsRequestBuilder';
import { TermItemRequestBuilder as i2282dcd6d5a69829af7a43007a958cb6dcc688113ef475c632dd8b5c696f7321 } from './terms/item/termItemRequestBuilder';
import { TermsRequestBuilder } from './terms/termsRequestBuilder';
import { RequestAdapter, RequestInformation, RequestOption, ResponseHandler } from '@microsoft/kiota-abstractions';
/** Provides operations to manage the sets property of the microsoft.graph.termStore.store entity.  */
export declare class SetItemRequestBuilder {
    get children(): ChildrenRequestBuilder;
    get parentGroup(): ParentGroupRequestBuilder;
    /** Path parameters for the request  */
    private readonly pathParameters;
    get relations(): RelationsRequestBuilder;
    /** The request adapter to use to execute the requests.  */
    private readonly requestAdapter;
    get terms(): TermsRequestBuilder;
    /** Url template to use to build the URL for the current request builder  */
    private readonly urlTemplate;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.sites.item.termStore.sets.item.children.item collection
     * @param id Unique identifier of the item
     * @returns a termItemRequestBuilder
     */
    childrenById(id: string): i8c485d5c92fa73ff573a33e3e5b758c43fc74b689d5b6cd70d7b3f228585bea1;
    /**
     * Instantiates a new SetItemRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters: Record<string, unknown> | string | undefined, requestAdapter: RequestAdapter);
    /**
     * Delete navigation property sets for sites
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createDeleteRequestInformation(h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Collection of all sets available in the term store.
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @returns a RequestInformation
     */
    createGetRequestInformation(q?: {
        expand?: string[];
        select?: string[];
    } | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Update the navigation property sets in sites
     * @param body
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createPatchRequestInformation(body: Set | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Delete navigation property sets for sites
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    delete(h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<void>;
    /**
     * Collection of all sets available in the term store.
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     * @returns a Promise of Set
     */
    get(q?: {
        expand?: string[];
        select?: string[];
    } | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<Set | undefined>;
    /**
     * Update the navigation property sets in sites
     * @param body
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    patch(body: Set | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<void>;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.sites.item.termStore.sets.item.relations.item collection
     * @param id Unique identifier of the item
     * @returns a relationItemRequestBuilder
     */
    relationsById(id: string): RelationItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.sites.item.termStore.sets.item.terms.item collection
     * @param id Unique identifier of the item
     * @returns a termItemRequestBuilder
     */
    termsById(id: string): i2282dcd6d5a69829af7a43007a958cb6dcc688113ef475c632dd8b5c696f7321;
}
