"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CancelRequestBody = void 0;
/** Provides operations to call the cancel method.  */
class CancelRequestBody {
    /**
     * Instantiates a new cancelRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the cancellationMessage property value.
     * @returns a string
     */
    get cancellationMessage() {
        return this._cancellationMessage;
    }
    ;
    /**
     * Sets the cancellationMessage property value.
     * @param value Value to set for the cancellationMessage property.
     */
    set cancellationMessage(value) {
        this._cancellationMessage = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "cancellationMessage": (o, n) => { o.cancellationMessage = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("cancellationMessage", this.cancellationMessage);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.CancelRequestBody = CancelRequestBody;
