import { BookingBusiness } from '../../../models/microsoft/graph/';
import { AppointmentsRequestBuilder } from './appointments/appointmentsRequestBuilder';
import { BookingAppointmentItemRequestBuilder as i549df13af914f5d18415b6b2e317bb0de2c91be54aaca79fb0e27b0aa2649626 } from './appointments/item/bookingAppointmentItemRequestBuilder';
import { CalendarViewRequestBuilder } from './calendarView/calendarViewRequestBuilder';
import { BookingAppointmentItemRequestBuilder as i286c0648ce5b2f5904e9046a9ca0cb117fe36890723bbbf3f391f7bbdb3c085b } from './calendarView/item/bookingAppointmentItemRequestBuilder';
import { CustomersRequestBuilder } from './customers/customersRequestBuilder';
import { BookingCustomerBaseItemRequestBuilder } from './customers/item/bookingCustomerBaseItemRequestBuilder';
import { CustomQuestionsRequestBuilder } from './customQuestions/customQuestionsRequestBuilder';
import { BookingCustomQuestionItemRequestBuilder } from './customQuestions/item/bookingCustomQuestionItemRequestBuilder';
import { PublishRequestBuilder } from './publish/publishRequestBuilder';
import { BookingServiceItemRequestBuilder } from './services/item/bookingServiceItemRequestBuilder';
import { ServicesRequestBuilder } from './services/servicesRequestBuilder';
import { BookingStaffMemberBaseItemRequestBuilder } from './staffMembers/item/bookingStaffMemberBaseItemRequestBuilder';
import { StaffMembersRequestBuilder } from './staffMembers/staffMembersRequestBuilder';
import { UnpublishRequestBuilder } from './unpublish/unpublishRequestBuilder';
import { RequestAdapter, RequestInformation, RequestOption, ResponseHandler } from '@microsoft/kiota-abstractions';
/** Provides operations to manage the bookingBusinesses property of the microsoft.graph.solutionsRoot entity.  */
export declare class BookingBusinessItemRequestBuilder {
    get appointments(): AppointmentsRequestBuilder;
    get calendarView(): CalendarViewRequestBuilder;
    get customers(): CustomersRequestBuilder;
    get customQuestions(): CustomQuestionsRequestBuilder;
    /** Path parameters for the request  */
    private readonly pathParameters;
    get publish(): PublishRequestBuilder;
    /** The request adapter to use to execute the requests.  */
    private readonly requestAdapter;
    get services(): ServicesRequestBuilder;
    get staffMembers(): StaffMembersRequestBuilder;
    get unpublish(): UnpublishRequestBuilder;
    /** Url template to use to build the URL for the current request builder  */
    private readonly urlTemplate;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.solutions.bookingBusinesses.item.appointments.item collection
     * @param id Unique identifier of the item
     * @returns a bookingAppointmentItemRequestBuilder
     */
    appointmentsById(id: string): i549df13af914f5d18415b6b2e317bb0de2c91be54aaca79fb0e27b0aa2649626;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.solutions.bookingBusinesses.item.calendarView.item collection
     * @param id Unique identifier of the item
     * @returns a bookingAppointmentItemRequestBuilder
     */
    calendarViewById(id: string): i286c0648ce5b2f5904e9046a9ca0cb117fe36890723bbbf3f391f7bbdb3c085b;
    /**
     * Instantiates a new BookingBusinessItemRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters: Record<string, unknown> | string | undefined, requestAdapter: RequestAdapter);
    /**
     * Delete navigation property bookingBusinesses for solutions
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createDeleteRequestInformation(h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Get bookingBusinesses from solutions
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @returns a RequestInformation
     */
    createGetRequestInformation(q?: {
        expand?: string[];
        select?: string[];
    } | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Update the navigation property bookingBusinesses in solutions
     * @param body
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createPatchRequestInformation(body: BookingBusiness | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.solutions.bookingBusinesses.item.customers.item collection
     * @param id Unique identifier of the item
     * @returns a bookingCustomerBaseItemRequestBuilder
     */
    customersById(id: string): BookingCustomerBaseItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.solutions.bookingBusinesses.item.customQuestions.item collection
     * @param id Unique identifier of the item
     * @returns a bookingCustomQuestionItemRequestBuilder
     */
    customQuestionsById(id: string): BookingCustomQuestionItemRequestBuilder;
    /**
     * Delete navigation property bookingBusinesses for solutions
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    delete(h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<void>;
    /**
     * Get bookingBusinesses from solutions
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     * @returns a Promise of BookingBusiness
     */
    get(q?: {
        expand?: string[];
        select?: string[];
    } | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<BookingBusiness | undefined>;
    /**
     * Update the navigation property bookingBusinesses in solutions
     * @param body
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    patch(body: BookingBusiness | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<void>;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.solutions.bookingBusinesses.item.services.item collection
     * @param id Unique identifier of the item
     * @returns a bookingServiceItemRequestBuilder
     */
    servicesById(id: string): BookingServiceItemRequestBuilder;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.solutions.bookingBusinesses.item.staffMembers.item collection
     * @param id Unique identifier of the item
     * @returns a bookingStaffMemberBaseItemRequestBuilder
     */
    staffMembersById(id: string): BookingStaffMemberBaseItemRequestBuilder;
}
