"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AcceptRequestBody = void 0;
/** Provides operations to call the accept method.  */
class AcceptRequestBody {
    /**
     * Instantiates a new acceptRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the comment property value.
     * @returns a string
     */
    get comment() {
        return this._comment;
    }
    ;
    /**
     * Sets the comment property value.
     * @param value Value to set for the Comment property.
     */
    set comment(value) {
        this._comment = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "comment": (o, n) => { o.comment = n.getStringValue(); },
            "sendResponse": (o, n) => { o.sendResponse = n.getBooleanValue(); },
        };
    }
    ;
    /**
     * Gets the sendResponse property value.
     * @returns a boolean
     */
    get sendResponse() {
        return this._sendResponse;
    }
    ;
    /**
     * Sets the sendResponse property value.
     * @param value Value to set for the SendResponse property.
     */
    set sendResponse(value) {
        this._sendResponse = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("comment", this.comment);
        writer.writeBooleanValue("sendResponse", this.sendResponse);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.AcceptRequestBody = AcceptRequestBody;
