import { Drive } from '../../../../models/microsoft/graph/';
import { BundlesRequestBuilder } from './bundles/bundlesRequestBuilder';
import { DriveItemItemRequestBuilder as ib08f474be1bf6a32ea5a8a95557e86524a0765282816e597ba8b79709bf93c99 } from './bundles/item/driveItemItemRequestBuilder';
import { FollowingRequestBuilder } from './following/followingRequestBuilder';
import { DriveItemItemRequestBuilder as i2f9674a8712d4f7a29b0f1d7aff3bb8e48a5d4e599babb4e5f02ebbba33aaa21 } from './following/item/driveItemItemRequestBuilder';
import { DriveItemItemRequestBuilder as if3d1223ef7bf868ebf92cd3a6fa5be29ff600d36007e6cc426ea21ab57388ec7 } from './items/item/driveItemItemRequestBuilder';
import { ItemsRequestBuilder } from './items/itemsRequestBuilder';
import { ListRequestBuilder } from './list/listRequestBuilder';
import { RootRequestBuilder } from './root/rootRequestBuilder';
import { DriveItemItemRequestBuilder as i49a2cf882c72a98c2f314c4c343164f580800188ce2ba1b8daf35e81cc398b60 } from './special/item/driveItemItemRequestBuilder';
import { SpecialRequestBuilder } from './special/specialRequestBuilder';
import { RequestAdapter, RequestInformation, RequestOption, ResponseHandler } from '@microsoft/kiota-abstractions';
/** Provides operations to manage the drives property of the microsoft.graph.user entity.  */
export declare class DriveItemRequestBuilder {
    get bundles(): BundlesRequestBuilder;
    get following(): FollowingRequestBuilder;
    get items(): ItemsRequestBuilder;
    get list(): ListRequestBuilder;
    /** Path parameters for the request  */
    private readonly pathParameters;
    /** The request adapter to use to execute the requests.  */
    private readonly requestAdapter;
    get root(): RootRequestBuilder;
    get special(): SpecialRequestBuilder;
    /** Url template to use to build the URL for the current request builder  */
    private readonly urlTemplate;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.users.item.drives.item.bundles.item collection
     * @param id Unique identifier of the item
     * @returns a driveItemItemRequestBuilder
     */
    bundlesById(id: string): ib08f474be1bf6a32ea5a8a95557e86524a0765282816e597ba8b79709bf93c99;
    /**
     * Instantiates a new DriveItemRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters: Record<string, unknown> | string | undefined, requestAdapter: RequestAdapter);
    /**
     * Delete navigation property drives for users
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createDeleteRequestInformation(h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * A collection of drives available for this user. Read-only.
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @returns a RequestInformation
     */
    createGetRequestInformation(q?: {
        expand?: string[];
        select?: string[];
    } | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Update the navigation property drives in users
     * @param body
     * @param h Request headers
     * @param o Request options
     * @returns a RequestInformation
     */
    createPatchRequestInformation(body: Drive | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined): RequestInformation;
    /**
     * Delete navigation property drives for users
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    delete(h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<void>;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.users.item.drives.item.following.item collection
     * @param id Unique identifier of the item
     * @returns a driveItemItemRequestBuilder
     */
    followingById(id: string): i2f9674a8712d4f7a29b0f1d7aff3bb8e48a5d4e599babb4e5f02ebbba33aaa21;
    /**
     * A collection of drives available for this user. Read-only.
     * @param h Request headers
     * @param o Request options
     * @param q Request query parameters
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     * @returns a Promise of Drive
     */
    get(q?: {
        expand?: string[];
        select?: string[];
    } | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<Drive | undefined>;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.users.item.drives.item.items.item collection
     * @param id Unique identifier of the item
     * @returns a driveItemItemRequestBuilder
     */
    itemsById(id: string): if3d1223ef7bf868ebf92cd3a6fa5be29ff600d36007e6cc426ea21ab57388ec7;
    /**
     * Update the navigation property drives in users
     * @param body
     * @param h Request headers
     * @param o Request options
     * @param responseHandler Response handler to use in place of the default response handling provided by the core service
     */
    patch(body: Drive | undefined, h?: Record<string, string> | undefined, o?: RequestOption[] | undefined, responseHandler?: ResponseHandler | undefined): Promise<void>;
    /**
     * Gets an item from the github.com/microsoftgraph/msgraph-sdk-typescript/.users.item.drives.item.special.item collection
     * @param id Unique identifier of the item
     * @returns a driveItemItemRequestBuilder
     */
    specialById(id: string): i49a2cf882c72a98c2f314c4c343164f580800188ce2ba1b8daf35e81cc398b60;
}
