"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GrantRequestBody = void 0;
const createDriveRecipientFromDiscriminatorValue_1 = require("../../../../../../../../../models/microsoft/graph/createDriveRecipientFromDiscriminatorValue");
/** Provides operations to call the grant method.  */
class GrantRequestBody {
    /**
     * Instantiates a new grantRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "recipients": (o, n) => { o.recipients = n.getCollectionOfObjectValues(createDriveRecipientFromDiscriminatorValue_1.createDriveRecipientFromDiscriminatorValue); },
            "roles": (o, n) => { o.roles = n.getCollectionOfPrimitiveValues(); },
        };
    }
    ;
    /**
     * Gets the recipients property value.
     * @returns a driveRecipient
     */
    get recipients() {
        return this._recipients;
    }
    ;
    /**
     * Sets the recipients property value.
     * @param value Value to set for the recipients property.
     */
    set recipients(value) {
        this._recipients = value;
    }
    ;
    /**
     * Gets the roles property value.
     * @returns a string
     */
    get roles() {
        return this._roles;
    }
    ;
    /**
     * Sets the roles property value.
     * @param value Value to set for the roles property.
     */
    set roles(value) {
        this._roles = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfObjectValues("recipients", this.recipients);
        writer.writeCollectionOfPrimitiveValues("roles", this.roles);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.GrantRequestBody = GrantRequestBody;
