import { AttendeeBase, LocationConstraint, TimeConstraint } from '../../../models/microsoft/graph/';
import { AdditionalDataHolder, Duration, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the findMeetingTimes method.  */
export declare class FindMeetingTimesRequestBody implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _attendees?;
    private _isOrganizerOptional?;
    private _locationConstraint?;
    private _maxCandidates?;
    private _meetingDuration?;
    private _minimumAttendeePercentage?;
    private _returnSuggestionReasons?;
    private _timeConstraint?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the attendees property value.
     * @returns a attendeeBase
     */
    get attendees(): AttendeeBase[] | undefined;
    /**
     * Sets the attendees property value.
     * @param value Value to set for the attendees property.
     */
    set attendees(value: AttendeeBase[] | undefined);
    /**
     * Instantiates a new findMeetingTimesRequestBody and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the isOrganizerOptional property value.
     * @returns a boolean
     */
    get isOrganizerOptional(): boolean | undefined;
    /**
     * Sets the isOrganizerOptional property value.
     * @param value Value to set for the isOrganizerOptional property.
     */
    set isOrganizerOptional(value: boolean | undefined);
    /**
     * Gets the locationConstraint property value.
     * @returns a locationConstraint
     */
    get locationConstraint(): LocationConstraint | undefined;
    /**
     * Sets the locationConstraint property value.
     * @param value Value to set for the locationConstraint property.
     */
    set locationConstraint(value: LocationConstraint | undefined);
    /**
     * Gets the maxCandidates property value.
     * @returns a integer
     */
    get maxCandidates(): number | undefined;
    /**
     * Sets the maxCandidates property value.
     * @param value Value to set for the maxCandidates property.
     */
    set maxCandidates(value: number | undefined);
    /**
     * Gets the meetingDuration property value.
     * @returns a Duration
     */
    get meetingDuration(): Duration | undefined;
    /**
     * Sets the meetingDuration property value.
     * @param value Value to set for the meetingDuration property.
     */
    set meetingDuration(value: Duration | undefined);
    /**
     * Gets the minimumAttendeePercentage property value.
     * @returns a double
     */
    get minimumAttendeePercentage(): number | undefined;
    /**
     * Sets the minimumAttendeePercentage property value.
     * @param value Value to set for the minimumAttendeePercentage property.
     */
    set minimumAttendeePercentage(value: number | undefined);
    /**
     * Gets the returnSuggestionReasons property value.
     * @returns a boolean
     */
    get returnSuggestionReasons(): boolean | undefined;
    /**
     * Sets the returnSuggestionReasons property value.
     * @param value Value to set for the returnSuggestionReasons property.
     */
    set returnSuggestionReasons(value: boolean | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the timeConstraint property value.
     * @returns a timeConstraint
     */
    get timeConstraint(): TimeConstraint | undefined;
    /**
     * Sets the timeConstraint property value.
     * @param value Value to set for the timeConstraint property.
     */
    set timeConstraint(value: TimeConstraint | undefined);
}
