"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FindMeetingTimesRequestBody = void 0;
const createAttendeeBaseFromDiscriminatorValue_1 = require("../../../models/microsoft/graph/createAttendeeBaseFromDiscriminatorValue");
const createLocationConstraintFromDiscriminatorValue_1 = require("../../../models/microsoft/graph/createLocationConstraintFromDiscriminatorValue");
const createTimeConstraintFromDiscriminatorValue_1 = require("../../../models/microsoft/graph/createTimeConstraintFromDiscriminatorValue");
/** Provides operations to call the findMeetingTimes method.  */
class FindMeetingTimesRequestBody {
    /**
     * Instantiates a new findMeetingTimesRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the attendees property value.
     * @returns a attendeeBase
     */
    get attendees() {
        return this._attendees;
    }
    ;
    /**
     * Sets the attendees property value.
     * @param value Value to set for the attendees property.
     */
    set attendees(value) {
        this._attendees = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "attendees": (o, n) => { o.attendees = n.getCollectionOfObjectValues(createAttendeeBaseFromDiscriminatorValue_1.createAttendeeBaseFromDiscriminatorValue); },
            "isOrganizerOptional": (o, n) => { o.isOrganizerOptional = n.getBooleanValue(); },
            "locationConstraint": (o, n) => { o.locationConstraint = n.getObjectValue(createLocationConstraintFromDiscriminatorValue_1.createLocationConstraintFromDiscriminatorValue); },
            "maxCandidates": (o, n) => { o.maxCandidates = n.getNumberValue(); },
            "meetingDuration": (o, n) => { o.meetingDuration = n.getDurationValue(); },
            "minimumAttendeePercentage": (o, n) => { o.minimumAttendeePercentage = n.getNumberValue(); },
            "returnSuggestionReasons": (o, n) => { o.returnSuggestionReasons = n.getBooleanValue(); },
            "timeConstraint": (o, n) => { o.timeConstraint = n.getObjectValue(createTimeConstraintFromDiscriminatorValue_1.createTimeConstraintFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the isOrganizerOptional property value.
     * @returns a boolean
     */
    get isOrganizerOptional() {
        return this._isOrganizerOptional;
    }
    ;
    /**
     * Sets the isOrganizerOptional property value.
     * @param value Value to set for the isOrganizerOptional property.
     */
    set isOrganizerOptional(value) {
        this._isOrganizerOptional = value;
    }
    ;
    /**
     * Gets the locationConstraint property value.
     * @returns a locationConstraint
     */
    get locationConstraint() {
        return this._locationConstraint;
    }
    ;
    /**
     * Sets the locationConstraint property value.
     * @param value Value to set for the locationConstraint property.
     */
    set locationConstraint(value) {
        this._locationConstraint = value;
    }
    ;
    /**
     * Gets the maxCandidates property value.
     * @returns a integer
     */
    get maxCandidates() {
        return this._maxCandidates;
    }
    ;
    /**
     * Sets the maxCandidates property value.
     * @param value Value to set for the maxCandidates property.
     */
    set maxCandidates(value) {
        this._maxCandidates = value;
    }
    ;
    /**
     * Gets the meetingDuration property value.
     * @returns a Duration
     */
    get meetingDuration() {
        return this._meetingDuration;
    }
    ;
    /**
     * Sets the meetingDuration property value.
     * @param value Value to set for the meetingDuration property.
     */
    set meetingDuration(value) {
        this._meetingDuration = value;
    }
    ;
    /**
     * Gets the minimumAttendeePercentage property value.
     * @returns a double
     */
    get minimumAttendeePercentage() {
        return this._minimumAttendeePercentage;
    }
    ;
    /**
     * Sets the minimumAttendeePercentage property value.
     * @param value Value to set for the minimumAttendeePercentage property.
     */
    set minimumAttendeePercentage(value) {
        this._minimumAttendeePercentage = value;
    }
    ;
    /**
     * Gets the returnSuggestionReasons property value.
     * @returns a boolean
     */
    get returnSuggestionReasons() {
        return this._returnSuggestionReasons;
    }
    ;
    /**
     * Sets the returnSuggestionReasons property value.
     * @param value Value to set for the returnSuggestionReasons property.
     */
    set returnSuggestionReasons(value) {
        this._returnSuggestionReasons = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfObjectValues("attendees", this.attendees);
        writer.writeBooleanValue("isOrganizerOptional", this.isOrganizerOptional);
        writer.writeObjectValue("locationConstraint", this.locationConstraint);
        writer.writeNumberValue("maxCandidates", this.maxCandidates);
        writer.writeDurationValue("meetingDuration", this.meetingDuration);
        writer.writeNumberValue("minimumAttendeePercentage", this.minimumAttendeePercentage);
        writer.writeBooleanValue("returnSuggestionReasons", this.returnSuggestionReasons);
        writer.writeObjectValue("timeConstraint", this.timeConstraint);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the timeConstraint property value.
     * @returns a timeConstraint
     */
    get timeConstraint() {
        return this._timeConstraint;
    }
    ;
    /**
     * Sets the timeConstraint property value.
     * @param value Value to set for the timeConstraint property.
     */
    set timeConstraint(value) {
        this._timeConstraint = value;
    }
    ;
}
exports.FindMeetingTimesRequestBody = FindMeetingTimesRequestBody;
