import { MailTipsType } from '../../../models/microsoft/graph/mailTipsType';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the getMailTips method.  */
export declare class GetMailTipsRequestBody implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _emailAddresses?;
    private _mailTipsOptions?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new getMailTipsRequestBody and sets the default values.
     */
    constructor();
    /**
     * Gets the emailAddresses property value.
     * @returns a string
     */
    get emailAddresses(): string[] | undefined;
    /**
     * Sets the emailAddresses property value.
     * @param value Value to set for the EmailAddresses property.
     */
    set emailAddresses(value: string[] | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the mailTipsOptions property value.
     * @returns a mailTipsType
     */
    get mailTipsOptions(): MailTipsType | undefined;
    /**
     * Sets the mailTipsOptions property value.
     * @param value Value to set for the MailTipsOptions property.
     */
    set mailTipsOptions(value: MailTipsType | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
