import { Message, Recipient } from '../../../../../models/microsoft/graph/';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the createForward method.  */
export declare class CreateForwardRequestBody implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _comment?;
    private _message?;
    private _toRecipients?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the comment property value.
     * @returns a string
     */
    get comment(): string | undefined;
    /**
     * Sets the comment property value.
     * @param value Value to set for the Comment property.
     */
    set comment(value: string | undefined);
    /**
     * Instantiates a new createForwardRequestBody and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the message property value.
     * @returns a message
     */
    get message(): Message | undefined;
    /**
     * Sets the message property value.
     * @param value Value to set for the Message property.
     */
    set message(value: Message | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the toRecipients property value.
     * @returns a recipient
     */
    get toRecipients(): Recipient[] | undefined;
    /**
     * Sets the toRecipients property value.
     * @param value Value to set for the ToRecipients property.
     */
    set toRecipients(value: Recipient[] | undefined);
}
