"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReplyRequestBody = void 0;
const createMessageFromDiscriminatorValue_1 = require("../../../../../models/microsoft/graph/createMessageFromDiscriminatorValue");
/** Provides operations to call the reply method.  */
class ReplyRequestBody {
    /**
     * Instantiates a new replyRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the comment property value.
     * @returns a string
     */
    get comment() {
        return this._comment;
    }
    ;
    /**
     * Sets the comment property value.
     * @param value Value to set for the Comment property.
     */
    set comment(value) {
        this._comment = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "comment": (o, n) => { o.comment = n.getStringValue(); },
            "message": (o, n) => { o.message = n.getObjectValue(createMessageFromDiscriminatorValue_1.createMessageFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the message property value.
     * @returns a message
     */
    get message() {
        return this._message;
    }
    ;
    /**
     * Sets the message property value.
     * @param value Value to set for the Message property.
     */
    set message(value) {
        this._message = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("comment", this.comment);
        writer.writeObjectValue("message", this.message);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ReplyRequestBody = ReplyRequestBody;
