"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClearPresenceRequestBody = void 0;
/** Provides operations to call the clearPresence method.  */
class ClearPresenceRequestBody {
    /**
     * Instantiates a new clearPresenceRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "sessionId": (o, n) => { o.sessionId = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("sessionId", this.sessionId);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the sessionId property value.
     * @returns a string
     */
    get sessionId() {
        return this._sessionId;
    }
    ;
    /**
     * Sets the sessionId property value.
     * @param value Value to set for the sessionId property.
     */
    set sessionId(value) {
        this._sessionId = value;
    }
    ;
}
exports.ClearPresenceRequestBody = ClearPresenceRequestBody;
