"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SetPresenceRequestBody = void 0;
/** Provides operations to call the setPresence method.  */
class SetPresenceRequestBody {
    /**
     * Instantiates a new setPresenceRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the activity property value.
     * @returns a string
     */
    get activity() {
        return this._activity;
    }
    ;
    /**
     * Sets the activity property value.
     * @param value Value to set for the activity property.
     */
    set activity(value) {
        this._activity = value;
    }
    ;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the availability property value.
     * @returns a string
     */
    get availability() {
        return this._availability;
    }
    ;
    /**
     * Sets the availability property value.
     * @param value Value to set for the availability property.
     */
    set availability(value) {
        this._availability = value;
    }
    ;
    ;
    /**
     * Gets the expirationDuration property value.
     * @returns a Duration
     */
    get expirationDuration() {
        return this._expirationDuration;
    }
    ;
    /**
     * Sets the expirationDuration property value.
     * @param value Value to set for the expirationDuration property.
     */
    set expirationDuration(value) {
        this._expirationDuration = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "activity": (o, n) => { o.activity = n.getStringValue(); },
            "availability": (o, n) => { o.availability = n.getStringValue(); },
            "expirationDuration": (o, n) => { o.expirationDuration = n.getDurationValue(); },
            "sessionId": (o, n) => { o.sessionId = n.getStringValue(); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("activity", this.activity);
        writer.writeStringValue("availability", this.availability);
        writer.writeDurationValue("expirationDuration", this.expirationDuration);
        writer.writeStringValue("sessionId", this.sessionId);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the sessionId property value.
     * @returns a string
     */
    get sessionId() {
        return this._sessionId;
    }
    ;
    /**
     * Sets the sessionId property value.
     * @param value Value to set for the sessionId property.
     */
    set sessionId(value) {
        this._sessionId = value;
    }
    ;
}
exports.SetPresenceRequestBody = SetPresenceRequestBody;
