import { ItemBody, KeyValuePair, TeamworkActivityTopic } from '../../../../models/microsoft/graph/';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the sendActivityNotification method.  */
export declare class SendActivityNotificationRequestBody implements AdditionalDataHolder, Parsable {
    private _activityType?;
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _chainId?;
    private _previewText?;
    private _templateParameters?;
    private _topic?;
    /**
     * Gets the activityType property value.
     * @returns a string
     */
    get activityType(): string | undefined;
    /**
     * Sets the activityType property value.
     * @param value Value to set for the activityType property.
     */
    set activityType(value: string | undefined);
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the chainId property value.
     * @returns a int64
     */
    get chainId(): number | undefined;
    /**
     * Sets the chainId property value.
     * @param value Value to set for the chainId property.
     */
    set chainId(value: number | undefined);
    /**
     * Instantiates a new sendActivityNotificationRequestBody and sets the default values.
     */
    constructor();
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the previewText property value.
     * @returns a itemBody
     */
    get previewText(): ItemBody | undefined;
    /**
     * Sets the previewText property value.
     * @param value Value to set for the previewText property.
     */
    set previewText(value: ItemBody | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the templateParameters property value.
     * @returns a keyValuePair
     */
    get templateParameters(): KeyValuePair[] | undefined;
    /**
     * Sets the templateParameters property value.
     * @param value Value to set for the templateParameters property.
     */
    set templateParameters(value: KeyValuePair[] | undefined);
    /**
     * Gets the topic property value.
     * @returns a teamworkActivityTopic
     */
    get topic(): TeamworkActivityTopic | undefined;
    /**
     * Sets the topic property value.
     * @param value Value to set for the topic property.
     */
    set topic(value: TeamworkActivityTopic | undefined);
}
