"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SendActivityNotificationRequestBody = void 0;
const createItemBodyFromDiscriminatorValue_1 = require("../../../../models/microsoft/graph/createItemBodyFromDiscriminatorValue");
const createKeyValuePairFromDiscriminatorValue_1 = require("../../../../models/microsoft/graph/createKeyValuePairFromDiscriminatorValue");
const createTeamworkActivityTopicFromDiscriminatorValue_1 = require("../../../../models/microsoft/graph/createTeamworkActivityTopicFromDiscriminatorValue");
/** Provides operations to call the sendActivityNotification method.  */
class SendActivityNotificationRequestBody {
    /**
     * Instantiates a new sendActivityNotificationRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the activityType property value.
     * @returns a string
     */
    get activityType() {
        return this._activityType;
    }
    ;
    /**
     * Sets the activityType property value.
     * @param value Value to set for the activityType property.
     */
    set activityType(value) {
        this._activityType = value;
    }
    ;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the chainId property value.
     * @returns a int64
     */
    get chainId() {
        return this._chainId;
    }
    ;
    /**
     * Sets the chainId property value.
     * @param value Value to set for the chainId property.
     */
    set chainId(value) {
        this._chainId = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "activityType": (o, n) => { o.activityType = n.getStringValue(); },
            "chainId": (o, n) => { o.chainId = n.getNumberValue(); },
            "previewText": (o, n) => { o.previewText = n.getObjectValue(createItemBodyFromDiscriminatorValue_1.createItemBodyFromDiscriminatorValue); },
            "templateParameters": (o, n) => { o.templateParameters = n.getCollectionOfObjectValues(createKeyValuePairFromDiscriminatorValue_1.createKeyValuePairFromDiscriminatorValue); },
            "topic": (o, n) => { o.topic = n.getObjectValue(createTeamworkActivityTopicFromDiscriminatorValue_1.createTeamworkActivityTopicFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the previewText property value.
     * @returns a itemBody
     */
    get previewText() {
        return this._previewText;
    }
    ;
    /**
     * Sets the previewText property value.
     * @param value Value to set for the previewText property.
     */
    set previewText(value) {
        this._previewText = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("activityType", this.activityType);
        writer.writeNumberValue("chainId", this.chainId);
        writer.writeObjectValue("previewText", this.previewText);
        writer.writeCollectionOfObjectValues("templateParameters", this.templateParameters);
        writer.writeObjectValue("topic", this.topic);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the templateParameters property value.
     * @returns a keyValuePair
     */
    get templateParameters() {
        return this._templateParameters;
    }
    ;
    /**
     * Sets the templateParameters property value.
     * @param value Value to set for the templateParameters property.
     */
    set templateParameters(value) {
        this._templateParameters = value;
    }
    ;
    /**
     * Gets the topic property value.
     * @returns a teamworkActivityTopic
     */
    get topic() {
        return this._topic;
    }
    ;
    /**
     * Sets the topic property value.
     * @param value Value to set for the topic property.
     */
    set topic(value) {
        this._topic = value;
    }
    ;
}
exports.SendActivityNotificationRequestBody = SendActivityNotificationRequestBody;
