"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TranslateExchangeIdsRequestBody = void 0;
const exchangeIdFormat_1 = require("../../../models/microsoft/graph/exchangeIdFormat");
/** Provides operations to call the translateExchangeIds method.  */
class TranslateExchangeIdsRequestBody {
    /**
     * Instantiates a new translateExchangeIdsRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "inputIds": (o, n) => { o.inputIds = n.getCollectionOfPrimitiveValues(); },
            "sourceIdType": (o, n) => { o.sourceIdType = n.getEnumValue(exchangeIdFormat_1.ExchangeIdFormat); },
            "targetIdType": (o, n) => { o.targetIdType = n.getEnumValue(exchangeIdFormat_1.ExchangeIdFormat); },
        };
    }
    ;
    /**
     * Gets the inputIds property value.
     * @returns a string
     */
    get inputIds() {
        return this._inputIds;
    }
    ;
    /**
     * Sets the inputIds property value.
     * @param value Value to set for the InputIds property.
     */
    set inputIds(value) {
        this._inputIds = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfPrimitiveValues("inputIds", this.inputIds);
        writer.writeEnumValue("sourceIdType", this.sourceIdType);
        writer.writeEnumValue("targetIdType", this.targetIdType);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the sourceIdType property value.
     * @returns a exchangeIdFormat
     */
    get sourceIdType() {
        return this._sourceIdType;
    }
    ;
    /**
     * Sets the sourceIdType property value.
     * @param value Value to set for the SourceIdType property.
     */
    set sourceIdType(value) {
        this._sourceIdType = value;
    }
    ;
    /**
     * Gets the targetIdType property value.
     * @returns a exchangeIdFormat
     */
    get targetIdType() {
        return this._targetIdType;
    }
    ;
    /**
     * Sets the targetIdType property value.
     * @param value Value to set for the TargetIdType property.
     */
    set targetIdType(value) {
        this._targetIdType = value;
    }
    ;
}
exports.TranslateExchangeIdsRequestBody = TranslateExchangeIdsRequestBody;
