"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CopyRequestBody = void 0;
const createItemReferenceFromDiscriminatorValue_1 = require("../../../models/microsoft/graph/createItemReferenceFromDiscriminatorValue");
/** Provides operations to call the copy method.  */
class CopyRequestBody {
    /**
     * Instantiates a new copyRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "name": (o, n) => { o.name = n.getStringValue(); },
            "parentReference": (o, n) => { o.parentReference = n.getObjectValue(createItemReferenceFromDiscriminatorValue_1.createItemReferenceFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Gets the name property value.
     * @returns a string
     */
    get name() {
        return this._name;
    }
    ;
    /**
     * Sets the name property value.
     * @param value Value to set for the name property.
     */
    set name(value) {
        this._name = value;
    }
    ;
    /**
     * Gets the parentReference property value.
     * @returns a itemReference
     */
    get parentReference() {
        return this._parentReference;
    }
    ;
    /**
     * Sets the parentReference property value.
     * @param value Value to set for the parentReference property.
     */
    set parentReference(value) {
        this._parentReference = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("name", this.name);
        writer.writeObjectValue("parentReference", this.parentReference);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.CopyRequestBody = CopyRequestBody;
