import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the createLink method.  */
export declare class CreateLinkRequestBody implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _expirationDateTime?;
    private _message?;
    private _password?;
    private _retainInheritedPermissions?;
    private _scope?;
    private _type?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new createLinkRequestBody and sets the default values.
     */
    constructor();
    /**
     * Gets the expirationDateTime property value.
     * @returns a Date
     */
    get expirationDateTime(): Date | undefined;
    /**
     * Sets the expirationDateTime property value.
     * @param value Value to set for the expirationDateTime property.
     */
    set expirationDateTime(value: Date | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the message property value.
     * @returns a string
     */
    get message(): string | undefined;
    /**
     * Sets the message property value.
     * @param value Value to set for the message property.
     */
    set message(value: string | undefined);
    /**
     * Gets the password property value.
     * @returns a string
     */
    get password(): string | undefined;
    /**
     * Sets the password property value.
     * @param value Value to set for the password property.
     */
    set password(value: string | undefined);
    /**
     * Gets the retainInheritedPermissions property value.
     * @returns a boolean
     */
    get retainInheritedPermissions(): boolean | undefined;
    /**
     * Sets the retainInheritedPermissions property value.
     * @param value Value to set for the retainInheritedPermissions property.
     */
    set retainInheritedPermissions(value: boolean | undefined);
    /**
     * Gets the scope property value.
     * @returns a string
     */
    get scope(): string | undefined;
    /**
     * Sets the scope property value.
     * @param value Value to set for the scope property.
     */
    set scope(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the type property value.
     * @returns a string
     */
    get type(): string | undefined;
    /**
     * Sets the type property value.
     * @param value Value to set for the type property.
     */
    set type(value: string | undefined);
}
