import { DriveRecipient } from '../../../models/microsoft/graph/';
import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
/** Provides operations to call the invite method.  */
export declare class InviteRequestBody implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    private _expirationDateTime?;
    private _message?;
    private _password?;
    private _recipients?;
    private _requireSignIn?;
    private _retainInheritedPermissions?;
    private _roles?;
    private _sendInvitation?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new inviteRequestBody and sets the default values.
     */
    constructor();
    /**
     * Gets the expirationDateTime property value.
     * @returns a string
     */
    get expirationDateTime(): string | undefined;
    /**
     * Sets the expirationDateTime property value.
     * @param value Value to set for the expirationDateTime property.
     */
    set expirationDateTime(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the message property value.
     * @returns a string
     */
    get message(): string | undefined;
    /**
     * Sets the message property value.
     * @param value Value to set for the message property.
     */
    set message(value: string | undefined);
    /**
     * Gets the password property value.
     * @returns a string
     */
    get password(): string | undefined;
    /**
     * Sets the password property value.
     * @param value Value to set for the password property.
     */
    set password(value: string | undefined);
    /**
     * Gets the recipients property value.
     * @returns a driveRecipient
     */
    get recipients(): DriveRecipient[] | undefined;
    /**
     * Sets the recipients property value.
     * @param value Value to set for the recipients property.
     */
    set recipients(value: DriveRecipient[] | undefined);
    /**
     * Gets the requireSignIn property value.
     * @returns a boolean
     */
    get requireSignIn(): boolean | undefined;
    /**
     * Sets the requireSignIn property value.
     * @param value Value to set for the requireSignIn property.
     */
    set requireSignIn(value: boolean | undefined);
    /**
     * Gets the retainInheritedPermissions property value.
     * @returns a boolean
     */
    get retainInheritedPermissions(): boolean | undefined;
    /**
     * Sets the retainInheritedPermissions property value.
     * @param value Value to set for the retainInheritedPermissions property.
     */
    set retainInheritedPermissions(value: boolean | undefined);
    /**
     * Gets the roles property value.
     * @returns a string
     */
    get roles(): string[] | undefined;
    /**
     * Sets the roles property value.
     * @param value Value to set for the roles property.
     */
    set roles(value: string[] | undefined);
    /**
     * Gets the sendInvitation property value.
     * @returns a boolean
     */
    get sendInvitation(): boolean | undefined;
    /**
     * Sets the sendInvitation property value.
     * @param value Value to set for the sendInvitation property.
     */
    set sendInvitation(value: boolean | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
}
