"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InviteRequestBody = void 0;
const createDriveRecipientFromDiscriminatorValue_1 = require("../../../models/microsoft/graph/createDriveRecipientFromDiscriminatorValue");
/** Provides operations to call the invite method.  */
class InviteRequestBody {
    /**
     * Instantiates a new inviteRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * Gets the expirationDateTime property value.
     * @returns a string
     */
    get expirationDateTime() {
        return this._expirationDateTime;
    }
    ;
    /**
     * Sets the expirationDateTime property value.
     * @param value Value to set for the expirationDateTime property.
     */
    set expirationDateTime(value) {
        this._expirationDateTime = value;
    }
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "expirationDateTime": (o, n) => { o.expirationDateTime = n.getStringValue(); },
            "message": (o, n) => { o.message = n.getStringValue(); },
            "password": (o, n) => { o.password = n.getStringValue(); },
            "recipients": (o, n) => { o.recipients = n.getCollectionOfObjectValues(createDriveRecipientFromDiscriminatorValue_1.createDriveRecipientFromDiscriminatorValue); },
            "requireSignIn": (o, n) => { o.requireSignIn = n.getBooleanValue(); },
            "retainInheritedPermissions": (o, n) => { o.retainInheritedPermissions = n.getBooleanValue(); },
            "roles": (o, n) => { o.roles = n.getCollectionOfPrimitiveValues(); },
            "sendInvitation": (o, n) => { o.sendInvitation = n.getBooleanValue(); },
        };
    }
    ;
    /**
     * Gets the message property value.
     * @returns a string
     */
    get message() {
        return this._message;
    }
    ;
    /**
     * Sets the message property value.
     * @param value Value to set for the message property.
     */
    set message(value) {
        this._message = value;
    }
    ;
    /**
     * Gets the password property value.
     * @returns a string
     */
    get password() {
        return this._password;
    }
    ;
    /**
     * Sets the password property value.
     * @param value Value to set for the password property.
     */
    set password(value) {
        this._password = value;
    }
    ;
    /**
     * Gets the recipients property value.
     * @returns a driveRecipient
     */
    get recipients() {
        return this._recipients;
    }
    ;
    /**
     * Sets the recipients property value.
     * @param value Value to set for the recipients property.
     */
    set recipients(value) {
        this._recipients = value;
    }
    ;
    /**
     * Gets the requireSignIn property value.
     * @returns a boolean
     */
    get requireSignIn() {
        return this._requireSignIn;
    }
    ;
    /**
     * Sets the requireSignIn property value.
     * @param value Value to set for the requireSignIn property.
     */
    set requireSignIn(value) {
        this._requireSignIn = value;
    }
    ;
    /**
     * Gets the retainInheritedPermissions property value.
     * @returns a boolean
     */
    get retainInheritedPermissions() {
        return this._retainInheritedPermissions;
    }
    ;
    /**
     * Sets the retainInheritedPermissions property value.
     * @param value Value to set for the retainInheritedPermissions property.
     */
    set retainInheritedPermissions(value) {
        this._retainInheritedPermissions = value;
    }
    ;
    /**
     * Gets the roles property value.
     * @returns a string
     */
    get roles() {
        return this._roles;
    }
    ;
    /**
     * Sets the roles property value.
     * @param value Value to set for the roles property.
     */
    set roles(value) {
        this._roles = value;
    }
    ;
    /**
     * Gets the sendInvitation property value.
     * @returns a boolean
     */
    get sendInvitation() {
        return this._sendInvitation;
    }
    ;
    /**
     * Sets the sendInvitation property value.
     * @param value Value to set for the sendInvitation property.
     */
    set sendInvitation(value) {
        this._sendInvitation = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("expirationDateTime", this.expirationDateTime);
        writer.writeStringValue("message", this.message);
        writer.writeStringValue("password", this.password);
        writer.writeCollectionOfObjectValues("recipients", this.recipients);
        writer.writeBooleanValue("requireSignIn", this.requireSignIn);
        writer.writeBooleanValue("retainInheritedPermissions", this.retainInheritedPermissions);
        writer.writeCollectionOfPrimitiveValues("roles", this.roles);
        writer.writeBooleanValue("sendInvitation", this.sendInvitation);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.InviteRequestBody = InviteRequestBody;
