"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InviteResponse = void 0;
const createPermissionFromDiscriminatorValue_1 = require("../../../models/microsoft/graph/createPermissionFromDiscriminatorValue");
/** Provides operations to call the invite method.  */
class InviteResponse {
    /**
     * Instantiates a new inviteResponse and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "value": (o, n) => { o.value = n.getCollectionOfObjectValues(createPermissionFromDiscriminatorValue_1.createPermissionFromDiscriminatorValue); },
        };
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeCollectionOfObjectValues("value", this.value);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the value property value.
     * @returns a permission
     */
    get value() {
        return this._value;
    }
    ;
    /**
     * Sets the value property value.
     * @param value Value to set for the value property.
     */
    set value(value) {
        this._value = value;
    }
    ;
}
exports.InviteResponse = InviteResponse;
