"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PreviewRequestBody = void 0;
/** Provides operations to call the preview method.  */
class PreviewRequestBody {
    /**
     * Instantiates a new previewRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "page": (o, n) => { o.page = n.getStringValue(); },
            "zoom": (o, n) => { o.zoom = n.getNumberValue(); },
        };
    }
    ;
    /**
     * Gets the page property value.
     * @returns a string
     */
    get page() {
        return this._page;
    }
    ;
    /**
     * Sets the page property value.
     * @param value Value to set for the page property.
     */
    set page(value) {
        this._page = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("page", this.page);
        writer.writeNumberValue("zoom", this.zoom);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
    /**
     * Gets the zoom property value.
     * @returns a double
     */
    get zoom() {
        return this._zoom;
    }
    ;
    /**
     * Sets the zoom property value.
     * @param value Value to set for the zoom property.
     */
    set zoom(value) {
        this._zoom = value;
    }
    ;
}
exports.PreviewRequestBody = PreviewRequestBody;
