"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValidatePermissionRequestBody = void 0;
/** Provides operations to call the validatePermission method.  */
class ValidatePermissionRequestBody {
    /**
     * Instantiates a new validatePermissionRequestBody and sets the default values.
     */
    constructor() {
        this._additionalData = {};
    }
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData() {
        return this._additionalData;
    }
    ;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value) {
        this._additionalData = value;
    }
    ;
    /**
     * Gets the challengeToken property value.
     * @returns a string
     */
    get challengeToken() {
        return this._challengeToken;
    }
    ;
    /**
     * Sets the challengeToken property value.
     * @param value Value to set for the challengeToken property.
     */
    set challengeToken(value) {
        this._challengeToken = value;
    }
    ;
    ;
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers() {
        return {
            "challengeToken": (o, n) => { o.challengeToken = n.getStringValue(); },
            "password": (o, n) => { o.password = n.getStringValue(); },
        };
    }
    ;
    /**
     * Gets the password property value.
     * @returns a string
     */
    get password() {
        return this._password;
    }
    ;
    /**
     * Sets the password property value.
     * @param value Value to set for the password property.
     */
    set password(value) {
        this._password = value;
    }
    ;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer) {
        if (!writer)
            throw new Error("writer cannot be undefined");
        writer.writeStringValue("challengeToken", this.challengeToken);
        writer.writeStringValue("password", this.password);
        writer.writeAdditionalData(this.additionalData);
    }
    ;
}
exports.ValidatePermissionRequestBody = ValidatePermissionRequestBody;
