import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class MalwareState implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Provider-generated malware category (for example, trojan, ransomware, etc.).  */
    private _category?;
    /** Provider-generated malware family (for example, 'wannacry', 'notpetya', etc.).  */
    private _family?;
    /** Provider-generated malware variant name (for example, Trojan:Win32/Powessere.H).  */
    private _name?;
    /** Provider-determined severity of this malware.  */
    private _severity?;
    /** Indicates whether the detected file (malware/vulnerability) was running at the time of detection or was detected at rest on the disk.  */
    private _wasRunning?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Gets the category property value. Provider-generated malware category (for example, trojan, ransomware, etc.).
     * @returns a string
     */
    get category(): string | undefined;
    /**
     * Sets the category property value. Provider-generated malware category (for example, trojan, ransomware, etc.).
     * @param value Value to set for the category property.
     */
    set category(value: string | undefined);
    /**
     * Instantiates a new malwareState and sets the default values.
     */
    constructor();
    /**
     * Gets the family property value. Provider-generated malware family (for example, 'wannacry', 'notpetya', etc.).
     * @returns a string
     */
    get family(): string | undefined;
    /**
     * Sets the family property value. Provider-generated malware family (for example, 'wannacry', 'notpetya', etc.).
     * @param value Value to set for the family property.
     */
    set family(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Gets the name property value. Provider-generated malware variant name (for example, Trojan:Win32/Powessere.H).
     * @returns a string
     */
    get name(): string | undefined;
    /**
     * Sets the name property value. Provider-generated malware variant name (for example, Trojan:Win32/Powessere.H).
     * @param value Value to set for the name property.
     */
    set name(value: string | undefined);
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the severity property value. Provider-determined severity of this malware.
     * @returns a string
     */
    get severity(): string | undefined;
    /**
     * Sets the severity property value. Provider-determined severity of this malware.
     * @param value Value to set for the severity property.
     */
    set severity(value: string | undefined);
    /**
     * Gets the wasRunning property value. Indicates whether the detected file (malware/vulnerability) was running at the time of detection or was detected at rest on the disk.
     * @returns a boolean
     */
    get wasRunning(): boolean | undefined;
    /**
     * Sets the wasRunning property value. Indicates whether the detected file (malware/vulnerability) was running at the time of detection or was detected at rest on the disk.
     * @param value Value to set for the wasRunning property.
     */
    set wasRunning(value: boolean | undefined);
}
