import { AdditionalDataHolder, Parsable, ParseNode, SerializationWriter } from '@microsoft/kiota-abstractions';
export declare class VulnerabilityState implements AdditionalDataHolder, Parsable {
    /** Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.  */
    private _additionalData;
    /** Common Vulnerabilities and Exposures (CVE) for the vulnerability.  */
    private _cve?;
    /** Base Common Vulnerability Scoring System (CVSS) severity score for this vulnerability.  */
    private _severity?;
    /** Indicates whether the detected vulnerability (file) was running at the time of detection or was the file detected at rest on the disk.  */
    private _wasRunning?;
    /**
     * Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @returns a Record<string, unknown>
     */
    get additionalData(): Record<string, unknown>;
    /**
     * Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     * @param value Value to set for the AdditionalData property.
     */
    set additionalData(value: Record<string, unknown>);
    /**
     * Instantiates a new vulnerabilityState and sets the default values.
     */
    constructor();
    /**
     * Gets the cve property value. Common Vulnerabilities and Exposures (CVE) for the vulnerability.
     * @returns a string
     */
    get cve(): string | undefined;
    /**
     * Sets the cve property value. Common Vulnerabilities and Exposures (CVE) for the vulnerability.
     * @param value Value to set for the cve property.
     */
    set cve(value: string | undefined);
    /**
     * The deserialization information for the current model
     * @returns a Record<string, (item: T, node: ParseNode) => void>
     */
    getFieldDeserializers<T>(): Record<string, (item: T, node: ParseNode) => void>;
    /**
     * Serializes information the current object
     * @param writer Serialization writer to use to serialize this model
     */
    serialize(writer: SerializationWriter): void;
    /**
     * Gets the severity property value. Base Common Vulnerability Scoring System (CVSS) severity score for this vulnerability.
     * @returns a string
     */
    get severity(): string | undefined;
    /**
     * Sets the severity property value. Base Common Vulnerability Scoring System (CVSS) severity score for this vulnerability.
     * @param value Value to set for the severity property.
     */
    set severity(value: string | undefined);
    /**
     * Gets the wasRunning property value. Indicates whether the detected vulnerability (file) was running at the time of detection or was the file detected at rest on the disk.
     * @returns a boolean
     */
    get wasRunning(): boolean | undefined;
    /**
     * Sets the wasRunning property value. Indicates whether the detected vulnerability (file) was running at the time of detection or was the file detected at rest on the disk.
     * @param value Value to set for the wasRunning property.
     */
    set wasRunning(value: boolean | undefined);
}
